# Generated by Django 3.2.11 on 2023-02-14 19:39

import core.models
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='GeomMigrationJob',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('typ', models.TextField()),
                ('count_selected_wgs84', models.IntegerField(default=0)),
                ('count_selected_sjtsk', models.IntegerField(default=0)),
                ('count_updated_wgs84', models.IntegerField(default=0)),
                ('count_updated_sjtsk', models.IntegerField(default=0)),
                ('count_error_wgs84', models.IntegerField(default=0)),
                ('count_error_sjtsk', models.IntegerField(default=0)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('detail', models.TextField(null=True)),
            ],
            options={
                'db_table': 'amcr_geom_migrations_jobs',
            },
        ),
        migrations.CreateModel(
            name='GeomMigrationJobSJTSKError',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
            ],
            options={
                'db_table': 'amcr_geom_migrations_jobs_sjtsk_errors',
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='GeomMigrationJobWGS84Error',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
            ],
            options={
                'db_table': 'amcr_geom_migrations_jobs_wgs84_errors',
            },
        ),
        migrations.CreateModel(
            name='OdstavkaSystemu',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('info_od', models.DateField(verbose_name='model.odstavka.infoOd')),
                ('datum_odstavky', models.DateField(verbose_name='model.odstavka.datumOdstavky')),
                ('cas_odstavky', models.TimeField(verbose_name='model.odstavka.casOdstavky')),
                ('status', models.BooleanField(default=True, verbose_name='model.odstavka.status')),
            ],
            options={
                'verbose_name': 'model.odstavka.modelTitle',
                'verbose_name_plural': 'model.odstavka.modelTitle',
                'db_table': 'odstavky_systemu',
            },
        ),
        migrations.CreateModel(
            name='ProjektSekvence',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rada', models.CharField(max_length=1)),
                ('rok', models.IntegerField()),
                ('sekvence', models.IntegerField()),
            ],
            options={
                'db_table': 'projekt_sekvence',
            },
        ),
        migrations.CreateModel(
            name='Soubor',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rozsah', models.IntegerField(blank=True, null=True)),
                ('nazev', models.TextField()),
                ('mimetype', models.TextField()),
                ('path', models.CharField(max_length=500, null=True)),
                ('size_mb', models.DecimalField(decimal_places=10, max_digits=150)),
                ('sha_512', models.CharField(blank=True, db_index=True, max_length=128, null=True))
            ],
            options={
                'db_table': 'soubor',
            },
        ),
        migrations.CreateModel(
            name='SouborVazby',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('typ_vazby', models.TextField(choices=[('projekt', 'Projekt'), ('dokument', 'Dokument'), ('samostatny_nalez', 'Samostatný nález')], max_length=24)),
            ],
            options={
                'db_table': 'soubor_vazby',
            },
        ),
    ]
