-- Doplnění skos relace do heslar_odkaz
ALTER TABLE heslar_odkaz ADD COLUMN skos_mapping_relation varchar(20) NOT NULL DEFAULT 'skos:exactMatch';

-- Odstranění řad ZA a ZL
DELETE FROM heslar WHERE ident_cely in ('HES-000884', 'HES-000885');

-- Úprava posudků
WITH posudky AS
(
    SELECT DISTINCT dokument as dok, (SELECT id FROM heslar WHERE ident_cely = 'HES-000615') as pos FROM dokument_posudek
    WHERE posudek = (SELECT id FROM heslar WHERE ident_cely = 'HES-000611')
)
INSERT INTO dokument_posudek (dokument, posudek) SELECT dok, pos FROM posudky WHERE NOT EXISTS (SELECT * FROM dokument_posudek WHERE dokument = dok AND posudek = pos);
DELETE FROM dokument_posudek WHERE posudek = (SELECT id FROM heslar WHERE ident_cely = 'HES-000611');

WITH posudky AS
(
    SELECT DISTINCT dokument as dok, (SELECT id FROM heslar WHERE ident_cely = 'HES-000613') as pos FROM dokument_posudek
    WHERE posudek = (SELECT id FROM heslar WHERE ident_cely = 'HES-000616')
)
INSERT INTO dokument_posudek (dokument, posudek) SELECT dok, pos FROM posudky WHERE NOT EXISTS (SELECT * FROM dokument_posudek WHERE dokument = dok AND posudek = pos);
DELETE FROM dokument_posudek WHERE posudek = (SELECT id FROM heslar WHERE ident_cely = 'HES-000616');

WITH posudky AS
(
    SELECT DISTINCT dokument as dok, (SELECT id FROM heslar WHERE ident_cely = 'HES-000628') as pos FROM dokument_posudek
    WHERE posudek = (SELECT id FROM heslar WHERE ident_cely = 'HES-000622')
)
INSERT INTO dokument_posudek (dokument, posudek) SELECT dok, pos FROM posudky WHERE NOT EXISTS (SELECT * FROM dokument_posudek WHERE dokument = dok AND posudek = pos);
DELETE FROM dokument_posudek WHERE posudek = (SELECT id FROM heslar WHERE ident_cely = 'HES-000622');

-- Sloučení duplicitních letišť
UPDATE let SET letiste_start = (SELECT id FROM heslar WHERE ident_cely = 'HES-000182') WHERE letiste_start = (SELECT id FROM heslar WHERE ident_cely = 'HES-000183');
UPDATE let SET letiste_cil = (SELECT id FROM heslar WHERE ident_cely = 'HES-000182') WHERE letiste_cil = (SELECT id FROM heslar WHERE ident_cely = 'HES-000183');
DELETE FROM heslar WHERE ident_cely = 'HES-000183';

-- Úprava památkové ochrany
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000175'), kulturni_pamatka_cislo = '', kulturni_pamatka_popis = '' WHERE kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000176');
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000175'), kulturni_pamatka_cislo = '', kulturni_pamatka_popis = '' WHERE ident_cely = 'C-202111237';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000175'), kulturni_pamatka_cislo = '', kulturni_pamatka_popis = '' WHERE ident_cely = 'C-201912990';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000175'), kulturni_pamatka_cislo = '', kulturni_pamatka_popis = '' WHERE ident_cely = 'C-202000589';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000177'), kulturni_pamatka_cislo = '105101', kulturni_pamatka_popis = 'štola Panny Marie Pomocné a štola Země zaslíbená' WHERE ident_cely = 'C-202111403';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000177'), kulturni_pamatka_cislo = '11758/3-874', kulturni_pamatka_popis = 'SHZ Český Krumlov' WHERE ident_cely = 'C-201913080';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000177'), kulturni_pamatka_cislo = '11758/3-874', kulturni_pamatka_popis = 'SHZ Český Krumlov' WHERE ident_cely = 'C-202012711';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000178'), kulturni_pamatka_cislo = '128', kulturni_pamatka_popis = 'Zámek v Litomyšli' WHERE ident_cely = 'C-202401226';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000178'), kulturni_pamatka_cislo = '128', kulturni_pamatka_popis = 'Zámek v Litomyšli' WHERE ident_cely = 'C-202311648';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000178'), kulturni_pamatka_cislo = '272', kulturni_pamatka_popis = 'Hřebčín v Kladrubech nad Labem' WHERE ident_cely = 'C-201912591';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000178'), kulturni_pamatka_cislo = '272', kulturni_pamatka_popis = 'Hřebčín v Kladrubech nad Labem' WHERE ident_cely = 'C-201909601';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000178'), kulturni_pamatka_cislo = '272', kulturni_pamatka_popis = 'Hřebčín v Kladrubech nad Labem' WHERE ident_cely = 'C-201909615';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000178'), kulturni_pamatka_cislo = '272', kulturni_pamatka_popis = 'Hřebčín v Kladrubech nad Labem' WHERE ident_cely = 'C-201806421';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000178'), kulturni_pamatka_cislo = '272', kulturni_pamatka_popis = 'Hřebčín v Kladrubech nad Labem' WHERE ident_cely = 'C-202003930';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000178'), kulturni_pamatka_cislo = '294', kulturni_pamatka_popis = 'Zámek - býv. klášter s basilikou sv. Prokopa' WHERE ident_cely = 'M-201903329';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-202004277';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-201901197';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-202213232';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-201911819';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-201446886';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-201908456';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-202005928';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-202011044';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-202011633';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-202210670';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-202311232';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-201905022';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-202007158';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-202107514';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-201900741';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1005', kulturni_pamatka_popis = 'Kutná Hora' WHERE ident_cely = 'C-201809688';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1011', kulturni_pamatka_popis = 'Český Krumlov' WHERE ident_cely = 'C-201903331';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1011', kulturni_pamatka_popis = 'Český Krumlov' WHERE ident_cely = 'C-201226680';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1011', kulturni_pamatka_popis = 'Český Krumlov' WHERE ident_cely = 'C-201661374';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1011', kulturni_pamatka_popis = 'Český Krumlov' WHERE ident_cely = 'C-202200365';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1011', kulturni_pamatka_popis = 'Český Krumlov' WHERE ident_cely = 'C-202200236';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1011', kulturni_pamatka_popis = 'Český Krumlov' WHERE ident_cely = 'C-202210702';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1011', kulturni_pamatka_popis = 'Český Krumlov' WHERE ident_cely = 'C-202400095';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1011', kulturni_pamatka_popis = 'Český Krumlov' WHERE ident_cely = 'C-202311716';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1025', kulturni_pamatka_popis = 'Telč' WHERE ident_cely = 'M-202301544';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1025', kulturni_pamatka_popis = 'Telč' WHERE ident_cely = 'M-201800294';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202108884';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201775585';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202012431';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201810860';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202206019';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201808995';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202000420';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201909193';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201911934';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201911935';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-200912961';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-200913626';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201014722';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201016058';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201014686';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201016007';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201017400';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201018097';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201123714';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201227039';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201441381';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201340645';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201447903';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201551348';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201554331';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201662162';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201662772';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201661829';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201662491';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201663653';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201665842';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702804';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201703604';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773694';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773082';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702760';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201776558';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702791';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201776269';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201701322';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201704036';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201705917';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201706471';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201706473';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201810530';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201704135';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201801862';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804957';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201808093';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201809388';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201908855';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002145';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202006067';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202010701';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202011895';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202010967';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202109052';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202203000';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202110544';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202211846';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202302679';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201703074';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201703231';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201703520';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201706395';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201123891';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201446770';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559469';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201558699';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702610';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804833';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201906535';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702347';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202210766';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201662177';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202109498';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202012895';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201800621';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202110013';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201120199';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201774316';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201703075';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201703069';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201800017';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201801492';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201801548';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804120';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201805299';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201806417';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201900150';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201902446';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002472';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202006126';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202005658';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201904743';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202100160';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201901533';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201808953';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201906475';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201903633';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670801';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201800208';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202012334';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201802933';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201704596';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804508';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201910729';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333380';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201229640';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333384';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333386';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333390';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333399';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333402';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341319';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201336518';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341321';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341327';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341331';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201776335';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450612';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201442668';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450626';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450662';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450668';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201445391';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450670';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450672';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559488';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450680';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201662755';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201561151';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201662910';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201668448';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201701296';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804832';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201807788';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202001979';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202110250';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202201363';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202205699';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202306433';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333400';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201336519';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201336516';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201233141';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333377';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201335250';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559482';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702543';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670473';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702608';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702615';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201909422';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202005539';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201906547';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333398';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450583';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450335';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201551223';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559485';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201561159';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201561160';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772440';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772442';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702542';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772445';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772449';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772454';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772458';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772460';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702617';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702759';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702790';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201801512';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201803929';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201908986';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202012044';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202100341';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202104878';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202203445';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202202004';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202203443';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333396';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450634';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772457';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201808698';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002082';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201911409';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002285';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201800559';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201704592';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201902571';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201704591';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450664';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201700987';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201704597';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772954';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773103';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773011';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201119888';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201119887';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201018441';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201226420';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201226424';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201227676';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201229641';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333387';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201233148';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772955';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201226423';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772913';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773073';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341326';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341337';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341333';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341198';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450643';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201444922';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772886';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450677';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450679';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201662105';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772815';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201662176';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559486';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201776623';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201560042';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201663950';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201663978';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772095';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772121';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772155';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772166';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670618';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201671547';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201671533';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702623';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201703014';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702795';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201700877';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702481';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804823';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201810536';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201907533';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201909310';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201906866';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202000207';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002526';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202005871';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202005581';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202008566';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202010953';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202101116';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202107241';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202112981';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202103737';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202007421';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202109121';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202200643';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202207736';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202209442';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202300724';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202307116';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202302013';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202307788';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202313356';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772912';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772959';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341334';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772888';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201119891';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202400204';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772957';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341332';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773006';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773102';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772990';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772956';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772953';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772917';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201340644';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201446540';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772814';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201671534';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702619';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201774132';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201904505';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202004048';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202104000';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202205872';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202208747';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002061';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772993';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201014785';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201018036';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773008';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773010';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772992';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772991';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773074';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201336517';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201340411';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450663';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772885';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772884';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772883';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772911';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450866';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559467';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559498';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670608';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772816';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201557800';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201661508';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772710';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772810';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670289';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201776622';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201774367';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201701767';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201800555';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804810';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804831';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201801037';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804968';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201806622';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201902579';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201912383';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202003853';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202102731';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341325';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201700569';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772455';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201441403';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201703034';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202109437';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202302279';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202312143';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559502';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202208158';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202007516';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202107037';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201905540';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202210290';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202209646';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202311974';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002190';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202201070';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202209386';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201912496';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202312321';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202104950';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202213809';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202108713';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201446711';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201662476';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670768';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670465';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670619';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201705613';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202003677';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772812';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201668392';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201015135';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201017977';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201233139';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333378';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333382';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333385';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201229897';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333391';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201336514';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341339';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201336521';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201334818';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341322';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201336523';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450660';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341330';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341335';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450621';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450615';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450618';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201443042';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670751';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450674';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450683';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450684';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559479';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201554777';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559421';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201666768';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702986';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702555';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201776360';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201776293';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201703122';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201704594';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201704038';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201800440';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201800445';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201906548';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201901812';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201910661';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201912163';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002081';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002164';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202005655';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002642';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202005421';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202011153';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202102044';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202104879';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202108337';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202309839';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202308379';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201341336';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201338618';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202100509';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201229642';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201447073';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772916';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201552530';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559475';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559491';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772452';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702566';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201774226';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201811067';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202009054';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202100335';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202100890';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201333392';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772918';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201340850';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201450669';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201559492';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201560239';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670609';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201555933';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201556939';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772713';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201561153';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201661514';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201670616';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702322';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201702626';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201903327';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202002083';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202001454';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202104876';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202109978';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201669736';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201908985';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202004026';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202004637';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202105928';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202211810';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202308410';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202311569';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201910825';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201906920';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804830';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202009016';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202008934';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201804827';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202112746';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202008966';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201912266';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202204489';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202300662';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202312659';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772952';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201773101';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201772149';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201017657';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201444165';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201661459';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202008097';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201668455';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104011';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104830';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104009';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-201200552';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202100691';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202305267';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-201903939';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202400084';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202103999';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104054';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104426';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-201200900';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202304709';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104072';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202105825';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202204755';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202303870';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202000596';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-201803089';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-201900180';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-201902221';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202004571';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104091';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104004';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-201200916';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202002931';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202204616';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202204785';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202203191';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202201186';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202100897';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104092';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104518';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202104241';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202200595';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202200248';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202206032';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202300104';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202304078';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202304841';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202400335';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202400539';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202400536';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202400535';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202400538';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202205868';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202101688';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202101690';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202101691';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2206', kulturni_pamatka_popis = 'Lednicko-valtický areál' WHERE ident_cely = 'M-202202247';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2485', kulturni_pamatka_popis = 'Hornická kulturní krajina Jáchymov' WHERE ident_cely = 'C-202308131';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2485', kulturni_pamatka_popis = 'Hornická kulturní krajina Jáchymov' WHERE ident_cely = 'C-202211712';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2485', kulturni_pamatka_popis = 'Hornická kulturní krajina Jáchymov' WHERE ident_cely = 'C-202211714';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2487', kulturni_pamatka_popis = 'Hornická kulturní krajina Krupka' WHERE ident_cely = 'C-202311045';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2491', kulturni_pamatka_popis = 'Kladrubské Polabí' WHERE ident_cely = 'C-202313105';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000179'), kulturni_pamatka_cislo = '2491', kulturni_pamatka_popis = 'Kladrubské Polabí' WHERE ident_cely = 'C-202209899';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202405811';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000178'), kulturni_pamatka_cislo = '128', kulturni_pamatka_popis = 'Zámek v Litomyšli' WHERE ident_cely = 'C-202403565';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202403587';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202402388';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202402261';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202402285';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202401983';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-202312164';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201229639';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201226979';
UPDATE projekt SET kulturni_pamatka = (SELECT id FROM heslar WHERE ident_cely = 'HES-000180'), kulturni_pamatka_cislo = '1028', kulturni_pamatka_popis = 'Praha' WHERE ident_cely = 'C-201774739';
DELETE FROM heslar WHERE ident_cely = 'HES-000176';
DELETE FROM heslar WHERE ident_cely = 'HES-000181';

-- Úprava hesel
UPDATE heslar SET razeni = 1, heslo = 'absolutní datování', heslo_en = 'absolute dating', popis = 'Méně obvyklé, samostatně nezmiňované metody absolutního datovaní (např. kosmogenní nuklidy, termoluminiscenční metoda, aj.).' WHERE ident_cely = 'HES-000634';
UPDATE heslar SET razeni = 1, heslo = 'anonym', heslo_en = 'anonymous', zkratka = 'A', popis = '' WHERE ident_cely = 'HES-000865';
UPDATE heslar SET razeni = 1, heslo = 'barvivo', heslo_en = 'colourant', popis = '' WHERE ident_cely = 'HES-000965';
UPDATE heslar SET razeni = 1, heslo = 'Benešov-Nesvačily', heslo_en = 'Benešov-Nesvačily', popis = '' WHERE ident_cely = 'HES-000193';
UPDATE heslar SET razeni = 1, heslo = 'bez ochrany', heslo_en = 'unprotected', popis = '' WHERE ident_cely = 'HES-000175';
UPDATE heslar SET razeni = 1, heslo = 'bod', heslo_en = 'point', popis = '' WHERE ident_cely = 'HES-001133';
UPDATE heslar SET razeni = 1, heslo = 'bodový objekt', heslo_en = 'point feature', popis = 'dříve "macula"' WHERE ident_cely = 'HES-001028';
UPDATE heslar SET razeni = 1, heslo = 'celek akce', heslo_en = 'fieldwork extent', popis = '' WHERE ident_cely = 'HES-001070';
UPDATE heslar SET razeni = 1, heslo = 'část knihy', heslo_en = 'book chapter', zkratka = 'B', popis = '' WHERE ident_cely = 'HES-001118';
UPDATE heslar SET razeni = 1, heslo = 'Česko', heslo_en = 'Czechia', zkratka = 'CZ', popis = '' WHERE ident_cely = 'HES-001198';
UPDATE heslar SET razeni = 1, heslo = 'čeština', heslo_en = 'Czech', zkratka = 'CS', popis = '' WHERE ident_cely = 'HES-000167';
UPDATE heslar SET razeni = 1, heslo = 'digitální soubor', heslo_en = 'digital file', popis = '' WHERE ident_cely = 'HES-000217';
UPDATE heslar SET razeni = 1, heslo = 'kinofilm (24 x 36 mm)', heslo_en = 'cine film (24 x 36 mm)', popis = '' WHERE ident_cely = 'HES-000141';
UPDATE heslar SET razeni = 1, heslo = 'konference', heslo_en = 'conference', popis = '' WHERE ident_cely = 'HES-001152';
UPDATE heslar SET razeni = 1, heslo = 'muzeum', heslo_en = 'museum', popis = '' WHERE ident_cely = 'HES-001127';
UPDATE heslar SET razeni = 1, heslo = 'náhodný/povrchový nález', heslo_en = 'chance find', popis = '' WHERE ident_cely = 'HES-001139';
UPDATE heslar SET razeni = 1, heslo = 'nálezová zpráva', heslo_en = 'fieldwork report', popis = '' WHERE ident_cely = 'HES-001075';
UPDATE heslar SET razeni = 1, heslo = 'nemovitá památka', heslo_en = 'heritage site', zkratka = 'N', popis = '' WHERE ident_cely = 'HES-001122';
UPDATE heslar SET razeni = 1, heslo = 'neznámá', heslo_en = 'unknown', popis = '' WHERE ident_cely = 'HES-000099';
UPDATE heslar SET razeni = 1, heslo = 'neznámé počasí', heslo_en = 'unknown weather', popis = '' WHERE ident_cely = 'HES-000586';
UPDATE heslar SET razeni = 1, heslo = 'objekt', heslo_en = 'feature', zkratka = 'O', popis = '' WHERE ident_cely = 'HES-001125';
UPDATE heslar SET razeni = 1, heslo = 'obývání', heslo_en = 'residential activity', zkratka = 'síd', popis = '' WHERE ident_cely = 'HES-000001';
UPDATE heslar SET razeni = 1, heslo = 'odborný záměr', heslo_en = 'expert project', popis = '' WHERE ident_cely = 'HES-000594';
UPDATE heslar SET razeni = 1, heslo = 'odchylka jednotky metrů', heslo_en = 'deviation in meters', zkratka = '1', popis = 'odchylka jednotky metrů' WHERE ident_cely = 'HES-000861';
UPDATE heslar SET razeni = 1, heslo = 'polygon archeologického průzkumu', heslo_en = 'archaeological survey polygon', popis = '' WHERE ident_cely = 'HES-000132';
UPDATE heslar SET razeni = 1, heslo = 'povrch sondy', heslo_en = 'trench surface', popis = '' WHERE ident_cely = 'HES-001157';
UPDATE heslar SET razeni = 1, heslo = 'povrch', heslo_en = 'surface', popis = '' WHERE ident_cely = 'HES-000242';
UPDATE heslar SET razeni = 1, heslo = 'primárně digitální dokument', heslo_en = 'born digital document', popis = '' WHERE ident_cely = 'HES-001166';
UPDATE heslar SET razeni = 1, heslo = 'přesné datum', heslo_en = 'exact date', popis = 'otevírají se políčka pro přesná data (od-do)' WHERE ident_cely = 'HES-000887';
UPDATE heslar SET razeni = 1, heslo = 'tisková kvalita', heslo_en = 'print quality', zkratka = '1', popis = '' WHERE ident_cely = 'HES-000237';
UPDATE heslar SET razeni = 1, heslo = 'zachováno 80–100 %', heslo_en = '80–100% preserved', zkratka = '1', popis = 'skenován' WHERE ident_cely = 'HES-001173';
UPDATE heslar SET razeni = 1, heslo = 'záchranný', heslo_en = 'rescue', popis = '' WHERE ident_cely = 'HES-001136';
UPDATE heslar SET razeni = 1, heslo = 'zprávy a hlášení', heslo_en = 'reports', zkratka = 'TX', popis = '' WHERE ident_cely = 'HES-000883';
UPDATE heslar SET razeni = 10, heslo = '80–90 km', heslo_en = '80–90 km', popis = '' WHERE ident_cely = 'HES-000108';
UPDATE heslar SET razeni = 10, heslo = 'A0 (84 x 119 cm)', heslo_en = 'A0 (84 x 119 cm)', popis = '' WHERE ident_cely = 'HES-000150';
UPDATE heslar SET razeni = 10, heslo = 'Anguilla', heslo_en = 'Anguilla', zkratka = 'AI', popis = '' WHERE ident_cely = 'HES-001187';
UPDATE heslar SET razeni = 10, heslo = 'archeoparazitologie', heslo_en = 'archeoparasitology', popis = 'Analýza parazitů v archeologických kontextech.' WHERE ident_cely = 'HES-000626';
UPDATE heslar SET razeni = 10, heslo = 'data geofyzikální', heslo_en = 'geophysical data', popis = '' WHERE ident_cely = 'HES-001084';
UPDATE heslar SET razeni = 10, heslo = 'fotografie terénu', heslo_en = 'photographs of fieldwork', zkratka = 'FT', popis = '' WHERE ident_cely = 'HES-000879';
UPDATE heslar SET razeni = 10, heslo = 'Chomutov-Pesvice', heslo_en = 'Chomutov-Pesvice', popis = '' WHERE ident_cely = 'HES-000190';
UPDATE heslar SET razeni = 10, heslo = 'intruze', heslo_en = 'intrusion', zkratka = 'int', popis = '' WHERE ident_cely = 'HES-000010';
UPDATE heslar SET razeni = 10, heslo = 'jiný kontext', heslo_en = 'other context', popis = '' WHERE ident_cely = 'HES-000251';
UPDATE heslar SET razeni = 10, heslo = 'kámen broušený', heslo_en = 'polished stone', popis = '' WHERE ident_cely = 'HES-000974';
UPDATE heslar SET razeni = 10, heslo = 'karton', heslo_en = 'cardboard', popis = '' WHERE ident_cely = 'HES-000226';
UPDATE heslar SET razeni = 10, heslo = 'nedestruktivní průzkum', heslo_en = 'non-destructive survey', popis = '' WHERE ident_cely = 'HES-001063';
UPDATE heslar SET razeni = 10, heslo = 'ohrazení kruhové velké', heslo_en = 'circular enclosure (large)', popis = '' WHERE ident_cely = 'HES-001037';
UPDATE heslar SET razeni = 10, heslo = 'polygon leteckého průzkumu', heslo_en = 'aerial survey polygon', popis = '' WHERE ident_cely = 'HES-000111';
UPDATE heslar SET razeni = 10, heslo = 'řez', heslo_en = 'linear trench', popis = '' WHERE ident_cely = 'HES-001148';
UPDATE heslar SET razeni = 10, heslo = 'sídliště', heslo_en = 'settlement', popis = '' WHERE ident_cely = 'HES-000083';
UPDATE heslar SET razeni = 10, heslo = 'sídliště', heslo_en = 'settlement', popis = 'sídlištní areál autarktní komunity' WHERE ident_cely = 'HES-000081';
UPDATE heslar SET razeni = 10, heslo = 'stavba', heslo_en = 'construction', popis = '' WHERE ident_cely = 'HES-000603';
UPDATE heslar SET razeni = 100, heslo = 'běžný nález', heslo_en = 'common find', popis = '' WHERE ident_cely = 'HES-000842';
UPDATE heslar SET razeni = 100, heslo = 'budova/stavba', heslo_en = 'building/structure', popis = '' WHERE ident_cely = 'HES-000438';
UPDATE heslar SET razeni = 100, heslo = 'budova/stavba', heslo_en = 'building/structure', popis = '' WHERE ident_cely = 'HES-000571';
UPDATE heslar SET razeni = 100, heslo = 'Kajmanské ostrovy', heslo_en = 'Cayman Islands (the)', zkratka = 'KY', popis = '' WHERE ident_cely = 'HES-001345';
UPDATE heslar SET razeni = 100, heslo = 'komunikace', heslo_en = 'transportation structure', popis = '' WHERE ident_cely = 'HES-000092';
UPDATE heslar SET razeni = 100, heslo = 'komunikace', heslo_en = 'transportation structure', popis = 'samostatný areál komunikace' WHERE ident_cely = 'HES-000047';
UPDATE heslar SET razeni = 100, heslo = 'konstrukce zděná', heslo_en = 'masonry construction', popis = '' WHERE ident_cely = 'HES-000893';
UPDATE heslar SET razeni = 100, heslo = 'paleolit', heslo_en = 'Palaeolithic', popis = '' WHERE ident_cely = 'HES-000395';
UPDATE heslar SET razeni = 100, heslo = 'paleolit', heslo_en = 'Palaeolithic', zkratka = 'paleol', popis = '' WHERE ident_cely = 'HES-000253';
UPDATE heslar SET razeni = 100, heslo = 'zlomek keramiky', heslo_en = 'potsherd', popis = '' WHERE ident_cely = 'HES-000705';
UPDATE heslar SET razeni = 100, heslo = 'způsob provedení', heslo_en = 'construction type', popis = '' WHERE ident_cely = 'HES-000963';
UPDATE heslar SET razeni = 1000, heslo = 'doba laténská', heslo_en = 'La Tène Period', popis = '' WHERE ident_cely = 'HES-000404';
UPDATE heslar SET razeni = 1000, heslo = 'doba laténská', heslo_en = 'La Tène Period', zkratka = 'laten', popis = '' WHERE ident_cely = 'HES-000254';
UPDATE heslar SET razeni = 1000, heslo = 'nástroj jemný', heslo_en = 'instrument', popis = '' WHERE ident_cely = 'HES-000727';
UPDATE heslar SET razeni = 1000, heslo = 'nástroj jemný', heslo_en = 'instrument', popis = '' WHERE ident_cely = 'HES-000851';
UPDATE heslar SET razeni = 1000, heslo = 'otopné zařízení', heslo_en = 'heating equipment', popis = '' WHERE ident_cely = 'HES-000421';
UPDATE heslar SET razeni = 1000, heslo = 'otopné zařízení', heslo_en = 'heating equipment', popis = '' WHERE ident_cely = 'HES-000580';
UPDATE heslar SET razeni = 1001, heslo = 'brousek', heslo_en = 'whetstone', popis = '' WHERE ident_cely = 'HES-000803';
UPDATE heslar SET razeni = 1001, heslo = 'kamna', heslo_en = 'stove', popis = '' WHERE ident_cely = 'HES-000422';
UPDATE heslar SET razeni = 1002, heslo = 'břitva', heslo_en = 'razor', popis = '' WHERE ident_cely = 'HES-000661';
UPDATE heslar SET razeni = 1002, heslo = 'ohniště', heslo_en = 'fireplace', popis = '' WHERE ident_cely = 'HES-000423';
UPDATE heslar SET razeni = 1003, heslo = 'čepel/čepelka', heslo_en = 'blade/small blade', popis = '' WHERE ident_cely = 'HES-000662';
UPDATE heslar SET razeni = 1003, heslo = 'otopná pec', heslo_en = 'oven', popis = '' WHERE ident_cely = 'HES-000424';
UPDATE heslar SET razeni = 1004, heslo = 'dláto', heslo_en = 'chisel', popis = '' WHERE ident_cely = 'HES-000824';
UPDATE heslar SET razeni = 1004, heslo = 'topný kanál', heslo_en = 'heating channel', popis = '' WHERE ident_cely = 'HES-000425';
UPDATE heslar SET razeni = 1005, heslo = 'hladítko', heslo_en = 'smoother', popis = '' WHERE ident_cely = 'HES-000825';
UPDATE heslar SET razeni = 1006, heslo = 'hřeben', heslo_en = 'comb', popis = '' WHERE ident_cely = 'HES-000826';
UPDATE heslar SET razeni = 1007, heslo = 'jehla/špendlík', heslo_en = 'needle/pin', popis = '' WHERE ident_cely = 'HES-000804';
UPDATE heslar SET razeni = 1008, heslo = 'klíč', heslo_en = 'key', popis = '' WHERE ident_cely = 'HES-000728';
UPDATE heslar SET razeni = 1009, heslo = 'křesadlo/ocílka', heslo_en = 'firesteel', popis = '' WHERE ident_cely = 'HES-000729';
UPDATE heslar SET razeni = 101, heslo = 'budova obytná', heslo_en = 'residential building', popis = '' WHERE ident_cely = 'HES-000439';
UPDATE heslar SET razeni = 101, heslo = 'cesta', heslo_en = 'roads', popis = '' WHERE ident_cely = 'HES-000048';
UPDATE heslar SET razeni = 101, heslo = 'Kambodža', heslo_en = 'Cambodia', zkratka = 'KH', popis = '' WHERE ident_cely = 'HES-001291';
UPDATE heslar SET razeni = 101, heslo = 'konstrukce cihlová', heslo_en = 'brick structure', popis = '' WHERE ident_cely = 'HES-000894';
UPDATE heslar SET razeni = 101, heslo = 'stavební keramika', heslo_en = 'construction ceramics', popis = '' WHERE ident_cely = 'HES-000748';
UPDATE heslar SET razeni = 1010, heslo = 'časná doba laténská (LtA)', heslo_en = 'Early La Tène Period (LtA)', zkratka = 'la.cas', popis = '' WHERE ident_cely = 'HES-000355';
UPDATE heslar SET razeni = 1010, heslo = 'lžíce', heslo_en = 'spoon', popis = '' WHERE ident_cely = 'HES-000730';
UPDATE heslar SET razeni = 1011, heslo = 'náprstek', heslo_en = 'thimble', popis = '' WHERE ident_cely = 'HES-000805';
UPDATE heslar SET razeni = 1011, heslo = 'podmokelská skupina', heslo_en = 'Podmokly Group', zkratka = 'la.pod', popis = '' WHERE ident_cely = 'HES-000329';
UPDATE heslar SET razeni = 1012, heslo = 'nůž', heslo_en = 'knife', popis = '' WHERE ident_cely = 'HES-000806';
UPDATE heslar SET razeni = 1013, heslo = 'nůžky', heslo_en = 'scissors', popis = '' WHERE ident_cely = 'HES-000807';
UPDATE heslar SET razeni = 1014, heslo = 'pinzeta', heslo_en = 'tweezers', popis = '' WHERE ident_cely = 'HES-000808';
UPDATE heslar SET razeni = 1015, heslo = 'přeslen', heslo_en = 'spindle whorl', popis = '' WHERE ident_cely = 'HES-000809';
UPDATE heslar SET razeni = 1016, heslo = 'rydlo', heslo_en = 'graver', popis = '' WHERE ident_cely = 'HES-000810';
UPDATE heslar SET razeni = 1017, heslo = 'stilus', heslo_en = 'stylus', popis = '' WHERE ident_cely = 'HES-000811';
UPDATE heslar SET razeni = 1018, heslo = 'šídlo', heslo_en = 'awl', popis = '' WHERE ident_cely = 'HES-000827';
UPDATE heslar SET razeni = 102, heslo = 'budova hospodářská', heslo_en = 'non-residential building', popis = '' WHERE ident_cely = 'HES-000440';
UPDATE heslar SET razeni = 102, heslo = 'Kamerun', heslo_en = 'Cameroon', zkratka = 'CM', popis = '' WHERE ident_cely = 'HES-001292';
UPDATE heslar SET razeni = 102, heslo = 'konstrukce dlaždicová', heslo_en = 'tiled structure', popis = '' WHERE ident_cely = 'HES-000895';
UPDATE heslar SET razeni = 102, heslo = 'most/brod', heslo_en = 'bridge/ford', popis = '' WHERE ident_cely = 'HES-000049';
UPDATE heslar SET razeni = 102, heslo = 'technická keramika', heslo_en = 'technical ceramics', popis = '' WHERE ident_cely = 'HES-000774';
UPDATE heslar SET razeni = 1020, heslo = 'střední doba laténská (LtB–C1)', heslo_en = 'Middle La Tène Period (LtB–C1)', zkratka = 'la.sd', popis = '' WHERE ident_cely = 'HES-000333';
UPDATE heslar SET razeni = 1025, heslo = 'střední/mladší doba laténská (LtC1–2)', heslo_en = 'Middle/Late La Tène Period (LtC1–2)', zkratka = 'la.c', popis = '' WHERE ident_cely = 'HES-001447';
UPDATE heslar SET razeni = 103, heslo = '(polo)zemnice', heslo_en = 'pit house', popis = '' WHERE ident_cely = 'HES-000497';
UPDATE heslar SET razeni = 103, heslo = 'Kanada', heslo_en = 'Canada', zkratka = 'CA', popis = '' WHERE ident_cely = 'HES-001293';
UPDATE heslar SET razeni = 103, heslo = 'konstrukce kamenná', heslo_en = 'stonework', popis = '' WHERE ident_cely = 'HES-000896';
UPDATE heslar SET razeni = 103, heslo = 'zlomek mazanice', heslo_en = 'daub fragment', popis = '' WHERE ident_cely = 'HES-000706';
UPDATE heslar SET razeni = 103, heslo = 'železnice', heslo_en = 'railway', popis = '' WHERE ident_cely = 'HES-000050';
UPDATE heslar SET razeni = 1030, heslo = 'mladší–pozdní doba laténská (LtC2–D)', heslo_en = 'Late–Final La Tène Period (LtC2–D)', zkratka = 'la.m-p', popis = '' WHERE ident_cely = 'HES-000255';
UPDATE heslar SET razeni = 1031, heslo = 'kultura púchovská', heslo_en = 'Púchov Culture', zkratka = 'lr.puc', popis = '' WHERE ident_cely = 'HES-000256';
UPDATE heslar SET razeni = 1032, heslo = 'kultura przeworská', heslo_en = 'Przeworsk Culture', zkratka = 'lr.prw', popis = '' WHERE ident_cely = 'HES-000257';
UPDATE heslar SET razeni = 104, heslo = 'haltýř', heslo_en = 'spring house', popis = '' WHERE ident_cely = 'HES-000478';
UPDATE heslar SET razeni = 104, heslo = 'Kapverdy', heslo_en = 'Cape Verde', zkratka = 'CV', popis = '' WHERE ident_cely = 'HES-001343';
UPDATE heslar SET razeni = 104, heslo = 'konstrukce dřevěná', heslo_en = 'wooden structure', popis = '' WHERE ident_cely = 'HES-000897';
UPDATE heslar SET razeni = 104, heslo = 'zlomek kosti', heslo_en = 'bone fragment', popis = '' WHERE ident_cely = 'HES-000639';
UPDATE heslar SET razeni = 1040, heslo = 'pozdní doba laténská (LtD)', heslo_en = 'Final La Tène Period (LtD)', zkratka = 'la.po', popis = '' WHERE ident_cely = 'HES-000258';
UPDATE heslar SET razeni = 1041, heslo = 'kobylská skupina', heslo_en = 'Kobyly Group', zkratka = 'la.kob', popis = '' WHERE ident_cely = 'HES-000259';
UPDATE heslar SET razeni = 105, heslo = 'kamenná industrie', heslo_en = 'lithics', popis = '' WHERE ident_cely = 'HES-000640';
UPDATE heslar SET razeni = 105, heslo = 'kašna', heslo_en = 'fountain', popis = '' WHERE ident_cely = 'HES-000479';
UPDATE heslar SET razeni = 105, heslo = 'Katar', heslo_en = 'Qatar', zkratka = 'QA', popis = '' WHERE ident_cely = 'HES-001286';
UPDATE heslar SET razeni = 105, heslo = 'konstrukce kůlová/sloupová', heslo_en = 'post-and-beam structure', popis = '' WHERE ident_cely = 'HES-000898';
UPDATE heslar SET razeni = 106, heslo = 'amorfní zlomek/předmět', heslo_en = 'amorphous fragment/object', popis = '' WHERE ident_cely = 'HES-000707';
UPDATE heslar SET razeni = 106, heslo = 'Kazachstán', heslo_en = 'Kazakhstan', zkratka = 'KZ', popis = '' WHERE ident_cely = 'HES-001316';
UPDATE heslar SET razeni = 106, heslo = 'konstrukce roubená', heslo_en = 'log construction', popis = '' WHERE ident_cely = 'HES-000899';
UPDATE heslar SET razeni = 106, heslo = 'mlýn', heslo_en = 'mill', popis = '' WHERE ident_cely = 'HES-000480';
UPDATE heslar SET razeni = 107, heslo = 'atypický předmět', heslo_en = 'exceptional object', popis = '' WHERE ident_cely = 'HES-000708';
UPDATE heslar SET razeni = 107, heslo = 'Keňa', heslo_en = 'Kenya', zkratka = 'KE', popis = '' WHERE ident_cely = 'HES-001398';
UPDATE heslar SET razeni = 107, heslo = 'konstrukce hrázděná', heslo_en = 'half-timber construction', popis = '' WHERE ident_cely = 'HES-000900';
UPDATE heslar SET razeni = 107, heslo = 'palác', heslo_en = 'palace', popis = '' WHERE ident_cely = 'HES-000481';
UPDATE heslar SET razeni = 108, heslo = 'Kiribati', heslo_en = 'Kiribati', zkratka = 'KI', popis = '' WHERE ident_cely = 'HES-001233';
UPDATE heslar SET razeni = 108, heslo = 'stáj/chlév', heslo_en = 'stable/cowshed', popis = '' WHERE ident_cely = 'HES-000482';
UPDATE heslar SET razeni = 109, heslo = 'Kokosové (Keelingovy) ostrovy', heslo_en = 'Cocos (Keeling) Islands (the)', zkratka = 'CC', popis = '' WHERE ident_cely = 'HES-001259';
UPDATE heslar SET razeni = 109, heslo = 'konstrukce sypaná/vršená', heslo_en = 'earth construction', popis = '' WHERE ident_cely = 'HES-000901';
UPDATE heslar SET razeni = 109, heslo = 'stodola', heslo_en = 'barn', popis = '' WHERE ident_cely = 'HES-000483';
UPDATE heslar SET razeni = 11, heslo = '>A0', heslo_en = '>A0', popis = '' WHERE ident_cely = 'HES-000151';
UPDATE heslar SET razeni = 11, heslo = '90–100 km', heslo_en = '90–100 km', popis = '' WHERE ident_cely = 'HES-000109';
UPDATE heslar SET razeni = 11, heslo = 'Antarktida', heslo_en = 'Antarctica', zkratka = 'AQ', popis = '' WHERE ident_cely = 'HES-001188';
UPDATE heslar SET razeni = 11, heslo = 'archeozoologie', heslo_en = 'archaeozoology', popis = 'Analýza pozůstatků zvířat v archeologických kontextech.' WHERE ident_cely = 'HES-000607';
UPDATE heslar SET razeni = 11, heslo = 'data GNSS', heslo_en = 'GNSS data', popis = '' WHERE ident_cely = 'HES-001085';
UPDATE heslar SET razeni = 11, heslo = 'fotografie terénu (digitální)', heslo_en = 'photographs of fieldwork (digital)', zkratka = 'DT', popis = '' WHERE ident_cely = 'HES-000874';
UPDATE heslar SET razeni = 11, heslo = 'hrazené sídliště', heslo_en = 'enclosed settlement', popis = '' WHERE ident_cely = 'HES-000064';
UPDATE heslar SET razeni = 11, heslo = 'Jaroměř', heslo_en = 'Jaroměř', popis = '' WHERE ident_cely = 'HES-000191';
UPDATE heslar SET razeni = 11, heslo = 'kámen drahý', heslo_en = 'gemstone', popis = '' WHERE ident_cely = 'HES-000975';
UPDATE heslar SET razeni = 11, heslo = 'negativ barevný', heslo_en = 'colour negative', zkratka = 'neg-bar', popis = '' WHERE ident_cely = 'HES-000227';
UPDATE heslar SET razeni = 11, heslo = 'ohrazení pravoúhlé malé', heslo_en = 'rectangular enclosure (small)', popis = '' WHERE ident_cely = 'HES-001038';
UPDATE heslar SET razeni = 11, heslo = 'skupina řezů', heslo_en = 'group of linear trenches', popis = '' WHERE ident_cely = 'HES-001149';
UPDATE heslar SET razeni = 11, heslo = 'vizuální/geodetický průzkum', heslo_en = 'visual/geodetic survey', popis = '' WHERE ident_cely = 'HES-001044';
UPDATE heslar SET razeni = 110, heslo = 'depot', heslo_en = 'hoard', popis = '' WHERE ident_cely = 'HES-000093';
UPDATE heslar SET razeni = 110, heslo = 'depot', heslo_en = 'hoard', popis = 'areál deponování mimo ostatní areály' WHERE ident_cely = 'HES-000051';
UPDATE heslar SET razeni = 110, heslo = 'Kolumbie', heslo_en = 'Colombia', zkratka = 'CO', popis = '' WHERE ident_cely = 'HES-001284';
UPDATE heslar SET razeni = 110, heslo = 'konstrukce zahloubená', heslo_en = 'sunken structure', popis = '' WHERE ident_cely = 'HES-000902';
UPDATE heslar SET razeni = 110, heslo = 'starší paleolit', heslo_en = 'Lower Palaeolithic', zkratka = 'pa.st', popis = '' WHERE ident_cely = 'HES-000291';
UPDATE heslar SET razeni = 110, heslo = 'sýpka/špýchar', heslo_en = 'granary/storehouse', popis = '' WHERE ident_cely = 'HES-000484';
UPDATE heslar SET razeni = 1100, heslo = 'doba halštatská–laténská', heslo_en = 'Hallstatt–La Tène Period', popis = '' WHERE ident_cely = 'HES-000405';
UPDATE heslar SET razeni = 1100, heslo = 'doba halštatská–laténská', heslo_en = 'Hallstatt–La Tène Period', zkratka = 'ha-la', popis = '' WHERE ident_cely = 'HES-000334';
UPDATE heslar SET razeni = 1100, heslo = 'nehotový výrobek/polotovar', heslo_en = 'semiproduct/blank', popis = '' WHERE ident_cely = 'HES-000828';
UPDATE heslar SET razeni = 1100, heslo = 'nehotový výrobek/polotovar', heslo_en = 'semiproduct/blank', popis = '' WHERE ident_cely = 'HES-000852';
UPDATE heslar SET razeni = 1100, heslo = 'pohřební objekt', heslo_en = 'funerary structure', popis = '' WHERE ident_cely = 'HES-000426';
UPDATE heslar SET razeni = 1100, heslo = 'pohřební objekt', heslo_en = 'funerary structure', popis = '' WHERE ident_cely = 'HES-000581';
UPDATE heslar SET razeni = 1101, heslo = 'hrob', heslo_en = 'grave', popis = '' WHERE ident_cely = 'HES-000427';
UPDATE heslar SET razeni = 1101, heslo = 'hřivna', heslo_en = 'ingot', popis = '' WHERE ident_cely = 'HES-000829';
UPDATE heslar SET razeni = 1102, heslo = 'hrob komorový', heslo_en = 'chamber grave', popis = '' WHERE ident_cely = 'HES-000428';
UPDATE heslar SET razeni = 1102, heslo = 'ruda', heslo_en = 'ore', popis = '' WHERE ident_cely = 'HES-000830';
UPDATE heslar SET razeni = 1103, heslo = 'hrob skříňkový', heslo_en = 'cist grave', popis = '' WHERE ident_cely = 'HES-000429';
UPDATE heslar SET razeni = 1103, heslo = 'slitek', heslo_en = 'bloom', popis = '' WHERE ident_cely = 'HES-000831';
UPDATE heslar SET razeni = 1104, heslo = 'hrobka', heslo_en = 'tomb', popis = '' WHERE ident_cely = 'HES-000430';
UPDATE heslar SET razeni = 1104, heslo = 'surovina', heslo_en = 'raw material', popis = '' WHERE ident_cely = 'HES-000832';
UPDATE heslar SET razeni = 1105, heslo = 'mohyla', heslo_en = 'burial mound', popis = '' WHERE ident_cely = 'HES-000431';
UPDATE heslar SET razeni = 1105, heslo = 'valoun', heslo_en = 'pebble', popis = '' WHERE ident_cely = 'HES-000833';
UPDATE heslar SET razeni = 1106, heslo = 'kostnice', heslo_en = 'ossuary', popis = '' WHERE ident_cely = 'HES-000432';
UPDATE heslar SET razeni = 1107, heslo = 'náhrobek/náhrobní kámen', heslo_en = 'gravestone', popis = '' WHERE ident_cely = 'HES-000433';
UPDATE heslar SET razeni = 1108, heslo = 'pohřeb kostrový', heslo_en = 'inhumation burial', popis = '' WHERE ident_cely = 'HES-000434';
UPDATE heslar SET razeni = 1109, heslo = 'pohřeb žárový', heslo_en = 'cremation burial', popis = '' WHERE ident_cely = 'HES-000435';
UPDATE heslar SET razeni = 111, heslo = 'Komory', heslo_en = 'Comoros (the)', zkratka = 'KM', popis = '' WHERE ident_cely = 'HES-001384';
UPDATE heslar SET razeni = 111, heslo = 'šibenice', heslo_en = 'gallows', popis = '' WHERE ident_cely = 'HES-000511';
UPDATE heslar SET razeni = 1110, heslo = 'pohřeb zvířete', heslo_en = 'animal burial', popis = '' WHERE ident_cely = 'HES-000436';
UPDATE heslar SET razeni = 1111, heslo = 'pohřeb v sídlištním objektu', heslo_en = 'burial in settlement context', popis = '' WHERE ident_cely = 'HES-000437';
UPDATE heslar SET razeni = 1112, heslo = 'stéla', heslo_en = 'stela', popis = '' WHERE ident_cely = 'HES-000469';
UPDATE heslar SET razeni = 112, heslo = 'Konžská republika', heslo_en = 'Congo (the)', zkratka = 'CG', popis = '' WHERE ident_cely = 'HES-001385';
UPDATE heslar SET razeni = 112, heslo = 'zvonice', heslo_en = 'bell tower', popis = '' WHERE ident_cely = 'HES-000485';
UPDATE heslar SET razeni = 113, heslo = 'Korejská lidově demokratická republika', heslo_en = 'Korea (the Democratic People''s Republic of)', zkratka = 'KP', popis = '' WHERE ident_cely = 'HES-001373';
UPDATE heslar SET razeni = 114, heslo = 'Korejská republika', heslo_en = 'Korea (the Republic of)', zkratka = 'KR', popis = '' WHERE ident_cely = 'HES-001225';
UPDATE heslar SET razeni = 115, heslo = 'Kosovo', heslo_en = 'Kosovo', zkratka = 'XK', popis = '' WHERE ident_cely = 'HES-001200';
UPDATE heslar SET razeni = 116, heslo = 'Kostarika', heslo_en = 'Costa Rica', zkratka = 'CR', popis = '' WHERE ident_cely = 'HES-001271';
UPDATE heslar SET razeni = 117, heslo = 'Kuba', heslo_en = 'Cuba', zkratka = 'CU', popis = '' WHERE ident_cely = 'HES-001234';
UPDATE heslar SET razeni = 118, heslo = 'Kuvajt', heslo_en = 'Kuwait', zkratka = 'KW', popis = '' WHERE ident_cely = 'HES-001201';
UPDATE heslar SET razeni = 119, heslo = 'Kypr', heslo_en = 'Cyprus', zkratka = 'CY', popis = '' WHERE ident_cely = 'HES-001237';
UPDATE heslar SET razeni = 12, heslo = '>100 km', heslo_en = '>100 km', popis = '' WHERE ident_cely = 'HES-000110';
UPDATE heslar SET razeni = 12, heslo = '3D – Autocad (*.dwg)', heslo_en = '3D – Autocad (*.dwg)', popis = '' WHERE ident_cely = 'HES-000152';
UPDATE heslar SET razeni = 12, heslo = 'Antigua a Barbuda', heslo_en = 'Antigua and Barbuda', zkratka = 'AG', popis = '' WHERE ident_cely = 'HES-001189';
UPDATE heslar SET razeni = 12, heslo = 'biologická antropologie', heslo_en = 'biological anthropology', popis = 'Zabývá se studiem člověka po biologické stránce a analýzou lidských pozůstatků.' WHERE ident_cely = 'HES-000605';
UPDATE heslar SET razeni = 12, heslo = 'data terénního výzkumu', heslo_en = 'fieldwork data', popis = '' WHERE ident_cely = 'HES-001086';
UPDATE heslar SET razeni = 12, heslo = 'fotografie jiné/osobní', heslo_en = 'other/personal photographs', zkratka = 'FJ', popis = '' WHERE ident_cely = 'HES-000877';
UPDATE heslar SET razeni = 12, heslo = 'Jičín', heslo_en = 'Jičín', popis = '' WHERE ident_cely = 'HES-000192';
UPDATE heslar SET razeni = 12, heslo = 'kámen drtidlo/žernov', heslo_en = 'grinding stone', popis = '' WHERE ident_cely = 'HES-000976';
UPDATE heslar SET razeni = 12, heslo = 'letecký průzkum', heslo_en = 'aerial survey', popis = '' WHERE ident_cely = 'HES-001045';
UPDATE heslar SET razeni = 12, heslo = 'negativ černobílý (film)', heslo_en = 'black-and-white negative (film)', zkratka = 'neg-čb-film', popis = '' WHERE ident_cely = 'HES-000228';
UPDATE heslar SET razeni = 12, heslo = 'ohrazení pravoúhlé střední', heslo_en = 'rectangular enclosure (medium)', popis = '' WHERE ident_cely = 'HES-001039';
UPDATE heslar SET razeni = 12, heslo = 'osídlený skalní prostor', heslo_en = 'cave settlement', popis = '' WHERE ident_cely = 'HES-000065';
UPDATE heslar SET razeni = 12, heslo = 'sonda', heslo_en = 'pit trench', popis = '' WHERE ident_cely = 'HES-001150';
UPDATE heslar SET razeni = 120, heslo = 'Kyrgyzstán', heslo_en = 'Kyrgyzstan', zkratka = 'KG', popis = '' WHERE ident_cely = 'HES-001297';
UPDATE heslar SET razeni = 120, heslo = 'střední paleolit', heslo_en = 'Middle Palaeolithic', zkratka = 'pa.sd', popis = '' WHERE ident_cely = 'HES-000274';
UPDATE heslar SET razeni = 120, heslo = 'vodní dílo', heslo_en = 'hydraulic structure', popis = '' WHERE ident_cely = 'HES-000094';
UPDATE heslar SET razeni = 120, heslo = 'vodní dílo', heslo_en = 'hydraulic structure', popis = 'prostor samostaného vodního díla' WHERE ident_cely = 'HES-000082';
UPDATE heslar SET razeni = 1200, heslo = 'doba římská', heslo_en = 'Roman Period', popis = '' WHERE ident_cely = 'HES-000406';
UPDATE heslar SET razeni = 1200, heslo = 'doba římská', heslo_en = 'Roman Period', zkratka = 'rim', popis = '' WHERE ident_cely = 'HES-000335';
UPDATE heslar SET razeni = 1200, heslo = 'ozdoba', heslo_en = 'adornment', popis = '' WHERE ident_cely = 'HES-000834';
UPDATE heslar SET razeni = 1200, heslo = 'ozdoba', heslo_en = 'adornment', popis = '' WHERE ident_cely = 'HES-000853';
UPDATE heslar SET razeni = 1200, heslo = 'přírodní útvar', heslo_en = 'natural landform', popis = '' WHERE ident_cely = 'HES-000470';
UPDATE heslar SET razeni = 1200, heslo = 'přírodní útvar', heslo_en = 'natural landform', popis = '' WHERE ident_cely = 'HES-000582';
UPDATE heslar SET razeni = 1201, heslo = 'erozní rýha', heslo_en = 'gully/ravine', popis = '' WHERE ident_cely = 'HES-000471';
UPDATE heslar SET razeni = 1201, heslo = 'gemma', heslo_en = 'gem', popis = '' WHERE ident_cely = 'HES-000731';
UPDATE heslar SET razeni = 1202, heslo = 'gombík', heslo_en = 'spherical button', popis = '' WHERE ident_cely = 'HES-000693';
UPDATE heslar SET razeni = 1202, heslo = 'jeskyně/skalní prostor', heslo_en = 'cave/abri', popis = '' WHERE ident_cely = 'HES-000472';
UPDATE heslar SET razeni = 1203, heslo = 'jehlice', heslo_en = 'clothing pin', popis = '' WHERE ident_cely = 'HES-000699';
UPDATE heslar SET razeni = 1203, heslo = 'pramen', heslo_en = 'spring', popis = '' WHERE ident_cely = 'HES-000473';
UPDATE heslar SET razeni = 1204, heslo = 'kaptorga', heslo_en = 'kaptorga (metal pendant case)', popis = '' WHERE ident_cely = 'HES-000700';
UPDATE heslar SET razeni = 1204, heslo = 'vodoteč', heslo_en = 'riverine water bodies', popis = '' WHERE ident_cely = 'HES-000474';
UPDATE heslar SET razeni = 1205, heslo = 'korálek', heslo_en = 'bead', popis = '' WHERE ident_cely = 'HES-000663';
UPDATE heslar SET razeni = 1205, heslo = 'vývrat', heslo_en = 'windthrow', popis = '' WHERE ident_cely = 'HES-000475';
UPDATE heslar SET razeni = 1206, heslo = 'křížek', heslo_en = 'cross', popis = '' WHERE ident_cely = 'HES-000664';
UPDATE heslar SET razeni = 1207, heslo = 'náhrdelník', heslo_en = 'necklace', popis = '' WHERE ident_cely = 'HES-000835';
UPDATE heslar SET razeni = 1208, heslo = 'nákrčník', heslo_en = 'neck ring', popis = '' WHERE ident_cely = 'HES-000665';
UPDATE heslar SET razeni = 1209, heslo = 'nánožník', heslo_en = 'anklet', popis = '' WHERE ident_cely = 'HES-000836';
UPDATE heslar SET razeni = 121, heslo = 'jez', heslo_en = 'weir', popis = '' WHERE ident_cely = 'HES-000052';
UPDATE heslar SET razeni = 121, heslo = 'Laos', heslo_en = 'Lao People''s Democratic Republic (the)', zkratka = 'LA', popis = '' WHERE ident_cely = 'HES-001298';
UPDATE heslar SET razeni = 121, heslo = 'moustérien', heslo_en = 'Mousterian', zkratka = 'pa.mou', popis = '' WHERE ident_cely = 'HES-000312';
UPDATE heslar SET razeni = 1210, heslo = 'nápažník', heslo_en = 'armlet', popis = '' WHERE ident_cely = 'HES-000812';
UPDATE heslar SET razeni = 1210, heslo = 'starší doba římská', heslo_en = 'Early Roman Period', zkratka = 'ri.st', popis = '' WHERE ident_cely = 'HES-000336';
UPDATE heslar SET razeni = 1211, heslo = 'náramek', heslo_en = 'bracelet', popis = '' WHERE ident_cely = 'HES-000666';
UPDATE heslar SET razeni = 1211, heslo = 'plaňanský typ', heslo_en = 'Plaňany Type', zkratka = 'ri.pla', popis = '' WHERE ident_cely = 'HES-000393';
UPDATE heslar SET razeni = 1212, heslo = 'náušnice', heslo_en = 'earring', popis = '' WHERE ident_cely = 'HES-000667';
UPDATE heslar SET razeni = 1213, heslo = 'nákončí', heslo_en = 'mordant', popis = '' WHERE ident_cely = 'HES-000668';
UPDATE heslar SET razeni = 1214, heslo = 'prsten', heslo_en = 'finger ring', popis = '' WHERE ident_cely = 'HES-000669';
UPDATE heslar SET razeni = 1215, heslo = 'přívěsek/závěsek', heslo_en = 'pendant', popis = '' WHERE ident_cely = 'HES-000837';
UPDATE heslar SET razeni = 1216, heslo = 'rolnička', heslo_en = 'jingle bell', popis = '' WHERE ident_cely = 'HES-000701';
UPDATE heslar SET razeni = 1217, heslo = 'růženec/medailon', heslo_en = 'rosary/medallion', popis = '' WHERE ident_cely = 'HES-000702';
UPDATE heslar SET razeni = 1218, heslo = 'řetízek', heslo_en = 'chain necklace', popis = '' WHERE ident_cely = 'HES-000756';
UPDATE heslar SET razeni = 1219, heslo = 'záušnice', heslo_en = 'temple ring', popis = '' WHERE ident_cely = 'HES-000838';
UPDATE heslar SET razeni = 122, heslo = 'kanál/náhon', heslo_en = 'channel/millrace', popis = '' WHERE ident_cely = 'HES-000053';
UPDATE heslar SET razeni = 122, heslo = 'Lesotho', heslo_en = 'Lesotho', zkratka = 'LS', popis = '' WHERE ident_cely = 'HES-001299';
UPDATE heslar SET razeni = 122, heslo = 'taubachien', heslo_en = 'Taubachian', zkratka = 'pa.tau', popis = '' WHERE ident_cely = 'HES-000313';
UPDATE heslar SET razeni = 1220, heslo = 'mladší doba římská', heslo_en = 'Late Roman Period', zkratka = 'ri.ml', popis = '' WHERE ident_cely = 'HES-000341';
UPDATE heslar SET razeni = 123, heslo = 'Libanon', heslo_en = 'Lebanon', zkratka = 'LB', popis = '' WHERE ident_cely = 'HES-001239';
UPDATE heslar SET razeni = 123, heslo = 'micoquien', heslo_en = 'Micoquien', zkratka = 'pa.mic', popis = '' WHERE ident_cely = 'HES-000292';
UPDATE heslar SET razeni = 123, heslo = 'přehrada', heslo_en = 'dam', popis = '' WHERE ident_cely = 'HES-000054';
UPDATE heslar SET razeni = 124, heslo = 'krumlovien', heslo_en = 'Krumlovian', zkratka = 'pa.kru', popis = '' WHERE ident_cely = 'HES-000314';
UPDATE heslar SET razeni = 124, heslo = 'Libérie', heslo_en = 'Liberia', zkratka = 'LR', popis = '' WHERE ident_cely = 'HES-001314';
UPDATE heslar SET razeni = 124, heslo = 'rybník', heslo_en = 'pond', popis = '' WHERE ident_cely = 'HES-000055';
UPDATE heslar SET razeni = 125, heslo = 'Libye', heslo_en = 'Libya', zkratka = 'LY', popis = '' WHERE ident_cely = 'HES-001308';
UPDATE heslar SET razeni = 126, heslo = 'Lichtenštejnsko', heslo_en = 'Liechtenstein', zkratka = 'LI', popis = '' WHERE ident_cely = 'HES-001371';
UPDATE heslar SET razeni = 127, heslo = 'Litva', heslo_en = 'Lithuania', zkratka = 'LT', popis = '' WHERE ident_cely = 'HES-001372';
UPDATE heslar SET razeni = 128, heslo = 'Lotyšsko', heslo_en = 'Latvia', zkratka = 'LV', popis = '' WHERE ident_cely = 'HES-001288';
UPDATE heslar SET razeni = 129, heslo = 'Lucembursko', heslo_en = 'Luxembourg', zkratka = 'LU', popis = '' WHERE ident_cely = 'HES-001289';
UPDATE heslar SET razeni = 13, heslo = '3D – Autodesk Exchange (*.fbx)', heslo_en = '3D – Autodesk Exchange (*.fbx)', popis = '' WHERE ident_cely = 'HES-000153';
UPDATE heslar SET razeni = 13, heslo = 'Argentina', heslo_en = 'Argentina', zkratka = 'AR', popis = '' WHERE ident_cely = 'HES-001190';
UPDATE heslar SET razeni = 13, heslo = 'data vektorového plánu', heslo_en = 'vector plan data', popis = '' WHERE ident_cely = 'HES-001087';
UPDATE heslar SET razeni = 13, heslo = 'diatomární analýza', heslo_en = 'diatomic analysis', popis = 'Analýza přítomnosti rozsivek (diatoma) v zamokřených archeologických kontextech.' WHERE ident_cely = 'HES-000610';
UPDATE heslar SET razeni = 13, heslo = 'Jihlava-Henčov', heslo_en = 'Jihlava-Henčov', popis = '' WHERE ident_cely = 'HES-000195';
UPDATE heslar SET razeni = 13, heslo = 'kámen stavební', heslo_en = 'building stone', popis = '' WHERE ident_cely = 'HES-000977';
UPDATE heslar SET razeni = 13, heslo = 'negativ černobílý (sklo)', heslo_en = 'black-and-white negative (glass)', zkratka = 'neg-čb-sklo', popis = '' WHERE ident_cely = 'HES-000229';
UPDATE heslar SET razeni = 13, heslo = 'ohrazení pravoúhlé velké', heslo_en = 'rectangular enclosure (large)', popis = '' WHERE ident_cely = 'HES-001040';
UPDATE heslar SET razeni = 13, heslo = 'plány', heslo_en = 'plans', zkratka = 'PY', popis = '' WHERE ident_cely = 'HES-000881';
UPDATE heslar SET razeni = 13, heslo = 'skupina sond', heslo_en = 'group of pit trenches', popis = '' WHERE ident_cely = 'HES-001151';
UPDATE heslar SET razeni = 13, heslo = 'stanice/tábořiště', heslo_en = 'camp', popis = '' WHERE ident_cely = 'HES-000066';
UPDATE heslar SET razeni = 130, heslo = 'areál jiné aktivity', heslo_en = 'other site', popis = '' WHERE ident_cely = 'HES-000056';
UPDATE heslar SET razeni = 130, heslo = 'areál jiné aktivity', heslo_en = 'other site', popis = '' WHERE ident_cely = 'HES-000095';
UPDATE heslar SET razeni = 130, heslo = 'Macao', heslo_en = 'Macao', zkratka = 'MO', popis = '' WHERE ident_cely = 'HES-001351';
UPDATE heslar SET razeni = 130, heslo = 'mladší paleolit', heslo_en = 'Upper Palaeolithic', zkratka = 'pa.ml', popis = '' WHERE ident_cely = 'HES-000315';
UPDATE heslar SET razeni = 1300, heslo = 'doba laténská–římská', heslo_en = 'La Tène–Roman Period', popis = '' WHERE ident_cely = 'HES-000407';
UPDATE heslar SET razeni = 1300, heslo = 'doba laténská–římská', heslo_en = 'La Tène–Roman Period', zkratka = 'la-ri', popis = '' WHERE ident_cely = 'HES-000288';
UPDATE heslar SET razeni = 1300, heslo = 'písemnost', heslo_en = 'written document', popis = '' WHERE ident_cely = 'HES-000839';
UPDATE heslar SET razeni = 1300, heslo = 'písemnost', heslo_en = 'written document', popis = '' WHERE ident_cely = 'HES-000854';
UPDATE heslar SET razeni = 1300, heslo = 'pyrotechnologické zařízení', heslo_en = 'pyrotechnological device', popis = '' WHERE ident_cely = 'HES-000476';
UPDATE heslar SET razeni = 1300, heslo = 'pyrotechnologické zařízení', heslo_en = 'pyrotechnological device', popis = '' WHERE ident_cely = 'HES-000583';
UPDATE heslar SET razeni = 1301, heslo = 'kniha', heslo_en = 'book', popis = '' WHERE ident_cely = 'HES-000840';
UPDATE heslar SET razeni = 1301, heslo = 'milíř', heslo_en = 'charcoal kiln', popis = '' WHERE ident_cely = 'HES-000554';
UPDATE heslar SET razeni = 1302, heslo = 'listina', heslo_en = 'deed', popis = '' WHERE ident_cely = 'HES-000670';
UPDATE heslar SET razeni = 1302, heslo = 'pec', heslo_en = 'kiln', popis = '' WHERE ident_cely = 'HES-000477';
UPDATE heslar SET razeni = 1303, heslo = 'pec cihlářská', heslo_en = 'brick oven', popis = '' WHERE ident_cely = 'HES-000548';
UPDATE heslar SET razeni = 1304, heslo = 'pec dehtářská', heslo_en = 'tar pit', popis = '' WHERE ident_cely = 'HES-000549';
UPDATE heslar SET razeni = 1305, heslo = 'pec hrnčířská', heslo_en = 'pottery kiln', popis = '' WHERE ident_cely = 'HES-000550';
UPDATE heslar SET razeni = 1306, heslo = 'pec hutnická', heslo_en = 'iron-smelting furnace', popis = '' WHERE ident_cely = 'HES-000551';
UPDATE heslar SET razeni = 1307, heslo = 'pec chlebová', heslo_en = 'bake oven', popis = '' WHERE ident_cely = 'HES-000552';
UPDATE heslar SET razeni = 1308, heslo = 'pec kovolitecká', heslo_en = 'foundry', popis = '' WHERE ident_cely = 'HES-000553';
UPDATE heslar SET razeni = 1309, heslo = 'pec sklářská', heslo_en = 'glass furnace', popis = '' WHERE ident_cely = 'HES-000555';
UPDATE heslar SET razeni = 131, heslo = 'Madagaskar', heslo_en = 'Madagascar', zkratka = 'MG', popis = '' WHERE ident_cely = 'HES-001352';
UPDATE heslar SET razeni = 131, heslo = 'místo sběru', heslo_en = 'collection site', popis = '' WHERE ident_cely = 'HES-000057';
UPDATE heslar SET razeni = 131, heslo = 'szeletien', heslo_en = 'Szeletian', zkratka = 'pa.sze', popis = '' WHERE ident_cely = 'HES-000260';
UPDATE heslar SET razeni = 1310, heslo = 'pec vápenická', heslo_en = 'lime kiln', popis = '' WHERE ident_cely = 'HES-000556';
UPDATE heslar SET razeni = 1311, heslo = 'kovářská výheň', heslo_en = 'forge', popis = '' WHERE ident_cely = 'HES-000557';
UPDATE heslar SET razeni = 132, heslo = 'bohunicien', heslo_en = 'Bohunician', zkratka = 'pa.boh', popis = '' WHERE ident_cely = 'HES-000261';
UPDATE heslar SET razeni = 132, heslo = 'Maďarsko', heslo_en = 'Hungary', zkratka = 'HU', popis = '' WHERE ident_cely = 'HES-001374';
UPDATE heslar SET razeni = 132, heslo = 'popraviště', heslo_en = 'execution site', popis = '' WHERE ident_cely = 'HES-000058';
UPDATE heslar SET razeni = 133, heslo = 'aurignacien', heslo_en = 'Aurignacian', zkratka = 'pa.aur', popis = '' WHERE ident_cely = 'HES-000262';
UPDATE heslar SET razeni = 133, heslo = 'park', heslo_en = 'park', popis = '' WHERE ident_cely = 'HES-000059';
UPDATE heslar SET razeni = 133, heslo = 'Severní Makedonie', heslo_en = 'North Macedonia', zkratka = 'MK', popis = '' WHERE ident_cely = 'HES-001375';
UPDATE heslar SET razeni = 134, heslo = 'Malajsie', heslo_en = 'Malaysia', zkratka = 'MY', popis = '' WHERE ident_cely = 'HES-001327';
UPDATE heslar SET razeni = 134, heslo = 'miškovický typ', heslo_en = 'Míškovice Type', zkratka = 'pa.mis', popis = '' WHERE ident_cely = 'HES-000282';
UPDATE heslar SET razeni = 135, heslo = 'gravettien', heslo_en = 'Gravettian', zkratka = 'pa.gra', popis = '' WHERE ident_cely = 'HES-000311';
UPDATE heslar SET razeni = 135, heslo = 'Malawi', heslo_en = 'Malawi', zkratka = 'MW', popis = '' WHERE ident_cely = 'HES-001310';
UPDATE heslar SET razeni = 136, heslo = 'magdalénien', heslo_en = 'Magdalenian', zkratka = 'pa.mag', popis = '' WHERE ident_cely = 'HES-000283';
UPDATE heslar SET razeni = 136, heslo = 'Maledivy', heslo_en = 'Maldives', zkratka = 'MV', popis = '' WHERE ident_cely = 'HES-001397';
UPDATE heslar SET razeni = 137, heslo = 'epigravettien', heslo_en = 'Epigravettian', zkratka = 'pa.epg', popis = '' WHERE ident_cely = 'HES-000263';
UPDATE heslar SET razeni = 137, heslo = 'Mali', heslo_en = 'Mali', zkratka = 'ML', popis = '' WHERE ident_cely = 'HES-001205';
UPDATE heslar SET razeni = 138, heslo = 'Malta', heslo_en = 'Malta', zkratka = 'MT', popis = '' WHERE ident_cely = 'HES-001366';
UPDATE heslar SET razeni = 139, heslo = 'Man', heslo_en = 'Isle of Man', zkratka = 'IM', popis = '' WHERE ident_cely = 'HES-001206';
UPDATE heslar SET razeni = 14, heslo = '3D – Blender (*.blend)', heslo_en = '3D – Blender (*.blend)', popis = '' WHERE ident_cely = 'HES-000154';
UPDATE heslar SET razeni = 14, heslo = 'Arménie', heslo_en = 'Armenia', zkratka = 'AM', popis = '' WHERE ident_cely = 'HES-001191';
UPDATE heslar SET razeni = 14, heslo = 'fotografie konzervace', heslo_en = 'photograph of conservation', popis = '' WHERE ident_cely = 'HES-001097';
UPDATE heslar SET razeni = 14, heslo = 'fytolitová analýza', heslo_en = 'phytological analysis', popis = 'Metoda zabývající fytolity (vápenatými rostlinnými zbytky) v archeologických kontextech.' WHERE ident_cely = 'HES-000612';
UPDATE heslar SET razeni = 14, heslo = 'geofyzikální průzkum', heslo_en = 'geophysical survey', popis = '' WHERE ident_cely = 'HES-001046';
UPDATE heslar SET razeni = 14, heslo = 'kámen štípaný', heslo_en = 'lithics', popis = '' WHERE ident_cely = 'HES-000978';
UPDATE heslar SET razeni = 14, heslo = 'Karlovy Vary', heslo_en = 'Karlovy Vary', popis = '' WHERE ident_cely = 'HES-000196';
UPDATE heslar SET razeni = 14, heslo = 'ohrazení polygonální malé', heslo_en = 'polygonal enclosure (small)', popis = '' WHERE ident_cely = 'HES-001041';
UPDATE heslar SET razeni = 14, heslo = 'papír', heslo_en = 'paper', popis = '' WHERE ident_cely = 'HES-000230';
UPDATE heslar SET razeni = 14, heslo = 'plány (digitální)', heslo_en = 'plans (digital)', zkratka = 'DY', popis = '' WHERE ident_cely = 'HES-000875';
UPDATE heslar SET razeni = 14, heslo = 'samostatná usedlost', heslo_en = 'individual homestead', popis = '' WHERE ident_cely = 'HES-000067';
UPDATE heslar SET razeni = 140, heslo = 'Maroko', heslo_en = 'Morocco', zkratka = 'MA', popis = '' WHERE ident_cely = 'HES-001208';
UPDATE heslar SET razeni = 140, heslo = 'pozdní paleolit', heslo_en = 'Epipalaeolithic', zkratka = 'pa.po', popis = '' WHERE ident_cely = 'HES-000264';
UPDATE heslar SET razeni = 1400, heslo = 'doba stěhování národů', heslo_en = 'Migration Period', popis = '' WHERE ident_cely = 'HES-000408';
UPDATE heslar SET razeni = 1400, heslo = 'doba stěhování národů', heslo_en = 'Migration Period', zkratka = 'snarod', popis = '' WHERE ident_cely = 'HES-000342';
UPDATE heslar SET razeni = 1400, heslo = 'postroj/doprava', heslo_en = 'harness/transportation', popis = '' WHERE ident_cely = 'HES-000742';
UPDATE heslar SET razeni = 1400, heslo = 'postroj/doprava', heslo_en = 'harness/transportation', popis = '' WHERE ident_cely = 'HES-000855';
UPDATE heslar SET razeni = 1400, heslo = 'těžební objekt', heslo_en = 'mining feature', popis = '' WHERE ident_cely = 'HES-000558';
UPDATE heslar SET razeni = 1400, heslo = 'těžební objekt', heslo_en = 'mining feature', popis = '' WHERE ident_cely = 'HES-000584';
UPDATE heslar SET razeni = 1401, heslo = 'brusle', heslo_en = 'ice skate', popis = '' WHERE ident_cely = 'HES-000743';
UPDATE heslar SET razeni = 1401, heslo = 'místo těžby', heslo_en = 'extracting place', popis = '' WHERE ident_cely = 'HES-000559';
UPDATE heslar SET razeni = 1402, heslo = 'člun', heslo_en = 'boat', popis = '' WHERE ident_cely = 'HES-000744';
UPDATE heslar SET razeni = 1402, heslo = 'lom', heslo_en = 'quarry', popis = '' WHERE ident_cely = 'HES-000560';
UPDATE heslar SET razeni = 1403, heslo = 'faléra', heslo_en = 'phalera', popis = '' WHERE ident_cely = 'HES-000745';
UPDATE heslar SET razeni = 1403, heslo = 'obval', heslo_en = 'spoil bank', popis = '' WHERE ident_cely = 'HES-000561';
UPDATE heslar SET razeni = 1404, heslo = 'pinka', heslo_en = 'binge', popis = '' WHERE ident_cely = 'HES-000562';
UPDATE heslar SET razeni = 1404, heslo = 'podkova', heslo_en = 'horseshoe', popis = '' WHERE ident_cely = 'HES-000746';
UPDATE heslar SET razeni = 1405, heslo = 'sejp/halda', heslo_en = 'spoil heap', popis = '' WHERE ident_cely = 'HES-000563';
UPDATE heslar SET razeni = 1405, heslo = 'součást postroje', heslo_en = 'harness component', popis = '' WHERE ident_cely = 'HES-000747';
UPDATE heslar SET razeni = 1406, heslo = 'součást vozu', heslo_en = 'cargo vehicle component', popis = '' WHERE ident_cely = 'HES-000703';
UPDATE heslar SET razeni = 1406, heslo = 'šachta', heslo_en = 'shaft', popis = '' WHERE ident_cely = 'HES-000564';
UPDATE heslar SET razeni = 1407, heslo = 'štola', heslo_en = 'adit', popis = '' WHERE ident_cely = 'HES-000565';
UPDATE heslar SET razeni = 1407, heslo = 'třmen', heslo_en = 'stirrup', popis = '' WHERE ident_cely = 'HES-000671';
UPDATE heslar SET razeni = 1408, heslo = 'těžební jáma', heslo_en = 'mining pit', popis = '' WHERE ident_cely = 'HES-000566';
UPDATE heslar SET razeni = 1408, heslo = 'udidlo', heslo_en = 'bridle bit', popis = '' WHERE ident_cely = 'HES-000672';
UPDATE heslar SET razeni = 141, heslo = 'epimagdalénien', heslo_en = 'Epimagdalenian', zkratka = 'pa.epm', popis = '' WHERE ident_cely = 'HES-000265';
UPDATE heslar SET razeni = 141, heslo = 'Marshallovy ostrovy', heslo_en = 'Marshall Islands (the)', zkratka = 'MH', popis = '' WHERE ident_cely = 'HES-001267';
UPDATE heslar SET razeni = 1410, heslo = 'starší doba stěhování národů', heslo_en = 'Early Migration Period', zkratka = 'sn.st', popis = '' WHERE ident_cely = 'HES-000343';
UPDATE heslar SET razeni = 1411, heslo = 'dobrodzieńská skupina', heslo_en = 'Dobrodzień Group', zkratka = 'sn.dob', popis = '' WHERE ident_cely = 'HES-000344';
UPDATE heslar SET razeni = 142, heslo = 'Martinik', heslo_en = 'Martinique', zkratka = 'MQ', popis = '' WHERE ident_cely = 'HES-001403';
UPDATE heslar SET razeni = 142, heslo = 'ostroměřská skupina', heslo_en = 'Ostroměř Group', zkratka = 'pa.ost', popis = '' WHERE ident_cely = 'HES-000266';
UPDATE heslar SET razeni = 1420, heslo = 'mladší doba stěhování národů', heslo_en = 'Late Migration Period', zkratka = 'sn.ml', popis = '' WHERE ident_cely = 'HES-000345';
UPDATE heslar SET razeni = 143, heslo = 'Mauricius', heslo_en = 'Mauritius', zkratka = 'MU', popis = '' WHERE ident_cely = 'HES-001238';
UPDATE heslar SET razeni = 144, heslo = 'Mauritánie', heslo_en = 'Mauritania', zkratka = 'MR', popis = '' WHERE ident_cely = 'HES-001325';
UPDATE heslar SET razeni = 145, heslo = 'Mayotte', heslo_en = 'Mayotte', zkratka = 'YT', popis = '' WHERE ident_cely = 'HES-001389';
UPDATE heslar SET razeni = 146, heslo = 'Menší odlehlé ostrovy USA', heslo_en = 'United States Minor Outlying Islands (the)', zkratka = 'UM', popis = '' WHERE ident_cely = 'HES-001247';
UPDATE heslar SET razeni = 147, heslo = 'Mexiko', heslo_en = 'Mexico', zkratka = 'MX', popis = '' WHERE ident_cely = 'HES-001210';
UPDATE heslar SET razeni = 148, heslo = 'Mikronésie', heslo_en = 'Micronesia (Federated States of)', zkratka = 'FM', popis = '' WHERE ident_cely = 'HES-001211';
UPDATE heslar SET razeni = 149, heslo = 'Moldavsko', heslo_en = 'Moldova (the Republic of)', zkratka = 'MD', popis = '' WHERE ident_cely = 'HES-001269';
UPDATE heslar SET razeni = 15, heslo = '3D – Collada (*.dae)', heslo_en = '3D – Collada (*.dae)', popis = '' WHERE ident_cely = 'HES-000155';
UPDATE heslar SET razeni = 15, heslo = 'Aruba', heslo_en = 'Aruba', zkratka = 'AW', popis = '' WHERE ident_cely = 'HES-001192';
UPDATE heslar SET razeni = 15, heslo = 'fotografie krajiny', heslo_en = 'photograph of landscape', popis = '' WHERE ident_cely = 'HES-001088';
UPDATE heslar SET razeni = 15, heslo = 'keramika', heslo_en = 'ceramic', popis = '' WHERE ident_cely = 'HES-000979';
UPDATE heslar SET razeni = 15, heslo = 'Kladno', heslo_en = 'Kladno', popis = '' WHERE ident_cely = 'HES-000197';
UPDATE heslar SET razeni = 15, heslo = 'makrozbytková analýza', heslo_en = 'macroremains analysis', popis = 'Metoda zabývající se rostlinnými makrozbytky (semena, plody, plévy, sláma, listy atd.) v archeologických kontextech.' WHERE ident_cely = 'HES-000620';
UPDATE heslar SET razeni = 15, heslo = 'ohrazení polygonální střední', heslo_en = 'polygonal enclosure (medium)', popis = '' WHERE ident_cely = 'HES-001042';
UPDATE heslar SET razeni = 15, heslo = 'papír kladívkový', heslo_en = 'drawing paper', popis = '' WHERE ident_cely = 'HES-000231';
UPDATE heslar SET razeni = 15, heslo = 'vesnice/městečko', heslo_en = 'village/town', popis = '' WHERE ident_cely = 'HES-000068';
UPDATE heslar SET razeni = 150, heslo = 'Monako', heslo_en = 'Monaco', zkratka = 'MC', popis = '' WHERE ident_cely = 'HES-001270';
UPDATE heslar SET razeni = 150, heslo = 'neurčený areál', heslo_en = 'unspecified site', popis = '' WHERE ident_cely = 'HES-000096';
UPDATE heslar SET razeni = 150, heslo = 'neurčený areál', heslo_en = 'unspecified site', popis = 'areál, jehož původní funkci nelze určit' WHERE ident_cely = 'HES-000060';
UPDATE heslar SET razeni = 1500, heslo = 'doba římská–stěhování národů', heslo_en = 'Roman–Migration Period', popis = '' WHERE ident_cely = 'HES-000409';
UPDATE heslar SET razeni = 1500, heslo = 'doba římská–stěhování národů', heslo_en = 'Roman–Migration Period', zkratka = 'ri-sn', popis = '' WHERE ident_cely = 'HES-000346';
UPDATE heslar SET razeni = 1500, heslo = 'součást hrobu', heslo_en = 'grave component', popis = '' WHERE ident_cely = 'HES-000673';
UPDATE heslar SET razeni = 1500, heslo = 'součást hrobu', heslo_en = 'grave component', popis = '' WHERE ident_cely = 'HES-000856';
UPDATE heslar SET razeni = 1501, heslo = 'rakev', heslo_en = 'coffin', popis = '' WHERE ident_cely = 'HES-000704';
UPDATE heslar SET razeni = 1502, heslo = 'stéla', heslo_en = 'stela', popis = '' WHERE ident_cely = 'HES-000688';
UPDATE heslar SET razeni = 151, heslo = 'Mongolsko', heslo_en = 'Mongolia', zkratka = 'MN', popis = '' WHERE ident_cely = 'HES-001240';
UPDATE heslar SET razeni = 151, heslo = 'nález v druhotné poloze', heslo_en = 'find in secondary context', popis = 'prostor s nálezy přemístěnými postdepozičními procesy' WHERE ident_cely = 'HES-000061';
UPDATE heslar SET razeni = 152, heslo = 'Montserrat', heslo_en = 'Montserrat', zkratka = 'MS', popis = '' WHERE ident_cely = 'HES-001241';
UPDATE heslar SET razeni = 152, heslo = 'ojedinělý nález', heslo_en = 'single find', popis = '' WHERE ident_cely = 'HES-000062';
UPDATE heslar SET razeni = 153, heslo = 'Mosambik', heslo_en = 'Mozambique', zkratka = 'MZ', popis = '' WHERE ident_cely = 'HES-001294';
UPDATE heslar SET razeni = 153, heslo = 'zničený prostor', heslo_en = 'destroyed site', popis = 'prostor zničený bez archeologické evidence' WHERE ident_cely = 'HES-000063';
UPDATE heslar SET razeni = 154, heslo = 'Myanmar', heslo_en = 'Myanmar', zkratka = 'MM', popis = '' WHERE ident_cely = 'HES-001356';
UPDATE heslar SET razeni = 155, heslo = 'Namibie', heslo_en = 'Namibia', zkratka = 'NA', popis = '' WHERE ident_cely = 'HES-001213';
UPDATE heslar SET razeni = 156, heslo = 'Nauru', heslo_en = 'Nauru', zkratka = 'NR', popis = '' WHERE ident_cely = 'HES-001346';
UPDATE heslar SET razeni = 157, heslo = 'Německo', heslo_en = 'Germany', zkratka = 'DE', popis = '' WHERE ident_cely = 'HES-001358';
UPDATE heslar SET razeni = 158, heslo = 'Nepál', heslo_en = 'Nepal', zkratka = 'NP', popis = '' WHERE ident_cely = 'HES-001204';
UPDATE heslar SET razeni = 159, heslo = 'Niger', heslo_en = 'Niger (the)', zkratka = 'NE', popis = '' WHERE ident_cely = 'HES-001273';
UPDATE heslar SET razeni = 16, heslo = '3D – Leica (*.pts, *.ptx)', heslo_en = '3D – Leica (*.pts, *.ptx)', popis = '' WHERE ident_cely = 'HES-000156';
UPDATE heslar SET razeni = 16, heslo = 'Austrálie', heslo_en = 'Australia', zkratka = 'AU', popis = '' WHERE ident_cely = 'HES-001193';
UPDATE heslar SET razeni = 16, heslo = 'fotografie lokality', heslo_en = 'photograph of site', popis = '' WHERE ident_cely = 'HES-001089';
UPDATE heslar SET razeni = 16, heslo = 'geochemický průzkum', heslo_en = 'geochemical survey', popis = '' WHERE ident_cely = 'HES-001047';
UPDATE heslar SET razeni = 16, heslo = 'keramika fajáns/majolika', heslo_en = 'faience/maiolica', popis = '' WHERE ident_cely = 'HES-000980';
UPDATE heslar SET razeni = 16, heslo = 'Kolín', heslo_en = 'Kolín', popis = '' WHERE ident_cely = 'HES-000198';
UPDATE heslar SET razeni = 16, heslo = 'ohrazení polygonální velké', heslo_en = 'polygonal enclosure (large)', popis = '' WHERE ident_cely = 'HES-001043';
UPDATE heslar SET razeni = 16, heslo = 'osteozoologie', heslo_en = 'osteozoology', popis = 'Zabývá se studiem zvířecích kostí.' WHERE ident_cely = 'HES-001440';
UPDATE heslar SET razeni = 16, heslo = 'papír milimetrový', heslo_en = 'graph paper', popis = '' WHERE ident_cely = 'HES-000212';
UPDATE heslar SET razeni = 16, heslo = 'výšinné sídliště', heslo_en = 'hill settlement', popis = 'vyčleněno polohou, potenciálně zvláštní funkce/komunita' WHERE ident_cely = 'HES-000069';
UPDATE heslar SET razeni = 160, heslo = 'Nigérie', heslo_en = 'Nigeria', zkratka = 'NG', popis = '' WHERE ident_cely = 'HES-001274';
UPDATE heslar SET razeni = 1600, heslo = 'nespecifikovaný reliéfní útvar', heslo_en = 'unspecified terrain feature', popis = '' WHERE ident_cely = 'HES-000567';
UPDATE heslar SET razeni = 1600, heslo = 'nespecifikovaný reliéfní útvar', heslo_en = 'unspecified terrain feature', popis = '' WHERE ident_cely = 'HES-000585';
UPDATE heslar SET razeni = 1600, heslo = 'součást oděvu', heslo_en = 'costume component', popis = '' WHERE ident_cely = 'HES-000674';
UPDATE heslar SET razeni = 1600, heslo = 'součást oděvu', heslo_en = 'costume component', popis = '' WHERE ident_cely = 'HES-000857';
UPDATE heslar SET razeni = 1600, heslo = 'zemědělský pravěk', heslo_en = 'farming prehistory', zkratka = 'pr.zem', popis = '' WHERE ident_cely = 'HES-000304';
UPDATE heslar SET razeni = 1601, heslo = 'knoflík', heslo_en = 'button', popis = '' WHERE ident_cely = 'HES-000675';
UPDATE heslar SET razeni = 1601, heslo = 'převýšená plocha', heslo_en = 'mound', popis = '' WHERE ident_cely = 'HES-000536';
UPDATE heslar SET razeni = 1602, heslo = 'nátepní destička', heslo_en = 'wrist guard', popis = '' WHERE ident_cely = 'HES-000734';
UPDATE heslar SET razeni = 1602, heslo = 'zahloubená plocha', heslo_en = 'depression', popis = '' WHERE ident_cely = 'HES-000537';
UPDATE heslar SET razeni = 1603, heslo = 'lineární převýšený útvar', heslo_en = 'linear mound', popis = '' WHERE ident_cely = 'HES-000538';
UPDATE heslar SET razeni = 1603, heslo = 'obuv', heslo_en = 'footwear', popis = '' WHERE ident_cely = 'HES-000735';
UPDATE heslar SET razeni = 1604, heslo = 'lineární zahloubený útvar', heslo_en = 'linear depression', popis = '' WHERE ident_cely = 'HES-000539';
UPDATE heslar SET razeni = 1604, heslo = 'opasek', heslo_en = 'belt', popis = '' WHERE ident_cely = 'HES-000676';
UPDATE heslar SET razeni = 1605, heslo = 'neklidný terén', heslo_en = 'uneven surface', popis = '' WHERE ident_cely = 'HES-000568';
UPDATE heslar SET razeni = 1605, heslo = 'pochva/pouzdro', heslo_en = 'sheath', popis = '' WHERE ident_cely = 'HES-000677';
UPDATE heslar SET razeni = 1606, heslo = 'plošina', heslo_en = 'platform', popis = '' WHERE ident_cely = 'HES-000569';
UPDATE heslar SET razeni = 1606, heslo = 'průvlečka', heslo_en = 'clothing buckle', popis = '' WHERE ident_cely = 'HES-000683';
UPDATE heslar SET razeni = 1607, heslo = 'přezka', heslo_en = 'buckle', popis = '' WHERE ident_cely = 'HES-000732';
UPDATE heslar SET razeni = 1607, heslo = 'terénní hrana', heslo_en = 'terrain edge', popis = '' WHERE ident_cely = 'HES-000570';
UPDATE heslar SET razeni = 1608, heslo = 'spona', heslo_en = 'fibula', popis = '' WHERE ident_cely = 'HES-000733';
UPDATE heslar SET razeni = 1609, heslo = 'zápona', heslo_en = 'clasp', popis = '' WHERE ident_cely = 'HES-000637';
UPDATE heslar SET razeni = 161, heslo = 'Nikaragua', heslo_en = 'Nicaragua', zkratka = 'NI', popis = '' WHERE ident_cely = 'HES-001229';
UPDATE heslar SET razeni = 1610, heslo = 'zavazadlo', heslo_en = 'luggage', popis = '' WHERE ident_cely = 'HES-000638';
UPDATE heslar SET razeni = 162, heslo = 'Niue', heslo_en = 'Niue', zkratka = 'NU', popis = '' WHERE ident_cely = 'HES-001279';
UPDATE heslar SET razeni = 163, heslo = 'Nizozemsko', heslo_en = 'Netherlands (the)', zkratka = 'NL', popis = '' WHERE ident_cely = 'HES-001230';
UPDATE heslar SET razeni = 164, heslo = 'Norfolk', heslo_en = 'Norfolk Island', zkratka = 'NF', popis = '' WHERE ident_cely = 'HES-001231';
UPDATE heslar SET razeni = 165, heslo = 'Norsko', heslo_en = 'Norway', zkratka = 'NO', popis = '' WHERE ident_cely = 'HES-001290';
UPDATE heslar SET razeni = 166, heslo = 'Nová Kaledonie', heslo_en = 'New Caledonia', zkratka = 'NC', popis = '' WHERE ident_cely = 'HES-001263';
UPDATE heslar SET razeni = 167, heslo = 'Nový Zéland', heslo_en = 'New Zealand', zkratka = 'NZ', popis = '' WHERE ident_cely = 'HES-001209';
UPDATE heslar SET razeni = 168, heslo = 'Omán', heslo_en = 'Oman', zkratka = 'OM', popis = '' WHERE ident_cely = 'HES-001223';
UPDATE heslar SET razeni = 169, heslo = 'Pákistán', heslo_en = 'Pakistan', zkratka = 'PK', popis = '' WHERE ident_cely = 'HES-001224';
UPDATE heslar SET razeni = 17, heslo = '3D – OBJ (*.obj)', heslo_en = '3D – OBJ (*.obj)', popis = '' WHERE ident_cely = 'HES-000157';
UPDATE heslar SET razeni = 17, heslo = 'Ázerbájdžán', heslo_en = 'Azerbaijan', zkratka = 'AZ', popis = '' WHERE ident_cely = 'HES-001194';
UPDATE heslar SET razeni = 17, heslo = 'fotografie objektu', heslo_en = 'photograph of feature', popis = '' WHERE ident_cely = 'HES-001094';
UPDATE heslar SET razeni = 17, heslo = 'keramika kamenina', heslo_en = 'stoneware', popis = '' WHERE ident_cely = 'HES-000981';
UPDATE heslar SET razeni = 17, heslo = 'Krakow', heslo_en = 'Krakow', popis = '' WHERE ident_cely = 'HES-000199';
UPDATE heslar SET razeni = 17, heslo = 'palynologie', heslo_en = 'palynology', popis = 'Metoda, která zkoumá a interpretuje přítomnost pylových zrn v archeologických kontextech.' WHERE ident_cely = 'HES-000625';
UPDATE heslar SET razeni = 17, heslo = 'papír s fotografiemi', heslo_en = 'paper with photographs', popis = '' WHERE ident_cely = 'HES-000213';
UPDATE heslar SET razeni = 17, heslo = 'sídliště specializované komunity', heslo_en = 'special-community settlement', popis = 'hornické sídliště, kasárna, komenda' WHERE ident_cely = 'HES-000070';
UPDATE heslar SET razeni = 170, heslo = 'Palau', heslo_en = 'Palau', zkratka = 'PW', popis = '' WHERE ident_cely = 'HES-001387';
UPDATE heslar SET razeni = 1700, heslo = 'pravěk', heslo_en = 'prehistory', popis = '' WHERE ident_cely = 'HES-000411';
UPDATE heslar SET razeni = 1700, heslo = 'pravěk', heslo_en = 'prehistory', zkratka = 'pravek', popis = '' WHERE ident_cely = 'HES-000289';
UPDATE heslar SET razeni = 1700, heslo = 'stavební/spojovací prvek', heslo_en = 'structural element component', popis = '' WHERE ident_cely = 'HES-000757';
UPDATE heslar SET razeni = 1700, heslo = 'stavební/spojovací prvek', heslo_en = 'structural element component', popis = '' WHERE ident_cely = 'HES-000858';
UPDATE heslar SET razeni = 1701, heslo = 'cihla', heslo_en = 'brick', popis = '' WHERE ident_cely = 'HES-000813';
UPDATE heslar SET razeni = 1702, heslo = 'dlaždice', heslo_en = 'floor tile', popis = '' WHERE ident_cely = 'HES-000678';
UPDATE heslar SET razeni = 1703, heslo = 'hřeb/hřebík/nýt', heslo_en = 'nail/rivet', popis = '' WHERE ident_cely = 'HES-000679';
UPDATE heslar SET razeni = 1704, heslo = 'kachel', heslo_en = 'stove tile', popis = '' WHERE ident_cely = 'HES-000736';
UPDATE heslar SET razeni = 1706, heslo = 'kůl', heslo_en = 'pole', popis = '' WHERE ident_cely = 'HES-000737';
UPDATE heslar SET razeni = 1707, heslo = 'okenní výplň', heslo_en = 'window panes', popis = '' WHERE ident_cely = 'HES-000738';
UPDATE heslar SET razeni = 1708, heslo = 'omítka', heslo_en = 'plaster', popis = '' WHERE ident_cely = 'HES-000739';
UPDATE heslar SET razeni = 1709, heslo = 'pojivo', heslo_en = 'binder', popis = '' WHERE ident_cely = 'HES-000740';
UPDATE heslar SET razeni = 171, heslo = 'Palestina', heslo_en = 'Palestine, State of', zkratka = 'PS', popis = '' WHERE ident_cely = 'HES-001368';
UPDATE heslar SET razeni = 1710, heslo = 'potrubí', heslo_en = 'plumbing pipe', popis = '' WHERE ident_cely = 'HES-000741';
UPDATE heslar SET razeni = 1711, heslo = 'prejz', heslo_en = 'pantile', popis = '' WHERE ident_cely = 'HES-000773';
UPDATE heslar SET razeni = 1712, heslo = 'prkno/fošna', heslo_en = 'board/plank', popis = '' WHERE ident_cely = 'HES-000687';
UPDATE heslar SET razeni = 1713, heslo = 'řetěz', heslo_en = 'chain', popis = '' WHERE ident_cely = 'HES-000814';
UPDATE heslar SET razeni = 1714, heslo = 'střešní krytina', heslo_en = 'roofing tile', popis = '' WHERE ident_cely = 'HES-000815';
UPDATE heslar SET razeni = 1715, heslo = 'trám', heslo_en = 'beam', popis = '' WHERE ident_cely = 'HES-000816';
UPDATE heslar SET razeni = 1716, heslo = 'zámek', heslo_en = 'lock', popis = '' WHERE ident_cely = 'HES-000817';
UPDATE heslar SET razeni = 172, heslo = 'Panama', heslo_en = 'Panama', zkratka = 'PA', popis = '' WHERE ident_cely = 'HES-001369';
UPDATE heslar SET razeni = 173, heslo = 'Papua Nová Guinea', heslo_en = 'Papua New Guinea', zkratka = 'PG', popis = '' WHERE ident_cely = 'HES-001370';
UPDATE heslar SET razeni = 174, heslo = 'Paraguay', heslo_en = 'Paraguay', zkratka = 'PY', popis = '' WHERE ident_cely = 'HES-001363';
UPDATE heslar SET razeni = 175, heslo = 'Peru', heslo_en = 'Peru', zkratka = 'PE', popis = '' WHERE ident_cely = 'HES-001296';
UPDATE heslar SET razeni = 176, heslo = 'Pitcairn', heslo_en = 'Pitcairn', zkratka = 'PN', popis = '' WHERE ident_cely = 'HES-001287';
UPDATE heslar SET razeni = 177, heslo = 'Pobřeží slonoviny', heslo_en = 'Côte d''Ivoire', zkratka = 'CI', popis = '' WHERE ident_cely = 'HES-001226';
UPDATE heslar SET razeni = 178, heslo = 'Polsko', heslo_en = 'Poland', zkratka = 'PL', popis = '' WHERE ident_cely = 'HES-001220';
UPDATE heslar SET razeni = 179, heslo = 'Portoriko', heslo_en = 'Puerto Rico', zkratka = 'PR', popis = '' WHERE ident_cely = 'HES-001221';
UPDATE heslar SET razeni = 18, heslo = '3D – 3D Printing (*.3mf)', heslo_en = '3D – 3D Printing (*.3mf)', popis = '' WHERE ident_cely = 'HES-000158';
UPDATE heslar SET razeni = 18, heslo = 'Bahamy', heslo_en = 'Bahamas (the)', zkratka = 'BS', popis = '' WHERE ident_cely = 'HES-001195';
UPDATE heslar SET razeni = 18, heslo = 'fotografie osobní', heslo_en = 'photograph of person', popis = '' WHERE ident_cely = 'HES-001091';
UPDATE heslar SET razeni = 18, heslo = 'keramika porcelán', heslo_en = 'porcelain', popis = '' WHERE ident_cely = 'HES-000982';
UPDATE heslar SET razeni = 18, heslo = 'Krakow-Balice', heslo_en = 'Krakow-Balice', popis = '' WHERE ident_cely = 'HES-000200';
UPDATE heslar SET razeni = 18, heslo = 'papír sešit', heslo_en = 'booklet', popis = '' WHERE ident_cely = 'HES-000214';
UPDATE heslar SET razeni = 18, heslo = 'stavebně-historický průzkum', heslo_en = 'architectural survey', popis = '' WHERE ident_cely = 'HES-001048';
UPDATE heslar SET razeni = 18, heslo = 'tafonomie', heslo_en = 'taphonomy', popis = 'Zkoumá procesy, které působí na organismus po jeho smrti a vedou k jeho fosilizaci.' WHERE ident_cely = 'HES-001441';
UPDATE heslar SET razeni = 180, heslo = 'Portugalsko', heslo_en = 'Portugal', zkratka = 'PT', popis = '' WHERE ident_cely = 'HES-001222';
UPDATE heslar SET razeni = 1800, heslo = 'herní předmět', heslo_en = 'game equipment', popis = '' WHERE ident_cely = 'HES-000681';
UPDATE heslar SET razeni = 1800, heslo = 'herní předmět', heslo_en = 'game equipment', popis = '' WHERE ident_cely = 'HES-000859';
UPDATE heslar SET razeni = 1800, heslo = 'raný středověk', heslo_en = 'Early Middle Ages', popis = '' WHERE ident_cely = 'HES-000412';
UPDATE heslar SET razeni = 1800, heslo = 'raný středověk', heslo_en = 'Early Middle Ages', zkratka = 'rstred', popis = '' WHERE ident_cely = 'HES-000385';
UPDATE heslar SET razeni = 1801, heslo = 'hrací kámen', heslo_en = 'game piece', popis = '' WHERE ident_cely = 'HES-000684';
UPDATE heslar SET razeni = 1802, heslo = 'hrací kostka', heslo_en = 'dice', popis = '' WHERE ident_cely = 'HES-000696';
UPDATE heslar SET razeni = 1803, heslo = 'žeton', heslo_en = 'token', popis = '' WHERE ident_cely = 'HES-000762';
UPDATE heslar SET razeni = 181, heslo = 'Rakousko', heslo_en = 'Austria', zkratka = 'AT', popis = '' WHERE ident_cely = 'HES-001295';
UPDATE heslar SET razeni = 1810, heslo = 'raný středověk 1', heslo_en = 'Early Middle Ages 1', zkratka = 'rs.1', popis = 'kultura pražského typu' WHERE ident_cely = 'HES-000386';
UPDATE heslar SET razeni = 182, heslo = 'Réunion', heslo_en = 'Réunion', zkratka = 'RE', popis = '' WHERE ident_cely = 'HES-001303';
UPDATE heslar SET razeni = 1820, heslo = 'raný středověk 2–4', heslo_en = 'Early Middle Ages 2–4', zkratka = 'rs.2-4', popis = 'hradištní období' WHERE ident_cely = 'HES-000276';
UPDATE heslar SET razeni = 183, heslo = 'Rovníková Guinea', heslo_en = 'Equatorial Guinea', zkratka = 'GQ', popis = '' WHERE ident_cely = 'HES-001235';
UPDATE heslar SET razeni = 1830, heslo = 'raný středověk 2', heslo_en = 'Early Middle Ages 2', zkratka = 'rs.2', popis = 'starší doba hradištní' WHERE ident_cely = 'HES-000301';
UPDATE heslar SET razeni = 184, heslo = 'Rumunsko', heslo_en = 'Romania', zkratka = 'RO', popis = '' WHERE ident_cely = 'HES-001236';
UPDATE heslar SET razeni = 1840, heslo = 'raný středověk 3', heslo_en = 'Early Middle Ages 3', zkratka = 'rs.3', popis = 'střední doba hradištní' WHERE ident_cely = 'HES-000379';
UPDATE heslar SET razeni = 1841, heslo = 'rané středohradištní období', heslo_en = 'Early Middle Hillfort Period', zkratka = 'rs.3.ra', popis = '' WHERE ident_cely = 'HES-000277';
UPDATE heslar SET razeni = 1842, heslo = 'vyspělé středohradištní období', heslo_en = 'Advanced Middle Hillfort Period', zkratka = 'rs.3.vy', popis = '' WHERE ident_cely = 'HES-000302';
UPDATE heslar SET razeni = 1843, heslo = 'pozdní středohradištní období', heslo_en = 'Final Middle Hillfort Period', zkratka = 'rs.3.po', popis = '' WHERE ident_cely = 'HES-000278';
UPDATE heslar SET razeni = 185, heslo = 'Rusko', heslo_en = 'Russian Federation (the)', zkratka = 'RU', popis = '' WHERE ident_cely = 'HES-001392';
UPDATE heslar SET razeni = 1850, heslo = 'raný středověk 4', heslo_en = 'Early Middle Ages 4', zkratka = 'rs.4', popis = 'mladší doba hradištní' WHERE ident_cely = 'HES-000325';
UPDATE heslar SET razeni = 1851, heslo = 'rané mladohradištní období', heslo_en = 'Early Late Hillfort Period', zkratka = 'rs.4.ra', popis = '' WHERE ident_cely = 'HES-000356';
UPDATE heslar SET razeni = 1852, heslo = 'vyspělé mladohradištní období', heslo_en = 'Advanced Late Hillfort Period', zkratka = 'rs.4.vy', popis = '' WHERE ident_cely = 'HES-000303';
UPDATE heslar SET razeni = 1853, heslo = 'pozdněhradištní období', heslo_en = 'Final Hillfort Period', zkratka = 'rs.4.po', popis = '' WHERE ident_cely = 'HES-000326';
UPDATE heslar SET razeni = 186, heslo = 'Rwanda', heslo_en = 'Rwanda', zkratka = 'RW', popis = '' WHERE ident_cely = 'HES-001393';
UPDATE heslar SET razeni = 1860, heslo = 'přechod raný/vrcholný středověk', heslo_en = 'Early/High Middle Ages Transition', zkratka = 'rs/vs', popis = '' WHERE ident_cely = 'HES-000270';
UPDATE heslar SET razeni = 187, heslo = 'Řecko', heslo_en = 'Greece', zkratka = 'GR', popis = '' WHERE ident_cely = 'HES-001304';
UPDATE heslar SET razeni = 188, heslo = 'Saint Pierre a Miquelon', heslo_en = 'Saint Pierre and Miquelon', zkratka = 'PM', popis = '' WHERE ident_cely = 'HES-001280';
UPDATE heslar SET razeni = 189, heslo = 'Salvador', heslo_en = 'El Salvador', zkratka = 'SV', popis = '' WHERE ident_cely = 'HES-001281';
UPDATE heslar SET razeni = 19, heslo = '3D – Revit (*.rvt)', heslo_en = '3D – Revit (*.rvt)', popis = '' WHERE ident_cely = 'HES-000159';
UPDATE heslar SET razeni = 19, heslo = 'Bahrajn', heslo_en = 'Bahrain', zkratka = 'BH', popis = '' WHERE ident_cely = 'HES-001196';
UPDATE heslar SET razeni = 19, heslo = 'fotografie pracovní', heslo_en = 'photograph of fieldwork', popis = '' WHERE ident_cely = 'HES-001093';
UPDATE heslar SET razeni = 19, heslo = 'geoarcheologie', heslo_en = 'geoarchaeology', popis = 'Méně obvyklé, samostatně nezmiňované metody geoarcheologického průzkumu.' WHERE ident_cely = 'HES-000613';
UPDATE heslar SET razeni = 19, heslo = 'keramika terra sigillata', heslo_en = 'terra sigillata ware', popis = '' WHERE ident_cely = 'HES-000983';
UPDATE heslar SET razeni = 19, heslo = 'Leszno', heslo_en = 'Leszno', popis = '' WHERE ident_cely = 'HES-000201';
UPDATE heslar SET razeni = 19, heslo = 'papír vázaný', heslo_en = 'bounded paper', popis = '' WHERE ident_cely = 'HES-000215';
UPDATE heslar SET razeni = 190, heslo = 'Samoa', heslo_en = 'Samoa', zkratka = 'WS', popis = '' WHERE ident_cely = 'HES-001321';
UPDATE heslar SET razeni = 1900, heslo = 'vrcholný–pozdní středověk', heslo_en = 'High–Late Middle Ages', popis = '' WHERE ident_cely = 'HES-000413';
UPDATE heslar SET razeni = 1900, heslo = 'vrcholný–pozdní středověk', heslo_en = 'High–Late Middle Ages', zkratka = 'vs-ps', popis = '' WHERE ident_cely = 'HES-000327';
UPDATE heslar SET razeni = 1900, heslo = 'vzorek', heslo_en = 'sample', popis = '' WHERE ident_cely = 'HES-000818';
UPDATE heslar SET razeni = 1900, heslo = 'vzorek', heslo_en = 'sample', popis = '' WHERE ident_cely = 'HES-000860';
UPDATE heslar SET razeni = 1901, heslo = 'vzorek antrakologický', heslo_en = 'anthracological sample', popis = '' WHERE ident_cely = 'HES-000763';
UPDATE heslar SET razeni = 1902, heslo = 'vzorek dendrochronologický', heslo_en = 'dendrochronological sample', popis = '' WHERE ident_cely = 'HES-000758';
UPDATE heslar SET razeni = 1903, heslo = 'vzorek geologický', heslo_en = 'geological sample', popis = '' WHERE ident_cely = 'HES-000685';
UPDATE heslar SET razeni = 1904, heslo = 'vzorek malakologický', heslo_en = 'malacological sample', popis = '' WHERE ident_cely = 'HES-000686';
UPDATE heslar SET razeni = 1905, heslo = 'vzorek paleobotanický', heslo_en = 'palaeobotanical sample', popis = '' WHERE ident_cely = 'HES-000698';
UPDATE heslar SET razeni = 1906, heslo = 'vzorek palynologický', heslo_en = 'palynological sample', popis = '' WHERE ident_cely = 'HES-000692';
UPDATE heslar SET razeni = 1907, heslo = 'vzorek pedologický', heslo_en = 'pedological sample', popis = '' WHERE ident_cely = 'HES-000697';
UPDATE heslar SET razeni = 1908, heslo = 'vzorek pro radiokarbonové datování', heslo_en = 'radiocarbon dating sample', popis = '' WHERE ident_cely = 'HES-000759';
UPDATE heslar SET razeni = 191, heslo = 'San Marino', heslo_en = 'San Marino', zkratka = 'SM', popis = '' WHERE ident_cely = 'HES-001376';
UPDATE heslar SET razeni = 1910, heslo = 'vrcholný středověk', heslo_en = 'High Middle Ages', zkratka = 'vstred', popis = '' WHERE ident_cely = 'HES-000328';
UPDATE heslar SET razeni = 192, heslo = 'Saúdská Arábie', heslo_en = 'Saudi Arabia', zkratka = 'SA', popis = '' WHERE ident_cely = 'HES-001380';
UPDATE heslar SET razeni = 1920, heslo = 'pozdní středověk', heslo_en = 'Late Middle Ages', zkratka = 'pstred', popis = '' WHERE ident_cely = 'HES-000271';
UPDATE heslar SET razeni = 193, heslo = 'Senegal', heslo_en = 'Senegal', zkratka = 'SN', popis = '' WHERE ident_cely = 'HES-001215';
UPDATE heslar SET razeni = 1930, heslo = 'přechod pozdní středověk/novověk', heslo_en = 'Late Middle Ages/Modern Transition', zkratka = 'ps/no', popis = '' WHERE ident_cely = 'HES-000272';
UPDATE heslar SET razeni = 194, heslo = 'Severní Mariany', heslo_en = 'Northern Mariana Islands (the)', zkratka = 'MP', popis = '' WHERE ident_cely = 'HES-001216';
UPDATE heslar SET razeni = 195, heslo = 'Seychely', heslo_en = 'Seychelles', zkratka = 'SC', popis = '' WHERE ident_cely = 'HES-001307';
UPDATE heslar SET razeni = 196, heslo = 'Sierra Leone', heslo_en = 'Sierra Leone', zkratka = 'SL', popis = '' WHERE ident_cely = 'HES-001257';
UPDATE heslar SET razeni = 197, heslo = 'Singapur', heslo_en = 'Singapore', zkratka = 'SG', popis = '' WHERE ident_cely = 'HES-001255';
UPDATE heslar SET razeni = 198, heslo = 'Slovensko', heslo_en = 'Slovakia', zkratka = 'SK', popis = '' WHERE ident_cely = 'HES-001367';
UPDATE heslar SET razeni = 199, heslo = 'Slovinsko', heslo_en = 'Slovenia', zkratka = 'SI', popis = '' WHERE ident_cely = 'HES-001312';
UPDATE heslar SET razeni = 2, heslo = '<10 km', heslo_en = '<10 km', popis = '' WHERE ident_cely = 'HES-000100';
UPDATE heslar SET razeni = 2, heslo = '6 x 6 cm', heslo_en = '6 x 6 cm', popis = '' WHERE ident_cely = 'HES-000142';
UPDATE heslar SET razeni = 2, heslo = 'Afghánistán', heslo_en = 'Afghanistan', zkratka = 'AF', popis = '' WHERE ident_cely = 'HES-001179';
UPDATE heslar SET razeni = 2, heslo = 'archiv ARÚB', heslo_en = 'IAB archive', popis = '' WHERE ident_cely = 'HES-001167';
UPDATE heslar SET razeni = 2, heslo = 'astralon', heslo_en = 'astralon (transparent foil)', popis = '' WHERE ident_cely = 'HES-000218';
UPDATE heslar SET razeni = 2, heslo = 'badatel', heslo_en = 'researcher', zkratka = 'B', popis = '' WHERE ident_cely = 'HES-000866';
UPDATE heslar SET razeni = 2, heslo = 'badatelský záměr', heslo_en = 'research project', popis = '' WHERE ident_cely = 'HES-000595';
UPDATE heslar SET razeni = 2, heslo = 'badatelský', heslo_en = 'research', popis = '' WHERE ident_cely = 'HES-001137';
UPDATE heslar SET razeni = 2, heslo = 'Brno-Černovice', heslo_en = 'Brno-Černovice', popis = '' WHERE ident_cely = 'HES-000182';
UPDATE heslar SET razeni = 2, heslo = 'bronz', heslo_en = 'bronze', popis = '' WHERE ident_cely = 'HES-000966';
UPDATE heslar SET razeni = 2, heslo = 'část akce', heslo_en = 'fieldwork segment', popis = '' WHERE ident_cely = 'HES-001071';
UPDATE heslar SET razeni = 2, heslo = 'článek v časopise', heslo_en = 'journal paper', zkratka = 'C', popis = '' WHERE ident_cely = 'HES-001119';
UPDATE heslar SET razeni = 2, heslo = 'data', heslo_en = 'data', zkratka = 'DD', popis = '' WHERE ident_cely = 'HES-000871';
UPDATE heslar SET razeni = 2, heslo = 'dendrochronologie', heslo_en = 'dendrochronology', popis = 'Metoda datování dřevěných vzorků a nálezů pomocí analýzy letokruhů a jejich srovnávání se známými řadami.' WHERE ident_cely = 'HES-000609';
UPDATE heslar SET razeni = 2, heslo = 'deštivo', heslo_en = 'rainy', popis = '' WHERE ident_cely = 'HES-000587';
UPDATE heslar SET razeni = 2, heslo = 'dno sondy', heslo_en = 'trench bottom', popis = '' WHERE ident_cely = 'HES-001158';
UPDATE heslar SET razeni = 2, heslo = 'jiná organizace', heslo_en = 'other organisation', popis = '' WHERE ident_cely = 'HES-001128';
UPDATE heslar SET razeni = 2, heslo = 'linie', heslo_en = 'line', popis = '' WHERE ident_cely = 'HES-001134';
UPDATE heslar SET razeni = 2, heslo = 'němčina', heslo_en = 'German', zkratka = 'DE', popis = '' WHERE ident_cely = 'HES-000168';
UPDATE heslar SET razeni = 2, heslo = 'neodborné narušení', heslo_en = 'non-professional intervention', popis = '' WHERE ident_cely = 'HES-001140';
UPDATE heslar SET razeni = 2, heslo = 'odchylka desítky metrů', heslo_en = 'deviation in tens of meters', zkratka = '2', popis = 'odchylka desítky metrů' WHERE ident_cely = 'HES-000862';
UPDATE heslar SET razeni = 2, heslo = 'ornice', heslo_en = 'arable topsoil', popis = '' WHERE ident_cely = 'HES-000243';
UPDATE heslar SET razeni = 2, heslo = 'pohřbívání', heslo_en = 'burial activity', zkratka = 'poh', popis = '' WHERE ident_cely = 'HES-000002';
UPDATE heslar SET razeni = 2, heslo = 'polygon průzkumu', heslo_en = 'survey polygon', zkratka = 'L', popis = '' WHERE ident_cely = 'HES-001123';
UPDATE heslar SET razeni = 2, heslo = 'použitelný', heslo_en = 'useable', zkratka = '2', popis = 'použitelný, pro tisk s obtížemi' WHERE ident_cely = 'HES-000238';
UPDATE heslar SET razeni = 2, heslo = 'předmět', heslo_en = 'object', zkratka = 'P', popis = '' WHERE ident_cely = 'HES-001126';
UPDATE heslar SET razeni = 2, heslo = 'přesně v letech', heslo_en = 'exact years', popis = 'možno zadat pouze rok; pouze u neregistrovaných akcí' WHERE ident_cely = 'HES-000886';
UPDATE heslar SET razeni = 2, heslo = 'příloha zprávy/hlášení', heslo_en = 'report annex', popis = '' WHERE ident_cely = 'HES-001076';
UPDATE heslar SET razeni = 2, heslo = 'přírodní útvar s lidskou aktivitou', heslo_en = 'inhabited natural landform', popis = '' WHERE ident_cely = 'HES-000133';
UPDATE heslar SET razeni = 2, heslo = 'shluk bodových objektů', heslo_en = 'group of point features', popis = '' WHERE ident_cely = 'HES-001029';
UPDATE heslar SET razeni = 2, heslo = 'zahraniční cesta', heslo_en = 'travel abroad', popis = '' WHERE ident_cely = 'HES-001153';
UPDATE heslar SET razeni = 2, heslo = 'zachováno 30–80 %', heslo_en = '30–80% preserved', zkratka = '2', popis = 'skenován' WHERE ident_cely = 'HES-001174';
UPDATE heslar SET razeni = 20, heslo = '3D – Sketchup (*.skp)', heslo_en = '3D – Sketchup (*.skp)', popis = '' WHERE ident_cely = 'HES-000160';
UPDATE heslar SET razeni = 20, heslo = 'Bangladéš', heslo_en = 'Bangladesh', zkratka = 'BD', popis = '' WHERE ident_cely = 'HES-001197';
UPDATE heslar SET razeni = 20, heslo = 'fotografie předmětu', heslo_en = 'photograph of object', popis = '' WHERE ident_cely = 'HES-001095';
UPDATE heslar SET razeni = 20, heslo = 'geofyzika', heslo_en = 'geophysics', popis = 'Soubor metod aplikované geofyziky pro nedestruktivní prospekci archeologických situací (geoelektrické analýzy, georadar, magnetometrie, seismické analýzy, gravimetrie, radionuklidové metody, geotermické metody).' WHERE ident_cely = 'HES-000614';
UPDATE heslar SET razeni = 20, heslo = 'korál', heslo_en = 'coral', popis = '' WHERE ident_cely = 'HES-000984';
UPDATE heslar SET razeni = 20, heslo = 'Mělník-Hořín', heslo_en = 'Mělník-Hořín', popis = '' WHERE ident_cely = 'HES-000202';
UPDATE heslar SET razeni = 20, heslo = 'nadkomunitní areál', heslo_en = 'supracommunity site', popis = '' WHERE ident_cely = 'HES-000084';
UPDATE heslar SET razeni = 20, heslo = 'nadkomunitní areál', heslo_en = 'supracommunity site', popis = '(sídlištní) areál sloužící více komunitám či jejich interakci' WHERE ident_cely = 'HES-000011';
UPDATE heslar SET razeni = 20, heslo = 'osídlený skalní prostor', heslo_en = 'cave settlement', popis = 'osídlené jeskyně, abri…' WHERE ident_cely = 'HES-000112';
UPDATE heslar SET razeni = 20, heslo = 'pauzák', heslo_en = 'tracing paper', popis = '' WHERE ident_cely = 'HES-000216';
UPDATE heslar SET razeni = 20, heslo = 'výzkum povrchové vrstvy', heslo_en = 'topsoil sampling', popis = '' WHERE ident_cely = 'HES-001064';
UPDATE heslar SET razeni = 200, heslo = 'architektonický článek', heslo_en = 'architectural element', popis = '' WHERE ident_cely = 'HES-000709';
UPDATE heslar SET razeni = 200, heslo = 'architektonický článek', heslo_en = 'architectural element', popis = '' WHERE ident_cely = 'HES-000843';
UPDATE heslar SET razeni = 200, heslo = 'mezolit', heslo_en = 'Mesolithic', popis = '' WHERE ident_cely = 'HES-000396';
UPDATE heslar SET razeni = 200, heslo = 'mezolit', heslo_en = 'Mesolithic', zkratka = 'mezoli', popis = '' WHERE ident_cely = 'HES-000275';
UPDATE heslar SET razeni = 200, heslo = 'Somálsko', heslo_en = 'Somalia', zkratka = 'SO', popis = '' WHERE ident_cely = 'HES-001326';
UPDATE heslar SET razeni = 200, heslo = 'zahloubený objekt', heslo_en = 'sunken feature', popis = '' WHERE ident_cely = 'HES-000486';
UPDATE heslar SET razeni = 200, heslo = 'zahloubený objekt', heslo_en = 'sunken feature', popis = '' WHERE ident_cely = 'HES-000572';
UPDATE heslar SET razeni = 2000, heslo = 'středověk', heslo_en = 'Middle Ages', popis = '' WHERE ident_cely = 'HES-000414';
UPDATE heslar SET razeni = 2000, heslo = 'středověk', heslo_en = 'Middle Ages', zkratka = 'stredo', popis = '' WHERE ident_cely = 'HES-000380';
UPDATE heslar SET razeni = 201, heslo = 'jáma', heslo_en = 'pit', popis = '' WHERE ident_cely = 'HES-000441';
UPDATE heslar SET razeni = 201, heslo = 'ostění', heslo_en = 'jamb', popis = '' WHERE ident_cely = 'HES-000710';
UPDATE heslar SET razeni = 201, heslo = 'Spojené arabské emiráty', heslo_en = 'United Arab Emirates (the)', zkratka = 'AE', popis = '' WHERE ident_cely = 'HES-001322';
UPDATE heslar SET razeni = 202, heslo = 'jáma kůlová/sloupová', heslo_en = 'stakehole/posthole', popis = '' WHERE ident_cely = 'HES-000442';
UPDATE heslar SET razeni = 202, heslo = 'portál', heslo_en = 'portal', popis = '' WHERE ident_cely = 'HES-000711';
UPDATE heslar SET razeni = 202, heslo = 'Spojené státy', heslo_en = 'United States of America (the)', zkratka = 'US', popis = '' WHERE ident_cely = 'HES-001323';
UPDATE heslar SET razeni = 203, heslo = 'jáma odpadní/jímka', heslo_en = 'waste pit/cesspit', popis = '' WHERE ident_cely = 'HES-000446';
UPDATE heslar SET razeni = 203, heslo = 'Srbsko', heslo_en = 'Serbia', zkratka = 'RS', popis = '' WHERE ident_cely = 'HES-001357';
UPDATE heslar SET razeni = 204, heslo = 'jáma stavební', heslo_en = 'construction pit', popis = '' WHERE ident_cely = 'HES-000443';
UPDATE heslar SET razeni = 204, heslo = 'Středoafrická republika', heslo_en = 'Central African Republic (the)', zkratka = 'CF', popis = '' WHERE ident_cely = 'HES-001386';
UPDATE heslar SET razeni = 205, heslo = 'jáma zásobní', heslo_en = 'storage pit', popis = '' WHERE ident_cely = 'HES-000444';
UPDATE heslar SET razeni = 205, heslo = 'Súdán', heslo_en = 'Sudan (the)', zkratka = 'SD', popis = '' WHERE ident_cely = 'HES-001272';
UPDATE heslar SET razeni = 206, heslo = 'cisterna', heslo_en = 'cistern', popis = '' WHERE ident_cely = 'HES-000445';
UPDATE heslar SET razeni = 206, heslo = 'Surinam', heslo_en = 'Suriname', zkratka = 'SR', popis = '' WHERE ident_cely = 'HES-001348';
UPDATE heslar SET razeni = 207, heslo = 'hliník', heslo_en = 'clay pit', popis = '' WHERE ident_cely = 'HES-000512';
UPDATE heslar SET razeni = 207, heslo = 'Svatá Helena', heslo_en = 'Saint Helena, Ascension and Tristan da Cunha', zkratka = 'SH', popis = '' WHERE ident_cely = 'HES-001258';
UPDATE heslar SET razeni = 208, heslo = 'loch', heslo_en = 'larder (cellar)', popis = '' WHERE ident_cely = 'HES-000487';
UPDATE heslar SET razeni = 208, heslo = 'Svatá Lucie', heslo_en = 'Saint Lucia', zkratka = 'LC', popis = '' WHERE ident_cely = 'HES-001332';
UPDATE heslar SET razeni = 209, heslo = 'náhon', heslo_en = 'millrace', popis = '' WHERE ident_cely = 'HES-000513';
UPDATE heslar SET razeni = 209, heslo = 'Svatý Bartoloměj', heslo_en = 'Saint Barthélemy', zkratka = 'BL', popis = '' WHERE ident_cely = 'HES-001355';
UPDATE heslar SET razeni = 21, heslo = '3D – Stanford PLY (*.ply)', heslo_en = '3D – Stanford PLY (*.ply)', popis = '' WHERE ident_cely = 'HES-000161';
UPDATE heslar SET razeni = 21, heslo = 'Barbados', heslo_en = 'Barbados', zkratka = 'BB', popis = '' WHERE ident_cely = 'HES-001402';
UPDATE heslar SET razeni = 21, heslo = 'fotografie události', heslo_en = 'photograph of event', popis = '' WHERE ident_cely = 'HES-001092';
UPDATE heslar SET razeni = 21, heslo = 'geochemie', heslo_en = 'geochemistry', popis = 'Metody aplikované geochemie užité při analýze a interpretaci archeologických lokalit. ' WHERE ident_cely = 'HES-000615';
UPDATE heslar SET razeni = 21, heslo = 'hrazený areál', heslo_en = 'enclosure', popis = '' WHERE ident_cely = 'HES-000071';
UPDATE heslar SET razeni = 21, heslo = 'kost', heslo_en = 'bone', popis = '' WHERE ident_cely = 'HES-000985';
UPDATE heslar SET razeni = 21, heslo = 'Mnichovo Hradiště', heslo_en = 'Mnichovo Hradiště', popis = '' WHERE ident_cely = 'HES-000203';
UPDATE heslar SET razeni = 21, heslo = 'tisk', heslo_en = 'print', popis = '' WHERE ident_cely = 'HES-000233';
UPDATE heslar SET razeni = 210, heslo = 'sklep', heslo_en = 'cellar', popis = '' WHERE ident_cely = 'HES-000488';
UPDATE heslar SET razeni = 210, heslo = 'Svatý Kryštof a Nevis', heslo_en = 'Saint Kitts and Nevis', zkratka = 'KN', popis = '' WHERE ident_cely = 'HES-001305';
UPDATE heslar SET razeni = 2100, heslo = 'novověk', heslo_en = 'Modern Period', popis = '' WHERE ident_cely = 'HES-000415';
UPDATE heslar SET razeni = 2100, heslo = 'novověk', heslo_en = 'Modern Period', zkratka = 'novove', popis = '' WHERE ident_cely = 'HES-000252';
UPDATE heslar SET razeni = 211, heslo = 'studna', heslo_en = 'water well', popis = '' WHERE ident_cely = 'HES-000514';
UPDATE heslar SET razeni = 211, heslo = 'Svatý Martin (FR)', heslo_en = 'Saint Martin (French part)', zkratka = 'MF', popis = '' WHERE ident_cely = 'HES-001268';
UPDATE heslar SET razeni = 2110, heslo = 'novověk 1', heslo_en = 'Modern Period 1', zkratka = 'no.1', popis = '' WHERE ident_cely = 'HES-000381';
UPDATE heslar SET razeni = 212, heslo = 'Svatý Martin (NL)', heslo_en = 'Sint Maarten (Dutch part)', zkratka = 'SX', popis = '' WHERE ident_cely = 'HES-001315';
UPDATE heslar SET razeni = 212, heslo = 'výkop', heslo_en = 'cut', popis = '' WHERE ident_cely = 'HES-000489';
UPDATE heslar SET razeni = 2120, heslo = 'novověk 2', heslo_en = 'Modern Period 2', zkratka = 'no.2', popis = '' WHERE ident_cely = 'HES-000382';
UPDATE heslar SET razeni = 213, heslo = 'Svatý Tomáš a Princův ostrov', heslo_en = 'Sao Tome and Principe', zkratka = 'ST', popis = '' WHERE ident_cely = 'HES-001212';
UPDATE heslar SET razeni = 213, heslo = 'žlab', heslo_en = 'ditch', popis = '' WHERE ident_cely = 'HES-000490';
UPDATE heslar SET razeni = 214, heslo = 'Svatý Vincenc a Grenadiny', heslo_en = 'Saint Vincent and the Grenadines', zkratka = 'VC', popis = '' WHERE ident_cely = 'HES-001378';
UPDATE heslar SET razeni = 215, heslo = 'Svazijsko', heslo_en = 'Eswatini', zkratka = 'SZ', popis = '' WHERE ident_cely = 'HES-001388';
UPDATE heslar SET razeni = 216, heslo = 'Sýrie', heslo_en = 'Syrian Arab Republic', zkratka = 'SY', popis = '' WHERE ident_cely = 'HES-001379';
UPDATE heslar SET razeni = 217, heslo = 'Šalomounovy ostrovy', heslo_en = 'Solomon Islands', zkratka = 'SB', popis = '' WHERE ident_cely = 'HES-001311';
UPDATE heslar SET razeni = 218, heslo = 'Španělsko', heslo_en = 'Spain', zkratka = 'ES', popis = '' WHERE ident_cely = 'HES-001300';
UPDATE heslar SET razeni = 219, heslo = 'Špicberky a Jan Mayen', heslo_en = 'Svalbard and Jan Mayen', zkratka = 'SJ', popis = '' WHERE ident_cely = 'HES-001253';
UPDATE heslar SET razeni = 22, heslo = '3D – Stereo Litography (*.stl)', heslo_en = '3D – Stereo Litography (*.stl)', popis = '' WHERE ident_cely = 'HES-000163';
UPDATE heslar SET razeni = 22, heslo = 'Belgie', heslo_en = 'Belgium', zkratka = 'BE', popis = '' WHERE ident_cely = 'HES-001202';
UPDATE heslar SET razeni = 22, heslo = 'fotografie výzkumu/sondy', heslo_en = 'photograph of excavation/trench', popis = '' WHERE ident_cely = 'HES-001090';
UPDATE heslar SET razeni = 22, heslo = 'geochronologie', heslo_en = 'geochronology', popis = 'Metoda relativního a absolutního datování sedimentů, paleopůd, stalagmitů, ohnišť apod.' WHERE ident_cely = 'HES-001442';
UPDATE heslar SET razeni = 22, heslo = 'hradiště', heslo_en = 'hillfort', popis = 'vč. oppidum' WHERE ident_cely = 'HES-000072';
UPDATE heslar SET razeni = 22, heslo = 'kost lidská', heslo_en = 'human bone', popis = '' WHERE ident_cely = 'HES-000986';
UPDATE heslar SET razeni = 22, heslo = 'Plasy', heslo_en = 'Plasy', popis = '' WHERE ident_cely = 'HES-000204';
UPDATE heslar SET razeni = 22, heslo = 'povrchový nález', heslo_en = 'surface find', popis = '' WHERE ident_cely = 'HES-001049';
UPDATE heslar SET razeni = 22, heslo = 'tisková fólie', heslo_en = 'printing foil', popis = '' WHERE ident_cely = 'HES-000234';
UPDATE heslar SET razeni = 220, heslo = 'Šrí Lanka', heslo_en = 'Sri Lanka', zkratka = 'LK', popis = '' WHERE ident_cely = 'HES-001254';
UPDATE heslar SET razeni = 2200, heslo = 'vrcholný středověk–novověk', heslo_en = 'High Middle Ages–Modern Period', zkratka = 'vs-no', popis = '' WHERE ident_cely = 'HES-000273';
UPDATE heslar SET razeni = 221, heslo = 'Švédsko', heslo_en = 'Sweden', zkratka = 'SE', popis = '' WHERE ident_cely = 'HES-001331';
UPDATE heslar SET razeni = 222, heslo = 'Švýcarsko', heslo_en = 'Switzerland', zkratka = 'CH', popis = '' WHERE ident_cely = 'HES-001365';
UPDATE heslar SET razeni = 223, heslo = 'Tádžikistán', heslo_en = 'Tajikistan', zkratka = 'TJ', popis = '' WHERE ident_cely = 'HES-001390';
UPDATE heslar SET razeni = 224, heslo = 'Tanzanie', heslo_en = 'Tanzania, United Republic of', zkratka = 'TZ', popis = '' WHERE ident_cely = 'HES-001244';
UPDATE heslar SET razeni = 225, heslo = 'Thajsko', heslo_en = 'Thailand', zkratka = 'TH', popis = '' WHERE ident_cely = 'HES-001341';
UPDATE heslar SET razeni = 226, heslo = 'Tchaj-wan', heslo_en = 'Taiwan (Province of China)', zkratka = 'TW', popis = '' WHERE ident_cely = 'HES-001306';
UPDATE heslar SET razeni = 227, heslo = 'Togo', heslo_en = 'Togo', zkratka = 'TG', popis = '' WHERE ident_cely = 'HES-001342';
UPDATE heslar SET razeni = 228, heslo = 'Tokelau', heslo_en = 'Tokelau', zkratka = 'TK', popis = '' WHERE ident_cely = 'HES-001406';
UPDATE heslar SET razeni = 229, heslo = 'Tonga', heslo_en = 'Tonga', zkratka = 'TO', popis = '' WHERE ident_cely = 'HES-001407';
UPDATE heslar SET razeni = 23, heslo = '3D – 3D Studio Max (*.max, *.3ds)', heslo_en = '3D – 3D Studio Max (*.max, *.3ds)', popis = '' WHERE ident_cely = 'HES-000164';
UPDATE heslar SET razeni = 23, heslo = 'Belize', heslo_en = 'Belize', zkratka = 'BZ', popis = '' WHERE ident_cely = 'HES-001334';
UPDATE heslar SET razeni = 23, heslo = 'geomorfologie', heslo_en = 'geomorphology', popis = 'Obor fyzické geografie, přispívající k pochopení geomorfologických procesů.' WHERE ident_cely = 'HES-001443';
UPDATE heslar SET razeni = 23, heslo = 'klášter', heslo_en = 'monastery', popis = '' WHERE ident_cely = 'HES-000073';
UPDATE heslar SET razeni = 23, heslo = 'kost zvířecí', heslo_en = 'animal bone', popis = '' WHERE ident_cely = 'HES-000987';
UPDATE heslar SET razeni = 23, heslo = 'letecká fotografie krajiny', heslo_en = 'aerial photograph of landscape', popis = '' WHERE ident_cely = 'HES-001098';
UPDATE heslar SET razeni = 23, heslo = 'Praha-Kbely', heslo_en = 'Praha-Kbely', popis = '' WHERE ident_cely = 'HES-000205';
UPDATE heslar SET razeni = 23, heslo = 'xerokopie barevná', heslo_en = 'colour xerographic copy', zkratka = 'xerox-bar', popis = '' WHERE ident_cely = 'HES-000235';
UPDATE heslar SET razeni = 230, heslo = 'Trinidad a Tobago', heslo_en = 'Trinidad and Tobago', zkratka = 'TT', popis = '' WHERE ident_cely = 'HES-001408';
UPDATE heslar SET razeni = 2300, heslo = 'středověk–novověk', heslo_en = 'Middle Ages–Modern Period', popis = '' WHERE ident_cely = 'HES-000416';
UPDATE heslar SET razeni = 2300, heslo = 'středověk–novověk', heslo_en = 'Middle Ages–Modern Period', zkratka = 'st-no', popis = '' WHERE ident_cely = 'HES-000392';
UPDATE heslar SET razeni = 231, heslo = 'Tunisko', heslo_en = 'Tunisia', zkratka = 'TN', popis = '' WHERE ident_cely = 'HES-001409';
UPDATE heslar SET razeni = 232, heslo = 'Turecko', heslo_en = 'Turkey', zkratka = 'TR', popis = '' WHERE ident_cely = 'HES-001410';
UPDATE heslar SET razeni = 233, heslo = 'Turkmenistán', heslo_en = 'Turkmenistan', zkratka = 'TM', popis = '' WHERE ident_cely = 'HES-001411';
UPDATE heslar SET razeni = 234, heslo = 'Turks a Caicos', heslo_en = 'Turks and Caicos Islands (the)', zkratka = 'TC', popis = '' WHERE ident_cely = 'HES-001412';
UPDATE heslar SET razeni = 235, heslo = 'Tuvalu', heslo_en = 'Tuvalu', zkratka = 'TV', popis = '' WHERE ident_cely = 'HES-001413';
UPDATE heslar SET razeni = 236, heslo = 'Uganda', heslo_en = 'Uganda', zkratka = 'UG', popis = '' WHERE ident_cely = 'HES-001414';
UPDATE heslar SET razeni = 237, heslo = 'Ukrajina', heslo_en = 'Ukraine', zkratka = 'UA', popis = '' WHERE ident_cely = 'HES-001415';
UPDATE heslar SET razeni = 238, heslo = 'Uruguay', heslo_en = 'Uruguay', zkratka = 'UY', popis = '' WHERE ident_cely = 'HES-001416';
UPDATE heslar SET razeni = 239, heslo = 'Uzbekistán', heslo_en = 'Uzbekistan', zkratka = 'UZ', popis = '' WHERE ident_cely = 'HES-001417';
UPDATE heslar SET razeni = 24, heslo = '3D – Universal (*.u3d)', heslo_en = '3D – Universal (*.u3d)', popis = '' WHERE ident_cely = 'HES-000162';
UPDATE heslar SET razeni = 24, heslo = 'Bělorusko', heslo_en = 'Belarus', zkratka = 'BY', popis = '' WHERE ident_cely = 'HES-001329';
UPDATE heslar SET razeni = 24, heslo = 'kov', heslo_en = 'metal', popis = '' WHERE ident_cely = 'HES-000988';
UPDATE heslar SET razeni = 24, heslo = 'letecká fotografie lokality', heslo_en = 'aerial photograph of site', popis = '' WHERE ident_cely = 'HES-001099';
UPDATE heslar SET razeni = 24, heslo = 'město', heslo_en = 'city', popis = '' WHERE ident_cely = 'HES-000074';
UPDATE heslar SET razeni = 24, heslo = 'mikrostratigrafie', heslo_en = 'microstratigraphy', popis = 'Metoda mikroskopické analýzy uloženin antropogenního i neantropogenního původu.' WHERE ident_cely = 'HES-001444';
UPDATE heslar SET razeni = 24, heslo = 'povrchový sběr', heslo_en = 'surface collection survey', popis = '' WHERE ident_cely = 'HES-001050';
UPDATE heslar SET razeni = 24, heslo = 'Praha-Letňany', heslo_en = 'Praha-Letňany', popis = '' WHERE ident_cely = 'HES-000206';
UPDATE heslar SET razeni = 24, heslo = 'xerokopie černobílá', heslo_en = 'black-and-white xerographic copy', zkratka = 'xerox-čb', popis = '' WHERE ident_cely = 'HES-000236';
UPDATE heslar SET razeni = 240, heslo = 'Vánoční ostrov', heslo_en = 'Christmas Island', zkratka = 'CX', popis = '' WHERE ident_cely = 'HES-001418';
UPDATE heslar SET razeni = 2400, heslo = 'industriální období', heslo_en = 'Industrial Period', popis = '' WHERE ident_cely = 'HES-000417';
UPDATE heslar SET razeni = 2400, heslo = 'industriální období', heslo_en = 'Industrial Period', zkratka = 'in', popis = '' WHERE ident_cely = 'HES-000347';
UPDATE heslar SET razeni = 241, heslo = 'Vanuatu', heslo_en = 'Vanuatu', zkratka = 'VU', popis = '' WHERE ident_cely = 'HES-001419';
UPDATE heslar SET razeni = 2410, heslo = 'industriální období 1', heslo_en = 'Industrial Period 1', zkratka = 'in.1', popis = '' WHERE ident_cely = 'HES-000348';
UPDATE heslar SET razeni = 242, heslo = 'Vatikán', heslo_en = 'Holy See (the)', zkratka = 'VA', popis = '' WHERE ident_cely = 'HES-001420';
UPDATE heslar SET razeni = 2420, heslo = 'industriální období 2', heslo_en = 'Industrial Period 2', zkratka = 'in.2', popis = '' WHERE ident_cely = 'HES-000349';
UPDATE heslar SET razeni = 243, heslo = 'Velká Británie', heslo_en = 'United Kingdom of Great Britain and Northern Ireland (the)', zkratka = 'GB', popis = '' WHERE ident_cely = 'HES-001421';
UPDATE heslar SET razeni = 244, heslo = 'Venezuela', heslo_en = 'Venezuela (Bolivarian Republic of)', zkratka = 'VE', popis = '' WHERE ident_cely = 'HES-001422';
UPDATE heslar SET razeni = 245, heslo = 'Vietnam', heslo_en = 'Viet Nam', zkratka = 'VN', popis = '' WHERE ident_cely = 'HES-001423';
UPDATE heslar SET razeni = 246, heslo = 'Východní Timor', heslo_en = 'Timor-Leste', zkratka = 'TL', popis = '' WHERE ident_cely = 'HES-001424';
UPDATE heslar SET razeni = 247, heslo = 'Wallis a Futuna', heslo_en = 'Wallis and Futuna', zkratka = 'WF', popis = '' WHERE ident_cely = 'HES-001425';
UPDATE heslar SET razeni = 248, heslo = 'Zambie', heslo_en = 'Zambia', zkratka = 'ZM', popis = '' WHERE ident_cely = 'HES-001426';
UPDATE heslar SET razeni = 249, heslo = 'Západní Sahara', heslo_en = 'Western Sahara', zkratka = 'EH', popis = '' WHERE ident_cely = 'HES-001427';
UPDATE heslar SET razeni = 25, heslo = '3D – VRML (*.wrl)', heslo_en = '3D – VRML (*.wrl)', popis = '' WHERE ident_cely = 'HES-000165';
UPDATE heslar SET razeni = 25, heslo = 'Benin', heslo_en = 'Benin', zkratka = 'BJ', popis = '' WHERE ident_cely = 'HES-001207';
UPDATE heslar SET razeni = 25, heslo = 'kov barevný', heslo_en = 'nonferrous metal', popis = '' WHERE ident_cely = 'HES-000989';
UPDATE heslar SET razeni = 25, heslo = 'letecká fotografie metody', heslo_en = 'aerial photograph of method', popis = '' WHERE ident_cely = 'HES-001116';
UPDATE heslar SET razeni = 25, heslo = 'neurčený materiál', heslo_en = 'unspecified material', popis = '' WHERE ident_cely = 'HES-000232';
UPDATE heslar SET razeni = 25, heslo = 'paleoklimatologie', heslo_en = 'paleoclimatology', popis = 'Vědecká disciplína, která studuje klima v minulosti za použití širokého spektra přírodovědných metod.' WHERE ident_cely = 'HES-001445';
UPDATE heslar SET razeni = 25, heslo = 'protourbánní aglomerace', heslo_en = 'proto-urban agglomeration', popis = '' WHERE ident_cely = 'HES-000075';
UPDATE heslar SET razeni = 25, heslo = 'Sazená', heslo_en = 'Sazená', popis = '' WHERE ident_cely = 'HES-000207';
UPDATE heslar SET razeni = 250, heslo = 'Zimbabwe', heslo_en = 'Zimbabwe', zkratka = 'ZW', popis = '' WHERE ident_cely = 'HES-001428';
UPDATE heslar SET razeni = 2500, heslo = 'novověk–industriální období', heslo_en = 'Modern–Industrial Period', popis = '' WHERE ident_cely = 'HES-000420';
UPDATE heslar SET razeni = 2500, heslo = 'novověk–industriální období', heslo_en = 'Modern–Industrial Period', zkratka = 'no-in', popis = '' WHERE ident_cely = 'HES-000350';
UPDATE heslar SET razeni = 26, heslo = '3D – jiný', heslo_en = '3D – other', popis = '' WHERE ident_cely = 'HES-000166';
UPDATE heslar SET razeni = 26, heslo = 'Bermudy', heslo_en = 'Bermuda', zkratka = 'BM', popis = '' WHERE ident_cely = 'HES-001330';
UPDATE heslar SET razeni = 26, heslo = 'kůra', heslo_en = 'bark', popis = '' WHERE ident_cely = 'HES-000990';
UPDATE heslar SET razeni = 26, heslo = 'letecká fotografie výzkumu', heslo_en = 'aerial photograph of fieldwork', popis = '' WHERE ident_cely = 'HES-001100';
UPDATE heslar SET razeni = 26, heslo = 'mikrosondáž/vzorkovací sondáž', heslo_en = 'shovel tests/test pitting', popis = 'mikrosondáž; vzorkovací sondáž' WHERE ident_cely = 'HES-001051';
UPDATE heslar SET razeni = 26, heslo = 'pedologie', heslo_en = 'pedology', popis = 'Celostní studium půd v archeologických kontextech i mimo ně.' WHERE ident_cely = 'HES-000627';
UPDATE heslar SET razeni = 26, heslo = 'předměstí', heslo_en = 'suburb', popis = '' WHERE ident_cely = 'HES-000076';
UPDATE heslar SET razeni = 26, heslo = 'Strunkovice', heslo_en = 'Strunkovice', popis = '' WHERE ident_cely = 'HES-000208';
UPDATE heslar SET razeni = 2600, heslo = 'datace neurčena', heslo_en = 'unspecified dating', popis = '' WHERE ident_cely = 'HES-000418';
UPDATE heslar SET razeni = 2600, heslo = 'datace neurčena', heslo_en = 'unspecified dating', zkratka = 'nedat', popis = 'komponenta chronologicky nezařaditelná' WHERE ident_cely = 'HES-000316';
UPDATE heslar SET razeni = 27, heslo = 'Bhútán', heslo_en = 'Bhutan', zkratka = 'BT', popis = '' WHERE ident_cely = 'HES-001395';
UPDATE heslar SET razeni = 27, heslo = 'kůže', heslo_en = 'leather', popis = '' WHERE ident_cely = 'HES-000991';
UPDATE heslar SET razeni = 27, heslo = 'letecká fotografie půdních příznaků', heslo_en = 'aerial photograph of soil marks', popis = '' WHERE ident_cely = 'HES-001103';
UPDATE heslar SET razeni = 27, heslo = 'petrografie/mineralogie', heslo_en = 'petrography', popis = 'Aplikované vědecké disciplíny, které se uplatňují při studiu nerostů (mineralogie) a hornin (petrografie), vč. studia artefaktů (kamenná industrie, keramická hmota), ekofaktů (těžební/výrobní odpad).' WHERE ident_cely = 'HES-000628';
UPDATE heslar SET razeni = 27, heslo = 'rondel/rondeloid', heslo_en = 'roundel/rondeloid', popis = '' WHERE ident_cely = 'HES-000012';
UPDATE heslar SET razeni = 27, heslo = 'Velká Dobrá', heslo_en = 'Velká Dobrá', popis = '' WHERE ident_cely = 'HES-000209';
UPDATE heslar SET razeni = 28, heslo = 'Bolívie', heslo_en = 'Bolivia (Plurinational State of)', zkratka = 'BO', popis = '' WHERE ident_cely = 'HES-001396';
UPDATE heslar SET razeni = 28, heslo = 'letecká fotografie sněžných příznaků', heslo_en = 'aerial photograph of snow marks', popis = '' WHERE ident_cely = 'HES-001104';
UPDATE heslar SET razeni = 28, heslo = 'malta', heslo_en = 'mortar', popis = '' WHERE ident_cely = 'HES-000992';
UPDATE heslar SET razeni = 28, heslo = 'materiálová analýza', heslo_en = 'material analysis', popis = 'Méně obvyklé, samostatně nezmiňované materiálové analýzy.' WHERE ident_cely = 'HES-000633';
UPDATE heslar SET razeni = 28, heslo = 'průzkum detektorem kovu', heslo_en = 'metal detector survey', popis = '' WHERE ident_cely = 'HES-001052';
UPDATE heslar SET razeni = 28, heslo = 'Vlašim', heslo_en = 'Vlašim', popis = '' WHERE ident_cely = 'HES-000210';
UPDATE heslar SET razeni = 29, heslo = 'Bonaire, Svatý Eustach a Saba', heslo_en = 'Bonaire, Sint Eustatius and Saba', zkratka = 'BQ', popis = '' WHERE ident_cely = 'HES-001328';
UPDATE heslar SET razeni = 29, heslo = 'chemická analýza', heslo_en = 'chemical analysis', popis = 'Dále nečleněné chemické metody užívané při analýze archeologických nálezů.' WHERE ident_cely = 'HES-000617';
UPDATE heslar SET razeni = 29, heslo = 'letecká fotografie stínových příznaků', heslo_en = 'aerial photograph of shadow marks', popis = '' WHERE ident_cely = 'HES-001105';
UPDATE heslar SET razeni = 29, heslo = 'mazanice', heslo_en = 'daub', popis = '' WHERE ident_cely = 'HES-000993';
UPDATE heslar SET razeni = 29, heslo = 'Vrchlabí', heslo_en = 'Vrchlabí', popis = '' WHERE ident_cely = 'HES-000211';
UPDATE heslar SET razeni = 3, heslo = '10–20 km', heslo_en = '10–20 km', popis = '' WHERE ident_cely = 'HES-000101';
UPDATE heslar SET razeni = 3, heslo = '6 x 9 cm', heslo_en = '6 x 9 cm', popis = '' WHERE ident_cely = 'HES-000143';
UPDATE heslar SET razeni = 3, heslo = 'Alandy', heslo_en = 'Åland Islands', zkratka = 'AX', popis = '' WHERE ident_cely = 'HES-001180';
UPDATE heslar SET razeni = 3, heslo = 'angličtina', heslo_en = 'English', zkratka = 'EN', popis = '' WHERE ident_cely = 'HES-000169';
UPDATE heslar SET razeni = 3, heslo = 'archeolog', heslo_en = 'archaeologist', zkratka = 'C', popis = '' WHERE ident_cely = 'HES-000867';
UPDATE heslar SET razeni = 3, heslo = 'archiv ARÚ', heslo_en = 'IAP archive', popis = '' WHERE ident_cely = 'HES-001168';
UPDATE heslar SET razeni = 3, heslo = 'bodové objekty uspořádané', heslo_en = 'organized point features', popis = '' WHERE ident_cely = 'HES-001030';
UPDATE heslar SET razeni = 3, heslo = 'bromkopie', heslo_en = 'hectograph copy', popis = '' WHERE ident_cely = 'HES-000219';
UPDATE heslar SET razeni = 3, heslo = 'cín', heslo_en = 'tin', popis = '' WHERE ident_cely = 'HES-000967';
UPDATE heslar SET razeni = 3, heslo = 'článek v novinách', heslo_en = 'newspaper article', zkratka = 'D', popis = '' WHERE ident_cely = 'HES-001120';
UPDATE heslar SET razeni = 3, heslo = 'data 3D', heslo_en = 'data 3D', zkratka = '3D', popis = '' WHERE ident_cely = 'HES-000870';
UPDATE heslar SET razeni = 3, heslo = 'expertní posudek', heslo_en = 'expert report', popis = '' WHERE ident_cely = 'HES-001077';
UPDATE heslar SET razeni = 3, heslo = 'geodetický průzkum', heslo_en = 'geodetic survey', popis = '' WHERE ident_cely = 'HES-001141';
UPDATE heslar SET razeni = 3, heslo = 'inženýrsko-geologický průzkum', heslo_en = 'engineering-geological survey', popis = '' WHERE ident_cely = 'HES-000596';
UPDATE heslar SET razeni = 3, heslo = 'krajina', heslo_en = 'landscape', zkratka = 'K', popis = '' WHERE ident_cely = 'HES-001124';
UPDATE heslar SET razeni = 2, heslo = 'kulturní památka', heslo_en = 'listed monument', popis = '' WHERE ident_cely = 'HES-000177';
UPDATE heslar SET razeni = 3, heslo = 'někdy v letech', heslo_en = 'approximate years', popis = 'možno zadat pouze rok; pouze u neregistrovaných akcí' WHERE ident_cely = 'HES-000889';
UPDATE heslar SET razeni = 3, heslo = 'nízká kvalita', heslo_en = 'poor quality', zkratka = '3', popis = 'orientační hodnota' WHERE ident_cely = 'HES-000239';
UPDATE heslar SET razeni = 3, heslo = 'oblačno', heslo_en = 'cloudy', popis = '' WHERE ident_cely = 'HES-000588';
UPDATE heslar SET razeni = 3, heslo = 'odchylka stovky metrů', heslo_en = 'deviation in hundreds of meters', zkratka = '3', popis = 'odchylka stovky metrů' WHERE ident_cely = 'HES-000863';
UPDATE heslar SET razeni = 3, heslo = 'pastvina/louka', heslo_en = 'pasture topsoil', popis = '' WHERE ident_cely = 'HES-000244';
UPDATE heslar SET razeni = 3, heslo = 'podloží', heslo_en = 'subsoil', popis = '' WHERE ident_cely = 'HES-001159';
UPDATE heslar SET razeni = 3, heslo = 'polygon', heslo_en = 'polygon', popis = '' WHERE ident_cely = 'HES-001135';
UPDATE heslar SET razeni = 3, heslo = 'průzkum', heslo_en = 'survey', popis = '' WHERE ident_cely = 'HES-001138';
UPDATE heslar SET razeni = 3, heslo = 'radiouhlíkové datování', heslo_en = 'radiocarbon dating', popis = 'Metoda datování biologického materiálu pomocí poločasu rozpadu radioaktivního izotopu uhlíku 14C.' WHERE ident_cely = 'HES-000608';
UPDATE heslar SET razeni = 3, heslo = 'sonda', heslo_en = 'trench', popis = '' WHERE ident_cely = 'HES-001072';
UPDATE heslar SET razeni = 3, heslo = 'terénní pracoviště', heslo_en = 'fieldwork unit', popis = '' WHERE ident_cely = 'HES-001129';
UPDATE heslar SET razeni = 3, heslo = 'výroba', heslo_en = 'production activity', zkratka = 'výr', popis = '' WHERE ident_cely = 'HES-000003';
UPDATE heslar SET razeni = 3, heslo = 'zahraniční výzkum', heslo_en = 'fieldwork abroad', popis = '' WHERE ident_cely = 'HES-001154';
UPDATE heslar SET razeni = 3, heslo = 'zachováno 0–30 %', heslo_en = '0–30% preserved', zkratka = '3', popis = 'nemusí být skenován' WHERE ident_cely = 'HES-001175';
UPDATE heslar SET razeni = 3, heslo = 'zaniklý/historický areál', heslo_en = 'deserted/historical site', popis = '' WHERE ident_cely = 'HES-000134';
UPDATE heslar SET razeni = 30, heslo = 'Bosna a Hercegovina', heslo_en = 'Bosnia and Herzegovina', zkratka = 'BA', popis = '' WHERE ident_cely = 'HES-001282';
UPDATE heslar SET razeni = 30, heslo = 'letecká fotografie vegetačních příznaků', heslo_en = 'aerial photograph of vegetation marks', popis = '' WHERE ident_cely = 'HES-001102';
UPDATE heslar SET razeni = 30, heslo = 'měď', heslo_en = 'copper', popis = '' WHERE ident_cely = 'HES-000994';
UPDATE heslar SET razeni = 30, heslo = 'pozůstatek komunikace', heslo_en = 'remains of transportation structure', popis = 'úvozy, zaniklé mosty...' WHERE ident_cely = 'HES-001429';
UPDATE heslar SET razeni = 30, heslo = 'prvková analýza', heslo_en = 'elemental analysis', popis = 'Analýza prvkového složení zkoumané látky pomocí fyzikální a chemických metod (XRF, SEM-EDS, IRMS, ICP-MS atd.)' WHERE ident_cely = 'HES-000631';
UPDATE heslar SET razeni = 30, heslo = 'terénní zásah', heslo_en = 'field intervention', popis = '' WHERE ident_cely = 'HES-001065';
UPDATE heslar SET razeni = 30, heslo = 'Znojmo', heslo_en = 'Znojmo', popis = '' WHERE ident_cely = 'HES-000194';
UPDATE heslar SET razeni = 300, heslo = 'doklad umění/kultu', heslo_en = 'artistic/ritual object', popis = '' WHERE ident_cely = 'HES-000641';
UPDATE heslar SET razeni = 300, heslo = 'doklad umění/kultu', heslo_en = 'artistic/ritual object', popis = '' WHERE ident_cely = 'HES-000844';
UPDATE heslar SET razeni = 300, heslo = 'konstrukční prvek', heslo_en = 'architectural element', popis = '' WHERE ident_cely = 'HES-000491';
UPDATE heslar SET razeni = 300, heslo = 'konstrukční prvek', heslo_en = 'architectural element', popis = '' WHERE ident_cely = 'HES-000573';
UPDATE heslar SET razeni = 300, heslo = 'paleolit–mezolit', heslo_en = 'Palaeolithic–Mesolithic', popis = '' WHERE ident_cely = 'HES-000397';
UPDATE heslar SET razeni = 300, heslo = 'paleolit–mezolit', heslo_en = 'Palaeolithic–Mesolithic', zkratka = 'pa-me', popis = 'lovecký pravěk' WHERE ident_cely = 'HES-000284';
UPDATE heslar SET razeni = 301, heslo = 'dláždění', heslo_en = 'pavement', popis = '' WHERE ident_cely = 'HES-000492';
UPDATE heslar SET razeni = 301, heslo = 'hudební nástroj', heslo_en = 'musical instrument', popis = '' WHERE ident_cely = 'HES-000749';
UPDATE heslar SET razeni = 302, heslo = 'hráz', heslo_en = 'embankment/dam', popis = '' WHERE ident_cely = 'HES-000493';
UPDATE heslar SET razeni = 302, heslo = 'plastika/soška', heslo_en = 'sculpture/statue', popis = '' WHERE ident_cely = 'HES-000750';
UPDATE heslar SET razeni = 303, heslo = 'chodba', heslo_en = 'corridor', popis = '' WHERE ident_cely = 'HES-000494';
UPDATE heslar SET razeni = 303, heslo = 'plastika/soška antropomorfní', heslo_en = 'anthropomorphic sculpture/statue', popis = '' WHERE ident_cely = 'HES-000751';
UPDATE heslar SET razeni = 304, heslo = 'klenba', heslo_en = 'vaults', popis = '' WHERE ident_cely = 'HES-000495';
UPDATE heslar SET razeni = 304, heslo = 'plastika/soška zoomorfní', heslo_en = 'zoomorphic sculpture/statue', popis = '' WHERE ident_cely = 'HES-000752';
UPDATE heslar SET razeni = 305, heslo = 'kůl/sloup', heslo_en = 'stake/post', popis = '' WHERE ident_cely = 'HES-000447';
UPDATE heslar SET razeni = 306, heslo = 'nika', heslo_en = 'niche', popis = '' WHERE ident_cely = 'HES-000448';
UPDATE heslar SET razeni = 307, heslo = 'pilíř', heslo_en = 'pillar', popis = '' WHERE ident_cely = 'HES-000449';
UPDATE heslar SET razeni = 308, heslo = 'pilota', heslo_en = 'pier', popis = '' WHERE ident_cely = 'HES-000450';
UPDATE heslar SET razeni = 309, heslo = 'podlaha (konstrukce)', heslo_en = 'floor (construction)', popis = '' WHERE ident_cely = 'HES-000451';
UPDATE heslar SET razeni = 31, heslo = 'Botswana', heslo_en = 'Botswana', zkratka = 'BW', popis = '' WHERE ident_cely = 'HES-001377';
UPDATE heslar SET razeni = 31, heslo = 'metalografie', heslo_en = 'metallography', popis = 'Zabývá se vnitřní stavbou kovů a slitin, strukturními složkami a jejich vlivem na vlastnosti kovů.' WHERE ident_cely = 'HES-000630';
UPDATE heslar SET razeni = 31, heslo = 'mikrofotografie', heslo_en = 'photomicrograph', popis = '' WHERE ident_cely = 'HES-001096';
UPDATE heslar SET razeni = 31, heslo = 'mosaz', heslo_en = 'brass', popis = '' WHERE ident_cely = 'HES-000995';
UPDATE heslar SET razeni = 32, heslo = 'pozůstatek mohylníku', heslo_en = 'remains of burial mounds', popis = 'mohylníky' WHERE ident_cely = 'HES-001430';
UPDATE heslar SET razeni = 31, heslo = 'sídlo elity', heslo_en = 'elite settlement', popis = '' WHERE ident_cely = 'HES-000085';
UPDATE heslar SET razeni = 31, heslo = 'sídlo elity', heslo_en = 'elite settlement', popis = 'sídlištní (rezidenční) areál společenské elity' WHERE ident_cely = 'HES-000013';
UPDATE heslar SET razeni = 310, heslo = 'schodiště', heslo_en = 'staircase', popis = '' WHERE ident_cely = 'HES-000452';
UPDATE heslar SET razeni = 311, heslo = 'základy', heslo_en = 'foundations', popis = '' WHERE ident_cely = 'HES-000498';
UPDATE heslar SET razeni = 32, heslo = 'Bouvetův ostrov', heslo_en = 'Bouvet Island', zkratka = 'BV', popis = '' WHERE ident_cely = 'HES-001347';
UPDATE heslar SET razeni = 32, heslo = 'dvorec/dvůr', heslo_en = 'curia/manorial farm', popis = 'vč. Viereckschanze' WHERE ident_cely = 'HES-000014';
UPDATE heslar SET razeni = 32, heslo = 'náhodný zásah/nález', heslo_en = 'chance find', popis = 'ojedinělý nález při stavebním či jiném podpovrchovém terénním zásahu' WHERE ident_cely = 'HES-001053';
UPDATE heslar SET razeni = 32, heslo = 'numismatika', heslo_en = 'numismatics', popis = 'Pomocná věda historická zabývající se studiem platidel.' WHERE ident_cely = 'HES-000623';
UPDATE heslar SET razeni = 32, heslo = 'obilky/semena', heslo_en = 'caryopses/seeds', popis = '' WHERE ident_cely = 'HES-000996';
UPDATE heslar SET razeni = 32, heslo = 'plán regionu', heslo_en = 'plan of region', popis = '' WHERE ident_cely = 'HES-001101';
UPDATE heslar SET razeni = 33, heslo = 'pozůstatek ohrazení', heslo_en = 'remains of enclosure', popis = 'hradiště, rondely, výšinná sídliště, dvorce...' WHERE ident_cely = 'HES-001431';
UPDATE heslar SET razeni = 33, heslo = 'Brazílie', heslo_en = 'Brazil', zkratka = 'BR', popis = '' WHERE ident_cely = 'HES-001252';
UPDATE heslar SET razeni = 33, heslo = 'expertní analýza', heslo_en = 'expert analysis', popis = 'Méně obvyklé, samostatně nezmiňované expertní analýzy.' WHERE ident_cely = 'HES-000619';
UPDATE heslar SET razeni = 33, heslo = 'hrad', heslo_en = 'castle', popis = '' WHERE ident_cely = 'HES-000015';
UPDATE heslar SET razeni = 33, heslo = 'olovo', heslo_en = 'lead', popis = '' WHERE ident_cely = 'HES-000997';
UPDATE heslar SET razeni = 33, heslo = 'plán lokality', heslo_en = 'plan of site', popis = '' WHERE ident_cely = 'HES-001106';
UPDATE heslar SET razeni = 34, heslo = 'pozůstatek represe', heslo_en = 'remains of repression site', popis = 'šibenice, popraviště, lágry, vězení...' WHERE ident_cely = 'HES-001432';
UPDATE heslar SET razeni = 34, heslo = 'Britské indickooceánské území', heslo_en = 'British Indian Ocean Territory (the)', zkratka = 'IO', popis = '' WHERE ident_cely = 'HES-001285';
UPDATE heslar SET razeni = 34, heslo = 'experimentální archeologie', heslo_en = 'experimental archaeology', popis = 'Zabývá se studiem výrobních procesů, způsobu života a dalších činností lidí v průběhu dějin pomocí experimentu.' WHERE ident_cely = 'HES-001446';
UPDATE heslar SET razeni = 34, heslo = 'městský palác', heslo_en = 'town palace', popis = '' WHERE ident_cely = 'HES-000016';
UPDATE heslar SET razeni = 34, heslo = 'nedokumentovaná akce', heslo_en = 'undocumented fieldwork', popis = 'stavební a jiná terénní akce bez účasti archeologa' WHERE ident_cely = 'HES-001054';
UPDATE heslar SET razeni = 34, heslo = 'omítka', heslo_en = 'plaster', popis = '' WHERE ident_cely = 'HES-000998';
UPDATE heslar SET razeni = 34, heslo = 'plán výzkumu', heslo_en = 'plan of fieldwork', popis = '' WHERE ident_cely = 'HES-001107';
UPDATE heslar SET razeni = 31, heslo = 'pozůstatek kultu', heslo_en = 'remains of ritual site', popis = 'kostely, kláštery, kaple, menhiry, hřbitovy...' WHERE ident_cely = 'HES-001433';
UPDATE heslar SET razeni = 35, heslo = 'Britské Panenské ostrovy', heslo_en = 'Virgin Islands (British)', zkratka = 'VG', popis = '' WHERE ident_cely = 'HES-001333';
UPDATE heslar SET razeni = 35, heslo = 'konzervace a restaurování', heslo_en = 'conservation and restoration', popis = 'Konzervace zahrnuje veškerou péči o předměty kulturního dědictví za účelem zachování jejich komplexní hodnoty. Restaurování si klade za cíl záchranu a odborné opravování uměleckých děl a starožitností.' WHERE ident_cely = 'HES-000629';
UPDATE heslar SET razeni = 35, heslo = 'papír', heslo_en = 'paper', popis = '' WHERE ident_cely = 'HES-000999';
UPDATE heslar SET razeni = 35, heslo = 'plán sondy', heslo_en = 'plan of trench', popis = '' WHERE ident_cely = 'HES-001108';
UPDATE heslar SET razeni = 35, heslo = 'pozůstatek sídla elity', heslo_en = 'remains of manorial site', popis = 'hrady, zámky, tvrze...' WHERE ident_cely = 'HES-001434';
UPDATE heslar SET razeni = 35, heslo = 'tvrz/hrádek', heslo_en = 'fortified manor', popis = '' WHERE ident_cely = 'HES-000017';
UPDATE heslar SET razeni = 36, heslo = 'Brunej', heslo_en = 'Brunei Darussalam', zkratka = 'BN', popis = '' WHERE ident_cely = 'HES-001359';
UPDATE heslar SET razeni = 36, heslo = 'orientační zjištění', heslo_en = 'brief evidence', popis = 'orientační ohledání teréního zásahu (narušené lokality) ' WHERE ident_cely = 'HES-001055';
UPDATE heslar SET razeni = 36, heslo = 'paroh', heslo_en = 'antler', popis = '' WHERE ident_cely = 'HES-001000';
UPDATE heslar SET razeni = 36, heslo = 'plán objektu', heslo_en = 'plan of feature', popis = '' WHERE ident_cely = 'HES-001109';
UPDATE heslar SET razeni = 36, heslo = 'pozůstatek sídliště', heslo_en = 'remains of settlement', popis = 'zaniklé vesnice, města, latrány, osady z historických obdobbí (středověk a mladší)' WHERE ident_cely = 'HES-001435';
UPDATE heslar SET razeni = 36, heslo = 'stavebně-historický průzkum', heslo_en = 'building-historical survey', popis = 'Komplexní analýza a interpretace historických staveb a jejich vývoje.' WHERE ident_cely = 'HES-000632';
UPDATE heslar SET razeni = 36, heslo = 'zámek/zámeček/vila', heslo_en = 'chateau/villa', popis = '' WHERE ident_cely = 'HES-000018';
UPDATE heslar SET razeni = 37, heslo = 'Bulharsko', heslo_en = 'Bulgaria', zkratka = 'BG', popis = '' WHERE ident_cely = 'HES-001360';
UPDATE heslar SET razeni = 37, heslo = 'kresba předmětu', heslo_en = 'object drawing', popis = '' WHERE ident_cely = 'HES-001110';
UPDATE heslar SET razeni = 37, heslo = 'pecka', heslo_en = 'fruit stone', popis = '' WHERE ident_cely = 'HES-001001';
UPDATE heslar SET razeni = 37, heslo = 'pozůstatek těžby', heslo_en = 'remains of extraction site', popis = 'doly, rýžoviště, lomy, písečníky...' WHERE ident_cely = 'HES-001436';
UPDATE heslar SET razeni = 38, heslo = 'Burkina Faso', heslo_en = 'Burkina Faso', zkratka = 'BF', popis = '' WHERE ident_cely = 'HES-001361';
UPDATE heslar SET razeni = 38, heslo = 'mapa', heslo_en = 'map', popis = '' WHERE ident_cely = 'HES-001111';
UPDATE heslar SET razeni = 38, heslo = 'perla', heslo_en = 'pearl', popis = '' WHERE ident_cely = 'HES-001002';
UPDATE heslar SET razeni = 38, heslo = 'pozůstatek vojenství', heslo_en = 'remains of military site', popis = 'polní opevnění, tábory, palebná postavení, kasárna, strážnice... (nikoli celá bojiště)' WHERE ident_cely = 'HES-001437';
UPDATE heslar SET razeni = 38, heslo = 'vertikální řez', heslo_en = 'linear trench', popis = '' WHERE ident_cely = 'HES-001056';
UPDATE heslar SET razeni = 39, heslo = '3D rekonstrukce', heslo_en = '3D reconstruction', popis = '' WHERE ident_cely = 'HES-001113';
UPDATE heslar SET razeni = 39, heslo = 'Burundi', heslo_en = 'Burundi', zkratka = 'BI', popis = '' WHERE ident_cely = 'HES-001362';
UPDATE heslar SET razeni = 39, heslo = 'perleť/mušle', heslo_en = 'nacre/shell', popis = '' WHERE ident_cely = 'HES-001003';
UPDATE heslar SET razeni = 39, heslo = 'pozůstatek výroby', heslo_en = 'remains of production site', popis = 'mlýny, pivovary, sklárny, hutě...' WHERE ident_cely = 'HES-001438';
UPDATE heslar SET razeni = 4, heslo = '20–30 km', heslo_en = '20–30 km', popis = '' WHERE ident_cely = 'HES-000102';
UPDATE heslar SET razeni = 4, heslo = '9 x 12 cm', heslo_en = '9 x 12 cm', popis = '' WHERE ident_cely = 'HES-000144';
UPDATE heslar SET razeni = 4, heslo = 'Albánie', heslo_en = 'Albania', zkratka = 'AL', popis = '' WHERE ident_cely = 'HES-001181';
UPDATE heslar SET razeni = 4, heslo = 'archiv jiné organizace', heslo_en = 'other institutional archive', popis = '' WHERE ident_cely = 'HES-001169';
UPDATE heslar SET razeni = 4, heslo = 'archivář', heslo_en = 'archivist', zkratka = 'D', popis = '' WHERE ident_cely = 'HES-000868';
UPDATE heslar SET razeni = 4, heslo = 'bioarcheologie', heslo_en = 'bioarchaeology', popis = 'Méně obvyklé, samostatně nezmiňované metody bioarcheologického výzkumu (např. paleodemografie).' WHERE ident_cely = 'HES-001439';
UPDATE heslar SET razeni = 4, heslo = 'Brno-Tuřany', heslo_en = 'Brno-Tuřany', popis = '' WHERE ident_cely = 'HES-000184';
UPDATE heslar SET razeni = 4, heslo = 'dehet', heslo_en = 'tar', popis = '' WHERE ident_cely = 'HES-000968';
UPDATE heslar SET razeni = 4, heslo = 'diapozitiv barevný', heslo_en = 'colour photoslide', zkratka = 'dia-bar', popis = '' WHERE ident_cely = 'HES-000220';
UPDATE heslar SET razeni = 4, heslo = 'fotografie diapozitivy', heslo_en = 'photoslides', zkratka = 'FD', popis = '' WHERE ident_cely = 'HES-000876';
UPDATE heslar SET razeni = 4, heslo = 'francouzština', heslo_en = 'French', zkratka = 'FR', popis = '' WHERE ident_cely = 'HES-000170';
UPDATE heslar SET razeni = 4, heslo = 'geofyzikální průzkum', heslo_en = 'geophysical survey', popis = '' WHERE ident_cely = 'HES-001142';
UPDATE heslar SET razeni = 4, heslo = 'havárie/stavební narušení', heslo_en = 'accident/building disruption', popis = '' WHERE ident_cely = 'HES-000597';
UPDATE heslar SET razeni = 4, heslo = 'katastrální území', heslo_en = 'cadastral area', popis = '' WHERE ident_cely = 'HES-001073';
UPDATE heslar SET razeni = 4, heslo = 'kniha', heslo_en = 'book', zkratka = 'A', popis = '' WHERE ident_cely = 'HES-001117';
UPDATE heslar SET razeni = 4, heslo = 'krajina', heslo_en = 'landscape', popis = '' WHERE ident_cely = 'HES-000136';
UPDATE heslar SET razeni = 4, heslo = 'lesní hrabanka', heslo_en = 'woodland topsoil', popis = '' WHERE ident_cely = 'HES-000245';
UPDATE heslar SET razeni = 3, heslo = 'národní kulturní památka', heslo_en = 'listed national monument', popis = '' WHERE ident_cely = 'HES-000178';
UPDATE heslar SET razeni = 4, heslo = 'není, nezjištěno', heslo_en = 'unavailable/unknown', zkratka = '4', popis = '' WHERE ident_cely = 'HES-000240';
UPDATE heslar SET razeni = 4, heslo = 'oblačno, zataženo', heslo_en = 'cloudy, overcast', popis = '' WHERE ident_cely = 'HES-000589';
UPDATE heslar SET razeni = 4, heslo = 'plošný objekt', heslo_en = 'polygonal feature', popis = 'zhruba nad 100 m2' WHERE ident_cely = 'HES-001031';
UPDATE heslar SET razeni = 4, heslo = 'poloha podle katastru', heslo_en = 'location by cadastral area', zkratka = '4', popis = 'poloha podle katastru' WHERE ident_cely = 'HES-000864';
UPDATE heslar SET razeni = 4, heslo = 'restaurátorská zpráva', heslo_en = 'conservator report', popis = '' WHERE ident_cely = 'HES-001078';
UPDATE heslar SET razeni = 4, heslo = 'snížené podloží', heslo_en = 'levelled subsoil', popis = '' WHERE ident_cely = 'HES-001160';
UPDATE heslar SET razeni = 4, heslo = 'společenská akce', heslo_en = 'social event', popis = '' WHERE ident_cely = 'HES-001155';
UPDATE heslar SET razeni = 4, heslo = 'těžba', heslo_en = 'mining activity', zkratka = 'těž', popis = '' WHERE ident_cely = 'HES-000004';
UPDATE heslar SET razeni = 4, heslo = 'univerzita', heslo_en = 'university', popis = '' WHERE ident_cely = 'HES-001132';
UPDATE heslar SET razeni = 4, heslo = 'ztraceno/skartováno', heslo_en = 'lost/discarded', zkratka = '4', popis = '' WHERE ident_cely = 'HES-001176';
UPDATE heslar SET razeni = 40, heslo = '3D dokumentace', heslo_en = '3D documentation', popis = '' WHERE ident_cely = 'HES-001114';
UPDATE heslar SET razeni = 40, heslo = 'Cookovy ostrovy', heslo_en = 'Cook Islands (the)', zkratka = 'CK', popis = '' WHERE ident_cely = 'HES-001283';
UPDATE heslar SET razeni = 40, heslo = 'krajina', heslo_en = 'landscape', popis = 'dnešní krajina bez specifikace (lokalizace na katastr)' WHERE ident_cely = 'HES-000117';
UPDATE heslar SET razeni = 40, heslo = 'kultovní areál', heslo_en = 'ritual site', popis = '' WHERE ident_cely = 'HES-000086';
UPDATE heslar SET razeni = 40, heslo = 'kultovní areál', heslo_en = 'ritual site', popis = 'samostatný kultovní areál' WHERE ident_cely = 'HES-000019';
UPDATE heslar SET razeni = 40, heslo = 'plast', heslo_en = 'plastic', popis = '' WHERE ident_cely = 'HES-001004';
UPDATE heslar SET razeni = 40, heslo = 'terénní odkryv', heslo_en = 'field excavation', popis = '' WHERE ident_cely = 'HES-001066';
UPDATE heslar SET razeni = 400, heslo = 'barvivo', heslo_en = 'colourant', popis = '' WHERE ident_cely = 'HES-000903';
UPDATE heslar SET razeni = 400, heslo = 'ekofakt', heslo_en = 'ecofact', popis = '' WHERE ident_cely = 'HES-000775';
UPDATE heslar SET razeni = 400, heslo = 'ekofakt', heslo_en = 'ecofact', popis = '' WHERE ident_cely = 'HES-000845';
UPDATE heslar SET razeni = 400, heslo = 'neolit', heslo_en = 'Neolithic', popis = '' WHERE ident_cely = 'HES-000398';
UPDATE heslar SET razeni = 400, heslo = 'neolit', heslo_en = 'Neolithic', zkratka = 'neolit', popis = '' WHERE ident_cely = 'HES-000267';
UPDATE heslar SET razeni = 400, heslo = 'těžený/zpracovávaný materiál', heslo_en = 'extracted/processed material', popis = '' WHERE ident_cely = 'HES-000964';
UPDATE heslar SET razeni = 400, heslo = 'vrstva/souvrství', heslo_en = 'layer/layer sequence', popis = '' WHERE ident_cely = 'HES-000453';
UPDATE heslar SET razeni = 400, heslo = 'vrstva/souvrství', heslo_en = 'layer/layer sequence', popis = '' WHERE ident_cely = 'HES-000574';
UPDATE heslar SET razeni = 401, heslo = 'bronz', heslo_en = 'bronze', popis = '' WHERE ident_cely = 'HES-000904';
UPDATE heslar SET razeni = 401, heslo = 'destrukční vrstva/souvrství', heslo_en = 'destruction layer/sequence', popis = '' WHERE ident_cely = 'HES-000454';
UPDATE heslar SET razeni = 401, heslo = 'kamenné jádro', heslo_en = 'stone core', popis = '' WHERE ident_cely = 'HES-000776';
UPDATE heslar SET razeni = 402, heslo = 'cín', heslo_en = 'tin', popis = '' WHERE ident_cely = 'HES-000921';
UPDATE heslar SET razeni = 402, heslo = 'geologická/přirozená vrstva', heslo_en = 'natural/geological layer', popis = '' WHERE ident_cely = 'HES-000455';
UPDATE heslar SET razeni = 402, heslo = 'kost', heslo_en = 'single bone', popis = '' WHERE ident_cely = 'HES-000753';
UPDATE heslar SET razeni = 403, heslo = 'dehet', heslo_en = 'tar', popis = '' WHERE ident_cely = 'HES-000922';
UPDATE heslar SET razeni = 403, heslo = 'kostra', heslo_en = 'skeleton', popis = '' WHERE ident_cely = 'HES-000642';
UPDATE heslar SET razeni = 403, heslo = 'násep', heslo_en = 'bank', popis = '' WHERE ident_cely = 'HES-000456';
UPDATE heslar SET razeni = 404, heslo = 'dřevo', heslo_en = 'wood', popis = '' WHERE ident_cely = 'HES-000923';
UPDATE heslar SET razeni = 404, heslo = 'malakofauna', heslo_en = 'mollusca', popis = '' WHERE ident_cely = 'HES-000777';
UPDATE heslar SET razeni = 404, heslo = 'navážka', heslo_en = 'backfill', popis = '' WHERE ident_cely = 'HES-000457';
UPDATE heslar SET razeni = 405, heslo = 'grafit', heslo_en = 'graphite', popis = '' WHERE ident_cely = 'HES-000924';
UPDATE heslar SET razeni = 405, heslo = 'odpad', heslo_en = 'waste', popis = '' WHERE ident_cely = 'HES-000778';
UPDATE heslar SET razeni = 405, heslo = 'odpadní vrstva/souvrství', heslo_en = 'waste layer/sequence', popis = '' WHERE ident_cely = 'HES-000458';
UPDATE heslar SET razeni = 406, heslo = 'hlína', heslo_en = 'clay', popis = '' WHERE ident_cely = 'HES-000925';
UPDATE heslar SET razeni = 406, heslo = 'odpad stavební', heslo_en = 'construction waste', popis = '' WHERE ident_cely = 'HES-000779';
UPDATE heslar SET razeni = 406, heslo = 'podlaha (vrstva/souvrství)', heslo_en = 'floor layer/sequence', popis = '' WHERE ident_cely = 'HES-000459';
UPDATE heslar SET razeni = 407, heslo = 'jantar', heslo_en = 'amber', popis = '' WHERE ident_cely = 'HES-000926';
UPDATE heslar SET razeni = 407, heslo = 'odpad výrobní', heslo_en = 'production waste', popis = '' WHERE ident_cely = 'HES-000780';
UPDATE heslar SET razeni = 407, heslo = 'sídlištní vrstva/souvrství', heslo_en = 'settlement layer/sequence', popis = '' WHERE ident_cely = 'HES-000460';
UPDATE heslar SET razeni = 408, heslo = 'kámen', heslo_en = 'stone', popis = '' WHERE ident_cely = 'HES-000927';
UPDATE heslar SET razeni = 408, heslo = 'přechovávaná přírodnina', heslo_en = 'natural object', popis = '' WHERE ident_cely = 'HES-000643';
UPDATE heslar SET razeni = 408, heslo = 'splach/naplavenina', heslo_en = 'colluvial/alluvial layer', popis = '' WHERE ident_cely = 'HES-000461';
UPDATE heslar SET razeni = 409, heslo = 'kámen broušený', heslo_en = 'polished stone', popis = '' WHERE ident_cely = 'HES-000928';
UPDATE heslar SET razeni = 409, heslo = 'rostlinné makrozbytky', heslo_en = 'plant macro-remain', popis = '' WHERE ident_cely = 'HES-000644';
UPDATE heslar SET razeni = 409, heslo = 'výplň/zásyp', heslo_en = 'fill/deposit', popis = '' WHERE ident_cely = 'HES-000462';
UPDATE heslar SET razeni = 41, heslo = '3D textura', heslo_en = '3D texture', popis = '' WHERE ident_cely = 'HES-001115';
UPDATE heslar SET razeni = 41, heslo = 'Curaçao', heslo_en = 'Curaçao', zkratka = 'CW', popis = '' WHERE ident_cely = 'HES-001243';
UPDATE heslar SET razeni = 41, heslo = 'kaple', heslo_en = 'chapel', popis = '' WHERE ident_cely = 'HES-000020';
UPDATE heslar SET razeni = 41, heslo = 'muzeum/skanzen', heslo_en = 'museum/open-air museum', popis = '' WHERE ident_cely = 'HES-000129';
UPDATE heslar SET razeni = 41, heslo = 'proutí', heslo_en = 'wattle', popis = '' WHERE ident_cely = 'HES-001005';
UPDATE heslar SET razeni = 410, heslo = 'kámen drahý', heslo_en = 'gemstone', popis = '' WHERE ident_cely = 'HES-000929';
UPDATE heslar SET razeni = 410, heslo = 'skořápka plodu', heslo_en = 'fruit shell/nutshell', popis = '' WHERE ident_cely = 'HES-000754';
UPDATE heslar SET razeni = 410, heslo = 'starší neolit', heslo_en = 'Early Neolithic', zkratka = 'ne.st', popis = '' WHERE ident_cely = 'HES-000268';
UPDATE heslar SET razeni = 410, heslo = 'žároviště', heslo_en = 'burned layer', popis = '' WHERE ident_cely = 'HES-000463';
UPDATE heslar SET razeni = 411, heslo = 'kámen drtidlo/žernov', heslo_en = 'grinding stone', popis = '' WHERE ident_cely = 'HES-000930';
UPDATE heslar SET razeni = 411, heslo = 'kultura s lineární keramikou', heslo_en = 'Linear Pottery Culture', zkratka = 'ne.lin', popis = '' WHERE ident_cely = 'HES-000269';
UPDATE heslar SET razeni = 411, heslo = 'struska', heslo_en = 'slag', popis = '' WHERE ident_cely = 'HES-000645';
UPDATE heslar SET razeni = 412, heslo = 'kámen stavební', heslo_en = 'building stone', popis = '' WHERE ident_cely = 'HES-000931';
UPDATE heslar SET razeni = 412, heslo = 'šárecký typ', heslo_en = 'Šárka Type', zkratka = 'ne.sar', popis = '' WHERE ident_cely = 'HES-000394';
UPDATE heslar SET razeni = 412, heslo = 'uhlíky/popel', heslo_en = 'charcoal/ash', popis = '' WHERE ident_cely = 'HES-000781';
UPDATE heslar SET razeni = 413, heslo = 'kámen štípaný', heslo_en = 'lithics', popis = '' WHERE ident_cely = 'HES-000932';
UPDATE heslar SET razeni = 413, heslo = 'vejce', heslo_en = 'eggshell', popis = '' WHERE ident_cely = 'HES-000646';
UPDATE heslar SET razeni = 413, heslo = 'želiezovská skupina', heslo_en = 'Želizovce Group', zkratka = 'ne.zel', popis = '' WHERE ident_cely = 'HES-000340';
UPDATE heslar SET razeni = 414, heslo = 'keramika', heslo_en = 'ceramic', popis = '' WHERE ident_cely = 'HES-000933';
UPDATE heslar SET razeni = 414, heslo = 'oberlauterbašská skupina', heslo_en = 'Oberlauterbach Group', zkratka = 'ne.obe', popis = '' WHERE ident_cely = 'HES-000305';
UPDATE heslar SET razeni = 414, heslo = 'zub', heslo_en = 'tooth', popis = '' WHERE ident_cely = 'HES-000647';
UPDATE heslar SET razeni = 415, heslo = 'keramika fajáns/majolika', heslo_en = 'faience/maiolica', popis = '' WHERE ident_cely = 'HES-000934';
UPDATE heslar SET razeni = 416, heslo = 'keramika kamenina', heslo_en = 'stoneware', popis = '' WHERE ident_cely = 'HES-000935';
UPDATE heslar SET razeni = 417, heslo = 'keramika porcelán', heslo_en = 'porcelain', popis = '' WHERE ident_cely = 'HES-000936';
UPDATE heslar SET razeni = 418, heslo = 'keramika terra sigillata', heslo_en = 'terra sigillata ware', popis = '' WHERE ident_cely = 'HES-000937';
UPDATE heslar SET razeni = 419, heslo = 'korál', heslo_en = 'coral', popis = '' WHERE ident_cely = 'HES-000938';
UPDATE heslar SET razeni = 42, heslo = 'Čad', heslo_en = 'Chad', zkratka = 'TD', popis = '' WHERE ident_cely = 'HES-001405';
UPDATE heslar SET razeni = 42, heslo = 'kostel', heslo_en = 'church', popis = '' WHERE ident_cely = 'HES-000021';
UPDATE heslar SET razeni = 42, heslo = 'neurčený dokument', heslo_en = 'unspecified document', popis = '' WHERE ident_cely = 'HES-001112';
UPDATE heslar SET razeni = 42, heslo = 'pomník/památník', heslo_en = 'memorial', popis = '' WHERE ident_cely = 'HES-000128';
UPDATE heslar SET razeni = 42, heslo = 'pryskyřice', heslo_en = 'resin', popis = '' WHERE ident_cely = 'HES-001006';
UPDATE heslar SET razeni = 42, heslo = 'sonda', heslo_en = 'pit trench', popis = '' WHERE ident_cely = 'HES-001057';
UPDATE heslar SET razeni = 420, heslo = 'kost', heslo_en = 'bone', popis = '' WHERE ident_cely = 'HES-000939';
UPDATE heslar SET razeni = 420, heslo = 'střední–mladší neolit', heslo_en = 'Middle–Late Neolithic', zkratka = 'ne.ml', popis = '' WHERE ident_cely = 'HES-000360';
UPDATE heslar SET razeni = 421, heslo = 'kost lidská', heslo_en = 'human bone', popis = '' WHERE ident_cely = 'HES-000905';
UPDATE heslar SET razeni = 421, heslo = 'kultura s vypíchanou keramikou', heslo_en = 'Stroke Pottery Culture', zkratka = 'ne.vyp', popis = '' WHERE ident_cely = 'HES-000361';
UPDATE heslar SET razeni = 422, heslo = 'kost zvířecí', heslo_en = 'animal bone', popis = '' WHERE ident_cely = 'HES-000906';
UPDATE heslar SET razeni = 422, heslo = 'kultura s moravskou malovanou keramikou 1', heslo_en = 'Moravian Painted Ware Culture 1', zkratka = 'ne.mm1', popis = '' WHERE ident_cely = 'HES-000362';
UPDATE heslar SET razeni = 423, heslo = 'kov', heslo_en = 'metal', popis = '' WHERE ident_cely = 'HES-000907';
UPDATE heslar SET razeni = 423, heslo = 'lengyelská kultura', heslo_en = 'Lengyel Culture', zkratka = 'ne.len', popis = '' WHERE ident_cely = 'HES-000306';
UPDATE heslar SET razeni = 424, heslo = 'kov barevný', heslo_en = 'nonferrous metal', popis = '' WHERE ident_cely = 'HES-000908';
UPDATE heslar SET razeni = 424, heslo = 'kultura münchshöfenská', heslo_en = 'Münchshofen Culture', zkratka = 'ne.mun', popis = '' WHERE ident_cely = 'HES-000389';
UPDATE heslar SET razeni = 425, heslo = 'kůra', heslo_en = 'bark', popis = '' WHERE ident_cely = 'HES-000940';
UPDATE heslar SET razeni = 426, heslo = 'kůže', heslo_en = 'leather', popis = '' WHERE ident_cely = 'HES-000909';
UPDATE heslar SET razeni = 427, heslo = 'malta', heslo_en = 'mortar', popis = '' WHERE ident_cely = 'HES-000910';
UPDATE heslar SET razeni = 428, heslo = 'mazanice', heslo_en = 'daub', popis = '' WHERE ident_cely = 'HES-000911';
UPDATE heslar SET razeni = 429, heslo = 'měď', heslo_en = 'copper', popis = '' WHERE ident_cely = 'HES-000912';
UPDATE heslar SET razeni = 43, heslo = 'Černá Hora', heslo_en = 'Montenegro', zkratka = 'ME', popis = '' WHERE ident_cely = 'HES-001248';
UPDATE heslar SET razeni = 43, heslo = 'kříž/boží muka', heslo_en = 'cross/calvary', popis = '' WHERE ident_cely = 'HES-000022';
UPDATE heslar SET razeni = 43, heslo = 'pyl', heslo_en = 'polen', popis = '' WHERE ident_cely = 'HES-001007';
UPDATE heslar SET razeni = 43, heslo = 'skupina/síť sond', heslo_en = 'group of pit trenches', popis = '' WHERE ident_cely = 'HES-001058';
UPDATE heslar SET razeni = 430, heslo = 'mosaz', heslo_en = 'brass', popis = '' WHERE ident_cely = 'HES-000913';
UPDATE heslar SET razeni = 431, heslo = 'obilky/semena', heslo_en = 'caryopses/seeds', popis = '' WHERE ident_cely = 'HES-000914';
UPDATE heslar SET razeni = 432, heslo = 'olovo', heslo_en = 'lead', popis = '' WHERE ident_cely = 'HES-000915';
UPDATE heslar SET razeni = 433, heslo = 'omítka', heslo_en = 'plaster', popis = '' WHERE ident_cely = 'HES-000916';
UPDATE heslar SET razeni = 434, heslo = 'papír', heslo_en = 'paper', popis = '' WHERE ident_cely = 'HES-000917';
UPDATE heslar SET razeni = 435, heslo = 'paroh', heslo_en = 'antler', popis = '' WHERE ident_cely = 'HES-000918';
UPDATE heslar SET razeni = 436, heslo = 'pecka', heslo_en = 'fruit stone', popis = '' WHERE ident_cely = 'HES-000919';
UPDATE heslar SET razeni = 437, heslo = 'perla', heslo_en = 'pearl', popis = '' WHERE ident_cely = 'HES-000920';
UPDATE heslar SET razeni = 438, heslo = 'perleť/mušle', heslo_en = 'nacre/shell', popis = '' WHERE ident_cely = 'HES-000941';
UPDATE heslar SET razeni = 439, heslo = 'plast', heslo_en = 'plastic', popis = '' WHERE ident_cely = 'HES-000942';
UPDATE heslar SET razeni = 44, heslo = 'Čína', heslo_en = 'China', zkratka = 'CN', popis = '' WHERE ident_cely = 'HES-001249';
UPDATE heslar SET razeni = 44, heslo = 'kultovní místo', heslo_en = 'ritual place', popis = '' WHERE ident_cely = 'HES-000023';
UPDATE heslar SET razeni = 44, heslo = 'roh', heslo_en = 'horn', popis = '' WHERE ident_cely = 'HES-001008';
UPDATE heslar SET razeni = 440, heslo = 'proutí', heslo_en = 'wattle', popis = '' WHERE ident_cely = 'HES-000943';
UPDATE heslar SET razeni = 441, heslo = 'pryskyřice', heslo_en = 'resin', popis = '' WHERE ident_cely = 'HES-000944';
UPDATE heslar SET razeni = 442, heslo = 'roh', heslo_en = 'horn', popis = '' WHERE ident_cely = 'HES-000945';
UPDATE heslar SET razeni = 443, heslo = 'schránky měkýšů', heslo_en = 'mollusc shell', popis = '' WHERE ident_cely = 'HES-000946';
UPDATE heslar SET razeni = 444, heslo = 'sklo', heslo_en = 'glass', popis = '' WHERE ident_cely = 'HES-000947';
UPDATE heslar SET razeni = 445, heslo = 'slonovina/mamutovina', heslo_en = 'ivory', popis = '' WHERE ident_cely = 'HES-000948';
UPDATE heslar SET razeni = 446, heslo = 'spondylus', heslo_en = 'spondylus', popis = '' WHERE ident_cely = 'HES-000949';
UPDATE heslar SET razeni = 447, heslo = 'stříbro', heslo_en = 'silver', popis = '' WHERE ident_cely = 'HES-000950';
UPDATE heslar SET razeni = 448, heslo = 'švartna', heslo_en = 'sapropel', popis = '' WHERE ident_cely = 'HES-000951';
UPDATE heslar SET razeni = 449, heslo = 'textil', heslo_en = 'textile', popis = '' WHERE ident_cely = 'HES-000952';
UPDATE heslar SET razeni = 45, heslo = 'Dánsko', heslo_en = 'Denmark', zkratka = 'DK', popis = '' WHERE ident_cely = 'HES-001250';
UPDATE heslar SET razeni = 45, heslo = 'plošný odkryv', heslo_en = 'total excavation', popis = '' WHERE ident_cely = 'HES-001059';
UPDATE heslar SET razeni = 45, heslo = 'rostlinné makrozbytky', heslo_en = 'plant macro-remains', popis = '' WHERE ident_cely = 'HES-001009';
UPDATE heslar SET razeni = 45, heslo = 'synagoga', heslo_en = 'synagogue', popis = '' WHERE ident_cely = 'HES-000024';
UPDATE heslar SET razeni = 450, heslo = 'uhlí', heslo_en = 'coal', popis = '' WHERE ident_cely = 'HES-000953';
UPDATE heslar SET razeni = 451, heslo = 'uhlí dřevěné', heslo_en = 'charcoal', popis = '' WHERE ident_cely = 'HES-000954';
UPDATE heslar SET razeni = 452, heslo = 'vápno', heslo_en = 'quicklime', popis = '' WHERE ident_cely = 'HES-000955';
UPDATE heslar SET razeni = 453, heslo = 'vejce', heslo_en = 'egg', popis = '' WHERE ident_cely = 'HES-000956';
UPDATE heslar SET razeni = 454, heslo = 'vosk', heslo_en = 'wax', popis = '' WHERE ident_cely = 'HES-000957';
UPDATE heslar SET razeni = 455, heslo = 'zlato', heslo_en = 'gold', popis = '' WHERE ident_cely = 'HES-000958';
UPDATE heslar SET razeni = 456, heslo = 'zub', heslo_en = 'tooth', popis = '' WHERE ident_cely = 'HES-000959';
UPDATE heslar SET razeni = 457, heslo = 'zub lidský', heslo_en = 'human tooth', popis = '' WHERE ident_cely = 'HES-000960';
UPDATE heslar SET razeni = 458, heslo = 'zub zvířecí', heslo_en = 'animal tooth', popis = '' WHERE ident_cely = 'HES-000961';
UPDATE heslar SET razeni = 459, heslo = 'železo', heslo_en = 'iron', popis = '' WHERE ident_cely = 'HES-000962';
UPDATE heslar SET razeni = 46, heslo = 'Konžská demokratická republika', heslo_en = 'Congo (the Democratic Republic of the)', zkratka = 'CD', popis = '' WHERE ident_cely = 'HES-001251';
UPDATE heslar SET razeni = 46, heslo = 'schránky měkýšů', heslo_en = 'mollusc shell', popis = '' WHERE ident_cely = 'HES-001010';
UPDATE heslar SET razeni = 47, heslo = 'Dominika', heslo_en = 'Dominica', zkratka = 'DM', popis = '' WHERE ident_cely = 'HES-001309';
UPDATE heslar SET razeni = 47, heslo = 'sklo', heslo_en = 'glass', popis = '' WHERE ident_cely = 'HES-001011';
UPDATE heslar SET razeni = 48, heslo = 'Dominikánská republika', heslo_en = 'Dominican Republic (the)', zkratka = 'DO', popis = '' WHERE ident_cely = 'HES-001350';
UPDATE heslar SET razeni = 48, heslo = 'slonovina/mamutovina', heslo_en = 'ivory', popis = '' WHERE ident_cely = 'HES-001012';
UPDATE heslar SET razeni = 49, heslo = 'Džibutsko', heslo_en = 'Djibouti', zkratka = 'DJ', popis = '' WHERE ident_cely = 'HES-001317';
UPDATE heslar SET razeni = 49, heslo = 'spondylus', heslo_en = 'spondylus', popis = '' WHERE ident_cely = 'HES-001013';
UPDATE heslar SET razeni = 5, heslo = '30–40 km', heslo_en = '30–40 km', popis = '' WHERE ident_cely = 'HES-000103';
UPDATE heslar SET razeni = 5, heslo = 'A5 (15 x 21 cm)', heslo_en = 'A5 (15 x 21 cm)', popis = '' WHERE ident_cely = 'HES-000145';
UPDATE heslar SET razeni = 5, heslo = 'Alžírsko', heslo_en = 'Algeria', zkratka = 'DZ', popis = '' WHERE ident_cely = 'HES-001182';
UPDATE heslar SET razeni = 5, heslo = 'analýza stabilních izotopů', heslo_en = 'stable isotope analysis', popis = 'Metoda získávání informací o výživě a migracích jedinců za pomocí poměrových analýz stabilních izotopů.' WHERE ident_cely = 'HES-000618';
UPDATE heslar SET razeni = 5, heslo = 'archiv autora', heslo_en = 'author''s archive', popis = 'fyzická osoba' WHERE ident_cely = 'HES-001170';
UPDATE heslar SET razeni = 5, heslo = 'Czestochowa', heslo_en = 'Czestochowa', popis = '' WHERE ident_cely = 'HES-000185';
UPDATE heslar SET razeni = 5, heslo = 'diapozitiv černobílý (film)', heslo_en = 'black-and-white photoslide (film)', zkratka = 'dia-čb-film', popis = '' WHERE ident_cely = 'HES-000221';
UPDATE heslar SET razeni = 5, heslo = 'dřevo', heslo_en = 'wood', popis = '' WHERE ident_cely = 'HES-000969';
UPDATE heslar SET razeni = 5, heslo = 'duplicita', heslo_en = 'duplicate', zkratka = 'D', popis = 'kvalitní, má záznam, neskenován z důvodu věcné duplicity' WHERE ident_cely = 'HES-001177';
UPDATE heslar SET razeni = 5, heslo = 'fotografie letecké (diapozitivy)', heslo_en = 'aerial photoslides', zkratka = 'LD', popis = '' WHERE ident_cely = 'HES-000880';
UPDATE heslar SET razeni = 5, heslo = 'investorská zpráva', heslo_en = 'client report', popis = '' WHERE ident_cely = 'HES-001079';
UPDATE heslar SET razeni = 5, heslo = 'inženýrské sítě', heslo_en = 'engineering networks', popis = '' WHERE ident_cely = 'HES-000598';
UPDATE heslar SET razeni = 5, heslo = 'jiná událost', heslo_en = 'other event', popis = '' WHERE ident_cely = 'HES-001156';
UPDATE heslar SET razeni = 5, heslo = 'jiný zdroj', heslo_en = 'other source', zkratka = 'E', popis = '' WHERE ident_cely = 'HES-001121';
UPDATE heslar SET razeni = 5, heslo = 'kult', heslo_en = 'ritual activity', zkratka = 'kul', popis = '' WHERE ident_cely = 'HES-000005';
UPDATE heslar SET razeni = 5, heslo = 'linie', heslo_en = 'linear feature', popis = '' WHERE ident_cely = 'HES-001032';
UPDATE heslar SET razeni = 5, heslo = 'lokalita', heslo_en = 'site', popis = '' WHERE ident_cely = 'HES-001074';
UPDATE heslar SET razeni = 5, heslo = 'mikroštítek', heslo_en = 'microfiche', zkratka = 'M', popis = 'vysoká kvalita, zpravidla skenován místo originálu' WHERE ident_cely = 'HES-000241';
UPDATE heslar SET razeni = 4, heslo = 'památková zóna', heslo_en = 'heritage zone', popis = '' WHERE ident_cely = 'HES-000179';
UPDATE heslar SET razeni = 5, heslo = 'pravěk', heslo_en = 'Prehistory', popis = '' WHERE ident_cely = 'HES-001161';
UPDATE heslar SET razeni = 5, heslo = 'přirozený půdní horizont', heslo_en = 'natural topsoil', popis = '' WHERE ident_cely = 'HES-000246';
UPDATE heslar SET razeni = 5, heslo = 'slovenština', heslo_en = 'Slovak', zkratka = 'SK', popis = '' WHERE ident_cely = 'HES-000171';
UPDATE heslar SET razeni = 5, heslo = 'slunečno', heslo_en = 'sunny', popis = '' WHERE ident_cely = 'HES-000590';
UPDATE heslar SET razeni = 5, heslo = 'stavebně-historický průzkum', heslo_en = 'building-history survey', popis = '' WHERE ident_cely = 'HES-001143';
UPDATE heslar SET razeni = 5, heslo = 'ústav památkové péče', heslo_en = 'heritage organisation', popis = '' WHERE ident_cely = 'HES-001130';
UPDATE heslar SET razeni = 50, heslo = 'Egypt', heslo_en = 'Egypt', zkratka = 'EG', popis = '' WHERE ident_cely = 'HES-001246';
UPDATE heslar SET razeni = 50, heslo = 'environmentální vzorek', heslo_en = 'environmental sampling', popis = '' WHERE ident_cely = 'HES-001067';
UPDATE heslar SET razeni = 50, heslo = 'environmentální vzorek', heslo_en = 'environmental sampling', popis = 'odběr vzorků; palynologický vrt; geologický vrt' WHERE ident_cely = 'HES-001060';
UPDATE heslar SET razeni = 50, heslo = 'pohřební areál', heslo_en = 'burial site', popis = '' WHERE ident_cely = 'HES-000087';
UPDATE heslar SET razeni = 50, heslo = 'pohřební areál', heslo_en = 'burial site', popis = 'prostor výhradně či převážně užívaný k pohřbívání' WHERE ident_cely = 'HES-000025';
UPDATE heslar SET razeni = 50, heslo = 'stříbro', heslo_en = 'silver', popis = '' WHERE ident_cely = 'HES-001014';
UPDATE heslar SET razeni = 500, heslo = 'deska', heslo_en = 'board', popis = '' WHERE ident_cely = 'HES-000712';
UPDATE heslar SET razeni = 500, heslo = 'eneolit', heslo_en = 'Eneolithic', popis = '' WHERE ident_cely = 'HES-000399';
UPDATE heslar SET razeni = 500, heslo = 'eneolit', heslo_en = 'Eneolithic', zkratka = 'eneoli', popis = '' WHERE ident_cely = 'HES-000285';
UPDATE heslar SET razeni = 500, heslo = 'funkčně neurčený předmět', heslo_en = 'object of unspecified function', popis = '' WHERE ident_cely = 'HES-000846';
UPDATE heslar SET razeni = 500, heslo = 'inženýrské sítě', heslo_en = 'utilities', popis = '' WHERE ident_cely = 'HES-000515';
UPDATE heslar SET razeni = 500, heslo = 'inženýrské sítě', heslo_en = 'utilities', popis = '' WHERE ident_cely = 'HES-000575';
UPDATE heslar SET razeni = 501, heslo = 'drát', heslo_en = 'wire', popis = '' WHERE ident_cely = 'HES-000782';
UPDATE heslar SET razeni = 501, heslo = 'kanalizace', heslo_en = 'sewer', popis = '' WHERE ident_cely = 'HES-000464';
UPDATE heslar SET razeni = 502, heslo = 'hrot/hák', heslo_en = 'spike/hook', popis = '' WHERE ident_cely = 'HES-000783';
UPDATE heslar SET razeni = 502, heslo = 'kolektor', heslo_en = 'collector', popis = '' WHERE ident_cely = 'HES-000516';
UPDATE heslar SET razeni = 503, heslo = 'kování', heslo_en = 'mount', popis = '' WHERE ident_cely = 'HES-000694';
UPDATE heslar SET razeni = 503, heslo = 'trativod', heslo_en = 'drainage', popis = '' WHERE ident_cely = 'HES-000517';
UPDATE heslar SET razeni = 504, heslo = 'kroužek/kruh', heslo_en = 'circle/ring', popis = '' WHERE ident_cely = 'HES-000764';
UPDATE heslar SET razeni = 504, heslo = 'vodovod', heslo_en = 'water supply pipe', popis = '' WHERE ident_cely = 'HES-000518';
UPDATE heslar SET razeni = 505, heslo = 'kulička/koule', heslo_en = 'ball/sphere', popis = '' WHERE ident_cely = 'HES-000760';
UPDATE heslar SET razeni = 506, heslo = 'plech', heslo_en = 'metal sheet', popis = '' WHERE ident_cely = 'HES-000680';
UPDATE heslar SET razeni = 507, heslo = 'tyčinka/váleček', heslo_en = 'rod/log', popis = '' WHERE ident_cely = 'HES-000765';
UPDATE heslar SET razeni = 51, heslo = 'Ekvádor', heslo_en = 'Ecuador', zkratka = 'EC', popis = '' WHERE ident_cely = 'HES-001354';
UPDATE heslar SET razeni = 51, heslo = 'izolovaný pohřeb', heslo_en = 'isolated grave', popis = '' WHERE ident_cely = 'HES-000026';
UPDATE heslar SET razeni = 51, heslo = 'švartna', heslo_en = 'sapropel', popis = '' WHERE ident_cely = 'HES-001015';
UPDATE heslar SET razeni = 510, heslo = 'časný eneolit', heslo_en = 'Proto-Eneolithic', zkratka = 'en.ca', popis = '' WHERE ident_cely = 'HES-000286';
UPDATE heslar SET razeni = 511, heslo = 'kultura s moravskou malovanou keramikou 2', heslo_en = 'Moravian Painted Ware Culture 2', zkratka = 'en.mm2', popis = '' WHERE ident_cely = 'HES-000363';
UPDATE heslar SET razeni = 512, heslo = 'jordanovská kultura', heslo_en = 'Jordanów Culture', zkratka = 'en.jor', popis = '' WHERE ident_cely = 'HES-000287';
UPDATE heslar SET razeni = 513, heslo = 'schusseriedská kultura', heslo_en = 'Schussenried Culture', zkratka = 'en.sch', popis = '' WHERE ident_cely = 'HES-000364';
UPDATE heslar SET razeni = 514, heslo = 'michelsberská kultura', heslo_en = 'Michelsberg Culture', zkratka = 'en.mic', popis = '' WHERE ident_cely = 'HES-000365';
UPDATE heslar SET razeni = 52, heslo = 'Eritrea', heslo_en = 'Eritrea', zkratka = 'ER', popis = '' WHERE ident_cely = 'HES-001394';
UPDATE heslar SET razeni = 52, heslo = 'pohřebiště/hřbitov', heslo_en = 'cemetery/graveyard', popis = '' WHERE ident_cely = 'HES-000027';
UPDATE heslar SET razeni = 52, heslo = 'textil', heslo_en = 'textile', popis = '' WHERE ident_cely = 'HES-001016';
UPDATE heslar SET razeni = 520, heslo = 'starší eneolit', heslo_en = 'Early Eneolithic', zkratka = 'en.st', popis = '' WHERE ident_cely = 'HES-000366';
UPDATE heslar SET razeni = 521, heslo = 'kultura Retz-Bajč-Křepice', heslo_en = 'Retz-Bajč-Křepice (Furchenstich) Culture', zkratka = 'en.rbk', popis = '' WHERE ident_cely = 'HES-000367';
UPDATE heslar SET razeni = 522, heslo = 'kultura nálevkovitých pohárů', heslo_en = 'Funnel Beaker Culture', zkratka = 'en.nal', popis = '' WHERE ident_cely = 'HES-000368';
UPDATE heslar SET razeni = 523, heslo = 'ohrozimský typ', heslo_en = 'Ohrozim Type', zkratka = 'en.ohr', popis = '' WHERE ident_cely = 'HES-000369';
UPDATE heslar SET razeni = 53, heslo = 'Estonsko', heslo_en = 'Estonia', zkratka = 'EE', popis = '' WHERE ident_cely = 'HES-001232';
UPDATE heslar SET razeni = 53, heslo = 'pohřebiště v sakrální stavbě', heslo_en = 'burials in sacral building', popis = '' WHERE ident_cely = 'HES-000077';
UPDATE heslar SET razeni = 53, heslo = 'uhlí', heslo_en = 'coal', popis = '' WHERE ident_cely = 'HES-001017';
UPDATE heslar SET razeni = 530, heslo = 'střední eneolit', heslo_en = 'Middle Eneolithic', zkratka = 'en.sd', popis = '' WHERE ident_cely = 'HES-000370';
UPDATE heslar SET razeni = 531, heslo = 'badenská kultura', heslo_en = 'Baden Culture', zkratka = 'en.bad', popis = '' WHERE ident_cely = 'HES-000317';
UPDATE heslar SET razeni = 532, heslo = 'chamská kultura', heslo_en = 'Cham Culture', zkratka = 'en.cha', popis = '' WHERE ident_cely = 'HES-000371';
UPDATE heslar SET razeni = 533, heslo = 'řivnáčská kultura', heslo_en = 'Řivnáč Culture', zkratka = 'en.riv', popis = '' WHERE ident_cely = 'HES-000372';
UPDATE heslar SET razeni = 534, heslo = 'kultura kulovitých amfor', heslo_en = 'Globular Amphora Culture', zkratka = 'en.kul', popis = '' WHERE ident_cely = 'HES-000279';
UPDATE heslar SET razeni = 54, heslo = 'Etiopie', heslo_en = 'Ethiopia', zkratka = 'ET', popis = '' WHERE ident_cely = 'HES-001335';
UPDATE heslar SET razeni = 54, heslo = 'uhlí dřevěné', heslo_en = 'charcoal', popis = '' WHERE ident_cely = 'HES-001018';
UPDATE heslar SET razeni = 540, heslo = 'mladší eneolit', heslo_en = 'Late Eneolithic', zkratka = 'en.ml', popis = '' WHERE ident_cely = 'HES-000280';
UPDATE heslar SET razeni = 541, heslo = 'jevišovická kultura', heslo_en = 'Jevišovice Culture', zkratka = 'en.jev', popis = '' WHERE ident_cely = 'HES-000373';
UPDATE heslar SET razeni = 542, heslo = 'bošácká skupina', heslo_en = 'Bošáca Group', zkratka = 'en.bos', popis = '' WHERE ident_cely = 'HES-000357';
UPDATE heslar SET razeni = 55, heslo = 'Faerské ostrovy', heslo_en = 'Faroe Islands (the)', zkratka = 'FO', popis = '' WHERE ident_cely = 'HES-001336';
UPDATE heslar SET razeni = 55, heslo = 'vápno', heslo_en = 'quicklime', popis = '' WHERE ident_cely = 'HES-001019';
UPDATE heslar SET razeni = 550, heslo = 'mladší/pozdní eneolit', heslo_en = 'Late/Final Eneolithic', zkratka = 'en.mlp', popis = '' WHERE ident_cely = 'HES-000374';
UPDATE heslar SET razeni = 551, heslo = 'kultura se šňůrovou keramikou', heslo_en = 'Corded Ware Culture', zkratka = 'en.snu', popis = '' WHERE ident_cely = 'HES-000375';
UPDATE heslar SET razeni = 552, heslo = 'kultura Kosihy-Čaka', heslo_en = 'Kosihy-Čaka Culture', zkratka = 'en.kča', popis = '' WHERE ident_cely = 'HES-000351';
UPDATE heslar SET razeni = 553, heslo = 'kultura zvoncovitých pohárů', heslo_en = 'Bell Beaker Culture', zkratka = 'en.zvo', popis = '' WHERE ident_cely = 'HES-000318';
UPDATE heslar SET razeni = 554, heslo = 'kultura Chlopice-Veselé', heslo_en = 'Chlopice-Veselé Culture', zkratka = 'en.chl', popis = '' WHERE ident_cely = 'HES-000352';
UPDATE heslar SET razeni = 56, heslo = 'Falklandy (Malvíny)', heslo_en = 'Falkland Islands (the) (Malvinas)', zkratka = 'FK', popis = '' WHERE ident_cely = 'HES-001227';
UPDATE heslar SET razeni = 56, heslo = 'vejce', heslo_en = 'egg', popis = '' WHERE ident_cely = 'HES-001020';
UPDATE heslar SET razeni = 57, heslo = 'Fidži', heslo_en = 'Fiji', zkratka = 'FJ', popis = '' WHERE ident_cely = 'HES-001337';
UPDATE heslar SET razeni = 57, heslo = 'vosk', heslo_en = 'wax', popis = '' WHERE ident_cely = 'HES-001021';
UPDATE heslar SET razeni = 58, heslo = 'Filipíny', heslo_en = 'Philippines (the)', zkratka = 'PH', popis = '' WHERE ident_cely = 'HES-001261';
UPDATE heslar SET razeni = 58, heslo = 'zlato', heslo_en = 'gold', popis = '' WHERE ident_cely = 'HES-001022';
UPDATE heslar SET razeni = 59, heslo = 'Finsko', heslo_en = 'Finland', zkratka = 'FI', popis = '' WHERE ident_cely = 'HES-001262';
UPDATE heslar SET razeni = 59, heslo = 'zub', heslo_en = 'tooth', popis = '' WHERE ident_cely = 'HES-001023';
UPDATE heslar SET razeni = 6, heslo = '40–50 km', heslo_en = '40–50 km', popis = '' WHERE ident_cely = 'HES-000104';
UPDATE heslar SET razeni = 6, heslo = 'A4 (21 x 30 cm)', heslo_en = 'A4 (21 x 30 cm)', popis = '' WHERE ident_cely = 'HES-000146';
UPDATE heslar SET razeni = 6, heslo = 'Americká Samoa', heslo_en = 'American Samoa', zkratka = 'AS', popis = '' WHERE ident_cely = 'HES-001183';
UPDATE heslar SET razeni = 6, heslo = 'antrakologie/xylotomie', heslo_en = 'anthracology/xylotomy', popis = 'Analýza zuhelnatělých (antrakologie) a nezuhelnatělých (xylotomie) pozůstatků dřev v archeologických kontextech.' WHERE ident_cely = 'HES-000604';
UPDATE heslar SET razeni = 6, heslo = 'Czestochowa-Rudniky', heslo_en = 'Czestochowa-Rudniky', popis = '' WHERE ident_cely = 'HES-000186';
UPDATE heslar SET razeni = 6, heslo = 'diapozitiv černobílý (sklo)', heslo_en = 'black-and-white photoslide (glass)', zkratka = 'dia-čb-sklo', popis = '' WHERE ident_cely = 'HES-000222';
UPDATE heslar SET razeni = 6, heslo = 'fotografie letecké (digitální)', heslo_en = 'aerial photographs (digital)', zkratka = 'DL', popis = '' WHERE ident_cely = 'HES-000872';
UPDATE heslar SET razeni = 6, heslo = 'geologický vrt', heslo_en = 'geological core sample', popis = '' WHERE ident_cely = 'HES-001144';
UPDATE heslar SET razeni = 6, heslo = 'grafit', heslo_en = 'graphite', popis = '' WHERE ident_cely = 'HES-000970';
UPDATE heslar SET razeni = 6, heslo = 'hlášení', heslo_en = 'brief report', popis = '' WHERE ident_cely = 'HES-001080';
UPDATE heslar SET razeni = 6, heslo = 'jiný podnět', heslo_en = 'other motivation', popis = '' WHERE ident_cely = 'HES-000599';
UPDATE heslar SET razeni = 6, heslo = 'komunikace', heslo_en = 'transportation activity', zkratka = 'kom', popis = '' WHERE ident_cely = 'HES-000006';
UPDATE heslar SET razeni = 6, heslo = 'kulturní vrstva/objekt', heslo_en = 'cultural layer/feature', popis = '' WHERE ident_cely = 'HES-000247';
UPDATE heslar SET razeni = 6, heslo = 'latina', heslo_en = 'Latin', zkratka = 'LA', popis = '' WHERE ident_cely = 'HES-000172';
UPDATE heslar SET razeni = 6, heslo = 'linie ohrazující', heslo_en = 'delimiting line', popis = '' WHERE ident_cely = 'HES-001033';
UPDATE heslar SET razeni = 6, heslo = 'nízká výpovědní hodnota', heslo_en = 'low relevancy', zkratka = 'N', popis = 'kvalitní, má záznam, neskenován kvůli nízké vypovídací hodnotě' WHERE ident_cely = 'HES-001178';
UPDATE heslar SET razeni = 6, heslo = 'originál ztracen/zničen', heslo_en = 'original lost/destroyed', popis = '' WHERE ident_cely = 'HES-001171';
UPDATE heslar SET razeni = 5, heslo = 'památková rezervace', heslo_en = 'heritage reserve', popis = '' WHERE ident_cely = 'HES-000180';
UPDATE heslar SET razeni = 6, heslo = 'raný středověk', heslo_en = 'Early Medieval', popis = '' WHERE ident_cely = 'HES-001162';
UPDATE heslar SET razeni = 6, heslo = 'slunečno, oblačno', heslo_en = 'sunny, cloudy', popis = '' WHERE ident_cely = 'HES-000591';
UPDATE heslar SET razeni = 6, heslo = 'výzkumná instituce', heslo_en = 'research organisation', popis = '' WHERE ident_cely = 'HES-001131';
UPDATE heslar SET razeni = 60, heslo = 'areál nezemědělské výroby', heslo_en = 'production site', popis = '' WHERE ident_cely = 'HES-000088';
UPDATE heslar SET razeni = 60, heslo = 'areál nezemědělské výroby', heslo_en = 'production site', popis = 'samostatný areál nezemědělské výroby' WHERE ident_cely = 'HES-000078';
UPDATE heslar SET razeni = 60, heslo = 'Francie', heslo_en = 'France', zkratka = 'FR', popis = '' WHERE ident_cely = 'HES-001349';
UPDATE heslar SET razeni = 60, heslo = 'jiná evidence', heslo_en = 'other evidence', popis = '' WHERE ident_cely = 'HES-001061';
UPDATE heslar SET razeni = 60, heslo = 'jiná evidence', heslo_en = 'other evidence', popis = '' WHERE ident_cely = 'HES-001068';
UPDATE heslar SET razeni = 60, heslo = 'zub lidský', heslo_en = 'human tooth', popis = '' WHERE ident_cely = 'HES-001024';
UPDATE heslar SET razeni = 600, heslo = 'komunikace', heslo_en = 'transportation structure', popis = '' WHERE ident_cely = 'HES-000576';
UPDATE heslar SET razeni = 600, heslo = 'militaria', heslo_en = 'weapons and armour', popis = '' WHERE ident_cely = 'HES-000784';
UPDATE heslar SET razeni = 600, heslo = 'militaria', heslo_en = 'weapons and armour', popis = '' WHERE ident_cely = 'HES-000847';
UPDATE heslar SET razeni = 600, heslo = 'neolit–eneolit', heslo_en = 'Neolithic–Eneolithic', popis = '' WHERE ident_cely = 'HES-000400';
UPDATE heslar SET razeni = 600, heslo = 'neolit–eneolit', heslo_en = 'Neolithic–Eneolithic', zkratka = 'ne-en', popis = '' WHERE ident_cely = 'HES-000387';
UPDATE heslar SET razeni = 600, heslo = 'součást komunikace', heslo_en = 'transportation structure', popis = '' WHERE ident_cely = 'HES-000519';
UPDATE heslar SET razeni = 601, heslo = 'bulava', heslo_en = 'club', popis = '' WHERE ident_cely = 'HES-000785';
UPDATE heslar SET razeni = 601, heslo = 'cesta', heslo_en = 'path/road', popis = '' WHERE ident_cely = 'HES-000520';
UPDATE heslar SET razeni = 602, heslo = 'dýka', heslo_en = 'dagger', popis = '' WHERE ident_cely = 'HES-000820';
UPDATE heslar SET razeni = 602, heslo = 'hať', heslo_en = 'corduroy road', popis = '' WHERE ident_cely = 'HES-000521';
UPDATE heslar SET razeni = 603, heslo = 'kopí/hrot kopí', heslo_en = 'spear/spearhead', popis = '' WHERE ident_cely = 'HES-000821';
UPDATE heslar SET razeni = 603, heslo = 'mezník/patník', heslo_en = 'milestone/boundary stone', popis = '' WHERE ident_cely = 'HES-000522';
UPDATE heslar SET razeni = 604, heslo = 'kuše', heslo_en = 'crossbow', popis = '' WHERE ident_cely = 'HES-000822';
UPDATE heslar SET razeni = 604, heslo = 'most', heslo_en = 'bridge', popis = '' WHERE ident_cely = 'HES-000523';
UPDATE heslar SET razeni = 605, heslo = 'luk', heslo_en = 'bow', popis = '' WHERE ident_cely = 'HES-000823';
UPDATE heslar SET razeni = 605, heslo = 'úvoz', heslo_en = 'hollow way', popis = '' WHERE ident_cely = 'HES-000524';
UPDATE heslar SET razeni = 606, heslo = 'meč', heslo_en = 'sword', popis = '' WHERE ident_cely = 'HES-000786';
UPDATE heslar SET razeni = 607, heslo = 'ostruha', heslo_en = 'spur', popis = '' WHERE ident_cely = 'HES-000787';
UPDATE heslar SET razeni = 608, heslo = 'oštěp/hrot oštěpu', heslo_en = 'javelin/javelin head', popis = '' WHERE ident_cely = 'HES-000788';
UPDATE heslar SET razeni = 609, heslo = 'projektil/kule/munice', heslo_en = 'projectile/bullet/ammunition', popis = '' WHERE ident_cely = 'HES-000755';
UPDATE heslar SET razeni = 61, heslo = 'Francouzská Guyana', heslo_en = 'French Guiana', zkratka = 'GF', popis = '' WHERE ident_cely = 'HES-001404';
UPDATE heslar SET razeni = 61, heslo = 'mlýn', heslo_en = 'mill', popis = '' WHERE ident_cely = 'HES-000028';
UPDATE heslar SET razeni = 61, heslo = 'zub zvířecí', heslo_en = 'animal tooth', popis = '' WHERE ident_cely = 'HES-001025';
UPDATE heslar SET razeni = 610, heslo = 'sekeromlat/mlat', heslo_en = 'hammer axe', popis = '' WHERE ident_cely = 'HES-000789';
UPDATE heslar SET razeni = 611, heslo = 'součást štítu', heslo_en = 'shield part', popis = '' WHERE ident_cely = 'HES-000790';
UPDATE heslar SET razeni = 612, heslo = 'součást zbroje', heslo_en = 'armor component', popis = '' WHERE ident_cely = 'HES-000648';
UPDATE heslar SET razeni = 613, heslo = 'šavle', heslo_en = 'sabre', popis = '' WHERE ident_cely = 'HES-000791';
UPDATE heslar SET razeni = 614, heslo = 'šíp/šipka/hrot šípu/šipky', heslo_en = 'arrow/arrowhead', popis = '' WHERE ident_cely = 'HES-000792';
UPDATE heslar SET razeni = 615, heslo = 'tesák', heslo_en = 'dussack', popis = '' WHERE ident_cely = 'HES-000793';
UPDATE heslar SET razeni = 616, heslo = 'zbraň chladná', heslo_en = 'cold weapon', popis = '' WHERE ident_cely = 'HES-000713';
UPDATE heslar SET razeni = 617, heslo = 'zbraň palná', heslo_en = 'firearm', popis = '' WHERE ident_cely = 'HES-000649';
UPDATE heslar SET razeni = 62, heslo = 'dehtárna', heslo_en = 'tar kiln', popis = '' WHERE ident_cely = 'HES-000079';
UPDATE heslar SET razeni = 62, heslo = 'Francouzská jižní a antarktická území', heslo_en = 'French Southern Territories (the)', zkratka = 'TF', popis = '' WHERE ident_cely = 'HES-001228';
UPDATE heslar SET razeni = 62, heslo = 'železo', heslo_en = 'iron', popis = '' WHERE ident_cely = 'HES-001026';
UPDATE heslar SET razeni = 63, heslo = 'Francouzská Polynésie', heslo_en = 'French Polynesia', zkratka = 'PF', popis = '' WHERE ident_cely = 'HES-001399';
UPDATE heslar SET razeni = 63, heslo = 'jiný materiál', heslo_en = 'other material', popis = '' WHERE ident_cely = 'HES-001027';
UPDATE heslar SET razeni = 63, heslo = 'milířiště', heslo_en = 'charcoal kiln', popis = '' WHERE ident_cely = 'HES-000029';
UPDATE heslar SET razeni = 64, heslo = 'Gabon', heslo_en = 'Gabon', zkratka = 'GA', popis = '' WHERE ident_cely = 'HES-001400';
UPDATE heslar SET razeni = 64, heslo = 'pivovar', heslo_en = 'brewery', popis = '' WHERE ident_cely = 'HES-000080';
UPDATE heslar SET razeni = 65, heslo = 'Gambie', heslo_en = 'Gambia (the)', zkratka = 'GM', popis = '' WHERE ident_cely = 'HES-001256';
UPDATE heslar SET razeni = 65, heslo = 'sklárna', heslo_en = 'glassworks', popis = '' WHERE ident_cely = 'HES-000030';
UPDATE heslar SET razeni = 66, heslo = 'Ghana', heslo_en = 'Ghana', zkratka = 'GH', popis = '' WHERE ident_cely = 'HES-001242';
UPDATE heslar SET razeni = 66, heslo = 'železářský areál', heslo_en = 'iron production site', popis = '' WHERE ident_cely = 'HES-000031';
UPDATE heslar SET razeni = 67, heslo = 'Gibraltar', heslo_en = 'Gibraltar', zkratka = 'GI', popis = '' WHERE ident_cely = 'HES-001264';
UPDATE heslar SET razeni = 68, heslo = 'Grenada', heslo_en = 'Grenada', zkratka = 'GD', popis = '' WHERE ident_cely = 'HES-001265';
UPDATE heslar SET razeni = 69, heslo = 'Grónsko', heslo_en = 'Greenland', zkratka = 'GL', popis = '' WHERE ident_cely = 'HES-001266';
UPDATE heslar SET razeni = 7, heslo = '50–60 km', heslo_en = '50–60 km', popis = '' WHERE ident_cely = 'HES-000105';
UPDATE heslar SET razeni = 7, heslo = 'A3 (30 x 42 cm)', heslo_en = 'A3 (30 x 42 cm)', popis = '' WHERE ident_cely = 'HES-000147';
UPDATE heslar SET razeni = 7, heslo = 'Americké Panenské ostrovy', heslo_en = 'Virgin Islands (U.S.)', zkratka = 'VI', popis = '' WHERE ident_cely = 'HES-001184';
UPDATE heslar SET razeni = 7, heslo = 'archeoentomologie', heslo_en = 'archeoentomology', popis = 'Analýza hmyzu a dalších členovců v archeologických kontextech.' WHERE ident_cely = 'HES-000624';
UPDATE heslar SET razeni = 7, heslo = 'České Budějovice-Hosín', heslo_en = 'České Budějovice-Hosín', popis = '' WHERE ident_cely = 'HES-000187';
UPDATE heslar SET razeni = 7, heslo = 'deponování', heslo_en = 'deposition activity', zkratka = 'dep', popis = '' WHERE ident_cely = 'HES-000007';
UPDATE heslar SET razeni = 7, heslo = 'fotografie barevná', heslo_en = 'colour photograph', zkratka = 'foto-bar', popis = '' WHERE ident_cely = 'HES-000225';
UPDATE heslar SET razeni = 7, heslo = 'fotografie letecké (negativy)', heslo_en = 'aerial photographs (negatives)', zkratka = 'LN', popis = '' WHERE ident_cely = 'HES-000882';
UPDATE heslar SET razeni = 7, heslo = 'geologická sonda', heslo_en = 'geological trench', popis = '' WHERE ident_cely = 'HES-001145';
UPDATE heslar SET razeni = 7, heslo = 'hlína', heslo_en = 'clay', popis = '' WHERE ident_cely = 'HES-000971';
UPDATE heslar SET razeni = 7, heslo = 'jiný text', heslo_en = 'other text', popis = '' WHERE ident_cely = 'HES-001081';
UPDATE heslar SET razeni = 7, heslo = 'lineární systém', heslo_en = 'system of linear features', popis = '' WHERE ident_cely = 'HES-001034';
UPDATE heslar SET razeni = 7, heslo = 'liniová stavba', heslo_en = 'line construction', popis = '' WHERE ident_cely = 'HES-000600';
UPDATE heslar SET razeni = 7, heslo = 'neznámé uložení', heslo_en = 'unknown deposition', popis = '' WHERE ident_cely = 'HES-001172';
UPDATE heslar SET razeni = 7, heslo = 'podorničí/podloží', heslo_en = 'subsoil', popis = '' WHERE ident_cely = 'HES-000248';
UPDATE heslar SET razeni = 7, heslo = 'ruština', heslo_en = 'Russian', zkratka = 'RU', popis = '' WHERE ident_cely = 'HES-000173';
UPDATE heslar SET razeni = 7, heslo = 'slunečno, oblačno, zataženo', heslo_en = 'sunny, cloudy, overcast', popis = '' WHERE ident_cely = 'HES-000592';
UPDATE heslar SET razeni = 7, heslo = 'středověk', heslo_en = 'Medieval', popis = '' WHERE ident_cely = 'HES-001163';
UPDATE heslar SET razeni = 70, heslo = 'areál těžby', heslo_en = 'extracting site', popis = '' WHERE ident_cely = 'HES-000089';
UPDATE heslar SET razeni = 70, heslo = 'areál těžby', heslo_en = 'extracting site', popis = 'areál těžby surovin ' WHERE ident_cely = 'HES-000032';
UPDATE heslar SET razeni = 70, heslo = 'bez okolností', heslo_en = 'unknown context', popis = '' WHERE ident_cely = 'HES-001062';
UPDATE heslar SET razeni = 70, heslo = 'bez okolností', heslo_en = 'unknown context', popis = '' WHERE ident_cely = 'HES-001069';
UPDATE heslar SET razeni = 70, heslo = 'Gruzie', heslo_en = 'Georgia', zkratka = 'GE', popis = '' WHERE ident_cely = 'HES-001391';
UPDATE heslar SET razeni = 700, heslo = 'doba bronzová', heslo_en = 'Bronze Age', popis = '' WHERE ident_cely = 'HES-000401';
UPDATE heslar SET razeni = 700, heslo = 'doba bronzová', heslo_en = 'Bronze Age', zkratka = 'bronz', popis = '' WHERE ident_cely = 'HES-000390';
UPDATE heslar SET razeni = 700, heslo = 'kultovní/sakrální objekt', heslo_en = 'ritual/sacral feature', popis = '' WHERE ident_cely = 'HES-000525';
UPDATE heslar SET razeni = 700, heslo = 'kultovní/sakrální objekt', heslo_en = 'ritual/sacral feature', popis = '' WHERE ident_cely = 'HES-000577';
UPDATE heslar SET razeni = 700, heslo = 'mince', heslo_en = 'coin', popis = '' WHERE ident_cely = 'HES-000794';
UPDATE heslar SET razeni = 700, heslo = 'platidlo', heslo_en = 'currency', popis = '' WHERE ident_cely = 'HES-000848';
UPDATE heslar SET razeni = 701, heslo = 'bankovka', heslo_en = 'paper money', popis = '' WHERE ident_cely = 'HES-000650';
UPDATE heslar SET razeni = 701, heslo = 'kaple', heslo_en = 'chapel', popis = '' WHERE ident_cely = 'HES-000496';
UPDATE heslar SET razeni = 702, heslo = 'kostel', heslo_en = 'church', popis = '' WHERE ident_cely = 'HES-000465';
UPDATE heslar SET razeni = 703, heslo = 'křtitelnice', heslo_en = 'baptismal font', popis = '' WHERE ident_cely = 'HES-000499';
UPDATE heslar SET razeni = 704, heslo = 'malba/freska', heslo_en = 'painting/fresco', popis = '' WHERE ident_cely = 'HES-000540';
UPDATE heslar SET razeni = 705, heslo = 'menhir', heslo_en = 'menhir', popis = '' WHERE ident_cely = 'HES-000500';
UPDATE heslar SET razeni = 706, heslo = 'oltář', heslo_en = 'altar', popis = '' WHERE ident_cely = 'HES-000501';
UPDATE heslar SET razeni = 707, heslo = 'skalní rytina', heslo_en = 'rock carving', popis = '' WHERE ident_cely = 'HES-000541';
UPDATE heslar SET razeni = 708, heslo = 'smírčí kříž', heslo_en = 'wayside cross', popis = '' WHERE ident_cely = 'HES-000502';
UPDATE heslar SET razeni = 71, heslo = 'důl', heslo_en = 'mine', popis = '' WHERE ident_cely = 'HES-000033';
UPDATE heslar SET razeni = 71, heslo = 'Guadeloupe', heslo_en = 'Guadeloupe', zkratka = 'GP', popis = '' WHERE ident_cely = 'HES-001203';
UPDATE heslar SET razeni = 710, heslo = 'starší doba bronzová', heslo_en = 'Early Bronze Age', zkratka = 'br.st', popis = '' WHERE ident_cely = 'HES-000319';
UPDATE heslar SET razeni = 711, heslo = 'protoúnětická kultura', heslo_en = 'Proto-Únětice Culture', zkratka = 'en.pun', popis = '' WHERE ident_cely = 'HES-000391';
UPDATE heslar SET razeni = 712, heslo = 'únětická kultura', heslo_en = 'Únětice Culture', zkratka = 'br.une', popis = '' WHERE ident_cely = 'HES-000358';
UPDATE heslar SET razeni = 713, heslo = 'nitranská kultura', heslo_en = 'Nitra Culture', zkratka = 'br.nit', popis = '' WHERE ident_cely = 'HES-000359';
UPDATE heslar SET razeni = 714, heslo = 'hatvanská kultura', heslo_en = 'Hatvan Culture', zkratka = 'br.hat', popis = '' WHERE ident_cely = 'HES-000320';
UPDATE heslar SET razeni = 715, heslo = 'věteřovská kultura', heslo_en = 'Věteřov Culture', zkratka = 'br.vet', popis = '' WHERE ident_cely = 'HES-000321';
UPDATE heslar SET razeni = 72, heslo = 'Guam', heslo_en = 'Guam', zkratka = 'GU', popis = '' WHERE ident_cely = 'HES-001217';
UPDATE heslar SET razeni = 72, heslo = 'lom', heslo_en = 'quarry', popis = '' WHERE ident_cely = 'HES-000034';
UPDATE heslar SET razeni = 720, heslo = 'střední doba bronzová', heslo_en = 'Middle Bronze Age', zkratka = 'br.sd', popis = '' WHERE ident_cely = 'HES-000322';
UPDATE heslar SET razeni = 721, heslo = 'středodunajská mohylová kultura', heslo_en = 'Middle-Danubian Tumulus Culture', zkratka = 'br.msd', popis = '' WHERE ident_cely = 'HES-000323';
UPDATE heslar SET razeni = 722, heslo = 'českofalcká mohylová kultura', heslo_en = 'Bohemian-Palatinate Tumulus Culture', zkratka = 'br.mcf', popis = '' WHERE ident_cely = 'HES-000324';
UPDATE heslar SET razeni = 73, heslo = 'Guatemala', heslo_en = 'Guatemala', zkratka = 'GT', popis = '' WHERE ident_cely = 'HES-001218';
UPDATE heslar SET razeni = 73, heslo = 'rýžoviště', heslo_en = 'panning site', popis = '' WHERE ident_cely = 'HES-000035';
UPDATE heslar SET razeni = 730, heslo = 'období popelnicových polí', heslo_en = 'Urnfield Period', zkratka = 'ppole', popis = '' WHERE ident_cely = 'HES-000281';
UPDATE heslar SET razeni = 74, heslo = 'Guernsey', heslo_en = 'Guernsey', zkratka = 'GG', popis = '' WHERE ident_cely = 'HES-001301';
UPDATE heslar SET razeni = 740, heslo = 'mladší doba bronzová', heslo_en = 'Late Bronze Age', zkratka = 'br.ml', popis = '' WHERE ident_cely = 'HES-000290';
UPDATE heslar SET razeni = 741, heslo = 'lužická kultura', heslo_en = 'Lusatian Culture', zkratka = 'br.luz', popis = '' WHERE ident_cely = 'HES-000337';
UPDATE heslar SET razeni = 742, heslo = 'velatická kultura', heslo_en = 'Velatice Culture', zkratka = 'br.vel', popis = '' WHERE ident_cely = 'HES-000338';
UPDATE heslar SET razeni = 743, heslo = 'milavečská kultura', heslo_en = 'Milavče Culture', zkratka = 'br.mil', popis = '' WHERE ident_cely = 'HES-000339';
UPDATE heslar SET razeni = 744, heslo = 'knovízská kultura', heslo_en = 'Knovíz Culture', zkratka = 'br.kno', popis = '' WHERE ident_cely = 'HES-000293';
UPDATE heslar SET razeni = 745, heslo = 'chebská kultura', heslo_en = 'Cheb Culture', zkratka = 'br.che', popis = '' WHERE ident_cely = 'HES-000294';
UPDATE heslar SET razeni = 746, heslo = 'saská lužická kultura', heslo_en = 'Saxonian-Lusatian Culture', zkratka = 'br.sas', popis = '' WHERE ident_cely = 'HES-000388';
UPDATE heslar SET razeni = 75, heslo = 'Guinea', heslo_en = 'Guinea', zkratka = 'GN', popis = '' WHERE ident_cely = 'HES-001219';
UPDATE heslar SET razeni = 750, heslo = 'pozdní doba bronzová', heslo_en = 'Final Bronze Age', zkratka = 'br.po', popis = '' WHERE ident_cely = 'HES-000383';
UPDATE heslar SET razeni = 751, heslo = 'slezskoplatěnická kultura', heslo_en = 'Silesian-Platěnice Culture', zkratka = 'pp.slp', popis = '' WHERE ident_cely = 'HES-000295';
UPDATE heslar SET razeni = 752, heslo = 'slezskoplatěnická kultura (HaB)', heslo_en = 'Silesian-Platěnice Culture (HaB)', zkratka = 'br.slp', popis = '' WHERE ident_cely = 'HES-000296';
UPDATE heslar SET razeni = 753, heslo = 'podolská kultura', heslo_en = 'Podolí Culture', zkratka = 'br.pod', popis = '' WHERE ident_cely = 'HES-000353';
UPDATE heslar SET razeni = 754, heslo = 'štítarská kultura', heslo_en = 'Štítary Culture', zkratka = 'br.sti', popis = '' WHERE ident_cely = 'HES-000297';
UPDATE heslar SET razeni = 755, heslo = 'slezská kultura', heslo_en = 'Silesian Culture', zkratka = 'br.sl', popis = '' WHERE ident_cely = 'HES-000298';
UPDATE heslar SET razeni = 756, heslo = 'nynická kultura', heslo_en = 'Nynice Culture', zkratka = 'br.nyn', popis = '' WHERE ident_cely = 'HES-000299';
UPDATE heslar SET razeni = 757, heslo = 'billendorfská kultura', heslo_en = 'Billendorf Culture', zkratka = 'br.bil', popis = '' WHERE ident_cely = 'HES-000330';
UPDATE heslar SET razeni = 76, heslo = 'Guinea-Bissau', heslo_en = 'Guinea-Bissau', zkratka = 'GW', popis = '' WHERE ident_cely = 'HES-001302';
UPDATE heslar SET razeni = 77, heslo = 'Guyana', heslo_en = 'Guyana', zkratka = 'GY', popis = '' WHERE ident_cely = 'HES-001401';
UPDATE heslar SET razeni = 78, heslo = 'Haiti', heslo_en = 'Haiti', zkratka = 'HT', popis = '' WHERE ident_cely = 'HES-001214';
UPDATE heslar SET razeni = 79, heslo = 'Heardův ostrov a MacDonaldovy ostrovy', heslo_en = 'Heard Island and McDonald Islands', zkratka = 'HM', popis = '' WHERE ident_cely = 'HES-001275';
UPDATE heslar SET razeni = 8, heslo = '60–70 km', heslo_en = '60–70 km', popis = '' WHERE ident_cely = 'HES-000106';
UPDATE heslar SET razeni = 8, heslo = 'A2 (42 x 59 cm)', heslo_en = 'A2 (42 x 59 cm)', popis = '' WHERE ident_cely = 'HES-000148';
UPDATE heslar SET razeni = 8, heslo = 'Andorra', heslo_en = 'Andorra', zkratka = 'AD', popis = '' WHERE ident_cely = 'HES-001185';
UPDATE heslar SET razeni = 8, heslo = 'archeogenetika', heslo_en = 'archaeogenetics', popis = 'Výzkum minulosti populací pomocí metod a poznatků moderní genetiky.' WHERE ident_cely = 'HES-000606';
UPDATE heslar SET razeni = 8, heslo = 'boj', heslo_en = 'fighting activity', zkratka = 'boj', popis = '' WHERE ident_cely = 'HES-000008';
UPDATE heslar SET razeni = 8, heslo = 'data analýzy ekofaktů', heslo_en = 'ecofact analysis data', popis = '' WHERE ident_cely = 'HES-001082';
UPDATE heslar SET razeni = 8, heslo = 'fotografie černobílá', heslo_en = 'black-and-white photograph', zkratka = 'foto-čb', popis = '' WHERE ident_cely = 'HES-000223';
UPDATE heslar SET razeni = 8, heslo = 'fotografie předmětů', heslo_en = 'photographs of objects', zkratka = 'FP', popis = '' WHERE ident_cely = 'HES-000878';
UPDATE heslar SET razeni = 8, heslo = 'Choceň', heslo_en = 'Choceň', popis = '' WHERE ident_cely = 'HES-000188';
UPDATE heslar SET razeni = 8, heslo = 'jantar', heslo_en = 'amber', popis = '' WHERE ident_cely = 'HES-000972';
UPDATE heslar SET razeni = 8, heslo = 'nerelevantní', heslo_en = 'irrelevant', zkratka = 'x', popis = '' WHERE ident_cely = 'HES-000174';
UPDATE heslar SET razeni = 8, heslo = 'neznámý', heslo_en = 'unknown', popis = '' WHERE ident_cely = 'HES-000601';
UPDATE heslar SET razeni = 8, heslo = 'novověk', heslo_en = 'Modern', popis = '' WHERE ident_cely = 'HES-001164';
UPDATE heslar SET razeni = 8, heslo = 'ohrazení kruhové malé', heslo_en = 'circular enclosure (small)', popis = '' WHERE ident_cely = 'HES-001035';
UPDATE heslar SET razeni = 8, heslo = 'vodní plocha/tok', heslo_en = 'water body/stream', popis = '' WHERE ident_cely = 'HES-000249';
UPDATE heslar SET razeni = 8, heslo = 'vrt', heslo_en = 'sediment core sample', popis = '' WHERE ident_cely = 'HES-001146';
UPDATE heslar SET razeni = 8, heslo = 'zataženo', heslo_en = 'overcast', popis = '' WHERE ident_cely = 'HES-000593';
UPDATE heslar SET razeni = 80, heslo = 'areál zemědělské výroby', heslo_en = 'agricultural production site', popis = '' WHERE ident_cely = 'HES-000090';
UPDATE heslar SET razeni = 80, heslo = 'areál zemědělské výroby', heslo_en = 'agricultural production site', popis = 'areál pěstování plodin a chovu zvěře' WHERE ident_cely = 'HES-000036';
UPDATE heslar SET razeni = 80, heslo = 'Honduras', heslo_en = 'Honduras', zkratka = 'HN', popis = '' WHERE ident_cely = 'HES-001276';
UPDATE heslar SET razeni = 800, heslo = 'doba halštatská', heslo_en = 'Hallstatt Period', popis = '' WHERE ident_cely = 'HES-000402';
UPDATE heslar SET razeni = 800, heslo = 'doba halštatská', heslo_en = 'Hallstatt Period', zkratka = 'halsta', popis = '' WHERE ident_cely = 'HES-000354';
UPDATE heslar SET razeni = 800, heslo = 'nádoba', heslo_en = 'vessel', popis = '' WHERE ident_cely = 'HES-000714';
UPDATE heslar SET razeni = 800, heslo = 'nádoba', heslo_en = 'vessel', popis = '' WHERE ident_cely = 'HES-000849';
UPDATE heslar SET razeni = 800, heslo = 'objekt/stopa výroby', heslo_en = 'production feature/trace', popis = '' WHERE ident_cely = 'HES-000578';
UPDATE heslar SET razeni = 800, heslo = 'výrobní objekt', heslo_en = 'production feature', popis = '' WHERE ident_cely = 'HES-000542';
UPDATE heslar SET razeni = 801, heslo = 'akvamanile', heslo_en = 'aquamanile', popis = '' WHERE ident_cely = 'HES-000651';
UPDATE heslar SET razeni = 801, heslo = 'místo zpracování', heslo_en = 'processing place', popis = '' WHERE ident_cely = 'HES-000543';
UPDATE heslar SET razeni = 802, heslo = 'amfora', heslo_en = 'amphorae', popis = '' WHERE ident_cely = 'HES-000652';
UPDATE heslar SET razeni = 802, heslo = 'místo výroby', heslo_en = 'production place', popis = '' WHERE ident_cely = 'HES-000544';
UPDATE heslar SET razeni = 803, heslo = 'cedník', heslo_en = 'colander', popis = '' WHERE ident_cely = 'HES-000682';
UPDATE heslar SET razeni = 803, heslo = 'hamr', heslo_en = 'hammer mill', popis = '' WHERE ident_cely = 'HES-000545';
UPDATE heslar SET razeni = 804, heslo = 'dýmka', heslo_en = 'pipe', popis = '' WHERE ident_cely = 'HES-000635';
UPDATE heslar SET razeni = 804, heslo = 'kovárna', heslo_en = 'blacksmith', popis = '' WHERE ident_cely = 'HES-000546';
UPDATE heslar SET razeni = 805, heslo = 'dyzna', heslo_en = 'nozzle', popis = '' WHERE ident_cely = 'HES-000689';
UPDATE heslar SET razeni = 805, heslo = 'vápenická jáma', heslo_en = 'lime pit', popis = '' WHERE ident_cely = 'HES-000547';
UPDATE heslar SET razeni = 806, heslo = 'džbán', heslo_en = 'jug', popis = '' WHERE ident_cely = 'HES-000636';
UPDATE heslar SET razeni = 806, heslo = 'zemědělský objekt', heslo_en = 'agricultural structure', popis = '' WHERE ident_cely = 'HES-000466';
UPDATE heslar SET razeni = 807, heslo = 'hrnec', heslo_en = 'pot', popis = '' WHERE ident_cely = 'HES-000768';
UPDATE heslar SET razeni = 807, heslo = 'mezní pás', heslo_en = 'field boundary', popis = '' WHERE ident_cely = 'HES-000503';
UPDATE heslar SET razeni = 808, heslo = 'koflík', heslo_en = 'cup', popis = '' WHERE ident_cely = 'HES-000769';
UPDATE heslar SET razeni = 808, heslo = 'plužina', heslo_en = 'field system', popis = '' WHERE ident_cely = 'HES-000504';
UPDATE heslar SET razeni = 809, heslo = 'konvice', heslo_en = 'pitcher', popis = '' WHERE ident_cely = 'HES-000690';
UPDATE heslar SET razeni = 809, heslo = 'rybník/nádrž', heslo_en = 'pond/water tank', popis = '' WHERE ident_cely = 'HES-000505';
UPDATE heslar SET razeni = 81, heslo = 'Hongkong', heslo_en = 'Hong Kong', zkratka = 'HK', popis = '' WHERE ident_cely = 'HES-001277';
UPDATE heslar SET razeni = 81, heslo = 'obora', heslo_en = 'game park', popis = '' WHERE ident_cely = 'HES-000037';
UPDATE heslar SET razeni = 810, heslo = 'kotel/kotlík', heslo_en = 'kettle', popis = '' WHERE ident_cely = 'HES-000770';
UPDATE heslar SET razeni = 810, heslo = 'starší doba halštatská (HaC–D1)', heslo_en = 'Early Hallstatt Period (HaC–D1)', zkratka = 'ha.st', popis = '' WHERE ident_cely = 'HES-000376';
UPDATE heslar SET razeni = 810, heslo = 'stopy orby', heslo_en = 'plough marks', popis = '' WHERE ident_cely = 'HES-000467';
UPDATE heslar SET razeni = 811, heslo = 'billendorfská kultura (HaC)', heslo_en = 'Billendorf Culture (HaC)', zkratka = 'ha.bil', popis = '' WHERE ident_cely = 'HES-000377';
UPDATE heslar SET razeni = 811, heslo = 'lahev', heslo_en = 'bottle', popis = '' WHERE ident_cely = 'HES-000691';
UPDATE heslar SET razeni = 811, heslo = 'zahrada', heslo_en = 'garden', popis = '' WHERE ident_cely = 'HES-000526';
UPDATE heslar SET razeni = 812, heslo = 'bylanská kultura', heslo_en = 'Bylany Culture', zkratka = 'ha.byl', popis = '' WHERE ident_cely = 'HES-000331';
UPDATE heslar SET razeni = 812, heslo = 'lampa/kahan', heslo_en = 'lamp/burner', popis = '' WHERE ident_cely = 'HES-000695';
UPDATE heslar SET razeni = 813, heslo = 'halštatská mohylová kultura', heslo_en = 'Hallstatt Tumulus Culture', zkratka = 'ha.moh', popis = '' WHERE ident_cely = 'HES-000332';
UPDATE heslar SET razeni = 813, heslo = 'mísa', heslo_en = 'bowl', popis = '' WHERE ident_cely = 'HES-000719';
UPDATE heslar SET razeni = 814, heslo = 'horákovská kultura', heslo_en = 'Horákov Culture', zkratka = 'ha.hor', popis = '' WHERE ident_cely = 'HES-000307';
UPDATE heslar SET razeni = 814, heslo = 'pánev', heslo_en = 'pan', popis = '' WHERE ident_cely = 'HES-000720';
UPDATE heslar SET razeni = 815, heslo = 'pekáč', heslo_en = 'baking pan', popis = '' WHERE ident_cely = 'HES-000761';
UPDATE heslar SET razeni = 815, heslo = 'platěnická kultura', heslo_en = 'Platěnice Culture', zkratka = 'ha.pl', popis = '' WHERE ident_cely = 'HES-000300';
UPDATE heslar SET razeni = 816, heslo = 'pohár/číše', heslo_en = 'beaker/goblet', popis = '' WHERE ident_cely = 'HES-000722';
UPDATE heslar SET razeni = 816, heslo = 'slezskoplatěnická kultura (HaC–D)', heslo_en = 'Silesian–Platěnice Culture (HaC–D)', zkratka = 'ha.slp', popis = '' WHERE ident_cely = 'HES-000378';
UPDATE heslar SET razeni = 817, heslo = 'poklička', heslo_en = 'lid', popis = '' WHERE ident_cely = 'HES-000724';
UPDATE heslar SET razeni = 817, heslo = 'turnovský typ', heslo_en = 'Turnov type', zkratka = 'pp.tur', popis = '' WHERE ident_cely = 'HES-000308';
UPDATE heslar SET razeni = 818, heslo = 'popelnice', heslo_en = 'urn', popis = '' WHERE ident_cely = 'HES-000726';
UPDATE heslar SET razeni = 819, heslo = 'pražnice', heslo_en = 'frying pan', popis = '' WHERE ident_cely = 'HES-000771';
UPDATE heslar SET razeni = 82, heslo = 'Chile', heslo_en = 'Chile', zkratka = 'CL', popis = '' WHERE ident_cely = 'HES-001338';
UPDATE heslar SET razeni = 82, heslo = 'pastvina/louka', heslo_en = 'pasture/meadow', popis = '' WHERE ident_cely = 'HES-000038';
UPDATE heslar SET razeni = 820, heslo = 'HaD–LtA', heslo_en = 'HaD–LtA', zkratka = 'ha.dla', popis = '' WHERE ident_cely = 'HES-000309';
UPDATE heslar SET razeni = 820, heslo = 'talíř', heslo_en = 'plate', popis = '' WHERE ident_cely = 'HES-000766';
UPDATE heslar SET razeni = 821, heslo = 'tyglík', heslo_en = 'crucible', popis = '' WHERE ident_cely = 'HES-000772';
UPDATE heslar SET razeni = 822, heslo = 'váza', heslo_en = 'vase', popis = '' WHERE ident_cely = 'HES-000841';
UPDATE heslar SET razeni = 823, heslo = 'vědro/situla', heslo_en = 'bucket/situla', popis = '' WHERE ident_cely = 'HES-000819';
UPDATE heslar SET razeni = 824, heslo = 'zásobnice', heslo_en = 'storage vessel', popis = '' WHERE ident_cely = 'HES-000767';
UPDATE heslar SET razeni = 83, heslo = 'Chorvatsko', heslo_en = 'Croatia', zkratka = 'HR', popis = '' WHERE ident_cely = 'HES-001339';
UPDATE heslar SET razeni = 83, heslo = 'pole', heslo_en = 'cropland', popis = '' WHERE ident_cely = 'HES-000039';
UPDATE heslar SET razeni = 830, heslo = 'mladší doba halštatská (HaD2–3)', heslo_en = 'Late Hallstatt Period (HaD2–3)', zkratka = 'ha.ml', popis = '' WHERE ident_cely = 'HES-000310';
UPDATE heslar SET razeni = 84, heslo = 'Indie', heslo_en = 'India', zkratka = 'IN', popis = '' WHERE ident_cely = 'HES-001340';
UPDATE heslar SET razeni = 84, heslo = 'zahrada/sad', heslo_en = 'garden', popis = '' WHERE ident_cely = 'HES-000040';
UPDATE heslar SET razeni = 85, heslo = 'Indonésie', heslo_en = 'Indonesia', zkratka = 'ID', popis = '' WHERE ident_cely = 'HES-001199';
UPDATE heslar SET razeni = 86, heslo = 'Irák', heslo_en = 'Iraq', zkratka = 'IQ', popis = '' WHERE ident_cely = 'HES-001260';
UPDATE heslar SET razeni = 87, heslo = 'Írán', heslo_en = 'Iran (Islamic Republic of)', zkratka = 'IR', popis = '' WHERE ident_cely = 'HES-001324';
UPDATE heslar SET razeni = 88, heslo = 'Irsko', heslo_en = 'Ireland', zkratka = 'IE', popis = '' WHERE ident_cely = 'HES-001344';
UPDATE heslar SET razeni = 89, heslo = 'Island', heslo_en = 'Iceland', zkratka = 'IS', popis = '' WHERE ident_cely = 'HES-001278';
UPDATE heslar SET razeni = 9, heslo = '70–80 km', heslo_en = '70–80 km', popis = '' WHERE ident_cely = 'HES-000107';
UPDATE heslar SET razeni = 9, heslo = 'A1 (59 x 84 cm)', heslo_en = 'A1 (59 x 84 cm)', popis = '' WHERE ident_cely = 'HES-000149';
UPDATE heslar SET razeni = 9, heslo = 'Angola', heslo_en = 'Angola', zkratka = 'AO', popis = '' WHERE ident_cely = 'HES-001186';
UPDATE heslar SET razeni = 9, heslo = 'archeomalakologie', heslo_en = 'archeomalacology', popis = 'Analýza schránek měkkýšů v archeologických kontextech.' WHERE ident_cely = 'HES-000621';
UPDATE heslar SET razeni = 9, heslo = 'budova', heslo_en = 'building', popis = '' WHERE ident_cely = 'HES-000250';
UPDATE heslar SET razeni = 9, heslo = 'data geodetická', heslo_en = 'geodetic data', popis = '' WHERE ident_cely = 'HES-001083';
UPDATE heslar SET razeni = 9, heslo = 'fotografie předmětů (digitální)', heslo_en = 'photographs of objects (digital)', zkratka = 'DP', popis = '' WHERE ident_cely = 'HES-000873';
UPDATE heslar SET razeni = 9, heslo = 'fotoplán', heslo_en = 'photogrammetric plan', popis = '' WHERE ident_cely = 'HES-000224';
UPDATE heslar SET razeni = 9, heslo = 'Chomutov', heslo_en = 'Chomutov', popis = '' WHERE ident_cely = 'HES-000189';
UPDATE heslar SET razeni = 9, heslo = 'industriál', heslo_en = 'Industrial', popis = '' WHERE ident_cely = 'HES-001165';
UPDATE heslar SET razeni = 9, heslo = 'jiná aktivita', heslo_en = 'other activity', zkratka = 'jin', popis = '' WHERE ident_cely = 'HES-000009';
UPDATE heslar SET razeni = 9, heslo = 'kámen', heslo_en = 'stone', popis = '' WHERE ident_cely = 'HES-000973';
UPDATE heslar SET razeni = 9, heslo = 'obdělávání půdy', heslo_en = 'farming', popis = '' WHERE ident_cely = 'HES-000602';
UPDATE heslar SET razeni = 9, heslo = 'ohrazení kruhové střední', heslo_en = 'circular enclosure (medium)', popis = '' WHERE ident_cely = 'HES-001036';
UPDATE heslar SET razeni = 9, heslo = 'skupina vrtů', heslo_en = 'group of sediment core samples', popis = '' WHERE ident_cely = 'HES-001147';
UPDATE heslar SET razeni = 90, heslo = 'areál vojenských aktivit', heslo_en = 'military site', popis = '' WHERE ident_cely = 'HES-000041';
UPDATE heslar SET razeni = 90, heslo = 'areál vojenských aktivit', heslo_en = 'military site', popis = '' WHERE ident_cely = 'HES-000091';
UPDATE heslar SET razeni = 90, heslo = 'Itálie', heslo_en = 'Italy', zkratka = 'IT', popis = '' WHERE ident_cely = 'HES-001319';
UPDATE heslar SET razeni = 900, heslo = 'doba bronzová–halštatská', heslo_en = 'Bronze Age–Hallstatt Period', popis = '' WHERE ident_cely = 'HES-000403';
UPDATE heslar SET razeni = 900, heslo = 'doba bronzová–halštatská', heslo_en = 'Bronze Age–Hallstatt Period', zkratka = 'br-ha', popis = '' WHERE ident_cely = 'HES-000384';
UPDATE heslar SET razeni = 900, heslo = 'nástroj hrubý', heslo_en = 'utensil', popis = '' WHERE ident_cely = 'HES-000653';
UPDATE heslar SET razeni = 900, heslo = 'nástroj hrubý', heslo_en = 'utensil', popis = '' WHERE ident_cely = 'HES-000850';
UPDATE heslar SET razeni = 900, heslo = 'ohrazení/fortifikace', heslo_en = 'enclosure/fortification', popis = '' WHERE ident_cely = 'HES-000527';
UPDATE heslar SET razeni = 900, heslo = 'ohrazení/fortifikace', heslo_en = 'enclosure/fortification', popis = '' WHERE ident_cely = 'HES-000579';
UPDATE heslar SET razeni = 901, heslo = 'bastion/reduta', heslo_en = 'bastion/redoubt', popis = '' WHERE ident_cely = 'HES-000468';
UPDATE heslar SET razeni = 901, heslo = 'drasadlo', heslo_en = 'side scraper', popis = '' WHERE ident_cely = 'HES-000715';
UPDATE heslar SET razeni = 902, heslo = 'bašta', heslo_en = 'wall tower', popis = '' WHERE ident_cely = 'HES-000528';
UPDATE heslar SET razeni = 902, heslo = 'drtidlo/zrnotěrka', heslo_en = 'handstone/saddle quern', popis = '' WHERE ident_cely = 'HES-000795';
UPDATE heslar SET razeni = 903, heslo = 'brána', heslo_en = 'gate', popis = '' WHERE ident_cely = 'HES-000529';
UPDATE heslar SET razeni = 903, heslo = 'kadlub', heslo_en = 'mold', popis = '' WHERE ident_cely = 'HES-000716';
UPDATE heslar SET razeni = 904, heslo = 'hradba', heslo_en = 'defensive wall', popis = '' WHERE ident_cely = 'HES-000530';
UPDATE heslar SET razeni = 904, heslo = 'kladivo/palice', heslo_en = 'hammer/sledgehammer', popis = '' WHERE ident_cely = 'HES-000796';
UPDATE heslar SET razeni = 905, heslo = 'kleště', heslo_en = 'pliers', popis = '' WHERE ident_cely = 'HES-000797';
UPDATE heslar SET razeni = 905, heslo = 'motte', heslo_en = 'motte', popis = '' WHERE ident_cely = 'HES-000531';
UPDATE heslar SET razeni = 906, heslo = 'klín', heslo_en = 'wedge', popis = '' WHERE ident_cely = 'HES-000717';
UPDATE heslar SET razeni = 906, heslo = 'ohradní zeď/plot', heslo_en = 'wall/fence', popis = '' WHERE ident_cely = 'HES-000532';
UPDATE heslar SET razeni = 907, heslo = 'kosa', heslo_en = 'scythe', popis = '' WHERE ident_cely = 'HES-000798';
UPDATE heslar SET razeni = 907, heslo = 'palebné postavení', heslo_en = 'gun emplacement', popis = '' WHERE ident_cely = 'HES-000506';
UPDATE heslar SET razeni = 908, heslo = 'kovadlina', heslo_en = 'anvil', popis = '' WHERE ident_cely = 'HES-000654';
UPDATE heslar SET razeni = 908, heslo = 'palisáda', heslo_en = 'palisade', popis = '' WHERE ident_cely = 'HES-000507';
UPDATE heslar SET razeni = 909, heslo = 'lopata/rýč', heslo_en = 'shovel/spade', popis = '' WHERE ident_cely = 'HES-000655';
UPDATE heslar SET razeni = 909, heslo = 'parkánová hradba', heslo_en = 'zwinger wall', popis = '' WHERE ident_cely = 'HES-000533';
UPDATE heslar SET razeni = 91, heslo = 'bojiště', heslo_en = 'battlefield', popis = '' WHERE ident_cely = 'HES-000042';
UPDATE heslar SET razeni = 91, heslo = 'Izrael', heslo_en = 'Israel', zkratka = 'IL', popis = '' WHERE ident_cely = 'HES-001320';
UPDATE heslar SET razeni = 910, heslo = 'motyka/krumpáč', heslo_en = 'mattock/pickaxe', popis = '' WHERE ident_cely = 'HES-000799';
UPDATE heslar SET razeni = 910, heslo = 'příkop', heslo_en = 'moat', popis = '' WHERE ident_cely = 'HES-000508';
UPDATE heslar SET razeni = 911, heslo = 'otloukač', heslo_en = 'hammerstone', popis = '' WHERE ident_cely = 'HES-000656';
UPDATE heslar SET razeni = 911, heslo = 'val', heslo_en = 'rampart', popis = '' WHERE ident_cely = 'HES-000534';
UPDATE heslar SET razeni = 912, heslo = 'pila', heslo_en = 'saw', popis = '' WHERE ident_cely = 'HES-000657';
UPDATE heslar SET razeni = 912, heslo = 'věž', heslo_en = 'tower', popis = '' WHERE ident_cely = 'HES-000509';
UPDATE heslar SET razeni = 913, heslo = 'pilník', heslo_en = 'file', popis = '' WHERE ident_cely = 'HES-000800';
UPDATE heslar SET razeni = 913, heslo = 'věžice', heslo_en = 'half tower', popis = '' WHERE ident_cely = 'HES-000510';
UPDATE heslar SET razeni = 914, heslo = 'sekáč', heslo_en = 'chopper', popis = '' WHERE ident_cely = 'HES-000801';
UPDATE heslar SET razeni = 914, heslo = 'zákop', heslo_en = 'trench', popis = '' WHERE ident_cely = 'HES-000535';
UPDATE heslar SET razeni = 915, heslo = 'sekera', heslo_en = 'axe', popis = '' WHERE ident_cely = 'HES-000802';
UPDATE heslar SET razeni = 916, heslo = 'součást pluhu', heslo_en = 'plow component', popis = '' WHERE ident_cely = 'HES-000658';
UPDATE heslar SET razeni = 917, heslo = 'srp', heslo_en = 'sickle', popis = '' WHERE ident_cely = 'HES-000659';
UPDATE heslar SET razeni = 918, heslo = 'škrabadlo', heslo_en = 'endscraper', popis = '' WHERE ident_cely = 'HES-000660';
UPDATE heslar SET razeni = 919, heslo = 'závaží', heslo_en = 'weight', popis = '' WHERE ident_cely = 'HES-000718';
UPDATE heslar SET razeni = 92, heslo = 'Jamajka', heslo_en = 'Jamaica', zkratka = 'JM', popis = '' WHERE ident_cely = 'HES-001245';
UPDATE heslar SET razeni = 92, heslo = 'pevnost', heslo_en = 'fortress', popis = '' WHERE ident_cely = 'HES-000043';
UPDATE heslar SET razeni = 920, heslo = 'závaží rybářské', heslo_en = 'net weight', popis = '' WHERE ident_cely = 'HES-000721';
UPDATE heslar SET razeni = 921, heslo = 'závaží tkalcovské', heslo_en = 'loom weight', popis = '' WHERE ident_cely = 'HES-000723';
UPDATE heslar SET razeni = 922, heslo = 'žernov/mlýnský kámen', heslo_en = 'quern', popis = '' WHERE ident_cely = 'HES-000725';
UPDATE heslar SET razeni = 93, heslo = 'Japonsko', heslo_en = 'Japan', zkratka = 'JP', popis = '' WHERE ident_cely = 'HES-001353';
UPDATE heslar SET razeni = 93, heslo = 'polní opevnění', heslo_en = 'field fortification', popis = '' WHERE ident_cely = 'HES-000044';
UPDATE heslar SET razeni = 94, heslo = 'Jemen', heslo_en = 'Yemen', zkratka = 'YE', popis = '' WHERE ident_cely = 'HES-001313';
UPDATE heslar SET razeni = 94, heslo = 'strážnice/předsunutá bašta', heslo_en = 'outpost/watchtower', popis = '' WHERE ident_cely = 'HES-000045';
UPDATE heslar SET razeni = 95, heslo = 'Jersey', heslo_en = 'Jersey', zkratka = 'JE', popis = '' WHERE ident_cely = 'HES-001364';
UPDATE heslar SET razeni = 95, heslo = 'vojenský tábor', heslo_en = 'military camp', popis = '' WHERE ident_cely = 'HES-000046';
UPDATE heslar SET razeni = 96, heslo = 'Jižní Afrika', heslo_en = 'South Africa', zkratka = 'ZA', popis = '' WHERE ident_cely = 'HES-001381';
UPDATE heslar SET razeni = 97, heslo = 'Jižní Georgie a Jižní Sandwichovy ostrovy', heslo_en = 'South Georgia and the South Sandwich Islands', zkratka = 'GS', popis = '' WHERE ident_cely = 'HES-001382';
UPDATE heslar SET razeni = 98, heslo = 'Jižní Súdán', heslo_en = 'South Sudan', zkratka = 'SS', popis = '' WHERE ident_cely = 'HES-001318';
UPDATE heslar SET razeni = 99, heslo = 'Jordánsko', heslo_en = 'Jordan', zkratka = 'JO', popis = '' WHERE ident_cely = 'HES-001383';


-- Doplnění kategorií pro období
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1010, 'časná doba laténská (LtA)', 'Early La Tène Period (LtA)', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1020, 'střední doba laténská (LtB–C1)', 'Middle La Tène Period (LtB–C1)', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1025, 'střední/mladší doba laténská (LtC1–2)', 'Middle/Late La Tène Period (LtC1–2)', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1030, 'mladší–pozdní doba laténská (LtC2–D)', 'Late–Final La Tène Period (LtC2–D)', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1040, 'pozdní doba laténská (LtD)', 'Final La Tène Period (LtD)', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (110, 'starší paleolit', 'Lower Palaeolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (120, 'střední paleolit', 'Middle Palaeolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1210, 'starší doba římská', 'Early Roman Period', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1220, 'mladší doba římská', 'Late Roman Period', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (130, 'mladší paleolit', 'Upper Palaeolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (140, 'pozdní paleolit', 'Epipalaeolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1410, 'starší doba stěhování národů', 'Early Migration Period', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1420, 'mladší doba stěhování národů', 'Late Migration Period', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1840, 'raný středověk 3', 'Early Middle Ages 3', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (1850, 'raný středověk 4', 'Early Middle Ages 4', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (410, 'starší neolit', 'Early Neolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (420, 'střední–mladší neolit', 'Middle–Late Neolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (510, 'časný eneolit', 'Proto-Eneolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (520, 'starší eneolit', 'Early Eneolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (530, 'střední eneolit', 'Middle Eneolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (540, 'mladší eneolit', 'Late Eneolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (550, 'mladší–pozdní eneolit', 'Late–Final Eneolithic', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (710, 'starší doba bronzová', 'Early Bronze Age', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (720, 'střední doba bronzová', 'Middle Bronze Age', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (730, 'období popelnicových polí', 'Urnfield Period', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (740, 'mladší doba bronzová', 'Late Bronze Age', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (750, 'pozdní doba bronzová', 'Final Bronze Age', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (810, 'starší doba halštatská (HaC–D1)', 'Early Hallstatt Period (HaC–D1)', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (820, 'HaD–LtA', 'HaD–LtA', 16);
INSERT INTO heslar (razeni, heslo, heslo_en, nazev_heslare) VALUES (830, 'mladší doba halštatská (HaD2–3)', 'Late Hallstatt Period (HaD2–3)', 16);
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 100 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000253');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1000 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000254');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1010 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000329');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1010 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000355');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1020 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000333');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1025 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-001447');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1030 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000255');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1030 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000256');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1030 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000257');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1040 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000258');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1040 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000259');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 110 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000291');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1100 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000334');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 120 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000274');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 120 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000292');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 120 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000312');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 120 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000313');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 120 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000314');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1200 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000335');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1210 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000336');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1210 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000393');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1220 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000341');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 130 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000260');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 130 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000261');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 130 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000262');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 130 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000263');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 130 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000282');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 130 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000283');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 130 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000311');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 130 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000315');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1300 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000288');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 140 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000264');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 140 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000265');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 140 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000266');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1400 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000342');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1410 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000343');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1410 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000344');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1420 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000345');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1500 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000346');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1700 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000289');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1700 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000304');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1800 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000276');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1800 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000301');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1800 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000385');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1800 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000386');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1840 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000277');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1840 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000278');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1840 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000302');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1840 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000379');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1850 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000303');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1850 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000325');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1850 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000326');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1850 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000356');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1900 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000270');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1900 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000271');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1900 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000272');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1900 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000327');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 1900 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000328');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 200 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000275');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2000 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000380');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2100 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000252');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2100 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000381');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2100 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000382');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2300 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000273');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2300 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000392');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2400 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000347');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2400 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000348');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2400 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000349');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2500 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000350');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 2600 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000316');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 300 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000284');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 400 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000267');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 410 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000268');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 410 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000269');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 410 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000305');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 410 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000340');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 410 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000394');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 420 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000306');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 420 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000360');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 420 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000361');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 420 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000362');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 420 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000389');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 500 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000285');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 510 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000286');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 510 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000287');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 510 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000363');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 510 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000364');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 510 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000365');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 520 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000366');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 520 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000367');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 520 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000368');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 520 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000369');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 530 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000279');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 530 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000317');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 530 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000370');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 530 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000371');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 530 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000372');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 540 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000280');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 540 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000357');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 540 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000373');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 550 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000318');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 550 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000351');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 550 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000352');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 550 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000374');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 550 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000375');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 600 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000387');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 700 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000390');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 710 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000319');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 710 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000320');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 710 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000321');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 710 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000358');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 710 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000359');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 710 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000391');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 720 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000322');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 720 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000323');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 720 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000324');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 730 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000281');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 740 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000290');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 740 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000293');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 740 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000294');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 740 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000337');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 740 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000338');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 740 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000339');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 740 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000388');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 750 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000295');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 750 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000296');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 750 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000297');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 750 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000298');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 750 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000299');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 750 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000330');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 750 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000353');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 750 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000383');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 800 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000354');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 810 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000300');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 810 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000307');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 810 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000308');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 810 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000331');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 810 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000332');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 810 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000376');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 810 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000377');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 810 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000378');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 820 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000309');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 830 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000310');
UPDATE heslar_hierarchie SET heslo_nadrazene = (SELECT id FROM heslar WHERE razeni = 900 AND nazev_heslare = 16) WHERE heslo_podrazene = (SELECT id FROM heslar WHERE ident_cely = 'HES-000384');
DELETE FROM heslar WHERE ident_cely = 'HES-000410';
DELETE FROM heslar WHERE ident_cely = 'HES-000419';

-- Odkazy na Getty AAT
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000291, 'http://vocab.getty.edu/aat/300000291', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000067';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000388, 'http://vocab.getty.edu/aat/300000388', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000057';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000388, 'http://vocab.getty.edu/aat/300000388', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000559';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000388, 'http://vocab.getty.edu/aat/300000388', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001436';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000388, 'http://vocab.getty.edu/aat/300000388', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000032';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000388, 'http://vocab.getty.edu/aat/300000388', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000089';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000388, 'http://vocab.getty.edu/aat/300000388', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000558';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000388, 'http://vocab.getty.edu/aat/300000388', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000584';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000389, 'http://vocab.getty.edu/aat/300000389', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000035';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000389, 'http://vocab.getty.edu/aat/300000389', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000512';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000389, 'http://vocab.getty.edu/aat/300000389', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000566';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000390, 'http://vocab.getty.edu/aat/300000390', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000033';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000402, 'http://vocab.getty.edu/aat/300000402', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000034';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000402, 'http://vocab.getty.edu/aat/300000402', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000560';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000476, 'http://vocab.getty.edu/aat/300000476', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000046';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000641, 'http://vocab.getty.edu/aat/300000641', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000073';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000821, 'http://vocab.getty.edu/aat/300000821', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000563';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000821, 'http://vocab.getty.edu/aat/300000821', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000561';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000833, 'http://vocab.getty.edu/aat/300000833', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000134';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000835, 'http://vocab.getty.edu/aat/300000835', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000042';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000874, 'http://vocab.getty.edu/aat/300000874', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000076';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000885, 'http://vocab.getty.edu/aat/300000885', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000491';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000885, 'http://vocab.getty.edu/aat/300000885', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000573';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000885, 'http://vocab.getty.edu/aat/300000885', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000709';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000885, 'http://vocab.getty.edu/aat/300000885', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000843';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000919, 'http://vocab.getty.edu/aat/300000919', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000498';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300000953, 'http://vocab.getty.edu/aat/300000953', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000450';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300001324, 'http://vocab.getty.edu/aat/300001324', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000495';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300001484, 'http://vocab.getty.edu/aat/300001484', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000898';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300001497, 'http://vocab.getty.edu/aat/300001497', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000816';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300001609, 'http://vocab.getty.edu/aat/300001609', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000447';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300001874, 'http://vocab.getty.edu/aat/300001874', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000737';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002060, 'http://vocab.getty.edu/aat/300002060', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000451';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002060, 'http://vocab.getty.edu/aat/300002060', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000459';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002088, 'http://vocab.getty.edu/aat/300002088', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000492';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002485, 'http://vocab.getty.edu/aat/300002485', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000530';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002495, 'http://vocab.getty.edu/aat/300002495', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000528';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002501, 'http://vocab.getty.edu/aat/300002501', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000506';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002505, 'http://vocab.getty.edu/aat/300002505', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000534';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002563, 'http://vocab.getty.edu/aat/300002563', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000533';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002704, 'http://vocab.getty.edu/aat/300002704', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000448';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300002916, 'http://vocab.getty.edu/aat/300002916', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000529';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300003146, 'http://vocab.getty.edu/aat/300003146', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000710';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300003228, 'http://vocab.getty.edu/aat/300003228', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000452';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300003650, 'http://vocab.getty.edu/aat/300003650', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000424';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300003716, 'http://vocab.getty.edu/aat/300003716', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000508';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300003717, 'http://vocab.getty.edu/aat/300003717', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000507';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300003725, 'http://vocab.getty.edu/aat/300003725', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000501';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004182, 'http://vocab.getty.edu/aat/300004182', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000503';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004182, 'http://vocab.getty.edu/aat/300004182', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000570';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004294, 'http://vocab.getty.edu/aat/300004294', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000494';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004498, 'http://vocab.getty.edu/aat/300004498', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000487';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004531, 'http://vocab.getty.edu/aat/300004531', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000543';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004531, 'http://vocab.getty.edu/aat/300004531', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001438';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004531, 'http://vocab.getty.edu/aat/300004531', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000078';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004531, 'http://vocab.getty.edu/aat/300004531', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000088';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004531, 'http://vocab.getty.edu/aat/300004531', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000544';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004590, 'http://vocab.getty.edu/aat/300004590', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000020';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004590, 'http://vocab.getty.edu/aat/300004590', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000496';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004759, 'http://vocab.getty.edu/aat/300004759', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000488';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004792, 'http://vocab.getty.edu/aat/300004792', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000438';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004792, 'http://vocab.getty.edu/aat/300004792', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000571';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004794, 'http://vocab.getty.edu/aat/300004794', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000250';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004848, 'http://vocab.getty.edu/aat/300004848', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000485';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004862, 'http://vocab.getty.edu/aat/300004862', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000509';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004895, 'http://vocab.getty.edu/aat/300004895', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000036';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004895, 'http://vocab.getty.edu/aat/300004895', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000090';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004895, 'http://vocab.getty.edu/aat/300004895', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000466';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004900, 'http://vocab.getty.edu/aat/300004900', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000483';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300004929, 'http://vocab.getty.edu/aat/300004929', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000484';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005015, 'http://vocab.getty.edu/aat/300005015', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000482';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005018, 'http://vocab.getty.edu/aat/300005018', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000444';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005044, 'http://vocab.getty.edu/aat/300005044', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000532';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005579, 'http://vocab.getty.edu/aat/300005579', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000017';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005734, 'http://vocab.getty.edu/aat/300005734', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000016';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005734, 'http://vocab.getty.edu/aat/300005734', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000481';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005768, 'http://vocab.getty.edu/aat/300005768', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000129';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005897, 'http://vocab.getty.edu/aat/300005897', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000432';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005903, 'http://vocab.getty.edu/aat/300005903', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001430';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005903, 'http://vocab.getty.edu/aat/300005903', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000431';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005907, 'http://vocab.getty.edu/aat/300005907', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000026';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005907, 'http://vocab.getty.edu/aat/300005907', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000427';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005923, 'http://vocab.getty.edu/aat/300005923', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000433';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005926, 'http://vocab.getty.edu/aat/300005926', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000430';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005935, 'http://vocab.getty.edu/aat/300005935', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000428';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300005941, 'http://vocab.getty.edu/aat/300005941', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000429';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006073, 'http://vocab.getty.edu/aat/300006073', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000082';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006073, 'http://vocab.getty.edu/aat/300006073', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000094';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006080, 'http://vocab.getty.edu/aat/300006080', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000513';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006084, 'http://vocab.getty.edu/aat/300006084', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000054';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006101, 'http://vocab.getty.edu/aat/300006101', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000052';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006122, 'http://vocab.getty.edu/aat/300006122', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000464';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006178, 'http://vocab.getty.edu/aat/300006178', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000490';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006179, 'http://vocab.getty.edu/aat/300006179', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000479';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006286, 'http://vocab.getty.edu/aat/300006286', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000028';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006341, 'http://vocab.getty.edu/aat/300006341', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000080';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006404, 'http://vocab.getty.edu/aat/300006404', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000556';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006425, 'http://vocab.getty.edu/aat/300006425', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000565';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006425, 'http://vocab.getty.edu/aat/300006425', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000564';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006891, 'http://vocab.getty.edu/aat/300006891', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000015';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006894, 'http://vocab.getty.edu/aat/300006894', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000043';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006911, 'http://vocab.getty.edu/aat/300006911', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000072';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006913, 'http://vocab.getty.edu/aat/300006913', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000468';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006951, 'http://vocab.getty.edu/aat/300006951', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000535';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006951, 'http://vocab.getty.edu/aat/300006951', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000044';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006956, 'http://vocab.getty.edu/aat/300006956', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000128';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006961, 'http://vocab.getty.edu/aat/300006961', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000522';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006969, 'http://vocab.getty.edu/aat/300006969', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000502';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300006985, 'http://vocab.getty.edu/aat/300006985', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000500';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300007023, 'http://vocab.getty.edu/aat/300007023', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000469';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300007023, 'http://vocab.getty.edu/aat/300007023', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000688';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300007031, 'http://vocab.getty.edu/aat/300007031', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001122';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263741, 'http://vocab.getty.edu/aat/300263741', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001433';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300007466, 'http://vocab.getty.edu/aat/300007466', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000021';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300007466, 'http://vocab.getty.edu/aat/300007466', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000465';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300007590, 'http://vocab.getty.edu/aat/300007590', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000024';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300007836, 'http://vocab.getty.edu/aat/300007836', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000523';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008001, 'http://vocab.getty.edu/aat/300008001', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000440';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008017, 'http://vocab.getty.edu/aat/300008017', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000478';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008020, 'http://vocab.getty.edu/aat/300008020', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001140';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008020, 'http://vocab.getty.edu/aat/300008020', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000486';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008020, 'http://vocab.getty.edu/aat/300008020', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000572';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008020, 'http://vocab.getty.edu/aat/300008020', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000902';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008021, 'http://vocab.getty.edu/aat/300008021', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000539';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008021, 'http://vocab.getty.edu/aat/300008021', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000489';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008021, 'http://vocab.getty.edu/aat/300008021', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000537';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008022, 'http://vocab.getty.edu/aat/300008022', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001059';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008022, 'http://vocab.getty.edu/aat/300008022', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001056';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008022, 'http://vocab.getty.edu/aat/300008022', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001057';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008022, 'http://vocab.getty.edu/aat/300008022', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001058';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008022, 'http://vocab.getty.edu/aat/300008022', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001145';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008022, 'http://vocab.getty.edu/aat/300008022', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001148';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008022, 'http://vocab.getty.edu/aat/300008022', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001149';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008022, 'http://vocab.getty.edu/aat/300008022', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001150';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008022, 'http://vocab.getty.edu/aat/300008022', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001151';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008023, 'http://vocab.getty.edu/aat/300008023', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000493';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008024, 'http://vocab.getty.edu/aat/300008024', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000456';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008024, 'http://vocab.getty.edu/aat/300008024', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000457';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008024, 'http://vocab.getty.edu/aat/300008024', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000536';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008027, 'http://vocab.getty.edu/aat/300008027', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000441';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008090, 'http://vocab.getty.edu/aat/300008090', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000040';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008090, 'http://vocab.getty.edu/aat/300008090', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000526';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008217, 'http://vocab.getty.edu/aat/300008217', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000048';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008217, 'http://vocab.getty.edu/aat/300008217', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000520';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008295, 'http://vocab.getty.edu/aat/300008295', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000524';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008347, 'http://vocab.getty.edu/aat/300008347', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000133';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008372, 'http://vocab.getty.edu/aat/300008372', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000068';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008389, 'http://vocab.getty.edu/aat/300008389', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000074';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008400, 'http://vocab.getty.edu/aat/300008400', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000075';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008542, 'http://vocab.getty.edu/aat/300008542', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001435';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008591, 'http://vocab.getty.edu/aat/300008591', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000050';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008626, 'http://vocab.getty.edu/aat/300008626', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000136';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008626, 'http://vocab.getty.edu/aat/300008626', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001124';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008632, 'http://vocab.getty.edu/aat/300008632', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000504';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008635, 'http://vocab.getty.edu/aat/300008635', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000038';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008635, 'http://vocab.getty.edu/aat/300008635', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000244';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008649, 'http://vocab.getty.edu/aat/300008649', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000243';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008649, 'http://vocab.getty.edu/aat/300008649', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000467';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008688, 'http://vocab.getty.edu/aat/300008688', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000055';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008688, 'http://vocab.getty.edu/aat/300008688', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000505';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008697, 'http://vocab.getty.edu/aat/300008697', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000473';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008746, 'http://vocab.getty.edu/aat/300008746', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000472';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008769, 'http://vocab.getty.edu/aat/300008769', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000471';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008863, 'http://vocab.getty.edu/aat/300008863', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000245';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008932, 'http://vocab.getty.edu/aat/300008932', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000117';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300008932, 'http://vocab.getty.edu/aat/300008932', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000248';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010439, 'http://vocab.getty.edu/aat/300010439', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000925';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010439, 'http://vocab.getty.edu/aat/300010439', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000971';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010463, 'http://vocab.getty.edu/aat/300010463', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000813';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010534, 'http://vocab.getty.edu/aat/300010534', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000894';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010662, 'http://vocab.getty.edu/aat/300010662', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000936';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010662, 'http://vocab.getty.edu/aat/300010662', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000982';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010668, 'http://vocab.getty.edu/aat/300010668', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000934';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010668, 'http://vocab.getty.edu/aat/300010668', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000980';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010672, 'http://vocab.getty.edu/aat/300010672', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000935';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010672, 'http://vocab.getty.edu/aat/300010672', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000981';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010699, 'http://vocab.getty.edu/aat/300010699', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000815';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010713, 'http://vocab.getty.edu/aat/300010713', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000773';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010797, 'http://vocab.getty.edu/aat/300010797', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000947';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010797, 'http://vocab.getty.edu/aat/300010797', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001011';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010900, 'http://vocab.getty.edu/aat/300010900', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000907';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010900, 'http://vocab.getty.edu/aat/300010900', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000988';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010946, 'http://vocab.getty.edu/aat/300010946', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000913';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010946, 'http://vocab.getty.edu/aat/300010946', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000995';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010957, 'http://vocab.getty.edu/aat/300010957', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000904';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300010957, 'http://vocab.getty.edu/aat/300010957', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000966';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011002, 'http://vocab.getty.edu/aat/300011002', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000962';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011002, 'http://vocab.getty.edu/aat/300011002', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001026';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011014, 'http://vocab.getty.edu/aat/300011014', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000908';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011014, 'http://vocab.getty.edu/aat/300011014', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000989';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011020, 'http://vocab.getty.edu/aat/300011020', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000912';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011020, 'http://vocab.getty.edu/aat/300011020', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000994';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011021, 'http://vocab.getty.edu/aat/300011021', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000958';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011021, 'http://vocab.getty.edu/aat/300011021', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001022';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011022, 'http://vocab.getty.edu/aat/300011022', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000915';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011022, 'http://vocab.getty.edu/aat/300011022', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000997';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011029, 'http://vocab.getty.edu/aat/300011029', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000950';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011029, 'http://vocab.getty.edu/aat/300011029', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001014';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011063, 'http://vocab.getty.edu/aat/300011063', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000782';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011098, 'http://vocab.getty.edu/aat/300011098', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000924';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011098, 'http://vocab.getty.edu/aat/300011098', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000970';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011172, 'http://vocab.getty.edu/aat/300011172', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000731';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011176, 'http://vocab.getty.edu/aat/300011176', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000928';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011176, 'http://vocab.getty.edu/aat/300011176', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000974';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011176, 'http://vocab.getty.edu/aat/300011176', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000927';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011176, 'http://vocab.getty.edu/aat/300011176', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000973';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011691, 'http://vocab.getty.edu/aat/300011691', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000833';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011700, 'http://vocab.getty.edu/aat/300011700', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000931';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011700, 'http://vocab.getty.edu/aat/300011700', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000977';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011740, 'http://vocab.getty.edu/aat/300011740', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000955';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011740, 'http://vocab.getty.edu/aat/300011740', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001019';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011790, 'http://vocab.getty.edu/aat/300011790', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000645';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011796, 'http://vocab.getty.edu/aat/300011796', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000918';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011796, 'http://vocab.getty.edu/aat/300011796', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001000';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011798, 'http://vocab.getty.edu/aat/300011798', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000906';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011798, 'http://vocab.getty.edu/aat/300011798', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000987';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011798, 'http://vocab.getty.edu/aat/300011798', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000939';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011798, 'http://vocab.getty.edu/aat/300011798', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000985';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011800, 'http://vocab.getty.edu/aat/300011800', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000938';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011800, 'http://vocab.getty.edu/aat/300011800', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000984';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011801, 'http://vocab.getty.edu/aat/300011801', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000956';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011801, 'http://vocab.getty.edu/aat/300011801', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001020';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011826, 'http://vocab.getty.edu/aat/300011826', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000945';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011826, 'http://vocab.getty.edu/aat/300011826', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001008';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011827, 'http://vocab.getty.edu/aat/300011827', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000920';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011827, 'http://vocab.getty.edu/aat/300011827', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001002';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011829, 'http://vocab.getty.edu/aat/300011829', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000946';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011829, 'http://vocab.getty.edu/aat/300011829', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001010';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011845, 'http://vocab.getty.edu/aat/300011845', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000909';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011845, 'http://vocab.getty.edu/aat/300011845', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000991';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011855, 'http://vocab.getty.edu/aat/300011855', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000960';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011855, 'http://vocab.getty.edu/aat/300011855', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000961';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011855, 'http://vocab.getty.edu/aat/300011855', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001024';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011855, 'http://vocab.getty.edu/aat/300011855', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001025';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011855, 'http://vocab.getty.edu/aat/300011855', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000959';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011855, 'http://vocab.getty.edu/aat/300011855', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001023';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011857, 'http://vocab.getty.edu/aat/300011857', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000948';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011857, 'http://vocab.getty.edu/aat/300011857', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001012';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011860, 'http://vocab.getty.edu/aat/300011860', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000940';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011860, 'http://vocab.getty.edu/aat/300011860', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000990';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011868, 'http://vocab.getty.edu/aat/300011868', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000919';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011868, 'http://vocab.getty.edu/aat/300011868', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001001';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011888, 'http://vocab.getty.edu/aat/300011888', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000943';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011888, 'http://vocab.getty.edu/aat/300011888', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001005';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011902, 'http://vocab.getty.edu/aat/300011902', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000914';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011902, 'http://vocab.getty.edu/aat/300011902', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000996';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011914, 'http://vocab.getty.edu/aat/300011914', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000923';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011914, 'http://vocab.getty.edu/aat/300011914', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000969';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300011914, 'http://vocab.getty.edu/aat/300011914', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000897';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012825, 'http://vocab.getty.edu/aat/300012825', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000687';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012862, 'http://vocab.getty.edu/aat/300012862', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000954';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012862, 'http://vocab.getty.edu/aat/300012862', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001018';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012862, 'http://vocab.getty.edu/aat/300012862', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000781';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012882, 'http://vocab.getty.edu/aat/300012882', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000944';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012882, 'http://vocab.getty.edu/aat/300012882', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001006';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012934, 'http://vocab.getty.edu/aat/300012934', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000926';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012934, 'http://vocab.getty.edu/aat/300012934', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000972';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012991, 'http://vocab.getty.edu/aat/300012991', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000922';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300012991, 'http://vocab.getty.edu/aat/300012991', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000968';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300013026, 'http://vocab.getty.edu/aat/300013026', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000903';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300013026, 'http://vocab.getty.edu/aat/300013026', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000965';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014109, 'http://vocab.getty.edu/aat/300014109', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000230';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014109, 'http://vocab.getty.edu/aat/300014109', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000917';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014109, 'http://vocab.getty.edu/aat/300014109', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000999';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014157, 'http://vocab.getty.edu/aat/300014157', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000231';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014159, 'http://vocab.getty.edu/aat/300014159', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000212';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014161, 'http://vocab.getty.edu/aat/300014161', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000216';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014224, 'http://vocab.getty.edu/aat/300014224', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000226';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014570, 'http://vocab.getty.edu/aat/300014570', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000942';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014570, 'http://vocab.getty.edu/aat/300014570', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001004';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014585, 'http://vocab.getty.edu/aat/300014585', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000957';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014585, 'http://vocab.getty.edu/aat/300014585', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001021';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014616, 'http://vocab.getty.edu/aat/300014616', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000712';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014625, 'http://vocab.getty.edu/aat/300014625', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000814';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014669, 'http://vocab.getty.edu/aat/300014669', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000765';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014671, 'http://vocab.getty.edu/aat/300014671', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000680';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014720, 'http://vocab.getty.edu/aat/300014720', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000740';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014741, 'http://vocab.getty.edu/aat/300014741', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000910';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014741, 'http://vocab.getty.edu/aat/300014741', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000992';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014922, 'http://vocab.getty.edu/aat/300014922', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000739';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014922, 'http://vocab.getty.edu/aat/300014922', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000916';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300014922, 'http://vocab.getty.edu/aat/300014922', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000998';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300015132, 'http://vocab.getty.edu/aat/300015132', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000462';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300015149, 'http://vocab.getty.edu/aat/300015149', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000953';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300015149, 'http://vocab.getty.edu/aat/300015149', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001017';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300015334, 'http://vocab.getty.edu/aat/300015334', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000896';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300015351, 'http://vocab.getty.edu/aat/300015351', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000832';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300015637, 'http://vocab.getty.edu/aat/300015637', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001091';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019258, 'http://vocab.getty.edu/aat/300019258', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000253';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019258, 'http://vocab.getty.edu/aat/300019258', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000395';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019260, 'http://vocab.getty.edu/aat/300019260', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000291';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019260, 'http://vocab.getty.edu/aat/300019260', 'skos:exactMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 110;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019261, 'http://vocab.getty.edu/aat/300019261', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000313';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019261, 'http://vocab.getty.edu/aat/300019261', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000314';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019261, 'http://vocab.getty.edu/aat/300019261', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000274';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019261, 'http://vocab.getty.edu/aat/300019261', 'skos:exactMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 120;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019262, 'http://vocab.getty.edu/aat/300019262', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000261';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019262, 'http://vocab.getty.edu/aat/300019262', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000282';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019262, 'http://vocab.getty.edu/aat/300019262', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000315';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019262, 'http://vocab.getty.edu/aat/300019262', 'skos:exactMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 130;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019264, 'http://vocab.getty.edu/aat/300019264', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000275';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019264, 'http://vocab.getty.edu/aat/300019264', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000396';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019267, 'http://vocab.getty.edu/aat/300019267', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000267';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019267, 'http://vocab.getty.edu/aat/300019267', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000398';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019270, 'http://vocab.getty.edu/aat/300019270', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000305';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019270, 'http://vocab.getty.edu/aat/300019270', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000340';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019270, 'http://vocab.getty.edu/aat/300019270', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000268';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019270, 'http://vocab.getty.edu/aat/300019270', 'skos:exactMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 410;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019272, 'http://vocab.getty.edu/aat/300019272', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000362';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019272, 'http://vocab.getty.edu/aat/300019272', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000389';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019272, 'http://vocab.getty.edu/aat/300019272', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000360';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019272, 'http://vocab.getty.edu/aat/300019272', 'skos:relatedMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 420;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019275, 'http://vocab.getty.edu/aat/300019275', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000390';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019275, 'http://vocab.getty.edu/aat/300019275', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000401';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019276, 'http://vocab.getty.edu/aat/300019276', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000320';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019276, 'http://vocab.getty.edu/aat/300019276', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000321';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019276, 'http://vocab.getty.edu/aat/300019276', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000359';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019276, 'http://vocab.getty.edu/aat/300019276', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000319';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019276, 'http://vocab.getty.edu/aat/300019276', 'skos:exactMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 710;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019277, 'http://vocab.getty.edu/aat/300019277', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000322';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019277, 'http://vocab.getty.edu/aat/300019277', 'skos:exactMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 720;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000293';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000294';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000297';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000299';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000330';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000339';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000383';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 750;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000290';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019278, 'http://vocab.getty.edu/aat/300019278', 'skos:exactMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 740;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000288';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000309';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000334';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000346';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000405';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000407';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000409';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 820;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000384';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019279, 'http://vocab.getty.edu/aat/300019279', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000403';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019291, 'http://vocab.getty.edu/aat/300019291', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000312';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019292, 'http://vocab.getty.edu/aat/300019292', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000262';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019297, 'http://vocab.getty.edu/aat/300019297', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000311';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019300, 'http://vocab.getty.edu/aat/300019300', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000263';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019305, 'http://vocab.getty.edu/aat/300019305', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000283';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019305, 'http://vocab.getty.edu/aat/300019305', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000265';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019332, 'http://vocab.getty.edu/aat/300019332', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000387';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019332, 'http://vocab.getty.edu/aat/300019332', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000400';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019337, 'http://vocab.getty.edu/aat/300019337', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000368';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019360, 'http://vocab.getty.edu/aat/300019360', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000323';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019360, 'http://vocab.getty.edu/aat/300019360', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000324';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019361, 'http://vocab.getty.edu/aat/300019361', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000358';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019361, 'http://vocab.getty.edu/aat/300019361', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000391';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019362, 'http://vocab.getty.edu/aat/300019362', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000295';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019362, 'http://vocab.getty.edu/aat/300019362', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000296';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019362, 'http://vocab.getty.edu/aat/300019362', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000298';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019362, 'http://vocab.getty.edu/aat/300019362', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000337';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019362, 'http://vocab.getty.edu/aat/300019362', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000338';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019362, 'http://vocab.getty.edu/aat/300019362', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000353';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019362, 'http://vocab.getty.edu/aat/300019362', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000388';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019362, 'http://vocab.getty.edu/aat/300019362', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000281';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019362, 'http://vocab.getty.edu/aat/300019362', 'skos:exactMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 730;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000300';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000307';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000308';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000310';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000331';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000332';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000376';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000377';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000378';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 810;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 830;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000354';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019368, 'http://vocab.getty.edu/aat/300019368', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000402';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000255';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000256';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000257';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000258';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000259';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000329';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000333';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000355';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1010;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1020;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1025;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1030;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1040;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000254';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019384, 'http://vocab.getty.edu/aat/300019384', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000404';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300019537, 'http://vocab.getty.edu/aat/300019537', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000386';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020533, 'http://vocab.getty.edu/aat/300020533', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000336';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020533, 'http://vocab.getty.edu/aat/300020533', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000341';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020533, 'http://vocab.getty.edu/aat/300020533', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000393';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020533, 'http://vocab.getty.edu/aat/300020533', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1210;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020533, 'http://vocab.getty.edu/aat/300020533', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1220;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020533, 'http://vocab.getty.edu/aat/300020533', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000335';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020533, 'http://vocab.getty.edu/aat/300020533', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000406';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020756, 'http://vocab.getty.edu/aat/300020756', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000380';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020756, 'http://vocab.getty.edu/aat/300020756', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000414';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020756, 'http://vocab.getty.edu/aat/300020756', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000273';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020756, 'http://vocab.getty.edu/aat/300020756', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000392';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020756, 'http://vocab.getty.edu/aat/300020756', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000416';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020760, 'http://vocab.getty.edu/aat/300020760', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000270';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020760, 'http://vocab.getty.edu/aat/300020760', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000276';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020760, 'http://vocab.getty.edu/aat/300020760', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000301';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020760, 'http://vocab.getty.edu/aat/300020760', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000385';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020760, 'http://vocab.getty.edu/aat/300020760', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000412';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020764, 'http://vocab.getty.edu/aat/300020764', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000277';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020764, 'http://vocab.getty.edu/aat/300020764', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000278';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020764, 'http://vocab.getty.edu/aat/300020764', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000302';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020764, 'http://vocab.getty.edu/aat/300020764', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000379';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020764, 'http://vocab.getty.edu/aat/300020764', 'skos:closeMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1840;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020766, 'http://vocab.getty.edu/aat/300020766', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000303';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020766, 'http://vocab.getty.edu/aat/300020766', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000326';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020766, 'http://vocab.getty.edu/aat/300020766', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000356';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020766, 'http://vocab.getty.edu/aat/300020766', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000325';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300020766, 'http://vocab.getty.edu/aat/300020766', 'skos:closeMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1850;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300021033, 'http://vocab.getty.edu/aat/300021033', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000350';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300021033, 'http://vocab.getty.edu/aat/300021033', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000420';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300021033, 'http://vocab.getty.edu/aat/300021033', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000252';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300021033, 'http://vocab.getty.edu/aat/300021033', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000415';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300021140, 'http://vocab.getty.edu/aat/300021140', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000381';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300021141, 'http://vocab.getty.edu/aat/300021141', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000272';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300021147, 'http://vocab.getty.edu/aat/300021147', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000382';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300022483, 'http://vocab.getty.edu/aat/300022483', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000811';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300022718, 'http://vocab.getty.edu/aat/300022718', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000810';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300022798, 'http://vocab.getty.edu/aat/300022798', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000029';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300022798, 'http://vocab.getty.edu/aat/300022798', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000079';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300022798, 'http://vocab.getty.edu/aat/300022798', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000549';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300022798, 'http://vocab.getty.edu/aat/300022798', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000554';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300022798, 'http://vocab.getty.edu/aat/300022798', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000477';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300022798, 'http://vocab.getty.edu/aat/300022798', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000583';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300022989, 'http://vocab.getty.edu/aat/300022989', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000548';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300023119, 'http://vocab.getty.edu/aat/300023119', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000654';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300023137, 'http://vocab.getty.edu/aat/300023137', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000557';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300023299, 'http://vocab.getty.edu/aat/300023299', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000803';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300023459, 'http://vocab.getty.edu/aat/300023459', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000807';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024101, 'http://vocab.getty.edu/aat/300024101', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000717';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024300, 'http://vocab.getty.edu/aat/300024300', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000655';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024371, 'http://vocab.getty.edu/aat/300024371', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000798';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024400, 'http://vocab.getty.edu/aat/300024400', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000746';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024491, 'http://vocab.getty.edu/aat/300024491', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000799';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024507, 'http://vocab.getty.edu/aat/300024507', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-001052';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024663, 'http://vocab.getty.edu/aat/300024663', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000827';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024664, 'http://vocab.getty.edu/aat/300024664', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000802';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024665, 'http://vocab.getty.edu/aat/300024665', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000801';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024665, 'http://vocab.getty.edu/aat/300024665', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000824';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024668, 'http://vocab.getty.edu/aat/300024668', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000806';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024671, 'http://vocab.getty.edu/aat/300024671', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000657';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024744, 'http://vocab.getty.edu/aat/300024744', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000797';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024749, 'http://vocab.getty.edu/aat/300024749', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000808';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024789, 'http://vocab.getty.edu/aat/300024789', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000804';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024809, 'http://vocab.getty.edu/aat/300024809', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000800';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024814, 'http://vocab.getty.edu/aat/300024814', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000716';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024823, 'http://vocab.getty.edu/aat/300024823', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000796';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024836, 'http://vocab.getty.edu/aat/300024836', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000660';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024838, 'http://vocab.getty.edu/aat/300024838', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000727';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024838, 'http://vocab.getty.edu/aat/300024838', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000851';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024854, 'http://vocab.getty.edu/aat/300024854', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000656';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300024917, 'http://vocab.getty.edu/aat/300024917', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000662';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300025313, 'http://vocab.getty.edu/aat/300025313', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000546';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300027249, 'http://vocab.getty.edu/aat/300027249', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000670';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300027257, 'http://vocab.getty.edu/aat/300027257', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001055';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300027267, 'http://vocab.getty.edu/aat/300027267', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001075';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300027267, 'http://vocab.getty.edu/aat/300027267', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001076';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300027267, 'http://vocab.getty.edu/aat/300027267', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001080';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300027267, 'http://vocab.getty.edu/aat/300027267', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000883';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300027268, 'http://vocab.getty.edu/aat/300027268', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001079';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300027323, 'http://vocab.getty.edu/aat/300027323', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001077';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300028048, 'http://vocab.getty.edu/aat/300028048', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000141';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300028051, 'http://vocab.getty.edu/aat/300028051', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000215';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300028051, 'http://vocab.getty.edu/aat/300028051', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000840';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300028094, 'http://vocab.getty.edu/aat/300028094', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001111';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300028459, 'http://vocab.getty.edu/aat/300028459', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000875';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300028484, 'http://vocab.getty.edu/aat/300028484', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000235';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300028484, 'http://vocab.getty.edu/aat/300028484', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000236';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300033407, 'http://vocab.getty.edu/aat/300033407', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000817';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300033565, 'http://vocab.getty.edu/aat/300033565', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000679';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300034121, 'http://vocab.getty.edu/aat/300034121', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001101';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300034122, 'http://vocab.getty.edu/aat/300034122', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001107';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300034122, 'http://vocab.getty.edu/aat/300034122', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001106';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300034395, 'http://vocab.getty.edu/aat/300034395', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001108';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300034395, 'http://vocab.getty.edu/aat/300034395', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001109';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300034789, 'http://vocab.getty.edu/aat/300034789', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001110';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300036427, 'http://vocab.getty.edu/aat/300036427', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000783';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300036869, 'http://vocab.getty.edu/aat/300036869', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000790';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300036923, 'http://vocab.getty.edu/aat/300036923', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000787';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300036928, 'http://vocab.getty.edu/aat/300036928', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000755';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300036976, 'http://vocab.getty.edu/aat/300036976', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000792';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300036999, 'http://vocab.getty.edu/aat/300036999', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000823';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037000, 'http://vocab.getty.edu/aat/300037000', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000822';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037019, 'http://vocab.getty.edu/aat/300037019', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000788';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037038, 'http://vocab.getty.edu/aat/300037038', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000821';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037048, 'http://vocab.getty.edu/aat/300037048', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000786';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037058, 'http://vocab.getty.edu/aat/300037058', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000820';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037086, 'http://vocab.getty.edu/aat/300037086', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000791';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037091, 'http://vocab.getty.edu/aat/300037091', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000793';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037110, 'http://vocab.getty.edu/aat/300037110', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000713';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037148, 'http://vocab.getty.edu/aat/300037148', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000649';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037206, 'http://vocab.getty.edu/aat/300037206', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000785';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037222, 'http://vocab.getty.edu/aat/300037222', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000794';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037334, 'http://vocab.getty.edu/aat/300037334', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000762';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300037592, 'http://vocab.getty.edu/aat/300037592', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000695';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300041273, 'http://vocab.getty.edu/aat/300041273', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000234';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300041273, 'http://vocab.getty.edu/aat/300041273', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000233';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300041620, 'http://vocab.getty.edu/aat/300041620', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000749';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300042983, 'http://vocab.getty.edu/aat/300042983', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000720';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300042991, 'http://vocab.getty.edu/aat/300042991', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000766';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300043149, 'http://vocab.getty.edu/aat/300043149', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000730';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300043198, 'http://vocab.getty.edu/aat/300043198', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000722';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300043202, 'http://vocab.getty.edu/aat/300043202', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000769';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300045627, 'http://vocab.getty.edu/aat/300045627', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000691';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300045651, 'http://vocab.getty.edu/aat/300045651', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000819';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300045667, 'http://vocab.getty.edu/aat/300045667', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000651';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300045685, 'http://vocab.getty.edu/aat/300045685', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000636';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300045697, 'http://vocab.getty.edu/aat/300045697', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000768';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300045712, 'http://vocab.getty.edu/aat/300045712', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000724';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300045990, 'http://vocab.getty.edu/aat/300045990', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000812';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300045991, 'http://vocab.getty.edu/aat/300045991', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000666';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300045998, 'http://vocab.getty.edu/aat/300045998', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000667';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300046001, 'http://vocab.getty.edu/aat/300046001', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000665';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300046001, 'http://vocab.getty.edu/aat/300046001', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000756';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300046001, 'http://vocab.getty.edu/aat/300046001', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000835';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300046002, 'http://vocab.getty.edu/aat/300046002', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000837';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300046004, 'http://vocab.getty.edu/aat/300046004', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000700';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300046012, 'http://vocab.getty.edu/aat/300046012', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000669';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300046300, 'http://vocab.getty.edu/aat/300046300', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000877';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300046300, 'http://vocab.getty.edu/aat/300046300', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000878';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300046300, 'http://vocab.getty.edu/aat/300046300', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000879';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300047090, 'http://vocab.getty.edu/aat/300047090', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000750';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300047455, 'http://vocab.getty.edu/aat/300047455', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000751';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300047455, 'http://vocab.getty.edu/aat/300047455', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000752';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300048715, 'http://vocab.getty.edu/aat/300048715', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001118';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300048715, 'http://vocab.getty.edu/aat/300048715', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001119';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300048715, 'http://vocab.getty.edu/aat/300048715', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001120';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300051531, 'http://vocab.getty.edu/aat/300051531', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000425';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300052201, 'http://vocab.getty.edu/aat/300052201', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000422';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300052267, 'http://vocab.getty.edu/aat/300052267', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000423';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300052556, 'http://vocab.getty.edu/aat/300052556', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000446';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300052558, 'http://vocab.getty.edu/aat/300052558', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000445';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300053087, 'http://vocab.getty.edu/aat/300053087', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000454';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300053580, 'http://vocab.getty.edu/aat/300053580', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000224';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300053688, 'http://vocab.getty.edu/aat/300053688', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000895';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054315, 'http://vocab.getty.edu/aat/300054315', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000605';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054419, 'http://vocab.getty.edu/aat/300054419', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000623';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054464, 'http://vocab.getty.edu/aat/300054464', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001439';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054472, 'http://vocab.getty.edu/aat/300054472', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001440';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054543, 'http://vocab.getty.edu/aat/300054543', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000615';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054544, 'http://vocab.getty.edu/aat/300054544', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-001083';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054546, 'http://vocab.getty.edu/aat/300054546', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000685';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054547, 'http://vocab.getty.edu/aat/300054547', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001443';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054548, 'http://vocab.getty.edu/aat/300054548', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000614';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054548, 'http://vocab.getty.edu/aat/300054548', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-001084';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054557, 'http://vocab.getty.edu/aat/300054557', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000627';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054557, 'http://vocab.getty.edu/aat/300054557', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000697';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054608, 'http://vocab.getty.edu/aat/300054608', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000963';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054691, 'http://vocab.getty.edu/aat/300054691', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000132';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054691, 'http://vocab.getty.edu/aat/300054691', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-001123';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054710, 'http://vocab.getty.edu/aat/300054710', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000004';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054713, 'http://vocab.getty.edu/aat/300054713', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000003';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054715, 'http://vocab.getty.edu/aat/300054715', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000609';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054715, 'http://vocab.getty.edu/aat/300054715', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000758';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054717, 'http://vocab.getty.edu/aat/300054717', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000608';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300054717, 'http://vocab.getty.edu/aat/300054717', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000759';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300055241, 'http://vocab.getty.edu/aat/300055241', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000458';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300055244, 'http://vocab.getty.edu/aat/300055244', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000006';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300055244, 'http://vocab.getty.edu/aat/300055244', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000742';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300055244, 'http://vocab.getty.edu/aat/300055244', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000855';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300056104, 'http://vocab.getty.edu/aat/300056104', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001442';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300056390, 'http://vocab.getty.edu/aat/300056390', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000007';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300060417, 'http://vocab.getty.edu/aat/300060417', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001117';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300065284, 'http://vocab.getty.edu/aat/300065284', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000005';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300068986, 'http://vocab.getty.edu/aat/300068986', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000463';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300071272, 'http://vocab.getty.edu/aat/300071272', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000018';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300076641, 'http://vocab.getty.edu/aat/300076641', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000711';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300077121, 'http://vocab.getty.edu/aat/300077121', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001050';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300077121, 'http://vocab.getty.edu/aat/300077121', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001063';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300077463, 'http://vocab.getty.edu/aat/300077463', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001054';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300077463, 'http://vocab.getty.edu/aat/300077463', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001065';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300077463, 'http://vocab.getty.edu/aat/300077463', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001066';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300077463, 'http://vocab.getty.edu/aat/300077463', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-001086';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300078053, 'http://vocab.getty.edu/aat/300078053', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000757';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300078053, 'http://vocab.getty.edu/aat/300078053', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000858';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300079719, 'http://vocab.getty.edu/aat/300079719', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001044';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300079719, 'http://vocab.getty.edu/aat/300079719', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001141';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300080131, 'http://vocab.getty.edu/aat/300080131', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000541';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300080617, 'http://vocab.getty.edu/aat/300080617', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000499';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300081683, 'http://vocab.getty.edu/aat/300081683', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000619';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300081685, 'http://vocab.getty.edu/aat/300081685', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000617';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300103997, 'http://vocab.getty.edu/aat/300103997', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000553';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106724, 'http://vocab.getty.edu/aat/300106724', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000284';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106724, 'http://vocab.getty.edu/aat/300106724', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000397';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106730, 'http://vocab.getty.edu/aat/300106730', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000266';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106730, 'http://vocab.getty.edu/aat/300106730', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000264';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106730, 'http://vocab.getty.edu/aat/300106730', 'skos:exactMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 140;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106747, 'http://vocab.getty.edu/aat/300106747', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000351';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106747, 'http://vocab.getty.edu/aat/300106747', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000352';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106747, 'http://vocab.getty.edu/aat/300106747', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000374';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106747, 'http://vocab.getty.edu/aat/300106747', 'skos:relatedMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 550;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000287';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000363';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000364';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000365';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000367';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000369';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000286';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000366';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:relatedMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 510;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106751, 'http://vocab.getty.edu/aat/300106751', 'skos:relatedMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 520;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106753, 'http://vocab.getty.edu/aat/300106753', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000279';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106753, 'http://vocab.getty.edu/aat/300106753', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000371';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106753, 'http://vocab.getty.edu/aat/300106753', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000372';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106753, 'http://vocab.getty.edu/aat/300106753', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000370';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106753, 'http://vocab.getty.edu/aat/300106753', 'skos:relatedMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 530;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106755, 'http://vocab.getty.edu/aat/300106755', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000357';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106755, 'http://vocab.getty.edu/aat/300106755', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000373';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106755, 'http://vocab.getty.edu/aat/300106755', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000280';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106755, 'http://vocab.getty.edu/aat/300106755', 'skos:relatedMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 540;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106757, 'http://vocab.getty.edu/aat/300106757', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000285';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106757, 'http://vocab.getty.edu/aat/300106757', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000399';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106810, 'http://vocab.getty.edu/aat/300106810', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000292';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106812, 'http://vocab.getty.edu/aat/300106812', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000260';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106849, 'http://vocab.getty.edu/aat/300106849', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000361';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106852, 'http://vocab.getty.edu/aat/300106852', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000375';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106854, 'http://vocab.getty.edu/aat/300106854', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000318';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106913, 'http://vocab.getty.edu/aat/300106913', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000343';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106913, 'http://vocab.getty.edu/aat/300106913', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000344';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106913, 'http://vocab.getty.edu/aat/300106913', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000345';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106913, 'http://vocab.getty.edu/aat/300106913', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1410;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106913, 'http://vocab.getty.edu/aat/300106913', 'skos:broadMatch' FROM heslar WHERE nazev_heslare = 16 AND razeni = 1420;
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106913, 'http://vocab.getty.edu/aat/300106913', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000342';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300106913, 'http://vocab.getty.edu/aat/300106913', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000408';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300107826, 'http://vocab.getty.edu/aat/300107826', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000269';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300107826, 'http://vocab.getty.edu/aat/300107826', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000394';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300108265, 'http://vocab.getty.edu/aat/300108265', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000443';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300111307, 'http://vocab.getty.edu/aat/300111307', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000328';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300111307, 'http://vocab.getty.edu/aat/300111307', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000271';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300111307, 'http://vocab.getty.edu/aat/300111307', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000327';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300111307, 'http://vocab.getty.edu/aat/300111307', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000413';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300117127, 'http://vocab.getty.edu/aat/300117127', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000842';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300117127, 'http://vocab.getty.edu/aat/300117127', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000846';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300120693, 'http://vocab.getty.edu/aat/300120693', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001429';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300120693, 'http://vocab.getty.edu/aat/300120693', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000047';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300120693, 'http://vocab.getty.edu/aat/300120693', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000092';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300120693, 'http://vocab.getty.edu/aat/300120693', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000519';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300120693, 'http://vocab.getty.edu/aat/300120693', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000576';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300122139, 'http://vocab.getty.edu/aat/300122139', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000031';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300122208, 'http://vocab.getty.edu/aat/300122208', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000673';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300122208, 'http://vocab.getty.edu/aat/300122208', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000856';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300122208, 'http://vocab.getty.edu/aat/300122208', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000426';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300122208, 'http://vocab.getty.edu/aat/300122208', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000581';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300124117, 'http://vocab.getty.edu/aat/300124117', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001009';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300124808, 'http://vocab.getty.edu/aat/300124808', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000726';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300125479, 'http://vocab.getty.edu/aat/300125479', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000900';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300127322, 'http://vocab.getty.edu/aat/300127322', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001096';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300127344, 'http://vocab.getty.edu/aat/300127344', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000228';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000872';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000880';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000882';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001098';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001099';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001100';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001102';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001103';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001104';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001105';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128222, 'http://vocab.getty.edu/aat/300128222', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001116';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128343, 'http://vocab.getty.edu/aat/300128343', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000229';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128347, 'http://vocab.getty.edu/aat/300128347', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000223';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128357, 'http://vocab.getty.edu/aat/300128357', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000227';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128359, 'http://vocab.getty.edu/aat/300128359', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000225';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128366, 'http://vocab.getty.edu/aat/300128366', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000220';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128371, 'http://vocab.getty.edu/aat/300128371', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000876';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128374, 'http://vocab.getty.edu/aat/300128374', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000222';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300128374, 'http://vocab.getty.edu/aat/300128374', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000221';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300132254, 'http://vocab.getty.edu/aat/300132254', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000841';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300132294, 'http://vocab.getty.edu/aat/300132294', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000246';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300132312, 'http://vocab.getty.edu/aat/300132312', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000474';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300132328, 'http://vocab.getty.edu/aat/300132328', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000461';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300132410, 'http://vocab.getty.edu/aat/300132410', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000475';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300132443, 'http://vocab.getty.edu/aat/300132443', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000039';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300133748, 'http://vocab.getty.edu/aat/300133748', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000921';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300133748, 'http://vocab.getty.edu/aat/300133748', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000967';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300133792, 'http://vocab.getty.edu/aat/300133792', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000053';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300133797, 'http://vocab.getty.edu/aat/300133797', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000022';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300134522, 'http://vocab.getty.edu/aat/300134522', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000045';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300134989, 'http://vocab.getty.edu/aat/300134989', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001092';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300135472, 'http://vocab.getty.edu/aat/300135472', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000142';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300135476, 'http://vocab.getty.edu/aat/300135476', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000144';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300135485, 'http://vocab.getty.edu/aat/300135485', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000143';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300137527, 'http://vocab.getty.edu/aat/300137527', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000497';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300137798, 'http://vocab.getty.edu/aat/300137798', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000058';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300137865, 'http://vocab.getty.edu/aat/300137865', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000829';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300138822, 'http://vocab.getty.edu/aat/300138822', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000606';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300148696, 'http://vocab.getty.edu/aat/300148696', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000652';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300151343, 'http://vocab.getty.edu/aat/300151343', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000748';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300151343, 'http://vocab.getty.edu/aat/300151343', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000774';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300152327, 'http://vocab.getty.edu/aat/300152327', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000514';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300152583, 'http://vocab.getty.edu/aat/300152583', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000830';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300152723, 'http://vocab.getty.edu/aat/300152723', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000516';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300152723, 'http://vocab.getty.edu/aat/300152723', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000515';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300152723, 'http://vocab.getty.edu/aat/300152723', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000575';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300163292, 'http://vocab.getty.edu/aat/300163292', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000476';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300163292, 'http://vocab.getty.edu/aat/300163292', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000421';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300163292, 'http://vocab.getty.edu/aat/300163292', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000580';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300163933, 'http://vocab.getty.edu/aat/300163933', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000706';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300163933, 'http://vocab.getty.edu/aat/300163933', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000911';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300163933, 'http://vocab.getty.edu/aat/300163933', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000993';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300164026, 'http://vocab.getty.edu/aat/300164026', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000899';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300164058, 'http://vocab.getty.edu/aat/300164058', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000517';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300164060, 'http://vocab.getty.edu/aat/300164060', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000041';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300164060, 'http://vocab.getty.edu/aat/300164060', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000091';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300164060, 'http://vocab.getty.edu/aat/300164060', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001437';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300164121, 'http://vocab.getty.edu/aat/300164121', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000542';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300164121, 'http://vocab.getty.edu/aat/300164121', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000578';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300167671, 'http://vocab.getty.edu/aat/300167671', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000247';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300171585, 'http://vocab.getty.edu/aat/300171585', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000694';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300175482, 'http://vocab.getty.edu/aat/300175482', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000531';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300177433, 'http://vocab.getty.edu/aat/300177433', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000540';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300178749, 'http://vocab.getty.edu/aat/300178749', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000744';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300178802, 'http://vocab.getty.edu/aat/300178802', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000674';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300178802, 'http://vocab.getty.edu/aat/300178802', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000857';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300181912, 'http://vocab.getty.edu/aat/300181912', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000213';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300185689, 'http://vocab.getty.edu/aat/300185689', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000784';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300185689, 'http://vocab.getty.edu/aat/300185689', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000847';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300189226, 'http://vocab.getty.edu/aat/300189226', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000839';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300189226, 'http://vocab.getty.edu/aat/300189226', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000854';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300191324, 'http://vocab.getty.edu/aat/300191324', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000650';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300191778, 'http://vocab.getty.edu/aat/300191778', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000642';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300191781, 'http://vocab.getty.edu/aat/300191781', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000639';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300191781, 'http://vocab.getty.edu/aat/300191781', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000753';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300191893, 'http://vocab.getty.edu/aat/300191893', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000646';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300192073, 'http://vocab.getty.edu/aat/300192073', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001444';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300193015, 'http://vocab.getty.edu/aat/300193015', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000714';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300193015, 'http://vocab.getty.edu/aat/300193015', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000849';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300194594, 'http://vocab.getty.edu/aat/300194594', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000828';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300194594, 'http://vocab.getty.edu/aat/300194594', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000852';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300194765, 'http://vocab.getty.edu/aat/300194765', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000690';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300195349, 'http://vocab.getty.edu/aat/300195349', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000770';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300195474, 'http://vocab.getty.edu/aat/300195474', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000051';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300195474, 'http://vocab.getty.edu/aat/300195474', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000093';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300195511, 'http://vocab.getty.edu/aat/300195511', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000552';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300196462, 'http://vocab.getty.edu/aat/300196462', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000772';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300197059, 'http://vocab.getty.edu/aat/300197059', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000648';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300197585, 'http://vocab.getty.edu/aat/300197585', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000704';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300198733, 'http://vocab.getty.edu/aat/300198733', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000677';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300198880, 'http://vocab.getty.edu/aat/300198880', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000767';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300200181, 'http://vocab.getty.edu/aat/300200181', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000725';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300200469, 'http://vocab.getty.edu/aat/300200469', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000682';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300201648, 'http://vocab.getty.edu/aat/300201648', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000789';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300201964, 'http://vocab.getty.edu/aat/300201964', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000929';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300201964, 'http://vocab.getty.edu/aat/300201964', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000975';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300203596, 'http://vocab.getty.edu/aat/300203596', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000719';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300209280, 'http://vocab.getty.edu/aat/300209280', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000735';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300209294, 'http://vocab.getty.edu/aat/300209294', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000836';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300209301, 'http://vocab.getty.edu/aat/300209301', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000838';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300209303, 'http://vocab.getty.edu/aat/300209303', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000733';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300209746, 'http://vocab.getty.edu/aat/300209746', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000738';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300210002, 'http://vocab.getty.edu/aat/300210002', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000676';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300211084, 'http://vocab.getty.edu/aat/300211084', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000696';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300211101, 'http://vocab.getty.edu/aat/300211101', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000684';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300212971, 'http://vocab.getty.edu/aat/300212971', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000747';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300213002, 'http://vocab.getty.edu/aat/300213002', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001007';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300215281, 'http://vocab.getty.edu/aat/300215281', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-001087';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300217875, 'http://vocab.getty.edu/aat/300217875', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000760';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300222722, 'http://vocab.getty.edu/aat/300222722', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000009';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300224276, 'http://vocab.getty.edu/aat/300224276', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000634';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300225937, 'http://vocab.getty.edu/aat/300225937', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000638';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300226182, 'http://vocab.getty.edu/aat/300226182', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000630';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300226220, 'http://vocab.getty.edu/aat/300226220', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000111';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300226220, 'http://vocab.getty.edu/aat/300226220', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001045';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300226788, 'http://vocab.getty.edu/aat/300226788', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000453';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300226788, 'http://vocab.getty.edu/aat/300226788', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000574';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300226800, 'http://vocab.getty.edu/aat/300226800', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000242';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300226883, 'http://vocab.getty.edu/aat/300226883', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000761';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300227811, 'http://vocab.getty.edu/aat/300227811', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000703';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300229602, 'http://vocab.getty.edu/aat/300229602', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000743';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300231565, 'http://vocab.getty.edu/aat/300231565', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000952';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300231565, 'http://vocab.getty.edu/aat/300231565', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001016';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300233317, 'http://vocab.getty.edu/aat/300233317', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000658';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300234006, 'http://vocab.getty.edu/aat/300234006', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000663';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300234117, 'http://vocab.getty.edu/aat/300234117', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000844';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300234117, 'http://vocab.getty.edu/aat/300234117', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000641';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300234996, 'http://vocab.getty.edu/aat/300234996', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000771';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300235507, 'http://vocab.getty.edu/aat/300235507', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000933';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300235507, 'http://vocab.getty.edu/aat/300235507', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000979';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300236397, 'http://vocab.getty.edu/aat/300236397', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000826';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300236438, 'http://vocab.getty.edu/aat/300236438', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000661';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300239260, 'http://vocab.getty.edu/aat/300239260', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000732';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300239261, 'http://vocab.getty.edu/aat/300239261', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000693';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300239261, 'http://vocab.getty.edu/aat/300239261', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000675';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300239507, 'http://vocab.getty.edu/aat/300239507', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000637';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300240142, 'http://vocab.getty.edu/aat/300240142', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000219';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300241917, 'http://vocab.getty.edu/aat/300241917', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000653';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300241917, 'http://vocab.getty.edu/aat/300241917', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000850';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300247011, 'http://vocab.getty.edu/aat/300247011', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000618';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300247551, 'http://vocab.getty.edu/aat/300247551', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000805';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300248042, 'http://vocab.getty.edu/aat/300248042', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000723';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300248067, 'http://vocab.getty.edu/aat/300248067', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000635';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300248085, 'http://vocab.getty.edu/aat/300248085', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000672';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300249172, 'http://vocab.getty.edu/aat/300249172', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001114';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300249323, 'http://vocab.getty.edu/aat/300249323', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000705';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300249387, 'http://vocab.getty.edu/aat/300249387', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000306';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300249766, 'http://vocab.getty.edu/aat/300249766', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000689';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300250799, 'http://vocab.getty.edu/aat/300250799', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000678';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251145, 'http://vocab.getty.edu/aat/300251145', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000625';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251145, 'http://vocab.getty.edu/aat/300251145', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000692';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251159, 'http://vocab.getty.edu/aat/300251159', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000728';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251618, 'http://vocab.getty.edu/aat/300251618', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000613';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251771, 'http://vocab.getty.edu/aat/300251771', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000612';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251771, 'http://vocab.getty.edu/aat/300251771', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000620';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251797, 'http://vocab.getty.edu/aat/300251797', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000436';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251856, 'http://vocab.getty.edu/aat/300251856', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000624';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251929, 'http://vocab.getty.edu/aat/300251929', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000621';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251929, 'http://vocab.getty.edu/aat/300251929', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000607';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300251929, 'http://vocab.getty.edu/aat/300251929', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000686';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300252681, 'http://vocab.getty.edu/aat/300252681', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001446';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300253876, 'http://vocab.getty.edu/aat/300253876', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000779';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300253876, 'http://vocab.getty.edu/aat/300253876', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000780';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300253876, 'http://vocab.getty.edu/aat/300253876', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000778';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300255573, 'http://vocab.getty.edu/aat/300255573', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000671';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300255747, 'http://vocab.getty.edu/aat/300255747', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000547';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300256200, 'http://vocab.getty.edu/aat/300256200', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001121';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300257104, 'http://vocab.getty.edu/aat/300257104', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000066';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300257729, 'http://vocab.getty.edu/aat/300257729', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000439';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300258683, 'http://vocab.getty.edu/aat/300258683', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000010';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300258961, 'http://vocab.getty.edu/aat/300258961', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000626';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300261080, 'http://vocab.getty.edu/aat/300261080', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000745';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300262564, 'http://vocab.getty.edu/aat/300262564', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000754';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300262745, 'http://vocab.getty.edu/aat/300262745', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000668';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300262831, 'http://vocab.getty.edu/aat/300262831', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000702';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263485, 'http://vocab.getty.edu/aat/300263485', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000002';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263489, 'http://vocab.getty.edu/aat/300263489', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000525';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263489, 'http://vocab.getty.edu/aat/300263489', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000577';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263678, 'http://vocab.getty.edu/aat/300263678', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000764';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263741, 'http://vocab.getty.edu/aat/300263741', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000019';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263741, 'http://vocab.getty.edu/aat/300263741', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000086';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263751, 'http://vocab.getty.edu/aat/300263751', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001081';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263886, 'http://vocab.getty.edu/aat/300263886', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000881';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263886, 'http://vocab.getty.edu/aat/300263886', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000218';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263888, 'http://vocab.getty.edu/aat/300263888', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-001085';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263933, 'http://vocab.getty.edu/aat/300263933', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000795';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263933, 'http://vocab.getty.edu/aat/300263933', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000930';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300263933, 'http://vocab.getty.edu/aat/300263933', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000976';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264341, 'http://vocab.getty.edu/aat/300264341', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001088';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264341, 'http://vocab.getty.edu/aat/300264341', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001089';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264341, 'http://vocab.getty.edu/aat/300264341', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001090';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264341, 'http://vocab.getty.edu/aat/300264341', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001093';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264341, 'http://vocab.getty.edu/aat/300264341', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001094';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264341, 'http://vocab.getty.edu/aat/300264341', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001095';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264341, 'http://vocab.getty.edu/aat/300264341', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001097';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264605, 'http://vocab.getty.edu/aat/300264605', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000449';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264626, 'http://vocab.getty.edu/aat/300264626', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000480';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264736, 'http://vocab.getty.edu/aat/300264736', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000347';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264736, 'http://vocab.getty.edu/aat/300264736', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000417';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300264860, 'http://vocab.getty.edu/aat/300264860', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000659';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300265134, 'http://vocab.getty.edu/aat/300265134', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000776';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300265420, 'http://vocab.getty.edu/aat/300265420', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000061';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300265420, 'http://vocab.getty.edu/aat/300265420', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000062';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300265451, 'http://vocab.getty.edu/aat/300265451', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000145';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300265451, 'http://vocab.getty.edu/aat/300265451', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000146';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300265451, 'http://vocab.getty.edu/aat/300265451', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000147';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300265455, 'http://vocab.getty.edu/aat/300265455', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000149';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300265461, 'http://vocab.getty.edu/aat/300265461', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000148';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300265738, 'http://vocab.getty.edu/aat/300265738', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000809';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266009, 'http://vocab.getty.edu/aat/300266009', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001078';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000152';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000153';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000154';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000155';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000156';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000157';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000158';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000159';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000160';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000161';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000162';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000163';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000164';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000165';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266011, 'http://vocab.getty.edu/aat/300266011', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000166';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266035, 'http://vocab.getty.edu/aat/300266035', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000151';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266059, 'http://vocab.getty.edu/aat/300266059', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000249';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266060, 'http://vocab.getty.edu/aat/300266060', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000470';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266060, 'http://vocab.getty.edu/aat/300266060', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000582';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266358, 'http://vocab.getty.edu/aat/300266358', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000435';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266510, 'http://vocab.getty.edu/aat/300266510', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000777';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266523, 'http://vocab.getty.edu/aat/300266523', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000729';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266755, 'http://vocab.getty.edu/aat/300266755', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000027';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300266883, 'http://vocab.getty.edu/aat/300266883', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000511';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300310135, 'http://vocab.getty.edu/aat/300310135', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001003';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300310135, 'http://vocab.getty.edu/aat/300310135', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000941';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300311670, 'http://vocab.getty.edu/aat/300311670', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000214';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300311889, 'http://vocab.getty.edu/aat/300311889', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000708';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300311889, 'http://vocab.getty.edu/aat/300311889', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000707';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300311889, 'http://vocab.getty.edu/aat/300311889', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001126';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300312038, 'http://vocab.getty.edu/aat/300312038', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000870';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300312038, 'http://vocab.getty.edu/aat/300312038', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000871';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300343371, 'http://vocab.getty.edu/aat/300343371', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000718';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300375171, 'http://vocab.getty.edu/aat/300375171', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000644';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000060';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000096';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000232';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000251';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000316';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000418';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001062';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001069';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001112';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379012, 'http://vocab.getty.edu/aat/300379012', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000174';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379261, 'http://vocab.getty.edu/aat/300379261', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000701';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379378, 'http://vocab.getty.edu/aat/300379378', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000633';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379383, 'http://vocab.getty.edu/aat/300379383', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000631';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379411, 'http://vocab.getty.edu/aat/300379411', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000610';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379414, 'http://vocab.getty.edu/aat/300379414', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000698';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379416, 'http://vocab.getty.edu/aat/300379416', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000628';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379429, 'http://vocab.getty.edu/aat/300379429', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001047';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379429, 'http://vocab.getty.edu/aat/300379429', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001060';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379429, 'http://vocab.getty.edu/aat/300379429', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001064';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379429, 'http://vocab.getty.edu/aat/300379429', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001067';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379429, 'http://vocab.getty.edu/aat/300379429', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001144';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379429, 'http://vocab.getty.edu/aat/300379429', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001146';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379429, 'http://vocab.getty.edu/aat/300379429', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001147';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379429, 'http://vocab.getty.edu/aat/300379429', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001051';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379447, 'http://vocab.getty.edu/aat/300379447', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001445';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379523, 'http://vocab.getty.edu/aat/300379523', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000629';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379566, 'http://vocab.getty.edu/aat/300379566', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000632';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379566, 'http://vocab.getty.edu/aat/300379566', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001048';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379566, 'http://vocab.getty.edu/aat/300379566', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001143';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379567, 'http://vocab.getty.edu/aat/300379567', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000640';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379567, 'http://vocab.getty.edu/aat/300379567', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000932';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379567, 'http://vocab.getty.edu/aat/300379567', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000978';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379641, 'http://vocab.getty.edu/aat/300379641', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001441';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379769, 'http://vocab.getty.edu/aat/300379769', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000964';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379773, 'http://vocab.getty.edu/aat/300379773', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000070';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379896, 'http://vocab.getty.edu/aat/300379896', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000434';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379907, 'http://vocab.getty.edu/aat/300379907', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001046';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379907, 'http://vocab.getty.edu/aat/300379907', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001142';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300379967, 'http://vocab.getty.edu/aat/300379967', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000008';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300380558, 'http://vocab.getty.edu/aat/300380558', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000951';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300380558, 'http://vocab.getty.edu/aat/300380558', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001015';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300386734, 'http://vocab.getty.edu/aat/300386734', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000834';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300386734, 'http://vocab.getty.edu/aat/300386734', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000853';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387000, 'http://vocab.getty.edu/aat/300387000', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000012';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387000, 'http://vocab.getty.edu/aat/300387000', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000023';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387004, 'http://vocab.getty.edu/aat/300387004', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000077';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387004, 'http://vocab.getty.edu/aat/300387004', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000437';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387004, 'http://vocab.getty.edu/aat/300387004', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000025';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387004, 'http://vocab.getty.edu/aat/300387004', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000087';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387100, 'http://vocab.getty.edu/aat/300387100', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000455';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387105, 'http://vocab.getty.edu/aat/300387105', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001125';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387238, 'http://vocab.getty.edu/aat/300387238', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000071';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387238, 'http://vocab.getty.edu/aat/300387238', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000064';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387238, 'http://vocab.getty.edu/aat/300387238', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001431';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387242, 'http://vocab.getty.edu/aat/300387242', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000460';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387244, 'http://vocab.getty.edu/aat/300387244', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000063';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387269, 'http://vocab.getty.edu/aat/300387269', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000011';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387269, 'http://vocab.getty.edu/aat/300387269', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000084';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387315, 'http://vocab.getty.edu/aat/300387315', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000069';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387350, 'http://vocab.getty.edu/aat/300387350', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000848';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387395, 'http://vocab.getty.edu/aat/300387395', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000937';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387395, 'http://vocab.getty.edu/aat/300387395', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000983';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387502, 'http://vocab.getty.edu/aat/300387502', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000014';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387704, 'http://vocab.getty.edu/aat/300387704', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000568';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387704, 'http://vocab.getty.edu/aat/300387704', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000567';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300387704, 'http://vocab.getty.edu/aat/300387704', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000585';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300388191, 'http://vocab.getty.edu/aat/300388191', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000167';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300388277, 'http://vocab.getty.edu/aat/300388277', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000169';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300388306, 'http://vocab.getty.edu/aat/300388306', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000170';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300388344, 'http://vocab.getty.edu/aat/300388344', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000168';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300388693, 'http://vocab.getty.edu/aat/300388693', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000172';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300389168, 'http://vocab.getty.edu/aat/300389168', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000173';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300389290, 'http://vocab.getty.edu/aat/300389290', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000171';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300389849, 'http://vocab.getty.edu/aat/300389849', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000030';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300389893, 'http://vocab.getty.edu/aat/300389893', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001113';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300390564, 'http://vocab.getty.edu/aat/300390564', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000317';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300391436, 'http://vocab.getty.edu/aat/300391436', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000056';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300391436, 'http://vocab.getty.edu/aat/300391436', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000095';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300393219, 'http://vocab.getty.edu/aat/300393219', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000569';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300400467, 'http://vocab.getty.edu/aat/300400467', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000647';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300400513, 'http://vocab.getty.edu/aat/300400513', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001027';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300400666, 'http://vocab.getty.edu/aat/300400666', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000442';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300400862, 'http://vocab.getty.edu/aat/300400862', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001115';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300403988, 'http://vocab.getty.edu/aat/300403988', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000049';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404125, 'http://vocab.getty.edu/aat/300404125', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000643';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404202, 'http://vocab.getty.edu/aat/300404202', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000217';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404382, 'http://vocab.getty.edu/aat/300404382', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000901';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404383, 'http://vocab.getty.edu/aat/300404383', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000893';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404415, 'http://vocab.getty.edu/aat/300404415', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000150';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404513, 'http://vocab.getty.edu/aat/300404513', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000348';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404514, 'http://vocab.getty.edu/aat/300404514', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000349';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404594, 'http://vocab.getty.edu/aat/300404594', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001061';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404594, 'http://vocab.getty.edu/aat/300404594', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001068';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404837, 'http://vocab.getty.edu/aat/300404837', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000013';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404837, 'http://vocab.getty.edu/aat/300404837', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000085';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300404854, 'http://vocab.getty.edu/aat/300404854', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000521';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300410475, 'http://vocab.getty.edu/aat/300410475', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000001';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300411363, 'http://vocab.getty.edu/aat/300411363', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-001432';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300411504, 'http://vocab.getty.edu/aat/300411504', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000510';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300417277, 'http://vocab.getty.edu/aat/300417277', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000289';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300417277, 'http://vocab.getty.edu/aat/300417277', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000304';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300417277, 'http://vocab.getty.edu/aat/300417277', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000411';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300417379, 'http://vocab.getty.edu/aat/300417379', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000873';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300417379, 'http://vocab.getty.edu/aat/300417379', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-000874';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300417382, 'http://vocab.getty.edu/aat/300417382', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000949';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300417382, 'http://vocab.getty.edu/aat/300417382', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-001013';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300417707, 'http://vocab.getty.edu/aat/300417707', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000059';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300417708, 'http://vocab.getty.edu/aat/300417708', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000037';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300419973, 'http://vocab.getty.edu/aat/300419973', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000681';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300419973, 'http://vocab.getty.edu/aat/300419973', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000859';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300421990, 'http://vocab.getty.edu/aat/300421990', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000831';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300423332, 'http://vocab.getty.edu/aat/300423332', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000683';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300423336, 'http://vocab.getty.edu/aat/300423336', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000699';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300423942, 'http://vocab.getty.edu/aat/300423942', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000775';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300423942, 'http://vocab.getty.edu/aat/300423942', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000845';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300423942, 'http://vocab.getty.edu/aat/300423942', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-001082';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300424383, 'http://vocab.getty.edu/aat/300424383', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000527';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300424383, 'http://vocab.getty.edu/aat/300424383', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000579';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300424940, 'http://vocab.getty.edu/aat/300424940', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000555';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300426925, 'http://vocab.getty.edu/aat/300426925', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000545';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300427128, 'http://vocab.getty.edu/aat/300427128', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000736';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300427425, 'http://vocab.getty.edu/aat/300427425', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000551';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300428241, 'http://vocab.getty.edu/aat/300428241', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000538';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300428645, 'http://vocab.getty.edu/aat/300428645', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000818';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300428645, 'http://vocab.getty.edu/aat/300428645', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000860';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300429537, 'http://vocab.getty.edu/aat/300429537', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000721';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300429888, 'http://vocab.getty.edu/aat/300429888', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000664';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300430511, 'http://vocab.getty.edu/aat/300430511', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000741';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300430673, 'http://vocab.getty.edu/aat/300430673', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000550';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300432482, 'http://vocab.getty.edu/aat/300432482', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000715';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300432673, 'http://vocab.getty.edu/aat/300432673', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000518';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300433081, 'http://vocab.getty.edu/aat/300433081', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000825';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300433337, 'http://vocab.getty.edu/aat/300433337', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000734';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300438514, 'http://vocab.getty.edu/aat/300438514', 'skos:narrowMatch' FROM heslar WHERE ident_cely = 'HES-000604';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300438514, 'http://vocab.getty.edu/aat/300438514', 'skos:relatedMatch' FROM heslar WHERE ident_cely = 'HES-000763';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300438624, 'http://vocab.getty.edu/aat/300438624', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001434';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300443505, 'http://vocab.getty.edu/aat/300443505', 'skos:closeMatch' FROM heslar WHERE ident_cely = 'HES-000562';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300444153, 'http://vocab.getty.edu/aat/300444153', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000081';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300444153, 'http://vocab.getty.edu/aat/300444153', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000083';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300449005, 'http://vocab.getty.edu/aat/300449005', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000065';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300449005, 'http://vocab.getty.edu/aat/300449005', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000112';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300451414, 'http://vocab.getty.edu/aat/300451414', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001049';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300451414, 'http://vocab.getty.edu/aat/300451414', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001053';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300451414, 'http://vocab.getty.edu/aat/300451414', 'skos:broadMatch' FROM heslar WHERE ident_cely = 'HES-001139';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300451454, 'http://vocab.getty.edu/aat/300451454', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000905';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'Getty AAT', 'ID', 300451454, 'http://vocab.getty.edu/aat/300451454', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000986';

-- Datace
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1000, -1000, -751, -751 FROM heslar WHERE ident_cely = 'HES-000383';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1000, -1000, -801, -801 FROM heslar WHERE ident_cely = 'HES-000298';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -10000, -10000, -8001, -8001 FROM heslar WHERE ident_cely = 'HES-000264';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -10000, -10000, -8001, -8001 FROM heslar WHERE ident_cely = 'HES-000265';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -10000, -10000, -8001, -8001 FROM heslar WHERE ident_cely = 'HES-000266';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1000000, -1000000, -300001, -300001 FROM heslar WHERE ident_cely = 'HES-000291';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1000000, -1000000, -5601, -5601 FROM heslar WHERE ident_cely = 'HES-000284';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1000000, -1000000, 580, 580 FROM heslar WHERE ident_cely = 'HES-000289';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1000000, -1000000, -9601, -9601 FROM heslar WHERE ident_cely = 'HES-000253';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1025, -1025, -751, -751 FROM heslar WHERE ident_cely = 'HES-000297';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1025, -1025, -751, -751 FROM heslar WHERE ident_cely = 'HES-000353';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1051, 1051, 1150, 1150 FROM heslar WHERE ident_cely = 'HES-000326';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -110, -110, -91, -91 FROM heslar WHERE ident_cely = 'HES-000259';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1100, -1100, -451, -451 FROM heslar WHERE ident_cely = 'HES-000295';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1100, -1100, -801, -801 FROM heslar WHERE ident_cely = 'HES-000296';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1151, 1151, 1250, 1250 FROM heslar WHERE ident_cely = 'HES-000270';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1200, -1200, -1001, -1001 FROM heslar WHERE ident_cely = 'HES-000294';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1201, 1201, 1300, 1300 FROM heslar WHERE ident_cely = 'HES-000328';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1201, 1201, 1500, 1500 FROM heslar WHERE ident_cely = 'HES-000327';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1201, 1201, 1800, 1800 FROM heslar WHERE ident_cely = 'HES-000273';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1250, -1250, -1001, -1001 FROM heslar WHERE ident_cely = 'HES-000290';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1250, -1250, -951, -951 FROM heslar WHERE ident_cely = 'HES-000293';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1250, -1250, -976, -976 FROM heslar WHERE ident_cely = 'HES-000339';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -130, -130, -31, -31 FROM heslar WHERE ident_cely = 'HES-000258';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1300, -1300, -1001, -1001 FROM heslar WHERE ident_cely = 'HES-000338';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1300, -1300, -1026, -1026 FROM heslar WHERE ident_cely = 'HES-000337';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1300, -1300, -751, -751 FROM heslar WHERE ident_cely = 'HES-000388';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1300, -1300, -801, -801 FROM heslar WHERE ident_cely = 'HES-000281';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -130000, -130000, -38001, -38001 FROM heslar WHERE ident_cely = 'HES-000314';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -130000, -130000, -70001, -70001 FROM heslar WHERE ident_cely = 'HES-000292';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -130000, -130000, -80001, -80001 FROM heslar WHERE ident_cely = 'HES-000313';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1301, 1301, 1500, 1500 FROM heslar WHERE ident_cely = 'HES-000271';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1451, 1451, 1550, 1550 FROM heslar WHERE ident_cely = 'HES-000272';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1501, 1501, 1650, 1650 FROM heslar WHERE ident_cely = 'HES-000381';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1501, 1501, 1800, 1800 FROM heslar WHERE ident_cely = 'HES-000252';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1501, 1501, 2000, 2000 FROM heslar WHERE ident_cely = 'HES-000350';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1650, -1650, -1251, -1251 FROM heslar WHERE ident_cely = 'HES-000323';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1650, -1650, -1251, -1251 FROM heslar WHERE ident_cely = 'HES-000324';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1651, 1651, 1800, 1800 FROM heslar WHERE ident_cely = 'HES-000382';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -170, -170, -31, -31 FROM heslar WHERE ident_cely = 'HES-000255';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1700, -1700, -1251, -1251 FROM heslar WHERE ident_cely = 'HES-000322';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1700, -1700, -1501, -1501 FROM heslar WHERE ident_cely = 'HES-000321';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -1800, -1800, -1601, -1601 FROM heslar WHERE ident_cely = 'HES-000320';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -18000, -18000, -10001, -10001 FROM heslar WHERE ident_cely = 'HES-000263';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1801, 1801, 1900, 1900 FROM heslar WHERE ident_cely = 'HES-000348';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1801, 1801, 2000, 2000 FROM heslar WHERE ident_cely = 'HES-000347';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 181, 181, 400, 400 FROM heslar WHERE ident_cely = 'HES-000341';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 1901, 1901, 2000, 2000 FROM heslar WHERE ident_cely = 'HES-000349';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -200, -200, 400, 400 FROM heslar WHERE ident_cely = 'HES-000257';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -20000, -20000, -10001, -10001 FROM heslar WHERE ident_cely = 'HES-000283';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2100, -2100, -1801, -1801 FROM heslar WHERE ident_cely = 'HES-000359';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -220000, -220000, -40001, -40001 FROM heslar WHERE ident_cely = 'HES-000312';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2300, -2300, -1551, -1551 FROM heslar WHERE ident_cely = 'HES-000319';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2300, -2300, -1651, -1651 FROM heslar WHERE ident_cely = 'HES-000358';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2300, -2300, -2001, -2001 FROM heslar WHERE ident_cely = 'HES-000391';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2300, -2300, -481, -481 FROM heslar WHERE ident_cely = 'HES-000384';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2300, -2300, -751, -751 FROM heslar WHERE ident_cely = 'HES-000390';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2400, -2400, -2101, -2101 FROM heslar WHERE ident_cely = 'HES-000352';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -250, -250, -120, -120 FROM heslar WHERE ident_cely = 'HES-001447';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2500, -2500, -2201, -2201 FROM heslar WHERE ident_cely = 'HES-000318';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2800, -2800, -2301, -2301 FROM heslar WHERE ident_cely = 'HES-000351';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2900, -2900, -2201, -2201 FROM heslar WHERE ident_cely = 'HES-000374';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -2900, -2900, -2501, -2501 FROM heslar WHERE ident_cely = 'HES-000375';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -30, -30, 180, 180 FROM heslar WHERE ident_cely = 'HES-000336';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -30, -30, 400, 400 FROM heslar WHERE ident_cely = 'HES-000335';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -30, -30, 580, 580 FROM heslar WHERE ident_cely = 'HES-000346';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -30, -30, -6, -6 FROM heslar WHERE ident_cely = 'HES-000393';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3000, -3000, -2601, -2601 FROM heslar WHERE ident_cely = 'HES-000357';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -30000, -30000, -18001, -18001 FROM heslar WHERE ident_cely = 'HES-000311';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -300000, -300000, -40001, -40001 FROM heslar WHERE ident_cely = 'HES-000274';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3100, -3100, -2301, -2301 FROM heslar WHERE ident_cely = 'HES-000280';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3100, -3100, -2801, -2801 FROM heslar WHERE ident_cely = 'HES-000279';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3100, -3100, -2801, -2801 FROM heslar WHERE ident_cely = 'HES-000371';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3100, -3100, -2801, -2801 FROM heslar WHERE ident_cely = 'HES-000372';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3100, -3100, -2801, -2801 FROM heslar WHERE ident_cely = 'HES-000373';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3350, -3350, -2801, -2801 FROM heslar WHERE ident_cely = 'HES-000370';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3400, -3400, -2901, -2901 FROM heslar WHERE ident_cely = 'HES-000317';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3500, -3500, -3301, -3301 FROM heslar WHERE ident_cely = 'HES-000369';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -370, -370, -171, -171 FROM heslar WHERE ident_cely = 'HES-000333';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -38000, -38000, -28001, -28001 FROM heslar WHERE ident_cely = 'HES-000262';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -38000, -38000, -28001, -28001 FROM heslar WHERE ident_cely = 'HES-000282';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 381, 381, 480, 480 FROM heslar WHERE ident_cely = 'HES-000343';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 381, 381, 480, 480 FROM heslar WHERE ident_cely = 'HES-000344';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 381, 381, 580, 580 FROM heslar WHERE ident_cely = 'HES-000342';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3900, -3900, -3301, -3301 FROM heslar WHERE ident_cely = 'HES-000368';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -3900, -3900, -3351, -3351 FROM heslar WHERE ident_cely = 'HES-000366';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -400, -400, -131, -131 FROM heslar WHERE ident_cely = 'HES-000329';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4000, -4000, -3501, -3501 FROM heslar WHERE ident_cely = 'HES-000367';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4000, -4000, -3801, -3801 FROM heslar WHERE ident_cely = 'HES-000365';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -40000, -40000, -10001, -10001 FROM heslar WHERE ident_cely = 'HES-000315';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -40000, -40000, -35001, -35001 FROM heslar WHERE ident_cely = 'HES-000261';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -40000, -40000, -38001, -38001 FROM heslar WHERE ident_cely = 'HES-000260';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -410, -410, -321, -321 FROM heslar WHERE ident_cely = 'HES-000308';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4200, -4200, -3801, -3801 FROM heslar WHERE ident_cely = 'HES-000364';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4200, -4200, -4001, -4001 FROM heslar WHERE ident_cely = 'HES-000287';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -450, -450, -31, -31 FROM heslar WHERE ident_cely = 'HES-000254';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -450, -450, 400, 400 FROM heslar WHERE ident_cely = 'HES-000288';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4500, -4500, -2301, -2301 FROM heslar WHERE ident_cely = 'HES-000285';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4500, -4500, -3801, -3801 FROM heslar WHERE ident_cely = 'HES-000286';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4500, -4500, -4101, -4101 FROM heslar WHERE ident_cely = 'HES-000363';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4500, -4500, -4201, -4201 FROM heslar WHERE ident_cely = 'HES-000389';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4600, -4600, -4201, -4201 FROM heslar WHERE ident_cely = 'HES-000306';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4700, -4700, -4201, -4201 FROM heslar WHERE ident_cely = 'HES-000360';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4700, -4700, -4501, -4501 FROM heslar WHERE ident_cely = 'HES-000362';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -480, -480, 180, 180 FROM heslar WHERE ident_cely = 'HES-000256';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -480, -480, -381, -381 FROM heslar WHERE ident_cely = 'HES-000355';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 481, 481, 580, 580 FROM heslar WHERE ident_cely = 'HES-000345';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -4900, -4900, -4401, -4401 FROM heslar WHERE ident_cely = 'HES-000361';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -5000, -5000, -4601, -4601 FROM heslar WHERE ident_cely = 'HES-000305';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -5000, -5000, -4701, -4701 FROM heslar WHERE ident_cely = 'HES-000340';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -5000, -5000, -4901, -4901 FROM heslar WHERE ident_cely = 'HES-000394';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -540, -540, -461, -461 FROM heslar WHERE ident_cely = 'HES-000310';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -5600, -5600, -2301, -2301 FROM heslar WHERE ident_cely = 'HES-000387';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -5600, -5600, -4201, -4201 FROM heslar WHERE ident_cely = 'HES-000267';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -5600, -5600, -4701, -4701 FROM heslar WHERE ident_cely = 'HES-000268';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -5600, -5600, -4901, -4901 FROM heslar WHERE ident_cely = 'HES-000269';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -5600, -5600, 580, 580 FROM heslar WHERE ident_cely = 'HES-000304';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 581, 581, 1200, 1200 FROM heslar WHERE ident_cely = 'HES-000385';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 581, 581, 1500, 1500 FROM heslar WHERE ident_cely = 'HES-000380';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 581, 581, 1800, 1800 FROM heslar WHERE ident_cely = 'HES-000392';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 581, 581, 650, 650 FROM heslar WHERE ident_cely = 'HES-000386';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -625, -625, -371, -371 FROM heslar WHERE ident_cely = 'HES-000309';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 651, 651, 1150, 1150 FROM heslar WHERE ident_cely = 'HES-000276';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 651, 651, 800, 800 FROM heslar WHERE ident_cely = 'HES-000301';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -800, -800, -31, -31 FROM heslar WHERE ident_cely = 'HES-000334';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -800, -800, -371, -371 FROM heslar WHERE ident_cely = 'HES-000354';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -800, -800, -371, -371 FROM heslar WHERE ident_cely = 'HES-000378';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -800, -800, -401, -401 FROM heslar WHERE ident_cely = 'HES-000300';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -800, -800, -461, -461 FROM heslar WHERE ident_cely = 'HES-000307';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -800, -800, -531, -531 FROM heslar WHERE ident_cely = 'HES-000331';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -800, -800, -531, -531 FROM heslar WHERE ident_cely = 'HES-000332';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -800, -800, -541, -541 FROM heslar WHERE ident_cely = 'HES-000376';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -800, -800, -626, -626 FROM heslar WHERE ident_cely = 'HES-000377';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 801, 801, 850, 850 FROM heslar WHERE ident_cely = 'HES-000277';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 801, 801, 930, 930 FROM heslar WHERE ident_cely = 'HES-000379';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 851, 851, 900, 900 FROM heslar WHERE ident_cely = 'HES-000302';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 901, 901, 930, 930 FROM heslar WHERE ident_cely = 'HES-000278';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 931, 931, 1150, 1150 FROM heslar WHERE ident_cely = 'HES-000325';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 931, 931, 950, 950 FROM heslar WHERE ident_cely = 'HES-000356';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -950, -950, -451, -451 FROM heslar WHERE ident_cely = 'HES-000330';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, 951, 951, 1050, 1050 FROM heslar WHERE ident_cely = 'HES-000303';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -9600, -9600, -5601, -5601 FROM heslar WHERE ident_cely = 'HES-000275';
INSERT INTO heslar_datace (obdobi, rok_od_min, rok_od_max, rok_do_min, rok_do_max) SELECT id, -975, -975, -751, -751 FROM heslar WHERE ident_cely = 'HES-000299';

-- Odkazy na PeriodO
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.bil', 'http://n2t.net/ark:/99152/p0wctqt238x', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000330';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.hat', 'http://n2t.net/ark:/99152/p0wctqtnkxz', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000320';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.che', 'http://n2t.net/ark:/99152/p0wctqtrgjm', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000294';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.kno', 'http://n2t.net/ark:/99152/p0wctqtc3bj', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000293';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.luz', 'http://n2t.net/ark:/99152/p0wctqtmw49', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000337';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.mcf', 'http://n2t.net/ark:/99152/p0wctqtp3zv', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000324';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.mil', 'http://n2t.net/ark:/99152/p0wctqtp5qb', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000339';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.ml', 'http://n2t.net/ark:/99152/p0wctqthnzw', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000290';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.msd', 'http://n2t.net/ark:/99152/p0wctqtfx9w', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000323';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.nit', 'http://n2t.net/ark:/99152/p0wctqt4sk8', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000359';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.nyn', 'http://n2t.net/ark:/99152/p0wctqtwzdx', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000299';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.po', 'http://n2t.net/ark:/99152/p0wctqt8snq', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000383';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.pod', 'http://n2t.net/ark:/99152/p0wctqtjjsv', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000353';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.sas', 'http://n2t.net/ark:/99152/p0wctqtt89f', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000388';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.sd', 'http://n2t.net/ark:/99152/p0wctqtpjbw', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000322';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.sl', 'http://n2t.net/ark:/99152/p0wctqtdvd3', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000298';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.slp', 'http://n2t.net/ark:/99152/p0wctqt4mnj', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000296';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.st', 'http://n2t.net/ark:/99152/p0wctqt5kq4', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000319';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.sti', 'http://n2t.net/ark:/99152/p0wctqtrmjn', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000297';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.une', 'http://n2t.net/ark:/99152/p0wctqtnz2f', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000358';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.vel', 'http://n2t.net/ark:/99152/p0wctqtdzdt', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000338';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br.vet', 'http://n2t.net/ark:/99152/p0wctqtbs25', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000321';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'br-ha', 'http://n2t.net/ark:/99152/p0wctqtv8q7', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000384';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'bronz', 'http://n2t.net/ark:/99152/p0wctqtcsjh', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000390';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.bad', 'http://n2t.net/ark:/99152/p0wctqtppz9', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000317';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.bos', 'http://n2t.net/ark:/99152/p0wctqtc2f6', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000357';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.ca', 'http://n2t.net/ark:/99152/p0wctqtvzk7', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000286';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.cha', 'http://n2t.net/ark:/99152/p0wctqttb7c', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000371';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.chl', 'http://n2t.net/ark:/99152/p0wctqt972r', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000352';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.jev', 'http://n2t.net/ark:/99152/p0wctqtsxs9', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000373';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.jor', 'http://n2t.net/ark:/99152/p0wctqtc2b9', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000287';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.kča', 'http://n2t.net/ark:/99152/p0wctqtjb3d', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000351';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.kul', 'http://n2t.net/ark:/99152/p0wctqth4z2', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000279';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.mic', 'http://n2t.net/ark:/99152/p0wctqt79p6', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000365';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.ml', 'http://n2t.net/ark:/99152/p0wctqtfn33', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000280';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.mlp', 'http://n2t.net/ark:/99152/p0wctqt2sh7', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000374';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.mm2', 'http://n2t.net/ark:/99152/p0wctqtxwfx', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000363';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.nal', 'http://n2t.net/ark:/99152/p0wctqtm5d7', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000368';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.ohr', 'http://n2t.net/ark:/99152/p0wctqt873t', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000369';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.pun', 'http://n2t.net/ark:/99152/p0wctqtv28s', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000391';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.rbk', 'http://n2t.net/ark:/99152/p0wctqtgnpb', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000367';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.riv', 'http://n2t.net/ark:/99152/p0wctqtgt56', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000372';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.sd', 'http://n2t.net/ark:/99152/p0wctqt6c3f', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000370';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.sch', 'http://n2t.net/ark:/99152/p0wctqtdprq', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000364';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.snu', 'http://n2t.net/ark:/99152/p0wctqtd54h', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000375';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.st', 'http://n2t.net/ark:/99152/p0wctqtf78f', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000366';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'en.zvo', 'http://n2t.net/ark:/99152/p0wctqtq7bs', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000318';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'eneoli', 'http://n2t.net/ark:/99152/p0wctqthbgf', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000285';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha.bil', 'http://n2t.net/ark:/99152/p0wctqtxj7k', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000377';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha.byl', 'http://n2t.net/ark:/99152/p0wctqtbbf2', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000331';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha.dla', 'http://n2t.net/ark:/99152/p0wctqtwhx2', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000309';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha.hor', 'http://n2t.net/ark:/99152/p0wctqt87bw', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000307';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha.ml', 'http://n2t.net/ark:/99152/p0wctqtgph4', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000310';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha.moh', 'http://n2t.net/ark:/99152/p0wctqtpkqf', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000332';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha.pl', 'http://n2t.net/ark:/99152/p0wctqtc3mw', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000300';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha.slp', 'http://n2t.net/ark:/99152/p0wctqtc4v8', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000378';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha.st', 'http://n2t.net/ark:/99152/p0wctqt4gkw', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000376';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ha-la', 'http://n2t.net/ark:/99152/p0wctqtbqvf', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000334';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'halsta', 'http://n2t.net/ark:/99152/p0wctqthv2r', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000354';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'in', 'http://n2t.net/ark:/99152/p0wctqtgrp4', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000347';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'in.1', 'http://n2t.net/ark:/99152/p0wctqtdjzg', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000348';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'in.2', 'http://n2t.net/ark:/99152/p0wctqtp45b', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000349';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'la.cas', 'http://n2t.net/ark:/99152/p0wctqt3rfk', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000355';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'la.kob', 'http://n2t.net/ark:/99152/p0wctqtqwgw', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000259';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'la.m-p', 'http://n2t.net/ark:/99152/p0wctqt5pcw', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000255';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'la.po', 'http://n2t.net/ark:/99152/p0wctqtnhvv', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000258';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'la.pod', 'http://n2t.net/ark:/99152/p0wctqt8389', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000329';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'la.sd', 'http://n2t.net/ark:/99152/p0wctqt8gr9', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000333';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'la-ri', 'http://n2t.net/ark:/99152/p0wctqtf7rk', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000288';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'laten', 'http://n2t.net/ark:/99152/p0wctqt5c64', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000254';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'lr.prw', 'http://n2t.net/ark:/99152/p0wctqtcmd2', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000257';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'lr.puc', 'http://n2t.net/ark:/99152/p0wctqtdqgm', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000256';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'mezoli', 'http://n2t.net/ark:/99152/p0wctqt662t', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000275';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.len', 'http://n2t.net/ark:/99152/p0wctqt4rnk', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000306';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.lin', 'http://n2t.net/ark:/99152/p0wctqtmksk', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000269';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.ml', 'http://n2t.net/ark:/99152/p0wctqt3c6n', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000360';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.mm1', 'http://n2t.net/ark:/99152/p0wctqt8cbx', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000362';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.mun', 'http://n2t.net/ark:/99152/p0wctqtqv96', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000389';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.obe', 'http://n2t.net/ark:/99152/p0wctqtmfxq', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000305';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.sar', 'http://n2t.net/ark:/99152/p0wctqtms37', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000394';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.st', 'http://n2t.net/ark:/99152/p0wctqtpn3m', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000268';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.vyp', 'http://n2t.net/ark:/99152/p0wctqtnkjq', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000361';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne.zel', 'http://n2t.net/ark:/99152/p0wctqt77nc', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000340';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ne-en', 'http://n2t.net/ark:/99152/p0wctqt7bn5', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000387';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'neolit', 'http://n2t.net/ark:/99152/p0wctqtc8g2', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000267';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'no.1', 'http://n2t.net/ark:/99152/p0wctqtb32x', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000381';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'no.2', 'http://n2t.net/ark:/99152/p0wctqts9sm', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000382';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'no-in', 'http://n2t.net/ark:/99152/p0wctqtg6mc', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000350';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'novove', 'http://n2t.net/ark:/99152/p0wctqtthxk', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000252';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.aur', 'http://n2t.net/ark:/99152/p0wctqtj5mj', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000262';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.boh', 'http://n2t.net/ark:/99152/p0wctqt59c3', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000261';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.epg', 'http://n2t.net/ark:/99152/p0wctqtg6fv', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000263';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.epm', 'http://n2t.net/ark:/99152/p0wctqtbjh6', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000265';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.gra', 'http://n2t.net/ark:/99152/p0wctqtg2nm', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000311';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.kru', 'http://n2t.net/ark:/99152/p0wctqtckf3', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000314';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.mag', 'http://n2t.net/ark:/99152/p0wctqtxz27', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000283';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.mic', 'http://n2t.net/ark:/99152/p0wctqt7sbt', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000292';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.mis', 'http://n2t.net/ark:/99152/p0wctqtmxw3', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000282';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.ml', 'http://n2t.net/ark:/99152/p0wctqt2gxf', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000315';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.mou', 'http://n2t.net/ark:/99152/p0wctqthrdx', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000312';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.ost', 'http://n2t.net/ark:/99152/p0wctqt9pr3', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000266';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.po', 'http://n2t.net/ark:/99152/p0wctqtdz5r', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000264';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.sd', 'http://n2t.net/ark:/99152/p0wctqt2zsv', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000274';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.st', 'http://n2t.net/ark:/99152/p0wctqtck79', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000291';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.sze', 'http://n2t.net/ark:/99152/p0wctqtbd83', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000260';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa.tau', 'http://n2t.net/ark:/99152/p0wctqtp4gz', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000313';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'paleol', 'http://n2t.net/ark:/99152/p0wctqtmzmx', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000253';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pa-me', 'http://n2t.net/ark:/99152/p0wctqtprj8', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000284';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pp.slp', 'http://n2t.net/ark:/99152/p0wctqtqnsr', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000295';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pp.tur', 'http://n2t.net/ark:/99152/p0wctqtbr9x', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000308';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ppole', 'http://n2t.net/ark:/99152/p0wctqtcbj5', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000281';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pr.zem', 'http://n2t.net/ark:/99152/p0wctqtcm3c', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000304';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pravek', 'http://n2t.net/ark:/99152/p0wctqtjkck', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000289';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ps/no', 'http://n2t.net/ark:/99152/p0wctqtkh74', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000272';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'pstred', 'http://n2t.net/ark:/99152/p0wctqtvn2f', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000271';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ri.ml', 'http://n2t.net/ark:/99152/p0wctqtqnt3', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000341';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ri.pla', 'http://n2t.net/ark:/99152/p0wctqtnx7n', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000393';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ri.st', 'http://n2t.net/ark:/99152/p0wctqtm493', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000336';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rim', 'http://n2t.net/ark:/99152/p0wctqt2zvg', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000335';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'ri-sn', 'http://n2t.net/ark:/99152/p0wctqtvpdn', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000346';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.1', 'http://n2t.net/ark:/99152/p0wctqt6qt8', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000386';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.2', 'http://n2t.net/ark:/99152/p0wctqtz4h3', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000301';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.2-4', 'http://n2t.net/ark:/99152/p0wctqtq6ph', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000276';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.3', 'http://n2t.net/ark:/99152/p0wctqtv8mb', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000379';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.3.po', 'http://n2t.net/ark:/99152/p0wctqthdkt', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000278';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.3.ra', 'http://n2t.net/ark:/99152/p0wctqtzzng', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000277';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.3.vy', 'http://n2t.net/ark:/99152/p0wctqtt5t4', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000302';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.4', 'http://n2t.net/ark:/99152/p0wctqtsqpt', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000325';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.4.po', 'http://n2t.net/ark:/99152/p0wctqtgj99', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000326';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.4.ra', 'http://n2t.net/ark:/99152/p0wctqt3qw6', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000356';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs.4.vy', 'http://n2t.net/ark:/99152/p0wctqtcwkk', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000303';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rs/vs', 'http://n2t.net/ark:/99152/p0wctqt9vng', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000270';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'rstred', 'http://n2t.net/ark:/99152/p0wctqtdpx7', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000385';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'sn.dob', 'http://n2t.net/ark:/99152/p0wctqtrwg5', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000344';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'sn.ml', 'http://n2t.net/ark:/99152/p0wctqtctk3', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000345';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'sn.st', 'http://n2t.net/ark:/99152/p0wctqt4n8j', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000343';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'snarod', 'http://n2t.net/ark:/99152/p0wctqt2cd7', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000342';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'st-no', 'http://n2t.net/ark:/99152/p0wctqtcr24', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000392';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'stredo', 'http://n2t.net/ark:/99152/p0wctqttj7w', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000380';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'vs-no', 'http://n2t.net/ark:/99152/p0wctqtsv2j', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000273';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'vs-ps', 'http://n2t.net/ark:/99152/p0wctqt8pj3', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000327';
INSERT INTO heslar_odkaz (heslo, zdroj, nazev_kodu, kod, uri, skos_mapping_relation) SELECT id, 'PeriodO', 'Locator', 'vstred', 'http://n2t.net/ark:/99152/p0wctqtvkmn', 'skos:exactMatch' FROM heslar WHERE ident_cely = 'HES-000328';

-- Úprava organizací
UPDATE organizace SET nazev_zkraceny_en = '[amateur archaeologist]', nazev_en = '[amateur archaeologist]', soucast = NULL, zanikla = False WHERE id = '315810';
UPDATE organizace SET nazev_zkraceny_en = '[independent archaeologist]', nazev_en = '[independent archaeologist]', soucast = NULL, zanikla = False WHERE id = '315752';
UPDATE organizace SET nazev_zkraceny_en = '[other organisation]', nazev_en = '[other organisation]', soucast = NULL, zanikla = False WHERE id = '315818';
UPDATE organizace SET nazev_zkraceny_en = '[affiliation unknown]', nazev_en = '[affiliation unknown]', soucast = NULL, zanikla = False WHERE id = '315811';
UPDATE organizace SET nazev_zkraceny_en = '[public administration]', nazev_en = '[public administration]', soucast = NULL, zanikla = False WHERE id = '1051411';
UPDATE organizace SET nazev_zkraceny_en = '[secondary source]', nazev_en = '[secondary source]', soucast = NULL, zanikla = False WHERE id = '746717';
UPDATE organizace SET nazev_zkraceny_en = '[foreign researcher/expedition]', nazev_en = '[foreign researcher/expedition]', soucast = NULL, zanikla = False WHERE id = '315843';
UPDATE organizace SET nazev_zkraceny_en = 'ARCHA 13', email = 'info@archa13.cz', adresa = 'Rumjancevova 637/3a, 460 01 Liberec 1', ico = '22891161', nazev_en = 'ARCHA 13', soucast = NULL, zanikla = False WHERE id = '990316';
UPDATE organizace SET nazev_zkraceny_en = 'Archaia', email = 'praha@archaia.cz', telefon = '224 314 978; 224 317 913 ', adresa = 'Truhlářská 20/1119, 110 00 Praha 1', ico = '45245932', nazev_en = 'Archaia', soucast = NULL, zanikla = False WHERE id = '315733';
UPDATE organizace SET nazev_zkraceny_en = 'Archaia Brno', email = 'brno@archaiabrno.cz', telefon = '515 548 650', adresa = 'Bezručova 15/78, 602 00 Brno', ico = '26268469', nazev_en = 'Archaia Brno', soucast = NULL, zanikla = False WHERE id = '315744';
UPDATE organizace SET nazev_zkraceny_en = 'Archaia Jih', email = 'kasak@archaiajih.cz', adresa = 'Latrán, třída Míru 144, 381 01 Český Krumlov', ico = '26108470', nazev_en = 'Archaia Jih', soucast = NULL, zanikla = False WHERE id = '315745';
UPDATE organizace SET nazev_zkraceny_en = 'Archaia Olomouc', email = 'archaiaolomouc@seznam.cz', telefon = '777 239 050', adresa = 'Panská 4, 779 00 Olomouc', ico = '27713725', nazev_en = 'Archaia Olomouc', soucast = NULL, zanikla = False WHERE id = '598420';
UPDATE organizace SET nazev_zkraceny_en = 'Archaia Praha', email = 'praha@archaia.cz', telefon = '224 314 978; 224 317 913; 224 311 425', adresa = 'Vratislavova 20/22, 128 00 Praha 2', ico = '26701227', nazev_en = 'Archaia Praha', soucast = NULL, zanikla = False WHERE id = '315746';
UPDATE organizace SET nazev_zkraceny_en = 'Archaia Příchovice [defunct]', nazev_en = 'Archaia Příchovice [defunct]', soucast = NULL, zanikla = True WHERE id = '315732';
UPDATE organizace SET nazev_zkraceny_en = 'Archeo Pro', email = 'info@archeo4u.cz', telefon = '224 829 055', adresa = 'Zlatnická 1122/11, 110 00 Praha 1', ico = '27448657', nazev_en = 'Archeo Pro', soucast = NULL, zanikla = False WHERE id = '315748';
UPDATE organizace SET nazev_zkraceny_en = 'ARCHEO North', email = 'info@archeosever.cz', telefon = '722 027 239', adresa = 'K Vápence 448, 415 03 Teplice', ico = '01507583', nazev_en = 'ARCHEO North', soucast = NULL, zanikla = False WHERE id = '315749';
UPDATE organizace SET nazev_zkraceny_en = 'ArcheoBohemia [defunct]', nazev_en = 'ArcheoBohemia [defunct]', soucast = NULL, zanikla = True WHERE id = '315750';
UPDATE organizace SET nazev_zkraceny_en = 'Archeocentrum', email = 'info@archeocentrum.cz', telefon = '773 558 374', adresa = 'Malátova 395/13, 150 00 Praha', ico = '28184653', nazev_en = 'Archeocentrum', soucast = NULL, zanikla = False WHERE id = '315751';
UPDATE organizace SET nazev_zkraceny_en = 'Archaeological Society', adresa = 'Chebská 169/38, 360 06  Karlovy Vary', ico = '26387140', nazev_en = 'Archaeological Society', soucast = NULL, zanikla = False WHERE id = '315753';
UPDATE organizace SET nazev_zkraceny_en = 'Archeological Centre Olomouc', email = 'office@ac-olomouc.cz', telefon = '585 311 621', adresa = 'U Hradiska 42/6, 779 00 Olomouc', ico = '75008271', nazev_en = 'Archeological Centre Olomouc', soucast = NULL, zanikla = False WHERE id = '598421';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Archaeology Brno', email = 'sekretariat@arub.cz', adresa = 'Čechyňská 363/19, 602 00 Brno', ico = '68081758', nazev_en = 'Institute of Archaeology Brno', soucast = NULL, zanikla = False WHERE id = '315754';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Archaeology Brno - Dolní Dunajovice', email = 'dolnidunajovice@arub.cz', telefon = '519 517 107', adresa = 'Rudé armády 17, 691 85 Dolní Dunajovice', nazev_en = 'Institute of Archaeology Brno - Dolní Dunajovice', soucast = 315754, zanikla = False WHERE id = '598422';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Archaeology Brno - Dolní Věstonice', email = 'hajkova@arub.cz', telefon = '519 517 637', adresa = 'Sklepní 25, Dolní Věstonice 691 29', nazev_en = 'Institute of Archaeology Brno - Dolní Věstonice', soucast = 315754, zanikla = False WHERE id = '598423';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Archaeology Brno - Mikulčice', email = 'mikulcice@arub.cz', telefon = '518 121 421', adresa = '736 Mikulčice, 696 19 Mikulčice', nazev_en = 'Institute of Archaeology Brno - Mikulčice', soucast = 315754, zanikla = False WHERE id = '598424';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Archaeology Brno - Opava', email = 'janaslowioczek@seznam.cz', adresa = 'Nádražní okruh 33, 746 01 Opava', nazev_en = 'Institute of Archaeology Brno - Opava', soucast = 315754, zanikla = False WHERE id = '598425';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Archaeology Prague', email = 'arupraha@arup.cas.cz', adresa = 'Letenská 123, 11800 Praha', ico = '67985912', nazev_en = 'Institute of Archaeology Prague', soucast = NULL, zanikla = False WHERE id = '315755';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Archaeology Most [defunct]', nazev_en = 'Institute of Archaeology Most [defunct]', soucast = 315755, zanikla = True WHERE id = '315734';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Archaeology Plzeň [defunct]', nazev_en = 'Institute of Archaeology Plzeň [defunct]', soucast = 315755, zanikla = True WHERE id = '315735';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Archeaeology Nitra', nazev_en = 'Institute of Archeaeology Nitra', soucast = NULL, zanikla = False WHERE id = '942842';
UPDATE organizace SET nazev_zkraceny_en = 'Archeos', email = 'jan-vladar@volny.cz', telefon = '338 314 284; 602 115 149', adresa = 'Nebahovská 1016, 383 01 Prachatice', ico = '63914344', nazev_en = 'Archeos', soucast = NULL, zanikla = False WHERE id = '315756';
UPDATE organizace SET nazev_zkraceny_en = 'Czech Archaeological Society', email = 'baly@csarcheologicka.eu', adresa = 'Šárecká 33, 160 00 Praha', ico = '28458681', nazev_en = 'Czech Archaeological Society', soucast = NULL, zanikla = False WHERE id = '315757';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Kutná Hora', email = 'info@cms-kh.cz', telefon = '733 420 366; 327 512 159', adresa = 'Barborská 28, 284 01 Kutná Hora', ico = '00342246', nazev_en = 'Museum Kutná Hora', soucast = NULL, zanikla = False WHERE id = '315758';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Geology CAS', nazev_en = 'Institute of Geology CAS', soucast = NULL, zanikla = False WHERE id = '315763';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Příbram', email = 'info@muzeum-pribram.cz', telefon = '318 626 307; 318 633 138', adresa = 'Třemošenská 293, 26101 Příbram', ico = '00360121', nazev_en = 'Museum Příbram', soucast = NULL, zanikla = False WHERE id = '315764';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Tábor', email = 'tabor@husitskemuzeum.cz', telefon = '380 831 596; 381 252 242; 381 251 884', adresa = 'náměstí Mikuláše z Husi 44, 390 01 Tábor', ico = '00072486', nazev_en = 'Museum Tábor', soucast = NULL, zanikla = False WHERE id = '315765';
UPDATE organizace SET nazev_zkraceny_en = 'INCAD', nazev_en = 'INCAD', soucast = NULL, zanikla = False WHERE id = '598033';
UPDATE organizace SET nazev_zkraceny_en = 'University of South Bohemia – Faculty of Philosophy', email = 'dekanat@ff.jcu.cz', telefon = '387 774 898', adresa = 'Branišovská 31a, 37005 České Budějovice', ico = '60076658', nazev_en = 'University of South Bohemia – Faculty of Philosophy', soucast = NULL, zanikla = False WHERE id = '315759';
UPDATE organizace SET nazev_zkraceny_en = 'Museum České Budějovice', email = 'muzeumcb@muzeumcb.cz', telefon = '391 001 544', adresa = 'Fráni Šrámka 4, 370 04 České Budějovice', ico = '00073539', nazev_en = 'Museum České Budějovice', soucast = NULL, zanikla = False WHERE id = '315766';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Znojmo', email = 'info@muzeumznojmo.cz', telefon = '515 282 211', adresa = 'Přemyslovců 129/8, 669 02 Znojmo', ico = '00092738', nazev_en = 'Museum Znojmo', soucast = NULL, zanikla = False WHERE id = '598465';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Napajedla', email = 'klub.kultury@napajedla.cz', adresa = 'Komenského 304, 763 61 Napajedla', nazev_en = 'Museum Napajedla', soucast = NULL, zanikla = False WHERE id = '598450';
UPDATE organizace SET nazev_zkraceny_en = 'Commission for Vyšehrad Research [defunct]', nazev_en = 'Commission for Vyšehrad Research [defunct]', soucast = NULL, zanikla = True WHERE id = '1565908';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Morkovice', email = 'kazikova@morkovice-slizany.cz', telefon = '724 085 110', adresa = 'Nádražní 169, 768 33 Morkovice-Slížany', nazev_en = 'Museum Morkovice', soucast = NULL, zanikla = False WHERE id = '598449';
UPDATE organizace SET nazev_zkraceny_en = 'Labrys', email = 'office@labrys.cz', telefon = '604 589 676', adresa = 'Hloubětínská 16/11, 198 00 Praha 9', ico = '27573486', nazev_en = 'Labrys', soucast = NULL, zanikla = False WHERE id = '315770';
UPDATE organizace SET nazev_zkraceny_en = 'Masaryk University - Faculty of Philosophy', email = 'sibickova@phil.muni.cz', telefon = '549 491 539', adresa = 'Joštova 13, 60200 Brno', ico = '00216224', nazev_en = 'Masaryk University - Faculty of Philosophy', soucast = NULL, zanikla = False WHERE id = '315760';
UPDATE organizace SET nazev_zkraceny_en = 'Masaryk University - Faculty of Education', email = 'sekretariat@ped.muni.cz', telefon = '549 491 600', adresa = 'Poříčí 623/7, 639 00 Brno', ico = '00216224', nazev_en = 'Masaryk University - Faculty of Education', soucast = 315760, zanikla = False WHERE id = '598473';
UPDATE organizace SET nazev_zkraceny_en = 'Masaryk University - Faculty of Science', email = 'info@muni.cz', adresa = 'Kotlářská 267/2, 611 37 Brno', ico = '00216224', nazev_en = 'Masaryk University - Faculty of Science', soucast = 315760, zanikla = False WHERE id = '598474';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Hodonín', email = 'masarykovomuzeum@masaryk.info', telefon = '518 351 834', adresa = 'Zámecké nám. 27/9, 695 01 Hodonín', ico = '00090352', nazev_en = 'Museum Hodonín', soucast = NULL, zanikla = False WHERE id = '598437';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Kyjov', email = 'muzeum.kyjov@masaryk.info', telefon = '724 986 073', adresa = 'Palackého 70, Kyjov 69701', nazev_en = 'Museum Kyjov', soucast = 598437, zanikla = False WHERE id = '598445';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Unhošť', email = 'muzeum@muunhost.cz', telefon = '312 698 683, 702 008 908', adresa = 'Dr. Beneše 1, 273 51 Unhošť', nazev_en = 'Museum Unhošť', soucast = NULL, zanikla = False WHERE id = '599134';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Hranice', email = 'stara.radnice@muzeum-hranice.cz', telefon = '581 607 479', adresa = 'Masarykovo nám. 71, 753 01 Hranice', nazev_en = 'Museum Hranice', soucast = NULL, zanikla = False WHERE id = '598439';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Krnov', email = 'muzeum@mikskrnov.cz', telefon = '554 614 706', adresa = 'Hlubčická 152/20, 794 01 Krnov', nazev_en = 'Museum Krnov', soucast = NULL, zanikla = False WHERE id = '598442';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Holešov', email = 'info@mks-holesov.cz', telefon = '571 160 880', adresa = 'nám. F. X. Richtra 190, 769 01 Holešov', nazev_en = 'Museum Holešov', soucast = NULL, zanikla = False WHERE id = '598438';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Kojetín', email = 'reditelka@meks.kojetin.cz', telefon = '581 762 046', adresa = 'náměstí Republiky 1033, 752 01 Kojetín', nazev_en = 'Museum Kojetín', soucast = NULL, zanikla = False WHERE id = '598482';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Moravský Krumlov', email = 'meks@meksmk.cz', telefon = '720 980 758', adresa = 'Náměstí TGM 40, Moravský Krumlov, 672 01', nazev_en = 'Museum Moravský Krumlov', soucast = NULL, zanikla = False WHERE id = '598448';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Uničov', email = 'sedlacek@mkzunicov.cz', telefon = '585 054 060', adresa = 'Moravské náměstí 1143, 783 91 Uničov', nazev_en = 'Museum Uničov', soucast = NULL, zanikla = False WHERE id = '598428';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Břeclav', email = 'info@muzeumbv.cz', telefon = '519 323 050', adresa = 'sídl. Dukelských hrdinů 2747/4a, 690 02 Břeclav', ico = '60680920', nazev_en = 'Museum Břeclav', soucast = NULL, zanikla = False WHERE id = '598435';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Hořice', nazev_en = 'Museum Hořice', soucast = NULL, zanikla = False WHERE id = '1096774';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Čáslav', email = 'muzeum@cmuz.cz', telefon = '327 312 207', adresa = 'Bojovníků za svobodu 1448, 286 01  Čáslav', nazev_en = 'Museum Čáslav', soucast = NULL, zanikla = False WHERE id = '315771';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Pacov', email = 'muzeum@mestopacov.cz', telefon = '565 455 106', adresa = 'náměstí Svobody 1, 395 01 Pacov', nazev_en = 'Museum Pacov', soucast = NULL, zanikla = False WHERE id = '599136';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Bystřice n. P.', email = 'muzeum.bystricko@tiscali.cz', telefon = '566 590 365', adresa = 'Masarykovo nám. 1, Bystřice nad Pernštejnem 593 01', nazev_en = 'Museum Bystřice n. P.', soucast = NULL, zanikla = False WHERE id = '777154';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Jevíčko', email = 'muzeumjevicko@seznam.cz', telefon = '605 531 067', adresa = 'Komenského nám. 167, 569 43  Jevíčko', nazev_en = 'Museum Jevíčko', soucast = NULL, zanikla = False WHERE id = '598441';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Mariánské Lázně', email = 'muzeum@muzeum-ml.cz', telefon = '354 622 740', adresa = 'Goethovo náměstí 11, 353 01 Mariánské Lázně', nazev_en = 'Museum Mariánské Lázně', soucast = NULL, zanikla = False WHERE id = '315772';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Moravská Třebová', email = 'muzeum@ksmt.cz', telefon = '461 544 285', adresa = 'Svitavská 18, 571 01 Moravská Třebová ', nazev_en = 'Museum Moravská Třebová', soucast = NULL, zanikla = False WHERE id = '943019';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Podbořany', email = 'kultura@podborany.net', telefon = '415 214 111', adresa = 'Dukelská 1, 441 01 Podbořany', nazev_en = 'Museum Podbořany', soucast = NULL, zanikla = False WHERE id = '942843';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Rýmařov', email = 'muzeum@inforymarov.cz', telefon = '554 254 382', adresa = 'nám. Míru 6, Rýmařov 79501', nazev_en = 'Museum Rýmařov', soucast = NULL, zanikla = False WHERE id = '747992';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Sedlčany', email = 'muzeum@muzeum-sedlcany.cz', telefon = '318 821 240', adresa = 'Tyršova 136, 264 01 Sedlčany', nazev_en = 'Museum Sedlčany', soucast = NULL, zanikla = False WHERE id = '599137';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Čelákovice', email = 'info@celmuz.cz', telefon = '326 991 192; 326 991 556', adresa = 'Na Hrádku 464, Čelákovice 250 88', ico = '00175722', nazev_en = 'Museum Čelákovice', soucast = NULL, zanikla = False WHERE id = '315773';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Kadaň', nazev_en = 'Museum Kadaň', soucast = NULL, zanikla = False WHERE id = '1096775';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Kralupy n. Vlt.', email = 'info@muzeumkralupy.cz', telefon = '315 723 035', adresa = 'Vrchlického 590, 278 01 Kralupy nad Vltavou', nazev_en = 'Museum Kralupy n. Vlt.', soucast = NULL, zanikla = False WHERE id = '315774';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Valašské Klobouky', email = 'muzeum@mu-vk.cz', telefon = '577 320 095', adresa = 'Masarykovo náměstí 276, 766 01 Valašské klobouky', nazev_en = 'Museum Valašské Klobouky', soucast = NULL, zanikla = False WHERE id = '598461';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Stříbro', email = 'muzeumstribro.navratil@seznam.cz', telefon = '374 622 214, 374 627 247', adresa = 'Masarykovo náměstí 21, 349 01 Stříbro', nazev_en = 'Museum Stříbro', soucast = NULL, zanikla = False WHERE id = '315775';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Volyně', nazev_en = 'Museum Volyně', soucast = NULL, zanikla = False WHERE id = '1096778';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Velvary', email = 'muzeum@velvary.cz', telefon = '315 761 419, 725 867 123', adresa = 'Pražská 109, 273 24 Velvary', nazev_en = 'Museum Velvary', soucast = NULL, zanikla = False WHERE id = '942845';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Milevsko', email = 'muzeum.milevsko@muzeumvmilevsku.cz', telefon = '382 521 093', adresa = 'Klášterní  557, 399 01 Milevsko', ico = '00374652', nazev_en = 'Museum Milevsko', soucast = NULL, zanikla = False WHERE id = '315776';
UPDATE organizace SET nazev_zkraceny_en = 'Moravian Museum Brno', email = 'podatelna@mzm.cz', adresa = 'Kapucínské náměstí 8, 659 37 Brno', ico = '00094862', nazev_en = 'Moravian Museum Brno', soucast = NULL, zanikla = False WHERE id = '598429';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Rychnov n. Kn.', email = 'moh@moh.cz', telefon = '494 534 450', adresa = 'Jiráskova 2, 516 01 Rychnov nad Kněžnou', ico = '00371149', nazev_en = 'Museum Rychnov n. Kn.', soucast = NULL, zanikla = False WHERE id = '315778';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Mariánská Týnice', email = 'info@marianskatynice.cz', telefon = '373 396 410; 373 397 993', adresa = 'Mariánská Týnice 1, 331 41 Kralovice', ico = '00368563', nazev_en = 'Museum Mariánská Týnice', soucast = NULL, zanikla = False WHERE id = '315779';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Prostějov', email = 'muzeumpv@muzeumpv.cz', telefon = '582 330 991', adresa = 'nám. T. G. Masaryka 2 , 796 01 Prostějov', ico = '00091405', nazev_en = 'Museum Prostějov', soucast = NULL, zanikla = False WHERE id = '598455';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Beskyd', email = 'info@muzeumbeskyd.com', telefon = '558 628 003', adresa = 'Hluboká 66, 738 01 Frýdek-Místek', nazev_en = 'Museum Beskyd', soucast = NULL, zanikla = False WHERE id = '598430';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Bílina [defunct]', nazev_en = 'Museum Bílina [defunct]', soucast = 315832, zanikla = True WHERE id = '315736';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Blansko', email = 'info@muzeum-blanenska.cz', telefon = '725 952 592', adresa = 'Zámek 1/1, 678 01 Blansko', ico = '04551320', nazev_en = 'Museum Blansko', soucast = NULL, zanikla = False WHERE id = '598431';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Bojkovice', email = 'info@muzeumbojkovska.cz', telefon = '739 202 813', adresa = 'Palackého 172-173, 687 71 Bojkovice', nazev_en = 'Museum Bojkovice', soucast = NULL, zanikla = False WHERE id = '598432';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Brno Region', email = 'muzeum@mbrn.cz', adresa = 'Porta coeli 1001, 666 02 Předklášteří', ico = '00089257', nazev_en = 'Museum Brno Region', soucast = NULL, zanikla = False WHERE id = '598434';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Beroun', email = 'podatelna@muzeum-beroun.cz', telefon = '720 243 535', adresa = 'Husovo nám. 87, 266 01 Beroun', ico = '00065293', nazev_en = 'Museum Beroun', soucast = NULL, zanikla = False WHERE id = '315781';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Hořovice', email = 'horovice@muzeum-beroun.cz', telefon = ' 601 374 204', adresa = 'Vrbnovská 27/5, 268 01 Hořovice', nazev_en = 'Museum Hořovice', soucast = 315781, zanikla = False WHERE id = '315782';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Tachov', email = 'info@muzeumtachov.cz', telefon = '374 722 171', adresa = 'Třída Míru 447, 347 01 Tachov', ico = '00076716', nazev_en = 'Museum Tachov', soucast = NULL, zanikla = False WHERE id = '315777';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Turnov', email = 'mail@muzeum-turnov.cz', telefon = '481 322 106; 481 321 148; 481 325 277', adresa = 'Skálova 71, 511 01 Turnov', ico = '00085804', nazev_en = 'Museum Turnov', soucast = NULL, zanikla = False WHERE id = '315780';
UPDATE organizace SET nazev_zkraceny_en = 'Museum City of Prague', email = 'muzeum@muzeumprahy.cz', telefon = '221 012 911', adresa = 'Kožná 1/475, 110 00  Praha 1', ico = '00064432', nazev_en = 'Museum City of Prague', soucast = NULL, zanikla = False WHERE id = '315783';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Horšovský Týn [defunct]', nazev_en = 'Museum Horšovský Týn [defunct]', soucast = NULL, zanikla = True WHERE id = '943016';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Cheb', email = 'sekretariat@muzeumcheb.cz', telefon = '739 322 499', adresa = 'nám. Krále Jiřího z Poděbrad 493/4, 35002 Cheb', ico = '00074276', nazev_en = 'Museum Cheb', soucast = NULL, zanikla = False WHERE id = '315784';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Domažlice', email = 'muzeum@muzeum-chodska.com', telefon = '379 776 009', adresa = 'Chodské náměstí 96, 344 01 Domažlice', ico = '00073873', nazev_en = 'Museum Domažlice', soucast = NULL, zanikla = False WHERE id = '315785';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Uherský Brod', email = 'muzeum@mjakub.cz', telefon = '572 632 288-9', adresa = 'Přemysla Otakara II. 37, 688 12 UHERSKÝ BROD', nazev_en = 'Museum Uherský Brod', soucast = NULL, zanikla = False WHERE id = '598460';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Zlín', email = 'info@muzeum-zlin.cz', telefon = '573 032 301', adresa = 'Vavrečkova 7040, 760 01 Zlín', ico = '00089982', nazev_en = 'Museum Zlín', soucast = NULL, zanikla = False WHERE id = '598464';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Jindřichův Hradec', email = 'muzeum@mjh.cz', telefon = '384 363 661', adresa = 'Balbínovo náměstí 19/I, 377 01 Jindřichův Hradec', ico = '00070971', nazev_en = 'Museum Jindřichův Hradec', soucast = NULL, zanikla = False WHERE id = '315786';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Blovice', email = 'muzeum@muzeum-blovice.cz', telefon = '371 522 208; 773 023 840', adresa = 'Hradiště 1, 336 01 Blovice', ico = '00075710', nazev_en = 'Museum Blovice', soucast = NULL, zanikla = False WHERE id = '315787';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Karlovy Vary', email = 'sekretariat@kvmuz.cz', telefon = '736 650 047', adresa = 'Nová louka 23, 360 01 Karlovy Vary', ico = '72053810', nazev_en = 'Museum Karlovy Vary', soucast = NULL, zanikla = False WHERE id = '315788';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Přerov', email = 'info@prerovmuzeum.cz', telefon = '581 215 052', adresa = 'Horní náměstí 7/7, 750 02 Přerov', ico = '00097969', nazev_en = 'Museum Přerov', soucast = NULL, zanikla = False WHERE id = '598456';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Kroměříž', email = 'muzeum@muzeum-km.cz', telefon = '573 338 457', adresa = 'Velké náměstí 38, 767 01 Kroměříž', ico = '00091138', nazev_en = 'Museum Kroměříž', soucast = NULL, zanikla = False WHERE id = '598443';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Kvasice', email = 'klapilp@seznam.cz', telefon = '573 358 540', adresa = 'A. Dohnala 18, 768 21 Kvasice', nazev_en = 'Museum Kvasice', soucast = NULL, zanikla = False WHERE id = '598444';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Brno City', email = 'muzeum.brno@spilberk.cz', telefon = '542 123 611', adresa = 'Špilberk 210/1, 60200 Brno', ico = '00101427', nazev_en = 'Museum Brno City', soucast = NULL, zanikla = False WHERE id = '598446';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Duchcov', email = 'muzeum@muzeumduchcov.cz', telefon = '417 835 526', adresa = 'Masarykova 71/7, 419 01 Duchcov', nazev_en = 'Museum Duchcov', soucast = NULL, zanikla = False WHERE id = '943015';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Ústí n. L.', email = 'muzeumusti@muzeumusti.cz', telefon = '475 210 937', adresa = 'Masarykova 1000/3, 400 01 Ústí nad Labem', ico = '00361321', nazev_en = 'Museum Ústí n. L.', soucast = NULL, zanikla = False WHERE id = '315789';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Mladá Boleslav', email = 'info@muzeummb.cz', telefon = '326 325 616', adresa = 'Staroměstské náměstí 1, 29301 Mladá Boleslav', ico = '00353639', nazev_en = 'Museum Mladá Boleslav', soucast = NULL, zanikla = False WHERE id = '315790';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Náchod', email = 'sekretariat@muzeumnachodska.cz', telefon = '491 423 248; 724 156 909', adresa = 'Masarykovo náměstí 1, 547 01 Náchod', ico = '00084930', nazev_en = 'Museum Náchod', soucast = NULL, zanikla = False WHERE id = '315831';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Nový Jičín', email = 'sekretariat@muzeumnj.cz', telefon = '556 701 156', adresa = '28. října 51/12, 74101 Nový Jičín', ico = '00096296', nazev_en = 'Museum Nový Jičín', soucast = NULL, zanikla = False WHERE id = '598451';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Vlašim/Benešov', email = 'archeolog@muzeumpodblanicka.cz', telefon = '317 842 927', adresa = 'Zámek 1, 258 01 Vlašim', ico = '00065048', nazev_en = 'Museum Vlašim/Benešov', soucast = NULL, zanikla = False WHERE id = '315791';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Trutnov', email = 'muzeum@muzeumtrutnov.cz', telefon = '499 811 897; 499 815 393', adresa = 'Školní 150, 541 01 Trutnov', ico = '75119153', nazev_en = 'Museum Trutnov', soucast = NULL, zanikla = False WHERE id = '315792';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Boskovice', email = 'muzeum@muzeum-boskovicka.cz', telefon = '516 452 077', adresa = 'Hradní 642/1, 68001 Boskovice', ico = '04536649', nazev_en = 'Museum Boskovice', soucast = NULL, zanikla = False WHERE id = '598433';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Vsetín', email = 'zamek.vsetin@muzeumvalassko.cz', telefon = '571 411 690', adresa = 'Horní náměstí 2, 755 01 Vsetín', ico = '00098574', nazev_en = 'Museum Vsetín', soucast = NULL, zanikla = False WHERE id = '598462';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Jablonec n. N.', email = 'info@msb-jablonec.cz', telefon = '483 369 011; 778 527 123', adresa = 'U Muzea 398/4, 466 01 Jablonec nad Nisou', nazev_en = 'Museum Jablonec n. N.', soucast = NULL, zanikla = False WHERE id = '943017';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Strakonice', email = 'informace@muzeum-st.cz', telefon = '380 422 608', adresa = 'Zámek 1, 386 01 Strakonice', ico = '00072150', nazev_en = 'Museum Strakonice', soucast = NULL, zanikla = False WHERE id = '315793';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Sušice', nazev_en = 'Museum Sušice', soucast = NULL, zanikla = False WHERE id = '1096777';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Rakovník', email = 'archeolog@muzeumtgm.cz', telefon = '313 516 230', adresa = 'Vysoká 95, 269 01 Rakovník', ico = '00360155', nazev_en = 'Museum Rakovník', soucast = NULL, zanikla = False WHERE id = '315794';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Český Těšín', email = 'muzeum@muzeumct.cz', telefon = '558 761 211', adresa = 'Masarykovy sady 103/19, 737 01 Český Těšín', ico = '00305847', nazev_en = 'Museum Český Těšín', soucast = NULL, zanikla = False WHERE id = '598436';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Týniště n. O. [defunct]', nazev_en = 'Museum Týniště n. O. [defunct]', soucast = NULL, zanikla = True WHERE id = '943020';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Hradec Králové', email = 'info@muzeumhk.cz', telefon = '495 544 996; 495 512 391; 495 512 392', adresa = 'Eliščino nábřeží 465, 500 03 Hradec Králové 3', ico = '00088382', nazev_en = 'Museum Hradec Králové', soucast = NULL, zanikla = False WHERE id = '315795';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Havlíčkův Brod', email = 'info@muzeumhb.cz', telefon = '569 429 151', adresa = 'Havlíčkovo nám. 19, 580 01 Havlíčkův Brod', ico = '00083607', nazev_en = 'Museum Havlíčkův Brod', soucast = NULL, zanikla = False WHERE id = '315796';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Jihlava', email = 'muzeum@muzeum.ji.cz', telefon = '567 573 880', adresa = 'Masarykovo náměstí 55, 586 01 Jihlava', ico = '00090735', nazev_en = 'Museum Jihlava', soucast = NULL, zanikla = False WHERE id = '315797';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Pelhřimov', email = 'muzeum.pelhrimov@muzeumpe.cz', telefon = '565 323 184', adresa = 'Masarykovo náměstí 12, 393 01 Pelhřimov', ico = '00071307 ', nazev_en = 'Museum Pelhřimov', soucast = NULL, zanikla = False WHERE id = '315798';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Třebíč', email = 'muzeum@muzeumtr.cz', telefon = '568 408 890', adresa = 'Zámek 1, 674 01 Třebíč', nazev_en = 'Museum Třebíč', soucast = NULL, zanikla = False WHERE id = '598459';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Vyškov', email = 'mv@muzeum-vyskovska.cz', adresa = 'náměstí Čsl. armády 475/2, 682 01 Vyškov', ico = '00092401', nazev_en = 'Museum Vyškov', soucast = NULL, zanikla = False WHERE id = '598463';
UPDATE organizace SET nazev_zkraceny_en = 'National Museum', email = 'sekretariat@nm.cz', telefon = '224 497 111', adresa = 'Václavské náměstí 1700/68, 110 00  Praha 1', ico = '00023272', nazev_en = 'National Museum', soucast = NULL, zanikla = False WHERE id = '315799';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute - Directorate', email = 'sekretariat@npu.cz', telefon = '257 010 111', adresa = 'Liliová 219/5, 110 00 Praha 1', ico = '75032333', nazev_en = 'National Heritage Institute - Directorate', soucast = NULL, zanikla = False WHERE id = '315800';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute střední Čechy', email = 'sekretariat.sc@npu.cz', telefon = '274 008 111', adresa = 'Sabinova 373/5, 130 00 Praha 3', ico = '75032333', nazev_en = 'National Heritage Institute střední Čechy', soucast = 315800, zanikla = False WHERE id = '315801';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Brno', email = 'sekretariat.brno@npu.cz', telefon = '542 536 111', adresa = 'náměstí Svobody 8, 601 54 Brno', ico = '75032333', nazev_en = 'National Heritage Institute Brno', soucast = 315800, zanikla = False WHERE id = '598469';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute České Budějovice', email = 'sekretariat.cb@npu.cz', telefon = '387 312 140', adresa = 'Senovážné náměstí 6, 370 21 České Budějovice', ico = '75032333', nazev_en = 'National Heritage Institute České Budějovice', soucast = 315800, zanikla = False WHERE id = '315802';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Praha', email = 'sekretariat.praha@npu.cz', telefon = '234 653 111', adresa = 'Na Perštýně 356/12, 110 00 Praha 1', ico = '75032333', nazev_en = 'National Heritage Institute Praha', soucast = 315800, zanikla = False WHERE id = '315803';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Josefov', email = 'sekretariat.josefov@npu.cz', telefon = '491 509 539', adresa = 'Okružní 418, 551 02 Jaroměř – Josefov', ico = '75032333', nazev_en = 'National Heritage Institute Josefov', soucast = 315800, zanikla = False WHERE id = '315812';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Kroměříž', email = 'uop.kromeriz@npu.cz', telefon = '776 198 363', adresa = 'Riegrovo náměstí 3228/22, 767 01 Kroměříž', ico = '75032333', nazev_en = 'National Heritage Institute Kroměříž', soucast = 315800, zanikla = False WHERE id = '598470';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Liberec', email = 'sekretariat.liberec@npu.cz', telefon = '485 222 411', adresa = 'Jablonecká 642/23, 460 01 Liberec', ico = '75032333', nazev_en = 'National Heritage Institute Liberec', soucast = 315800, zanikla = False WHERE id = '315804';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Loket', email = 'sekretariat.loket@npu.cz', telefon = '352 684 796', adresa = 'Kostelní 81/25, 357 33 Loket', ico = '75032333', nazev_en = 'National Heritage Institute Loket', soucast = 315800, zanikla = False WHERE id = '315813';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Olomouc', email = 'sekretariat.olomouc@npu.cz', telefon = '775 888 957', adresa = 'Horní náměstí 25, 779 00 Olomouc', ico = '75032333', nazev_en = 'National Heritage Institute Olomouc', soucast = 315800, zanikla = False WHERE id = '598471';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Ostrava', email = 'sekretariat.ostrava@npu.cz', telefon = '595 133 903', adresa = 'ul. Odboje 1941/1, 702 00 Ostrava – Moravská Ostrava', ico = '75032333', nazev_en = 'National Heritage Institute Ostrava', soucast = 315800, zanikla = False WHERE id = '598472';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Pardubice', email = 'sekretariat.pardubice@npu.cz', telefon = '466 797 711', adresa = 'Příhrádek 5, 531 16 Pardubice', ico = '75032333', nazev_en = 'National Heritage Institute Pardubice', soucast = 315800, zanikla = False WHERE id = '315805';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Plzeň', email = 'sekretariat.plzen@npu.cz', telefon = '377 360 911; 606 648 620', adresa = 'Prešovská 7/171, 306 37  Plzeň', ico = '75032333', nazev_en = 'National Heritage Institute Plzeň', soucast = 315800, zanikla = False WHERE id = '315806';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Telč', email = 'sekretariat.telc@npu.cz', telefon = '567 213 116', adresa = 'Hradecká 6, 588 56 Telč', ico = '75032333', nazev_en = 'National Heritage Institute Telč', soucast = 315800, zanikla = False WHERE id = '315807';
UPDATE organizace SET nazev_zkraceny_en = 'National Heritage Institute Ústí nad Labem', email = 'sekretariat.usti@npu.cz', telefon = '472 704 800', adresa = 'P. O. Box 3, 400 07 Ústí nad Labem', ico = '75032333', nazev_en = 'National Heritage Institute Ústí nad Labem', soucast = 315800, zanikla = False WHERE id = '315808';
UPDATE organizace SET nazev_zkraceny_en = 'National Technical Museum', email = 'info@ntm.cz', telefon = '220 399 111', adresa = 'Kostelní 42, 170 78 Praha 7', nazev_en = 'National Technical Museum', soucast = NULL, zanikla = False WHERE id = '315809';
UPDATE organizace SET nazev_zkraceny_en = 'Our History', email = 'info@nasehistorie.cz', adresa = 'Noskov 21, 391 43  Mladá Vožice', ico = '27057895', nazev_en = 'Our History', soucast = NULL, zanikla = False WHERE id = '598468';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Most', email = 'info@omgm.cz ', telefon = '476 442 111', adresa = 'Čsl. armády 1360/35, 434 01 Most', nazev_en = 'Museum Most', soucast = NULL, zanikla = False WHERE id = '945637';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Brandýs n. L.', email = 'muzeum.brandys@gmail.com', telefon = '326 396 599; 326 396 600', adresa = 'Masarykovo náměstí 97, 250 01 Brandýs nad Labem - Stará Boleslav', ico = '00067539', nazev_en = 'Museum Brandýs n. L.', soucast = NULL, zanikla = False WHERE id = '315814';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Děčín', email = 'info@muzeumdc.cz', telefon = '412 531 549', adresa = 'Čsl. mládeže 1/31, 405 02 Děčín', ico = '00360210', nazev_en = 'Museum Děčín', soucast = NULL, zanikla = False WHERE id = '778008';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Chomutov', email = 'sekretariat@muzeumchomutov.cz', telefon = '474 651 251', adresa = 'Palackého 86, 430 01  Chomutov', ico = '00360571', nazev_en = 'Museum Chomutov', soucast = NULL, zanikla = False WHERE id = '315815';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Litoměřice', email = 'info@muzeumlitomerice.cz', adresa = 'Dlouhá 173, 412 01 Litoměřice', ico = '00360635', nazev_en = 'Museum Litoměřice', soucast = NULL, zanikla = False WHERE id = '315816';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Louny', email = 'info@muzeumlouny.cz', telefon = '415 652 456', adresa = 'Pivovarská 28, 440 01 Louny', ico = '00360716', nazev_en = 'Museum Louny', soucast = NULL, zanikla = False WHERE id = '315817';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Židlochovice [defunct]', nazev_en = 'Museum Židlochovice [defunct]', soucast = NULL, zanikla = True WHERE id = '598467';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Choceň', email = 'muzeum.chocen@centrum.cz', telefon = '465 471 624', adresa = 'Pernerova 1, 565 01 Choceň', ico = '00278955', nazev_en = 'Museum Choceň', soucast = NULL, zanikla = False WHERE id = '777152';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Ostrava', email = 'muzeum@ostrmuz.cz', telefon = '597 578 452', adresa = 'Masarykovo nám. 1/1, 70200 Ostrava', ico = '00097594', nazev_en = 'Museum Ostrava', soucast = NULL, zanikla = False WHERE id = '598454';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Roudnice n. L.', email = 'podripskemuzeum@seznam.cz', telefon = '416 810 761', adresa = 'nám. Jana z Dražic 101, 413 01 Roudnice nad Labem', ico = '68435002', nazev_en = 'Museum Roudnice n. L.', soucast = NULL, zanikla = False WHERE id = '315819';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Poděbrady', email = 'info@polabskemuzeum.cz', telefon = '325 612 640; 733 715 343', adresa = 'Na Dláždění 68, 290 01 Poděbrady', ico = '00069841', nazev_en = 'Museum Poděbrady', soucast = NULL, zanikla = False WHERE id = '315820';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Nymburk', email = 'nymburk@polabskemuzeum.cz', telefon = '325 512 473; 739 768 191', adresa = 'Tyršova 174, 288 02 Nymburk', nazev_en = 'Museum Nymburk', soucast = 315820, zanikla = False WHERE id = '599135';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Prachatice', email = 'muzeum@prachatickemuzeum.cz', telefon = '388 311 419; 606 644 530', adresa = 'Velké náměstí 13, 383 01 Prachatice', ico = '00071854', nazev_en = 'Museum Prachatice', soucast = NULL, zanikla = False WHERE id = '315821';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Písek', email = 'info@prachenskemuzeum.cz', telefon = '382 201 111', adresa = 'Velké nám. 114, 397 01 Písek', ico = '00367851', nazev_en = 'Museum Písek', soucast = NULL, zanikla = False WHERE id = '315822';
UPDATE organizace SET nazev_zkraceny_en = 'Pueblo', email = 'info@pueblo-ops.cz', telefon = '774 903 255', adresa = 'Podjavorinské 1601/8, Praha 4', ico = '28966465', nazev_en = 'Pueblo', soucast = NULL, zanikla = False WHERE id = '315824';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Pyšely', nazev_en = 'Museum Pyšely', soucast = NULL, zanikla = False WHERE id = '1096776';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Jičín', email = 'muzeumhry@muzeumhry.cz', telefon = '493 532 204', adresa = 'Valdštejnovo náměstí 1, 506 01 Jičín', ico = '00084549', nazev_en = 'Museum Jičín', soucast = NULL, zanikla = False WHERE id = '315825';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Žatec', email = 'rmz@muzeumzatec.cz', telefon = '608 200 697', adresa = 'Husova 678, Žatec', ico = '00360805', nazev_en = 'Museum Žatec', soucast = NULL, zanikla = False WHERE id = '315826';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Mělník', email = 'muzeum@muzeum-melnik.cz', telefon = '315 630 936', adresa = 'nám. Míru 54, 276 01 Mělník', ico = '00066567', nazev_en = 'Museum Mělník', soucast = NULL, zanikla = False WHERE id = '315827';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Český Krumlov', email = 'info@muzeumck.cz', telefon = '380 711 674', adresa = 'Horní ulice 152, 381 01 Český Krumlov', ico = '00070572', nazev_en = 'Museum Český Krumlov', soucast = NULL, zanikla = False WHERE id = '315828';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Jílové u Prahy', email = 'info@muzeumjilove.cz', telefon = '241 950 791', adresa = 'Masarykovo náměstí 16, 254 01 Jílové u Prahy', nazev_en = 'Museum Jílové u Prahy', soucast = NULL, zanikla = False WHERE id = '943018';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Kolín', email = 'info@muzeumkolin.cz', telefon = '321 723 841', adresa = 'Karlovo náměstí 8, 280 02 Kolín', ico = '00410047', nazev_en = 'Museum Kolín', soucast = NULL, zanikla = False WHERE id = '315829';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Český Brod', email = 'ceskybrod@muzeumkolin.cz', telefon = '321 622 330; 601 390 349', adresa = 'Žitomířská 761, 282 01 Český Brod', nazev_en = 'Museum Český Brod', soucast = 315829, zanikla = False WHERE id = '943014';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Litomyšl', email = 'info@rml.cz', telefon = '461 615 821', adresa = 'Jiráskova 9, 570 01 Litomyšl', ico = '71191283', nazev_en = 'Museum Litomyšl', soucast = NULL, zanikla = False WHERE id = '315830';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Mikulov', email = 'rmm@rmm.cz', telefon = '519 309 019', adresa = 'Zámek 1/4, 692 01 Mikulov', ico = '00089613', nazev_en = 'Museum Mikulov', soucast = NULL, zanikla = False WHERE id = '598447';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Teplice', email = 'info@muzeum-teplice.cz', telefon = '412 359 017', adresa = 'Srbická 479, 415 10 Teplice - Sobědruhy', ico = '00083241', nazev_en = 'Museum Teplice', soucast = NULL, zanikla = False WHERE id = '315832';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Chrudim', email = 'info@muzeumcr.cz', telefon = '469 620 330', adresa = 'Široká 86, 537 01 Chrudim', ico = '00370941', nazev_en = 'Museum Chrudim', soucast = NULL, zanikla = False WHERE id = '315833';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Vysoké Mýto', email = 'muzeum@muzeum-myto.cz', telefon = '465 461 950', adresa = 'A. V. Šembery 125, 566 01 Vysoké Mýto', ico = '00372331', nazev_en = 'Museum Vysoké Mýto', soucast = NULL, zanikla = False WHERE id = '315834';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Liberec', email = 'muzeumlb@muzeumlb.cz', telefon = '485 246 111', adresa = 'Masarykova 11, 460 01 Liberec', ico = '00083232', nazev_en = 'Museum Liberec', soucast = NULL, zanikla = False WHERE id = '315835';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Kladno', email = 'muzeum@omk.cz', telefon = '312 248 045', adresa = 'Huťská 1375, 272 01 Kladno', nazev_en = 'Museum Kladno', soucast = NULL, zanikla = False WHERE id = '778007';
UPDATE organizace SET nazev_zkraceny_en = 'Silesian University – Faculty of Philosophy and Science', email = 'dekanat@fpf.slu.cz', telefon = '553 684 400', adresa = 'Masarykova třída 343/37, 746 01 Opava', ico = '47813059', nazev_en = 'Silesian University – Faculty of Philosophy and Science', soucast = NULL, zanikla = False WHERE id = '598427';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Opava', email = 'szm@szm.cz', telefon = '553 622 999', adresa = 'Nádražní okruh 31, 746 01 Opava', ico = '00100595 ', nazev_en = 'Museum Opava', soucast = NULL, zanikla = False WHERE id = '598453';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Uherské Hradiště', email = 'info@slovackemuzeum.cz', telefon = '572 551 370', adresa = 'Smetanovy sady 179, Uherské Hradiště 686 01', ico = '00092126', nazev_en = 'Museum Uherské Hradiště', soucast = NULL, zanikla = False WHERE id = '598475';
UPDATE organizace SET nazev_zkraceny_en = 'SmartGIS', nazev_en = 'SmartGIS', soucast = NULL, zanikla = False WHERE id = '3';
UPDATE organizace SET nazev_zkraceny_en = 'Space Systems Czech', nazev_en = 'Space Systems Czech', soucast = NULL, zanikla = False WHERE id = '769066';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Vrchlabí', email = 'muzeum@krnap.cz', telefon = '737 203 059', adresa = 'Husova 213, 543 01 Vrchlabí', ico = '00088455', nazev_en = 'Museum Vrchlabí', soucast = NULL, zanikla = False WHERE id = '315769';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Roztoky', email = 'muzeum@muzeum-roztoky.cz', telefon = '233 029 011', adresa = 'Zámek 1, 252 63 Roztoky', ico = '00069850', nazev_en = 'Museum Roztoky', soucast = NULL, zanikla = False WHERE id = '315836';
UPDATE organizace SET nazev_zkraceny_en = 'Syrakus', email = 'archeologie@syrakus.org', telefon = '603 463 995', adresa = 'Havlíčkova 1026/6, 110 00 Praha', ico = '22736328', nazev_en = 'Syrakus', soucast = NULL, zanikla = False WHERE id = '315837';
UPDATE organizace SET nazev_zkraceny_en = 'Technical Museum in Brno', email = 'info@tmbrno.cz', telefon = '541 421 411', adresa = 'Purkyňova 105, 612 00 Brno', ico = '00101435', nazev_en = 'Technical Museum in Brno', soucast = NULL, zanikla = False WHERE id = '777162';
UPDATE organizace SET nazev_zkraceny_en = 'University Hradec Králové – Faculty of Philosophy', email = 'epodatelna@uhk.cz', telefon = '493 331 271', adresa = 'Rokitanského 62, 500 03 Hradec Králové', ico = '62690094', nazev_en = 'University Hradec Králové – Faculty of Philosophy', soucast = NULL, zanikla = False WHERE id = '315767';
UPDATE organizace SET nazev_zkraceny_en = 'Charles University – Faculty of Philosophy', email = 'sekretariat-dekan@ff.cuni.cz', telefon = '221 619 364, 603 154 674', adresa = 'Nám. Jana Palacha 2, 11000 Praha 1', ico = '00216208', nazev_en = 'Charles University – Faculty of Philosophy', soucast = NULL, zanikla = False WHERE id = '315761';
UPDATE organizace SET nazev_zkraceny_en = 'Charles University – Faculty of Science', nazev_en = 'Charles University – Faculty of Science', soucast = 315761, zanikla = False WHERE id = '315823';
UPDATE organizace SET nazev_zkraceny_en = 'University of Palacký Olomouc – Faculty of Philosophy', email = 'dekan.ff@upol.cz', telefon = '585 633 011', adresa = 'Křížkovského 511/10, 771 47 Olomouc', ico = '61989592', nazev_en = 'University of Palacký Olomouc – Faculty of Philosophy', soucast = NULL, zanikla = False WHERE id = '598426';
UPDATE organizace SET nazev_zkraceny_en = 'ÚAPP-Institute Brno', email = 'sekretariat@uapp.cz', telefon = '602 564 755', adresa = 'Kaloudova 1321/30, 614 00 Brno', ico = '48511005', nazev_en = 'ÚAPP-Institute Brno', soucast = NULL, zanikla = False WHERE id = '598476';
UPDATE organizace SET nazev_zkraceny_en = 'ÚAPPSZČ-Institute Most', email = 'office@uappmost.cz', telefon = '476 704 465', adresa = 'Jana Žižky 835/9, 434 01 Most', ico = '47325011', nazev_en = 'ÚAPPSZČ-Institute Most', soucast = NULL, zanikla = False WHERE id = '315838';
UPDATE organizace SET nazev_zkraceny_en = 'ÚAPPSČ-Institute Central Bohemia', email = 'praha@uappsc.cz', telefon = '274 817 993', adresa = 'Nad Olšinami 448/3, 100 00 Praha 10', ico = '49276433', nazev_en = 'ÚAPPSČ-Institute Central Bohemia', soucast = NULL, zanikla = False WHERE id = '315839';
UPDATE organizace SET nazev_zkraceny_en = 'Institute for Archaeology and Documentation of Monuments', email = 'uadp@uadp.cz', adresa = 'Na Kopečku 577, 54101 Trutnov', ico = '09581634', nazev_en = 'Institute for Archaeology and Documentation of Monuments', soucast = NULL, zanikla = False WHERE id = '1362210';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Česká Lípa', email = 'muzeumcl@muzeumcl.cz', telefon = '487 824 145', adresa = 'Nám. Osvobození 297/1, 470 01 Česká Lípa', ico = '00360198', nazev_en = 'Museum Česká Lípa', soucast = NULL, zanikla = False WHERE id = '315840';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Klatovy', email = 'info@muzeumklatovy.cz', telefon = '376 326 362; 737 061 235; 603 267 600', adresa = 'Hostašova 1, 33901 Klatovy', ico = '00075078', nazev_en = 'Museum Klatovy', soucast = NULL, zanikla = False WHERE id = '315841';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Jeseník', email = 'info@muzeumjesenik.cz', telefon = '725 073 539', adresa = 'Zámecké náměstí 1, 790 01 Jeseník', nazev_en = 'Museum Jeseník', soucast = NULL, zanikla = False WHERE id = '598440';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Olomouc', email = 'vmo@vmo.cz', telefon = '585 515 111', adresa = 'nám. Republiky 5, 77900 Olomouc', ico = '00100609', nazev_en = 'Museum Olomouc', soucast = NULL, zanikla = False WHERE id = '598452';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Šumperk', email = 'vmsumperk@muzeum-sumperk.cz', telefon = '583 363 070', adresa = 'Hlavní třída 22, 787 31 Šumperk', ico = '00098311', nazev_en = 'Museum Šumperk', soucast = NULL, zanikla = False WHERE id = '598458';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Slaný', email = 'muzeum@slansko.cz', telefon = '312 517 990, 312 517 991', adresa = 'Masarykovo náměstí 159, 274 01 Slaný', nazev_en = 'Museum Slaný', soucast = NULL, zanikla = False WHERE id = '942844';
UPDATE organizace SET nazev_zkraceny_en = 'Institute of Military History', email = 'museum@army.cz', telefon = '973 204 900', adresa = 'U Památníku 2, 130 05 Praha 3', ico = '60162694', nazev_en = 'Institute of Military History', soucast = NULL, zanikla = False WHERE id = '777166';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Ždánice', email = 'muzeum@muzdanice.cz', telefon = '725 920 846', adresa = 'Zámek 1, 696 32 Ždánice', nazev_en = 'Museum Ždánice', soucast = NULL, zanikla = False WHERE id = '598466';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Pardubice', email = 'vcm@vcm.cz', telefon = '466 799 240', adresa = 'Zámek 2, 530 02 Pardubice', ico = '14450542', nazev_en = 'Museum Pardubice', soucast = NULL, zanikla = False WHERE id = '315842';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Slavkov', email = 'info@zamek-slavkov.cz', telefon = '544 221 204', adresa = 'Palackého nám. 1, 684 01 Slavkov u Brna', nazev_en = 'Museum Slavkov', soucast = NULL, zanikla = False WHERE id = '598457';
UPDATE organizace SET nazev_zkraceny_en = 'University of West Bohemia – Faculty of Philosophy', email = 'veselah@kar.zcu.cz', telefon = '377 635 147', adresa = 'Sedláčkova 15, 30100 Plzeň', ico = '49777513', nazev_en = 'University of West Bohemia – Faculty of Philosophy', soucast = NULL, zanikla = False WHERE id = '315768';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Plzeň', email = 'info@zcm.cz', telefon = '378 370 112, 604 105 580', adresa = 'Kopeckého sady 357/2, 301 00  Plzeň 3', ico = '00228745', nazev_en = 'Museum Plzeň', soucast = NULL, zanikla = False WHERE id = '315844';
UPDATE organizace SET nazev_zkraceny_en = 'Museum Rokycany', email = 'ropruvodci@zcm.cz', telefon = '378 370 734', adresa = 'nám. J. Urbana 141, 337 01 Rokycany', nazev_en = 'Museum Rokycany', soucast = 315844, zanikla = False WHERE id = '599138';
UPDATE organizace SET nazev_zkraceny_en = 'ZIP Pilsen', email = 'info@zip-ops.cz', telefon = '777 915 600', adresa = 'Tomanova 3, 30100 Plzeň', ico = '26324105', nazev_en = 'ZIP Pilsen', soucast = NULL, zanikla = False WHERE id = '315845';
