-- Issue 372
-- archeologicky_zaznam.hlavni_katastr
WITH prevod AS
(
    SELECT archeologicky_zaznam.historie as vazba, k1.nazev as stary, k2.nazev as novy FROM archeologicky_zaznam 
    JOIN ruian_katastr k1 ON k1.id = archeologicky_zaznam.hlavni_katastr
    JOIN ruian_katastr k2 ON k2.id = k1.soucasny
    WHERE k1.aktualni is false
)
INSERT INTO historie (datum_zmeny, uzivatel, poznamka, vazba, typ_zmeny) SELECT now(), (SELECT id FROM auth_user WHERE email = 'amcr@arup.cas.cz'), stary || ' -> ' || novy, vazba, 'KAT' FROM prevod;
UPDATE archeologicky_zaznam SET hlavni_katastr = ruian_katastr.soucasny FROM ruian_katastr WHERE ruian_katastr.id = archeologicky_zaznam.hlavni_katastr AND aktualni is false;

-- archeologicky_zaznam_katastr.katastr_id
WITH prevod AS
(
    SELECT archeologicky_zaznam.historie as vazba, k1.nazev as stary, k2.nazev as novy FROM archeologicky_zaznam_katastr
    JOIN archeologicky_zaznam ON archeologicky_zaznam.id = archeologicky_zaznam_katastr.archeologicky_zaznam_id
    JOIN ruian_katastr k1 ON k1.id = archeologicky_zaznam_katastr.katastr_id
    JOIN ruian_katastr k2 ON k2.id = k1.soucasny
    WHERE k1.aktualni is false
)
INSERT INTO historie (datum_zmeny, uzivatel, poznamka, vazba, typ_zmeny) SELECT now(), (SELECT id FROM auth_user WHERE email = 'amcr@arup.cas.cz'), stary || ' -> ' || novy, vazba, 'KAT' FROM prevod;
WITH prevod AS
(
    SELECT DISTINCT archeologicky_zaznam_katastr.archeologicky_zaznam_id as az, ruian_katastr.soucasny as kat FROM archeologicky_zaznam_katastr
    JOIN ruian_katastr ON ruian_katastr.id = archeologicky_zaznam_katastr.katastr_id
    WHERE ruian_katastr.aktualni is false
)
INSERT INTO archeologicky_zaznam_katastr (archeologicky_zaznam_id, katastr_id) SELECT az, kat FROM prevod WHERE NOT EXISTS (SELECT * FROM archeologicky_zaznam_katastr WHERE archeologicky_zaznam_id = az AND katastr_id = kat);
DELETE FROM archeologicky_zaznam_katastr WHERE (SELECT aktualni FROM ruian_katastr WHERE ruian_katastr.id = archeologicky_zaznam_katastr.katastr_id) is false;
DELETE FROM archeologicky_zaznam_katastr WHERE (SELECT hlavni_katastr FROM archeologicky_zaznam WHERE archeologicky_zaznam.id = archeologicky_zaznam_katastr.archeologicky_zaznam_id) = katastr_id;

-- neident_akce.katastr
UPDATE neident_akce SET katastr = ruian_katastr.soucasny FROM ruian_katastr WHERE ruian_katastr.id = neident_akce.katastr AND aktualni is false;

-- projekt.hlavni_katastr
WITH prevod AS
(
    SELECT projekt.historie as vazba, k1.nazev as stary, k2.nazev as novy FROM projekt 
    JOIN ruian_katastr k1 ON k1.id = projekt.hlavni_katastr
    JOIN ruian_katastr k2 ON k2.id = k1.soucasny
    WHERE k1.aktualni is false
)
INSERT INTO historie (datum_zmeny, uzivatel, poznamka, vazba, typ_zmeny) SELECT now(), (SELECT id FROM auth_user WHERE email = 'amcr@arup.cas.cz'), stary || ' -> ' || novy, vazba, 'KAT' FROM prevod;
UPDATE projekt SET hlavni_katastr = ruian_katastr.soucasny FROM ruian_katastr WHERE ruian_katastr.id = projekt.hlavni_katastr AND aktualni is false;

-- projekt_katastr.katastr_id
WITH prevod AS
(
    SELECT projekt.historie as vazba, k1.nazev as stary, k2.nazev as novy FROM projekt_katastr
    JOIN projekt ON projekt.id = projekt_katastr.projekt_id
    JOIN ruian_katastr k1 ON k1.id = projekt_katastr.katastr_id
    JOIN ruian_katastr k2 ON k2.id = k1.soucasny
    WHERE k1.aktualni is false
)
INSERT INTO historie (datum_zmeny, uzivatel, poznamka, vazba, typ_zmeny) SELECT now(), (SELECT id FROM auth_user WHERE email = 'amcr@arup.cas.cz'), stary || ' -> ' || novy, vazba, 'KAT' FROM prevod;
WITH prevod AS
(
    SELECT DISTINCT projekt_katastr.projekt_id as proj, ruian_katastr.soucasny as kat FROM projekt_katastr
    JOIN ruian_katastr ON ruian_katastr.id = projekt_katastr.katastr_id
    WHERE ruian_katastr.aktualni is false
)
INSERT INTO projekt_katastr (projekt_id, katastr_id) SELECT proj, kat FROM prevod WHERE NOT EXISTS (SELECT * FROM projekt_katastr WHERE projekt_id = proj AND katastr_id = kat);
DELETE FROM projekt_katastr WHERE (SELECT aktualni FROM ruian_katastr WHERE ruian_katastr.id = projekt_katastr.katastr_id) is false;
DELETE FROM projekt_katastr WHERE (SELECT hlavni_katastr FROM projekt WHERE projekt.id = projekt_katastr.projekt_id) = katastr_id;

-- samostatny_nalez.katastr
WITH prevod AS
(
    SELECT samostatny_nalez.historie as vazba, k1.nazev as stary, k2.nazev as novy FROM samostatny_nalez 
    JOIN ruian_katastr k1 ON k1.id = samostatny_nalez.katastr
    JOIN ruian_katastr k2 ON k2.id = k1.soucasny
    WHERE k1.aktualni is false
)
INSERT INTO historie (datum_zmeny, uzivatel, poznamka, vazba, typ_zmeny) SELECT now(), (SELECT id FROM auth_user WHERE email = 'amcr@arup.cas.cz'), stary || ' -> ' || novy, vazba, 'KAT' FROM prevod;
UPDATE samostatny_nalez SET katastr = ruian_katastr.soucasny FROM ruian_katastr WHERE ruian_katastr.id = samostatny_nalez.katastr AND aktualni is false;

-- smazání neaktuálních katastrů
DELETE FROM ruian_katastr WHERE aktualni is false;

-- úprava struktury
ALTER TABLE ruian_katastr ADD CONSTRAINT ruian_katastr_nazev_key UNIQUE(nazev);
ALTER TABLE ruian_katastr ADD CONSTRAINT ruian_katastr_kod_key UNIQUE(kod);
ALTER TABLE ruian_katastr DROP COLUMN nazev_stary; 
ALTER TABLE ruian_katastr DROP COLUMN aktualni; 
ALTER TABLE ruian_katastr DROP COLUMN soucasny;

-- oprava názvů KÚ
UPDATE ruian_katastr SET nazev = 'Abertamy' WHERE kod = 600016;
UPDATE ruian_katastr SET nazev = 'Hřebečná' WHERE kod = 600024;
UPDATE ruian_katastr SET nazev = 'Adamov u Českých Budějovic' WHERE kod = 600032;
UPDATE ruian_katastr SET nazev = 'Adamov' WHERE kod = 600041;
UPDATE ruian_katastr SET nazev = 'Dolní Adršpach' WHERE kod = 600059;
UPDATE ruian_katastr SET nazev = 'Horní Adršpach' WHERE kod = 600067;
UPDATE ruian_katastr SET nazev = 'Albeř' WHERE kod = 600075;
UPDATE ruian_katastr SET nazev = 'Albrechtice' WHERE kod = 600083;
UPDATE ruian_katastr SET nazev = 'Albrechtice u Mostu' WHERE kod = 600091;
UPDATE ruian_katastr SET nazev = 'Jezeří' WHERE kod = 600105;
UPDATE ruian_katastr SET nazev = 'Albrechtice u Lanškrouna' WHERE kod = 600113;
UPDATE ruian_katastr SET nazev = 'Albrechtice u Českého Těšína' WHERE kod = 600121;
UPDATE ruian_katastr SET nazev = 'Albrechtice nad Orlicí' WHERE kod = 600172;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Albrechtic' WHERE kod = 600199;
UPDATE ruian_katastr SET nazev = 'Štěpánovsko' WHERE kod = 600202;
UPDATE ruian_katastr SET nazev = 'Albrechtice nad Vltavou' WHERE kod = 600229;
UPDATE ruian_katastr SET nazev = 'Údraž' WHERE kod = 600261;
UPDATE ruian_katastr SET nazev = 'Albrechtice v Jizerských horách' WHERE kod = 600288;
UPDATE ruian_katastr SET nazev = 'Albrechtičky' WHERE kod = 600300;
UPDATE ruian_katastr SET nazev = 'Nová Horka' WHERE kod = 600318;
UPDATE ruian_katastr SET nazev = 'Andělka' WHERE kod = 600326;
UPDATE ruian_katastr SET nazev = 'Andělská Hora' WHERE kod = 600369;
UPDATE ruian_katastr SET nazev = 'Anenská Studánka' WHERE kod = 600377;
UPDATE ruian_katastr SET nazev = 'Helvíkov' WHERE kod = 600385;
UPDATE ruian_katastr SET nazev = 'Antošovice' WHERE kod = 600393;
UPDATE ruian_katastr SET nazev = 'Archlebov' WHERE kod = 600407;
UPDATE ruian_katastr SET nazev = 'Arneštovice' WHERE kod = 600415;
UPDATE ruian_katastr SET nazev = 'Arnolec' WHERE kod = 600423;
UPDATE ruian_katastr SET nazev = 'Arnoltice' WHERE kod = 600431;
UPDATE ruian_katastr SET nazev = 'Bynovec' WHERE kod = 600440;
UPDATE ruian_katastr SET nazev = 'Labská Stráň' WHERE kod = 600458;
UPDATE ruian_katastr SET nazev = 'Arnoštovice' WHERE kod = 600466;
UPDATE ruian_katastr SET nazev = 'Aš' WHERE kod = 600521;
UPDATE ruian_katastr SET nazev = 'Babí' WHERE kod = 600598;
UPDATE ruian_katastr SET nazev = 'Babice' WHERE kod = 600601;
UPDATE ruian_katastr SET nazev = 'Velké Babice' WHERE kod = 600610;
UPDATE ruian_katastr SET nazev = 'Babice u Lesonic' WHERE kod = 600636;
UPDATE ruian_katastr SET nazev = 'Bolíkovice' WHERE kod = 600644;
UPDATE ruian_katastr SET nazev = 'Babice u Uherského Hradiště' WHERE kod = 600652;
UPDATE ruian_katastr SET nazev = 'Babice u Šternberka' WHERE kod = 600661;
UPDATE ruian_katastr SET nazev = 'Krakořice' WHERE kod = 600679;
UPDATE ruian_katastr SET nazev = 'Babice u Kelče' WHERE kod = 600687;
UPDATE ruian_katastr SET nazev = 'Babice nad Svitavou' WHERE kod = 600695;
UPDATE ruian_katastr SET nazev = 'Babice u Rosic' WHERE kod = 600709;
UPDATE ruian_katastr SET nazev = 'Babylon' WHERE kod = 600717;
UPDATE ruian_katastr SET nazev = 'Bácovice' WHERE kod = 600725;
UPDATE ruian_katastr SET nazev = 'Milotičky' WHERE kod = 600733;
UPDATE ruian_katastr SET nazev = 'Bačetín' WHERE kod = 600741;
UPDATE ruian_katastr SET nazev = 'Sudín' WHERE kod = 600750;
UPDATE ruian_katastr SET nazev = 'Bačice' WHERE kod = 600768;
UPDATE ruian_katastr SET nazev = 'Udeřice' WHERE kod = 600776;
UPDATE ruian_katastr SET nazev = 'Bačkov' WHERE kod = 600784;
UPDATE ruian_katastr SET nazev = 'Lubno u Bačkova' WHERE kod = 600792;
UPDATE ruian_katastr SET nazev = 'Zboží' WHERE kod = 600806;
UPDATE ruian_katastr SET nazev = 'Bačkovice' WHERE kod = 600814;
UPDATE ruian_katastr SET nazev = 'Bačov' WHERE kod = 600822;
UPDATE ruian_katastr SET nazev = 'Bakov nad Jizerou' WHERE kod = 600831;
UPDATE ruian_katastr SET nazev = 'Baliny' WHERE kod = 600849;
UPDATE ruian_katastr SET nazev = 'Banín' WHERE kod = 600857;
UPDATE ruian_katastr SET nazev = 'Bánov' WHERE kod = 600865;
UPDATE ruian_katastr SET nazev = 'Báňovice' WHERE kod = 600873;
UPDATE ruian_katastr SET nazev = 'Bantice' WHERE kod = 600881;
UPDATE ruian_katastr SET nazev = 'Barchov' WHERE kod = 600890;
UPDATE ruian_katastr SET nazev = 'Barchov u Pardubic' WHERE kod = 600903;
UPDATE ruian_katastr SET nazev = 'Barchovice' WHERE kod = 600911;
UPDATE ruian_katastr SET nazev = 'Hryzely' WHERE kod = 600920;
UPDATE ruian_katastr SET nazev = 'Radlice u Barchovic' WHERE kod = 600938;
UPDATE ruian_katastr SET nazev = 'Barchůvek' WHERE kod = 600946;
UPDATE ruian_katastr SET nazev = 'Bartoňov' WHERE kod = 600954;
UPDATE ruian_katastr SET nazev = 'Radomilov' WHERE kod = 600962;
UPDATE ruian_katastr SET nazev = 'Bartošovice' WHERE kod = 600971;
UPDATE ruian_katastr SET nazev = 'Bartošovice v Orlických horách' WHERE kod = 600989;
UPDATE ruian_katastr SET nazev = 'Neratov v Orlických horách' WHERE kod = 600997;
UPDATE ruian_katastr SET nazev = 'Nová Ves v Orlických horách' WHERE kod = 601004;
UPDATE ruian_katastr SET nazev = 'Podlesí v Orlických horách' WHERE kod = 601012;
UPDATE ruian_katastr SET nazev = 'Vrchní Orlice' WHERE kod = 601021;
UPDATE ruian_katastr SET nazev = 'Malá Strana v Orlických horách' WHERE kod = 601039;
UPDATE ruian_katastr SET nazev = 'Bařice' WHERE kod = 601047;
UPDATE ruian_katastr SET nazev = 'Velké Těšany' WHERE kod = 601055;
UPDATE ruian_katastr SET nazev = 'Baška' WHERE kod = 601063;
UPDATE ruian_katastr SET nazev = 'Hodoňovice' WHERE kod = 601080;
UPDATE ruian_katastr SET nazev = 'Kunčičky u Bašky' WHERE kod = 601098;
UPDATE ruian_katastr SET nazev = 'Bašnice' WHERE kod = 601101;
UPDATE ruian_katastr SET nazev = 'Bašť' WHERE kod = 601128;
UPDATE ruian_katastr SET nazev = 'Batelov' WHERE kod = 601144;
UPDATE ruian_katastr SET nazev = 'Batňovice' WHERE kod = 601152;
UPDATE ruian_katastr SET nazev = 'Bavorov' WHERE kod = 601179;
UPDATE ruian_katastr SET nazev = 'Tourov' WHERE kod = 601195;
UPDATE ruian_katastr SET nazev = 'Bavory' WHERE kod = 601209;
UPDATE ruian_katastr SET nazev = 'Bavoryně' WHERE kod = 601217;
UPDATE ruian_katastr SET nazev = 'Bdín' WHERE kod = 601225;
UPDATE ruian_katastr SET nazev = 'Bečov u Mostu' WHERE kod = 601233;
UPDATE ruian_katastr SET nazev = 'Milá' WHERE kod = 601241;
UPDATE ruian_katastr SET nazev = 'Zaječice u Bečova' WHERE kod = 601250;
UPDATE ruian_katastr SET nazev = 'Bečov nad Teplou' WHERE kod = 601268;
UPDATE ruian_katastr SET nazev = 'Krásný Jez' WHERE kod = 601276;
UPDATE ruian_katastr SET nazev = 'Vodná u Bečova nad Teplou' WHERE kod = 601284;
UPDATE ruian_katastr SET nazev = 'Bečváry' WHERE kod = 601292;
UPDATE ruian_katastr SET nazev = 'Červený Hrádek u Bečvár' WHERE kod = 601306;
UPDATE ruian_katastr SET nazev = 'Poďousy' WHERE kod = 601314;
UPDATE ruian_katastr SET nazev = 'Zadní Hrádek' WHERE kod = 601322;
UPDATE ruian_katastr SET nazev = 'Bedihošť' WHERE kod = 601331;
UPDATE ruian_katastr SET nazev = 'Bednárec' WHERE kod = 601349;
UPDATE ruian_katastr SET nazev = 'Bednáreček' WHERE kod = 601357;
UPDATE ruian_katastr SET nazev = 'Bedřichov u Jablonce nad Nisou' WHERE kod = 601365;
UPDATE ruian_katastr SET nazev = 'Bedřichov' WHERE kod = 601373;
UPDATE ruian_katastr SET nazev = 'Bedřichovice' WHERE kod = 601381;
UPDATE ruian_katastr SET nazev = 'Běhařov' WHERE kod = 601390;
UPDATE ruian_katastr SET nazev = 'Dubová Lhota' WHERE kod = 601403;
UPDATE ruian_katastr SET nazev = 'Úborsko' WHERE kod = 601411;
UPDATE ruian_katastr SET nazev = 'Běhařovice' WHERE kod = 601420;
UPDATE ruian_katastr SET nazev = 'Ratišovice' WHERE kod = 601438;
UPDATE ruian_katastr SET nazev = 'Stupešice' WHERE kod = 601446;
UPDATE ruian_katastr SET nazev = 'Běchary' WHERE kod = 601462;
UPDATE ruian_katastr SET nazev = 'Bechlín' WHERE kod = 601471;
UPDATE ruian_katastr SET nazev = 'Předonín' WHERE kod = 601497;
UPDATE ruian_katastr SET nazev = 'Bechov' WHERE kod = 601501;
UPDATE ruian_katastr SET nazev = 'Běchovice' WHERE kod = 601527;
UPDATE ruian_katastr SET nazev = 'Bechyně' WHERE kod = 601543;
UPDATE ruian_katastr SET nazev = 'Senožaty u Bechyně' WHERE kod = 601560;
UPDATE ruian_katastr SET nazev = 'Bělá u Horní Cerekve' WHERE kod = 601586;
UPDATE ruian_katastr SET nazev = 'Bělá' WHERE kod = 601594;
UPDATE ruian_katastr SET nazev = 'Bělá u Staré Paky' WHERE kod = 601608;
UPDATE ruian_katastr SET nazev = 'Bělá ve Slezsku' WHERE kod = 601616;
UPDATE ruian_katastr SET nazev = 'Bělá nad Radbuzou' WHERE kod = 601624;
UPDATE ruian_katastr SET nazev = 'Bystřice u Bělé nad Radbuzou' WHERE kod = 601632;
UPDATE ruian_katastr SET nazev = 'Čečín' WHERE kod = 601641;
UPDATE ruian_katastr SET nazev = 'Černá Hora u Bělé nad Radbuzou' WHERE kod = 601659;
UPDATE ruian_katastr SET nazev = 'Doubravka u Bělé nad Radbuzou' WHERE kod = 601667;
UPDATE ruian_katastr SET nazev = 'Újezd Svatého Kříže' WHERE kod = 601675;
UPDATE ruian_katastr SET nazev = 'Bělá nad Svitavou' WHERE kod = 601683;
UPDATE ruian_katastr SET nazev = 'Bělá pod Bezdězem' WHERE kod = 601705;
UPDATE ruian_katastr SET nazev = 'Adolfovice' WHERE kod = 601756;
UPDATE ruian_katastr SET nazev = 'Domašov u Jeseníka' WHERE kod = 601772;
UPDATE ruian_katastr SET nazev = 'Bělá u Jevíčka' WHERE kod = 601799;
UPDATE ruian_katastr SET nazev = 'Malonín' WHERE kod = 601802;
UPDATE ruian_katastr SET nazev = 'Smolná u Jevíčka' WHERE kod = 601811;
UPDATE ruian_katastr SET nazev = 'Bělá u Pecky' WHERE kod = 601829;
UPDATE ruian_katastr SET nazev = 'Dolní Javoří' WHERE kod = 601837;
UPDATE ruian_katastr SET nazev = 'Horní Javoří' WHERE kod = 601845;
UPDATE ruian_katastr SET nazev = 'Radkyně' WHERE kod = 601853;
UPDATE ruian_katastr SET nazev = 'Uhlíře' WHERE kod = 601861;
UPDATE ruian_katastr SET nazev = 'Bělčice' WHERE kod = 601870;
UPDATE ruian_katastr SET nazev = 'Běleč' WHERE kod = 601888;
UPDATE ruian_katastr SET nazev = 'Běleč u Mladé Vožice' WHERE kod = 601896;
UPDATE ruian_katastr SET nazev = 'Běleč u Lomnice' WHERE kod = 601918;
UPDATE ruian_katastr SET nazev = 'Křeptov' WHERE kod = 601926;
UPDATE ruian_katastr SET nazev = 'Běleč nad Orlicí' WHERE kod = 601934;
UPDATE ruian_katastr SET nazev = 'Bělečko' WHERE kod = 601942;
UPDATE ruian_katastr SET nazev = 'Bělice' WHERE kod = 601951;
UPDATE ruian_katastr SET nazev = 'Bělkovice' WHERE kod = 601977;
UPDATE ruian_katastr SET nazev = 'Lašťany' WHERE kod = 601985;
UPDATE ruian_katastr SET nazev = 'Běloky' WHERE kod = 601993;
UPDATE ruian_katastr SET nazev = 'Bělotín' WHERE kod = 602001;
UPDATE ruian_katastr SET nazev = 'Bělov' WHERE kod = 602019;
UPDATE ruian_katastr SET nazev = 'Bělušice' WHERE kod = 602027;
UPDATE ruian_katastr SET nazev = 'Bedřichův Světec' WHERE kod = 602035;
UPDATE ruian_katastr SET nazev = 'Bělušice u Mostu' WHERE kod = 602043;
UPDATE ruian_katastr SET nazev = 'Odolice' WHERE kod = 602051;
UPDATE ruian_katastr SET nazev = 'Benátecká Vrutice' WHERE kod = 602060;
UPDATE ruian_katastr SET nazev = 'Jiřice' WHERE kod = 602078;
UPDATE ruian_katastr SET nazev = 'Benátky' WHERE kod = 602086;
UPDATE ruian_katastr SET nazev = 'Benátky u Litomyšle' WHERE kod = 602094;
UPDATE ruian_katastr SET nazev = 'Nové Benátky' WHERE kod = 602108;
UPDATE ruian_katastr SET nazev = 'Obodř' WHERE kod = 602116;
UPDATE ruian_katastr SET nazev = 'Staré Benátky' WHERE kod = 602124;
UPDATE ruian_katastr SET nazev = 'Benecko' WHERE kod = 602132;
UPDATE ruian_katastr SET nazev = 'Dolní Štěpanice' WHERE kod = 602141;
UPDATE ruian_katastr SET nazev = 'Horní Štěpanice' WHERE kod = 602159;
UPDATE ruian_katastr SET nazev = 'Mrklov' WHERE kod = 602167;
UPDATE ruian_katastr SET nazev = 'Benešov u Prahy' WHERE kod = 602191;
UPDATE ruian_katastr SET nazev = 'Benešov' WHERE kod = 602353;
UPDATE ruian_katastr SET nazev = 'Benešov u Boskovic' WHERE kod = 602361;
UPDATE ruian_katastr SET nazev = 'Benešov nad Černou' WHERE kod = 602388;
UPDATE ruian_katastr SET nazev = 'Velký Jindřichov' WHERE kod = 602396;
UPDATE ruian_katastr SET nazev = 'Hartunkov' WHERE kod = 602400;
UPDATE ruian_katastr SET nazev = 'Klení' WHERE kod = 602426;
UPDATE ruian_katastr SET nazev = 'Kuří' WHERE kod = 602434;
UPDATE ruian_katastr SET nazev = 'Valtéřov' WHERE kod = 602442;
UPDATE ruian_katastr SET nazev = 'Benešov nad Ploučnicí' WHERE kod = 602451;
UPDATE ruian_katastr SET nazev = 'Ovesná' WHERE kod = 602469;
UPDATE ruian_katastr SET nazev = 'Benešov u Semil' WHERE kod = 602477;
UPDATE ruian_katastr SET nazev = 'Benešova Hora' WHERE kod = 602515;
UPDATE ruian_katastr SET nazev = 'Čábuze' WHERE kod = 602523;
UPDATE ruian_katastr SET nazev = 'Benešovice' WHERE kod = 602531;
UPDATE ruian_katastr SET nazev = 'Lom u Stříbra' WHERE kod = 602540;
UPDATE ruian_katastr SET nazev = 'Benetice' WHERE kod = 602566;
UPDATE ruian_katastr SET nazev = 'Věstoňovice' WHERE kod = 602574;
UPDATE ruian_katastr SET nazev = 'Benice' WHERE kod = 602582;
UPDATE ruian_katastr SET nazev = 'Benkovice' WHERE kod = 602591;
UPDATE ruian_katastr SET nazev = 'Beňov' WHERE kod = 602604;
UPDATE ruian_katastr SET nazev = 'Prusy' WHERE kod = 602612;
UPDATE ruian_katastr SET nazev = 'Beranov' WHERE kod = 602621;
UPDATE ruian_katastr SET nazev = 'Kladruby u Beranova' WHERE kod = 602639;
UPDATE ruian_katastr SET nazev = 'Bernardov' WHERE kod = 602647;
UPDATE ruian_katastr SET nazev = 'Bernartice u Dolních Kralovic' WHERE kod = 602655;
UPDATE ruian_katastr SET nazev = 'Bernartice u Milevska' WHERE kod = 602663;
UPDATE ruian_katastr SET nazev = 'Bilinka' WHERE kod = 602671;
UPDATE ruian_katastr SET nazev = 'Bojenice' WHERE kod = 602680;
UPDATE ruian_katastr SET nazev = 'Zběšice' WHERE kod = 602698;
UPDATE ruian_katastr SET nazev = 'Bernartice u Stráže' WHERE kod = 602701;
UPDATE ruian_katastr SET nazev = 'Borek u Tachova' WHERE kod = 602710;
UPDATE ruian_katastr SET nazev = 'Dehetná' WHERE kod = 602728;
UPDATE ruian_katastr SET nazev = 'Strachovice u Bernartic' WHERE kod = 602736;
UPDATE ruian_katastr SET nazev = 'Bečkov' WHERE kod = 602744;
UPDATE ruian_katastr SET nazev = 'Bernartice' WHERE kod = 602752;
UPDATE ruian_katastr SET nazev = 'Královec' WHERE kod = 602761;
UPDATE ruian_katastr SET nazev = 'Křenov u Žacléře' WHERE kod = 602779;
UPDATE ruian_katastr SET nazev = 'Lampertice' WHERE kod = 602787;
UPDATE ruian_katastr SET nazev = 'Bernartice u Javorníka' WHERE kod = 602825;
UPDATE ruian_katastr SET nazev = 'Buková u Bernartic' WHERE kod = 602833;
UPDATE ruian_katastr SET nazev = 'Horní Heřmanice u Bernartic' WHERE kod = 602841;
UPDATE ruian_katastr SET nazev = 'Bernartice nad Odrou' WHERE kod = 602850;
UPDATE ruian_katastr SET nazev = 'Beroun' WHERE kod = 602868;
UPDATE ruian_katastr SET nazev = 'Zdejcina' WHERE kod = 603074;
UPDATE ruian_katastr SET nazev = 'Jarov u Berouna' WHERE kod = 603091;
UPDATE ruian_katastr SET nazev = 'Běrunice' WHERE kod = 603104;
UPDATE ruian_katastr SET nazev = 'Běruničky' WHERE kod = 603112;
UPDATE ruian_katastr SET nazev = 'Kněžičky' WHERE kod = 603121;
UPDATE ruian_katastr SET nazev = 'Slibovice' WHERE kod = 603155;
UPDATE ruian_katastr SET nazev = 'Velké Výkleky' WHERE kod = 603163;
UPDATE ruian_katastr SET nazev = 'Vlkov nad Lesy' WHERE kod = 603171;
UPDATE ruian_katastr SET nazev = 'Běřín' WHERE kod = 603180;
UPDATE ruian_katastr SET nazev = 'Bakov' WHERE kod = 603198;
UPDATE ruian_katastr SET nazev = 'Beřovice' WHERE kod = 603201;
UPDATE ruian_katastr SET nazev = 'Besednice' WHERE kod = 603210;
UPDATE ruian_katastr SET nazev = 'Malče' WHERE kod = 603228;
UPDATE ruian_katastr SET nazev = 'Běstovice' WHERE kod = 603236;
UPDATE ruian_katastr SET nazev = 'Běstvina' WHERE kod = 603244;
UPDATE ruian_katastr SET nazev = 'Pařížov' WHERE kod = 603261;
UPDATE ruian_katastr SET nazev = 'Spačice' WHERE kod = 603287;
UPDATE ruian_katastr SET nazev = 'Vestec u Běstviny' WHERE kod = 603295;
UPDATE ruian_katastr SET nazev = 'Běšiny' WHERE kod = 603317;
UPDATE ruian_katastr SET nazev = 'Hořákov' WHERE kod = 603325;
UPDATE ruian_katastr SET nazev = 'Kozí' WHERE kod = 603333;
UPDATE ruian_katastr SET nazev = 'Rajské' WHERE kod = 603341;
UPDATE ruian_katastr SET nazev = 'Úloh' WHERE kod = 603350;
UPDATE ruian_katastr SET nazev = 'Běštín' WHERE kod = 603368;
UPDATE ruian_katastr SET nazev = 'Bezděčí u Trnávky' WHERE kod = 603376;
UPDATE ruian_katastr SET nazev = 'Unerázka' WHERE kod = 603384;
UPDATE ruian_katastr SET nazev = 'Bezděčí u Velkých Opatovic' WHERE kod = 603392;
UPDATE ruian_katastr SET nazev = 'Bezděčín u Jablonce nad Nisou' WHERE kod = 603406;
UPDATE ruian_katastr SET nazev = 'Jílové u Hodkovic nad Mohelkou' WHERE kod = 603414;
UPDATE ruian_katastr SET nazev = 'Bezděčín na Moravě' WHERE kod = 603431;
UPDATE ruian_katastr SET nazev = 'Bezdědice' WHERE kod = 603449;
UPDATE ruian_katastr SET nazev = 'Bezdědovice' WHERE kod = 603457;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Klatov' WHERE kod = 603481;
UPDATE ruian_katastr SET nazev = 'Koryta u Bezděkova' WHERE kod = 603490;
UPDATE ruian_katastr SET nazev = 'Struhadlo' WHERE kod = 603503;
UPDATE ruian_katastr SET nazev = 'Tetětice u Bezděkova' WHERE kod = 603511;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Kasejovic' WHERE kod = 603538;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Žatce' WHERE kod = 603546;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Krásné Hory' WHERE kod = 603554;
UPDATE ruian_katastr SET nazev = 'Bezděkov' WHERE kod = 603571;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Velké Bíteše' WHERE kod = 603589;
UPDATE ruian_katastr SET nazev = 'Bezděkov nad Metují' WHERE kod = 603597;
UPDATE ruian_katastr SET nazev = 'Bezděkov pod Třemšínem' WHERE kod = 603601;
UPDATE ruian_katastr SET nazev = 'Vševily' WHERE kod = 603619;
UPDATE ruian_katastr SET nazev = 'Těchnice' WHERE kod = 603627;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Libice nad Doubravou' WHERE kod = 603635;
UPDATE ruian_katastr SET nazev = 'Kladruby u Libice' WHERE kod = 603643;
UPDATE ruian_katastr SET nazev = 'Malochyně' WHERE kod = 603651;
UPDATE ruian_katastr SET nazev = 'Sloupno u Chotěboře' WHERE kod = 603660;
UPDATE ruian_katastr SET nazev = 'Bezděz' WHERE kod = 603686;
UPDATE ruian_katastr SET nazev = 'Bezdružice' WHERE kod = 603694;
UPDATE ruian_katastr SET nazev = 'Polžice u Bezdružic' WHERE kod = 603708;
UPDATE ruian_katastr SET nazev = 'Kohoutov u Bezdružic' WHERE kod = 603724;
UPDATE ruian_katastr SET nazev = 'Křivce' WHERE kod = 603732;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Bezdružic' WHERE kod = 603741;
UPDATE ruian_katastr SET nazev = 'Potín' WHERE kod = 603767;
UPDATE ruian_katastr SET nazev = 'Řešín' WHERE kod = 603775;
UPDATE ruian_katastr SET nazev = 'Zhořec u Bezdružic' WHERE kod = 603783;
UPDATE ruian_katastr SET nazev = 'Bezkov' WHERE kod = 603791;
UPDATE ruian_katastr SET nazev = 'Bezměrov' WHERE kod = 603805;
UPDATE ruian_katastr SET nazev = 'Bezník' WHERE kod = 603813;
UPDATE ruian_katastr SET nazev = 'Bezno' WHERE kod = 603821;
UPDATE ruian_katastr SET nazev = 'Bezuchov' WHERE kod = 603830;
UPDATE ruian_katastr SET nazev = 'Bezvěrov' WHERE kod = 603848;
UPDATE ruian_katastr SET nazev = 'Krašov' WHERE kod = 603856;
UPDATE ruian_katastr SET nazev = 'Potok' WHERE kod = 603864;
UPDATE ruian_katastr SET nazev = 'Vlkošov' WHERE kod = 603872;
UPDATE ruian_katastr SET nazev = 'Bílá u Českého Dubu' WHERE kod = 603881;
UPDATE ruian_katastr SET nazev = 'Vlčetín u Bílé' WHERE kod = 603902;
UPDATE ruian_katastr SET nazev = 'Bílá' WHERE kod = 603911;
UPDATE ruian_katastr SET nazev = 'Bílá Lhota' WHERE kod = 603953;
UPDATE ruian_katastr SET nazev = 'Hrabí' WHERE kod = 603961;
UPDATE ruian_katastr SET nazev = 'Hradečná u Bílé Lhoty' WHERE kod = 603970;
UPDATE ruian_katastr SET nazev = 'Pateřín' WHERE kod = 603988;
UPDATE ruian_katastr SET nazev = 'Bílá Třemešná' WHERE kod = 604003;
UPDATE ruian_katastr SET nazev = 'Bílá Voda u Javorníka' WHERE kod = 604011;
UPDATE ruian_katastr SET nazev = 'Kamenička u Bílé Vody' WHERE kod = 604020;
UPDATE ruian_katastr SET nazev = 'Bílany' WHERE kod = 604038;
UPDATE ruian_katastr SET nazev = 'Bílavsko' WHERE kod = 604046;
UPDATE ruian_katastr SET nazev = 'Bílčice' WHERE kod = 604054;
UPDATE ruian_katastr SET nazev = 'Bílé Podolí' WHERE kod = 604062;
UPDATE ruian_katastr SET nazev = 'Brambory' WHERE kod = 604071;
UPDATE ruian_katastr SET nazev = 'Lovčice' WHERE kod = 604097;
UPDATE ruian_katastr SET nazev = 'Semtěš u Bílého Podolí' WHERE kod = 604101;
UPDATE ruian_katastr SET nazev = 'Starkoč u Bílého Podolí' WHERE kod = 604119;
UPDATE ruian_katastr SET nazev = 'Zaříčany' WHERE kod = 604127;
UPDATE ruian_katastr SET nazev = 'Bílé Poličany' WHERE kod = 604135;
UPDATE ruian_katastr SET nazev = 'Bílé Vchynice' WHERE kod = 604143;
UPDATE ruian_katastr SET nazev = 'Bílence' WHERE kod = 604151;
UPDATE ruian_katastr SET nazev = 'Škrle' WHERE kod = 604160;
UPDATE ruian_katastr SET nazev = 'Bílenice' WHERE kod = 604186;
UPDATE ruian_katastr SET nazev = 'Bílichov' WHERE kod = 604194;
UPDATE ruian_katastr SET nazev = 'Bílina' WHERE kod = 604208;
UPDATE ruian_katastr SET nazev = 'Bílina-Újezd' WHERE kod = 604283;
UPDATE ruian_katastr SET nazev = 'Chudeřice u Bíliny' WHERE kod = 604348;
UPDATE ruian_katastr SET nazev = 'Bílkov' WHERE kod = 604372;
UPDATE ruian_katastr SET nazev = 'Dobrohošť' WHERE kod = 604381;
UPDATE ruian_katastr SET nazev = 'Bílov v Čechách' WHERE kod = 604399;
UPDATE ruian_katastr SET nazev = 'Bílov' WHERE kod = 604402;
UPDATE ruian_katastr SET nazev = 'Bílovec-město' WHERE kod = 604429;
UPDATE ruian_katastr SET nazev = 'Bílovec-Dolní Předměstí' WHERE kod = 604445;
UPDATE ruian_katastr SET nazev = 'Radotín u Bílovce' WHERE kod = 604453;
UPDATE ruian_katastr SET nazev = 'Bílovec-Horní Předměstí' WHERE kod = 604470;
UPDATE ruian_katastr SET nazev = 'Bílovice u Uherského Hradiště' WHERE kod = 604518;
UPDATE ruian_katastr SET nazev = 'Včelary' WHERE kod = 604526;
UPDATE ruian_katastr SET nazev = 'Bílovice' WHERE kod = 604534;
UPDATE ruian_katastr SET nazev = 'Lutotín' WHERE kod = 604542;
UPDATE ruian_katastr SET nazev = 'Bílovice nad Svitavou' WHERE kod = 604551;
UPDATE ruian_katastr SET nazev = 'Bílsko u Vodňan' WHERE kod = 604569;
UPDATE ruian_katastr SET nazev = 'Měkynec' WHERE kod = 604577;
UPDATE ruian_katastr SET nazev = 'Bílsko' WHERE kod = 604585;
UPDATE ruian_katastr SET nazev = 'Cakov' WHERE kod = 604593;
UPDATE ruian_katastr SET nazev = 'Loučka u Bílska' WHERE kod = 604607;
UPDATE ruian_katastr SET nazev = 'Bílý Kámen' WHERE kod = 604615;
UPDATE ruian_katastr SET nazev = 'Bílý Kostel nad Nisou' WHERE kod = 604623;
UPDATE ruian_katastr SET nazev = 'Panenská Hůrka' WHERE kod = 604631;
UPDATE ruian_katastr SET nazev = 'Bílý Potok pod Smrkem' WHERE kod = 604658;
UPDATE ruian_katastr SET nazev = 'Bílý Potok' WHERE kod = 604666;
UPDATE ruian_katastr SET nazev = 'Horní Hoštice' WHERE kod = 604674;
UPDATE ruian_katastr SET nazev = 'Bílý Újezd' WHERE kod = 604691;
UPDATE ruian_katastr SET nazev = 'Bílý Újezd u Dobrušky' WHERE kod = 604712;
UPDATE ruian_katastr SET nazev = 'Hroška' WHERE kod = 604721;
UPDATE ruian_katastr SET nazev = 'Masty' WHERE kod = 604739;
UPDATE ruian_katastr SET nazev = 'Biskoupky na Moravě' WHERE kod = 604755;
UPDATE ruian_katastr SET nazev = 'Biskupice u Jevíčka' WHERE kod = 604763;
UPDATE ruian_katastr SET nazev = 'Zálesí u Jevíčka' WHERE kod = 604771;
UPDATE ruian_katastr SET nazev = 'Biskupice u Luhačovic' WHERE kod = 604780;
UPDATE ruian_katastr SET nazev = 'Biskupice na Hané' WHERE kod = 604801;
UPDATE ruian_katastr SET nazev = 'Biskupice u Hrotovic' WHERE kod = 604810;
UPDATE ruian_katastr SET nazev = 'Pulkov' WHERE kod = 604828;
UPDATE ruian_katastr SET nazev = 'Bítouchov u Mladé Boleslavi' WHERE kod = 604836;
UPDATE ruian_katastr SET nazev = 'Dalešice u Bakova nad Jizerou' WHERE kod = 604844;
UPDATE ruian_katastr SET nazev = 'Bítov' WHERE kod = 604861;
UPDATE ruian_katastr SET nazev = 'Bítov u Bílovce' WHERE kod = 604879;
UPDATE ruian_katastr SET nazev = 'Bítovany' WHERE kod = 604895;
UPDATE ruian_katastr SET nazev = 'Horní Bítovčice' WHERE kod = 604909;
UPDATE ruian_katastr SET nazev = 'Dolní Bítovčice' WHERE kod = 604917;
UPDATE ruian_katastr SET nazev = 'Bitozeves' WHERE kod = 604925;
UPDATE ruian_katastr SET nazev = 'Vidovle' WHERE kod = 604933;
UPDATE ruian_katastr SET nazev = 'Blahoňov' WHERE kod = 604941;
UPDATE ruian_katastr SET nazev = 'Prosatín' WHERE kod = 604950;
UPDATE ruian_katastr SET nazev = 'Blahutovice' WHERE kod = 604968;
UPDATE ruian_katastr SET nazev = 'Bendovo Záhoří' WHERE kod = 604976;
UPDATE ruian_katastr SET nazev = 'Blanice u Mladé Vožice' WHERE kod = 604984;
UPDATE ruian_katastr SET nazev = 'Krchova Lomná' WHERE kod = 604992;
UPDATE ruian_katastr SET nazev = 'Blanné' WHERE kod = 605000;
UPDATE ruian_katastr SET nazev = 'Blansko' WHERE kod = 605018;
UPDATE ruian_katastr SET nazev = 'Blatce' WHERE kod = 605115;
UPDATE ruian_katastr SET nazev = 'Houska' WHERE kod = 605140;
UPDATE ruian_katastr SET nazev = 'Tubož' WHERE kod = 605166;
UPDATE ruian_katastr SET nazev = 'Blatec u Hodětína' WHERE kod = 605174;
UPDATE ruian_katastr SET nazev = 'Blatec' WHERE kod = 605204;
UPDATE ruian_katastr SET nazev = 'Blatenka' WHERE kod = 605212;
UPDATE ruian_katastr SET nazev = 'Jindřichovice u Blatenky' WHERE kod = 605221;
UPDATE ruian_katastr SET nazev = 'Lažánky' WHERE kod = 605239;
UPDATE ruian_katastr SET nazev = 'Blatná' WHERE kod = 605247;
UPDATE ruian_katastr SET nazev = 'Blatnice u Nýřan' WHERE kod = 605301;
UPDATE ruian_katastr SET nazev = 'Blatnice pod Svatým Antonínkem' WHERE kod = 605310;
UPDATE ruian_katastr SET nazev = 'Blatnice' WHERE kod = 605328;
UPDATE ruian_katastr SET nazev = 'Ohrazenice na Moravě' WHERE kod = 605336;
UPDATE ruian_katastr SET nazev = 'Blatnička' WHERE kod = 605344;
UPDATE ruian_katastr SET nazev = 'Bečov' WHERE kod = 605352;
UPDATE ruian_katastr SET nazev = 'Blatno u Chomutova' WHERE kod = 605361;
UPDATE ruian_katastr SET nazev = 'Hrádečná' WHERE kod = 605379;
UPDATE ruian_katastr SET nazev = 'Květnov u Chomutova' WHERE kod = 605387;
UPDATE ruian_katastr SET nazev = 'Mezihoří u Chomutova' WHERE kod = 605395;
UPDATE ruian_katastr SET nazev = 'Radenov' WHERE kod = 605409;
UPDATE ruian_katastr SET nazev = 'Šerchov' WHERE kod = 605417;
UPDATE ruian_katastr SET nazev = 'Zákoutí' WHERE kod = 605425;
UPDATE ruian_katastr SET nazev = 'Blatno u Podbořan' WHERE kod = 605433;
UPDATE ruian_katastr SET nazev = 'Malměřice' WHERE kod = 605441;
UPDATE ruian_katastr SET nazev = 'Blazice' WHERE kod = 605450;
UPDATE ruian_katastr SET nazev = 'Blažejov' WHERE kod = 605468;
UPDATE ruian_katastr SET nazev = 'Dvoreček' WHERE kod = 605476;
UPDATE ruian_katastr SET nazev = 'Malý Ratmírov' WHERE kod = 605484;
UPDATE ruian_katastr SET nazev = 'Mutyněves' WHERE kod = 605492;
UPDATE ruian_katastr SET nazev = 'Oldřiš u Blažejova' WHERE kod = 605506;
UPDATE ruian_katastr SET nazev = 'Blažejovice' WHERE kod = 605514;
UPDATE ruian_katastr SET nazev = 'Vítonice u Blažejovic' WHERE kod = 605522;
UPDATE ruian_katastr SET nazev = 'Blažim nad Vltavou' WHERE kod = 605531;
UPDATE ruian_katastr SET nazev = 'Blažim' WHERE kod = 605549;
UPDATE ruian_katastr SET nazev = 'Blažkov' WHERE kod = 605557;
UPDATE ruian_katastr SET nazev = 'Dolní Rozsíčka' WHERE kod = 605565;
UPDATE ruian_katastr SET nazev = 'Blažovice' WHERE kod = 605573;
UPDATE ruian_katastr SET nazev = 'Blešno' WHERE kod = 605581;
UPDATE ruian_katastr SET nazev = 'Blevice' WHERE kod = 605590;
UPDATE ruian_katastr SET nazev = 'Blízkov' WHERE kod = 605603;
UPDATE ruian_katastr SET nazev = 'Dědkov' WHERE kod = 605611;
UPDATE ruian_katastr SET nazev = 'Blížejov' WHERE kod = 605620;
UPDATE ruian_katastr SET nazev = 'Chotiměř u Blížejova' WHERE kod = 605646;
UPDATE ruian_katastr SET nazev = 'Přívozec' WHERE kod = 605654;
UPDATE ruian_katastr SET nazev = 'Blíževedly' WHERE kod = 605662;
UPDATE ruian_katastr SET nazev = 'Hvězda pod Vlhoštěm' WHERE kod = 605671;
UPDATE ruian_katastr SET nazev = 'Ves Blížkovice' WHERE kod = 605689;
UPDATE ruian_katastr SET nazev = 'Městys Blížkovice' WHERE kod = 605697;
UPDATE ruian_katastr SET nazev = 'Blovice' WHERE kod = 605735;
UPDATE ruian_katastr SET nazev = 'Hradiště u Blovic' WHERE kod = 605751;
UPDATE ruian_katastr SET nazev = 'Blšany' WHERE kod = 605786;
UPDATE ruian_katastr SET nazev = 'Stachov u Blšan' WHERE kod = 605794;
UPDATE ruian_katastr SET nazev = 'Blučina' WHERE kod = 605808;
UPDATE ruian_katastr SET nazev = 'Bludov' WHERE kod = 605816;
UPDATE ruian_katastr SET nazev = 'Bludovice u Nového Jičína' WHERE kod = 605832;
UPDATE ruian_katastr SET nazev = 'Bobnice' WHERE kod = 605841;
UPDATE ruian_katastr SET nazev = 'Dolní Bobrová' WHERE kod = 605859;
UPDATE ruian_katastr SET nazev = 'Horní Bobrová' WHERE kod = 605867;
UPDATE ruian_katastr SET nazev = 'Bobrovníky' WHERE kod = 605875;
UPDATE ruian_katastr SET nazev = 'Bobrůvka' WHERE kod = 605883;
UPDATE ruian_katastr SET nazev = 'Boč' WHERE kod = 605891;
UPDATE ruian_katastr SET nazev = 'Smilov nad Ohří' WHERE kod = 605905;
UPDATE ruian_katastr SET nazev = 'Srní u Boče' WHERE kod = 605913;
UPDATE ruian_katastr SET nazev = 'Malý Hrzín' WHERE kod = 605921;
UPDATE ruian_katastr SET nazev = 'Boháňka' WHERE kod = 605930;
UPDATE ruian_katastr SET nazev = 'Chloumek u Hořic' WHERE kod = 605948;
UPDATE ruian_katastr SET nazev = 'Votuz' WHERE kod = 605964;
UPDATE ruian_katastr SET nazev = 'Boharyně' WHERE kod = 605972;
UPDATE ruian_katastr SET nazev = 'Puchlovice' WHERE kod = 605999;
UPDATE ruian_katastr SET nazev = 'Bohaté Málkovice' WHERE kod = 606006;
UPDATE ruian_katastr SET nazev = 'Bohatice u Zákup' WHERE kod = 606014;
UPDATE ruian_katastr SET nazev = 'Bohdalec' WHERE kod = 606022;
UPDATE ruian_katastr SET nazev = 'Bohdalice' WHERE kod = 606031;
UPDATE ruian_katastr SET nazev = 'Pavlovice' WHERE kod = 606057;
UPDATE ruian_katastr SET nazev = 'Bohdalín' WHERE kod = 606065;
UPDATE ruian_katastr SET nazev = 'Bohdalov u Městečka Trnávky' WHERE kod = 606073;
UPDATE ruian_katastr SET nazev = 'Bohdalov' WHERE kod = 606081;
UPDATE ruian_katastr SET nazev = 'Chroustov u Bohdalova' WHERE kod = 606090;
UPDATE ruian_katastr SET nazev = 'Bohdaneč u Zbraslavic' WHERE kod = 606103;
UPDATE ruian_katastr SET nazev = 'Dvorecko' WHERE kod = 606111;
UPDATE ruian_katastr SET nazev = 'Kotoučov' WHERE kod = 606120;
UPDATE ruian_katastr SET nazev = 'Prostřední Ves' WHERE kod = 606146;
UPDATE ruian_katastr SET nazev = 'Řeplice' WHERE kod = 606154;
UPDATE ruian_katastr SET nazev = 'Lázně Bohdaneč' WHERE kod = 606171;
UPDATE ruian_katastr SET nazev = 'Bohdanovice' WHERE kod = 606189;
UPDATE ruian_katastr SET nazev = 'Bohdašín v Orlických horách' WHERE kod = 606197;
UPDATE ruian_katastr SET nazev = 'Dolní Bohdíkov' WHERE kod = 606227;
UPDATE ruian_katastr SET nazev = 'Raškov Dvůr' WHERE kod = 606235;
UPDATE ruian_katastr SET nazev = 'Komňátka' WHERE kod = 606243;
UPDATE ruian_katastr SET nazev = 'Raškov Ves' WHERE kod = 606251;
UPDATE ruian_katastr SET nazev = 'Bohostice' WHERE kod = 606260;
UPDATE ruian_katastr SET nazev = 'Kamenná u Bohostic' WHERE kod = 606278;
UPDATE ruian_katastr SET nazev = 'Zbenické Zlákovice' WHERE kod = 606286;
UPDATE ruian_katastr SET nazev = 'Bohouňovice I' WHERE kod = 606294;
UPDATE ruian_katastr SET nazev = 'Bořetice u Kolína' WHERE kod = 606308;
UPDATE ruian_katastr SET nazev = 'Opatovice' WHERE kod = 606316;
UPDATE ruian_katastr SET nazev = 'Bohousová' WHERE kod = 606324;
UPDATE ruian_katastr SET nazev = 'Bohučovice' WHERE kod = 606332;
UPDATE ruian_katastr SET nazev = 'Bohumileč' WHERE kod = 606359;
UPDATE ruian_katastr SET nazev = 'Bohumilice v Čechách' WHERE kod = 606375;
UPDATE ruian_katastr SET nazev = 'Bohumilice' WHERE kod = 606383;
UPDATE ruian_katastr SET nazev = 'Bohuňov nad Křetínkou' WHERE kod = 606391;
UPDATE ruian_katastr SET nazev = 'Bohuňov' WHERE kod = 606405;
UPDATE ruian_katastr SET nazev = 'Janovičky u Bohuňova' WHERE kod = 606413;
UPDATE ruian_katastr SET nazev = 'Bohuňovice u Litomyšle' WHERE kod = 606421;
UPDATE ruian_katastr SET nazev = 'Bohuňovice' WHERE kod = 606430;
UPDATE ruian_katastr SET nazev = 'Moravská Loděnice' WHERE kod = 606448;
UPDATE ruian_katastr SET nazev = 'Trusovice' WHERE kod = 606456;
UPDATE ruian_katastr SET nazev = 'Bohuslavice nad Metují' WHERE kod = 606464;
UPDATE ruian_katastr SET nazev = 'Bohuslavice' WHERE kod = 606481;
UPDATE ruian_katastr SET nazev = 'Bohuslavice u Konice' WHERE kod = 606499;
UPDATE ruian_katastr SET nazev = 'Hačky' WHERE kod = 606502;
UPDATE ruian_katastr SET nazev = 'Polomí' WHERE kod = 606511;
UPDATE ruian_katastr SET nazev = 'Bohuslavice u Hlučína' WHERE kod = 606529;
UPDATE ruian_katastr SET nazev = 'Bohuslavice nad Moravou' WHERE kod = 606537;
UPDATE ruian_katastr SET nazev = 'Bohuslavice nad Úpou' WHERE kod = 606553;
UPDATE ruian_katastr SET nazev = 'Bohuslavice nad Vláří' WHERE kod = 606561;
UPDATE ruian_katastr SET nazev = 'Bohuslavice u Zlína' WHERE kod = 606570;
UPDATE ruian_katastr SET nazev = 'Bohuslavice u Kyjova' WHERE kod = 606588;
UPDATE ruian_katastr SET nazev = 'Bohuslávky' WHERE kod = 606596;
UPDATE ruian_katastr SET nazev = 'Bohušice' WHERE kod = 606600;
UPDATE ruian_katastr SET nazev = 'Bohušov' WHERE kod = 606618;
UPDATE ruian_katastr SET nazev = 'Karlov u Bohušova' WHERE kod = 606626;
UPDATE ruian_katastr SET nazev = 'Kašnice u Bohušova' WHERE kod = 606642;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Bohušova' WHERE kod = 606651;
UPDATE ruian_katastr SET nazev = 'Bohušovice nad Ohří' WHERE kod = 606669;
UPDATE ruian_katastr SET nazev = 'Bohutice' WHERE kod = 606677;
UPDATE ruian_katastr SET nazev = 'Bohutín' WHERE kod = 606685;
UPDATE ruian_katastr SET nazev = 'Tisová u Bohutína' WHERE kod = 606693;
UPDATE ruian_katastr SET nazev = 'Vysoká Pec u Bohutína' WHERE kod = 606707;
UPDATE ruian_katastr SET nazev = 'Bohutín nad Moravou' WHERE kod = 606715;
UPDATE ruian_katastr SET nazev = 'Bochoř' WHERE kod = 606723;
UPDATE ruian_katastr SET nazev = 'Věžky u Přerova' WHERE kod = 606740;
UPDATE ruian_katastr SET nazev = 'Bochov' WHERE kod = 606758;
UPDATE ruian_katastr SET nazev = 'Sovolusky u Bochova' WHERE kod = 606774;
UPDATE ruian_katastr SET nazev = 'Teleč' WHERE kod = 606782;
UPDATE ruian_katastr SET nazev = 'Těšetice u Bochova' WHERE kod = 606791;
UPDATE ruian_katastr SET nazev = 'Jesínky' WHERE kod = 606804;
UPDATE ruian_katastr SET nazev = 'Batouchovice' WHERE kod = 606812;
UPDATE ruian_katastr SET nazev = 'Bochovice' WHERE kod = 606821;
UPDATE ruian_katastr SET nazev = 'Bojanov' WHERE kod = 606839;
UPDATE ruian_katastr SET nazev = 'Horní Bezděkov u Bojanova' WHERE kod = 606847;
UPDATE ruian_katastr SET nazev = 'Bojanovice' WHERE kod = 606863;
UPDATE ruian_katastr SET nazev = 'Bojanovice u Znojma' WHERE kod = 606880;
UPDATE ruian_katastr SET nazev = 'Boješice' WHERE kod = 606898;
UPDATE ruian_katastr SET nazev = 'Ohař' WHERE kod = 606901;
UPDATE ruian_katastr SET nazev = 'Bojetice' WHERE kod = 606928;
UPDATE ruian_katastr SET nazev = 'Bojiště' WHERE kod = 606936;
UPDATE ruian_katastr SET nazev = 'Kouty u Bojiště' WHERE kod = 606944;
UPDATE ruian_katastr SET nazev = 'Mstislavice' WHERE kod = 606952;
UPDATE ruian_katastr SET nazev = 'Veliká' WHERE kod = 606961;
UPDATE ruian_katastr SET nazev = 'Bojkovice' WHERE kod = 606979;
UPDATE ruian_katastr SET nazev = 'Bolatice' WHERE kod = 606987;
UPDATE ruian_katastr SET nazev = 'Boleboř' WHERE kod = 607002;
UPDATE ruian_katastr SET nazev = 'Orasín' WHERE kod = 607011;
UPDATE ruian_katastr SET nazev = 'Pyšná' WHERE kod = 607029;
UPDATE ruian_katastr SET nazev = 'Svahová' WHERE kod = 607037;
UPDATE ruian_katastr SET nazev = 'Bolehošť' WHERE kod = 607045;
UPDATE ruian_katastr SET nazev = 'Bolechov' WHERE kod = 607061;
UPDATE ruian_katastr SET nazev = 'Poříčí u Bolechova' WHERE kod = 607070;
UPDATE ruian_katastr SET nazev = 'Boleradice' WHERE kod = 607118;
UPDATE ruian_katastr SET nazev = 'Bolešiny' WHERE kod = 607126;
UPDATE ruian_katastr SET nazev = 'Ostřetice' WHERE kod = 607134;
UPDATE ruian_katastr SET nazev = 'Slavošovice u Klatov' WHERE kod = 607142;
UPDATE ruian_katastr SET nazev = 'Boletice' WHERE kod = 607151;
UPDATE ruian_katastr SET nazev = 'Boletice nad Labem' WHERE kod = 607169;
UPDATE ruian_katastr SET nazev = 'Křešice u Děčína' WHERE kod = 607185;
UPDATE ruian_katastr SET nazev = 'Nebočady' WHERE kod = 607193;
UPDATE ruian_katastr SET nazev = 'Bolina' WHERE kod = 607207;
UPDATE ruian_katastr SET nazev = 'Bonkovice' WHERE kod = 607223;
UPDATE ruian_katastr SET nazev = 'Boňov' WHERE kod = 607231;
UPDATE ruian_katastr SET nazev = 'Bor u Březnice' WHERE kod = 607240;
UPDATE ruian_katastr SET nazev = 'Bor' WHERE kod = 607266;
UPDATE ruian_katastr SET nazev = 'Bor u Karlových Var' WHERE kod = 607274;
UPDATE ruian_katastr SET nazev = 'Stráň' WHERE kod = 607282;
UPDATE ruian_katastr SET nazev = 'Boječnice' WHERE kod = 607291;
UPDATE ruian_katastr SET nazev = 'Bor u Tachova' WHERE kod = 607304;
UPDATE ruian_katastr SET nazev = 'Borovany u Boru' WHERE kod = 607312;
UPDATE ruian_katastr SET nazev = 'Čečkovice' WHERE kod = 607321;
UPDATE ruian_katastr SET nazev = 'Doly u Boru' WHERE kod = 607339;
UPDATE ruian_katastr SET nazev = 'Kosov u Boru' WHERE kod = 607347;
UPDATE ruian_katastr SET nazev = 'Lužná u Boru' WHERE kod = 607355;
UPDATE ruian_katastr SET nazev = 'Skviřín' WHERE kod = 607380;
UPDATE ruian_katastr SET nazev = 'Vysočany u Boru' WHERE kod = 607398;
UPDATE ruian_katastr SET nazev = 'Bor u Skutče' WHERE kod = 607410;
UPDATE ruian_katastr SET nazev = 'Borač' WHERE kod = 607428;
UPDATE ruian_katastr SET nazev = 'Podolí u Borače' WHERE kod = 607436;
UPDATE ruian_katastr SET nazev = 'Bordovice' WHERE kod = 607444;
UPDATE ruian_katastr SET nazev = 'Boreč' WHERE kod = 607461;
UPDATE ruian_katastr SET nazev = 'Boreč u Lovosic' WHERE kod = 607495;
UPDATE ruian_katastr SET nazev = 'Borek nad Labem' WHERE kod = 607517;
UPDATE ruian_katastr SET nazev = 'Borek u Českých Budějovic' WHERE kod = 607525;
UPDATE ruian_katastr SET nazev = 'Borek u Dačic' WHERE kod = 607533;
UPDATE ruian_katastr SET nazev = 'Borek u Chotěboře' WHERE kod = 607541;
UPDATE ruian_katastr SET nazev = 'Ostružno' WHERE kod = 607550;
UPDATE ruian_katastr SET nazev = 'Borek u Miletína' WHERE kod = 607568;
UPDATE ruian_katastr SET nazev = 'Želejov' WHERE kod = 607576;
UPDATE ruian_katastr SET nazev = 'Borek' WHERE kod = 607584;
UPDATE ruian_katastr SET nazev = 'Borkovany' WHERE kod = 607592;
UPDATE ruian_katastr SET nazev = 'Borkovice' WHERE kod = 607606;
UPDATE ruian_katastr SET nazev = 'Borohrádek' WHERE kod = 607614;
UPDATE ruian_katastr SET nazev = 'Šachov u Borohrádku' WHERE kod = 607622;
UPDATE ruian_katastr SET nazev = 'Borotice' WHERE kod = 607631;
UPDATE ruian_katastr SET nazev = 'Hubenov u Borotic' WHERE kod = 607649;
UPDATE ruian_katastr SET nazev = 'Borotice nad Jevišovkou' WHERE kod = 607657;
UPDATE ruian_katastr SET nazev = 'Borotín u Tábora' WHERE kod = 607665;
UPDATE ruian_katastr SET nazev = 'Kamenná Lhota u Borotína' WHERE kod = 607681;
UPDATE ruian_katastr SET nazev = 'Pikov' WHERE kod = 607690;
UPDATE ruian_katastr SET nazev = 'Borotín u Boskovic' WHERE kod = 607703;
UPDATE ruian_katastr SET nazev = 'Borová' WHERE kod = 607711;
UPDATE ruian_katastr SET nazev = 'Borová u Poličky' WHERE kod = 607720;
UPDATE ruian_katastr SET nazev = 'Borovany' WHERE kod = 607746;
UPDATE ruian_katastr SET nazev = 'Hluboká u Borovan' WHERE kod = 607754;
UPDATE ruian_katastr SET nazev = 'Vrcov' WHERE kod = 607771;
UPDATE ruian_katastr SET nazev = 'Borovany u Milevska' WHERE kod = 607789;
UPDATE ruian_katastr SET nazev = 'Borovná' WHERE kod = 607797;
UPDATE ruian_katastr SET nazev = 'Borovnice' WHERE kod = 607801;
UPDATE ruian_katastr SET nazev = 'Borovnice u Potštejna' WHERE kod = 607819;
UPDATE ruian_katastr SET nazev = 'Rájec' WHERE kod = 607843;
UPDATE ruian_katastr SET nazev = 'Borovnice u Staré Paky' WHERE kod = 607851;
UPDATE ruian_katastr SET nazev = 'Borovnička' WHERE kod = 607860;
UPDATE ruian_katastr SET nazev = 'Borovnice u Jimramova' WHERE kod = 607886;
UPDATE ruian_katastr SET nazev = 'Borovník' WHERE kod = 607894;
UPDATE ruian_katastr SET nazev = 'Borovno' WHERE kod = 607908;
UPDATE ruian_katastr SET nazev = 'Míšov' WHERE kod = 607924;
UPDATE ruian_katastr SET nazev = 'Borovsko' WHERE kod = 607932;
UPDATE ruian_katastr SET nazev = 'Borovy' WHERE kod = 607941;
UPDATE ruian_katastr SET nazev = 'Nezdice nad Úhlavou' WHERE kod = 607959;
UPDATE ruian_katastr SET nazev = 'Vřeskovice' WHERE kod = 607967;
UPDATE ruian_katastr SET nazev = 'Boršice u Blatnice' WHERE kod = 607975;
UPDATE ruian_katastr SET nazev = 'Boršice u Buchlovic' WHERE kod = 607983;
UPDATE ruian_katastr SET nazev = 'Boršov u Moravské Třebové' WHERE kod = 607991;
UPDATE ruian_katastr SET nazev = 'Boršov' WHERE kod = 608009;
UPDATE ruian_katastr SET nazev = 'Boršov nad Vltavou' WHERE kod = 608025;
UPDATE ruian_katastr SET nazev = 'Borušov' WHERE kod = 608041;
UPDATE ruian_katastr SET nazev = 'Prklišov' WHERE kod = 608050;
UPDATE ruian_katastr SET nazev = 'Svojanov u Borušova' WHERE kod = 608068;
UPDATE ruian_katastr SET nazev = 'Bořanovice' WHERE kod = 608076;
UPDATE ruian_katastr SET nazev = 'Bořeňovice' WHERE kod = 608084;
UPDATE ruian_katastr SET nazev = 'Býkovice u Bořeňovic' WHERE kod = 608092;
UPDATE ruian_katastr SET nazev = 'Jezero' WHERE kod = 608106;
UPDATE ruian_katastr SET nazev = 'Střížkov u Bořeňovic' WHERE kod = 608114;
UPDATE ruian_katastr SET nazev = 'Bořenovice' WHERE kod = 608131;
UPDATE ruian_katastr SET nazev = 'Bořetice' WHERE kod = 608149;
UPDATE ruian_katastr SET nazev = 'Bořetice u Hustopečí' WHERE kod = 608157;
UPDATE ruian_katastr SET nazev = 'Bořetín u Strmilova' WHERE kod = 608165;
UPDATE ruian_katastr SET nazev = 'Bořetín' WHERE kod = 608173;
UPDATE ruian_katastr SET nazev = 'Bořice u Domažlic' WHERE kod = 608181;
UPDATE ruian_katastr SET nazev = 'Bořice u Hrochova Týnce' WHERE kod = 608190;
UPDATE ruian_katastr SET nazev = 'Bernartice u Boříkov' WHERE kod = 608211;
UPDATE ruian_katastr SET nazev = 'Boříkovy' WHERE kod = 608220;
UPDATE ruian_katastr SET nazev = 'Hradiště u Boříkov' WHERE kod = 608238;
UPDATE ruian_katastr SET nazev = 'Bílka' WHERE kod = 608246;
UPDATE ruian_katastr SET nazev = 'Bořislav' WHERE kod = 608254;
UPDATE ruian_katastr SET nazev = 'Bořitov' WHERE kod = 608262;
UPDATE ruian_katastr SET nazev = 'Boseň' WHERE kod = 608271;
UPDATE ruian_katastr SET nazev = 'Lhotice u Bosně' WHERE kod = 608297;
UPDATE ruian_katastr SET nazev = 'Mužský' WHERE kod = 608301;
UPDATE ruian_katastr SET nazev = 'Boskovice' WHERE kod = 608327;
UPDATE ruian_katastr SET nazev = 'Hrádkov' WHERE kod = 608475;
UPDATE ruian_katastr SET nazev = 'Mladkov u Boskovic' WHERE kod = 608483;
UPDATE ruian_katastr SET nazev = 'Boskovštejn' WHERE kod = 608491;
UPDATE ruian_katastr SET nazev = 'Bosonohy' WHERE kod = 608505;
UPDATE ruian_katastr SET nazev = 'Bošice' WHERE kod = 608513;
UPDATE ruian_katastr SET nazev = 'Budilov' WHERE kod = 608530;
UPDATE ruian_katastr SET nazev = 'Hradčany u Čkyně' WHERE kod = 608548;
UPDATE ruian_katastr SET nazev = 'Bošilec' WHERE kod = 608572;
UPDATE ruian_katastr SET nazev = 'Boškov' WHERE kod = 608581;
UPDATE ruian_katastr SET nazev = 'Bošovice' WHERE kod = 608599;
UPDATE ruian_katastr SET nazev = 'Bořanovice u Vimperka' WHERE kod = 608602;
UPDATE ruian_katastr SET nazev = 'Boubská' WHERE kod = 608611;
UPDATE ruian_katastr SET nazev = 'Pravětín' WHERE kod = 608629;
UPDATE ruian_katastr SET nazev = 'Veselka u Vimperka' WHERE kod = 608637;
UPDATE ruian_katastr SET nazev = 'Bousín' WHERE kod = 608645;
UPDATE ruian_katastr SET nazev = 'Repechy' WHERE kod = 608653;
UPDATE ruian_katastr SET nazev = 'Bousov' WHERE kod = 608661;
UPDATE ruian_katastr SET nazev = 'Bezděkov nad Třebůvkou' WHERE kod = 608688;
UPDATE ruian_katastr SET nazev = 'Bouzov' WHERE kod = 608696;
UPDATE ruian_katastr SET nazev = 'Doly u Bouzova' WHERE kod = 608700;
UPDATE ruian_katastr SET nazev = 'Hvozdečko' WHERE kod = 608718;
UPDATE ruian_katastr SET nazev = 'Jeřmaň' WHERE kod = 608726;
UPDATE ruian_katastr SET nazev = 'Bozkov' WHERE kod = 608742;
UPDATE ruian_katastr SET nazev = 'Božanov' WHERE kod = 608769;
UPDATE ruian_katastr SET nazev = 'Božejov' WHERE kod = 608777;
UPDATE ruian_katastr SET nazev = 'Božejovice' WHERE kod = 608793;
UPDATE ruian_katastr SET nazev = 'Drahnětice' WHERE kod = 608815;
UPDATE ruian_katastr SET nazev = 'Svoříž' WHERE kod = 608831;
UPDATE ruian_katastr SET nazev = 'Božetice' WHERE kod = 608840;
UPDATE ruian_katastr SET nazev = 'Radihošť' WHERE kod = 608858;
UPDATE ruian_katastr SET nazev = 'Boží Dar' WHERE kod = 608866;
UPDATE ruian_katastr SET nazev = 'Ryžovna' WHERE kod = 608874;
UPDATE ruian_katastr SET nazev = 'Božice' WHERE kod = 608882;
UPDATE ruian_katastr SET nazev = 'České Křídlovice' WHERE kod = 608904;
UPDATE ruian_katastr SET nazev = 'Božičany' WHERE kod = 608939;
UPDATE ruian_katastr SET nazev = 'Jimlíkov' WHERE kod = 608947;
UPDATE ruian_katastr SET nazev = 'Božtěšice' WHERE kod = 608955;
UPDATE ruian_katastr SET nazev = 'Bradáčov' WHERE kod = 608963;
UPDATE ruian_katastr SET nazev = 'Horní Světlá u Bradáčova' WHERE kod = 608971;
UPDATE ruian_katastr SET nazev = 'Bradlec' WHERE kod = 608980;
UPDATE ruian_katastr SET nazev = 'Bradlecká Lhota' WHERE kod = 608998;
UPDATE ruian_katastr SET nazev = 'Braňany' WHERE kod = 609005;
UPDATE ruian_katastr SET nazev = 'Kaňkov' WHERE kod = 609013;
UPDATE ruian_katastr SET nazev = 'Brandlín' WHERE kod = 609021;
UPDATE ruian_katastr SET nazev = 'Brandov' WHERE kod = 609030;
UPDATE ruian_katastr SET nazev = 'Brandýs nad Labem' WHERE kod = 609048;
UPDATE ruian_katastr SET nazev = 'Stará Boleslav' WHERE kod = 609170;
UPDATE ruian_katastr SET nazev = 'Zápy' WHERE kod = 609226;
UPDATE ruian_katastr SET nazev = 'Ostrov u Brandýsa nad Labem' WHERE kod = 609234;
UPDATE ruian_katastr SET nazev = 'Popovice u Brandýsa nad Labem' WHERE kod = 609251;
UPDATE ruian_katastr SET nazev = 'Stránka u Brandýsa nad Labem' WHERE kod = 609269;
UPDATE ruian_katastr SET nazev = 'Brandýs nad Orlicí' WHERE kod = 609277;
UPDATE ruian_katastr SET nazev = 'Brandýsek' WHERE kod = 609285;
UPDATE ruian_katastr SET nazev = 'Branice' WHERE kod = 609307;
UPDATE ruian_katastr SET nazev = 'Křižanov u Branic' WHERE kod = 609315;
UPDATE ruian_katastr SET nazev = 'Okrouhlá u Branic' WHERE kod = 609323;
UPDATE ruian_katastr SET nazev = 'Stehlovice' WHERE kod = 609331;
UPDATE ruian_katastr SET nazev = 'Braníškov' WHERE kod = 609340;
UPDATE ruian_katastr SET nazev = 'Branišov pod Křemešníkem' WHERE kod = 609358;
UPDATE ruian_katastr SET nazev = 'Branišov u Jihlavy' WHERE kod = 609366;
UPDATE ruian_katastr SET nazev = 'Branišovice' WHERE kod = 609374;
UPDATE ruian_katastr SET nazev = 'Branka u Opavy' WHERE kod = 609382;
UPDATE ruian_katastr SET nazev = 'Brankovice' WHERE kod = 609391;
UPDATE ruian_katastr SET nazev = 'Branky' WHERE kod = 609404;
UPDATE ruian_katastr SET nazev = 'Branná' WHERE kod = 609421;
UPDATE ruian_katastr SET nazev = 'Branná u Šumperka' WHERE kod = 609447;
UPDATE ruian_katastr SET nazev = 'Branov' WHERE kod = 609455;
UPDATE ruian_katastr SET nazev = 'Bransouze' WHERE kod = 609471;
UPDATE ruian_katastr SET nazev = 'Brantice' WHERE kod = 609480;
UPDATE ruian_katastr SET nazev = 'Radim u Brantic' WHERE kod = 609498;
UPDATE ruian_katastr SET nazev = 'Branžež' WHERE kod = 609501;
UPDATE ruian_katastr SET nazev = 'Srbsko' WHERE kod = 609528;
UPDATE ruian_katastr SET nazev = 'Braškov' WHERE kod = 609536;
UPDATE ruian_katastr SET nazev = 'Bratčice' WHERE kod = 609561;
UPDATE ruian_katastr SET nazev = 'Bratkovice u Velvar' WHERE kod = 609579;
UPDATE ruian_katastr SET nazev = 'Nabdín' WHERE kod = 609587;
UPDATE ruian_katastr SET nazev = 'Bratkovice' WHERE kod = 609595;
UPDATE ruian_katastr SET nazev = 'Dominikální Paseky' WHERE kod = 609609;
UPDATE ruian_katastr SET nazev = 'Bratronice u Kladna' WHERE kod = 609617;
UPDATE ruian_katastr SET nazev = 'Bratronice u Luštěnic' WHERE kod = 609625;
UPDATE ruian_katastr SET nazev = 'Bratrouchov' WHERE kod = 609633;
UPDATE ruian_katastr SET nazev = 'Bratrušov' WHERE kod = 609650;
UPDATE ruian_katastr SET nazev = 'Osikov' WHERE kod = 609668;
UPDATE ruian_katastr SET nazev = 'Bratřejov u Vizovic' WHERE kod = 609676;
UPDATE ruian_katastr SET nazev = 'Bratřice' WHERE kod = 609692;
UPDATE ruian_katastr SET nazev = 'Bratříkovice' WHERE kod = 609714;
UPDATE ruian_katastr SET nazev = 'Bratřínov' WHERE kod = 609722;
UPDATE ruian_katastr SET nazev = 'Bravantice' WHERE kod = 609731;
UPDATE ruian_katastr SET nazev = 'Bravinné' WHERE kod = 609749;
UPDATE ruian_katastr SET nazev = 'Brázdim' WHERE kod = 609773;
UPDATE ruian_katastr SET nazev = 'Brdo' WHERE kod = 609790;
UPDATE ruian_katastr SET nazev = 'Krsmol' WHERE kod = 609803;
UPDATE ruian_katastr SET nazev = 'Brenná' WHERE kod = 609820;
UPDATE ruian_katastr SET nazev = 'Veselí nad Ploučnicí' WHERE kod = 609838;
UPDATE ruian_katastr SET nazev = 'Brloh pod Kletí' WHERE kod = 609846;
UPDATE ruian_katastr SET nazev = 'Janské Údolí-Kovářov' WHERE kod = 609854;
UPDATE ruian_katastr SET nazev = 'Jaronín-Kuklov' WHERE kod = 609862;
UPDATE ruian_katastr SET nazev = 'Benešovice u Přelouče' WHERE kod = 609871;
UPDATE ruian_katastr SET nazev = 'Brloh u Přelouče' WHERE kod = 609889;
UPDATE ruian_katastr SET nazev = 'Brná' WHERE kod = 609897;
UPDATE ruian_katastr SET nazev = 'Brná nad Labem' WHERE kod = 609901;
UPDATE ruian_katastr SET nazev = 'Brňany' WHERE kod = 609919;
UPDATE ruian_katastr SET nazev = 'Brněnec' WHERE kod = 609927;
UPDATE ruian_katastr SET nazev = 'Brníčko u Zábřeha' WHERE kod = 609935;
UPDATE ruian_katastr SET nazev = 'Brnířov' WHERE kod = 609951;
UPDATE ruian_katastr SET nazev = 'Podzámčí' WHERE kod = 609960;
UPDATE ruian_katastr SET nazev = 'Brniště' WHERE kod = 609978;
UPDATE ruian_katastr SET nazev = 'Hlemýždí' WHERE kod = 609986;
UPDATE ruian_katastr SET nazev = 'Město Brno' WHERE kod = 610003;
UPDATE ruian_katastr SET nazev = 'Staré Brno' WHERE kod = 610089;
UPDATE ruian_katastr SET nazev = 'Štýřice' WHERE kod = 610186;
UPDATE ruian_katastr SET nazev = 'Pisárky' WHERE kod = 610208;
UPDATE ruian_katastr SET nazev = 'Nový Lískovec' WHERE kod = 610283;
UPDATE ruian_katastr SET nazev = 'Kohoutovice' WHERE kod = 610313;
UPDATE ruian_katastr SET nazev = 'Stránice' WHERE kod = 610330;
UPDATE ruian_katastr SET nazev = 'Veveří' WHERE kod = 610372;
UPDATE ruian_katastr SET nazev = 'Žabovřesky' WHERE kod = 610470;
UPDATE ruian_katastr SET nazev = 'Jundrov' WHERE kod = 610542;
UPDATE ruian_katastr SET nazev = 'Komín' WHERE kod = 610585;
UPDATE ruian_katastr SET nazev = 'Zábrdovice' WHERE kod = 610704;
UPDATE ruian_katastr SET nazev = 'Černá Pole' WHERE kod = 610771;
UPDATE ruian_katastr SET nazev = 'Husovice' WHERE kod = 610844;
UPDATE ruian_katastr SET nazev = 'Lesná' WHERE kod = 610887;
UPDATE ruian_katastr SET nazev = 'Trnitá' WHERE kod = 610950;
UPDATE ruian_katastr SET nazev = 'Komárov' WHERE kod = 611026;
UPDATE ruian_katastr SET nazev = 'Židenice' WHERE kod = 611115;
UPDATE ruian_katastr SET nazev = 'Černovice' WHERE kod = 611263;
UPDATE ruian_katastr SET nazev = 'Ponava' WHERE kod = 611379;
UPDATE ruian_katastr SET nazev = 'Královo Pole' WHERE kod = 611484;
UPDATE ruian_katastr SET nazev = 'Sadová' WHERE kod = 611565;
UPDATE ruian_katastr SET nazev = 'Řečkovice' WHERE kod = 611646;
UPDATE ruian_katastr SET nazev = 'Mokrá Hora' WHERE kod = 611701;
UPDATE ruian_katastr SET nazev = 'Medlánky' WHERE kod = 611743;
UPDATE ruian_katastr SET nazev = 'Bystrc' WHERE kod = 611778;
UPDATE ruian_katastr SET nazev = 'Kníničky' WHERE kod = 611905;
UPDATE ruian_katastr SET nazev = 'Bohunice' WHERE kod = 612006;
UPDATE ruian_katastr SET nazev = 'Starý Lískovec' WHERE kod = 612014;
UPDATE ruian_katastr SET nazev = 'Horní Heršpice' WHERE kod = 612065;
UPDATE ruian_katastr SET nazev = 'Dolní Heršpice' WHERE kod = 612111;
UPDATE ruian_katastr SET nazev = 'Přízřenice' WHERE kod = 612146;
UPDATE ruian_katastr SET nazev = 'Tuřany' WHERE kod = 612171;
UPDATE ruian_katastr SET nazev = 'Brněnské Ivanovice' WHERE kod = 612227;
UPDATE ruian_katastr SET nazev = 'Holásky' WHERE kod = 612243;
UPDATE ruian_katastr SET nazev = 'Slatina' WHERE kod = 612286;
UPDATE ruian_katastr SET nazev = 'Líšeň' WHERE kod = 612405;
UPDATE ruian_katastr SET nazev = 'Maloměřice' WHERE kod = 612499;
UPDATE ruian_katastr SET nazev = 'Obřany' WHERE kod = 612553;
UPDATE ruian_katastr SET nazev = 'Brocná' WHERE kod = 612600;
UPDATE ruian_katastr SET nazev = 'Svinná u Brocné' WHERE kod = 612626;
UPDATE ruian_katastr SET nazev = 'Brod u Příbramě' WHERE kod = 612634;
UPDATE ruian_katastr SET nazev = 'Brod nad Dyjí' WHERE kod = 612642;
UPDATE ruian_katastr SET nazev = 'Brod nad Tichou' WHERE kod = 612651;
UPDATE ruian_katastr SET nazev = 'Brod u Stříbra' WHERE kod = 612669;
UPDATE ruian_katastr SET nazev = 'Tuněchody u Stříbra' WHERE kod = 612677;
UPDATE ruian_katastr SET nazev = 'Brodce nad Jizerou' WHERE kod = 612685;
UPDATE ruian_katastr SET nazev = 'Brodec' WHERE kod = 612693;
UPDATE ruian_katastr SET nazev = 'Brodek u Konice' WHERE kod = 612707;
UPDATE ruian_katastr SET nazev = 'Dešná' WHERE kod = 612715;
UPDATE ruian_katastr SET nazev = 'Lhota u Konice' WHERE kod = 612723;
UPDATE ruian_katastr SET nazev = 'Brodek u Prostějova' WHERE kod = 612731;
UPDATE ruian_katastr SET nazev = 'Sněhotice' WHERE kod = 612740;
UPDATE ruian_katastr SET nazev = 'Brodek u Přerova' WHERE kod = 612758;
UPDATE ruian_katastr SET nazev = 'Broumov' WHERE kod = 612766;
UPDATE ruian_katastr SET nazev = 'Velká Ves u Broumova' WHERE kod = 612782;
UPDATE ruian_katastr SET nazev = 'Benešov u Broumova' WHERE kod = 612812;
UPDATE ruian_katastr SET nazev = 'Rožmitál' WHERE kod = 612821;
UPDATE ruian_katastr SET nazev = 'Broumova Lhota' WHERE kod = 612839;
UPDATE ruian_katastr SET nazev = 'Broumovice' WHERE kod = 612847;
UPDATE ruian_katastr SET nazev = 'Broumy' WHERE kod = 612871;
UPDATE ruian_katastr SET nazev = 'Brozany nad Ohří' WHERE kod = 612898;
UPDATE ruian_katastr SET nazev = 'Hostěnice u Brozan' WHERE kod = 612901;
UPDATE ruian_katastr SET nazev = 'Brtec' WHERE kod = 612910;
UPDATE ruian_katastr SET nazev = 'Vratišov' WHERE kod = 612928;
UPDATE ruian_katastr SET nazev = 'Brteč' WHERE kod = 612936;
UPDATE ruian_katastr SET nazev = 'Brtná' WHERE kod = 612944;
UPDATE ruian_katastr SET nazev = 'Brtnice' WHERE kod = 612952;
UPDATE ruian_katastr SET nazev = 'Jestřebí u Brtnice' WHERE kod = 612961;
UPDATE ruian_katastr SET nazev = 'Brtnička' WHERE kod = 612979;
UPDATE ruian_katastr SET nazev = 'Brtníky' WHERE kod = 612987;
UPDATE ruian_katastr SET nazev = 'Kopec' WHERE kod = 612995;
UPDATE ruian_katastr SET nazev = 'Brťov u Černé Hory' WHERE kod = 613002;
UPDATE ruian_katastr SET nazev = 'Jeneč' WHERE kod = 613011;
UPDATE ruian_katastr SET nazev = 'Brťov u Velkých Opatovic' WHERE kod = 613029;
UPDATE ruian_katastr SET nazev = 'Korbelova Lhota' WHERE kod = 613037;
UPDATE ruian_katastr SET nazev = 'Brůdek' WHERE kod = 613045;
UPDATE ruian_katastr SET nazev = 'Brumov u Lomnice' WHERE kod = 613053;
UPDATE ruian_katastr SET nazev = 'Brumov' WHERE kod = 613061;
UPDATE ruian_katastr SET nazev = 'Bylnice' WHERE kod = 613070;
UPDATE ruian_katastr SET nazev = 'Brumovice' WHERE kod = 613096;
UPDATE ruian_katastr SET nazev = 'Brumovice u Opavy' WHERE kod = 613100;
UPDATE ruian_katastr SET nazev = 'Skrochovice' WHERE kod = 613142;
UPDATE ruian_katastr SET nazev = 'Úblo' WHERE kod = 613151;
UPDATE ruian_katastr SET nazev = 'Bruntál-město' WHERE kod = 613169;
UPDATE ruian_katastr SET nazev = 'Oborná' WHERE kod = 613231;
UPDATE ruian_katastr SET nazev = 'Slezský Kočov' WHERE kod = 613291;
UPDATE ruian_katastr SET nazev = 'Moravský Kočov' WHERE kod = 613304;
UPDATE ruian_katastr SET nazev = 'Staré Město u Bruntálu' WHERE kod = 613312;
UPDATE ruian_katastr SET nazev = 'Malá Véska' WHERE kod = 613321;
UPDATE ruian_katastr SET nazev = 'Brusná' WHERE kod = 613339;
UPDATE ruian_katastr SET nazev = 'Řepka' WHERE kod = 613347;
UPDATE ruian_katastr SET nazev = 'Veselí u Lomnice' WHERE kod = 613355;
UPDATE ruian_katastr SET nazev = 'Brusné' WHERE kod = 613363;
UPDATE ruian_katastr SET nazev = 'Brusy' WHERE kod = 613371;
UPDATE ruian_katastr SET nazev = 'Brušperk' WHERE kod = 613380;
UPDATE ruian_katastr SET nazev = 'Bruzovice' WHERE kod = 613398;
UPDATE ruian_katastr SET nazev = 'Brzice' WHERE kod = 613436;
UPDATE ruian_katastr SET nazev = 'Proruby' WHERE kod = 613452;
UPDATE ruian_katastr SET nazev = 'Harcov' WHERE kod = 613479;
UPDATE ruian_katastr SET nazev = 'Brzkov' WHERE kod = 613487;
UPDATE ruian_katastr SET nazev = 'Brzotice' WHERE kod = 613495;
UPDATE ruian_katastr SET nazev = 'Břasy' WHERE kod = 613517;
UPDATE ruian_katastr SET nazev = 'Kříše' WHERE kod = 613533;
UPDATE ruian_katastr SET nazev = 'Stupno' WHERE kod = 613550;
UPDATE ruian_katastr SET nazev = 'Vranovice u Břas' WHERE kod = 613576;
UPDATE ruian_katastr SET nazev = 'Břeclav' WHERE kod = 613584;
UPDATE ruian_katastr SET nazev = 'Břehy' WHERE kod = 613771;
UPDATE ruian_katastr SET nazev = 'Břest' WHERE kod = 613797;
UPDATE ruian_katastr SET nazev = 'Břestek' WHERE kod = 613801;
UPDATE ruian_katastr SET nazev = 'Břešťany u Zlonic' WHERE kod = 613827;
UPDATE ruian_katastr SET nazev = 'Břevenec' WHERE kod = 613835;
UPDATE ruian_katastr SET nazev = 'Břevnice' WHERE kod = 613843;
UPDATE ruian_katastr SET nazev = 'Břevniště pod Ralskem' WHERE kod = 613851;
UPDATE ruian_katastr SET nazev = 'Březejc' WHERE kod = 613860;
UPDATE ruian_katastr SET nazev = 'Březhrad' WHERE kod = 613878;
UPDATE ruian_katastr SET nazev = 'Březí u Říčan' WHERE kod = 613886;
UPDATE ruian_katastr SET nazev = 'Březí u Blatné' WHERE kod = 613894;
UPDATE ruian_katastr SET nazev = 'Březí u Mikulova' WHERE kod = 613908;
UPDATE ruian_katastr SET nazev = 'Březí u Osové Bítýšky' WHERE kod = 613916;
UPDATE ruian_katastr SET nazev = 'Ondrušky' WHERE kod = 613924;
UPDATE ruian_katastr SET nazev = 'Březí nad Oslavou' WHERE kod = 613932;
UPDATE ruian_katastr SET nazev = 'Březí u Týna nad Vltavou' WHERE kod = 613941;
UPDATE ruian_katastr SET nazev = 'Knín' WHERE kod = 613959;
UPDATE ruian_katastr SET nazev = 'Kočín' WHERE kod = 613967;
UPDATE ruian_katastr SET nazev = 'Křtěnov' WHERE kod = 613975;
UPDATE ruian_katastr SET nazev = 'Zvěrkovice u Týna nad Vltavou' WHERE kod = 614009;
UPDATE ruian_katastr SET nazev = 'Březina u Mnichova Hradiště' WHERE kod = 614017;
UPDATE ruian_katastr SET nazev = 'Olšina' WHERE kod = 614041;
UPDATE ruian_katastr SET nazev = 'Březina u Deštné' WHERE kod = 614050;
UPDATE ruian_katastr SET nazev = 'Březina u Rokycan' WHERE kod = 614068;
UPDATE ruian_katastr SET nazev = 'Březina u Moravské Třebové' WHERE kod = 614076;
UPDATE ruian_katastr SET nazev = 'Šnekov' WHERE kod = 614084;
UPDATE ruian_katastr SET nazev = 'Březina u Křtin' WHERE kod = 614092;
UPDATE ruian_katastr SET nazev = 'Proseč u Březiny' WHERE kod = 614106;
UPDATE ruian_katastr SET nazev = 'Březina u Tišnova' WHERE kod = 614114;
UPDATE ruian_katastr SET nazev = 'Stříbrná u Březiny' WHERE kod = 614122;
UPDATE ruian_katastr SET nazev = 'Březiněves' WHERE kod = 614131;
UPDATE ruian_katastr SET nazev = 'Březinka u Kokořína' WHERE kod = 614149;
UPDATE ruian_katastr SET nazev = 'Šemanovice' WHERE kod = 614157;
UPDATE ruian_katastr SET nazev = 'Truskavna' WHERE kod = 614165;
UPDATE ruian_katastr SET nazev = 'Březinka pod Bezdězem' WHERE kod = 614173;
UPDATE ruian_katastr SET nazev = 'Březinky' WHERE kod = 614181;
UPDATE ruian_katastr SET nazev = 'Březiny u Děčína' WHERE kod = 614190;
UPDATE ruian_katastr SET nazev = 'Chlum u Děčína' WHERE kod = 614203;
UPDATE ruian_katastr SET nazev = 'Folknáře' WHERE kod = 614211;
UPDATE ruian_katastr SET nazev = 'Březiny u Poličky' WHERE kod = 614238;
UPDATE ruian_katastr SET nazev = 'Březka u Velké Bíteše' WHERE kod = 614246;
UPDATE ruian_katastr SET nazev = 'Březná' WHERE kod = 614262;
UPDATE ruian_katastr SET nazev = 'Březnice' WHERE kod = 614271;
UPDATE ruian_katastr SET nazev = 'Přední Poříčí' WHERE kod = 614319;
UPDATE ruian_katastr SET nazev = 'Březnice u Bechyně' WHERE kod = 614386;
UPDATE ruian_katastr SET nazev = 'Březnice u Zlína' WHERE kod = 614408;
UPDATE ruian_katastr SET nazev = 'Březník' WHERE kod = 614441;
UPDATE ruian_katastr SET nazev = 'Kuroslepy' WHERE kod = 614459;
UPDATE ruian_katastr SET nazev = 'Březno u Mladé Boleslavi' WHERE kod = 614467;
UPDATE ruian_katastr SET nazev = 'Březno u Chomutova' WHERE kod = 614491;
UPDATE ruian_katastr SET nazev = 'Denětice' WHERE kod = 614505;
UPDATE ruian_katastr SET nazev = 'Holetice' WHERE kod = 614513;
UPDATE ruian_katastr SET nazev = 'Stranná u Nechranic' WHERE kod = 614548;
UPDATE ruian_katastr SET nazev = 'Březno u Postoloprt' WHERE kod = 614572;
UPDATE ruian_katastr SET nazev = 'Březolupy' WHERE kod = 614599;
UPDATE ruian_katastr SET nazev = 'Březová u Hořovic' WHERE kod = 614602;
UPDATE ruian_katastr SET nazev = 'Březová u Sokolova' WHERE kod = 614611;
UPDATE ruian_katastr SET nazev = 'Kamenice u Březové' WHERE kod = 614629;
UPDATE ruian_katastr SET nazev = 'Tisová u Sokolova' WHERE kod = 614645;
UPDATE ruian_katastr SET nazev = 'Lobzy u Březové' WHERE kod = 614653;
UPDATE ruian_katastr SET nazev = 'Paseka u Březové' WHERE kod = 614661;
UPDATE ruian_katastr SET nazev = 'Březová u Broumova' WHERE kod = 614670;
UPDATE ruian_katastr SET nazev = 'Vernéřovice' WHERE kod = 614688;
UPDATE ruian_katastr SET nazev = 'Březová u Zlína' WHERE kod = 614696;
UPDATE ruian_katastr SET nazev = 'Březová u Uherského Brodu' WHERE kod = 614700;
UPDATE ruian_katastr SET nazev = 'Březová u Vítkova' WHERE kod = 614718;
UPDATE ruian_katastr SET nazev = 'Březová nad Svitavou' WHERE kod = 614726;
UPDATE ruian_katastr SET nazev = 'Česká Dlouhá' WHERE kod = 614734;
UPDATE ruian_katastr SET nazev = 'Moravská Dlouhá' WHERE kod = 614742;
UPDATE ruian_katastr SET nazev = 'Muzlov' WHERE kod = 614751;
UPDATE ruian_katastr SET nazev = 'Zářečí nad Svitavou' WHERE kod = 614769;
UPDATE ruian_katastr SET nazev = 'Březovice pod Bezdězem' WHERE kod = 614777;
UPDATE ruian_katastr SET nazev = 'Víska u Březovic' WHERE kod = 614785;
UPDATE ruian_katastr SET nazev = 'Březovice' WHERE kod = 614793;
UPDATE ruian_katastr SET nazev = 'Březské' WHERE kod = 614807;
UPDATE ruian_katastr SET nazev = 'Březsko' WHERE kod = 614815;
UPDATE ruian_katastr SET nazev = 'Ladín' WHERE kod = 614823;
UPDATE ruian_katastr SET nazev = 'Březůvky' WHERE kod = 614831;
UPDATE ruian_katastr SET nazev = 'Břešťany' WHERE kod = 614858;
UPDATE ruian_katastr SET nazev = 'Břežánky' WHERE kod = 614866;
UPDATE ruian_katastr SET nazev = 'Břežany u Rakovníka' WHERE kod = 614874;
UPDATE ruian_katastr SET nazev = 'Břežany' WHERE kod = 614891;
UPDATE ruian_katastr SET nazev = 'Břežany u Žatce' WHERE kod = 614904;
UPDATE ruian_katastr SET nazev = 'Číňov' WHERE kod = 614912;
UPDATE ruian_katastr SET nazev = 'Břežany u Znojma' WHERE kod = 614921;
UPDATE ruian_katastr SET nazev = 'Břežany I' WHERE kod = 614939;
UPDATE ruian_katastr SET nazev = 'Chocenice u Břežan I' WHERE kod = 614947;
UPDATE ruian_katastr SET nazev = 'Břežany II' WHERE kod = 614955;
UPDATE ruian_katastr SET nazev = 'Břežany nad Ohří' WHERE kod = 614971;
UPDATE ruian_katastr SET nazev = 'Albrechtice u Rýmařova' WHERE kod = 614980;
UPDATE ruian_katastr SET nazev = 'Břidličná' WHERE kod = 614998;
UPDATE ruian_katastr SET nazev = 'Vajglov' WHERE kod = 615005;
UPDATE ruian_katastr SET nazev = 'Velká Štáhle' WHERE kod = 615013;
UPDATE ruian_katastr SET nazev = 'Břilice' WHERE kod = 615021;
UPDATE ruian_katastr SET nazev = 'Bříství' WHERE kod = 615056;
UPDATE ruian_katastr SET nazev = 'Bříšťany' WHERE kod = 615064;
UPDATE ruian_katastr SET nazev = 'Petrovičky u Hořic' WHERE kod = 615072;
UPDATE ruian_katastr SET nazev = 'Bříza' WHERE kod = 615081;
UPDATE ruian_katastr SET nazev = 'Břízsko' WHERE kod = 615099;
UPDATE ruian_katastr SET nazev = 'Robčice' WHERE kod = 615102;
UPDATE ruian_katastr SET nazev = 'Břvany' WHERE kod = 615111;
UPDATE ruian_katastr SET nazev = 'Bublava' WHERE kod = 615129;
UPDATE ruian_katastr SET nazev = 'Bubovice' WHERE kod = 615137;
UPDATE ruian_katastr SET nazev = 'Bučí' WHERE kod = 615145;
UPDATE ruian_katastr SET nazev = 'Bučina' WHERE kod = 615153;
UPDATE ruian_katastr SET nazev = 'Bučovice' WHERE kod = 615161;
UPDATE ruian_katastr SET nazev = 'Vícemilice' WHERE kod = 615170;
UPDATE ruian_katastr SET nazev = 'Budčeves' WHERE kod = 615188;
UPDATE ruian_katastr SET nazev = 'Nečas' WHERE kod = 615196;
UPDATE ruian_katastr SET nazev = 'Budeč' WHERE kod = 615218;
UPDATE ruian_katastr SET nazev = 'Budeč u Žďáru nad Sázavou' WHERE kod = 615226;
UPDATE ruian_katastr SET nazev = 'Budenín' WHERE kod = 615234;
UPDATE ruian_katastr SET nazev = 'Hory u Votic' WHERE kod = 615242;
UPDATE ruian_katastr SET nazev = 'Hostišov' WHERE kod = 615251;
UPDATE ruian_katastr SET nazev = 'Budětice' WHERE kod = 615307;
UPDATE ruian_katastr SET nazev = 'Lipová Lhota' WHERE kod = 615315;
UPDATE ruian_katastr SET nazev = 'Budětsko' WHERE kod = 615323;
UPDATE ruian_katastr SET nazev = 'Budíkov' WHERE kod = 615358;
UPDATE ruian_katastr SET nazev = 'Budíkovice' WHERE kod = 615382;
UPDATE ruian_katastr SET nazev = 'Okřešice u Třebíče' WHERE kod = 615391;
UPDATE ruian_katastr SET nazev = 'Budiměřice' WHERE kod = 615404;
UPDATE ruian_katastr SET nazev = 'Šlotava' WHERE kod = 615412;
UPDATE ruian_katastr SET nazev = 'Budislav' WHERE kod = 615421;
UPDATE ruian_katastr SET nazev = 'Katov u Budislavi' WHERE kod = 615439;
UPDATE ruian_katastr SET nazev = 'Budislav u Litomyšle' WHERE kod = 615447;
UPDATE ruian_katastr SET nazev = 'Budíškovice' WHERE kod = 615455;
UPDATE ruian_katastr SET nazev = 'Budišov' WHERE kod = 615463;
UPDATE ruian_katastr SET nazev = 'Budišov nad Budišovkou' WHERE kod = 615501;
UPDATE ruian_katastr SET nazev = 'Guntramovice' WHERE kod = 615510;
UPDATE ruian_katastr SET nazev = 'Svatoňovice' WHERE kod = 615536;
UPDATE ruian_katastr SET nazev = 'Lesy' WHERE kod = 615544;
UPDATE ruian_katastr SET nazev = 'Budišovice' WHERE kod = 615552;
UPDATE ruian_katastr SET nazev = 'Budkov u Husince' WHERE kod = 615579;
UPDATE ruian_katastr SET nazev = 'Budkov' WHERE kod = 615587;
UPDATE ruian_katastr SET nazev = 'Budkovice' WHERE kod = 615595;
UPDATE ruian_katastr SET nazev = 'Budyně' WHERE kod = 615609;
UPDATE ruian_katastr SET nazev = 'Budyně nad Ohří' WHERE kod = 615617;
UPDATE ruian_katastr SET nazev = 'Buchlovice' WHERE kod = 615625;
UPDATE ruian_katastr SET nazev = 'Suchdol u Bujanova' WHERE kod = 615706;
UPDATE ruian_katastr SET nazev = 'Zdíky' WHERE kod = 615714;
UPDATE ruian_katastr SET nazev = 'Bujesily' WHERE kod = 615722;
UPDATE ruian_katastr SET nazev = 'Buk' WHERE kod = 615731;
UPDATE ruian_katastr SET nazev = 'Bukol' WHERE kod = 615749;
UPDATE ruian_katastr SET nazev = 'Bukov na Moravě' WHERE kod = 615757;
UPDATE ruian_katastr SET nazev = 'Milasín' WHERE kod = 615765;
UPDATE ruian_katastr SET nazev = 'Střítež u Bukova' WHERE kod = 615773;
UPDATE ruian_katastr SET nazev = 'Buková u Semněvic' WHERE kod = 615781;
UPDATE ruian_katastr SET nazev = 'Buková u Třešti' WHERE kod = 615790;
UPDATE ruian_katastr SET nazev = 'Buková u Protivanova' WHERE kod = 615803;
UPDATE ruian_katastr SET nazev = 'Buková u Příbramě' WHERE kod = 615811;
UPDATE ruian_katastr SET nazev = 'Bukovany u Týnce nad Sázavou' WHERE kod = 615820;
UPDATE ruian_katastr SET nazev = 'Bukovany u Kozárovic' WHERE kod = 615838;
UPDATE ruian_katastr SET nazev = 'Holušice u Kozárovic' WHERE kod = 615846;
UPDATE ruian_katastr SET nazev = 'Bukovany u Sokolova' WHERE kod = 615889;
UPDATE ruian_katastr SET nazev = 'Bukovany u Nového Boru' WHERE kod = 615897;
UPDATE ruian_katastr SET nazev = 'Bukovany u Kyjova' WHERE kod = 615919;
UPDATE ruian_katastr SET nazev = 'Bukovany u Olomouce' WHERE kod = 615927;
UPDATE ruian_katastr SET nazev = 'Bukovec u Horšovského Týna' WHERE kod = 615935;
UPDATE ruian_katastr SET nazev = 'Čečovice u Bukovce' WHERE kod = 615943;
UPDATE ruian_katastr SET nazev = 'Černovice u Bukovce' WHERE kod = 615951;
UPDATE ruian_katastr SET nazev = 'Nemněnice' WHERE kod = 615960;
UPDATE ruian_katastr SET nazev = 'Pocinovice u Semněvic' WHERE kod = 615978;
UPDATE ruian_katastr SET nazev = 'Šlovice u Bukovce' WHERE kod = 615986;
UPDATE ruian_katastr SET nazev = 'Bukovec u Jablunkova' WHERE kod = 615994;
UPDATE ruian_katastr SET nazev = 'Bukovice u Rohozce' WHERE kod = 616010;
UPDATE ruian_katastr SET nazev = 'Bukovice u Velkých Losin' WHERE kod = 616028;
UPDATE ruian_katastr SET nazev = 'Bukovina u Mladotic' WHERE kod = 616036;
UPDATE ruian_katastr SET nazev = 'Bukovina u Hradce Králové' WHERE kod = 616044;
UPDATE ruian_katastr SET nazev = 'Bukovina nad Labem' WHERE kod = 616052;
UPDATE ruian_katastr SET nazev = 'Bukovina u Přelouče' WHERE kod = 616061;
UPDATE ruian_katastr SET nazev = 'Bukovina' WHERE kod = 616079;
UPDATE ruian_katastr SET nazev = 'Bukovina u Čisté' WHERE kod = 616087;
UPDATE ruian_katastr SET nazev = 'Bukovina u Pecky' WHERE kod = 616109;
UPDATE ruian_katastr SET nazev = 'Bukovinka' WHERE kod = 616117;
UPDATE ruian_katastr SET nazev = 'Bukovka' WHERE kod = 616125;
UPDATE ruian_katastr SET nazev = 'Bukovník' WHERE kod = 616133;
UPDATE ruian_katastr SET nazev = 'Mačice' WHERE kod = 616141;
UPDATE ruian_katastr SET nazev = 'Bukovno' WHERE kod = 616150;
UPDATE ruian_katastr SET nazev = 'Bulhary' WHERE kod = 616168;
UPDATE ruian_katastr SET nazev = 'Arnoltice u Bulovky' WHERE kod = 616176;
UPDATE ruian_katastr SET nazev = 'Bulovka' WHERE kod = 616184;
UPDATE ruian_katastr SET nazev = 'Dolní Oldřiš' WHERE kod = 616192;
UPDATE ruian_katastr SET nazev = 'Buřenice' WHERE kod = 616214;
UPDATE ruian_katastr SET nazev = 'Kyjov u Buřenic' WHERE kod = 616231;
UPDATE ruian_katastr SET nazev = 'Radějov u Buřenic' WHERE kod = 616249;
UPDATE ruian_katastr SET nazev = 'Buš' WHERE kod = 616257;
UPDATE ruian_katastr SET nazev = 'Bušanovice' WHERE kod = 616273;
UPDATE ruian_katastr SET nazev = 'Dolní Nakvasovice' WHERE kod = 616281;
UPDATE ruian_katastr SET nazev = 'Horní Nakvasovice' WHERE kod = 616290;
UPDATE ruian_katastr SET nazev = 'Bušín' WHERE kod = 616303;
UPDATE ruian_katastr SET nazev = 'Hartíkov' WHERE kod = 616311;
UPDATE ruian_katastr SET nazev = 'Buškovice' WHERE kod = 616320;
UPDATE ruian_katastr SET nazev = 'Bušovice' WHERE kod = 616338;
UPDATE ruian_katastr SET nazev = 'Sedlecko' WHERE kod = 616346;
UPDATE ruian_katastr SET nazev = 'Smědčice' WHERE kod = 616354;
UPDATE ruian_katastr SET nazev = 'Střapole' WHERE kod = 616362;
UPDATE ruian_katastr SET nazev = 'Všenice' WHERE kod = 616371;
UPDATE ruian_katastr SET nazev = 'Buštěhrad' WHERE kod = 616397;
UPDATE ruian_katastr SET nazev = 'Buzice' WHERE kod = 616401;
UPDATE ruian_katastr SET nazev = 'Býčkovice' WHERE kod = 616427;
UPDATE ruian_katastr SET nazev = 'Velký Újezd u Litoměřic' WHERE kod = 616435;
UPDATE ruian_katastr SET nazev = 'Býchory' WHERE kod = 616443;
UPDATE ruian_katastr SET nazev = 'Němčice u Kolína' WHERE kod = 616451;
UPDATE ruian_katastr SET nazev = 'Býkev' WHERE kod = 616460;
UPDATE ruian_katastr SET nazev = 'Daminěves' WHERE kod = 616478;
UPDATE ruian_katastr SET nazev = 'Jenišovice u Mělníka' WHERE kod = 616486;
UPDATE ruian_katastr SET nazev = 'Bykoš' WHERE kod = 616494;
UPDATE ruian_katastr SET nazev = 'Býkov' WHERE kod = 616508;
UPDATE ruian_katastr SET nazev = 'Býkovice' WHERE kod = 616524;
UPDATE ruian_katastr SET nazev = 'Bylany u Mostu' WHERE kod = 616532;
UPDATE ruian_katastr SET nazev = 'Slatinice u Mostu' WHERE kod = 616559;
UPDATE ruian_katastr SET nazev = 'Bylany' WHERE kod = 616567;
UPDATE ruian_katastr SET nazev = 'Lány u Bylan' WHERE kod = 616583;
UPDATE ruian_katastr SET nazev = 'Bynina' WHERE kod = 616591;
UPDATE ruian_katastr SET nazev = 'Byseň' WHERE kod = 616605;
UPDATE ruian_katastr SET nazev = 'Bystrá' WHERE kod = 616621;
UPDATE ruian_katastr SET nazev = 'Bystrá nad Jizerou' WHERE kod = 616630;
UPDATE ruian_katastr SET nazev = 'Bystré v Orlických horách' WHERE kod = 616648;
UPDATE ruian_katastr SET nazev = 'Bystré u Poličky' WHERE kod = 616664;
UPDATE ruian_katastr SET nazev = 'Bystročice' WHERE kod = 616672;
UPDATE ruian_katastr SET nazev = 'Žerůvky' WHERE kod = 616681;
UPDATE ruian_katastr SET nazev = 'Bystrovany' WHERE kod = 616699;
UPDATE ruian_katastr SET nazev = 'Bystřany' WHERE kod = 616702;
UPDATE ruian_katastr SET nazev = 'Nechvalice u Bystřan' WHERE kod = 616711;
UPDATE ruian_katastr SET nazev = 'Bystřany-Světice' WHERE kod = 616737;
UPDATE ruian_katastr SET nazev = 'Bystřec' WHERE kod = 616753;
UPDATE ruian_katastr SET nazev = 'Bystřice u Benešova' WHERE kod = 616770;
UPDATE ruian_katastr SET nazev = 'Jinošice' WHERE kod = 616818;
UPDATE ruian_katastr SET nazev = 'Jírovice' WHERE kod = 616826;
UPDATE ruian_katastr SET nazev = 'Líšno' WHERE kod = 616834;
UPDATE ruian_katastr SET nazev = 'Nesvačily u Bystřice' WHERE kod = 616869;
UPDATE ruian_katastr SET nazev = 'Tvoršovice' WHERE kod = 616893;
UPDATE ruian_katastr SET nazev = 'Bystřice' WHERE kod = 616907;
UPDATE ruian_katastr SET nazev = 'Važice' WHERE kod = 616915;
UPDATE ruian_katastr SET nazev = 'Bystřice nad Olší' WHERE kod = 616923;
UPDATE ruian_katastr SET nazev = 'Bystřice nad Pernštejnem' WHERE kod = 616958;
UPDATE ruian_katastr SET nazev = 'Dvořiště u Bystřice nad Pernštejnem' WHERE kod = 616982;
UPDATE ruian_katastr SET nazev = 'Bratrušín' WHERE kod = 617008;
UPDATE ruian_katastr SET nazev = 'Domanínek' WHERE kod = 617075;
UPDATE ruian_katastr SET nazev = 'Bystřice nad Úhlavou' WHERE kod = 617083;
UPDATE ruian_katastr SET nazev = 'Petrovice nad Úhlavou' WHERE kod = 617091;
UPDATE ruian_katastr SET nazev = 'Starý Láz' WHERE kod = 617105;
UPDATE ruian_katastr SET nazev = 'Bystřice pod Hostýnem' WHERE kod = 617113;
UPDATE ruian_katastr SET nazev = 'Rychlov u Bystřice pod Hostýnem' WHERE kod = 617121;
UPDATE ruian_katastr SET nazev = 'Bystřice pod Lopeníkem' WHERE kod = 617130;
UPDATE ruian_katastr SET nazev = 'Bystřička II' WHERE kod = 617148;
UPDATE ruian_katastr SET nazev = 'Bystřička I' WHERE kod = 617156;
UPDATE ruian_katastr SET nazev = 'Byšice' WHERE kod = 617172;
UPDATE ruian_katastr SET nazev = 'Hostín u Mělníka' WHERE kod = 617181;
UPDATE ruian_katastr SET nazev = 'Liblice' WHERE kod = 617199;
UPDATE ruian_katastr SET nazev = 'Býškovice' WHERE kod = 617202;
UPDATE ruian_katastr SET nazev = 'Býšovec' WHERE kod = 617211;
UPDATE ruian_katastr SET nazev = 'Smrček' WHERE kod = 617229;
UPDATE ruian_katastr SET nazev = 'Býšť' WHERE kod = 617237;
UPDATE ruian_katastr SET nazev = 'Hrachoviště u Býště' WHERE kod = 617245;
UPDATE ruian_katastr SET nazev = 'Byzhradec' WHERE kod = 617261;
UPDATE ruian_katastr SET nazev = 'Bzenec' WHERE kod = 617270;
UPDATE ruian_katastr SET nazev = 'Bzí' WHERE kod = 617300;
UPDATE ruian_katastr SET nazev = 'Bzová u Hořovic' WHERE kod = 617318;
UPDATE ruian_katastr SET nazev = 'Bzová u Uherského Brodu' WHERE kod = 617326;
UPDATE ruian_katastr SET nazev = 'Bžany' WHERE kod = 617342;
UPDATE ruian_katastr SET nazev = 'Lhenice u Bžan' WHERE kod = 617351;
UPDATE ruian_katastr SET nazev = 'Bezemín' WHERE kod = 617377;
UPDATE ruian_katastr SET nazev = 'Cebiv' WHERE kod = 617385;
UPDATE ruian_katastr SET nazev = 'Cehnice' WHERE kod = 617393;
UPDATE ruian_katastr SET nazev = 'Cejle' WHERE kod = 617407;
UPDATE ruian_katastr SET nazev = 'Dvorce u Jihlavy' WHERE kod = 617415;
UPDATE ruian_katastr SET nazev = 'Hutě' WHERE kod = 617423;
UPDATE ruian_katastr SET nazev = 'Kostelecký Dvůr' WHERE kod = 617431;
UPDATE ruian_katastr SET nazev = 'Cekov' WHERE kod = 617440;
UPDATE ruian_katastr SET nazev = 'Sirá' WHERE kod = 617458;
UPDATE ruian_katastr SET nazev = 'Cep' WHERE kod = 617466;
UPDATE ruian_katastr SET nazev = 'Cerekvice nad Bystřicí' WHERE kod = 617474;
UPDATE ruian_katastr SET nazev = 'Cerekvice nad Loučnou' WHERE kod = 617491;
UPDATE ruian_katastr SET nazev = 'Pekla' WHERE kod = 617504;
UPDATE ruian_katastr SET nazev = 'Řídký' WHERE kod = 617512;
UPDATE ruian_katastr SET nazev = 'Cerekvička' WHERE kod = 617521;
UPDATE ruian_katastr SET nazev = 'Rosice u Cerekvičky' WHERE kod = 617539;
UPDATE ruian_katastr SET nazev = 'Cerhenice' WHERE kod = 617547;
UPDATE ruian_katastr SET nazev = 'Cerhýnky' WHERE kod = 617555;
UPDATE ruian_katastr SET nazev = 'Cerhonice' WHERE kod = 617571;
UPDATE ruian_katastr SET nazev = 'Radobytce' WHERE kod = 617601;
UPDATE ruian_katastr SET nazev = 'Cerhovice' WHERE kod = 617610;
UPDATE ruian_katastr SET nazev = 'Cetechovice' WHERE kod = 617628;
UPDATE ruian_katastr SET nazev = 'Cetenov' WHERE kod = 617636;
UPDATE ruian_katastr SET nazev = 'Cetkovice' WHERE kod = 617661;
UPDATE ruian_katastr SET nazev = 'Cetoraz' WHERE kod = 617679;
UPDATE ruian_katastr SET nazev = 'Cetyně' WHERE kod = 617687;
UPDATE ruian_katastr SET nazev = 'Cidlina' WHERE kod = 617709;
UPDATE ruian_katastr SET nazev = 'Zámezí' WHERE kod = 617725;
UPDATE ruian_katastr SET nazev = 'Cidlina na Moravě' WHERE kod = 617733;
UPDATE ruian_katastr SET nazev = 'Cínovec' WHERE kod = 617741;
UPDATE ruian_katastr SET nazev = 'Církvice u Kutné Hory' WHERE kod = 617750;
UPDATE ruian_katastr SET nazev = 'Jakub' WHERE kod = 617768;
UPDATE ruian_katastr SET nazev = 'Třebešice' WHERE kod = 617776;
UPDATE ruian_katastr SET nazev = 'Císařov' WHERE kod = 617784;
UPDATE ruian_katastr SET nazev = 'Citice' WHERE kod = 617792;
UPDATE ruian_katastr SET nazev = 'Hlavno' WHERE kod = 617806;
UPDATE ruian_katastr SET nazev = 'Brloh' WHERE kod = 617814;
UPDATE ruian_katastr SET nazev = 'Cítoliby' WHERE kod = 617822;
UPDATE ruian_katastr SET nazev = 'Citonice' WHERE kod = 617831;
UPDATE ruian_katastr SET nazev = 'Cítov' WHERE kod = 617849;
UPDATE ruian_katastr SET nazev = 'Citov' WHERE kod = 617857;
UPDATE ruian_katastr SET nazev = 'Cizkrajov' WHERE kod = 617865;
UPDATE ruian_katastr SET nazev = 'Dolní Bolíkov' WHERE kod = 617873;
UPDATE ruian_katastr SET nazev = 'Holešice u Cizkrajova' WHERE kod = 617881;
UPDATE ruian_katastr SET nazev = 'Mutná' WHERE kod = 617890;
UPDATE ruian_katastr SET nazev = 'Cotkytle' WHERE kod = 617903;
UPDATE ruian_katastr SET nazev = 'Crhov u Olešnice' WHERE kod = 617920;
UPDATE ruian_katastr SET nazev = 'Crhov' WHERE kod = 617938;
UPDATE ruian_katastr SET nazev = 'Ctětín' WHERE kod = 617954;
UPDATE ruian_katastr SET nazev = 'Ctiboř' WHERE kod = 618004;
UPDATE ruian_katastr SET nazev = 'Březí u Tachova' WHERE kod = 618021;
UPDATE ruian_katastr SET nazev = 'Ctiboř u Tachova' WHERE kod = 618039;
UPDATE ruian_katastr SET nazev = 'Ctidružice' WHERE kod = 618047;
UPDATE ruian_katastr SET nazev = 'Ctiměřice' WHERE kod = 618055;
UPDATE ruian_katastr SET nazev = 'Ctiněves' WHERE kod = 618063;
UPDATE ruian_katastr SET nazev = 'Černouček' WHERE kod = 618071;
UPDATE ruian_katastr SET nazev = 'Cvikov' WHERE kod = 618080;
UPDATE ruian_katastr SET nazev = 'Drnovec' WHERE kod = 618098;
UPDATE ruian_katastr SET nazev = 'Naděje' WHERE kod = 618101;
UPDATE ruian_katastr SET nazev = 'Trávník u Cvikova' WHERE kod = 618110;
UPDATE ruian_katastr SET nazev = 'Cvrčovice' WHERE kod = 618128;
UPDATE ruian_katastr SET nazev = 'Cvrčovice u Pohořelic' WHERE kod = 618152;
UPDATE ruian_katastr SET nazev = 'Cvrčovice u Zdounek' WHERE kod = 618161;
UPDATE ruian_katastr SET nazev = 'Čachnov' WHERE kod = 618179;
UPDATE ruian_katastr SET nazev = 'Čachotín' WHERE kod = 618187;
UPDATE ruian_katastr SET nazev = 'Čachovice' WHERE kod = 618195;
UPDATE ruian_katastr SET nazev = 'Bradné' WHERE kod = 618209;
UPDATE ruian_katastr SET nazev = 'Březí u Čachrova' WHERE kod = 618217;
UPDATE ruian_katastr SET nazev = 'Čachrov' WHERE kod = 618225;
UPDATE ruian_katastr SET nazev = 'Chřepice' WHERE kod = 618233;
UPDATE ruian_katastr SET nazev = 'Jesení' WHERE kod = 618241;
UPDATE ruian_katastr SET nazev = 'Onen Svět' WHERE kod = 618250;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Čachrova' WHERE kod = 618268;
UPDATE ruian_katastr SET nazev = 'Čakov' WHERE kod = 618276;
UPDATE ruian_katastr SET nazev = 'Tatouňovice' WHERE kod = 618284;
UPDATE ruian_katastr SET nazev = 'Vlkov u Čakova' WHERE kod = 618292;
UPDATE ruian_katastr SET nazev = 'Čaková' WHERE kod = 618306;
UPDATE ruian_katastr SET nazev = 'Čakovice u Pelhřimova' WHERE kod = 618314;
UPDATE ruian_katastr SET nazev = 'Blížňovice' WHERE kod = 618322;
UPDATE ruian_katastr SET nazev = 'Čankovice' WHERE kod = 618331;
UPDATE ruian_katastr SET nazev = 'Čáslav' WHERE kod = 618349;
UPDATE ruian_katastr SET nazev = 'Filipov u Čáslavi' WHERE kod = 618497;
UPDATE ruian_katastr SET nazev = 'Čáslavice' WHERE kod = 618501;
UPDATE ruian_katastr SET nazev = 'Čáslavsko' WHERE kod = 618527;
UPDATE ruian_katastr SET nazev = 'Štědrovice' WHERE kod = 618551;
UPDATE ruian_katastr SET nazev = 'Částkov u Tachova' WHERE kod = 618560;
UPDATE ruian_katastr SET nazev = 'Maršovy Chody' WHERE kod = 618578;
UPDATE ruian_katastr SET nazev = 'Pernolec' WHERE kod = 618586;
UPDATE ruian_katastr SET nazev = 'Velký Rapotín' WHERE kod = 618594;
UPDATE ruian_katastr SET nazev = 'Částkov' WHERE kod = 618608;
UPDATE ruian_katastr SET nazev = 'Částkovice' WHERE kod = 618616;
UPDATE ruian_katastr SET nazev = 'Častolovice' WHERE kod = 618624;
UPDATE ruian_katastr SET nazev = 'Hřibiny' WHERE kod = 618632;
UPDATE ruian_katastr SET nazev = 'Velká Ledská' WHERE kod = 618667;
UPDATE ruian_katastr SET nazev = 'Častonín' WHERE kod = 618675;
UPDATE ruian_katastr SET nazev = 'Sedliště u Častonína' WHERE kod = 618683;
UPDATE ruian_katastr SET nazev = 'Ctiboř u Častrova' WHERE kod = 618691;
UPDATE ruian_katastr SET nazev = 'Častrov' WHERE kod = 618705;
UPDATE ruian_katastr SET nazev = 'Jakubín' WHERE kod = 618713;
UPDATE ruian_katastr SET nazev = 'Metánov' WHERE kod = 618721;
UPDATE ruian_katastr SET nazev = 'Pelec' WHERE kod = 618730;
UPDATE ruian_katastr SET nazev = 'Čavisov' WHERE kod = 618756;
UPDATE ruian_katastr SET nazev = 'Čebín' WHERE kod = 618764;
UPDATE ruian_katastr SET nazev = 'Čečelice' WHERE kod = 618772;
UPDATE ruian_katastr SET nazev = 'Čečelovice' WHERE kod = 618781;
UPDATE ruian_katastr SET nazev = 'Čečovice' WHERE kod = 618799;
UPDATE ruian_katastr SET nazev = 'Liškov' WHERE kod = 618802;
UPDATE ruian_katastr SET nazev = 'Měrčín' WHERE kod = 618811;
UPDATE ruian_katastr SET nazev = 'Čehovice' WHERE kod = 618829;
UPDATE ruian_katastr SET nazev = 'Čechočovice' WHERE kod = 618837;
UPDATE ruian_katastr SET nazev = 'Čechovice' WHERE kod = 618845;
UPDATE ruian_katastr SET nazev = 'Čechovice u Prostějova' WHERE kod = 618853;
UPDATE ruian_katastr SET nazev = 'Domamyslice' WHERE kod = 618861;
UPDATE ruian_katastr SET nazev = 'Čechovice-Záhoří' WHERE kod = 618870;
UPDATE ruian_katastr SET nazev = 'Čechtice' WHERE kod = 618888;
UPDATE ruian_katastr SET nazev = 'Čechtín' WHERE kod = 618918;
UPDATE ruian_katastr SET nazev = 'Čechy pod Kosířem' WHERE kod = 618926;
UPDATE ruian_katastr SET nazev = 'Čechyně' WHERE kod = 618934;
UPDATE ruian_katastr SET nazev = 'Čejč' WHERE kod = 618942;
UPDATE ruian_katastr SET nazev = 'Čejetice' WHERE kod = 618951;
UPDATE ruian_katastr SET nazev = 'Sudoměř u Čejetic' WHERE kod = 618977;
UPDATE ruian_katastr SET nazev = 'Čejkov' WHERE kod = 618985;
UPDATE ruian_katastr SET nazev = 'Čejkovice u Hluboké nad Vltavou' WHERE kod = 618993;
UPDATE ruian_katastr SET nazev = 'Čejkovice' WHERE kod = 619001;
UPDATE ruian_katastr SET nazev = 'Čejkovice u Znojma' WHERE kod = 619019;
UPDATE ruian_katastr SET nazev = 'Čejkovy' WHERE kod = 619027;
UPDATE ruian_katastr SET nazev = 'Zbynice' WHERE kod = 619035;
UPDATE ruian_katastr SET nazev = 'Čejov' WHERE kod = 619043;
UPDATE ruian_katastr SET nazev = 'Čekanice' WHERE kod = 619060;
UPDATE ruian_katastr SET nazev = 'Milčice u Čekanic' WHERE kod = 619078;
UPDATE ruian_katastr SET nazev = 'Čekanice u Tábora' WHERE kod = 619086;
UPDATE ruian_katastr SET nazev = 'Stoklasná Lhota' WHERE kod = 619094;
UPDATE ruian_katastr SET nazev = 'Čekyně' WHERE kod = 619108;
UPDATE ruian_katastr SET nazev = 'Čeladná' WHERE kod = 619116;
UPDATE ruian_katastr SET nazev = 'Čelákovice' WHERE kod = 619159;
UPDATE ruian_katastr SET nazev = 'Sedlčánky' WHERE kod = 619213;
UPDATE ruian_katastr SET nazev = 'Záluží u Čelákovic' WHERE kod = 619230;
UPDATE ruian_katastr SET nazev = 'Čelčice' WHERE kod = 619311;
UPDATE ruian_katastr SET nazev = 'Čelechovice' WHERE kod = 619329;
UPDATE ruian_katastr SET nazev = 'Čelechovice u Přerova' WHERE kod = 619337;
UPDATE ruian_katastr SET nazev = 'Čelechovice na Hané' WHERE kod = 619345;
UPDATE ruian_katastr SET nazev = 'Studenec' WHERE kod = 619361;
UPDATE ruian_katastr SET nazev = 'Čelina' WHERE kod = 619370;
UPDATE ruian_katastr SET nazev = 'Čelistná' WHERE kod = 619388;
UPDATE ruian_katastr SET nazev = 'Vlásenice-Drbohlavy' WHERE kod = 619396;
UPDATE ruian_katastr SET nazev = 'Čelivo' WHERE kod = 619400;
UPDATE ruian_katastr SET nazev = 'Čelkovice' WHERE kod = 619418;
UPDATE ruian_katastr SET nazev = 'Čeložnice' WHERE kod = 619426;
UPDATE ruian_katastr SET nazev = 'Čeminy' WHERE kod = 619434;
UPDATE ruian_katastr SET nazev = 'Kůští' WHERE kod = 619442;
UPDATE ruian_katastr SET nazev = 'Čenkov u Příbramě' WHERE kod = 619451;
UPDATE ruian_katastr SET nazev = 'Čenkov u Třešti' WHERE kod = 619469;
UPDATE ruian_katastr SET nazev = 'Čenkov u Bechyně' WHERE kod = 619477;
UPDATE ruian_katastr SET nazev = 'Čenkov u Malšic' WHERE kod = 619485;
UPDATE ruian_katastr SET nazev = 'Dobřejice' WHERE kod = 619493;
UPDATE ruian_katastr SET nazev = 'Třebelice' WHERE kod = 619507;
UPDATE ruian_katastr SET nazev = 'Všechlapy u Malšic' WHERE kod = 619515;
UPDATE ruian_katastr SET nazev = 'Čenkovice' WHERE kod = 619523;
UPDATE ruian_katastr SET nazev = 'Čeňovice' WHERE kod = 619531;
UPDATE ruian_katastr SET nazev = 'Čeperka' WHERE kod = 619558;
UPDATE ruian_katastr SET nazev = 'Čepí' WHERE kod = 619582;
UPDATE ruian_katastr SET nazev = 'Čepirohy' WHERE kod = 619591;
UPDATE ruian_katastr SET nazev = 'Čepřovice' WHERE kod = 619612;
UPDATE ruian_katastr SET nazev = 'Čeradice u Žatce' WHERE kod = 619621;
UPDATE ruian_katastr SET nazev = 'Kličín' WHERE kod = 619639;
UPDATE ruian_katastr SET nazev = 'Větrušice' WHERE kod = 619647;
UPDATE ruian_katastr SET nazev = 'Čeradice nad Loučnou' WHERE kod = 619655;
UPDATE ruian_katastr SET nazev = 'Čerčany' WHERE kod = 619663;
UPDATE ruian_katastr SET nazev = 'Čermákovice' WHERE kod = 619698;
UPDATE ruian_katastr SET nazev = 'Čermná u Staňkova' WHERE kod = 619701;
UPDATE ruian_katastr SET nazev = 'Poděvousy' WHERE kod = 619710;
UPDATE ruian_katastr SET nazev = 'Čermná' WHERE kod = 619728;
UPDATE ruian_katastr SET nazev = 'Čermná v Krkonoších' WHERE kod = 619752;
UPDATE ruian_katastr SET nazev = 'Čermná ve Slezsku' WHERE kod = 619761;
UPDATE ruian_katastr SET nazev = 'Malá Čermná nad Orlicí' WHERE kod = 619787;
UPDATE ruian_katastr SET nazev = 'Velká Čermná nad Orlicí' WHERE kod = 619795;
UPDATE ruian_katastr SET nazev = 'Černá' WHERE kod = 619809;
UPDATE ruian_katastr SET nazev = 'Milíkov' WHERE kod = 619817;
UPDATE ruian_katastr SET nazev = 'Černá Hora' WHERE kod = 619825;
UPDATE ruian_katastr SET nazev = 'Jindřichova Hora' WHERE kod = 619841;
UPDATE ruian_katastr SET nazev = 'Černá v Pošumaví' WHERE kod = 619868;
UPDATE ruian_katastr SET nazev = 'Kyselov' WHERE kod = 619914;
UPDATE ruian_katastr SET nazev = 'Černá Voda' WHERE kod = 619922;
UPDATE ruian_katastr SET nazev = 'Rokliny' WHERE kod = 619949;
UPDATE ruian_katastr SET nazev = 'Černá za Bory' WHERE kod = 619965;
UPDATE ruian_katastr SET nazev = 'Drozdice' WHERE kod = 619973;
UPDATE ruian_katastr SET nazev = 'Mnětice' WHERE kod = 619981;
UPDATE ruian_katastr SET nazev = 'Staročernsko' WHERE kod = 619990;
UPDATE ruian_katastr SET nazev = 'Černava' WHERE kod = 620017;
UPDATE ruian_katastr SET nazev = 'Rájec u Černavy' WHERE kod = 620033;
UPDATE ruian_katastr SET nazev = 'Černčice u Loun' WHERE kod = 620041;
UPDATE ruian_katastr SET nazev = 'Obora u Loun' WHERE kod = 620050;
UPDATE ruian_katastr SET nazev = 'Černčice' WHERE kod = 620068;
UPDATE ruian_katastr SET nazev = 'Černčín' WHERE kod = 620076;
UPDATE ruian_katastr SET nazev = 'Černé Voděrady' WHERE kod = 620084;
UPDATE ruian_katastr SET nazev = 'Černěves' WHERE kod = 620092;
UPDATE ruian_katastr SET nazev = 'Černice' WHERE kod = 620106;
UPDATE ruian_katastr SET nazev = 'Radobyčice' WHERE kod = 620122;
UPDATE ruian_katastr SET nazev = 'Černíč' WHERE kod = 620131;
UPDATE ruian_katastr SET nazev = 'Myslůvka' WHERE kod = 620149;
UPDATE ruian_katastr SET nazev = 'Slaviboř' WHERE kod = 620157;
UPDATE ruian_katastr SET nazev = 'Černičí' WHERE kod = 620165;
UPDATE ruian_katastr SET nazev = 'Černíkov' WHERE kod = 620190;
UPDATE ruian_katastr SET nazev = 'Černíkovice' WHERE kod = 620203;
UPDATE ruian_katastr SET nazev = 'Domašín u Černíkovic' WHERE kod = 620211;
UPDATE ruian_katastr SET nazev = 'Černíky' WHERE kod = 620220;
UPDATE ruian_katastr SET nazev = 'Černilov' WHERE kod = 620238;
UPDATE ruian_katastr SET nazev = 'Černín' WHERE kod = 620246;
UPDATE ruian_katastr SET nazev = 'Bahno' WHERE kod = 620254;
UPDATE ruian_katastr SET nazev = 'Černíny' WHERE kod = 620262;
UPDATE ruian_katastr SET nazev = 'Hetlín' WHERE kod = 620271;
UPDATE ruian_katastr SET nazev = 'Předbořice' WHERE kod = 620297;
UPDATE ruian_katastr SET nazev = 'Štipoklasy u Černín' WHERE kod = 620301;
UPDATE ruian_katastr SET nazev = 'Zdeslavice u Černín' WHERE kod = 620327;
UPDATE ruian_katastr SET nazev = 'Černiv' WHERE kod = 620335;
UPDATE ruian_katastr SET nazev = 'Černochov' WHERE kod = 620343;
UPDATE ruian_katastr SET nazev = 'Černolice' WHERE kod = 620351;
UPDATE ruian_katastr SET nazev = 'Černošice' WHERE kod = 620386;
UPDATE ruian_katastr SET nazev = 'Černošín' WHERE kod = 620408;
UPDATE ruian_katastr SET nazev = 'Krásné Údolí u Černošína' WHERE kod = 620416;
UPDATE ruian_katastr SET nazev = 'Lažany u Černošína' WHERE kod = 620424;
UPDATE ruian_katastr SET nazev = 'Ostrovce' WHERE kod = 620441;
UPDATE ruian_katastr SET nazev = 'Pytlov' WHERE kod = 620459;
UPDATE ruian_katastr SET nazev = 'Třebel' WHERE kod = 620467;
UPDATE ruian_katastr SET nazev = 'Záhoří u Černošína' WHERE kod = 620475;
UPDATE ruian_katastr SET nazev = 'Černotín' WHERE kod = 620483;
UPDATE ruian_katastr SET nazev = 'Boleslav' WHERE kod = 620491;
UPDATE ruian_katastr SET nazev = 'Černousy' WHERE kod = 620505;
UPDATE ruian_katastr SET nazev = 'Ves' WHERE kod = 620513;
UPDATE ruian_katastr SET nazev = 'Černov' WHERE kod = 620521;
UPDATE ruian_katastr SET nazev = 'Černovice u Tábora' WHERE kod = 620530;
UPDATE ruian_katastr SET nazev = 'Svatava u Černovic' WHERE kod = 620564;
UPDATE ruian_katastr SET nazev = 'Čerňovice' WHERE kod = 620581;
UPDATE ruian_katastr SET nazev = 'Černovice u Chomutova' WHERE kod = 620599;
UPDATE ruian_katastr SET nazev = 'Černovice u Kunštátu' WHERE kod = 620602;
UPDATE ruian_katastr SET nazev = 'Černovír u Ústí nad Orlicí' WHERE kod = 620611;
UPDATE ruian_katastr SET nazev = 'Černožice nad Labem' WHERE kod = 620629;
UPDATE ruian_katastr SET nazev = 'Černuc' WHERE kod = 620637;
UPDATE ruian_katastr SET nazev = 'Loucká' WHERE kod = 620645;
UPDATE ruian_katastr SET nazev = 'Miletice u Velvar' WHERE kod = 620653;
UPDATE ruian_katastr SET nazev = 'Černvír' WHERE kod = 620661;
UPDATE ruian_katastr SET nazev = 'Černý Důl' WHERE kod = 620670;
UPDATE ruian_katastr SET nazev = 'Čistá v Krkonoších' WHERE kod = 620688;
UPDATE ruian_katastr SET nazev = 'Fořt' WHERE kod = 620696;
UPDATE ruian_katastr SET nazev = 'Červená Lhota' WHERE kod = 620700;
UPDATE ruian_katastr SET nazev = 'Červená Řečice' WHERE kod = 620718;
UPDATE ruian_katastr SET nazev = 'Červená Třemešná' WHERE kod = 620726;
UPDATE ruian_katastr SET nazev = 'Bílá Voda' WHERE kod = 620751;
UPDATE ruian_katastr SET nazev = 'Červená Voda' WHERE kod = 620769;
UPDATE ruian_katastr SET nazev = 'Dolní Orlice' WHERE kod = 620777;
UPDATE ruian_katastr SET nazev = 'Horní Orlice' WHERE kod = 620793;
UPDATE ruian_katastr SET nazev = 'Mlýnice u Červené Vody' WHERE kod = 620807;
UPDATE ruian_katastr SET nazev = 'Mlýnický Dvůr' WHERE kod = 620815;
UPDATE ruian_katastr SET nazev = 'Moravský Karlov' WHERE kod = 620823;
UPDATE ruian_katastr SET nazev = 'Šanov u Červené Vody' WHERE kod = 620831;
UPDATE ruian_katastr SET nazev = 'Bludov v Čechách' WHERE kod = 620840;
UPDATE ruian_katastr SET nazev = 'Červené Janovice' WHERE kod = 620858;
UPDATE ruian_katastr SET nazev = 'Chvalov u Červených Janovic' WHERE kod = 620866;
UPDATE ruian_katastr SET nazev = 'Opatovice I' WHERE kod = 620882;
UPDATE ruian_katastr SET nazev = 'Víckovice' WHERE kod = 620891;
UPDATE ruian_katastr SET nazev = 'Vilémovice u Červených Janovic' WHERE kod = 620904;
UPDATE ruian_katastr SET nazev = 'Zhoř u Červených Janovic' WHERE kod = 620912;
UPDATE ruian_katastr SET nazev = 'Červené Pečky' WHERE kod = 620947;
UPDATE ruian_katastr SET nazev = 'Dolany u Červených Peček' WHERE kod = 620963;
UPDATE ruian_katastr SET nazev = 'Červené Poříčí' WHERE kod = 620980;
UPDATE ruian_katastr SET nazev = 'Jíno' WHERE kod = 620998;
UPDATE ruian_katastr SET nazev = 'Kaliště u Červeného Poříčí' WHERE kod = 621005;
UPDATE ruian_katastr SET nazev = 'Stropčice' WHERE kod = 621013;
UPDATE ruian_katastr SET nazev = 'Třebýcinka' WHERE kod = 621021;
UPDATE ruian_katastr SET nazev = 'Červenka' WHERE kod = 621030;
UPDATE ruian_katastr SET nazev = 'Tři Dvory u Litovle' WHERE kod = 621056;
UPDATE ruian_katastr SET nazev = 'Červený Hrádek u Dačic' WHERE kod = 621064;
UPDATE ruian_katastr SET nazev = 'Jersice' WHERE kod = 621072;
UPDATE ruian_katastr SET nazev = 'Červený Hrádek u Plzně' WHERE kod = 621081;
UPDATE ruian_katastr SET nazev = 'Bohdašín nad Olešnicí' WHERE kod = 621099;
UPDATE ruian_katastr SET nazev = 'Červený Kostelec' WHERE kod = 621102;
UPDATE ruian_katastr SET nazev = 'Horní Kostelec' WHERE kod = 621111;
UPDATE ruian_katastr SET nazev = 'Lhota za Červeným Kostelcem' WHERE kod = 621129;
UPDATE ruian_katastr SET nazev = 'Stolín' WHERE kod = 621145;
UPDATE ruian_katastr SET nazev = 'Červený Újezd u Miličína' WHERE kod = 621153;
UPDATE ruian_katastr SET nazev = 'Horní Borek' WHERE kod = 621161;
UPDATE ruian_katastr SET nazev = 'Červený Újezd' WHERE kod = 621200;
UPDATE ruian_katastr SET nazev = 'Česká' WHERE kod = 621226;
UPDATE ruian_katastr SET nazev = 'Cibotín' WHERE kod = 621234;
UPDATE ruian_katastr SET nazev = 'Česká Bělá' WHERE kod = 621242;
UPDATE ruian_katastr SET nazev = 'Česká Bříza' WHERE kod = 621251;
UPDATE ruian_katastr SET nazev = 'Česká Čermná' WHERE kod = 621269;
UPDATE ruian_katastr SET nazev = 'Česká Jablonná' WHERE kod = 621277;
UPDATE ruian_katastr SET nazev = 'Česká Kamenice' WHERE kod = 621285;
UPDATE ruian_katastr SET nazev = 'Dolní Kamenice' WHERE kod = 621293;
UPDATE ruian_katastr SET nazev = 'Horní Kamenice' WHERE kod = 621315;
UPDATE ruian_katastr SET nazev = 'Česká Kubice' WHERE kod = 621366;
UPDATE ruian_katastr SET nazev = 'Česká Lípa' WHERE kod = 621382;
UPDATE ruian_katastr SET nazev = 'Stará Lípa' WHERE kod = 621439;
UPDATE ruian_katastr SET nazev = 'Dubice u České Lípy' WHERE kod = 621528;
UPDATE ruian_katastr SET nazev = 'Dolní Libchava' WHERE kod = 621544;
UPDATE ruian_katastr SET nazev = 'Lada' WHERE kod = 621595;
UPDATE ruian_katastr SET nazev = 'Častolovice u České Lípy' WHERE kod = 621609;
UPDATE ruian_katastr SET nazev = 'Česká Metuje' WHERE kod = 621625;
UPDATE ruian_katastr SET nazev = 'Skalka u České Metuje' WHERE kod = 621633;
UPDATE ruian_katastr SET nazev = 'Metujka' WHERE kod = 621641;
UPDATE ruian_katastr SET nazev = 'Česká Olešná' WHERE kod = 621650;
UPDATE ruian_katastr SET nazev = 'Česká Rybná' WHERE kod = 621668;
UPDATE ruian_katastr SET nazev = 'Česká Rybná u Žamberka' WHERE kod = 621676;
UPDATE ruian_katastr SET nazev = 'Česká Skalice' WHERE kod = 621684;
UPDATE ruian_katastr SET nazev = 'Malá Skalice' WHERE kod = 621692;
UPDATE ruian_katastr SET nazev = 'Ratibořice u České Skalice' WHERE kod = 621706;
UPDATE ruian_katastr SET nazev = 'Říkov' WHERE kod = 621714;
UPDATE ruian_katastr SET nazev = 'Spyta' WHERE kod = 621722;
UPDATE ruian_katastr SET nazev = 'Zájezd u České Skalice' WHERE kod = 621731;
UPDATE ruian_katastr SET nazev = 'Zlíč' WHERE kod = 621749;
UPDATE ruian_katastr SET nazev = 'Česká Třebová' WHERE kod = 621757;
UPDATE ruian_katastr SET nazev = 'Parník' WHERE kod = 621820;
UPDATE ruian_katastr SET nazev = 'Česká Ves' WHERE kod = 621901;
UPDATE ruian_katastr SET nazev = 'České Budějovice 1' WHERE kod = 621919;
UPDATE ruian_katastr SET nazev = 'České Budějovice 2' WHERE kod = 621943;
UPDATE ruian_katastr SET nazev = 'České Budějovice 3' WHERE kod = 622052;
UPDATE ruian_katastr SET nazev = 'České Budějovice 4' WHERE kod = 622222;
UPDATE ruian_katastr SET nazev = 'České Budějovice 5' WHERE kod = 622281;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Českých Budějovic' WHERE kod = 622320;
UPDATE ruian_katastr SET nazev = 'České Budějovice 6' WHERE kod = 622346;
UPDATE ruian_katastr SET nazev = 'České Budějovice 7' WHERE kod = 622486;
UPDATE ruian_katastr SET nazev = 'České Hamry u Vejprt' WHERE kod = 622541;
UPDATE ruian_katastr SET nazev = 'České Heřmanice' WHERE kod = 622567;
UPDATE ruian_katastr SET nazev = 'České Kopisty' WHERE kod = 622583;
UPDATE ruian_katastr SET nazev = 'Počaply u Terezína' WHERE kod = 622591;
UPDATE ruian_katastr SET nazev = 'České Lhotice' WHERE kod = 622605;
UPDATE ruian_katastr SET nazev = 'Hodonín u Nasavrk' WHERE kod = 622613;
UPDATE ruian_katastr SET nazev = 'České Libchavy' WHERE kod = 622630;
UPDATE ruian_katastr SET nazev = 'České Meziříčí' WHERE kod = 622656;
UPDATE ruian_katastr SET nazev = 'Rohenice' WHERE kod = 622699;
UPDATE ruian_katastr SET nazev = 'České Petrovice' WHERE kod = 622702;
UPDATE ruian_katastr SET nazev = 'České Velenice' WHERE kod = 622711;
UPDATE ruian_katastr SET nazev = 'České Vrbné' WHERE kod = 622729;
UPDATE ruian_katastr SET nazev = 'Český Brod' WHERE kod = 622737;
UPDATE ruian_katastr SET nazev = 'Štolmíř' WHERE kod = 622818;
UPDATE ruian_katastr SET nazev = 'Liblice u Českého Brodu' WHERE kod = 622826;
UPDATE ruian_katastr SET nazev = 'Český Dub' WHERE kod = 622842;
UPDATE ruian_katastr SET nazev = 'Loukovičky' WHERE kod = 622877;
UPDATE ruian_katastr SET nazev = 'Smržov u Českého Dubu' WHERE kod = 622893;
UPDATE ruian_katastr SET nazev = 'Český Jiřetín' WHERE kod = 622915;
UPDATE ruian_katastr SET nazev = 'Fláje' WHERE kod = 622923;
UPDATE ruian_katastr SET nazev = 'Český Krumlov' WHERE kod = 622931;
UPDATE ruian_katastr SET nazev = 'Vyšný' WHERE kod = 623016;
UPDATE ruian_katastr SET nazev = 'Slupenec' WHERE kod = 623059;
UPDATE ruian_katastr SET nazev = 'Kladné-Dobrkovice' WHERE kod = 623075;
UPDATE ruian_katastr SET nazev = 'Přísečná-Domoradice' WHERE kod = 623083;
UPDATE ruian_katastr SET nazev = 'Spolí-Nové Spolí' WHERE kod = 623091;
UPDATE ruian_katastr SET nazev = 'Český Rudolec' WHERE kod = 623105;
UPDATE ruian_katastr SET nazev = 'Dolní Bolíkov-Nová Ves' WHERE kod = 623113;
UPDATE ruian_katastr SET nazev = 'Stoječín' WHERE kod = 623130;
UPDATE ruian_katastr SET nazev = 'Český Šternberk' WHERE kod = 623156;
UPDATE ruian_katastr SET nazev = 'Český Těšín' WHERE kod = 623164;
UPDATE ruian_katastr SET nazev = 'Dolní Žukov' WHERE kod = 623261;
UPDATE ruian_katastr SET nazev = 'Český Újezd' WHERE kod = 623270;
UPDATE ruian_katastr SET nazev = 'Střížovice u Ústí nad Labem' WHERE kod = 623288;
UPDATE ruian_katastr SET nazev = 'Čestice' WHERE kod = 623296;
UPDATE ruian_katastr SET nazev = 'Nuzín' WHERE kod = 623318;
UPDATE ruian_katastr SET nazev = 'Radešov u Čestic' WHERE kod = 623326;
UPDATE ruian_katastr SET nazev = 'Čestice u Častolovic' WHERE kod = 623351;
UPDATE ruian_katastr SET nazev = 'Čestín u Jankova' WHERE kod = 623377;
UPDATE ruian_katastr SET nazev = 'Čenovice' WHERE kod = 623385;
UPDATE ruian_katastr SET nazev = 'Čestín' WHERE kod = 623393;
UPDATE ruian_katastr SET nazev = 'Kasanice' WHERE kod = 623407;
UPDATE ruian_katastr SET nazev = 'Kněž u Čestína' WHERE kod = 623415;
UPDATE ruian_katastr SET nazev = 'Polipsy' WHERE kod = 623431;
UPDATE ruian_katastr SET nazev = 'Čestlice' WHERE kod = 623440;
UPDATE ruian_katastr SET nazev = 'Nupaky' WHERE kod = 623458;
UPDATE ruian_katastr SET nazev = 'Češov' WHERE kod = 623466;
UPDATE ruian_katastr SET nazev = 'Liběšice' WHERE kod = 623474;
UPDATE ruian_katastr SET nazev = 'Číčenice' WHERE kod = 623482;
UPDATE ruian_katastr SET nazev = 'Číčov' WHERE kod = 623512;
UPDATE ruian_katastr SET nazev = 'Hořice' WHERE kod = 623521;
UPDATE ruian_katastr SET nazev = 'Číčová' WHERE kod = 623539;
UPDATE ruian_katastr SET nazev = 'Malé Číčovice' WHERE kod = 623547;
UPDATE ruian_katastr SET nazev = 'Velké Číčovice' WHERE kod = 623555;
UPDATE ruian_katastr SET nazev = 'Číhalín' WHERE kod = 623563;
UPDATE ruian_katastr SET nazev = 'Číhaň' WHERE kod = 623571;
UPDATE ruian_katastr SET nazev = 'Křížovice u Číhaně' WHERE kod = 623580;
UPDATE ruian_katastr SET nazev = 'Plánička' WHERE kod = 623598;
UPDATE ruian_katastr SET nazev = 'Vracov u Číhaně' WHERE kod = 623601;
UPDATE ruian_katastr SET nazev = 'Zdebořice' WHERE kod = 623610;
UPDATE ruian_katastr SET nazev = 'Budeč u Číhané' WHERE kod = 623628;
UPDATE ruian_katastr SET nazev = 'Číhaná' WHERE kod = 623636;
UPDATE ruian_katastr SET nazev = 'Štipoklasy u Číhané' WHERE kod = 623644;
UPDATE ruian_katastr SET nazev = 'Vojtěšín' WHERE kod = 623652;
UPDATE ruian_katastr SET nazev = 'Číhošť' WHERE kod = 623661;
UPDATE ruian_katastr SET nazev = 'Hlohov' WHERE kod = 623679;
UPDATE ruian_katastr SET nazev = 'Hroznětín u Číhoště' WHERE kod = 623687;
UPDATE ruian_katastr SET nazev = 'Tunochody' WHERE kod = 623695;
UPDATE ruian_katastr SET nazev = 'Zdeslavice' WHERE kod = 623709;
UPDATE ruian_katastr SET nazev = 'Číhovice' WHERE kod = 623717;
UPDATE ruian_katastr SET nazev = 'Čichalov' WHERE kod = 623725;
UPDATE ruian_katastr SET nazev = 'Kovářov u Žlutic' WHERE kod = 623733;
UPDATE ruian_katastr SET nazev = 'Štoutov' WHERE kod = 623741;
UPDATE ruian_katastr SET nazev = 'Brtnický Číchov' WHERE kod = 623750;
UPDATE ruian_katastr SET nazev = 'Třebíčský Číchov' WHERE kod = 623768;
UPDATE ruian_katastr SET nazev = 'Čichtice' WHERE kod = 623776;
UPDATE ruian_katastr SET nazev = 'Čikov' WHERE kod = 623784;
UPDATE ruian_katastr SET nazev = 'Čilec' WHERE kod = 623792;
UPDATE ruian_katastr SET nazev = 'Čím' WHERE kod = 623806;
UPDATE ruian_katastr SET nazev = 'Čimelice' WHERE kod = 623822;
UPDATE ruian_katastr SET nazev = 'Krsice' WHERE kod = 623831;
UPDATE ruian_katastr SET nazev = 'Rakovice' WHERE kod = 623849;
UPDATE ruian_katastr SET nazev = 'Číměř' WHERE kod = 623865;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Číměře' WHERE kod = 623873;
UPDATE ruian_katastr SET nazev = 'Potočná u Číměře' WHERE kod = 623881;
UPDATE ruian_katastr SET nazev = 'Číměř nad Jihlavou' WHERE kod = 623890;
UPDATE ruian_katastr SET nazev = 'Střížov u Třebíče' WHERE kod = 623903;
UPDATE ruian_katastr SET nazev = 'Čímice u Sušice' WHERE kod = 623911;
UPDATE ruian_katastr SET nazev = 'Činěves' WHERE kod = 623920;
UPDATE ruian_katastr SET nazev = 'Čisovice' WHERE kod = 623946;
UPDATE ruian_katastr SET nazev = 'Čistá u Mladé Boleslavi' WHERE kod = 623954;
UPDATE ruian_katastr SET nazev = 'Čistá u Rakovníka' WHERE kod = 623962;
UPDATE ruian_katastr SET nazev = 'Strachovice' WHERE kod = 623971;
UPDATE ruian_katastr SET nazev = 'Čistá u Horek' WHERE kod = 623989;
UPDATE ruian_katastr SET nazev = 'Čistá u Litomyšle' WHERE kod = 624004;
UPDATE ruian_katastr SET nazev = 'Čistěves' WHERE kod = 624012;
UPDATE ruian_katastr SET nazev = 'Čivice' WHERE kod = 624021;
UPDATE ruian_katastr SET nazev = 'Čižice' WHERE kod = 624039;
UPDATE ruian_katastr SET nazev = 'Nebílovský Borek' WHERE kod = 624047;
UPDATE ruian_katastr SET nazev = 'Štěnovický Borek' WHERE kod = 624055;
UPDATE ruian_katastr SET nazev = 'Čížkov' WHERE kod = 624063;
UPDATE ruian_katastr SET nazev = 'Čížkov u Blovic' WHERE kod = 624071;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Čížkova' WHERE kod = 624098;
UPDATE ruian_katastr SET nazev = 'Čížkovice' WHERE kod = 624101;
UPDATE ruian_katastr SET nazev = 'Čížkrajice' WHERE kod = 624128;
UPDATE ruian_katastr SET nazev = 'Mezilesí u Trhových Svinů' WHERE kod = 624144;
UPDATE ruian_katastr SET nazev = 'Borečnice' WHERE kod = 624152;
UPDATE ruian_katastr SET nazev = 'Bošovice u Čížové' WHERE kod = 624161;
UPDATE ruian_katastr SET nazev = 'Krašovice u Čížové' WHERE kod = 624187;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Čížové' WHERE kod = 624195;
UPDATE ruian_katastr SET nazev = 'Zlivice' WHERE kod = 624209;
UPDATE ruian_katastr SET nazev = 'Čkyně' WHERE kod = 624217;
UPDATE ruian_katastr SET nazev = 'Dolany u Čkyně' WHERE kod = 624225;
UPDATE ruian_katastr SET nazev = 'Horosedly u Čkyně' WHERE kod = 624241;
UPDATE ruian_katastr SET nazev = 'Lčovice' WHERE kod = 624250;
UPDATE ruian_katastr SET nazev = 'Onšovice u Čkyně' WHERE kod = 624268;
UPDATE ruian_katastr SET nazev = 'Předenice u Čkyně' WHERE kod = 624276;
UPDATE ruian_katastr SET nazev = 'Spůle u Čkyně' WHERE kod = 624284;
UPDATE ruian_katastr SET nazev = 'Člunek' WHERE kod = 624306;
UPDATE ruian_katastr SET nazev = 'Kunějov' WHERE kod = 624314;
UPDATE ruian_katastr SET nazev = 'Lomy u Kunžaku' WHERE kod = 624322;
UPDATE ruian_katastr SET nazev = 'Čtyřkoly' WHERE kod = 624331;
UPDATE ruian_katastr SET nazev = 'Lštění' WHERE kod = 624357;
UPDATE ruian_katastr SET nazev = 'Čučice' WHERE kod = 624373;
UPDATE ruian_katastr SET nazev = 'Čunín' WHERE kod = 624381;
UPDATE ruian_katastr SET nazev = 'Křemenec' WHERE kod = 624390;
UPDATE ruian_katastr SET nazev = 'Dačice' WHERE kod = 624403;
UPDATE ruian_katastr SET nazev = 'Dalečín' WHERE kod = 624462;
UPDATE ruian_katastr SET nazev = 'Hluboké u Dalečína' WHERE kod = 624471;
UPDATE ruian_katastr SET nazev = 'Veselí u Dalečína' WHERE kod = 624489;
UPDATE ruian_katastr SET nazev = 'Daleké Dušníky' WHERE kod = 624497;
UPDATE ruian_katastr SET nazev = 'Druhlice' WHERE kod = 624501;
UPDATE ruian_katastr SET nazev = 'Dalešice nad Vltavou' WHERE kod = 624519;
UPDATE ruian_katastr SET nazev = 'Dalešice' WHERE kod = 624527;
UPDATE ruian_katastr SET nazev = 'Stropešín' WHERE kod = 624535;
UPDATE ruian_katastr SET nazev = 'Dalkovice' WHERE kod = 624543;
UPDATE ruian_katastr SET nazev = 'Dalov' WHERE kod = 624551;
UPDATE ruian_katastr SET nazev = 'Dalovice u Mladé Boleslavi' WHERE kod = 624578;
UPDATE ruian_katastr SET nazev = 'Dalovice' WHERE kod = 624586;
UPDATE ruian_katastr SET nazev = 'Všeborovice' WHERE kod = 624594;
UPDATE ruian_katastr SET nazev = 'Vysoká u Dalovic' WHERE kod = 624608;
UPDATE ruian_katastr SET nazev = 'Dalovy' WHERE kod = 624624;
UPDATE ruian_katastr SET nazev = 'Dambořice' WHERE kod = 624632;
UPDATE ruian_katastr SET nazev = 'Daměnice' WHERE kod = 624641;
UPDATE ruian_katastr SET nazev = 'Damíč' WHERE kod = 624659;
UPDATE ruian_katastr SET nazev = 'Damnice' WHERE kod = 624675;
UPDATE ruian_katastr SET nazev = 'Damníkov' WHERE kod = 624683;
UPDATE ruian_katastr SET nazev = 'Trpík' WHERE kod = 624691;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Damnova' WHERE kod = 624705;
UPDATE ruian_katastr SET nazev = 'Damnov' WHERE kod = 624713;
UPDATE ruian_katastr SET nazev = 'Velká Ves u Damnova' WHERE kod = 624721;
UPDATE ruian_katastr SET nazev = 'Daňkovice' WHERE kod = 624730;
UPDATE ruian_katastr SET nazev = 'Darkovice' WHERE kod = 624756;
UPDATE ruian_katastr SET nazev = 'Daskabát' WHERE kod = 624764;
UPDATE ruian_katastr SET nazev = 'Dasnice' WHERE kod = 624772;
UPDATE ruian_katastr SET nazev = 'Dasný' WHERE kod = 624781;
UPDATE ruian_katastr SET nazev = 'Dašice' WHERE kod = 624799;
UPDATE ruian_katastr SET nazev = 'Prachovice u Dašic' WHERE kod = 624802;
UPDATE ruian_katastr SET nazev = 'Davle' WHERE kod = 624811;
UPDATE ruian_katastr SET nazev = 'Sázava u Davle' WHERE kod = 624837;
UPDATE ruian_katastr SET nazev = 'Deblín' WHERE kod = 624853;
UPDATE ruian_katastr SET nazev = 'Děbolín' WHERE kod = 624861;
UPDATE ruian_katastr SET nazev = 'Matná' WHERE kod = 624870;
UPDATE ruian_katastr SET nazev = 'Debrník' WHERE kod = 624888;
UPDATE ruian_katastr SET nazev = 'Děčany' WHERE kod = 624896;
UPDATE ruian_katastr SET nazev = 'Lukohořany' WHERE kod = 624900;
UPDATE ruian_katastr SET nazev = 'Semeč' WHERE kod = 624918;
UPDATE ruian_katastr SET nazev = 'Děčín' WHERE kod = 624926;
UPDATE ruian_katastr SET nazev = 'Děčín-Staré Město' WHERE kod = 625035;
UPDATE ruian_katastr SET nazev = 'Vilsnice' WHERE kod = 625078;
UPDATE ruian_katastr SET nazev = 'Chrochvice' WHERE kod = 625086;
UPDATE ruian_katastr SET nazev = 'Podmokly' WHERE kod = 625141;
UPDATE ruian_katastr SET nazev = 'Horní Oldřichov' WHERE kod = 625221;
UPDATE ruian_katastr SET nazev = 'Bynov' WHERE kod = 625230;
UPDATE ruian_katastr SET nazev = 'Bělá u Děčína' WHERE kod = 625248;
UPDATE ruian_katastr SET nazev = 'Maxičky' WHERE kod = 625272;
UPDATE ruian_katastr SET nazev = 'Prostřední Žleb' WHERE kod = 625302;
UPDATE ruian_katastr SET nazev = 'Loubí u Děčína' WHERE kod = 625311;
UPDATE ruian_katastr SET nazev = 'Dědice' WHERE kod = 625329;
UPDATE ruian_katastr SET nazev = 'Dědová' WHERE kod = 625337;
UPDATE ruian_katastr SET nazev = 'Černice u Defurových Lažan' WHERE kod = 625345;
UPDATE ruian_katastr SET nazev = 'Defurovy Lažany' WHERE kod = 625353;
UPDATE ruian_katastr SET nazev = 'Újezd u Chanovic' WHERE kod = 625361;
UPDATE ruian_katastr SET nazev = 'Dehtáře' WHERE kod = 625370;
UPDATE ruian_katastr SET nazev = 'Milotice' WHERE kod = 625388;
UPDATE ruian_katastr SET nazev = 'Onšovice u Dehtářů' WHERE kod = 625396;
UPDATE ruian_katastr SET nazev = 'Vadčice' WHERE kod = 625400;
UPDATE ruian_katastr SET nazev = 'Děhylov' WHERE kod = 625418;
UPDATE ruian_katastr SET nazev = 'Děkanovice' WHERE kod = 625426;
UPDATE ruian_katastr SET nazev = 'Děkov' WHERE kod = 625434;
UPDATE ruian_katastr SET nazev = 'Vlkov u Rakovníka' WHERE kod = 625451;
UPDATE ruian_katastr SET nazev = 'Datelov' WHERE kod = 625469;
UPDATE ruian_katastr SET nazev = 'Děpoltice' WHERE kod = 625477;
UPDATE ruian_katastr SET nazev = 'Divišovice u Děpoltic' WHERE kod = 625485;
UPDATE ruian_katastr SET nazev = 'Městiště u Děpoltic' WHERE kod = 625493;
UPDATE ruian_katastr SET nazev = 'Oldřichovice u Děpoltic' WHERE kod = 625507;
UPDATE ruian_katastr SET nazev = 'Děpoltovice' WHERE kod = 625515;
UPDATE ruian_katastr SET nazev = 'Nivy' WHERE kod = 625523;
UPDATE ruian_katastr SET nazev = 'Odeř' WHERE kod = 625531;
UPDATE ruian_katastr SET nazev = 'Derflice' WHERE kod = 625540;
UPDATE ruian_katastr SET nazev = 'Děrné' WHERE kod = 625558;
UPDATE ruian_katastr SET nazev = 'Desná I' WHERE kod = 625574;
UPDATE ruian_katastr SET nazev = 'Desná II' WHERE kod = 625582;
UPDATE ruian_katastr SET nazev = 'Desná III' WHERE kod = 625591;
UPDATE ruian_katastr SET nazev = 'Desná u Litomyšle' WHERE kod = 625639;
UPDATE ruian_katastr SET nazev = 'Dešenice' WHERE kod = 625647;
UPDATE ruian_katastr SET nazev = 'Milence' WHERE kod = 625655;
UPDATE ruian_katastr SET nazev = 'Žiznětice' WHERE kod = 625663;
UPDATE ruian_katastr SET nazev = 'Matějovice u Dešenic' WHERE kod = 625671;
UPDATE ruian_katastr SET nazev = 'Dančovice' WHERE kod = 625680;
UPDATE ruian_katastr SET nazev = 'Dešná u Dačic' WHERE kod = 625698;
UPDATE ruian_katastr SET nazev = 'Plačovice' WHERE kod = 625701;
UPDATE ruian_katastr SET nazev = 'Dešná u Zlína' WHERE kod = 625710;
UPDATE ruian_katastr SET nazev = 'Velký Dešov' WHERE kod = 625728;
UPDATE ruian_katastr SET nazev = 'Malý Dešov' WHERE kod = 625736;
UPDATE ruian_katastr SET nazev = 'Deštná u Jindřichova Hradce' WHERE kod = 625744;
UPDATE ruian_katastr SET nazev = 'Deštná' WHERE kod = 625761;
UPDATE ruian_katastr SET nazev = 'Horní Smržov' WHERE kod = 625779;
UPDATE ruian_katastr SET nazev = 'Roubanina' WHERE kod = 625795;
UPDATE ruian_katastr SET nazev = 'Rumberk' WHERE kod = 625809;
UPDATE ruian_katastr SET nazev = 'Deštné v Orlických horách' WHERE kod = 625817;
UPDATE ruian_katastr SET nazev = 'Jedlová v Orlických horách' WHERE kod = 625833;
UPDATE ruian_katastr SET nazev = 'Deštné' WHERE kod = 625876;
UPDATE ruian_katastr SET nazev = 'Deštnice' WHERE kod = 625892;
UPDATE ruian_katastr SET nazev = 'Sádek u Deštnice' WHERE kod = 625906;
UPDATE ruian_katastr SET nazev = 'Brodek' WHERE kod = 625914;
UPDATE ruian_katastr SET nazev = 'Dětenice' WHERE kod = 625922;
UPDATE ruian_katastr SET nazev = 'Osenice' WHERE kod = 625931;
UPDATE ruian_katastr SET nazev = 'Dětkovice u Prostějova' WHERE kod = 625949;
UPDATE ruian_katastr SET nazev = 'Dětkovice' WHERE kod = 625957;
UPDATE ruian_katastr SET nazev = 'Dětmarovice' WHERE kod = 625965;
UPDATE ruian_katastr SET nazev = 'Koukolná' WHERE kod = 625973;
UPDATE ruian_katastr SET nazev = 'Albrechtice u Frýdlantu' WHERE kod = 625981;
UPDATE ruian_katastr SET nazev = 'Dětřichov u Frýdlantu' WHERE kod = 625990;
UPDATE ruian_katastr SET nazev = 'Heřmanice u Frýdlantu' WHERE kod = 626007;
UPDATE ruian_katastr SET nazev = 'Kristiánov' WHERE kod = 626015;
UPDATE ruian_katastr SET nazev = 'Dětřichov u Svitav' WHERE kod = 626031;
UPDATE ruian_katastr SET nazev = 'Dětřichov nad Bystřicí' WHERE kod = 626066;
UPDATE ruian_katastr SET nazev = 'Dětřichov u Moravské Třebové' WHERE kod = 626074;
UPDATE ruian_katastr SET nazev = 'Díly' WHERE kod = 626082;
UPDATE ruian_katastr SET nazev = 'Dírná' WHERE kod = 626091;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Dírné' WHERE kod = 626104;
UPDATE ruian_katastr SET nazev = 'Záříčí u Dírné' WHERE kod = 626112;
UPDATE ruian_katastr SET nazev = 'Závsí' WHERE kod = 626121;
UPDATE ruian_katastr SET nazev = 'Diváky' WHERE kod = 626139;
UPDATE ruian_katastr SET nazev = 'Dívčí Hrad' WHERE kod = 626147;
UPDATE ruian_katastr SET nazev = 'Sádek u Dívčího Hradu' WHERE kod = 626155;
UPDATE ruian_katastr SET nazev = 'Životice u Dívčího Hradu' WHERE kod = 626163;
UPDATE ruian_katastr SET nazev = 'Dívčice' WHERE kod = 626180;
UPDATE ruian_katastr SET nazev = 'Mydlovary u Dívčic' WHERE kod = 626210;
UPDATE ruian_katastr SET nazev = 'Divec' WHERE kod = 626252;
UPDATE ruian_katastr SET nazev = 'Divišov u Benešova' WHERE kod = 626261;
UPDATE ruian_katastr SET nazev = 'Bolechovice I' WHERE kod = 626279;
UPDATE ruian_katastr SET nazev = 'Divišovice' WHERE kod = 626287;
UPDATE ruian_katastr SET nazev = 'Dlažkovice' WHERE kod = 626317;
UPDATE ruian_katastr SET nazev = 'Buková u Klatov' WHERE kod = 626325;
UPDATE ruian_katastr SET nazev = 'Dlažov' WHERE kod = 626333;
UPDATE ruian_katastr SET nazev = 'Miletice u Dlažova' WHERE kod = 626341;
UPDATE ruian_katastr SET nazev = 'Soustov' WHERE kod = 626368;
UPDATE ruian_katastr SET nazev = 'Dlouhá Brtnice' WHERE kod = 626376;
UPDATE ruian_katastr SET nazev = 'Dlouhá Lhota u Mladé Boleslavi' WHERE kod = 626384;
UPDATE ruian_katastr SET nazev = 'Dlouhá Lhota u Dobříše' WHERE kod = 626392;
UPDATE ruian_katastr SET nazev = 'Dlouhá Lhota u Tábora' WHERE kod = 626406;
UPDATE ruian_katastr SET nazev = 'Dlouhá Lhota' WHERE kod = 626414;
UPDATE ruian_katastr SET nazev = 'Dlouhá Lomnice' WHERE kod = 626422;
UPDATE ruian_katastr SET nazev = 'Dlouhá Loučka' WHERE kod = 626431;
UPDATE ruian_katastr SET nazev = 'Dolní Dlouhá Loučka' WHERE kod = 626449;
UPDATE ruian_katastr SET nazev = 'Horní Dlouhá Loučka' WHERE kod = 626457;
UPDATE ruian_katastr SET nazev = 'Křivá' WHERE kod = 626465;
UPDATE ruian_katastr SET nazev = 'Plinkout' WHERE kod = 626473;
UPDATE ruian_katastr SET nazev = 'Dlouhá Stráň' WHERE kod = 626490;
UPDATE ruian_katastr SET nazev = 'Dlouhá Třebová' WHERE kod = 626503;
UPDATE ruian_katastr SET nazev = 'Bohdašice' WHERE kod = 626520;
UPDATE ruian_katastr SET nazev = 'Dlouhá Ves u Sušice' WHERE kod = 626538;
UPDATE ruian_katastr SET nazev = 'Janovice u Sušice' WHERE kod = 626546;
UPDATE ruian_katastr SET nazev = 'Nové Městečko' WHERE kod = 626554;
UPDATE ruian_katastr SET nazev = 'Platoř' WHERE kod = 626562;
UPDATE ruian_katastr SET nazev = 'Dlouhá Ves u Havlíčkova Brodu' WHERE kod = 626571;
UPDATE ruian_katastr SET nazev = 'Dlouhá Ves u Rychnova nad Kněžnou' WHERE kod = 626589;
UPDATE ruian_katastr SET nazev = 'Jámy u Rychnova nad Kněžnou' WHERE kod = 626597;
UPDATE ruian_katastr SET nazev = 'Dlouhé na Moravě' WHERE kod = 626619;
UPDATE ruian_katastr SET nazev = 'Dlouhé Dvory' WHERE kod = 626627;
UPDATE ruian_katastr SET nazev = 'Benkov' WHERE kod = 626635;
UPDATE ruian_katastr SET nazev = 'Dlouhomilov' WHERE kod = 626643;
UPDATE ruian_katastr SET nazev = 'Dlouhopolsko' WHERE kod = 626651;
UPDATE ruian_katastr SET nazev = 'Dlouhý Most' WHERE kod = 626660;
UPDATE ruian_katastr SET nazev = 'Javorník u Dlouhého Mostu' WHERE kod = 626686;
UPDATE ruian_katastr SET nazev = 'Dlouhý Újezd' WHERE kod = 626694;
UPDATE ruian_katastr SET nazev = 'Dluhonice' WHERE kod = 626708;
UPDATE ruian_katastr SET nazev = 'Dolní Dlužiny' WHERE kod = 626716;
UPDATE ruian_katastr SET nazev = 'Horní Dlužiny' WHERE kod = 626724;
UPDATE ruian_katastr SET nazev = 'Dmýštice' WHERE kod = 626732;
UPDATE ruian_katastr SET nazev = 'Klisín' WHERE kod = 626741;
UPDATE ruian_katastr SET nazev = 'Něžovice' WHERE kod = 626759;
UPDATE ruian_katastr SET nazev = 'Dneboh' WHERE kod = 626767;
UPDATE ruian_katastr SET nazev = 'Černotín u Dnešic' WHERE kod = 626775;
UPDATE ruian_katastr SET nazev = 'Dnešice' WHERE kod = 626783;
UPDATE ruian_katastr SET nazev = 'Oplot' WHERE kod = 626805;
UPDATE ruian_katastr SET nazev = 'Přestavlky u Dnešic' WHERE kod = 626813;
UPDATE ruian_katastr SET nazev = 'Dobelice' WHERE kod = 626821;
UPDATE ruian_katastr SET nazev = 'Dobešov u Černovic' WHERE kod = 626830;
UPDATE ruian_katastr SET nazev = 'Vlkosovice' WHERE kod = 626864;
UPDATE ruian_katastr SET nazev = 'Dobešov' WHERE kod = 626872;
UPDATE ruian_katastr SET nazev = 'Stará Dobev' WHERE kod = 626881;
UPDATE ruian_katastr SET nazev = 'Oldřichov u Písku' WHERE kod = 626902;
UPDATE ruian_katastr SET nazev = 'Nepodřice' WHERE kod = 626911;
UPDATE ruian_katastr SET nazev = 'Borek u Děčína' WHERE kod = 626929;
UPDATE ruian_katastr SET nazev = 'Dobkovice' WHERE kod = 626937;
UPDATE ruian_katastr SET nazev = 'Prosetín u Dobkovic' WHERE kod = 626953;
UPDATE ruian_katastr SET nazev = 'Dobrá' WHERE kod = 626961;
UPDATE ruian_katastr SET nazev = 'Dobrá u Frýdku-Místku' WHERE kod = 626988;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Pelhřimova' WHERE kod = 626996;
UPDATE ruian_katastr SET nazev = 'Rohovka' WHERE kod = 627011;
UPDATE ruian_katastr SET nazev = 'Branišov' WHERE kod = 627020;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Toužimi' WHERE kod = 627038;
UPDATE ruian_katastr SET nazev = 'Dřevohryzy' WHERE kod = 627046;
UPDATE ruian_katastr SET nazev = 'Prášily' WHERE kod = 627054;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Křižanova' WHERE kod = 627062;
UPDATE ruian_katastr SET nazev = 'Dolní Dobrá Voda' WHERE kod = 627071;
UPDATE ruian_katastr SET nazev = 'Horní Dobrá Voda' WHERE kod = 627089;
UPDATE ruian_katastr SET nazev = 'Bílsko u Hořic' WHERE kod = 627101;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Pacova' WHERE kod = 627119;
UPDATE ruian_katastr SET nazev = 'Dobranov' WHERE kod = 627127;
UPDATE ruian_katastr SET nazev = 'Bukovice u Dobratic' WHERE kod = 627135;
UPDATE ruian_katastr SET nazev = 'Dobratice' WHERE kod = 627143;
UPDATE ruian_katastr SET nazev = 'Dobrčice' WHERE kod = 627186;
UPDATE ruian_katastr SET nazev = 'Dobré' WHERE kod = 627194;
UPDATE ruian_katastr SET nazev = 'Hlinné u Dobrého' WHERE kod = 627208;
UPDATE ruian_katastr SET nazev = 'Kamenice u Dobrého' WHERE kod = 627224;
UPDATE ruian_katastr SET nazev = 'Rovné u Dobrého' WHERE kod = 627241;
UPDATE ruian_katastr SET nazev = 'Dobré Pole' WHERE kod = 627259;
UPDATE ruian_katastr SET nazev = 'Dobrkov' WHERE kod = 627267;
UPDATE ruian_katastr SET nazev = 'Dobrkovice' WHERE kod = 627275;
UPDATE ruian_katastr SET nazev = 'Brložec' WHERE kod = 627283;
UPDATE ruian_katastr SET nazev = 'Dobrná' WHERE kod = 627291;
UPDATE ruian_katastr SET nazev = 'Dobročkovice' WHERE kod = 627305;
UPDATE ruian_katastr SET nazev = 'Dobročovice' WHERE kod = 627313;
UPDATE ruian_katastr SET nazev = 'Dobrohostov' WHERE kod = 627321;
UPDATE ruian_katastr SET nazev = 'Chválkov' WHERE kod = 627330;
UPDATE ruian_katastr SET nazev = 'Dobrochov' WHERE kod = 627348;
UPDATE ruian_katastr SET nazev = 'Dobroměřice' WHERE kod = 627356;
UPDATE ruian_katastr SET nazev = 'Dobromilice' WHERE kod = 627364;
UPDATE ruian_katastr SET nazev = 'Dobronice u Bechyně' WHERE kod = 627372;
UPDATE ruian_katastr SET nazev = 'Dobronice u Chýnova' WHERE kod = 627399;
UPDATE ruian_katastr SET nazev = 'Dobronín' WHERE kod = 627402;
UPDATE ruian_katastr SET nazev = 'Střelecká' WHERE kod = 627429;
UPDATE ruian_katastr SET nazev = 'Dobroslavice' WHERE kod = 627437;
UPDATE ruian_katastr SET nazev = 'Dobrošov' WHERE kod = 627445;
UPDATE ruian_katastr SET nazev = 'Dobrotice' WHERE kod = 627453;
UPDATE ruian_katastr SET nazev = 'Dobroutov' WHERE kod = 627461;
UPDATE ruian_katastr SET nazev = 'Dobrovice' WHERE kod = 627470;
UPDATE ruian_katastr SET nazev = 'Dobrovíz' WHERE kod = 627488;
UPDATE ruian_katastr SET nazev = 'Dobruška' WHERE kod = 627496;
UPDATE ruian_katastr SET nazev = 'Pulice' WHERE kod = 627534;
UPDATE ruian_katastr SET nazev = 'Křovice' WHERE kod = 627542;
UPDATE ruian_katastr SET nazev = 'Mělčany u Dobrušky' WHERE kod = 627551;
UPDATE ruian_katastr SET nazev = 'Běstviny' WHERE kod = 627577;
UPDATE ruian_katastr SET nazev = 'Dobřany' WHERE kod = 627615;
UPDATE ruian_katastr SET nazev = 'Vodní Újezd' WHERE kod = 627623;
UPDATE ruian_katastr SET nazev = 'Dobřany v Orlických horách' WHERE kod = 627631;
UPDATE ruian_katastr SET nazev = 'Dobřejovice' WHERE kod = 627640;
UPDATE ruian_katastr SET nazev = 'Herink' WHERE kod = 627666;
UPDATE ruian_katastr SET nazev = 'Chomutovice u Dobřejovic' WHERE kod = 627674;
UPDATE ruian_katastr SET nazev = 'Modletice u Dobřejovic' WHERE kod = 627682;
UPDATE ruian_katastr SET nazev = 'Popovičky' WHERE kod = 627704;
UPDATE ruian_katastr SET nazev = 'Dobřeň' WHERE kod = 627712;
UPDATE ruian_katastr SET nazev = 'Jestřebice u Kokořína' WHERE kod = 627721;
UPDATE ruian_katastr SET nazev = 'Střezivojice' WHERE kod = 627739;
UPDATE ruian_katastr SET nazev = 'Dobřenice' WHERE kod = 627747;
UPDATE ruian_katastr SET nazev = 'Dobříč u Prahy' WHERE kod = 627763;
UPDATE ruian_katastr SET nazev = 'Dobříč' WHERE kod = 627771;
UPDATE ruian_katastr SET nazev = 'Dobříčany' WHERE kod = 627780;
UPDATE ruian_katastr SET nazev = 'Trnovany u Žatce' WHERE kod = 627798;
UPDATE ruian_katastr SET nazev = 'Dobřichov' WHERE kod = 627801;
UPDATE ruian_katastr SET nazev = 'Dobřichovice' WHERE kod = 627810;
UPDATE ruian_katastr SET nazev = 'Karlík' WHERE kod = 627828;
UPDATE ruian_katastr SET nazev = 'Branišov na Šumavě' WHERE kod = 627844;
UPDATE ruian_katastr SET nazev = 'Dobříkov na Šumavě' WHERE kod = 627852;
UPDATE ruian_katastr SET nazev = 'Dobříkov' WHERE kod = 627861;
UPDATE ruian_katastr SET nazev = 'Rzy' WHERE kod = 627879;
UPDATE ruian_katastr SET nazev = 'Dobříň' WHERE kod = 627887;
UPDATE ruian_katastr SET nazev = 'Záluží u Roudnice nad Labem' WHERE kod = 627909;
UPDATE ruian_katastr SET nazev = 'Dobřínsko' WHERE kod = 627917;
UPDATE ruian_katastr SET nazev = 'Dobříš' WHERE kod = 627968;
UPDATE ruian_katastr SET nazev = 'Dobřív' WHERE kod = 628000;
UPDATE ruian_katastr SET nazev = 'Pavlovsko' WHERE kod = 628026;
UPDATE ruian_katastr SET nazev = 'Dobšice u Žehuně' WHERE kod = 628042;
UPDATE ruian_katastr SET nazev = 'Dobšice u Týna nad Vltavou' WHERE kod = 628077;
UPDATE ruian_katastr SET nazev = 'Předčice' WHERE kod = 628093;
UPDATE ruian_katastr SET nazev = 'Smilovice u Týna nad Vltavou' WHERE kod = 628107;
UPDATE ruian_katastr SET nazev = 'Třitim' WHERE kod = 628115;
UPDATE ruian_katastr SET nazev = 'Dobšice u Znojma' WHERE kod = 628123;
UPDATE ruian_katastr SET nazev = 'Dobšín' WHERE kod = 628131;
UPDATE ruian_katastr SET nazev = 'Dohalice' WHERE kod = 628166;
UPDATE ruian_katastr SET nazev = 'Horní Dohalice' WHERE kod = 628174;
UPDATE ruian_katastr SET nazev = 'Doksany' WHERE kod = 628182;
UPDATE ruian_katastr SET nazev = 'Doksy u Kladna' WHERE kod = 628191;
UPDATE ruian_katastr SET nazev = 'Doksy u Máchova jezera' WHERE kod = 628212;
UPDATE ruian_katastr SET nazev = 'Dolánky' WHERE kod = 628239;
UPDATE ruian_katastr SET nazev = 'Dolánky nad Ohří' WHERE kod = 628247;
UPDATE ruian_katastr SET nazev = 'Bukovina u Turnova' WHERE kod = 628255;
UPDATE ruian_katastr SET nazev = 'Malý Rohozec' WHERE kod = 628280;
UPDATE ruian_katastr SET nazev = 'Dolany u Kladna' WHERE kod = 628301;
UPDATE ruian_katastr SET nazev = 'Debrno' WHERE kod = 628310;
UPDATE ruian_katastr SET nazev = 'Dolany u Prahy' WHERE kod = 628328;
UPDATE ruian_katastr SET nazev = 'Balkovy' WHERE kod = 628336;
UPDATE ruian_katastr SET nazev = 'Dolany u Klatov' WHERE kod = 628344;
UPDATE ruian_katastr SET nazev = 'Malechov' WHERE kod = 628352;
UPDATE ruian_katastr SET nazev = 'Řakom' WHERE kod = 628361;
UPDATE ruian_katastr SET nazev = 'Svrčovec' WHERE kod = 628379;
UPDATE ruian_katastr SET nazev = 'Dolany u Plzně' WHERE kod = 628395;
UPDATE ruian_katastr SET nazev = 'Čáslavky' WHERE kod = 628409;
UPDATE ruian_katastr SET nazev = 'Dolany u Jaroměře' WHERE kod = 628417;
UPDATE ruian_katastr SET nazev = 'Krabčice' WHERE kod = 628425;
UPDATE ruian_katastr SET nazev = 'Svinišťany' WHERE kod = 628441;
UPDATE ruian_katastr SET nazev = 'Dolany u Pardubic' WHERE kod = 628450;
UPDATE ruian_katastr SET nazev = 'Dolany u Olomouce' WHERE kod = 628468;
UPDATE ruian_katastr SET nazev = 'Tovéř' WHERE kod = 628484;
UPDATE ruian_katastr SET nazev = 'Dolenice' WHERE kod = 628492;
UPDATE ruian_katastr SET nazev = 'Dolín' WHERE kod = 628506;
UPDATE ruian_katastr SET nazev = 'Dolní Bečva' WHERE kod = 628522;
UPDATE ruian_katastr SET nazev = 'Dolní Bělá' WHERE kod = 628590;
UPDATE ruian_katastr SET nazev = 'Líté' WHERE kod = 628603;
UPDATE ruian_katastr SET nazev = 'Loza' WHERE kod = 628611;
UPDATE ruian_katastr SET nazev = 'Dolní Benešov' WHERE kod = 628638;
UPDATE ruian_katastr SET nazev = 'Dolní Beřkovice' WHERE kod = 628654;
UPDATE ruian_katastr SET nazev = 'Vliněves' WHERE kod = 628671;
UPDATE ruian_katastr SET nazev = 'Dolní Bezděkov u Kladna' WHERE kod = 628689;
UPDATE ruian_katastr SET nazev = 'Dolní Bezděkov' WHERE kod = 628697;
UPDATE ruian_katastr SET nazev = 'Dolní Bojanovice' WHERE kod = 628701;
UPDATE ruian_katastr SET nazev = 'Dolní Bory' WHERE kod = 628719;
UPDATE ruian_katastr SET nazev = 'Dolní Boříkovice' WHERE kod = 628727;
UPDATE ruian_katastr SET nazev = 'Dolní Bousov' WHERE kod = 628735;
UPDATE ruian_katastr SET nazev = 'Dolní Branná' WHERE kod = 628743;
UPDATE ruian_katastr SET nazev = 'Dolní Brusnice' WHERE kod = 628751;
UPDATE ruian_katastr SET nazev = 'Dolní Březinka' WHERE kod = 628778;
UPDATE ruian_katastr SET nazev = 'Dolní Břežany' WHERE kod = 628794;
UPDATE ruian_katastr SET nazev = 'Lhota u Dolních Břežan' WHERE kod = 628808;
UPDATE ruian_katastr SET nazev = 'Dolní Bukovsko' WHERE kod = 628824;
UPDATE ruian_katastr SET nazev = 'Pelejovice' WHERE kod = 628841;
UPDATE ruian_katastr SET nazev = 'Popovice u Dolního Bukovska' WHERE kod = 628859;
UPDATE ruian_katastr SET nazev = 'Sedlíkovice u Dolního Bukovska' WHERE kod = 628867;
UPDATE ruian_katastr SET nazev = 'Dolní Cerekev' WHERE kod = 628875;
UPDATE ruian_katastr SET nazev = 'Dolní Čermná' WHERE kod = 628883;
UPDATE ruian_katastr SET nazev = 'Dolní Černůtky' WHERE kod = 628891;
UPDATE ruian_katastr SET nazev = 'Dolní Datyně' WHERE kod = 628905;
UPDATE ruian_katastr SET nazev = 'Dolní Dobrouč' WHERE kod = 628913;
UPDATE ruian_katastr SET nazev = 'Dolní Domaslavice' WHERE kod = 628921;
UPDATE ruian_katastr SET nazev = 'Volovec' WHERE kod = 628930;
UPDATE ruian_katastr SET nazev = 'Dolní Dubňany' WHERE kod = 628956;
UPDATE ruian_katastr SET nazev = 'Dolní Dunajovice' WHERE kod = 628964;
UPDATE ruian_katastr SET nazev = 'Dolní Dvořiště' WHERE kod = 628972;
UPDATE ruian_katastr SET nazev = 'Jenín' WHERE kod = 628981;
UPDATE ruian_katastr SET nazev = 'Rybník u Dolního Dvořiště' WHERE kod = 628999;
UPDATE ruian_katastr SET nazev = 'Horní Kaliště' WHERE kod = 629006;
UPDATE ruian_katastr SET nazev = 'Trojany u Dolního Dvořiště' WHERE kod = 629014;
UPDATE ruian_katastr SET nazev = 'Dolní Dvůr' WHERE kod = 629022;
UPDATE ruian_katastr SET nazev = 'Dolní Habartice' WHERE kod = 629049;
UPDATE ruian_katastr SET nazev = 'Dolní Hbity' WHERE kod = 629057;
UPDATE ruian_katastr SET nazev = 'Dolní Heřmanice v Čechách' WHERE kod = 629065;
UPDATE ruian_katastr SET nazev = 'Dolní Heřmanice' WHERE kod = 629081;
UPDATE ruian_katastr SET nazev = 'Oslava' WHERE kod = 629090;
UPDATE ruian_katastr SET nazev = 'Dolní Hořice' WHERE kod = 629103;
UPDATE ruian_katastr SET nazev = 'Kladruby' WHERE kod = 629120;
UPDATE ruian_katastr SET nazev = 'Lejčkov' WHERE kod = 629138;
UPDATE ruian_katastr SET nazev = 'Dolní Hradiště' WHERE kod = 629146;
UPDATE ruian_katastr SET nazev = 'Dolní Chvatliny' WHERE kod = 629154;
UPDATE ruian_katastr SET nazev = 'Horní Chvatliny' WHERE kod = 629162;
UPDATE ruian_katastr SET nazev = 'Mančice' WHERE kod = 629171;
UPDATE ruian_katastr SET nazev = 'Polní Voděrady' WHERE kod = 629189;
UPDATE ruian_katastr SET nazev = 'Dolní Jablonná' WHERE kod = 629197;
UPDATE ruian_katastr SET nazev = 'Dolní Jadruž' WHERE kod = 629201;
UPDATE ruian_katastr SET nazev = 'Dolní Jamné' WHERE kod = 629219;
UPDATE ruian_katastr SET nazev = 'Chudeč' WHERE kod = 629227;
UPDATE ruian_katastr SET nazev = 'Světec u Dolního Jamného' WHERE kod = 629235;
UPDATE ruian_katastr SET nazev = 'Žernovník u Dolního Jamného' WHERE kod = 629243;
UPDATE ruian_katastr SET nazev = 'Čtrnáct Dvorců' WHERE kod = 629251;
UPDATE ruian_katastr SET nazev = 'Dolní Jiřetín' WHERE kod = 629260;
UPDATE ruian_katastr SET nazev = 'Dolní Kalná' WHERE kod = 629278;
UPDATE ruian_katastr SET nazev = 'Dolní Kounice' WHERE kod = 629286;
UPDATE ruian_katastr SET nazev = 'Dachov' WHERE kod = 629294;
UPDATE ruian_katastr SET nazev = 'Dolní Kožlí' WHERE kod = 629308;
UPDATE ruian_katastr SET nazev = 'Horní Kožlí' WHERE kod = 629316;
UPDATE ruian_katastr SET nazev = 'Mojkov' WHERE kod = 629324;
UPDATE ruian_katastr SET nazev = 'Dolní Kralovice' WHERE kod = 629332;
UPDATE ruian_katastr SET nazev = 'Libčice u Dolních Kralovic' WHERE kod = 629341;
UPDATE ruian_katastr SET nazev = 'Vraždovy Lhotice' WHERE kod = 629375;
UPDATE ruian_katastr SET nazev = 'Zahrádčice' WHERE kod = 629383;
UPDATE ruian_katastr SET nazev = 'Dolní Krupá u Mnichova Hradiště' WHERE kod = 629391;
UPDATE ruian_katastr SET nazev = 'Dolní Krupá u Havlíčkova Brodu' WHERE kod = 629405;
UPDATE ruian_katastr SET nazev = 'Dolní Lánov' WHERE kod = 629421;
UPDATE ruian_katastr SET nazev = 'Dolní Lažany' WHERE kod = 629430;
UPDATE ruian_katastr SET nazev = 'Vícenice u Dolních Lažan' WHERE kod = 629448;
UPDATE ruian_katastr SET nazev = 'Dolní Lhota u Stráže nad Nežárkou' WHERE kod = 629456;
UPDATE ruian_katastr SET nazev = 'Dvorce u Stráže nad Nežárkou' WHERE kod = 629464;
UPDATE ruian_katastr SET nazev = 'Dolní Lhota u Klatov' WHERE kod = 629481;
UPDATE ruian_katastr SET nazev = 'Lomec u Klatov' WHERE kod = 629499;
UPDATE ruian_katastr SET nazev = 'Novákovice' WHERE kod = 629502;
UPDATE ruian_katastr SET nazev = 'Vacovy' WHERE kod = 629511;
UPDATE ruian_katastr SET nazev = 'Dolní Lhota' WHERE kod = 629529;
UPDATE ruian_katastr SET nazev = 'Dolní Lhota u Luhačovic' WHERE kod = 629537;
UPDATE ruian_katastr SET nazev = 'Dolní Lhota u Ostravy' WHERE kod = 629545;
UPDATE ruian_katastr SET nazev = 'Dolní Libchavy' WHERE kod = 629553;
UPDATE ruian_katastr SET nazev = 'Bojanov u Dolní Libochové' WHERE kod = 629561;
UPDATE ruian_katastr SET nazev = 'Dolní Libochová' WHERE kod = 629570;
UPDATE ruian_katastr SET nazev = 'Dolní Lipka' WHERE kod = 629588;
UPDATE ruian_katastr SET nazev = 'Dolní Lochov' WHERE kod = 629596;
UPDATE ruian_katastr SET nazev = 'Dolní Lomná' WHERE kod = 629600;
UPDATE ruian_katastr SET nazev = 'Dolní Loučky' WHERE kod = 629669;
UPDATE ruian_katastr SET nazev = 'Střemchoví' WHERE kod = 629677;
UPDATE ruian_katastr SET nazev = 'Dolní Lukavice' WHERE kod = 629685;
UPDATE ruian_katastr SET nazev = 'Horní Lukavice' WHERE kod = 629693;
UPDATE ruian_katastr SET nazev = 'Krasavce' WHERE kod = 629707;
UPDATE ruian_katastr SET nazev = 'Lišice u Dolní Lukavice' WHERE kod = 629715;
UPDATE ruian_katastr SET nazev = 'Snopoušovy' WHERE kod = 629723;
UPDATE ruian_katastr SET nazev = 'Dolní Lutyně' WHERE kod = 629731;
UPDATE ruian_katastr SET nazev = 'Dolní Město' WHERE kod = 629740;
UPDATE ruian_katastr SET nazev = 'Meziklasí' WHERE kod = 629766;
UPDATE ruian_katastr SET nazev = 'Dolní Morava' WHERE kod = 629774;
UPDATE ruian_katastr SET nazev = 'Horní Morava' WHERE kod = 629782;
UPDATE ruian_katastr SET nazev = 'Velká Morava' WHERE kod = 629791;
UPDATE ruian_katastr SET nazev = 'Dolní Moravice' WHERE kod = 629804;
UPDATE ruian_katastr SET nazev = 'Horní Moravice' WHERE kod = 629812;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Rýmařova' WHERE kod = 629821;
UPDATE ruian_katastr SET nazev = 'Dolní Němčí' WHERE kod = 629839;
UPDATE ruian_katastr SET nazev = 'Dolní Němčice' WHERE kod = 629847;
UPDATE ruian_katastr SET nazev = 'Hostkovice u Dolních Němčic' WHERE kod = 629855;
UPDATE ruian_katastr SET nazev = 'Dolní Nětčice' WHERE kod = 629863;
UPDATE ruian_katastr SET nazev = 'Boučí' WHERE kod = 629871;
UPDATE ruian_katastr SET nazev = 'Dolní Nivy' WHERE kod = 629880;
UPDATE ruian_katastr SET nazev = 'Horní Nivy' WHERE kod = 629898;
UPDATE ruian_katastr SET nazev = 'Horní Rozmyšl' WHERE kod = 629901;
UPDATE ruian_katastr SET nazev = 'Dolní Olešnice' WHERE kod = 629910;
UPDATE ruian_katastr SET nazev = 'Vestřev' WHERE kod = 629944;
UPDATE ruian_katastr SET nazev = 'Dolní Počernice' WHERE kod = 629952;
UPDATE ruian_katastr SET nazev = 'Dolní Podluží' WHERE kod = 629979;
UPDATE ruian_katastr SET nazev = 'Dolní Poustevna' WHERE kod = 629987;
UPDATE ruian_katastr SET nazev = 'Horní Poustevna' WHERE kod = 629995;
UPDATE ruian_katastr SET nazev = 'Nová Víska u Dolní Poustevny' WHERE kod = 630012;
UPDATE ruian_katastr SET nazev = 'Dolní Povelice' WHERE kod = 630021;
UPDATE ruian_katastr SET nazev = 'Dolní Přím' WHERE kod = 630039;
UPDATE ruian_katastr SET nazev = 'Dolní Radechová' WHERE kod = 630063;
UPDATE ruian_katastr SET nazev = 'Dolní Radouň' WHERE kod = 630071;
UPDATE ruian_katastr SET nazev = 'Dolní Roveň' WHERE kod = 630080;
UPDATE ruian_katastr SET nazev = 'Dolní Rožínka' WHERE kod = 630098;
UPDATE ruian_katastr SET nazev = 'Horní Rozsíčka' WHERE kod = 630101;
UPDATE ruian_katastr SET nazev = 'Rodkov' WHERE kod = 630110;
UPDATE ruian_katastr SET nazev = 'Dolní Řasnice' WHERE kod = 630128;
UPDATE ruian_katastr SET nazev = 'Dolní Ředice' WHERE kod = 630136;
UPDATE ruian_katastr SET nazev = 'Dolní Skrýchov' WHERE kod = 630144;
UPDATE ruian_katastr SET nazev = 'Dolní Slivno' WHERE kod = 630152;
UPDATE ruian_katastr SET nazev = 'Slivínko' WHERE kod = 630161;
UPDATE ruian_katastr SET nazev = 'Dolní Sloupnice' WHERE kod = 630179;
UPDATE ruian_katastr SET nazev = 'Dolní Smrčné' WHERE kod = 630187;
UPDATE ruian_katastr SET nazev = 'Dolní Stakory' WHERE kod = 630195;
UPDATE ruian_katastr SET nazev = 'Dolní Studénky' WHERE kod = 630209;
UPDATE ruian_katastr SET nazev = 'Dolní Sukolom' WHERE kod = 630225;
UPDATE ruian_katastr SET nazev = 'Dolní Tošanovice' WHERE kod = 630233;
UPDATE ruian_katastr SET nazev = 'Dolní Svince' WHERE kod = 630241;
UPDATE ruian_katastr SET nazev = 'Dolní Třebonín' WHERE kod = 630250;
UPDATE ruian_katastr SET nazev = 'Prostřední Svince' WHERE kod = 630284;
UPDATE ruian_katastr SET nazev = 'Dolní Újezd u Litomyšle' WHERE kod = 630292;
UPDATE ruian_katastr SET nazev = 'Dolní Újezd u Lipníka nad Bečvou' WHERE kod = 630322;
UPDATE ruian_katastr SET nazev = 'Dolní Věstonice' WHERE kod = 630331;
UPDATE ruian_katastr SET nazev = 'Dolní Vilémovice' WHERE kod = 630349;
UPDATE ruian_katastr SET nazev = 'Dolní Vilímeč' WHERE kod = 630357;
UPDATE ruian_katastr SET nazev = 'Dolní Zálezly' WHERE kod = 630365;
UPDATE ruian_katastr SET nazev = 'Chvalov' WHERE kod = 630373;
UPDATE ruian_katastr SET nazev = 'Brtná u Dolního Žandova' WHERE kod = 630381;
UPDATE ruian_katastr SET nazev = 'Dolní Žandov' WHERE kod = 630390;
UPDATE ruian_katastr SET nazev = 'Horní Žandov' WHERE kod = 630403;
UPDATE ruian_katastr SET nazev = 'Podlesí u Dolního Žandova' WHERE kod = 630411;
UPDATE ruian_katastr SET nazev = 'Úbočí u Dolního Žandova' WHERE kod = 630420;
UPDATE ruian_katastr SET nazev = 'Dolní Žďár u Lásenice' WHERE kod = 630438;
UPDATE ruian_katastr SET nazev = 'Horní Lhota u Lásenice' WHERE kod = 630446;
UPDATE ruian_katastr SET nazev = 'Dolní Životice' WHERE kod = 630454;
UPDATE ruian_katastr SET nazev = 'Dolní Žleb' WHERE kod = 630471;
UPDATE ruian_katastr SET nazev = 'Doloplazy' WHERE kod = 630489;
UPDATE ruian_katastr SET nazev = 'Poličky' WHERE kod = 630497;
UPDATE ruian_katastr SET nazev = 'Doloplazy u Olomouce' WHERE kod = 630501;
UPDATE ruian_katastr SET nazev = 'Doly' WHERE kod = 630527;
UPDATE ruian_katastr SET nazev = 'Domamil' WHERE kod = 630543;
UPDATE ruian_katastr SET nazev = 'Babčice' WHERE kod = 630551;
UPDATE ruian_katastr SET nazev = 'Domamyšl' WHERE kod = 630560;
UPDATE ruian_katastr SET nazev = 'Domanín u Třeboně' WHERE kod = 630586;
UPDATE ruian_katastr SET nazev = 'Domanín' WHERE kod = 630608;
UPDATE ruian_katastr SET nazev = 'Domanín u Bystřice nad Pernštejnem' WHERE kod = 630616;
UPDATE ruian_katastr SET nazev = 'Domašice' WHERE kod = 630624;
UPDATE ruian_katastr SET nazev = 'Domašín' WHERE kod = 630641;
UPDATE ruian_katastr SET nazev = 'Hrazená Lhota' WHERE kod = 630659;
UPDATE ruian_katastr SET nazev = 'Znosim' WHERE kod = 630675;
UPDATE ruian_katastr SET nazev = 'Domašín u Studené' WHERE kod = 630683;
UPDATE ruian_katastr SET nazev = 'Domašín u Klášterce nad Ohří' WHERE kod = 630691;
UPDATE ruian_katastr SET nazev = 'Louchov' WHERE kod = 630705;
UPDATE ruian_katastr SET nazev = 'Petlery' WHERE kod = 630713;
UPDATE ruian_katastr SET nazev = 'Nová Víska u Domašína' WHERE kod = 630721;
UPDATE ruian_katastr SET nazev = 'Podmilesy' WHERE kod = 630730;
UPDATE ruian_katastr SET nazev = 'Domašín u Dobrušky' WHERE kod = 630748;
UPDATE ruian_katastr SET nazev = 'Spáleniště' WHERE kod = 630781;
UPDATE ruian_katastr SET nazev = 'Domašov u Brna' WHERE kod = 630799;
UPDATE ruian_katastr SET nazev = 'Říčky u Brna' WHERE kod = 630802;
UPDATE ruian_katastr SET nazev = 'Domašov nad Bystřicí' WHERE kod = 630811;
UPDATE ruian_katastr SET nazev = 'Domašov u Šternberka' WHERE kod = 630829;
UPDATE ruian_katastr SET nazev = 'Čechy' WHERE kod = 630837;
UPDATE ruian_katastr SET nazev = 'Domaželice' WHERE kod = 630845;
UPDATE ruian_katastr SET nazev = 'Domažlice' WHERE kod = 630853;
UPDATE ruian_katastr SET nazev = 'Domoradice' WHERE kod = 630942;
UPDATE ruian_katastr SET nazev = 'Domoradovice' WHERE kod = 630951;
UPDATE ruian_katastr SET nazev = 'Filipovice' WHERE kod = 630969;
UPDATE ruian_katastr SET nazev = 'Domoraz' WHERE kod = 630977;
UPDATE ruian_katastr SET nazev = 'Domoslavice' WHERE kod = 630985;
UPDATE ruian_katastr SET nazev = 'Sylvárův Újezd' WHERE kod = 630993;
UPDATE ruian_katastr SET nazev = 'Domousnice' WHERE kod = 631001;
UPDATE ruian_katastr SET nazev = 'Domoušice' WHERE kod = 631019;
UPDATE ruian_katastr SET nazev = 'Doňov' WHERE kod = 631027;
UPDATE ruian_katastr SET nazev = 'Doubek' WHERE kod = 631035;
UPDATE ruian_katastr SET nazev = 'Cihelny' WHERE kod = 631043;
UPDATE ruian_katastr SET nazev = 'Doubí u Karlových Var' WHERE kod = 631051;
UPDATE ruian_katastr SET nazev = 'Tašovice' WHERE kod = 631060;
UPDATE ruian_katastr SET nazev = 'Doubí u Liberce' WHERE kod = 631086;
UPDATE ruian_katastr SET nazev = 'Hluboká u Liberce' WHERE kod = 631094;
UPDATE ruian_katastr SET nazev = 'Pilínkov' WHERE kod = 631108;
UPDATE ruian_katastr SET nazev = 'Doubice' WHERE kod = 631116;
UPDATE ruian_katastr SET nazev = 'Doubrava nad Vltavou' WHERE kod = 631124;
UPDATE ruian_katastr SET nazev = 'Doubrava u Plzně' WHERE kod = 631141;
UPDATE ruian_katastr SET nazev = 'Doubrava' WHERE kod = 631159;
UPDATE ruian_katastr SET nazev = 'Doubrava u Orlové' WHERE kod = 631167;
UPDATE ruian_katastr SET nazev = 'Doubravčice' WHERE kod = 631205;
UPDATE ruian_katastr SET nazev = 'Masojedy' WHERE kod = 631213;
UPDATE ruian_katastr SET nazev = 'Štíhlice' WHERE kod = 631221;
UPDATE ruian_katastr SET nazev = 'Doubravice' WHERE kod = 631230;
UPDATE ruian_katastr SET nazev = 'Doubravice u Strakonic' WHERE kod = 631248;
UPDATE ruian_katastr SET nazev = 'Lažany u Doubravice' WHERE kod = 631256;
UPDATE ruian_katastr SET nazev = 'Nahošín' WHERE kod = 631264;
UPDATE ruian_katastr SET nazev = 'Doubravice u Dvora Králové' WHERE kod = 631272;
UPDATE ruian_katastr SET nazev = 'Zálesí u Dvora Králové' WHERE kod = 631299;
UPDATE ruian_katastr SET nazev = 'Doubravice nad Moravou' WHERE kod = 631302;
UPDATE ruian_katastr SET nazev = 'Doubravice nad Svitavou' WHERE kod = 631329;
UPDATE ruian_katastr SET nazev = 'Klemov' WHERE kod = 631337;
UPDATE ruian_katastr SET nazev = 'Doubravice u Volyně' WHERE kod = 631345;
UPDATE ruian_katastr SET nazev = 'Počátky u Volyně' WHERE kod = 631353;
UPDATE ruian_katastr SET nazev = 'Střídka' WHERE kod = 631361;
UPDATE ruian_katastr SET nazev = 'Doubravička' WHERE kod = 631370;
UPDATE ruian_katastr SET nazev = 'Doubravník' WHERE kod = 631388;
UPDATE ruian_katastr SET nazev = 'Doubravy' WHERE kod = 631396;
UPDATE ruian_katastr SET nazev = 'Doudleby' WHERE kod = 631400;
UPDATE ruian_katastr SET nazev = 'Doudleby nad Orlicí' WHERE kod = 631426;
UPDATE ruian_katastr SET nazev = 'Vyhnánov' WHERE kod = 631442;
UPDATE ruian_katastr SET nazev = 'Doupě' WHERE kod = 631451;
UPDATE ruian_katastr SET nazev = 'Dožice' WHERE kod = 631469;
UPDATE ruian_katastr SET nazev = 'Drahanovice' WHERE kod = 631477;
UPDATE ruian_katastr SET nazev = 'Lhota pod Kosířem' WHERE kod = 631493;
UPDATE ruian_katastr SET nazev = 'Ludéřov' WHERE kod = 631507;
UPDATE ruian_katastr SET nazev = 'Drahany' WHERE kod = 631523;
UPDATE ruian_katastr SET nazev = 'Drahelčice' WHERE kod = 631531;
UPDATE ruian_katastr SET nazev = 'Drahenice' WHERE kod = 631540;
UPDATE ruian_katastr SET nazev = 'Drahenický Málkov' WHERE kod = 631558;
UPDATE ruian_katastr SET nazev = 'Drahkov' WHERE kod = 631582;
UPDATE ruian_katastr SET nazev = 'Drahlín' WHERE kod = 631604;
UPDATE ruian_katastr SET nazev = 'Drahňovice' WHERE kod = 631621;
UPDATE ruian_katastr SET nazev = 'Drahobudice' WHERE kod = 631647;
UPDATE ruian_katastr SET nazev = 'Hatě' WHERE kod = 631655;
UPDATE ruian_katastr SET nazev = 'Horní Jelčany' WHERE kod = 631663;
UPDATE ruian_katastr SET nazev = 'Břehoryje' WHERE kod = 631671;
UPDATE ruian_katastr SET nazev = 'Drahobuz' WHERE kod = 631680;
UPDATE ruian_katastr SET nazev = 'Strážiště u Drahobuze' WHERE kod = 631701;
UPDATE ruian_katastr SET nazev = 'Drahonice' WHERE kod = 631710;
UPDATE ruian_katastr SET nazev = 'Drahonice u Lubence' WHERE kod = 631728;
UPDATE ruian_katastr SET nazev = 'Lužec' WHERE kod = 631736;
UPDATE ruian_katastr SET nazev = 'Vesce u Drahonic' WHERE kod = 631752;
UPDATE ruian_katastr SET nazev = 'Drahonín' WHERE kod = 631761;
UPDATE ruian_katastr SET nazev = 'Drahoňův Újezd' WHERE kod = 631779;
UPDATE ruian_katastr SET nazev = 'Chotětín' WHERE kod = 631787;
UPDATE ruian_katastr SET nazev = 'Třebnuška' WHERE kod = 631795;
UPDATE ruian_katastr SET nazev = 'Drahoraz' WHERE kod = 631809;
UPDATE ruian_katastr SET nazev = 'Keteň' WHERE kod = 631817;
UPDATE ruian_katastr SET nazev = 'Pševes' WHERE kod = 631825;
UPDATE ruian_katastr SET nazev = 'Drahotěšice' WHERE kod = 631833;
UPDATE ruian_katastr SET nazev = 'Radonice u Drahotěšic' WHERE kod = 631841;
UPDATE ruian_katastr SET nazev = 'Vlkov u Drahotěšic' WHERE kod = 631850;
UPDATE ruian_katastr SET nazev = 'Drahotice' WHERE kod = 631876;
UPDATE ruian_katastr SET nazev = 'Drahotín' WHERE kod = 631884;
UPDATE ruian_katastr SET nazev = 'Hora Svatého Václava' WHERE kod = 631892;
UPDATE ruian_katastr SET nazev = 'Načetín u Drahotína' WHERE kod = 631906;
UPDATE ruian_katastr SET nazev = 'Sezemín' WHERE kod = 631914;
UPDATE ruian_katastr SET nazev = 'Šibanov' WHERE kod = 631922;
UPDATE ruian_katastr SET nazev = 'Šidlákov' WHERE kod = 631931;
UPDATE ruian_katastr SET nazev = 'Drahotuše' WHERE kod = 631949;
UPDATE ruian_katastr SET nazev = 'Drahouš' WHERE kod = 631965;
UPDATE ruian_katastr SET nazev = 'Tlestky' WHERE kod = 631981;
UPDATE ruian_katastr SET nazev = 'Drahov' WHERE kod = 631990;
UPDATE ruian_katastr SET nazev = 'Božkovice' WHERE kod = 632015;
UPDATE ruian_katastr SET nazev = 'Drachkov' WHERE kod = 632023;
UPDATE ruian_katastr SET nazev = 'Dráchov' WHERE kod = 632066;
UPDATE ruian_katastr SET nazev = 'Drásov u Příbramě' WHERE kod = 632074;
UPDATE ruian_katastr SET nazev = 'Drásov' WHERE kod = 632104;
UPDATE ruian_katastr SET nazev = 'Draženov' WHERE kod = 632112;
UPDATE ruian_katastr SET nazev = 'Dražetice II' WHERE kod = 632121;
UPDATE ruian_katastr SET nazev = 'Chramiště' WHERE kod = 632139;
UPDATE ruian_katastr SET nazev = 'Dražice' WHERE kod = 632147;
UPDATE ruian_katastr SET nazev = 'Dražice u Tábora' WHERE kod = 632163;
UPDATE ruian_katastr SET nazev = 'Drhovice' WHERE kod = 632171;
UPDATE ruian_katastr SET nazev = 'Meziříčí' WHERE kod = 632180;
UPDATE ruian_katastr SET nazev = 'Dražíč' WHERE kod = 632198;
UPDATE ruian_katastr SET nazev = 'Dražičky' WHERE kod = 632236;
UPDATE ruian_katastr SET nazev = 'Dražkov nad Labem' WHERE kod = 632244;
UPDATE ruian_katastr SET nazev = 'Dražkovice' WHERE kod = 632252;
UPDATE ruian_katastr SET nazev = 'Dobrš' WHERE kod = 632261;
UPDATE ruian_katastr SET nazev = 'Drážov' WHERE kod = 632279;
UPDATE ruian_katastr SET nazev = 'Kváskovice u Drážova' WHERE kod = 632287;
UPDATE ruian_katastr SET nazev = 'Zálesí u Drážova' WHERE kod = 632295;
UPDATE ruian_katastr SET nazev = 'Hlinky' WHERE kod = 632317;
UPDATE ruian_katastr SET nazev = 'Dražov' WHERE kod = 632325;
UPDATE ruian_katastr SET nazev = 'Dražovice u Sušice' WHERE kod = 632333;
UPDATE ruian_katastr SET nazev = 'Dražovice' WHERE kod = 632350;
UPDATE ruian_katastr SET nazev = 'Dražůvky' WHERE kod = 632368;
UPDATE ruian_katastr SET nazev = 'Drevníky' WHERE kod = 632376;
UPDATE ruian_katastr SET nazev = 'Slovanská Lhota' WHERE kod = 632384;
UPDATE ruian_katastr SET nazev = 'Županovice' WHERE kod = 632392;
UPDATE ruian_katastr SET nazev = 'Brloh u Drhovle' WHERE kod = 632406;
UPDATE ruian_katastr SET nazev = 'Drhovle' WHERE kod = 632414;
UPDATE ruian_katastr SET nazev = 'Mladotice u Drhovle' WHERE kod = 632457;
UPDATE ruian_katastr SET nazev = 'Pamětice u Drhovle' WHERE kod = 632473;
UPDATE ruian_katastr SET nazev = 'Drhovy' WHERE kod = 632481;
UPDATE ruian_katastr SET nazev = 'Drchlava' WHERE kod = 632490;
UPDATE ruian_katastr SET nazev = 'Drmoul' WHERE kod = 632503;
UPDATE ruian_katastr SET nazev = 'Drnek' WHERE kod = 632511;
UPDATE ruian_katastr SET nazev = 'Drnholec' WHERE kod = 632520;
UPDATE ruian_katastr SET nazev = 'Drnovice' WHERE kod = 632538;
UPDATE ruian_katastr SET nazev = 'Drnovice u Valašských Klobouk' WHERE kod = 632546;
UPDATE ruian_katastr SET nazev = 'Drnovice u Vyškova' WHERE kod = 632554;
UPDATE ruian_katastr SET nazev = 'Černíkov u Strakonic' WHERE kod = 632562;
UPDATE ruian_katastr SET nazev = 'Droužetice' WHERE kod = 632571;
UPDATE ruian_katastr SET nazev = 'Podolí u Strakonic' WHERE kod = 632589;
UPDATE ruian_katastr SET nazev = 'Droužkovice' WHERE kod = 632597;
UPDATE ruian_katastr SET nazev = 'Drozdov v Čechách' WHERE kod = 632601;
UPDATE ruian_katastr SET nazev = 'Drozdov' WHERE kod = 632619;
UPDATE ruian_katastr SET nazev = 'Droždín' WHERE kod = 632635;
UPDATE ruian_katastr SET nazev = 'Drslavice' WHERE kod = 632643;
UPDATE ruian_katastr SET nazev = 'Drsník' WHERE kod = 632651;
UPDATE ruian_katastr SET nazev = 'Druhanov' WHERE kod = 632660;
UPDATE ruian_katastr SET nazev = 'Drunče' WHERE kod = 632686;
UPDATE ruian_katastr SET nazev = 'Druzcov' WHERE kod = 632694;
UPDATE ruian_katastr SET nazev = 'Druztová' WHERE kod = 632708;
UPDATE ruian_katastr SET nazev = 'Družec' WHERE kod = 632716;
UPDATE ruian_katastr SET nazev = 'Drysice' WHERE kod = 632724;
UPDATE ruian_katastr SET nazev = 'Držkov' WHERE kod = 632732;
UPDATE ruian_katastr SET nazev = 'Držková' WHERE kod = 632741;
UPDATE ruian_katastr SET nazev = 'Brusov' WHERE kod = 632759;
UPDATE ruian_katastr SET nazev = 'Držovice' WHERE kod = 632767;
UPDATE ruian_katastr SET nazev = 'Starý Týn' WHERE kod = 632775;
UPDATE ruian_katastr SET nazev = 'Držovice na Moravě' WHERE kod = 632783;
UPDATE ruian_katastr SET nazev = 'Děkovka' WHERE kod = 632805;
UPDATE ruian_katastr SET nazev = 'Dřemčice' WHERE kod = 632813;
UPDATE ruian_katastr SET nazev = 'Chrášťany u Dřemčic' WHERE kod = 632821;
UPDATE ruian_katastr SET nazev = 'Dřenice' WHERE kod = 632830;
UPDATE ruian_katastr SET nazev = 'Třibřichy' WHERE kod = 632856;
UPDATE ruian_katastr SET nazev = 'Dřešín' WHERE kod = 632864;
UPDATE ruian_katastr SET nazev = 'Dřešínek' WHERE kod = 632872;
UPDATE ruian_katastr SET nazev = 'Chvalšovice' WHERE kod = 632899;
UPDATE ruian_katastr SET nazev = 'Dřetovice' WHERE kod = 632929;
UPDATE ruian_katastr SET nazev = 'Dřevčice u Brandýsa nad Labem' WHERE kod = 632937;
UPDATE ruian_katastr SET nazev = 'Dřevčice' WHERE kod = 632945;
UPDATE ruian_katastr SET nazev = 'Heřmánky' WHERE kod = 632953;
UPDATE ruian_katastr SET nazev = 'Buček' WHERE kod = 632961;
UPDATE ruian_katastr SET nazev = 'Černíkovice u Dřevce' WHERE kod = 632970;
UPDATE ruian_katastr SET nazev = 'Dřevec' WHERE kod = 632988;
UPDATE ruian_katastr SET nazev = 'Hedčany' WHERE kod = 632996;
UPDATE ruian_katastr SET nazev = 'Hodyně u Dřevce' WHERE kod = 633003;
UPDATE ruian_katastr SET nazev = 'Dřevnovice' WHERE kod = 633011;
UPDATE ruian_katastr SET nazev = 'Dřevohostice' WHERE kod = 633020;
UPDATE ruian_katastr SET nazev = 'Nahošovice' WHERE kod = 633038;
UPDATE ruian_katastr SET nazev = 'Turovice' WHERE kod = 633046;
UPDATE ruian_katastr SET nazev = 'Drchkov' WHERE kod = 633054;
UPDATE ruian_katastr SET nazev = 'Dřínov u Zlonic' WHERE kod = 633062;
UPDATE ruian_katastr SET nazev = 'Královice u Zlonic' WHERE kod = 633071;
UPDATE ruian_katastr SET nazev = 'Dřínov' WHERE kod = 633089;
UPDATE ruian_katastr SET nazev = 'Dřínov u Komořan' WHERE kod = 633097;
UPDATE ruian_katastr SET nazev = 'Dřínov u Kroměříže' WHERE kod = 633101;
UPDATE ruian_katastr SET nazev = 'Dřísy' WHERE kod = 633119;
UPDATE ruian_katastr SET nazev = 'Dříteč' WHERE kod = 633127;
UPDATE ruian_katastr SET nazev = 'Dříteň' WHERE kod = 633135;
UPDATE ruian_katastr SET nazev = 'Nákří' WHERE kod = 633151;
UPDATE ruian_katastr SET nazev = 'Borčice' WHERE kod = 633186;
UPDATE ruian_katastr SET nazev = 'Dub u Prachatic' WHERE kod = 633194;
UPDATE ruian_katastr SET nazev = 'Dubská Lhota' WHERE kod = 633208;
UPDATE ruian_katastr SET nazev = 'Dvorec u Dubu' WHERE kod = 633216;
UPDATE ruian_katastr SET nazev = 'Javornice u Dubu' WHERE kod = 633224;
UPDATE ruian_katastr SET nazev = 'Lipovice' WHERE kod = 633241;
UPDATE ruian_katastr SET nazev = 'Dub u Ratibořských Hor' WHERE kod = 633259;
UPDATE ruian_katastr SET nazev = 'Dub u Nového Jičína' WHERE kod = 633267;
UPDATE ruian_katastr SET nazev = 'Dub nad Moravou' WHERE kod = 633275;
UPDATE ruian_katastr SET nazev = 'Dražejov u Dubé' WHERE kod = 633283;
UPDATE ruian_katastr SET nazev = 'Dubá' WHERE kod = 633291;
UPDATE ruian_katastr SET nazev = 'Dubany' WHERE kod = 633321;
UPDATE ruian_katastr SET nazev = 'Dubeč' WHERE kod = 633330;
UPDATE ruian_katastr SET nazev = 'Dubějovice' WHERE kod = 633348;
UPDATE ruian_katastr SET nazev = 'Bytíz' WHERE kod = 633356;
UPDATE ruian_katastr SET nazev = 'Dubenec u Příbramě' WHERE kod = 633364;
UPDATE ruian_katastr SET nazev = 'Dubenec' WHERE kod = 633372;
UPDATE ruian_katastr SET nazev = 'Dubí u Teplic' WHERE kod = 633381;
UPDATE ruian_katastr SET nazev = 'Dubí-Bystřice' WHERE kod = 633402;
UPDATE ruian_katastr SET nazev = 'Běhánky' WHERE kod = 633411;
UPDATE ruian_katastr SET nazev = 'Drahůnky' WHERE kod = 633429;
UPDATE ruian_katastr SET nazev = 'Dubí-Pozorka' WHERE kod = 633461;
UPDATE ruian_katastr SET nazev = 'Dubice nad Labem' WHERE kod = 633496;
UPDATE ruian_katastr SET nazev = 'Moravany u Dubic' WHERE kod = 633500;
UPDATE ruian_katastr SET nazev = 'Radejčín' WHERE kod = 633518;
UPDATE ruian_katastr SET nazev = 'Dubicko' WHERE kod = 633526;
UPDATE ruian_katastr SET nazev = 'Dubičné' WHERE kod = 633534;
UPDATE ruian_katastr SET nazev = 'Břekova Lhota' WHERE kod = 633569;
UPDATE ruian_katastr SET nazev = 'Dublovice' WHERE kod = 633577;
UPDATE ruian_katastr SET nazev = 'Dubňany' WHERE kod = 633585;
UPDATE ruian_katastr SET nazev = 'Branišov u Dubného' WHERE kod = 633615;
UPDATE ruian_katastr SET nazev = 'Dubné' WHERE kod = 633623;
UPDATE ruian_katastr SET nazev = 'Jaronice' WHERE kod = 633631;
UPDATE ruian_katastr SET nazev = 'Křenovice u Dubného' WHERE kod = 633640;
UPDATE ruian_katastr SET nazev = 'Třebín' WHERE kod = 633658;
UPDATE ruian_katastr SET nazev = 'Dubnice pod Ralskem' WHERE kod = 633666;
UPDATE ruian_katastr SET nazev = 'Dubnice' WHERE kod = 633674;
UPDATE ruian_katastr SET nazev = 'Dubno' WHERE kod = 633682;
UPDATE ruian_katastr SET nazev = 'Dubovice' WHERE kod = 633691;
UPDATE ruian_katastr SET nazev = 'Dudín' WHERE kod = 633704;
UPDATE ruian_katastr SET nazev = 'Duchcov' WHERE kod = 633712;
UPDATE ruian_katastr SET nazev = 'Dukovany' WHERE kod = 633810;
UPDATE ruian_katastr SET nazev = 'Dunajovice' WHERE kod = 633828;
UPDATE ruian_katastr SET nazev = 'Dunice' WHERE kod = 633836;
UPDATE ruian_katastr SET nazev = 'Dunovice' WHERE kod = 633844;
UPDATE ruian_katastr SET nazev = 'Dušejov' WHERE kod = 633852;
UPDATE ruian_katastr SET nazev = 'Dušníky' WHERE kod = 633861;
UPDATE ruian_katastr SET nazev = 'Dvorce u Bruntálu' WHERE kod = 633879;
UPDATE ruian_katastr SET nazev = 'Rejchartice' WHERE kod = 633887;
UPDATE ruian_katastr SET nazev = 'Dvorska' WHERE kod = 633895;
UPDATE ruian_katastr SET nazev = 'Dvory u Nymburka' WHERE kod = 633909;
UPDATE ruian_katastr SET nazev = 'Dvory nad Lužnicí' WHERE kod = 633925;
UPDATE ruian_katastr SET nazev = 'Dvořisko' WHERE kod = 633933;
UPDATE ruian_katastr SET nazev = 'Nořín' WHERE kod = 633941;
UPDATE ruian_katastr SET nazev = 'Dvůr Králové nad Labem' WHERE kod = 633968;
UPDATE ruian_katastr SET nazev = 'Zboží u Dvora Králové' WHERE kod = 634077;
UPDATE ruian_katastr SET nazev = 'Žireč Městys' WHERE kod = 634085;
UPDATE ruian_katastr SET nazev = 'Žirecká Podstráň' WHERE kod = 634093;
UPDATE ruian_katastr SET nazev = 'Sylvárov' WHERE kod = 634123;
UPDATE ruian_katastr SET nazev = 'Žireč Ves' WHERE kod = 634131;
UPDATE ruian_katastr SET nazev = 'Dyjákovice' WHERE kod = 634140;
UPDATE ruian_katastr SET nazev = 'Velký Karlov' WHERE kod = 634158;
UPDATE ruian_katastr SET nazev = 'Dyjákovičky' WHERE kod = 634166;
UPDATE ruian_katastr SET nazev = 'Dyje' WHERE kod = 634174;
UPDATE ruian_katastr SET nazev = 'Dolní Dvorce u Telče' WHERE kod = 634182;
UPDATE ruian_katastr SET nazev = 'Dyjice' WHERE kod = 634191;
UPDATE ruian_katastr SET nazev = 'Rozsíčky u Telče' WHERE kod = 634204;
UPDATE ruian_katastr SET nazev = 'Dyjička' WHERE kod = 634212;
UPDATE ruian_katastr SET nazev = 'Stranná u Telče' WHERE kod = 634221;
UPDATE ruian_katastr SET nazev = 'Černá Hora u Dymokur' WHERE kod = 634239;
UPDATE ruian_katastr SET nazev = 'Dymokury' WHERE kod = 634247;
UPDATE ruian_katastr SET nazev = 'Dynín' WHERE kod = 634255;
UPDATE ruian_katastr SET nazev = 'Lhota u Dynína' WHERE kod = 634271;
UPDATE ruian_katastr SET nazev = 'Dýšina' WHERE kod = 634280;
UPDATE ruian_katastr SET nazev = 'Dzbel' WHERE kod = 634301;
UPDATE ruian_katastr SET nazev = 'Džbánice' WHERE kod = 634310;
UPDATE ruian_katastr SET nazev = 'Džbánov u Litomyšle' WHERE kod = 634328;
UPDATE ruian_katastr SET nazev = 'Džbánov u Vysokého Mýta' WHERE kod = 634336;
UPDATE ruian_katastr SET nazev = 'Ejpovice' WHERE kod = 634344;
UPDATE ruian_katastr SET nazev = 'Encovany' WHERE kod = 634379;
UPDATE ruian_katastr SET nazev = 'Třebutičky' WHERE kod = 634387;
UPDATE ruian_katastr SET nazev = 'Blahousty' WHERE kod = 634395;
UPDATE ruian_katastr SET nazev = 'Erpužice' WHERE kod = 634409;
UPDATE ruian_katastr SET nazev = 'Lomnička' WHERE kod = 634417;
UPDATE ruian_katastr SET nazev = 'Malovice u Erpužic' WHERE kod = 634425;
UPDATE ruian_katastr SET nazev = 'Eš' WHERE kod = 634433;
UPDATE ruian_katastr SET nazev = 'Evaň' WHERE kod = 634441;
UPDATE ruian_katastr SET nazev = 'Horka u Libochovic' WHERE kod = 634450;
UPDATE ruian_katastr SET nazev = 'Felbabka' WHERE kod = 634468;
UPDATE ruian_katastr SET nazev = 'Filipov' WHERE kod = 634476;
UPDATE ruian_katastr SET nazev = 'Fojtov' WHERE kod = 634492;
UPDATE ruian_katastr SET nazev = 'Lužec u Nejdku' WHERE kod = 634506;
UPDATE ruian_katastr SET nazev = 'Pozorka u Nejdku' WHERE kod = 634522;
UPDATE ruian_katastr SET nazev = 'Smolné Pece' WHERE kod = 634531;
UPDATE ruian_katastr SET nazev = 'Vysoká Štola' WHERE kod = 634549;
UPDATE ruian_katastr SET nazev = 'Dolní Folmava' WHERE kod = 634557;
UPDATE ruian_katastr SET nazev = 'Horní Folmava' WHERE kod = 634565;
UPDATE ruian_katastr SET nazev = 'Francova Lhota' WHERE kod = 634581;
UPDATE ruian_katastr SET nazev = 'Františkov nad Ploučnicí' WHERE kod = 634603;
UPDATE ruian_katastr SET nazev = 'Oldřichov nad Ploučnicí' WHERE kod = 634620;
UPDATE ruian_katastr SET nazev = 'Jedličná' WHERE kod = 634638;
UPDATE ruian_katastr SET nazev = 'Františkovy Lázně' WHERE kod = 634646;
UPDATE ruian_katastr SET nazev = 'Horní Lomany' WHERE kod = 634654;
UPDATE ruian_katastr SET nazev = 'Krapice' WHERE kod = 634662;
UPDATE ruian_katastr SET nazev = 'Slatina u Františkových Lázní' WHERE kod = 634689;
UPDATE ruian_katastr SET nazev = 'Žírovice' WHERE kod = 634697;
UPDATE ruian_katastr SET nazev = 'Františky' WHERE kod = 634701;
UPDATE ruian_katastr SET nazev = 'Frenštát pod Radhoštěm' WHERE kod = 634719;
UPDATE ruian_katastr SET nazev = 'Fryčovice' WHERE kod = 634808;
UPDATE ruian_katastr SET nazev = 'Místek' WHERE kod = 634824;
UPDATE ruian_katastr SET nazev = 'Frýdek' WHERE kod = 634956;
UPDATE ruian_katastr SET nazev = 'Panské Nové Dvory' WHERE kod = 635081;
UPDATE ruian_katastr SET nazev = 'Frýdlant' WHERE kod = 635090;
UPDATE ruian_katastr SET nazev = 'Frýdlant nad Ostravicí' WHERE kod = 635171;
UPDATE ruian_katastr SET nazev = 'Frýdnava' WHERE kod = 635197;
UPDATE ruian_katastr SET nazev = 'Frýdštejn' WHERE kod = 635201;
UPDATE ruian_katastr SET nazev = 'Ondříkovice' WHERE kod = 635227;
UPDATE ruian_katastr SET nazev = 'Frymburk' WHERE kod = 635260;
UPDATE ruian_katastr SET nazev = 'Pasečná' WHERE kod = 635286;
UPDATE ruian_katastr SET nazev = 'Frydava' WHERE kod = 635294;
UPDATE ruian_katastr SET nazev = 'Jasánky' WHERE kod = 635316;
UPDATE ruian_katastr SET nazev = 'Fryšava pod Žákovou horou' WHERE kod = 635324;
UPDATE ruian_katastr SET nazev = 'Tři Studně' WHERE kod = 635332;
UPDATE ruian_katastr SET nazev = 'Dolní Ves' WHERE kod = 635341;
UPDATE ruian_katastr SET nazev = 'Fryšták' WHERE kod = 635359;
UPDATE ruian_katastr SET nazev = 'Horní Ves u Fryštáku' WHERE kod = 635367;
UPDATE ruian_katastr SET nazev = 'Vítová' WHERE kod = 635405;
UPDATE ruian_katastr SET nazev = 'Fulnek' WHERE kod = 635448;
UPDATE ruian_katastr SET nazev = 'Jerlochovice' WHERE kod = 635456;
UPDATE ruian_katastr SET nazev = 'Golčův Jeníkov' WHERE kod = 635481;
UPDATE ruian_katastr SET nazev = 'Kobylí Hlava' WHERE kod = 635499;
UPDATE ruian_katastr SET nazev = 'Nasavrky u Golčova Jeníkova' WHERE kod = 635502;
UPDATE ruian_katastr SET nazev = 'Podmoky u Golčova Jeníkova' WHERE kod = 635537;
UPDATE ruian_katastr SET nazev = 'Římovice' WHERE kod = 635545;
UPDATE ruian_katastr SET nazev = 'Vrtěšice' WHERE kod = 635553;
UPDATE ruian_katastr SET nazev = 'Zlín' WHERE kod = 635561;
UPDATE ruian_katastr SET nazev = 'Příluky u Zlína' WHERE kod = 635812;
UPDATE ruian_katastr SET nazev = 'Jaroslavice u Zlína' WHERE kod = 635863;
UPDATE ruian_katastr SET nazev = 'Kudlov' WHERE kod = 635898;
UPDATE ruian_katastr SET nazev = 'Malenovice u Zlína' WHERE kod = 635987;
UPDATE ruian_katastr SET nazev = 'Tečovice' WHERE kod = 636029;
UPDATE ruian_katastr SET nazev = 'Lhotka u Zlína' WHERE kod = 636053;
UPDATE ruian_katastr SET nazev = 'Louky nad Dřevnicí' WHERE kod = 636118;
UPDATE ruian_katastr SET nazev = 'Prštné' WHERE kod = 636142;
UPDATE ruian_katastr SET nazev = 'Mladcová' WHERE kod = 636177;
UPDATE ruian_katastr SET nazev = 'Grešlové Mýto' WHERE kod = 636215;
UPDATE ruian_katastr SET nazev = 'Gručovice' WHERE kod = 636223;
UPDATE ruian_katastr SET nazev = 'Gruna' WHERE kod = 636231;
UPDATE ruian_katastr SET nazev = 'Žipotín' WHERE kod = 636258;
UPDATE ruian_katastr SET nazev = 'Grygov' WHERE kod = 636266;
UPDATE ruian_katastr SET nazev = 'Grymov' WHERE kod = 636274;
UPDATE ruian_katastr SET nazev = 'Guty' WHERE kod = 636291;
UPDATE ruian_katastr SET nazev = 'Habartice u Frýdlantu' WHERE kod = 636312;
UPDATE ruian_katastr SET nazev = 'Háj u Habartic' WHERE kod = 636321;
UPDATE ruian_katastr SET nazev = 'Habartov' WHERE kod = 636339;
UPDATE ruian_katastr SET nazev = 'Habrek' WHERE kod = 636363;
UPDATE ruian_katastr SET nazev = 'Obrvaň' WHERE kod = 636371;
UPDATE ruian_katastr SET nazev = 'Souboř' WHERE kod = 636380;
UPDATE ruian_katastr SET nazev = 'Habrovany u Řehlovic' WHERE kod = 636398;
UPDATE ruian_katastr SET nazev = 'Habrovany' WHERE kod = 636401;
UPDATE ruian_katastr SET nazev = 'Olšany' WHERE kod = 636410;
UPDATE ruian_katastr SET nazev = 'Habrovice' WHERE kod = 636436;
UPDATE ruian_katastr SET nazev = 'Strážky u Habrovic' WHERE kod = 636444;
UPDATE ruian_katastr SET nazev = 'Habrůvka' WHERE kod = 636452;
UPDATE ruian_katastr SET nazev = 'Habry' WHERE kod = 636479;
UPDATE ruian_katastr SET nazev = 'Habřina' WHERE kod = 636487;
UPDATE ruian_katastr SET nazev = 'Chabičov ve Slezsku' WHERE kod = 636495;
UPDATE ruian_katastr SET nazev = 'Smolkov' WHERE kod = 636509;
UPDATE ruian_katastr SET nazev = 'Domaslavice' WHERE kod = 636517;
UPDATE ruian_katastr SET nazev = 'Háj u Duchcova' WHERE kod = 636525;
UPDATE ruian_katastr SET nazev = 'Hajany u Blatné' WHERE kod = 636533;
UPDATE ruian_katastr SET nazev = 'Hajany' WHERE kod = 636541;
UPDATE ruian_katastr SET nazev = 'Háje u Příbramě' WHERE kod = 636550;
UPDATE ruian_katastr SET nazev = 'Dolní Pelhřimov' WHERE kod = 636568;
UPDATE ruian_katastr SET nazev = 'Háje u Chebu' WHERE kod = 636576;
UPDATE ruian_katastr SET nazev = 'Dolní Sytová' WHERE kod = 636614;
UPDATE ruian_katastr SET nazev = 'Háje nad Jizerou' WHERE kod = 636622;
UPDATE ruian_katastr SET nazev = 'Rybnice' WHERE kod = 636649;
UPDATE ruian_katastr SET nazev = 'Blanice' WHERE kod = 636657;
UPDATE ruian_katastr SET nazev = 'Hájek u Bavorova' WHERE kod = 636665;
UPDATE ruian_katastr SET nazev = 'Hájek u Všerub' WHERE kod = 636673;
UPDATE ruian_katastr SET nazev = 'Hájek u Ostrova' WHERE kod = 636681;
UPDATE ruian_katastr SET nazev = 'Nová Víska u Ostrova' WHERE kod = 636690;
UPDATE ruian_katastr SET nazev = 'Hájek u Tišnova' WHERE kod = 636711;
UPDATE ruian_katastr SET nazev = 'Brusnice' WHERE kod = 636720;
UPDATE ruian_katastr SET nazev = 'Hajnice' WHERE kod = 636738;
UPDATE ruian_katastr SET nazev = 'Kyje u Hajnice' WHERE kod = 636746;
UPDATE ruian_katastr SET nazev = 'Nesytá' WHERE kod = 636762;
UPDATE ruian_katastr SET nazev = 'Hájov' WHERE kod = 636771;
UPDATE ruian_katastr SET nazev = 'Haklovy Dvory' WHERE kod = 636797;
UPDATE ruian_katastr SET nazev = 'Halámky' WHERE kod = 636827;
UPDATE ruian_katastr SET nazev = 'Halenkov' WHERE kod = 636878;
UPDATE ruian_katastr SET nazev = 'Halenkovice' WHERE kod = 636908;
UPDATE ruian_katastr SET nazev = 'Haluzice' WHERE kod = 636959;
UPDATE ruian_katastr SET nazev = 'Branka u Tachova' WHERE kod = 636967;
UPDATE ruian_katastr SET nazev = 'Halže' WHERE kod = 636975;
UPDATE ruian_katastr SET nazev = 'Výšina' WHERE kod = 636983;
UPDATE ruian_katastr SET nazev = 'Svobodka' WHERE kod = 636991;
UPDATE ruian_katastr SET nazev = 'Žďár u Tachova' WHERE kod = 637009;
UPDATE ruian_katastr SET nazev = 'Hamr' WHERE kod = 637017;
UPDATE ruian_katastr SET nazev = 'Hamr na Jezeře' WHERE kod = 637033;
UPDATE ruian_katastr SET nazev = 'Hamr u Litvínova' WHERE kod = 637050;
UPDATE ruian_katastr SET nazev = 'Janov u Litvínova' WHERE kod = 637068;
UPDATE ruian_katastr SET nazev = 'Křížatky' WHERE kod = 637076;
UPDATE ruian_katastr SET nazev = 'Hamry u Hlinska' WHERE kod = 637084;
UPDATE ruian_katastr SET nazev = 'Hamry nad Křetínkou' WHERE kod = 637092;
UPDATE ruian_katastr SET nazev = 'Hamry nad Sázavou' WHERE kod = 637106;
UPDATE ruian_katastr SET nazev = 'Najdek na Moravě' WHERE kod = 637114;
UPDATE ruian_katastr SET nazev = 'Haňovice' WHERE kod = 637131;
UPDATE ruian_katastr SET nazev = 'Chudobín' WHERE kod = 637157;
UPDATE ruian_katastr SET nazev = 'Myslechovice' WHERE kod = 637165;
UPDATE ruian_katastr SET nazev = 'Nasobůrky' WHERE kod = 637173;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Litovle' WHERE kod = 637181;
UPDATE ruian_katastr SET nazev = 'Víska u Litovle' WHERE kod = 637190;
UPDATE ruian_katastr SET nazev = 'Hanušovice' WHERE kod = 637203;
UPDATE ruian_katastr SET nazev = 'Hynčice nad Moravou' WHERE kod = 637211;
UPDATE ruian_katastr SET nazev = 'Potůčník' WHERE kod = 637220;
UPDATE ruian_katastr SET nazev = 'Harrachov' WHERE kod = 637238;
UPDATE ruian_katastr SET nazev = 'Hartinkov' WHERE kod = 637254;
UPDATE ruian_katastr SET nazev = 'Dolejší Těšov' WHERE kod = 637262;
UPDATE ruian_katastr SET nazev = 'Hartmanice I' WHERE kod = 637271;
UPDATE ruian_katastr SET nazev = 'Hořejší Krušec' WHERE kod = 637289;
UPDATE ruian_katastr SET nazev = 'Hořejší Těšov' WHERE kod = 637297;
UPDATE ruian_katastr SET nazev = 'Chlum u Hartmanic' WHERE kod = 637301;
UPDATE ruian_katastr SET nazev = 'Javoří u Hartmanic' WHERE kod = 637319;
UPDATE ruian_katastr SET nazev = 'Kochánov II' WHERE kod = 637327;
UPDATE ruian_katastr SET nazev = 'Kundratice I' WHERE kod = 637335;
UPDATE ruian_katastr SET nazev = 'Loučová' WHERE kod = 637343;
UPDATE ruian_katastr SET nazev = 'Mochov u Hartmanic' WHERE kod = 637351;
UPDATE ruian_katastr SET nazev = 'Dolejší Krušec' WHERE kod = 637378;
UPDATE ruian_katastr SET nazev = 'Světlá u Hartmanic' WHERE kod = 637386;
UPDATE ruian_katastr SET nazev = 'Štěpanice' WHERE kod = 637394;
UPDATE ruian_katastr SET nazev = 'Vatětice' WHERE kod = 637408;
UPDATE ruian_katastr SET nazev = 'Vlastějov' WHERE kod = 637416;
UPDATE ruian_katastr SET nazev = 'Zálužice I' WHERE kod = 637424;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Hartmanic' WHERE kod = 637432;
UPDATE ruian_katastr SET nazev = 'Hartmanice u Poličky' WHERE kod = 637441;
UPDATE ruian_katastr SET nazev = 'Hartvíkovice' WHERE kod = 637459;
UPDATE ruian_katastr SET nazev = 'Třesov' WHERE kod = 637467;
UPDATE ruian_katastr SET nazev = 'Hasina' WHERE kod = 637483;
UPDATE ruian_katastr SET nazev = 'Hať' WHERE kod = 637491;
UPDATE ruian_katastr SET nazev = 'Hatín' WHERE kod = 637513;
UPDATE ruian_katastr SET nazev = 'Polště' WHERE kod = 637530;
UPDATE ruian_katastr SET nazev = 'Stajka' WHERE kod = 637548;
UPDATE ruian_katastr SET nazev = 'Havířov-město' WHERE kod = 637556;
UPDATE ruian_katastr SET nazev = 'Bludovice' WHERE kod = 637696;
UPDATE ruian_katastr SET nazev = 'Šumbark' WHERE kod = 637734;
UPDATE ruian_katastr SET nazev = 'Prostřední Suchá' WHERE kod = 637742;
UPDATE ruian_katastr SET nazev = 'Dolní Suchá' WHERE kod = 637777;
UPDATE ruian_katastr SET nazev = 'Havlíčkův Brod' WHERE kod = 637823;
UPDATE ruian_katastr SET nazev = 'Perknov' WHERE kod = 637955;
UPDATE ruian_katastr SET nazev = 'Havlíčkova Borová' WHERE kod = 637963;
UPDATE ruian_katastr SET nazev = 'Peršíkov' WHERE kod = 637971;
UPDATE ruian_katastr SET nazev = 'Havlovice u Domažlic' WHERE kod = 637980;
UPDATE ruian_katastr SET nazev = 'Havlovice' WHERE kod = 637998;
UPDATE ruian_katastr SET nazev = 'Havraň' WHERE kod = 638021;
UPDATE ruian_katastr SET nazev = 'Havraníky' WHERE kod = 638056;
UPDATE ruian_katastr SET nazev = 'Havřice' WHERE kod = 638064;
UPDATE ruian_katastr SET nazev = 'Hazlov' WHERE kod = 638072;
UPDATE ruian_katastr SET nazev = 'Lipná u Hazlova' WHERE kod = 638081;
UPDATE ruian_katastr SET nazev = 'Polná u Hazlova' WHERE kod = 638111;
UPDATE ruian_katastr SET nazev = 'Skalka u Hazlova' WHERE kod = 638129;
UPDATE ruian_katastr SET nazev = 'Táborská' WHERE kod = 638137;
UPDATE ruian_katastr SET nazev = 'Výhledy' WHERE kod = 638145;
UPDATE ruian_katastr SET nazev = 'Otov u Hazlova' WHERE kod = 638153;
UPDATE ruian_katastr SET nazev = 'Hejná' WHERE kod = 638161;
UPDATE ruian_katastr SET nazev = 'Hejnice' WHERE kod = 638196;
UPDATE ruian_katastr SET nazev = 'Hejnice u Žamberka' WHERE kod = 638200;
UPDATE ruian_katastr SET nazev = 'Hejtmánkovice' WHERE kod = 638226;
UPDATE ruian_katastr SET nazev = 'Helkovice' WHERE kod = 638234;
UPDATE ruian_katastr SET nazev = 'Helvíkovice' WHERE kod = 638242;
UPDATE ruian_katastr SET nazev = 'Hemže' WHERE kod = 638269;
UPDATE ruian_katastr SET nazev = 'Henčlov' WHERE kod = 638277;
UPDATE ruian_katastr SET nazev = 'Boňkov' WHERE kod = 638285;
UPDATE ruian_katastr SET nazev = 'Herálec' WHERE kod = 638293;
UPDATE ruian_katastr SET nazev = 'Koječín' WHERE kod = 638315;
UPDATE ruian_katastr SET nazev = 'Český Herálec' WHERE kod = 638323;
UPDATE ruian_katastr SET nazev = 'Kocanda' WHERE kod = 638340;
UPDATE ruian_katastr SET nazev = 'Herálec na Moravě' WHERE kod = 638358;
UPDATE ruian_katastr SET nazev = 'Heraltice' WHERE kod = 638366;
UPDATE ruian_katastr SET nazev = 'Pokojovice' WHERE kod = 638382;
UPDATE ruian_katastr SET nazev = 'Herbortice' WHERE kod = 638391;
UPDATE ruian_katastr SET nazev = 'Mezilesí u Lanškrouna' WHERE kod = 638404;
UPDATE ruian_katastr SET nazev = 'Heroltice u Tišnova' WHERE kod = 638412;
UPDATE ruian_katastr SET nazev = 'Heroltice u Jihlavy' WHERE kod = 638421;
UPDATE ruian_katastr SET nazev = 'Heroltice u Štítů' WHERE kod = 638439;
UPDATE ruian_katastr SET nazev = 'Heřmaň' WHERE kod = 638447;
UPDATE ruian_katastr SET nazev = 'Heřmaneč' WHERE kod = 638455;
UPDATE ruian_katastr SET nazev = 'Maršov u Heřmanče' WHERE kod = 638463;
UPDATE ruian_katastr SET nazev = 'Heřmanice v Podještědí' WHERE kod = 638471;
UPDATE ruian_katastr SET nazev = 'Brod nad Labem' WHERE kod = 638498;
UPDATE ruian_katastr SET nazev = 'Heřmanice nad Labem' WHERE kod = 638501;
UPDATE ruian_katastr SET nazev = 'Hořenice' WHERE kod = 638510;
UPDATE ruian_katastr SET nazev = 'Slotov' WHERE kod = 638528;
UPDATE ruian_katastr SET nazev = 'Heřmanice u Rouchovan' WHERE kod = 638536;
UPDATE ruian_katastr SET nazev = 'Heřmanice u Oder' WHERE kod = 638544;
UPDATE ruian_katastr SET nazev = 'Véska u Oder' WHERE kod = 638552;
UPDATE ruian_katastr SET nazev = 'Heřmanice u Polomi' WHERE kod = 638561;
UPDATE ruian_katastr SET nazev = 'Heřmanice u Žandova' WHERE kod = 638579;
UPDATE ruian_katastr SET nazev = 'Heřmaničky' WHERE kod = 638587;
UPDATE ruian_katastr SET nazev = 'Heřmánkovice' WHERE kod = 638609;
UPDATE ruian_katastr SET nazev = 'Janovičky u Broumova' WHERE kod = 638625;
UPDATE ruian_katastr SET nazev = 'Blankartice' WHERE kod = 638633;
UPDATE ruian_katastr SET nazev = 'Fojtovice u Heřmanova' WHERE kod = 638641;
UPDATE ruian_katastr SET nazev = 'Heřmanov' WHERE kod = 638650;
UPDATE ruian_katastr SET nazev = 'Heřmanov u Křižanova' WHERE kod = 638668;
UPDATE ruian_katastr SET nazev = 'Milešín' WHERE kod = 638676;
UPDATE ruian_katastr SET nazev = 'Dolní Sekyřany' WHERE kod = 638684;
UPDATE ruian_katastr SET nazev = 'Hněvnice' WHERE kod = 638692;
UPDATE ruian_katastr SET nazev = 'Horní Sekyřany' WHERE kod = 638706;
UPDATE ruian_katastr SET nazev = 'Vlkýš' WHERE kod = 638714;
UPDATE ruian_katastr SET nazev = 'Heřmanovice' WHERE kod = 638722;
UPDATE ruian_katastr SET nazev = 'Heřmanův Městec' WHERE kod = 638731;
UPDATE ruian_katastr SET nazev = 'Chotěnice' WHERE kod = 638749;
UPDATE ruian_katastr SET nazev = 'Hevlín' WHERE kod = 638781;
UPDATE ruian_katastr SET nazev = 'Hladké Životice' WHERE kod = 638790;
UPDATE ruian_katastr SET nazev = 'Hladov' WHERE kod = 638811;
UPDATE ruian_katastr SET nazev = 'Hlasivo' WHERE kod = 638838;
UPDATE ruian_katastr SET nazev = 'Rašovice u Hlasiva' WHERE kod = 638854;
UPDATE ruian_katastr SET nazev = 'Březina u Jičína' WHERE kod = 638871;
UPDATE ruian_katastr SET nazev = 'Hlásná Lhota u Jičína' WHERE kod = 638889;
UPDATE ruian_katastr SET nazev = 'Hlásná Třebaň' WHERE kod = 638901;
UPDATE ruian_katastr SET nazev = 'Hlásnice' WHERE kod = 638927;
UPDATE ruian_katastr SET nazev = 'Hlavatce' WHERE kod = 638935;
UPDATE ruian_katastr SET nazev = 'Vyhnanice' WHERE kod = 638943;
UPDATE ruian_katastr SET nazev = 'Hlavečník' WHERE kod = 638951;
UPDATE ruian_katastr SET nazev = 'Hlavenec' WHERE kod = 638960;
UPDATE ruian_katastr SET nazev = 'Hlavice' WHERE kod = 638978;
UPDATE ruian_katastr SET nazev = 'Hrubý Lesnov' WHERE kod = 638986;
UPDATE ruian_katastr SET nazev = 'Vápno' WHERE kod = 639010;
UPDATE ruian_katastr SET nazev = 'Hlávkov' WHERE kod = 639028;
UPDATE ruian_katastr SET nazev = 'Hlavnice' WHERE kod = 639036;
UPDATE ruian_katastr SET nazev = 'Hlavňov u Budislavi' WHERE kod = 639044;
UPDATE ruian_katastr SET nazev = 'Častonice' WHERE kod = 639061;
UPDATE ruian_katastr SET nazev = 'Čeletice' WHERE kod = 639079;
UPDATE ruian_katastr SET nazev = 'Horní Staňkov' WHERE kod = 639095;
UPDATE ruian_katastr SET nazev = 'Pích' WHERE kod = 639109;
UPDATE ruian_katastr SET nazev = 'Milínov' WHERE kod = 639117;
UPDATE ruian_katastr SET nazev = 'Přestanice' WHERE kod = 639125;
UPDATE ruian_katastr SET nazev = 'Radostice u Hlavňovic' WHERE kod = 639133;
UPDATE ruian_katastr SET nazev = 'Suchá u Hlavňovic' WHERE kod = 639141;
UPDATE ruian_katastr SET nazev = 'Zámyšl' WHERE kod = 639150;
UPDATE ruian_katastr SET nazev = 'Zvíkov' WHERE kod = 639168;
UPDATE ruian_katastr SET nazev = 'Mokřany' WHERE kod = 639176;
UPDATE ruian_katastr SET nazev = 'Hlína u Ivančic' WHERE kod = 639184;
UPDATE ruian_katastr SET nazev = 'Hlincová Hora' WHERE kod = 639192;
UPDATE ruian_katastr SET nazev = 'Hliněný Újezd' WHERE kod = 639206;
UPDATE ruian_katastr SET nazev = 'Malé Hydčice' WHERE kod = 639214;
UPDATE ruian_katastr SET nazev = 'Týnec u Hliněného Újezdu' WHERE kod = 639222;
UPDATE ruian_katastr SET nazev = 'Hlinice' WHERE kod = 639231;
UPDATE ruian_katastr SET nazev = 'Hlinka' WHERE kod = 639249;
UPDATE ruian_katastr SET nazev = 'Hlinná' WHERE kod = 639257;
UPDATE ruian_katastr SET nazev = 'Lbín' WHERE kod = 639273;
UPDATE ruian_katastr SET nazev = 'Tlučeň' WHERE kod = 639281;
UPDATE ruian_katastr SET nazev = 'Hlinné' WHERE kod = 639290;
UPDATE ruian_katastr SET nazev = 'Hlinsko v Čechách' WHERE kod = 639303;
UPDATE ruian_katastr SET nazev = 'Blatno u Hlinska' WHERE kod = 639346;
UPDATE ruian_katastr SET nazev = 'Srní u Hlinska' WHERE kod = 639397;
UPDATE ruian_katastr SET nazev = 'Hlinsko' WHERE kod = 639401;
UPDATE ruian_katastr SET nazev = 'Hlinsko pod Hostýnem' WHERE kod = 639419;
UPDATE ruian_katastr SET nazev = 'Hlohová' WHERE kod = 639427;
UPDATE ruian_katastr SET nazev = 'Hlohovec' WHERE kod = 639435;
UPDATE ruian_katastr SET nazev = 'Hlohovice' WHERE kod = 639443;
UPDATE ruian_katastr SET nazev = 'Hlohovičky' WHERE kod = 639451;
UPDATE ruian_katastr SET nazev = 'Mostiště u Hlohovic' WHERE kod = 639460;
UPDATE ruian_katastr SET nazev = 'Svinná u Hlohovic' WHERE kod = 639478;
UPDATE ruian_katastr SET nazev = 'Hlubočany' WHERE kod = 639486;
UPDATE ruian_katastr SET nazev = 'Hlubočec' WHERE kod = 639508;
UPDATE ruian_katastr SET nazev = 'Hlubočky' WHERE kod = 639524;
UPDATE ruian_katastr SET nazev = 'Hluboká u Dačic' WHERE kod = 639532;
UPDATE ruian_katastr SET nazev = 'Hluboká u Krucemburku' WHERE kod = 639541;
UPDATE ruian_katastr SET nazev = 'Hluboká u Skutče' WHERE kod = 639559;
UPDATE ruian_katastr SET nazev = 'Střítež u Skutče' WHERE kod = 639575;
UPDATE ruian_katastr SET nazev = 'Bavorovice' WHERE kod = 639583;
UPDATE ruian_katastr SET nazev = 'Hluboká nad Vltavou' WHERE kod = 639605;
UPDATE ruian_katastr SET nazev = 'Munice' WHERE kod = 639613;
UPDATE ruian_katastr SET nazev = 'Hluboké' WHERE kod = 639648;
UPDATE ruian_katastr SET nazev = 'Hluboké Dvory' WHERE kod = 639656;
UPDATE ruian_katastr SET nazev = 'Hluboké Mašůvky' WHERE kod = 639664;
UPDATE ruian_katastr SET nazev = 'Hluboké u Kunštátu' WHERE kod = 639672;
UPDATE ruian_katastr SET nazev = 'Hluboš' WHERE kod = 639681;
UPDATE ruian_katastr SET nazev = 'Kardavec' WHERE kod = 639699;
UPDATE ruian_katastr SET nazev = 'Hlubyně' WHERE kod = 639702;
UPDATE ruian_katastr SET nazev = 'Hlučín' WHERE kod = 639711;
UPDATE ruian_katastr SET nazev = 'Darkovičky' WHERE kod = 639869;
UPDATE ruian_katastr SET nazev = 'Hluchov' WHERE kod = 639893;
UPDATE ruian_katastr SET nazev = 'Hluk' WHERE kod = 639907;
UPDATE ruian_katastr SET nazev = 'Hlupín' WHERE kod = 639915;
UPDATE ruian_katastr SET nazev = 'Hlušice' WHERE kod = 639923;
UPDATE ruian_katastr SET nazev = 'Hlušičky' WHERE kod = 639931;
UPDATE ruian_katastr SET nazev = 'Hlušovice' WHERE kod = 639940;
UPDATE ruian_katastr SET nazev = 'Hluzov' WHERE kod = 639958;
UPDATE ruian_katastr SET nazev = 'Hnanice pod Troskami' WHERE kod = 639982;
UPDATE ruian_katastr SET nazev = 'Štěpánovice u Rovenska pod Troskami' WHERE kod = 639991;
UPDATE ruian_katastr SET nazev = 'Hnanice' WHERE kod = 640000;
UPDATE ruian_katastr SET nazev = 'Hnátnice' WHERE kod = 640018;
UPDATE ruian_katastr SET nazev = 'Hněvčeves' WHERE kod = 640026;
UPDATE ruian_katastr SET nazev = 'Hněvětice' WHERE kod = 640034;
UPDATE ruian_katastr SET nazev = 'Hněvkov' WHERE kod = 640051;
UPDATE ruian_katastr SET nazev = 'Hněvkovice u Humpolce' WHERE kod = 640069;
UPDATE ruian_katastr SET nazev = 'Budeč nad Želivkou' WHERE kod = 640077;
UPDATE ruian_katastr SET nazev = 'Habrovčice' WHERE kod = 640085;
UPDATE ruian_katastr SET nazev = 'Hněvkovice u Ledče nad Sázavou' WHERE kod = 640093;
UPDATE ruian_katastr SET nazev = 'Chotěměřice' WHERE kod = 640107;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Dolních Kralovic' WHERE kod = 640115;
UPDATE ruian_katastr SET nazev = 'Zahájí u Hněvkovic' WHERE kod = 640131;
UPDATE ruian_katastr SET nazev = 'Hněvošice' WHERE kod = 640140;
UPDATE ruian_katastr SET nazev = 'Hněvotín' WHERE kod = 640158;
UPDATE ruian_katastr SET nazev = 'Hnojice' WHERE kod = 640166;
UPDATE ruian_katastr SET nazev = 'Hnojnice' WHERE kod = 640174;
UPDATE ruian_katastr SET nazev = 'Židovice u Hnojnic' WHERE kod = 640182;
UPDATE ruian_katastr SET nazev = 'Hnojník' WHERE kod = 640191;
UPDATE ruian_katastr SET nazev = 'Hobšovice' WHERE kod = 640204;
UPDATE ruian_katastr SET nazev = 'Skůry' WHERE kod = 640221;
UPDATE ruian_katastr SET nazev = 'Hodějice' WHERE kod = 640239;
UPDATE ruian_katastr SET nazev = 'Hodějovice' WHERE kod = 640247;
UPDATE ruian_katastr SET nazev = 'Hoděšovice' WHERE kod = 640255;
UPDATE ruian_katastr SET nazev = 'Hodětín' WHERE kod = 640263;
UPDATE ruian_katastr SET nazev = 'Hodice' WHERE kod = 640271;
UPDATE ruian_katastr SET nazev = 'Hodíškov' WHERE kod = 640280;
UPDATE ruian_katastr SET nazev = 'Hodkov' WHERE kod = 640298;
UPDATE ruian_katastr SET nazev = 'Krasoňovice' WHERE kod = 640301;
UPDATE ruian_katastr SET nazev = 'Lipina u Zruče nad Sázavou' WHERE kod = 640310;
UPDATE ruian_katastr SET nazev = 'Želivec' WHERE kod = 640336;
UPDATE ruian_katastr SET nazev = 'Hodkovice nad Mohelkou' WHERE kod = 640344;
UPDATE ruian_katastr SET nazev = 'Radoňovice' WHERE kod = 640352;
UPDATE ruian_katastr SET nazev = 'Záskalí' WHERE kod = 640361;
UPDATE ruian_katastr SET nazev = 'Hodonice u Bechyně' WHERE kod = 640387;
UPDATE ruian_katastr SET nazev = 'Hodonice' WHERE kod = 640395;
UPDATE ruian_katastr SET nazev = 'Hodonín u Kunštátu' WHERE kod = 640409;
UPDATE ruian_katastr SET nazev = 'Hodonín' WHERE kod = 640417;
UPDATE ruian_katastr SET nazev = 'Hodov' WHERE kod = 640611;
UPDATE ruian_katastr SET nazev = 'Hodslavice' WHERE kod = 640620;
UPDATE ruian_katastr SET nazev = 'Hojanovice' WHERE kod = 640638;
UPDATE ruian_katastr SET nazev = 'Hoješín' WHERE kod = 640654;
UPDATE ruian_katastr SET nazev = 'Hojkov' WHERE kod = 640697;
UPDATE ruian_katastr SET nazev = 'Hojovice' WHERE kod = 640719;
UPDATE ruian_katastr SET nazev = 'Hojsova Stráž' WHERE kod = 640727;
UPDATE ruian_katastr SET nazev = 'Holany' WHERE kod = 640735;
UPDATE ruian_katastr SET nazev = 'Loubí pod Vlhoštěm' WHERE kod = 640751;
UPDATE ruian_katastr SET nazev = 'Holasice' WHERE kod = 640778;
UPDATE ruian_katastr SET nazev = 'Holasovice' WHERE kod = 640786;
UPDATE ruian_katastr SET nazev = 'Kamenec' WHERE kod = 640794;
UPDATE ruian_katastr SET nazev = 'Loděnice' WHERE kod = 640808;
UPDATE ruian_katastr SET nazev = 'Neplachovice' WHERE kod = 640816;
UPDATE ruian_katastr SET nazev = 'Štemplovec' WHERE kod = 640824;
UPDATE ruian_katastr SET nazev = 'Dlouhá Ves' WHERE kod = 640841;
UPDATE ruian_katastr SET nazev = 'Hejnov' WHERE kod = 640859;
UPDATE ruian_katastr SET nazev = 'Holčovice' WHERE kod = 640867;
UPDATE ruian_katastr SET nazev = 'Jelení u Holčovic' WHERE kod = 640875;
UPDATE ruian_katastr SET nazev = 'Komora' WHERE kod = 640883;
UPDATE ruian_katastr SET nazev = 'Spálené' WHERE kod = 640891;
UPDATE ruian_katastr SET nazev = 'Holé Vrchy' WHERE kod = 640905;
UPDATE ruian_katastr SET nazev = 'Holedeč' WHERE kod = 640913;
UPDATE ruian_katastr SET nazev = 'Stránky' WHERE kod = 640921;
UPDATE ruian_katastr SET nazev = 'Veletice' WHERE kod = 640930;
UPDATE ruian_katastr SET nazev = 'Holenice' WHERE kod = 640948;
UPDATE ruian_katastr SET nazev = 'Holešice' WHERE kod = 640956;
UPDATE ruian_katastr SET nazev = 'Holešín' WHERE kod = 640964;
UPDATE ruian_katastr SET nazev = 'Holešov' WHERE kod = 640972;
UPDATE ruian_katastr SET nazev = 'Všetuly' WHERE kod = 641057;
UPDATE ruian_katastr SET nazev = 'Holešovice u Chroustovic' WHERE kod = 641111;
UPDATE ruian_katastr SET nazev = 'Dolní Holetín' WHERE kod = 641120;
UPDATE ruian_katastr SET nazev = 'Holetín' WHERE kod = 641138;
UPDATE ruian_katastr SET nazev = 'Holice v Čechách' WHERE kod = 641146;
UPDATE ruian_katastr SET nazev = 'Holice u Olomouce' WHERE kod = 641227;
UPDATE ruian_katastr SET nazev = 'Holín' WHERE kod = 641243;
UPDATE ruian_katastr SET nazev = 'Horní Lochov' WHERE kod = 641251;
UPDATE ruian_katastr SET nazev = 'Ohaveč' WHERE kod = 641260;
UPDATE ruian_katastr SET nazev = 'Pařezská Lhota' WHERE kod = 641278;
UPDATE ruian_katastr SET nazev = 'Prachov' WHERE kod = 641286;
UPDATE ruian_katastr SET nazev = 'Holohlavy' WHERE kod = 641294;
UPDATE ruian_katastr SET nazev = 'Holostřevy' WHERE kod = 641308;
UPDATE ruian_katastr SET nazev = 'Holoubkov' WHERE kod = 641316;
UPDATE ruian_katastr SET nazev = 'Těškov' WHERE kod = 641324;
UPDATE ruian_katastr SET nazev = 'Holovousy v Podkrkonoší' WHERE kod = 641332;
UPDATE ruian_katastr SET nazev = 'Holštejn' WHERE kod = 641367;
UPDATE ruian_katastr SET nazev = 'Babice u Holubče' WHERE kod = 641375;
UPDATE ruian_katastr SET nazev = 'Holubeč' WHERE kod = 641383;
UPDATE ruian_katastr SET nazev = 'Mělnice' WHERE kod = 641391;
UPDATE ruian_katastr SET nazev = 'Přes' WHERE kod = 641405;
UPDATE ruian_katastr SET nazev = 'Skařez' WHERE kod = 641413;
UPDATE ruian_katastr SET nazev = 'Holubí Zhoř' WHERE kod = 641430;
UPDATE ruian_katastr SET nazev = 'Holubice v Čechách' WHERE kod = 641456;
UPDATE ruian_katastr SET nazev = 'Kozinec' WHERE kod = 641464;
UPDATE ruian_katastr SET nazev = 'Holubov' WHERE kod = 641472;
UPDATE ruian_katastr SET nazev = 'Třísov' WHERE kod = 641529;
UPDATE ruian_katastr SET nazev = 'Holušice' WHERE kod = 641537;
UPDATE ruian_katastr SET nazev = 'Lísky u Holušic' WHERE kod = 641545;
UPDATE ruian_katastr SET nazev = 'Holýšov' WHERE kod = 641553;
UPDATE ruian_katastr SET nazev = 'Homole' WHERE kod = 641588;
UPDATE ruian_katastr SET nazev = 'Hradce u Homol' WHERE kod = 641596;
UPDATE ruian_katastr SET nazev = 'Planá u Českých Budějovic' WHERE kod = 641618;
UPDATE ruian_katastr SET nazev = 'Závraty' WHERE kod = 641626;
UPDATE ruian_katastr SET nazev = 'Bláhov' WHERE kod = 641634;
UPDATE ruian_katastr SET nazev = 'Homole u Panny' WHERE kod = 641677;
UPDATE ruian_katastr SET nazev = 'Lhota pod Pannou' WHERE kod = 641685;
UPDATE ruian_katastr SET nazev = 'Babiny II' WHERE kod = 641693;
UPDATE ruian_katastr SET nazev = 'Suletice' WHERE kod = 641707;
UPDATE ruian_katastr SET nazev = 'Babiny I' WHERE kod = 641715;
UPDATE ruian_katastr SET nazev = 'Honbice' WHERE kod = 641723;
UPDATE ruian_katastr SET nazev = 'Libanice' WHERE kod = 641731;
UPDATE ruian_katastr SET nazev = 'Honětice' WHERE kod = 641740;
UPDATE ruian_katastr SET nazev = 'Honezovice' WHERE kod = 641758;
UPDATE ruian_katastr SET nazev = 'Hradišťany' WHERE kod = 641766;
UPDATE ruian_katastr SET nazev = 'Hora Svaté Kateřiny' WHERE kod = 641774;
UPDATE ruian_katastr SET nazev = 'Malý Háj' WHERE kod = 641782;
UPDATE ruian_katastr SET nazev = 'Rudolice v Horách' WHERE kod = 641791;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Křimova' WHERE kod = 641804;
UPDATE ruian_katastr SET nazev = 'Hora Svatého Šebestiána' WHERE kod = 641812;
UPDATE ruian_katastr SET nazev = 'Jilmová' WHERE kod = 641821;
UPDATE ruian_katastr SET nazev = 'Pohraniční' WHERE kod = 641839;
UPDATE ruian_katastr SET nazev = 'Horákov' WHERE kod = 641847;
UPDATE ruian_katastr SET nazev = 'Horažďovice' WHERE kod = 641855;
UPDATE ruian_katastr SET nazev = 'Babín u Horažďovic' WHERE kod = 641871;
UPDATE ruian_katastr SET nazev = 'Svaté Pole u Horažďovic' WHERE kod = 641910;
UPDATE ruian_katastr SET nazev = 'Zářečí u Horažďovic' WHERE kod = 641928;
UPDATE ruian_katastr SET nazev = 'Horčápsko' WHERE kod = 641944;
UPDATE ruian_katastr SET nazev = 'Hlína' WHERE kod = 641979;
UPDATE ruian_katastr SET nazev = 'Horka u Chrudimi' WHERE kod = 641987;
UPDATE ruian_katastr SET nazev = 'Smrček u Žumberku' WHERE kod = 642002;
UPDATE ruian_katastr SET nazev = 'Horka nad Sázavou' WHERE kod = 642037;
UPDATE ruian_katastr SET nazev = 'Hrádek nad Želivkou' WHERE kod = 642045;
UPDATE ruian_katastr SET nazev = 'Horka nad Moravou' WHERE kod = 642061;
UPDATE ruian_katastr SET nazev = 'Horky u Tábora' WHERE kod = 642096;
UPDATE ruian_katastr SET nazev = 'Horky' WHERE kod = 642118;
UPDATE ruian_katastr SET nazev = 'Horky nad Jizerou' WHERE kod = 642126;
UPDATE ruian_katastr SET nazev = 'Horní Bečva' WHERE kod = 642169;
UPDATE ruian_katastr SET nazev = 'Horní Bělá' WHERE kod = 642312;
UPDATE ruian_katastr SET nazev = 'Hubenov u Horní Bělé' WHERE kod = 642321;
UPDATE ruian_katastr SET nazev = 'Horní Benešov' WHERE kod = 642355;
UPDATE ruian_katastr SET nazev = 'Horní Beřkovice' WHERE kod = 642363;
UPDATE ruian_katastr SET nazev = 'Horní Bezděkov' WHERE kod = 642371;
UPDATE ruian_katastr SET nazev = 'Horní Blatná' WHERE kod = 642380;
UPDATE ruian_katastr SET nazev = 'Horní Bludovice' WHERE kod = 642401;
UPDATE ruian_katastr SET nazev = 'Prostřední Bludovice' WHERE kod = 642410;
UPDATE ruian_katastr SET nazev = 'Horní Bojanovice' WHERE kod = 642444;
UPDATE ruian_katastr SET nazev = 'Horní Bolíkov' WHERE kod = 642452;
UPDATE ruian_katastr SET nazev = 'Horní Bory' WHERE kod = 642479;
UPDATE ruian_katastr SET nazev = 'Horní Bousov' WHERE kod = 642487;
UPDATE ruian_katastr SET nazev = 'Horní Bradlo' WHERE kod = 642517;
UPDATE ruian_katastr SET nazev = 'Lipka' WHERE kod = 642533;
UPDATE ruian_katastr SET nazev = 'Travná u Horního Bradla' WHERE kod = 642550;
UPDATE ruian_katastr SET nazev = 'Velká Střítež' WHERE kod = 642568;
UPDATE ruian_katastr SET nazev = 'Horní Branná' WHERE kod = 642584;
UPDATE ruian_katastr SET nazev = 'Horní Brusnice' WHERE kod = 642592;
UPDATE ruian_katastr SET nazev = 'Čížov' WHERE kod = 642606;
UPDATE ruian_katastr SET nazev = 'Horní Břečkov' WHERE kod = 642614;
UPDATE ruian_katastr SET nazev = 'Vracovice u Horního Břečkova' WHERE kod = 642622;
UPDATE ruian_katastr SET nazev = 'Horní Bříza' WHERE kod = 642631;
UPDATE ruian_katastr SET nazev = 'Bílá Hlína' WHERE kod = 642649;
UPDATE ruian_katastr SET nazev = 'Horní Bukovina' WHERE kod = 642665;
UPDATE ruian_katastr SET nazev = 'Horní Bukovsko' WHERE kod = 642673;
UPDATE ruian_katastr SET nazev = 'Horní Cerekev' WHERE kod = 642681;
UPDATE ruian_katastr SET nazev = 'Horní Čermná' WHERE kod = 642690;
UPDATE ruian_katastr SET nazev = 'Nepomuky' WHERE kod = 642703;
UPDATE ruian_katastr SET nazev = 'Horní Datyně' WHERE kod = 642720;
UPDATE ruian_katastr SET nazev = 'Horní Dehtov' WHERE kod = 642754;
UPDATE ruian_katastr SET nazev = 'Horní Dobrouč' WHERE kod = 642771;
UPDATE ruian_katastr SET nazev = 'Horní Domaslavice' WHERE kod = 642789;
UPDATE ruian_katastr SET nazev = 'Horní Dubenky' WHERE kod = 642827;
UPDATE ruian_katastr SET nazev = 'Horní Dubňany' WHERE kod = 642843;
UPDATE ruian_katastr SET nazev = 'Domčice' WHERE kod = 642851;
UPDATE ruian_katastr SET nazev = 'Horní Dunajovice' WHERE kod = 642860;
UPDATE ruian_katastr SET nazev = 'Horní Dušnice' WHERE kod = 642878;
UPDATE ruian_katastr SET nazev = 'Stromkovice' WHERE kod = 642886;
UPDATE ruian_katastr SET nazev = 'Český Heršlák' WHERE kod = 642894;
UPDATE ruian_katastr SET nazev = 'Horní Dvořiště' WHERE kod = 642908;
UPDATE ruian_katastr SET nazev = 'Horní Habartice' WHERE kod = 642916;
UPDATE ruian_katastr SET nazev = 'Horní Heřmanice v Čechách' WHERE kod = 642924;
UPDATE ruian_katastr SET nazev = 'Horní Heřmanice' WHERE kod = 642932;
UPDATE ruian_katastr SET nazev = 'Horní Hradiště' WHERE kod = 642941;
UPDATE ruian_katastr SET nazev = 'Dolní Chrášťany' WHERE kod = 642959;
UPDATE ruian_katastr SET nazev = 'Horní Chrášťany' WHERE kod = 642967;
UPDATE ruian_katastr SET nazev = 'Dolní Jelení' WHERE kod = 642975;
UPDATE ruian_katastr SET nazev = 'Horní Jelení' WHERE kod = 642983;
UPDATE ruian_katastr SET nazev = 'Černice u Horního Jiřetína' WHERE kod = 643025;
UPDATE ruian_katastr SET nazev = 'Horní Jiřetín' WHERE kod = 643033;
UPDATE ruian_katastr SET nazev = 'Horní Kalná' WHERE kod = 643050;
UPDATE ruian_katastr SET nazev = 'Dolní Kamenice u Holýšova' WHERE kod = 643068;
UPDATE ruian_katastr SET nazev = 'Horní Kamenice u Staňkova' WHERE kod = 643076;
UPDATE ruian_katastr SET nazev = 'Horní Kosov' WHERE kod = 643084;
UPDATE ruian_katastr SET nazev = 'Hosov' WHERE kod = 643092;
UPDATE ruian_katastr SET nazev = 'Horní Kounice' WHERE kod = 643106;
UPDATE ruian_katastr SET nazev = 'Horní Kozolupy' WHERE kod = 643114;
UPDATE ruian_katastr SET nazev = 'Očín' WHERE kod = 643122;
UPDATE ruian_katastr SET nazev = 'Slavice u Horních Kozolup' WHERE kod = 643131;
UPDATE ruian_katastr SET nazev = 'Strahov' WHERE kod = 643149;
UPDATE ruian_katastr SET nazev = 'Horní Krupá u Havlíčkova Brodu' WHERE kod = 643157;
UPDATE ruian_katastr SET nazev = 'Bohouňovice II' WHERE kod = 643190;
UPDATE ruian_katastr SET nazev = 'Dolní Kruty' WHERE kod = 643203;
UPDATE ruian_katastr SET nazev = 'Horní Kruty' WHERE kod = 643211;
UPDATE ruian_katastr SET nazev = 'Újezdec u Horních Krut' WHERE kod = 643238;
UPDATE ruian_katastr SET nazev = 'Horní Lapač' WHERE kod = 643246;
UPDATE ruian_katastr SET nazev = 'Horní Lhota' WHERE kod = 643262;
UPDATE ruian_katastr SET nazev = 'Horní Lhota u Blanska' WHERE kod = 643271;
UPDATE ruian_katastr SET nazev = 'Horní Lhota u Luhačovic' WHERE kod = 643289;
UPDATE ruian_katastr SET nazev = 'Horní Lhota u Ostravy' WHERE kod = 643297;
UPDATE ruian_katastr SET nazev = 'Horní Libchava' WHERE kod = 643319;
UPDATE ruian_katastr SET nazev = 'Horní Libchavy' WHERE kod = 643327;
UPDATE ruian_katastr SET nazev = 'Prostřední Libchavy' WHERE kod = 643335;
UPDATE ruian_katastr SET nazev = 'Horní Libochová' WHERE kod = 643343;
UPDATE ruian_katastr SET nazev = 'Horní Lideč' WHERE kod = 643351;
UPDATE ruian_katastr SET nazev = 'Horní Lipka' WHERE kod = 643360;
UPDATE ruian_katastr SET nazev = 'Horní Loděnice' WHERE kod = 643378;
UPDATE ruian_katastr SET nazev = 'Nové Dvorce' WHERE kod = 643386;
UPDATE ruian_katastr SET nazev = 'Horní Lomná' WHERE kod = 643394;
UPDATE ruian_katastr SET nazev = 'Horní Loučky' WHERE kod = 643416;
UPDATE ruian_katastr SET nazev = 'Skryje' WHERE kod = 643424;
UPDATE ruian_katastr SET nazev = 'Újezd u Tišnova' WHERE kod = 643432;
UPDATE ruian_katastr SET nazev = 'Dolní Albeřice' WHERE kod = 643441;
UPDATE ruian_katastr SET nazev = 'Dolní Lysečiny' WHERE kod = 643459;
UPDATE ruian_katastr SET nazev = 'Horní Albeřice' WHERE kod = 643467;
UPDATE ruian_katastr SET nazev = 'Horní Lysečiny' WHERE kod = 643475;
UPDATE ruian_katastr SET nazev = 'Horní Maršov' WHERE kod = 643483;
UPDATE ruian_katastr SET nazev = 'Maršov III' WHERE kod = 643491;
UPDATE ruian_katastr SET nazev = 'Suchý Důl v Krkonoších' WHERE kod = 643513;
UPDATE ruian_katastr SET nazev = 'Temný Důl' WHERE kod = 643521;
UPDATE ruian_katastr SET nazev = 'Dobřečov' WHERE kod = 643530;
UPDATE ruian_katastr SET nazev = 'Horní Město' WHERE kod = 643548;
UPDATE ruian_katastr SET nazev = 'Stříbrné Hory' WHERE kod = 643556;
UPDATE ruian_katastr SET nazev = 'Horní Meziříčko' WHERE kod = 643564;
UPDATE ruian_katastr SET nazev = 'Horní Moštěnice' WHERE kod = 643572;
UPDATE ruian_katastr SET nazev = 'Horní Myslová' WHERE kod = 643581;
UPDATE ruian_katastr SET nazev = 'Horní Němčí' WHERE kod = 643599;
UPDATE ruian_katastr SET nazev = 'Horní Němčice' WHERE kod = 643602;
UPDATE ruian_katastr SET nazev = 'Horní Nětčice' WHERE kod = 643611;
UPDATE ruian_katastr SET nazev = 'Horní Olešná' WHERE kod = 643629;
UPDATE ruian_katastr SET nazev = 'Horní Olešnice' WHERE kod = 643637;
UPDATE ruian_katastr SET nazev = 'Prostřední Olešnice' WHERE kod = 643645;
UPDATE ruian_katastr SET nazev = 'Dolní Pěna' WHERE kod = 643653;
UPDATE ruian_katastr SET nazev = 'Horní Pěna' WHERE kod = 643661;
UPDATE ruian_katastr SET nazev = 'Malíkov nad Nežárkou' WHERE kod = 643670;
UPDATE ruian_katastr SET nazev = 'Horní Planá' WHERE kod = 643700;
UPDATE ruian_katastr SET nazev = 'Zvonková' WHERE kod = 643734;
UPDATE ruian_katastr SET nazev = 'Pestřice' WHERE kod = 643742;
UPDATE ruian_katastr SET nazev = 'Horní Počaply' WHERE kod = 643751;
UPDATE ruian_katastr SET nazev = 'Křivenice' WHERE kod = 643769;
UPDATE ruian_katastr SET nazev = 'Horní Počernice' WHERE kod = 643777;
UPDATE ruian_katastr SET nazev = 'Horní Podluží' WHERE kod = 643807;
UPDATE ruian_katastr SET nazev = 'Horní Pole' WHERE kod = 643815;
UPDATE ruian_katastr SET nazev = 'Horní Police' WHERE kod = 643823;
UPDATE ruian_katastr SET nazev = 'Horní Poříčí u Letovic' WHERE kod = 643840;
UPDATE ruian_katastr SET nazev = 'Horní Povelice' WHERE kod = 643858;
UPDATE ruian_katastr SET nazev = 'Horní Přím' WHERE kod = 643866;
UPDATE ruian_katastr SET nazev = 'Horní Radechová' WHERE kod = 643874;
UPDATE ruian_katastr SET nazev = 'Horní Radouň' WHERE kod = 643912;
UPDATE ruian_katastr SET nazev = 'Okrouhlá Radouň' WHERE kod = 643939;
UPDATE ruian_katastr SET nazev = 'Starý Bozděchov' WHERE kod = 643947;
UPDATE ruian_katastr SET nazev = 'Horní Radslavice' WHERE kod = 643955;
UPDATE ruian_katastr SET nazev = 'Horní Rápotice' WHERE kod = 643963;
UPDATE ruian_katastr SET nazev = 'Horní Roveň' WHERE kod = 643971;
UPDATE ruian_katastr SET nazev = 'Horní Rožínka' WHERE kod = 643980;
UPDATE ruian_katastr SET nazev = 'Horní Řasnice' WHERE kod = 643998;
UPDATE ruian_katastr SET nazev = 'Srbská' WHERE kod = 644005;
UPDATE ruian_katastr SET nazev = 'Horní Ředice' WHERE kod = 644013;
UPDATE ruian_katastr SET nazev = 'Horní Řepčice' WHERE kod = 644021;
UPDATE ruian_katastr SET nazev = 'Horní Slatina' WHERE kod = 644030;
UPDATE ruian_katastr SET nazev = 'Bošířany' WHERE kod = 644048;
UPDATE ruian_katastr SET nazev = 'Horní Slavkov' WHERE kod = 644056;
UPDATE ruian_katastr SET nazev = 'Kfely u Horního Slavkova' WHERE kod = 644064;
UPDATE ruian_katastr SET nazev = 'Ležnice' WHERE kod = 644072;
UPDATE ruian_katastr SET nazev = 'Ležnička' WHERE kod = 644081;
UPDATE ruian_katastr SET nazev = 'Třídomí' WHERE kod = 644102;
UPDATE ruian_katastr SET nazev = 'Horní Slivno' WHERE kod = 644111;
UPDATE ruian_katastr SET nazev = 'Horní Sloupnice' WHERE kod = 644129;
UPDATE ruian_katastr SET nazev = 'Horní Stakory' WHERE kod = 644137;
UPDATE ruian_katastr SET nazev = 'Bedřichov u Horní Stropnice' WHERE kod = 644153;
UPDATE ruian_katastr SET nazev = 'Dlouhá Stropnice' WHERE kod = 644161;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Horní Stropnice' WHERE kod = 644170;
UPDATE ruian_katastr SET nazev = 'Hojná Voda' WHERE kod = 644188;
UPDATE ruian_katastr SET nazev = 'Horní Stropnice' WHERE kod = 644196;
UPDATE ruian_katastr SET nazev = 'Meziluží' WHERE kod = 644234;
UPDATE ruian_katastr SET nazev = 'Staré Hutě u Horní Stropnice' WHERE kod = 644269;
UPDATE ruian_katastr SET nazev = 'Svébohy' WHERE kod = 644293;
UPDATE ruian_katastr SET nazev = 'Šejby' WHERE kod = 644315;
UPDATE ruian_katastr SET nazev = 'Paseky u Horní Stropnice' WHERE kod = 644323;
UPDATE ruian_katastr SET nazev = 'Horní Studenec' WHERE kod = 644358;
UPDATE ruian_katastr SET nazev = 'Hudeč' WHERE kod = 644366;
UPDATE ruian_katastr SET nazev = 'Nový Studenec' WHERE kod = 644374;
UPDATE ruian_katastr SET nazev = 'Podmoklany' WHERE kod = 644382;
UPDATE ruian_katastr SET nazev = 'Horní Studénky' WHERE kod = 644391;
UPDATE ruian_katastr SET nazev = 'Horní Suchá' WHERE kod = 644404;
UPDATE ruian_katastr SET nazev = 'Horní Sukolom' WHERE kod = 644412;
UPDATE ruian_katastr SET nazev = 'Nová Dědina u Uničova' WHERE kod = 644421;
UPDATE ruian_katastr SET nazev = 'Horní Štěpánov' WHERE kod = 644439;
UPDATE ruian_katastr SET nazev = 'Horní Tošanovice' WHERE kod = 644463;
UPDATE ruian_katastr SET nazev = 'Horní Třešňovec' WHERE kod = 644480;
UPDATE ruian_katastr SET nazev = 'Horní Újezd u Litomyšle' WHERE kod = 644501;
UPDATE ruian_katastr SET nazev = 'Horní Újezd u Třebíče' WHERE kod = 644528;
UPDATE ruian_katastr SET nazev = 'Vacenovice' WHERE kod = 644536;
UPDATE ruian_katastr SET nazev = 'Horní Újezd' WHERE kod = 644544;
UPDATE ruian_katastr SET nazev = 'Horní Ves' WHERE kod = 644552;
UPDATE ruian_katastr SET nazev = 'Horní Věstonice' WHERE kod = 644579;
UPDATE ruian_katastr SET nazev = 'Horní Vilémovice' WHERE kod = 644587;
UPDATE ruian_katastr SET nazev = 'Horní Vltavice' WHERE kod = 644595;
UPDATE ruian_katastr SET nazev = 'Kubova Huť' WHERE kod = 644609;
UPDATE ruian_katastr SET nazev = 'Račí' WHERE kod = 644625;
UPDATE ruian_katastr SET nazev = 'Březová Lada' WHERE kod = 644633;
UPDATE ruian_katastr SET nazev = 'Polka' WHERE kod = 644641;
UPDATE ruian_katastr SET nazev = 'Slatina u Horní Vltavice' WHERE kod = 644650;
UPDATE ruian_katastr SET nazev = 'Žlíbky' WHERE kod = 644668;
UPDATE ruian_katastr SET nazev = 'Dolní Žďár' WHERE kod = 644676;
UPDATE ruian_katastr SET nazev = 'Horní Žďár' WHERE kod = 644692;
UPDATE ruian_katastr SET nazev = 'Horní Životice' WHERE kod = 644714;
UPDATE ruian_katastr SET nazev = 'Horní Žukov' WHERE kod = 644722;
UPDATE ruian_katastr SET nazev = 'Hornice' WHERE kod = 644757;
UPDATE ruian_katastr SET nazev = 'Hornosín' WHERE kod = 644765;
UPDATE ruian_katastr SET nazev = 'Horoměřice' WHERE kod = 644773;
UPDATE ruian_katastr SET nazev = 'Horosedly' WHERE kod = 644781;
UPDATE ruian_katastr SET nazev = 'Horoušany' WHERE kod = 644803;
UPDATE ruian_katastr SET nazev = 'Horská Kamenice' WHERE kod = 644811;
UPDATE ruian_katastr SET nazev = 'Dolce' WHERE kod = 644820;
UPDATE ruian_katastr SET nazev = 'Horšice' WHERE kod = 644838;
UPDATE ruian_katastr SET nazev = 'Týniště u Horšic' WHERE kod = 644846;
UPDATE ruian_katastr SET nazev = 'Újezd u Horšic' WHERE kod = 644854;
UPDATE ruian_katastr SET nazev = 'Horšovský Týn' WHERE kod = 644871;
UPDATE ruian_katastr SET nazev = 'Horní Metelsko' WHERE kod = 644927;
UPDATE ruian_katastr SET nazev = 'Dolní Metelsko' WHERE kod = 644935;
UPDATE ruian_katastr SET nazev = 'Kocourov u Horšovského Týna' WHERE kod = 644943;
UPDATE ruian_katastr SET nazev = 'Podražnice' WHERE kod = 644951;
UPDATE ruian_katastr SET nazev = 'Horšov' WHERE kod = 644960;
UPDATE ruian_katastr SET nazev = 'Horusice' WHERE kod = 644978;
UPDATE ruian_katastr SET nazev = 'Drouhavec' WHERE kod = 644986;
UPDATE ruian_katastr SET nazev = 'Hory Matky Boží' WHERE kod = 644994;
UPDATE ruian_katastr SET nazev = 'Hořany u Poříčan' WHERE kod = 645001;
UPDATE ruian_katastr SET nazev = 'Hořany' WHERE kod = 645010;
UPDATE ruian_katastr SET nazev = 'Hořátev' WHERE kod = 645028;
UPDATE ruian_katastr SET nazev = 'Hořejší Kunčice' WHERE kod = 645036;
UPDATE ruian_katastr SET nazev = 'Kerhartice u Budišova nad Budišovkou' WHERE kod = 645044;
UPDATE ruian_katastr SET nazev = 'Medlice u Budišova nad Budišovkou' WHERE kod = 645052;
UPDATE ruian_katastr SET nazev = 'Březina u Hořepníku' WHERE kod = 645061;
UPDATE ruian_katastr SET nazev = 'Hořepník' WHERE kod = 645079;
UPDATE ruian_katastr SET nazev = 'Rovná u Hořepníku' WHERE kod = 645087;
UPDATE ruian_katastr SET nazev = 'Hořesedly' WHERE kod = 645109;
UPDATE ruian_katastr SET nazev = 'Hořešovice' WHERE kod = 645117;
UPDATE ruian_katastr SET nazev = 'Hořešovičky' WHERE kod = 645125;
UPDATE ruian_katastr SET nazev = 'Hořetice' WHERE kod = 645133;
UPDATE ruian_katastr SET nazev = 'Hořice u Humpolce' WHERE kod = 645150;
UPDATE ruian_katastr SET nazev = 'Hořice v Podkrkonoší' WHERE kod = 645168;
UPDATE ruian_katastr SET nazev = 'Libonice' WHERE kod = 645214;
UPDATE ruian_katastr SET nazev = 'Chvalina' WHERE kod = 645222;
UPDATE ruian_katastr SET nazev = 'Hořice na Šumavě' WHERE kod = 645231;
UPDATE ruian_katastr SET nazev = 'Mýto u Hořic na Šumavě' WHERE kod = 645249;
UPDATE ruian_katastr SET nazev = 'Skláře na Šumavě' WHERE kod = 645257;
UPDATE ruian_katastr SET nazev = 'Šebanov' WHERE kod = 645265;
UPDATE ruian_katastr SET nazev = 'Svíba' WHERE kod = 645273;
UPDATE ruian_katastr SET nazev = 'Hořičky' WHERE kod = 645281;
UPDATE ruian_katastr SET nazev = 'Chlístov u Hořiček' WHERE kod = 645290;
UPDATE ruian_katastr SET nazev = 'Litoboř' WHERE kod = 645303;
UPDATE ruian_katastr SET nazev = 'Brozánky' WHERE kod = 645320;
UPDATE ruian_katastr SET nazev = 'Hořín' WHERE kod = 645338;
UPDATE ruian_katastr SET nazev = 'Vrbno u Mělníka' WHERE kod = 645346;
UPDATE ruian_katastr SET nazev = 'Zelčín' WHERE kod = 645354;
UPDATE ruian_katastr SET nazev = 'Hořiněves' WHERE kod = 645362;
UPDATE ruian_katastr SET nazev = 'Hořovice' WHERE kod = 645371;
UPDATE ruian_katastr SET nazev = 'Velká Víska' WHERE kod = 645389;
UPDATE ruian_katastr SET nazev = 'Hokov' WHERE kod = 645486;
UPDATE ruian_katastr SET nazev = 'Hořovičky' WHERE kod = 645494;
UPDATE ruian_katastr SET nazev = 'Vrbice u Hořoviček' WHERE kod = 645516;
UPDATE ruian_katastr SET nazev = 'Dobřejovice u Hosína' WHERE kod = 645524;
UPDATE ruian_katastr SET nazev = 'Hosín' WHERE kod = 645532;
UPDATE ruian_katastr SET nazev = 'Hodějov' WHERE kod = 645541;
UPDATE ruian_katastr SET nazev = 'Hoslovice' WHERE kod = 645559;
UPDATE ruian_katastr SET nazev = 'Škrobočov' WHERE kod = 645567;
UPDATE ruian_katastr SET nazev = 'Hospozín' WHERE kod = 645575;
UPDATE ruian_katastr SET nazev = 'Hospříz' WHERE kod = 645583;
UPDATE ruian_katastr SET nazev = 'Hrutkov' WHERE kod = 645591;
UPDATE ruian_katastr SET nazev = 'Kačlehy' WHERE kod = 645605;
UPDATE ruian_katastr SET nazev = 'Hostašovice' WHERE kod = 645613;
UPDATE ruian_katastr SET nazev = 'Hostějeves' WHERE kod = 645621;
UPDATE ruian_katastr SET nazev = 'Nekrasín' WHERE kod = 645630;
UPDATE ruian_katastr SET nazev = 'Pejdlova Rosička' WHERE kod = 645648;
UPDATE ruian_katastr SET nazev = 'Hostějov' WHERE kod = 645656;
UPDATE ruian_katastr SET nazev = 'Hostěnice' WHERE kod = 645664;
UPDATE ruian_katastr SET nazev = 'Hostěradice na Moravě' WHERE kod = 645672;
UPDATE ruian_katastr SET nazev = 'Chlupice' WHERE kod = 645681;
UPDATE ruian_katastr SET nazev = 'Míšovice' WHERE kod = 645699;
UPDATE ruian_katastr SET nazev = 'Hostěrádky' WHERE kod = 645702;
UPDATE ruian_katastr SET nazev = 'Částkovice u Hostětic' WHERE kod = 645711;
UPDATE ruian_katastr SET nazev = 'Hostětice' WHERE kod = 645729;
UPDATE ruian_katastr SET nazev = 'Hostim u Berouna' WHERE kod = 645737;
UPDATE ruian_katastr SET nazev = 'Hostim' WHERE kod = 645745;
UPDATE ruian_katastr SET nazev = 'Jiřice u Moravských Budějovic' WHERE kod = 645753;
UPDATE ruian_katastr SET nazev = 'Hostín u Vojkovic' WHERE kod = 645761;
UPDATE ruian_katastr SET nazev = 'Hostinné' WHERE kod = 645770;
UPDATE ruian_katastr SET nazev = 'Hostišová' WHERE kod = 645788;
UPDATE ruian_katastr SET nazev = 'Hostišovice' WHERE kod = 645796;
UPDATE ruian_katastr SET nazev = 'Podruhlí' WHERE kod = 645818;
UPDATE ruian_katastr SET nazev = 'Hostivice' WHERE kod = 645834;
UPDATE ruian_katastr SET nazev = 'Litovice' WHERE kod = 645842;
UPDATE ruian_katastr SET nazev = 'Hostokryje' WHERE kod = 645869;
UPDATE ruian_katastr SET nazev = 'Bezdědice u Hostomic' WHERE kod = 645877;
UPDATE ruian_katastr SET nazev = 'Hostomice pod Brdy' WHERE kod = 645885;
UPDATE ruian_katastr SET nazev = 'Hostomice nad Bílinou' WHERE kod = 645915;
UPDATE ruian_katastr SET nazev = 'Hostouň u Prahy' WHERE kod = 645923;
UPDATE ruian_katastr SET nazev = 'Horoušany u Hostouně' WHERE kod = 645931;
UPDATE ruian_katastr SET nazev = 'Hostouň u Horšovského Týna' WHERE kod = 645940;
UPDATE ruian_katastr SET nazev = 'Mírkovice' WHERE kod = 645958;
UPDATE ruian_katastr SET nazev = 'Slatina u Hostouně' WHERE kod = 645966;
UPDATE ruian_katastr SET nazev = 'Svržno' WHERE kod = 645974;
UPDATE ruian_katastr SET nazev = 'Hostovice u Ústí nad Labem' WHERE kod = 645982;
UPDATE ruian_katastr SET nazev = 'Hostovice u Pardubic' WHERE kod = 645991;
UPDATE ruian_katastr SET nazev = 'Hostovlice u Čáslavi' WHERE kod = 646008;
UPDATE ruian_katastr SET nazev = 'Hosty' WHERE kod = 646016;
UPDATE ruian_katastr SET nazev = 'Pašovice' WHERE kod = 646032;
UPDATE ruian_katastr SET nazev = 'Hošťálková' WHERE kod = 646059;
UPDATE ruian_katastr SET nazev = 'Hošťálkovice' WHERE kod = 646075;
UPDATE ruian_katastr SET nazev = 'Hošťálkovy' WHERE kod = 646091;
UPDATE ruian_katastr SET nazev = 'Křížová ve Slezsku' WHERE kod = 646105;
UPDATE ruian_katastr SET nazev = 'Staré Purkartice' WHERE kod = 646113;
UPDATE ruian_katastr SET nazev = 'Vraclávek' WHERE kod = 646121;
UPDATE ruian_katastr SET nazev = 'Březinka u Hošťalovic' WHERE kod = 646130;
UPDATE ruian_katastr SET nazev = 'Hošťalovice' WHERE kod = 646148;
UPDATE ruian_katastr SET nazev = 'Hoštejn' WHERE kod = 646156;
UPDATE ruian_katastr SET nazev = 'Hoštice u Volyně' WHERE kod = 646164;
UPDATE ruian_katastr SET nazev = 'Milejovice' WHERE kod = 646172;
UPDATE ruian_katastr SET nazev = 'Přechovice' WHERE kod = 646181;
UPDATE ruian_katastr SET nazev = 'Hoštice u Nemyšle' WHERE kod = 646199;
UPDATE ruian_katastr SET nazev = 'Hoštice u Litenčic' WHERE kod = 646202;
UPDATE ruian_katastr SET nazev = 'Heroltice' WHERE kod = 646211;
UPDATE ruian_katastr SET nazev = 'Hoštice' WHERE kod = 646229;
UPDATE ruian_katastr SET nazev = 'Hošťka' WHERE kod = 646237;
UPDATE ruian_katastr SET nazev = 'Žebráky' WHERE kod = 646245;
UPDATE ruian_katastr SET nazev = 'Pořejov' WHERE kod = 646253;
UPDATE ruian_katastr SET nazev = 'Hoštka' WHERE kod = 646261;
UPDATE ruian_katastr SET nazev = 'Kochovice' WHERE kod = 646270;
UPDATE ruian_katastr SET nazev = 'Malešov u Hoštky' WHERE kod = 646288;
UPDATE ruian_katastr SET nazev = 'Velešice u Hoštky' WHERE kod = 646296;
UPDATE ruian_katastr SET nazev = 'Benátky u Houserovky' WHERE kod = 646300;
UPDATE ruian_katastr SET nazev = 'Houserovka' WHERE kod = 646318;
UPDATE ruian_katastr SET nazev = 'Janovice u Houserovky' WHERE kod = 646326;
UPDATE ruian_katastr SET nazev = 'Ostrovec u Houserovky' WHERE kod = 646334;
UPDATE ruian_katastr SET nazev = 'Hovězí' WHERE kod = 646342;
UPDATE ruian_katastr SET nazev = 'Hovorany' WHERE kod = 646377;
UPDATE ruian_katastr SET nazev = 'Hovorčovice' WHERE kod = 646385;
UPDATE ruian_katastr SET nazev = 'Hrabenov' WHERE kod = 646393;
UPDATE ruian_katastr SET nazev = 'Hraběšice' WHERE kod = 646407;
UPDATE ruian_katastr SET nazev = 'Krásné u Šumperka' WHERE kod = 646415;
UPDATE ruian_katastr SET nazev = 'Hraběšín' WHERE kod = 646423;
UPDATE ruian_katastr SET nazev = 'Hrabětice' WHERE kod = 646431;
UPDATE ruian_katastr SET nazev = 'Hrabice' WHERE kod = 646466;
UPDATE ruian_katastr SET nazev = 'Křesanov' WHERE kod = 646482;
UPDATE ruian_katastr SET nazev = 'Hrabišín' WHERE kod = 646521;
UPDATE ruian_katastr SET nazev = 'Hrabová u Dubicka' WHERE kod = 646547;
UPDATE ruian_katastr SET nazev = 'Hrabří' WHERE kod = 646563;
UPDATE ruian_katastr SET nazev = 'Oříkov' WHERE kod = 646571;
UPDATE ruian_katastr SET nazev = 'Hrabství' WHERE kod = 646580;
UPDATE ruian_katastr SET nazev = 'Hrabůvka u Hranic' WHERE kod = 646598;
UPDATE ruian_katastr SET nazev = 'Hrabyně' WHERE kod = 646601;
UPDATE ruian_katastr SET nazev = 'Hradčany u Žehuně' WHERE kod = 646628;
UPDATE ruian_katastr SET nazev = 'Hradčany u Českého Dubu' WHERE kod = 646644;
UPDATE ruian_katastr SET nazev = 'Chvalčovice' WHERE kod = 646652;
UPDATE ruian_katastr SET nazev = 'Hradčany u Tišnova' WHERE kod = 646687;
UPDATE ruian_katastr SET nazev = 'Hradčany na Moravě' WHERE kod = 646695;
UPDATE ruian_katastr SET nazev = 'Hradčany u Prostějova' WHERE kod = 646709;
UPDATE ruian_katastr SET nazev = 'Kobeřice' WHERE kod = 646717;
UPDATE ruian_katastr SET nazev = 'Hradčovice' WHERE kod = 646725;
UPDATE ruian_katastr SET nazev = 'Lhotka u Hradčovic' WHERE kod = 646733;
UPDATE ruian_katastr SET nazev = 'Hradec u Stoda' WHERE kod = 646750;
UPDATE ruian_katastr SET nazev = 'Lisov' WHERE kod = 646768;
UPDATE ruian_katastr SET nazev = 'Střelice' WHERE kod = 646776;
UPDATE ruian_katastr SET nazev = 'Hradec u Ledče nad Sázavou' WHERE kod = 646792;
UPDATE ruian_katastr SET nazev = 'Ostrov u Ledče nad Sázavou' WHERE kod = 646806;
UPDATE ruian_katastr SET nazev = 'Hradec nad Moravicí' WHERE kod = 646814;
UPDATE ruian_katastr SET nazev = 'Kajlovec' WHERE kod = 646822;
UPDATE ruian_katastr SET nazev = 'Hradec u Jeseníka' WHERE kod = 646857;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Jeseníka' WHERE kod = 646865;
UPDATE ruian_katastr SET nazev = 'Hradec Králové' WHERE kod = 646873;
UPDATE ruian_katastr SET nazev = 'Slezské Předměstí' WHERE kod = 646971;
UPDATE ruian_katastr SET nazev = 'Malšovice u Hradce Králové' WHERE kod = 646997;
UPDATE ruian_katastr SET nazev = 'Třebeš' WHERE kod = 647047;
UPDATE ruian_katastr SET nazev = 'Pražské Předměstí' WHERE kod = 647101;
UPDATE ruian_katastr SET nazev = 'Nový Hradec Králové' WHERE kod = 647187;
UPDATE ruian_katastr SET nazev = 'Kukleny' WHERE kod = 647209;
UPDATE ruian_katastr SET nazev = 'Kluky' WHERE kod = 647225;
UPDATE ruian_katastr SET nazev = 'Hradec nad Svitavou' WHERE kod = 647233;
UPDATE ruian_katastr SET nazev = 'Hradecko' WHERE kod = 647241;
UPDATE ruian_katastr SET nazev = 'Hradečno' WHERE kod = 647250;
UPDATE ruian_katastr SET nazev = 'Hrádek u Sušice' WHERE kod = 647276;
UPDATE ruian_katastr SET nazev = 'Tedražice' WHERE kod = 647284;
UPDATE ruian_katastr SET nazev = 'Hrádek u Rokycan' WHERE kod = 647306;
UPDATE ruian_katastr SET nazev = 'Nová Huť' WHERE kod = 647314;
UPDATE ruian_katastr SET nazev = 'Hrádek u Nechanic' WHERE kod = 647322;
UPDATE ruian_katastr SET nazev = 'Hrádek u Pardubic' WHERE kod = 647331;
UPDATE ruian_katastr SET nazev = 'Hrádek u Znojma' WHERE kod = 647349;
UPDATE ruian_katastr SET nazev = 'Hrádek' WHERE kod = 647357;
UPDATE ruian_katastr SET nazev = 'Dolní Sedlo' WHERE kod = 647365;
UPDATE ruian_katastr SET nazev = 'Donín u Hrádku nad Nisou' WHERE kod = 647373;
UPDATE ruian_katastr SET nazev = 'Hrádek nad Nisou' WHERE kod = 647390;
UPDATE ruian_katastr SET nazev = 'Loučná' WHERE kod = 647403;
UPDATE ruian_katastr SET nazev = 'Černíč u Hradešic' WHERE kod = 647411;
UPDATE ruian_katastr SET nazev = 'Hradešice' WHERE kod = 647420;
UPDATE ruian_katastr SET nazev = 'Smrkovec u Hradešic' WHERE kod = 647438;
UPDATE ruian_katastr SET nazev = 'Hradisko' WHERE kod = 647446;
UPDATE ruian_katastr SET nazev = 'Hradiště u Domažlic' WHERE kod = 647454;
UPDATE ruian_katastr SET nazev = 'Hradiště u Kasejovic' WHERE kod = 647471;
UPDATE ruian_katastr SET nazev = 'Hradiště pod Babí horou' WHERE kod = 647489;
UPDATE ruian_katastr SET nazev = 'Hradištko u Sadské' WHERE kod = 647519;
UPDATE ruian_katastr SET nazev = 'Hradištko pod Medníkem' WHERE kod = 647543;
UPDATE ruian_katastr SET nazev = 'Hradišťko I' WHERE kod = 647560;
UPDATE ruian_katastr SET nazev = 'Hradišťská Lhotka' WHERE kod = 647578;
UPDATE ruian_katastr SET nazev = 'Hradišťský Újezd' WHERE kod = 647586;
UPDATE ruian_katastr SET nazev = 'Hracholusky nad Berounkou' WHERE kod = 647594;
UPDATE ruian_katastr SET nazev = 'Hracholusky u Prachatic' WHERE kod = 647608;
UPDATE ruian_katastr SET nazev = 'Obora u Hracholusk' WHERE kod = 647616;
UPDATE ruian_katastr SET nazev = 'Hrachovec' WHERE kod = 647624;
UPDATE ruian_katastr SET nazev = 'Hrachoviště u Třeboně' WHERE kod = 647632;
UPDATE ruian_katastr SET nazev = 'Hranice u Aše' WHERE kod = 647641;
UPDATE ruian_katastr SET nazev = 'Trojmezí' WHERE kod = 647675;
UPDATE ruian_katastr SET nazev = 'Hranice' WHERE kod = 647683;
UPDATE ruian_katastr SET nazev = 'Hranice u Nových Hradů' WHERE kod = 647888;
UPDATE ruian_katastr SET nazev = 'Hraničné Petrovice' WHERE kod = 647900;
UPDATE ruian_katastr SET nazev = 'Dobrošov u Hrazan' WHERE kod = 647918;
UPDATE ruian_katastr SET nazev = 'Hrazánky' WHERE kod = 647926;
UPDATE ruian_katastr SET nazev = 'Hrazany' WHERE kod = 647934;
UPDATE ruian_katastr SET nazev = 'Klisinec' WHERE kod = 647942;
UPDATE ruian_katastr SET nazev = 'Hrbov' WHERE kod = 647951;
UPDATE ruian_katastr SET nazev = 'Hrbov u Velkého Meziříčí' WHERE kod = 647969;
UPDATE ruian_katastr SET nazev = 'Svařenov' WHERE kod = 647977;
UPDATE ruian_katastr SET nazev = 'Hrbovice' WHERE kod = 647985;
UPDATE ruian_katastr SET nazev = 'Hrčava' WHERE kod = 647993;
UPDATE ruian_katastr SET nazev = 'Hrdějovice' WHERE kod = 648001;
UPDATE ruian_katastr SET nazev = 'Hrdibořice' WHERE kod = 648027;
UPDATE ruian_katastr SET nazev = 'Hrdlív' WHERE kod = 648035;
UPDATE ruian_katastr SET nazev = 'Hrdlořezy u Mladé Boleslavi' WHERE kod = 648051;
UPDATE ruian_katastr SET nazev = 'Hrdlořezy u Suchdola nad Lužnicí' WHERE kod = 648060;
UPDATE ruian_katastr SET nazev = 'Hrdlovka-Nový Dvůr' WHERE kod = 648078;
UPDATE ruian_katastr SET nazev = 'Hrdly' WHERE kod = 648086;
UPDATE ruian_katastr SET nazev = 'Hrejkovice' WHERE kod = 648094;
UPDATE ruian_katastr SET nazev = 'Hrob' WHERE kod = 648116;
UPDATE ruian_katastr SET nazev = 'Křižanov u Hrobu' WHERE kod = 648124;
UPDATE ruian_katastr SET nazev = 'Mlýny' WHERE kod = 648132;
UPDATE ruian_katastr SET nazev = 'Verneřice u Hrobu' WHERE kod = 648141;
UPDATE ruian_katastr SET nazev = 'Hrobce' WHERE kod = 648159;
UPDATE ruian_katastr SET nazev = 'Hrobčice' WHERE kod = 648167;
UPDATE ruian_katastr SET nazev = 'Chouč' WHERE kod = 648175;
UPDATE ruian_katastr SET nazev = 'Kučlín' WHERE kod = 648183;
UPDATE ruian_katastr SET nazev = 'Mirošovice' WHERE kod = 648191;
UPDATE ruian_katastr SET nazev = 'Mrzlice' WHERE kod = 648205;
UPDATE ruian_katastr SET nazev = 'Razice' WHERE kod = 648213;
UPDATE ruian_katastr SET nazev = 'Tvrdín' WHERE kod = 648221;
UPDATE ruian_katastr SET nazev = 'Hrobice' WHERE kod = 648230;
UPDATE ruian_katastr SET nazev = 'Hrobice na Moravě' WHERE kod = 648248;
UPDATE ruian_katastr SET nazev = 'Hroby' WHERE kod = 648256;
UPDATE ruian_katastr SET nazev = 'Kozmice u Chýnova' WHERE kod = 648264;
UPDATE ruian_katastr SET nazev = 'Lažany u Chýnova' WHERE kod = 648272;
UPDATE ruian_katastr SET nazev = 'Blansko u Hrochova Týnce' WHERE kod = 648281;
UPDATE ruian_katastr SET nazev = 'Hrochův Týnec' WHERE kod = 648299;
UPDATE ruian_katastr SET nazev = 'Stíčany' WHERE kod = 648311;
UPDATE ruian_katastr SET nazev = 'Hromnice' WHERE kod = 648329;
UPDATE ruian_katastr SET nazev = 'Chotiná' WHERE kod = 648337;
UPDATE ruian_katastr SET nazev = 'Žichlice u Hromnic' WHERE kod = 648345;
UPDATE ruian_katastr SET nazev = 'Hronětice' WHERE kod = 648353;
UPDATE ruian_katastr SET nazev = 'Hronov' WHERE kod = 648370;
UPDATE ruian_katastr SET nazev = 'Zbečník' WHERE kod = 648396;
UPDATE ruian_katastr SET nazev = 'Velký Dřevíč' WHERE kod = 648400;
UPDATE ruian_katastr SET nazev = 'Žabokrky' WHERE kod = 648418;
UPDATE ruian_katastr SET nazev = 'Velké Poříčí' WHERE kod = 648426;
UPDATE ruian_katastr SET nazev = 'Rokytník' WHERE kod = 648434;
UPDATE ruian_katastr SET nazev = 'Malá Čermná' WHERE kod = 648451;
UPDATE ruian_katastr SET nazev = 'Hrotovice' WHERE kod = 648469;
UPDATE ruian_katastr SET nazev = 'Hroubovice' WHERE kod = 648477;
UPDATE ruian_katastr SET nazev = 'Hroznětice' WHERE kod = 648493;
UPDATE ruian_katastr SET nazev = 'Bystřice u Hroznětína' WHERE kod = 648507;
UPDATE ruian_katastr SET nazev = 'Hroznětín' WHERE kod = 648515;
UPDATE ruian_katastr SET nazev = 'Ruprechtov u Hroznětína' WHERE kod = 648523;
UPDATE ruian_katastr SET nazev = 'Hroznová Lhota' WHERE kod = 648540;
UPDATE ruian_katastr SET nazev = 'Hrozová' WHERE kod = 648558;
UPDATE ruian_katastr SET nazev = 'Hrubá Skála' WHERE kod = 648574;
UPDATE ruian_katastr SET nazev = 'Hrubá Voda' WHERE kod = 648591;
UPDATE ruian_katastr SET nazev = 'Hrubá Vrbka' WHERE kod = 648604;
UPDATE ruian_katastr SET nazev = 'Hrubčice' WHERE kod = 648612;
UPDATE ruian_katastr SET nazev = 'Hrubšice' WHERE kod = 648639;
UPDATE ruian_katastr SET nazev = 'Hrubý Jeseník' WHERE kod = 648647;
UPDATE ruian_katastr SET nazev = 'Hrusice' WHERE kod = 648655;
UPDATE ruian_katastr SET nazev = 'Hruška' WHERE kod = 648671;
UPDATE ruian_katastr SET nazev = 'Henčov' WHERE kod = 648680;
UPDATE ruian_katastr SET nazev = 'Hruškové Dvory' WHERE kod = 648698;
UPDATE ruian_katastr SET nazev = 'Hrušky' WHERE kod = 648701;
UPDATE ruian_katastr SET nazev = 'Hrušky u Brna' WHERE kod = 648728;
UPDATE ruian_katastr SET nazev = 'Hrušov nad Jizerou' WHERE kod = 648736;
UPDATE ruian_katastr SET nazev = 'Hrušová' WHERE kod = 648752;
UPDATE ruian_katastr SET nazev = 'Hrušova Lhota' WHERE kod = 648761;
UPDATE ruian_katastr SET nazev = 'Hrušovany u Chomutova' WHERE kod = 648779;
UPDATE ruian_katastr SET nazev = 'Lažany u Chomutova' WHERE kod = 648787;
UPDATE ruian_katastr SET nazev = 'Vysočany u Chomutova' WHERE kod = 648795;
UPDATE ruian_katastr SET nazev = 'Hrušovany nad Jevišovkou' WHERE kod = 648809;
UPDATE ruian_katastr SET nazev = 'Hrušovany u Brna' WHERE kod = 648833;
UPDATE ruian_katastr SET nazev = 'Hrutov' WHERE kod = 648876;
UPDATE ruian_katastr SET nazev = 'Hřebeč' WHERE kod = 648884;
UPDATE ruian_katastr SET nazev = 'Hřebečníky' WHERE kod = 648906;
UPDATE ruian_katastr SET nazev = 'Týřovice nad Berounkou' WHERE kod = 648922;
UPDATE ruian_katastr SET nazev = 'Hředle u Zdic' WHERE kod = 648931;
UPDATE ruian_katastr SET nazev = 'Hředle' WHERE kod = 648949;
UPDATE ruian_katastr SET nazev = 'Hřensko' WHERE kod = 648957;
UPDATE ruian_katastr SET nazev = 'Hřešice' WHERE kod = 648965;
UPDATE ruian_katastr SET nazev = 'Hřešihlavy' WHERE kod = 648973;
UPDATE ruian_katastr SET nazev = 'Hříběcí' WHERE kod = 648981;
UPDATE ruian_katastr SET nazev = 'Hřibojedy' WHERE kod = 648990;
UPDATE ruian_katastr SET nazev = 'Hvězda' WHERE kod = 649007;
UPDATE ruian_katastr SET nazev = 'Hřibsko' WHERE kod = 649023;
UPDATE ruian_katastr SET nazev = 'Hříchovice' WHERE kod = 649031;
UPDATE ruian_katastr SET nazev = 'Hřiměždice' WHERE kod = 649058;
UPDATE ruian_katastr SET nazev = 'Vestec u Hřiměždic' WHERE kod = 649066;
UPDATE ruian_katastr SET nazev = 'Hříšice' WHERE kod = 649074;
UPDATE ruian_katastr SET nazev = 'Bedřichovice u Hříškova' WHERE kod = 649082;
UPDATE ruian_katastr SET nazev = 'Hříškov' WHERE kod = 649091;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Hříškova' WHERE kod = 649112;
UPDATE ruian_katastr SET nazev = 'Hřiště' WHERE kod = 649121;
UPDATE ruian_katastr SET nazev = 'Hřivčice' WHERE kod = 649139;
UPDATE ruian_katastr SET nazev = 'Hřivice' WHERE kod = 649147;
UPDATE ruian_katastr SET nazev = 'Markvarec u Hřivic' WHERE kod = 649155;
UPDATE ruian_katastr SET nazev = 'Hřivínův Újezd' WHERE kod = 649163;
UPDATE ruian_katastr SET nazev = 'Hřivno' WHERE kod = 649171;
UPDATE ruian_katastr SET nazev = 'Hřmenín' WHERE kod = 649180;
UPDATE ruian_katastr SET nazev = 'Hubenice' WHERE kod = 649198;
UPDATE ruian_katastr SET nazev = 'Hubenov' WHERE kod = 649210;
UPDATE ruian_katastr SET nazev = 'Hudcov' WHERE kod = 649228;
UPDATE ruian_katastr SET nazev = 'Hudčice' WHERE kod = 649236;
UPDATE ruian_katastr SET nazev = 'Hudlice' WHERE kod = 649252;
UPDATE ruian_katastr SET nazev = 'Hukovice' WHERE kod = 649279;
UPDATE ruian_katastr SET nazev = 'Hulice' WHERE kod = 649287;
UPDATE ruian_katastr SET nazev = 'Hulín' WHERE kod = 649309;
UPDATE ruian_katastr SET nazev = 'Humburky' WHERE kod = 649317;
UPDATE ruian_katastr SET nazev = 'Humpolec' WHERE kod = 649325;
UPDATE ruian_katastr SET nazev = 'Rozkoš u Humpolce' WHERE kod = 649406;
UPDATE ruian_katastr SET nazev = 'Vilémov u Humpolce' WHERE kod = 649414;
UPDATE ruian_katastr SET nazev = 'Hunčice' WHERE kod = 649473;
UPDATE ruian_katastr SET nazev = 'Těchoděly' WHERE kod = 649481;
UPDATE ruian_katastr SET nazev = 'Košetice u Hunčic' WHERE kod = 649490;
UPDATE ruian_katastr SET nazev = 'Lipno u Hunčic' WHERE kod = 649503;
UPDATE ruian_katastr SET nazev = 'Huntířov u Děčína' WHERE kod = 649520;
UPDATE ruian_katastr SET nazev = 'Nová Oleška' WHERE kod = 649546;
UPDATE ruian_katastr SET nazev = 'Stará Oleška' WHERE kod = 649554;
UPDATE ruian_katastr SET nazev = 'Hůrka' WHERE kod = 649562;
UPDATE ruian_katastr SET nazev = 'Hůrky u Lišova' WHERE kod = 649589;
UPDATE ruian_katastr SET nazev = 'Blato u Hůrek' WHERE kod = 649597;
UPDATE ruian_katastr SET nazev = 'Hůrky' WHERE kod = 649601;
UPDATE ruian_katastr SET nazev = 'Kaproun' WHERE kod = 649619;
UPDATE ruian_katastr SET nazev = 'Klenová u Hůrek' WHERE kod = 649627;
UPDATE ruian_katastr SET nazev = 'Senotín' WHERE kod = 649635;
UPDATE ruian_katastr SET nazev = 'Hůrky u Rokycan' WHERE kod = 649643;
UPDATE ruian_katastr SET nazev = 'Hůry' WHERE kod = 649651;
UPDATE ruian_katastr SET nazev = 'Husí Lhota' WHERE kod = 649660;
UPDATE ruian_katastr SET nazev = 'Husinec u Řeže' WHERE kod = 649678;
UPDATE ruian_katastr SET nazev = 'Horouty' WHERE kod = 649694;
UPDATE ruian_katastr SET nazev = 'Husinec' WHERE kod = 649708;
UPDATE ruian_katastr SET nazev = 'Výrov u Husince' WHERE kod = 649716;
UPDATE ruian_katastr SET nazev = 'Huslenky' WHERE kod = 649767;
UPDATE ruian_katastr SET nazev = 'Hustířany' WHERE kod = 649856;
UPDATE ruian_katastr SET nazev = 'Hustopeče u Brna' WHERE kod = 649864;
UPDATE ruian_katastr SET nazev = 'Hustopeče nad Bečvou' WHERE kod = 649988;
UPDATE ruian_katastr SET nazev = 'Huštěnovice' WHERE kod = 649996;
UPDATE ruian_katastr SET nazev = 'Hutě pod Třemšínem' WHERE kod = 650005;
UPDATE ruian_katastr SET nazev = 'Hutisko' WHERE kod = 650013;
UPDATE ruian_katastr SET nazev = 'Solanec pod Soláněm' WHERE kod = 650064;
UPDATE ruian_katastr SET nazev = 'Arnoltice u Huzové' WHERE kod = 650099;
UPDATE ruian_katastr SET nazev = 'Huzová' WHERE kod = 650102;
UPDATE ruian_katastr SET nazev = 'Veveří u Huzové' WHERE kod = 650111;
UPDATE ruian_katastr SET nazev = 'Bukovice' WHERE kod = 650129;
UPDATE ruian_katastr SET nazev = 'Hlavňov' WHERE kod = 650137;
UPDATE ruian_katastr SET nazev = 'Nové Hvězdlice' WHERE kod = 650145;
UPDATE ruian_katastr SET nazev = 'Staré Hvězdlice' WHERE kod = 650153;
UPDATE ruian_katastr SET nazev = 'Hvězdonice' WHERE kod = 650170;
UPDATE ruian_katastr SET nazev = 'Hvězdoňovice' WHERE kod = 650188;
UPDATE ruian_katastr SET nazev = 'Hvozd' WHERE kod = 650196;
UPDATE ruian_katastr SET nazev = 'Dražeň' WHERE kod = 650218;
UPDATE ruian_katastr SET nazev = 'Hodoviz' WHERE kod = 650226;
UPDATE ruian_katastr SET nazev = 'Hvozd u Manětína' WHERE kod = 650234;
UPDATE ruian_katastr SET nazev = 'Hvozd u Konice' WHERE kod = 650242;
UPDATE ruian_katastr SET nazev = 'Klužínek' WHERE kod = 650251;
UPDATE ruian_katastr SET nazev = 'Vojtěchov u Konice' WHERE kod = 650277;
UPDATE ruian_katastr SET nazev = 'Hvozdec' WHERE kod = 650285;
UPDATE ruian_katastr SET nazev = 'Hvozdec u Veverské Bítýšky' WHERE kod = 650307;
UPDATE ruian_katastr SET nazev = 'Hvozdná' WHERE kod = 650315;
UPDATE ruian_katastr SET nazev = 'Hvozdnice' WHERE kod = 650323;
UPDATE ruian_katastr SET nazev = 'Hvožďany' WHERE kod = 650331;
UPDATE ruian_katastr SET nazev = 'Pozdyně' WHERE kod = 650340;
UPDATE ruian_katastr SET nazev = 'Hvožďany u Bechyně' WHERE kod = 650358;
UPDATE ruian_katastr SET nazev = 'Hybrálec' WHERE kod = 650366;
UPDATE ruian_katastr SET nazev = 'Dlouhá Voda' WHERE kod = 650374;
UPDATE ruian_katastr SET nazev = 'Hynčice u Krnova' WHERE kod = 650382;
UPDATE ruian_katastr SET nazev = 'Valštejn' WHERE kod = 650391;
UPDATE ruian_katastr SET nazev = 'Ztracená Voda' WHERE kod = 650404;
UPDATE ruian_katastr SET nazev = 'Hynčina' WHERE kod = 650412;
UPDATE ruian_katastr SET nazev = 'Hyršov' WHERE kod = 650421;
UPDATE ruian_katastr SET nazev = 'Chalupy' WHERE kod = 650439;
UPDATE ruian_katastr SET nazev = 'Pláně na Šumavě' WHERE kod = 650447;
UPDATE ruian_katastr SET nazev = 'Pomezí na Šumavě' WHERE kod = 650455;
UPDATE ruian_katastr SET nazev = 'Sruby na Šumavě' WHERE kod = 650463;
UPDATE ruian_katastr SET nazev = 'Hýskov' WHERE kod = 650471;
UPDATE ruian_katastr SET nazev = 'Hýsly' WHERE kod = 650480;
UPDATE ruian_katastr SET nazev = 'Chabařovice' WHERE kod = 650498;
UPDATE ruian_katastr SET nazev = 'Chabeřice' WHERE kod = 650528;
UPDATE ruian_katastr SET nazev = 'Hlásnice u Šternberka' WHERE kod = 650536;
UPDATE ruian_katastr SET nazev = 'Chabičov' WHERE kod = 650544;
UPDATE ruian_katastr SET nazev = 'Chabrovice' WHERE kod = 650552;
UPDATE ruian_katastr SET nazev = 'Chacholice' WHERE kod = 650561;
UPDATE ruian_katastr SET nazev = 'Chaloupky' WHERE kod = 650579;
UPDATE ruian_katastr SET nazev = 'Dobrotice u Chanovic' WHERE kod = 650617;
UPDATE ruian_katastr SET nazev = 'Holkovice' WHERE kod = 650625;
UPDATE ruian_katastr SET nazev = 'Chanovice' WHERE kod = 650633;
UPDATE ruian_katastr SET nazev = 'Charvatce u Jabkenic' WHERE kod = 650641;
UPDATE ruian_katastr SET nazev = 'Charvatce u Loun' WHERE kod = 650668;
UPDATE ruian_katastr SET nazev = 'Mnichov u Loun' WHERE kod = 650676;
UPDATE ruian_katastr SET nazev = 'Charvátská Nová Ves' WHERE kod = 650684;
UPDATE ruian_katastr SET nazev = 'Charváty' WHERE kod = 650714;
UPDATE ruian_katastr SET nazev = 'Chbany' WHERE kod = 650722;
UPDATE ruian_katastr SET nazev = 'Přeskaky' WHERE kod = 650731;
UPDATE ruian_katastr SET nazev = 'Roztyly' WHERE kod = 650749;
UPDATE ruian_katastr SET nazev = 'Soběsuky nad Ohří' WHERE kod = 650757;
UPDATE ruian_katastr SET nazev = 'Vadkovice' WHERE kod = 650765;
UPDATE ruian_katastr SET nazev = 'Vikletice' WHERE kod = 650773;
UPDATE ruian_katastr SET nazev = 'Brocno' WHERE kod = 650781;
UPDATE ruian_katastr SET nazev = 'Chcebuz' WHERE kod = 650790;
UPDATE ruian_katastr SET nazev = 'Újezd u Chcebuze' WHERE kod = 650803;
UPDATE ruian_katastr SET nazev = 'Bříza nad Ohří' WHERE kod = 650820;
UPDATE ruian_katastr SET nazev = 'Cetnov' WHERE kod = 650838;
UPDATE ruian_katastr SET nazev = 'Podhoří u Chebu' WHERE kod = 650846;
UPDATE ruian_katastr SET nazev = 'Klest' WHERE kod = 650854;
UPDATE ruian_katastr SET nazev = 'Skalka u Chebu' WHERE kod = 650862;
UPDATE ruian_katastr SET nazev = 'Střížov u Chebu' WHERE kod = 650871;
UPDATE ruian_katastr SET nazev = 'Cheb' WHERE kod = 650919;
UPDATE ruian_katastr SET nazev = 'Hradiště u Chebu' WHERE kod = 651028;
UPDATE ruian_katastr SET nazev = 'Dolní Dvory' WHERE kod = 651052;
UPDATE ruian_katastr SET nazev = 'Horní Dvory' WHERE kod = 651061;
UPDATE ruian_katastr SET nazev = 'Dřenice u Chebu' WHERE kod = 651079;
UPDATE ruian_katastr SET nazev = 'Chelčice' WHERE kod = 651117;
UPDATE ruian_katastr SET nazev = 'Truskovice' WHERE kod = 651125;
UPDATE ruian_katastr SET nazev = 'Cheznovice' WHERE kod = 651133;
UPDATE ruian_katastr SET nazev = 'Chlebičov' WHERE kod = 651141;
UPDATE ruian_katastr SET nazev = 'Chlebovice' WHERE kod = 651150;
UPDATE ruian_katastr SET nazev = 'Chleby u Týnce nad Sázavou' WHERE kod = 651168;
UPDATE ruian_katastr SET nazev = 'Chleby' WHERE kod = 651184;
UPDATE ruian_katastr SET nazev = 'Chleny' WHERE kod = 651206;
UPDATE ruian_katastr SET nazev = 'Krchleby u Kostelce nad Orlicí' WHERE kod = 651222;
UPDATE ruian_katastr SET nazev = 'Svídnice u Kostelce nad Orlicí' WHERE kod = 651249;
UPDATE ruian_katastr SET nazev = 'Vrbice u Kostelce nad Orlicí' WHERE kod = 651257;
UPDATE ruian_katastr SET nazev = 'Chlístov u Benešova' WHERE kod = 651273;
UPDATE ruian_katastr SET nazev = 'Úročnice' WHERE kod = 651290;
UPDATE ruian_katastr SET nazev = 'Chlistov' WHERE kod = 651320;
UPDATE ruian_katastr SET nazev = 'Chlístov u Rokytnice nad Rokytnou' WHERE kod = 651338;
UPDATE ruian_katastr SET nazev = 'Chlístovice' WHERE kod = 651346;
UPDATE ruian_katastr SET nazev = 'Chroustkov' WHERE kod = 651354;
UPDATE ruian_katastr SET nazev = 'Zdeslavice u Chlístovic' WHERE kod = 651362;
UPDATE ruian_katastr SET nazev = 'Chloumek u Mladé Boleslavi' WHERE kod = 651371;
UPDATE ruian_katastr SET nazev = 'Barovice' WHERE kod = 651389;
UPDATE ruian_katastr SET nazev = 'Chloumek' WHERE kod = 651397;
UPDATE ruian_katastr SET nazev = 'Chlum u Vlašimi' WHERE kod = 651427;
UPDATE ruian_katastr SET nazev = 'Chlum u Rakovníka' WHERE kod = 651443;
UPDATE ruian_katastr SET nazev = 'Ryšín' WHERE kod = 651451;
UPDATE ruian_katastr SET nazev = 'Chlum u Křemže' WHERE kod = 651460;
UPDATE ruian_katastr SET nazev = 'Chlum u Blatné' WHERE kod = 651494;
UPDATE ruian_katastr SET nazev = 'Chlum u Blovic' WHERE kod = 651516;
UPDATE ruian_katastr SET nazev = 'Chlum nad Berounkou' WHERE kod = 651524;
UPDATE ruian_katastr SET nazev = 'Chlum u Dubé' WHERE kod = 651532;
UPDATE ruian_katastr SET nazev = 'Chlum u Hradce Králové' WHERE kod = 651541;
UPDATE ruian_katastr SET nazev = 'Chlum u Hlinska' WHERE kod = 651559;
UPDATE ruian_katastr SET nazev = 'Chlum u Hořic' WHERE kod = 651567;
UPDATE ruian_katastr SET nazev = 'Babolky' WHERE kod = 651575;
UPDATE ruian_katastr SET nazev = 'Chlum u Letovic' WHERE kod = 651583;
UPDATE ruian_katastr SET nazev = 'Chlum nad Jihlavou' WHERE kod = 651591;
UPDATE ruian_katastr SET nazev = 'Chlum' WHERE kod = 651605;
UPDATE ruian_katastr SET nazev = 'Korouhvice' WHERE kod = 651613;
UPDATE ruian_katastr SET nazev = 'Chlum Svaté Maří' WHERE kod = 651621;
UPDATE ruian_katastr SET nazev = 'Chlum u Třeboně' WHERE kod = 651630;
UPDATE ruian_katastr SET nazev = 'Chlumany' WHERE kod = 651702;
UPDATE ruian_katastr SET nazev = 'Pěčnov' WHERE kod = 651711;
UPDATE ruian_katastr SET nazev = 'Chlumčany u Přeštic' WHERE kod = 651737;
UPDATE ruian_katastr SET nazev = 'Blšany u Loun' WHERE kod = 651745;
UPDATE ruian_katastr SET nazev = 'Chlumčany u Loun' WHERE kod = 651753;
UPDATE ruian_katastr SET nazev = 'Vlčí u Chlumčan' WHERE kod = 651761;
UPDATE ruian_katastr SET nazev = 'Hradišťko u Dačic' WHERE kod = 651770;
UPDATE ruian_katastr SET nazev = 'Chlumec u Dačic' WHERE kod = 651788;
UPDATE ruian_katastr SET nazev = 'Chlumec u Chabařovic' WHERE kod = 651796;
UPDATE ruian_katastr SET nazev = 'Chlumec nad Cidlinou' WHERE kod = 651800;
UPDATE ruian_katastr SET nazev = 'Chlumek' WHERE kod = 651826;
UPDATE ruian_katastr SET nazev = 'Chlumětín' WHERE kod = 651834;
UPDATE ruian_katastr SET nazev = 'Chlumín' WHERE kod = 651842;
UPDATE ruian_katastr SET nazev = 'Chlumy' WHERE kod = 651851;
UPDATE ruian_katastr SET nazev = 'Chlustina' WHERE kod = 651869;
UPDATE ruian_katastr SET nazev = 'Chmelík' WHERE kod = 651877;
UPDATE ruian_katastr SET nazev = 'Chmelná u Vlašimi' WHERE kod = 651885;
UPDATE ruian_katastr SET nazev = 'Chmelná u Pelhřimova' WHERE kod = 651893;
UPDATE ruian_katastr SET nazev = 'Myslov' WHERE kod = 651907;
UPDATE ruian_katastr SET nazev = 'Malá Chmelná' WHERE kod = 651915;
UPDATE ruian_katastr SET nazev = 'Velká Chmelná' WHERE kod = 651923;
UPDATE ruian_katastr SET nazev = 'Dolní Chobolice' WHERE kod = 651931;
UPDATE ruian_katastr SET nazev = 'Horní Chobolice' WHERE kod = 651940;
UPDATE ruian_katastr SET nazev = 'Mladé' WHERE kod = 651966;
UPDATE ruian_katastr SET nazev = 'Choceň' WHERE kod = 651974;
UPDATE ruian_katastr SET nazev = 'Chocenice' WHERE kod = 651982;
UPDATE ruian_katastr SET nazev = 'Kotousov' WHERE kod = 651991;
UPDATE ruian_katastr SET nazev = 'Chocenická Lhota' WHERE kod = 652008;
UPDATE ruian_katastr SET nazev = 'Chocenický Újezd' WHERE kod = 652016;
UPDATE ruian_katastr SET nazev = 'Chocerady' WHERE kod = 652024;
UPDATE ruian_katastr SET nazev = 'Samechov' WHERE kod = 652059;
UPDATE ruian_katastr SET nazev = 'Vestec u Chocerad' WHERE kod = 652067;
UPDATE ruian_katastr SET nazev = 'Vlkovec' WHERE kod = 652075;
UPDATE ruian_katastr SET nazev = 'Chocnějovice' WHERE kod = 652083;
UPDATE ruian_katastr SET nazev = 'Chocomyšl' WHERE kod = 652105;
UPDATE ruian_katastr SET nazev = 'Chodouň' WHERE kod = 652113;
UPDATE ruian_katastr SET nazev = 'Chodouny' WHERE kod = 652121;
UPDATE ruian_katastr SET nazev = 'Chodov u Domažlic' WHERE kod = 652130;
UPDATE ruian_katastr SET nazev = 'Chodov u Bečova nad Teplou' WHERE kod = 652148;
UPDATE ruian_katastr SET nazev = 'Dolní Chodov' WHERE kod = 652172;
UPDATE ruian_katastr SET nazev = 'Dolní Kramolín' WHERE kod = 652199;
UPDATE ruian_katastr SET nazev = 'Holubín' WHERE kod = 652202;
UPDATE ruian_katastr SET nazev = 'Chodová Planá' WHERE kod = 652211;
UPDATE ruian_katastr SET nazev = 'Pístov' WHERE kod = 652229;
UPDATE ruian_katastr SET nazev = 'Výškov u Chodové Plané' WHERE kod = 652237;
UPDATE ruian_katastr SET nazev = 'Chodovlice' WHERE kod = 652245;
UPDATE ruian_katastr SET nazev = 'Chodská Lhota' WHERE kod = 652253;
UPDATE ruian_katastr SET nazev = 'Horní Jadruž' WHERE kod = 652288;
UPDATE ruian_katastr SET nazev = 'Chodský Újezd' WHERE kod = 652296;
UPDATE ruian_katastr SET nazev = 'Neblažov' WHERE kod = 652300;
UPDATE ruian_katastr SET nazev = 'Štokov' WHERE kod = 652318;
UPDATE ruian_katastr SET nazev = 'Chocholatá Lhota' WHERE kod = 652326;
UPDATE ruian_katastr SET nazev = 'Cholenice' WHERE kod = 652334;
UPDATE ruian_katastr SET nazev = 'Dubčany u Choliny' WHERE kod = 652342;
UPDATE ruian_katastr SET nazev = 'Cholina' WHERE kod = 652351;
UPDATE ruian_katastr SET nazev = 'Choltice' WHERE kod = 652369;
UPDATE ruian_katastr SET nazev = 'Chrtníky' WHERE kod = 652377;
UPDATE ruian_katastr SET nazev = 'Cholupice' WHERE kod = 652393;
UPDATE ruian_katastr SET nazev = 'Točná' WHERE kod = 652407;
UPDATE ruian_katastr SET nazev = 'Chomoutov' WHERE kod = 652415;
UPDATE ruian_katastr SET nazev = 'Chomutice' WHERE kod = 652423;
UPDATE ruian_katastr SET nazev = 'Chomutičky' WHERE kod = 652431;
UPDATE ruian_katastr SET nazev = 'Obora u Chomutic' WHERE kod = 652440;
UPDATE ruian_katastr SET nazev = 'Chomutov I' WHERE kod = 652458;
UPDATE ruian_katastr SET nazev = 'Chomutov II' WHERE kod = 652636;
UPDATE ruian_katastr SET nazev = 'Chomýž' WHERE kod = 652695;
UPDATE ruian_katastr SET nazev = 'Choratice' WHERE kod = 652709;
UPDATE ruian_katastr SET nazev = 'Xaverov' WHERE kod = 652717;
UPDATE ruian_katastr SET nazev = 'Chornice' WHERE kod = 652725;
UPDATE ruian_katastr SET nazev = 'Choroušky' WHERE kod = 652733;
UPDATE ruian_katastr SET nazev = 'Chorušice' WHERE kod = 652741;
UPDATE ruian_katastr SET nazev = 'Velký Újezd u Chorušic' WHERE kod = 652750;
UPDATE ruian_katastr SET nazev = 'Zahájí u Chorušic' WHERE kod = 652768;
UPDATE ruian_katastr SET nazev = 'Choryně' WHERE kod = 652776;
UPDATE ruian_katastr SET nazev = 'Chořelice' WHERE kod = 652784;
UPDATE ruian_katastr SET nazev = 'Choťánky' WHERE kod = 652792;
UPDATE ruian_katastr SET nazev = 'Chotčiny' WHERE kod = 652814;
UPDATE ruian_katastr SET nazev = 'Mašovice' WHERE kod = 652822;
UPDATE ruian_katastr SET nazev = 'Chotěboř' WHERE kod = 652831;
UPDATE ruian_katastr SET nazev = 'Bílek' WHERE kod = 652873;
UPDATE ruian_katastr SET nazev = 'Chotěbudice' WHERE kod = 652946;
UPDATE ruian_katastr SET nazev = 'Chotěbuz' WHERE kod = 652954;
UPDATE ruian_katastr SET nazev = 'Podobora' WHERE kod = 652962;
UPDATE ruian_katastr SET nazev = 'Zpupná Lhota' WHERE kod = 652971;
UPDATE ruian_katastr SET nazev = 'Choteč u Prahy' WHERE kod = 652989;
UPDATE ruian_katastr SET nazev = 'Chýnice' WHERE kod = 652997;
UPDATE ruian_katastr SET nazev = 'Časy' WHERE kod = 653004;
UPDATE ruian_katastr SET nazev = 'Choteč u Holic' WHERE kod = 653012;
UPDATE ruian_katastr SET nazev = 'Chotělice' WHERE kod = 653021;
UPDATE ruian_katastr SET nazev = 'Chotěmice' WHERE kod = 653039;
UPDATE ruian_katastr SET nazev = 'Chotěnov' WHERE kod = 653047;
UPDATE ruian_katastr SET nazev = 'Olšany u Chotěnova' WHERE kod = 653055;
UPDATE ruian_katastr SET nazev = 'Břístev' WHERE kod = 653063;
UPDATE ruian_katastr SET nazev = 'Chotěšice' WHERE kod = 653071;
UPDATE ruian_katastr SET nazev = 'Malá Strana u Chotěšic' WHERE kod = 653080;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Chotěšic' WHERE kod = 653098;
UPDATE ruian_katastr SET nazev = 'Chotěšiny' WHERE kod = 653101;
UPDATE ruian_katastr SET nazev = 'Bedlno' WHERE kod = 653110;
UPDATE ruian_katastr SET nazev = 'Chotěšov u Rakovníka' WHERE kod = 653128;
UPDATE ruian_katastr SET nazev = 'Chotěšov u Velhartic' WHERE kod = 653136;
UPDATE ruian_katastr SET nazev = 'Radvanice u Chotěšova' WHERE kod = 653144;
UPDATE ruian_katastr SET nazev = 'Stojanovice' WHERE kod = 653152;
UPDATE ruian_katastr SET nazev = 'Chotěšov' WHERE kod = 653161;
UPDATE ruian_katastr SET nazev = 'Losina' WHERE kod = 653179;
UPDATE ruian_katastr SET nazev = 'Mantov' WHERE kod = 653187;
UPDATE ruian_katastr SET nazev = 'Týnec u Chotěšova' WHERE kod = 653217;
UPDATE ruian_katastr SET nazev = 'Chotěšov u Vrbičan' WHERE kod = 653225;
UPDATE ruian_katastr SET nazev = 'Chotětov' WHERE kod = 653233;
UPDATE ruian_katastr SET nazev = 'Chotěvice' WHERE kod = 653250;
UPDATE ruian_katastr SET nazev = 'Chotíkov' WHERE kod = 653276;
UPDATE ruian_katastr SET nazev = 'Hněvšín' WHERE kod = 653284;
UPDATE ruian_katastr SET nazev = 'Chotilsko' WHERE kod = 653292;
UPDATE ruian_katastr SET nazev = 'Křeničná' WHERE kod = 653306;
UPDATE ruian_katastr SET nazev = 'Sejcká Lhota' WHERE kod = 653314;
UPDATE ruian_katastr SET nazev = 'Dobkovičky' WHERE kod = 653331;
UPDATE ruian_katastr SET nazev = 'Chotiměř' WHERE kod = 653349;
UPDATE ruian_katastr SET nazev = 'Kletečná' WHERE kod = 653357;
UPDATE ruian_katastr SET nazev = 'Chotiněves' WHERE kod = 653365;
UPDATE ruian_katastr SET nazev = 'Jištěrpy' WHERE kod = 653373;
UPDATE ruian_katastr SET nazev = 'Chotovice u Nového Boru' WHERE kod = 653381;
UPDATE ruian_katastr SET nazev = 'Chotovice' WHERE kod = 653390;
UPDATE ruian_katastr SET nazev = 'Červené Záhoří' WHERE kod = 653403;
UPDATE ruian_katastr SET nazev = 'Chotoviny' WHERE kod = 653411;
UPDATE ruian_katastr SET nazev = 'Liderovice' WHERE kod = 653420;
UPDATE ruian_katastr SET nazev = 'Moraveč u Chotovin' WHERE kod = 653438;
UPDATE ruian_katastr SET nazev = 'Sedlečko u Chotovin' WHERE kod = 653462;
UPDATE ruian_katastr SET nazev = 'Vrážná' WHERE kod = 653471;
UPDATE ruian_katastr SET nazev = 'Chotusice' WHERE kod = 653489;
UPDATE ruian_katastr SET nazev = 'Chotutice' WHERE kod = 653497;
UPDATE ruian_katastr SET nazev = 'Chotýčany' WHERE kod = 653501;
UPDATE ruian_katastr SET nazev = 'Dolní Suchá u Chotyně' WHERE kod = 653527;
UPDATE ruian_katastr SET nazev = 'Grabštejn' WHERE kod = 653535;
UPDATE ruian_katastr SET nazev = 'Chotyně' WHERE kod = 653543;
UPDATE ruian_katastr SET nazev = 'Chotýšany' WHERE kod = 653551;
UPDATE ruian_katastr SET nazev = 'Městečko u Chotýšan' WHERE kod = 653578;
UPDATE ruian_katastr SET nazev = 'Choustník' WHERE kod = 653594;
UPDATE ruian_katastr SET nazev = 'Kajetín' WHERE kod = 653608;
UPDATE ruian_katastr SET nazev = 'Předboř u Choustníku' WHERE kod = 653616;
UPDATE ruian_katastr SET nazev = 'Choustníkovo Hradiště' WHERE kod = 653641;
UPDATE ruian_katastr SET nazev = 'Chožov' WHERE kod = 653659;
UPDATE ruian_katastr SET nazev = 'Chramosty' WHERE kod = 653667;
UPDATE ruian_katastr SET nazev = 'Chrančovice' WHERE kod = 653675;
UPDATE ruian_katastr SET nazev = 'Chrástov' WHERE kod = 653683;
UPDATE ruian_katastr SET nazev = 'Klenovice u Chrančovic' WHERE kod = 653691;
UPDATE ruian_katastr SET nazev = 'Popovice u Chrančovic' WHERE kod = 653705;
UPDATE ruian_katastr SET nazev = 'Chranišov' WHERE kod = 653713;
UPDATE ruian_katastr SET nazev = 'Chrást u Poříčan' WHERE kod = 653748;
UPDATE ruian_katastr SET nazev = 'Chrást u Tochovic' WHERE kod = 653756;
UPDATE ruian_katastr SET nazev = 'Oslí' WHERE kod = 653772;
UPDATE ruian_katastr SET nazev = 'Chrást u Plzně' WHERE kod = 653781;
UPDATE ruian_katastr SET nazev = 'Chrast' WHERE kod = 653799;
UPDATE ruian_katastr SET nazev = 'Andělská Hora u Chrastavy' WHERE kod = 653811;
UPDATE ruian_katastr SET nazev = 'Dolní Chrastava' WHERE kod = 653829;
UPDATE ruian_katastr SET nazev = 'Horní Chrastava' WHERE kod = 653837;
UPDATE ruian_katastr SET nazev = 'Chrastava I' WHERE kod = 653845;
UPDATE ruian_katastr SET nazev = 'Chrastava II' WHERE kod = 653853;
UPDATE ruian_katastr SET nazev = 'Chrastavec' WHERE kod = 653888;
UPDATE ruian_katastr SET nazev = 'Chrastavice' WHERE kod = 653900;
UPDATE ruian_katastr SET nazev = 'Chrastěšov' WHERE kod = 653918;
UPDATE ruian_katastr SET nazev = 'Hynčice pod Sušinou' WHERE kod = 653926;
UPDATE ruian_katastr SET nazev = 'Chrastice' WHERE kod = 653934;
UPDATE ruian_katastr SET nazev = 'Chrástov u Horní Cerekve' WHERE kod = 653942;
UPDATE ruian_katastr SET nazev = 'Chrášťany u Benešova' WHERE kod = 653969;
UPDATE ruian_katastr SET nazev = 'Bylany u Českého Brodu' WHERE kod = 653985;
UPDATE ruian_katastr SET nazev = 'Chotouň' WHERE kod = 653993;
UPDATE ruian_katastr SET nazev = 'Chrášťany u Českého Brodu' WHERE kod = 654001;
UPDATE ruian_katastr SET nazev = 'Chrášťany u Prahy' WHERE kod = 654019;
UPDATE ruian_katastr SET nazev = 'Chrášťany u Rakovníka' WHERE kod = 654027;
UPDATE ruian_katastr SET nazev = 'Doubravka u Týna nad Vltavou' WHERE kod = 654043;
UPDATE ruian_katastr SET nazev = 'Chrášťany u Týna nad Vltavou' WHERE kod = 654051;
UPDATE ruian_katastr SET nazev = 'Koloměřice' WHERE kod = 654060;
UPDATE ruian_katastr SET nazev = 'Chraštice' WHERE kod = 654078;
UPDATE ruian_katastr SET nazev = 'Zbenice' WHERE kod = 654094;
UPDATE ruian_katastr SET nazev = 'Chrášťovice' WHERE kod = 654108;
UPDATE ruian_katastr SET nazev = 'Klínovice' WHERE kod = 654116;
UPDATE ruian_katastr SET nazev = 'Chrbonín' WHERE kod = 654124;
UPDATE ruian_katastr SET nazev = 'Chrlice' WHERE kod = 654132;
UPDATE ruian_katastr SET nazev = 'Chroboly' WHERE kod = 654141;
UPDATE ruian_katastr SET nazev = 'Leptač' WHERE kod = 654159;
UPDATE ruian_katastr SET nazev = 'Ovesné' WHERE kod = 654175;
UPDATE ruian_katastr SET nazev = 'Rohanov u Prachatic' WHERE kod = 654191;
UPDATE ruian_katastr SET nazev = 'Záhoří u Chrobol' WHERE kod = 654205;
UPDATE ruian_katastr SET nazev = 'Lažíšťko' WHERE kod = 654213;
UPDATE ruian_katastr SET nazev = 'Chromeč' WHERE kod = 654221;
UPDATE ruian_katastr SET nazev = 'Chropyně' WHERE kod = 654230;
UPDATE ruian_katastr SET nazev = 'Chroustov' WHERE kod = 654248;
UPDATE ruian_katastr SET nazev = 'Chroustov u Miletína' WHERE kod = 654256;
UPDATE ruian_katastr SET nazev = 'Chroustovice' WHERE kod = 654264;
UPDATE ruian_katastr SET nazev = 'Chrtníč' WHERE kod = 654272;
UPDATE ruian_katastr SET nazev = 'Chrudichromy' WHERE kod = 654281;
UPDATE ruian_katastr SET nazev = 'Chrudim' WHERE kod = 654299;
UPDATE ruian_katastr SET nazev = 'Vestec u Chrudimi' WHERE kod = 654361;
UPDATE ruian_katastr SET nazev = 'Chrustenice' WHERE kod = 654400;
UPDATE ruian_katastr SET nazev = 'Budihostice' WHERE kod = 654418;
UPDATE ruian_katastr SET nazev = 'Dolní Kamenice u Velvar' WHERE kod = 654426;
UPDATE ruian_katastr SET nazev = 'Chržín' WHERE kod = 654434;
UPDATE ruian_katastr SET nazev = 'Chřešťovice' WHERE kod = 654442;
UPDATE ruian_katastr SET nazev = 'Jehnědno' WHERE kod = 654451;
UPDATE ruian_katastr SET nazev = 'Dolní Chřibská' WHERE kod = 654469;
UPDATE ruian_katastr SET nazev = 'Horní Chřibská' WHERE kod = 654477;
UPDATE ruian_katastr SET nazev = 'Chřibská' WHERE kod = 654485;
UPDATE ruian_katastr SET nazev = 'Krásné Pole u Chřibské' WHERE kod = 654493;
UPDATE ruian_katastr SET nazev = 'Kostelany' WHERE kod = 654507;
UPDATE ruian_katastr SET nazev = 'Lhotka u Kroměříže' WHERE kod = 654515;
UPDATE ruian_katastr SET nazev = 'Újezdsko' WHERE kod = 654523;
UPDATE ruian_katastr SET nazev = 'Hlince' WHERE kod = 654531;
UPDATE ruian_katastr SET nazev = 'Holovousy' WHERE kod = 654540;
UPDATE ruian_katastr SET nazev = 'Chříč' WHERE kod = 654558;
UPDATE ruian_katastr SET nazev = 'Lhota u Chříče' WHERE kod = 654566;
UPDATE ruian_katastr SET nazev = 'Slatina u Chříče' WHERE kod = 654574;
UPDATE ruian_katastr SET nazev = 'Studená u Chříče' WHERE kod = 654582;
UPDATE ruian_katastr SET nazev = 'Chudčice' WHERE kod = 654591;
UPDATE ruian_katastr SET nazev = 'Bezpravovice' WHERE kod = 654604;
UPDATE ruian_katastr SET nazev = 'Chudenice' WHERE kod = 654612;
UPDATE ruian_katastr SET nazev = 'Lučice u Chudenic' WHERE kod = 654621;
UPDATE ruian_katastr SET nazev = 'Slatina u Chudenic' WHERE kod = 654639;
UPDATE ruian_katastr SET nazev = 'Fleky' WHERE kod = 654647;
UPDATE ruian_katastr SET nazev = 'Hadrava' WHERE kod = 654655;
UPDATE ruian_katastr SET nazev = 'Chudenín' WHERE kod = 654663;
UPDATE ruian_katastr SET nazev = 'Liščí u Chudenína' WHERE kod = 654671;
UPDATE ruian_katastr SET nazev = 'Skelná Huť' WHERE kod = 654680;
UPDATE ruian_katastr SET nazev = 'Suchý Kámen' WHERE kod = 654698;
UPDATE ruian_katastr SET nazev = 'Svatá Kateřina u Chudenína' WHERE kod = 654701;
UPDATE ruian_katastr SET nazev = 'Uhliště' WHERE kod = 654710;
UPDATE ruian_katastr SET nazev = 'Hvězda u Chudenína' WHERE kod = 654728;
UPDATE ruian_katastr SET nazev = 'Chuderov' WHERE kod = 654736;
UPDATE ruian_katastr SET nazev = 'Chuderovec' WHERE kod = 654744;
UPDATE ruian_katastr SET nazev = 'Žežice u Chuderova' WHERE kod = 654779;
UPDATE ruian_katastr SET nazev = 'Chudeřice' WHERE kod = 654787;
UPDATE ruian_katastr SET nazev = 'Chudíř' WHERE kod = 654795;
UPDATE ruian_katastr SET nazev = 'Chudoplesy' WHERE kod = 654809;
UPDATE ruian_katastr SET nazev = 'Chudoslavice' WHERE kod = 654817;
UPDATE ruian_katastr SET nazev = 'Chuchelna' WHERE kod = 654833;
UPDATE ruian_katastr SET nazev = 'Chuchelná' WHERE kod = 654876;
UPDATE ruian_katastr SET nazev = 'Chvalatice' WHERE kod = 654884;
UPDATE ruian_katastr SET nazev = 'Chvalčov' WHERE kod = 654892;
UPDATE ruian_katastr SET nazev = 'Chvalčova Lhota' WHERE kod = 654906;
UPDATE ruian_katastr SET nazev = 'Chvaleč' WHERE kod = 654922;
UPDATE ruian_katastr SET nazev = 'Petříkovice u Trutnova' WHERE kod = 654931;
UPDATE ruian_katastr SET nazev = 'Chouzovy' WHERE kod = 654949;
UPDATE ruian_katastr SET nazev = 'Chválenice' WHERE kod = 654957;
UPDATE ruian_katastr SET nazev = 'Želčany' WHERE kod = 654965;
UPDATE ruian_katastr SET nazev = 'Chvalešovice' WHERE kod = 654981;
UPDATE ruian_katastr SET nazev = 'Chvaletice u Protivína' WHERE kod = 655007;
UPDATE ruian_katastr SET nazev = 'Chvaletice' WHERE kod = 655015;
UPDATE ruian_katastr SET nazev = 'Chvaletín' WHERE kod = 655023;
UPDATE ruian_katastr SET nazev = 'Václavov u Chvaletína' WHERE kod = 655031;
UPDATE ruian_katastr SET nazev = 'Chvalíkovice' WHERE kod = 655040;
UPDATE ruian_katastr SET nazev = 'Chválkov u Kamenice nad Lipou' WHERE kod = 655066;
UPDATE ruian_katastr SET nazev = 'Bělčovice' WHERE kod = 655074;
UPDATE ruian_katastr SET nazev = 'Chvalkovice u Dešné' WHERE kod = 655082;
UPDATE ruian_katastr SET nazev = 'Županovice u Dešné' WHERE kod = 655091;
UPDATE ruian_katastr SET nazev = 'Chvalkovice v Čechách' WHERE kod = 655104;
UPDATE ruian_katastr SET nazev = 'Malá Bukovina u Chvalkovic' WHERE kod = 655121;
UPDATE ruian_katastr SET nazev = 'Miskolezy' WHERE kod = 655139;
UPDATE ruian_katastr SET nazev = 'Střeziměřice' WHERE kod = 655147;
UPDATE ruian_katastr SET nazev = 'Velká Bukovina u Chvalkovic' WHERE kod = 655155;
UPDATE ruian_katastr SET nazev = 'Chvalkovice' WHERE kod = 655171;
UPDATE ruian_katastr SET nazev = 'Chvalkovice na Hané' WHERE kod = 655180;
UPDATE ruian_katastr SET nazev = 'Chvalnov' WHERE kod = 655198;
UPDATE ruian_katastr SET nazev = 'Lísky' WHERE kod = 655201;
UPDATE ruian_katastr SET nazev = 'Chválov' WHERE kod = 655228;
UPDATE ruian_katastr SET nazev = 'Babice u Netolic' WHERE kod = 655244;
UPDATE ruian_katastr SET nazev = 'Chvalovice u Netolic' WHERE kod = 655252;
UPDATE ruian_katastr SET nazev = 'Lužice u Netolic' WHERE kod = 655261;
UPDATE ruian_katastr SET nazev = 'Zvěřetice' WHERE kod = 655279;
UPDATE ruian_katastr SET nazev = 'Chvalovice' WHERE kod = 655287;
UPDATE ruian_katastr SET nazev = 'Borová u Chvalšin' WHERE kod = 655295;
UPDATE ruian_katastr SET nazev = 'Chvalšiny' WHERE kod = 655333;
UPDATE ruian_katastr SET nazev = 'Střemily' WHERE kod = 655341;
UPDATE ruian_katastr SET nazev = 'Chvatěruby' WHERE kod = 655368;
UPDATE ruian_katastr SET nazev = 'Zlončice' WHERE kod = 655376;
UPDATE ruian_katastr SET nazev = 'Chvojenec' WHERE kod = 655384;
UPDATE ruian_katastr SET nazev = 'Chvojnov' WHERE kod = 655392;
UPDATE ruian_katastr SET nazev = 'Dolany u Chyjic' WHERE kod = 655422;
UPDATE ruian_katastr SET nazev = 'Chyjice' WHERE kod = 655431;
UPDATE ruian_katastr SET nazev = 'Chyňava' WHERE kod = 655449;
UPDATE ruian_katastr SET nazev = 'Chýně' WHERE kod = 655465;
UPDATE ruian_katastr SET nazev = 'Chýnov u Tábora' WHERE kod = 655473;
UPDATE ruian_katastr SET nazev = 'Záhostice' WHERE kod = 655481;
UPDATE ruian_katastr SET nazev = 'Chýstovice' WHERE kod = 655490;
UPDATE ruian_katastr SET nazev = 'Čichořice' WHERE kod = 655511;
UPDATE ruian_katastr SET nazev = 'Chyše' WHERE kod = 655538;
UPDATE ruian_katastr SET nazev = 'Mokrá u Chyší' WHERE kod = 655554;
UPDATE ruian_katastr SET nazev = 'Podštěly' WHERE kod = 655571;
UPDATE ruian_katastr SET nazev = 'Radotín u Chyší' WHERE kod = 655597;
UPDATE ruian_katastr SET nazev = 'Žďárek u Chyší' WHERE kod = 655601;
UPDATE ruian_katastr SET nazev = 'Jablonná u Chyší' WHERE kod = 655619;
UPDATE ruian_katastr SET nazev = 'Chyška' WHERE kod = 655627;
UPDATE ruian_katastr SET nazev = 'Chyšky' WHERE kod = 655635;
UPDATE ruian_katastr SET nazev = 'Mezný' WHERE kod = 655643;
UPDATE ruian_katastr SET nazev = 'Podchýšská Lhota' WHERE kod = 655660;
UPDATE ruian_katastr SET nazev = 'Rohozov' WHERE kod = 655678;
UPDATE ruian_katastr SET nazev = 'Chýšť' WHERE kod = 655686;
UPDATE ruian_katastr SET nazev = 'Malé Výkleky' WHERE kod = 655694;
UPDATE ruian_katastr SET nazev = 'Ivaň' WHERE kod = 655708;
UPDATE ruian_katastr SET nazev = 'Ivaň na Hané' WHERE kod = 655716;
UPDATE ruian_katastr SET nazev = 'Ivančice' WHERE kod = 655724;
UPDATE ruian_katastr SET nazev = 'Kounické Předměstí' WHERE kod = 655741;
UPDATE ruian_katastr SET nazev = 'Němčice u Ivančic' WHERE kod = 655813;
UPDATE ruian_katastr SET nazev = 'Alexovice' WHERE kod = 655821;
UPDATE ruian_katastr SET nazev = 'Letkovice' WHERE kod = 655830;
UPDATE ruian_katastr SET nazev = 'Ivanovice na Hané' WHERE kod = 655848;
UPDATE ruian_katastr SET nazev = 'Ivanovice' WHERE kod = 655856;
UPDATE ruian_katastr SET nazev = 'Jabkenice' WHERE kod = 655864;
UPDATE ruian_katastr SET nazev = 'Jablečno' WHERE kod = 655872;
UPDATE ruian_katastr SET nazev = 'Přísednice' WHERE kod = 655881;
UPDATE ruian_katastr SET nazev = 'Jabloňany' WHERE kod = 655899;
UPDATE ruian_katastr SET nazev = 'Buřany' WHERE kod = 655902;
UPDATE ruian_katastr SET nazev = 'Jablonec nad Jizerou' WHERE kod = 655929;
UPDATE ruian_katastr SET nazev = 'Jablonec nad Nisou' WHERE kod = 655970;
UPDATE ruian_katastr SET nazev = 'Jablonecké Paseky' WHERE kod = 656038;
UPDATE ruian_katastr SET nazev = 'Vrkoslavice' WHERE kod = 656071;
UPDATE ruian_katastr SET nazev = 'Rýnovice' WHERE kod = 656101;
UPDATE ruian_katastr SET nazev = 'Lukášov' WHERE kod = 656127;
UPDATE ruian_katastr SET nazev = 'Mšeno nad Nisou' WHERE kod = 656135;
UPDATE ruian_katastr SET nazev = 'Jablonná nad Vltavou' WHERE kod = 656151;
UPDATE ruian_katastr SET nazev = 'Horní Hbity' WHERE kod = 656178;
UPDATE ruian_katastr SET nazev = 'Jablonná' WHERE kod = 656186;
UPDATE ruian_katastr SET nazev = 'Jablonné nad Orlicí' WHERE kod = 656194;
UPDATE ruian_katastr SET nazev = 'Česká Ves v Podještědí' WHERE kod = 656208;
UPDATE ruian_katastr SET nazev = 'Jablonné v Podještědí' WHERE kod = 656216;
UPDATE ruian_katastr SET nazev = 'Markvartice v Podještědí' WHERE kod = 656232;
UPDATE ruian_katastr SET nazev = 'Jabloňov u Velkého Meziříčí' WHERE kod = 656259;
UPDATE ruian_katastr SET nazev = 'Jablůnka' WHERE kod = 656267;
UPDATE ruian_katastr SET nazev = 'Bocanovice' WHERE kod = 656291;
UPDATE ruian_katastr SET nazev = 'Jablunkov' WHERE kod = 656305;
UPDATE ruian_katastr SET nazev = 'Návsí' WHERE kod = 656348;
UPDATE ruian_katastr SET nazev = 'Písečná u Jablunkova' WHERE kod = 656356;
UPDATE ruian_katastr SET nazev = 'Jackov' WHERE kod = 656429;
UPDATE ruian_katastr SET nazev = 'Jáchymov' WHERE kod = 656437;
UPDATE ruian_katastr SET nazev = 'Popov u Jáchymova' WHERE kod = 656470;
UPDATE ruian_katastr SET nazev = 'Jakartovice' WHERE kod = 656488;
UPDATE ruian_katastr SET nazev = 'Jakubčovice' WHERE kod = 656496;
UPDATE ruian_katastr SET nazev = 'Heřmánky nad Odrou' WHERE kod = 656500;
UPDATE ruian_katastr SET nazev = 'Jakubčovice nad Odrou' WHERE kod = 656518;
UPDATE ruian_katastr SET nazev = 'Klokočůvek' WHERE kod = 656526;
UPDATE ruian_katastr SET nazev = 'Loučky nad Odrou' WHERE kod = 656534;
UPDATE ruian_katastr SET nazev = 'Jakubov u Moravských Budějovic' WHERE kod = 656551;
UPDATE ruian_katastr SET nazev = 'Martínkov' WHERE kod = 656569;
UPDATE ruian_katastr SET nazev = 'Jakubovice' WHERE kod = 656577;
UPDATE ruian_katastr SET nazev = 'Jakubovice u Šumperka' WHERE kod = 656585;
UPDATE ruian_katastr SET nazev = 'Jalubí' WHERE kod = 656593;
UPDATE ruian_katastr SET nazev = 'Jamné u Tišnova' WHERE kod = 656607;
UPDATE ruian_katastr SET nazev = 'Jamné u Jihlavy' WHERE kod = 656615;
UPDATE ruian_katastr SET nazev = 'Jamné nad Orlicí' WHERE kod = 656623;
UPDATE ruian_katastr SET nazev = 'Jamnice' WHERE kod = 656631;
UPDATE ruian_katastr SET nazev = 'Jamný' WHERE kod = 656640;
UPDATE ruian_katastr SET nazev = 'Kašina Hora' WHERE kod = 656658;
UPDATE ruian_katastr SET nazev = 'Temešvár' WHERE kod = 656666;
UPDATE ruian_katastr SET nazev = 'Jamolice' WHERE kod = 656674;
UPDATE ruian_katastr SET nazev = 'Jámy' WHERE kod = 656682;
UPDATE ruian_katastr SET nazev = 'Jančí' WHERE kod = 656691;
UPDATE ruian_katastr SET nazev = 'Jankov' WHERE kod = 656704;
UPDATE ruian_katastr SET nazev = 'Jankovská Lhota' WHERE kod = 656712;
UPDATE ruian_katastr SET nazev = 'Pičín u Jankova' WHERE kod = 656739;
UPDATE ruian_katastr SET nazev = 'Čakov u Českých Budějovic' WHERE kod = 656747;
UPDATE ruian_katastr SET nazev = 'Čakovec' WHERE kod = 656755;
UPDATE ruian_katastr SET nazev = 'Holašovice' WHERE kod = 656763;
UPDATE ruian_katastr SET nazev = 'Jankov u Českých Budějovic' WHERE kod = 656780;
UPDATE ruian_katastr SET nazev = 'Jankov u Pelhřimova' WHERE kod = 656798;
UPDATE ruian_katastr SET nazev = 'Jankovice u Přelouče' WHERE kod = 656801;
UPDATE ruian_katastr SET nazev = 'Kozašice' WHERE kod = 656810;
UPDATE ruian_katastr SET nazev = 'Seník' WHERE kod = 656828;
UPDATE ruian_katastr SET nazev = 'Jankovice u Holešova' WHERE kod = 656836;
UPDATE ruian_katastr SET nazev = 'Jankovice u Uherského Hradiště' WHERE kod = 656844;
UPDATE ruian_katastr SET nazev = 'Janoslavice' WHERE kod = 656852;
UPDATE ruian_katastr SET nazev = 'Janoušov' WHERE kod = 656861;
UPDATE ruian_katastr SET nazev = 'Janov' WHERE kod = 656879;
UPDATE ruian_katastr SET nazev = 'Janov u Mladé Vožice' WHERE kod = 656909;
UPDATE ruian_katastr SET nazev = 'Janov v Orlických horách' WHERE kod = 656925;
UPDATE ruian_katastr SET nazev = 'Tis' WHERE kod = 656933;
UPDATE ruian_katastr SET nazev = 'Janov u Litomyšle' WHERE kod = 656950;
UPDATE ruian_katastr SET nazev = 'Janov u Krnova' WHERE kod = 656976;
UPDATE ruian_katastr SET nazev = 'Petrovice ve Slezsku' WHERE kod = 656984;
UPDATE ruian_katastr SET nazev = 'Hraničná nad Nisou' WHERE kod = 656992;
UPDATE ruian_katastr SET nazev = 'Janov nad Nisou' WHERE kod = 657000;
UPDATE ruian_katastr SET nazev = 'Loučná nad Nisou' WHERE kod = 657018;
UPDATE ruian_katastr SET nazev = 'Janová' WHERE kod = 657026;
UPDATE ruian_katastr SET nazev = 'Janovice u Kravař' WHERE kod = 657034;
UPDATE ruian_katastr SET nazev = 'Hodkovice u Trutnova' WHERE kod = 657042;
UPDATE ruian_katastr SET nazev = 'Janovice u Trutnova' WHERE kod = 657051;
UPDATE ruian_katastr SET nazev = 'Janovice u Polné' WHERE kod = 657069;
UPDATE ruian_katastr SET nazev = 'Skrýšov u Polné' WHERE kod = 657077;
UPDATE ruian_katastr SET nazev = 'Janovice u Frýdku-Místku' WHERE kod = 657107;
UPDATE ruian_katastr SET nazev = 'Janovice u Nového Jičína' WHERE kod = 657115;
UPDATE ruian_katastr SET nazev = 'Hvízdalka' WHERE kod = 657123;
UPDATE ruian_katastr SET nazev = 'Janovice nad Úhlavou' WHERE kod = 657131;
UPDATE ruian_katastr SET nazev = 'Ondřejovice u Janovic nad Úhlavou' WHERE kod = 657140;
UPDATE ruian_katastr SET nazev = 'Rohozno' WHERE kod = 657166;
UPDATE ruian_katastr SET nazev = 'Spůle' WHERE kod = 657174;
UPDATE ruian_katastr SET nazev = 'Veselí nad Úhlavou' WHERE kod = 657182;
UPDATE ruian_katastr SET nazev = 'Janovice v Podještědí' WHERE kod = 657191;
UPDATE ruian_katastr SET nazev = 'Janská' WHERE kod = 657204;
UPDATE ruian_katastr SET nazev = 'Černá Hora v Krkonoších' WHERE kod = 657212;
UPDATE ruian_katastr SET nazev = 'Janské Lázně' WHERE kod = 657239;
UPDATE ruian_katastr SET nazev = 'Janůvky' WHERE kod = 657255;
UPDATE ruian_katastr SET nazev = 'Jarcová' WHERE kod = 657271;
UPDATE ruian_katastr SET nazev = 'Drahlov u Jarohněvic' WHERE kod = 657301;
UPDATE ruian_katastr SET nazev = 'Jarohněvice' WHERE kod = 657310;
UPDATE ruian_katastr SET nazev = 'Šelešovice' WHERE kod = 657328;
UPDATE ruian_katastr SET nazev = 'Jaroměř' WHERE kod = 657336;
UPDATE ruian_katastr SET nazev = 'Josefov u Jaroměře' WHERE kod = 657425;
UPDATE ruian_katastr SET nazev = 'Jezbiny' WHERE kod = 657441;
UPDATE ruian_katastr SET nazev = 'Jaroměřice' WHERE kod = 657484;
UPDATE ruian_katastr SET nazev = 'Jaroměřice nad Rokytnou' WHERE kod = 657506;
UPDATE ruian_katastr SET nazev = 'Popovice nad Rokytnou' WHERE kod = 657514;
UPDATE ruian_katastr SET nazev = 'Jaroslav' WHERE kod = 657522;
UPDATE ruian_katastr SET nazev = 'Jaroslavice' WHERE kod = 657531;
UPDATE ruian_katastr SET nazev = 'Jarošov u Litomyšle' WHERE kod = 657549;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Jarošova' WHERE kod = 657557;
UPDATE ruian_katastr SET nazev = 'Jarošov u Uherského Hradiště' WHERE kod = 657565;
UPDATE ruian_katastr SET nazev = 'Jarošov nad Nežárkou' WHERE kod = 657573;
UPDATE ruian_katastr SET nazev = 'Matějovec nad Nežárkou' WHERE kod = 657581;
UPDATE ruian_katastr SET nazev = 'Jarov u Blovic' WHERE kod = 657603;
UPDATE ruian_katastr SET nazev = 'Zhůř' WHERE kod = 657611;
UPDATE ruian_katastr SET nazev = 'Jarov' WHERE kod = 657620;
UPDATE ruian_katastr SET nazev = 'Jarpice' WHERE kod = 657646;
UPDATE ruian_katastr SET nazev = 'Jasenice' WHERE kod = 657654;
UPDATE ruian_katastr SET nazev = 'Jasenice u Valašského Meziříčí' WHERE kod = 657662;
UPDATE ruian_katastr SET nazev = 'Jasenná' WHERE kod = 657671;
UPDATE ruian_katastr SET nazev = 'Jasenná na Moravě' WHERE kod = 657689;
UPDATE ruian_katastr SET nazev = 'Jasinov' WHERE kod = 657697;
UPDATE ruian_katastr SET nazev = 'Ořechov u Letovic' WHERE kod = 657701;
UPDATE ruian_katastr SET nazev = 'Javorek' WHERE kod = 657719;
UPDATE ruian_katastr SET nazev = 'Číhaná u Javorné' WHERE kod = 657727;
UPDATE ruian_katastr SET nazev = 'Javorná u Toužimi' WHERE kod = 657735;
UPDATE ruian_katastr SET nazev = 'Německý Chloumek' WHERE kod = 657743;
UPDATE ruian_katastr SET nazev = 'Nové Kounice' WHERE kod = 657751;
UPDATE ruian_katastr SET nazev = 'Rybničná' WHERE kod = 657760;
UPDATE ruian_katastr SET nazev = 'Javorná na Šumavě' WHERE kod = 657778;
UPDATE ruian_katastr SET nazev = 'Svinná na Šumavě' WHERE kod = 657786;
UPDATE ruian_katastr SET nazev = 'Javornice' WHERE kod = 657816;
UPDATE ruian_katastr SET nazev = 'Javorník u Vlašimi' WHERE kod = 657832;
UPDATE ruian_katastr SET nazev = 'Javorník u Stach' WHERE kod = 657841;
UPDATE ruian_katastr SET nazev = 'Javorník u Svitav' WHERE kod = 657867;
UPDATE ruian_katastr SET nazev = 'Javorník v Krkonoších' WHERE kod = 657875;
UPDATE ruian_katastr SET nazev = 'Javorník u Vysokého Mýta' WHERE kod = 657883;
UPDATE ruian_katastr SET nazev = 'Javorník nad Veličkou' WHERE kod = 657905;
UPDATE ruian_katastr SET nazev = 'Javorník-město' WHERE kod = 657921;
UPDATE ruian_katastr SET nazev = 'Travná u Javorníka' WHERE kod = 657948;
UPDATE ruian_katastr SET nazev = 'Javorník-ves' WHERE kod = 657956;
UPDATE ruian_katastr SET nazev = 'Zálesí u Javorníka' WHERE kod = 657964;
UPDATE ruian_katastr SET nazev = 'Javůrek' WHERE kod = 657972;
UPDATE ruian_katastr SET nazev = 'Bělá u Jedlé' WHERE kod = 657999;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Jedlé' WHERE kod = 658006;
UPDATE ruian_katastr SET nazev = 'Chřenovice' WHERE kod = 658014;
UPDATE ruian_katastr SET nazev = 'Jedlá' WHERE kod = 658022;
UPDATE ruian_katastr SET nazev = 'Beranova Lhota' WHERE kod = 658049;
UPDATE ruian_katastr SET nazev = 'Jedlany' WHERE kod = 658057;
UPDATE ruian_katastr SET nazev = 'Jedlí' WHERE kod = 658073;
UPDATE ruian_katastr SET nazev = 'Jedlová u Poličky' WHERE kod = 658081;
UPDATE ruian_katastr SET nazev = 'Jedomělice' WHERE kod = 658103;
UPDATE ruian_katastr SET nazev = 'Jedouchov' WHERE kod = 658111;
UPDATE ruian_katastr SET nazev = 'Jedousov' WHERE kod = 658120;
UPDATE ruian_katastr SET nazev = 'Jedov' WHERE kod = 658146;
UPDATE ruian_katastr SET nazev = 'Jedovnice' WHERE kod = 658154;
UPDATE ruian_katastr SET nazev = 'Hrádek u Jehnědí' WHERE kod = 658189;
UPDATE ruian_katastr SET nazev = 'Jehnědí' WHERE kod = 658197;
UPDATE ruian_katastr SET nazev = 'Jehnice' WHERE kod = 658201;
UPDATE ruian_katastr SET nazev = 'Jelence' WHERE kod = 658219;
UPDATE ruian_katastr SET nazev = 'Jemnice' WHERE kod = 658227;
UPDATE ruian_katastr SET nazev = 'Jemnice u Moravce' WHERE kod = 658235;
UPDATE ruian_katastr SET nazev = 'Jemníky' WHERE kod = 658243;
UPDATE ruian_katastr SET nazev = 'Jenčice' WHERE kod = 658251;
UPDATE ruian_katastr SET nazev = 'Jeneč u Prahy' WHERE kod = 658260;
UPDATE ruian_katastr SET nazev = 'Broučkova Lhota' WHERE kod = 658278;
UPDATE ruian_katastr SET nazev = 'Jeníčkova Lhota' WHERE kod = 658286;
UPDATE ruian_katastr SET nazev = 'Hleďsebe' WHERE kod = 658294;
UPDATE ruian_katastr SET nazev = 'Jenichov' WHERE kod = 658308;
UPDATE ruian_katastr SET nazev = 'Jeníkov u Vlašimi' WHERE kod = 658316;
UPDATE ruian_katastr SET nazev = 'Hajniště u Duchcova' WHERE kod = 658324;
UPDATE ruian_katastr SET nazev = 'Jeníkov u Duchcova' WHERE kod = 658332;
UPDATE ruian_katastr SET nazev = 'Oldřichov u Duchcova' WHERE kod = 658341;
UPDATE ruian_katastr SET nazev = 'Jeníkov u Hlinska' WHERE kod = 658359;
UPDATE ruian_katastr SET nazev = 'Jeníkovice u Hradce Králové' WHERE kod = 658367;
UPDATE ruian_katastr SET nazev = 'Jeníkovice u Choltic' WHERE kod = 658375;
UPDATE ruian_katastr SET nazev = 'Hory u Jenišova' WHERE kod = 658383;
UPDATE ruian_katastr SET nazev = 'Jenišov' WHERE kod = 658391;
UPDATE ruian_katastr SET nazev = 'Jenišovice u Jablonce nad Nisou' WHERE kod = 658413;
UPDATE ruian_katastr SET nazev = 'Odolenovice u Jenišovic' WHERE kod = 658430;
UPDATE ruian_katastr SET nazev = 'Jenišovice u Chrudimi' WHERE kod = 658448;
UPDATE ruian_katastr SET nazev = 'Zalažany' WHERE kod = 658464;
UPDATE ruian_katastr SET nazev = 'Jenišův Újezd' WHERE kod = 658472;
UPDATE ruian_katastr SET nazev = 'Dehtáry' WHERE kod = 658481;
UPDATE ruian_katastr SET nazev = 'Jenštejn' WHERE kod = 658499;
UPDATE ruian_katastr SET nazev = 'Jersín' WHERE kod = 658502;
UPDATE ruian_katastr SET nazev = 'Jeřice' WHERE kod = 658511;
UPDATE ruian_katastr SET nazev = 'Jeřičky' WHERE kod = 658529;
UPDATE ruian_katastr SET nazev = 'Čečkovice u Jeřišna' WHERE kod = 658537;
UPDATE ruian_katastr SET nazev = 'Chuchel' WHERE kod = 658545;
UPDATE ruian_katastr SET nazev = 'Jeřišno' WHERE kod = 658553;
UPDATE ruian_katastr SET nazev = 'Vestecká Lhotka' WHERE kod = 658570;
UPDATE ruian_katastr SET nazev = 'Jeřmanice' WHERE kod = 658588;
UPDATE ruian_katastr SET nazev = 'Jesenec' WHERE kod = 658596;
UPDATE ruian_katastr SET nazev = 'Horní Jirčany' WHERE kod = 658600;
UPDATE ruian_katastr SET nazev = 'Jesenice u Prahy' WHERE kod = 658618;
UPDATE ruian_katastr SET nazev = 'Dobrošovice' WHERE kod = 658626;
UPDATE ruian_katastr SET nazev = 'Jesenice u Sedlčan' WHERE kod = 658651;
UPDATE ruian_katastr SET nazev = 'Jesenice u Rakovníka' WHERE kod = 658693;
UPDATE ruian_katastr SET nazev = 'Kosobody' WHERE kod = 658707;
UPDATE ruian_katastr SET nazev = 'Soseň' WHERE kod = 658715;
UPDATE ruian_katastr SET nazev = 'Jeseník' WHERE kod = 658723;
UPDATE ruian_katastr SET nazev = 'Bukovice u Jeseníka' WHERE kod = 658880;
UPDATE ruian_katastr SET nazev = 'Seč u Jeseníka' WHERE kod = 658928;
UPDATE ruian_katastr SET nazev = 'Hrabětice nad Odrou' WHERE kod = 658944;
UPDATE ruian_katastr SET nazev = 'Jeseník nad Odrou' WHERE kod = 658952;
UPDATE ruian_katastr SET nazev = 'Jesenný' WHERE kod = 658979;
UPDATE ruian_katastr SET nazev = 'Jestřabí nad Vláří' WHERE kod = 658987;
UPDATE ruian_katastr SET nazev = 'Kochavec' WHERE kod = 658995;
UPDATE ruian_katastr SET nazev = 'Jestřabí u Fulneku' WHERE kod = 659002;
UPDATE ruian_katastr SET nazev = 'Jestřabí Lhota' WHERE kod = 659011;
UPDATE ruian_katastr SET nazev = 'Jestřabí v Krkonoších' WHERE kod = 659029;
UPDATE ruian_katastr SET nazev = 'Roudnice v Krkonoších' WHERE kod = 659045;
UPDATE ruian_katastr SET nazev = 'Jestřabice' WHERE kod = 659053;
UPDATE ruian_katastr SET nazev = 'Jestřebí u České Lípy' WHERE kod = 659061;
UPDATE ruian_katastr SET nazev = 'Újezd u Jestřebí' WHERE kod = 659070;
UPDATE ruian_katastr SET nazev = 'Jestřebí nad Metují' WHERE kod = 659088;
UPDATE ruian_katastr SET nazev = 'Libchyně' WHERE kod = 659096;
UPDATE ruian_katastr SET nazev = 'Sendraž' WHERE kod = 659100;
UPDATE ruian_katastr SET nazev = 'Jestřebí u Zábřeha' WHERE kod = 659118;
UPDATE ruian_katastr SET nazev = 'Jestřebíčko' WHERE kod = 659126;
UPDATE ruian_katastr SET nazev = 'Ješetice' WHERE kod = 659134;
UPDATE ruian_katastr SET nazev = 'Ješín' WHERE kod = 659169;
UPDATE ruian_katastr SET nazev = 'Jetětice' WHERE kod = 659185;
UPDATE ruian_katastr SET nazev = 'Jetřichov' WHERE kod = 659193;
UPDATE ruian_katastr SET nazev = 'Jetřichovec' WHERE kod = 659207;
UPDATE ruian_katastr SET nazev = 'Jetřichovice' WHERE kod = 659215;
UPDATE ruian_katastr SET nazev = 'Sušetice' WHERE kod = 659223;
UPDATE ruian_katastr SET nazev = 'Šanovice' WHERE kod = 659231;
UPDATE ruian_katastr SET nazev = 'Uhřice u Sedlce' WHERE kod = 659240;
UPDATE ruian_katastr SET nazev = 'Jetřichovice u Děčína' WHERE kod = 659258;
UPDATE ruian_katastr SET nazev = 'Rynartice' WHERE kod = 659274;
UPDATE ruian_katastr SET nazev = 'Všemily' WHERE kod = 659282;
UPDATE ruian_katastr SET nazev = 'Vysoká Lípa' WHERE kod = 659291;
UPDATE ruian_katastr SET nazev = 'Jevany' WHERE kod = 659312;
UPDATE ruian_katastr SET nazev = 'Jevíčko-město' WHERE kod = 659321;
UPDATE ruian_katastr SET nazev = 'Jevíčko-předměstí' WHERE kod = 659339;
UPDATE ruian_katastr SET nazev = 'Jeviněves' WHERE kod = 659347;
UPDATE ruian_katastr SET nazev = 'Jevišovice' WHERE kod = 659355;
UPDATE ruian_katastr SET nazev = 'Jevišovka' WHERE kod = 659363;
UPDATE ruian_katastr SET nazev = 'Jezbořice' WHERE kod = 659371;
UPDATE ruian_katastr SET nazev = 'Jezdkovice' WHERE kod = 659380;
UPDATE ruian_katastr SET nazev = 'Jezdovice' WHERE kod = 659398;
UPDATE ruian_katastr SET nazev = 'Jezernice' WHERE kod = 659401;
UPDATE ruian_katastr SET nazev = 'Jezeřany' WHERE kod = 659428;
UPDATE ruian_katastr SET nazev = 'Maršovice' WHERE kod = 659436;
UPDATE ruian_katastr SET nazev = 'Jeznice' WHERE kod = 659452;
UPDATE ruian_katastr SET nazev = 'Ježená' WHERE kod = 659461;
UPDATE ruian_katastr SET nazev = 'Ježkovice' WHERE kod = 659479;
UPDATE ruian_katastr SET nazev = 'Ježkovice na Moravě' WHERE kod = 659487;
UPDATE ruian_katastr SET nazev = 'Ježov nad Želivkou' WHERE kod = 659495;
UPDATE ruian_katastr SET nazev = 'Ježov' WHERE kod = 659509;
UPDATE ruian_katastr SET nazev = 'Chlumská' WHERE kod = 659517;
UPDATE ruian_katastr SET nazev = 'Ježovy' WHERE kod = 659525;
UPDATE ruian_katastr SET nazev = 'Trnčí' WHERE kod = 659533;
UPDATE ruian_katastr SET nazev = 'Jičín' WHERE kod = 659541;
UPDATE ruian_katastr SET nazev = 'Jičina' WHERE kod = 659622;
UPDATE ruian_katastr SET nazev = 'Bartoušov u Jičíněvsi' WHERE kod = 659631;
UPDATE ruian_katastr SET nazev = 'Jičíněves' WHERE kod = 659649;
UPDATE ruian_katastr SET nazev = 'Kostelec u Jičíněvsi' WHERE kod = 659657;
UPDATE ruian_katastr SET nazev = 'Žitětín' WHERE kod = 659665;
UPDATE ruian_katastr SET nazev = 'Jihlava' WHERE kod = 659673;
UPDATE ruian_katastr SET nazev = 'Helenín' WHERE kod = 659827;
UPDATE ruian_katastr SET nazev = 'Pančava' WHERE kod = 659835;
UPDATE ruian_katastr SET nazev = 'Sasov' WHERE kod = 659843;
UPDATE ruian_katastr SET nazev = 'Staré Hory' WHERE kod = 659860;
UPDATE ruian_katastr SET nazev = 'Bedřichov u Jihlavy' WHERE kod = 659878;
UPDATE ruian_katastr SET nazev = 'Pávov' WHERE kod = 659916;
UPDATE ruian_katastr SET nazev = 'Jihlávka' WHERE kod = 659924;
UPDATE ruian_katastr SET nazev = 'Jíkev' WHERE kod = 659932;
UPDATE ruian_katastr SET nazev = 'Jilem' WHERE kod = 659941;
UPDATE ruian_katastr SET nazev = 'Jilemnice' WHERE kod = 659959;
UPDATE ruian_katastr SET nazev = 'Hrabačov' WHERE kod = 659975;
UPDATE ruian_katastr SET nazev = 'Jilemník' WHERE kod = 660019;
UPDATE ruian_katastr SET nazev = 'Ždírec u Pohledu' WHERE kod = 660027;
UPDATE ruian_katastr SET nazev = 'Jilešovice' WHERE kod = 660035;
UPDATE ruian_katastr SET nazev = 'Jílové u Děčína' WHERE kod = 660043;
UPDATE ruian_katastr SET nazev = 'Martiněves u Děčína' WHERE kod = 660051;
UPDATE ruian_katastr SET nazev = 'Jílové u Držkova' WHERE kod = 660060;
UPDATE ruian_katastr SET nazev = 'Borek nad Sázavou' WHERE kod = 660078;
UPDATE ruian_katastr SET nazev = 'Jílové u Prahy' WHERE kod = 660094;
UPDATE ruian_katastr SET nazev = 'Jílovec' WHERE kod = 660132;
UPDATE ruian_katastr SET nazev = 'Jílovice u Trhových Svinů' WHERE kod = 660141;
UPDATE ruian_katastr SET nazev = 'Jílovice u Českého Meziříčí' WHERE kod = 660167;
UPDATE ruian_katastr SET nazev = 'Jíloviště' WHERE kod = 660175;
UPDATE ruian_katastr SET nazev = 'Trnová u Jíloviště' WHERE kod = 660183;
UPDATE ruian_katastr SET nazev = 'Jimlín' WHERE kod = 660191;
UPDATE ruian_katastr SET nazev = 'Opočno u Loun' WHERE kod = 660205;
UPDATE ruian_katastr SET nazev = 'Zeměchy u Loun' WHERE kod = 660213;
UPDATE ruian_katastr SET nazev = 'Jimramov' WHERE kod = 660230;
UPDATE ruian_katastr SET nazev = 'Sedliště u Jimramova' WHERE kod = 660248;
UPDATE ruian_katastr SET nazev = 'Trhonice' WHERE kod = 660256;
UPDATE ruian_katastr SET nazev = 'Ubušín' WHERE kod = 660264;
UPDATE ruian_katastr SET nazev = 'Jinačovice' WHERE kod = 660272;
UPDATE ruian_katastr SET nazev = 'Jince' WHERE kod = 660281;
UPDATE ruian_katastr SET nazev = 'Jindice' WHERE kod = 660299;
UPDATE ruian_katastr SET nazev = 'Jestřabí u Velké Bíteše' WHERE kod = 660302;
UPDATE ruian_katastr SET nazev = 'Jindřichov u Velké Bíteše' WHERE kod = 660311;
UPDATE ruian_katastr SET nazev = 'Arnultovice u Jindřichova' WHERE kod = 660329;
UPDATE ruian_katastr SET nazev = 'Jindřichov ve Slezsku' WHERE kod = 660337;
UPDATE ruian_katastr SET nazev = 'Jindřichov u Hranic' WHERE kod = 660345;
UPDATE ruian_katastr SET nazev = 'Habartice u Jindřichova' WHERE kod = 660353;
UPDATE ruian_katastr SET nazev = 'Pekařov' WHERE kod = 660370;
UPDATE ruian_katastr SET nazev = 'Pleče' WHERE kod = 660388;
UPDATE ruian_katastr SET nazev = 'Pusté Žibřidovice' WHERE kod = 660396;
UPDATE ruian_katastr SET nazev = 'Háj u Jindřichovic' WHERE kod = 660400;
UPDATE ruian_katastr SET nazev = 'Heřmanov v Krušných horách' WHERE kod = 660418;
UPDATE ruian_katastr SET nazev = 'Hradecká' WHERE kod = 660426;
UPDATE ruian_katastr SET nazev = 'Jindřichovice v Krušných horách' WHERE kod = 660434;
UPDATE ruian_katastr SET nazev = 'Loučná v Krušných horách' WHERE kod = 660442;
UPDATE ruian_katastr SET nazev = 'Mezihorská' WHERE kod = 660451;
UPDATE ruian_katastr SET nazev = 'Poušť' WHERE kod = 660469;
UPDATE ruian_katastr SET nazev = 'Stará' WHERE kod = 660485;
UPDATE ruian_katastr SET nazev = 'Jindřichovice na Moravě' WHERE kod = 660493;
UPDATE ruian_katastr SET nazev = 'Dětřichovec' WHERE kod = 660507;
UPDATE ruian_katastr SET nazev = 'Jindřichovice pod Smrkem' WHERE kod = 660515;
UPDATE ruian_katastr SET nazev = 'Jindřichův Hradec' WHERE kod = 660523;
UPDATE ruian_katastr SET nazev = 'Buk u Jindřichova Hradce' WHERE kod = 660647;
UPDATE ruian_katastr SET nazev = 'Políkno u Jindřichova Hradce' WHERE kod = 660698;
UPDATE ruian_katastr SET nazev = 'Horní Žďár u Jindřichova Hradce' WHERE kod = 660701;
UPDATE ruian_katastr SET nazev = 'Jinín' WHERE kod = 660710;
UPDATE ruian_katastr SET nazev = 'Třešovice' WHERE kod = 660728;
UPDATE ruian_katastr SET nazev = 'Zorkovice' WHERE kod = 660736;
UPDATE ruian_katastr SET nazev = 'Jinočany' WHERE kod = 660744;
UPDATE ruian_katastr SET nazev = 'Jinošov' WHERE kod = 660752;
UPDATE ruian_katastr SET nazev = 'Jirkov' WHERE kod = 660761;
UPDATE ruian_katastr SET nazev = 'Březenec' WHERE kod = 660809;
UPDATE ruian_katastr SET nazev = 'Jindřišská' WHERE kod = 660833;
UPDATE ruian_katastr SET nazev = 'Červený Hrádek u Jirkova' WHERE kod = 660876;
UPDATE ruian_katastr SET nazev = 'Jirkov u Železného Brodu' WHERE kod = 660906;
UPDATE ruian_katastr SET nazev = 'Střevelná' WHERE kod = 660914;
UPDATE ruian_katastr SET nazev = 'Jirny' WHERE kod = 660922;
UPDATE ruian_katastr SET nazev = 'Dolní Borek' WHERE kod = 660949;
UPDATE ruian_katastr SET nazev = 'Jiřetice u Neustupova' WHERE kod = 660965;
UPDATE ruian_katastr SET nazev = 'Jiřetice u Čepřovic' WHERE kod = 660973;
UPDATE ruian_katastr SET nazev = 'Koječín u Čepřovic' WHERE kod = 660981;
UPDATE ruian_katastr SET nazev = 'Jedlová' WHERE kod = 660990;
UPDATE ruian_katastr SET nazev = 'Jiřetín pod Jedlovou' WHERE kod = 661007;
UPDATE ruian_katastr SET nazev = 'Rozhled' WHERE kod = 661023;
UPDATE ruian_katastr SET nazev = 'Jiřice u Kostelce nad Labem' WHERE kod = 661031;
UPDATE ruian_katastr SET nazev = 'Jiřice u Humpolce' WHERE kod = 661040;
UPDATE ruian_katastr SET nazev = 'Jiřice u Miroslavi' WHERE kod = 661058;
UPDATE ruian_katastr SET nazev = 'Filipov u Jiříkova' WHERE kod = 661066;
UPDATE ruian_katastr SET nazev = 'Jiříkov' WHERE kod = 661074;
UPDATE ruian_katastr SET nazev = 'Jiříkov u Rýmařova' WHERE kod = 661082;
UPDATE ruian_katastr SET nazev = 'Jiříkovice' WHERE kod = 661091;
UPDATE ruian_katastr SET nazev = 'Jiříkovice u Nového Města na Moravě' WHERE kod = 661104;
UPDATE ruian_katastr SET nazev = 'Jiřín' WHERE kod = 661112;
UPDATE ruian_katastr SET nazev = 'Cunkov' WHERE kod = 661139;
UPDATE ruian_katastr SET nazev = 'Chlum u Jistebnice' WHERE kod = 661155;
UPDATE ruian_katastr SET nazev = 'Jistebnice' WHERE kod = 661171;
UPDATE ruian_katastr SET nazev = 'Plechov' WHERE kod = 661198;
UPDATE ruian_katastr SET nazev = 'Pohoří u Jistebnice' WHERE kod = 661201;
UPDATE ruian_katastr SET nazev = 'Zvěstonín' WHERE kod = 661228;
UPDATE ruian_katastr SET nazev = 'Jistebník' WHERE kod = 661236;
UPDATE ruian_katastr SET nazev = 'Jivany' WHERE kod = 661252;
UPDATE ruian_katastr SET nazev = 'Jivina u Hořovic' WHERE kod = 661261;
UPDATE ruian_katastr SET nazev = 'Borovice' WHERE kod = 661279;
UPDATE ruian_katastr SET nazev = 'Jivina' WHERE kod = 661287;
UPDATE ruian_katastr SET nazev = 'Kozmice u Jiviny' WHERE kod = 661295;
UPDATE ruian_katastr SET nazev = 'Mohelnice nad Jizerou' WHERE kod = 661309;
UPDATE ruian_katastr SET nazev = 'Mukařov u Jiviny' WHERE kod = 661317;
UPDATE ruian_katastr SET nazev = 'Neveklovice' WHERE kod = 661325;
UPDATE ruian_katastr SET nazev = 'Strážiště u Jiviny' WHERE kod = 661333;
UPDATE ruian_katastr SET nazev = 'Vicmanov' WHERE kod = 661341;
UPDATE ruian_katastr SET nazev = 'Dolní Vernéřovice' WHERE kod = 661350;
UPDATE ruian_katastr SET nazev = 'Horní Vernéřovice' WHERE kod = 661368;
UPDATE ruian_katastr SET nazev = 'Jívka' WHERE kod = 661376;
UPDATE ruian_katastr SET nazev = 'Studnice u Jívky' WHERE kod = 661392;
UPDATE ruian_katastr SET nazev = 'Jívová' WHERE kod = 661406;
UPDATE ruian_katastr SET nazev = 'Jívoví' WHERE kod = 661414;
UPDATE ruian_katastr SET nazev = 'Jizbice u Nymburka' WHERE kod = 661422;
UPDATE ruian_katastr SET nazev = 'Jizbice u Náchoda' WHERE kod = 661449;
UPDATE ruian_katastr SET nazev = 'Jizerní Vtelno' WHERE kod = 661457;
UPDATE ruian_katastr SET nazev = 'Jižná' WHERE kod = 661481;
UPDATE ruian_katastr SET nazev = 'Josefov u Hodonína' WHERE kod = 661490;
UPDATE ruian_katastr SET nazev = 'Josefův Důl u Mladé Boleslavi' WHERE kod = 661503;
UPDATE ruian_katastr SET nazev = 'Antonínov' WHERE kod = 661511;
UPDATE ruian_katastr SET nazev = 'Dolní Maxov' WHERE kod = 661520;
UPDATE ruian_katastr SET nazev = 'Josefův Důl u Jablonce nad Nisou' WHERE kod = 661538;
UPDATE ruian_katastr SET nazev = 'Karlov u Josefova Dolu' WHERE kod = 661546;
UPDATE ruian_katastr SET nazev = 'Juřinka' WHERE kod = 661554;
UPDATE ruian_katastr SET nazev = 'Kacanovy' WHERE kod = 661571;
UPDATE ruian_katastr SET nazev = 'Kaceřov' WHERE kod = 661589;
UPDATE ruian_katastr SET nazev = 'Horní Pochlovice' WHERE kod = 661597;
UPDATE ruian_katastr SET nazev = 'Kaceřov u Kynšperka nad Ohří' WHERE kod = 661601;
UPDATE ruian_katastr SET nazev = 'Káciň' WHERE kod = 661619;
UPDATE ruian_katastr SET nazev = 'Zderadinky' WHERE kod = 661627;
UPDATE ruian_katastr SET nazev = 'Kácov' WHERE kod = 661635;
UPDATE ruian_katastr SET nazev = 'Zderadiny' WHERE kod = 661651;
UPDATE ruian_katastr SET nazev = 'Kačice' WHERE kod = 661678;
UPDATE ruian_katastr SET nazev = 'Kadaň' WHERE kod = 661686;
UPDATE ruian_katastr SET nazev = 'Pokutice' WHERE kod = 661813;
UPDATE ruian_katastr SET nazev = 'Zásada u Kadaně' WHERE kod = 661821;
UPDATE ruian_katastr SET nazev = 'Prunéřov' WHERE kod = 661864;
UPDATE ruian_katastr SET nazev = 'Bystřice u Kadaně' WHERE kod = 661899;
UPDATE ruian_katastr SET nazev = 'Kadolec' WHERE kod = 661911;
UPDATE ruian_katastr SET nazev = 'Kadov u Blatné' WHERE kod = 661929;
UPDATE ruian_katastr SET nazev = 'Lnářský Málkov' WHERE kod = 661937;
UPDATE ruian_katastr SET nazev = 'Mračov' WHERE kod = 661945;
UPDATE ruian_katastr SET nazev = 'Vrbno' WHERE kod = 661953;
UPDATE ruian_katastr SET nazev = 'Kadov' WHERE kod = 661961;
UPDATE ruian_katastr SET nazev = 'Kadov u Sněžného' WHERE kod = 661970;
UPDATE ruian_katastr SET nazev = 'Krátká' WHERE kod = 661988;
UPDATE ruian_katastr SET nazev = 'Samotín' WHERE kod = 661996;
UPDATE ruian_katastr SET nazev = 'Kladenské Rovné' WHERE kod = 662020;
UPDATE ruian_katastr SET nazev = 'Kladné' WHERE kod = 662038;
UPDATE ruian_katastr SET nazev = 'Křenov u Kájova' WHERE kod = 662046;
UPDATE ruian_katastr SET nazev = 'Novosedly u Kájova' WHERE kod = 662062;
UPDATE ruian_katastr SET nazev = 'Kal' WHERE kod = 662101;
UPDATE ruian_katastr SET nazev = 'Kalek' WHERE kod = 662119;
UPDATE ruian_katastr SET nazev = 'Načetín u Kalku' WHERE kod = 662127;
UPDATE ruian_katastr SET nazev = 'Gabrielina Huť' WHERE kod = 662135;
UPDATE ruian_katastr SET nazev = 'Načetín' WHERE kod = 662143;
UPDATE ruian_katastr SET nazev = 'Kalenice' WHERE kod = 662151;
UPDATE ruian_katastr SET nazev = 'Kalhov' WHERE kod = 662160;
UPDATE ruian_katastr SET nazev = 'Kaliště u Ondřejova' WHERE kod = 662178;
UPDATE ruian_katastr SET nazev = 'Lensedly' WHERE kod = 662186;
UPDATE ruian_katastr SET nazev = 'Kaliště u Českých Budějovic' WHERE kod = 662208;
UPDATE ruian_katastr SET nazev = 'Třebotovice' WHERE kod = 662216;
UPDATE ruian_katastr SET nazev = 'Zaliny' WHERE kod = 662224;
UPDATE ruian_katastr SET nazev = 'Kaliště' WHERE kod = 662241;
UPDATE ruian_katastr SET nazev = 'Býkovec' WHERE kod = 662259;
UPDATE ruian_katastr SET nazev = 'Kaliště u Horních Dubenek' WHERE kod = 662267;
UPDATE ruian_katastr SET nazev = 'Kalivody' WHERE kod = 662275;
UPDATE ruian_katastr SET nazev = 'Kalovice' WHERE kod = 662283;
UPDATE ruian_katastr SET nazev = 'Rašovice u Kalovic' WHERE kod = 662291;
UPDATE ruian_katastr SET nazev = 'Robeč' WHERE kod = 662305;
UPDATE ruian_katastr SET nazev = 'Kalubice' WHERE kod = 662313;
UPDATE ruian_katastr SET nazev = 'Kaly' WHERE kod = 662321;
UPDATE ruian_katastr SET nazev = 'Zahrada' WHERE kod = 662330;
UPDATE ruian_katastr SET nazev = 'Kámen u Pacova' WHERE kod = 662348;
UPDATE ruian_katastr SET nazev = 'Nízká Lhota' WHERE kod = 662356;
UPDATE ruian_katastr SET nazev = 'Jiříkov u Kamene' WHERE kod = 662372;
UPDATE ruian_katastr SET nazev = 'Kámen u Habrů' WHERE kod = 662381;
UPDATE ruian_katastr SET nazev = 'Proseč u Kamene' WHERE kod = 662399;
UPDATE ruian_katastr SET nazev = 'Kamenec u Radnic' WHERE kod = 662402;
UPDATE ruian_katastr SET nazev = 'Kamenec u Poličky' WHERE kod = 662411;
UPDATE ruian_katastr SET nazev = 'Ládví' WHERE kod = 662445;
UPDATE ruian_katastr SET nazev = 'Štiřín' WHERE kod = 662496;
UPDATE ruian_katastr SET nazev = 'Těptín' WHERE kod = 662500;
UPDATE ruian_katastr SET nazev = 'Kamenice u Zákup' WHERE kod = 662534;
UPDATE ruian_katastr SET nazev = 'Kamenice u Herálce' WHERE kod = 662542;
UPDATE ruian_katastr SET nazev = 'Kamenice u Jihlavy' WHERE kod = 662551;
UPDATE ruian_katastr SET nazev = 'Vržanov' WHERE kod = 662569;
UPDATE ruian_katastr SET nazev = 'Kamenice nad Lipou' WHERE kod = 662577;
UPDATE ruian_katastr SET nazev = 'Kamenický Šenov' WHERE kod = 662640;
UPDATE ruian_katastr SET nazev = 'Kamenička' WHERE kod = 662658;
UPDATE ruian_katastr SET nazev = 'Kameničky' WHERE kod = 662666;
UPDATE ruian_katastr SET nazev = 'Kameničná' WHERE kod = 662674;
UPDATE ruian_katastr SET nazev = 'Kamenka' WHERE kod = 662682;
UPDATE ruian_katastr SET nazev = 'Kamenná u Příbramě' WHERE kod = 662691;
UPDATE ruian_katastr SET nazev = 'Zavržice' WHERE kod = 662704;
UPDATE ruian_katastr SET nazev = 'Kamenná u Trhových Svinů' WHERE kod = 662712;
UPDATE ruian_katastr SET nazev = 'Kondrač' WHERE kod = 662739;
UPDATE ruian_katastr SET nazev = 'Kamenná u Jihlavy' WHERE kod = 662747;
UPDATE ruian_katastr SET nazev = 'Nové Dvory u Kamenné' WHERE kod = 662755;
UPDATE ruian_katastr SET nazev = 'Kamenná nad Oslavou' WHERE kod = 662763;
UPDATE ruian_katastr SET nazev = 'Klementice' WHERE kod = 662771;
UPDATE ruian_katastr SET nazev = 'Kamenná' WHERE kod = 662780;
UPDATE ruian_katastr SET nazev = 'Česká Kamenná Horka' WHERE kod = 662798;
UPDATE ruian_katastr SET nazev = 'Moravská Kamenná Horka' WHERE kod = 662801;
UPDATE ruian_katastr SET nazev = 'Kamenná Lhota' WHERE kod = 662810;
UPDATE ruian_katastr SET nazev = 'Kamenné Zboží' WHERE kod = 662828;
UPDATE ruian_katastr SET nazev = 'Kamenné Žehrovice' WHERE kod = 662844;
UPDATE ruian_katastr SET nazev = 'Kamenný Malíkov' WHERE kod = 662852;
UPDATE ruian_katastr SET nazev = 'Hostěradice' WHERE kod = 662861;
UPDATE ruian_katastr SET nazev = 'Kamenný Přívoz' WHERE kod = 662879;
UPDATE ruian_katastr SET nazev = 'Kamenný Újezd' WHERE kod = 662925;
UPDATE ruian_katastr SET nazev = 'Kamenný Újezd u Rokycan' WHERE kod = 662968;
UPDATE ruian_katastr SET nazev = 'Kamýk u Litoměřic' WHERE kod = 662976;
UPDATE ruian_katastr SET nazev = 'Kamýk nad Vltavou' WHERE kod = 662984;
UPDATE ruian_katastr SET nazev = 'Kanice u Domažlic' WHERE kod = 662992;
UPDATE ruian_katastr SET nazev = 'Kanice' WHERE kod = 663000;
UPDATE ruian_katastr SET nazev = 'Kaničky' WHERE kod = 663018;
UPDATE ruian_katastr SET nazev = 'Kanina' WHERE kod = 663026;
UPDATE ruian_katastr SET nazev = 'Kaňovice u Luhačovic' WHERE kod = 663034;
UPDATE ruian_katastr SET nazev = 'Kaňovice' WHERE kod = 663051;
UPDATE ruian_katastr SET nazev = 'Kaplice' WHERE kod = 663069;
UPDATE ruian_katastr SET nazev = 'Blansko u Kaplice' WHERE kod = 663140;
UPDATE ruian_katastr SET nazev = 'Hradiště u Kaplice' WHERE kod = 663158;
UPDATE ruian_katastr SET nazev = 'Mostky' WHERE kod = 663166;
UPDATE ruian_katastr SET nazev = 'Káranice' WHERE kod = 663182;
UPDATE ruian_katastr SET nazev = 'Kardašova Řečice' WHERE kod = 663204;
UPDATE ruian_katastr SET nazev = 'Mnich u Kardašovy Řečice' WHERE kod = 663212;
UPDATE ruian_katastr SET nazev = 'Nítovice' WHERE kod = 663221;
UPDATE ruian_katastr SET nazev = 'Karle' WHERE kod = 663247;
UPDATE ruian_katastr SET nazev = 'Ostrý Kámen' WHERE kod = 663255;
UPDATE ruian_katastr SET nazev = 'Karlín na Moravě' WHERE kod = 663263;
UPDATE ruian_katastr SET nazev = 'Karlov' WHERE kod = 663271;
UPDATE ruian_katastr SET nazev = 'Karlovec' WHERE kod = 663280;
UPDATE ruian_katastr SET nazev = 'Nová Pláň' WHERE kod = 663298;
UPDATE ruian_katastr SET nazev = 'Karlova Studánka' WHERE kod = 663301;
UPDATE ruian_katastr SET nazev = 'Karlova Ves' WHERE kod = 663310;
UPDATE ruian_katastr SET nazev = 'Karlovice' WHERE kod = 663328;
UPDATE ruian_katastr SET nazev = 'Karlovice u Zlína' WHERE kod = 663379;
UPDATE ruian_katastr SET nazev = 'Karlovice ve Slezsku' WHERE kod = 663387;
UPDATE ruian_katastr SET nazev = 'Adamov u Karlovic' WHERE kod = 663409;
UPDATE ruian_katastr SET nazev = 'Nové Purkartice' WHERE kod = 663417;
UPDATE ruian_katastr SET nazev = 'Karlovy Vary' WHERE kod = 663433;
UPDATE ruian_katastr SET nazev = 'Tuhnice' WHERE kod = 663492;
UPDATE ruian_katastr SET nazev = 'Dvory' WHERE kod = 663549;
UPDATE ruian_katastr SET nazev = 'Rybáře' WHERE kod = 663557;
UPDATE ruian_katastr SET nazev = 'Bohatice' WHERE kod = 663581;
UPDATE ruian_katastr SET nazev = 'Olšová Vrata' WHERE kod = 663654;
UPDATE ruian_katastr SET nazev = 'Březová' WHERE kod = 663697;
UPDATE ruian_katastr SET nazev = 'Drahovice' WHERE kod = 663701;
UPDATE ruian_katastr SET nazev = 'Budňany' WHERE kod = 663719;
UPDATE ruian_katastr SET nazev = 'Poučník' WHERE kod = 663743;
UPDATE ruian_katastr SET nazev = 'Karolín' WHERE kod = 663751;
UPDATE ruian_katastr SET nazev = 'Karolinka' WHERE kod = 663778;
UPDATE ruian_katastr SET nazev = 'Karpentná' WHERE kod = 663816;
UPDATE ruian_katastr SET nazev = 'Karviná-město' WHERE kod = 663824;
UPDATE ruian_katastr SET nazev = 'Ráj' WHERE kod = 663981;
UPDATE ruian_katastr SET nazev = 'Darkov' WHERE kod = 664014;
UPDATE ruian_katastr SET nazev = 'Karviná-Doly' WHERE kod = 664103;
UPDATE ruian_katastr SET nazev = 'Staré Město u Karviné' WHERE kod = 664197;
UPDATE ruian_katastr SET nazev = 'Kařez' WHERE kod = 664227;
UPDATE ruian_katastr SET nazev = 'Kařízek' WHERE kod = 664235;
UPDATE ruian_katastr SET nazev = 'Kasalice' WHERE kod = 664260;
UPDATE ruian_katastr SET nazev = 'Kasaličky' WHERE kod = 664278;
UPDATE ruian_katastr SET nazev = 'Pravy' WHERE kod = 664286;
UPDATE ruian_katastr SET nazev = 'Chloumek u Kasejovic' WHERE kod = 664294;
UPDATE ruian_katastr SET nazev = 'Kasejovice' WHERE kod = 664308;
UPDATE ruian_katastr SET nazev = 'Polánka u Kasejovic' WHERE kod = 664316;
UPDATE ruian_katastr SET nazev = 'Řesanice' WHERE kod = 664324;
UPDATE ruian_katastr SET nazev = 'Újezd u Kasejovic' WHERE kod = 664332;
UPDATE ruian_katastr SET nazev = 'Kašava' WHERE kod = 664341;
UPDATE ruian_katastr SET nazev = 'Kašnice' WHERE kod = 664359;
UPDATE ruian_katastr SET nazev = 'Červená u Kašperských Hor' WHERE kod = 664375;
UPDATE ruian_katastr SET nazev = 'Dolní Dvorce u Kašperských Hor' WHERE kod = 664383;
UPDATE ruian_katastr SET nazev = 'Kašperské Hory' WHERE kod = 664391;
UPDATE ruian_katastr SET nazev = 'Kavrlík' WHERE kod = 664405;
UPDATE ruian_katastr SET nazev = 'Lídlovy Dvory' WHERE kod = 664413;
UPDATE ruian_katastr SET nazev = 'Opolenec' WHERE kod = 664421;
UPDATE ruian_katastr SET nazev = 'Tuškov' WHERE kod = 664430;
UPDATE ruian_katastr SET nazev = 'Žlíbek' WHERE kod = 664448;
UPDATE ruian_katastr SET nazev = 'Dolánky u Kaštic' WHERE kod = 664456;
UPDATE ruian_katastr SET nazev = 'Kaštice' WHERE kod = 664464;
UPDATE ruian_katastr SET nazev = 'Neprobylice u Kaštic' WHERE kod = 664472;
UPDATE ruian_katastr SET nazev = 'Kateřinice' WHERE kod = 664481;
UPDATE ruian_katastr SET nazev = 'Kateřinice u Vsetína' WHERE kod = 664499;
UPDATE ruian_katastr SET nazev = 'Katovice' WHERE kod = 664529;
UPDATE ruian_katastr SET nazev = 'Katusice' WHERE kod = 664537;
UPDATE ruian_katastr SET nazev = 'Spikaly' WHERE kod = 664545;
UPDATE ruian_katastr SET nazev = 'Kaznějov' WHERE kod = 664553;
UPDATE ruian_katastr SET nazev = 'Kbel' WHERE kod = 664561;
UPDATE ruian_katastr SET nazev = 'Kbel u Přeštic' WHERE kod = 664588;
UPDATE ruian_katastr SET nazev = 'Malinec' WHERE kod = 664596;
UPDATE ruian_katastr SET nazev = 'Kbelnice' WHERE kod = 664626;
UPDATE ruian_katastr SET nazev = 'Kdanice' WHERE kod = 664634;
UPDATE ruian_katastr SET nazev = 'Kdousov' WHERE kod = 664651;
UPDATE ruian_katastr SET nazev = 'Hluboká u Kdyně' WHERE kod = 664669;
UPDATE ruian_katastr SET nazev = 'Kdyně' WHERE kod = 664677;
UPDATE ruian_katastr SET nazev = 'Keblice' WHERE kod = 664693;
UPDATE ruian_katastr SET nazev = 'Keblov' WHERE kod = 664707;
UPDATE ruian_katastr SET nazev = 'Kejnice' WHERE kod = 664723;
UPDATE ruian_katastr SET nazev = 'Kejžlice' WHERE kod = 664731;
UPDATE ruian_katastr SET nazev = 'Kelč-Nové Město' WHERE kod = 664758;
UPDATE ruian_katastr SET nazev = 'Kelč-Staré Město' WHERE kod = 664766;
UPDATE ruian_katastr SET nazev = 'Kelčany' WHERE kod = 664774;
UPDATE ruian_katastr SET nazev = 'Kelníky' WHERE kod = 664782;
UPDATE ruian_katastr SET nazev = 'Kerhartice' WHERE kod = 664791;
UPDATE ruian_katastr SET nazev = 'Staré Kestřany' WHERE kod = 664821;
UPDATE ruian_katastr SET nazev = 'Lhota u Kestřan' WHERE kod = 664839;
UPDATE ruian_katastr SET nazev = 'Zátaví' WHERE kod = 664847;
UPDATE ruian_katastr SET nazev = 'Ketkovice' WHERE kod = 664855;
UPDATE ruian_katastr SET nazev = 'Hluboký' WHERE kod = 664863;
UPDATE ruian_katastr SET nazev = 'Kfely u Ostrova' WHERE kod = 664871;
UPDATE ruian_katastr SET nazev = 'Klabava' WHERE kod = 664880;
UPDATE ruian_katastr SET nazev = 'Kladeruby' WHERE kod = 664898;
UPDATE ruian_katastr SET nazev = 'Kladeruby nad Oslavou' WHERE kod = 664901;
UPDATE ruian_katastr SET nazev = 'Kladina' WHERE kod = 664910;
UPDATE ruian_katastr SET nazev = 'Kladky' WHERE kod = 664928;
UPDATE ruian_katastr SET nazev = 'Kladná Žilín' WHERE kod = 664944;
UPDATE ruian_katastr SET nazev = 'Kladníky' WHERE kod = 664952;
UPDATE ruian_katastr SET nazev = 'Rozdělov' WHERE kod = 664961;
UPDATE ruian_katastr SET nazev = 'Kladno' WHERE kod = 665061;
UPDATE ruian_katastr SET nazev = 'Kročehlavy' WHERE kod = 665126;
UPDATE ruian_katastr SET nazev = 'Dubí u Kladna' WHERE kod = 665169;
UPDATE ruian_katastr SET nazev = 'Vrapice' WHERE kod = 665177;
UPDATE ruian_katastr SET nazev = 'Kladno u Hlinska' WHERE kod = 665266;
UPDATE ruian_katastr SET nazev = 'Kladoruby' WHERE kod = 665274;
UPDATE ruian_katastr SET nazev = 'Trávník u Kladorub' WHERE kod = 665282;
UPDATE ruian_katastr SET nazev = 'Kladrubce' WHERE kod = 665291;
UPDATE ruian_katastr SET nazev = 'Přebudov' WHERE kod = 665304;
UPDATE ruian_katastr SET nazev = 'Kladruby u Vlašimi' WHERE kod = 665312;
UPDATE ruian_katastr SET nazev = 'Kladruby u Strakonic' WHERE kod = 665321;
UPDATE ruian_katastr SET nazev = 'Kladruby u Radnic' WHERE kod = 665347;
UPDATE ruian_katastr SET nazev = 'Kladruby u Stříbra' WHERE kod = 665355;
UPDATE ruian_katastr SET nazev = 'Láz u Kladrub' WHERE kod = 665363;
UPDATE ruian_katastr SET nazev = 'Milevo' WHERE kod = 665371;
UPDATE ruian_katastr SET nazev = 'Pozorka u Kladrub' WHERE kod = 665380;
UPDATE ruian_katastr SET nazev = 'Vrbice u Stříbra' WHERE kod = 665398;
UPDATE ruian_katastr SET nazev = 'Kladruby u Teplic' WHERE kod = 665401;
UPDATE ruian_katastr SET nazev = 'Kladruby nad Labem' WHERE kod = 665410;
UPDATE ruian_katastr SET nazev = 'Klamoš' WHERE kod = 665428;
UPDATE ruian_katastr SET nazev = 'Štít' WHERE kod = 665436;
UPDATE ruian_katastr SET nazev = 'Klánovice' WHERE kod = 665444;
UPDATE ruian_katastr SET nazev = 'Klapý' WHERE kod = 665452;
UPDATE ruian_katastr SET nazev = 'Klášter' WHERE kod = 665461;
UPDATE ruian_katastr SET nazev = 'Konrac' WHERE kod = 665479;
UPDATE ruian_katastr SET nazev = 'Klášter u Nepomuka' WHERE kod = 665495;
UPDATE ruian_katastr SET nazev = 'Klášter Hradiště nad Jizerou' WHERE kod = 665517;
UPDATE ruian_katastr SET nazev = 'Arnoštka' WHERE kod = 665525;
UPDATE ruian_katastr SET nazev = 'Klášterec u Vimperka' WHERE kod = 665533;
UPDATE ruian_katastr SET nazev = 'Korkusova Huť' WHERE kod = 665541;
UPDATE ruian_katastr SET nazev = 'Lipka u Vimperka' WHERE kod = 665550;
UPDATE ruian_katastr SET nazev = 'Michlova Huť' WHERE kod = 665568;
UPDATE ruian_katastr SET nazev = 'Skláře u Vimperka' WHERE kod = 665576;
UPDATE ruian_katastr SET nazev = 'Solná Lhota' WHERE kod = 665584;
UPDATE ruian_katastr SET nazev = 'Huťský Dvůr' WHERE kod = 665592;
UPDATE ruian_katastr SET nazev = 'Klášterec' WHERE kod = 665606;
UPDATE ruian_katastr SET nazev = 'Klášterec nad Ohří' WHERE kod = 665622;
UPDATE ruian_katastr SET nazev = 'Klášterecká Jeseň' WHERE kod = 665631;
UPDATE ruian_katastr SET nazev = 'Lestkov u Klášterce nad Ohří' WHERE kod = 665649;
UPDATE ruian_katastr SET nazev = 'Miřetice u Klášterce nad Ohří' WHERE kod = 665657;
UPDATE ruian_katastr SET nazev = 'Rašovice u Klášterce nad Ohří' WHERE kod = 665665;
UPDATE ruian_katastr SET nazev = 'Suchý Důl u Klášterce nad Ohří' WHERE kod = 665673;
UPDATE ruian_katastr SET nazev = 'Velká Lesná' WHERE kod = 665690;
UPDATE ruian_katastr SET nazev = 'Klášterec nad Orlicí' WHERE kod = 665720;
UPDATE ruian_katastr SET nazev = 'Klášterská Lhota' WHERE kod = 665754;
UPDATE ruian_katastr SET nazev = 'Klatovec' WHERE kod = 665762;
UPDATE ruian_katastr SET nazev = 'Klatovy' WHERE kod = 665797;
UPDATE ruian_katastr SET nazev = 'Sobětice u Klatov' WHERE kod = 665959;
UPDATE ruian_katastr SET nazev = 'Kosmáčov' WHERE kod = 665967;
UPDATE ruian_katastr SET nazev = 'Luby' WHERE kod = 665975;
UPDATE ruian_katastr SET nazev = 'Kal u Klatov' WHERE kod = 665983;
UPDATE ruian_katastr SET nazev = 'Klec' WHERE kod = 666009;
UPDATE ruian_katastr SET nazev = 'Drasty' WHERE kod = 666017;
UPDATE ruian_katastr SET nazev = 'Klecany' WHERE kod = 666033;
UPDATE ruian_katastr SET nazev = 'Klečůvka' WHERE kod = 666041;
UPDATE ruian_katastr SET nazev = 'Klenčí pod Čerchovem' WHERE kod = 666068;
UPDATE ruian_katastr SET nazev = 'Lísková u Nemanic' WHERE kod = 666076;
UPDATE ruian_katastr SET nazev = 'Kleneč' WHERE kod = 666084;
UPDATE ruian_katastr SET nazev = 'Klenov' WHERE kod = 666092;
UPDATE ruian_katastr SET nazev = 'Klenovice u Soběslavi' WHERE kod = 666106;
UPDATE ruian_katastr SET nazev = 'Klenovice na Hané' WHERE kod = 666122;
UPDATE ruian_katastr SET nazev = 'Klenovka' WHERE kod = 666131;
UPDATE ruian_katastr SET nazev = 'Klentnice' WHERE kod = 666149;
UPDATE ruian_katastr SET nazev = 'Klepačov' WHERE kod = 666157;
UPDATE ruian_katastr SET nazev = 'Klešice' WHERE kod = 666165;
UPDATE ruian_katastr SET nazev = 'Kletečná u Humpolce' WHERE kod = 666181;
UPDATE ruian_katastr SET nazev = 'Kletné' WHERE kod = 666190;
UPDATE ruian_katastr SET nazev = 'Klíčany' WHERE kod = 666203;
UPDATE ruian_katastr SET nazev = 'Klíčov u Mrákova' WHERE kod = 666238;
UPDATE ruian_katastr SET nazev = 'Klikov' WHERE kod = 666262;
UPDATE ruian_katastr SET nazev = 'Klimkovice' WHERE kod = 666319;
UPDATE ruian_katastr SET nazev = 'Klínec' WHERE kod = 666343;
UPDATE ruian_katastr SET nazev = 'Klíny I' WHERE kod = 666351;
UPDATE ruian_katastr SET nazev = 'Klíny II' WHERE kod = 666360;
UPDATE ruian_katastr SET nazev = 'Rašov u Litvínova' WHERE kod = 666378;
UPDATE ruian_katastr SET nazev = 'Kloboučky' WHERE kod = 666394;
UPDATE ruian_katastr SET nazev = 'Klobouky u Brna' WHERE kod = 666408;
UPDATE ruian_katastr SET nazev = 'Klobuky' WHERE kod = 666424;
UPDATE ruian_katastr SET nazev = 'Kobylníky' WHERE kod = 666432;
UPDATE ruian_katastr SET nazev = 'Kokovice' WHERE kod = 666441;
UPDATE ruian_katastr SET nazev = 'Klokočí' WHERE kod = 666459;
UPDATE ruian_katastr SET nazev = 'Klokočná' WHERE kod = 666467;
UPDATE ruian_katastr SET nazev = 'Klokočov' WHERE kod = 666475;
UPDATE ruian_katastr SET nazev = 'Klokočí u Turnova' WHERE kod = 666483;
UPDATE ruian_katastr SET nazev = 'Loučky u Turnova' WHERE kod = 666491;
UPDATE ruian_katastr SET nazev = 'Klokoty' WHERE kod = 666513;
UPDATE ruian_katastr SET nazev = 'Klopina' WHERE kod = 666548;
UPDATE ruian_katastr SET nazev = 'Veleboř' WHERE kod = 666556;
UPDATE ruian_katastr SET nazev = 'Klopotovice' WHERE kod = 666564;
UPDATE ruian_katastr SET nazev = 'Kloužovice' WHERE kod = 666572;
UPDATE ruian_katastr SET nazev = 'Velmovice' WHERE kod = 666581;
UPDATE ruian_katastr SET nazev = 'Klučenice' WHERE kod = 666602;
UPDATE ruian_katastr SET nazev = 'Planá u Klučenic' WHERE kod = 666629;
UPDATE ruian_katastr SET nazev = 'Voltýřov' WHERE kod = 666637;
UPDATE ruian_katastr SET nazev = 'Klučov u Českého Brodu' WHERE kod = 666645;
UPDATE ruian_katastr SET nazev = 'Lstiboř' WHERE kod = 666653;
UPDATE ruian_katastr SET nazev = 'Klučov' WHERE kod = 666661;
UPDATE ruian_katastr SET nazev = 'Kluk' WHERE kod = 666670;
UPDATE ruian_katastr SET nazev = 'Kluky u Čáslavi' WHERE kod = 666688;
UPDATE ruian_katastr SET nazev = 'Kluky u Mladé Boleslavi' WHERE kod = 666696;
UPDATE ruian_katastr SET nazev = 'Dobešice' WHERE kod = 666700;
UPDATE ruian_katastr SET nazev = 'Kluky u Písku' WHERE kod = 666734;
UPDATE ruian_katastr SET nazev = 'Kly' WHERE kod = 666777;
UPDATE ruian_katastr SET nazev = 'Záboří u Kel' WHERE kod = 666785;
UPDATE ruian_katastr SET nazev = 'Kmetiněves' WHERE kod = 666793;
UPDATE ruian_katastr SET nazev = 'Poštovice' WHERE kod = 666807;
UPDATE ruian_katastr SET nazev = 'Dolní Houžovec' WHERE kod = 666815;
UPDATE ruian_katastr SET nazev = 'Horní Houžovec' WHERE kod = 666823;
UPDATE ruian_katastr SET nazev = 'Knapovec' WHERE kod = 666831;
UPDATE ruian_katastr SET nazev = 'Kněždub' WHERE kod = 666840;
UPDATE ruian_katastr SET nazev = 'Kněževes u Prahy' WHERE kod = 666858;
UPDATE ruian_katastr SET nazev = 'Kněževes u Rakovníka' WHERE kod = 666866;
UPDATE ruian_katastr SET nazev = 'Kněževes' WHERE kod = 666882;
UPDATE ruian_katastr SET nazev = 'Veselka u Olešnice' WHERE kod = 666891;
UPDATE ruian_katastr SET nazev = 'Kněževes nad Oslavou' WHERE kod = 666904;
UPDATE ruian_katastr SET nazev = 'Dubečno' WHERE kod = 666912;
UPDATE ruian_katastr SET nazev = 'Kněžice u Městce Králové' WHERE kod = 666921;
UPDATE ruian_katastr SET nazev = 'Kněžice v Lužických horách' WHERE kod = 666939;
UPDATE ruian_katastr SET nazev = 'Kněžice u Podbořan' WHERE kod = 666947;
UPDATE ruian_katastr SET nazev = 'Kněžice u Ronova' WHERE kod = 666971;
UPDATE ruian_katastr SET nazev = 'Moravany u Ronova' WHERE kod = 666980;
UPDATE ruian_katastr SET nazev = 'Brodce' WHERE kod = 666998;
UPDATE ruian_katastr SET nazev = 'Kněžice u Třebíče' WHERE kod = 667005;
UPDATE ruian_katastr SET nazev = 'Rychlov u Kněžic' WHERE kod = 667013;
UPDATE ruian_katastr SET nazev = 'Víska u Kněžic' WHERE kod = 667030;
UPDATE ruian_katastr SET nazev = 'Kněžmost' WHERE kod = 667056;
UPDATE ruian_katastr SET nazev = 'Suhrovice' WHERE kod = 667064;
UPDATE ruian_katastr SET nazev = 'Kněžnice' WHERE kod = 667081;
UPDATE ruian_katastr SET nazev = 'Kněžpole u Uherského Hradiště' WHERE kod = 667102;
UPDATE ruian_katastr SET nazev = 'Kněžpole' WHERE kod = 667111;
UPDATE ruian_katastr SET nazev = 'Knínice' WHERE kod = 667137;
UPDATE ruian_katastr SET nazev = 'Knínice u Boskovic' WHERE kod = 667145;
UPDATE ruian_katastr SET nazev = 'Kňovice' WHERE kod = 667153;
UPDATE ruian_katastr SET nazev = 'Knovíz' WHERE kod = 667188;
UPDATE ruian_katastr SET nazev = 'Český Dvůr' WHERE kod = 667196;
UPDATE ruian_katastr SET nazev = 'Knyk' WHERE kod = 667200;
UPDATE ruian_katastr SET nazev = 'Zbožice' WHERE kod = 667234;
UPDATE ruian_katastr SET nazev = 'Koberovice' WHERE kod = 667242;
UPDATE ruian_katastr SET nazev = 'Besedice' WHERE kod = 667251;
UPDATE ruian_katastr SET nazev = 'Koberovy' WHERE kod = 667285;
UPDATE ruian_katastr SET nazev = 'Vrát' WHERE kod = 667315;
UPDATE ruian_katastr SET nazev = 'Kobeřice u Brna' WHERE kod = 667331;
UPDATE ruian_katastr SET nazev = 'Kobeřice ve Slezsku' WHERE kod = 667340;
UPDATE ruian_katastr SET nazev = 'Koblov' WHERE kod = 667366;
UPDATE ruian_katastr SET nazev = 'Koburk' WHERE kod = 667382;
UPDATE ruian_katastr SET nazev = 'Kobylá nad Vidnavkou' WHERE kod = 667404;
UPDATE ruian_katastr SET nazev = 'Kobylí' WHERE kod = 667421;
UPDATE ruian_katastr SET nazev = 'Kobylí na Moravě' WHERE kod = 667455;
UPDATE ruian_katastr SET nazev = 'Kobylnice' WHERE kod = 667463;
UPDATE ruian_katastr SET nazev = 'Kobylnice u Brna' WHERE kod = 667471;
UPDATE ruian_katastr SET nazev = 'Kobyly' WHERE kod = 667498;
UPDATE ruian_katastr SET nazev = 'Kocbeře' WHERE kod = 667544;
UPDATE ruian_katastr SET nazev = 'Kocelovice' WHERE kod = 667579;
UPDATE ruian_katastr SET nazev = 'Koclířov' WHERE kod = 667595;
UPDATE ruian_katastr SET nazev = 'Bystré u Klatov' WHERE kod = 667609;
UPDATE ruian_katastr SET nazev = 'Kocourov' WHERE kod = 667617;
UPDATE ruian_katastr SET nazev = 'Lhůta u Klatov' WHERE kod = 667625;
UPDATE ruian_katastr SET nazev = 'Kočí' WHERE kod = 667633;
UPDATE ruian_katastr SET nazev = 'Topol' WHERE kod = 667641;
UPDATE ruian_katastr SET nazev = 'Kočín u Kralovic' WHERE kod = 667650;
UPDATE ruian_katastr SET nazev = 'Klíčov' WHERE kod = 667668;
UPDATE ruian_katastr SET nazev = 'Kočov' WHERE kod = 667676;
UPDATE ruian_katastr SET nazev = 'Ústí nad Mží' WHERE kod = 667684;
UPDATE ruian_katastr SET nazev = 'Kladruby u Kohoutova' WHERE kod = 667692;
UPDATE ruian_katastr SET nazev = 'Kohoutov' WHERE kod = 667706;
UPDATE ruian_katastr SET nazev = 'Kochánky' WHERE kod = 667731;
UPDATE ruian_katastr SET nazev = 'Kochánov' WHERE kod = 667749;
UPDATE ruian_katastr SET nazev = 'Úhořilka' WHERE kod = 667757;
UPDATE ruian_katastr SET nazev = 'Kochov' WHERE kod = 667765;
UPDATE ruian_katastr SET nazev = 'Kojákovice' WHERE kod = 667773;
UPDATE ruian_katastr SET nazev = 'Kramolín u Kojákovic' WHERE kod = 667781;
UPDATE ruian_katastr SET nazev = 'Lipnice u Kojákovic' WHERE kod = 667790;
UPDATE ruian_katastr SET nazev = 'Kojatice' WHERE kod = 667803;
UPDATE ruian_katastr SET nazev = 'Velký Újezd u Kojatic' WHERE kod = 667811;
UPDATE ruian_katastr SET nazev = 'Kojátky' WHERE kod = 667820;
UPDATE ruian_katastr SET nazev = 'Kojčice' WHERE kod = 667838;
UPDATE ruian_katastr SET nazev = 'Služátky u Pelhřimova' WHERE kod = 667846;
UPDATE ruian_katastr SET nazev = 'Kojetice u Prahy' WHERE kod = 667854;
UPDATE ruian_katastr SET nazev = 'Kojetice na Moravě' WHERE kod = 667862;
UPDATE ruian_katastr SET nazev = 'Kojetín u Havlíčkova Brodu' WHERE kod = 667871;
UPDATE ruian_katastr SET nazev = 'Kojetín u Starého Jičína' WHERE kod = 667889;
UPDATE ruian_katastr SET nazev = 'Kojetín' WHERE kod = 667897;
UPDATE ruian_katastr SET nazev = 'Kojice' WHERE kod = 667901;
UPDATE ruian_katastr SET nazev = 'Kojovice' WHERE kod = 667919;
UPDATE ruian_katastr SET nazev = 'Břetislav' WHERE kod = 667927;
UPDATE ruian_katastr SET nazev = 'Čeliv' WHERE kod = 667935;
UPDATE ruian_katastr SET nazev = 'Kokašice' WHERE kod = 667943;
UPDATE ruian_katastr SET nazev = 'Lomy u Domaslavi' WHERE kod = 667951;
UPDATE ruian_katastr SET nazev = 'Kokonín' WHERE kod = 667960;
UPDATE ruian_katastr SET nazev = 'Kokory' WHERE kod = 667978;
UPDATE ruian_katastr SET nazev = 'Janova Ves' WHERE kod = 667986;
UPDATE ruian_katastr SET nazev = 'Kokořín' WHERE kod = 667994;
UPDATE ruian_katastr SET nazev = 'Kolaje' WHERE kod = 668010;
UPDATE ruian_katastr SET nazev = 'Koldín' WHERE kod = 668036;
UPDATE ruian_katastr SET nazev = 'Koleč' WHERE kod = 668044;
UPDATE ruian_katastr SET nazev = 'Kolesa' WHERE kod = 668079;
UPDATE ruian_katastr SET nazev = 'Bukov u Hořoviček' WHERE kod = 668087;
UPDATE ruian_katastr SET nazev = 'Kolešov' WHERE kod = 668095;
UPDATE ruian_katastr SET nazev = 'Kolešovice' WHERE kod = 668125;
UPDATE ruian_katastr SET nazev = 'Zderaz u Kolešovic' WHERE kod = 668133;
UPDATE ruian_katastr SET nazev = 'Količín' WHERE kod = 668141;
UPDATE ruian_katastr SET nazev = 'Kolín' WHERE kod = 668150;
UPDATE ruian_katastr SET nazev = 'Štítary u Kolína' WHERE kod = 668249;
UPDATE ruian_katastr SET nazev = 'Brod' WHERE kod = 668397;
UPDATE ruian_katastr SET nazev = 'Buršice' WHERE kod = 668401;
UPDATE ruian_katastr SET nazev = 'Kolinec' WHERE kod = 668419;
UPDATE ruian_katastr SET nazev = 'Ujčín' WHERE kod = 668443;
UPDATE ruian_katastr SET nazev = 'Vlčkovice u Kolince' WHERE kod = 668451;
UPDATE ruian_katastr SET nazev = 'Červený Újezdec' WHERE kod = 668460;
UPDATE ruian_katastr SET nazev = 'Kolný' WHERE kod = 668478;
UPDATE ruian_katastr SET nazev = 'Lhotice u Českých Budějovic' WHERE kod = 668486;
UPDATE ruian_katastr SET nazev = 'Velechvín' WHERE kod = 668494;
UPDATE ruian_katastr SET nazev = 'Koloděje' WHERE kod = 668508;
UPDATE ruian_katastr SET nazev = 'Koloděje nad Lužnicí' WHERE kod = 668516;
UPDATE ruian_katastr SET nazev = 'Kolomuty' WHERE kod = 668541;
UPDATE ruian_katastr SET nazev = 'Háje u Karlových Var' WHERE kod = 668559;
UPDATE ruian_katastr SET nazev = 'Kolová' WHERE kod = 668567;
UPDATE ruian_katastr SET nazev = 'Koloveč' WHERE kod = 668575;
UPDATE ruian_katastr SET nazev = 'Zichov' WHERE kod = 668583;
UPDATE ruian_katastr SET nazev = 'Kolovraty' WHERE kod = 668591;
UPDATE ruian_katastr SET nazev = 'Lipany' WHERE kod = 668605;
UPDATE ruian_katastr SET nazev = 'Kolšov' WHERE kod = 668613;
UPDATE ruian_katastr SET nazev = 'Komárno' WHERE kod = 668621;
UPDATE ruian_katastr SET nazev = 'Kleštěnice' WHERE kod = 668630;
UPDATE ruian_katastr SET nazev = 'Komárov u Hořovic' WHERE kod = 668648;
UPDATE ruian_katastr SET nazev = 'Komárov u Soběslavi' WHERE kod = 668664;
UPDATE ruian_katastr SET nazev = 'Komárov u Štědré' WHERE kod = 668672;
UPDATE ruian_katastr SET nazev = 'Smilov u Štědré' WHERE kod = 668681;
UPDATE ruian_katastr SET nazev = 'Komárov u Holic' WHERE kod = 668699;
UPDATE ruian_katastr SET nazev = 'Komárov u Přelouče' WHERE kod = 668702;
UPDATE ruian_katastr SET nazev = 'Komárov u Napajedel' WHERE kod = 668711;
UPDATE ruian_katastr SET nazev = 'Komárovice u Jihlavy' WHERE kod = 668729;
UPDATE ruian_katastr SET nazev = 'Komárovice u Moravských Budějovic' WHERE kod = 668737;
UPDATE ruian_katastr SET nazev = 'Komárovice' WHERE kod = 668745;
UPDATE ruian_katastr SET nazev = 'Komařice' WHERE kod = 668753;
UPDATE ruian_katastr SET nazev = 'Pašinovice' WHERE kod = 668761;
UPDATE ruian_katastr SET nazev = 'Sedlo u Komařic' WHERE kod = 668770;
UPDATE ruian_katastr SET nazev = 'Komňa' WHERE kod = 668800;
UPDATE ruian_katastr SET nazev = 'Komorní Lhotka' WHERE kod = 668818;
UPDATE ruian_katastr SET nazev = 'Komorno' WHERE kod = 668842;
UPDATE ruian_katastr SET nazev = 'Komorovice' WHERE kod = 668851;
UPDATE ruian_katastr SET nazev = 'Vystrkov u Humpolce' WHERE kod = 668869;
UPDATE ruian_katastr SET nazev = 'Ervěnice' WHERE kod = 668885;
UPDATE ruian_katastr SET nazev = 'Komořany u Mostu' WHERE kod = 668893;
UPDATE ruian_katastr SET nazev = 'Komořany na Moravě' WHERE kod = 668907;
UPDATE ruian_katastr SET nazev = 'Podbřežice' WHERE kod = 668915;
UPDATE ruian_katastr SET nazev = 'Komušín' WHERE kod = 668923;
UPDATE ruian_katastr SET nazev = 'Slivonice' WHERE kod = 668931;
UPDATE ruian_katastr SET nazev = 'Konárovice' WHERE kod = 668958;
UPDATE ruian_katastr SET nazev = 'Dub u Kondrace' WHERE kod = 668966;
UPDATE ruian_katastr SET nazev = 'Kondrac' WHERE kod = 668974;
UPDATE ruian_katastr SET nazev = 'Kamenice u Konecchlumí' WHERE kod = 668991;
UPDATE ruian_katastr SET nazev = 'Konecchlumí' WHERE kod = 669008;
UPDATE ruian_katastr SET nazev = 'Kovač' WHERE kod = 669016;
UPDATE ruian_katastr SET nazev = 'Bítov u Koněprus' WHERE kod = 669024;
UPDATE ruian_katastr SET nazev = 'Koněprusy' WHERE kod = 669032;
UPDATE ruian_katastr SET nazev = 'Koněšín' WHERE kod = 669041;
UPDATE ruian_katastr SET nazev = 'Konětopy' WHERE kod = 669059;
UPDATE ruian_katastr SET nazev = 'Konětopy u Příbramě' WHERE kod = 669083;
UPDATE ruian_katastr SET nazev = 'Konice' WHERE kod = 669091;
UPDATE ruian_katastr SET nazev = 'Konice u Znojma' WHERE kod = 669113;
UPDATE ruian_katastr SET nazev = 'Popice u Znojma' WHERE kod = 669121;
UPDATE ruian_katastr SET nazev = 'Bílý Kostelec' WHERE kod = 669148;
UPDATE ruian_katastr SET nazev = 'Dubičná' WHERE kod = 669156;
UPDATE ruian_katastr SET nazev = 'Konojedy u Úštěku' WHERE kod = 669164;
UPDATE ruian_katastr SET nazev = 'Ličenice' WHERE kod = 669172;
UPDATE ruian_katastr SET nazev = 'Konstantinovy Lázně' WHERE kod = 669199;
UPDATE ruian_katastr SET nazev = 'Bor u Kopaniny' WHERE kod = 669202;
UPDATE ruian_katastr SET nazev = 'Kopanina' WHERE kod = 669211;
UPDATE ruian_katastr SET nazev = 'Mlýnek' WHERE kod = 669229;
UPDATE ruian_katastr SET nazev = 'Doubrava u Aše' WHERE kod = 669237;
UPDATE ruian_katastr SET nazev = 'Kopaniny' WHERE kod = 669253;
UPDATE ruian_katastr SET nazev = 'Podhradí u Aše' WHERE kod = 669261;
UPDATE ruian_katastr SET nazev = 'Svatý Kopeček' WHERE kod = 669288;
UPDATE ruian_katastr SET nazev = 'Kopidlno' WHERE kod = 669296;
UPDATE ruian_katastr SET nazev = 'Kopidlo' WHERE kod = 669318;
UPDATE ruian_katastr SET nazev = 'Konobrže' WHERE kod = 669326;
UPDATE ruian_katastr SET nazev = 'Kopisty' WHERE kod = 669334;
UPDATE ruian_katastr SET nazev = 'Pařidla' WHERE kod = 669342;
UPDATE ruian_katastr SET nazev = 'Koprník' WHERE kod = 669351;
UPDATE ruian_katastr SET nazev = 'Násedlnice' WHERE kod = 669369;
UPDATE ruian_katastr SET nazev = 'Kopřivná' WHERE kod = 669377;
UPDATE ruian_katastr SET nazev = 'Lužná u Hanušovic' WHERE kod = 669385;
UPDATE ruian_katastr SET nazev = 'Kopřivnice' WHERE kod = 669393;
UPDATE ruian_katastr SET nazev = 'Horky u Dubé' WHERE kod = 669482;
UPDATE ruian_katastr SET nazev = 'Korce' WHERE kod = 669491;
UPDATE ruian_katastr SET nazev = 'Korkyně' WHERE kod = 669512;
UPDATE ruian_katastr SET nazev = 'Kornice' WHERE kod = 669521;
UPDATE ruian_katastr SET nazev = 'Korolupy' WHERE kod = 669539;
UPDATE ruian_katastr SET nazev = 'Korouhev' WHERE kod = 669555;
UPDATE ruian_katastr SET nazev = 'Lačnov u Korouhve' WHERE kod = 669563;
UPDATE ruian_katastr SET nazev = 'Kobylnice nad Svratkou' WHERE kod = 669580;
UPDATE ruian_katastr SET nazev = 'Koroužné' WHERE kod = 669598;
UPDATE ruian_katastr SET nazev = 'Švařec' WHERE kod = 669601;
UPDATE ruian_katastr SET nazev = 'Korozluky' WHERE kod = 669610;
UPDATE ruian_katastr SET nazev = 'Sedlec u Obrnic' WHERE kod = 669628;
UPDATE ruian_katastr SET nazev = 'Koruna' WHERE kod = 669636;
UPDATE ruian_katastr SET nazev = 'Korycany' WHERE kod = 669644;
UPDATE ruian_katastr SET nazev = 'Blišice' WHERE kod = 669652;
UPDATE ruian_katastr SET nazev = 'Koryčany' WHERE kod = 669661;
UPDATE ruian_katastr SET nazev = 'Koryta u Mnichova Hradiště' WHERE kod = 669679;
UPDATE ruian_katastr SET nazev = 'Koryta' WHERE kod = 669687;
UPDATE ruian_katastr SET nazev = 'Korytná' WHERE kod = 669695;
UPDATE ruian_katastr SET nazev = 'Kořenec' WHERE kod = 669709;
UPDATE ruian_katastr SET nazev = 'Chotouchov' WHERE kod = 669717;
UPDATE ruian_katastr SET nazev = 'Kořenice' WHERE kod = 669725;
UPDATE ruian_katastr SET nazev = 'Pučery' WHERE kod = 669733;
UPDATE ruian_katastr SET nazev = 'Polubný' WHERE kod = 669750;
UPDATE ruian_katastr SET nazev = 'Jizerka' WHERE kod = 669768;
UPDATE ruian_katastr SET nazev = 'Příchovice u Kořenova' WHERE kod = 669792;
UPDATE ruian_katastr SET nazev = 'Rejdice' WHERE kod = 669806;
UPDATE ruian_katastr SET nazev = 'Kosice' WHERE kod = 669831;
UPDATE ruian_katastr SET nazev = 'Kosičky' WHERE kod = 669849;
UPDATE ruian_katastr SET nazev = 'Kosmonosy' WHERE kod = 669857;
UPDATE ruian_katastr SET nazev = 'Kosmová' WHERE kod = 669946;
UPDATE ruian_katastr SET nazev = 'Kosobudy' WHERE kod = 669954;
UPDATE ruian_katastr SET nazev = 'Zadní Chlum' WHERE kod = 669962;
UPDATE ruian_katastr SET nazev = 'Kosoř' WHERE kod = 669971;
UPDATE ruian_katastr SET nazev = 'Kosořice' WHERE kod = 669989;
UPDATE ruian_katastr SET nazev = 'Kosov' WHERE kod = 669997;
UPDATE ruian_katastr SET nazev = 'Janov u Kosovy Hory' WHERE kod = 670006;
UPDATE ruian_katastr SET nazev = 'Kosova Hora' WHERE kod = 670014;
UPDATE ruian_katastr SET nazev = 'Kostelany nad Moravou' WHERE kod = 670031;
UPDATE ruian_katastr SET nazev = 'Hroznějovice' WHERE kod = 670049;
UPDATE ruian_katastr SET nazev = 'Jaroslavice u Kostelce' WHERE kod = 670057;
UPDATE ruian_katastr SET nazev = 'Kostelec' WHERE kod = 670065;
UPDATE ruian_katastr SET nazev = 'Líšnice u Kostelce' WHERE kod = 670073;
UPDATE ruian_katastr SET nazev = 'Poněšice' WHERE kod = 670081;
UPDATE ruian_katastr SET nazev = 'Kostelec u Stříbra' WHERE kod = 670090;
UPDATE ruian_katastr SET nazev = 'Lšelín' WHERE kod = 670103;
UPDATE ruian_katastr SET nazev = 'Nedražice' WHERE kod = 670111;
UPDATE ruian_katastr SET nazev = 'Kostelec u Jihlavy' WHERE kod = 670120;
UPDATE ruian_katastr SET nazev = 'Kostelec u Zlína' WHERE kod = 670138;
UPDATE ruian_katastr SET nazev = 'Štípa' WHERE kod = 670146;
UPDATE ruian_katastr SET nazev = 'Kostelec na Hané' WHERE kod = 670154;
UPDATE ruian_katastr SET nazev = 'Kostelec nad Černými lesy' WHERE kod = 670162;
UPDATE ruian_katastr SET nazev = 'Kostelec nad Labem' WHERE kod = 670171;
UPDATE ruian_katastr SET nazev = 'Rudeč' WHERE kod = 670189;
UPDATE ruian_katastr SET nazev = 'Kostelec nad Orlicí' WHERE kod = 670197;
UPDATE ruian_katastr SET nazev = 'Kostelec nad Vltavou' WHERE kod = 670201;
UPDATE ruian_katastr SET nazev = 'Přílepov' WHERE kod = 670227;
UPDATE ruian_katastr SET nazev = 'Sobědraž' WHERE kod = 670235;
UPDATE ruian_katastr SET nazev = 'Vesec' WHERE kod = 670243;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Kovářova' WHERE kod = 670251;
UPDATE ruian_katastr SET nazev = 'Kostelec u Heřmanova Městce' WHERE kod = 670260;
UPDATE ruian_katastr SET nazev = 'Karlovice u Holešova' WHERE kod = 670286;
UPDATE ruian_katastr SET nazev = 'Kostelec u Holešova' WHERE kod = 670294;
UPDATE ruian_katastr SET nazev = 'Kostelec u Křížků' WHERE kod = 670308;
UPDATE ruian_katastr SET nazev = 'Kostelec u Kyjova' WHERE kod = 670316;
UPDATE ruian_katastr SET nazev = 'Kostelecká Lhota' WHERE kod = 670332;
UPDATE ruian_katastr SET nazev = 'Kostelecké Horky' WHERE kod = 670359;
UPDATE ruian_katastr SET nazev = 'Černá u Kraslic' WHERE kod = 670367;
UPDATE ruian_katastr SET nazev = 'Čirá' WHERE kod = 670375;
UPDATE ruian_katastr SET nazev = 'Kámen u Kraslic' WHERE kod = 670383;
UPDATE ruian_katastr SET nazev = 'Kostelní' WHERE kod = 670391;
UPDATE ruian_katastr SET nazev = 'Počátky u Kraslic' WHERE kod = 670405;
UPDATE ruian_katastr SET nazev = 'Valtéřov u Kraslic' WHERE kod = 670413;
UPDATE ruian_katastr SET nazev = 'Arnoltov' WHERE kod = 670421;
UPDATE ruian_katastr SET nazev = 'Kostelní Bříza' WHERE kod = 670430;
UPDATE ruian_katastr SET nazev = 'Rudolec u Březové' WHERE kod = 670448;
UPDATE ruian_katastr SET nazev = 'Bystřina' WHERE kod = 670456;
UPDATE ruian_katastr SET nazev = 'Krásná Lípa u Březové' WHERE kod = 670464;
UPDATE ruian_katastr SET nazev = 'Ostrov u Březové' WHERE kod = 670472;
UPDATE ruian_katastr SET nazev = 'Smrkovec u Březové' WHERE kod = 670481;
UPDATE ruian_katastr SET nazev = 'Studánka u Březové' WHERE kod = 670499;
UPDATE ruian_katastr SET nazev = 'Žitná u Březové' WHERE kod = 670502;
UPDATE ruian_katastr SET nazev = 'Kostelní Hlavno' WHERE kod = 670511;
UPDATE ruian_katastr SET nazev = 'Kostelní Lhota' WHERE kod = 670529;
UPDATE ruian_katastr SET nazev = 'Kostelní Myslová' WHERE kod = 670537;
UPDATE ruian_katastr SET nazev = 'Kostelní Radouň' WHERE kod = 670545;
UPDATE ruian_katastr SET nazev = 'Kostelní Vydří' WHERE kod = 670553;
UPDATE ruian_katastr SET nazev = 'Prostřední Vydří' WHERE kod = 670561;
UPDATE ruian_katastr SET nazev = 'Kostěnice' WHERE kod = 670570;
UPDATE ruian_katastr SET nazev = 'Kostice' WHERE kod = 670588;
UPDATE ruian_katastr SET nazev = 'Kostníky' WHERE kod = 670596;
UPDATE ruian_katastr SET nazev = 'Kostomlátky' WHERE kod = 670600;
UPDATE ruian_katastr SET nazev = 'Doubrava u Kostomlat nad Labem' WHERE kod = 670618;
UPDATE ruian_katastr SET nazev = 'Kostomlaty nad Labem' WHERE kod = 670626;
UPDATE ruian_katastr SET nazev = 'Lány u Kostomlat nad Labem' WHERE kod = 670634;
UPDATE ruian_katastr SET nazev = 'Kostomlaty pod Milešovkou' WHERE kod = 670669;
UPDATE ruian_katastr SET nazev = 'Kostomlaty pod Řípem' WHERE kod = 670677;
UPDATE ruian_katastr SET nazev = 'Kostrčany' WHERE kod = 670685;
UPDATE ruian_katastr SET nazev = 'Nahořečice' WHERE kod = 670693;
UPDATE ruian_katastr SET nazev = 'Košařiska' WHERE kod = 670707;
UPDATE ruian_katastr SET nazev = 'Košatka nad Odrou' WHERE kod = 670723;
UPDATE ruian_katastr SET nazev = 'Košátky' WHERE kod = 670740;
UPDATE ruian_katastr SET nazev = 'Košetice' WHERE kod = 670758;
UPDATE ruian_katastr SET nazev = 'Košetice ve Slezsku' WHERE kod = 670782;
UPDATE ruian_katastr SET nazev = 'Doubí nad Lužnicí' WHERE kod = 670804;
UPDATE ruian_katastr SET nazev = 'Košice u Soběslavi' WHERE kod = 670812;
UPDATE ruian_katastr SET nazev = 'Doubravany' WHERE kod = 670821;
UPDATE ruian_katastr SET nazev = 'Košík' WHERE kod = 670839;
UPDATE ruian_katastr SET nazev = 'Seletice' WHERE kod = 670855;
UPDATE ruian_katastr SET nazev = 'Sovolusky u Košíku' WHERE kod = 670863;
UPDATE ruian_katastr SET nazev = 'Tuchom' WHERE kod = 670871;
UPDATE ruian_katastr SET nazev = 'Košíky' WHERE kod = 670880;
UPDATE ruian_katastr SET nazev = 'Košín' WHERE kod = 670910;
UPDATE ruian_katastr SET nazev = 'Čikvásky' WHERE kod = 670928;
UPDATE ruian_katastr SET nazev = 'Košťálov' WHERE kod = 670936;
UPDATE ruian_katastr SET nazev = 'Košťany' WHERE kod = 670961;
UPDATE ruian_katastr SET nazev = 'Střelná' WHERE kod = 670979;
UPDATE ruian_katastr SET nazev = 'Koštice' WHERE kod = 670987;
UPDATE ruian_katastr SET nazev = 'Vojnice u Koštic' WHERE kod = 670995;
UPDATE ruian_katastr SET nazev = 'Vojničky' WHERE kod = 671002;
UPDATE ruian_katastr SET nazev = 'Želevice' WHERE kod = 671011;
UPDATE ruian_katastr SET nazev = 'Koštov' WHERE kod = 671029;
UPDATE ruian_katastr SET nazev = 'Kotenčice' WHERE kod = 671045;
UPDATE ruian_katastr SET nazev = 'Koterov' WHERE kod = 671053;
UPDATE ruian_katastr SET nazev = 'Kotlasy' WHERE kod = 671061;
UPDATE ruian_katastr SET nazev = 'Kotopeky' WHERE kod = 671070;
UPDATE ruian_katastr SET nazev = 'Hoříkovice u Chotěšova' WHERE kod = 671088;
UPDATE ruian_katastr SET nazev = 'Kotovice' WHERE kod = 671096;
UPDATE ruian_katastr SET nazev = 'Záluží' WHERE kod = 671118;
UPDATE ruian_katastr SET nazev = 'Kotvrdovice' WHERE kod = 671126;
UPDATE ruian_katastr SET nazev = 'Koubalova Lhota' WHERE kod = 671134;
UPDATE ruian_katastr SET nazev = 'Kounice' WHERE kod = 671142;
UPDATE ruian_katastr SET nazev = 'Kounov u Rakovníka' WHERE kod = 671151;
UPDATE ruian_katastr SET nazev = 'Kounov u Dobrušky' WHERE kod = 671177;
UPDATE ruian_katastr SET nazev = 'Nedvězí u Dobrušky' WHERE kod = 671185;
UPDATE ruian_katastr SET nazev = 'Šediviny' WHERE kod = 671193;
UPDATE ruian_katastr SET nazev = 'Koupě' WHERE kod = 671207;
UPDATE ruian_katastr SET nazev = 'Kouřim' WHERE kod = 671215;
UPDATE ruian_katastr SET nazev = 'Kout na Šumavě' WHERE kod = 671231;
UPDATE ruian_katastr SET nazev = 'Kouty u Poděbrad' WHERE kod = 671266;
UPDATE ruian_katastr SET nazev = 'Kouty u Třebíče' WHERE kod = 671274;
UPDATE ruian_katastr SET nazev = 'Kovalovice' WHERE kod = 671282;
UPDATE ruian_katastr SET nazev = 'Koválovice u Tištína' WHERE kod = 671291;
UPDATE ruian_katastr SET nazev = 'Osíčany' WHERE kod = 671304;
UPDATE ruian_katastr SET nazev = 'Kovalovice u Kojetína' WHERE kod = 671312;
UPDATE ruian_katastr SET nazev = 'Kovanec' WHERE kod = 671321;
UPDATE ruian_katastr SET nazev = 'Chvalovice u Nymburka' WHERE kod = 671339;
UPDATE ruian_katastr SET nazev = 'Kovanice' WHERE kod = 671347;
UPDATE ruian_katastr SET nazev = 'Kovansko' WHERE kod = 671355;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Kovářova' WHERE kod = 671363;
UPDATE ruian_katastr SET nazev = 'Kovářov' WHERE kod = 671380;
UPDATE ruian_katastr SET nazev = 'Březí u Kovářova' WHERE kod = 671398;
UPDATE ruian_katastr SET nazev = 'Radvánov' WHERE kod = 671401;
UPDATE ruian_katastr SET nazev = 'Vepice' WHERE kod = 671428;
UPDATE ruian_katastr SET nazev = 'Vladyčín' WHERE kod = 671436;
UPDATE ruian_katastr SET nazev = 'Hrbokov' WHERE kod = 671461;
UPDATE ruian_katastr SET nazev = 'Kovářov u Seče' WHERE kod = 671479;
UPDATE ruian_katastr SET nazev = 'Kovářov u Bouzova' WHERE kod = 671487;
UPDATE ruian_katastr SET nazev = 'Kovářov u Potštátu' WHERE kod = 671495;
UPDATE ruian_katastr SET nazev = 'Kovářská' WHERE kod = 671509;
UPDATE ruian_katastr SET nazev = 'Kozárov' WHERE kod = 671517;
UPDATE ruian_katastr SET nazev = 'Kozárovice' WHERE kod = 671525;
UPDATE ruian_katastr SET nazev = 'Vystrkov' WHERE kod = 671533;
UPDATE ruian_katastr SET nazev = 'Kovčín' WHERE kod = 671541;
UPDATE ruian_katastr SET nazev = 'Milčice' WHERE kod = 671550;
UPDATE ruian_katastr SET nazev = 'Kozičín' WHERE kod = 671576;
UPDATE ruian_katastr SET nazev = 'Lazec' WHERE kod = 671584;
UPDATE ruian_katastr SET nazev = 'Kozlany' WHERE kod = 671592;
UPDATE ruian_katastr SET nazev = 'Kozlany u Vyškova' WHERE kod = 671606;
UPDATE ruian_katastr SET nazev = 'Kozlov nad Otavou' WHERE kod = 671614;
UPDATE ruian_katastr SET nazev = 'Kozlov' WHERE kod = 671622;
UPDATE ruian_katastr SET nazev = 'Mirotice u Kozlova' WHERE kod = 671631;
UPDATE ruian_katastr SET nazev = 'Pávice' WHERE kod = 671649;
UPDATE ruian_katastr SET nazev = 'Pěčkovice' WHERE kod = 671657;
UPDATE ruian_katastr SET nazev = 'Kozlov u Ledče nad Sázavou' WHERE kod = 671665;
UPDATE ruian_katastr SET nazev = 'Leština u Ledče nad Sázavou' WHERE kod = 671673;
UPDATE ruian_katastr SET nazev = 'Olešná u Ledče nad Sázavou' WHERE kod = 671681;
UPDATE ruian_katastr SET nazev = 'Kozlov u České Třebové' WHERE kod = 671690;
UPDATE ruian_katastr SET nazev = 'Svinná u České Třebové' WHERE kod = 671703;
UPDATE ruian_katastr SET nazev = 'Kozlov u Jihlavy' WHERE kod = 671711;
UPDATE ruian_katastr SET nazev = 'Rytířsko' WHERE kod = 671720;
UPDATE ruian_katastr SET nazev = 'Kozlov u Křižanova' WHERE kod = 671738;
UPDATE ruian_katastr SET nazev = 'Kozlovice u Nepomuka' WHERE kod = 671746;
UPDATE ruian_katastr SET nazev = 'Kozlovice' WHERE kod = 671771;
UPDATE ruian_katastr SET nazev = 'Měrkovice' WHERE kod = 671789;
UPDATE ruian_katastr SET nazev = 'Kozly u České Lípy' WHERE kod = 671819;
UPDATE ruian_katastr SET nazev = 'Kozly u Loun' WHERE kod = 671827;
UPDATE ruian_katastr SET nazev = 'Sinutec' WHERE kod = 671835;
UPDATE ruian_katastr SET nazev = 'Kozmice u Benešova' WHERE kod = 671851;
UPDATE ruian_katastr SET nazev = 'Kozmice' WHERE kod = 671878;
UPDATE ruian_katastr SET nazev = 'Kozojedy u Kostelce nad Černými Lesy' WHERE kod = 671886;
UPDATE ruian_katastr SET nazev = 'Kozojedy' WHERE kod = 671894;
UPDATE ruian_katastr SET nazev = 'Bohy' WHERE kod = 671908;
UPDATE ruian_katastr SET nazev = 'Borek u Kozojed' WHERE kod = 671916;
UPDATE ruian_katastr SET nazev = 'Brodeslavy' WHERE kod = 671924;
UPDATE ruian_katastr SET nazev = 'Kozojedy u Kralovic' WHERE kod = 671932;
UPDATE ruian_katastr SET nazev = 'Rakolusky' WHERE kod = 671941;
UPDATE ruian_katastr SET nazev = 'Kozojídky' WHERE kod = 671959;
UPDATE ruian_katastr SET nazev = 'Kozolupy' WHERE kod = 671967;
UPDATE ruian_katastr SET nazev = 'Bdeněves' WHERE kod = 671975;
UPDATE ruian_katastr SET nazev = 'Kozolupy u Plzně' WHERE kod = 671983;
UPDATE ruian_katastr SET nazev = 'Myslinka' WHERE kod = 671991;
UPDATE ruian_katastr SET nazev = 'Kozomín' WHERE kod = 672009;
UPDATE ruian_katastr SET nazev = 'Blažov' WHERE kod = 672017;
UPDATE ruian_katastr SET nazev = 'Kadeřín' WHERE kod = 672025;
UPDATE ruian_katastr SET nazev = 'Kozov' WHERE kod = 672033;
UPDATE ruian_katastr SET nazev = 'Svojanov u Bouzova' WHERE kod = 672041;
UPDATE ruian_katastr SET nazev = 'Kožichovice' WHERE kod = 672050;
UPDATE ruian_katastr SET nazev = 'Kožlany' WHERE kod = 672068;
UPDATE ruian_katastr SET nazev = 'Bohumilice u Kožlí' WHERE kod = 672076;
UPDATE ruian_katastr SET nazev = 'Kožlí' WHERE kod = 672084;
UPDATE ruian_katastr SET nazev = 'Sechov' WHERE kod = 672092;
UPDATE ruian_katastr SET nazev = 'Kožušany' WHERE kod = 672106;
UPDATE ruian_katastr SET nazev = 'Tážaly' WHERE kod = 672114;
UPDATE ruian_katastr SET nazev = 'Kožušice' WHERE kod = 672122;
UPDATE ruian_katastr SET nazev = 'Krabčice u Roudnice nad Labem' WHERE kod = 672131;
UPDATE ruian_katastr SET nazev = 'Rovné pod Řípem' WHERE kod = 672149;
UPDATE ruian_katastr SET nazev = 'Vesce pod Řípem' WHERE kod = 672157;
UPDATE ruian_katastr SET nazev = 'Dálčice' WHERE kod = 672165;
UPDATE ruian_katastr SET nazev = 'Kraborovice' WHERE kod = 672181;
UPDATE ruian_katastr SET nazev = 'Úhrov' WHERE kod = 672190;
UPDATE ruian_katastr SET nazev = 'Krahulčí u Telče' WHERE kod = 672203;
UPDATE ruian_katastr SET nazev = 'Krahulčí' WHERE kod = 672211;
UPDATE ruian_katastr SET nazev = 'Krahulov' WHERE kod = 672220;
UPDATE ruian_katastr SET nazev = 'Dolina u Krajkové' WHERE kod = 672246;
UPDATE ruian_katastr SET nazev = 'Hrádek u Krajkové' WHERE kod = 672254;
UPDATE ruian_katastr SET nazev = 'Krajková' WHERE kod = 672262;
UPDATE ruian_katastr SET nazev = 'Květná u Krajkové' WHERE kod = 672271;
UPDATE ruian_katastr SET nazev = 'Leopoldovy Hamry' WHERE kod = 672289;
UPDATE ruian_katastr SET nazev = 'Libnov' WHERE kod = 672297;
UPDATE ruian_katastr SET nazev = 'Markvarec u Krajkové' WHERE kod = 672301;
UPDATE ruian_katastr SET nazev = 'Krajníčko' WHERE kod = 672319;
UPDATE ruian_katastr SET nazev = 'Útěšov' WHERE kod = 672327;
UPDATE ruian_katastr SET nazev = 'Krakov' WHERE kod = 672335;
UPDATE ruian_katastr SET nazev = 'Božec' WHERE kod = 672343;
UPDATE ruian_katastr SET nazev = 'Krakovany' WHERE kod = 672351;
UPDATE ruian_katastr SET nazev = 'Krakovec u Rakovníka' WHERE kod = 672360;
UPDATE ruian_katastr SET nazev = 'Kralice' WHERE kod = 672386;
UPDATE ruian_katastr SET nazev = 'Vernýřov' WHERE kod = 672416;
UPDATE ruian_katastr SET nazev = 'Všesoky' WHERE kod = 672424;
UPDATE ruian_katastr SET nazev = 'Žandov' WHERE kod = 672432;
UPDATE ruian_katastr SET nazev = 'Kralice na Hané' WHERE kod = 672441;
UPDATE ruian_katastr SET nazev = 'Vitonice na Hané' WHERE kod = 672467;
UPDATE ruian_katastr SET nazev = 'Horní Lhotice' WHERE kod = 672475;
UPDATE ruian_katastr SET nazev = 'Kralice nad Oslavou' WHERE kod = 672483;
UPDATE ruian_katastr SET nazev = 'Chmelovice' WHERE kod = 672491;
UPDATE ruian_katastr SET nazev = 'Králíky u Nového Bydžova' WHERE kod = 672505;
UPDATE ruian_katastr SET nazev = 'Podoliby' WHERE kod = 672513;
UPDATE ruian_katastr SET nazev = 'Červený Potok' WHERE kod = 672530;
UPDATE ruian_katastr SET nazev = 'Dolní Hedeč' WHERE kod = 672548;
UPDATE ruian_katastr SET nazev = 'Králíky' WHERE kod = 672556;
UPDATE ruian_katastr SET nazev = 'Hlivice' WHERE kod = 672564;
UPDATE ruian_katastr SET nazev = 'Králová' WHERE kod = 672572;
UPDATE ruian_katastr SET nazev = 'Králova Lhota' WHERE kod = 672581;
UPDATE ruian_katastr SET nazev = 'Laziště' WHERE kod = 672599;
UPDATE ruian_katastr SET nazev = 'Probulov' WHERE kod = 672602;
UPDATE ruian_katastr SET nazev = 'Králova Lhota u Českého Meziříčí' WHERE kod = 672611;
UPDATE ruian_katastr SET nazev = 'Královice' WHERE kod = 672629;
UPDATE ruian_katastr SET nazev = 'Kralovice' WHERE kod = 672637;
UPDATE ruian_katastr SET nazev = 'Kralovice u Rakovníka' WHERE kod = 672645;
UPDATE ruian_katastr SET nazev = 'Královské Poříčí' WHERE kod = 672688;
UPDATE ruian_katastr SET nazev = 'Království' WHERE kod = 672696;
UPDATE ruian_katastr SET nazev = 'Fukov' WHERE kod = 672700;
UPDATE ruian_katastr SET nazev = 'Kralupy nad Vltavou' WHERE kod = 672718;
UPDATE ruian_katastr SET nazev = 'Mikovice u Kralup nad Vltavou' WHERE kod = 672742;
UPDATE ruian_katastr SET nazev = 'Minice u Kralup nad Vltavou' WHERE kod = 672751;
UPDATE ruian_katastr SET nazev = 'Lobeček' WHERE kod = 672866;
UPDATE ruian_katastr SET nazev = 'Lobeč' WHERE kod = 672912;
UPDATE ruian_katastr SET nazev = 'Kralupy u Chomutova' WHERE kod = 672921;
UPDATE ruian_katastr SET nazev = 'Králův Dvůr' WHERE kod = 672947;
UPDATE ruian_katastr SET nazev = 'Popovice u Králova Dvora' WHERE kod = 672963;
UPDATE ruian_katastr SET nazev = 'Počaply' WHERE kod = 672971;
UPDATE ruian_katastr SET nazev = 'Kramolín u Nepomuka' WHERE kod = 673099;
UPDATE ruian_katastr SET nazev = 'Kramolín' WHERE kod = 673102;
UPDATE ruian_katastr SET nazev = 'Krasejovka' WHERE kod = 673111;
UPDATE ruian_katastr SET nazev = 'Otmanka' WHERE kod = 673137;
UPDATE ruian_katastr SET nazev = 'Kraselov' WHERE kod = 673145;
UPDATE ruian_katastr SET nazev = 'Mladotice u Kraselova' WHERE kod = 673170;
UPDATE ruian_katastr SET nazev = 'Krásensko' WHERE kod = 673188;
UPDATE ruian_katastr SET nazev = 'Podomí' WHERE kod = 673196;
UPDATE ruian_katastr SET nazev = 'Krasíkov' WHERE kod = 673200;
UPDATE ruian_katastr SET nazev = 'Krasíkovice' WHERE kod = 673218;
UPDATE ruian_katastr SET nazev = 'Pobistrýce' WHERE kod = 673226;
UPDATE ruian_katastr SET nazev = 'Radětín' WHERE kod = 673234;
UPDATE ruian_katastr SET nazev = 'Kraskov' WHERE kod = 673242;
UPDATE ruian_katastr SET nazev = 'Tisová u Kraslic' WHERE kod = 673251;
UPDATE ruian_katastr SET nazev = 'Zelená Hora u Kraslic' WHERE kod = 673269;
UPDATE ruian_katastr SET nazev = 'Kraslice' WHERE kod = 673293;
UPDATE ruian_katastr SET nazev = 'Hraničná' WHERE kod = 673323;
UPDATE ruian_katastr SET nazev = 'Krásná u Kraslic' WHERE kod = 673331;
UPDATE ruian_katastr SET nazev = 'Krásná' WHERE kod = 673358;
UPDATE ruian_katastr SET nazev = 'Štítary u Krásné' WHERE kod = 673366;
UPDATE ruian_katastr SET nazev = 'Újezd u Krásné' WHERE kod = 673374;
UPDATE ruian_katastr SET nazev = 'Krásná pod Lysou Horou' WHERE kod = 673391;
UPDATE ruian_katastr SET nazev = 'Bratroňov' WHERE kod = 673447;
UPDATE ruian_katastr SET nazev = 'Čekánov' WHERE kod = 673455;
UPDATE ruian_katastr SET nazev = 'Kojkovice' WHERE kod = 673463;
UPDATE ruian_katastr SET nazev = 'Kojkovičky' WHERE kod = 673471;
UPDATE ruian_katastr SET nazev = 'Krásná Hora' WHERE kod = 673480;
UPDATE ruian_katastr SET nazev = 'Mozolov u Krásné Hory' WHERE kod = 673498;
UPDATE ruian_katastr SET nazev = 'Volichov' WHERE kod = 673501;
UPDATE ruian_katastr SET nazev = 'Krásná Hora nad Vltavou' WHERE kod = 673528;
UPDATE ruian_katastr SET nazev = 'Plešiště' WHERE kod = 673536;
UPDATE ruian_katastr SET nazev = 'Švastalova Lhota' WHERE kod = 673544;
UPDATE ruian_katastr SET nazev = 'Tisovnice' WHERE kod = 673552;
UPDATE ruian_katastr SET nazev = 'Vletice' WHERE kod = 673561;
UPDATE ruian_katastr SET nazev = 'Zhoř nad Vltavou' WHERE kod = 673579;
UPDATE ruian_katastr SET nazev = 'Krásná Lípa' WHERE kod = 673617;
UPDATE ruian_katastr SET nazev = 'Krásný Buk' WHERE kod = 673625;
UPDATE ruian_katastr SET nazev = 'Kyjov u Krásné Lípy' WHERE kod = 673633;
UPDATE ruian_katastr SET nazev = 'Krásná Studánka' WHERE kod = 673641;
UPDATE ruian_katastr SET nazev = 'Radčice u Krásné Studánky' WHERE kod = 673650;
UPDATE ruian_katastr SET nazev = 'Kováň' WHERE kod = 673668;
UPDATE ruian_katastr SET nazev = 'Krásná Ves' WHERE kod = 673676;
UPDATE ruian_katastr SET nazev = 'Krásné' WHERE kod = 673692;
UPDATE ruian_katastr SET nazev = 'Polánka' WHERE kod = 673706;
UPDATE ruian_katastr SET nazev = 'Krásné nad Svratkou' WHERE kod = 673714;
UPDATE ruian_katastr SET nazev = 'Krásné Pole' WHERE kod = 673722;
UPDATE ruian_katastr SET nazev = 'Český Chloumek' WHERE kod = 673731;
UPDATE ruian_katastr SET nazev = 'Krásné Údolí' WHERE kod = 673749;
UPDATE ruian_katastr SET nazev = 'Odolenovice' WHERE kod = 673757;
UPDATE ruian_katastr SET nazev = 'Přílezy' WHERE kod = 673765;
UPDATE ruian_katastr SET nazev = 'Krásněves' WHERE kod = 673773;
UPDATE ruian_katastr SET nazev = 'Dolní Hluboká' WHERE kod = 673781;
UPDATE ruian_katastr SET nazev = 'Háje nad Teplou' WHERE kod = 673790;
UPDATE ruian_katastr SET nazev = 'Krásno nad Teplou' WHERE kod = 673811;
UPDATE ruian_katastr SET nazev = 'Milešov' WHERE kod = 673820;
UPDATE ruian_katastr SET nazev = 'Krásný Dvůr' WHERE kod = 673862;
UPDATE ruian_katastr SET nazev = 'Damice' WHERE kod = 673901;
UPDATE ruian_katastr SET nazev = 'Krásný Les' WHERE kod = 673927;
UPDATE ruian_katastr SET nazev = 'Léno' WHERE kod = 673935;
UPDATE ruian_katastr SET nazev = 'Plavno' WHERE kod = 673943;
UPDATE ruian_katastr SET nazev = 'Vrch' WHERE kod = 673951;
UPDATE ruian_katastr SET nazev = 'Krásný Les u Frýdlantu' WHERE kod = 673960;
UPDATE ruian_katastr SET nazev = 'Větrov u Krásného Lesa' WHERE kod = 673978;
UPDATE ruian_katastr SET nazev = 'Krásný Les v Krušných horách' WHERE kod = 673986;
UPDATE ruian_katastr SET nazev = 'Nakléřov' WHERE kod = 673994;
UPDATE ruian_katastr SET nazev = 'Krásný Studenec' WHERE kod = 674001;
UPDATE ruian_katastr SET nazev = 'Krasonice' WHERE kod = 674010;
UPDATE ruian_katastr SET nazev = 'Krasoňov' WHERE kod = 674028;
UPDATE ruian_katastr SET nazev = 'Krasov' WHERE kod = 674036;
UPDATE ruian_katastr SET nazev = 'Krasová' WHERE kod = 674044;
UPDATE ruian_katastr SET nazev = 'Krašlovice' WHERE kod = 674052;
UPDATE ruian_katastr SET nazev = 'Lidmovice' WHERE kod = 674061;
UPDATE ruian_katastr SET nazev = 'Vitice u Vodňan' WHERE kod = 674079;
UPDATE ruian_katastr SET nazev = 'Krašovice' WHERE kod = 674087;
UPDATE ruian_katastr SET nazev = 'Mokřice' WHERE kod = 674095;
UPDATE ruian_katastr SET nazev = 'Krašovice u Plzně' WHERE kod = 674117;
UPDATE ruian_katastr SET nazev = 'Krátká Ves' WHERE kod = 674125;
UPDATE ruian_katastr SET nazev = 'Kratochvilka' WHERE kod = 674133;
UPDATE ruian_katastr SET nazev = 'Kratonohy' WHERE kod = 674141;
UPDATE ruian_katastr SET nazev = 'Michnovka' WHERE kod = 674150;
UPDATE ruian_katastr SET nazev = 'Obědovice' WHERE kod = 674168;
UPDATE ruian_katastr SET nazev = 'Krátošice' WHERE kod = 674176;
UPDATE ruian_katastr SET nazev = 'Kravaře v Čechách' WHERE kod = 674184;
UPDATE ruian_katastr SET nazev = 'Rané' WHERE kod = 674192;
UPDATE ruian_katastr SET nazev = 'Kravaře ve Slezsku' WHERE kod = 674231;
UPDATE ruian_katastr SET nazev = 'Kravsko' WHERE kod = 674257;
UPDATE ruian_katastr SET nazev = 'Plenkovice' WHERE kod = 674265;
UPDATE ruian_katastr SET nazev = 'Krbice' WHERE kod = 674273;
UPDATE ruian_katastr SET nazev = 'Krč u Protivína' WHERE kod = 674303;
UPDATE ruian_katastr SET nazev = 'Těšínov u Protivína' WHERE kod = 674311;
UPDATE ruian_katastr SET nazev = 'Záboří u Protivína' WHERE kod = 674320;
UPDATE ruian_katastr SET nazev = 'Krčmaň' WHERE kod = 674338;
UPDATE ruian_katastr SET nazev = 'Krejnice' WHERE kod = 674346;
UPDATE ruian_katastr SET nazev = 'Vojnice' WHERE kod = 674354;
UPDATE ruian_katastr SET nazev = 'Krhanice' WHERE kod = 674362;
UPDATE ruian_katastr SET nazev = 'Krhov' WHERE kod = 674389;
UPDATE ruian_katastr SET nazev = 'Krhov u Hrotovic' WHERE kod = 674397;
UPDATE ruian_katastr SET nazev = 'Krhov u Bojkovic' WHERE kod = 674401;
UPDATE ruian_katastr SET nazev = 'Krhovice' WHERE kod = 674419;
UPDATE ruian_katastr SET nazev = 'Krchleby' WHERE kod = 674427;
UPDATE ruian_katastr SET nazev = 'Chedrbí' WHERE kod = 674435;
UPDATE ruian_katastr SET nazev = 'Krchleby u Čáslavi' WHERE kod = 674443;
UPDATE ruian_katastr SET nazev = 'Močovice' WHERE kod = 674451;
UPDATE ruian_katastr SET nazev = 'Vodranty' WHERE kod = 674460;
UPDATE ruian_katastr SET nazev = 'Krchleby u Nymburka' WHERE kod = 674478;
UPDATE ruian_katastr SET nazev = 'Dolní Bušínov' WHERE kod = 674486;
UPDATE ruian_katastr SET nazev = 'Krchleby na Moravě' WHERE kod = 674494;
UPDATE ruian_katastr SET nazev = 'Krmelín' WHERE kod = 674508;
UPDATE ruian_katastr SET nazev = 'Krňany' WHERE kod = 674516;
UPDATE ruian_katastr SET nazev = 'Teletín' WHERE kod = 674524;
UPDATE ruian_katastr SET nazev = 'Třebsín' WHERE kod = 674532;
UPDATE ruian_katastr SET nazev = 'Opavské Předměstí' WHERE kod = 674630;
UPDATE ruian_katastr SET nazev = 'Krnov-Horní Předměstí' WHERE kod = 674737;
UPDATE ruian_katastr SET nazev = 'Krásné Loučky' WHERE kod = 674770;
UPDATE ruian_katastr SET nazev = 'Krnsko' WHERE kod = 674788;
UPDATE ruian_katastr SET nazev = 'Řehnice' WHERE kod = 674818;
UPDATE ruian_katastr SET nazev = 'Krokočín' WHERE kod = 674826;
UPDATE ruian_katastr SET nazev = 'Kroměříž' WHERE kod = 674834;
UPDATE ruian_katastr SET nazev = 'Vážany u Kroměříže' WHERE kod = 674991;
UPDATE ruian_katastr SET nazev = 'Kotojedy' WHERE kod = 675008;
UPDATE ruian_katastr SET nazev = 'Dolní Světlá pod Luží' WHERE kod = 675016;
UPDATE ruian_katastr SET nazev = 'Horní Světlá pod Luží' WHERE kod = 675024;
UPDATE ruian_katastr SET nazev = 'Krompach' WHERE kod = 675032;
UPDATE ruian_katastr SET nazev = 'Kropáčova Vrutice' WHERE kod = 675041;
UPDATE ruian_katastr SET nazev = 'Sušno' WHERE kod = 675059;
UPDATE ruian_katastr SET nazev = 'Kroučová' WHERE kod = 675067;
UPDATE ruian_katastr SET nazev = 'Krouna' WHERE kod = 675075;
UPDATE ruian_katastr SET nazev = 'Kroužek' WHERE kod = 675083;
UPDATE ruian_katastr SET nazev = 'Krpy' WHERE kod = 675091;
UPDATE ruian_katastr SET nazev = 'Kejšovice' WHERE kod = 675105;
UPDATE ruian_katastr SET nazev = 'Krsy' WHERE kod = 675113;
UPDATE ruian_katastr SET nazev = 'Polínka' WHERE kod = 675121;
UPDATE ruian_katastr SET nazev = 'Trhomné' WHERE kod = 675148;
UPDATE ruian_katastr SET nazev = 'Krtov' WHERE kod = 675156;
UPDATE ruian_katastr SET nazev = 'Krty' WHERE kod = 675164;
UPDATE ruian_katastr SET nazev = 'Krty u Strakonic' WHERE kod = 675181;
UPDATE ruian_katastr SET nazev = 'Kruh' WHERE kod = 675199;
UPDATE ruian_katastr SET nazev = 'Krumsín' WHERE kod = 675202;
UPDATE ruian_katastr SET nazev = 'Krumvíř' WHERE kod = 675211;
UPDATE ruian_katastr SET nazev = 'Krupá u Kostelce nad Černými Lesy' WHERE kod = 675229;
UPDATE ruian_katastr SET nazev = 'Svatbín' WHERE kod = 675237;
UPDATE ruian_katastr SET nazev = 'Krupá' WHERE kod = 675253;
UPDATE ruian_katastr SET nazev = 'Krupka' WHERE kod = 675261;
UPDATE ruian_katastr SET nazev = 'Bohosudov' WHERE kod = 675288;
UPDATE ruian_katastr SET nazev = 'Nové Modlany' WHERE kod = 675296;
UPDATE ruian_katastr SET nazev = 'Maršov u Krupky' WHERE kod = 675300;
UPDATE ruian_katastr SET nazev = 'Unčín u Krupky' WHERE kod = 675318;
UPDATE ruian_katastr SET nazev = 'Horní Krupka' WHERE kod = 675334;
UPDATE ruian_katastr SET nazev = 'Vrchoslav' WHERE kod = 675351;
UPDATE ruian_katastr SET nazev = 'Habartice u Krupky' WHERE kod = 675377;
UPDATE ruian_katastr SET nazev = 'Fojtovice u Krupky' WHERE kod = 675385;
UPDATE ruian_katastr SET nazev = 'Mohelnice u Krupky' WHERE kod = 675393;
UPDATE ruian_katastr SET nazev = 'Krusičany' WHERE kod = 675407;
UPDATE ruian_katastr SET nazev = 'Krušovice' WHERE kod = 675415;
UPDATE ruian_katastr SET nazev = 'Kružberk' WHERE kod = 675431;
UPDATE ruian_katastr SET nazev = 'Staré Lublice' WHERE kod = 675440;
UPDATE ruian_katastr SET nazev = 'Staré Těchanovice' WHERE kod = 675458;
UPDATE ruian_katastr SET nazev = 'Kryry' WHERE kod = 675466;
UPDATE ruian_katastr SET nazev = 'Kryštofovo Údolí' WHERE kod = 675474;
UPDATE ruian_katastr SET nazev = 'Novina u Liberce' WHERE kod = 675482;
UPDATE ruian_katastr SET nazev = 'Křeč' WHERE kod = 675491;
UPDATE ruian_katastr SET nazev = 'Křečhoř' WHERE kod = 675512;
UPDATE ruian_katastr SET nazev = 'Kutlíře' WHERE kod = 675521;
UPDATE ruian_katastr SET nazev = 'Křečkov' WHERE kod = 675539;
UPDATE ruian_katastr SET nazev = 'Křečovice u Neveklova' WHERE kod = 675547;
UPDATE ruian_katastr SET nazev = 'Křekovice u Vyšetic' WHERE kod = 675580;
UPDATE ruian_katastr SET nazev = 'Břuchotín' WHERE kod = 675628;
UPDATE ruian_katastr SET nazev = 'Křelov' WHERE kod = 675636;
UPDATE ruian_katastr SET nazev = 'Jiřičky' WHERE kod = 675644;
UPDATE ruian_katastr SET nazev = 'Křelovice u Pelhřimova' WHERE kod = 675652;
UPDATE ruian_katastr SET nazev = 'Křelovice u Pernarce' WHERE kod = 675661;
UPDATE ruian_katastr SET nazev = 'Mydlovary' WHERE kod = 675679;
UPDATE ruian_katastr SET nazev = 'Něšov' WHERE kod = 675687;
UPDATE ruian_katastr SET nazev = 'Pakoslav' WHERE kod = 675695;
UPDATE ruian_katastr SET nazev = 'Rozněvice' WHERE kod = 675709;
UPDATE ruian_katastr SET nazev = 'Skupeč' WHERE kod = 675717;
UPDATE ruian_katastr SET nazev = 'Křemačov' WHERE kod = 675725;
UPDATE ruian_katastr SET nazev = 'Křemže' WHERE kod = 675768;
UPDATE ruian_katastr SET nazev = 'Křenek' WHERE kod = 675806;
UPDATE ruian_katastr SET nazev = 'Křenice u Prahy' WHERE kod = 675814;
UPDATE ruian_katastr SET nazev = 'Biřkov' WHERE kod = 675822;
UPDATE ruian_katastr SET nazev = 'Kámen u Křenic' WHERE kod = 675831;
UPDATE ruian_katastr SET nazev = 'Křenice' WHERE kod = 675849;
UPDATE ruian_katastr SET nazev = 'Přetín' WHERE kod = 675857;
UPDATE ruian_katastr SET nazev = 'Křenov' WHERE kod = 675873;
UPDATE ruian_katastr SET nazev = 'Křenovice u Slavkova' WHERE kod = 675881;
UPDATE ruian_katastr SET nazev = 'Křenovice u Kojetína' WHERE kod = 675890;
UPDATE ruian_katastr SET nazev = 'Křenovy' WHERE kod = 675903;
UPDATE ruian_katastr SET nazev = 'Semošice' WHERE kod = 675911;
UPDATE ruian_katastr SET nazev = 'Vránov' WHERE kod = 675920;
UPDATE ruian_katastr SET nazev = 'Křepenice' WHERE kod = 675938;
UPDATE ruian_katastr SET nazev = 'Křepice u Hustopečí' WHERE kod = 675946;
UPDATE ruian_katastr SET nazev = 'Křepice' WHERE kod = 675954;
UPDATE ruian_katastr SET nazev = 'Beranovka' WHERE kod = 675962;
UPDATE ruian_katastr SET nazev = 'Křepkovice' WHERE kod = 675971;
UPDATE ruian_katastr SET nazev = 'Nezdice u Křepkovic' WHERE kod = 675989;
UPDATE ruian_katastr SET nazev = 'Pěkovice' WHERE kod = 675997;
UPDATE ruian_katastr SET nazev = 'Bykáň' WHERE kod = 676004;
UPDATE ruian_katastr SET nazev = 'Chrást u Křesetic' WHERE kod = 676021;
UPDATE ruian_katastr SET nazev = 'Krupá u Křesetic' WHERE kod = 676039;
UPDATE ruian_katastr SET nazev = 'Křesetice' WHERE kod = 676047;
UPDATE ruian_katastr SET nazev = 'Křesín' WHERE kod = 676055;
UPDATE ruian_katastr SET nazev = 'Levousy' WHERE kod = 676063;
UPDATE ruian_katastr SET nazev = 'Křeslice' WHERE kod = 676071;
UPDATE ruian_katastr SET nazev = 'Křešice u Litoměřic' WHERE kod = 676080;
UPDATE ruian_katastr SET nazev = 'Nučnice' WHERE kod = 676098;
UPDATE ruian_katastr SET nazev = 'Křešín' WHERE kod = 676101;
UPDATE ruian_katastr SET nazev = 'Kramolín u Křešína' WHERE kod = 676136;
UPDATE ruian_katastr SET nazev = 'Křešín u Pacova' WHERE kod = 676144;
UPDATE ruian_katastr SET nazev = 'Dolní Poříčí nad Křetínkou' WHERE kod = 676161;
UPDATE ruian_katastr SET nazev = 'Křetín' WHERE kod = 676179;
UPDATE ruian_katastr SET nazev = 'Křičeň' WHERE kod = 676187;
UPDATE ruian_katastr SET nazev = 'Křimice' WHERE kod = 676195;
UPDATE ruian_katastr SET nazev = 'Domina' WHERE kod = 676209;
UPDATE ruian_katastr SET nazev = 'Krásná Lípa u Křimova' WHERE kod = 676217;
UPDATE ruian_katastr SET nazev = 'Křimov' WHERE kod = 676225;
UPDATE ruian_katastr SET nazev = 'Strážky u Křimova' WHERE kod = 676233;
UPDATE ruian_katastr SET nazev = 'Suchdol u Křimova' WHERE kod = 676241;
UPDATE ruian_katastr SET nazev = 'Menhartice u Křimova' WHERE kod = 676250;
UPDATE ruian_katastr SET nazev = 'Nebovazy' WHERE kod = 676268;
UPDATE ruian_katastr SET nazev = 'Stráž u Křimova' WHERE kod = 676276;
UPDATE ruian_katastr SET nazev = 'Bošín' WHERE kod = 676284;
UPDATE ruian_katastr SET nazev = 'Křinec' WHERE kod = 676292;
UPDATE ruian_katastr SET nazev = 'Zábrdovice u Křince' WHERE kod = 676306;
UPDATE ruian_katastr SET nazev = 'Křinice' WHERE kod = 676314;
UPDATE ruian_katastr SET nazev = 'Křišťanov' WHERE kod = 676331;
UPDATE ruian_katastr SET nazev = 'Křišťanovice' WHERE kod = 676357;
UPDATE ruian_katastr SET nazev = 'Křivice' WHERE kod = 676365;
UPDATE ruian_katastr SET nazev = 'Křivoklát' WHERE kod = 676390;
UPDATE ruian_katastr SET nazev = 'Křivsoudov' WHERE kod = 676411;
UPDATE ruian_katastr SET nazev = 'České Křižánky' WHERE kod = 676438;
UPDATE ruian_katastr SET nazev = 'Moravské Křižánky' WHERE kod = 676446;
UPDATE ruian_katastr SET nazev = 'Křižanov' WHERE kod = 676454;
UPDATE ruian_katastr SET nazev = 'Křižanov u Zábřeha' WHERE kod = 676471;
UPDATE ruian_katastr SET nazev = 'Křižanovice u Bučovic' WHERE kod = 676489;
UPDATE ruian_katastr SET nazev = 'Křižanovice u Vyškova' WHERE kod = 676497;
UPDATE ruian_katastr SET nazev = 'Křižany' WHERE kod = 676501;
UPDATE ruian_katastr SET nazev = 'Katov' WHERE kod = 676519;
UPDATE ruian_katastr SET nazev = 'Křižínkov' WHERE kod = 676527;
UPDATE ruian_katastr SET nazev = 'Pánov' WHERE kod = 676535;
UPDATE ruian_katastr SET nazev = 'Čenětice' WHERE kod = 676543;
UPDATE ruian_katastr SET nazev = 'Křížkový Újezdec' WHERE kod = 676551;
UPDATE ruian_katastr SET nazev = 'Křížlice' WHERE kod = 676560;
UPDATE ruian_katastr SET nazev = 'Křížov pod Blaníkem' WHERE kod = 676594;
UPDATE ruian_katastr SET nazev = 'Křížov' WHERE kod = 676616;
UPDATE ruian_katastr SET nazev = 'Krucemburk' WHERE kod = 676624;
UPDATE ruian_katastr SET nazev = 'Křižovatka' WHERE kod = 676632;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Křižovatky' WHERE kod = 676641;
UPDATE ruian_katastr SET nazev = 'Velký Luh' WHERE kod = 676659;
UPDATE ruian_katastr SET nazev = 'Mostek u Křižovatky' WHERE kod = 676667;
UPDATE ruian_katastr SET nazev = 'Křížovice' WHERE kod = 676675;
UPDATE ruian_katastr SET nazev = 'Křoví' WHERE kod = 676683;
UPDATE ruian_katastr SET nazev = 'Křtěnov u Olešnice' WHERE kod = 676691;
UPDATE ruian_katastr SET nazev = 'Kloub' WHERE kod = 676705;
UPDATE ruian_katastr SET nazev = 'Křtětice' WHERE kod = 676713;
UPDATE ruian_katastr SET nazev = 'Pohorovice' WHERE kod = 676721;
UPDATE ruian_katastr SET nazev = 'Křtiny' WHERE kod = 676730;
UPDATE ruian_katastr SET nazev = 'Kšice' WHERE kod = 676748;
UPDATE ruian_katastr SET nazev = 'Únehle' WHERE kod = 676756;
UPDATE ruian_katastr SET nazev = 'Dobročkov' WHERE kod = 676772;
UPDATE ruian_katastr SET nazev = 'Ktiš' WHERE kod = 676781;
UPDATE ruian_katastr SET nazev = 'Smědeč' WHERE kod = 676802;
UPDATE ruian_katastr SET nazev = 'Křížovice u Ktiše' WHERE kod = 676837;
UPDATE ruian_katastr SET nazev = 'Ktová' WHERE kod = 676853;
UPDATE ruian_katastr SET nazev = 'Kublov' WHERE kod = 676861;
UPDATE ruian_katastr SET nazev = 'Kubšice' WHERE kod = 676888;
UPDATE ruian_katastr SET nazev = 'Kučerov' WHERE kod = 676896;
UPDATE ruian_katastr SET nazev = 'Jickovice' WHERE kod = 676900;
UPDATE ruian_katastr SET nazev = 'Kučeř' WHERE kod = 676918;
UPDATE ruian_katastr SET nazev = 'Kudlovice' WHERE kod = 676934;
UPDATE ruian_katastr SET nazev = 'Kuchař' WHERE kod = 676942;
UPDATE ruian_katastr SET nazev = 'Kuchařovice' WHERE kod = 676951;
UPDATE ruian_katastr SET nazev = 'Kujavy' WHERE kod = 676969;
UPDATE ruian_katastr SET nazev = 'Pohořílky u Kujav' WHERE kod = 676977;
UPDATE ruian_katastr SET nazev = 'Kuklík' WHERE kod = 676993;
UPDATE ruian_katastr SET nazev = 'Kašov' WHERE kod = 677001;
UPDATE ruian_katastr SET nazev = 'Kuks' WHERE kod = 677019;
UPDATE ruian_katastr SET nazev = 'Stanovice u Kuksu' WHERE kod = 677035;
UPDATE ruian_katastr SET nazev = 'Kulířov' WHERE kod = 677043;
UPDATE ruian_katastr SET nazev = 'Kunčice u Nechanic' WHERE kod = 677051;
UPDATE ruian_katastr SET nazev = 'Kunčice nad Labem' WHERE kod = 677060;
UPDATE ruian_katastr SET nazev = 'Kunčice' WHERE kod = 677078;
UPDATE ruian_katastr SET nazev = 'Kunčice pod Králickým Sněžníkem' WHERE kod = 677086;
UPDATE ruian_katastr SET nazev = 'Kunčice pod Ondřejníkem' WHERE kod = 677094;
UPDATE ruian_katastr SET nazev = 'Kunčina' WHERE kod = 677141;
UPDATE ruian_katastr SET nazev = 'Kunčina Ves' WHERE kod = 677159;
UPDATE ruian_katastr SET nazev = 'Kundratice u Chomutova' WHERE kod = 677167;
UPDATE ruian_katastr SET nazev = 'Kundratice' WHERE kod = 677175;
UPDATE ruian_katastr SET nazev = 'Kundratice u Křižanova' WHERE kod = 677183;
UPDATE ruian_katastr SET nazev = 'Kunějovice' WHERE kod = 677191;
UPDATE ruian_katastr SET nazev = 'Kuní' WHERE kod = 677205;
UPDATE ruian_katastr SET nazev = 'Dolní Lomnice u Kunic' WHERE kod = 677213;
UPDATE ruian_katastr SET nazev = 'Kunice u Říčan' WHERE kod = 677230;
UPDATE ruian_katastr SET nazev = 'Všešímy' WHERE kod = 677256;
UPDATE ruian_katastr SET nazev = 'Kunice' WHERE kod = 677264;
UPDATE ruian_katastr SET nazev = 'Kuničky' WHERE kod = 677272;
UPDATE ruian_katastr SET nazev = 'Kunín' WHERE kod = 677281;
UPDATE ruian_katastr SET nazev = 'Dobřemilice' WHERE kod = 677299;
UPDATE ruian_katastr SET nazev = 'Chvalšovice u Čachrova' WHERE kod = 677302;
UPDATE ruian_katastr SET nazev = 'Kunkovice u Čachrova' WHERE kod = 677311;
UPDATE ruian_katastr SET nazev = 'Kunkovice u Litenčic' WHERE kod = 677329;
UPDATE ruian_katastr SET nazev = 'Kuňovice' WHERE kod = 677337;
UPDATE ruian_katastr SET nazev = 'Kunovice u Uherského Hradiště' WHERE kod = 677345;
UPDATE ruian_katastr SET nazev = 'Kunovice' WHERE kod = 677353;
UPDATE ruian_katastr SET nazev = 'Kunratice u České Kamenice' WHERE kod = 677370;
UPDATE ruian_katastr SET nazev = 'Líska' WHERE kod = 677396;
UPDATE ruian_katastr SET nazev = 'Studený u Kunratic' WHERE kod = 677400;
UPDATE ruian_katastr SET nazev = 'Kunratice u Frýdlantu' WHERE kod = 677418;
UPDATE ruian_katastr SET nazev = 'Kunratice u Cvikova' WHERE kod = 677426;
UPDATE ruian_katastr SET nazev = 'Kunštát na Moravě' WHERE kod = 677434;
UPDATE ruian_katastr SET nazev = 'Sychotín' WHERE kod = 677442;
UPDATE ruian_katastr SET nazev = 'Újezd u Kunštátu' WHERE kod = 677451;
UPDATE ruian_katastr SET nazev = 'Kunvald' WHERE kod = 677493;
UPDATE ruian_katastr SET nazev = 'Kunžak' WHERE kod = 677531;
UPDATE ruian_katastr SET nazev = 'Mosty' WHERE kod = 677540;
UPDATE ruian_katastr SET nazev = 'Suchdol u Kunžaku' WHERE kod = 677558;
UPDATE ruian_katastr SET nazev = 'Kupařovice' WHERE kod = 677582;
UPDATE ruian_katastr SET nazev = 'Kurdějov' WHERE kod = 677591;
UPDATE ruian_katastr SET nazev = 'Kurojedy' WHERE kod = 677604;
UPDATE ruian_katastr SET nazev = 'Málkovice' WHERE kod = 677612;
UPDATE ruian_katastr SET nazev = 'Kurovice' WHERE kod = 677639;
UPDATE ruian_katastr SET nazev = 'Kuří u Říčan' WHERE kod = 677647;
UPDATE ruian_katastr SET nazev = 'Kuřim' WHERE kod = 677655;
UPDATE ruian_katastr SET nazev = 'Kuřimany' WHERE kod = 677671;
UPDATE ruian_katastr SET nazev = 'Kuřimská Nová Ves' WHERE kod = 677680;
UPDATE ruian_katastr SET nazev = 'Kuřimské Jestřabí' WHERE kod = 677698;
UPDATE ruian_katastr SET nazev = 'Kutná Hora' WHERE kod = 677710;
UPDATE ruian_katastr SET nazev = 'Poličany' WHERE kod = 677850;
UPDATE ruian_katastr SET nazev = 'Perštejnec' WHERE kod = 677906;
UPDATE ruian_katastr SET nazev = 'Neškaredice' WHERE kod = 677922;
UPDATE ruian_katastr SET nazev = 'Sedlec u Kutné Hory' WHERE kod = 677973;
UPDATE ruian_katastr SET nazev = 'Kaňk' WHERE kod = 678015;
UPDATE ruian_katastr SET nazev = 'Malín' WHERE kod = 678023;
UPDATE ruian_katastr SET nazev = 'Kutrovice' WHERE kod = 678031;
UPDATE ruian_katastr SET nazev = 'Neprobylice u Kutrovic' WHERE kod = 678040;
UPDATE ruian_katastr SET nazev = 'Kuželov' WHERE kod = 678058;
UPDATE ruian_katastr SET nazev = 'Kvaň' WHERE kod = 678082;
UPDATE ruian_katastr SET nazev = 'Kvasejovice' WHERE kod = 678104;
UPDATE ruian_katastr SET nazev = 'Měšetice' WHERE kod = 678139;
UPDATE ruian_katastr SET nazev = 'Nové Dvory u Kvasejovic' WHERE kod = 678155;
UPDATE ruian_katastr SET nazev = 'Veletín' WHERE kod = 678171;
UPDATE ruian_katastr SET nazev = 'Kvasice' WHERE kod = 678180;
UPDATE ruian_katastr SET nazev = 'Kvasiny' WHERE kod = 678198;
UPDATE ruian_katastr SET nazev = 'Kváskovice' WHERE kod = 678201;
UPDATE ruian_katastr SET nazev = 'Skály u Kváskovic' WHERE kod = 678210;
UPDATE ruian_katastr SET nazev = 'Kvášňovice' WHERE kod = 678228;
UPDATE ruian_katastr SET nazev = 'Olšany u Kvášňovic' WHERE kod = 678236;
UPDATE ruian_katastr SET nazev = 'Květín' WHERE kod = 678244;
UPDATE ruian_katastr SET nazev = 'Kvasetice u Květinova' WHERE kod = 678252;
UPDATE ruian_katastr SET nazev = 'Květinov' WHERE kod = 678261;
UPDATE ruian_katastr SET nazev = 'Květná' WHERE kod = 678279;
UPDATE ruian_katastr SET nazev = 'Hanušov' WHERE kod = 678287;
UPDATE ruian_katastr SET nazev = 'Květnová' WHERE kod = 678295;
UPDATE ruian_katastr SET nazev = 'Maroltov' WHERE kod = 678309;
UPDATE ruian_katastr SET nazev = 'Květov' WHERE kod = 678317;
UPDATE ruian_katastr SET nazev = 'Vůsí' WHERE kod = 678325;
UPDATE ruian_katastr SET nazev = 'Kvíčovice' WHERE kod = 678333;
UPDATE ruian_katastr SET nazev = 'Štichov' WHERE kod = 678341;
UPDATE ruian_katastr SET nazev = 'Kvilda' WHERE kod = 678350;
UPDATE ruian_katastr SET nazev = 'Bučina u Kvildy' WHERE kod = 678368;
UPDATE ruian_katastr SET nazev = 'Kvílice' WHERE kod = 678376;
UPDATE ruian_katastr SET nazev = 'Kvítkov u České Lípy' WHERE kod = 678384;
UPDATE ruian_katastr SET nazev = 'Kydliny' WHERE kod = 678392;
UPDATE ruian_katastr SET nazev = 'Kyje u Jičína' WHERE kod = 678406;
UPDATE ruian_katastr SET nazev = 'Kyjov u Havlíčkova Brodu' WHERE kod = 678422;
UPDATE ruian_katastr SET nazev = 'Kyjov' WHERE kod = 678431;
UPDATE ruian_katastr SET nazev = 'Nětčice u Kyjova' WHERE kod = 678511;
UPDATE ruian_katastr SET nazev = 'Boršov u Kyjova' WHERE kod = 678520;
UPDATE ruian_katastr SET nazev = 'Kyjov u Černé' WHERE kod = 678546;
UPDATE ruian_katastr SET nazev = 'Kyjovice' WHERE kod = 678554;
UPDATE ruian_katastr SET nazev = 'Kyjovice ve Slezsku' WHERE kod = 678562;
UPDATE ruian_katastr SET nazev = 'Kynice' WHERE kod = 678571;
UPDATE ruian_katastr SET nazev = 'Dolní Pochlovice' WHERE kod = 678589;
UPDATE ruian_katastr SET nazev = 'Chotíkov u Kynšperka nad Ohří' WHERE kod = 678601;
UPDATE ruian_katastr SET nazev = 'Kamenný Dvůr' WHERE kod = 678619;
UPDATE ruian_katastr SET nazev = 'Kynšperk nad Ohří' WHERE kod = 678627;
UPDATE ruian_katastr SET nazev = 'Zlatá u Kynšperka nad Ohří' WHERE kod = 678635;
UPDATE ruian_katastr SET nazev = 'Liboc u Kynšperka nad Ohří' WHERE kod = 678643;
UPDATE ruian_katastr SET nazev = 'Štědrá u Kynšperka nad Ohří' WHERE kod = 678651;
UPDATE ruian_katastr SET nazev = 'Kyselka' WHERE kod = 678678;
UPDATE ruian_katastr SET nazev = 'Nová Kyselka' WHERE kod = 678686;
UPDATE ruian_katastr SET nazev = 'Radošov u Kyselky' WHERE kod = 678694;
UPDATE ruian_katastr SET nazev = 'Kyselovice' WHERE kod = 678708;
UPDATE ruian_katastr SET nazev = 'Kyšice' WHERE kod = 678716;
UPDATE ruian_katastr SET nazev = 'Kyšice u Plzně' WHERE kod = 678724;
UPDATE ruian_katastr SET nazev = 'Brzánky' WHERE kod = 678732;
UPDATE ruian_katastr SET nazev = 'Kyškovice' WHERE kod = 678741;
UPDATE ruian_katastr SET nazev = 'Kytín' WHERE kod = 678759;
UPDATE ruian_katastr SET nazev = 'Dolní Falknov' WHERE kod = 678767;
UPDATE ruian_katastr SET nazev = 'Falknov' WHERE kod = 678775;
UPDATE ruian_katastr SET nazev = 'Kytlické Mlýny' WHERE kod = 678783;
UPDATE ruian_katastr SET nazev = 'Kyžlířov' WHERE kod = 678805;
UPDATE ruian_katastr SET nazev = 'Labouň' WHERE kod = 678813;
UPDATE ruian_katastr SET nazev = 'Labské Chrčice' WHERE kod = 678821;
UPDATE ruian_katastr SET nazev = 'Labuť' WHERE kod = 678830;
UPDATE ruian_katastr SET nazev = 'Bohuslav' WHERE kod = 678848;
UPDATE ruian_katastr SET nazev = 'Labuty' WHERE kod = 678856;
UPDATE ruian_katastr SET nazev = 'Lačnov' WHERE kod = 678864;
UPDATE ruian_katastr SET nazev = 'Ladná' WHERE kod = 678872;
UPDATE ruian_katastr SET nazev = 'Lahošť' WHERE kod = 678881;
UPDATE ruian_katastr SET nazev = 'Lančov' WHERE kod = 678899;
UPDATE ruian_katastr SET nazev = 'Horní Lánov' WHERE kod = 678902;
UPDATE ruian_katastr SET nazev = 'Prostřední Lánov' WHERE kod = 678911;
UPDATE ruian_katastr SET nazev = 'Lanškroun' WHERE kod = 678929;
UPDATE ruian_katastr SET nazev = 'Dolní Třešňovec' WHERE kod = 679020;
UPDATE ruian_katastr SET nazev = 'Lanšperk' WHERE kod = 679038;
UPDATE ruian_katastr SET nazev = 'Lány' WHERE kod = 679046;
UPDATE ruian_katastr SET nazev = 'Vašírov' WHERE kod = 679062;
UPDATE ruian_katastr SET nazev = 'Lány na Důlku' WHERE kod = 679071;
UPDATE ruian_katastr SET nazev = 'Opočínek' WHERE kod = 679089;
UPDATE ruian_katastr SET nazev = 'Srnojedy' WHERE kod = 679097;
UPDATE ruian_katastr SET nazev = 'Lány u Dašic' WHERE kod = 679101;
UPDATE ruian_katastr SET nazev = 'Lanžhot' WHERE kod = 679119;
UPDATE ruian_katastr SET nazev = 'Lanžov' WHERE kod = 679127;
UPDATE ruian_katastr SET nazev = 'Sedlec u Lanžova' WHERE kod = 679151;
UPDATE ruian_katastr SET nazev = 'Lásenice' WHERE kod = 679160;
UPDATE ruian_katastr SET nazev = 'Krakovec na Moravě' WHERE kod = 679194;
UPDATE ruian_katastr SET nazev = 'Laškov' WHERE kod = 679208;
UPDATE ruian_katastr SET nazev = 'Lašovice' WHERE kod = 679216;
UPDATE ruian_katastr SET nazev = 'Lavičky' WHERE kod = 679232;
UPDATE ruian_katastr SET nazev = 'Závist u Velkého Meziříčí' WHERE kod = 679241;
UPDATE ruian_katastr SET nazev = 'Lavičné' WHERE kod = 679259;
UPDATE ruian_katastr SET nazev = 'Láz' WHERE kod = 679267;
UPDATE ruian_katastr SET nazev = 'Lazinov' WHERE kod = 679275;
UPDATE ruian_katastr SET nazev = 'Brtev' WHERE kod = 679283;
UPDATE ruian_katastr SET nazev = 'Dolní Nová Ves' WHERE kod = 679291;
UPDATE ruian_katastr SET nazev = 'Horní Nová Ves' WHERE kod = 679305;
UPDATE ruian_katastr SET nazev = 'Hřídelec' WHERE kod = 679313;
UPDATE ruian_katastr SET nazev = 'Lány u Lázní Bělohradu' WHERE kod = 679321;
UPDATE ruian_katastr SET nazev = 'Lázně Bělohrad' WHERE kod = 679330;
UPDATE ruian_katastr SET nazev = 'Prostřední Nová Ves' WHERE kod = 679348;
UPDATE ruian_katastr SET nazev = 'Lazy' WHERE kod = 679364;
UPDATE ruian_katastr SET nazev = 'Lázně Kynžvart' WHERE kod = 679372;
UPDATE ruian_katastr SET nazev = 'Lázně Libverda' WHERE kod = 679381;
UPDATE ruian_katastr SET nazev = 'Lazníčky' WHERE kod = 679399;
UPDATE ruian_katastr SET nazev = 'Svrčov' WHERE kod = 679402;
UPDATE ruian_katastr SET nazev = 'Lazníky' WHERE kod = 679411;
UPDATE ruian_katastr SET nazev = 'Lazsko' WHERE kod = 679429;
UPDATE ruian_katastr SET nazev = 'Lázy' WHERE kod = 679437;
UPDATE ruian_katastr SET nazev = 'Lázy u Valašského Meziříčí' WHERE kod = 679445;
UPDATE ruian_katastr SET nazev = 'Lažánky u Blanska' WHERE kod = 679453;
UPDATE ruian_katastr SET nazev = 'Holasice u Veverské Bítýšky' WHERE kod = 679461;
UPDATE ruian_katastr SET nazev = 'Lažánky u Veverské Bítýšky' WHERE kod = 679470;
UPDATE ruian_katastr SET nazev = 'Lažany u Skutče' WHERE kod = 679488;
UPDATE ruian_katastr SET nazev = 'Lažany' WHERE kod = 679496;
UPDATE ruian_katastr SET nazev = 'Dvory u Lažišť' WHERE kod = 679518;
UPDATE ruian_katastr SET nazev = 'Chlístov u Lažišť' WHERE kod = 679526;
UPDATE ruian_katastr SET nazev = 'Kratušín' WHERE kod = 679534;
UPDATE ruian_katastr SET nazev = 'Lažiště' WHERE kod = 679542;
UPDATE ruian_katastr SET nazev = 'Švihov u Lažišť' WHERE kod = 679551;
UPDATE ruian_katastr SET nazev = 'Zábrdí u Lažišť' WHERE kod = 679569;
UPDATE ruian_katastr SET nazev = 'Lážovice' WHERE kod = 679577;
UPDATE ruian_katastr SET nazev = 'Křešice u Divišova' WHERE kod = 679593;
UPDATE ruian_katastr SET nazev = 'Lbosín' WHERE kod = 679607;
UPDATE ruian_katastr SET nazev = 'Ledce u Kladna' WHERE kod = 679615;
UPDATE ruian_katastr SET nazev = 'Ledce u Mladé Boleslavi' WHERE kod = 679623;
UPDATE ruian_katastr SET nazev = 'Ledce u Plzně' WHERE kod = 679631;
UPDATE ruian_katastr SET nazev = 'Příšov' WHERE kod = 679640;
UPDATE ruian_katastr SET nazev = 'Klášter nad Dědinou' WHERE kod = 679658;
UPDATE ruian_katastr SET nazev = 'Ledce' WHERE kod = 679666;
UPDATE ruian_katastr SET nazev = 'Ledce u Židlochovic' WHERE kod = 679682;
UPDATE ruian_katastr SET nazev = 'Ledčice' WHERE kod = 679691;
UPDATE ruian_katastr SET nazev = 'Ledec' WHERE kod = 679704;
UPDATE ruian_katastr SET nazev = 'Ledeč nad Sázavou' WHERE kod = 679712;
UPDATE ruian_katastr SET nazev = 'Ledečko' WHERE kod = 679755;
UPDATE ruian_katastr SET nazev = 'Ledečky' WHERE kod = 679771;
UPDATE ruian_katastr SET nazev = 'Ledenice' WHERE kod = 679798;
UPDATE ruian_katastr SET nazev = 'Lednice' WHERE kod = 679810;
UPDATE ruian_katastr SET nazev = 'Lednice na Moravě' WHERE kod = 679828;
UPDATE ruian_katastr SET nazev = 'Nejdek u Lednice' WHERE kod = 679836;
UPDATE ruian_katastr SET nazev = 'Ledvice' WHERE kod = 679844;
UPDATE ruian_katastr SET nazev = 'Lechotice' WHERE kod = 679852;
UPDATE ruian_katastr SET nazev = 'Lechovice' WHERE kod = 679861;
UPDATE ruian_katastr SET nazev = 'Lejšovka' WHERE kod = 679887;
UPDATE ruian_katastr SET nazev = 'Lelekovice' WHERE kod = 679895;
UPDATE ruian_katastr SET nazev = 'Leletice' WHERE kod = 679917;
UPDATE ruian_katastr SET nazev = 'Lenešice' WHERE kod = 679925;
UPDATE ruian_katastr SET nazev = 'Houžná' WHERE kod = 679933;
UPDATE ruian_katastr SET nazev = 'Lenora' WHERE kod = 679950;
UPDATE ruian_katastr SET nazev = 'Vlčí Jámy' WHERE kod = 679976;
UPDATE ruian_katastr SET nazev = 'Leskovec u Vítkova' WHERE kod = 679992;
UPDATE ruian_katastr SET nazev = 'Leskovec' WHERE kod = 680001;
UPDATE ruian_katastr SET nazev = 'Leskovec nad Moravicí' WHERE kod = 680010;
UPDATE ruian_katastr SET nazev = 'Slezská Harta' WHERE kod = 680028;
UPDATE ruian_katastr SET nazev = 'Leskovice' WHERE kod = 680036;
UPDATE ruian_katastr SET nazev = 'Česká Ves u Lesné' WHERE kod = 680044;
UPDATE ruian_katastr SET nazev = 'Jedlina' WHERE kod = 680052;
UPDATE ruian_katastr SET nazev = 'Lesná u Tachova' WHERE kod = 680061;
UPDATE ruian_katastr SET nazev = 'Pavlův Studenec 1' WHERE kod = 680079;
UPDATE ruian_katastr SET nazev = 'Písařova Vesce' WHERE kod = 680087;
UPDATE ruian_katastr SET nazev = 'Stará Knížecí Huť' WHERE kod = 680095;
UPDATE ruian_katastr SET nazev = 'Bažantov' WHERE kod = 680109;
UPDATE ruian_katastr SET nazev = 'Zahájí u Lesné' WHERE kod = 680117;
UPDATE ruian_katastr SET nazev = 'Hoštice nad Labem' WHERE kod = 680125;
UPDATE ruian_katastr SET nazev = 'Lesná u Děčína' WHERE kod = 680133;
UPDATE ruian_katastr SET nazev = 'Lesná u Želetavy' WHERE kod = 680168;
UPDATE ruian_katastr SET nazev = 'Lesná u Znojma' WHERE kod = 680176;
UPDATE ruian_katastr SET nazev = 'Lesní Albrechtice' WHERE kod = 680184;
UPDATE ruian_katastr SET nazev = 'Lesní Hluboké' WHERE kod = 680192;
UPDATE ruian_katastr SET nazev = 'Lesní Jakubov' WHERE kod = 680206;
UPDATE ruian_katastr SET nazev = 'Lesnice' WHERE kod = 680214;
UPDATE ruian_katastr SET nazev = 'Horní Lažany u Lesonic' WHERE kod = 680222;
UPDATE ruian_katastr SET nazev = 'Lesonice' WHERE kod = 680231;
UPDATE ruian_katastr SET nazev = 'Lesonice u Moravského Krumlova' WHERE kod = 680249;
UPDATE ruian_katastr SET nazev = 'Kozlov u Lesoňovic' WHERE kod = 680257;
UPDATE ruian_katastr SET nazev = 'Lesoňovice' WHERE kod = 680265;
UPDATE ruian_katastr SET nazev = 'Pivonice u Lesoňovic' WHERE kod = 680273;
UPDATE ruian_katastr SET nazev = 'Dolní Víska' WHERE kod = 680281;
UPDATE ruian_katastr SET nazev = 'Domaslav' WHERE kod = 680290;
UPDATE ruian_katastr SET nazev = 'Hanov u Lestkova' WHERE kod = 680303;
UPDATE ruian_katastr SET nazev = 'Kořen' WHERE kod = 680311;
UPDATE ruian_katastr SET nazev = 'Lestkov' WHERE kod = 680320;
UPDATE ruian_katastr SET nazev = 'Stan u Lestkova' WHERE kod = 680338;
UPDATE ruian_katastr SET nazev = 'Vrbice u Bezdružic' WHERE kod = 680346;
UPDATE ruian_katastr SET nazev = 'Vysoké Jamné' WHERE kod = 680354;
UPDATE ruian_katastr SET nazev = 'Lesůňky' WHERE kod = 680362;
UPDATE ruian_katastr SET nazev = 'Břežany u Lešan' WHERE kod = 680371;
UPDATE ruian_katastr SET nazev = 'Lešany nad Sázavou' WHERE kod = 680389;
UPDATE ruian_katastr SET nazev = 'Lešany' WHERE kod = 680419;
UPDATE ruian_katastr SET nazev = 'Lešany u Prostějova' WHERE kod = 680427;
UPDATE ruian_katastr SET nazev = 'Lešetice' WHERE kod = 680435;
UPDATE ruian_katastr SET nazev = 'Leškovice' WHERE kod = 680443;
UPDATE ruian_katastr SET nazev = 'Lešná' WHERE kod = 680451;
UPDATE ruian_katastr SET nazev = 'Lešov' WHERE kod = 680460;
UPDATE ruian_katastr SET nazev = 'Leština u Herálce' WHERE kod = 680478;
UPDATE ruian_katastr SET nazev = 'Doubravice u Leštiny' WHERE kod = 680486;
UPDATE ruian_katastr SET nazev = 'Leština' WHERE kod = 680508;
UPDATE ruian_katastr SET nazev = 'Podhořany u Nových Hradů' WHERE kod = 680516;
UPDATE ruian_katastr SET nazev = 'Leština u Zábřeha' WHERE kod = 680524;
UPDATE ruian_katastr SET nazev = 'Dobrnice' WHERE kod = 680532;
UPDATE ruian_katastr SET nazev = 'Leština u Světlé' WHERE kod = 680541;
UPDATE ruian_katastr SET nazev = 'Štěpánov u Leštiny' WHERE kod = 680559;
UPDATE ruian_katastr SET nazev = 'Vrbice u Leštiny' WHERE kod = 680567;
UPDATE ruian_katastr SET nazev = 'Leštinka' WHERE kod = 680575;
UPDATE ruian_katastr SET nazev = 'Kbelnice u Letin' WHERE kod = 680583;
UPDATE ruian_katastr SET nazev = 'Letiny' WHERE kod = 680605;
UPDATE ruian_katastr SET nazev = 'Svárkov' WHERE kod = 680613;
UPDATE ruian_katastr SET nazev = 'Letkov' WHERE kod = 680621;
UPDATE ruian_katastr SET nazev = 'Červená' WHERE kod = 680630;
UPDATE ruian_katastr SET nazev = 'Kunčice u Letohradu' WHERE kod = 680656;
UPDATE ruian_katastr SET nazev = 'Letohrad' WHERE kod = 680664;
UPDATE ruian_katastr SET nazev = 'Orlice' WHERE kod = 680672;
UPDATE ruian_katastr SET nazev = 'Letonice' WHERE kod = 680699;
UPDATE ruian_katastr SET nazev = 'Klevetov' WHERE kod = 680702;
UPDATE ruian_katastr SET nazev = 'Letovice' WHERE kod = 680711;
UPDATE ruian_katastr SET nazev = 'Lhota u Letovic' WHERE kod = 680729;
UPDATE ruian_katastr SET nazev = 'Slatinka' WHERE kod = 680737;
UPDATE ruian_katastr SET nazev = 'Třebětín u Letovic' WHERE kod = 680745;
UPDATE ruian_katastr SET nazev = 'Zboněk' WHERE kod = 680753;
UPDATE ruian_katastr SET nazev = 'Lety u Dobřichovic' WHERE kod = 680761;
UPDATE ruian_katastr SET nazev = 'Lety' WHERE kod = 680770;
UPDATE ruian_katastr SET nazev = 'Šerkov' WHERE kod = 680788;
UPDATE ruian_katastr SET nazev = 'Levín u Berouna' WHERE kod = 680796;
UPDATE ruian_katastr SET nazev = 'Levín u Litoměřic' WHERE kod = 680800;
UPDATE ruian_katastr SET nazev = 'Muckov' WHERE kod = 680818;
UPDATE ruian_katastr SET nazev = 'Lezník' WHERE kod = 680826;
UPDATE ruian_katastr SET nazev = 'Ležky' WHERE kod = 680834;
UPDATE ruian_katastr SET nazev = 'Přibenice' WHERE kod = 680842;
UPDATE ruian_katastr SET nazev = 'Lhánice' WHERE kod = 680851;
UPDATE ruian_katastr SET nazev = 'Hrbov u Lhenic' WHERE kod = 680877;
UPDATE ruian_katastr SET nazev = 'Lhenice' WHERE kod = 680885;
UPDATE ruian_katastr SET nazev = 'Třešňový Újezdec' WHERE kod = 680893;
UPDATE ruian_katastr SET nazev = 'Vadkov' WHERE kod = 680907;
UPDATE ruian_katastr SET nazev = 'Vodice u Lhenic' WHERE kod = 680915;
UPDATE ruian_katastr SET nazev = 'Lhota u Kamenných Žehrovic' WHERE kod = 680923;
UPDATE ruian_katastr SET nazev = 'Lhota u Dřís' WHERE kod = 680931;
UPDATE ruian_katastr SET nazev = 'Lhota u Dobřan' WHERE kod = 680940;
UPDATE ruian_katastr SET nazev = 'Lhota Komárov' WHERE kod = 680974;
UPDATE ruian_katastr SET nazev = 'Lhota u Zlína' WHERE kod = 680982;
UPDATE ruian_katastr SET nazev = 'Lhota u Opavy' WHERE kod = 680991;
UPDATE ruian_katastr SET nazev = 'Lhota u Lipníka nad Bečvou' WHERE kod = 681008;
UPDATE ruian_katastr SET nazev = 'Lhota nad Rohanovem' WHERE kod = 681024;
UPDATE ruian_katastr SET nazev = 'Lhota pod Hořičkami' WHERE kod = 681059;
UPDATE ruian_katastr SET nazev = 'Světlá u Hořiček' WHERE kod = 681067;
UPDATE ruian_katastr SET nazev = 'Újezdec u Hořiček' WHERE kod = 681075;
UPDATE ruian_katastr SET nazev = 'Vestec u Hořiček' WHERE kod = 681083;
UPDATE ruian_katastr SET nazev = 'Lhota pod Libčany' WHERE kod = 681105;
UPDATE ruian_katastr SET nazev = 'Lhota pod Přeloučí' WHERE kod = 681113;
UPDATE ruian_katastr SET nazev = 'Škudly' WHERE kod = 681121;
UPDATE ruian_katastr SET nazev = 'Lhota pod Radčem' WHERE kod = 681130;
UPDATE ruian_katastr SET nazev = 'Lhota Rapotina' WHERE kod = 681148;
UPDATE ruian_katastr SET nazev = 'Lhota u Choryně' WHERE kod = 681156;
UPDATE ruian_katastr SET nazev = 'Lhota u Chroustovic' WHERE kod = 681164;
UPDATE ruian_katastr SET nazev = 'Lhota u Kamenice nad Lipou' WHERE kod = 681172;
UPDATE ruian_katastr SET nazev = 'Lhota u Kelče' WHERE kod = 681181;
UPDATE ruian_katastr SET nazev = 'Lhota u Lysic' WHERE kod = 681199;
UPDATE ruian_katastr SET nazev = 'Lhota u Olešnice' WHERE kod = 681202;
UPDATE ruian_katastr SET nazev = 'Lhota u Příbramě' WHERE kod = 681211;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Trutnova' WHERE kod = 681229;
UPDATE ruian_katastr SET nazev = 'Lhota u Trutnova' WHERE kod = 681237;
UPDATE ruian_katastr SET nazev = 'Lhota u Vsetína' WHERE kod = 681245;
UPDATE ruian_katastr SET nazev = 'Lhotice' WHERE kod = 681270;
UPDATE ruian_katastr SET nazev = 'Miletín u Humpolce' WHERE kod = 681288;
UPDATE ruian_katastr SET nazev = 'Lhotice u Jemnice' WHERE kod = 681296;
UPDATE ruian_katastr SET nazev = 'Lhotka u Hořovic' WHERE kod = 681300;
UPDATE ruian_katastr SET nazev = 'Lhotka u Mělníka' WHERE kod = 681326;
UPDATE ruian_katastr SET nazev = 'Lhotka u Humpolce' WHERE kod = 681342;
UPDATE ruian_katastr SET nazev = 'Chockov' WHERE kod = 681351;
UPDATE ruian_katastr SET nazev = 'Lhotka u Radnic' WHERE kod = 681369;
UPDATE ruian_katastr SET nazev = 'Lhotka u České Třebové' WHERE kod = 681377;
UPDATE ruian_katastr SET nazev = 'Lhotka u Mrákotína' WHERE kod = 681385;
UPDATE ruian_katastr SET nazev = 'Lhotka u Žďáru nad Sázavou' WHERE kod = 681393;
UPDATE ruian_katastr SET nazev = 'Lhotka u Frýdku-Místku' WHERE kod = 681407;
UPDATE ruian_katastr SET nazev = 'Lhotka u Přerova' WHERE kod = 681415;
UPDATE ruian_katastr SET nazev = 'Lhotka nad Bečvou' WHERE kod = 681423;
UPDATE ruian_katastr SET nazev = 'Lhotka nad Labem' WHERE kod = 681431;
UPDATE ruian_katastr SET nazev = 'Lhotka u Litultovic' WHERE kod = 681440;
UPDATE ruian_katastr SET nazev = 'Lhotka u Ostravy' WHERE kod = 681458;
UPDATE ruian_katastr SET nazev = 'Lhotky u Mladé Boleslavi' WHERE kod = 681466;
UPDATE ruian_katastr SET nazev = 'Dolní Radslavice' WHERE kod = 681482;
UPDATE ruian_katastr SET nazev = 'Kúsky' WHERE kod = 681491;
UPDATE ruian_katastr SET nazev = 'Lhotky u Velkého Meziříčí' WHERE kod = 681504;
UPDATE ruian_katastr SET nazev = 'Lhotsko' WHERE kod = 681512;
UPDATE ruian_katastr SET nazev = 'Lhoty u Potštejna' WHERE kod = 681539;
UPDATE ruian_katastr SET nazev = 'Polom u Potštejna' WHERE kod = 681547;
UPDATE ruian_katastr SET nazev = 'Proruby u Potštejna' WHERE kod = 681555;
UPDATE ruian_katastr SET nazev = 'Lhůta u Vysokého Mýta' WHERE kod = 681580;
UPDATE ruian_katastr SET nazev = 'Dobrošov u Libé' WHERE kod = 681598;
UPDATE ruian_katastr SET nazev = 'Hůrka u Libé' WHERE kod = 681601;
UPDATE ruian_katastr SET nazev = 'Libá' WHERE kod = 681610;
UPDATE ruian_katastr SET nazev = 'Pomezná' WHERE kod = 681628;
UPDATE ruian_katastr SET nazev = 'Lužná u Františkových Lázní' WHERE kod = 681636;
UPDATE ruian_katastr SET nazev = 'Dubina' WHERE kod = 681644;
UPDATE ruian_katastr SET nazev = 'Rybáře u Libé' WHERE kod = 681652;
UPDATE ruian_katastr SET nazev = 'Libáň' WHERE kod = 681679;
UPDATE ruian_katastr SET nazev = 'Libavské Údolí' WHERE kod = 681695;
UPDATE ruian_katastr SET nazev = 'Šabina' WHERE kod = 681709;
UPDATE ruian_katastr SET nazev = 'Hvozdnice u Hradce Králové' WHERE kod = 681717;
UPDATE ruian_katastr SET nazev = 'Libčany' WHERE kod = 681725;
UPDATE ruian_katastr SET nazev = 'Želí' WHERE kod = 681733;
UPDATE ruian_katastr SET nazev = 'Hořenec' WHERE kod = 681741;
UPDATE ruian_katastr SET nazev = 'Jablonec u Libčevsi' WHERE kod = 681750;
UPDATE ruian_katastr SET nazev = 'Lahovice u Libčevsi' WHERE kod = 681768;
UPDATE ruian_katastr SET nazev = 'Libčeves' WHERE kod = 681776;
UPDATE ruian_katastr SET nazev = 'Řisuty u Libčevsi' WHERE kod = 681784;
UPDATE ruian_katastr SET nazev = 'Všechlapy u Libčevsi' WHERE kod = 681792;
UPDATE ruian_katastr SET nazev = 'Libčice' WHERE kod = 681806;
UPDATE ruian_katastr SET nazev = 'Chýnov' WHERE kod = 681814;
UPDATE ruian_katastr SET nazev = 'Letky' WHERE kod = 681822;
UPDATE ruian_katastr SET nazev = 'Libčice nad Vltavou' WHERE kod = 681831;
UPDATE ruian_katastr SET nazev = 'Javorníček' WHERE kod = 681849;
UPDATE ruian_katastr SET nazev = 'Libecina' WHERE kod = 681857;
UPDATE ruian_katastr SET nazev = 'Libeč' WHERE kod = 681873;
UPDATE ruian_katastr SET nazev = 'Libečov' WHERE kod = 681881;
UPDATE ruian_katastr SET nazev = 'Libědice' WHERE kod = 681903;
UPDATE ruian_katastr SET nazev = 'Ješovice' WHERE kod = 681911;
UPDATE ruian_katastr SET nazev = 'Liběchov' WHERE kod = 681920;
UPDATE ruian_katastr SET nazev = 'Černěves u Libějovic' WHERE kod = 681946;
UPDATE ruian_katastr SET nazev = 'Libějovice' WHERE kod = 681954;
UPDATE ruian_katastr SET nazev = 'Nestanice' WHERE kod = 681962;
UPDATE ruian_katastr SET nazev = 'Grunta' WHERE kod = 681971;
UPDATE ruian_katastr SET nazev = 'Libenice' WHERE kod = 681989;
UPDATE ruian_katastr SET nazev = 'Libenice u Tábora' WHERE kod = 682012;
UPDATE ruian_katastr SET nazev = 'Liberec' WHERE kod = 682039;
UPDATE ruian_katastr SET nazev = 'Ruprechtice' WHERE kod = 682144;
UPDATE ruian_katastr SET nazev = 'Nové Pavlovice' WHERE kod = 682161;
UPDATE ruian_katastr SET nazev = 'Staré Pavlovice' WHERE kod = 682179;
UPDATE ruian_katastr SET nazev = 'Růžodol I' WHERE kod = 682209;
UPDATE ruian_katastr SET nazev = 'Františkov u Liberce' WHERE kod = 682233;
UPDATE ruian_katastr SET nazev = 'Janův Důl u Liberce' WHERE kod = 682241;
UPDATE ruian_katastr SET nazev = 'Horní Růžodol' WHERE kod = 682250;
UPDATE ruian_katastr SET nazev = 'Dolní Hanychov' WHERE kod = 682268;
UPDATE ruian_katastr SET nazev = 'Rochlice u Liberce' WHERE kod = 682314;
UPDATE ruian_katastr SET nazev = 'Starý Harcov' WHERE kod = 682390;
UPDATE ruian_katastr SET nazev = 'Kateřinky u Liberce' WHERE kod = 682438;
UPDATE ruian_katastr SET nazev = 'Rudolfov' WHERE kod = 682446;
UPDATE ruian_katastr SET nazev = 'Horní Hanychov' WHERE kod = 682462;
UPDATE ruian_katastr SET nazev = 'Ostašov u Liberce' WHERE kod = 682471;
UPDATE ruian_katastr SET nazev = 'Horní Suchá u Liberce' WHERE kod = 682489;
UPDATE ruian_katastr SET nazev = 'Karlinky' WHERE kod = 682497;
UPDATE ruian_katastr SET nazev = 'Bělá u Liberka' WHERE kod = 682501;
UPDATE ruian_katastr SET nazev = 'Hláska' WHERE kod = 682519;
UPDATE ruian_katastr SET nazev = 'Liberk' WHERE kod = 682527;
UPDATE ruian_katastr SET nazev = 'Prorubky' WHERE kod = 682535;
UPDATE ruian_katastr SET nazev = 'Rampuše' WHERE kod = 682543;
UPDATE ruian_katastr SET nazev = 'Libeň u Libeře' WHERE kod = 682551;
UPDATE ruian_katastr SET nazev = 'Libeř' WHERE kod = 682560;
UPDATE ruian_katastr SET nazev = 'Liběšice u Litoměřic' WHERE kod = 682578;
UPDATE ruian_katastr SET nazev = 'Trnobrany' WHERE kod = 682586;
UPDATE ruian_katastr SET nazev = 'Zimoř' WHERE kod = 682594;
UPDATE ruian_katastr SET nazev = 'Dubčany u Liběšic' WHERE kod = 682608;
UPDATE ruian_katastr SET nazev = 'Kluček' WHERE kod = 682616;
UPDATE ruian_katastr SET nazev = 'Liběšice u Žatce' WHERE kod = 682624;
UPDATE ruian_katastr SET nazev = 'Líčkov' WHERE kod = 682632;
UPDATE ruian_katastr SET nazev = 'Liběšovice' WHERE kod = 682641;
UPDATE ruian_katastr SET nazev = 'Siřem' WHERE kod = 682659;
UPDATE ruian_katastr SET nazev = 'Líbeznice' WHERE kod = 682667;
UPDATE ruian_katastr SET nazev = 'Libež' WHERE kod = 682675;
UPDATE ruian_katastr SET nazev = 'Libhošť' WHERE kod = 682683;
UPDATE ruian_katastr SET nazev = 'Libice nad Cidlinou' WHERE kod = 682691;
UPDATE ruian_katastr SET nazev = 'Horní Sokolovec' WHERE kod = 682713;
UPDATE ruian_katastr SET nazev = 'Lány u Libice nad Doubravou' WHERE kod = 682721;
UPDATE ruian_katastr SET nazev = 'Lhůta' WHERE kod = 682730;
UPDATE ruian_katastr SET nazev = 'Libice nad Doubravou' WHERE kod = 682748;
UPDATE ruian_katastr SET nazev = 'Libická Lhotka' WHERE kod = 682756;
UPDATE ruian_katastr SET nazev = 'Libíč' WHERE kod = 682781;
UPDATE ruian_katastr SET nazev = 'Libichov' WHERE kod = 682799;
UPDATE ruian_katastr SET nazev = 'Doubravice u Sedlčan' WHERE kod = 682802;
UPDATE ruian_katastr SET nazev = 'Libíň' WHERE kod = 682811;
UPDATE ruian_katastr SET nazev = 'Libín' WHERE kod = 682829;
UPDATE ruian_katastr SET nazev = 'Dolní Libina' WHERE kod = 682837;
UPDATE ruian_katastr SET nazev = 'Horní Libina' WHERE kod = 682845;
UPDATE ruian_katastr SET nazev = 'Obědné' WHERE kod = 682853;
UPDATE ruian_katastr SET nazev = 'Libínky' WHERE kod = 682861;
UPDATE ruian_katastr SET nazev = 'Trnová u Polep' WHERE kod = 682870;
UPDATE ruian_katastr SET nazev = 'Libínské Sedlo' WHERE kod = 682888;
UPDATE ruian_katastr SET nazev = 'Perlovice' WHERE kod = 682896;
UPDATE ruian_katastr SET nazev = 'Sviňovice' WHERE kod = 682900;
UPDATE ruian_katastr SET nazev = 'Libišany' WHERE kod = 682918;
UPDATE ruian_katastr SET nazev = 'Libivá' WHERE kod = 682926;
UPDATE ruian_katastr SET nazev = 'Libkov' WHERE kod = 682934;
UPDATE ruian_katastr SET nazev = 'Libkov u Nasavrk' WHERE kod = 682942;
UPDATE ruian_katastr SET nazev = 'Libkova Voda' WHERE kod = 682951;
UPDATE ruian_katastr SET nazev = 'Libkovice u Mostu' WHERE kod = 682969;
UPDATE ruian_katastr SET nazev = 'Libkovice pod Řípem' WHERE kod = 682977;
UPDATE ruian_katastr SET nazev = 'Liblín' WHERE kod = 682993;
UPDATE ruian_katastr SET nazev = 'Libňatov' WHERE kod = 683001;
UPDATE ruian_katastr SET nazev = 'Jelmo' WHERE kod = 683027;
UPDATE ruian_katastr SET nazev = 'Libníč' WHERE kod = 683035;
UPDATE ruian_katastr SET nazev = 'Libníkovice' WHERE kod = 683078;
UPDATE ruian_katastr SET nazev = 'Libočany' WHERE kod = 683086;
UPDATE ruian_katastr SET nazev = 'Libodřice' WHERE kod = 683094;
UPDATE ruian_katastr SET nazev = 'Libochovany' WHERE kod = 683108;
UPDATE ruian_katastr SET nazev = 'Řepnice' WHERE kod = 683116;
UPDATE ruian_katastr SET nazev = 'Libochovice' WHERE kod = 683124;
UPDATE ruian_katastr SET nazev = 'Libochovičky' WHERE kod = 683132;
UPDATE ruian_katastr SET nazev = 'Křižanovice' WHERE kod = 683141;
UPDATE ruian_katastr SET nazev = 'Liboměřice' WHERE kod = 683159;
UPDATE ruian_katastr SET nazev = 'Licibořice' WHERE kod = 683167;
UPDATE ruian_katastr SET nazev = 'Nové Lhotice' WHERE kod = 683175;
UPDATE ruian_katastr SET nazev = 'Libomyšl' WHERE kod = 683205;
UPDATE ruian_katastr SET nazev = 'Želkovice u Libomyšle' WHERE kod = 683213;
UPDATE ruian_katastr SET nazev = 'Libořezy' WHERE kod = 683221;
UPDATE ruian_katastr SET nazev = 'Libořice' WHERE kod = 683230;
UPDATE ruian_katastr SET nazev = 'Železná u Libořic' WHERE kod = 683248;
UPDATE ruian_katastr SET nazev = 'Libosváry u Bystřice pod Hostýnem' WHERE kod = 683256;
UPDATE ruian_katastr SET nazev = 'Krnov' WHERE kod = 683264;
UPDATE ruian_katastr SET nazev = 'Liboš' WHERE kod = 683272;
UPDATE ruian_katastr SET nazev = 'Dobšice' WHERE kod = 683281;
UPDATE ruian_katastr SET nazev = 'Libošovice' WHERE kod = 683299;
UPDATE ruian_katastr SET nazev = 'Malechovice' WHERE kod = 683311;
UPDATE ruian_katastr SET nazev = 'Nepřívěc' WHERE kod = 683337;
UPDATE ruian_katastr SET nazev = 'Rytířova Lhota' WHERE kod = 683353;
UPDATE ruian_katastr SET nazev = 'Vesec u Sobotky' WHERE kod = 683361;
UPDATE ruian_katastr SET nazev = 'Libotenice' WHERE kod = 683370;
UPDATE ruian_katastr SET nazev = 'Libotov' WHERE kod = 683388;
UPDATE ruian_katastr SET nazev = 'Čermná u Libouchce' WHERE kod = 683396;
UPDATE ruian_katastr SET nazev = 'Libouchec' WHERE kod = 683418;
UPDATE ruian_katastr SET nazev = 'Bořkovice' WHERE kod = 683434;
UPDATE ruian_katastr SET nazev = 'Laby' WHERE kod = 683442;
UPDATE ruian_katastr SET nazev = 'Libouň' WHERE kod = 683451;
UPDATE ruian_katastr SET nazev = 'Libovice u Slaného' WHERE kod = 683477;
UPDATE ruian_katastr SET nazev = 'Librantice' WHERE kod = 683485;
UPDATE ruian_katastr SET nazev = 'Libřice' WHERE kod = 683493;
UPDATE ruian_katastr SET nazev = 'Libštát' WHERE kod = 683507;
UPDATE ruian_katastr SET nazev = 'Březka' WHERE kod = 683515;
UPDATE ruian_katastr SET nazev = 'Libuň' WHERE kod = 683523;
UPDATE ruian_katastr SET nazev = 'Libunec' WHERE kod = 683531;
UPDATE ruian_katastr SET nazev = 'Libušín' WHERE kod = 683582;
UPDATE ruian_katastr SET nazev = 'Lično' WHERE kod = 683591;
UPDATE ruian_katastr SET nazev = 'Ostašovice' WHERE kod = 683604;
UPDATE ruian_katastr SET nazev = 'Radostovice u Lična' WHERE kod = 683612;
UPDATE ruian_katastr SET nazev = 'Děkanské Skaliny' WHERE kod = 683621;
UPDATE ruian_katastr SET nazev = 'Ličov-Desky' WHERE kod = 683639;
UPDATE ruian_katastr SET nazev = 'Dluhoště' WHERE kod = 683647;
UPDATE ruian_katastr SET nazev = 'Ličov' WHERE kod = 683655;
UPDATE ruian_katastr SET nazev = 'Lidečko' WHERE kod = 683671;
UPDATE ruian_katastr SET nazev = 'Lidice' WHERE kod = 683701;
UPDATE ruian_katastr SET nazev = 'Lidmaň' WHERE kod = 683728;
UPDATE ruian_katastr SET nazev = 'Lidmaňka' WHERE kod = 683736;
UPDATE ruian_katastr SET nazev = 'Lichkov' WHERE kod = 683744;
UPDATE ruian_katastr SET nazev = 'Lichnov u Bruntálu' WHERE kod = 683752;
UPDATE ruian_katastr SET nazev = 'Lichnov u Nového Jičína' WHERE kod = 683787;
UPDATE ruian_katastr SET nazev = 'Lichoceves' WHERE kod = 683795;
UPDATE ruian_katastr SET nazev = 'Noutonice' WHERE kod = 683809;
UPDATE ruian_katastr SET nazev = 'Okoř' WHERE kod = 683817;
UPDATE ruian_katastr SET nazev = 'Líchovy' WHERE kod = 683825;
UPDATE ruian_katastr SET nazev = 'Lindava' WHERE kod = 683833;
UPDATE ruian_katastr SET nazev = 'Svitava' WHERE kod = 683841;
UPDATE ruian_katastr SET nazev = 'Líně' WHERE kod = 683850;
UPDATE ruian_katastr SET nazev = 'Linhartice' WHERE kod = 683868;
UPDATE ruian_katastr SET nazev = 'Linhartovy' WHERE kod = 683876;
UPDATE ruian_katastr SET nazev = 'Opavice' WHERE kod = 683884;
UPDATE ruian_katastr SET nazev = 'Líny' WHERE kod = 683892;
UPDATE ruian_katastr SET nazev = 'Lípa u Havlíčkova Brodu' WHERE kod = 683906;
UPDATE ruian_katastr SET nazev = 'Petrkov' WHERE kod = 683914;
UPDATE ruian_katastr SET nazev = 'Lípa u Hradce Králové' WHERE kod = 683922;
UPDATE ruian_katastr SET nazev = 'Lípa nad Orlicí' WHERE kod = 683949;
UPDATE ruian_katastr SET nazev = 'Lipany u Vitic' WHERE kod = 683957;
UPDATE ruian_katastr SET nazev = 'Lipence' WHERE kod = 683973;
UPDATE ruian_katastr SET nazev = 'Lipenec' WHERE kod = 683981;
UPDATE ruian_katastr SET nazev = 'Habří u Lipí' WHERE kod = 683990;
UPDATE ruian_katastr SET nazev = 'Kaliště u Lipí' WHERE kod = 684007;
UPDATE ruian_katastr SET nazev = 'Kvítkovice u Lipí' WHERE kod = 684015;
UPDATE ruian_katastr SET nazev = 'Lipí' WHERE kod = 684023;
UPDATE ruian_katastr SET nazev = 'Lipí u Náchoda' WHERE kod = 684031;
UPDATE ruian_katastr SET nazev = 'Bitětice' WHERE kod = 684040;
UPDATE ruian_katastr SET nazev = 'Lipice' WHERE kod = 684058;
UPDATE ruian_katastr SET nazev = 'Pejškov' WHERE kod = 684066;
UPDATE ruian_katastr SET nazev = 'Lipina u Opavy' WHERE kod = 684074;
UPDATE ruian_katastr SET nazev = 'Křekov' WHERE kod = 684082;
UPDATE ruian_katastr SET nazev = 'Lipina' WHERE kod = 684091;
UPDATE ruian_katastr SET nazev = 'Lipinka' WHERE kod = 684104;
UPDATE ruian_katastr SET nazev = 'Lipná' WHERE kod = 684112;
UPDATE ruian_katastr SET nazev = 'Lipňany' WHERE kod = 684121;
UPDATE ruian_katastr SET nazev = 'Lipnice u Spáleného Poříčí' WHERE kod = 684139;
UPDATE ruian_katastr SET nazev = 'Lipnice u Dvora Králové' WHERE kod = 684171;
UPDATE ruian_katastr SET nazev = 'Lipnice nad Sázavou' WHERE kod = 684198;
UPDATE ruian_katastr SET nazev = 'Kochánov u Lipničky' WHERE kod = 684210;
UPDATE ruian_katastr SET nazev = 'Lipnička' WHERE kod = 684228;
UPDATE ruian_katastr SET nazev = 'Radostovice u Lipničky' WHERE kod = 684236;
UPDATE ruian_katastr SET nazev = 'Lipník' WHERE kod = 684244;
UPDATE ruian_katastr SET nazev = 'Lipník u Hrotovic' WHERE kod = 684252;
UPDATE ruian_katastr SET nazev = 'Lipník nad Bečvou' WHERE kod = 684261;
UPDATE ruian_katastr SET nazev = 'Drahomyšl' WHERE kod = 684287;
UPDATE ruian_katastr SET nazev = 'Lipno' WHERE kod = 684295;
UPDATE ruian_katastr SET nazev = 'Lipno nad Vltavou' WHERE kod = 684309;
UPDATE ruian_katastr SET nazev = 'Lipolec' WHERE kod = 684325;
UPDATE ruian_katastr SET nazev = 'Lipoltice' WHERE kod = 684333;
UPDATE ruian_katastr SET nazev = 'Sovoluská Lhota' WHERE kod = 684350;
UPDATE ruian_katastr SET nazev = 'Lipov' WHERE kod = 684368;
UPDATE ruian_katastr SET nazev = 'Dolní Lažany u Lipové' WHERE kod = 684376;
UPDATE ruian_katastr SET nazev = 'Dolní Lipina' WHERE kod = 684384;
UPDATE ruian_katastr SET nazev = 'Doubrava u Lipové' WHERE kod = 684392;
UPDATE ruian_katastr SET nazev = 'Horní Lažany u Lipové' WHERE kod = 684406;
UPDATE ruian_katastr SET nazev = 'Horní Lipina' WHERE kod = 684414;
UPDATE ruian_katastr SET nazev = 'Kozly u Lipové' WHERE kod = 684422;
UPDATE ruian_katastr SET nazev = 'Lipová u Chebu' WHERE kod = 684431;
UPDATE ruian_katastr SET nazev = 'Mechová' WHERE kod = 684449;
UPDATE ruian_katastr SET nazev = 'Mýtina' WHERE kod = 684457;
UPDATE ruian_katastr SET nazev = 'Oldřichov u Lipové' WHERE kod = 684465;
UPDATE ruian_katastr SET nazev = 'Palič' WHERE kod = 684473;
UPDATE ruian_katastr SET nazev = 'Stebnice' WHERE kod = 684481;
UPDATE ruian_katastr SET nazev = 'Žírnice' WHERE kod = 684490;
UPDATE ruian_katastr SET nazev = 'Mýtina I' WHERE kod = 684503;
UPDATE ruian_katastr SET nazev = 'Lipová u Šluknova' WHERE kod = 684511;
UPDATE ruian_katastr SET nazev = 'Liščí' WHERE kod = 684520;
UPDATE ruian_katastr SET nazev = 'Libov' WHERE kod = 684546;
UPDATE ruian_katastr SET nazev = 'Lipová pod Blanskem' WHERE kod = 684554;
UPDATE ruian_katastr SET nazev = 'Radešín u Lipové' WHERE kod = 684562;
UPDATE ruian_katastr SET nazev = 'Slavošov' WHERE kod = 684571;
UPDATE ruian_katastr SET nazev = 'Lipová u Slavičína' WHERE kod = 684589;
UPDATE ruian_katastr SET nazev = 'Hrochov' WHERE kod = 684597;
UPDATE ruian_katastr SET nazev = 'Lipová' WHERE kod = 684601;
UPDATE ruian_katastr SET nazev = 'Seč u Lipové' WHERE kod = 684619;
UPDATE ruian_katastr SET nazev = 'Křtomil' WHERE kod = 684627;
UPDATE ruian_katastr SET nazev = 'Lipová u Přerova' WHERE kod = 684635;
UPDATE ruian_katastr SET nazev = 'Horní Lipová' WHERE kod = 684651;
UPDATE ruian_katastr SET nazev = 'Dolní Lipová' WHERE kod = 684660;
UPDATE ruian_katastr SET nazev = 'Licoměřice' WHERE kod = 684678;
UPDATE ruian_katastr SET nazev = 'Lipovec' WHERE kod = 684686;
UPDATE ruian_katastr SET nazev = 'Lipovec u Blanska' WHERE kod = 684694;
UPDATE ruian_katastr SET nazev = 'Lipovka' WHERE kod = 684716;
UPDATE ruian_katastr SET nazev = 'Lipovka u Rychnova nad Kněžnou' WHERE kod = 684724;
UPDATE ruian_katastr SET nazev = 'Litohrady' WHERE kod = 684732;
UPDATE ruian_katastr SET nazev = 'Liptál' WHERE kod = 684767;
UPDATE ruian_katastr SET nazev = 'Bučávka' WHERE kod = 684805;
UPDATE ruian_katastr SET nazev = 'Liptaň' WHERE kod = 684813;
UPDATE ruian_katastr SET nazev = 'Liptice' WHERE kod = 684821;
UPDATE ruian_katastr SET nazev = 'Lipůvka' WHERE kod = 684830;
UPDATE ruian_katastr SET nazev = 'Lípy' WHERE kod = 684848;
UPDATE ruian_katastr SET nazev = 'Lhota u Lísku' WHERE kod = 684856;
UPDATE ruian_katastr SET nazev = 'Lísek' WHERE kod = 684864;
UPDATE ruian_katastr SET nazev = 'Vojtěchov u Lísku' WHERE kod = 684872;
UPDATE ruian_katastr SET nazev = 'Lískovec' WHERE kod = 684881;
UPDATE ruian_katastr SET nazev = 'Lískovec u Frýdku-Místku' WHERE kod = 684899;
UPDATE ruian_katastr SET nazev = 'Lískovice u Ostroměře' WHERE kod = 684902;
UPDATE ruian_katastr SET nazev = 'Líský' WHERE kod = 684911;
UPDATE ruian_katastr SET nazev = 'Lišany u Rakovníka' WHERE kod = 684929;
UPDATE ruian_katastr SET nazev = 'Dolejší Hůrky' WHERE kod = 684945;
UPDATE ruian_katastr SET nazev = 'Levonice' WHERE kod = 684953;
UPDATE ruian_katastr SET nazev = 'Lišany u Žatce' WHERE kod = 684961;
UPDATE ruian_katastr SET nazev = 'Lišice' WHERE kod = 684970;
UPDATE ruian_katastr SET nazev = 'Líšina' WHERE kod = 684996;
UPDATE ruian_katastr SET nazev = 'Líšná u Zbiroha' WHERE kod = 685011;
UPDATE ruian_katastr SET nazev = 'Líšná' WHERE kod = 685020;
UPDATE ruian_katastr SET nazev = 'Líšná u Přerova' WHERE kod = 685038;
UPDATE ruian_katastr SET nazev = 'Líšnice u Prahy' WHERE kod = 685054;
UPDATE ruian_katastr SET nazev = 'Lišnice' WHERE kod = 685071;
UPDATE ruian_katastr SET nazev = 'Líšnice' WHERE kod = 685097;
UPDATE ruian_katastr SET nazev = 'Líšnice u Mohelnice' WHERE kod = 685119;
UPDATE ruian_katastr SET nazev = 'Vyšehorky' WHERE kod = 685127;
UPDATE ruian_katastr SET nazev = 'Líšný' WHERE kod = 685135;
UPDATE ruian_katastr SET nazev = 'Dolní Miletín' WHERE kod = 685143;
UPDATE ruian_katastr SET nazev = 'Horní Miletín' WHERE kod = 685151;
UPDATE ruian_katastr SET nazev = 'Levín u Lišova' WHERE kod = 685160;
UPDATE ruian_katastr SET nazev = 'Lišov' WHERE kod = 685178;
UPDATE ruian_katastr SET nazev = 'Líšťany' WHERE kod = 685186;
UPDATE ruian_katastr SET nazev = 'Luhov u Líšťan' WHERE kod = 685194;
UPDATE ruian_katastr SET nazev = 'Náklov' WHERE kod = 685208;
UPDATE ruian_katastr SET nazev = 'Třebobuz' WHERE kod = 685216;
UPDATE ruian_katastr SET nazev = 'Líšťany u Cítolib' WHERE kod = 685224;
UPDATE ruian_katastr SET nazev = 'Běleč u Litně' WHERE kod = 685232;
UPDATE ruian_katastr SET nazev = 'Liteň' WHERE kod = 685267;
UPDATE ruian_katastr SET nazev = 'Litenčice' WHERE kod = 685275;
UPDATE ruian_katastr SET nazev = 'Litětiny' WHERE kod = 685283;
UPDATE ruian_katastr SET nazev = 'Litice' WHERE kod = 685291;
UPDATE ruian_katastr SET nazev = 'Litice nad Orlicí' WHERE kod = 685305;
UPDATE ruian_katastr SET nazev = 'Litíč' WHERE kod = 685313;
UPDATE ruian_katastr SET nazev = 'Litichovice' WHERE kod = 685330;
UPDATE ruian_katastr SET nazev = 'Litkovice' WHERE kod = 685348;
UPDATE ruian_katastr SET nazev = 'Litobratřice' WHERE kod = 685356;
UPDATE ruian_katastr SET nazev = 'Litohlavy' WHERE kod = 685364;
UPDATE ruian_katastr SET nazev = 'Litohoř' WHERE kod = 685372;
UPDATE ruian_katastr SET nazev = 'Litochovice u Volyně' WHERE kod = 685381;
UPDATE ruian_katastr SET nazev = 'Neuslužice' WHERE kod = 685399;
UPDATE ruian_katastr SET nazev = 'Střítež u Volyně' WHERE kod = 685402;
UPDATE ruian_katastr SET nazev = 'Litochovice nad Labem' WHERE kod = 685411;
UPDATE ruian_katastr SET nazev = 'Litoměřice' WHERE kod = 685429;
UPDATE ruian_katastr SET nazev = 'Pokratice' WHERE kod = 685569;
UPDATE ruian_katastr SET nazev = 'Litomyšl' WHERE kod = 685674;
UPDATE ruian_katastr SET nazev = 'Lány u Litomyšle' WHERE kod = 685682;
UPDATE ruian_katastr SET nazev = 'Záhraď' WHERE kod = 685704;
UPDATE ruian_katastr SET nazev = 'Nedošín' WHERE kod = 685747;
UPDATE ruian_katastr SET nazev = 'Litoradlice' WHERE kod = 685828;
UPDATE ruian_katastr SET nazev = 'Litostrov' WHERE kod = 685836;
UPDATE ruian_katastr SET nazev = 'Litošice' WHERE kod = 685852;
UPDATE ruian_katastr SET nazev = 'Horní Částkov' WHERE kod = 685861;
UPDATE ruian_katastr SET nazev = 'Lítov' WHERE kod = 685879;
UPDATE ruian_katastr SET nazev = 'Litovany' WHERE kod = 685895;
UPDATE ruian_katastr SET nazev = 'Litovel' WHERE kod = 685909;
UPDATE ruian_katastr SET nazev = 'Litultovice' WHERE kod = 686018;
UPDATE ruian_katastr SET nazev = 'Horní Litvínov' WHERE kod = 686042;
UPDATE ruian_katastr SET nazev = 'Dolní Litvínov' WHERE kod = 686131;
UPDATE ruian_katastr SET nazev = 'Chudeřín u Litvínova' WHERE kod = 686158;
UPDATE ruian_katastr SET nazev = 'Šumná u Litvínova' WHERE kod = 686174;
UPDATE ruian_katastr SET nazev = 'Lounice' WHERE kod = 686182;
UPDATE ruian_katastr SET nazev = 'Růžodol' WHERE kod = 686191;
UPDATE ruian_katastr SET nazev = 'Litvínovice' WHERE kod = 686204;
UPDATE ruian_katastr SET nazev = 'Lkáň' WHERE kod = 686239;
UPDATE ruian_katastr SET nazev = 'Lnáře' WHERE kod = 686247;
UPDATE ruian_katastr SET nazev = 'Zahorčice u Lnář' WHERE kod = 686255;
UPDATE ruian_katastr SET nazev = 'Lobeč u Mšena' WHERE kod = 686263;
UPDATE ruian_katastr SET nazev = 'Lobendava' WHERE kod = 686271;
UPDATE ruian_katastr SET nazev = 'Severní' WHERE kod = 686280;
UPDATE ruian_katastr SET nazev = 'Lobodice' WHERE kod = 686298;
UPDATE ruian_katastr SET nazev = 'Ločenice' WHERE kod = 686301;
UPDATE ruian_katastr SET nazev = 'Nesměň u Ločenic' WHERE kod = 686310;
UPDATE ruian_katastr SET nazev = 'Loděnice u Berouna' WHERE kod = 686328;
UPDATE ruian_katastr SET nazev = 'Lodenice' WHERE kod = 686336;
UPDATE ruian_katastr SET nazev = 'Loděnice u Moravského Krumlova' WHERE kod = 686344;
UPDATE ruian_katastr SET nazev = 'Lodhéřov' WHERE kod = 686352;
UPDATE ruian_katastr SET nazev = 'Najdek u Lodhéřova' WHERE kod = 686361;
UPDATE ruian_katastr SET nazev = 'Lodín' WHERE kod = 686387;
UPDATE ruian_katastr SET nazev = 'Lohenice' WHERE kod = 686395;
UPDATE ruian_katastr SET nazev = 'Lohenice u Přelouče' WHERE kod = 686409;
UPDATE ruian_katastr SET nazev = 'Lochenice' WHERE kod = 686417;
UPDATE ruian_katastr SET nazev = 'Lochkov' WHERE kod = 686425;
UPDATE ruian_katastr SET nazev = 'Lochočice' WHERE kod = 686433;
UPDATE ruian_katastr SET nazev = 'Lochousice' WHERE kod = 686441;
UPDATE ruian_katastr SET nazev = 'Lochovice' WHERE kod = 686468;
UPDATE ruian_katastr SET nazev = 'Loket u Dolních Kralovic' WHERE kod = 686492;
UPDATE ruian_katastr SET nazev = 'Dvory u Lokte' WHERE kod = 686506;
UPDATE ruian_katastr SET nazev = 'Loket' WHERE kod = 686514;
UPDATE ruian_katastr SET nazev = 'Nadlesí' WHERE kod = 686522;
UPDATE ruian_katastr SET nazev = 'Údolí u Lokte' WHERE kod = 686531;
UPDATE ruian_katastr SET nazev = 'Lom u Blatné' WHERE kod = 686549;
UPDATE ruian_katastr SET nazev = 'Míreč' WHERE kod = 686557;
UPDATE ruian_katastr SET nazev = 'Lom u Mostu' WHERE kod = 686573;
UPDATE ruian_katastr SET nazev = 'Loučná u Lomu' WHERE kod = 686590;
UPDATE ruian_katastr SET nazev = 'Lom u Tachova' WHERE kod = 686603;
UPDATE ruian_katastr SET nazev = 'Lomnice u Sokolova' WHERE kod = 686620;
UPDATE ruian_katastr SET nazev = 'Týn u Lomnice' WHERE kod = 686638;
UPDATE ruian_katastr SET nazev = 'Lomnice u Tišnova' WHERE kod = 686654;
UPDATE ruian_katastr SET nazev = 'Lomnice u Rýmařova' WHERE kod = 686662;
UPDATE ruian_katastr SET nazev = 'Tylov' WHERE kod = 686671;
UPDATE ruian_katastr SET nazev = 'Frahelž' WHERE kod = 686689;
UPDATE ruian_katastr SET nazev = 'Lomnice nad Lužnicí' WHERE kod = 686697;
UPDATE ruian_katastr SET nazev = 'Smržov u Lomnice nad Lužnicí' WHERE kod = 686701;
UPDATE ruian_katastr SET nazev = 'Chlum pod Táborem' WHERE kod = 686735;
UPDATE ruian_katastr SET nazev = 'Košov' WHERE kod = 686743;
UPDATE ruian_katastr SET nazev = 'Lomnice nad Popelkou' WHERE kod = 686751;
UPDATE ruian_katastr SET nazev = 'Ploužnice pod Táborem' WHERE kod = 686786;
UPDATE ruian_katastr SET nazev = 'Želechy' WHERE kod = 686794;
UPDATE ruian_katastr SET nazev = 'Lomnička u Tišnova' WHERE kod = 686808;
UPDATE ruian_katastr SET nazev = 'Lomy u Jemnice' WHERE kod = 686816;
UPDATE ruian_katastr SET nazev = 'Lopeník' WHERE kod = 686832;
UPDATE ruian_katastr SET nazev = 'Losiná u Plzně' WHERE kod = 686841;
UPDATE ruian_katastr SET nazev = 'Lošánky' WHERE kod = 686859;
UPDATE ruian_katastr SET nazev = 'Lošany' WHERE kod = 686867;
UPDATE ruian_katastr SET nazev = 'Lošov' WHERE kod = 686875;
UPDATE ruian_katastr SET nazev = 'Loštice' WHERE kod = 686883;
UPDATE ruian_katastr SET nazev = 'Žádlovice' WHERE kod = 686891;
UPDATE ruian_katastr SET nazev = 'Lotouš' WHERE kod = 686905;
UPDATE ruian_katastr SET nazev = 'Loučany na Hané' WHERE kod = 686921;
UPDATE ruian_katastr SET nazev = 'Loučeň' WHERE kod = 686930;
UPDATE ruian_katastr SET nazev = 'Patřín' WHERE kod = 686948;
UPDATE ruian_katastr SET nazev = 'Studce' WHERE kod = 686956;
UPDATE ruian_katastr SET nazev = 'Loučim' WHERE kod = 686972;
UPDATE ruian_katastr SET nazev = 'Loučka I' WHERE kod = 686981;
UPDATE ruian_katastr SET nazev = 'Loučka u Nového Jičína' WHERE kod = 687006;
UPDATE ruian_katastr SET nazev = 'Loučka' WHERE kod = 687014;
UPDATE ruian_katastr SET nazev = 'Loučka u Valašského Meziříčí' WHERE kod = 687022;
UPDATE ruian_katastr SET nazev = 'Loučky' WHERE kod = 687031;
UPDATE ruian_katastr SET nazev = 'Háj u Loučné pod Klínovcem' WHERE kod = 687049;
UPDATE ruian_katastr SET nazev = 'Loučná pod Klínovcem' WHERE kod = 687057;
UPDATE ruian_katastr SET nazev = 'Filipová' WHERE kod = 687065;
UPDATE ruian_katastr SET nazev = 'Kouty nad Desnou' WHERE kod = 687073;
UPDATE ruian_katastr SET nazev = 'Kociánov' WHERE kod = 687081;
UPDATE ruian_katastr SET nazev = 'Přemyslov' WHERE kod = 687090;
UPDATE ruian_katastr SET nazev = 'Rejhotice' WHERE kod = 687103;
UPDATE ruian_katastr SET nazev = 'Bolechy' WHERE kod = 687111;
UPDATE ruian_katastr SET nazev = 'Loučovice' WHERE kod = 687138;
UPDATE ruian_katastr SET nazev = 'Boršov u Loučovic' WHERE kod = 687162;
UPDATE ruian_katastr SET nazev = 'Dvorečná' WHERE kod = 687171;
UPDATE ruian_katastr SET nazev = 'Louka' WHERE kod = 687189;
UPDATE ruian_katastr SET nazev = 'Louka u Jemnice' WHERE kod = 687197;
UPDATE ruian_katastr SET nazev = 'Louka u Ostrohu' WHERE kod = 687201;
UPDATE ruian_katastr SET nazev = 'Louka u Litvínova' WHERE kod = 687219;
UPDATE ruian_katastr SET nazev = 'Loukov u Mnichova Hradiště' WHERE kod = 687235;
UPDATE ruian_katastr SET nazev = 'Loukov u Bystřice pod Hostýnem' WHERE kod = 687251;
UPDATE ruian_katastr SET nazev = 'Loukovec' WHERE kod = 687278;
UPDATE ruian_katastr SET nazev = 'Loukovice' WHERE kod = 687286;
UPDATE ruian_katastr SET nazev = 'Louky nad Olší' WHERE kod = 687308;
UPDATE ruian_katastr SET nazev = 'Lounky' WHERE kod = 687332;
UPDATE ruian_katastr SET nazev = 'Louňová' WHERE kod = 687341;
UPDATE ruian_katastr SET nazev = 'Louňovice' WHERE kod = 687359;
UPDATE ruian_katastr SET nazev = 'Býkovice u Louňovic' WHERE kod = 687367;
UPDATE ruian_katastr SET nazev = 'Louňovice pod Blaníkem' WHERE kod = 687375;
UPDATE ruian_katastr SET nazev = 'Světlá pod Blaníkem' WHERE kod = 687383;
UPDATE ruian_katastr SET nazev = 'Louny' WHERE kod = 687391;
UPDATE ruian_katastr SET nazev = 'Loužnice' WHERE kod = 687570;
UPDATE ruian_katastr SET nazev = 'Bližanovy' WHERE kod = 687588;
UPDATE ruian_katastr SET nazev = 'Kvasetice' WHERE kod = 687596;
UPDATE ruian_katastr SET nazev = 'Lovčice u Klatov' WHERE kod = 687600;
UPDATE ruian_katastr SET nazev = 'Pohoří u Lovčic' WHERE kod = 687618;
UPDATE ruian_katastr SET nazev = 'Štipoklasy u Lovčic' WHERE kod = 687626;
UPDATE ruian_katastr SET nazev = 'Lovčice u Nového Bydžova' WHERE kod = 687634;
UPDATE ruian_katastr SET nazev = 'Lovčice u Kyjova' WHERE kod = 687642;
UPDATE ruian_katastr SET nazev = 'Lovčičky' WHERE kod = 687651;
UPDATE ruian_katastr SET nazev = 'Levínské Petrovice' WHERE kod = 687669;
UPDATE ruian_katastr SET nazev = 'Lovečkovice' WHERE kod = 687677;
UPDATE ruian_katastr SET nazev = 'Lovětín' WHERE kod = 687685;
UPDATE ruian_katastr SET nazev = 'Lovětín u Třešti' WHERE kod = 687693;
UPDATE ruian_katastr SET nazev = 'Lovosice' WHERE kod = 687707;
UPDATE ruian_katastr SET nazev = 'Lozice' WHERE kod = 687847;
UPDATE ruian_katastr SET nazev = 'Lštění nad Zubřinou' WHERE kod = 687855;
UPDATE ruian_katastr SET nazev = 'Malonice nad Zubřinou' WHERE kod = 687863;
UPDATE ruian_katastr SET nazev = 'Lubě' WHERE kod = 687871;
UPDATE ruian_katastr SET nazev = 'Horní Záhoří' WHERE kod = 687880;
UPDATE ruian_katastr SET nazev = 'Libkovice' WHERE kod = 687898;
UPDATE ruian_katastr SET nazev = 'Libyně' WHERE kod = 687901;
UPDATE ruian_katastr SET nazev = 'Lubenec' WHERE kod = 687910;
UPDATE ruian_katastr SET nazev = 'Vítkovice u Lubence' WHERE kod = 687936;
UPDATE ruian_katastr SET nazev = 'Dolní Záhoří' WHERE kod = 687944;
UPDATE ruian_katastr SET nazev = 'Luběnice' WHERE kod = 687952;
UPDATE ruian_katastr SET nazev = 'Drnholec nad Lubinou' WHERE kod = 687961;
UPDATE ruian_katastr SET nazev = 'Větřkovice u Lubiny' WHERE kod = 687987;
UPDATE ruian_katastr SET nazev = 'Lubná u Rakovníka' WHERE kod = 688002;
UPDATE ruian_katastr SET nazev = 'Lubná u Poličky' WHERE kod = 688011;
UPDATE ruian_katastr SET nazev = 'Lubná u Kroměříže' WHERE kod = 688029;
UPDATE ruian_katastr SET nazev = 'Lubné' WHERE kod = 688037;
UPDATE ruian_katastr SET nazev = 'Lubnice' WHERE kod = 688045;
UPDATE ruian_katastr SET nazev = 'Lubník' WHERE kod = 688053;
UPDATE ruian_katastr SET nazev = 'Lubno' WHERE kod = 688061;
UPDATE ruian_katastr SET nazev = 'Lubojaty' WHERE kod = 688096;
UPDATE ruian_katastr SET nazev = 'Luboměř' WHERE kod = 688118;
UPDATE ruian_katastr SET nazev = 'Dolní Luby' WHERE kod = 688126;
UPDATE ruian_katastr SET nazev = 'Horní Luby' WHERE kod = 688142;
UPDATE ruian_katastr SET nazev = 'Luby I' WHERE kod = 688151;
UPDATE ruian_katastr SET nazev = 'Opatov u Lubů' WHERE kod = 688169;
UPDATE ruian_katastr SET nazev = 'Výspa' WHERE kod = 688177;
UPDATE ruian_katastr SET nazev = 'Luby II' WHERE kod = 688193;
UPDATE ruian_katastr SET nazev = 'Horní Maxov' WHERE kod = 688223;
UPDATE ruian_katastr SET nazev = 'Jindřichov nad Nisou' WHERE kod = 688240;
UPDATE ruian_katastr SET nazev = 'Lučany nad Nisou' WHERE kod = 688258;
UPDATE ruian_katastr SET nazev = 'Lučice' WHERE kod = 688282;
UPDATE ruian_katastr SET nazev = 'Lučice u Chlumce nad Cidlinou' WHERE kod = 688291;
UPDATE ruian_katastr SET nazev = 'Lučice na Moravě' WHERE kod = 688304;
UPDATE ruian_katastr SET nazev = 'Lučina u Tachova' WHERE kod = 688312;
UPDATE ruian_katastr SET nazev = 'Milíře u Tachova' WHERE kod = 688321;
UPDATE ruian_katastr SET nazev = 'Mýto u Tachova' WHERE kod = 688339;
UPDATE ruian_katastr SET nazev = 'Obora u Tachova' WHERE kod = 688347;
UPDATE ruian_katastr SET nazev = 'Pavlův Studenec 2' WHERE kod = 688355;
UPDATE ruian_katastr SET nazev = 'Kocurovice' WHERE kod = 688363;
UPDATE ruian_katastr SET nazev = 'Lučina' WHERE kod = 688371;
UPDATE ruian_katastr SET nazev = 'Arnultovice u Lučního Chvojna' WHERE kod = 688380;
UPDATE ruian_katastr SET nazev = 'Luční Chvojno' WHERE kod = 688398;
UPDATE ruian_katastr SET nazev = 'Mnichov u Lučního Chvojna' WHERE kod = 688401;
UPDATE ruian_katastr SET nazev = 'Ludgeřovice' WHERE kod = 688410;
UPDATE ruian_katastr SET nazev = 'Ludíkov' WHERE kod = 688436;
UPDATE ruian_katastr SET nazev = 'Ludkovice' WHERE kod = 688444;
UPDATE ruian_katastr SET nazev = 'Ludmírov' WHERE kod = 688461;
UPDATE ruian_katastr SET nazev = 'Milkov na Moravě' WHERE kod = 688479;
UPDATE ruian_katastr SET nazev = 'Ospělov' WHERE kod = 688487;
UPDATE ruian_katastr SET nazev = 'Ludslavice' WHERE kod = 688495;
UPDATE ruian_katastr SET nazev = 'Kámen' WHERE kod = 688509;
UPDATE ruian_katastr SET nazev = 'Ludvíkovice' WHERE kod = 688517;
UPDATE ruian_katastr SET nazev = 'Luh nad Svatavou' WHERE kod = 688550;
UPDATE ruian_katastr SET nazev = 'Radvanov' WHERE kod = 688568;
UPDATE ruian_katastr SET nazev = 'Luhačovice' WHERE kod = 688576;
UPDATE ruian_katastr SET nazev = 'Luhov u Mimoně' WHERE kod = 688584;
UPDATE ruian_katastr SET nazev = 'Luhy' WHERE kod = 688606;
UPDATE ruian_katastr SET nazev = 'Třtí' WHERE kod = 688614;
UPDATE ruian_katastr SET nazev = 'Luka u Verušiček' WHERE kod = 688622;
UPDATE ruian_katastr SET nazev = 'Velký Hlavákov' WHERE kod = 688631;
UPDATE ruian_katastr SET nazev = 'Luka' WHERE kod = 688649;
UPDATE ruian_katastr SET nazev = 'Březina' WHERE kod = 688665;
UPDATE ruian_katastr SET nazev = 'Javoříčko' WHERE kod = 688673;
UPDATE ruian_katastr SET nazev = 'Luká' WHERE kod = 688681;
UPDATE ruian_katastr SET nazev = 'Veselíčko' WHERE kod = 688690;
UPDATE ruian_katastr SET nazev = 'Luka nad Jihlavou' WHERE kod = 688703;
UPDATE ruian_katastr SET nazev = 'Otín nad Jihlavou' WHERE kod = 688711;
UPDATE ruian_katastr SET nazev = 'Předboř nad Jihlavou' WHERE kod = 688720;
UPDATE ruian_katastr SET nazev = 'Svatoslav nad Jihlavou' WHERE kod = 688738;
UPDATE ruian_katastr SET nazev = 'Luka pod Medníkem' WHERE kod = 688754;
UPDATE ruian_katastr SET nazev = 'Lukavec u Pacova' WHERE kod = 688771;
UPDATE ruian_katastr SET nazev = 'Týmova Ves' WHERE kod = 688789;
UPDATE ruian_katastr SET nazev = 'Lukavec u Lovosic' WHERE kod = 688797;
UPDATE ruian_katastr SET nazev = 'Lukavec u Bílovce' WHERE kod = 688801;
UPDATE ruian_katastr SET nazev = 'Černín u Lukavce' WHERE kod = 688819;
UPDATE ruian_katastr SET nazev = 'Dobeš' WHERE kod = 688827;
UPDATE ruian_katastr SET nazev = 'Lukavec u Hořic' WHERE kod = 688835;
UPDATE ruian_katastr SET nazev = 'Lukavice u Rychnova nad Kněžnou' WHERE kod = 688851;
UPDATE ruian_katastr SET nazev = 'Lukavice v Čechách' WHERE kod = 688860;
UPDATE ruian_katastr SET nazev = 'Lukavice na Moravě' WHERE kod = 688878;
UPDATE ruian_katastr SET nazev = 'Slavoňov u Lukavice' WHERE kod = 688886;
UPDATE ruian_katastr SET nazev = 'Vlachov' WHERE kod = 688894;
UPDATE ruian_katastr SET nazev = 'Lukavice' WHERE kod = 688908;
UPDATE ruian_katastr SET nazev = 'Výsonín' WHERE kod = 688924;
UPDATE ruian_katastr SET nazev = 'Horní Kamenice u Lukova' WHERE kod = 688932;
UPDATE ruian_katastr SET nazev = 'Lukov' WHERE kod = 688941;
UPDATE ruian_katastr SET nazev = 'Lukov u Bíliny' WHERE kod = 688959;
UPDATE ruian_katastr SET nazev = 'Štěpánov u Lukova' WHERE kod = 688967;
UPDATE ruian_katastr SET nazev = 'Lukov u Zlína' WHERE kod = 688975;
UPDATE ruian_katastr SET nazev = 'Lukov u Moravských Budějovic' WHERE kod = 688983;
UPDATE ruian_katastr SET nazev = 'Lukov nad Dyjí' WHERE kod = 688991;
UPDATE ruian_katastr SET nazev = 'Luková nad Cidlinou' WHERE kod = 689009;
UPDATE ruian_katastr SET nazev = 'Květná u Lukové' WHERE kod = 689017;
UPDATE ruian_katastr SET nazev = 'Luková' WHERE kod = 689025;
UPDATE ruian_katastr SET nazev = 'Luková u Přerova' WHERE kod = 689033;
UPDATE ruian_katastr SET nazev = 'Lukovany' WHERE kod = 689041;
UPDATE ruian_katastr SET nazev = 'Lukoveček' WHERE kod = 689050;
UPDATE ruian_katastr SET nazev = 'Lukoviště' WHERE kod = 689068;
UPDATE ruian_katastr SET nazev = 'Lukovna' WHERE kod = 689076;
UPDATE ruian_katastr SET nazev = 'Luleč' WHERE kod = 689084;
UPDATE ruian_katastr SET nazev = 'Lupenice' WHERE kod = 689092;
UPDATE ruian_katastr SET nazev = 'Luštěnice' WHERE kod = 689106;
UPDATE ruian_katastr SET nazev = 'Voděrady u Luštěnic' WHERE kod = 689114;
UPDATE ruian_katastr SET nazev = 'Lutín' WHERE kod = 689122;
UPDATE ruian_katastr SET nazev = 'Lutonina' WHERE kod = 689131;
UPDATE ruian_katastr SET nazev = 'Lutopecny' WHERE kod = 689149;
UPDATE ruian_katastr SET nazev = 'Měrůtky' WHERE kod = 689157;
UPDATE ruian_katastr SET nazev = 'Lutová' WHERE kod = 689165;
UPDATE ruian_katastr SET nazev = 'Dlouhá Louka u Lužan' WHERE kod = 689173;
UPDATE ruian_katastr SET nazev = 'Lužany u Přeštic' WHERE kod = 689181;
UPDATE ruian_katastr SET nazev = 'Zelené' WHERE kod = 689203;
UPDATE ruian_katastr SET nazev = 'Lužany nad Trotinou' WHERE kod = 689220;
UPDATE ruian_katastr SET nazev = 'Lužany u Jičína' WHERE kod = 689238;
UPDATE ruian_katastr SET nazev = 'Lužce' WHERE kod = 689246;
UPDATE ruian_katastr SET nazev = 'Luže' WHERE kod = 689254;
UPDATE ruian_katastr SET nazev = 'Zdislav' WHERE kod = 689262;
UPDATE ruian_katastr SET nazev = 'Lužec nad Cidlinou' WHERE kod = 689271;
UPDATE ruian_katastr SET nazev = 'Chramostek' WHERE kod = 689289;
UPDATE ruian_katastr SET nazev = 'Lužec nad Vltavou' WHERE kod = 689297;
UPDATE ruian_katastr SET nazev = 'Luženice' WHERE kod = 689301;
UPDATE ruian_katastr SET nazev = 'Luženičky' WHERE kod = 689319;
UPDATE ruian_katastr SET nazev = 'Lužice u Mostu' WHERE kod = 689327;
UPDATE ruian_katastr SET nazev = 'Svinčice' WHERE kod = 689335;
UPDATE ruian_katastr SET nazev = 'Lužice u Hodonína' WHERE kod = 689343;
UPDATE ruian_katastr SET nazev = 'Lužice u Šternberka' WHERE kod = 689351;
UPDATE ruian_katastr SET nazev = 'Lužná u Rakovníka' WHERE kod = 689378;
UPDATE ruian_katastr SET nazev = 'Lužná u Vsetína' WHERE kod = 689416;
UPDATE ruian_katastr SET nazev = 'Lužnice' WHERE kod = 689459;
UPDATE ruian_katastr SET nazev = 'Lvová' WHERE kod = 689475;
UPDATE ruian_katastr SET nazev = 'Lysá nad Labem' WHERE kod = 689505;
UPDATE ruian_katastr SET nazev = 'Litol' WHERE kod = 689556;
UPDATE ruian_katastr SET nazev = 'Lysec' WHERE kod = 689653;
UPDATE ruian_katastr SET nazev = 'Lysice' WHERE kod = 689661;
UPDATE ruian_katastr SET nazev = 'Lysovice' WHERE kod = 689670;
UPDATE ruian_katastr SET nazev = 'Lysůvky' WHERE kod = 689688;
UPDATE ruian_katastr SET nazev = 'Lžín' WHERE kod = 689700;
UPDATE ruian_katastr SET nazev = 'Mackovice' WHERE kod = 689718;
UPDATE ruian_katastr SET nazev = 'Hněvkov u Mačkova' WHERE kod = 689726;
UPDATE ruian_katastr SET nazev = 'Mačkov' WHERE kod = 689734;
UPDATE ruian_katastr SET nazev = 'Mahouš' WHERE kod = 689769;
UPDATE ruian_katastr SET nazev = 'Němčice u Netolic' WHERE kod = 689777;
UPDATE ruian_katastr SET nazev = 'Olšovice' WHERE kod = 689785;
UPDATE ruian_katastr SET nazev = 'Sedlovice' WHERE kod = 689793;
UPDATE ruian_katastr SET nazev = 'Machnín' WHERE kod = 689823;
UPDATE ruian_katastr SET nazev = 'Bělý' WHERE kod = 689831;
UPDATE ruian_katastr SET nazev = 'Machov' WHERE kod = 689840;
UPDATE ruian_katastr SET nazev = 'Machovská Lhota' WHERE kod = 689858;
UPDATE ruian_katastr SET nazev = 'Nízká Srbská' WHERE kod = 689866;
UPDATE ruian_katastr SET nazev = 'Machová' WHERE kod = 689882;
UPDATE ruian_katastr SET nazev = 'Majdalena' WHERE kod = 689904;
UPDATE ruian_katastr SET nazev = 'Majetín' WHERE kod = 689921;
UPDATE ruian_katastr SET nazev = 'Májůvka' WHERE kod = 689939;
UPDATE ruian_katastr SET nazev = 'Makotřasy' WHERE kod = 689947;
UPDATE ruian_katastr SET nazev = 'Makov u Jistebnice' WHERE kod = 689963;
UPDATE ruian_katastr SET nazev = 'Padařov' WHERE kod = 689971;
UPDATE ruian_katastr SET nazev = 'Vlásenice u Makova' WHERE kod = 689998;
UPDATE ruian_katastr SET nazev = 'Makov u Litomyšle' WHERE kod = 690007;
UPDATE ruian_katastr SET nazev = 'Makov' WHERE kod = 690015;
UPDATE ruian_katastr SET nazev = 'Malá Bělá' WHERE kod = 690023;
UPDATE ruian_katastr SET nazev = 'Malá Bukovina' WHERE kod = 690031;
UPDATE ruian_katastr SET nazev = 'Malá Bystřice' WHERE kod = 690040;
UPDATE ruian_katastr SET nazev = 'Malá Černoc' WHERE kod = 690066;
UPDATE ruian_katastr SET nazev = 'Malá Hraštice' WHERE kod = 690074;
UPDATE ruian_katastr SET nazev = 'Velká Hraštice' WHERE kod = 690091;
UPDATE ruian_katastr SET nazev = 'Malá Lečice' WHERE kod = 690104;
UPDATE ruian_katastr SET nazev = 'Malá Lhota' WHERE kod = 690112;
UPDATE ruian_katastr SET nazev = 'Malá Lhota u Valašského Meziříčí' WHERE kod = 690121;
UPDATE ruian_katastr SET nazev = 'Malá Losenice' WHERE kod = 690147;
UPDATE ruian_katastr SET nazev = 'Malá Morava' WHERE kod = 690155;
UPDATE ruian_katastr SET nazev = 'Sklené u Malé Moravy' WHERE kod = 690163;
UPDATE ruian_katastr SET nazev = 'Vlaské' WHERE kod = 690171;
UPDATE ruian_katastr SET nazev = 'Vojtíškov' WHERE kod = 690180;
UPDATE ruian_katastr SET nazev = 'Vysoká u Malé Moravy' WHERE kod = 690198;
UPDATE ruian_katastr SET nazev = 'Vysoký Potok' WHERE kod = 690201;
UPDATE ruian_katastr SET nazev = 'Zlatý Potok' WHERE kod = 690210;
UPDATE ruian_katastr SET nazev = 'Karlov pod Pradědem' WHERE kod = 690228;
UPDATE ruian_katastr SET nazev = 'Malá Morávka' WHERE kod = 690236;
UPDATE ruian_katastr SET nazev = 'Malá Roudka' WHERE kod = 690244;
UPDATE ruian_katastr SET nazev = 'Skočova Lhota' WHERE kod = 690252;
UPDATE ruian_katastr SET nazev = 'Sněhov' WHERE kod = 690317;
UPDATE ruian_katastr SET nazev = 'Vranové I' WHERE kod = 690325;
UPDATE ruian_katastr SET nazev = 'Vranové II' WHERE kod = 690333;
UPDATE ruian_katastr SET nazev = 'Malá Štáhle' WHERE kod = 690350;
UPDATE ruian_katastr SET nazev = 'Dolní Malá Úpa' WHERE kod = 690368;
UPDATE ruian_katastr SET nazev = 'Horní Malá Úpa' WHERE kod = 690376;
UPDATE ruian_katastr SET nazev = 'Malá Veleň' WHERE kod = 690392;
UPDATE ruian_katastr SET nazev = 'Malá Víska' WHERE kod = 690414;
UPDATE ruian_katastr SET nazev = 'Malá Vrbka' WHERE kod = 690422;
UPDATE ruian_katastr SET nazev = 'Malčín' WHERE kod = 690431;
UPDATE ruian_katastr SET nazev = 'Malé Březno' WHERE kod = 690449;
UPDATE ruian_katastr SET nazev = 'Leština u Malého Března' WHERE kod = 690465;
UPDATE ruian_katastr SET nazev = 'Vitín u Malého Března' WHERE kod = 690473;
UPDATE ruian_katastr SET nazev = 'Malé Březno nad Labem' WHERE kod = 690481;
UPDATE ruian_katastr SET nazev = 'Malé Heraltice' WHERE kod = 690490;
UPDATE ruian_katastr SET nazev = 'Malé Hradisko' WHERE kod = 690503;
UPDATE ruian_katastr SET nazev = 'Malé Kyšice' WHERE kod = 690520;
UPDATE ruian_katastr SET nazev = 'Malé Přílepy' WHERE kod = 690538;
UPDATE ruian_katastr SET nazev = 'Malé Přítočno' WHERE kod = 690554;
UPDATE ruian_katastr SET nazev = 'Malé Svatoňovice' WHERE kod = 690562;
UPDATE ruian_katastr SET nazev = 'Malé Všelisy' WHERE kod = 690571;
UPDATE ruian_katastr SET nazev = 'Malé Žernoseky' WHERE kod = 690589;
UPDATE ruian_katastr SET nazev = 'Maleč' WHERE kod = 690597;
UPDATE ruian_katastr SET nazev = 'Horní Lhotka' WHERE kod = 690627;
UPDATE ruian_katastr SET nazev = 'Hranice u Malče' WHERE kod = 690635;
UPDATE ruian_katastr SET nazev = 'Jeníkovec' WHERE kod = 690643;
UPDATE ruian_katastr SET nazev = 'Maleč u Chotěboře' WHERE kod = 690651;
UPDATE ruian_katastr SET nazev = 'Předboř u Malče' WHERE kod = 690660;
UPDATE ruian_katastr SET nazev = 'Březí u Malečova' WHERE kod = 690678;
UPDATE ruian_katastr SET nazev = 'Kojetice u Malečova' WHERE kod = 690686;
UPDATE ruian_katastr SET nazev = 'Malečov' WHERE kod = 690694;
UPDATE ruian_katastr SET nazev = 'Němčí u Malečova' WHERE kod = 690708;
UPDATE ruian_katastr SET nazev = 'Pohoří u Malečova' WHERE kod = 690716;
UPDATE ruian_katastr SET nazev = 'Malenice' WHERE kod = 690724;
UPDATE ruian_katastr SET nazev = 'Malenovice' WHERE kod = 690783;
UPDATE ruian_katastr SET nazev = 'Dolní Vlkýš' WHERE kod = 690813;
UPDATE ruian_katastr SET nazev = 'Malesice' WHERE kod = 690821;
UPDATE ruian_katastr SET nazev = 'Malešov' WHERE kod = 690830;
UPDATE ruian_katastr SET nazev = 'Polánka u Malešova' WHERE kod = 690856;
UPDATE ruian_katastr SET nazev = 'Týniště u Malešova' WHERE kod = 690864;
UPDATE ruian_katastr SET nazev = 'Malešovice' WHERE kod = 690872;
UPDATE ruian_katastr SET nazev = 'Javoří u Maletína' WHERE kod = 690881;
UPDATE ruian_katastr SET nazev = 'Nový Maletín' WHERE kod = 690899;
UPDATE ruian_katastr SET nazev = 'Starý Maletín' WHERE kod = 690902;
UPDATE ruian_katastr SET nazev = 'Malhostovice' WHERE kod = 690911;
UPDATE ruian_katastr SET nazev = 'Nuzířov' WHERE kod = 690929;
UPDATE ruian_katastr SET nazev = 'Malhotice' WHERE kod = 690937;
UPDATE ruian_katastr SET nazev = 'Malíkov' WHERE kod = 690945;
UPDATE ruian_katastr SET nazev = 'Malíkovice' WHERE kod = 690961;
UPDATE ruian_katastr SET nazev = 'Malínky' WHERE kod = 690970;
UPDATE ruian_katastr SET nazev = 'Malinová' WHERE kod = 690988;
UPDATE ruian_katastr SET nazev = 'Málkov u Suchomast' WHERE kod = 690996;
UPDATE ruian_katastr SET nazev = 'Ahníkov' WHERE kod = 691003;
UPDATE ruian_katastr SET nazev = 'Málkov u Chomutova' WHERE kod = 691011;
UPDATE ruian_katastr SET nazev = 'Zelená' WHERE kod = 691038;
UPDATE ruian_katastr SET nazev = 'Jindřichovice u Malonic' WHERE kod = 691046;
UPDATE ruian_katastr SET nazev = 'Malonice' WHERE kod = 691054;
UPDATE ruian_katastr SET nazev = 'Sluhov' WHERE kod = 691062;
UPDATE ruian_katastr SET nazev = 'Střítež u Malonic' WHERE kod = 691071;
UPDATE ruian_katastr SET nazev = 'Tajanov u Malonic' WHERE kod = 691089;
UPDATE ruian_katastr SET nazev = 'Bělá u Malont' WHERE kod = 691097;
UPDATE ruian_katastr SET nazev = 'Bukovsko' WHERE kod = 691101;
UPDATE ruian_katastr SET nazev = 'Jaroměř u Malont' WHERE kod = 691119;
UPDATE ruian_katastr SET nazev = 'Malonty' WHERE kod = 691127;
UPDATE ruian_katastr SET nazev = 'Meziříčí u Malont' WHERE kod = 691135;
UPDATE ruian_katastr SET nazev = 'Radčice u Malont' WHERE kod = 691143;
UPDATE ruian_katastr SET nazev = 'Hodonice u Malont' WHERE kod = 691151;
UPDATE ruian_katastr SET nazev = 'Rapotice u Malont' WHERE kod = 691160;
UPDATE ruian_katastr SET nazev = 'Lhotky u Malotic' WHERE kod = 691178;
UPDATE ruian_katastr SET nazev = 'Malotice' WHERE kod = 691186;
UPDATE ruian_katastr SET nazev = 'Krtely' WHERE kod = 691216;
UPDATE ruian_katastr SET nazev = 'Malovice u Netolic' WHERE kod = 691224;
UPDATE ruian_katastr SET nazev = 'Malovičky' WHERE kod = 691232;
UPDATE ruian_katastr SET nazev = 'Podeřiště' WHERE kod = 691241;
UPDATE ruian_katastr SET nazev = 'Bečice nad Lužnicí' WHERE kod = 691267;
UPDATE ruian_katastr SET nazev = 'Malšice' WHERE kod = 691275;
UPDATE ruian_katastr SET nazev = 'Malšova Lhota' WHERE kod = 691305;
UPDATE ruian_katastr SET nazev = 'Hliněná' WHERE kod = 691313;
UPDATE ruian_katastr SET nazev = 'Javory' WHERE kod = 691330;
UPDATE ruian_katastr SET nazev = 'Malšovice' WHERE kod = 691348;
UPDATE ruian_katastr SET nazev = 'Stará Bohyně' WHERE kod = 691364;
UPDATE ruian_katastr SET nazev = 'Kosov u Jihlavy' WHERE kod = 691372;
UPDATE ruian_katastr SET nazev = 'Malý Beranov' WHERE kod = 691381;
UPDATE ruian_katastr SET nazev = 'Malý Bor' WHERE kod = 691399;
UPDATE ruian_katastr SET nazev = 'Malý Jeníkov' WHERE kod = 691402;
UPDATE ruian_katastr SET nazev = 'Malý Pěčín' WHERE kod = 691411;
UPDATE ruian_katastr SET nazev = 'Jelenice u Mělníka' WHERE kod = 691429;
UPDATE ruian_katastr SET nazev = 'Malý Újezd' WHERE kod = 691437;
UPDATE ruian_katastr SET nazev = 'Brdo u Manětína' WHERE kod = 691453;
UPDATE ruian_katastr SET nazev = 'Česká Doubravice' WHERE kod = 691461;
UPDATE ruian_katastr SET nazev = 'Hrádek u Manětína' WHERE kod = 691470;
UPDATE ruian_katastr SET nazev = 'Lipí u Manětína' WHERE kod = 691488;
UPDATE ruian_katastr SET nazev = 'Manětín' WHERE kod = 691496;
UPDATE ruian_katastr SET nazev = 'Radějov u Manětína' WHERE kod = 691500;
UPDATE ruian_katastr SET nazev = 'Vladměřice' WHERE kod = 691518;
UPDATE ruian_katastr SET nazev = 'Vysočany u Manětína' WHERE kod = 691526;
UPDATE ruian_katastr SET nazev = 'Mankovice' WHERE kod = 691534;
UPDATE ruian_katastr SET nazev = 'Manušice' WHERE kod = 691542;
UPDATE ruian_katastr SET nazev = 'Marefy' WHERE kod = 691551;
UPDATE ruian_katastr SET nazev = 'Mariánské Lázně' WHERE kod = 691585;
UPDATE ruian_katastr SET nazev = 'Úšovice' WHERE kod = 691607;
UPDATE ruian_katastr SET nazev = 'Stanoviště u Mariánských Lázní' WHERE kod = 691674;
UPDATE ruian_katastr SET nazev = 'Mariánské Radčice' WHERE kod = 691691;
UPDATE ruian_katastr SET nazev = 'Marketa' WHERE kod = 691704;
UPDATE ruian_katastr SET nazev = 'Modletice' WHERE kod = 691712;
UPDATE ruian_katastr SET nazev = 'Markoušovice' WHERE kod = 691721;
UPDATE ruian_katastr SET nazev = 'Starý Sedloňov' WHERE kod = 691747;
UPDATE ruian_katastr SET nazev = 'Lipnice u Markvarce' WHERE kod = 691755;
UPDATE ruian_katastr SET nazev = 'Markvarec' WHERE kod = 691763;
UPDATE ruian_katastr SET nazev = 'Markvarec u Nové Cerekve' WHERE kod = 691771;
UPDATE ruian_katastr SET nazev = 'Markvartice u Děčína' WHERE kod = 691780;
UPDATE ruian_katastr SET nazev = 'Markvartice u Sobotky' WHERE kod = 691801;
UPDATE ruian_katastr SET nazev = 'Příchvoj' WHERE kod = 691836;
UPDATE ruian_katastr SET nazev = 'Rakov u Markvartic' WHERE kod = 691844;
UPDATE ruian_katastr SET nazev = 'Skuřina' WHERE kod = 691852;
UPDATE ruian_katastr SET nazev = 'Markvartice' WHERE kod = 691879;
UPDATE ruian_katastr SET nazev = 'Markvartice u Třebíče' WHERE kod = 691887;
UPDATE ruian_katastr SET nazev = 'Markvartovice' WHERE kod = 691895;
UPDATE ruian_katastr SET nazev = 'Maršíkov' WHERE kod = 691909;
UPDATE ruian_katastr SET nazev = 'Maršov u Tábora' WHERE kod = 691917;
UPDATE ruian_katastr SET nazev = 'Obora u Maršova' WHERE kod = 691925;
UPDATE ruian_katastr SET nazev = 'Zhoř u Tábora' WHERE kod = 691933;
UPDATE ruian_katastr SET nazev = 'Maršov u Veverské Bítýšky' WHERE kod = 691941;
UPDATE ruian_katastr SET nazev = 'Maršov u Uherského Brodu' WHERE kod = 691950;
UPDATE ruian_katastr SET nazev = 'Maršov u Úpice' WHERE kod = 691968;
UPDATE ruian_katastr SET nazev = 'Maršovice u Benešova' WHERE kod = 691976;
UPDATE ruian_katastr SET nazev = 'Dalešice u Jablonce nad Nisou' WHERE kod = 691992;
UPDATE ruian_katastr SET nazev = 'Maršovice u Jablonce nad Nisou' WHERE kod = 692000;
UPDATE ruian_katastr SET nazev = 'Charvatce u Martiněvsi' WHERE kod = 692018;
UPDATE ruian_katastr SET nazev = 'Martiněves u Libochovic' WHERE kod = 692026;
UPDATE ruian_katastr SET nazev = 'Beztahov' WHERE kod = 692034;
UPDATE ruian_katastr SET nazev = 'Martinice u Votic' WHERE kod = 692051;
UPDATE ruian_katastr SET nazev = 'Martinice u Březnice' WHERE kod = 692085;
UPDATE ruian_katastr SET nazev = 'Martinice u Skutče' WHERE kod = 692093;
UPDATE ruian_katastr SET nazev = 'Martinice u Holešova' WHERE kod = 692107;
UPDATE ruian_katastr SET nazev = 'Martinice u Velkého Meziříčí' WHERE kod = 692115;
UPDATE ruian_katastr SET nazev = 'Martinice u Dolních Kralovic' WHERE kod = 692123;
UPDATE ruian_katastr SET nazev = 'Chyšná' WHERE kod = 692131;
UPDATE ruian_katastr SET nazev = 'Martinice u Onšova' WHERE kod = 692140;
UPDATE ruian_katastr SET nazev = 'Skoranovice' WHERE kod = 692158;
UPDATE ruian_katastr SET nazev = 'Martínkovice' WHERE kod = 692166;
UPDATE ruian_katastr SET nazev = 'Mařenice' WHERE kod = 692174;
UPDATE ruian_katastr SET nazev = 'Mařeničky' WHERE kod = 692182;
UPDATE ruian_katastr SET nazev = 'Masečín' WHERE kod = 692204;
UPDATE ruian_katastr SET nazev = 'Máslojedy' WHERE kod = 692212;
UPDATE ruian_katastr SET nazev = 'Máslovice' WHERE kod = 692221;
UPDATE ruian_katastr SET nazev = 'Mastník' WHERE kod = 692239;
UPDATE ruian_katastr SET nazev = 'Mašovice u Znojma' WHERE kod = 692247;
UPDATE ruian_katastr SET nazev = 'Dobřenec' WHERE kod = 692255;
UPDATE ruian_katastr SET nazev = 'Konice u Mašťova' WHERE kod = 692271;
UPDATE ruian_katastr SET nazev = 'Mašťov' WHERE kod = 692280;
UPDATE ruian_katastr SET nazev = 'Matějov' WHERE kod = 692298;
UPDATE ruian_katastr SET nazev = 'Matějovec' WHERE kod = 692301;
UPDATE ruian_katastr SET nazev = 'Matějovice' WHERE kod = 692328;
UPDATE ruian_katastr SET nazev = 'Maxov' WHERE kod = 692336;
UPDATE ruian_katastr SET nazev = 'Mcely' WHERE kod = 692344;
UPDATE ruian_katastr SET nazev = 'Březí u Meclova' WHERE kod = 692352;
UPDATE ruian_katastr SET nazev = 'Mašovice u Meclova' WHERE kod = 692361;
UPDATE ruian_katastr SET nazev = 'Meclov' WHERE kod = 692379;
UPDATE ruian_katastr SET nazev = 'Mračnice' WHERE kod = 692387;
UPDATE ruian_katastr SET nazev = 'Mečeříž' WHERE kod = 692395;
UPDATE ruian_katastr SET nazev = 'Mečichov' WHERE kod = 692409;
UPDATE ruian_katastr SET nazev = 'Bíluky' WHERE kod = 692417;
UPDATE ruian_katastr SET nazev = 'Měčín' WHERE kod = 692441;
UPDATE ruian_katastr SET nazev = 'Nedanice' WHERE kod = 692450;
UPDATE ruian_katastr SET nazev = 'Nedaničky' WHERE kod = 692468;
UPDATE ruian_katastr SET nazev = 'Petrovice u Měčína' WHERE kod = 692484;
UPDATE ruian_katastr SET nazev = 'Radkovice u Měčína' WHERE kod = 692492;
UPDATE ruian_katastr SET nazev = 'Třebýcina' WHERE kod = 692506;
UPDATE ruian_katastr SET nazev = 'Mečíř' WHERE kod = 692514;
UPDATE ruian_katastr SET nazev = 'Horní Halže' WHERE kod = 692522;
UPDATE ruian_katastr SET nazev = 'Kamenné' WHERE kod = 692531;
UPDATE ruian_katastr SET nazev = 'Měděnec' WHERE kod = 692549;
UPDATE ruian_katastr SET nazev = 'Mýtinka' WHERE kod = 692557;
UPDATE ruian_katastr SET nazev = 'Vykmanov u Měděnce' WHERE kod = 692565;
UPDATE ruian_katastr SET nazev = 'Medlešice' WHERE kod = 692573;
UPDATE ruian_katastr SET nazev = 'Medlice' WHERE kod = 692581;
UPDATE ruian_katastr SET nazev = 'Medlov' WHERE kod = 692590;
UPDATE ruian_katastr SET nazev = 'Medlov u Uničova' WHERE kod = 692611;
UPDATE ruian_katastr SET nazev = 'Zadní Újezd' WHERE kod = 692620;
UPDATE ruian_katastr SET nazev = 'Medlovice u Uherského Hradiště' WHERE kod = 692638;
UPDATE ruian_katastr SET nazev = 'Medlovice' WHERE kod = 692654;
UPDATE ruian_katastr SET nazev = 'Rybníček' WHERE kod = 692662;
UPDATE ruian_katastr SET nazev = 'Kocourov u Medvědic' WHERE kod = 692671;
UPDATE ruian_katastr SET nazev = 'Lhota u Medvědic' WHERE kod = 692689;
UPDATE ruian_katastr SET nazev = 'Medvědice' WHERE kod = 692697;
UPDATE ruian_katastr SET nazev = 'Mrsklesy' WHERE kod = 692701;
UPDATE ruian_katastr SET nazev = 'Měchenice' WHERE kod = 692719;
UPDATE ruian_katastr SET nazev = 'Měchnov' WHERE kod = 692727;
UPDATE ruian_katastr SET nazev = 'Měcholupy u Blovic' WHERE kod = 692743;
UPDATE ruian_katastr SET nazev = 'Měcholupy u Žatce' WHERE kod = 692751;
UPDATE ruian_katastr SET nazev = 'Milošice' WHERE kod = 692760;
UPDATE ruian_katastr SET nazev = 'Melč' WHERE kod = 692778;
UPDATE ruian_katastr SET nazev = 'Mělčany u Ivančic' WHERE kod = 692786;
UPDATE ruian_katastr SET nazev = 'Mělice' WHERE kod = 692794;
UPDATE ruian_katastr SET nazev = 'Mělnické Vtelno' WHERE kod = 692808;
UPDATE ruian_katastr SET nazev = 'Mělník' WHERE kod = 692816;
UPDATE ruian_katastr SET nazev = 'Vehlovice' WHERE kod = 692999;
UPDATE ruian_katastr SET nazev = 'Korno' WHERE kod = 693006;
UPDATE ruian_katastr SET nazev = 'Měňany' WHERE kod = 693014;
UPDATE ruian_katastr SET nazev = 'Tobolka' WHERE kod = 693022;
UPDATE ruian_katastr SET nazev = 'Lovčovice' WHERE kod = 693031;
UPDATE ruian_katastr SET nazev = 'Menhartice' WHERE kod = 693049;
UPDATE ruian_katastr SET nazev = 'Bydžovská Lhotka' WHERE kod = 693057;
UPDATE ruian_katastr SET nazev = 'Měník u Nového Bydžova' WHERE kod = 693073;
UPDATE ruian_katastr SET nazev = 'Měnín' WHERE kod = 693090;
UPDATE ruian_katastr SET nazev = 'Mentour' WHERE kod = 693103;
UPDATE ruian_katastr SET nazev = 'Merboltice' WHERE kod = 693111;
UPDATE ruian_katastr SET nazev = 'Lípa' WHERE kod = 693120;
UPDATE ruian_katastr SET nazev = 'Merklín u Karlových Var' WHERE kod = 693138;
UPDATE ruian_katastr SET nazev = 'Oldřiš u Merklína' WHERE kod = 693146;
UPDATE ruian_katastr SET nazev = 'Pstruží u Merklína' WHERE kod = 693154;
UPDATE ruian_katastr SET nazev = 'Buková u Merklína' WHERE kod = 693162;
UPDATE ruian_katastr SET nazev = 'Kloušov' WHERE kod = 693171;
UPDATE ruian_katastr SET nazev = 'Merklín u Přeštic' WHERE kod = 693197;
UPDATE ruian_katastr SET nazev = 'Merklovice' WHERE kod = 693201;
UPDATE ruian_katastr SET nazev = 'Měrovice nad Hanou' WHERE kod = 693219;
UPDATE ruian_katastr SET nazev = 'Měrunice' WHERE kod = 693227;
UPDATE ruian_katastr SET nazev = 'Žichov' WHERE kod = 693235;
UPDATE ruian_katastr SET nazev = 'Měřín' WHERE kod = 693243;
UPDATE ruian_katastr SET nazev = 'Pustina u Měřína' WHERE kod = 693251;
UPDATE ruian_katastr SET nazev = 'Na Pouštích' WHERE kod = 693260;
UPDATE ruian_katastr SET nazev = 'Městec' WHERE kod = 693278;
UPDATE ruian_katastr SET nazev = 'Městec Králové' WHERE kod = 693286;
UPDATE ruian_katastr SET nazev = 'Vinice u Městce Králové' WHERE kod = 693308;
UPDATE ruian_katastr SET nazev = 'Městečko u Křivoklátu' WHERE kod = 693316;
UPDATE ruian_katastr SET nazev = 'Městečko Trnávka' WHERE kod = 693341;
UPDATE ruian_katastr SET nazev = 'Mezihoří u Městečka Trnávky' WHERE kod = 693359;
UPDATE ruian_katastr SET nazev = 'Stará Trnávka' WHERE kod = 693367;
UPDATE ruian_katastr SET nazev = 'Burkvíz' WHERE kod = 693375;
UPDATE ruian_katastr SET nazev = 'Česká Ves u Města Albrechtic' WHERE kod = 693383;
UPDATE ruian_katastr SET nazev = 'Město Albrechtice' WHERE kod = 693391;
UPDATE ruian_katastr SET nazev = 'Piskořov' WHERE kod = 693405;
UPDATE ruian_katastr SET nazev = 'Město Libavá' WHERE kod = 693421;
UPDATE ruian_katastr SET nazev = 'Město Touškov' WHERE kod = 693430;
UPDATE ruian_katastr SET nazev = 'Měšice u Prahy' WHERE kod = 693448;
UPDATE ruian_katastr SET nazev = 'Měšice u Tábora' WHERE kod = 693456;
UPDATE ruian_katastr SET nazev = 'Měšín' WHERE kod = 693481;
UPDATE ruian_katastr SET nazev = 'Kakejcov' WHERE kod = 693502;
UPDATE ruian_katastr SET nazev = 'Kornatice' WHERE kod = 693511;
UPDATE ruian_katastr SET nazev = 'Mešno' WHERE kod = 693529;
UPDATE ruian_katastr SET nazev = 'Metly' WHERE kod = 693537;
UPDATE ruian_katastr SET nazev = 'Metylovice' WHERE kod = 693545;
UPDATE ruian_katastr SET nazev = 'Mezholezy u Černíkova' WHERE kod = 693553;
UPDATE ruian_katastr SET nazev = 'Mezholezy u Horšovského Týna' WHERE kod = 693561;
UPDATE ruian_katastr SET nazev = 'Luková u Manětína' WHERE kod = 693570;
UPDATE ruian_katastr SET nazev = 'Mezí' WHERE kod = 693588;
UPDATE ruian_katastr SET nazev = 'Zhořec u Manětína' WHERE kod = 693596;
UPDATE ruian_katastr SET nazev = 'Meziboří u Litvínova' WHERE kod = 693600;
UPDATE ruian_katastr SET nazev = 'Křižanov u Mezilečí' WHERE kod = 693618;
UPDATE ruian_katastr SET nazev = 'Mezilečí' WHERE kod = 693634;
UPDATE ruian_katastr SET nazev = 'Posadov' WHERE kod = 693642;
UPDATE ruian_katastr SET nazev = 'Mezilesí' WHERE kod = 693669;
UPDATE ruian_katastr SET nazev = 'Mezilesí u Náchoda' WHERE kod = 693685;
UPDATE ruian_katastr SET nazev = 'Meziměstí' WHERE kod = 693693;
UPDATE ruian_katastr SET nazev = 'Vižňov' WHERE kod = 693723;
UPDATE ruian_katastr SET nazev = 'Mezina' WHERE kod = 693731;
UPDATE ruian_katastr SET nazev = 'Meziříčko u Letovic' WHERE kod = 693740;
UPDATE ruian_katastr SET nazev = 'Meziříčko u Jihlavy' WHERE kod = 693758;
UPDATE ruian_katastr SET nazev = 'Meziříčko u Moravských Budějovic' WHERE kod = 693766;
UPDATE ruian_katastr SET nazev = 'Mezná u Pelhřimova' WHERE kod = 693774;
UPDATE ruian_katastr SET nazev = 'Vratišov u Mezné' WHERE kod = 693782;
UPDATE ruian_katastr SET nazev = 'Mezná u Soběslavi' WHERE kod = 693791;
UPDATE ruian_katastr SET nazev = 'Mezná u Hřenska' WHERE kod = 693804;
UPDATE ruian_katastr SET nazev = 'Lažany u Mezna' WHERE kod = 693821;
UPDATE ruian_katastr SET nazev = 'Mezno' WHERE kod = 693839;
UPDATE ruian_katastr SET nazev = 'Mitrovice' WHERE kod = 693847;
UPDATE ruian_katastr SET nazev = 'Stupčice' WHERE kod = 693855;
UPDATE ruian_katastr SET nazev = 'Mezouň' WHERE kod = 693863;
UPDATE ruian_katastr SET nazev = 'Jetonice' WHERE kod = 693871;
UPDATE ruian_katastr SET nazev = 'Míčov' WHERE kod = 693880;
UPDATE ruian_katastr SET nazev = 'Rudov' WHERE kod = 693898;
UPDATE ruian_katastr SET nazev = 'Sušice' WHERE kod = 693901;
UPDATE ruian_katastr SET nazev = 'Zbyslavec' WHERE kod = 693910;
UPDATE ruian_katastr SET nazev = 'Frantoly' WHERE kod = 693928;
UPDATE ruian_katastr SET nazev = 'Jáma' WHERE kod = 693936;
UPDATE ruian_katastr SET nazev = 'Klenovice u Mičovic' WHERE kod = 693944;
UPDATE ruian_katastr SET nazev = 'Mičovice' WHERE kod = 693952;
UPDATE ruian_katastr SET nazev = 'Ratiborova Lhota' WHERE kod = 693961;
UPDATE ruian_katastr SET nazev = 'Michalovice u Havlíčkova Brodu' WHERE kod = 693979;
UPDATE ruian_katastr SET nazev = 'Šmolovy u Havlíčkova Brodu' WHERE kod = 693987;
UPDATE ruian_katastr SET nazev = 'Boněnov' WHERE kod = 693995;
UPDATE ruian_katastr SET nazev = 'Hostíčkov' WHERE kod = 694002;
UPDATE ruian_katastr SET nazev = 'Michalovy Hory' WHERE kod = 694011;
UPDATE ruian_katastr SET nazev = 'Domaslavičky' WHERE kod = 694029;
UPDATE ruian_katastr SET nazev = 'Výškovice u Michalových Hor' WHERE kod = 694037;
UPDATE ruian_katastr SET nazev = 'Míchov u Boskovic' WHERE kod = 694045;
UPDATE ruian_katastr SET nazev = 'Podolí u Míchova' WHERE kod = 694053;
UPDATE ruian_katastr SET nazev = 'Mikolajice' WHERE kod = 694061;
UPDATE ruian_katastr SET nazev = 'Míkovice nad Olšavou' WHERE kod = 694070;
UPDATE ruian_katastr SET nazev = 'Svatá Kateřina u Svatého Mikuláše' WHERE kod = 694088;
UPDATE ruian_katastr SET nazev = 'Svatý Mikuláš' WHERE kod = 694096;
UPDATE ruian_katastr SET nazev = 'Rohozec u Žehušic' WHERE kod = 694100;
UPDATE ruian_katastr SET nazev = 'Mikulášov' WHERE kod = 694118;
UPDATE ruian_katastr SET nazev = 'Mikulášovice' WHERE kod = 694126;
UPDATE ruian_katastr SET nazev = 'Mikulčice' WHERE kod = 694142;
UPDATE ruian_katastr SET nazev = 'Kukle' WHERE kod = 694169;
UPDATE ruian_katastr SET nazev = 'Mikuleč' WHERE kod = 694177;
UPDATE ruian_katastr SET nazev = 'Mikulov v Krušných horách' WHERE kod = 694185;
UPDATE ruian_katastr SET nazev = 'Mikulov na Moravě' WHERE kod = 694193;
UPDATE ruian_katastr SET nazev = 'Mikulovice u Vernéřova' WHERE kod = 694355;
UPDATE ruian_katastr SET nazev = 'Blato' WHERE kod = 694363;
UPDATE ruian_katastr SET nazev = 'Mikulovice u Pardubic' WHERE kod = 694371;
UPDATE ruian_katastr SET nazev = 'Mikulovice' WHERE kod = 694380;
UPDATE ruian_katastr SET nazev = 'Mikulovice u Znojma' WHERE kod = 694398;
UPDATE ruian_katastr SET nazev = 'Kolnovice' WHERE kod = 694401;
UPDATE ruian_katastr SET nazev = 'Mikulovice u Jeseníka' WHERE kod = 694410;
UPDATE ruian_katastr SET nazev = 'Široký Brod' WHERE kod = 694428;
UPDATE ruian_katastr SET nazev = 'Mikulůvka' WHERE kod = 694479;
UPDATE ruian_katastr SET nazev = 'Milavče' WHERE kod = 694509;
UPDATE ruian_katastr SET nazev = 'Nahošice' WHERE kod = 694517;
UPDATE ruian_katastr SET nazev = 'Výrov u Milavčí' WHERE kod = 694525;
UPDATE ruian_katastr SET nazev = 'Milčice u Peček' WHERE kod = 694533;
UPDATE ruian_katastr SET nazev = 'Bezděkovec' WHERE kod = 694541;
UPDATE ruian_katastr SET nazev = 'Maňovice' WHERE kod = 694550;
UPDATE ruian_katastr SET nazev = 'Mileč' WHERE kod = 694568;
UPDATE ruian_katastr SET nazev = 'Záhoří u Milče' WHERE kod = 694576;
UPDATE ruian_katastr SET nazev = 'Želvice' WHERE kod = 694584;
UPDATE ruian_katastr SET nazev = 'Milenov' WHERE kod = 694592;
UPDATE ruian_katastr SET nazev = 'Orlické Zlákovice' WHERE kod = 694614;
UPDATE ruian_katastr SET nazev = 'Milešov nad Vltavou' WHERE kod = 694622;
UPDATE ruian_katastr SET nazev = 'Přední Chlum' WHERE kod = 694631;
UPDATE ruian_katastr SET nazev = 'Milešov u Lovosic' WHERE kod = 694649;
UPDATE ruian_katastr SET nazev = 'Milešovice' WHERE kod = 694657;
UPDATE ruian_katastr SET nazev = 'Miletín' WHERE kod = 694665;
UPDATE ruian_katastr SET nazev = 'Milevsko' WHERE kod = 694673;
UPDATE ruian_katastr SET nazev = 'Rukáveč' WHERE kod = 694762;
UPDATE ruian_katastr SET nazev = 'Děvín' WHERE kod = 694771;
UPDATE ruian_katastr SET nazev = 'Dolní Částkov' WHERE kod = 694789;
UPDATE ruian_katastr SET nazev = 'Hluboká u Milhostova' WHERE kod = 694797;
UPDATE ruian_katastr SET nazev = 'Horka u Milhostova' WHERE kod = 694801;
UPDATE ruian_katastr SET nazev = 'Milhostov' WHERE kod = 694819;
UPDATE ruian_katastr SET nazev = 'Vackovec' WHERE kod = 694827;
UPDATE ruian_katastr SET nazev = 'Doubrava u Milhostova' WHERE kod = 694835;
UPDATE ruian_katastr SET nazev = 'Malovice u Miličína' WHERE kod = 694843;
UPDATE ruian_katastr SET nazev = 'Miličín' WHERE kod = 694851;
UPDATE ruian_katastr SET nazev = 'Záhoří u Miličína' WHERE kod = 694878;
UPDATE ruian_katastr SET nazev = 'Milíčov u Jihlavy' WHERE kod = 694894;
UPDATE ruian_katastr SET nazev = 'Milíčovice' WHERE kod = 694908;
UPDATE ruian_katastr SET nazev = 'Malá Šitboř' WHERE kod = 694916;
UPDATE ruian_katastr SET nazev = 'Milíkov u Mariánských Lázní' WHERE kod = 694924;
UPDATE ruian_katastr SET nazev = 'Těšov u Milíkova' WHERE kod = 694932;
UPDATE ruian_katastr SET nazev = 'Milíkov u Jablunkova' WHERE kod = 694941;
UPDATE ruian_katastr SET nazev = 'Milín' WHERE kod = 694975;
UPDATE ruian_katastr SET nazev = 'Bačalky' WHERE kod = 694991;
UPDATE ruian_katastr SET nazev = 'Lično u Milkovic' WHERE kod = 695009;
UPDATE ruian_katastr SET nazev = 'Záhuby' WHERE kod = 695025;
UPDATE ruian_katastr SET nazev = 'Zelenecká Lhota' WHERE kod = 695033;
UPDATE ruian_katastr SET nazev = 'Milonice' WHERE kod = 695041;
UPDATE ruian_katastr SET nazev = 'Uhřice' WHERE kod = 695068;
UPDATE ruian_katastr SET nazev = 'Milonice u Lipůvky' WHERE kod = 695076;
UPDATE ruian_katastr SET nazev = 'Závist' WHERE kod = 695084;
UPDATE ruian_katastr SET nazev = 'Miloňovice' WHERE kod = 695092;
UPDATE ruian_katastr SET nazev = 'Sudkovice' WHERE kod = 695114;
UPDATE ruian_katastr SET nazev = 'Milostín' WHERE kod = 695122;
UPDATE ruian_katastr SET nazev = 'Milostovice' WHERE kod = 695149;
UPDATE ruian_katastr SET nazev = 'Milotice u Kyjova' WHERE kod = 695157;
UPDATE ruian_katastr SET nazev = 'Milotice nad Bečvou' WHERE kod = 695165;
UPDATE ruian_katastr SET nazev = 'Jelení u Bruntálu' WHERE kod = 695173;
UPDATE ruian_katastr SET nazev = 'Milotice nad Opavou' WHERE kod = 695181;
UPDATE ruian_katastr SET nazev = 'Milovice nad Labem' WHERE kod = 695190;
UPDATE ruian_katastr SET nazev = 'Milovice u Hořic' WHERE kod = 695203;
UPDATE ruian_katastr SET nazev = 'Milovice u Mikulova' WHERE kod = 695211;
UPDATE ruian_katastr SET nazev = 'České Milovy' WHERE kod = 695220;
UPDATE ruian_katastr SET nazev = 'Milý' WHERE kod = 695246;
UPDATE ruian_katastr SET nazev = 'Mimoň' WHERE kod = 695254;
UPDATE ruian_katastr SET nazev = 'Pertoltice pod Ralskem' WHERE kod = 695262;
UPDATE ruian_katastr SET nazev = 'Vranov pod Ralskem' WHERE kod = 695289;
UPDATE ruian_katastr SET nazev = 'Chabičovice' WHERE kod = 695297;
UPDATE ruian_katastr SET nazev = 'Malčice' WHERE kod = 695301;
UPDATE ruian_katastr SET nazev = 'Mirkovice' WHERE kod = 695319;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Mirkovic' WHERE kod = 695335;
UPDATE ruian_katastr SET nazev = 'Žaltice' WHERE kod = 695343;
UPDATE ruian_katastr SET nazev = 'Mirochov' WHERE kod = 695351;
UPDATE ruian_katastr SET nazev = 'Miroslav' WHERE kod = 695378;
UPDATE ruian_katastr SET nazev = 'Miroslavské Knínice' WHERE kod = 695394;
UPDATE ruian_katastr SET nazev = 'Mirošov' WHERE kod = 695424;
UPDATE ruian_katastr SET nazev = 'Mirošov u Jihlavy' WHERE kod = 695459;
UPDATE ruian_katastr SET nazev = 'Mirošov u Bobrové' WHERE kod = 695467;
UPDATE ruian_katastr SET nazev = 'Mirošovice u Říčan' WHERE kod = 695475;
UPDATE ruian_katastr SET nazev = 'Boudy' WHERE kod = 695483;
UPDATE ruian_katastr SET nazev = 'Lučkovice' WHERE kod = 695491;
UPDATE ruian_katastr SET nazev = 'Mirotice' WHERE kod = 695505;
UPDATE ruian_katastr SET nazev = 'Mirotínek' WHERE kod = 695513;
UPDATE ruian_katastr SET nazev = 'Mírov' WHERE kod = 695521;
UPDATE ruian_katastr SET nazev = 'Míroveček' WHERE kod = 695530;
UPDATE ruian_katastr SET nazev = 'Mírovský Grunt' WHERE kod = 695548;
UPDATE ruian_katastr SET nazev = 'Mírová' WHERE kod = 695556;
UPDATE ruian_katastr SET nazev = 'Bělá u Turnova' WHERE kod = 695572;
UPDATE ruian_katastr SET nazev = 'Loktuše' WHERE kod = 695637;
UPDATE ruian_katastr SET nazev = 'Sekerkovy Loučky' WHERE kod = 695670;
UPDATE ruian_katastr SET nazev = 'Vesec pod Kozákovem' WHERE kod = 695700;
UPDATE ruian_katastr SET nazev = 'Mirovice' WHERE kod = 695726;
UPDATE ruian_katastr SET nazev = 'Bartoušov' WHERE kod = 695734;
UPDATE ruian_katastr SET nazev = 'Mírovka' WHERE kod = 695769;
UPDATE ruian_katastr SET nazev = 'Vysoká u Havlíčkova Brodu' WHERE kod = 695785;
UPDATE ruian_katastr SET nazev = 'Miřejovice' WHERE kod = 695793;
UPDATE ruian_katastr SET nazev = 'Letovy' WHERE kod = 695815;
UPDATE ruian_katastr SET nazev = 'Miřenice' WHERE kod = 695823;
UPDATE ruian_katastr SET nazev = 'Otěšín' WHERE kod = 695840;
UPDATE ruian_katastr SET nazev = 'Miřetice' WHERE kod = 695858;
UPDATE ruian_katastr SET nazev = 'Havlovice u Miřetic' WHERE kod = 695891;
UPDATE ruian_katastr SET nazev = 'Miřetice u Nasavrk' WHERE kod = 695921;
UPDATE ruian_katastr SET nazev = 'Miřetín' WHERE kod = 695947;
UPDATE ruian_katastr SET nazev = 'Mířkov' WHERE kod = 695955;
UPDATE ruian_katastr SET nazev = 'Bylany u Kutné Hory' WHERE kod = 695963;
UPDATE ruian_katastr SET nazev = 'Hořany u Kutné Hory' WHERE kod = 695971;
UPDATE ruian_katastr SET nazev = 'Mezholezy u Kutné Hory' WHERE kod = 695980;
UPDATE ruian_katastr SET nazev = 'Miskovice' WHERE kod = 695998;
UPDATE ruian_katastr SET nazev = 'Přítoky' WHERE kod = 696005;
UPDATE ruian_katastr SET nazev = 'Blahuňov' WHERE kod = 696013;
UPDATE ruian_katastr SET nazev = 'Lideň' WHERE kod = 696021;
UPDATE ruian_katastr SET nazev = 'Místo' WHERE kod = 696030;
UPDATE ruian_katastr SET nazev = 'Vysoká u Chomutova' WHERE kod = 696048;
UPDATE ruian_katastr SET nazev = 'Vysoká Jedle' WHERE kod = 696056;
UPDATE ruian_katastr SET nazev = 'Mistrovice nad Orlicí' WHERE kod = 696064;
UPDATE ruian_katastr SET nazev = 'Javorovec' WHERE kod = 696072;
UPDATE ruian_katastr SET nazev = 'Mistřice I' WHERE kod = 696081;
UPDATE ruian_katastr SET nazev = 'Mistřice II' WHERE kod = 696099;
UPDATE ruian_katastr SET nazev = 'Koňákov' WHERE kod = 696111;
UPDATE ruian_katastr SET nazev = 'Mistřovice' WHERE kod = 696129;
UPDATE ruian_katastr SET nazev = 'Mosty u Českého Těšína' WHERE kod = 696137;
UPDATE ruian_katastr SET nazev = 'Míškovice' WHERE kod = 696161;
UPDATE ruian_katastr SET nazev = 'Kakovice' WHERE kod = 696170;
UPDATE ruian_katastr SET nazev = 'Minice u Mišovic' WHERE kod = 696188;
UPDATE ruian_katastr SET nazev = 'Mišovice' WHERE kod = 696196;
UPDATE ruian_katastr SET nazev = 'Pohoří u Mirovic' WHERE kod = 696200;
UPDATE ruian_katastr SET nazev = 'Kochánov u Mitrova' WHERE kod = 696234;
UPDATE ruian_katastr SET nazev = 'Mitrov u Uhlířských Janovic' WHERE kod = 696251;
UPDATE ruian_katastr SET nazev = 'Opatovice II' WHERE kod = 696269;
UPDATE ruian_katastr SET nazev = 'Mladá Boleslav' WHERE kod = 696293;
UPDATE ruian_katastr SET nazev = 'Jemníky u Mladé Boleslavi' WHERE kod = 696455;
UPDATE ruian_katastr SET nazev = 'Bezděčín u Mladé Boleslavi' WHERE kod = 696579;
UPDATE ruian_katastr SET nazev = 'Chrást u Mladé Boleslavi' WHERE kod = 696587;
UPDATE ruian_katastr SET nazev = 'Čejetice u Mladé Boleslavi' WHERE kod = 696641;
UPDATE ruian_katastr SET nazev = 'Debř' WHERE kod = 696692;
UPDATE ruian_katastr SET nazev = 'Mladá Vožice' WHERE kod = 696722;
UPDATE ruian_katastr SET nazev = 'Mladé Bříště' WHERE kod = 696765;
UPDATE ruian_katastr SET nazev = 'Hertvíkovice' WHERE kod = 696781;
UPDATE ruian_katastr SET nazev = 'Kalná Voda' WHERE kod = 696790;
UPDATE ruian_katastr SET nazev = 'Mladé Buky' WHERE kod = 696803;
UPDATE ruian_katastr SET nazev = 'Sklenářovice' WHERE kod = 696811;
UPDATE ruian_katastr SET nazev = 'Mladecko' WHERE kod = 696820;
UPDATE ruian_katastr SET nazev = 'Měrotín' WHERE kod = 696846;
UPDATE ruian_katastr SET nazev = 'Mladeč' WHERE kod = 696854;
UPDATE ruian_katastr SET nazev = 'Sobáčov' WHERE kod = 696862;
UPDATE ruian_katastr SET nazev = 'Hubojedy' WHERE kod = 696871;
UPDATE ruian_katastr SET nazev = 'Mladějov v Čechách' WHERE kod = 696897;
UPDATE ruian_katastr SET nazev = 'Mladějov na Moravě' WHERE kod = 696927;
UPDATE ruian_katastr SET nazev = 'Mladějovice' WHERE kod = 696935;
UPDATE ruian_katastr SET nazev = 'Sedliště u Mladějovic' WHERE kod = 696943;
UPDATE ruian_katastr SET nazev = 'Komárov u Mladějovic' WHERE kod = 696960;
UPDATE ruian_katastr SET nazev = 'Mladějovice u Šternberka' WHERE kod = 696978;
UPDATE ruian_katastr SET nazev = 'Řídeč' WHERE kod = 696986;
UPDATE ruian_katastr SET nazev = 'Mladkov' WHERE kod = 696994;
UPDATE ruian_katastr SET nazev = 'Petrovičky u Mladkova' WHERE kod = 697001;
UPDATE ruian_katastr SET nazev = 'Mladoňov u Oskavy' WHERE kod = 697010;
UPDATE ruian_katastr SET nazev = 'Václavov u Oskavy' WHERE kod = 697028;
UPDATE ruian_katastr SET nazev = 'Čejkovice u Mladoňovic' WHERE kod = 697036;
UPDATE ruian_katastr SET nazev = 'Deblov' WHERE kod = 697044;
UPDATE ruian_katastr SET nazev = 'Petříkovice u Mladoňovic' WHERE kod = 697079;
UPDATE ruian_katastr SET nazev = 'Pohled u Mladoňovic' WHERE kod = 697087;
UPDATE ruian_katastr SET nazev = 'Mladoňovice na Moravě' WHERE kod = 697117;
UPDATE ruian_katastr SET nazev = 'Mladošovice' WHERE kod = 697125;
UPDATE ruian_katastr SET nazev = 'Černá Hať' WHERE kod = 697133;
UPDATE ruian_katastr SET nazev = 'Chrášťovice u Mladotic' WHERE kod = 697141;
UPDATE ruian_katastr SET nazev = 'Mladotice' WHERE kod = 697150;
UPDATE ruian_katastr SET nazev = 'Strážiště u Mladotic' WHERE kod = 697168;
UPDATE ruian_katastr SET nazev = 'Mladotice nad Doubravou' WHERE kod = 697176;
UPDATE ruian_katastr SET nazev = 'Budislavice' WHERE kod = 697184;
UPDATE ruian_katastr SET nazev = 'Mladý Smolivec' WHERE kod = 697192;
UPDATE ruian_katastr SET nazev = 'Starý Smolivec' WHERE kod = 697206;
UPDATE ruian_katastr SET nazev = 'Choteč u Lázní Bělohradu' WHERE kod = 697214;
UPDATE ruian_katastr SET nazev = 'Mlázovice' WHERE kod = 697249;
UPDATE ruian_katastr SET nazev = 'Svatojanský Újezd' WHERE kod = 697257;
UPDATE ruian_katastr SET nazev = 'Šárovcova Lhota' WHERE kod = 697265;
UPDATE ruian_katastr SET nazev = 'Mlázovy' WHERE kod = 697281;
UPDATE ruian_katastr SET nazev = 'Mlečice' WHERE kod = 697290;
UPDATE ruian_katastr SET nazev = 'Mlékojedy u Litoměřic' WHERE kod = 697303;
UPDATE ruian_katastr SET nazev = 'Mlékosrby' WHERE kod = 697311;
UPDATE ruian_katastr SET nazev = 'Mlékovice u Neveklova' WHERE kod = 697346;
UPDATE ruian_katastr SET nazev = 'Mlýnec u Kopidlna' WHERE kod = 697371;
UPDATE ruian_katastr SET nazev = 'Mlýny u Choustníku' WHERE kod = 697389;
UPDATE ruian_katastr SET nazev = 'Mnetěš' WHERE kod = 697397;
UPDATE ruian_katastr SET nazev = 'Mirotín' WHERE kod = 697419;
UPDATE ruian_katastr SET nazev = 'Mnich' WHERE kod = 697427;
UPDATE ruian_katastr SET nazev = 'Mnichov' WHERE kod = 697443;
UPDATE ruian_katastr SET nazev = 'Hvožďany u Poběžovic' WHERE kod = 697451;
UPDATE ruian_katastr SET nazev = 'Mnichov u Poběžovic' WHERE kod = 697460;
UPDATE ruian_katastr SET nazev = 'Pivoň' WHERE kod = 697478;
UPDATE ruian_katastr SET nazev = 'Vranov u Mnichova' WHERE kod = 697486;
UPDATE ruian_katastr SET nazev = 'Skláře u Mnichova' WHERE kod = 697494;
UPDATE ruian_katastr SET nazev = 'Mnichov u Mariánských Lázní' WHERE kod = 697508;
UPDATE ruian_katastr SET nazev = 'Sítiny' WHERE kod = 697516;
UPDATE ruian_katastr SET nazev = 'Mnichovice' WHERE kod = 697524;
UPDATE ruian_katastr SET nazev = 'Božkov u Mnichovic' WHERE kod = 697532;
UPDATE ruian_katastr SET nazev = 'Mnichovice u Říčan' WHERE kod = 697541;
UPDATE ruian_katastr SET nazev = 'Myšlín' WHERE kod = 697559;
UPDATE ruian_katastr SET nazev = 'Hoškovice' WHERE kod = 697567;
UPDATE ruian_katastr SET nazev = 'Mnichovo Hradiště' WHERE kod = 697575;
UPDATE ruian_katastr SET nazev = 'Mníšek' WHERE kod = 697583;
UPDATE ruian_katastr SET nazev = 'Fojtka' WHERE kod = 697591;
UPDATE ruian_katastr SET nazev = 'Mníšek u Liberce' WHERE kod = 697605;
UPDATE ruian_katastr SET nazev = 'Mníšek pod Brdy' WHERE kod = 697621;
UPDATE ruian_katastr SET nazev = 'Rymaně' WHERE kod = 697630;
UPDATE ruian_katastr SET nazev = 'Stříbrná Lhota' WHERE kod = 697648;
UPDATE ruian_katastr SET nazev = 'Zahořany u Mníšku pod Brdy' WHERE kod = 697656;
UPDATE ruian_katastr SET nazev = 'Mniší' WHERE kod = 697664;
UPDATE ruian_katastr SET nazev = 'Močerady' WHERE kod = 697672;
UPDATE ruian_katastr SET nazev = 'Nové Dvory u Močerad' WHERE kod = 697681;
UPDATE ruian_katastr SET nazev = 'Kvítkov u Modlan' WHERE kod = 697702;
UPDATE ruian_katastr SET nazev = 'Modlany' WHERE kod = 697711;
UPDATE ruian_katastr SET nazev = 'Suché' WHERE kod = 697729;
UPDATE ruian_katastr SET nazev = 'Věšťany' WHERE kod = 697737;
UPDATE ruian_katastr SET nazev = 'Žichlice u Modlan' WHERE kod = 697745;
UPDATE ruian_katastr SET nazev = 'Hajská' WHERE kod = 697753;
UPDATE ruian_katastr SET nazev = 'Modlešovice' WHERE kod = 697761;
UPDATE ruian_katastr SET nazev = 'Sedlíkovice' WHERE kod = 697770;
UPDATE ruian_katastr SET nazev = 'Modlibohov' WHERE kod = 697796;
UPDATE ruian_katastr SET nazev = 'Sobákov' WHERE kod = 697800;
UPDATE ruian_katastr SET nazev = 'Starý Dub' WHERE kod = 697818;
UPDATE ruian_katastr SET nazev = 'Modlíkov u Přibyslavi' WHERE kod = 697826;
UPDATE ruian_katastr SET nazev = 'Modrá u Děčína' WHERE kod = 697834;
UPDATE ruian_katastr SET nazev = 'Modrá u Velehradu' WHERE kod = 697842;
UPDATE ruian_katastr SET nazev = 'Filipova Huť' WHERE kod = 697851;
UPDATE ruian_katastr SET nazev = 'Horská Kvilda' WHERE kod = 697869;
UPDATE ruian_katastr SET nazev = 'Javoří Pila' WHERE kod = 697885;
UPDATE ruian_katastr SET nazev = 'Roklanský Les' WHERE kod = 697893;
UPDATE ruian_katastr SET nazev = 'Modřec' WHERE kod = 697907;
UPDATE ruian_katastr SET nazev = 'Kostelík' WHERE kod = 697915;
UPDATE ruian_katastr SET nazev = 'Modřejovice' WHERE kod = 697923;
UPDATE ruian_katastr SET nazev = 'Modřice' WHERE kod = 697931;
UPDATE ruian_katastr SET nazev = 'Modřišice' WHERE kod = 697940;
UPDATE ruian_katastr SET nazev = 'Modřovice' WHERE kod = 697966;
UPDATE ruian_katastr SET nazev = 'Čmelíny' WHERE kod = 697974;
UPDATE ruian_katastr SET nazev = 'Mohelnice u Nepomuka' WHERE kod = 697982;
UPDATE ruian_katastr SET nazev = 'Třebčice' WHERE kod = 697991;
UPDATE ruian_katastr SET nazev = 'Víska' WHERE kod = 698008;
UPDATE ruian_katastr SET nazev = 'Mohelnice' WHERE kod = 698032;
UPDATE ruian_katastr SET nazev = 'Mohelno' WHERE kod = 698059;
UPDATE ruian_katastr SET nazev = 'Mochov' WHERE kod = 698067;
UPDATE ruian_katastr SET nazev = 'Hoštice u Mochtína' WHERE kod = 698075;
UPDATE ruian_katastr SET nazev = 'Mochtín' WHERE kod = 698091;
UPDATE ruian_katastr SET nazev = 'Srbice u Mochtína' WHERE kod = 698105;
UPDATE ruian_katastr SET nazev = 'Těšetiny' WHERE kod = 698113;
UPDATE ruian_katastr SET nazev = 'Újezdec u Mochtína' WHERE kod = 698121;
UPDATE ruian_katastr SET nazev = 'Rájov-Černice' WHERE kod = 698130;
UPDATE ruian_katastr SET nazev = 'Mojné' WHERE kod = 698148;
UPDATE ruian_katastr SET nazev = 'Záhorkovice' WHERE kod = 698156;
UPDATE ruian_katastr SET nazev = 'Mojžíř' WHERE kod = 698164;
UPDATE ruian_katastr SET nazev = 'Mokošín' WHERE kod = 698181;
UPDATE ruian_katastr SET nazev = 'Mokrá u Brna' WHERE kod = 698199;
UPDATE ruian_katastr SET nazev = 'Mokrovraty' WHERE kod = 698202;
UPDATE ruian_katastr SET nazev = 'Mokré' WHERE kod = 698211;
UPDATE ruian_katastr SET nazev = 'Mokré Lazce' WHERE kod = 698237;
UPDATE ruian_katastr SET nazev = 'Lešišov' WHERE kod = 698245;
UPDATE ruian_katastr SET nazev = 'Mokrosuky' WHERE kod = 698253;
UPDATE ruian_katastr SET nazev = 'Mokrovousy' WHERE kod = 698261;
UPDATE ruian_katastr SET nazev = 'Mokřiny' WHERE kod = 698270;
UPDATE ruian_katastr SET nazev = 'Nebesa' WHERE kod = 698288;
UPDATE ruian_katastr SET nazev = 'Nový Žďár' WHERE kod = 698296;
UPDATE ruian_katastr SET nazev = 'Moldava' WHERE kod = 698300;
UPDATE ruian_katastr SET nazev = 'Nové Město u Mikulova' WHERE kod = 698318;
UPDATE ruian_katastr SET nazev = 'Oldřiš u Moldavy' WHERE kod = 698326;
UPDATE ruian_katastr SET nazev = 'Pastviny u Moldavy' WHERE kod = 698334;
UPDATE ruian_katastr SET nazev = 'Holičky u Chrudimi' WHERE kod = 698342;
UPDATE ruian_katastr SET nazev = 'Janovice u Chrudimi' WHERE kod = 698351;
UPDATE ruian_katastr SET nazev = 'Morašice u Chrudimi' WHERE kod = 698369;
UPDATE ruian_katastr SET nazev = 'Skupice u Chrudimi' WHERE kod = 698377;
UPDATE ruian_katastr SET nazev = 'Zbyhněvice' WHERE kod = 698385;
UPDATE ruian_katastr SET nazev = 'Lažany u Litomyšle' WHERE kod = 698393;
UPDATE ruian_katastr SET nazev = 'Morašice u Litomyšle' WHERE kod = 698407;
UPDATE ruian_katastr SET nazev = 'Nová Sídla' WHERE kod = 698415;
UPDATE ruian_katastr SET nazev = 'Řikovice u Litomyšle' WHERE kod = 698423;
UPDATE ruian_katastr SET nazev = 'Tržek u Litomyšle' WHERE kod = 698440;
UPDATE ruian_katastr SET nazev = 'Morašice' WHERE kod = 698466;
UPDATE ruian_katastr SET nazev = 'Moravanský' WHERE kod = 698474;
UPDATE ruian_katastr SET nazev = 'Moravany nad Loučnou' WHERE kod = 698482;
UPDATE ruian_katastr SET nazev = 'Platěnice' WHERE kod = 698491;
UPDATE ruian_katastr SET nazev = 'Moravany u Brna' WHERE kod = 698504;
UPDATE ruian_katastr SET nazev = 'Moravany u Kyjova' WHERE kod = 698521;
UPDATE ruian_katastr SET nazev = 'Moravec' WHERE kod = 698539;
UPDATE ruian_katastr SET nazev = 'Pikárec' WHERE kod = 698547;
UPDATE ruian_katastr SET nazev = 'Radkov u Moravce' WHERE kod = 698555;
UPDATE ruian_katastr SET nazev = 'Moravecké Pavlovice' WHERE kod = 698571;
UPDATE ruian_katastr SET nazev = 'Moraveč' WHERE kod = 698580;
UPDATE ruian_katastr SET nazev = 'Moravice' WHERE kod = 698601;
UPDATE ruian_katastr SET nazev = 'Moravičany' WHERE kod = 698610;
UPDATE ruian_katastr SET nazev = 'Morávka' WHERE kod = 698679;
UPDATE ruian_katastr SET nazev = 'Moravská Huzová' WHERE kod = 698750;
UPDATE ruian_katastr SET nazev = 'Stádlo' WHERE kod = 698768;
UPDATE ruian_katastr SET nazev = 'Chrastová Lhota' WHERE kod = 698776;
UPDATE ruian_katastr SET nazev = 'Moravská Chrastová' WHERE kod = 698784;
UPDATE ruian_katastr SET nazev = 'Moravská Nová Ves' WHERE kod = 698792;
UPDATE ruian_katastr SET nazev = 'Moravská Třebová' WHERE kod = 698806;
UPDATE ruian_katastr SET nazev = 'Moravské Bránice' WHERE kod = 698890;
UPDATE ruian_katastr SET nazev = 'Moravské Budějovice' WHERE kod = 698903;
UPDATE ruian_katastr SET nazev = 'Moravské Knínice' WHERE kod = 699055;
UPDATE ruian_katastr SET nazev = 'Moravské Málkovice' WHERE kod = 699063;
UPDATE ruian_katastr SET nazev = 'Čabová' WHERE kod = 699071;
UPDATE ruian_katastr SET nazev = 'Moravský Beroun' WHERE kod = 699080;
UPDATE ruian_katastr SET nazev = 'Nové Valteřice' WHERE kod = 699098;
UPDATE ruian_katastr SET nazev = 'Ondrášov' WHERE kod = 699101;
UPDATE ruian_katastr SET nazev = 'Sedm Dvorů' WHERE kod = 699110;
UPDATE ruian_katastr SET nazev = 'Moravský Krumlov' WHERE kod = 699128;
UPDATE ruian_katastr SET nazev = 'Rokytná' WHERE kod = 699225;
UPDATE ruian_katastr SET nazev = 'Moravský Písek' WHERE kod = 699233;
UPDATE ruian_katastr SET nazev = 'Moravský Žižkov' WHERE kod = 699250;
UPDATE ruian_katastr SET nazev = 'Morkovice' WHERE kod = 699268;
UPDATE ruian_katastr SET nazev = 'Slížany' WHERE kod = 699276;
UPDATE ruian_katastr SET nazev = 'Morkůvky' WHERE kod = 699284;
UPDATE ruian_katastr SET nazev = 'Mořice' WHERE kod = 699292;
UPDATE ruian_katastr SET nazev = 'Mořina' WHERE kod = 699306;
UPDATE ruian_katastr SET nazev = 'Mořinka' WHERE kod = 699322;
UPDATE ruian_katastr SET nazev = 'Mořkov' WHERE kod = 699331;
UPDATE ruian_katastr SET nazev = 'Most I' WHERE kod = 699357;
UPDATE ruian_katastr SET nazev = 'Most II' WHERE kod = 699594;
UPDATE ruian_katastr SET nazev = 'Rudolice nad Bílinou' WHERE kod = 699691;
UPDATE ruian_katastr SET nazev = 'Střimice' WHERE kod = 699748;
UPDATE ruian_katastr SET nazev = 'Debrné u Mostku' WHERE kod = 699756;
UPDATE ruian_katastr SET nazev = 'Mostek' WHERE kod = 699799;
UPDATE ruian_katastr SET nazev = 'Souvrať' WHERE kod = 699811;
UPDATE ruian_katastr SET nazev = 'Mostek nad Orlicí' WHERE kod = 699837;
UPDATE ruian_katastr SET nazev = 'Mostiště u Velkého Meziříčí' WHERE kod = 699853;
UPDATE ruian_katastr SET nazev = 'Mostkovice' WHERE kod = 699870;
UPDATE ruian_katastr SET nazev = 'Stichovice' WHERE kod = 699888;
UPDATE ruian_katastr SET nazev = 'Mosty u Jablunkova' WHERE kod = 699896;
UPDATE ruian_katastr SET nazev = 'Mošnov' WHERE kod = 699934;
UPDATE ruian_katastr SET nazev = 'Mouchnice' WHERE kod = 699969;
UPDATE ruian_katastr SET nazev = 'Mouřínov' WHERE kod = 699977;
UPDATE ruian_katastr SET nazev = 'Moutnice' WHERE kod = 699985;
UPDATE ruian_katastr SET nazev = 'Mrač' WHERE kod = 700002;
UPDATE ruian_katastr SET nazev = 'Mradice' WHERE kod = 700011;
UPDATE ruian_katastr SET nazev = 'Mrákotín u Skutče' WHERE kod = 700029;
UPDATE ruian_katastr SET nazev = 'Mrákotín u Telče' WHERE kod = 700053;
UPDATE ruian_katastr SET nazev = 'Praskolesy u Mrákotína' WHERE kod = 700061;
UPDATE ruian_katastr SET nazev = 'Mrákov' WHERE kod = 700070;
UPDATE ruian_katastr SET nazev = 'Smolov u Domažlic' WHERE kod = 700088;
UPDATE ruian_katastr SET nazev = 'Mramotice' WHERE kod = 700100;
UPDATE ruian_katastr SET nazev = 'Mratín' WHERE kod = 700118;
UPDATE ruian_katastr SET nazev = 'Mrlínek' WHERE kod = 700126;
UPDATE ruian_katastr SET nazev = 'Mrsklesy na Moravě' WHERE kod = 700151;
UPDATE ruian_katastr SET nazev = 'Mrtník' WHERE kod = 700169;
UPDATE ruian_katastr SET nazev = 'Benetice u Světlé nad Sázavou' WHERE kod = 700177;
UPDATE ruian_katastr SET nazev = 'Leštinka u Světlé nad Sázavou' WHERE kod = 700185;
UPDATE ruian_katastr SET nazev = 'Mrzkovice' WHERE kod = 700193;
UPDATE ruian_katastr SET nazev = 'Mříčná' WHERE kod = 700207;
UPDATE ruian_katastr SET nazev = 'Mstišov' WHERE kod = 700215;
UPDATE ruian_katastr SET nazev = 'Mšec' WHERE kod = 700231;
UPDATE ruian_katastr SET nazev = 'Mšecké Žehrovice' WHERE kod = 700240;
UPDATE ruian_katastr SET nazev = 'Mšené-lázně' WHERE kod = 700258;
UPDATE ruian_katastr SET nazev = 'Vrbice u Mšeného-lázní' WHERE kod = 700266;
UPDATE ruian_katastr SET nazev = 'Mšeno' WHERE kod = 700274;
UPDATE ruian_katastr SET nazev = 'Olešno' WHERE kod = 700282;
UPDATE ruian_katastr SET nazev = 'Mštěnovice' WHERE kod = 700312;
UPDATE ruian_katastr SET nazev = 'Mukařov u Říčan' WHERE kod = 700321;
UPDATE ruian_katastr SET nazev = 'Žernovka' WHERE kod = 700339;
UPDATE ruian_katastr SET nazev = 'Mukařov u Jablonce nad Nisou' WHERE kod = 700347;
UPDATE ruian_katastr SET nazev = 'Mukařov u Úštěku' WHERE kod = 700363;
UPDATE ruian_katastr SET nazev = 'Náčkovice' WHERE kod = 700371;
UPDATE ruian_katastr SET nazev = 'Červený Újezd u Mukova' WHERE kod = 700380;
UPDATE ruian_katastr SET nazev = 'Mukov' WHERE kod = 700398;
UPDATE ruian_katastr SET nazev = 'Mušov' WHERE kod = 700401;
UPDATE ruian_katastr SET nazev = 'Lhota pod Džbánem' WHERE kod = 700410;
UPDATE ruian_katastr SET nazev = 'Mutějovice' WHERE kod = 700428;
UPDATE ruian_katastr SET nazev = 'Mutěnice u Strakonic' WHERE kod = 700436;
UPDATE ruian_katastr SET nazev = 'Mutěnice' WHERE kod = 700444;
UPDATE ruian_katastr SET nazev = 'Mutěnín' WHERE kod = 700461;
UPDATE ruian_katastr SET nazev = 'Bezvěrov I' WHERE kod = 700479;
UPDATE ruian_katastr SET nazev = 'Starý Kramolín' WHERE kod = 700487;
UPDATE ruian_katastr SET nazev = 'Holušice u Mužetic' WHERE kod = 700495;
UPDATE ruian_katastr SET nazev = 'Mužetice' WHERE kod = 700509;
UPDATE ruian_katastr SET nazev = 'Kobylničky' WHERE kod = 700517;
UPDATE ruian_katastr SET nazev = 'Křenůvky' WHERE kod = 700525;
UPDATE ruian_katastr SET nazev = 'Myslejovice' WHERE kod = 700533;
UPDATE ruian_katastr SET nazev = 'Mysletice' WHERE kod = 700541;
UPDATE ruian_katastr SET nazev = 'Olší u Telče' WHERE kod = 700550;
UPDATE ruian_katastr SET nazev = 'Zadní Vydří' WHERE kod = 700568;
UPDATE ruian_katastr SET nazev = 'Mysletín' WHERE kod = 700576;
UPDATE ruian_katastr SET nazev = 'Mysliboř' WHERE kod = 700584;
UPDATE ruian_katastr SET nazev = 'Myslibořice' WHERE kod = 700592;
UPDATE ruian_katastr SET nazev = 'Myslík' WHERE kod = 700606;
UPDATE ruian_katastr SET nazev = 'Myslín' WHERE kod = 700631;
UPDATE ruian_katastr SET nazev = 'Loužná' WHERE kod = 700657;
UPDATE ruian_katastr SET nazev = 'Myslív' WHERE kod = 700665;
UPDATE ruian_katastr SET nazev = 'Nehodiv' WHERE kod = 700673;
UPDATE ruian_katastr SET nazev = 'Nový Dvůr u Myslíva' WHERE kod = 700681;
UPDATE ruian_katastr SET nazev = 'Myslkovice' WHERE kod = 700690;
UPDATE ruian_katastr SET nazev = 'Mysločovice' WHERE kod = 700703;
UPDATE ruian_katastr SET nazev = 'Myslotín' WHERE kod = 700711;
UPDATE ruian_katastr SET nazev = 'Domažličky' WHERE kod = 700720;
UPDATE ruian_katastr SET nazev = 'Kroměždice' WHERE kod = 700738;
UPDATE ruian_katastr SET nazev = 'Myslovice' WHERE kod = 700746;
UPDATE ruian_katastr SET nazev = 'Pečetín' WHERE kod = 700754;
UPDATE ruian_katastr SET nazev = 'Újezdec u Měcholup' WHERE kod = 700762;
UPDATE ruian_katastr SET nazev = 'Maletice' WHERE kod = 700771;
UPDATE ruian_katastr SET nazev = 'Myšenec' WHERE kod = 700789;
UPDATE ruian_katastr SET nazev = 'Selibov' WHERE kod = 700797;
UPDATE ruian_katastr SET nazev = 'Myštěves' WHERE kod = 700801;
UPDATE ruian_katastr SET nazev = 'Kožlí u Myštic' WHERE kod = 700835;
UPDATE ruian_katastr SET nazev = 'Myštice' WHERE kod = 700851;
UPDATE ruian_katastr SET nazev = 'Vahlovice' WHERE kod = 700894;
UPDATE ruian_katastr SET nazev = 'Výšice' WHERE kod = 700908;
UPDATE ruian_katastr SET nazev = 'Medový Újezd' WHERE kod = 700924;
UPDATE ruian_katastr SET nazev = 'Mýto v Čechách' WHERE kod = 700932;
UPDATE ruian_katastr SET nazev = 'Dub u Mžan' WHERE kod = 700941;
UPDATE ruian_katastr SET nazev = 'Mžany' WHERE kod = 700959;
UPDATE ruian_katastr SET nazev = 'Stračovská Lhota' WHERE kod = 700967;
UPDATE ruian_katastr SET nazev = 'Nabočany' WHERE kod = 700983;
UPDATE ruian_katastr SET nazev = 'Načeradec' WHERE kod = 700991;
UPDATE ruian_katastr SET nazev = 'Olešná u Načeradce' WHERE kod = 701009;
UPDATE ruian_katastr SET nazev = 'Vračkovice' WHERE kod = 701017;
UPDATE ruian_katastr SET nazev = 'Načeratice' WHERE kod = 701025;
UPDATE ruian_katastr SET nazev = 'Licomělice' WHERE kod = 701033;
UPDATE ruian_katastr SET nazev = 'Načešice' WHERE kod = 701041;
UPDATE ruian_katastr SET nazev = 'Chlístov u Nadějkova' WHERE kod = 701068;
UPDATE ruian_katastr SET nazev = 'Nadějkov' WHERE kod = 701084;
UPDATE ruian_katastr SET nazev = 'Starcova Lhota' WHERE kod = 701092;
UPDATE ruian_katastr SET nazev = 'Nadějov' WHERE kod = 701106;
UPDATE ruian_katastr SET nazev = 'Kostelec u Nadryb' WHERE kod = 701114;
UPDATE ruian_katastr SET nazev = 'Nadryby' WHERE kod = 701122;
UPDATE ruian_katastr SET nazev = 'Nahoruby' WHERE kod = 701131;
UPDATE ruian_katastr SET nazev = 'Živohošť' WHERE kod = 701157;
UPDATE ruian_katastr SET nazev = 'Krušlov' WHERE kod = 701165;
UPDATE ruian_katastr SET nazev = 'Nahořany u Čkyně' WHERE kod = 701173;
UPDATE ruian_katastr SET nazev = 'Vacovice' WHERE kod = 701181;
UPDATE ruian_katastr SET nazev = 'Dolsko' WHERE kod = 701190;
UPDATE ruian_katastr SET nazev = 'Lhota u Nahořan' WHERE kod = 701211;
UPDATE ruian_katastr SET nazev = 'Městec u Nahořan' WHERE kod = 701220;
UPDATE ruian_katastr SET nazev = 'Nahořany nad Metují' WHERE kod = 701238;
UPDATE ruian_katastr SET nazev = 'Nahý Újezdec' WHERE kod = 701246;
UPDATE ruian_katastr SET nazev = 'Náchod u Tábora' WHERE kod = 701254;
UPDATE ruian_katastr SET nazev = 'Náchod' WHERE kod = 701262;
UPDATE ruian_katastr SET nazev = 'Babí u Náchoda' WHERE kod = 701297;
UPDATE ruian_katastr SET nazev = 'Běloves' WHERE kod = 701301;
UPDATE ruian_katastr SET nazev = 'Staré Město nad Metují' WHERE kod = 701335;
UPDATE ruian_katastr SET nazev = 'Bražec' WHERE kod = 701343;
UPDATE ruian_katastr SET nazev = 'Malé Poříčí' WHERE kod = 701378;
UPDATE ruian_katastr SET nazev = 'Lhota nad Moravou' WHERE kod = 701386;
UPDATE ruian_katastr SET nazev = 'Mezice' WHERE kod = 701394;
UPDATE ruian_katastr SET nazev = 'Náklo' WHERE kod = 701408;
UPDATE ruian_katastr SET nazev = 'Střeň' WHERE kod = 701416;
UPDATE ruian_katastr SET nazev = 'Nakvasovice' WHERE kod = 701432;
UPDATE ruian_katastr SET nazev = 'Naloučany' WHERE kod = 701467;
UPDATE ruian_katastr SET nazev = 'Nalžovice' WHERE kod = 701491;
UPDATE ruian_katastr SET nazev = 'Nalžovické Podhájí' WHERE kod = 701505;
UPDATE ruian_katastr SET nazev = 'Nalžovské Hory' WHERE kod = 701521;
UPDATE ruian_katastr SET nazev = 'Náměšť na Hané' WHERE kod = 701548;
UPDATE ruian_katastr SET nazev = 'Náměšť nad Oslavou' WHERE kod = 701564;
UPDATE ruian_katastr SET nazev = 'Napajedla' WHERE kod = 701572;
UPDATE ruian_katastr SET nazev = 'Nárameč' WHERE kod = 701599;
UPDATE ruian_katastr SET nazev = 'Valdíkov' WHERE kod = 701602;
UPDATE ruian_katastr SET nazev = 'Narysov' WHERE kod = 701629;
UPDATE ruian_katastr SET nazev = 'Nasavrky' WHERE kod = 701637;
UPDATE ruian_katastr SET nazev = 'Nasavrky u Chocně' WHERE kod = 701645;
UPDATE ruian_katastr SET nazev = 'Násedlovice' WHERE kod = 701653;
UPDATE ruian_katastr SET nazev = 'Našiměřice' WHERE kod = 701661;
UPDATE ruian_katastr SET nazev = 'Návojná' WHERE kod = 701670;
UPDATE ruian_katastr SET nazev = 'Jelemek' WHERE kod = 701688;
UPDATE ruian_katastr SET nazev = 'Lažišťka' WHERE kod = 701696;
UPDATE ruian_katastr SET nazev = 'Nebahovy' WHERE kod = 701700;
UPDATE ruian_katastr SET nazev = 'Žernovice' WHERE kod = 701718;
UPDATE ruian_katastr SET nazev = 'Hartoušov' WHERE kod = 701726;
UPDATE ruian_katastr SET nazev = 'Hněvín' WHERE kod = 701734;
UPDATE ruian_katastr SET nazev = 'Nebanice' WHERE kod = 701742;
UPDATE ruian_katastr SET nazev = 'Vrbová' WHERE kod = 701751;
UPDATE ruian_katastr SET nazev = 'Nebeská Rybná' WHERE kod = 701777;
UPDATE ruian_katastr SET nazev = 'Nebory' WHERE kod = 701793;
UPDATE ruian_katastr SET nazev = 'Nebovidy' WHERE kod = 701823;
UPDATE ruian_katastr SET nazev = 'Nebovidy u Brna' WHERE kod = 701831;
UPDATE ruian_katastr SET nazev = 'Nebřehovice' WHERE kod = 701840;
UPDATE ruian_katastr SET nazev = 'Zadní Ptákovice' WHERE kod = 701858;
UPDATE ruian_katastr SET nazev = 'Nebužely' WHERE kod = 701866;
UPDATE ruian_katastr SET nazev = 'Lhota u Nečemic' WHERE kod = 701874;
UPDATE ruian_katastr SET nazev = 'Nečemice' WHERE kod = 701882;
UPDATE ruian_katastr SET nazev = 'Chraberce' WHERE kod = 701891;
UPDATE ruian_katastr SET nazev = 'Nečichy' WHERE kod = 701904;
UPDATE ruian_katastr SET nazev = 'Lipiny' WHERE kod = 701912;
UPDATE ruian_katastr SET nazev = 'Nečín' WHERE kod = 701921;
UPDATE ruian_katastr SET nazev = 'Žebrák u Nečína' WHERE kod = 701939;
UPDATE ruian_katastr SET nazev = 'Březín' WHERE kod = 701947;
UPDATE ruian_katastr SET nazev = 'Čestětín' WHERE kod = 701955;
UPDATE ruian_katastr SET nazev = 'Doubravice u Nečtin' WHERE kod = 701963;
UPDATE ruian_katastr SET nazev = 'Hrad Nečtiny' WHERE kod = 701971;
UPDATE ruian_katastr SET nazev = 'Kamenná Hora' WHERE kod = 701998;
UPDATE ruian_katastr SET nazev = 'Lešovice' WHERE kod = 702005;
UPDATE ruian_katastr SET nazev = 'Nečtiny' WHERE kod = 702013;
UPDATE ruian_katastr SET nazev = 'Nové Městečko u Nečtin' WHERE kod = 702021;
UPDATE ruian_katastr SET nazev = 'Plachtín' WHERE kod = 702030;
UPDATE ruian_katastr SET nazev = 'Račín u Nečtin' WHERE kod = 702048;
UPDATE ruian_katastr SET nazev = 'Borovnice u Českých Budějovic' WHERE kod = 702056;
UPDATE ruian_katastr SET nazev = 'Doubravice u Českých Budějovic' WHERE kod = 702064;
UPDATE ruian_katastr SET nazev = 'Heřmaň u Českých Budějovic' WHERE kod = 702072;
UPDATE ruian_katastr SET nazev = 'Nedabyle' WHERE kod = 702102;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Českých Budějovic' WHERE kod = 702111;
UPDATE ruian_katastr SET nazev = 'Nedachlebice' WHERE kod = 702137;
UPDATE ruian_katastr SET nazev = 'Nedakonice' WHERE kod = 702145;
UPDATE ruian_katastr SET nazev = 'Nedamov' WHERE kod = 702161;
UPDATE ruian_katastr SET nazev = 'Nedašov' WHERE kod = 702188;
UPDATE ruian_katastr SET nazev = 'Nedašova Lhota' WHERE kod = 702196;
UPDATE ruian_katastr SET nazev = 'Horní Neděliště' WHERE kod = 702218;
UPDATE ruian_katastr SET nazev = 'Dolní Neděliště' WHERE kod = 702226;
UPDATE ruian_katastr SET nazev = 'Bor u Sedlčan' WHERE kod = 702234;
UPDATE ruian_katastr SET nazev = 'Kamenice u Nedrahovic' WHERE kod = 702242;
UPDATE ruian_katastr SET nazev = 'Nedrahovice' WHERE kod = 702251;
UPDATE ruian_katastr SET nazev = 'Nedrahovické Podhájí' WHERE kod = 702269;
UPDATE ruian_katastr SET nazev = 'Radeč u Nedrahovic' WHERE kod = 702277;
UPDATE ruian_katastr SET nazev = 'Nedvědice pod Pernštejnem' WHERE kod = 702307;
UPDATE ruian_katastr SET nazev = 'Pernštejn' WHERE kod = 702315;
UPDATE ruian_katastr SET nazev = 'Nedvězí u Říčan' WHERE kod = 702323;
UPDATE ruian_katastr SET nazev = 'Nedvězí u Poličky' WHERE kod = 702331;
UPDATE ruian_katastr SET nazev = 'Nedvězíčko' WHERE kod = 702340;
UPDATE ruian_katastr SET nazev = 'Nedvězí u Olomouce' WHERE kod = 702358;
UPDATE ruian_katastr SET nazev = 'Nedvězí u Zábřeha' WHERE kod = 702366;
UPDATE ruian_katastr SET nazev = 'Nehasice' WHERE kod = 702374;
UPDATE ruian_katastr SET nazev = 'Tatinná' WHERE kod = 702382;
UPDATE ruian_katastr SET nazev = 'Nehvizdy' WHERE kod = 702404;
UPDATE ruian_katastr SET nazev = 'Homole u Nechalova' WHERE kod = 702412;
UPDATE ruian_katastr SET nazev = 'Nechalov' WHERE kod = 702421;
UPDATE ruian_katastr SET nazev = 'Nechanice u Nových Mitrovic' WHERE kod = 702447;
UPDATE ruian_katastr SET nazev = 'Lubno u Nechanic' WHERE kod = 702463;
UPDATE ruian_katastr SET nazev = 'Nechanice' WHERE kod = 702471;
UPDATE ruian_katastr SET nazev = 'Staré Nechanice' WHERE kod = 702480;
UPDATE ruian_katastr SET nazev = 'Březí u Trhových Svinů' WHERE kod = 702498;
UPDATE ruian_katastr SET nazev = 'Něchov' WHERE kod = 702501;
UPDATE ruian_katastr SET nazev = 'Todně' WHERE kod = 702528;
UPDATE ruian_katastr SET nazev = 'Bratřejov' WHERE kod = 702536;
UPDATE ruian_katastr SET nazev = 'Bratříkovice u Nechvalic' WHERE kod = 702544;
UPDATE ruian_katastr SET nazev = 'Křemenice' WHERE kod = 702552;
UPDATE ruian_katastr SET nazev = 'Libčice u Nechvalic' WHERE kod = 702561;
UPDATE ruian_katastr SET nazev = 'Mokřany u Nechvalic' WHERE kod = 702579;
UPDATE ruian_katastr SET nazev = 'Nechvalice' WHERE kod = 702587;
UPDATE ruian_katastr SET nazev = 'Nechvalín' WHERE kod = 702595;
UPDATE ruian_katastr SET nazev = 'Bernov' WHERE kod = 702609;
UPDATE ruian_katastr SET nazev = 'Lesík' WHERE kod = 702617;
UPDATE ruian_katastr SET nazev = 'Nejdek' WHERE kod = 702625;
UPDATE ruian_katastr SET nazev = 'Oldřichov u Nejdku' WHERE kod = 702633;
UPDATE ruian_katastr SET nazev = 'Rudné' WHERE kod = 702641;
UPDATE ruian_katastr SET nazev = 'Tisová u Nejdku' WHERE kod = 702650;
UPDATE ruian_katastr SET nazev = 'Vysoká Pec u Nejdku' WHERE kod = 702668;
UPDATE ruian_katastr SET nazev = 'Nejdek u Hranic' WHERE kod = 702676;
UPDATE ruian_katastr SET nazev = 'Klouzovy u Chotěboře' WHERE kod = 702684;
UPDATE ruian_katastr SET nazev = 'Nejepín' WHERE kod = 702692;
UPDATE ruian_katastr SET nazev = 'Lhotka u Nekmíře' WHERE kod = 702706;
UPDATE ruian_katastr SET nazev = 'Nekmíř' WHERE kod = 702714;
UPDATE ruian_katastr SET nazev = 'Nekoř' WHERE kod = 702731;
UPDATE ruian_katastr SET nazev = 'Nekvasovy' WHERE kod = 702757;
UPDATE ruian_katastr SET nazev = 'Lešany u Nelahozevsi' WHERE kod = 702781;
UPDATE ruian_katastr SET nazev = 'Nelahozeves' WHERE kod = 702790;
UPDATE ruian_katastr SET nazev = 'Podhořany' WHERE kod = 702803;
UPDATE ruian_katastr SET nazev = 'Nelepeč' WHERE kod = 702811;
UPDATE ruian_katastr SET nazev = 'Žernůvka' WHERE kod = 702820;
UPDATE ruian_katastr SET nazev = 'Nelešovice' WHERE kod = 702838;
UPDATE ruian_katastr SET nazev = 'Nemanice' WHERE kod = 702846;
UPDATE ruian_katastr SET nazev = 'Lučina u Nemanic' WHERE kod = 702889;
UPDATE ruian_katastr SET nazev = 'Novosedly u Nemanic' WHERE kod = 702897;
UPDATE ruian_katastr SET nazev = 'Němčany' WHERE kod = 702901;
UPDATE ruian_katastr SET nazev = 'Alberovice' WHERE kod = 702919;
UPDATE ruian_katastr SET nazev = 'Kačerov' WHERE kod = 702927;
UPDATE ruian_katastr SET nazev = 'Němčice u Dolních Kralovic' WHERE kod = 702935;
UPDATE ruian_katastr SET nazev = 'Němčice u Luštěnic' WHERE kod = 702943;
UPDATE ruian_katastr SET nazev = 'Němčice u Volyně' WHERE kod = 702951;
UPDATE ruian_katastr SET nazev = 'Němčice u Kdyně' WHERE kod = 702960;
UPDATE ruian_katastr SET nazev = 'Němčice u Klatov' WHERE kod = 702986;
UPDATE ruian_katastr SET nazev = 'Třebíšov' WHERE kod = 702994;
UPDATE ruian_katastr SET nazev = 'Němčice u České Třebové' WHERE kod = 703001;
UPDATE ruian_katastr SET nazev = 'Němčice' WHERE kod = 703028;
UPDATE ruian_katastr SET nazev = 'Němčice u Holešova' WHERE kod = 703036;
UPDATE ruian_katastr SET nazev = 'Němčice nad Hanou' WHERE kod = 703044;
UPDATE ruian_katastr SET nazev = 'Němčičky' WHERE kod = 703052;
UPDATE ruian_katastr SET nazev = 'Němčičky u Hustopečí' WHERE kod = 703061;
UPDATE ruian_katastr SET nazev = 'Němčičky nad Jevišovkou' WHERE kod = 703079;
UPDATE ruian_katastr SET nazev = 'Němčovice' WHERE kod = 703087;
UPDATE ruian_katastr SET nazev = 'Němetice' WHERE kod = 703095;
UPDATE ruian_katastr SET nazev = 'Nemilany' WHERE kod = 703109;
UPDATE ruian_katastr SET nazev = 'Lupěné' WHERE kod = 703117;
UPDATE ruian_katastr SET nazev = 'Nemile' WHERE kod = 703125;
UPDATE ruian_katastr SET nazev = 'Filipov u Zábřeha' WHERE kod = 703133;
UPDATE ruian_katastr SET nazev = 'Nemilkov' WHERE kod = 703141;
UPDATE ruian_katastr SET nazev = 'Nemíž' WHERE kod = 703168;
UPDATE ruian_katastr SET nazev = 'Nemochovice' WHERE kod = 703176;
UPDATE ruian_katastr SET nazev = 'Nemojany' WHERE kod = 703184;
UPDATE ruian_katastr SET nazev = 'Nemojov' WHERE kod = 703192;
UPDATE ruian_katastr SET nazev = 'Dolní Nemojov' WHERE kod = 703206;
UPDATE ruian_katastr SET nazev = 'Horní Nemojov' WHERE kod = 703214;
UPDATE ruian_katastr SET nazev = 'Nový Nemojov' WHERE kod = 703222;
UPDATE ruian_katastr SET nazev = 'Starobucké Debrné' WHERE kod = 703231;
UPDATE ruian_katastr SET nazev = 'Nemošice' WHERE kod = 703249;
UPDATE ruian_katastr SET nazev = 'Nemotice' WHERE kod = 703257;
UPDATE ruian_katastr SET nazev = 'Nemyčeves' WHERE kod = 703273;
UPDATE ruian_katastr SET nazev = 'Nemyslovice' WHERE kod = 703281;
UPDATE ruian_katastr SET nazev = 'Dědice u Nemyšle' WHERE kod = 703290;
UPDATE ruian_katastr SET nazev = 'Nemyšl' WHERE kod = 703311;
UPDATE ruian_katastr SET nazev = 'Prudice' WHERE kod = 703320;
UPDATE ruian_katastr SET nazev = 'Nenačovice' WHERE kod = 703354;
UPDATE ruian_katastr SET nazev = 'Nenkovice' WHERE kod = 703362;
UPDATE ruian_katastr SET nazev = 'Nepasice' WHERE kod = 703371;
UPDATE ruian_katastr SET nazev = 'Neplachov' WHERE kod = 703389;
UPDATE ruian_katastr SET nazev = 'Nepolisy' WHERE kod = 703397;
UPDATE ruian_katastr SET nazev = 'Košice u Nepoměřic' WHERE kod = 703419;
UPDATE ruian_katastr SET nazev = 'Miletice u Nepoměřic' WHERE kod = 703427;
UPDATE ruian_katastr SET nazev = 'Nepoměřice' WHERE kod = 703435;
UPDATE ruian_katastr SET nazev = 'Nepomuk pod Třemšínem' WHERE kod = 703443;
UPDATE ruian_katastr SET nazev = 'Dvorec' WHERE kod = 703460;
UPDATE ruian_katastr SET nazev = 'Nepomuk' WHERE kod = 703478;
UPDATE ruian_katastr SET nazev = 'Dětaň' WHERE kod = 703486;
UPDATE ruian_katastr SET nazev = 'Dvérce' WHERE kod = 703494;
UPDATE ruian_katastr SET nazev = 'Chmelištná' WHERE kod = 703508;
UPDATE ruian_katastr SET nazev = 'Nepomyšl' WHERE kod = 703516;
UPDATE ruian_katastr SET nazev = 'Neprochovy' WHERE kod = 703524;
UPDATE ruian_katastr SET nazev = 'Nepřejov' WHERE kod = 703541;
UPDATE ruian_katastr SET nazev = 'Nepřevázka' WHERE kod = 703559;
UPDATE ruian_katastr SET nazev = 'Neratovice' WHERE kod = 703567;
UPDATE ruian_katastr SET nazev = 'Libiš' WHERE kod = 703621;
UPDATE ruian_katastr SET nazev = 'Byškovice' WHERE kod = 703656;
UPDATE ruian_katastr SET nazev = 'Lobkovice' WHERE kod = 703664;
UPDATE ruian_katastr SET nazev = 'Mlékojedy u Neratovic' WHERE kod = 703672;
UPDATE ruian_katastr SET nazev = 'Dolní Nerestce' WHERE kod = 703699;
UPDATE ruian_katastr SET nazev = 'Horní Nerestce' WHERE kod = 703702;
UPDATE ruian_katastr SET nazev = 'Nerošov' WHERE kod = 703711;
UPDATE ruian_katastr SET nazev = 'Neslovice' WHERE kod = 703729;
UPDATE ruian_katastr SET nazev = 'Letošov' WHERE kod = 703737;
UPDATE ruian_katastr SET nazev = 'Nesovice' WHERE kod = 703745;
UPDATE ruian_katastr SET nazev = 'Nespeky' WHERE kod = 703770;
UPDATE ruian_katastr SET nazev = 'Hradiště' WHERE kod = 703788;
UPDATE ruian_katastr SET nazev = 'Nesperská Lhota' WHERE kod = 703800;
UPDATE ruian_katastr SET nazev = 'Nesuchyně' WHERE kod = 703826;
UPDATE ruian_katastr SET nazev = 'Nesvačilka' WHERE kod = 703834;
UPDATE ruian_katastr SET nazev = 'Nesvačily u Berouna' WHERE kod = 703842;
UPDATE ruian_katastr SET nazev = 'Nesvačily pod Třemšínem' WHERE kod = 703851;
UPDATE ruian_katastr SET nazev = 'Neštěmice' WHERE kod = 703869;
UPDATE ruian_katastr SET nazev = 'Neštětice' WHERE kod = 703885;
UPDATE ruian_katastr SET nazev = 'Nětčice' WHERE kod = 703893;
UPDATE ruian_katastr SET nazev = 'Netěchovice' WHERE kod = 703907;
UPDATE ruian_katastr SET nazev = 'Netín' WHERE kod = 703915;
UPDATE ruian_katastr SET nazev = 'Záseka' WHERE kod = 703923;
UPDATE ruian_katastr SET nazev = 'Netolice' WHERE kod = 703940;
UPDATE ruian_katastr SET nazev = 'Netonice' WHERE kod = 703974;
UPDATE ruian_katastr SET nazev = 'Radějovice u Netonic' WHERE kod = 703982;
UPDATE ruian_katastr SET nazev = 'Kopeč' WHERE kod = 703991;
UPDATE ruian_katastr SET nazev = 'Netřeba' WHERE kod = 704008;
UPDATE ruian_katastr SET nazev = 'Netřebice u Nymburka' WHERE kod = 704016;
UPDATE ruian_katastr SET nazev = 'Dlouhá' WHERE kod = 704024;
UPDATE ruian_katastr SET nazev = 'Netřebice' WHERE kod = 704041;
UPDATE ruian_katastr SET nazev = 'Chodeč-Zvíkov' WHERE kod = 704067;
UPDATE ruian_katastr SET nazev = 'Nebílovy' WHERE kod = 704075;
UPDATE ruian_katastr SET nazev = 'Netunice' WHERE kod = 704083;
UPDATE ruian_katastr SET nazev = 'Předenice' WHERE kod = 704091;
UPDATE ruian_katastr SET nazev = 'Dunávice' WHERE kod = 704105;
UPDATE ruian_katastr SET nazev = 'Maskovice' WHERE kod = 704113;
UPDATE ruian_katastr SET nazev = 'Netvořice' WHERE kod = 704121;
UPDATE ruian_katastr SET nazev = 'Tuchyně' WHERE kod = 704130;
UPDATE ruian_katastr SET nazev = 'Všetice' WHERE kod = 704148;
UPDATE ruian_katastr SET nazev = 'Neubuz' WHERE kod = 704156;
UPDATE ruian_katastr SET nazev = 'Neuměř' WHERE kod = 704164;
UPDATE ruian_katastr SET nazev = 'Všekary' WHERE kod = 704172;
UPDATE ruian_katastr SET nazev = 'Kamenný Most' WHERE kod = 704181;
UPDATE ruian_katastr SET nazev = 'Neuměřice' WHERE kod = 704199;
UPDATE ruian_katastr SET nazev = 'Neumětely' WHERE kod = 704202;
UPDATE ruian_katastr SET nazev = 'Klikařov' WHERE kod = 704211;
UPDATE ruian_katastr SET nazev = 'Neurazy' WHERE kod = 704229;
UPDATE ruian_katastr SET nazev = 'Neustupov' WHERE kod = 704245;
UPDATE ruian_katastr SET nazev = 'Nevcehle' WHERE kod = 704261;
UPDATE ruian_katastr SET nazev = 'Neveklov' WHERE kod = 704288;
UPDATE ruian_katastr SET nazev = 'Nevězice' WHERE kod = 704318;
UPDATE ruian_katastr SET nazev = 'Nevid' WHERE kod = 704326;
UPDATE ruian_katastr SET nazev = 'Nevojice' WHERE kod = 704334;
UPDATE ruian_katastr SET nazev = 'Nevolice' WHERE kod = 704342;
UPDATE ruian_katastr SET nazev = 'Nevřeň' WHERE kod = 704351;
UPDATE ruian_katastr SET nazev = 'Nevšová' WHERE kod = 704369;
UPDATE ruian_katastr SET nazev = 'Nezabudice' WHERE kod = 704377;
UPDATE ruian_katastr SET nazev = 'Nezamyslice u Horažďovic' WHERE kod = 704385;
UPDATE ruian_katastr SET nazev = 'Nezamyslice nad Hanou' WHERE kod = 704393;
UPDATE ruian_katastr SET nazev = 'Těšice u Nezamyslic' WHERE kod = 704407;
UPDATE ruian_katastr SET nazev = 'Nezdenice' WHERE kod = 704415;
UPDATE ruian_katastr SET nazev = 'Nezdice na Šumavě' WHERE kod = 704423;
UPDATE ruian_katastr SET nazev = 'Pohorsko' WHERE kod = 704431;
UPDATE ruian_katastr SET nazev = 'Nezdřev' WHERE kod = 704458;
UPDATE ruian_katastr SET nazev = 'Milínov u Nezvěstic' WHERE kod = 704466;
UPDATE ruian_katastr SET nazev = 'Nezvěstice' WHERE kod = 704474;
UPDATE ruian_katastr SET nazev = 'Olešná u Nezvěstic' WHERE kod = 704482;
UPDATE ruian_katastr SET nazev = 'Žákava' WHERE kod = 704504;
UPDATE ruian_katastr SET nazev = 'Němětice' WHERE kod = 704521;
UPDATE ruian_katastr SET nazev = 'Nihošovice' WHERE kod = 704539;
UPDATE ruian_katastr SET nazev = 'Níhov' WHERE kod = 704547;
UPDATE ruian_katastr SET nazev = 'Nikolčice' WHERE kod = 704555;
UPDATE ruian_katastr SET nazev = 'Níkovice' WHERE kod = 704571;
UPDATE ruian_katastr SET nazev = 'Niměřice' WHERE kod = 704601;
UPDATE ruian_katastr SET nazev = 'Nimpšov' WHERE kod = 704610;
UPDATE ruian_katastr SET nazev = 'Černětice' WHERE kod = 704628;
UPDATE ruian_katastr SET nazev = 'Nišovice' WHERE kod = 704636;
UPDATE ruian_katastr SET nazev = 'Račí u Nišovic' WHERE kod = 704644;
UPDATE ruian_katastr SET nazev = 'Nítkovice' WHERE kod = 704652;
UPDATE ruian_katastr SET nazev = 'Niva' WHERE kod = 704661;
UPDATE ruian_katastr SET nazev = 'Nivnice' WHERE kod = 704679;
UPDATE ruian_katastr SET nazev = 'Nižbor' WHERE kod = 704687;
UPDATE ruian_katastr SET nazev = 'Nížebohy' WHERE kod = 704709;
UPDATE ruian_katastr SET nazev = 'Buková u Nížkova' WHERE kod = 704717;
UPDATE ruian_katastr SET nazev = 'Nížkov' WHERE kod = 704725;
UPDATE ruian_katastr SET nazev = 'Špinov' WHERE kod = 704733;
UPDATE ruian_katastr SET nazev = 'Heršpice' WHERE kod = 704741;
UPDATE ruian_katastr SET nazev = 'Nížkovice' WHERE kod = 704768;
UPDATE ruian_katastr SET nazev = 'Norberčany' WHERE kod = 704776;
UPDATE ruian_katastr SET nazev = 'Trhavice' WHERE kod = 704784;
UPDATE ruian_katastr SET nazev = 'Libovice' WHERE kod = 704792;
UPDATE ruian_katastr SET nazev = 'Nosálov' WHERE kod = 704806;
UPDATE ruian_katastr SET nazev = 'Květuš' WHERE kod = 704831;
UPDATE ruian_katastr SET nazev = 'Nosetín' WHERE kod = 704849;
UPDATE ruian_katastr SET nazev = 'Nosislav' WHERE kod = 704865;
UPDATE ruian_katastr SET nazev = 'Noskov' WHERE kod = 704881;
UPDATE ruian_katastr SET nazev = 'Nižní Lhoty' WHERE kod = 704903;
UPDATE ruian_katastr SET nazev = 'Nošovice' WHERE kod = 704911;
UPDATE ruian_katastr SET nazev = 'Nouzov u Dymokur' WHERE kod = 704920;
UPDATE ruian_katastr SET nazev = 'Nová Bělá' WHERE kod = 704946;
UPDATE ruian_katastr SET nazev = 'Nová Buková' WHERE kod = 704954;
UPDATE ruian_katastr SET nazev = 'Artolec' WHERE kod = 704962;
UPDATE ruian_katastr SET nazev = 'Nová Bystřice' WHERE kod = 704971;
UPDATE ruian_katastr SET nazev = 'Hradiště u Nové Bystřice' WHERE kod = 705004;
UPDATE ruian_katastr SET nazev = 'Nová Cerekev' WHERE kod = 705012;
UPDATE ruian_katastr SET nazev = 'Stanovice u Nové Cerekve' WHERE kod = 705021;
UPDATE ruian_katastr SET nazev = 'Nová Dědina' WHERE kod = 705039;
UPDATE ruian_katastr SET nazev = 'Nová Dědina u Konice' WHERE kod = 705047;
UPDATE ruian_katastr SET nazev = 'Nová Hradečná' WHERE kod = 705063;
UPDATE ruian_katastr SET nazev = 'Nová Lhota' WHERE kod = 705071;
UPDATE ruian_katastr SET nazev = 'Nová Lhota u Veselí nad Moravou' WHERE kod = 705098;
UPDATE ruian_katastr SET nazev = 'Nová Paka' WHERE kod = 705128;
UPDATE ruian_katastr SET nazev = 'Nová Pec' WHERE kod = 705225;
UPDATE ruian_katastr SET nazev = 'Mezirolí' WHERE kod = 705241;
UPDATE ruian_katastr SET nazev = 'Nová Role' WHERE kod = 705250;
UPDATE ruian_katastr SET nazev = 'Nová Říše' WHERE kod = 705268;
UPDATE ruian_katastr SET nazev = 'Nová Telib' WHERE kod = 705276;
UPDATE ruian_katastr SET nazev = 'Dívčí Kopy' WHERE kod = 705292;
UPDATE ruian_katastr SET nazev = 'Hadravova Rosička' WHERE kod = 705306;
UPDATE ruian_katastr SET nazev = 'Nová Včelnice' WHERE kod = 705322;
UPDATE ruian_katastr SET nazev = 'Vlčetínec' WHERE kod = 705331;
UPDATE ruian_katastr SET nazev = 'Žďár u Nové Včelnice' WHERE kod = 705349;
UPDATE ruian_katastr SET nazev = 'Malá Rosička' WHERE kod = 705357;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Postupic' WHERE kod = 705373;
UPDATE ruian_katastr SET nazev = 'Pozov' WHERE kod = 705381;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Nelahozevsi' WHERE kod = 705390;
UPDATE ruian_katastr SET nazev = 'Čakovičky' WHERE kod = 705403;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Prahy' WHERE kod = 705411;
UPDATE ruian_katastr SET nazev = 'Lhota u Rakovníka' WHERE kod = 705438;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Rakovníka' WHERE kod = 705446;
UPDATE ruian_katastr SET nazev = 'Jaronín' WHERE kod = 705471;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Brloha' WHERE kod = 705497;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Sedla' WHERE kod = 705527;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Strakonic' WHERE kod = 705535;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Kdyně' WHERE kod = 705543;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Plzně' WHERE kod = 705551;
UPDATE ruian_katastr SET nazev = 'Louka u Mariánských Lázní' WHERE kod = 705560;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Sokolova' WHERE kod = 705578;
UPDATE ruian_katastr SET nazev = 'Mlýnice' WHERE kod = 705586;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Chrastavy' WHERE kod = 705594;
UPDATE ruian_katastr SET nazev = 'Nová Ves' WHERE kod = 705616;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Voděrad' WHERE kod = 705624;
UPDATE ruian_katastr SET nazev = 'Vojenice' WHERE kod = 705632;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Moravské Třebové' WHERE kod = 705641;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Oslavan' WHERE kod = 705659;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Pohořelic' WHERE kod = 705667;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Třešti' WHERE kod = 705675;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Třebíče' WHERE kod = 705683;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Heřmanova' WHERE kod = 705691;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Frýdlantu nad Ostravicí' WHERE kod = 705705;
UPDATE ruian_katastr SET nazev = 'Nová Ves I' WHERE kod = 705713;
UPDATE ruian_katastr SET nazev = 'Krabonoš' WHERE kod = 705730;
UPDATE ruian_katastr SET nazev = 'Nová Ves nad Lužnicí' WHERE kod = 705756;
UPDATE ruian_katastr SET nazev = 'Nová Ves nad Nisou' WHERE kod = 705799;
UPDATE ruian_katastr SET nazev = 'Nová Ves nad Popelkou' WHERE kod = 705802;
UPDATE ruian_katastr SET nazev = 'Nová Ves pod Pleší' WHERE kod = 705811;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Bakova nad Jizerou' WHERE kod = 705837;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Chotěboře' WHERE kod = 705845;
UPDATE ruian_katastr SET nazev = 'Víska u Chotěboře' WHERE kod = 705861;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Chýnova' WHERE kod = 705870;
UPDATE ruian_katastr SET nazev = 'Turovec' WHERE kod = 705888;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Leštiny' WHERE kod = 705896;
UPDATE ruian_katastr SET nazev = 'Horní Střítež' WHERE kod = 705900;
UPDATE ruian_katastr SET nazev = 'Křtěnovice' WHERE kod = 705918;
UPDATE ruian_katastr SET nazev = 'Mutice' WHERE kod = 705926;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Mladé Vožice' WHERE kod = 705934;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Nepomuka' WHERE kod = 705942;
UPDATE ruian_katastr SET nazev = 'Křídla' WHERE kod = 705951;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Nového Města na Moravě' WHERE kod = 705969;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Světlé nad Sázavou' WHERE kod = 705985;
UPDATE ruian_katastr SET nazev = 'Lesná v Krušných horách' WHERE kod = 705993;
UPDATE ruian_katastr SET nazev = 'Mikulovice v Krušných horách' WHERE kod = 706001;
UPDATE ruian_katastr SET nazev = 'Mníšek v Krušných horách' WHERE kod = 706019;
UPDATE ruian_katastr SET nazev = 'Nová Ves v Horách' WHERE kod = 706027;
UPDATE ruian_katastr SET nazev = 'Nová Véska' WHERE kod = 706035;
UPDATE ruian_katastr SET nazev = 'Nové Bránice' WHERE kod = 706043;
UPDATE ruian_katastr SET nazev = 'Hlízov' WHERE kod = 706051;
UPDATE ruian_katastr SET nazev = 'Nové Dvory u Kutné Hory' WHERE kod = 706078;
UPDATE ruian_katastr SET nazev = 'Krámy' WHERE kod = 706086;
UPDATE ruian_katastr SET nazev = 'Nové Dvory u Dobříše' WHERE kod = 706094;
UPDATE ruian_katastr SET nazev = 'Nové Dvory' WHERE kod = 706116;
UPDATE ruian_katastr SET nazev = 'Chvalín' WHERE kod = 706124;
UPDATE ruian_katastr SET nazev = 'Nové Dvory u Doksan' WHERE kod = 706132;
UPDATE ruian_katastr SET nazev = 'Nové Dvory nad Bečvou' WHERE kod = 706141;
UPDATE ruian_katastr SET nazev = 'Jelení u Nových Hamrů' WHERE kod = 706159;
UPDATE ruian_katastr SET nazev = 'Nové Hamry' WHERE kod = 706167;
UPDATE ruian_katastr SET nazev = 'Nové Heřminovy' WHERE kod = 706183;
UPDATE ruian_katastr SET nazev = 'Byňov' WHERE kod = 706191;
UPDATE ruian_katastr SET nazev = 'Mýtiny' WHERE kod = 706230;
UPDATE ruian_katastr SET nazev = 'Nakolice' WHERE kod = 706248;
UPDATE ruian_katastr SET nazev = 'Nové Hrady' WHERE kod = 706256;
UPDATE ruian_katastr SET nazev = 'Štiptoň' WHERE kod = 706264;
UPDATE ruian_katastr SET nazev = 'Údolí u Nových Hradů' WHERE kod = 706272;
UPDATE ruian_katastr SET nazev = 'Veveří u Nových Hradů' WHERE kod = 706281;
UPDATE ruian_katastr SET nazev = 'Mokrá Lhota' WHERE kod = 706299;
UPDATE ruian_katastr SET nazev = 'Nové Hrady u Skutče' WHERE kod = 706302;
UPDATE ruian_katastr SET nazev = 'Nové Kopisty' WHERE kod = 706337;
UPDATE ruian_katastr SET nazev = 'Nové Lesy' WHERE kod = 706353;
UPDATE ruian_katastr SET nazev = 'Labe' WHERE kod = 706361;
UPDATE ruian_katastr SET nazev = 'Nové Losiny' WHERE kod = 706370;
UPDATE ruian_katastr SET nazev = 'Nové Lublice' WHERE kod = 706388;
UPDATE ruian_katastr SET nazev = 'Nové Město nad Cidlinou' WHERE kod = 706396;
UPDATE ruian_katastr SET nazev = 'Maršovice u Nového Města na Moravě' WHERE kod = 706400;
UPDATE ruian_katastr SET nazev = 'Nové Město na Moravě' WHERE kod = 706418;
UPDATE ruian_katastr SET nazev = 'Pohledec' WHERE kod = 706426;
UPDATE ruian_katastr SET nazev = 'Krčín' WHERE kod = 706434;
UPDATE ruian_katastr SET nazev = 'Nové Město nad Metují' WHERE kod = 706442;
UPDATE ruian_katastr SET nazev = 'Spy' WHERE kod = 706485;
UPDATE ruian_katastr SET nazev = 'Hajniště pod Smrkem' WHERE kod = 706507;
UPDATE ruian_katastr SET nazev = 'Ludvíkov pod Smrkem' WHERE kod = 706515;
UPDATE ruian_katastr SET nazev = 'Nové Město pod Smrkem' WHERE kod = 706523;
UPDATE ruian_katastr SET nazev = 'Mítov' WHERE kod = 706540;
UPDATE ruian_katastr SET nazev = 'Nové Mitrovice' WHERE kod = 706558;
UPDATE ruian_katastr SET nazev = 'Planiny' WHERE kod = 706566;
UPDATE ruian_katastr SET nazev = 'Nové Ouholice' WHERE kod = 706582;
UPDATE ruian_katastr SET nazev = 'Vepřek' WHERE kod = 706604;
UPDATE ruian_katastr SET nazev = 'Nové Sady' WHERE kod = 706621;
UPDATE ruian_katastr SET nazev = 'Nové Sady u Velké Bíteše' WHERE kod = 706639;
UPDATE ruian_katastr SET nazev = 'Nové Sedlice' WHERE kod = 706647;
UPDATE ruian_katastr SET nazev = 'Loučky u Lokte' WHERE kod = 706663;
UPDATE ruian_katastr SET nazev = 'Nové Sedlo u Lokte' WHERE kod = 706680;
UPDATE ruian_katastr SET nazev = 'Chudeřín' WHERE kod = 706701;
UPDATE ruian_katastr SET nazev = 'Nové Sedlo u Žatce' WHERE kod = 706710;
UPDATE ruian_katastr SET nazev = 'Nové Sedlo nad Bílinou' WHERE kod = 706728;
UPDATE ruian_katastr SET nazev = 'Nové Smrkovice' WHERE kod = 706736;
UPDATE ruian_katastr SET nazev = 'Nové Strašecí' WHERE kod = 706744;
UPDATE ruian_katastr SET nazev = 'Krnčice' WHERE kod = 706779;
UPDATE ruian_katastr SET nazev = 'Láz u Nových Syrovic' WHERE kod = 706787;
UPDATE ruian_katastr SET nazev = 'Nové Syrovice' WHERE kod = 706795;
UPDATE ruian_katastr SET nazev = 'Lhotka u Vítkova' WHERE kod = 706809;
UPDATE ruian_katastr SET nazev = 'Nové Těchanovice' WHERE kod = 706817;
UPDATE ruian_katastr SET nazev = 'Nové Veselí' WHERE kod = 706833;
UPDATE ruian_katastr SET nazev = 'Nové Zámky' WHERE kod = 706841;
UPDATE ruian_katastr SET nazev = 'Novičí' WHERE kod = 706850;
UPDATE ruian_katastr SET nazev = 'Noviny pod Ralskem' WHERE kod = 706868;
UPDATE ruian_katastr SET nazev = 'Novosedlice' WHERE kod = 706876;
UPDATE ruian_katastr SET nazev = 'Novosedly u Rakovníka' WHERE kod = 706884;
UPDATE ruian_katastr SET nazev = 'Koclov' WHERE kod = 706892;
UPDATE ruian_katastr SET nazev = 'Novosedly u Strakonic' WHERE kod = 706906;
UPDATE ruian_katastr SET nazev = 'Sloučín' WHERE kod = 706914;
UPDATE ruian_katastr SET nazev = 'Chlum u Novosedel' WHERE kod = 706922;
UPDATE ruian_katastr SET nazev = 'Močidlec' WHERE kod = 706931;
UPDATE ruian_katastr SET nazev = 'Novosedly u Žlutic' WHERE kod = 706949;
UPDATE ruian_katastr SET nazev = 'Vladořice' WHERE kod = 706957;
UPDATE ruian_katastr SET nazev = 'Záhořice' WHERE kod = 706965;
UPDATE ruian_katastr SET nazev = 'Novosedly na Moravě' WHERE kod = 706973;
UPDATE ruian_katastr SET nazev = 'Kolence' WHERE kod = 706981;
UPDATE ruian_katastr SET nazev = 'Mláka' WHERE kod = 706990;
UPDATE ruian_katastr SET nazev = 'Novosedly nad Nežárkou' WHERE kod = 707007;
UPDATE ruian_katastr SET nazev = 'Nový Bohumín' WHERE kod = 707031;
UPDATE ruian_katastr SET nazev = 'Kopytov' WHERE kod = 707139;
UPDATE ruian_katastr SET nazev = 'Arnultovice u Nového Boru' WHERE kod = 707147;
UPDATE ruian_katastr SET nazev = 'Nový Bor' WHERE kod = 707155;
UPDATE ruian_katastr SET nazev = 'Nový Bydžov' WHERE kod = 707163;
UPDATE ruian_katastr SET nazev = 'Chudonice' WHERE kod = 707198;
UPDATE ruian_katastr SET nazev = 'Zábědov' WHERE kod = 707210;
UPDATE ruian_katastr SET nazev = 'Nový Dům' WHERE kod = 707279;
UPDATE ruian_katastr SET nazev = 'Nový Dvůr u Oskořínka' WHERE kod = 707287;
UPDATE ruian_katastr SET nazev = 'Nový Dvůr u Opavy' WHERE kod = 707309;
UPDATE ruian_katastr SET nazev = 'Dlouhé' WHERE kod = 707317;
UPDATE ruian_katastr SET nazev = 'Nový Hrádek' WHERE kod = 707341;
UPDATE ruian_katastr SET nazev = 'Nový Hrozenkov' WHERE kod = 707384;
UPDATE ruian_katastr SET nazev = 'Nový Jáchymov' WHERE kod = 707406;
UPDATE ruian_katastr SET nazev = 'Nový Jičín-město' WHERE kod = 707414;
UPDATE ruian_katastr SET nazev = 'Nový Jičín-Horní Předměstí' WHERE kod = 707431;
UPDATE ruian_katastr SET nazev = 'Nový Jičín-Dolní Předměstí' WHERE kod = 707465;
UPDATE ruian_katastr SET nazev = 'Žilina u Nového Jičína' WHERE kod = 707511;
UPDATE ruian_katastr SET nazev = 'Šenov u Nového Jičína' WHERE kod = 707546;
UPDATE ruian_katastr SET nazev = 'Nový Jimramov' WHERE kod = 707597;
UPDATE ruian_katastr SET nazev = 'Svatý Jiří' WHERE kod = 707601;
UPDATE ruian_katastr SET nazev = 'Kozí Hory' WHERE kod = 707627;
UPDATE ruian_katastr SET nazev = 'Nový Knín' WHERE kod = 707635;
UPDATE ruian_katastr SET nazev = 'Starý Knín' WHERE kod = 707643;
UPDATE ruian_katastr SET nazev = 'Sudovice' WHERE kod = 707651;
UPDATE ruian_katastr SET nazev = 'Božetín' WHERE kod = 707660;
UPDATE ruian_katastr SET nazev = 'Čižebná' WHERE kod = 707678;
UPDATE ruian_katastr SET nazev = 'Hrzín u Nového Kostela' WHERE kod = 707686;
UPDATE ruian_katastr SET nazev = 'Lesná u Nového Kostela' WHERE kod = 707694;
UPDATE ruian_katastr SET nazev = 'Nový Kostel' WHERE kod = 707708;
UPDATE ruian_katastr SET nazev = 'Smrčí u Nového Kostela' WHERE kod = 707724;
UPDATE ruian_katastr SET nazev = 'Svažec' WHERE kod = 707732;
UPDATE ruian_katastr SET nazev = 'Nový Kramolín' WHERE kod = 707741;
UPDATE ruian_katastr SET nazev = 'Pařezov' WHERE kod = 707759;
UPDATE ruian_katastr SET nazev = 'Ohnišťovice' WHERE kod = 707767;
UPDATE ruian_katastr SET nazev = 'Otov u Nového Kramolína' WHERE kod = 707775;
UPDATE ruian_katastr SET nazev = 'Šitboř' WHERE kod = 707783;
UPDATE ruian_katastr SET nazev = 'Vlkanov u Nového Kramolína' WHERE kod = 707791;
UPDATE ruian_katastr SET nazev = 'Valtířov u Nového Kramolína' WHERE kod = 707805;
UPDATE ruian_katastr SET nazev = 'Nový Malín' WHERE kod = 707813;
UPDATE ruian_katastr SET nazev = 'Mistrovice u Nového Oldřichova' WHERE kod = 707821;
UPDATE ruian_katastr SET nazev = 'Nový Oldřichov' WHERE kod = 707830;
UPDATE ruian_katastr SET nazev = 'Nový Ples' WHERE kod = 707848;
UPDATE ruian_katastr SET nazev = 'Nový Poddvorov' WHERE kod = 707856;
UPDATE ruian_katastr SET nazev = 'Nový Přerov' WHERE kod = 707864;
UPDATE ruian_katastr SET nazev = 'Nový Rychnov' WHERE kod = 707881;
UPDATE ruian_katastr SET nazev = 'Borová Lada' WHERE kod = 707899;
UPDATE ruian_katastr SET nazev = 'Nové Hutě' WHERE kod = 707902;
UPDATE ruian_katastr SET nazev = 'Nový Svět u Borových Lad' WHERE kod = 707911;
UPDATE ruian_katastr SET nazev = 'Paseka u Borových Lad' WHERE kod = 707929;
UPDATE ruian_katastr SET nazev = 'Svinná Lada' WHERE kod = 707937;
UPDATE ruian_katastr SET nazev = 'Šindlov' WHERE kod = 707945;
UPDATE ruian_katastr SET nazev = 'Černá Lada' WHERE kod = 707953;
UPDATE ruian_katastr SET nazev = 'Knížecí Pláně' WHERE kod = 707961;
UPDATE ruian_katastr SET nazev = 'Zahrádky u Borových Lad' WHERE kod = 707970;
UPDATE ruian_katastr SET nazev = 'Nový Šaldorf' WHERE kod = 707988;
UPDATE ruian_katastr SET nazev = 'Sedlešovice' WHERE kod = 707996;
UPDATE ruian_katastr SET nazev = 'Nový Telečkov' WHERE kod = 708003;
UPDATE ruian_katastr SET nazev = 'Oslavička' WHERE kod = 708011;
UPDATE ruian_katastr SET nazev = 'Káraný' WHERE kod = 708020;
UPDATE ruian_katastr SET nazev = 'Nový Vestec' WHERE kod = 708038;
UPDATE ruian_katastr SET nazev = 'Nový Vojířov' WHERE kod = 708046;
UPDATE ruian_katastr SET nazev = 'Nučice u Rudné' WHERE kod = 708062;
UPDATE ruian_katastr SET nazev = 'Konojedy' WHERE kod = 708097;
UPDATE ruian_katastr SET nazev = 'Nučice' WHERE kod = 708101;
UPDATE ruian_katastr SET nazev = 'Oplany' WHERE kod = 708119;
UPDATE ruian_katastr SET nazev = 'Prusice' WHERE kod = 708127;
UPDATE ruian_katastr SET nazev = 'Výžerky' WHERE kod = 708135;
UPDATE ruian_katastr SET nazev = 'Nuzice' WHERE kod = 708143;
UPDATE ruian_katastr SET nazev = 'Nýdek' WHERE kod = 708186;
UPDATE ruian_katastr SET nazev = 'Nyklovice' WHERE kod = 708224;
UPDATE ruian_katastr SET nazev = 'Nymburk' WHERE kod = 708232;
UPDATE ruian_katastr SET nazev = 'Drahelice' WHERE kod = 708381;
UPDATE ruian_katastr SET nazev = 'Nynice' WHERE kod = 708399;
UPDATE ruian_katastr SET nazev = 'Planá u Nynic' WHERE kod = 708402;
UPDATE ruian_katastr SET nazev = 'Nýrov' WHERE kod = 708411;
UPDATE ruian_katastr SET nazev = 'Blata' WHERE kod = 708437;
UPDATE ruian_katastr SET nazev = 'Hodousice' WHERE kod = 708445;
UPDATE ruian_katastr SET nazev = 'Nýrsko' WHERE kod = 708453;
UPDATE ruian_katastr SET nazev = 'Stará Lhota' WHERE kod = 708461;
UPDATE ruian_katastr SET nazev = 'Kamenný Újezd u Nýřan' WHERE kod = 708470;
UPDATE ruian_katastr SET nazev = 'Nýřany' WHERE kod = 708496;
UPDATE ruian_katastr SET nazev = 'Občov' WHERE kod = 708526;
UPDATE ruian_katastr SET nazev = 'Obděnice' WHERE kod = 708534;
UPDATE ruian_katastr SET nazev = 'Žemličkova Lhota' WHERE kod = 708551;
UPDATE ruian_katastr SET nazev = 'Obecnice' WHERE kod = 708569;
UPDATE ruian_katastr SET nazev = 'Obědkovice' WHERE kod = 708577;
UPDATE ruian_katastr SET nazev = 'Hartvíkov' WHERE kod = 708585;
UPDATE ruian_katastr SET nazev = 'Oblajovice' WHERE kod = 708607;
UPDATE ruian_katastr SET nazev = 'Oblekovice' WHERE kod = 708615;
UPDATE ruian_katastr SET nazev = 'Obora u Kaznějova' WHERE kod = 708623;
UPDATE ruian_katastr SET nazev = 'Obora u Boskovic' WHERE kod = 708640;
UPDATE ruian_katastr SET nazev = 'Obory' WHERE kod = 708658;
UPDATE ruian_katastr SET nazev = 'Lhotka u Dobříše' WHERE kod = 708674;
UPDATE ruian_katastr SET nazev = 'Obořiště' WHERE kod = 708682;
UPDATE ruian_katastr SET nazev = 'Bezděčín u Obrataně' WHERE kod = 708691;
UPDATE ruian_katastr SET nazev = 'Hrobská Zahrádka' WHERE kod = 708704;
UPDATE ruian_katastr SET nazev = 'Obrataň' WHERE kod = 708712;
UPDATE ruian_katastr SET nazev = 'Šimpach' WHERE kod = 708721;
UPDATE ruian_katastr SET nazev = 'České Zlatníky' WHERE kod = 708739;
UPDATE ruian_katastr SET nazev = 'Chanov' WHERE kod = 708747;
UPDATE ruian_katastr SET nazev = 'Obrnice' WHERE kod = 708755;
UPDATE ruian_katastr SET nazev = 'Lítkovice u Kněžmostu' WHERE kod = 708771;
UPDATE ruian_katastr SET nazev = 'Obrubce' WHERE kod = 708798;
UPDATE ruian_katastr SET nazev = 'Obruby' WHERE kod = 708801;
UPDATE ruian_katastr SET nazev = 'Obříství' WHERE kod = 708828;
UPDATE ruian_katastr SET nazev = 'Úpor' WHERE kod = 708836;
UPDATE ruian_katastr SET nazev = 'Obyčtov' WHERE kod = 708844;
UPDATE ruian_katastr SET nazev = 'Habartice u Obytců' WHERE kod = 708852;
UPDATE ruian_katastr SET nazev = 'Obytce' WHERE kod = 708861;
UPDATE ruian_katastr SET nazev = 'Ocmanice' WHERE kod = 708887;
UPDATE ruian_katastr SET nazev = 'Městec nad Dědinou' WHERE kod = 708895;
UPDATE ruian_katastr SET nazev = 'Očelice' WHERE kod = 708909;
UPDATE ruian_katastr SET nazev = 'Očihov' WHERE kod = 708917;
UPDATE ruian_katastr SET nazev = 'Očihovec' WHERE kod = 708925;
UPDATE ruian_katastr SET nazev = 'Čečkov' WHERE kod = 708933;
UPDATE ruian_katastr SET nazev = 'Nosákov' WHERE kod = 708941;
UPDATE ruian_katastr SET nazev = 'Odlochovice' WHERE kod = 708950;
UPDATE ruian_katastr SET nazev = 'Čenkov' WHERE kod = 708976;
UPDATE ruian_katastr SET nazev = 'Dolínek' WHERE kod = 708984;
UPDATE ruian_katastr SET nazev = 'Odolena Voda' WHERE kod = 708992;
UPDATE ruian_katastr SET nazev = 'Břetětice' WHERE kod = 709000;
UPDATE ruian_katastr SET nazev = 'Odolenov' WHERE kod = 709018;
UPDATE ruian_katastr SET nazev = 'Dobroše' WHERE kod = 709026;
UPDATE ruian_katastr SET nazev = 'Mostov' WHERE kod = 709042;
UPDATE ruian_katastr SET nazev = 'Obilná' WHERE kod = 709051;
UPDATE ruian_katastr SET nazev = 'Odrava' WHERE kod = 709069;
UPDATE ruian_katastr SET nazev = 'Odrovice' WHERE kod = 709077;
UPDATE ruian_katastr SET nazev = 'Odry' WHERE kod = 709085;
UPDATE ruian_katastr SET nazev = 'Veselí u Oder' WHERE kod = 709158;
UPDATE ruian_katastr SET nazev = 'Odřepsy' WHERE kod = 709174;
UPDATE ruian_katastr SET nazev = 'Odunec' WHERE kod = 709182;
UPDATE ruian_katastr SET nazev = 'Dománovice' WHERE kod = 709191;
UPDATE ruian_katastr SET nazev = 'Ohaře' WHERE kod = 709204;
UPDATE ruian_katastr SET nazev = 'Polní Chrčice' WHERE kod = 709212;
UPDATE ruian_katastr SET nazev = 'Křemýž' WHERE kod = 709221;
UPDATE ruian_katastr SET nazev = 'Ohníč' WHERE kod = 709239;
UPDATE ruian_katastr SET nazev = 'Ohnišov' WHERE kod = 709263;
UPDATE ruian_katastr SET nazev = 'Zákraví' WHERE kod = 709271;
UPDATE ruian_katastr SET nazev = 'Ohnišťany' WHERE kod = 709280;
UPDATE ruian_katastr SET nazev = 'Ohrazenice u Jinec' WHERE kod = 709310;
UPDATE ruian_katastr SET nazev = 'Ohrazenice' WHERE kod = 709328;
UPDATE ruian_katastr SET nazev = 'Ohrazenice u Turnova' WHERE kod = 709336;
UPDATE ruian_katastr SET nazev = 'Ohrobec' WHERE kod = 709352;
UPDATE ruian_katastr SET nazev = 'Ohrozim' WHERE kod = 709361;
UPDATE ruian_katastr SET nazev = 'Ochoz u Nasavrk' WHERE kod = 709395;
UPDATE ruian_katastr SET nazev = 'Ochoz u Konice' WHERE kod = 709417;
UPDATE ruian_katastr SET nazev = 'Ochoz u Brna' WHERE kod = 709433;
UPDATE ruian_katastr SET nazev = 'Ochoz u Tišnova' WHERE kod = 709441;
UPDATE ruian_katastr SET nazev = 'Okarec' WHERE kod = 709450;
UPDATE ruian_katastr SET nazev = 'Obora v Podbezdězí' WHERE kod = 709468;
UPDATE ruian_katastr SET nazev = 'Okna v Podbezdězí' WHERE kod = 709476;
UPDATE ruian_katastr SET nazev = 'Kotvina' WHERE kod = 709484;
UPDATE ruian_katastr SET nazev = 'Krupice' WHERE kod = 709492;
UPDATE ruian_katastr SET nazev = 'Okounov' WHERE kod = 709506;
UPDATE ruian_katastr SET nazev = 'Oslovice' WHERE kod = 709514;
UPDATE ruian_katastr SET nazev = 'Jesenice u Chebu' WHERE kod = 709522;
UPDATE ruian_katastr SET nazev = 'Okrouhlá u Chebu' WHERE kod = 709531;
UPDATE ruian_katastr SET nazev = 'Salajna' WHERE kod = 709549;
UPDATE ruian_katastr SET nazev = 'Úval' WHERE kod = 709557;
UPDATE ruian_katastr SET nazev = 'Velká Šitboř' WHERE kod = 709565;
UPDATE ruian_katastr SET nazev = 'Okrouhlá u Nového Boru' WHERE kod = 709573;
UPDATE ruian_katastr SET nazev = 'Okrouhlá u Boskovic' WHERE kod = 709581;
UPDATE ruian_katastr SET nazev = 'Dlouhé Hradiště' WHERE kod = 709590;
UPDATE ruian_katastr SET nazev = 'Okrouhlé Hradiště' WHERE kod = 709603;
UPDATE ruian_katastr SET nazev = 'Poloučany' WHERE kod = 709611;
UPDATE ruian_katastr SET nazev = 'Babice u Okrouhlice' WHERE kod = 709620;
UPDATE ruian_katastr SET nazev = 'Chlístov u Okrouhlice' WHERE kod = 709638;
UPDATE ruian_katastr SET nazev = 'Okrouhlice' WHERE kod = 709654;
UPDATE ruian_katastr SET nazev = 'Olešnice u Okrouhlice' WHERE kod = 709662;
UPDATE ruian_katastr SET nazev = 'Vadín' WHERE kod = 709671;
UPDATE ruian_katastr SET nazev = 'Okrouhlička' WHERE kod = 709697;
UPDATE ruian_katastr SET nazev = 'Okrouhlo' WHERE kod = 709719;
UPDATE ruian_katastr SET nazev = 'Okřesaneč' WHERE kod = 709735;
UPDATE ruian_katastr SET nazev = 'Okřešice u České Lípy' WHERE kod = 709743;
UPDATE ruian_katastr SET nazev = 'Okřínek' WHERE kod = 709751;
UPDATE ruian_katastr SET nazev = 'Srbce u Okřínka' WHERE kod = 709760;
UPDATE ruian_katastr SET nazev = 'Okříšky' WHERE kod = 709778;
UPDATE ruian_katastr SET nazev = 'Olbramice' WHERE kod = 709808;
UPDATE ruian_katastr SET nazev = 'Olbramkostel' WHERE kod = 709816;
UPDATE ruian_katastr SET nazev = 'Olbramov' WHERE kod = 709824;
UPDATE ruian_katastr SET nazev = 'Zádub u Olbramova' WHERE kod = 709832;
UPDATE ruian_katastr SET nazev = 'Křešice u Olbramovic' WHERE kod = 709859;
UPDATE ruian_katastr SET nazev = 'Olbramovice u Votic' WHERE kod = 709875;
UPDATE ruian_katastr SET nazev = 'Zahradnice' WHERE kod = 709921;
UPDATE ruian_katastr SET nazev = 'Olbramovice u Moravského Krumlova' WHERE kod = 709930;
UPDATE ruian_katastr SET nazev = 'Oldřetice' WHERE kod = 709948;
UPDATE ruian_katastr SET nazev = 'Oldřichov u Mladé Vožice' WHERE kod = 709956;
UPDATE ruian_katastr SET nazev = 'Zhoř u Mladé Vožice' WHERE kod = 709981;
UPDATE ruian_katastr SET nazev = 'Oldřichov na Moravě' WHERE kod = 709999;
UPDATE ruian_katastr SET nazev = 'Oldřichov na Hranicích' WHERE kod = 710008;
UPDATE ruian_katastr SET nazev = 'Oldřichov v Hájích' WHERE kod = 710016;
UPDATE ruian_katastr SET nazev = 'Oldřichovice u Napajedel' WHERE kod = 710024;
UPDATE ruian_katastr SET nazev = 'Oldřichovice u Třince' WHERE kod = 710032;
UPDATE ruian_katastr SET nazev = 'Oldřiš u Hlinska' WHERE kod = 710075;
UPDATE ruian_katastr SET nazev = 'Oldřiš u Poličky' WHERE kod = 710091;
UPDATE ruian_katastr SET nazev = 'Oldřišov' WHERE kod = 710113;
UPDATE ruian_katastr SET nazev = 'Oleksovice' WHERE kod = 710121;
UPDATE ruian_katastr SET nazev = 'Olešenka' WHERE kod = 710130;
UPDATE ruian_katastr SET nazev = 'Brník' WHERE kod = 710148;
UPDATE ruian_katastr SET nazev = 'Krymlov' WHERE kod = 710172;
UPDATE ruian_katastr SET nazev = 'Oleška' WHERE kod = 710181;
UPDATE ruian_katastr SET nazev = 'Olešná u Hořovic' WHERE kod = 710199;
UPDATE ruian_katastr SET nazev = 'Olešná u Rakovníka' WHERE kod = 710202;
UPDATE ruian_katastr SET nazev = 'Chválov u Pelhřimova' WHERE kod = 710211;
UPDATE ruian_katastr SET nazev = 'Olešná u Pelhřimova' WHERE kod = 710229;
UPDATE ruian_katastr SET nazev = 'Plevnice' WHERE kod = 710237;
UPDATE ruian_katastr SET nazev = 'Řemenov' WHERE kod = 710245;
UPDATE ruian_katastr SET nazev = 'Olešná u Radnic' WHERE kod = 710253;
UPDATE ruian_katastr SET nazev = 'Bonětice' WHERE kod = 710261;
UPDATE ruian_katastr SET nazev = 'Bonětičky' WHERE kod = 710270;
UPDATE ruian_katastr SET nazev = 'Olešná' WHERE kod = 710288;
UPDATE ruian_katastr SET nazev = 'Olešná u Havlíčkova Brodu' WHERE kod = 710296;
UPDATE ruian_katastr SET nazev = 'Hořice u Blanska' WHERE kod = 710300;
UPDATE ruian_katastr SET nazev = 'Olešná u Blanska' WHERE kod = 710318;
UPDATE ruian_katastr SET nazev = 'Olešná na Moravě' WHERE kod = 710326;
UPDATE ruian_katastr SET nazev = 'Olešnice u Trhových Svinů' WHERE kod = 710334;
UPDATE ruian_katastr SET nazev = 'Levín nad Cidlinou' WHERE kod = 710342;
UPDATE ruian_katastr SET nazev = 'Olešnice nad Cidlinou' WHERE kod = 710351;
UPDATE ruian_katastr SET nazev = 'Olešnice u Červeného Kostelce' WHERE kod = 710369;
UPDATE ruian_katastr SET nazev = 'Hoděčín' WHERE kod = 710377;
UPDATE ruian_katastr SET nazev = 'Olešnice u Rychnova nad Kněžnou' WHERE kod = 710385;
UPDATE ruian_katastr SET nazev = 'Olešnice u Turnova' WHERE kod = 710393;
UPDATE ruian_katastr SET nazev = 'Olešnice na Moravě' WHERE kod = 710415;
UPDATE ruian_katastr SET nazev = 'Horka u Staré Paky' WHERE kod = 710423;
UPDATE ruian_katastr SET nazev = 'Levínská Olešnice' WHERE kod = 710431;
UPDATE ruian_katastr SET nazev = 'Nedaříž' WHERE kod = 710440;
UPDATE ruian_katastr SET nazev = 'Žďár u Staré Paky' WHERE kod = 710458;
UPDATE ruian_katastr SET nazev = 'Olešnice v Orlických horách' WHERE kod = 710466;
UPDATE ruian_katastr SET nazev = 'Olešník' WHERE kod = 710491;
UPDATE ruian_katastr SET nazev = 'Olomouc-město' WHERE kod = 710504;
UPDATE ruian_katastr SET nazev = 'Klášterní Hradisko' WHERE kod = 710555;
UPDATE ruian_katastr SET nazev = 'Černovír' WHERE kod = 710571;
UPDATE ruian_katastr SET nazev = 'Lazce' WHERE kod = 710598;
UPDATE ruian_katastr SET nazev = 'Hejčín' WHERE kod = 710644;
UPDATE ruian_katastr SET nazev = 'Neředín' WHERE kod = 710687;
UPDATE ruian_katastr SET nazev = 'Nová Ulice' WHERE kod = 710717;
UPDATE ruian_katastr SET nazev = 'Povel' WHERE kod = 710784;
UPDATE ruian_katastr SET nazev = 'Nové Sady u Olomouce' WHERE kod = 710814;
UPDATE ruian_katastr SET nazev = 'Hodolany' WHERE kod = 710873;
UPDATE ruian_katastr SET nazev = 'Bělidla' WHERE kod = 710881;
UPDATE ruian_katastr SET nazev = 'Chválkovice' WHERE kod = 710911;
UPDATE ruian_katastr SET nazev = 'Nový Svět u Olomouce' WHERE kod = 710920;
UPDATE ruian_katastr SET nazev = 'Pavlovičky' WHERE kod = 710938;
UPDATE ruian_katastr SET nazev = 'Řepčín' WHERE kod = 710946;
UPDATE ruian_katastr SET nazev = 'Olomučany' WHERE kod = 710954;
UPDATE ruian_katastr SET nazev = 'Oloví' WHERE kod = 710962;
UPDATE ruian_katastr SET nazev = 'Studenec u Oloví' WHERE kod = 710997;
UPDATE ruian_katastr SET nazev = 'Hory u Oloví' WHERE kod = 711004;
UPDATE ruian_katastr SET nazev = 'Nové Domy' WHERE kod = 711021;
UPDATE ruian_katastr SET nazev = 'Olovnice' WHERE kod = 711039;
UPDATE ruian_katastr SET nazev = 'Olšany u Čáslavi' WHERE kod = 711047;
UPDATE ruian_katastr SET nazev = 'Pucheř' WHERE kod = 711055;
UPDATE ruian_katastr SET nazev = 'Olšany u Dačic' WHERE kod = 711071;
UPDATE ruian_katastr SET nazev = 'Olšany u Telče' WHERE kod = 711080;
UPDATE ruian_katastr SET nazev = 'Olšany nad Moravou' WHERE kod = 711098;
UPDATE ruian_katastr SET nazev = 'Hablov' WHERE kod = 711101;
UPDATE ruian_katastr SET nazev = 'Olšany u Prostějova' WHERE kod = 711110;
UPDATE ruian_katastr SET nazev = 'Klokočí u Olší' WHERE kod = 711128;
UPDATE ruian_katastr SET nazev = 'Litava' WHERE kod = 711136;
UPDATE ruian_katastr SET nazev = 'Olší u Tišnova' WHERE kod = 711144;
UPDATE ruian_katastr SET nazev = 'Rakové' WHERE kod = 711152;
UPDATE ruian_katastr SET nazev = 'Olší nad Oslavou' WHERE kod = 711161;
UPDATE ruian_katastr SET nazev = 'Boňkov u Hranic' WHERE kod = 711179;
UPDATE ruian_katastr SET nazev = 'Olšovec' WHERE kod = 711187;
UPDATE ruian_katastr SET nazev = 'Omice' WHERE kod = 711195;
UPDATE ruian_katastr SET nazev = 'Omlenice' WHERE kod = 711217;
UPDATE ruian_katastr SET nazev = 'Stradov u Kaplice' WHERE kod = 711233;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Omlenic' WHERE kod = 711241;
UPDATE ruian_katastr SET nazev = 'Ondratice' WHERE kod = 711268;
UPDATE ruian_katastr SET nazev = 'Ondřejov u Prahy' WHERE kod = 711276;
UPDATE ruian_katastr SET nazev = 'Turkovice u Ondřejova' WHERE kod = 711284;
UPDATE ruian_katastr SET nazev = 'Ondřejov u Pelhřimova' WHERE kod = 711292;
UPDATE ruian_katastr SET nazev = 'Křečovice u Onomyšle' WHERE kod = 711306;
UPDATE ruian_katastr SET nazev = 'Miletín u Onomyšle' WHERE kod = 711314;
UPDATE ruian_katastr SET nazev = 'Onomyšl' WHERE kod = 711322;
UPDATE ruian_katastr SET nazev = 'Rozkoš u Onomyšle' WHERE kod = 711331;
UPDATE ruian_katastr SET nazev = 'Chlovy' WHERE kod = 711349;
UPDATE ruian_katastr SET nazev = 'Onšov' WHERE kod = 711357;
UPDATE ruian_katastr SET nazev = 'Těškovice u Onšova' WHERE kod = 711365;
UPDATE ruian_katastr SET nazev = 'Onšov na Moravě' WHERE kod = 711373;
UPDATE ruian_katastr SET nazev = 'Kosov u Opalic' WHERE kod = 711381;
UPDATE ruian_katastr SET nazev = 'Opalice' WHERE kod = 711390;
UPDATE ruian_katastr SET nazev = 'Oparno' WHERE kod = 711411;
UPDATE ruian_katastr SET nazev = 'Opařany' WHERE kod = 711438;
UPDATE ruian_katastr SET nazev = 'Podboří' WHERE kod = 711446;
UPDATE ruian_katastr SET nazev = 'Opatov v Čechách' WHERE kod = 711454;
UPDATE ruian_katastr SET nazev = 'Opatov u Jihlavy' WHERE kod = 711462;
UPDATE ruian_katastr SET nazev = 'Opatov na Moravě' WHERE kod = 711471;
UPDATE ruian_katastr SET nazev = 'Opatovec' WHERE kod = 711501;
UPDATE ruian_katastr SET nazev = 'Opatovice u Rajhradu' WHERE kod = 711527;
UPDATE ruian_katastr SET nazev = 'Opatovice u Vyškova' WHERE kod = 711535;
UPDATE ruian_katastr SET nazev = 'Opatovice u Hranic' WHERE kod = 711543;
UPDATE ruian_katastr SET nazev = 'Opatovice nad Labem' WHERE kod = 711551;
UPDATE ruian_katastr SET nazev = 'Opava-Město' WHERE kod = 711560;
UPDATE ruian_katastr SET nazev = 'Opava-Předměstí' WHERE kod = 711578;
UPDATE ruian_katastr SET nazev = 'Jaktař' WHERE kod = 711730;
UPDATE ruian_katastr SET nazev = 'Kateřinky u Opavy' WHERE kod = 711756;
UPDATE ruian_katastr SET nazev = 'Kylešovice' WHERE kod = 711811;
UPDATE ruian_katastr SET nazev = 'Komárov u Opavy' WHERE kod = 711845;
UPDATE ruian_katastr SET nazev = 'Malé Hoštice' WHERE kod = 711870;
UPDATE ruian_katastr SET nazev = 'Oplocany' WHERE kod = 711918;
UPDATE ruian_katastr SET nazev = 'Opočnice' WHERE kod = 711926;
UPDATE ruian_katastr SET nazev = 'Čánka' WHERE kod = 711934;
UPDATE ruian_katastr SET nazev = 'Opočno pod Orlickými horami' WHERE kod = 711951;
UPDATE ruian_katastr SET nazev = 'Kanín' WHERE kod = 711977;
UPDATE ruian_katastr SET nazev = 'Opolánky' WHERE kod = 711985;
UPDATE ruian_katastr SET nazev = 'Opolany' WHERE kod = 711993;
UPDATE ruian_katastr SET nazev = 'Oškobrh' WHERE kod = 712001;
UPDATE ruian_katastr SET nazev = 'Oponešice' WHERE kod = 712019;
UPDATE ruian_katastr SET nazev = 'Oprechtice na Šumavě' WHERE kod = 712027;
UPDATE ruian_katastr SET nazev = 'Oprechtice ve Slezsku' WHERE kod = 712035;
UPDATE ruian_katastr SET nazev = 'Oprostovice' WHERE kod = 712043;
UPDATE ruian_katastr SET nazev = 'Klečetné' WHERE kod = 712060;
UPDATE ruian_katastr SET nazev = 'Oráčov' WHERE kod = 712078;
UPDATE ruian_katastr SET nazev = 'Orel' WHERE kod = 712086;
UPDATE ruian_katastr SET nazev = 'Vlčnov u Chrudimi' WHERE kod = 712094;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda u Orlického Podhůří' WHERE kod = 712108;
UPDATE ruian_katastr SET nazev = 'Rviště' WHERE kod = 712141;
UPDATE ruian_katastr SET nazev = 'Říčky u Orlického Podhůří' WHERE kod = 712159;
UPDATE ruian_katastr SET nazev = 'Bedřichovka' WHERE kod = 712167;
UPDATE ruian_katastr SET nazev = 'Černá Voda u Orlického Záhoří' WHERE kod = 712175;
UPDATE ruian_katastr SET nazev = 'Jadrná' WHERE kod = 712183;
UPDATE ruian_katastr SET nazev = 'Kunštát u Orlického Záhoří' WHERE kod = 712191;
UPDATE ruian_katastr SET nazev = 'Trčkov' WHERE kod = 712205;
UPDATE ruian_katastr SET nazev = 'Orličky' WHERE kod = 712221;
UPDATE ruian_katastr SET nazev = 'Kožlí u Orlíka' WHERE kod = 712230;
UPDATE ruian_katastr SET nazev = 'Orlík nad Vltavou' WHERE kod = 712248;
UPDATE ruian_katastr SET nazev = 'Orlov' WHERE kod = 712272;
UPDATE ruian_katastr SET nazev = 'Orlov u Jistebnice' WHERE kod = 712302;
UPDATE ruian_katastr SET nazev = 'Orlová' WHERE kod = 712361;
UPDATE ruian_katastr SET nazev = 'Lazy u Orlové' WHERE kod = 712434;
UPDATE ruian_katastr SET nazev = 'Poruba u Orlové' WHERE kod = 712493;
UPDATE ruian_katastr SET nazev = 'Horní Lutyně' WHERE kod = 712531;
UPDATE ruian_katastr SET nazev = 'Orlovice' WHERE kod = 712591;
UPDATE ruian_katastr SET nazev = 'Ořech' WHERE kod = 712604;
UPDATE ruian_katastr SET nazev = 'Ořechov' WHERE kod = 712612;
UPDATE ruian_katastr SET nazev = 'Ořechov u Telče' WHERE kod = 712647;
UPDATE ruian_katastr SET nazev = 'Ořechov u Uherského Hradiště' WHERE kod = 712655;
UPDATE ruian_katastr SET nazev = 'Ořechov u Křižanova' WHERE kod = 712663;
UPDATE ruian_katastr SET nazev = 'Ořešín' WHERE kod = 712680;
UPDATE ruian_katastr SET nazev = 'Oseč' WHERE kod = 712698;
UPDATE ruian_katastr SET nazev = 'Osečany' WHERE kod = 712701;
UPDATE ruian_katastr SET nazev = 'Velběhy' WHERE kod = 712728;
UPDATE ruian_katastr SET nazev = 'Oseček' WHERE kod = 712744;
UPDATE ruian_katastr SET nazev = 'Chrastná' WHERE kod = 712752;
UPDATE ruian_katastr SET nazev = 'Kotel' WHERE kod = 712761;
UPDATE ruian_katastr SET nazev = 'Lázně Kundratice' WHERE kod = 712779;
UPDATE ruian_katastr SET nazev = 'Osečná' WHERE kod = 712787;
UPDATE ruian_katastr SET nazev = 'Zábrdí u Osečné' WHERE kod = 712795;
UPDATE ruian_katastr SET nazev = 'Lomy u Osečnice' WHERE kod = 712809;
UPDATE ruian_katastr SET nazev = 'Osečnice' WHERE kod = 712817;
UPDATE ruian_katastr SET nazev = 'Osek u Hořovic' WHERE kod = 712841;
UPDATE ruian_katastr SET nazev = 'Dvořiště' WHERE kod = 712868;
UPDATE ruian_katastr SET nazev = 'Osek' WHERE kod = 712876;
UPDATE ruian_katastr SET nazev = 'Osek u Milevska' WHERE kod = 712884;
UPDATE ruian_katastr SET nazev = 'Jemnice u Oseka' WHERE kod = 712892;
UPDATE ruian_katastr SET nazev = 'Malá Turná' WHERE kod = 712906;
UPDATE ruian_katastr SET nazev = 'Osek u Radomyšle' WHERE kod = 712914;
UPDATE ruian_katastr SET nazev = 'Petrovice u Oseka' WHERE kod = 712922;
UPDATE ruian_katastr SET nazev = 'Velká Turná' WHERE kod = 712931;
UPDATE ruian_katastr SET nazev = 'Osek u Rokycan' WHERE kod = 712949;
UPDATE ruian_katastr SET nazev = 'Dlouhá Louka' WHERE kod = 712957;
UPDATE ruian_katastr SET nazev = 'Hrad Osek' WHERE kod = 712965;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Oseka' WHERE kod = 712973;
UPDATE ruian_katastr SET nazev = 'Osek u Duchcova' WHERE kod = 712981;
UPDATE ruian_katastr SET nazev = 'Mackov' WHERE kod = 712990;
UPDATE ruian_katastr SET nazev = 'Osek u Sobotky' WHERE kod = 713007;
UPDATE ruian_katastr SET nazev = 'Osek nad Bečvou' WHERE kod = 713015;
UPDATE ruian_katastr SET nazev = 'Kotouň' WHERE kod = 713023;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Horažďovic' WHERE kod = 713031;
UPDATE ruian_katastr SET nazev = 'Oselce' WHERE kod = 713040;
UPDATE ruian_katastr SET nazev = 'Osice' WHERE kod = 713058;
UPDATE ruian_katastr SET nazev = 'Trávník u Osic' WHERE kod = 713066;
UPDATE ruian_katastr SET nazev = 'Osíčko' WHERE kod = 713074;
UPDATE ruian_katastr SET nazev = 'Příkazy u Osíčka' WHERE kod = 713082;
UPDATE ruian_katastr SET nazev = 'Osičky' WHERE kod = 713091;
UPDATE ruian_katastr SET nazev = 'Osík' WHERE kod = 713104;
UPDATE ruian_katastr SET nazev = 'Osiky' WHERE kod = 713112;
UPDATE ruian_katastr SET nazev = 'Bedřichov u Oskavy' WHERE kod = 713121;
UPDATE ruian_katastr SET nazev = 'Mostkov' WHERE kod = 713139;
UPDATE ruian_katastr SET nazev = 'Oskava' WHERE kod = 713147;
UPDATE ruian_katastr SET nazev = 'Třemešek' WHERE kod = 713155;
UPDATE ruian_katastr SET nazev = 'Oskořínek' WHERE kod = 713163;
UPDATE ruian_katastr SET nazev = 'Oslavany' WHERE kod = 713180;
UPDATE ruian_katastr SET nazev = 'Oslavice' WHERE kod = 713198;
UPDATE ruian_katastr SET nazev = 'Oslnovice' WHERE kod = 713201;
UPDATE ruian_katastr SET nazev = 'Oslov' WHERE kod = 713228;
UPDATE ruian_katastr SET nazev = 'Tukleky u Oslova' WHERE kod = 713244;
UPDATE ruian_katastr SET nazev = 'Vlastec' WHERE kod = 713252;
UPDATE ruian_katastr SET nazev = 'Osnice' WHERE kod = 713279;
UPDATE ruian_katastr SET nazev = 'Zdiměřice u Prahy' WHERE kod = 713287;
UPDATE ruian_katastr SET nazev = 'Osoblaha' WHERE kod = 713295;
UPDATE ruian_katastr SET nazev = 'Slezské Pavlovice' WHERE kod = 713309;
UPDATE ruian_katastr SET nazev = 'Studnice u Osoblahy' WHERE kod = 713317;
UPDATE ruian_katastr SET nazev = 'Osov' WHERE kod = 713325;
UPDATE ruian_katastr SET nazev = 'Osová' WHERE kod = 713341;
UPDATE ruian_katastr SET nazev = 'Osová Bítýška' WHERE kod = 713350;
UPDATE ruian_katastr SET nazev = 'Osové' WHERE kod = 713368;
UPDATE ruian_katastr SET nazev = 'Ostašov na Moravě' WHERE kod = 713376;
UPDATE ruian_katastr SET nazev = 'Ostojkovice' WHERE kod = 713384;
UPDATE ruian_katastr SET nazev = 'Ostopovice' WHERE kod = 713392;
UPDATE ruian_katastr SET nazev = 'Ostrá' WHERE kod = 713406;
UPDATE ruian_katastr SET nazev = 'Ostrata' WHERE kod = 713422;
UPDATE ruian_katastr SET nazev = 'Moravská Ostrava' WHERE kod = 713520;
UPDATE ruian_katastr SET nazev = 'Přívoz' WHERE kod = 713767;
UPDATE ruian_katastr SET nazev = 'Mariánské Hory' WHERE kod = 713830;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Ostravy' WHERE kod = 713937;
UPDATE ruian_katastr SET nazev = 'Zábřeh-Hulváky' WHERE kod = 713970;
UPDATE ruian_katastr SET nazev = 'Vítkovice' WHERE kod = 714071;
UPDATE ruian_katastr SET nazev = 'Zábřeh-VŽ' WHERE kod = 714089;
UPDATE ruian_katastr SET nazev = 'Kunčice nad Ostravicí' WHERE kod = 714224;
UPDATE ruian_katastr SET nazev = 'Kunčičky' WHERE kod = 714241;
UPDATE ruian_katastr SET nazev = 'Zábřeh nad Odrou' WHERE kod = 714305;
UPDATE ruian_katastr SET nazev = 'Hrabová' WHERE kod = 714534;
UPDATE ruian_katastr SET nazev = 'Hrabůvka' WHERE kod = 714585;
UPDATE ruian_katastr SET nazev = 'Heřmanice' WHERE kod = 714691;
UPDATE ruian_katastr SET nazev = 'Michálkovice' WHERE kod = 714747;
UPDATE ruian_katastr SET nazev = 'Slezská Ostrava' WHERE kod = 714828;
UPDATE ruian_katastr SET nazev = 'Hrušov' WHERE kod = 714917;
UPDATE ruian_katastr SET nazev = 'Muglinov' WHERE kod = 714941;
UPDATE ruian_katastr SET nazev = 'Radvanice' WHERE kod = 715018;
UPDATE ruian_katastr SET nazev = 'Bartovice' WHERE kod = 715085;
UPDATE ruian_katastr SET nazev = 'Poruba' WHERE kod = 715174;
UPDATE ruian_katastr SET nazev = 'Poruba-sever' WHERE kod = 715221;
UPDATE ruian_katastr SET nazev = 'Pustkovec' WHERE kod = 715301;
UPDATE ruian_katastr SET nazev = 'Martinov ve Slezsku' WHERE kod = 715379;
UPDATE ruian_katastr SET nazev = 'Třebovice ve Slezsku' WHERE kod = 715433;
UPDATE ruian_katastr SET nazev = 'Svinov' WHERE kod = 715506;
UPDATE ruian_katastr SET nazev = 'Výškovice u Ostravy' WHERE kod = 715620;
UPDATE ruian_katastr SET nazev = 'Staré Hamry 2' WHERE kod = 715646;
UPDATE ruian_katastr SET nazev = 'Ostravice 1' WHERE kod = 715671;
UPDATE ruian_katastr SET nazev = 'Ostré' WHERE kod = 715719;
UPDATE ruian_katastr SET nazev = 'Ostroměř' WHERE kod = 715727;
UPDATE ruian_katastr SET nazev = 'Ostrov u Bohdanče' WHERE kod = 715735;
UPDATE ruian_katastr SET nazev = 'Ostrov u Tochovic' WHERE kod = 715743;
UPDATE ruian_katastr SET nazev = 'Ostrov na Šumavě' WHERE kod = 715760;
UPDATE ruian_katastr SET nazev = 'Běleň' WHERE kod = 715778;
UPDATE ruian_katastr SET nazev = 'Horní Dlouhá' WHERE kod = 715786;
UPDATE ruian_katastr SET nazev = 'Horní Okolí' WHERE kod = 715794;
UPDATE ruian_katastr SET nazev = 'Šafléřov' WHERE kod = 715808;
UPDATE ruian_katastr SET nazev = 'Arnoldov' WHERE kod = 715816;
UPDATE ruian_katastr SET nazev = 'Horní Žďár u Ostrova' WHERE kod = 715824;
UPDATE ruian_katastr SET nazev = 'Vykmanov u Ostrova' WHERE kod = 715841;
UPDATE ruian_katastr SET nazev = 'Dolní Žďár u Ostrova' WHERE kod = 715859;
UPDATE ruian_katastr SET nazev = 'Ostrov nad Ohří' WHERE kod = 715883;
UPDATE ruian_katastr SET nazev = 'Mořičov' WHERE kod = 715956;
UPDATE ruian_katastr SET nazev = 'Lhota u Tachova' WHERE kod = 715964;
UPDATE ruian_katastr SET nazev = 'Ostrov u Tachova' WHERE kod = 715972;
UPDATE ruian_katastr SET nazev = 'Ostrov' WHERE kod = 715981;
UPDATE ruian_katastr SET nazev = 'Ostrov u Lanškrouna' WHERE kod = 715999;
UPDATE ruian_katastr SET nazev = 'Ostrov nad Oslavou' WHERE kod = 716006;
UPDATE ruian_katastr SET nazev = 'Suky' WHERE kod = 716014;
UPDATE ruian_katastr SET nazev = 'Blažim u Bezdružic' WHERE kod = 716022;
UPDATE ruian_katastr SET nazev = 'Krsov' WHERE kod = 716031;
UPDATE ruian_katastr SET nazev = 'Ostrov u Bezdružic' WHERE kod = 716049;
UPDATE ruian_katastr SET nazev = 'Pláň' WHERE kod = 716057;
UPDATE ruian_katastr SET nazev = 'Ostrov u Macochy' WHERE kod = 716065;
UPDATE ruian_katastr SET nazev = 'Ostrov u Stříbra' WHERE kod = 716073;
UPDATE ruian_katastr SET nazev = 'Popov u Stříbra' WHERE kod = 716081;
UPDATE ruian_katastr SET nazev = 'Vrhaveč' WHERE kod = 716090;
UPDATE ruian_katastr SET nazev = 'Ostrovačice' WHERE kod = 716103;
UPDATE ruian_katastr SET nazev = 'Ostrovánky' WHERE kod = 716111;
UPDATE ruian_katastr SET nazev = 'Dědovice' WHERE kod = 716120;
UPDATE ruian_katastr SET nazev = 'Dolní Ostrovec' WHERE kod = 716138;
UPDATE ruian_katastr SET nazev = 'Horní Ostrovec' WHERE kod = 716146;
UPDATE ruian_katastr SET nazev = 'Lhotka u Terešova' WHERE kod = 716154;
UPDATE ruian_katastr SET nazev = 'Ostrovec u Terešova' WHERE kod = 716162;
UPDATE ruian_katastr SET nazev = 'Ostrožská Lhota' WHERE kod = 716171;
UPDATE ruian_katastr SET nazev = 'Chylice' WHERE kod = 716189;
UPDATE ruian_katastr SET nazev = 'Ostrožská Nová Ves' WHERE kod = 716201;
UPDATE ruian_katastr SET nazev = 'Ostružná' WHERE kod = 716219;
UPDATE ruian_katastr SET nazev = 'Petříkov u Branné' WHERE kod = 716227;
UPDATE ruian_katastr SET nazev = 'Ostružno na Šumavě' WHERE kod = 716251;
UPDATE ruian_katastr SET nazev = 'Ostružno u Jičína' WHERE kod = 716260;
UPDATE ruian_katastr SET nazev = 'Bělčice u Ostředka' WHERE kod = 716278;
UPDATE ruian_katastr SET nazev = 'Ostředek' WHERE kod = 716294;
UPDATE ruian_katastr SET nazev = 'Vodslivy' WHERE kod = 716308;
UPDATE ruian_katastr SET nazev = 'Ostřešany' WHERE kod = 716324;
UPDATE ruian_katastr SET nazev = 'Ostřetín' WHERE kod = 716332;
UPDATE ruian_katastr SET nazev = 'Vysoká u Holic' WHERE kod = 716341;
UPDATE ruian_katastr SET nazev = 'Osvětimany' WHERE kod = 716359;
UPDATE ruian_katastr SET nazev = 'Osvračín' WHERE kod = 716391;
UPDATE ruian_katastr SET nazev = 'Dolní Plezom' WHERE kod = 716405;
UPDATE ruian_katastr SET nazev = 'Horní Plezom' WHERE kod = 716413;
UPDATE ruian_katastr SET nazev = 'Lobzy u Ošelína' WHERE kod = 716421;
UPDATE ruian_katastr SET nazev = 'Ošelín' WHERE kod = 716430;
UPDATE ruian_katastr SET nazev = 'Otaslavice' WHERE kod = 716448;
UPDATE ruian_katastr SET nazev = 'Vincencov' WHERE kod = 716464;
UPDATE ruian_katastr SET nazev = 'Otěšice' WHERE kod = 716472;
UPDATE ruian_katastr SET nazev = 'Otice' WHERE kod = 716481;
UPDATE ruian_katastr SET nazev = 'Otín u Jindřichova Hradce' WHERE kod = 716502;
UPDATE ruian_katastr SET nazev = 'Otín u Stonařova' WHERE kod = 716511;
UPDATE ruian_katastr SET nazev = 'Geršov' WHERE kod = 716529;
UPDATE ruian_katastr SET nazev = 'Otín u Měřína' WHERE kod = 716537;
UPDATE ruian_katastr SET nazev = 'Pohořílky u Otína' WHERE kod = 716545;
UPDATE ruian_katastr SET nazev = 'Otinoves' WHERE kod = 716553;
UPDATE ruian_katastr SET nazev = 'Otmíče' WHERE kod = 716561;
UPDATE ruian_katastr SET nazev = 'Otnice' WHERE kod = 716570;
UPDATE ruian_katastr SET nazev = 'Otovice u Karlových Var' WHERE kod = 716596;
UPDATE ruian_katastr SET nazev = 'Otovice u Broumova' WHERE kod = 716600;
UPDATE ruian_katastr SET nazev = 'Otradice' WHERE kod = 716618;
UPDATE ruian_katastr SET nazev = 'Otradov' WHERE kod = 716626;
UPDATE ruian_katastr SET nazev = 'Otročice' WHERE kod = 716634;
UPDATE ruian_katastr SET nazev = 'Brť' WHERE kod = 716642;
UPDATE ruian_katastr SET nazev = 'Měchov' WHERE kod = 716651;
UPDATE ruian_katastr SET nazev = 'Otročín' WHERE kod = 716669;
UPDATE ruian_katastr SET nazev = 'Poseč' WHERE kod = 716677;
UPDATE ruian_katastr SET nazev = 'Tisová u Otročína' WHERE kod = 716685;
UPDATE ruian_katastr SET nazev = 'Otročiněves' WHERE kod = 716715;
UPDATE ruian_katastr SET nazev = 'Otrokovice' WHERE kod = 716731;
UPDATE ruian_katastr SET nazev = 'Kvítkovice u Otrokovic' WHERE kod = 716766;
UPDATE ruian_katastr SET nazev = 'Ježovice' WHERE kod = 716901;
UPDATE ruian_katastr SET nazev = 'Podveky' WHERE kod = 716928;
UPDATE ruian_katastr SET nazev = 'Soběšín' WHERE kod = 716936;
UPDATE ruian_katastr SET nazev = 'Otvice' WHERE kod = 716961;
UPDATE ruian_katastr SET nazev = 'Pesvice' WHERE kod = 716979;
UPDATE ruian_katastr SET nazev = 'Otvovice' WHERE kod = 716987;
UPDATE ruian_katastr SET nazev = 'Ouběnice u Votic' WHERE kod = 717002;
UPDATE ruian_katastr SET nazev = 'Ostrov u Ouběnic' WHERE kod = 717037;
UPDATE ruian_katastr SET nazev = 'Ouběnice u Dobříše' WHERE kod = 717045;
UPDATE ruian_katastr SET nazev = 'Oucmanice' WHERE kod = 717053;
UPDATE ruian_katastr SET nazev = 'Jitkov' WHERE kod = 717061;
UPDATE ruian_katastr SET nazev = 'Oudoleň' WHERE kod = 717070;
UPDATE ruian_katastr SET nazev = 'Slavětín u Oudoleně' WHERE kod = 717088;
UPDATE ruian_katastr SET nazev = 'Ovčáry u Kolína' WHERE kod = 717096;
UPDATE ruian_katastr SET nazev = 'Nedomice' WHERE kod = 717100;
UPDATE ruian_katastr SET nazev = 'Ovčáry u Dřís' WHERE kod = 717118;
UPDATE ruian_katastr SET nazev = 'Ovesná Lhota' WHERE kod = 717126;
UPDATE ruian_katastr SET nazev = 'Ovesné Kladruby' WHERE kod = 717134;
UPDATE ruian_katastr SET nazev = 'Vysočany u Ovesných Kladrub' WHERE kod = 717142;
UPDATE ruian_katastr SET nazev = 'Oznice' WHERE kod = 717169;
UPDATE ruian_katastr SET nazev = 'Pacetluky' WHERE kod = 717193;
UPDATE ruian_katastr SET nazev = 'Pacov u Říčan' WHERE kod = 717207;
UPDATE ruian_katastr SET nazev = 'Pacov' WHERE kod = 717215;
UPDATE ruian_katastr SET nazev = 'Pacov u Moravské Třebové' WHERE kod = 717274;
UPDATE ruian_katastr SET nazev = 'Maňovice u Pačejova' WHERE kod = 717282;
UPDATE ruian_katastr SET nazev = 'Pačejov' WHERE kod = 717304;
UPDATE ruian_katastr SET nazev = 'Strážovice u Pačejova' WHERE kod = 717312;
UPDATE ruian_katastr SET nazev = 'Týřovice u Pačejova' WHERE kod = 717321;
UPDATE ruian_katastr SET nazev = 'Velešice u Pačejova' WHERE kod = 717339;
UPDATE ruian_katastr SET nazev = 'Lhota u Pačlavic' WHERE kod = 717347;
UPDATE ruian_katastr SET nazev = 'Pačlavice' WHERE kod = 717355;
UPDATE ruian_katastr SET nazev = 'Pornice' WHERE kod = 717363;
UPDATE ruian_katastr SET nazev = 'Padochov' WHERE kod = 717371;
UPDATE ruian_katastr SET nazev = 'Palačov' WHERE kod = 717380;
UPDATE ruian_katastr SET nazev = 'Páleč u Zlonic' WHERE kod = 717398;
UPDATE ruian_katastr SET nazev = 'Čeradice u Pálečku' WHERE kod = 717401;
UPDATE ruian_katastr SET nazev = 'Páleček' WHERE kod = 717410;
UPDATE ruian_katastr SET nazev = 'Palkovice' WHERE kod = 717452;
UPDATE ruian_katastr SET nazev = 'Palonín' WHERE kod = 717479;
UPDATE ruian_katastr SET nazev = 'Pálovice' WHERE kod = 717487;
UPDATE ruian_katastr SET nazev = 'Panenská' WHERE kod = 717495;
UPDATE ruian_katastr SET nazev = 'Palupín' WHERE kod = 717509;
UPDATE ruian_katastr SET nazev = 'Pamětice na Moravě' WHERE kod = 717525;
UPDATE ruian_katastr SET nazev = 'Pamětník' WHERE kod = 717533;
UPDATE ruian_katastr SET nazev = 'Panenská Rozsíčka' WHERE kod = 717541;
UPDATE ruian_katastr SET nazev = 'Panenské Břežany' WHERE kod = 717550;
UPDATE ruian_katastr SET nazev = 'Panenský Týnec' WHERE kod = 717568;
UPDATE ruian_katastr SET nazev = 'Úherce u Panenského Týnce' WHERE kod = 717576;
UPDATE ruian_katastr SET nazev = 'Žerotín u Panenského Týnce' WHERE kod = 717584;
UPDATE ruian_katastr SET nazev = 'Panoší Újezd' WHERE kod = 717592;
UPDATE ruian_katastr SET nazev = 'Panská Lhota' WHERE kod = 717614;
UPDATE ruian_katastr SET nazev = 'Panské Dubenky' WHERE kod = 717631;
UPDATE ruian_katastr SET nazev = 'Paračov' WHERE kod = 717649;
UPDATE ruian_katastr SET nazev = 'Pardubice' WHERE kod = 717657;
UPDATE ruian_katastr SET nazev = 'Pardubičky' WHERE kod = 717835;
UPDATE ruian_katastr SET nazev = 'Studánka' WHERE kod = 717843;
UPDATE ruian_katastr SET nazev = 'Spojil' WHERE kod = 717851;
UPDATE ruian_katastr SET nazev = 'Trnová' WHERE kod = 717959;
UPDATE ruian_katastr SET nazev = 'Svítkov' WHERE kod = 718033;
UPDATE ruian_katastr SET nazev = 'Popkovice' WHERE kod = 718068;
UPDATE ruian_katastr SET nazev = 'Nové Jesenčany' WHERE kod = 718084;
UPDATE ruian_katastr SET nazev = 'Paršovice' WHERE kod = 718106;
UPDATE ruian_katastr SET nazev = 'Partoltice' WHERE kod = 718114;
UPDATE ruian_katastr SET nazev = 'Partutovice' WHERE kod = 718122;
UPDATE ruian_katastr SET nazev = 'Pasečnice' WHERE kod = 718131;
UPDATE ruian_katastr SET nazev = 'Karlov u Paseky' WHERE kod = 718149;
UPDATE ruian_katastr SET nazev = 'Mutkov' WHERE kod = 718157;
UPDATE ruian_katastr SET nazev = 'Paseka u Šternberka' WHERE kod = 718165;
UPDATE ruian_katastr SET nazev = 'Paseky u Proseče' WHERE kod = 718173;
UPDATE ruian_katastr SET nazev = 'Paseky nad Jizerou' WHERE kod = 718203;
UPDATE ruian_katastr SET nazev = 'Paskov' WHERE kod = 718211;
UPDATE ruian_katastr SET nazev = 'Pasohlávky' WHERE kod = 718220;
UPDATE ruian_katastr SET nazev = 'Pastviny u Klášterce nad Orlicí' WHERE kod = 718238;
UPDATE ruian_katastr SET nazev = 'Pašovice na Moravě' WHERE kod = 718254;
UPDATE ruian_katastr SET nazev = 'Pátek u Poděbrad' WHERE kod = 718262;
UPDATE ruian_katastr SET nazev = 'Pátek u Loun' WHERE kod = 718271;
UPDATE ruian_katastr SET nazev = 'Radonice nad Ohří' WHERE kod = 718289;
UPDATE ruian_katastr SET nazev = 'Stradonice u Pátku' WHERE kod = 718297;
UPDATE ruian_katastr SET nazev = 'Patokryje' WHERE kod = 718301;
UPDATE ruian_katastr SET nazev = 'Pavlice' WHERE kod = 718319;
UPDATE ruian_katastr SET nazev = 'Pavlíkov' WHERE kod = 718327;
UPDATE ruian_katastr SET nazev = 'Pavlínov' WHERE kod = 718335;
UPDATE ruian_katastr SET nazev = 'Pavlišov' WHERE kod = 718343;
UPDATE ruian_katastr SET nazev = 'Pavlov u Unhoště' WHERE kod = 718351;
UPDATE ruian_katastr SET nazev = 'Pavlov u Rynárce' WHERE kod = 718360;
UPDATE ruian_katastr SET nazev = 'Pavlov u Ledče nad Sázavou' WHERE kod = 718378;
UPDATE ruian_katastr SET nazev = 'Pavlov u Dolních Věstonic' WHERE kod = 718394;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Třešti' WHERE kod = 718408;
UPDATE ruian_katastr SET nazev = 'Pavlov u Stonařova' WHERE kod = 718416;
UPDATE ruian_katastr SET nazev = 'Stajiště' WHERE kod = 718424;
UPDATE ruian_katastr SET nazev = 'Pavlov' WHERE kod = 718432;
UPDATE ruian_katastr SET nazev = 'Starý Telečkov' WHERE kod = 718441;
UPDATE ruian_katastr SET nazev = 'Lechovice u Pavlova' WHERE kod = 718459;
UPDATE ruian_katastr SET nazev = 'Pavlov u Loštic' WHERE kod = 718467;
UPDATE ruian_katastr SET nazev = 'Svinov u Pavlova' WHERE kod = 718475;
UPDATE ruian_katastr SET nazev = 'Zavadilka' WHERE kod = 718483;
UPDATE ruian_katastr SET nazev = 'Pavlov u Herálce' WHERE kod = 718491;
UPDATE ruian_katastr SET nazev = 'Pavlovice u Vlašimi' WHERE kod = 718505;
UPDATE ruian_katastr SET nazev = 'Pavlovice nad Mží' WHERE kod = 718521;
UPDATE ruian_katastr SET nazev = 'Vítovice u Pavlovic' WHERE kod = 718530;
UPDATE ruian_katastr SET nazev = 'Pavlovice u Jestřebí' WHERE kod = 718548;
UPDATE ruian_katastr SET nazev = 'Pavlovice u Kojetína' WHERE kod = 718564;
UPDATE ruian_katastr SET nazev = 'Pavlovice u Přerova' WHERE kod = 718581;
UPDATE ruian_katastr SET nazev = 'Prusínky' WHERE kod = 718599;
UPDATE ruian_katastr SET nazev = 'Pazderna' WHERE kod = 718602;
UPDATE ruian_katastr SET nazev = 'Pazucha' WHERE kod = 718611;
UPDATE ruian_katastr SET nazev = 'Pec' WHERE kod = 718629;
UPDATE ruian_katastr SET nazev = 'Pec pod Sněžkou' WHERE kod = 718637;
UPDATE ruian_katastr SET nazev = 'Velká Úpa I' WHERE kod = 718645;
UPDATE ruian_katastr SET nazev = 'Velká Úpa II' WHERE kod = 718653;
UPDATE ruian_katastr SET nazev = 'Pecerady' WHERE kod = 718661;
UPDATE ruian_katastr SET nazev = 'Lhota u Pecky' WHERE kod = 718688;
UPDATE ruian_katastr SET nazev = 'Pecka' WHERE kod = 718696;
UPDATE ruian_katastr SET nazev = 'Staňkov u Pecky' WHERE kod = 718700;
UPDATE ruian_katastr SET nazev = 'Lidéřovice' WHERE kod = 718718;
UPDATE ruian_katastr SET nazev = 'Peč' WHERE kod = 718726;
UPDATE ruian_katastr SET nazev = 'Urbaneč' WHERE kod = 718734;
UPDATE ruian_katastr SET nazev = 'Pěčice' WHERE kod = 718742;
UPDATE ruian_katastr SET nazev = 'Pečice' WHERE kod = 718769;
UPDATE ruian_katastr SET nazev = 'Pečičky' WHERE kod = 718785;
UPDATE ruian_katastr SET nazev = 'Pěčíkov' WHERE kod = 718793;
UPDATE ruian_katastr SET nazev = 'Pěčín u Rychnova nad Kněžnou' WHERE kod = 718815;
UPDATE ruian_katastr SET nazev = 'Pečky' WHERE kod = 718823;
UPDATE ruian_katastr SET nazev = 'Pechova Lhota' WHERE kod = 718831;
UPDATE ruian_katastr SET nazev = 'Pejškov u Tišnova' WHERE kod = 718840;
UPDATE ruian_katastr SET nazev = 'Peklo nad Zdobnicí' WHERE kod = 718874;
UPDATE ruian_katastr SET nazev = 'Hony' WHERE kod = 718891;
UPDATE ruian_katastr SET nazev = 'Pěkov' WHERE kod = 718904;
UPDATE ruian_katastr SET nazev = 'Pelhřimov' WHERE kod = 718912;
UPDATE ruian_katastr SET nazev = 'Penčice' WHERE kod = 719056;
UPDATE ruian_katastr SET nazev = 'Penčičky' WHERE kod = 719064;
UPDATE ruian_katastr SET nazev = 'Alšovice' WHERE kod = 719072;
UPDATE ruian_katastr SET nazev = 'Bratříkov' WHERE kod = 719081;
UPDATE ruian_katastr SET nazev = 'Huť' WHERE kod = 719102;
UPDATE ruian_katastr SET nazev = 'Jistebsko' WHERE kod = 719111;
UPDATE ruian_katastr SET nazev = 'Kamení' WHERE kod = 719161;
UPDATE ruian_katastr SET nazev = 'Pěnčín' WHERE kod = 719170;
UPDATE ruian_katastr SET nazev = 'Pěnčín na Moravě' WHERE kod = 719200;
UPDATE ruian_katastr SET nazev = 'Perálec' WHERE kod = 719226;
UPDATE ruian_katastr SET nazev = 'Zderaz' WHERE kod = 719234;
UPDATE ruian_katastr SET nazev = 'Perná' WHERE kod = 719242;
UPDATE ruian_katastr SET nazev = 'Perná u Valašského Meziříčí' WHERE kod = 719251;
UPDATE ruian_katastr SET nazev = 'Březí u Pernarce' WHERE kod = 719269;
UPDATE ruian_katastr SET nazev = 'Krukanice' WHERE kod = 719277;
UPDATE ruian_katastr SET nazev = 'Málkovice u Pernarce' WHERE kod = 719285;
UPDATE ruian_katastr SET nazev = 'Pernarec' WHERE kod = 719293;
UPDATE ruian_katastr SET nazev = 'Pernek' WHERE kod = 719307;
UPDATE ruian_katastr SET nazev = 'Pernink' WHERE kod = 719315;
UPDATE ruian_katastr SET nazev = 'Husle' WHERE kod = 719331;
UPDATE ruian_katastr SET nazev = 'Jilmoví' WHERE kod = 719340;
UPDATE ruian_katastr SET nazev = 'Maňová' WHERE kod = 719358;
UPDATE ruian_katastr SET nazev = 'Pernštejnské Jestřabí' WHERE kod = 719366;
UPDATE ruian_katastr SET nazev = 'Černýš' WHERE kod = 719374;
UPDATE ruian_katastr SET nazev = 'Ondřejov u Perštejna' WHERE kod = 719391;
UPDATE ruian_katastr SET nazev = 'Perštejn' WHERE kod = 719404;
UPDATE ruian_katastr SET nazev = 'Rájov u Perštejna' WHERE kod = 719412;
UPDATE ruian_katastr SET nazev = 'Dolní Pohleď' WHERE kod = 719439;
UPDATE ruian_katastr SET nazev = 'Chlístovice u Pertoltic' WHERE kod = 719447;
UPDATE ruian_katastr SET nazev = 'Laziště u Pertoltic' WHERE kod = 719455;
UPDATE ruian_katastr SET nazev = 'Machovice' WHERE kod = 719463;
UPDATE ruian_katastr SET nazev = 'Milanovice' WHERE kod = 719471;
UPDATE ruian_katastr SET nazev = 'Pertoltice u Zruče nad Sázavou' WHERE kod = 719480;
UPDATE ruian_katastr SET nazev = 'Dolní Pertoltice' WHERE kod = 719498;
UPDATE ruian_katastr SET nazev = 'Horní Pertoltice' WHERE kod = 719501;
UPDATE ruian_katastr SET nazev = 'Peruc' WHERE kod = 719528;
UPDATE ruian_katastr SET nazev = 'Peřimov' WHERE kod = 719536;
UPDATE ruian_katastr SET nazev = 'Pětikozly' WHERE kod = 719552;
UPDATE ruian_katastr SET nazev = 'Pětipsy' WHERE kod = 719561;
UPDATE ruian_katastr SET nazev = 'Račetice' WHERE kod = 719579;
UPDATE ruian_katastr SET nazev = 'Petkovy' WHERE kod = 719609;
UPDATE ruian_katastr SET nazev = 'Petrašovice' WHERE kod = 719641;
UPDATE ruian_katastr SET nazev = 'Petráveč' WHERE kod = 719668;
UPDATE ruian_katastr SET nazev = 'Bílenec' WHERE kod = 719676;
UPDATE ruian_katastr SET nazev = 'Černčice u Petrohradu' WHERE kod = 719684;
UPDATE ruian_katastr SET nazev = 'Petrohrad' WHERE kod = 719692;
UPDATE ruian_katastr SET nazev = 'Petroupim' WHERE kod = 719706;
UPDATE ruian_katastr SET nazev = 'Sázava u Petrova' WHERE kod = 719749;
UPDATE ruian_katastr SET nazev = 'Petrov u Prahy' WHERE kod = 719757;
UPDATE ruian_katastr SET nazev = 'Petrov' WHERE kod = 719765;
UPDATE ruian_katastr SET nazev = 'Petrov u Hodonína' WHERE kod = 719773;
UPDATE ruian_katastr SET nazev = 'Petrov nad Desnou' WHERE kod = 719790;
UPDATE ruian_katastr SET nazev = 'Nasavrky u Miličína' WHERE kod = 719820;
UPDATE ruian_katastr SET nazev = 'Petrovice u Miličína' WHERE kod = 719846;
UPDATE ruian_katastr SET nazev = 'Kojetín u Petrovic' WHERE kod = 719854;
UPDATE ruian_katastr SET nazev = 'Mašov' WHERE kod = 719871;
UPDATE ruian_katastr SET nazev = 'Petrovice u Sedlčan' WHERE kod = 719889;
UPDATE ruian_katastr SET nazev = 'Porešín' WHERE kod = 719897;
UPDATE ruian_katastr SET nazev = 'Vilasova Lhota' WHERE kod = 719901;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Petrovic' WHERE kod = 719919;
UPDATE ruian_katastr SET nazev = 'Petrovice u Rakovníka' WHERE kod = 719927;
UPDATE ruian_katastr SET nazev = 'Petrovice u Borovan' WHERE kod = 719935;
UPDATE ruian_katastr SET nazev = 'Petrovice u Humpolce' WHERE kod = 719943;
UPDATE ruian_katastr SET nazev = 'Petrovice u Domažlic' WHERE kod = 719951;
UPDATE ruian_katastr SET nazev = 'Dolní Kochánov' WHERE kod = 719960;
UPDATE ruian_katastr SET nazev = 'Chamutice' WHERE kod = 719986;
UPDATE ruian_katastr SET nazev = 'Jiřičná' WHERE kod = 719994;
UPDATE ruian_katastr SET nazev = 'Kojšice' WHERE kod = 720003;
UPDATE ruian_katastr SET nazev = 'Petrovice u Sušice' WHERE kod = 720020;
UPDATE ruian_katastr SET nazev = 'Posobice' WHERE kod = 720038;
UPDATE ruian_katastr SET nazev = 'Rovná u Sušice' WHERE kod = 720046;
UPDATE ruian_katastr SET nazev = 'Trsice' WHERE kod = 720054;
UPDATE ruian_katastr SET nazev = 'Petrovice v Lužických horách' WHERE kod = 720071;
UPDATE ruian_katastr SET nazev = 'Petrovice u Chabařovic' WHERE kod = 720097;
UPDATE ruian_katastr SET nazev = 'Petrovice u Štoků' WHERE kod = 720101;
UPDATE ruian_katastr SET nazev = 'Kanice u Petrovic' WHERE kod = 720119;
UPDATE ruian_katastr SET nazev = 'Petrovice u Nového Bydžova' WHERE kod = 720127;
UPDATE ruian_katastr SET nazev = 'Petrovice nad Orlicí' WHERE kod = 720135;
UPDATE ruian_katastr SET nazev = 'Petrovice u Lanškrouna' WHERE kod = 720143;
UPDATE ruian_katastr SET nazev = 'Petrovice u Blanska' WHERE kod = 720151;
UPDATE ruian_katastr SET nazev = 'Petrovice u Třebíče' WHERE kod = 720160;
UPDATE ruian_katastr SET nazev = 'Petrovice u Moravského Krumlova' WHERE kod = 720178;
UPDATE ruian_katastr SET nazev = 'Petrovice u Nového Města na Moravě' WHERE kod = 720186;
UPDATE ruian_katastr SET nazev = 'Hološiny' WHERE kod = 720194;
UPDATE ruian_katastr SET nazev = 'Michalovice' WHERE kod = 720208;
UPDATE ruian_katastr SET nazev = 'Paběnice' WHERE kod = 720216;
UPDATE ruian_katastr SET nazev = 'Petrovice I' WHERE kod = 720224;
UPDATE ruian_katastr SET nazev = 'Senetín' WHERE kod = 720232;
UPDATE ruian_katastr SET nazev = 'Újezdec' WHERE kod = 720241;
UPDATE ruian_katastr SET nazev = 'Losiny' WHERE kod = 720267;
UPDATE ruian_katastr SET nazev = 'Staré Nespeřice' WHERE kod = 720305;
UPDATE ruian_katastr SET nazev = 'Dolní Marklovice' WHERE kod = 720321;
UPDATE ruian_katastr SET nazev = 'Petrovice u Karviné' WHERE kod = 720356;
UPDATE ruian_katastr SET nazev = 'Prstná' WHERE kod = 720364;
UPDATE ruian_katastr SET nazev = 'Závada nad Olší' WHERE kod = 720372;
UPDATE ruian_katastr SET nazev = 'Petrůvka u Městečka Trnávky' WHERE kod = 720381;
UPDATE ruian_katastr SET nazev = 'Petrůvka u Slavičína' WHERE kod = 720399;
UPDATE ruian_katastr SET nazev = 'Petrůvky' WHERE kod = 720402;
UPDATE ruian_katastr SET nazev = 'Petříkov u Velkých Popovic' WHERE kod = 720411;
UPDATE ruian_katastr SET nazev = 'Radimovice u Velkých Popovic' WHERE kod = 720429;
UPDATE ruian_katastr SET nazev = 'Mozolov' WHERE kod = 720437;
UPDATE ruian_katastr SET nazev = 'Modlíkov' WHERE kod = 720445;
UPDATE ruian_katastr SET nazev = 'Petříkovice' WHERE kod = 720453;
UPDATE ruian_katastr SET nazev = 'Petřkovice u Starého Jičína' WHERE kod = 720461;
UPDATE ruian_katastr SET nazev = 'Petřkovice u Ostravy' WHERE kod = 720470;
UPDATE ruian_katastr SET nazev = 'Petřvald u Karviné' WHERE kod = 720488;
UPDATE ruian_katastr SET nazev = 'Petřvald u Nového Jičína' WHERE kod = 720500;
UPDATE ruian_katastr SET nazev = 'Harty' WHERE kod = 720518;
UPDATE ruian_katastr SET nazev = 'Petřvaldík' WHERE kod = 720526;
UPDATE ruian_katastr SET nazev = 'Pchery' WHERE kod = 720542;
UPDATE ruian_katastr SET nazev = 'Pičín' WHERE kod = 720551;
UPDATE ruian_katastr SET nazev = 'Pihel' WHERE kod = 720585;
UPDATE ruian_katastr SET nazev = 'Pila' WHERE kod = 720593;
UPDATE ruian_katastr SET nazev = 'Pilníkov I' WHERE kod = 720615;
UPDATE ruian_katastr SET nazev = 'Pilníkov II' WHERE kod = 720623;
UPDATE ruian_katastr SET nazev = 'Pilníkov III' WHERE kod = 720631;
UPDATE ruian_katastr SET nazev = 'Bukovice u Písařova' WHERE kod = 720640;
UPDATE ruian_katastr SET nazev = 'Písařov' WHERE kod = 720658;
UPDATE ruian_katastr SET nazev = 'Písečná u Dobranova' WHERE kod = 720666;
UPDATE ruian_katastr SET nazev = 'Písečná u Žamberka' WHERE kod = 720674;
UPDATE ruian_katastr SET nazev = 'Písečná u Jeseníka' WHERE kod = 720691;
UPDATE ruian_katastr SET nazev = 'Studený Zejf' WHERE kod = 720704;
UPDATE ruian_katastr SET nazev = 'Nové Sady u Písečného' WHERE kod = 720712;
UPDATE ruian_katastr SET nazev = 'Písečné u Slavonic' WHERE kod = 720721;
UPDATE ruian_katastr SET nazev = 'Písečné' WHERE kod = 720739;
UPDATE ruian_katastr SET nazev = 'Vítochov' WHERE kod = 720747;
UPDATE ruian_katastr SET nazev = 'Písek' WHERE kod = 720755;
UPDATE ruian_katastr SET nazev = 'Hradiště u Písku' WHERE kod = 720909;
UPDATE ruian_katastr SET nazev = 'Písek u Chlumce nad Cidlinou' WHERE kod = 720917;
UPDATE ruian_katastr SET nazev = 'Písek u Jablunkova' WHERE kod = 720941;
UPDATE ruian_katastr SET nazev = 'Pískov' WHERE kod = 720950;
UPDATE ruian_katastr SET nazev = 'Písková Lhota' WHERE kod = 720968;
UPDATE ruian_katastr SET nazev = 'Písková Lhota u Poděbrad' WHERE kod = 720976;
UPDATE ruian_katastr SET nazev = 'Písnice' WHERE kod = 720984;
UPDATE ruian_katastr SET nazev = 'Pístina' WHERE kod = 720992;
UPDATE ruian_katastr SET nazev = 'Pístov u Jihlavy' WHERE kod = 721000;
UPDATE ruian_katastr SET nazev = 'Vysoká u Jihlavy' WHERE kod = 721018;
UPDATE ruian_katastr SET nazev = 'Písty u Nymburka' WHERE kod = 721026;
UPDATE ruian_katastr SET nazev = 'Písty' WHERE kod = 721042;
UPDATE ruian_katastr SET nazev = 'Píšť u Humpolce' WHERE kod = 721051;
UPDATE ruian_katastr SET nazev = 'Vranice u Humpolce' WHERE kod = 721069;
UPDATE ruian_katastr SET nazev = 'Píšť' WHERE kod = 721085;
UPDATE ruian_katastr SET nazev = 'Češnovice' WHERE kod = 721093;
UPDATE ruian_katastr SET nazev = 'Pašice' WHERE kod = 721107;
UPDATE ruian_katastr SET nazev = 'Pištín' WHERE kod = 721115;
UPDATE ruian_katastr SET nazev = 'Hostětín' WHERE kod = 721131;
UPDATE ruian_katastr SET nazev = 'Pitín' WHERE kod = 721158;
UPDATE ruian_katastr SET nazev = 'Pivín' WHERE kod = 721166;
UPDATE ruian_katastr SET nazev = 'Pivkovice' WHERE kod = 721182;
UPDATE ruian_katastr SET nazev = 'Pivonín' WHERE kod = 721191;
UPDATE ruian_katastr SET nazev = 'Plácky' WHERE kod = 721204;
UPDATE ruian_katastr SET nazev = 'Plačice' WHERE kod = 721212;
UPDATE ruian_katastr SET nazev = 'Plačkov' WHERE kod = 721221;
UPDATE ruian_katastr SET nazev = 'Křínov' WHERE kod = 721255;
UPDATE ruian_katastr SET nazev = 'Kříženec' WHERE kod = 721263;
UPDATE ruian_katastr SET nazev = 'Otín u Plané' WHERE kod = 721271;
UPDATE ruian_katastr SET nazev = 'Planá u Mariánských Lázní' WHERE kod = 721280;
UPDATE ruian_katastr SET nazev = 'Týnec u Plané' WHERE kod = 721298;
UPDATE ruian_katastr SET nazev = 'Vysoké Sedliště' WHERE kod = 721301;
UPDATE ruian_katastr SET nazev = 'Planá nad Lužnicí' WHERE kod = 721336;
UPDATE ruian_katastr SET nazev = 'Blinka' WHERE kod = 721361;
UPDATE ruian_katastr SET nazev = 'Hradenín' WHERE kod = 721379;
UPDATE ruian_katastr SET nazev = 'Plaňany' WHERE kod = 721387;
UPDATE ruian_katastr SET nazev = 'Žabonosy' WHERE kod = 721395;
UPDATE ruian_katastr SET nazev = 'Plandry' WHERE kod = 721409;
UPDATE ruian_katastr SET nazev = 'Korýtka' WHERE kod = 721417;
UPDATE ruian_katastr SET nazev = 'Ondřejov nad Střelou' WHERE kod = 721425;
UPDATE ruian_katastr SET nazev = 'Pláně u Plas' WHERE kod = 721433;
UPDATE ruian_katastr SET nazev = 'Vrážné nad Střelou' WHERE kod = 721441;
UPDATE ruian_katastr SET nazev = 'Hnačov' WHERE kod = 721450;
UPDATE ruian_katastr SET nazev = 'Plánice' WHERE kod = 721476;
UPDATE ruian_katastr SET nazev = 'Zborovy' WHERE kod = 721484;
UPDATE ruian_katastr SET nazev = 'Plasná' WHERE kod = 721492;
UPDATE ruian_katastr SET nazev = 'Babina' WHERE kod = 721506;
UPDATE ruian_katastr SET nazev = 'Lomnička u Plas' WHERE kod = 721514;
UPDATE ruian_katastr SET nazev = 'Nebřeziny' WHERE kod = 721522;
UPDATE ruian_katastr SET nazev = 'Plasy' WHERE kod = 721531;
UPDATE ruian_katastr SET nazev = 'Plav' WHERE kod = 721549;
UPDATE ruian_katastr SET nazev = 'Plaveč' WHERE kod = 721557;
UPDATE ruian_katastr SET nazev = 'Plavsko' WHERE kod = 721565;
UPDATE ruian_katastr SET nazev = 'Haratice' WHERE kod = 721573;
UPDATE ruian_katastr SET nazev = 'Plavy' WHERE kod = 721581;
UPDATE ruian_katastr SET nazev = 'Plazy' WHERE kod = 721590;
UPDATE ruian_katastr SET nazev = 'Lomnička u Plesné' WHERE kod = 721611;
UPDATE ruian_katastr SET nazev = 'Plesná' WHERE kod = 721620;
UPDATE ruian_katastr SET nazev = 'Smrčina' WHERE kod = 721638;
UPDATE ruian_katastr SET nazev = 'Šneky' WHERE kod = 721646;
UPDATE ruian_katastr SET nazev = 'Vackov' WHERE kod = 721654;
UPDATE ruian_katastr SET nazev = 'Nová Plesná' WHERE kod = 721671;
UPDATE ruian_katastr SET nazev = 'Stará Plesná' WHERE kod = 721689;
UPDATE ruian_katastr SET nazev = 'Pleše' WHERE kod = 721697;
UPDATE ruian_katastr SET nazev = 'Újezdec u Kardašovy Řečice' WHERE kod = 721701;
UPDATE ruian_katastr SET nazev = 'Višňová u Kardašovy Řečice' WHERE kod = 721719;
UPDATE ruian_katastr SET nazev = 'Záhoří' WHERE kod = 721727;
UPDATE ruian_katastr SET nazev = 'Plešnice' WHERE kod = 721735;
UPDATE ruian_katastr SET nazev = 'Plešovec' WHERE kod = 721743;
UPDATE ruian_katastr SET nazev = 'Pletený Újezd' WHERE kod = 721751;
UPDATE ruian_katastr SET nazev = 'Plhov' WHERE kod = 721786;
UPDATE ruian_katastr SET nazev = 'Plch' WHERE kod = 721808;
UPDATE ruian_katastr SET nazev = 'Plchov' WHERE kod = 721816;
UPDATE ruian_katastr SET nazev = 'Plchovice' WHERE kod = 721824;
UPDATE ruian_katastr SET nazev = 'Plchůvky' WHERE kod = 721859;
UPDATE ruian_katastr SET nazev = 'Plískov' WHERE kod = 721867;
UPDATE ruian_katastr SET nazev = 'Plíškovice' WHERE kod = 721875;
UPDATE ruian_katastr SET nazev = 'Ráztely' WHERE kod = 721883;
UPDATE ruian_katastr SET nazev = 'Ploskovice' WHERE kod = 721905;
UPDATE ruian_katastr SET nazev = 'Těchobuzice' WHERE kod = 721913;
UPDATE ruian_katastr SET nazev = 'Vinné' WHERE kod = 721921;
UPDATE ruian_katastr SET nazev = 'Plotiště nad Labem' WHERE kod = 721930;
UPDATE ruian_katastr SET nazev = 'Mostečný' WHERE kod = 721948;
UPDATE ruian_katastr SET nazev = 'Pluhův Žďár' WHERE kod = 721956;
UPDATE ruian_katastr SET nazev = 'Plumlov' WHERE kod = 721964;
UPDATE ruian_katastr SET nazev = 'Plužná' WHERE kod = 721972;
UPDATE ruian_katastr SET nazev = 'Plzeň' WHERE kod = 721981;
UPDATE ruian_katastr SET nazev = 'Bolevec' WHERE kod = 722120;
UPDATE ruian_katastr SET nazev = 'Božkov' WHERE kod = 722294;
UPDATE ruian_katastr SET nazev = 'Hradiště u Plzně' WHERE kod = 722341;
UPDATE ruian_katastr SET nazev = 'Bručná' WHERE kod = 722367;
UPDATE ruian_katastr SET nazev = 'Doudlevce' WHERE kod = 722464;
UPDATE ruian_katastr SET nazev = 'Valcha' WHERE kod = 722472;
UPDATE ruian_katastr SET nazev = 'Skvrňany' WHERE kod = 722596;
UPDATE ruian_katastr SET nazev = 'Lobzy' WHERE kod = 722618;
UPDATE ruian_katastr SET nazev = 'Doubravka' WHERE kod = 722677;
UPDATE ruian_katastr SET nazev = 'Újezd' WHERE kod = 722685;
UPDATE ruian_katastr SET nazev = 'Bukovec' WHERE kod = 722707;
UPDATE ruian_katastr SET nazev = 'Plzeň 4' WHERE kod = 722731;
UPDATE ruian_katastr SET nazev = 'Litice u Plzně' WHERE kod = 722740;
UPDATE ruian_katastr SET nazev = 'Konětopy u Pnětluk' WHERE kod = 722758;
UPDATE ruian_katastr SET nazev = 'Pnětluky' WHERE kod = 722766;
UPDATE ruian_katastr SET nazev = 'Klipec' WHERE kod = 722774;
UPDATE ruian_katastr SET nazev = 'Pňov' WHERE kod = 722782;
UPDATE ruian_katastr SET nazev = 'Předhradí' WHERE kod = 722791;
UPDATE ruian_katastr SET nazev = 'Pňovany' WHERE kod = 722804;
UPDATE ruian_katastr SET nazev = 'Dolany u Stříbra' WHERE kod = 722812;
UPDATE ruian_katastr SET nazev = 'Pňovice pod Třemšínem' WHERE kod = 722839;
UPDATE ruian_katastr SET nazev = 'Skuhrov pod Třemšínem' WHERE kod = 722847;
UPDATE ruian_katastr SET nazev = 'Pňovice' WHERE kod = 722855;
UPDATE ruian_katastr SET nazev = 'Poběžovice u Domažlic' WHERE kod = 722863;
UPDATE ruian_katastr SET nazev = 'Sedlec u Poběžovic' WHERE kod = 722871;
UPDATE ruian_katastr SET nazev = 'Zámělíč' WHERE kod = 722880;
UPDATE ruian_katastr SET nazev = 'Poběžovice u Holic' WHERE kod = 722898;
UPDATE ruian_katastr SET nazev = 'Poběžovice u Přelouče' WHERE kod = 722901;
UPDATE ruian_katastr SET nazev = 'Pobučí' WHERE kod = 722910;
UPDATE ruian_katastr SET nazev = 'Orlovice u Pocinovic' WHERE kod = 722928;
UPDATE ruian_katastr SET nazev = 'Pocinovice' WHERE kod = 722936;
UPDATE ruian_katastr SET nazev = 'Pocoucov' WHERE kod = 722944;
UPDATE ruian_katastr SET nazev = 'Počaply u Březnice' WHERE kod = 722952;
UPDATE ruian_katastr SET nazev = 'Stražiště' WHERE kod = 722961;
UPDATE ruian_katastr SET nazev = 'Heřmaneč u Počátek' WHERE kod = 722979;
UPDATE ruian_katastr SET nazev = 'Horní Vilímeč' WHERE kod = 722987;
UPDATE ruian_katastr SET nazev = 'Léskovec' WHERE kod = 722995;
UPDATE ruian_katastr SET nazev = 'Počátky' WHERE kod = 723002;
UPDATE ruian_katastr SET nazev = 'Prostý' WHERE kod = 723011;
UPDATE ruian_katastr SET nazev = 'Stojčín' WHERE kod = 723029;
UPDATE ruian_katastr SET nazev = 'Vesce u Počátek' WHERE kod = 723037;
UPDATE ruian_katastr SET nazev = 'Dobkov' WHERE kod = 723045;
UPDATE ruian_katastr SET nazev = 'Počátky u Chotěboře' WHERE kod = 723053;
UPDATE ruian_katastr SET nazev = 'Dolní Počátky' WHERE kod = 723061;
UPDATE ruian_katastr SET nazev = 'Počátky Horní' WHERE kod = 723070;
UPDATE ruian_katastr SET nazev = 'Javorka' WHERE kod = 723088;
UPDATE ruian_katastr SET nazev = 'Orasice' WHERE kod = 723096;
UPDATE ruian_katastr SET nazev = 'Počedělice' WHERE kod = 723100;
UPDATE ruian_katastr SET nazev = 'Volenice u Počedělic' WHERE kod = 723118;
UPDATE ruian_katastr SET nazev = 'Počenice' WHERE kod = 723126;
UPDATE ruian_katastr SET nazev = 'Tetětice' WHERE kod = 723134;
UPDATE ruian_katastr SET nazev = 'Počepice' WHERE kod = 723151;
UPDATE ruian_katastr SET nazev = 'Skuhrov u Počepic' WHERE kod = 723169;
UPDATE ruian_katastr SET nazev = 'Vitín u Počepic' WHERE kod = 723177;
UPDATE ruian_katastr SET nazev = 'Počerady' WHERE kod = 723185;
UPDATE ruian_katastr SET nazev = 'Počítky' WHERE kod = 723193;
UPDATE ruian_katastr SET nazev = 'Vysoké' WHERE kod = 723207;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Podbořan' WHERE kod = 723215;
UPDATE ruian_katastr SET nazev = 'Podbořanský Rohozec' WHERE kod = 723223;
UPDATE ruian_katastr SET nazev = 'Podbořany' WHERE kod = 723231;
UPDATE ruian_katastr SET nazev = 'Hlubany' WHERE kod = 723282;
UPDATE ruian_katastr SET nazev = 'Letov' WHERE kod = 723304;
UPDATE ruian_katastr SET nazev = 'Valov' WHERE kod = 723321;
UPDATE ruian_katastr SET nazev = 'Brníkov' WHERE kod = 723339;
UPDATE ruian_katastr SET nazev = 'Ječovice' WHERE kod = 723347;
UPDATE ruian_katastr SET nazev = 'Podbradec' WHERE kod = 723355;
UPDATE ruian_katastr SET nazev = 'Podbrdy' WHERE kod = 723363;
UPDATE ruian_katastr SET nazev = 'Lhota u Dobrušky' WHERE kod = 723380;
UPDATE ruian_katastr SET nazev = 'Podbřezí' WHERE kod = 723398;
UPDATE ruian_katastr SET nazev = 'Březinka u Havlíčkova Brodu' WHERE kod = 723410;
UPDATE ruian_katastr SET nazev = 'Hurtova Lhota' WHERE kod = 723444;
UPDATE ruian_katastr SET nazev = 'Klanečná' WHERE kod = 723452;
UPDATE ruian_katastr SET nazev = 'Poděbaby' WHERE kod = 723479;
UPDATE ruian_katastr SET nazev = 'Veselice u Havlíčkova Brodu' WHERE kod = 723487;
UPDATE ruian_katastr SET nazev = 'Poděbrady' WHERE kod = 723495;
UPDATE ruian_katastr SET nazev = 'Polabec' WHERE kod = 723541;
UPDATE ruian_katastr SET nazev = 'Velké Zboží' WHERE kod = 723550;
UPDATE ruian_katastr SET nazev = 'Poděčely' WHERE kod = 723622;
UPDATE ruian_katastr SET nazev = 'Chářovice' WHERE kod = 723631;
UPDATE ruian_katastr SET nazev = 'Podělusy' WHERE kod = 723649;
UPDATE ruian_katastr SET nazev = 'Poděšín' WHERE kod = 723657;
UPDATE ruian_katastr SET nazev = 'Podhorní Újezd' WHERE kod = 723665;
UPDATE ruian_katastr SET nazev = 'Vojice' WHERE kod = 723673;
UPDATE ruian_katastr SET nazev = 'Podhořany u Ronova' WHERE kod = 723703;
UPDATE ruian_katastr SET nazev = 'Podhoří na Moravě' WHERE kod = 723711;
UPDATE ruian_katastr SET nazev = 'Podhrad' WHERE kod = 723720;
UPDATE ruian_katastr SET nazev = 'Čejkovice u Jičína' WHERE kod = 723738;
UPDATE ruian_katastr SET nazev = 'Podhradí u Jičína' WHERE kod = 723746;
UPDATE ruian_katastr SET nazev = 'Staré Místo' WHERE kod = 723754;
UPDATE ruian_katastr SET nazev = 'Podhradí nad Dyjí' WHERE kod = 723789;
UPDATE ruian_katastr SET nazev = 'Podhradní Lhota' WHERE kod = 723797;
UPDATE ruian_katastr SET nazev = 'Podhůří u Nepomuka' WHERE kod = 723801;
UPDATE ruian_katastr SET nazev = 'Podivice' WHERE kod = 723819;
UPDATE ruian_katastr SET nazev = 'Podivice na Moravě' WHERE kod = 723827;
UPDATE ruian_katastr SET nazev = 'Podivín' WHERE kod = 723835;
UPDATE ruian_katastr SET nazev = 'Podkopná Lhota' WHERE kod = 723843;
UPDATE ruian_katastr SET nazev = 'Podkost' WHERE kod = 723851;
UPDATE ruian_katastr SET nazev = 'Podlažice' WHERE kod = 723860;
UPDATE ruian_katastr SET nazev = 'Podlesí nad Litavkou' WHERE kod = 723886;
UPDATE ruian_katastr SET nazev = 'Němčí' WHERE kod = 723894;
UPDATE ruian_katastr SET nazev = 'Turov' WHERE kod = 723908;
UPDATE ruian_katastr SET nazev = 'Podlesí nad Odrou' WHERE kod = 723916;
UPDATE ruian_katastr SET nazev = 'Křivá Voda' WHERE kod = 723924;
UPDATE ruian_katastr SET nazev = 'Podlesí-město' WHERE kod = 723932;
UPDATE ruian_katastr SET nazev = 'Brňov' WHERE kod = 723941;
UPDATE ruian_katastr SET nazev = 'Křivé' WHERE kod = 723959;
UPDATE ruian_katastr SET nazev = 'Podlešín' WHERE kod = 723983;
UPDATE ruian_katastr SET nazev = 'Podlíšťany' WHERE kod = 724009;
UPDATE ruian_katastr SET nazev = 'Vížky' WHERE kod = 724025;
UPDATE ruian_katastr SET nazev = 'Podluhy' WHERE kod = 724033;
UPDATE ruian_katastr SET nazev = 'Podmokly u Sušice' WHERE kod = 724041;
UPDATE ruian_katastr SET nazev = 'Čilá' WHERE kod = 724050;
UPDATE ruian_katastr SET nazev = 'Hradiště nad Berounkou' WHERE kod = 724068;
UPDATE ruian_katastr SET nazev = 'Podmokly nad Berounkou' WHERE kod = 724076;
UPDATE ruian_katastr SET nazev = 'Podmoky u Městce Králové' WHERE kod = 724084;
UPDATE ruian_katastr SET nazev = 'Podmoky' WHERE kod = 724092;
UPDATE ruian_katastr SET nazev = 'Proudkovice' WHERE kod = 724106;
UPDATE ruian_katastr SET nazev = 'Podmolí' WHERE kod = 724114;
UPDATE ruian_katastr SET nazev = 'Podmyče' WHERE kod = 724122;
UPDATE ruian_katastr SET nazev = 'Podolanka' WHERE kod = 724149;
UPDATE ruian_katastr SET nazev = 'Podolí u Mnichova Hradiště' WHERE kod = 724190;
UPDATE ruian_katastr SET nazev = 'Sychrov nad Jizerou' WHERE kod = 724203;
UPDATE ruian_katastr SET nazev = 'Podolí u Ratibořských Hor' WHERE kod = 724211;
UPDATE ruian_katastr SET nazev = 'Javoří u Podolí' WHERE kod = 724220;
UPDATE ruian_katastr SET nazev = 'Podolí u Klatov' WHERE kod = 724238;
UPDATE ruian_katastr SET nazev = 'Tržek' WHERE kod = 724246;
UPDATE ruian_katastr SET nazev = 'Podolí u Brna' WHERE kod = 724254;
UPDATE ruian_katastr SET nazev = 'Podolí nad Olšavou' WHERE kod = 724262;
UPDATE ruian_katastr SET nazev = 'Podolí nad Bobrůvkou' WHERE kod = 724271;
UPDATE ruian_katastr SET nazev = 'Obectov' WHERE kod = 724289;
UPDATE ruian_katastr SET nazev = 'Olešnice u Bouzova' WHERE kod = 724297;
UPDATE ruian_katastr SET nazev = 'Podolí u Bouzova' WHERE kod = 724301;
UPDATE ruian_katastr SET nazev = 'Podolí u Přerova' WHERE kod = 724319;
UPDATE ruian_katastr SET nazev = 'Podolí u Mohelnice' WHERE kod = 724327;
UPDATE ruian_katastr SET nazev = 'Podolí u Valašského Meziříčí' WHERE kod = 724335;
UPDATE ruian_katastr SET nazev = 'Křenovice' WHERE kod = 724343;
UPDATE ruian_katastr SET nazev = 'Olešná nad Vltavou' WHERE kod = 724351;
UPDATE ruian_katastr SET nazev = 'Podolí I' WHERE kod = 724360;
UPDATE ruian_katastr SET nazev = 'Kožlí u Čížové' WHERE kod = 724408;
UPDATE ruian_katastr SET nazev = 'Křešice u Čížové' WHERE kod = 724416;
UPDATE ruian_katastr SET nazev = 'Malčice u Mirotic' WHERE kod = 724424;
UPDATE ruian_katastr SET nazev = 'Podolí II' WHERE kod = 724432;
UPDATE ruian_katastr SET nazev = 'Soběšice u Předotic' WHERE kod = 724441;
UPDATE ruian_katastr SET nazev = 'Šamonice' WHERE kod = 724459;
UPDATE ruian_katastr SET nazev = 'Třebkov' WHERE kod = 724467;
UPDATE ruian_katastr SET nazev = 'Obřice' WHERE kod = 724483;
UPDATE ruian_katastr SET nazev = 'Pnětluky u Podsedic' WHERE kod = 724491;
UPDATE ruian_katastr SET nazev = 'Podsedice' WHERE kod = 724505;
UPDATE ruian_katastr SET nazev = 'Podůlšany' WHERE kod = 724513;
UPDATE ruian_katastr SET nazev = 'Brada' WHERE kod = 724521;
UPDATE ruian_katastr SET nazev = 'Dílce' WHERE kod = 724530;
UPDATE ruian_katastr SET nazev = 'Podůlší' WHERE kod = 724556;
UPDATE ruian_katastr SET nazev = 'Jinolice' WHERE kod = 724564;
UPDATE ruian_katastr SET nazev = 'Kbelnice u Jičína' WHERE kod = 724572;
UPDATE ruian_katastr SET nazev = 'Podvihov' WHERE kod = 724637;
UPDATE ruian_katastr SET nazev = 'Pohled' WHERE kod = 724645;
UPDATE ruian_katastr SET nazev = 'Simtany' WHERE kod = 724653;
UPDATE ruian_katastr SET nazev = 'Horní Hynčina' WHERE kod = 724661;
UPDATE ruian_katastr SET nazev = 'Pohledy' WHERE kod = 724670;
UPDATE ruian_katastr SET nazev = 'Horní Hrachovice' WHERE kod = 724696;
UPDATE ruian_katastr SET nazev = 'Pohnánec' WHERE kod = 724700;
UPDATE ruian_katastr SET nazev = 'Blanička' WHERE kod = 724718;
UPDATE ruian_katastr SET nazev = 'Mostek u Ratibořských Hor' WHERE kod = 724726;
UPDATE ruian_katastr SET nazev = 'Pohnání' WHERE kod = 724734;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Litomyšle' WHERE kod = 724742;
UPDATE ruian_katastr SET nazev = 'Pohodlí' WHERE kod = 724751;
UPDATE ruian_katastr SET nazev = 'Dolní Příbraní' WHERE kod = 724769;
UPDATE ruian_katastr SET nazev = 'Lužnice u Pohorské Vsi' WHERE kod = 724777;
UPDATE ruian_katastr SET nazev = 'Pivonice u Pohorské Vsi' WHERE kod = 724785;
UPDATE ruian_katastr SET nazev = 'Pohoří na Šumavě' WHERE kod = 724807;
UPDATE ruian_katastr SET nazev = 'Pohoř' WHERE kod = 724815;
UPDATE ruian_katastr SET nazev = 'Maškovice' WHERE kod = 724823;
UPDATE ruian_katastr SET nazev = 'Pohořany' WHERE kod = 724831;
UPDATE ruian_katastr SET nazev = 'Staňkovice' WHERE kod = 724840;
UPDATE ruian_katastr SET nazev = 'Pohořany na Moravě' WHERE kod = 724858;
UPDATE ruian_katastr SET nazev = 'Pohořelice nad Jihlavou' WHERE kod = 724866;
UPDATE ruian_katastr SET nazev = 'Pohořelice u Napajedel' WHERE kod = 724882;
UPDATE ruian_katastr SET nazev = 'Pohoří u Prahy' WHERE kod = 724904;
UPDATE ruian_katastr SET nazev = 'Pohoří u Kardašovy Řečice' WHERE kod = 724921;
UPDATE ruian_katastr SET nazev = 'Pohoří u Dobrušky' WHERE kod = 724939;
UPDATE ruian_katastr SET nazev = 'Pohřebačka' WHERE kod = 724947;
UPDATE ruian_katastr SET nazev = 'Pochvalov' WHERE kod = 724955;
UPDATE ruian_katastr SET nazev = 'Pojbuky' WHERE kod = 724980;
UPDATE ruian_katastr SET nazev = 'Zadní Lomná' WHERE kod = 724998;
UPDATE ruian_katastr SET nazev = 'Zadní Střítež' WHERE kod = 725005;
UPDATE ruian_katastr SET nazev = 'Pokojov' WHERE kod = 725013;
UPDATE ruian_katastr SET nazev = 'Pokřikov' WHERE kod = 725021;
UPDATE ruian_katastr SET nazev = 'Poláky' WHERE kod = 725048;
UPDATE ruian_katastr SET nazev = 'Polánka u Nepomuka' WHERE kod = 725056;
UPDATE ruian_katastr SET nazev = 'Polánka u Moravského Krumlova' WHERE kod = 725064;
UPDATE ruian_katastr SET nazev = 'Polanka nad Odrou' WHERE kod = 725081;
UPDATE ruian_katastr SET nazev = 'Pole' WHERE kod = 725111;
UPDATE ruian_katastr SET nazev = 'Pušperk' WHERE kod = 725129;
UPDATE ruian_katastr SET nazev = 'Mlýnec' WHERE kod = 725137;
UPDATE ruian_katastr SET nazev = 'Poleň' WHERE kod = 725145;
UPDATE ruian_katastr SET nazev = 'Poleňka' WHERE kod = 725153;
UPDATE ruian_katastr SET nazev = 'Zdeslav' WHERE kod = 725161;
UPDATE ruian_katastr SET nazev = 'Polepy u Kolína' WHERE kod = 725170;
UPDATE ruian_katastr SET nazev = 'Hrušovany' WHERE kod = 725188;
UPDATE ruian_katastr SET nazev = 'Okna u Polep' WHERE kod = 725196;
UPDATE ruian_katastr SET nazev = 'Polepy' WHERE kod = 725200;
UPDATE ruian_katastr SET nazev = 'Polerady u Prahy' WHERE kod = 725218;
UPDATE ruian_katastr SET nazev = 'Polerady' WHERE kod = 725226;
UPDATE ruian_katastr SET nazev = 'Volevčice' WHERE kod = 725234;
UPDATE ruian_katastr SET nazev = 'Polesí u Počátek' WHERE kod = 725242;
UPDATE ruian_katastr SET nazev = 'Polešovice' WHERE kod = 725251;
UPDATE ruian_katastr SET nazev = 'Polevsko' WHERE kod = 725269;
UPDATE ruian_katastr SET nazev = 'Jiratice' WHERE kod = 725277;
UPDATE ruian_katastr SET nazev = 'Police u Jemnice' WHERE kod = 725285;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Úsova' WHERE kod = 725293;
UPDATE ruian_katastr SET nazev = 'Police' WHERE kod = 725307;
UPDATE ruian_katastr SET nazev = 'Police u Valašského Meziříčí' WHERE kod = 725315;
UPDATE ruian_katastr SET nazev = 'Police nad Metují' WHERE kod = 725323;
UPDATE ruian_katastr SET nazev = 'Radešov nad Metují' WHERE kod = 725331;
UPDATE ruian_katastr SET nazev = 'Velká Ledhuje' WHERE kod = 725340;
UPDATE ruian_katastr SET nazev = 'Polička' WHERE kod = 725358;
UPDATE ruian_katastr SET nazev = 'Poličná' WHERE kod = 725455;
UPDATE ruian_katastr SET nazev = 'Polichno' WHERE kod = 725463;
UPDATE ruian_katastr SET nazev = 'Polizy' WHERE kod = 725471;
UPDATE ruian_katastr SET nazev = 'Polkovice' WHERE kod = 725480;
UPDATE ruian_katastr SET nazev = 'Polná' WHERE kod = 725498;
UPDATE ruian_katastr SET nazev = 'Polnička' WHERE kod = 725501;
UPDATE ruian_katastr SET nazev = 'Račín u Polničky' WHERE kod = 725510;
UPDATE ruian_katastr SET nazev = 'Stržanov' WHERE kod = 725528;
UPDATE ruian_katastr SET nazev = 'Polom u Hranic' WHERE kod = 725536;
UPDATE ruian_katastr SET nazev = 'Polouvsí' WHERE kod = 725544;
UPDATE ruian_katastr SET nazev = 'Pomezí' WHERE kod = 725552;
UPDATE ruian_katastr SET nazev = 'Dolní Hraničná' WHERE kod = 725561;
UPDATE ruian_katastr SET nazev = 'Pomezí nad Ohří' WHERE kod = 725587;
UPDATE ruian_katastr SET nazev = 'Tůně' WHERE kod = 725595;
UPDATE ruian_katastr SET nazev = 'Ponědraž' WHERE kod = 725617;
UPDATE ruian_katastr SET nazev = 'Ponědrážka' WHERE kod = 725625;
UPDATE ruian_katastr SET nazev = 'Záblatí u Ponědraže' WHERE kod = 725633;
UPDATE ruian_katastr SET nazev = 'Ponětovice' WHERE kod = 725641;
UPDATE ruian_katastr SET nazev = 'Ponikev' WHERE kod = 725650;
UPDATE ruian_katastr SET nazev = 'Poniklá' WHERE kod = 725684;
UPDATE ruian_katastr SET nazev = 'Přívlaka' WHERE kod = 725692;
UPDATE ruian_katastr SET nazev = 'Popelín' WHERE kod = 725722;
UPDATE ruian_katastr SET nazev = 'Popelištná' WHERE kod = 725731;
UPDATE ruian_katastr SET nazev = 'Zmišovice' WHERE kod = 725749;
UPDATE ruian_katastr SET nazev = 'Popice' WHERE kod = 725757;
UPDATE ruian_katastr SET nazev = 'Popice u Jihlavy' WHERE kod = 725765;
UPDATE ruian_katastr SET nazev = 'Poplze' WHERE kod = 725773;
UPDATE ruian_katastr SET nazev = 'Popovice u Benešova' WHERE kod = 725803;
UPDATE ruian_katastr SET nazev = 'Popovice u Nechanic' WHERE kod = 725820;
UPDATE ruian_katastr SET nazev = 'Popovice u Jičína' WHERE kod = 725838;
UPDATE ruian_katastr SET nazev = 'Popovice u Rajhradu' WHERE kod = 725854;
UPDATE ruian_katastr SET nazev = 'Popovice u Uherského Hradiště' WHERE kod = 725862;
UPDATE ruian_katastr SET nazev = 'Popůvky u Brna' WHERE kod = 725871;
UPDATE ruian_katastr SET nazev = 'Popůvky nad Jihlavou' WHERE kod = 725889;
UPDATE ruian_katastr SET nazev = 'Popůvky u Kojetína' WHERE kod = 725897;
UPDATE ruian_katastr SET nazev = 'Poruba nad Bečvou' WHERE kod = 725901;
UPDATE ruian_katastr SET nazev = 'Pořešice' WHERE kod = 725927;
UPDATE ruian_katastr SET nazev = 'Pořešín' WHERE kod = 725943;
UPDATE ruian_katastr SET nazev = 'Pořežany' WHERE kod = 725960;
UPDATE ruian_katastr SET nazev = 'Tuchonice' WHERE kod = 725978;
UPDATE ruian_katastr SET nazev = 'Poříčany' WHERE kod = 725986;
UPDATE ruian_katastr SET nazev = 'Dolní Poříčí' WHERE kod = 725994;
UPDATE ruian_katastr SET nazev = 'Horní Poříčí' WHERE kod = 726001;
UPDATE ruian_katastr SET nazev = 'Poříčí u Přibyslavi' WHERE kod = 726010;
UPDATE ruian_katastr SET nazev = 'Poříčí nad Sázavou' WHERE kod = 726036;
UPDATE ruian_katastr SET nazev = 'Mladočov' WHERE kod = 726044;
UPDATE ruian_katastr SET nazev = 'Poříčí u Litomyšle' WHERE kod = 726052;
UPDATE ruian_katastr SET nazev = 'Nové Dvory u Pořína' WHERE kod = 726079;
UPDATE ruian_katastr SET nazev = 'Pořín' WHERE kod = 726087;
UPDATE ruian_katastr SET nazev = 'Posluchov' WHERE kod = 726109;
UPDATE ruian_katastr SET nazev = 'Postoloprty' WHERE kod = 726117;
UPDATE ruian_katastr SET nazev = 'Vrbka u Postoloprt' WHERE kod = 726125;
UPDATE ruian_katastr SET nazev = 'Miňůvky' WHERE kod = 726133;
UPDATE ruian_katastr SET nazev = 'Postoupky' WHERE kod = 726141;
UPDATE ruian_katastr SET nazev = 'Postřekov' WHERE kod = 726168;
UPDATE ruian_katastr SET nazev = 'Postřelmov' WHERE kod = 726176;
UPDATE ruian_katastr SET nazev = 'Postřelmůvek' WHERE kod = 726184;
UPDATE ruian_katastr SET nazev = 'Postřelná' WHERE kod = 726192;
UPDATE ruian_katastr SET nazev = 'Postřižín' WHERE kod = 726206;
UPDATE ruian_katastr SET nazev = 'Jemniště' WHERE kod = 726231;
UPDATE ruian_katastr SET nazev = 'Milovanice' WHERE kod = 726265;
UPDATE ruian_katastr SET nazev = 'Postupice' WHERE kod = 726273;
UPDATE ruian_katastr SET nazev = 'Roubíčkova Lhota' WHERE kod = 726281;
UPDATE ruian_katastr SET nazev = 'Důl' WHERE kod = 726290;
UPDATE ruian_katastr SET nazev = 'Pošná' WHERE kod = 726320;
UPDATE ruian_katastr SET nazev = 'Proseč u Pošné' WHERE kod = 726338;
UPDATE ruian_katastr SET nazev = 'Poštorná' WHERE kod = 726346;
UPDATE ruian_katastr SET nazev = 'Poteč' WHERE kod = 726371;
UPDATE ruian_katastr SET nazev = 'Bratčice u Potěh' WHERE kod = 726389;
UPDATE ruian_katastr SET nazev = 'Drobovice' WHERE kod = 726397;
UPDATE ruian_katastr SET nazev = 'Horky u Čáslavi' WHERE kod = 726401;
UPDATE ruian_katastr SET nazev = 'Potěhy' WHERE kod = 726419;
UPDATE ruian_katastr SET nazev = 'Chvoječná' WHERE kod = 726427;
UPDATE ruian_katastr SET nazev = 'Loužek' WHERE kod = 726435;
UPDATE ruian_katastr SET nazev = 'Potočiště' WHERE kod = 726443;
UPDATE ruian_katastr SET nazev = 'Padesát Lánů' WHERE kod = 726451;
UPDATE ruian_katastr SET nazev = 'Potštát' WHERE kod = 726460;
UPDATE ruian_katastr SET nazev = 'Potštejn' WHERE kod = 726508;
UPDATE ruian_katastr SET nazev = 'Potůčky' WHERE kod = 726516;
UPDATE ruian_katastr SET nazev = 'Potvorov' WHERE kod = 726532;
UPDATE ruian_katastr SET nazev = 'Piletice' WHERE kod = 726541;
UPDATE ruian_katastr SET nazev = 'Pouchov' WHERE kod = 726559;
UPDATE ruian_katastr SET nazev = 'Věkoše' WHERE kod = 726583;
UPDATE ruian_katastr SET nazev = 'Mýtinka u Poustky' WHERE kod = 726591;
UPDATE ruian_katastr SET nazev = 'Ostroh' WHERE kod = 726605;
UPDATE ruian_katastr SET nazev = 'Poustka u Františkových Lázní' WHERE kod = 726613;
UPDATE ruian_katastr SET nazev = 'Pouště' WHERE kod = 726621;
UPDATE ruian_katastr SET nazev = 'Babice u Poutnova' WHERE kod = 726630;
UPDATE ruian_katastr SET nazev = 'Bohuslav u Poutnova' WHERE kod = 726648;
UPDATE ruian_katastr SET nazev = 'Číhaná u Poutnova' WHERE kod = 726656;
UPDATE ruian_katastr SET nazev = 'Horní Kramolín' WHERE kod = 726664;
UPDATE ruian_katastr SET nazev = 'Hoštěc' WHERE kod = 726672;
UPDATE ruian_katastr SET nazev = 'Jankovice' WHERE kod = 726681;
UPDATE ruian_katastr SET nazev = 'Popovice u Poutnova' WHERE kod = 726699;
UPDATE ruian_katastr SET nazev = 'Poutnov' WHERE kod = 726702;
UPDATE ruian_katastr SET nazev = 'Služetín u Poutnova' WHERE kod = 726711;
UPDATE ruian_katastr SET nazev = 'Pouzdřany' WHERE kod = 726729;
UPDATE ruian_katastr SET nazev = 'Český Bukov' WHERE kod = 726753;
UPDATE ruian_katastr SET nazev = 'Lužec u Petrova Mlýna' WHERE kod = 726761;
UPDATE ruian_katastr SET nazev = 'Lysá' WHERE kod = 726770;
UPDATE ruian_katastr SET nazev = 'Mašovice pod Vysokým kamenem' WHERE kod = 726788;
UPDATE ruian_katastr SET nazev = 'Mírkov' WHERE kod = 726796;
UPDATE ruian_katastr SET nazev = 'Neštědice' WHERE kod = 726800;
UPDATE ruian_katastr SET nazev = 'Povrly' WHERE kod = 726818;
UPDATE ruian_katastr SET nazev = 'Roztoky nad Labem' WHERE kod = 726826;
UPDATE ruian_katastr SET nazev = 'Šachov' WHERE kod = 726834;
UPDATE ruian_katastr SET nazev = 'Pozďatín' WHERE kod = 726842;
UPDATE ruian_katastr SET nazev = 'Pozděchov' WHERE kod = 726851;
UPDATE ruian_katastr SET nazev = 'Pozdeň' WHERE kod = 726869;
UPDATE ruian_katastr SET nazev = 'Podhradí u Luhačovic' WHERE kod = 726877;
UPDATE ruian_katastr SET nazev = 'Pozlovice' WHERE kod = 726885;
UPDATE ruian_katastr SET nazev = 'Pozořice' WHERE kod = 726907;
UPDATE ruian_katastr SET nazev = 'Prace' WHERE kod = 726915;
UPDATE ruian_katastr SET nazev = 'Drachkov u Strakonic' WHERE kod = 726923;
UPDATE ruian_katastr SET nazev = 'Makarov' WHERE kod = 726931;
UPDATE ruian_katastr SET nazev = 'Pracejovice' WHERE kod = 726940;
UPDATE ruian_katastr SET nazev = 'Prackovice nad Labem' WHERE kod = 726958;
UPDATE ruian_katastr SET nazev = 'Práče' WHERE kod = 726966;
UPDATE ruian_katastr SET nazev = 'Novotníky' WHERE kod = 726974;
UPDATE ruian_katastr SET nazev = 'Prádlo' WHERE kod = 726982;
UPDATE ruian_katastr SET nazev = 'Josefov' WHERE kod = 727008;
UPDATE ruian_katastr SET nazev = 'Staré Město' WHERE kod = 727024;
UPDATE ruian_katastr SET nazev = 'Malá Strana' WHERE kod = 727091;
UPDATE ruian_katastr SET nazev = 'Hradčany' WHERE kod = 727121;
UPDATE ruian_katastr SET nazev = 'Vinohrady' WHERE kod = 727164;
UPDATE ruian_katastr SET nazev = 'Nové Město' WHERE kod = 727181;
UPDATE ruian_katastr SET nazev = 'Vyšehrad' WHERE kod = 727300;
UPDATE ruian_katastr SET nazev = 'Žižkov' WHERE kod = 727415;
UPDATE ruian_katastr SET nazev = 'Krč' WHERE kod = 727598;
UPDATE ruian_katastr SET nazev = 'Michle' WHERE kod = 727750;
UPDATE ruian_katastr SET nazev = 'Hodkovičky' WHERE kod = 727857;
UPDATE ruian_katastr SET nazev = 'Braník' WHERE kod = 727873;
UPDATE ruian_katastr SET nazev = 'Lhotka' WHERE kod = 728071;
UPDATE ruian_katastr SET nazev = 'Podolí' WHERE kod = 728152;
UPDATE ruian_katastr SET nazev = 'Nusle' WHERE kod = 728161;
UPDATE ruian_katastr SET nazev = 'Chodov' WHERE kod = 728225;
UPDATE ruian_katastr SET nazev = 'Háje' WHERE kod = 728233;
UPDATE ruian_katastr SET nazev = 'Kunratice' WHERE kod = 728314;
UPDATE ruian_katastr SET nazev = 'Libuš' WHERE kod = 728390;
UPDATE ruian_katastr SET nazev = 'Kamýk' WHERE kod = 728438;
UPDATE ruian_katastr SET nazev = 'Komořany' WHERE kod = 728519;
UPDATE ruian_katastr SET nazev = 'Modřany' WHERE kod = 728616;
UPDATE ruian_katastr SET nazev = 'Radlice' WHERE kod = 728641;
UPDATE ruian_katastr SET nazev = 'Jinonice' WHERE kod = 728730;
UPDATE ruian_katastr SET nazev = 'Košíře' WHERE kod = 728764;
UPDATE ruian_katastr SET nazev = 'Hlubočepy' WHERE kod = 728837;
UPDATE ruian_katastr SET nazev = 'Motol' WHERE kod = 728951;
UPDATE ruian_katastr SET nazev = 'Smíchov' WHERE kod = 729051;
UPDATE ruian_katastr SET nazev = 'Malá Chuchle' WHERE kod = 729183;
UPDATE ruian_katastr SET nazev = 'Velká Chuchle' WHERE kod = 729213;
UPDATE ruian_katastr SET nazev = 'Lahovice' WHERE kod = 729248;
UPDATE ruian_katastr SET nazev = 'Dejvice' WHERE kod = 729272;
UPDATE ruian_katastr SET nazev = 'Střešovice' WHERE kod = 729302;
UPDATE ruian_katastr SET nazev = 'Veleslavín' WHERE kod = 729353;
UPDATE ruian_katastr SET nazev = 'Vokovice' WHERE kod = 729418;
UPDATE ruian_katastr SET nazev = 'Břevnov' WHERE kod = 729582;
UPDATE ruian_katastr SET nazev = 'Řepy' WHERE kod = 729701;
UPDATE ruian_katastr SET nazev = 'Ruzyně' WHERE kod = 729710;
UPDATE ruian_katastr SET nazev = 'Liboc' WHERE kod = 729795;
UPDATE ruian_katastr SET nazev = 'Nebušice' WHERE kod = 729876;
UPDATE ruian_katastr SET nazev = 'Lysolaje' WHERE kod = 729931;
UPDATE ruian_katastr SET nazev = 'Suchdol' WHERE kod = 729981;
UPDATE ruian_katastr SET nazev = 'Sedlec' WHERE kod = 730041;
UPDATE ruian_katastr SET nazev = 'Bubeneč' WHERE kod = 730106;
UPDATE ruian_katastr SET nazev = 'Holešovice' WHERE kod = 730122;
UPDATE ruian_katastr SET nazev = 'Troja' WHERE kod = 730190;
UPDATE ruian_katastr SET nazev = 'Čimice' WHERE kod = 730394;
UPDATE ruian_katastr SET nazev = 'Kobylisy' WHERE kod = 730475;
UPDATE ruian_katastr SET nazev = 'Bohnice' WHERE kod = 730556;
UPDATE ruian_katastr SET nazev = 'Dolní Chabry' WHERE kod = 730599;
UPDATE ruian_katastr SET nazev = 'Ďáblice' WHERE kod = 730629;
UPDATE ruian_katastr SET nazev = 'Střížkov' WHERE kod = 730866;
UPDATE ruian_katastr SET nazev = 'Libeň' WHERE kod = 730891;
UPDATE ruian_katastr SET nazev = 'Karlín' WHERE kod = 730955;
UPDATE ruian_katastr SET nazev = 'Kyje' WHERE kod = 731226;
UPDATE ruian_katastr SET nazev = 'Hloubětín' WHERE kod = 731234;
UPDATE ruian_katastr SET nazev = 'Vysočany' WHERE kod = 731285;
UPDATE ruian_katastr SET nazev = 'Prosek' WHERE kod = 731382;
UPDATE ruian_katastr SET nazev = 'Letňany' WHERE kod = 731439;
UPDATE ruian_katastr SET nazev = 'Třeboradice' WHERE kod = 731528;
UPDATE ruian_katastr SET nazev = 'Miškovice' WHERE kod = 731552;
UPDATE ruian_katastr SET nazev = 'Čakovice' WHERE kod = 731561;
UPDATE ruian_katastr SET nazev = 'Kbely' WHERE kod = 731641;
UPDATE ruian_katastr SET nazev = 'Černý Most' WHERE kod = 731676;
UPDATE ruian_katastr SET nazev = 'Hostavice' WHERE kod = 731722;
UPDATE ruian_katastr SET nazev = 'Hrdlořezy' WHERE kod = 731765;
UPDATE ruian_katastr SET nazev = 'Strašnice' WHERE kod = 731943;
UPDATE ruian_katastr SET nazev = 'Hostivař' WHERE kod = 732052;
UPDATE ruian_katastr SET nazev = 'Záběhlice' WHERE kod = 732117;
UPDATE ruian_katastr SET nazev = 'Vršovice' WHERE kod = 732257;
UPDATE ruian_katastr SET nazev = 'Malešice' WHERE kod = 732451;
UPDATE ruian_katastr SET nazev = 'Štěrboholy' WHERE kod = 732516;
UPDATE ruian_katastr SET nazev = 'Dolní Měcholupy' WHERE kod = 732541;
UPDATE ruian_katastr SET nazev = 'Horní Měcholupy' WHERE kod = 732583;
UPDATE ruian_katastr SET nazev = 'Petrovice' WHERE kod = 732613;
UPDATE ruian_katastr SET nazev = 'Prachatice' WHERE kod = 732630;
UPDATE ruian_katastr SET nazev = 'Staré Prachatice' WHERE kod = 732711;
UPDATE ruian_katastr SET nazev = 'Kahov' WHERE kod = 732737;
UPDATE ruian_katastr SET nazev = 'Oseky' WHERE kod = 732745;
UPDATE ruian_katastr SET nazev = 'Stádla' WHERE kod = 732753;
UPDATE ruian_katastr SET nazev = 'Volovice' WHERE kod = 732761;
UPDATE ruian_katastr SET nazev = 'Prácheň' WHERE kod = 732770;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Prachomet' WHERE kod = 732788;
UPDATE ruian_katastr SET nazev = 'Prachomety' WHERE kod = 732796;
UPDATE ruian_katastr SET nazev = 'Prachovice' WHERE kod = 732800;
UPDATE ruian_katastr SET nazev = 'Prakšice' WHERE kod = 732826;
UPDATE ruian_katastr SET nazev = 'Prameny' WHERE kod = 732842;
UPDATE ruian_katastr SET nazev = 'Prapořiště' WHERE kod = 732851;
UPDATE ruian_katastr SET nazev = 'Kobylice' WHERE kod = 732869;
UPDATE ruian_katastr SET nazev = 'Prasek' WHERE kod = 732885;
UPDATE ruian_katastr SET nazev = 'Zdechovice u Nového Bydžova' WHERE kod = 732893;
UPDATE ruian_katastr SET nazev = 'Prasetín' WHERE kod = 732907;
UPDATE ruian_katastr SET nazev = 'Praskačka' WHERE kod = 732915;
UPDATE ruian_katastr SET nazev = 'Urbanice u Praskačky' WHERE kod = 732923;
UPDATE ruian_katastr SET nazev = 'Vlčkovice u Praskačky' WHERE kod = 732931;
UPDATE ruian_katastr SET nazev = 'Praskolesy' WHERE kod = 732940;
UPDATE ruian_katastr SET nazev = 'Prašný Újezd' WHERE kod = 732958;
UPDATE ruian_katastr SET nazev = 'Pravčice' WHERE kod = 732974;
UPDATE ruian_katastr SET nazev = 'Pravětice' WHERE kod = 732982;
UPDATE ruian_katastr SET nazev = 'Pravice' WHERE kod = 732991;
UPDATE ruian_katastr SET nazev = 'Pravíkov' WHERE kod = 733008;
UPDATE ruian_katastr SET nazev = 'Pravlov' WHERE kod = 733016;
UPDATE ruian_katastr SET nazev = 'Pravonín' WHERE kod = 733032;
UPDATE ruian_katastr SET nazev = 'Tisek' WHERE kod = 733041;
UPDATE ruian_katastr SET nazev = 'Pražmo' WHERE kod = 733059;
UPDATE ruian_katastr SET nazev = 'Prchalov' WHERE kod = 733067;
UPDATE ruian_katastr SET nazev = 'Prlov' WHERE kod = 733083;
UPDATE ruian_katastr SET nazev = 'Probluz' WHERE kod = 733091;
UPDATE ruian_katastr SET nazev = 'Proboštov u Teplic' WHERE kod = 733105;
UPDATE ruian_katastr SET nazev = 'Přítkov' WHERE kod = 733113;
UPDATE ruian_katastr SET nazev = 'Prodašice' WHERE kod = 733121;
UPDATE ruian_katastr SET nazev = 'Prohoř' WHERE kod = 733130;
UPDATE ruian_katastr SET nazev = 'Prokopov' WHERE kod = 733148;
UPDATE ruian_katastr SET nazev = 'Proseč u Humpolce' WHERE kod = 733156;
UPDATE ruian_katastr SET nazev = 'Podměstí' WHERE kod = 733172;
UPDATE ruian_katastr SET nazev = 'Proseč u Skutče' WHERE kod = 733181;
UPDATE ruian_katastr SET nazev = 'Záboří u Proseče' WHERE kod = 733199;
UPDATE ruian_katastr SET nazev = 'Proseč-Obořiště' WHERE kod = 733202;
UPDATE ruian_katastr SET nazev = 'Proseč nad Nisou' WHERE kod = 733211;
UPDATE ruian_katastr SET nazev = 'Javorník u Českého Dubu' WHERE kod = 733229;
UPDATE ruian_katastr SET nazev = 'Proseč pod Ještědem' WHERE kod = 733245;
UPDATE ruian_katastr SET nazev = 'Proseč pod Křemešníkem' WHERE kod = 733253;
UPDATE ruian_katastr SET nazev = 'Prosečné' WHERE kod = 733261;
UPDATE ruian_katastr SET nazev = 'Prosenice' WHERE kod = 733288;
UPDATE ruian_katastr SET nazev = 'Proseničky' WHERE kod = 733296;
UPDATE ruian_katastr SET nazev = 'Luhy u Prosenické Lhoty' WHERE kod = 733326;
UPDATE ruian_katastr SET nazev = 'Prosenická Lhota' WHERE kod = 733342;
UPDATE ruian_katastr SET nazev = 'Suchdol u Prosenické Lhoty' WHERE kod = 733351;
UPDATE ruian_katastr SET nazev = 'Prosetín u Hlinska' WHERE kod = 733393;
UPDATE ruian_katastr SET nazev = 'Brťoví' WHERE kod = 733407;
UPDATE ruian_katastr SET nazev = 'Čtyři Dvory' WHERE kod = 733415;
UPDATE ruian_katastr SET nazev = 'Prosetín u Bystřice nad Pernštejnem' WHERE kod = 733423;
UPDATE ruian_katastr SET nazev = 'Prosíčka' WHERE kod = 733431;
UPDATE ruian_katastr SET nazev = 'Nezdín' WHERE kod = 733458;
UPDATE ruian_katastr SET nazev = 'Prosiměřice' WHERE kod = 733466;
UPDATE ruian_katastr SET nazev = 'Proskovice' WHERE kod = 733474;
UPDATE ruian_katastr SET nazev = 'Prosmyky' WHERE kod = 733482;
UPDATE ruian_katastr SET nazev = 'Prostějov' WHERE kod = 733491;
UPDATE ruian_katastr SET nazev = 'Krasice' WHERE kod = 733695;
UPDATE ruian_katastr SET nazev = 'Prostějovičky' WHERE kod = 733709;
UPDATE ruian_katastr SET nazev = 'Prostiboř' WHERE kod = 733717;
UPDATE ruian_katastr SET nazev = 'Prostřední Bečva' WHERE kod = 733750;
UPDATE ruian_katastr SET nazev = 'Prostřední Lhota' WHERE kod = 733784;
UPDATE ruian_katastr SET nazev = 'Heřmanice u Králík' WHERE kod = 733792;
UPDATE ruian_katastr SET nazev = 'Prostřední Lipka' WHERE kod = 733806;
UPDATE ruian_katastr SET nazev = 'Prostřední Poříčí' WHERE kod = 733814;
UPDATE ruian_katastr SET nazev = 'Protivanov' WHERE kod = 733822;
UPDATE ruian_katastr SET nazev = 'Protivec u Žlutic' WHERE kod = 733831;
UPDATE ruian_katastr SET nazev = 'Milenovice' WHERE kod = 733849;
UPDATE ruian_katastr SET nazev = 'Protivín' WHERE kod = 733857;
UPDATE ruian_katastr SET nazev = 'Provodín' WHERE kod = 733865;
UPDATE ruian_katastr SET nazev = 'Kleny' WHERE kod = 733873;
UPDATE ruian_katastr SET nazev = 'Provodov' WHERE kod = 733881;
UPDATE ruian_katastr SET nazev = 'Šeřeč' WHERE kod = 733890;
UPDATE ruian_katastr SET nazev = 'Domkov' WHERE kod = 733911;
UPDATE ruian_katastr SET nazev = 'Provodov na Moravě' WHERE kod = 733938;
UPDATE ruian_katastr SET nazev = 'Provodovice' WHERE kod = 733946;
UPDATE ruian_katastr SET nazev = 'Prštice' WHERE kod = 733954;
UPDATE ruian_katastr SET nazev = 'Hole u Průhonic' WHERE kod = 733962;
UPDATE ruian_katastr SET nazev = 'Průhonice' WHERE kod = 733971;
UPDATE ruian_katastr SET nazev = 'Prusinovice' WHERE kod = 733997;
UPDATE ruian_katastr SET nazev = 'Boškůvky' WHERE kod = 734004;
UPDATE ruian_katastr SET nazev = 'Moravské Prusy' WHERE kod = 734012;
UPDATE ruian_katastr SET nazev = 'Prušánky' WHERE kod = 734021;
UPDATE ruian_katastr SET nazev = 'Dolní Prysk' WHERE kod = 734039;
UPDATE ruian_katastr SET nazev = 'Horní Prysk' WHERE kod = 734047;
UPDATE ruian_katastr SET nazev = 'Pržno' WHERE kod = 734055;
UPDATE ruian_katastr SET nazev = 'Pržno u Vsetína' WHERE kod = 734063;
UPDATE ruian_katastr SET nazev = 'Přáslavice' WHERE kod = 734098;
UPDATE ruian_katastr SET nazev = 'Přáslavice u Olomouce' WHERE kod = 734110;
UPDATE ruian_katastr SET nazev = 'Přeborov' WHERE kod = 734128;
UPDATE ruian_katastr SET nazev = 'Přebuz' WHERE kod = 734136;
UPDATE ruian_katastr SET nazev = 'Rolava' WHERE kod = 734144;
UPDATE ruian_katastr SET nazev = 'Chaloupky u Přebuze' WHERE kod = 734152;
UPDATE ruian_katastr SET nazev = 'Přeckov' WHERE kod = 734161;
UPDATE ruian_katastr SET nazev = 'Přečín' WHERE kod = 734179;
UPDATE ruian_katastr SET nazev = 'Přečkovice' WHERE kod = 734195;
UPDATE ruian_katastr SET nazev = 'Předboj' WHERE kod = 734209;
UPDATE ruian_katastr SET nazev = 'Předboř u Prahy' WHERE kod = 734225;
UPDATE ruian_katastr SET nazev = 'Předhradí u Skutče' WHERE kod = 734241;
UPDATE ruian_katastr SET nazev = 'Hory u Předína' WHERE kod = 734250;
UPDATE ruian_katastr SET nazev = 'Předín' WHERE kod = 734268;
UPDATE ruian_katastr SET nazev = 'Předměřice nad Jizerou' WHERE kod = 734284;
UPDATE ruian_katastr SET nazev = 'Předměřice nad Labem' WHERE kod = 734292;
UPDATE ruian_katastr SET nazev = 'Předměstí' WHERE kod = 734322;
UPDATE ruian_katastr SET nazev = 'Předmíř' WHERE kod = 734349;
UPDATE ruian_katastr SET nazev = 'Přední Arnoštov' WHERE kod = 734357;
UPDATE ruian_katastr SET nazev = 'Přední Kopanina' WHERE kod = 734373;
UPDATE ruian_katastr SET nazev = 'Přední Lhota u Poděbrad' WHERE kod = 734381;
UPDATE ruian_katastr SET nazev = 'Přední Výtoň' WHERE kod = 734390;
UPDATE ruian_katastr SET nazev = 'Zadní Výtoň' WHERE kod = 734403;
UPDATE ruian_katastr SET nazev = 'Makov u Předslavi' WHERE kod = 734411;
UPDATE ruian_katastr SET nazev = 'Měcholupy u Předslavi' WHERE kod = 734420;
UPDATE ruian_katastr SET nazev = 'Petrovičky u Předslavi' WHERE kod = 734438;
UPDATE ruian_katastr SET nazev = 'Předslav' WHERE kod = 734446;
UPDATE ruian_katastr SET nazev = 'Kakovice u Volyně' WHERE kod = 734454;
UPDATE ruian_katastr SET nazev = 'Marčovice' WHERE kod = 734462;
UPDATE ruian_katastr SET nazev = 'Předslavice' WHERE kod = 734471;
UPDATE ruian_katastr SET nazev = 'Úlehle u Předslavic' WHERE kod = 734489;
UPDATE ruian_katastr SET nazev = 'Všechlapy u Volyně' WHERE kod = 734497;
UPDATE ruian_katastr SET nazev = 'Kvasejovice u Soběslavi' WHERE kod = 734501;
UPDATE ruian_katastr SET nazev = 'Přehořov u Soběslavi' WHERE kod = 734519;
UPDATE ruian_katastr SET nazev = 'Bítov u Přehýšova' WHERE kod = 734527;
UPDATE ruian_katastr SET nazev = 'Přehýšov' WHERE kod = 734535;
UPDATE ruian_katastr SET nazev = 'Radějovice u Přehýšova' WHERE kod = 734543;
UPDATE ruian_katastr SET nazev = 'Přelíc' WHERE kod = 734551;
UPDATE ruian_katastr SET nazev = 'Přelouč' WHERE kod = 734560;
UPDATE ruian_katastr SET nazev = 'Přelovice' WHERE kod = 734641;
UPDATE ruian_katastr SET nazev = 'Přemyslovice' WHERE kod = 734659;
UPDATE ruian_katastr SET nazev = 'Štarnov u Přemyslovic' WHERE kod = 734667;
UPDATE ruian_katastr SET nazev = 'Přepeře' WHERE kod = 734675;
UPDATE ruian_katastr SET nazev = 'Přepeře u Turnova' WHERE kod = 734683;
UPDATE ruian_katastr SET nazev = 'Přepychy' WHERE kod = 734691;
UPDATE ruian_katastr SET nazev = 'Přepychy u Opočna' WHERE kod = 734705;
UPDATE ruian_katastr SET nazev = 'Přerov' WHERE kod = 734713;
UPDATE ruian_katastr SET nazev = 'Předmostí' WHERE kod = 734977;
UPDATE ruian_katastr SET nazev = 'Kozlovice u Přerova' WHERE kod = 734985;
UPDATE ruian_katastr SET nazev = 'Lověšice u Přerova' WHERE kod = 735001;
UPDATE ruian_katastr SET nazev = 'Přerov nad Labem' WHERE kod = 735035;
UPDATE ruian_katastr SET nazev = 'Přerubenice' WHERE kod = 735051;
UPDATE ruian_katastr SET nazev = 'Přeseka' WHERE kod = 735060;
UPDATE ruian_katastr SET nazev = 'Přestanov' WHERE kod = 735078;
UPDATE ruian_katastr SET nazev = 'Dvorce u Sedlce' WHERE kod = 735086;
UPDATE ruian_katastr SET nazev = 'Přestavlky u Sedlce' WHERE kod = 735108;
UPDATE ruian_katastr SET nazev = 'Přestavlky u Roudnice nad Labem' WHERE kod = 735141;
UPDATE ruian_katastr SET nazev = 'Přestavlky u Chrudimi' WHERE kod = 735159;
UPDATE ruian_katastr SET nazev = 'Přestavlky u Přerova' WHERE kod = 735167;
UPDATE ruian_katastr SET nazev = 'Přestavlky u Čerčan' WHERE kod = 735191;
UPDATE ruian_katastr SET nazev = 'Přešovice' WHERE kod = 735205;
UPDATE ruian_katastr SET nazev = 'Držkrajov' WHERE kod = 735213;
UPDATE ruian_katastr SET nazev = 'Přeštěnice' WHERE kod = 735230;
UPDATE ruian_katastr SET nazev = 'Týnice' WHERE kod = 735248;
UPDATE ruian_katastr SET nazev = 'Přeštice' WHERE kod = 735256;
UPDATE ruian_katastr SET nazev = 'Přešťovice' WHERE kod = 735264;
UPDATE ruian_katastr SET nazev = 'Slaník' WHERE kod = 735272;
UPDATE ruian_katastr SET nazev = 'Převýšov' WHERE kod = 735299;
UPDATE ruian_katastr SET nazev = 'Přezletice' WHERE kod = 735302;
UPDATE ruian_katastr SET nazev = 'Přibice' WHERE kod = 735311;
UPDATE ruian_katastr SET nazev = 'Příbor' WHERE kod = 735329;
UPDATE ruian_katastr SET nazev = 'Klokočov u Příbora' WHERE kod = 735370;
UPDATE ruian_katastr SET nazev = 'Příbram' WHERE kod = 735426;
UPDATE ruian_katastr SET nazev = 'Březové Hory' WHERE kod = 735515;
UPDATE ruian_katastr SET nazev = 'Zdaboř' WHERE kod = 735566;
UPDATE ruian_katastr SET nazev = 'Příbram na Moravě' WHERE kod = 735639;
UPDATE ruian_katastr SET nazev = 'Příbraz' WHERE kod = 735663;
UPDATE ruian_katastr SET nazev = 'Přibyslav' WHERE kod = 735698;
UPDATE ruian_katastr SET nazev = 'Ronov nad Sázavou' WHERE kod = 735701;
UPDATE ruian_katastr SET nazev = 'Přibyslav nad Metují' WHERE kod = 735710;
UPDATE ruian_katastr SET nazev = 'Benešovice u Všelibic' WHERE kod = 735728;
UPDATE ruian_katastr SET nazev = 'Nesvačily u Všelibic' WHERE kod = 735744;
UPDATE ruian_katastr SET nazev = 'Podhora u Pěnčína' WHERE kod = 735752;
UPDATE ruian_katastr SET nazev = 'Přibyslavice' WHERE kod = 735761;
UPDATE ruian_katastr SET nazev = 'Přibyslavice u Velké Bíteše' WHERE kod = 735787;
UPDATE ruian_katastr SET nazev = 'Radoškov' WHERE kod = 735795;
UPDATE ruian_katastr SET nazev = 'Přibyslavice nad Jihlavou' WHERE kod = 735809;
UPDATE ruian_katastr SET nazev = 'Přibyšice' WHERE kod = 735817;
UPDATE ruian_katastr SET nazev = 'Příčina' WHERE kod = 735825;
UPDATE ruian_katastr SET nazev = 'Příčovy' WHERE kod = 735833;
UPDATE ruian_katastr SET nazev = 'Zátes' WHERE kod = 735850;
UPDATE ruian_katastr SET nazev = 'Přídolí' WHERE kod = 735868;
UPDATE ruian_katastr SET nazev = 'Spolí' WHERE kod = 735884;
UPDATE ruian_katastr SET nazev = 'Malčice-Osek' WHERE kod = 735892;
UPDATE ruian_katastr SET nazev = 'Lověšice' WHERE kod = 735914;
UPDATE ruian_katastr SET nazev = 'Všeměry' WHERE kod = 735922;
UPDATE ruian_katastr SET nazev = 'Kucíny' WHERE kod = 735931;
UPDATE ruian_katastr SET nazev = 'Příchovice u Přeštic' WHERE kod = 735949;
UPDATE ruian_katastr SET nazev = 'Radkovice u Příchovic' WHERE kod = 735957;
UPDATE ruian_katastr SET nazev = 'Zálesí u Příchovic' WHERE kod = 735965;
UPDATE ruian_katastr SET nazev = 'Příjemky' WHERE kod = 735981;
UPDATE ruian_katastr SET nazev = 'Hynkov' WHERE kod = 735990;
UPDATE ruian_katastr SET nazev = 'Příkazy' WHERE kod = 736007;
UPDATE ruian_katastr SET nazev = 'Příkosice' WHERE kod = 736015;
UPDATE ruian_katastr SET nazev = 'Štítov' WHERE kod = 736023;
UPDATE ruian_katastr SET nazev = 'Příkrý' WHERE kod = 736031;
UPDATE ruian_katastr SET nazev = 'Přílepy' WHERE kod = 736040;
UPDATE ruian_katastr SET nazev = 'Přílepy u Holešova' WHERE kod = 736058;
UPDATE ruian_katastr SET nazev = 'Příložany' WHERE kod = 736066;
UPDATE ruian_katastr SET nazev = 'Příluka' WHERE kod = 736074;
UPDATE ruian_katastr SET nazev = 'Příluky' WHERE kod = 736082;
UPDATE ruian_katastr SET nazev = 'Málkov u Přimdy' WHERE kod = 736091;
UPDATE ruian_katastr SET nazev = 'Nová Ves pod Přimdou' WHERE kod = 736104;
UPDATE ruian_katastr SET nazev = 'Přimda' WHERE kod = 736112;
UPDATE ruian_katastr SET nazev = 'Přímětice' WHERE kod = 736121;
UPDATE ruian_katastr SET nazev = 'Přísečná' WHERE kod = 736147;
UPDATE ruian_katastr SET nazev = 'Srnín' WHERE kod = 736155;
UPDATE ruian_katastr SET nazev = 'Dolina' WHERE kod = 736163;
UPDATE ruian_katastr SET nazev = 'Kotlina' WHERE kod = 736171;
UPDATE ruian_katastr SET nazev = 'Kryštofovy Hamry' WHERE kod = 736180;
UPDATE ruian_katastr SET nazev = 'Přísečnice' WHERE kod = 736201;
UPDATE ruian_katastr SET nazev = 'Rusová' WHERE kod = 736210;
UPDATE ruian_katastr SET nazev = 'Příseka' WHERE kod = 736228;
UPDATE ruian_katastr SET nazev = 'Pohleď' WHERE kod = 736236;
UPDATE ruian_katastr SET nazev = 'Příseka u Světlé nad Sázavou' WHERE kod = 736244;
UPDATE ruian_katastr SET nazev = 'Služátky' WHERE kod = 736252;
UPDATE ruian_katastr SET nazev = 'Přísnotice' WHERE kod = 736261;
UPDATE ruian_katastr SET nazev = 'Přistoupim' WHERE kod = 736279;
UPDATE ruian_katastr SET nazev = 'Hradešín' WHERE kod = 736287;
UPDATE ruian_katastr SET nazev = 'Přišimasy' WHERE kod = 736295;
UPDATE ruian_katastr SET nazev = 'Příšovice' WHERE kod = 736309;
UPDATE ruian_katastr SET nazev = 'Příštpo' WHERE kod = 736317;
UPDATE ruian_katastr SET nazev = 'Nové Mlýny' WHERE kod = 736325;
UPDATE ruian_katastr SET nazev = 'Přítluky' WHERE kod = 736333;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Radnic' WHERE kod = 736341;
UPDATE ruian_katastr SET nazev = 'Přívětice' WHERE kod = 736350;
UPDATE ruian_katastr SET nazev = 'Sklená Huť' WHERE kod = 736368;
UPDATE ruian_katastr SET nazev = 'Přívory' WHERE kod = 736376;
UPDATE ruian_katastr SET nazev = 'Přívrat' WHERE kod = 736384;
UPDATE ruian_katastr SET nazev = 'Psárov' WHERE kod = 736392;
UPDATE ruian_katastr SET nazev = 'Tříklasovice' WHERE kod = 736406;
UPDATE ruian_katastr SET nazev = 'Dolní Jirčany' WHERE kod = 736414;
UPDATE ruian_katastr SET nazev = 'Psáry' WHERE kod = 736422;
UPDATE ruian_katastr SET nazev = 'Psáře' WHERE kod = 736431;
UPDATE ruian_katastr SET nazev = 'Křešice u Psinic' WHERE kod = 736449;
UPDATE ruian_katastr SET nazev = 'Psinice' WHERE kod = 736457;
UPDATE ruian_katastr SET nazev = 'Pstruží' WHERE kod = 736465;
UPDATE ruian_katastr SET nazev = 'Pšánky' WHERE kod = 736473;
UPDATE ruian_katastr SET nazev = 'Borek u Štědré' WHERE kod = 736481;
UPDATE ruian_katastr SET nazev = 'Kobylé' WHERE kod = 736490;
UPDATE ruian_katastr SET nazev = 'Kolešov u Žlutic' WHERE kod = 736503;
UPDATE ruian_katastr SET nazev = 'Pšov u Žlutic' WHERE kod = 736511;
UPDATE ruian_katastr SET nazev = 'Semtěš u Žlutic' WHERE kod = 736520;
UPDATE ruian_katastr SET nazev = 'Pšov u Podbořan' WHERE kod = 736538;
UPDATE ruian_katastr SET nazev = 'Sýrovice' WHERE kod = 736546;
UPDATE ruian_katastr SET nazev = 'Pšovlky' WHERE kod = 736554;
UPDATE ruian_katastr SET nazev = 'Ptáčov' WHERE kod = 736562;
UPDATE ruian_katastr SET nazev = 'Ptení' WHERE kod = 736589;
UPDATE ruian_katastr SET nazev = 'Ptenín' WHERE kod = 736601;
UPDATE ruian_katastr SET nazev = 'Ptice' WHERE kod = 736635;
UPDATE ruian_katastr SET nazev = 'Ptýrov' WHERE kod = 736651;
UPDATE ruian_katastr SET nazev = 'Doubrava u Puclic' WHERE kod = 736678;
UPDATE ruian_katastr SET nazev = 'Malý Malahov' WHERE kod = 736686;
UPDATE ruian_katastr SET nazev = 'Puclice' WHERE kod = 736694;
UPDATE ruian_katastr SET nazev = 'Pucov' WHERE kod = 736708;
UPDATE ruian_katastr SET nazev = 'Pudlov' WHERE kod = 736716;
UPDATE ruian_katastr SET nazev = 'Petrovice u Jihlavy' WHERE kod = 736759;
UPDATE ruian_katastr SET nazev = 'Puklice' WHERE kod = 736767;
UPDATE ruian_katastr SET nazev = 'Studénky' WHERE kod = 736775;
UPDATE ruian_katastr SET nazev = 'Pulčín' WHERE kod = 736783;
UPDATE ruian_katastr SET nazev = 'Purkarec' WHERE kod = 736791;
UPDATE ruian_katastr SET nazev = 'Pustá Kamenice' WHERE kod = 736821;
UPDATE ruian_katastr SET nazev = 'Pustá Polom' WHERE kod = 736830;
UPDATE ruian_katastr SET nazev = 'Pustá Rybná' WHERE kod = 736899;
UPDATE ruian_katastr SET nazev = 'Pustějov' WHERE kod = 736902;
UPDATE ruian_katastr SET nazev = 'Pustiměř' WHERE kod = 736911;
UPDATE ruian_katastr SET nazev = 'Pustina' WHERE kod = 736937;
UPDATE ruian_katastr SET nazev = 'Pustověty' WHERE kod = 736961;
UPDATE ruian_katastr SET nazev = 'Putim' WHERE kod = 736970;
UPDATE ruian_katastr SET nazev = 'Putimov' WHERE kod = 736996;
UPDATE ruian_katastr SET nazev = 'Pyšel' WHERE kod = 737003;
UPDATE ruian_katastr SET nazev = 'Vaneč' WHERE kod = 737011;
UPDATE ruian_katastr SET nazev = 'Kovářovice' WHERE kod = 737038;
UPDATE ruian_katastr SET nazev = 'Pyšely' WHERE kod = 737054;
UPDATE ruian_katastr SET nazev = 'Zaječice' WHERE kod = 737071;
UPDATE ruian_katastr SET nazev = 'Rabakov' WHERE kod = 737089;
UPDATE ruian_katastr SET nazev = 'Bojanovice pod Rabím' WHERE kod = 737097;
UPDATE ruian_katastr SET nazev = 'Čepice' WHERE kod = 737101;
UPDATE ruian_katastr SET nazev = 'Rabí' WHERE kod = 737119;
UPDATE ruian_katastr SET nazev = 'Kotaneč' WHERE kod = 737127;
UPDATE ruian_katastr SET nazev = 'Rabštejn nad Střelou' WHERE kod = 737135;
UPDATE ruian_katastr SET nazev = 'Rabštejnská Lhota' WHERE kod = 737151;
UPDATE ruian_katastr SET nazev = 'Smrkový Týnec' WHERE kod = 737160;
UPDATE ruian_katastr SET nazev = 'Kunětice' WHERE kod = 737178;
UPDATE ruian_katastr SET nazev = 'Němčice nad Labem' WHERE kod = 737186;
UPDATE ruian_katastr SET nazev = 'Ráby' WHERE kod = 737194;
UPDATE ruian_katastr SET nazev = 'Blaženice' WHERE kod = 737216;
UPDATE ruian_katastr SET nazev = 'Rabyně' WHERE kod = 737267;
UPDATE ruian_katastr SET nazev = 'Racková' WHERE kod = 737283;
UPDATE ruian_katastr SET nazev = 'Rácov' WHERE kod = 737291;
UPDATE ruian_katastr SET nazev = 'Račerovice' WHERE kod = 737305;
UPDATE ruian_katastr SET nazev = 'Račice nad Berounkou' WHERE kod = 737313;
UPDATE ruian_katastr SET nazev = 'Hněvice' WHERE kod = 737321;
UPDATE ruian_katastr SET nazev = 'Račice u Štětí' WHERE kod = 737330;
UPDATE ruian_katastr SET nazev = 'Račice u Hrotovic' WHERE kod = 737348;
UPDATE ruian_katastr SET nazev = 'Račice u Dlouhého' WHERE kod = 737356;
UPDATE ruian_katastr SET nazev = 'Pístovice' WHERE kod = 737364;
UPDATE ruian_katastr SET nazev = 'Račice' WHERE kod = 737372;
UPDATE ruian_katastr SET nazev = 'Račice nad Trotinou' WHERE kod = 737381;
UPDATE ruian_katastr SET nazev = 'Račiněves' WHERE kod = 737399;
UPDATE ruian_katastr SET nazev = 'Radčice u Vodňan' WHERE kod = 737402;
UPDATE ruian_katastr SET nazev = 'Radčice u Plzně' WHERE kod = 737411;
UPDATE ruian_katastr SET nazev = 'Radčice' WHERE kod = 737429;
UPDATE ruian_katastr SET nazev = 'Radčice u Skutče' WHERE kod = 737437;
UPDATE ruian_katastr SET nazev = 'Radeč u Horní Police' WHERE kod = 737445;
UPDATE ruian_katastr SET nazev = 'Radeč' WHERE kod = 737453;
UPDATE ruian_katastr SET nazev = 'Radějov u Strážnice' WHERE kod = 737461;
UPDATE ruian_katastr SET nazev = 'Olešky' WHERE kod = 737470;
UPDATE ruian_katastr SET nazev = 'Radějovice' WHERE kod = 737488;
UPDATE ruian_katastr SET nazev = 'Radenice' WHERE kod = 737496;
UPDATE ruian_katastr SET nazev = 'Bítov u Radenína' WHERE kod = 737500;
UPDATE ruian_katastr SET nazev = 'Radenín' WHERE kod = 737518;
UPDATE ruian_katastr SET nazev = 'Radešín' WHERE kod = 737534;
UPDATE ruian_katastr SET nazev = 'Radešín u Martiněvsi' WHERE kod = 737542;
UPDATE ruian_katastr SET nazev = 'Radešín nad Bobrůvkou' WHERE kod = 737551;
UPDATE ruian_katastr SET nazev = 'Radešínská Svratka' WHERE kod = 737569;
UPDATE ruian_katastr SET nazev = 'Radětice' WHERE kod = 737585;
UPDATE ruian_katastr SET nazev = 'Radětice u Bechyně' WHERE kod = 737593;
UPDATE ruian_katastr SET nazev = 'Libotyně' WHERE kod = 737615;
UPDATE ruian_katastr SET nazev = 'Lštění u Radhostic' WHERE kod = 737623;
UPDATE ruian_katastr SET nazev = 'Radhostice' WHERE kod = 737631;
UPDATE ruian_katastr SET nazev = 'Radhošť' WHERE kod = 737640;
UPDATE ruian_katastr SET nazev = 'Sedlíšťka' WHERE kod = 737658;
UPDATE ruian_katastr SET nazev = 'Radíč' WHERE kod = 737674;
UPDATE ruian_katastr SET nazev = 'Milčeves' WHERE kod = 737691;
UPDATE ruian_katastr SET nazev = 'Radíčeves' WHERE kod = 737704;
UPDATE ruian_katastr SET nazev = 'Dolní Radíkov' WHERE kod = 737712;
UPDATE ruian_katastr SET nazev = 'Horní Radíkov' WHERE kod = 737721;
UPDATE ruian_katastr SET nazev = 'Radíkov u Olomouce' WHERE kod = 737747;
UPDATE ruian_katastr SET nazev = 'Radíkov u Hranic' WHERE kod = 737755;
UPDATE ruian_katastr SET nazev = 'Radíkovice' WHERE kod = 737763;
UPDATE ruian_katastr SET nazev = 'Radim u Kolína' WHERE kod = 737780;
UPDATE ruian_katastr SET nazev = 'Radim' WHERE kod = 737798;
UPDATE ruian_katastr SET nazev = 'Dřevěnice' WHERE kod = 737801;
UPDATE ruian_katastr SET nazev = 'Lháň' WHERE kod = 737810;
UPDATE ruian_katastr SET nazev = 'Radim u Jičína' WHERE kod = 737828;
UPDATE ruian_katastr SET nazev = 'Studeňany' WHERE kod = 737836;
UPDATE ruian_katastr SET nazev = 'Tužín' WHERE kod = 737844;
UPDATE ruian_katastr SET nazev = 'Radiměř' WHERE kod = 737852;
UPDATE ruian_katastr SET nazev = 'Hnojná Lhotka' WHERE kod = 737879;
UPDATE ruian_katastr SET nazev = 'Libějice' WHERE kod = 737887;
UPDATE ruian_katastr SET nazev = 'Lom' WHERE kod = 737895;
UPDATE ruian_katastr SET nazev = 'Radimovice u Želče' WHERE kod = 737909;
UPDATE ruian_katastr SET nazev = 'Slapy u Tábora' WHERE kod = 737917;
UPDATE ruian_katastr SET nazev = 'Balkova Lhota' WHERE kod = 737925;
UPDATE ruian_katastr SET nazev = 'Radimovice u Tábora' WHERE kod = 737950;
UPDATE ruian_katastr SET nazev = 'Radkov u Tábora' WHERE kod = 737968;
UPDATE ruian_katastr SET nazev = 'Radkov u Moravské Třebové' WHERE kod = 737976;
UPDATE ruian_katastr SET nazev = 'Radkov u Telče' WHERE kod = 737984;
UPDATE ruian_katastr SET nazev = 'Radkov u Vítkova' WHERE kod = 738018;
UPDATE ruian_katastr SET nazev = 'Radkova Lhota' WHERE kod = 738026;
UPDATE ruian_katastr SET nazev = 'Radkovice u Budče' WHERE kod = 738034;
UPDATE ruian_katastr SET nazev = 'Radkovice u Hrotovic' WHERE kod = 738042;
UPDATE ruian_katastr SET nazev = 'Radkovy' WHERE kod = 738051;
UPDATE ruian_katastr SET nazev = 'Radlice u Volfířova' WHERE kod = 738069;
UPDATE ruian_katastr SET nazev = 'Rádlo' WHERE kod = 738085;
UPDATE ruian_katastr SET nazev = 'Radnice u Rokycan' WHERE kod = 738107;
UPDATE ruian_katastr SET nazev = 'Skomelno' WHERE kod = 738115;
UPDATE ruian_katastr SET nazev = 'Újezd u Svatého Kříže' WHERE kod = 738123;
UPDATE ruian_katastr SET nazev = 'Radnice' WHERE kod = 738131;
UPDATE ruian_katastr SET nazev = 'Radňov u Rynárce' WHERE kod = 738158;
UPDATE ruian_katastr SET nazev = 'Radňov u Květinova' WHERE kod = 738166;
UPDATE ruian_katastr SET nazev = 'Radňoves' WHERE kod = 738174;
UPDATE ruian_katastr SET nazev = 'Radňovice' WHERE kod = 738182;
UPDATE ruian_katastr SET nazev = 'Radochovy' WHERE kod = 738191;
UPDATE ruian_katastr SET nazev = 'Domanice' WHERE kod = 738204;
UPDATE ruian_katastr SET nazev = 'Leskovice u Radomyšle' WHERE kod = 738212;
UPDATE ruian_katastr SET nazev = 'Radomyšl' WHERE kod = 738221;
UPDATE ruian_katastr SET nazev = 'Kaletice' WHERE kod = 738239;
UPDATE ruian_katastr SET nazev = 'Radonice u Prahy' WHERE kod = 738247;
UPDATE ruian_katastr SET nazev = 'Radonice u Milavčí' WHERE kod = 738255;
UPDATE ruian_katastr SET nazev = 'Radonice u Kadaně' WHERE kod = 738280;
UPDATE ruian_katastr SET nazev = 'Radonín' WHERE kod = 738301;
UPDATE ruian_katastr SET nazev = 'Radostice u Brna' WHERE kod = 738310;
UPDATE ruian_katastr SET nazev = 'Radostín u Sychrova' WHERE kod = 738328;
UPDATE ruian_katastr SET nazev = 'Radostín u Havlíčkova Brodu' WHERE kod = 738361;
UPDATE ruian_katastr SET nazev = 'Radostín u Vojnova Městce' WHERE kod = 738379;
UPDATE ruian_katastr SET nazev = 'Radostín nad Oslavou' WHERE kod = 738387;
UPDATE ruian_katastr SET nazev = 'Zahradiště' WHERE kod = 738395;
UPDATE ruian_katastr SET nazev = 'Lestkov pod Kozákovem' WHERE kod = 738417;
UPDATE ruian_katastr SET nazev = 'Volavec' WHERE kod = 738433;
UPDATE ruian_katastr SET nazev = 'Radostov' WHERE kod = 738450;
UPDATE ruian_katastr SET nazev = 'Radostovice u Smilových Hor' WHERE kod = 738484;
UPDATE ruian_katastr SET nazev = 'Radošice' WHERE kod = 738492;
UPDATE ruian_katastr SET nazev = 'Horní Smrčné' WHERE kod = 738506;
UPDATE ruian_katastr SET nazev = 'Radošov' WHERE kod = 738514;
UPDATE ruian_katastr SET nazev = 'Radošovice u Vlašimi' WHERE kod = 738549;
UPDATE ruian_katastr SET nazev = 'Radošovice u Českých Budějovic' WHERE kod = 738557;
UPDATE ruian_katastr SET nazev = 'Tupesy' WHERE kod = 738573;
UPDATE ruian_katastr SET nazev = 'Kapsova Lhota' WHERE kod = 738581;
UPDATE ruian_katastr SET nazev = 'Radošovice u Strakonic' WHERE kod = 738590;
UPDATE ruian_katastr SET nazev = 'Radotice' WHERE kod = 738603;
UPDATE ruian_katastr SET nazev = 'Radotín' WHERE kod = 738620;
UPDATE ruian_katastr SET nazev = 'Radotín u Lipníka nad Bečvou' WHERE kod = 738638;
UPDATE ruian_katastr SET nazev = 'Čakovice u Radouně' WHERE kod = 738646;
UPDATE ruian_katastr SET nazev = 'Radouň u Štětí' WHERE kod = 738654;
UPDATE ruian_katastr SET nazev = 'Radouňka' WHERE kod = 738689;
UPDATE ruian_katastr SET nazev = 'Radouš' WHERE kod = 738697;
UPDATE ruian_katastr SET nazev = 'Radovesice u Libochovic' WHERE kod = 738701;
UPDATE ruian_katastr SET nazev = 'Dřínek' WHERE kod = 738719;
UPDATE ruian_katastr SET nazev = 'Hetov' WHERE kod = 738727;
UPDATE ruian_katastr SET nazev = 'Radovesice u Bíliny' WHERE kod = 738735;
UPDATE ruian_katastr SET nazev = 'Radovesnice I' WHERE kod = 738743;
UPDATE ruian_katastr SET nazev = 'Zibohlavy' WHERE kod = 738751;
UPDATE ruian_katastr SET nazev = 'Lipec' WHERE kod = 738760;
UPDATE ruian_katastr SET nazev = 'Radovesnice II' WHERE kod = 738778;
UPDATE ruian_katastr SET nazev = 'Rozehnaly' WHERE kod = 738786;
UPDATE ruian_katastr SET nazev = 'Radslavice u Vyškova' WHERE kod = 738794;
UPDATE ruian_katastr SET nazev = 'Radslavičky' WHERE kod = 738808;
UPDATE ruian_katastr SET nazev = 'Radslavice u Přerova' WHERE kod = 738816;
UPDATE ruian_katastr SET nazev = 'Raduň' WHERE kod = 738824;
UPDATE ruian_katastr SET nazev = 'Radvanice v Čechách' WHERE kod = 738832;
UPDATE ruian_katastr SET nazev = 'Slavětín u Radvanic' WHERE kod = 738841;
UPDATE ruian_katastr SET nazev = 'Radvanice u Lipníka nad Bečvou' WHERE kod = 738859;
UPDATE ruian_katastr SET nazev = 'Radvanov u Mladé Vožice' WHERE kod = 738875;
UPDATE ruian_katastr SET nazev = 'Rájec u Zábřeha' WHERE kod = 738883;
UPDATE ruian_katastr SET nazev = 'Jestřebí' WHERE kod = 738891;
UPDATE ruian_katastr SET nazev = 'Rájec nad Svitavou' WHERE kod = 738905;
UPDATE ruian_katastr SET nazev = 'Ráječko' WHERE kod = 738913;
UPDATE ruian_katastr SET nazev = 'Rajhrad' WHERE kod = 738921;
UPDATE ruian_katastr SET nazev = 'Otmarov' WHERE kod = 738948;
UPDATE ruian_katastr SET nazev = 'Rajhradice' WHERE kod = 738956;
UPDATE ruian_katastr SET nazev = 'Rajnochovice' WHERE kod = 739006;
UPDATE ruian_katastr SET nazev = 'Rájov u Mariánských Lázní' WHERE kod = 739031;
UPDATE ruian_katastr SET nazev = 'Rakousy' WHERE kod = 739049;
UPDATE ruian_katastr SET nazev = 'Rakov u Hranic' WHERE kod = 739057;
UPDATE ruian_katastr SET nazev = 'Raková u Rokycan' WHERE kod = 739065;
UPDATE ruian_katastr SET nazev = 'Raková u Konice' WHERE kod = 739073;
UPDATE ruian_katastr SET nazev = 'Rakovník' WHERE kod = 739081;
UPDATE ruian_katastr SET nazev = 'Rakůvka' WHERE kod = 739197;
UPDATE ruian_katastr SET nazev = 'Rakvice' WHERE kod = 739201;
UPDATE ruian_katastr SET nazev = 'Kuřívody' WHERE kod = 739227;
UPDATE ruian_katastr SET nazev = 'Hrádek u Loun' WHERE kod = 739235;
UPDATE ruian_katastr SET nazev = 'Raná u Loun' WHERE kod = 739243;
UPDATE ruian_katastr SET nazev = 'Raná u Hlinska' WHERE kod = 739260;
UPDATE ruian_katastr SET nazev = 'Rancířov' WHERE kod = 739278;
UPDATE ruian_katastr SET nazev = 'Rančířov' WHERE kod = 739286;
UPDATE ruian_katastr SET nazev = 'Rankov u Chotěboře' WHERE kod = 739294;
UPDATE ruian_katastr SET nazev = 'Rantířov' WHERE kod = 739316;
UPDATE ruian_katastr SET nazev = 'Rapotice' WHERE kod = 739324;
UPDATE ruian_katastr SET nazev = 'Rapotín' WHERE kod = 739359;
UPDATE ruian_katastr SET nazev = 'Rapšach' WHERE kod = 739375;
UPDATE ruian_katastr SET nazev = 'Rasošky' WHERE kod = 739413;
UPDATE ruian_katastr SET nazev = 'Raspenava' WHERE kod = 739448;
UPDATE ruian_katastr SET nazev = 'Rašín' WHERE kod = 739456;
UPDATE ruian_katastr SET nazev = 'Raškovice' WHERE kod = 739502;
UPDATE ruian_katastr SET nazev = 'Rašov' WHERE kod = 739511;
UPDATE ruian_katastr SET nazev = 'Mančice u Rašovic' WHERE kod = 739529;
UPDATE ruian_katastr SET nazev = 'Rašovice u Uhlířských Janovic' WHERE kod = 739537;
UPDATE ruian_katastr SET nazev = 'Rašovice u Nymburka' WHERE kod = 739545;
UPDATE ruian_katastr SET nazev = 'Rašovice u Týniště nad Orlicí' WHERE kod = 739553;
UPDATE ruian_katastr SET nazev = 'Rašovice u Bučovic' WHERE kod = 739561;
UPDATE ruian_katastr SET nazev = 'Rataje u Vlašimi' WHERE kod = 739570;
UPDATE ruian_katastr SET nazev = 'Haškovcova Lhota' WHERE kod = 739588;
UPDATE ruian_katastr SET nazev = 'Rataje u Bechyně' WHERE kod = 739600;
UPDATE ruian_katastr SET nazev = 'Popovice u Kroměříže' WHERE kod = 739618;
UPDATE ruian_katastr SET nazev = 'Rataje u Kroměříže' WHERE kod = 739626;
UPDATE ruian_katastr SET nazev = 'Sobělice' WHERE kod = 739634;
UPDATE ruian_katastr SET nazev = 'Rataje u Olomouce' WHERE kod = 739642;
UPDATE ruian_katastr SET nazev = 'Malovidy' WHERE kod = 739651;
UPDATE ruian_katastr SET nazev = 'Mirošovice u Rataj nad Sázavou' WHERE kod = 739669;
UPDATE ruian_katastr SET nazev = 'Rataje nad Sázavou' WHERE kod = 739677;
UPDATE ruian_katastr SET nazev = 'Kbel u Ratboře' WHERE kod = 739685;
UPDATE ruian_katastr SET nazev = 'Pašinka' WHERE kod = 739707;
UPDATE ruian_katastr SET nazev = 'Ratboř' WHERE kod = 739715;
UPDATE ruian_katastr SET nazev = 'Sedlov' WHERE kod = 739723;
UPDATE ruian_katastr SET nazev = 'Ratenice' WHERE kod = 739740;
UPDATE ruian_katastr SET nazev = 'Ratiboř u Jindřichova Hradce' WHERE kod = 739758;
UPDATE ruian_katastr SET nazev = 'Branišovice u Ratiboře' WHERE kod = 739766;
UPDATE ruian_katastr SET nazev = 'Ratiboř' WHERE kod = 739791;
UPDATE ruian_katastr SET nazev = 'Ratiboř u Vsetína' WHERE kod = 739847;
UPDATE ruian_katastr SET nazev = 'Ratibořice u Tábora' WHERE kod = 739863;
UPDATE ruian_katastr SET nazev = 'Ratibořice na Moravě' WHERE kod = 739871;
UPDATE ruian_katastr SET nazev = 'Ratibořské Hory' WHERE kod = 739880;
UPDATE ruian_katastr SET nazev = 'Ratíškovice' WHERE kod = 739901;
UPDATE ruian_katastr SET nazev = 'Ratměřice' WHERE kod = 739910;
UPDATE ruian_katastr SET nazev = 'Střítež u Kaplice' WHERE kod = 739961;
UPDATE ruian_katastr SET nazev = 'Žďár u Kaplice' WHERE kod = 739979;
UPDATE ruian_katastr SET nazev = 'Razová' WHERE kod = 739987;
UPDATE ruian_katastr SET nazev = 'Ražice' WHERE kod = 739995;
UPDATE ruian_katastr SET nazev = 'Rebešovice' WHERE kod = 740004;
UPDATE ruian_katastr SET nazev = 'Dobrá Voda Lipnická' WHERE kod = 740012;
UPDATE ruian_katastr SET nazev = 'Rejčkov' WHERE kod = 740021;
UPDATE ruian_katastr SET nazev = 'Rejchartice u Šumperka' WHERE kod = 740039;
UPDATE ruian_katastr SET nazev = 'Rejkovice' WHERE kod = 740047;
UPDATE ruian_katastr SET nazev = 'Rejšice' WHERE kod = 740055;
UPDATE ruian_katastr SET nazev = 'Klášterský Mlýn I' WHERE kod = 740063;
UPDATE ruian_katastr SET nazev = 'Kozí Hřbet' WHERE kod = 740071;
UPDATE ruian_katastr SET nazev = 'Radešov u Rejštejna' WHERE kod = 740080;
UPDATE ruian_katastr SET nazev = 'Rejštejn' WHERE kod = 740098;
UPDATE ruian_katastr SET nazev = 'Svojše' WHERE kod = 740101;
UPDATE ruian_katastr SET nazev = 'Velký Radkov I' WHERE kod = 740110;
UPDATE ruian_katastr SET nazev = 'Zhůří u Rejštejna' WHERE kod = 740128;
UPDATE ruian_katastr SET nazev = 'Dětřichov' WHERE kod = 740136;
UPDATE ruian_katastr SET nazev = 'Renoty' WHERE kod = 740144;
UPDATE ruian_katastr SET nazev = 'Kordula' WHERE kod = 740152;
UPDATE ruian_katastr SET nazev = 'Rešice' WHERE kod = 740161;
UPDATE ruian_katastr SET nazev = 'Rešov' WHERE kod = 740179;
UPDATE ruian_katastr SET nazev = 'Roblín' WHERE kod = 740195;
UPDATE ruian_katastr SET nazev = 'Moravčice' WHERE kod = 740217;
UPDATE ruian_katastr SET nazev = 'Robousy' WHERE kod = 740225;
UPDATE ruian_katastr SET nazev = 'Břínkov' WHERE kod = 740233;
UPDATE ruian_katastr SET nazev = 'Dolní Ročov' WHERE kod = 740241;
UPDATE ruian_katastr SET nazev = 'Horní Ročov' WHERE kod = 740250;
UPDATE ruian_katastr SET nazev = 'Úlovice' WHERE kod = 740268;
UPDATE ruian_katastr SET nazev = 'Rodinov' WHERE kod = 740276;
UPDATE ruian_katastr SET nazev = 'Nahořany u Mladé Vožice' WHERE kod = 740284;
UPDATE ruian_katastr SET nazev = 'Rodná' WHERE kod = 740292;
UPDATE ruian_katastr SET nazev = 'Rodov' WHERE kod = 740306;
UPDATE ruian_katastr SET nazev = 'Horní Skrýchov' WHERE kod = 740322;
UPDATE ruian_katastr SET nazev = 'Jindřiš' WHERE kod = 740331;
UPDATE ruian_katastr SET nazev = 'Rodvínov' WHERE kod = 740349;
UPDATE ruian_katastr SET nazev = 'Rohanov' WHERE kod = 740357;
UPDATE ruian_katastr SET nazev = 'Oleško u Rohatců' WHERE kod = 740365;
UPDATE ruian_katastr SET nazev = 'Rohatce' WHERE kod = 740373;
UPDATE ruian_katastr SET nazev = 'Rohatec' WHERE kod = 740381;
UPDATE ruian_katastr SET nazev = 'Rohatsko' WHERE kod = 740411;
UPDATE ruian_katastr SET nazev = 'Rohle' WHERE kod = 740420;
UPDATE ruian_katastr SET nazev = 'Rohov' WHERE kod = 740438;
UPDATE ruian_katastr SET nazev = 'Rohovládova Bělá' WHERE kod = 740446;
UPDATE ruian_katastr SET nazev = 'Rohozec u Tišnova' WHERE kod = 740454;
UPDATE ruian_katastr SET nazev = 'Rohozná u Poličky' WHERE kod = 740471;
UPDATE ruian_katastr SET nazev = 'Rohozná u Jihlavy' WHERE kod = 740497;
UPDATE ruian_katastr SET nazev = 'Rohoznice u Hořic' WHERE kod = 740501;
UPDATE ruian_katastr SET nazev = 'Rohoznice' WHERE kod = 740527;
UPDATE ruian_katastr SET nazev = 'Rohy' WHERE kod = 740535;
UPDATE ruian_katastr SET nazev = 'Kbelany' WHERE kod = 740543;
UPDATE ruian_katastr SET nazev = 'Rochlov' WHERE kod = 740551;
UPDATE ruian_katastr SET nazev = 'Rochov' WHERE kod = 740560;
UPDATE ruian_katastr SET nazev = 'Rojetín' WHERE kod = 740578;
UPDATE ruian_katastr SET nazev = 'Láz u Radomyšle' WHERE kod = 740586;
UPDATE ruian_katastr SET nazev = 'Rojice' WHERE kod = 740594;
UPDATE ruian_katastr SET nazev = 'Janské Údolí' WHERE kod = 740608;
UPDATE ruian_katastr SET nazev = 'Rojšín' WHERE kod = 740624;
UPDATE ruian_katastr SET nazev = 'Rokle' WHERE kod = 740675;
UPDATE ruian_katastr SET nazev = 'Rokycany' WHERE kod = 740691;
UPDATE ruian_katastr SET nazev = 'Borek u Rokycan' WHERE kod = 740829;
UPDATE ruian_katastr SET nazev = 'Dolní Rokytá' WHERE kod = 740845;
UPDATE ruian_katastr SET nazev = 'Horní Rokytá' WHERE kod = 740853;
UPDATE ruian_katastr SET nazev = 'Dolní Rokytňany' WHERE kod = 740861;
UPDATE ruian_katastr SET nazev = 'Horní Rokytňany' WHERE kod = 740870;
UPDATE ruian_katastr SET nazev = 'Rokytnice u Slavičína' WHERE kod = 740888;
UPDATE ruian_katastr SET nazev = 'Rokytnice u Přerova' WHERE kod = 740896;
UPDATE ruian_katastr SET nazev = 'Dolní Rokytnice' WHERE kod = 740900;
UPDATE ruian_katastr SET nazev = 'Františkov v Krkonoších' WHERE kod = 740918;
UPDATE ruian_katastr SET nazev = 'Horní Rokytnice nad Jizerou' WHERE kod = 740934;
UPDATE ruian_katastr SET nazev = 'Rokytno v Krkonoších' WHERE kod = 740969;
UPDATE ruian_katastr SET nazev = 'Rokytnice nad Rokytnou' WHERE kod = 740993;
UPDATE ruian_katastr SET nazev = 'Dolní Rokytnice v Orlických horách' WHERE kod = 741001;
UPDATE ruian_katastr SET nazev = 'Horní Rokytnice' WHERE kod = 741027;
UPDATE ruian_katastr SET nazev = 'Panské Pole' WHERE kod = 741035;
UPDATE ruian_katastr SET nazev = 'Prostřední Rokytnice' WHERE kod = 741043;
UPDATE ruian_katastr SET nazev = 'Rokytnice v Orlických horách' WHERE kod = 741051;
UPDATE ruian_katastr SET nazev = 'Rokytno' WHERE kod = 741078;
UPDATE ruian_katastr SET nazev = 'Rokytno na Moravě' WHERE kod = 741086;
UPDATE ruian_katastr SET nazev = 'Studnice u Rokytna' WHERE kod = 741094;
UPDATE ruian_katastr SET nazev = 'Vlachovice u Rokytna' WHERE kod = 741108;
UPDATE ruian_katastr SET nazev = 'Rokytovec' WHERE kod = 741124;
UPDATE ruian_katastr SET nazev = 'Biskupice u Ronova nad Doubravou' WHERE kod = 741132;
UPDATE ruian_katastr SET nazev = 'Ronov nad Doubravou' WHERE kod = 741141;
UPDATE ruian_katastr SET nazev = 'Ropice' WHERE kod = 741167;
UPDATE ruian_katastr SET nazev = 'Roprachtice' WHERE kod = 741175;
UPDATE ruian_katastr SET nazev = 'Roseč' WHERE kod = 741183;
UPDATE ruian_katastr SET nazev = 'Rosice u Chrasti' WHERE kod = 741191;
UPDATE ruian_katastr SET nazev = 'Rosice nad Labem' WHERE kod = 741205;
UPDATE ruian_katastr SET nazev = 'Rosice u Brna' WHERE kod = 741221;
UPDATE ruian_katastr SET nazev = 'Rosička u Deštné' WHERE kod = 741353;
UPDATE ruian_katastr SET nazev = 'Rosovice' WHERE kod = 741370;
UPDATE ruian_katastr SET nazev = 'Rostěnice' WHERE kod = 741396;
UPDATE ruian_katastr SET nazev = 'Zvonovice' WHERE kod = 741400;
UPDATE ruian_katastr SET nazev = 'Rostkov' WHERE kod = 741426;
UPDATE ruian_katastr SET nazev = 'Nová Ves II' WHERE kod = 741434;
UPDATE ruian_katastr SET nazev = 'Rostoklaty' WHERE kod = 741442;
UPDATE ruian_katastr SET nazev = 'Karlov u Roškopova' WHERE kod = 741451;
UPDATE ruian_katastr SET nazev = 'Roškopov' WHERE kod = 741469;
UPDATE ruian_katastr SET nazev = 'Ústí u Staré Paky' WHERE kod = 741477;
UPDATE ruian_katastr SET nazev = 'Roštění' WHERE kod = 741485;
UPDATE ruian_katastr SET nazev = 'Roštín' WHERE kod = 741507;
UPDATE ruian_katastr SET nazev = 'Rotava' WHERE kod = 741531;
UPDATE ruian_katastr SET nazev = 'Smolná' WHERE kod = 741558;
UPDATE ruian_katastr SET nazev = 'Roučkovice' WHERE kod = 741574;
UPDATE ruian_katastr SET nazev = 'Roudná nad Lužnicí' WHERE kod = 741591;
UPDATE ruian_katastr SET nazev = 'Roudné' WHERE kod = 741612;
UPDATE ruian_katastr SET nazev = 'Vidov' WHERE kod = 741621;
UPDATE ruian_katastr SET nazev = 'Roudnice' WHERE kod = 741639;
UPDATE ruian_katastr SET nazev = 'Roudnice nad Labem' WHERE kod = 741647;
UPDATE ruian_katastr SET nazev = 'Podlusky' WHERE kod = 741779;
UPDATE ruian_katastr SET nazev = 'Kostelec nad Ohří' WHERE kod = 741795;
UPDATE ruian_katastr SET nazev = 'Roudníček' WHERE kod = 741809;
UPDATE ruian_katastr SET nazev = 'Vrbka u Roudníčku' WHERE kod = 741817;
UPDATE ruian_katastr SET nazev = 'Roudnička' WHERE kod = 741825;
UPDATE ruian_katastr SET nazev = 'Roudníky' WHERE kod = 741833;
UPDATE ruian_katastr SET nazev = 'Roudno' WHERE kod = 741841;
UPDATE ruian_katastr SET nazev = 'Rouchovany' WHERE kod = 741868;
UPDATE ruian_katastr SET nazev = 'Šemíkovice' WHERE kod = 741876;
UPDATE ruian_katastr SET nazev = 'Bolkov u Roupova' WHERE kod = 741884;
UPDATE ruian_katastr SET nazev = 'Roupov' WHERE kod = 741892;
UPDATE ruian_katastr SET nazev = 'Rousínov u Rakovníka' WHERE kod = 741914;
UPDATE ruian_katastr SET nazev = 'Rousínov u Vyškova' WHERE kod = 741922;
UPDATE ruian_katastr SET nazev = 'Rouské' WHERE kod = 741957;
UPDATE ruian_katastr SET nazev = 'Rousměrov' WHERE kod = 741973;
UPDATE ruian_katastr SET nazev = 'Malé Tresné' WHERE kod = 741981;
UPDATE ruian_katastr SET nazev = 'Rovečné' WHERE kod = 741990;
UPDATE ruian_katastr SET nazev = 'Velké Tresné' WHERE kod = 742007;
UPDATE ruian_katastr SET nazev = 'Roveň u Sobotky' WHERE kod = 742023;
UPDATE ruian_katastr SET nazev = 'Jahodov' WHERE kod = 742031;
UPDATE ruian_katastr SET nazev = 'Roveň u Rychnova nad Kněžnou' WHERE kod = 742040;
UPDATE ruian_katastr SET nazev = 'Rovensko' WHERE kod = 742058;
UPDATE ruian_katastr SET nazev = 'Křečovice pod Troskami' WHERE kod = 742066;
UPDATE ruian_katastr SET nazev = 'Rovensko pod Troskami' WHERE kod = 742082;
UPDATE ruian_katastr SET nazev = 'Rovina' WHERE kod = 742091;
UPDATE ruian_katastr SET nazev = 'Rohozná u Rovné' WHERE kod = 742104;
UPDATE ruian_katastr SET nazev = 'Rovná u Strakonic' WHERE kod = 742112;
UPDATE ruian_katastr SET nazev = 'Řepice' WHERE kod = 742121;
UPDATE ruian_katastr SET nazev = 'Rovná u Sokolova' WHERE kod = 742147;
UPDATE ruian_katastr SET nazev = 'Bystřina u Rovné' WHERE kod = 742155;
UPDATE ruian_katastr SET nazev = 'Čistá u Rovné' WHERE kod = 742163;
UPDATE ruian_katastr SET nazev = 'Krásná Lípa u Rovné' WHERE kod = 742171;
UPDATE ruian_katastr SET nazev = 'Milíře u Rovné' WHERE kod = 742180;
UPDATE ruian_katastr SET nazev = 'Vranov u Rovné' WHERE kod = 742198;
UPDATE ruian_katastr SET nazev = 'Divišov' WHERE kod = 742201;
UPDATE ruian_katastr SET nazev = 'Rovné' WHERE kod = 742210;
UPDATE ruian_katastr SET nazev = 'Rozběřice' WHERE kod = 742228;
UPDATE ruian_katastr SET nazev = 'Rozdrojovice' WHERE kod = 742236;
UPDATE ruian_katastr SET nazev = 'Rozhovice' WHERE kod = 742244;
UPDATE ruian_katastr SET nazev = 'Bradlné' WHERE kod = 742252;
UPDATE ruian_katastr SET nazev = 'Rozhraní' WHERE kod = 742261;
UPDATE ruian_katastr SET nazev = 'Vilémov u Rozhraní' WHERE kod = 742279;
UPDATE ruian_katastr SET nazev = 'Rozkoš u Jevišovic' WHERE kod = 742287;
UPDATE ruian_katastr SET nazev = 'Rozseč u Třešti' WHERE kod = 742295;
UPDATE ruian_katastr SET nazev = 'Rozseč' WHERE kod = 742309;
UPDATE ruian_katastr SET nazev = 'Rozseč nad Kunštátem' WHERE kod = 742317;
UPDATE ruian_katastr SET nazev = 'Kadešice' WHERE kod = 742325;
UPDATE ruian_katastr SET nazev = 'Rozsedly' WHERE kod = 742333;
UPDATE ruian_katastr SET nazev = 'Šimanov na Šumavě' WHERE kod = 742341;
UPDATE ruian_katastr SET nazev = 'Rozsíčka' WHERE kod = 742368;
UPDATE ruian_katastr SET nazev = 'Ústup' WHERE kod = 742376;
UPDATE ruian_katastr SET nazev = 'Rozsochatec' WHERE kod = 742392;
UPDATE ruian_katastr SET nazev = 'Albrechtice u Rozsoch' WHERE kod = 742406;
UPDATE ruian_katastr SET nazev = 'Blažejovice u Rozsoch' WHERE kod = 742414;
UPDATE ruian_katastr SET nazev = 'Kundratice u Rozsoch' WHERE kod = 742422;
UPDATE ruian_katastr SET nazev = 'Rozsochy' WHERE kod = 742431;
UPDATE ruian_katastr SET nazev = 'Vojetín u Rozsoch' WHERE kod = 742449;
UPDATE ruian_katastr SET nazev = 'Janův Důl' WHERE kod = 742457;
UPDATE ruian_katastr SET nazev = 'Rozstání pod Ještědem' WHERE kod = 742465;
UPDATE ruian_katastr SET nazev = 'Rozstání u Moravské Třebové' WHERE kod = 742473;
UPDATE ruian_katastr SET nazev = 'Rozstání pod Kojálem' WHERE kod = 742490;
UPDATE ruian_katastr SET nazev = 'Roztoky u Prahy' WHERE kod = 742503;
UPDATE ruian_katastr SET nazev = 'Žalov' WHERE kod = 742511;
UPDATE ruian_katastr SET nazev = 'Roztoky u Křivoklátu' WHERE kod = 742554;
UPDATE ruian_katastr SET nazev = 'Roztoky u Jilemnice' WHERE kod = 742562;
UPDATE ruian_katastr SET nazev = 'Roztoky u Semil' WHERE kod = 742589;
UPDATE ruian_katastr SET nazev = 'Svatá Kateřina u Rozvadova' WHERE kod = 742601;
UPDATE ruian_katastr SET nazev = 'Nové Domky' WHERE kod = 742627;
UPDATE ruian_katastr SET nazev = 'Rozvadov' WHERE kod = 742643;
UPDATE ruian_katastr SET nazev = 'Střeble' WHERE kod = 742651;
UPDATE ruian_katastr SET nazev = 'Podlužany' WHERE kod = 742660;
UPDATE ruian_katastr SET nazev = 'Podolí u Rožďalovic' WHERE kod = 742678;
UPDATE ruian_katastr SET nazev = 'Rožďalovice' WHERE kod = 742686;
UPDATE ruian_katastr SET nazev = 'Zámostí u Rožďalovic' WHERE kod = 742694;
UPDATE ruian_katastr SET nazev = 'Roželov' WHERE kod = 742724;
UPDATE ruian_katastr SET nazev = 'Horní Jílovice' WHERE kod = 742732;
UPDATE ruian_katastr SET nazev = 'Rožmberk nad Vltavou' WHERE kod = 742741;
UPDATE ruian_katastr SET nazev = 'Čeřín' WHERE kod = 742759;
UPDATE ruian_katastr SET nazev = 'Hněvanov' WHERE kod = 742767;
UPDATE ruian_katastr SET nazev = 'Rožmitál na Šumavě' WHERE kod = 742805;
UPDATE ruian_katastr SET nazev = 'Koryta u Hněvanova' WHERE kod = 742813;
UPDATE ruian_katastr SET nazev = 'Zahrádka' WHERE kod = 742821;
UPDATE ruian_katastr SET nazev = 'Rožmitál pod Třemšínem' WHERE kod = 742848;
UPDATE ruian_katastr SET nazev = 'Starý Rožmitál' WHERE kod = 742856;
UPDATE ruian_katastr SET nazev = 'Josefov u Rožné' WHERE kod = 742881;
UPDATE ruian_katastr SET nazev = 'Rožná' WHERE kod = 742899;
UPDATE ruian_katastr SET nazev = 'Zlatkov' WHERE kod = 742902;
UPDATE ruian_katastr SET nazev = 'Neznášov' WHERE kod = 742911;
UPDATE ruian_katastr SET nazev = 'Rožnov' WHERE kod = 742929;
UPDATE ruian_katastr SET nazev = 'Rožnov pod Radhoštěm' WHERE kod = 742937;
UPDATE ruian_katastr SET nazev = 'Rpety' WHERE kod = 743062;
UPDATE ruian_katastr SET nazev = 'Rtišovice' WHERE kod = 743071;
UPDATE ruian_katastr SET nazev = 'Malhostice' WHERE kod = 743097;
UPDATE ruian_katastr SET nazev = 'Rtyně nad Bílinou' WHERE kod = 743101;
UPDATE ruian_katastr SET nazev = 'Velvěty' WHERE kod = 743127;
UPDATE ruian_katastr SET nazev = 'Rtyně v Podkrkonoší' WHERE kod = 743143;
UPDATE ruian_katastr SET nazev = 'Ruda u Nového Strašecí' WHERE kod = 743178;
UPDATE ruian_katastr SET nazev = 'Lhotka u Velkého Meziříčí' WHERE kod = 743186;
UPDATE ruian_katastr SET nazev = 'Ruda u Velkého Meziříčí' WHERE kod = 743194;
UPDATE ruian_katastr SET nazev = 'Ruda u Rýmařova' WHERE kod = 743208;
UPDATE ruian_katastr SET nazev = 'Hostice' WHERE kod = 743216;
UPDATE ruian_katastr SET nazev = 'Ruda nad Moravou' WHERE kod = 743224;
UPDATE ruian_katastr SET nazev = 'Rudice u Blanska' WHERE kod = 743232;
UPDATE ruian_katastr SET nazev = 'Rudice' WHERE kod = 743241;
UPDATE ruian_katastr SET nazev = 'Hroznatín' WHERE kod = 743259;
UPDATE ruian_katastr SET nazev = 'Rudíkov' WHERE kod = 743267;
UPDATE ruian_katastr SET nazev = 'Rudimov' WHERE kod = 743275;
UPDATE ruian_katastr SET nazev = 'Rudka u Kunštátu' WHERE kod = 743283;
UPDATE ruian_katastr SET nazev = 'Rudka' WHERE kod = 743291;
UPDATE ruian_katastr SET nazev = 'Rudlice' WHERE kod = 743305;
UPDATE ruian_katastr SET nazev = 'Dušníky u Rudné' WHERE kod = 743313;
UPDATE ruian_katastr SET nazev = 'Hořelice' WHERE kod = 743321;
UPDATE ruian_katastr SET nazev = 'Dolní Rudná' WHERE kod = 743330;
UPDATE ruian_katastr SET nazev = 'Horní Rudná' WHERE kod = 743348;
UPDATE ruian_katastr SET nazev = 'Nová Rudná' WHERE kod = 743356;
UPDATE ruian_katastr SET nazev = 'Podlesí pod Pradědem' WHERE kod = 743364;
UPDATE ruian_katastr SET nazev = 'Stará Rudná' WHERE kod = 743372;
UPDATE ruian_katastr SET nazev = 'Arnultovice' WHERE kod = 743381;
UPDATE ruian_katastr SET nazev = 'Bolkov' WHERE kod = 743399;
UPDATE ruian_katastr SET nazev = 'Rudník' WHERE kod = 743429;
UPDATE ruian_katastr SET nazev = 'Rudolec' WHERE kod = 743453;
UPDATE ruian_katastr SET nazev = 'Jivno' WHERE kod = 743461;
UPDATE ruian_katastr SET nazev = 'Rudolfov u Českých Budějovic' WHERE kod = 743470;
UPDATE ruian_katastr SET nazev = 'Rudoltice u Černíkova' WHERE kod = 743496;
UPDATE ruian_katastr SET nazev = 'Rudoltice u Lanškrouna' WHERE kod = 743500;
UPDATE ruian_katastr SET nazev = 'Rumburk' WHERE kod = 743518;
UPDATE ruian_katastr SET nazev = 'Horní Jindřichov' WHERE kod = 743593;
UPDATE ruian_katastr SET nazev = 'Dolní Křečany' WHERE kod = 743607;
UPDATE ruian_katastr SET nazev = 'Runářov' WHERE kod = 743615;
UPDATE ruian_katastr SET nazev = 'Hynčice u Broumova' WHERE kod = 743623;
UPDATE ruian_katastr SET nazev = 'Ruprechtice u Broumova' WHERE kod = 743631;
UPDATE ruian_katastr SET nazev = 'Ruprechtov' WHERE kod = 743640;
UPDATE ruian_katastr SET nazev = 'Rusava' WHERE kod = 743666;
UPDATE ruian_katastr SET nazev = 'Rusek' WHERE kod = 743674;
UPDATE ruian_katastr SET nazev = 'Rusín' WHERE kod = 743682;
UPDATE ruian_katastr SET nazev = 'Vratkov' WHERE kod = 743691;
UPDATE ruian_katastr SET nazev = 'Rušinov' WHERE kod = 743704;
UPDATE ruian_katastr SET nazev = 'Růžďka' WHERE kod = 743739;
UPDATE ruian_katastr SET nazev = 'Růžená' WHERE kod = 743755;
UPDATE ruian_katastr SET nazev = 'Janov u Hřenska' WHERE kod = 743763;
UPDATE ruian_katastr SET nazev = 'Kamenická Stráň' WHERE kod = 743771;
UPDATE ruian_katastr SET nazev = 'Růžová' WHERE kod = 743780;
UPDATE ruian_katastr SET nazev = 'Rváčov' WHERE kod = 743801;
UPDATE ruian_katastr SET nazev = 'Rybí' WHERE kod = 743828;
UPDATE ruian_katastr SET nazev = 'Černá u Bohdanče' WHERE kod = 743844;
UPDATE ruian_katastr SET nazev = 'Rybitví' WHERE kod = 743852;
UPDATE ruian_katastr SET nazev = 'Rybná nad Zdobnicí' WHERE kod = 743879;
UPDATE ruian_katastr SET nazev = 'Rybné' WHERE kod = 743887;
UPDATE ruian_katastr SET nazev = 'Rybnice u Kaznějova' WHERE kod = 743895;
UPDATE ruian_katastr SET nazev = 'Rybníček u Habrů' WHERE kod = 743909;
UPDATE ruian_katastr SET nazev = 'Rybník nad Radbuzou' WHERE kod = 743917;
UPDATE ruian_katastr SET nazev = 'Závist u Rybníku' WHERE kod = 743925;
UPDATE ruian_katastr SET nazev = 'Švarcava' WHERE kod = 743933;
UPDATE ruian_katastr SET nazev = 'Korytany' WHERE kod = 743941;
UPDATE ruian_katastr SET nazev = 'Mostek u Rybníku' WHERE kod = 743950;
UPDATE ruian_katastr SET nazev = 'Novosedly u Rybníku' WHERE kod = 743968;
UPDATE ruian_katastr SET nazev = 'Velký Horšín' WHERE kod = 743976;
UPDATE ruian_katastr SET nazev = 'Rybník u České Třebové' WHERE kod = 743984;
UPDATE ruian_katastr SET nazev = 'Libice' WHERE kod = 744000;
UPDATE ruian_katastr SET nazev = 'Rybníky' WHERE kod = 744018;
UPDATE ruian_katastr SET nazev = 'Rybníky na Moravě' WHERE kod = 744026;
UPDATE ruian_katastr SET nazev = 'Nová Chřibská' WHERE kod = 744034;
UPDATE ruian_katastr SET nazev = 'Rybniště' WHERE kod = 744042;
UPDATE ruian_katastr SET nazev = 'Rýdeč' WHERE kod = 744051;
UPDATE ruian_katastr SET nazev = 'Řetouň' WHERE kod = 744069;
UPDATE ruian_katastr SET nazev = 'Rýdrovice' WHERE kod = 744077;
UPDATE ruian_katastr SET nazev = 'Rychnov' WHERE kod = 744085;
UPDATE ruian_katastr SET nazev = 'Rychnov na Moravě' WHERE kod = 744093;
UPDATE ruian_katastr SET nazev = 'Rychnov nad Kněžnou' WHERE kod = 744107;
UPDATE ruian_katastr SET nazev = 'Panská Habrová' WHERE kod = 744191;
UPDATE ruian_katastr SET nazev = 'Mladoňov' WHERE kod = 744204;
UPDATE ruian_katastr SET nazev = 'Rychnov nad Malší' WHERE kod = 744212;
UPDATE ruian_katastr SET nazev = 'Tichá' WHERE kod = 744221;
UPDATE ruian_katastr SET nazev = 'Všeměřice' WHERE kod = 744247;
UPDATE ruian_katastr SET nazev = 'Cetviny' WHERE kod = 744255;
UPDATE ruian_katastr SET nazev = 'Mikulov' WHERE kod = 744263;
UPDATE ruian_katastr SET nazev = 'Štědrkov' WHERE kod = 744271;
UPDATE ruian_katastr SET nazev = 'Pelíkovice' WHERE kod = 744310;
UPDATE ruian_katastr SET nazev = 'Pulečný' WHERE kod = 744328;
UPDATE ruian_katastr SET nazev = 'Rychnov u Jablonce nad Nisou' WHERE kod = 744344;
UPDATE ruian_katastr SET nazev = 'Konratice' WHERE kod = 744352;
UPDATE ruian_katastr SET nazev = 'Rychnov u Nových Hradů' WHERE kod = 744361;
UPDATE ruian_katastr SET nazev = 'Doubravice u České Skalice' WHERE kod = 744379;
UPDATE ruian_katastr SET nazev = 'Rychnovek' WHERE kod = 744387;
UPDATE ruian_katastr SET nazev = 'Zvole' WHERE kod = 744395;
UPDATE ruian_katastr SET nazev = 'Lhota' WHERE kod = 744409;
UPDATE ruian_katastr SET nazev = 'Rychtářov' WHERE kod = 744425;
UPDATE ruian_katastr SET nazev = 'Rychvald' WHERE kod = 744441;
UPDATE ruian_katastr SET nazev = 'Ryjice' WHERE kod = 744450;
UPDATE ruian_katastr SET nazev = 'Rýmařov' WHERE kod = 744468;
UPDATE ruian_katastr SET nazev = 'Edrovice' WHERE kod = 744573;
UPDATE ruian_katastr SET nazev = 'Janovice u Rýmařova' WHERE kod = 744581;
UPDATE ruian_katastr SET nazev = 'Janušov' WHERE kod = 744590;
UPDATE ruian_katastr SET nazev = 'Jamartice' WHERE kod = 744603;
UPDATE ruian_katastr SET nazev = 'Ondřejov u Rýmařova' WHERE kod = 744611;
UPDATE ruian_katastr SET nazev = 'Stránské' WHERE kod = 744620;
UPDATE ruian_katastr SET nazev = 'Rymice' WHERE kod = 744638;
UPDATE ruian_katastr SET nazev = 'Rynárec' WHERE kod = 744646;
UPDATE ruian_katastr SET nazev = 'Vokov u Rynárce' WHERE kod = 744654;
UPDATE ruian_katastr SET nazev = 'Rynholec' WHERE kod = 744671;
UPDATE ruian_katastr SET nazev = 'Jítrava' WHERE kod = 744689;
UPDATE ruian_katastr SET nazev = 'Polesí u Rynoltic' WHERE kod = 744701;
UPDATE ruian_katastr SET nazev = 'Rynoltice' WHERE kod = 744719;
UPDATE ruian_katastr SET nazev = 'Hážovice' WHERE kod = 744727;
UPDATE ruian_katastr SET nazev = 'Tylovice' WHERE kod = 744743;
UPDATE ruian_katastr SET nazev = 'Ryžoviště' WHERE kod = 744751;
UPDATE ruian_katastr SET nazev = 'Řásná' WHERE kod = 744760;
UPDATE ruian_katastr SET nazev = 'Labětín' WHERE kod = 744778;
UPDATE ruian_katastr SET nazev = 'Řečany nad Labem' WHERE kod = 744786;
UPDATE ruian_katastr SET nazev = 'Trnávka' WHERE kod = 744794;
UPDATE ruian_katastr SET nazev = 'Řečice' WHERE kod = 744816;
UPDATE ruian_katastr SET nazev = 'Řečice u Humpolce' WHERE kod = 744859;
UPDATE ruian_katastr SET nazev = 'Křepiny' WHERE kod = 744867;
UPDATE ruian_katastr SET nazev = 'Řečice nad Bobrůvkou' WHERE kod = 744883;
UPDATE ruian_katastr SET nazev = 'Ředhošť' WHERE kod = 744905;
UPDATE ruian_katastr SET nazev = 'Ředice' WHERE kod = 744913;
UPDATE ruian_katastr SET nazev = 'Babice u Řehenic' WHERE kod = 744930;
UPDATE ruian_katastr SET nazev = 'Čakovice u Řehenic' WHERE kod = 744956;
UPDATE ruian_katastr SET nazev = 'Malešín' WHERE kod = 744972;
UPDATE ruian_katastr SET nazev = 'Řehlovice' WHERE kod = 745031;
UPDATE ruian_katastr SET nazev = 'Řehořov' WHERE kod = 745049;
UPDATE ruian_katastr SET nazev = 'Řeka' WHERE kod = 745057;
UPDATE ruian_katastr SET nazev = 'Řemíčov' WHERE kod = 745073;
UPDATE ruian_katastr SET nazev = 'Libákovice' WHERE kod = 745081;
UPDATE ruian_katastr SET nazev = 'Plevňov' WHERE kod = 745090;
UPDATE ruian_katastr SET nazev = 'Řenče' WHERE kod = 745103;
UPDATE ruian_katastr SET nazev = 'Řendějov' WHERE kod = 745120;
UPDATE ruian_katastr SET nazev = 'Oltyně' WHERE kod = 745154;
UPDATE ruian_katastr SET nazev = 'Řepeč' WHERE kod = 745162;
UPDATE ruian_katastr SET nazev = 'Řepín' WHERE kod = 745171;
UPDATE ruian_katastr SET nazev = 'Řepiště' WHERE kod = 745197;
UPDATE ruian_katastr SET nazev = 'Pěšice' WHERE kod = 745219;
UPDATE ruian_katastr SET nazev = 'Popovec u Řepníků' WHERE kod = 745227;
UPDATE ruian_katastr SET nazev = 'Řepníky' WHERE kod = 745235;
UPDATE ruian_katastr SET nazev = 'Řeporyje' WHERE kod = 745251;
UPDATE ruian_katastr SET nazev = 'Zadní Kopanina' WHERE kod = 745278;
UPDATE ruian_katastr SET nazev = 'Řepov' WHERE kod = 745286;
UPDATE ruian_katastr SET nazev = 'Řepová' WHERE kod = 745294;
UPDATE ruian_katastr SET nazev = 'Řeřichy' WHERE kod = 745316;
UPDATE ruian_katastr SET nazev = 'Řestoky' WHERE kod = 745324;
UPDATE ruian_katastr SET nazev = 'Řetechov' WHERE kod = 745341;
UPDATE ruian_katastr SET nazev = 'Řetová' WHERE kod = 745359;
UPDATE ruian_katastr SET nazev = 'Řetůvka' WHERE kod = 745367;
UPDATE ruian_katastr SET nazev = 'Řevnice' WHERE kod = 745375;
UPDATE ruian_katastr SET nazev = 'Řevničov' WHERE kod = 745383;
UPDATE ruian_katastr SET nazev = 'Řevnov' WHERE kod = 745413;
UPDATE ruian_katastr SET nazev = 'Řeznovice' WHERE kod = 745421;
UPDATE ruian_katastr SET nazev = 'Řeženčice' WHERE kod = 745430;
UPDATE ruian_katastr SET nazev = 'Řícmanice' WHERE kod = 745448;
UPDATE ruian_katastr SET nazev = 'Říčany u Prahy' WHERE kod = 745456;
UPDATE ruian_katastr SET nazev = 'Říčany-Radošovice' WHERE kod = 745511;
UPDATE ruian_katastr SET nazev = 'Voděrádky' WHERE kod = 745529;
UPDATE ruian_katastr SET nazev = 'Jažlovice' WHERE kod = 745537;
UPDATE ruian_katastr SET nazev = 'Říčany u Brna' WHERE kod = 745545;
UPDATE ruian_katastr SET nazev = 'Říčky v Orlických horách' WHERE kod = 745553;
UPDATE ruian_katastr SET nazev = 'Řídelov' WHERE kod = 745561;
UPDATE ruian_katastr SET nazev = 'Řikonín' WHERE kod = 745570;
UPDATE ruian_katastr SET nazev = 'Říkovice u Přerova' WHERE kod = 745588;
UPDATE ruian_katastr SET nazev = 'Červená Lhota u Řimic' WHERE kod = 745596;
UPDATE ruian_katastr SET nazev = 'Měník' WHERE kod = 745600;
UPDATE ruian_katastr SET nazev = 'Řimice' WHERE kod = 745626;
UPDATE ruian_katastr SET nazev = 'Branišovice u Římova' WHERE kod = 745642;
UPDATE ruian_katastr SET nazev = 'Dolní Stropnice' WHERE kod = 745651;
UPDATE ruian_katastr SET nazev = 'Mokrý Lom' WHERE kod = 745707;
UPDATE ruian_katastr SET nazev = 'Římov' WHERE kod = 745723;
UPDATE ruian_katastr SET nazev = 'Římov na Moravě' WHERE kod = 745731;
UPDATE ruian_katastr SET nazev = 'Řimovice' WHERE kod = 745758;
UPDATE ruian_katastr SET nazev = 'Řípec' WHERE kod = 745766;
UPDATE ruian_katastr SET nazev = 'Řisuty u Slaného' WHERE kod = 745782;
UPDATE ruian_katastr SET nazev = 'Řiště' WHERE kod = 745791;
UPDATE ruian_katastr SET nazev = 'Řitka' WHERE kod = 745804;
UPDATE ruian_katastr SET nazev = 'Řitonice' WHERE kod = 745812;
UPDATE ruian_katastr SET nazev = 'Skyšice' WHERE kod = 745821;
UPDATE ruian_katastr SET nazev = 'Sádek' WHERE kod = 745839;
UPDATE ruian_katastr SET nazev = 'Sádek u Poličky' WHERE kod = 745847;
UPDATE ruian_katastr SET nazev = 'Sádek u Opavy' WHERE kod = 745863;
UPDATE ruian_katastr SET nazev = 'Lesov' WHERE kod = 745880;
UPDATE ruian_katastr SET nazev = 'Podlesí u Sadova' WHERE kod = 745898;
UPDATE ruian_katastr SET nazev = 'Sadov' WHERE kod = 745901;
UPDATE ruian_katastr SET nazev = 'Sadská' WHERE kod = 745928;
UPDATE ruian_katastr SET nazev = 'Salačova Lhota' WHERE kod = 745936;
UPDATE ruian_katastr SET nazev = 'Salaš u Zlína' WHERE kod = 745952;
UPDATE ruian_katastr SET nazev = 'Salaš u Velehradu' WHERE kod = 745961;
UPDATE ruian_katastr SET nazev = 'Salavice' WHERE kod = 745979;
UPDATE ruian_katastr SET nazev = 'Samopše' WHERE kod = 746002;
UPDATE ruian_katastr SET nazev = 'Talmberk' WHERE kod = 746011;
UPDATE ruian_katastr SET nazev = 'Samosoly' WHERE kod = 746029;
UPDATE ruian_katastr SET nazev = 'Samotíšky' WHERE kod = 746037;
UPDATE ruian_katastr SET nazev = 'Samšín' WHERE kod = 746045;
UPDATE ruian_katastr SET nazev = 'Drštěkryje' WHERE kod = 746070;
UPDATE ruian_katastr SET nazev = 'Ohařice' WHERE kod = 746096;
UPDATE ruian_katastr SET nazev = 'Samšina' WHERE kod = 746100;
UPDATE ruian_katastr SET nazev = 'Zámostí' WHERE kod = 746118;
UPDATE ruian_katastr SET nazev = 'Sány' WHERE kod = 746126;
UPDATE ruian_katastr SET nazev = 'Satalice' WHERE kod = 746134;
UPDATE ruian_katastr SET nazev = 'Savín' WHERE kod = 746142;
UPDATE ruian_katastr SET nazev = 'Bělokozly' WHERE kod = 746151;
UPDATE ruian_katastr SET nazev = 'Černé Budy' WHERE kod = 746169;
UPDATE ruian_katastr SET nazev = 'Čeřenice' WHERE kod = 746177;
UPDATE ruian_katastr SET nazev = 'Dojetřice' WHERE kod = 746185;
UPDATE ruian_katastr SET nazev = 'Sázava' WHERE kod = 746193;
UPDATE ruian_katastr SET nazev = 'Sázava pod Křemešníkem' WHERE kod = 746215;
UPDATE ruian_katastr SET nazev = 'Sázava u Lanškrouna' WHERE kod = 746223;
UPDATE ruian_katastr SET nazev = 'Česká Mez' WHERE kod = 746231;
UPDATE ruian_katastr SET nazev = 'Rosička' WHERE kod = 746258;
UPDATE ruian_katastr SET nazev = 'Sázava u Žďáru nad Sázavou' WHERE kod = 746266;
UPDATE ruian_katastr SET nazev = 'Kunemil' WHERE kod = 746274;
UPDATE ruian_katastr SET nazev = 'Sázavka' WHERE kod = 746282;
UPDATE ruian_katastr SET nazev = 'Sazená' WHERE kod = 746291;
UPDATE ruian_katastr SET nazev = 'Sazovice' WHERE kod = 746304;
UPDATE ruian_katastr SET nazev = 'Hrobičany' WHERE kod = 746312;
UPDATE ruian_katastr SET nazev = 'Sběř' WHERE kod = 746321;
UPDATE ruian_katastr SET nazev = 'Velešice' WHERE kod = 746339;
UPDATE ruian_katastr SET nazev = 'Biskoupky' WHERE kod = 746347;
UPDATE ruian_katastr SET nazev = 'Sebečice' WHERE kod = 746355;
UPDATE ruian_katastr SET nazev = 'Kaliště u Sebranic' WHERE kod = 746363;
UPDATE ruian_katastr SET nazev = 'Pohora' WHERE kod = 746371;
UPDATE ruian_katastr SET nazev = 'Sebranice u Litomyšle' WHERE kod = 746380;
UPDATE ruian_katastr SET nazev = 'Sebranice u Boskovic' WHERE kod = 746401;
UPDATE ruian_katastr SET nazev = 'Církvice' WHERE kod = 746410;
UPDATE ruian_katastr SET nazev = 'Sebuzín' WHERE kod = 746428;
UPDATE ruian_katastr SET nazev = 'Seč u Blovic' WHERE kod = 746436;
UPDATE ruian_katastr SET nazev = 'Proseč u Seče' WHERE kod = 746444;
UPDATE ruian_katastr SET nazev = 'Prosíčka u Seče' WHERE kod = 746452;
UPDATE ruian_katastr SET nazev = 'Seč' WHERE kod = 746461;
UPDATE ruian_katastr SET nazev = 'Seč u Brandýsa nad Orlicí' WHERE kod = 746487;
UPDATE ruian_katastr SET nazev = 'Sedčice' WHERE kod = 746495;
UPDATE ruian_katastr SET nazev = 'Žabokliky' WHERE kod = 746509;
UPDATE ruian_katastr SET nazev = 'Sedlatice' WHERE kod = 746517;
UPDATE ruian_katastr SET nazev = 'Sedlčany' WHERE kod = 746533;
UPDATE ruian_katastr SET nazev = 'Sestrouň' WHERE kod = 746568;
UPDATE ruian_katastr SET nazev = 'Sedlec u Mšena' WHERE kod = 746657;
UPDATE ruian_katastr SET nazev = 'Sedlec u Benátek nad Jizerou' WHERE kod = 746665;
UPDATE ruian_katastr SET nazev = 'Sedlec u Líbeznic' WHERE kod = 746673;
UPDATE ruian_katastr SET nazev = 'Hlavatce u Českých Budějovic' WHERE kod = 746681;
UPDATE ruian_katastr SET nazev = 'Lékařova Lhota' WHERE kod = 746690;
UPDATE ruian_katastr SET nazev = 'Malé Chrášťany' WHERE kod = 746703;
UPDATE ruian_katastr SET nazev = 'Plástovice' WHERE kod = 746711;
UPDATE ruian_katastr SET nazev = 'Sedlec u Českých Budějovic' WHERE kod = 746720;
UPDATE ruian_katastr SET nazev = 'Vlhlavy' WHERE kod = 746738;
UPDATE ruian_katastr SET nazev = 'Čankov' WHERE kod = 746746;
UPDATE ruian_katastr SET nazev = 'Sedlec u Karlových Var' WHERE kod = 746754;
UPDATE ruian_katastr SET nazev = 'Sedlec u Kralovic' WHERE kod = 746762;
UPDATE ruian_katastr SET nazev = 'Sedlec u Libochovic' WHERE kod = 746771;
UPDATE ruian_katastr SET nazev = 'Sedlec u Mikulova' WHERE kod = 746789;
UPDATE ruian_katastr SET nazev = 'Sedlec u Náměště nad Oslavou' WHERE kod = 746801;
UPDATE ruian_katastr SET nazev = 'Prčice' WHERE kod = 746819;
UPDATE ruian_katastr SET nazev = 'Sedlec u Votic' WHERE kod = 746827;
UPDATE ruian_katastr SET nazev = 'Sedlejov' WHERE kod = 746835;
UPDATE ruian_katastr SET nazev = 'Jilem u Sedletína' WHERE kod = 746843;
UPDATE ruian_katastr SET nazev = 'Sedletín' WHERE kod = 746851;
UPDATE ruian_katastr SET nazev = 'Veselá u Sedletína' WHERE kod = 746860;
UPDATE ruian_katastr SET nazev = 'Sedlice u Želivi' WHERE kod = 746878;
UPDATE ruian_katastr SET nazev = 'Němčice u Sedlice' WHERE kod = 746886;
UPDATE ruian_katastr SET nazev = 'Sedlice u Blatné' WHERE kod = 746894;
UPDATE ruian_katastr SET nazev = 'Sedlice u Domažlic' WHERE kod = 746908;
UPDATE ruian_katastr SET nazev = 'Krásnice' WHERE kod = 746916;
UPDATE ruian_katastr SET nazev = 'Sedlice u Hradce Králové' WHERE kod = 746924;
UPDATE ruian_katastr SET nazev = 'Sedliště u Litomyšle' WHERE kod = 746941;
UPDATE ruian_katastr SET nazev = 'Sedliště ve Slezsku' WHERE kod = 746983;
UPDATE ruian_katastr SET nazev = 'Sedlnice' WHERE kod = 747009;
UPDATE ruian_katastr SET nazev = 'Bílá u Sedla' WHERE kod = 747017;
UPDATE ruian_katastr SET nazev = 'Lhota u Sedla' WHERE kod = 747025;
UPDATE ruian_katastr SET nazev = 'Sedlo u Číměře' WHERE kod = 747033;
UPDATE ruian_katastr SET nazev = 'Sedlo u Horažďovic' WHERE kod = 747041;
UPDATE ruian_katastr SET nazev = 'Střelskohoštická Lhota' WHERE kod = 747050;
UPDATE ruian_katastr SET nazev = 'Polom v Orlických horách' WHERE kod = 747076;
UPDATE ruian_katastr SET nazev = 'Sedloňov' WHERE kod = 747084;
UPDATE ruian_katastr SET nazev = 'Sedmpány' WHERE kod = 747092;
UPDATE ruian_katastr SET nazev = 'Sehradice' WHERE kod = 747106;
UPDATE ruian_katastr SET nazev = 'Bor u Nedvědice' WHERE kod = 747114;
UPDATE ruian_katastr SET nazev = 'Sejřek' WHERE kod = 747131;
UPDATE ruian_katastr SET nazev = 'Selmice' WHERE kod = 747149;
UPDATE ruian_katastr SET nazev = 'Semanín' WHERE kod = 747157;
UPDATE ruian_katastr SET nazev = 'Semčice' WHERE kod = 747165;
UPDATE ruian_katastr SET nazev = 'Semechnice' WHERE kod = 747181;
UPDATE ruian_katastr SET nazev = 'Rvenice' WHERE kod = 747190;
UPDATE ruian_katastr SET nazev = 'Seménkovice' WHERE kod = 747203;
UPDATE ruian_katastr SET nazev = 'Semice nad Labem' WHERE kod = 747211;
UPDATE ruian_katastr SET nazev = 'Nový Dvůr u Písku' WHERE kod = 747220;
UPDATE ruian_katastr SET nazev = 'Semice u Písku' WHERE kod = 747238;
UPDATE ruian_katastr SET nazev = 'Semily' WHERE kod = 747246;
UPDATE ruian_katastr SET nazev = 'Bítouchov u Semil' WHERE kod = 747271;
UPDATE ruian_katastr SET nazev = 'Spálov u Semil' WHERE kod = 747289;
UPDATE ruian_katastr SET nazev = 'Semín' WHERE kod = 747319;
UPDATE ruian_katastr SET nazev = 'Borovice u Horšovského Týna' WHERE kod = 747327;
UPDATE ruian_katastr SET nazev = 'Křakov' WHERE kod = 747335;
UPDATE ruian_katastr SET nazev = 'Semněvice' WHERE kod = 747343;
UPDATE ruian_katastr SET nazev = 'Věvrov' WHERE kod = 747351;
UPDATE ruian_katastr SET nazev = 'Semonice' WHERE kod = 747360;
UPDATE ruian_katastr SET nazev = 'Semtín' WHERE kod = 747386;
UPDATE ruian_katastr SET nazev = 'Sendražice u Kolína' WHERE kod = 747394;
UPDATE ruian_katastr SET nazev = 'Sendražice u Smiřic' WHERE kod = 747408;
UPDATE ruian_katastr SET nazev = 'Senec u Rakovníka' WHERE kod = 747416;
UPDATE ruian_katastr SET nazev = 'Senešnice' WHERE kod = 747424;
UPDATE ruian_katastr SET nazev = 'Senetářov' WHERE kod = 747432;
UPDATE ruian_katastr SET nazev = 'Senice' WHERE kod = 747441;
UPDATE ruian_katastr SET nazev = 'Senice na Hané' WHERE kod = 747459;
UPDATE ruian_katastr SET nazev = 'Odrlice' WHERE kod = 747467;
UPDATE ruian_katastr SET nazev = 'Senička' WHERE kod = 747475;
UPDATE ruian_katastr SET nazev = 'Seninka' WHERE kod = 747483;
UPDATE ruian_katastr SET nazev = 'Pětihosty' WHERE kod = 747491;
UPDATE ruian_katastr SET nazev = 'Senohraby' WHERE kod = 747505;
UPDATE ruian_katastr SET nazev = 'Nouzov u Senomat' WHERE kod = 747513;
UPDATE ruian_katastr SET nazev = 'Senomaty' WHERE kod = 747521;
UPDATE ruian_katastr SET nazev = 'Senorady' WHERE kod = 747530;
UPDATE ruian_katastr SET nazev = 'Nečice' WHERE kod = 747548;
UPDATE ruian_katastr SET nazev = 'Senožaty' WHERE kod = 747564;
UPDATE ruian_katastr SET nazev = 'Syrov' WHERE kod = 747572;
UPDATE ruian_katastr SET nazev = 'Sentice' WHERE kod = 747581;
UPDATE ruian_katastr SET nazev = 'Líšnice u Sepekova' WHERE kod = 747599;
UPDATE ruian_katastr SET nazev = 'Sepekov' WHERE kod = 747602;
UPDATE ruian_katastr SET nazev = 'Zálší u Sepekova' WHERE kod = 747611;
UPDATE ruian_katastr SET nazev = 'Setěchovice' WHERE kod = 747637;
UPDATE ruian_katastr SET nazev = 'Sezemice' WHERE kod = 747645;
UPDATE ruian_katastr SET nazev = 'Počaply nad Loučnou' WHERE kod = 747661;
UPDATE ruian_katastr SET nazev = 'Sezemice nad Loučnou' WHERE kod = 747670;
UPDATE ruian_katastr SET nazev = 'Sezimovo Ústí' WHERE kod = 747688;
UPDATE ruian_katastr SET nazev = 'Květnice' WHERE kod = 747751;
UPDATE ruian_katastr SET nazev = 'Sibřina' WHERE kod = 747769;
UPDATE ruian_katastr SET nazev = 'Stupice' WHERE kod = 747785;
UPDATE ruian_katastr SET nazev = 'Sidonie' WHERE kod = 747793;
UPDATE ruian_katastr SET nazev = 'Silůvky' WHERE kod = 747815;
UPDATE ruian_katastr SET nazev = 'Sirákov' WHERE kod = 747823;
UPDATE ruian_katastr SET nazev = 'Siřejovice' WHERE kod = 747831;
UPDATE ruian_katastr SET nazev = 'Sivice' WHERE kod = 747840;
UPDATE ruian_katastr SET nazev = 'Skála u Havlíčkova Brodu' WHERE kod = 747858;
UPDATE ruian_katastr SET nazev = 'Skála u Chrasti' WHERE kod = 747866;
UPDATE ruian_katastr SET nazev = 'Skalice u Dobříše' WHERE kod = 747874;
UPDATE ruian_katastr SET nazev = 'Rybova Lhota' WHERE kod = 747882;
UPDATE ruian_katastr SET nazev = 'Skalice nad Lužnicí' WHERE kod = 747891;
UPDATE ruian_katastr SET nazev = 'Skalice u České Lípy' WHERE kod = 747904;
UPDATE ruian_katastr SET nazev = 'Číbuz' WHERE kod = 747921;
UPDATE ruian_katastr SET nazev = 'Skalice u Smiřic' WHERE kod = 747939;
UPDATE ruian_katastr SET nazev = 'Skalice u Znojma' WHERE kod = 747947;
UPDATE ruian_katastr SET nazev = 'Skalice u Frýdku-Místku' WHERE kod = 747971;
UPDATE ruian_katastr SET nazev = 'Skalice nad Svitavou' WHERE kod = 747998;
UPDATE ruian_katastr SET nazev = 'Skaličany' WHERE kod = 748005;
UPDATE ruian_katastr SET nazev = 'Skalička nad Labem' WHERE kod = 748013;
UPDATE ruian_katastr SET nazev = 'Skalička u Hranic' WHERE kod = 748021;
UPDATE ruian_katastr SET nazev = 'Skalka u Blíževedel' WHERE kod = 748030;
UPDATE ruian_katastr SET nazev = 'Skalka u Kyjova' WHERE kod = 748048;
UPDATE ruian_katastr SET nazev = 'Skalka u Prostějova' WHERE kod = 748056;
UPDATE ruian_katastr SET nazev = 'Skalka u Doks' WHERE kod = 748072;
UPDATE ruian_katastr SET nazev = 'Skalná' WHERE kod = 748102;
UPDATE ruian_katastr SET nazev = 'Starý Rybník' WHERE kod = 748111;
UPDATE ruian_katastr SET nazev = 'Vonšov' WHERE kod = 748129;
UPDATE ruian_katastr SET nazev = 'Suchá u Skalné' WHERE kod = 748137;
UPDATE ruian_katastr SET nazev = 'Velký Rybník u Skalné' WHERE kod = 748145;
UPDATE ruian_katastr SET nazev = 'Skalsko' WHERE kod = 748153;
UPDATE ruian_katastr SET nazev = 'Skály u Protivína' WHERE kod = 748161;
UPDATE ruian_katastr SET nazev = 'Skály u Rýmařova' WHERE kod = 748170;
UPDATE ruian_katastr SET nazev = 'Krtín' WHERE kod = 748188;
UPDATE ruian_katastr SET nazev = 'Skapce' WHERE kod = 748196;
UPDATE ruian_katastr SET nazev = 'Skašov' WHERE kod = 748218;
UPDATE ruian_katastr SET nazev = 'Skaštice' WHERE kod = 748226;
UPDATE ruian_katastr SET nazev = 'Sklenařice' WHERE kod = 748234;
UPDATE ruian_katastr SET nazev = 'Sklené u Svitav' WHERE kod = 748242;
UPDATE ruian_katastr SET nazev = 'Sklené u Žďáru nad Sázavou' WHERE kod = 748251;
UPDATE ruian_katastr SET nazev = 'Sklené nad Oslavou' WHERE kod = 748269;
UPDATE ruian_katastr SET nazev = 'Sklenov' WHERE kod = 748293;
UPDATE ruian_katastr SET nazev = 'Rychaltice' WHERE kod = 748307;
UPDATE ruian_katastr SET nazev = 'Skočice' WHERE kod = 748315;
UPDATE ruian_katastr SET nazev = 'Skočice u Přeštic' WHERE kod = 748323;
UPDATE ruian_katastr SET nazev = 'Skochovice' WHERE kod = 748331;
UPDATE ruian_katastr SET nazev = 'Skopytce' WHERE kod = 748358;
UPDATE ruian_katastr SET nazev = 'Otradovice' WHERE kod = 748366;
UPDATE ruian_katastr SET nazev = 'Skorkov' WHERE kod = 748382;
UPDATE ruian_katastr SET nazev = 'Skorkov u Herálce' WHERE kod = 748391;
UPDATE ruian_katastr SET nazev = 'Skoronice' WHERE kod = 748404;
UPDATE ruian_katastr SET nazev = 'Petrovice u Skorošic' WHERE kod = 748421;
UPDATE ruian_katastr SET nazev = 'Dolní Skorošice' WHERE kod = 748447;
UPDATE ruian_katastr SET nazev = 'Tomíkovice' WHERE kod = 748455;
UPDATE ruian_katastr SET nazev = 'Horní Skorošice' WHERE kod = 748471;
UPDATE ruian_katastr SET nazev = 'Skorotice u Ústí nad Labem' WHERE kod = 748480;
UPDATE ruian_katastr SET nazev = 'Chlébské' WHERE kod = 748498;
UPDATE ruian_katastr SET nazev = 'Skorotice' WHERE kod = 748501;
UPDATE ruian_katastr SET nazev = 'Bošín u Chocně' WHERE kod = 748510;
UPDATE ruian_katastr SET nazev = 'Skořenice' WHERE kod = 748528;
UPDATE ruian_katastr SET nazev = 'Skořice' WHERE kod = 748544;
UPDATE ruian_katastr SET nazev = 'Skotnice' WHERE kod = 748561;
UPDATE ruian_katastr SET nazev = 'Skramníky' WHERE kod = 748587;
UPDATE ruian_katastr SET nazev = 'Žhery' WHERE kod = 748595;
UPDATE ruian_katastr SET nazev = 'Skramouš' WHERE kod = 748609;
UPDATE ruian_katastr SET nazev = 'Skrbeň' WHERE kod = 748617;
UPDATE ruian_katastr SET nazev = 'Bahna' WHERE kod = 748625;
UPDATE ruian_katastr SET nazev = 'Dolní Smržov' WHERE kod = 748641;
UPDATE ruian_katastr SET nazev = 'Skrchov' WHERE kod = 748650;
UPDATE ruian_katastr SET nazev = 'Skršice' WHERE kod = 748668;
UPDATE ruian_katastr SET nazev = 'Dobrčice u Skršína' WHERE kod = 748684;
UPDATE ruian_katastr SET nazev = 'Chrámce' WHERE kod = 748692;
UPDATE ruian_katastr SET nazev = 'Skršín' WHERE kod = 748706;
UPDATE ruian_katastr SET nazev = 'Skrýchov' WHERE kod = 748714;
UPDATE ruian_katastr SET nazev = 'Dudov' WHERE kod = 748722;
UPDATE ruian_katastr SET nazev = 'Skrýchov u Malšic' WHERE kod = 748731;
UPDATE ruian_katastr SET nazev = 'Nové Dvory u Opařan' WHERE kod = 748757;
UPDATE ruian_katastr SET nazev = 'Olší u Opařan' WHERE kod = 748765;
UPDATE ruian_katastr SET nazev = 'Skrýchov u Opařan' WHERE kod = 748773;
UPDATE ruian_katastr SET nazev = 'Skryje nad Berounkou' WHERE kod = 748790;
UPDATE ruian_katastr SET nazev = 'Sirákovice' WHERE kod = 748811;
UPDATE ruian_katastr SET nazev = 'Skryje u Golčova Jeníkova' WHERE kod = 748820;
UPDATE ruian_katastr SET nazev = 'Stupárovice' WHERE kod = 748838;
UPDATE ruian_katastr SET nazev = 'Lipňany u Skryjí' WHERE kod = 748846;
UPDATE ruian_katastr SET nazev = 'Skryje nad Jihlavou' WHERE kod = 748854;
UPDATE ruian_katastr SET nazev = 'Skrýšov u Pelhřimova' WHERE kod = 748862;
UPDATE ruian_katastr SET nazev = 'Skřečoň' WHERE kod = 748871;
UPDATE ruian_katastr SET nazev = 'Skřinářov' WHERE kod = 748901;
UPDATE ruian_katastr SET nazev = 'Skřipel' WHERE kod = 748919;
UPDATE ruian_katastr SET nazev = 'Skřípov' WHERE kod = 748927;
UPDATE ruian_katastr SET nazev = 'Skřipov' WHERE kod = 748943;
UPDATE ruian_katastr SET nazev = 'Skřivaň' WHERE kod = 748951;
UPDATE ruian_katastr SET nazev = 'Skřivany' WHERE kod = 748960;
UPDATE ruian_katastr SET nazev = 'Hodyně u Skuhrova' WHERE kod = 748994;
UPDATE ruian_katastr SET nazev = 'Skuhrov pod Brdy' WHERE kod = 749010;
UPDATE ruian_katastr SET nazev = 'Skuhrov u Železného Brodu' WHERE kod = 749028;
UPDATE ruian_katastr SET nazev = 'Skuhrov u Havlíčkova Brodu' WHERE kod = 749036;
UPDATE ruian_katastr SET nazev = 'Skuhrov u České Třebové' WHERE kod = 749044;
UPDATE ruian_katastr SET nazev = 'Skuhrov nad Bělou' WHERE kod = 749109;
UPDATE ruian_katastr SET nazev = 'Skupá' WHERE kod = 749117;
UPDATE ruian_katastr SET nazev = 'Malnice' WHERE kod = 749125;
UPDATE ruian_katastr SET nazev = 'Skupice u Postoloprt' WHERE kod = 749133;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Skutče' WHERE kod = 749141;
UPDATE ruian_katastr SET nazev = 'Skuteč' WHERE kod = 749168;
UPDATE ruian_katastr SET nazev = 'Skutíčko' WHERE kod = 749176;
UPDATE ruian_katastr SET nazev = 'Církvice u Kolína' WHERE kod = 749184;
UPDATE ruian_katastr SET nazev = 'Skvrňov' WHERE kod = 749192;
UPDATE ruian_katastr SET nazev = 'Skyřice' WHERE kod = 749206;
UPDATE ruian_katastr SET nazev = 'Velebudice' WHERE kod = 749214;
UPDATE ruian_katastr SET nazev = 'Skytaly' WHERE kod = 749222;
UPDATE ruian_katastr SET nazev = 'Vrbička' WHERE kod = 749231;
UPDATE ruian_katastr SET nazev = 'Slabce' WHERE kod = 749257;
UPDATE ruian_katastr SET nazev = 'Nemějice' WHERE kod = 749265;
UPDATE ruian_katastr SET nazev = 'Písecká Smoleč' WHERE kod = 749273;
UPDATE ruian_katastr SET nazev = 'Slabčice' WHERE kod = 749281;
UPDATE ruian_katastr SET nazev = 'Bořkov' WHERE kod = 749311;
UPDATE ruian_katastr SET nazev = 'Hořensko' WHERE kod = 749320;
UPDATE ruian_katastr SET nazev = 'Nedvězí u Semil' WHERE kod = 749338;
UPDATE ruian_katastr SET nazev = 'Slaná' WHERE kod = 749354;
UPDATE ruian_katastr SET nazev = 'Slaný' WHERE kod = 749362;
UPDATE ruian_katastr SET nazev = 'Otruby' WHERE kod = 749508;
UPDATE ruian_katastr SET nazev = 'Blahotice' WHERE kod = 749516;
UPDATE ruian_katastr SET nazev = 'Netovice' WHERE kod = 749524;
UPDATE ruian_katastr SET nazev = 'Kvíc' WHERE kod = 749532;
UPDATE ruian_katastr SET nazev = 'Moraveč u Mladé Vožice' WHERE kod = 749567;
UPDATE ruian_katastr SET nazev = 'Slapsko' WHERE kod = 749575;
UPDATE ruian_katastr SET nazev = 'Přestavlky u Slap' WHERE kod = 749605;
UPDATE ruian_katastr SET nazev = 'Slapy nad Vltavou' WHERE kod = 749613;
UPDATE ruian_katastr SET nazev = 'Slatina u Velvar' WHERE kod = 749621;
UPDATE ruian_katastr SET nazev = 'Slatina u Horažďovic' WHERE kod = 749630;
UPDATE ruian_katastr SET nazev = 'Slatina pod Hazmburkem' WHERE kod = 749648;
UPDATE ruian_katastr SET nazev = 'Slatina u Hradce Králové' WHERE kod = 749656;
UPDATE ruian_katastr SET nazev = 'Březinka' WHERE kod = 749664;
UPDATE ruian_katastr SET nazev = 'Slatina u Jevíčka' WHERE kod = 749672;
UPDATE ruian_katastr SET nazev = 'Slatina u Vysokého Mýta' WHERE kod = 749681;
UPDATE ruian_katastr SET nazev = 'Slatina u Jevišovic' WHERE kod = 749699;
UPDATE ruian_katastr SET nazev = 'Slatina u Bílovce' WHERE kod = 749729;
UPDATE ruian_katastr SET nazev = 'Výškovice u Slatiny' WHERE kod = 749737;
UPDATE ruian_katastr SET nazev = 'Slatina nad Úpou' WHERE kod = 749761;
UPDATE ruian_katastr SET nazev = 'Slatina nad Zdobnicí' WHERE kod = 749770;
UPDATE ruian_katastr SET nazev = 'Kunčí' WHERE kod = 749788;
UPDATE ruian_katastr SET nazev = 'Slatiňany' WHERE kod = 749796;
UPDATE ruian_katastr SET nazev = 'Škrovád' WHERE kod = 749800;
UPDATE ruian_katastr SET nazev = 'Slatinice na Hané' WHERE kod = 749818;
UPDATE ruian_katastr SET nazev = 'Slatinky' WHERE kod = 749826;
UPDATE ruian_katastr SET nazev = 'Milíčeves' WHERE kod = 749842;
UPDATE ruian_katastr SET nazev = 'Slatiny' WHERE kod = 749851;
UPDATE ruian_katastr SET nazev = 'Dobrkovská Lhotka' WHERE kod = 749869;
UPDATE ruian_katastr SET nazev = 'Keblany' WHERE kod = 749885;
UPDATE ruian_katastr SET nazev = 'Mohuřice' WHERE kod = 749907;
UPDATE ruian_katastr SET nazev = 'Slavče u Trhových Svinů' WHERE kod = 749915;
UPDATE ruian_katastr SET nazev = 'Slavětice' WHERE kod = 749931;
UPDATE ruian_katastr SET nazev = 'Řísnice' WHERE kod = 749940;
UPDATE ruian_katastr SET nazev = 'Slavětín u Načeradce' WHERE kod = 749958;
UPDATE ruian_katastr SET nazev = 'Zdiměřice u Načeradce' WHERE kod = 749966;
UPDATE ruian_katastr SET nazev = 'Slavětín u Slavonic' WHERE kod = 749974;
UPDATE ruian_katastr SET nazev = 'Kystra' WHERE kod = 749982;
UPDATE ruian_katastr SET nazev = 'Slavětín nad Ohří' WHERE kod = 749991;
UPDATE ruian_katastr SET nazev = 'Ješov' WHERE kod = 750000;
UPDATE ruian_katastr SET nazev = 'Slavětín u Litovle' WHERE kod = 750018;
UPDATE ruian_katastr SET nazev = 'Slavětín nad Metují' WHERE kod = 750026;
UPDATE ruian_katastr SET nazev = 'Slavice' WHERE kod = 750034;
UPDATE ruian_katastr SET nazev = 'Slavíč' WHERE kod = 750042;
UPDATE ruian_katastr SET nazev = 'Divnice' WHERE kod = 750069;
UPDATE ruian_katastr SET nazev = 'Hrádek na Vlárské dráze' WHERE kod = 750077;
UPDATE ruian_katastr SET nazev = 'Slavičín' WHERE kod = 750085;
UPDATE ruian_katastr SET nazev = 'Okrašovice' WHERE kod = 750093;
UPDATE ruian_katastr SET nazev = 'Pozďátky' WHERE kod = 750107;
UPDATE ruian_katastr SET nazev = 'Slavičky' WHERE kod = 750115;
UPDATE ruian_katastr SET nazev = 'Dolní Vestec' WHERE kod = 750123;
UPDATE ruian_katastr SET nazev = 'Kocourov u Slavíkova' WHERE kod = 750140;
UPDATE ruian_katastr SET nazev = 'Rovný' WHERE kod = 750158;
UPDATE ruian_katastr SET nazev = 'Slavíkov u Chotěboře' WHERE kod = 750166;
UPDATE ruian_katastr SET nazev = 'Slavíkov u Náchoda' WHERE kod = 750182;
UPDATE ruian_katastr SET nazev = 'Nevděk' WHERE kod = 750191;
UPDATE ruian_katastr SET nazev = 'Slavíkovice' WHERE kod = 750204;
UPDATE ruian_katastr SET nazev = 'Slavíkovice u Jemnice' WHERE kod = 750212;
UPDATE ruian_katastr SET nazev = 'Větřní-Kaliště' WHERE kod = 750221;
UPDATE ruian_katastr SET nazev = 'Slavkov u Českého Krumlova' WHERE kod = 750247;
UPDATE ruian_katastr SET nazev = 'Cipín' WHERE kod = 750255;
UPDATE ruian_katastr SET nazev = 'Žestov' WHERE kod = 750263;
UPDATE ruian_katastr SET nazev = 'Slavkov u Uherského Brodu' WHERE kod = 750271;
UPDATE ruian_katastr SET nazev = 'Slavkov u Opavy' WHERE kod = 750280;
UPDATE ruian_katastr SET nazev = 'Slavkov pod Hostýnem' WHERE kod = 750298;
UPDATE ruian_katastr SET nazev = 'Slavkov u Brna' WHERE kod = 750301;
UPDATE ruian_katastr SET nazev = 'Slavkovice' WHERE kod = 750310;
UPDATE ruian_katastr SET nazev = 'Slavníč' WHERE kod = 750328;
UPDATE ruian_katastr SET nazev = 'Kadolec u Slavonic' WHERE kod = 750336;
UPDATE ruian_katastr SET nazev = 'Maříž' WHERE kod = 750344;
UPDATE ruian_katastr SET nazev = 'Mutišov' WHERE kod = 750352;
UPDATE ruian_katastr SET nazev = 'Slavonice' WHERE kod = 750361;
UPDATE ruian_katastr SET nazev = 'Vlastkovec' WHERE kod = 750379;
UPDATE ruian_katastr SET nazev = 'Slavonín' WHERE kod = 750387;
UPDATE ruian_katastr SET nazev = 'Blažkov u Slavoňova' WHERE kod = 750395;
UPDATE ruian_katastr SET nazev = 'Slavoňov' WHERE kod = 750409;
UPDATE ruian_katastr SET nazev = 'Hranice u Slavošova' WHERE kod = 750417;
UPDATE ruian_katastr SET nazev = 'Slavošov u Zruče nad Sázavou' WHERE kod = 750425;
UPDATE ruian_katastr SET nazev = 'Slavošovice u Lišova' WHERE kod = 750441;
UPDATE ruian_katastr SET nazev = 'Slemeno v Podkrkonoší' WHERE kod = 750450;
UPDATE ruian_katastr SET nazev = 'Bělešovice' WHERE kod = 750468;
UPDATE ruian_katastr SET nazev = 'Lipec u Slepotic' WHERE kod = 750476;
UPDATE ruian_katastr SET nazev = 'Slepotice' WHERE kod = 750492;
UPDATE ruian_katastr SET nazev = 'Koberno' WHERE kod = 750514;
UPDATE ruian_katastr SET nazev = 'Ves Rudoltice' WHERE kod = 750522;
UPDATE ruian_katastr SET nazev = 'Víno' WHERE kod = 750531;
UPDATE ruian_katastr SET nazev = 'Městys Rudoltice' WHERE kod = 750549;
UPDATE ruian_katastr SET nazev = 'Nový Les' WHERE kod = 750557;
UPDATE ruian_katastr SET nazev = 'Pelhřimovy' WHERE kod = 750565;
UPDATE ruian_katastr SET nazev = 'Holyně' WHERE kod = 750573;
UPDATE ruian_katastr SET nazev = 'Slivenec' WHERE kod = 750590;
UPDATE ruian_katastr SET nazev = 'Slopné' WHERE kod = 750611;
UPDATE ruian_katastr SET nazev = 'Janov u Nového Boru' WHERE kod = 750620;
UPDATE ruian_katastr SET nazev = 'Radvanec' WHERE kod = 750646;
UPDATE ruian_katastr SET nazev = 'Sloup v Čechách' WHERE kod = 750654;
UPDATE ruian_katastr SET nazev = 'Sloup v Moravském krasu' WHERE kod = 750662;
UPDATE ruian_katastr SET nazev = 'Sloupno nad Cidlinou' WHERE kod = 750671;
UPDATE ruian_katastr SET nazev = 'Kamilov' WHERE kod = 750689;
UPDATE ruian_katastr SET nazev = 'Sloveč' WHERE kod = 750697;
UPDATE ruian_katastr SET nazev = 'Střihov' WHERE kod = 750701;
UPDATE ruian_katastr SET nazev = 'Slověnice' WHERE kod = 750719;
UPDATE ruian_katastr SET nazev = 'Dolní Slověnice' WHERE kod = 750727;
UPDATE ruian_katastr SET nazev = 'Horní Slověnice' WHERE kod = 750735;
UPDATE ruian_katastr SET nazev = 'Sluhy' WHERE kod = 750751;
UPDATE ruian_katastr SET nazev = 'Slunečná u České Lípy' WHERE kod = 750760;
UPDATE ruian_katastr SET nazev = 'Oleksovičky' WHERE kod = 750778;
UPDATE ruian_katastr SET nazev = 'Slup' WHERE kod = 750786;
UPDATE ruian_katastr SET nazev = 'Slušovice' WHERE kod = 750794;
UPDATE ruian_katastr SET nazev = 'Sluštice' WHERE kod = 750808;
UPDATE ruian_katastr SET nazev = 'Buč' WHERE kod = 750816;
UPDATE ruian_katastr SET nazev = 'Služetín u Bezvěrova' WHERE kod = 750824;
UPDATE ruian_katastr SET nazev = 'Služovice' WHERE kod = 750832;
UPDATE ruian_katastr SET nazev = 'Smečno' WHERE kod = 750841;
UPDATE ruian_katastr SET nazev = 'Smetanova Lhota' WHERE kod = 750867;
UPDATE ruian_katastr SET nazev = 'Varvažov' WHERE kod = 750883;
UPDATE ruian_katastr SET nazev = 'Červeněves' WHERE kod = 750913;
UPDATE ruian_katastr SET nazev = 'Křičov' WHERE kod = 750921;
UPDATE ruian_katastr SET nazev = 'Loučná Hora' WHERE kod = 750930;
UPDATE ruian_katastr SET nazev = 'Smidary' WHERE kod = 750948;
UPDATE ruian_katastr SET nazev = 'Kouty u Smilkova' WHERE kod = 750956;
UPDATE ruian_katastr SET nazev = 'Smilkov' WHERE kod = 750981;
UPDATE ruian_katastr SET nazev = 'Pozovice' WHERE kod = 750999;
UPDATE ruian_katastr SET nazev = 'Smilov u Štoků' WHERE kod = 751006;
UPDATE ruian_katastr SET nazev = 'Smilovice u Luštěnic' WHERE kod = 751014;
UPDATE ruian_katastr SET nazev = 'Smilovice' WHERE kod = 751022;
UPDATE ruian_katastr SET nazev = 'Rakovec' WHERE kod = 751031;
UPDATE ruian_katastr SET nazev = 'Smilovice u Třince' WHERE kod = 751049;
UPDATE ruian_katastr SET nazev = 'Smilovy Hory' WHERE kod = 751065;
UPDATE ruian_katastr SET nazev = 'Stojslavice' WHERE kod = 751073;
UPDATE ruian_katastr SET nazev = 'Smiřice' WHERE kod = 751081;
UPDATE ruian_katastr SET nazev = 'Smolín' WHERE kod = 751090;
UPDATE ruian_katastr SET nazev = 'Smolina' WHERE kod = 751103;
UPDATE ruian_katastr SET nazev = 'Smolnice u Loun' WHERE kod = 751111;
UPDATE ruian_katastr SET nazev = 'Smolotely' WHERE kod = 751138;
UPDATE ruian_katastr SET nazev = 'Smolov' WHERE kod = 751162;
UPDATE ruian_katastr SET nazev = 'Železná u Smolova' WHERE kod = 751171;
UPDATE ruian_katastr SET nazev = 'Pleš' WHERE kod = 751189;
UPDATE ruian_katastr SET nazev = 'Smrčná na Moravě' WHERE kod = 751197;
UPDATE ruian_katastr SET nazev = 'Kojatín' WHERE kod = 751219;
UPDATE ruian_katastr SET nazev = 'Smrk na Moravě' WHERE kod = 751227;
UPDATE ruian_katastr SET nazev = 'Smrkovice' WHERE kod = 751235;
UPDATE ruian_katastr SET nazev = 'Smržice' WHERE kod = 751243;
UPDATE ruian_katastr SET nazev = 'Hubíles' WHERE kod = 751251;
UPDATE ruian_katastr SET nazev = 'Smržov u Smiřic' WHERE kod = 751260;
UPDATE ruian_katastr SET nazev = 'Smržovice' WHERE kod = 751294;
UPDATE ruian_katastr SET nazev = 'Jiřetín pod Bukovou' WHERE kod = 751308;
UPDATE ruian_katastr SET nazev = 'Smržovka' WHERE kod = 751324;
UPDATE ruian_katastr SET nazev = 'Křešov' WHERE kod = 751341;
UPDATE ruian_katastr SET nazev = 'Snědovice' WHERE kod = 751359;
UPDATE ruian_katastr SET nazev = 'Střížovice u Snědovic' WHERE kod = 751367;
UPDATE ruian_katastr SET nazev = 'Snět' WHERE kod = 751375;
UPDATE ruian_katastr SET nazev = 'Liboc u Kraslic' WHERE kod = 751383;
UPDATE ruian_katastr SET nazev = 'Mlýnská' WHERE kod = 751391;
UPDATE ruian_katastr SET nazev = 'Sněžná' WHERE kod = 751405;
UPDATE ruian_katastr SET nazev = 'Sněžné' WHERE kod = 751413;
UPDATE ruian_katastr SET nazev = 'Blatiny' WHERE kod = 751421;
UPDATE ruian_katastr SET nazev = 'Podlesí u Sněžného' WHERE kod = 751448;
UPDATE ruian_katastr SET nazev = 'Sněžné na Moravě' WHERE kod = 751456;
UPDATE ruian_katastr SET nazev = 'Vříšť' WHERE kod = 751464;
UPDATE ruian_katastr SET nazev = 'Sněžník' WHERE kod = 751472;
UPDATE ruian_katastr SET nazev = 'Snovídky' WHERE kod = 751481;
UPDATE ruian_katastr SET nazev = 'Sobčice' WHERE kod = 751499;
UPDATE ruian_katastr SET nazev = 'Sobědruhy' WHERE kod = 751502;
UPDATE ruian_katastr SET nazev = 'Soběhrdy' WHERE kod = 751537;
UPDATE ruian_katastr SET nazev = 'Žíňany' WHERE kod = 751553;
UPDATE ruian_katastr SET nazev = 'Soběchleby u Podbořan' WHERE kod = 751561;
UPDATE ruian_katastr SET nazev = 'Soběchleby u Krupky' WHERE kod = 751570;
UPDATE ruian_katastr SET nazev = 'Soběchleby' WHERE kod = 751588;
UPDATE ruian_katastr SET nazev = 'Horušany' WHERE kod = 751596;
UPDATE ruian_katastr SET nazev = 'Soběkury' WHERE kod = 751600;
UPDATE ruian_katastr SET nazev = 'Horní Nezly' WHERE kod = 751634;
UPDATE ruian_katastr SET nazev = 'Soběnice' WHERE kod = 751642;
UPDATE ruian_katastr SET nazev = 'Soběnov' WHERE kod = 751677;
UPDATE ruian_katastr SET nazev = 'Soběraz' WHERE kod = 751685;
UPDATE ruian_katastr SET nazev = 'Těšín' WHERE kod = 751693;
UPDATE ruian_katastr SET nazev = 'Soběslav' WHERE kod = 751707;
UPDATE ruian_katastr SET nazev = 'Chlebov' WHERE kod = 751804;
UPDATE ruian_katastr SET nazev = 'Soběslavice' WHERE kod = 751839;
UPDATE ruian_katastr SET nazev = 'Střížovice u Pěnčína' WHERE kod = 751847;
UPDATE ruian_katastr SET nazev = 'Soběsuky u Nepomuka' WHERE kod = 751855;
UPDATE ruian_katastr SET nazev = 'Milovice' WHERE kod = 751863;
UPDATE ruian_katastr SET nazev = 'Skržice' WHERE kod = 751871;
UPDATE ruian_katastr SET nazev = 'Soběsuky' WHERE kod = 751880;
UPDATE ruian_katastr SET nazev = 'Soběsuky u Plumlova' WHERE kod = 751898;
UPDATE ruian_katastr SET nazev = 'Soběšice u Sušice' WHERE kod = 751901;
UPDATE ruian_katastr SET nazev = 'Soběšice' WHERE kod = 751910;
UPDATE ruian_katastr SET nazev = 'Pitrov' WHERE kod = 751928;
UPDATE ruian_katastr SET nazev = 'Horní Soběšovice' WHERE kod = 751936;
UPDATE ruian_katastr SET nazev = 'Dolní Soběšovice' WHERE kod = 751944;
UPDATE ruian_katastr SET nazev = 'Sobětuchy' WHERE kod = 751961;
UPDATE ruian_katastr SET nazev = 'Stolany' WHERE kod = 751979;
UPDATE ruian_katastr SET nazev = 'Sobětuš' WHERE kod = 751987;
UPDATE ruian_katastr SET nazev = 'Sobíňov' WHERE kod = 752002;
UPDATE ruian_katastr SET nazev = 'Sobíšky' WHERE kod = 752029;
UPDATE ruian_katastr SET nazev = 'Sobkovice' WHERE kod = 752037;
UPDATE ruian_katastr SET nazev = 'Klepáčov' WHERE kod = 752045;
UPDATE ruian_katastr SET nazev = 'Rudoltice u Sobotína' WHERE kod = 752053;
UPDATE ruian_katastr SET nazev = 'Sobotín' WHERE kod = 752061;
UPDATE ruian_katastr SET nazev = 'Čálovice' WHERE kod = 752070;
UPDATE ruian_katastr SET nazev = 'Lavice' WHERE kod = 752088;
UPDATE ruian_katastr SET nazev = 'Sobotka' WHERE kod = 752096;
UPDATE ruian_katastr SET nazev = 'Spyšova' WHERE kod = 752100;
UPDATE ruian_katastr SET nazev = 'Staňkova Lhota' WHERE kod = 752118;
UPDATE ruian_katastr SET nazev = 'Stéblovice' WHERE kod = 752126;
UPDATE ruian_katastr SET nazev = 'Sobotovice' WHERE kod = 752142;
UPDATE ruian_katastr SET nazev = 'Sobůlky' WHERE kod = 752151;
UPDATE ruian_katastr SET nazev = 'Sojovice' WHERE kod = 752169;
UPDATE ruian_katastr SET nazev = 'Sokoleč' WHERE kod = 752177;
UPDATE ruian_katastr SET nazev = 'Sokolí' WHERE kod = 752185;
UPDATE ruian_katastr SET nazev = 'Sokolnice' WHERE kod = 752193;
UPDATE ruian_katastr SET nazev = 'Sokolov' WHERE kod = 752223;
UPDATE ruian_katastr SET nazev = 'Dolní Rychnov' WHERE kod = 752304;
UPDATE ruian_katastr SET nazev = 'Těšovice' WHERE kod = 752312;
UPDATE ruian_katastr SET nazev = 'Solany' WHERE kod = 752321;
UPDATE ruian_katastr SET nazev = 'Malobratřice' WHERE kod = 752347;
UPDATE ruian_katastr SET nazev = 'Solec' WHERE kod = 752355;
UPDATE ruian_katastr SET nazev = 'Dolní Líšnice' WHERE kod = 752371;
UPDATE ruian_katastr SET nazev = 'Solenice' WHERE kod = 752398;
UPDATE ruian_katastr SET nazev = 'Větrov u Solenic' WHERE kod = 752401;
UPDATE ruian_katastr SET nazev = 'Ještětice' WHERE kod = 752410;
UPDATE ruian_katastr SET nazev = 'Solnice' WHERE kod = 752428;
UPDATE ruian_katastr SET nazev = 'Solopysky u Loun' WHERE kod = 752436;
UPDATE ruian_katastr SET nazev = 'Sopotnice' WHERE kod = 752444;
UPDATE ruian_katastr SET nazev = 'Sopřeč' WHERE kod = 752452;
UPDATE ruian_katastr SET nazev = 'Sosnová u České Lípy' WHERE kod = 752461;
UPDATE ruian_katastr SET nazev = 'Sosnová' WHERE kod = 752479;
UPDATE ruian_katastr SET nazev = 'Souňov' WHERE kod = 752487;
UPDATE ruian_katastr SET nazev = 'Libětice' WHERE kod = 752495;
UPDATE ruian_katastr SET nazev = 'Smiradice' WHERE kod = 752509;
UPDATE ruian_katastr SET nazev = 'Sousedovice' WHERE kod = 752517;
UPDATE ruian_katastr SET nazev = 'Soušice' WHERE kod = 752541;
UPDATE ruian_katastr SET nazev = 'Soutice' WHERE kod = 752576;
UPDATE ruian_katastr SET nazev = 'Sovadina' WHERE kod = 752584;
UPDATE ruian_katastr SET nazev = 'Sovenice u Mnichova Hradiště' WHERE kod = 752606;
UPDATE ruian_katastr SET nazev = 'Sovenice' WHERE kod = 752614;
UPDATE ruian_katastr SET nazev = 'Horní Černůtky' WHERE kod = 752622;
UPDATE ruian_katastr SET nazev = 'Sadová u Sovětic' WHERE kod = 752631;
UPDATE ruian_katastr SET nazev = 'Sovětice' WHERE kod = 752649;
UPDATE ruian_katastr SET nazev = 'Křížov u Sovince' WHERE kod = 752657;
UPDATE ruian_katastr SET nazev = 'Sovinec' WHERE kod = 752665;
UPDATE ruian_katastr SET nazev = 'Sovínky' WHERE kod = 752673;
UPDATE ruian_katastr SET nazev = 'Sovolusky u Přelouče' WHERE kod = 752681;
UPDATE ruian_katastr SET nazev = 'Spálené Poříčí' WHERE kod = 752703;
UPDATE ruian_katastr SET nazev = 'Vlkov u Spáleného Poříčí' WHERE kod = 752711;
UPDATE ruian_katastr SET nazev = 'Nový Spálenec' WHERE kod = 752720;
UPDATE ruian_katastr SET nazev = 'Starý Spálenec' WHERE kod = 752746;
UPDATE ruian_katastr SET nazev = 'Spálov' WHERE kod = 752754;
UPDATE ruian_katastr SET nazev = 'Spáňov' WHERE kod = 752771;
UPDATE ruian_katastr SET nazev = 'Spělkov' WHERE kod = 752789;
UPDATE ruian_katastr SET nazev = 'Spělov' WHERE kod = 752801;
UPDATE ruian_katastr SET nazev = 'Speřice' WHERE kod = 752819;
UPDATE ruian_katastr SET nazev = 'Spešov' WHERE kod = 752827;
UPDATE ruian_katastr SET nazev = 'Spolí u Ledenic' WHERE kod = 752835;
UPDATE ruian_katastr SET nazev = 'Spomyšl' WHERE kod = 752843;
UPDATE ruian_katastr SET nazev = 'Spořice' WHERE kod = 752851;
UPDATE ruian_katastr SET nazev = 'Spytihněv' WHERE kod = 752860;
UPDATE ruian_katastr SET nazev = 'Srbce u Luže' WHERE kod = 752878;
UPDATE ruian_katastr SET nazev = 'Srbce na Moravě' WHERE kod = 752886;
UPDATE ruian_katastr SET nazev = 'Srbeč' WHERE kod = 752894;
UPDATE ruian_katastr SET nazev = 'Hlohovčice' WHERE kod = 752908;
UPDATE ruian_katastr SET nazev = 'Srbice u Kolovče' WHERE kod = 752916;
UPDATE ruian_katastr SET nazev = 'Těšovice u Kolovče' WHERE kod = 752924;
UPDATE ruian_katastr SET nazev = 'Srbice' WHERE kod = 752941;
UPDATE ruian_katastr SET nazev = 'Srbín' WHERE kod = 752967;
UPDATE ruian_katastr SET nazev = 'Srbská Kamenice' WHERE kod = 752975;
UPDATE ruian_katastr SET nazev = 'Srbsko u Karlštejna' WHERE kod = 752983;
UPDATE ruian_katastr SET nazev = 'Srby u Tuchlovic' WHERE kod = 752991;
UPDATE ruian_katastr SET nazev = 'Medná' WHERE kod = 753009;
UPDATE ruian_katastr SET nazev = 'Polžice u Horšovského Týna' WHERE kod = 753017;
UPDATE ruian_katastr SET nazev = 'Roudná u Horšovského Týna' WHERE kod = 753025;
UPDATE ruian_katastr SET nazev = 'Srby u Horšovského Týna' WHERE kod = 753033;
UPDATE ruian_katastr SET nazev = 'Vítání' WHERE kod = 753041;
UPDATE ruian_katastr SET nazev = 'Srdov' WHERE kod = 753050;
UPDATE ruian_katastr SET nazev = 'Pohránov' WHERE kod = 753068;
UPDATE ruian_katastr SET nazev = 'Srch' WHERE kod = 753076;
UPDATE ruian_katastr SET nazev = 'Vchynice-Tetov I' WHERE kod = 753084;
UPDATE ruian_katastr SET nazev = 'Srní I' WHERE kod = 753092;
UPDATE ruian_katastr SET nazev = 'Srní u České Lípy' WHERE kod = 753114;
UPDATE ruian_katastr SET nazev = 'Srubec' WHERE kod = 753131;
UPDATE ruian_katastr SET nazev = 'Sruby' WHERE kod = 753165;
UPDATE ruian_katastr SET nazev = 'Stadice' WHERE kod = 753181;
UPDATE ruian_katastr SET nazev = 'Křída u Stádlce' WHERE kod = 753203;
UPDATE ruian_katastr SET nazev = 'Slavňovice' WHERE kod = 753211;
UPDATE ruian_katastr SET nazev = 'Stádlec' WHERE kod = 753220;
UPDATE ruian_katastr SET nazev = 'Staré Sedlo u Stádlce' WHERE kod = 753238;
UPDATE ruian_katastr SET nazev = 'Stachovice' WHERE kod = 753246;
UPDATE ruian_katastr SET nazev = 'Nicov' WHERE kod = 753343;
UPDATE ruian_katastr SET nazev = 'Řetenice u Stach' WHERE kod = 753360;
UPDATE ruian_katastr SET nazev = 'Stachy' WHERE kod = 753386;
UPDATE ruian_katastr SET nazev = 'Studenec u Stach' WHERE kod = 753394;
UPDATE ruian_katastr SET nazev = 'Úbislav' WHERE kod = 753416;
UPDATE ruian_katastr SET nazev = 'Milov' WHERE kod = 753432;
UPDATE ruian_katastr SET nazev = 'Stáj' WHERE kod = 753441;
UPDATE ruian_katastr SET nazev = 'Stálkov' WHERE kod = 753459;
UPDATE ruian_katastr SET nazev = 'Stálky' WHERE kod = 753475;
UPDATE ruian_katastr SET nazev = 'Skoky u Staměřic' WHERE kod = 753483;
UPDATE ruian_katastr SET nazev = 'Staměřice' WHERE kod = 753491;
UPDATE ruian_katastr SET nazev = 'Stanětice' WHERE kod = 753505;
UPDATE ruian_katastr SET nazev = 'Stanislavice' WHERE kod = 753521;
UPDATE ruian_katastr SET nazev = 'Staňkov' WHERE kod = 753548;
UPDATE ruian_katastr SET nazev = 'Krchleby u Staňkova' WHERE kod = 753556;
UPDATE ruian_katastr SET nazev = 'Ohučov' WHERE kod = 753564;
UPDATE ruian_katastr SET nazev = 'Staňkov-město' WHERE kod = 753572;
UPDATE ruian_katastr SET nazev = 'Smilovice u Staňkovic' WHERE kod = 753602;
UPDATE ruian_katastr SET nazev = 'Staňkovice u Uhlířských Janovic' WHERE kod = 753611;
UPDATE ruian_katastr SET nazev = 'Staňkovice u Žatce' WHERE kod = 753629;
UPDATE ruian_katastr SET nazev = 'Stanovice' WHERE kod = 753645;
UPDATE ruian_katastr SET nazev = 'Stanoviště na Moravě' WHERE kod = 753653;
UPDATE ruian_katastr SET nazev = 'Stará Bělá' WHERE kod = 753661;
UPDATE ruian_katastr SET nazev = 'Nová Červená Voda' WHERE kod = 753670;
UPDATE ruian_katastr SET nazev = 'Stará Červená Voda' WHERE kod = 753688;
UPDATE ruian_katastr SET nazev = 'Dolní Červená Voda' WHERE kod = 753696;
UPDATE ruian_katastr SET nazev = 'Stará Hlína' WHERE kod = 753726;
UPDATE ruian_katastr SET nazev = 'Holičky u Staré Hlíny' WHERE kod = 753742;
UPDATE ruian_katastr SET nazev = 'Stará Huť' WHERE kod = 753751;
UPDATE ruian_katastr SET nazev = 'Stará Chodovská' WHERE kod = 753777;
UPDATE ruian_katastr SET nazev = 'Stará Libavá' WHERE kod = 753785;
UPDATE ruian_katastr SET nazev = 'Stará Lysá' WHERE kod = 753807;
UPDATE ruian_katastr SET nazev = 'Stará Paka' WHERE kod = 753823;
UPDATE ruian_katastr SET nazev = 'Počerny' WHERE kod = 753831;
UPDATE ruian_katastr SET nazev = 'Rosnice u Staré Role' WHERE kod = 753840;
UPDATE ruian_katastr SET nazev = 'Stará Role' WHERE kod = 753858;
UPDATE ruian_katastr SET nazev = 'Stará Roveň' WHERE kod = 753874;
UPDATE ruian_katastr SET nazev = 'Nepomuky na Moravě' WHERE kod = 753882;
UPDATE ruian_katastr SET nazev = 'Stará Říše' WHERE kod = 753891;
UPDATE ruian_katastr SET nazev = 'Stará Ves u Vysokého nad Jizerou' WHERE kod = 753904;
UPDATE ruian_katastr SET nazev = 'Stará Ves u Rýmařova' WHERE kod = 753912;
UPDATE ruian_katastr SET nazev = 'Žďárský Potok' WHERE kod = 753921;
UPDATE ruian_katastr SET nazev = 'Stará Ves u Přerova' WHERE kod = 753939;
UPDATE ruian_katastr SET nazev = 'Stará Ves nad Ondřejnicí' WHERE kod = 753947;
UPDATE ruian_katastr SET nazev = 'Stará Ves u Bílovce' WHERE kod = 753963;
UPDATE ruian_katastr SET nazev = 'Háj u Staré Vody' WHERE kod = 753971;
UPDATE ruian_katastr SET nazev = 'Stará Voda u Mariánských Lázní' WHERE kod = 753998;
UPDATE ruian_katastr SET nazev = 'Vysoká u Staré Vody' WHERE kod = 754013;
UPDATE ruian_katastr SET nazev = 'Jedlová u Staré Vody' WHERE kod = 754021;
UPDATE ruian_katastr SET nazev = 'Nové Mohelno' WHERE kod = 754030;
UPDATE ruian_katastr SET nazev = 'Slatina u Staré Vody' WHERE kod = 754048;
UPDATE ruian_katastr SET nazev = 'Stará Voda' WHERE kod = 754056;
UPDATE ruian_katastr SET nazev = 'Stará Vožice' WHERE kod = 754064;
UPDATE ruian_katastr SET nazev = 'Dřevce' WHERE kod = 754072;
UPDATE ruian_katastr SET nazev = 'Leská' WHERE kod = 754081;
UPDATE ruian_katastr SET nazev = 'Skalice u Lovosic' WHERE kod = 754099;
UPDATE ruian_katastr SET nazev = 'Staré' WHERE kod = 754102;
UPDATE ruian_katastr SET nazev = 'Šepetely' WHERE kod = 754111;
UPDATE ruian_katastr SET nazev = 'Staré Bříště' WHERE kod = 754129;
UPDATE ruian_katastr SET nazev = 'Dolní Staré Buky' WHERE kod = 754137;
UPDATE ruian_katastr SET nazev = 'Horní Staré Buky' WHERE kod = 754153;
UPDATE ruian_katastr SET nazev = 'Prostřední Staré Buky' WHERE kod = 754161;
UPDATE ruian_katastr SET nazev = 'Staré Čívice' WHERE kod = 754170;
UPDATE ruian_katastr SET nazev = 'Ostravice 2' WHERE kod = 754277;
UPDATE ruian_katastr SET nazev = 'Staré Hamry 1' WHERE kod = 754285;
UPDATE ruian_katastr SET nazev = 'Staré Heřminovy' WHERE kod = 754307;
UPDATE ruian_katastr SET nazev = 'Nové Hobzí' WHERE kod = 754315;
UPDATE ruian_katastr SET nazev = 'Staré Hobzí' WHERE kod = 754323;
UPDATE ruian_katastr SET nazev = 'Staré Hodějovice' WHERE kod = 754331;
UPDATE ruian_katastr SET nazev = 'Brozany nad Labem' WHERE kod = 754340;
UPDATE ruian_katastr SET nazev = 'Staré Hradiště' WHERE kod = 754366;
UPDATE ruian_katastr SET nazev = 'Sedliště u Starých Hradů' WHERE kod = 754374;
UPDATE ruian_katastr SET nazev = 'Staré Hrady' WHERE kod = 754382;
UPDATE ruian_katastr SET nazev = 'Staré Hutě na Moravě' WHERE kod = 754404;
UPDATE ruian_katastr SET nazev = 'Staré Jesenčany' WHERE kod = 754412;
UPDATE ruian_katastr SET nazev = 'Panský' WHERE kod = 754421;
UPDATE ruian_katastr SET nazev = 'Staré Křečany' WHERE kod = 754439;
UPDATE ruian_katastr SET nazev = 'Petrušov' WHERE kod = 754463;
UPDATE ruian_katastr SET nazev = 'Radišov' WHERE kod = 754471;
UPDATE ruian_katastr SET nazev = 'Staré Město u Moravské Třebové' WHERE kod = 754480;
UPDATE ruian_katastr SET nazev = 'Staré Město u Frýdku-Místku' WHERE kod = 754498;
UPDATE ruian_katastr SET nazev = 'Malé Vrbno' WHERE kod = 754510;
UPDATE ruian_katastr SET nazev = 'Staré Město pod Králickým Sněžníkem' WHERE kod = 754528;
UPDATE ruian_katastr SET nazev = 'Velké Vrbno' WHERE kod = 754544;
UPDATE ruian_katastr SET nazev = 'Dobrotín' WHERE kod = 754552;
UPDATE ruian_katastr SET nazev = 'Podlesí pod Landštejnem' WHERE kod = 754561;
UPDATE ruian_katastr SET nazev = 'Pomezí pod Landštejnem' WHERE kod = 754579;
UPDATE ruian_katastr SET nazev = 'Skalka u Nové Bystřice' WHERE kod = 754587;
UPDATE ruian_katastr SET nazev = 'Staré Město pod Landštejnem' WHERE kod = 754595;
UPDATE ruian_katastr SET nazev = 'Vitíněves' WHERE kod = 754609;
UPDATE ruian_katastr SET nazev = 'Staré Město u Uherského Hradiště' WHERE kod = 754617;
UPDATE ruian_katastr SET nazev = 'Staré Oldřůvky' WHERE kod = 754625;
UPDATE ruian_katastr SET nazev = 'Staré Ransko' WHERE kod = 754633;
UPDATE ruian_katastr SET nazev = 'Mchov' WHERE kod = 754641;
UPDATE ruian_katastr SET nazev = 'Nové Sedliště' WHERE kod = 754650;
UPDATE ruian_katastr SET nazev = 'Staré Sedliště' WHERE kod = 754668;
UPDATE ruian_katastr SET nazev = 'Úšava' WHERE kod = 754676;
UPDATE ruian_katastr SET nazev = 'Beroun u Starého Sedla' WHERE kod = 754684;
UPDATE ruian_katastr SET nazev = 'Heřmanov u Starého Sedla' WHERE kod = 754692;
UPDATE ruian_katastr SET nazev = 'Staré Sedlo u Teplé' WHERE kod = 754706;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Starého Sedla' WHERE kod = 754714;
UPDATE ruian_katastr SET nazev = 'Staré Sedlo u Sokolova' WHERE kod = 754722;
UPDATE ruian_katastr SET nazev = 'Darmyšl' WHERE kod = 754731;
UPDATE ruian_katastr SET nazev = 'Racov' WHERE kod = 754749;
UPDATE ruian_katastr SET nazev = 'Staré Sedlo u Tachova' WHERE kod = 754757;
UPDATE ruian_katastr SET nazev = 'Nevratice' WHERE kod = 754765;
UPDATE ruian_katastr SET nazev = 'Staré Smrkovice' WHERE kod = 754773;
UPDATE ruian_katastr SET nazev = 'Staré Ždánice' WHERE kod = 754781;
UPDATE ruian_katastr SET nazev = 'Starec' WHERE kod = 754790;
UPDATE ruian_katastr SET nazev = 'Bystré u Stárkova' WHERE kod = 754803;
UPDATE ruian_katastr SET nazev = 'Horní Dřevíč' WHERE kod = 754811;
UPDATE ruian_katastr SET nazev = 'Chlívce' WHERE kod = 754820;
UPDATE ruian_katastr SET nazev = 'Stárkov' WHERE kod = 754838;
UPDATE ruian_katastr SET nazev = 'Starojická Lhota' WHERE kod = 754854;
UPDATE ruian_katastr SET nazev = 'Starosedlský Hrádek' WHERE kod = 754862;
UPDATE ruian_katastr SET nazev = 'Starovice' WHERE kod = 754871;
UPDATE ruian_katastr SET nazev = 'Starovičky' WHERE kod = 754889;
UPDATE ruian_katastr SET nazev = 'Starý Bohumín' WHERE kod = 754897;
UPDATE ruian_katastr SET nazev = 'Skřeněř' WHERE kod = 754927;
UPDATE ruian_katastr SET nazev = 'Starý Bydžov' WHERE kod = 754943;
UPDATE ruian_katastr SET nazev = 'Podhradí v Železných horách' WHERE kod = 754951;
UPDATE ruian_katastr SET nazev = 'Skoranov' WHERE kod = 754960;
UPDATE ruian_katastr SET nazev = 'Starý Dvůr' WHERE kod = 754978;
UPDATE ruian_katastr SET nazev = 'Starý Hrozenkov' WHERE kod = 755001;
UPDATE ruian_katastr SET nazev = 'Starý Hrozňatov' WHERE kod = 755028;
UPDATE ruian_katastr SET nazev = 'Starý Jičín' WHERE kod = 755036;
UPDATE ruian_katastr SET nazev = 'Vlčnov u Starého Jičína' WHERE kod = 755044;
UPDATE ruian_katastr SET nazev = 'Starý Kolín' WHERE kod = 755052;
UPDATE ruian_katastr SET nazev = 'Dubany nad Bylankou' WHERE kod = 755061;
UPDATE ruian_katastr SET nazev = 'Starý Mateřov' WHERE kod = 755079;
UPDATE ruian_katastr SET nazev = 'Třebosice' WHERE kod = 755087;
UPDATE ruian_katastr SET nazev = 'Starý Pelhřimov' WHERE kod = 755095;
UPDATE ruian_katastr SET nazev = 'Jazovice' WHERE kod = 755109;
UPDATE ruian_katastr SET nazev = 'Nový Petřín' WHERE kod = 755117;
UPDATE ruian_katastr SET nazev = 'Starý Petřín' WHERE kod = 755125;
UPDATE ruian_katastr SET nazev = 'Starý Ples' WHERE kod = 755133;
UPDATE ruian_katastr SET nazev = 'Sedlec u Starého Plzence' WHERE kod = 755141;
UPDATE ruian_katastr SET nazev = 'Starý Plzenec' WHERE kod = 755150;
UPDATE ruian_katastr SET nazev = 'Starý Poddvorov' WHERE kod = 755168;
UPDATE ruian_katastr SET nazev = 'Starý Rokytník' WHERE kod = 755192;
UPDATE ruian_katastr SET nazev = 'Starý Svojanov' WHERE kod = 755206;
UPDATE ruian_katastr SET nazev = 'Malý Šachov' WHERE kod = 755214;
UPDATE ruian_katastr SET nazev = 'Starý Šachov' WHERE kod = 755222;
UPDATE ruian_katastr SET nazev = 'Starý Vestec' WHERE kod = 755231;
UPDATE ruian_katastr SET nazev = 'Kracovice' WHERE kod = 755257;
UPDATE ruian_katastr SET nazev = 'Stařeč' WHERE kod = 755265;
UPDATE ruian_katastr SET nazev = 'Služín' WHERE kod = 755273;
UPDATE ruian_katastr SET nazev = 'Stařechovice' WHERE kod = 755281;
UPDATE ruian_katastr SET nazev = 'Staříč' WHERE kod = 755290;
UPDATE ruian_katastr SET nazev = 'Stašov u Zdic' WHERE kod = 755311;
UPDATE ruian_katastr SET nazev = 'Stašov' WHERE kod = 755320;
UPDATE ruian_katastr SET nazev = 'Statenice' WHERE kod = 755346;
UPDATE ruian_katastr SET nazev = 'Stavenice' WHERE kod = 755354;
UPDATE ruian_katastr SET nazev = 'Stavěšice' WHERE kod = 755362;
UPDATE ruian_katastr SET nazev = 'Stéblová' WHERE kod = 755371;
UPDATE ruian_katastr SET nazev = 'Stebno u Petrohradu' WHERE kod = 755389;
UPDATE ruian_katastr SET nazev = 'Podlešín u Stebna' WHERE kod = 755401;
UPDATE ruian_katastr SET nazev = 'Stebno u Dubic' WHERE kod = 755419;
UPDATE ruian_katastr SET nazev = 'Suchá u Stebna' WHERE kod = 755427;
UPDATE ruian_katastr SET nazev = 'Stěbořice' WHERE kod = 755435;
UPDATE ruian_katastr SET nazev = 'Stehelčeves' WHERE kod = 755443;
UPDATE ruian_katastr SET nazev = 'Stěžery' WHERE kod = 755451;
UPDATE ruian_katastr SET nazev = 'Stěžírky' WHERE kod = 755478;
UPDATE ruian_katastr SET nazev = 'Stěžov' WHERE kod = 755486;
UPDATE ruian_katastr SET nazev = 'Stínava' WHERE kod = 755494;
UPDATE ruian_katastr SET nazev = 'Lelov' WHERE kod = 755508;
UPDATE ruian_katastr SET nazev = 'Stod' WHERE kod = 755516;
UPDATE ruian_katastr SET nazev = 'Stodůlky' WHERE kod = 755541;
UPDATE ruian_katastr SET nazev = 'Honice' WHERE kod = 755559;
UPDATE ruian_katastr SET nazev = 'Stochov' WHERE kod = 755567;
UPDATE ruian_katastr SET nazev = 'Holotín' WHERE kod = 755575;
UPDATE ruian_katastr SET nazev = 'Stojice' WHERE kod = 755583;
UPDATE ruian_katastr SET nazev = 'Sokolíčko' WHERE kod = 755591;
UPDATE ruian_katastr SET nazev = 'Stonařov' WHERE kod = 755605;
UPDATE ruian_katastr SET nazev = 'Stonava' WHERE kod = 755630;
UPDATE ruian_katastr SET nazev = 'Stošíkovice na Louce' WHERE kod = 755648;
UPDATE ruian_katastr SET nazev = 'České Žleby' WHERE kod = 755664;
UPDATE ruian_katastr SET nazev = 'Stožec' WHERE kod = 755699;
UPDATE ruian_katastr SET nazev = 'Horní Cazov' WHERE kod = 755702;
UPDATE ruian_katastr SET nazev = 'Radvanovice' WHERE kod = 755711;
UPDATE ruian_katastr SET nazev = 'Křepice u Vodňan' WHERE kod = 755729;
UPDATE ruian_katastr SET nazev = 'Stožice' WHERE kod = 755745;
UPDATE ruian_katastr SET nazev = 'Strabenice' WHERE kod = 755753;
UPDATE ruian_katastr SET nazev = 'Klenice' WHERE kod = 755761;
UPDATE ruian_katastr SET nazev = 'Stračov' WHERE kod = 755770;
UPDATE ruian_katastr SET nazev = 'Stradonice u Nižboru' WHERE kod = 755788;
UPDATE ruian_katastr SET nazev = 'Stradonice u Zlonic' WHERE kod = 755796;
UPDATE ruian_katastr SET nazev = 'Stradouň' WHERE kod = 755800;
UPDATE ruian_katastr SET nazev = 'Stradov u Chabařovic' WHERE kod = 755818;
UPDATE ruian_katastr SET nazev = 'Strahovice' WHERE kod = 755826;
UPDATE ruian_katastr SET nazev = 'Bylochov' WHERE kod = 755842;
UPDATE ruian_katastr SET nazev = 'Strachaly' WHERE kod = 755851;
UPDATE ruian_katastr SET nazev = 'Strachoňovice' WHERE kod = 755869;
UPDATE ruian_katastr SET nazev = 'Micmanice' WHERE kod = 755877;
UPDATE ruian_katastr SET nazev = 'Strachotice' WHERE kod = 755885;
UPDATE ruian_katastr SET nazev = 'Strachotín' WHERE kod = 755893;
UPDATE ruian_katastr SET nazev = 'Strachujov' WHERE kod = 755907;
UPDATE ruian_katastr SET nazev = 'Strakonice' WHERE kod = 755915;
UPDATE ruian_katastr SET nazev = 'Nové Strakonice' WHERE kod = 755923;
UPDATE ruian_katastr SET nazev = 'Přední Ptákovice' WHERE kod = 755931;
UPDATE ruian_katastr SET nazev = 'Dražejov u Strakonic' WHERE kod = 755940;
UPDATE ruian_katastr SET nazev = 'Střela' WHERE kod = 755958;
UPDATE ruian_katastr SET nazev = 'Strakov' WHERE kod = 756041;
UPDATE ruian_katastr SET nazev = 'Straky' WHERE kod = 756059;
UPDATE ruian_katastr SET nazev = 'Strančice' WHERE kod = 756067;
UPDATE ruian_katastr SET nazev = 'Frankův Zhořec' WHERE kod = 756075;
UPDATE ruian_katastr SET nazev = 'Kochánov u Stránecké Zhoře' WHERE kod = 756083;
UPDATE ruian_katastr SET nazev = 'Nová Zhoř' WHERE kod = 756091;
UPDATE ruian_katastr SET nazev = 'Stránecká Zhoř' WHERE kod = 756105;
UPDATE ruian_katastr SET nazev = 'Strání' WHERE kod = 756113;
UPDATE ruian_katastr SET nazev = 'Straník' WHERE kod = 756130;
UPDATE ruian_katastr SET nazev = 'Kadlín' WHERE kod = 756148;
UPDATE ruian_katastr SET nazev = 'Ledce u Stránky' WHERE kod = 756156;
UPDATE ruian_katastr SET nazev = 'Ostrý' WHERE kod = 756164;
UPDATE ruian_katastr SET nazev = 'Stránka u Mšena' WHERE kod = 756172;
UPDATE ruian_katastr SET nazev = 'Tajná' WHERE kod = 756181;
UPDATE ruian_katastr SET nazev = 'Stranná u Žirovnice' WHERE kod = 756199;
UPDATE ruian_katastr SET nazev = 'Stranný' WHERE kod = 756202;
UPDATE ruian_katastr SET nazev = 'Strašice v Pošumaví' WHERE kod = 756211;
UPDATE ruian_katastr SET nazev = 'Strašice' WHERE kod = 756229;
UPDATE ruian_katastr SET nazev = 'Strašín u Říčan' WHERE kod = 756237;
UPDATE ruian_katastr SET nazev = 'Nahořánky' WHERE kod = 756253;
UPDATE ruian_katastr SET nazev = 'Strašín u Sušice' WHERE kod = 756261;
UPDATE ruian_katastr SET nazev = 'Zuklín' WHERE kod = 756270;
UPDATE ruian_katastr SET nazev = 'Straškov' WHERE kod = 756288;
UPDATE ruian_katastr SET nazev = 'Vodochody' WHERE kod = 756296;
UPDATE ruian_katastr SET nazev = 'Strašnov' WHERE kod = 756300;
UPDATE ruian_katastr SET nazev = 'Strašov' WHERE kod = 756318;
UPDATE ruian_katastr SET nazev = 'Stratov' WHERE kod = 756326;
UPDATE ruian_katastr SET nazev = 'Pelechy' WHERE kod = 756334;
UPDATE ruian_katastr SET nazev = 'Stráž u Domažlic' WHERE kod = 756342;
UPDATE ruian_katastr SET nazev = 'Souměř' WHERE kod = 756351;
UPDATE ruian_katastr SET nazev = 'Stráž u Tachova' WHERE kod = 756369;
UPDATE ruian_katastr SET nazev = 'Stráž nad Nežárkou' WHERE kod = 756377;
UPDATE ruian_katastr SET nazev = 'Stráž nad Nisou' WHERE kod = 756393;
UPDATE ruian_katastr SET nazev = 'Svárov u Liberce' WHERE kod = 756407;
UPDATE ruian_katastr SET nazev = 'Korunní' WHERE kod = 756423;
UPDATE ruian_katastr SET nazev = 'Osvinov' WHERE kod = 756431;
UPDATE ruian_katastr SET nazev = 'Stráž nad Ohří' WHERE kod = 756440;
UPDATE ruian_katastr SET nazev = 'Peklo' WHERE kod = 756458;
UPDATE ruian_katastr SET nazev = 'Stráž pod Ralskem' WHERE kod = 756466;
UPDATE ruian_katastr SET nazev = 'Habří' WHERE kod = 756474;
UPDATE ruian_katastr SET nazev = 'Meziboří' WHERE kod = 756491;
UPDATE ruian_katastr SET nazev = 'Mitrov' WHERE kod = 756504;
UPDATE ruian_katastr SET nazev = 'Moravecké Janovice' WHERE kod = 756512;
UPDATE ruian_katastr SET nazev = 'Strážek' WHERE kod = 756521;
UPDATE ruian_katastr SET nazev = 'Maleny' WHERE kod = 756539;
UPDATE ruian_katastr SET nazev = 'Růžov na Moravě' WHERE kod = 756547;
UPDATE ruian_katastr SET nazev = 'Stražisko' WHERE kod = 756555;
UPDATE ruian_katastr SET nazev = 'Lomec' WHERE kod = 756571;
UPDATE ruian_katastr SET nazev = 'Strážkovice' WHERE kod = 756598;
UPDATE ruian_katastr SET nazev = 'Odolov' WHERE kod = 756601;
UPDATE ruian_katastr SET nazev = 'Petrovice u Strážkovic' WHERE kod = 756610;
UPDATE ruian_katastr SET nazev = 'Strážkovice v Podkrkonoší' WHERE kod = 756628;
UPDATE ruian_katastr SET nazev = 'Strážná' WHERE kod = 756636;
UPDATE ruian_katastr SET nazev = 'Strážné' WHERE kod = 756644;
UPDATE ruian_katastr SET nazev = 'Strážnice na Moravě' WHERE kod = 756652;
UPDATE ruian_katastr SET nazev = 'Hliniště' WHERE kod = 756661;
UPDATE ruian_katastr SET nazev = 'Řasnice' WHERE kod = 756679;
UPDATE ruian_katastr SET nazev = 'Strážný' WHERE kod = 756687;
UPDATE ruian_katastr SET nazev = 'Dolní Světlé Hory' WHERE kod = 756695;
UPDATE ruian_katastr SET nazev = 'Horní Světlé Hory' WHERE kod = 756709;
UPDATE ruian_katastr SET nazev = 'Silnice' WHERE kod = 756717;
UPDATE ruian_katastr SET nazev = 'Stodůlky u Strážného' WHERE kod = 756725;
UPDATE ruian_katastr SET nazev = 'České Hamry' WHERE kod = 756733;
UPDATE ruian_katastr SET nazev = 'Krotějov' WHERE kod = 756741;
UPDATE ruian_katastr SET nazev = 'Lehom' WHERE kod = 756750;
UPDATE ruian_katastr SET nazev = 'Lukavice u Strážova' WHERE kod = 756768;
UPDATE ruian_katastr SET nazev = 'Opálka' WHERE kod = 756776;
UPDATE ruian_katastr SET nazev = 'Rovná' WHERE kod = 756784;
UPDATE ruian_katastr SET nazev = 'Strážov na Šumavě' WHERE kod = 756806;
UPDATE ruian_katastr SET nazev = 'Zahorčice na Šumavě' WHERE kod = 756814;
UPDATE ruian_katastr SET nazev = 'Bořice u Mirotic' WHERE kod = 756822;
UPDATE ruian_katastr SET nazev = 'Jarotice' WHERE kod = 756831;
UPDATE ruian_katastr SET nazev = 'Stráž u Mirotic' WHERE kod = 756849;
UPDATE ruian_katastr SET nazev = 'Strážovice u Mirotic' WHERE kod = 756857;
UPDATE ruian_katastr SET nazev = 'Strážovice' WHERE kod = 756865;
UPDATE ruian_katastr SET nazev = 'Strenice' WHERE kod = 756873;
UPDATE ruian_katastr SET nazev = 'Strhaře' WHERE kod = 756881;
UPDATE ruian_katastr SET nazev = 'Hradiště nad Ohří' WHERE kod = 756903;
UPDATE ruian_katastr SET nazev = 'Strkovice' WHERE kod = 756911;
UPDATE ruian_katastr SET nazev = 'Jelcovy Lhotky' WHERE kod = 756920;
UPDATE ruian_katastr SET nazev = 'Strměchy' WHERE kod = 756938;
UPDATE ruian_katastr SET nazev = 'Leština u Strmilova' WHERE kod = 756946;
UPDATE ruian_katastr SET nazev = 'Nová Olešná' WHERE kod = 756954;
UPDATE ruian_katastr SET nazev = 'Strmilov' WHERE kod = 756962;
UPDATE ruian_katastr SET nazev = 'Strojetice' WHERE kod = 756971;
UPDATE ruian_katastr SET nazev = 'Běsno' WHERE kod = 756989;
UPDATE ruian_katastr SET nazev = 'Strojetice u Podbořan' WHERE kod = 756997;
UPDATE ruian_katastr SET nazev = 'Přívlaky' WHERE kod = 757004;
UPDATE ruian_katastr SET nazev = 'Stroupeč' WHERE kod = 757012;
UPDATE ruian_katastr SET nazev = 'Struhaře' WHERE kod = 757021;
UPDATE ruian_katastr SET nazev = 'Myslíč' WHERE kod = 757055;
UPDATE ruian_katastr SET nazev = 'Skalice u Benešova' WHERE kod = 757063;
UPDATE ruian_katastr SET nazev = 'Struhařov u Benešova' WHERE kod = 757071;
UPDATE ruian_katastr SET nazev = 'Struhařov u Mnichovic' WHERE kod = 757080;
UPDATE ruian_katastr SET nazev = 'Struhy' WHERE kod = 757098;
UPDATE ruian_katastr SET nazev = 'Protivec' WHERE kod = 757110;
UPDATE ruian_katastr SET nazev = 'Strunkovice nad Blanicí' WHERE kod = 757128;
UPDATE ruian_katastr SET nazev = 'Svojnice' WHERE kod = 757136;
UPDATE ruian_katastr SET nazev = 'Šipoun' WHERE kod = 757144;
UPDATE ruian_katastr SET nazev = 'Žíchovec' WHERE kod = 757152;
UPDATE ruian_katastr SET nazev = 'Přední Zborovice' WHERE kod = 757161;
UPDATE ruian_katastr SET nazev = 'Strunkovice nad Volyňkou' WHERE kod = 757179;
UPDATE ruian_katastr SET nazev = 'Strupčice' WHERE kod = 757195;
UPDATE ruian_katastr SET nazev = 'Strupšín' WHERE kod = 757209;
UPDATE ruian_katastr SET nazev = 'Pohoří u Stružince' WHERE kod = 757225;
UPDATE ruian_katastr SET nazev = 'Stružinec u Lomnice nad Popelkou' WHERE kod = 757233;
UPDATE ruian_katastr SET nazev = 'Tuhaň u Stružince' WHERE kod = 757241;
UPDATE ruian_katastr SET nazev = 'Horní Tašovice' WHERE kod = 757250;
UPDATE ruian_katastr SET nazev = 'Stružná' WHERE kod = 757276;
UPDATE ruian_katastr SET nazev = 'Žalmanov' WHERE kod = 757284;
UPDATE ruian_katastr SET nazev = 'Jezvé' WHERE kod = 757306;
UPDATE ruian_katastr SET nazev = 'Stráž u České Lípy' WHERE kod = 757314;
UPDATE ruian_katastr SET nazev = 'Stružnice' WHERE kod = 757322;
UPDATE ruian_katastr SET nazev = 'Strýčkovice' WHERE kod = 757349;
UPDATE ruian_katastr SET nazev = 'Strýčkovy' WHERE kod = 757357;
UPDATE ruian_katastr SET nazev = 'Středokluky' WHERE kod = 757381;
UPDATE ruian_katastr SET nazev = 'Středolesí' WHERE kod = 757390;
UPDATE ruian_katastr SET nazev = 'Střechov nad Sázavou' WHERE kod = 757411;
UPDATE ruian_katastr SET nazev = 'Střeleč' WHERE kod = 757420;
UPDATE ruian_katastr SET nazev = 'Střelice u Brna' WHERE kod = 757438;
UPDATE ruian_katastr SET nazev = 'Střelice u Jevišovic' WHERE kod = 757446;
UPDATE ruian_katastr SET nazev = 'Benkov u Střelic' WHERE kod = 757454;
UPDATE ruian_katastr SET nazev = 'Střelice u Litovle' WHERE kod = 757462;
UPDATE ruian_katastr SET nazev = 'Střelná na Moravě' WHERE kod = 757471;
UPDATE ruian_katastr SET nazev = 'Střelské Hoštice' WHERE kod = 757489;
UPDATE ruian_katastr SET nazev = 'Střemeníčko' WHERE kod = 757501;
UPDATE ruian_katastr SET nazev = 'Střemošice' WHERE kod = 757527;
UPDATE ruian_katastr SET nazev = 'Střemy' WHERE kod = 757535;
UPDATE ruian_katastr SET nazev = 'Nadslav' WHERE kod = 757551;
UPDATE ruian_katastr SET nazev = 'Střevač' WHERE kod = 757560;
UPDATE ruian_katastr SET nazev = 'Střezetice' WHERE kod = 757586;
UPDATE ruian_katastr SET nazev = 'Křištín' WHERE kod = 757594;
UPDATE ruian_katastr SET nazev = 'Střeziměř' WHERE kod = 757608;
UPDATE ruian_katastr SET nazev = 'Střezimíř' WHERE kod = 757624;
UPDATE ruian_katastr SET nazev = 'Stříbrná' WHERE kod = 757641;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Kraslic' WHERE kod = 757659;
UPDATE ruian_katastr SET nazev = 'Hradec u Stříbrné Skalice' WHERE kod = 757667;
UPDATE ruian_katastr SET nazev = 'Hradové Střimelice' WHERE kod = 757675;
UPDATE ruian_katastr SET nazev = 'Kostelní Střimelice' WHERE kod = 757683;
UPDATE ruian_katastr SET nazev = 'Stříbrná Skalice' WHERE kod = 757691;
UPDATE ruian_katastr SET nazev = 'Stříbrné Hory u Přibyslavi' WHERE kod = 757705;
UPDATE ruian_katastr SET nazev = 'Stříbrnice v Čechách' WHERE kod = 757713;
UPDATE ruian_katastr SET nazev = 'Stříbrnice u Uherského Hradiště' WHERE kod = 757730;
UPDATE ruian_katastr SET nazev = 'Stříbrnice nad Hanou' WHERE kod = 757748;
UPDATE ruian_katastr SET nazev = 'Nová Seninka' WHERE kod = 757756;
UPDATE ruian_katastr SET nazev = 'Stříbrnice' WHERE kod = 757764;
UPDATE ruian_katastr SET nazev = 'Dobětice' WHERE kod = 757772;
UPDATE ruian_katastr SET nazev = 'Milíkov u Stříbra' WHERE kod = 757799;
UPDATE ruian_katastr SET nazev = 'Stříbro' WHERE kod = 757837;
UPDATE ruian_katastr SET nazev = 'Stříbřec' WHERE kod = 757853;
UPDATE ruian_katastr SET nazev = 'Střílky' WHERE kod = 757861;
UPDATE ruian_katastr SET nazev = 'Střítež u Poličky' WHERE kod = 757870;
UPDATE ruian_katastr SET nazev = 'Střítež u Trutnova' WHERE kod = 757896;
UPDATE ruian_katastr SET nazev = 'Antonínův Důl' WHERE kod = 757900;
UPDATE ruian_katastr SET nazev = 'Střítež u Jihlavy' WHERE kod = 757918;
UPDATE ruian_katastr SET nazev = 'Střítež u Třebíče' WHERE kod = 757926;
UPDATE ruian_katastr SET nazev = 'Střítež' WHERE kod = 757934;
UPDATE ruian_katastr SET nazev = 'Střítež nad Bečvou' WHERE kod = 757942;
UPDATE ruian_katastr SET nazev = 'Střítež nad Ludinou' WHERE kod = 757969;
UPDATE ruian_katastr SET nazev = 'Střítež pod Křemešníkem' WHERE kod = 757985;
UPDATE ruian_katastr SET nazev = 'Bor u Božejova' WHERE kod = 757993;
UPDATE ruian_katastr SET nazev = 'Krumvald' WHERE kod = 758001;
UPDATE ruian_katastr SET nazev = 'Střítež u Božejova' WHERE kod = 758019;
UPDATE ruian_katastr SET nazev = 'Střítež u Černovic' WHERE kod = 758027;
UPDATE ruian_katastr SET nazev = 'Střížov nad Malší' WHERE kod = 758035;
UPDATE ruian_katastr SET nazev = 'Střížov u Chotěboře' WHERE kod = 758051;
UPDATE ruian_katastr SET nazev = 'Přímělkov' WHERE kod = 758060;
UPDATE ruian_katastr SET nazev = 'Střížov' WHERE kod = 758078;
UPDATE ruian_katastr SET nazev = 'Střížovice' WHERE kod = 758086;
UPDATE ruian_katastr SET nazev = 'Budkov u Střížovic' WHERE kod = 758094;
UPDATE ruian_katastr SET nazev = 'Střížovice u Kunžaku' WHERE kod = 758108;
UPDATE ruian_katastr SET nazev = 'Vlčice u Střížovic' WHERE kod = 758116;
UPDATE ruian_katastr SET nazev = 'Střížovice u Plzně' WHERE kod = 758124;
UPDATE ruian_katastr SET nazev = 'Střížovice u Kvasic' WHERE kod = 758132;
UPDATE ruian_katastr SET nazev = 'Pastviny u Studánky' WHERE kod = 758159;
UPDATE ruian_katastr SET nazev = 'Studánka u Aše' WHERE kod = 758167;
UPDATE ruian_katastr SET nazev = 'Studánka u Tachova' WHERE kod = 758175;
UPDATE ruian_katastr SET nazev = 'Studánka u Rumburku' WHERE kod = 758183;
UPDATE ruian_katastr SET nazev = 'Studená' WHERE kod = 758191;
UPDATE ruian_katastr SET nazev = 'Buková u Studené Loučky' WHERE kod = 758205;
UPDATE ruian_katastr SET nazev = 'Bušín u Studené Loučky' WHERE kod = 758213;
UPDATE ruian_katastr SET nazev = 'Studená Loučka' WHERE kod = 758221;
UPDATE ruian_katastr SET nazev = 'Studené' WHERE kod = 758248;
UPDATE ruian_katastr SET nazev = 'Martinice v Krkonoších' WHERE kod = 758256;
UPDATE ruian_katastr SET nazev = 'Rovnáčov' WHERE kod = 758264;
UPDATE ruian_katastr SET nazev = 'Studenec u Horek' WHERE kod = 758272;
UPDATE ruian_katastr SET nazev = 'Studenec u Trutnova' WHERE kod = 758281;
UPDATE ruian_katastr SET nazev = 'Studenec u Třebíče' WHERE kod = 758299;
UPDATE ruian_katastr SET nazev = 'Studeněves' WHERE kod = 758311;
UPDATE ruian_katastr SET nazev = 'Heřmanice u Nové Paky' WHERE kod = 758329;
UPDATE ruian_katastr SET nazev = 'Kumburský Újezd' WHERE kod = 758337;
UPDATE ruian_katastr SET nazev = 'Studénka u Nové Paky' WHERE kod = 758345;
UPDATE ruian_katastr SET nazev = 'Studénka nad Odrou' WHERE kod = 758396;
UPDATE ruian_katastr SET nazev = 'Butovice' WHERE kod = 758442;
UPDATE ruian_katastr SET nazev = 'Studený' WHERE kod = 758469;
UPDATE ruian_katastr SET nazev = 'Studnice u Lodhéřova' WHERE kod = 758477;
UPDATE ruian_katastr SET nazev = 'Košinov' WHERE kod = 758485;
UPDATE ruian_katastr SET nazev = 'Studnice u Hlinska' WHERE kod = 758493;
UPDATE ruian_katastr SET nazev = 'Zalíbené' WHERE kod = 758507;
UPDATE ruian_katastr SET nazev = 'Řešetova Lhota' WHERE kod = 758531;
UPDATE ruian_katastr SET nazev = 'Studnice u Náchoda' WHERE kod = 758540;
UPDATE ruian_katastr SET nazev = 'Třtice nad Olešnicí' WHERE kod = 758558;
UPDATE ruian_katastr SET nazev = 'Studnice u Telče' WHERE kod = 758574;
UPDATE ruian_katastr SET nazev = 'Studnice' WHERE kod = 758582;
UPDATE ruian_katastr SET nazev = 'Studnice u Vyškova' WHERE kod = 758604;
UPDATE ruian_katastr SET nazev = 'Stupava' WHERE kod = 758612;
UPDATE ruian_katastr SET nazev = 'Stvolínecké Petrovice' WHERE kod = 758647;
UPDATE ruian_katastr SET nazev = 'Stvolínky' WHERE kod = 758655;
UPDATE ruian_katastr SET nazev = 'Stvolny' WHERE kod = 758671;
UPDATE ruian_katastr SET nazev = 'Stvolová' WHERE kod = 758680;
UPDATE ruian_katastr SET nazev = 'Skřib' WHERE kod = 758698;
UPDATE ruian_katastr SET nazev = 'Vlkov u Letovic' WHERE kod = 758701;
UPDATE ruian_katastr SET nazev = 'Kamenná Lhota u Čestína' WHERE kod = 758710;
UPDATE ruian_katastr SET nazev = 'Sudějov' WHERE kod = 758728;
UPDATE ruian_katastr SET nazev = 'Sudice u Boskovic' WHERE kod = 758736;
UPDATE ruian_katastr SET nazev = 'Sudice u Náměště nad Oslavou' WHERE kod = 758744;
UPDATE ruian_katastr SET nazev = 'Sudice' WHERE kod = 758752;
UPDATE ruian_katastr SET nazev = 'Sudislav nad Orlicí' WHERE kod = 758761;
UPDATE ruian_katastr SET nazev = 'Sudkov' WHERE kod = 758779;
UPDATE ruian_katastr SET nazev = 'Sudkův Důl' WHERE kod = 758787;
UPDATE ruian_katastr SET nazev = 'Sudoměř' WHERE kod = 758795;
UPDATE ruian_katastr SET nazev = 'Sudoměřice' WHERE kod = 758817;
UPDATE ruian_katastr SET nazev = 'Bechyňská Smoleč' WHERE kod = 758825;
UPDATE ruian_katastr SET nazev = 'Bežerovice' WHERE kod = 758833;
UPDATE ruian_katastr SET nazev = 'Černýšovice' WHERE kod = 758841;
UPDATE ruian_katastr SET nazev = 'Sudoměřice u Bechyně' WHERE kod = 758876;
UPDATE ruian_katastr SET nazev = 'Sudoměřice u Tábora' WHERE kod = 758884;
UPDATE ruian_katastr SET nazev = 'Sudovo Hlavno' WHERE kod = 758892;
UPDATE ruian_katastr SET nazev = 'Sudslava' WHERE kod = 758906;
UPDATE ruian_katastr SET nazev = 'Suchá u Nejdku' WHERE kod = 758931;
UPDATE ruian_katastr SET nazev = 'Květnov' WHERE kod = 758949;
UPDATE ruian_katastr SET nazev = 'Suchá u Havlíčkova Brodu' WHERE kod = 758965;
UPDATE ruian_katastr SET nazev = 'Suchá u Nechanic' WHERE kod = 758981;
UPDATE ruian_katastr SET nazev = 'Beranovec' WHERE kod = 758990;
UPDATE ruian_katastr SET nazev = 'Prostředkovice' WHERE kod = 759007;
UPDATE ruian_katastr SET nazev = 'Suchá u Jihlavy' WHERE kod = 759015;
UPDATE ruian_katastr SET nazev = 'Suchá Lhota' WHERE kod = 759023;
UPDATE ruian_katastr SET nazev = 'Suchá Loz' WHERE kod = 759031;
UPDATE ruian_katastr SET nazev = 'Dobřeň u Kutné Hory' WHERE kod = 759058;
UPDATE ruian_katastr SET nazev = 'Malenovice u Kutné Hory' WHERE kod = 759066;
UPDATE ruian_katastr SET nazev = 'Solopysky u Kutné Hory' WHERE kod = 759074;
UPDATE ruian_katastr SET nazev = 'Suchdol u Kutné Hory' WHERE kod = 759082;
UPDATE ruian_katastr SET nazev = 'Labutice' WHERE kod = 759112;
UPDATE ruian_katastr SET nazev = 'Suchdol u Konice' WHERE kod = 759121;
UPDATE ruian_katastr SET nazev = 'Suchdol nad Lužnicí' WHERE kod = 759147;
UPDATE ruian_katastr SET nazev = 'Suchdol nad Odrou' WHERE kod = 759163;
UPDATE ruian_katastr SET nazev = 'Suché Lazce' WHERE kod = 759180;
UPDATE ruian_katastr SET nazev = 'Liha' WHERE kod = 759198;
UPDATE ruian_katastr SET nazev = 'Suchodol' WHERE kod = 759201;
UPDATE ruian_katastr SET nazev = 'Suchohrdly u Miroslavi' WHERE kod = 759210;
UPDATE ruian_katastr SET nazev = 'Suchohrdly u Znojma' WHERE kod = 759228;
UPDATE ruian_katastr SET nazev = 'Suchomasty' WHERE kod = 759244;
UPDATE ruian_katastr SET nazev = 'Hostkovice' WHERE kod = 759252;
UPDATE ruian_katastr SET nazev = 'Přestavlky' WHERE kod = 759261;
UPDATE ruian_katastr SET nazev = 'Suchonice' WHERE kod = 759279;
UPDATE ruian_katastr SET nazev = 'Suchov' WHERE kod = 759287;
UPDATE ruian_katastr SET nazev = 'Suchovršice' WHERE kod = 759309;
UPDATE ruian_katastr SET nazev = 'Suchý' WHERE kod = 759317;
UPDATE ruian_katastr SET nazev = 'Slavný' WHERE kod = 759325;
UPDATE ruian_katastr SET nazev = 'Suchý Důl' WHERE kod = 759333;
UPDATE ruian_katastr SET nazev = 'Sukorady u Mladé Boleslavi' WHERE kod = 759350;
UPDATE ruian_katastr SET nazev = 'Mošnice' WHERE kod = 759368;
UPDATE ruian_katastr SET nazev = 'Sukorady' WHERE kod = 759376;
UPDATE ruian_katastr SET nazev = 'Velký Hubenov' WHERE kod = 759384;
UPDATE ruian_katastr SET nazev = 'Sukorady u Hořic' WHERE kod = 759406;
UPDATE ruian_katastr SET nazev = 'Sulejovice' WHERE kod = 759414;
UPDATE ruian_katastr SET nazev = 'Sulice' WHERE kod = 759431;
UPDATE ruian_katastr SET nazev = 'Sulíkov' WHERE kod = 759457;
UPDATE ruian_katastr SET nazev = 'Vřesice' WHERE kod = 759465;
UPDATE ruian_katastr SET nazev = 'Karolín u Sulimova' WHERE kod = 759473;
UPDATE ruian_katastr SET nazev = 'Sulimov' WHERE kod = 759481;
UPDATE ruian_katastr SET nazev = 'Vrbka u Sulimova' WHERE kod = 759490;
UPDATE ruian_katastr SET nazev = 'Sulislav' WHERE kod = 759503;
UPDATE ruian_katastr SET nazev = 'Polom u Sulkovce' WHERE kod = 759511;
UPDATE ruian_katastr SET nazev = 'Sulkovec' WHERE kod = 759520;
UPDATE ruian_katastr SET nazev = 'Ubušínek' WHERE kod = 759538;
UPDATE ruian_katastr SET nazev = 'Lišice u Sulovic' WHERE kod = 759546;
UPDATE ruian_katastr SET nazev = 'Sulovice' WHERE kod = 759554;
UPDATE ruian_katastr SET nazev = 'Sumrakov' WHERE kod = 759562;
UPDATE ruian_katastr SET nazev = 'Supíkovice' WHERE kod = 759571;
UPDATE ruian_katastr SET nazev = 'Sušany' WHERE kod = 759597;
UPDATE ruian_katastr SET nazev = 'Sušice nad Otavou' WHERE kod = 759601;
UPDATE ruian_katastr SET nazev = 'Dobršín' WHERE kod = 759635;
UPDATE ruian_katastr SET nazev = 'Rok' WHERE kod = 759678;
UPDATE ruian_katastr SET nazev = 'Vrabcov' WHERE kod = 759686;
UPDATE ruian_katastr SET nazev = 'Albrechtice u Sušice' WHERE kod = 759694;
UPDATE ruian_katastr SET nazev = 'Milčice u Sušice' WHERE kod = 759708;
UPDATE ruian_katastr SET nazev = 'Humpolec u Sušice' WHERE kod = 759716;
UPDATE ruian_katastr SET nazev = 'Divišov u Sušice' WHERE kod = 759724;
UPDATE ruian_katastr SET nazev = 'Nuzerov' WHERE kod = 759732;
UPDATE ruian_katastr SET nazev = 'Dolní Staňkov' WHERE kod = 759741;
UPDATE ruian_katastr SET nazev = 'Červené Dvorce' WHERE kod = 759759;
UPDATE ruian_katastr SET nazev = 'Sušice u Uherského Hradiště' WHERE kod = 759783;
UPDATE ruian_katastr SET nazev = 'Sušice u Přerova' WHERE kod = 759791;
UPDATE ruian_katastr SET nazev = 'Budov u Svádova' WHERE kod = 759805;
UPDATE ruian_katastr SET nazev = 'Olešnice u Svádova' WHERE kod = 759813;
UPDATE ruian_katastr SET nazev = 'Svádov' WHERE kod = 759830;
UPDATE ruian_katastr SET nazev = 'Svahy' WHERE kod = 759856;
UPDATE ruian_katastr SET nazev = 'Vížka' WHERE kod = 759864;
UPDATE ruian_katastr SET nazev = 'Zliv nad Mží' WHERE kod = 759872;
UPDATE ruian_katastr SET nazev = 'Svárov u Unhoště' WHERE kod = 759899;
UPDATE ruian_katastr SET nazev = 'Svárov u Velkých Opatovic' WHERE kod = 759902;
UPDATE ruian_katastr SET nazev = 'Svárov u Uherského Hradiště' WHERE kod = 759911;
UPDATE ruian_katastr SET nazev = 'Milíkovice' WHERE kod = 759937;
UPDATE ruian_katastr SET nazev = 'Svaryšov' WHERE kod = 759945;
UPDATE ruian_katastr SET nazev = 'Svařeň' WHERE kod = 759953;
UPDATE ruian_katastr SET nazev = 'Svatá' WHERE kod = 759961;
UPDATE ruian_katastr SET nazev = 'Svatá Maří' WHERE kod = 759970;
UPDATE ruian_katastr SET nazev = 'Trhonín' WHERE kod = 759988;
UPDATE ruian_katastr SET nazev = 'Čistá u Svatavy' WHERE kod = 760005;
UPDATE ruian_katastr SET nazev = 'Svatava' WHERE kod = 760021;
UPDATE ruian_katastr SET nazev = 'Svaté Pole' WHERE kod = 760056;
UPDATE ruian_katastr SET nazev = 'Rakov u Svatkovic' WHERE kod = 760064;
UPDATE ruian_katastr SET nazev = 'Svatkovice' WHERE kod = 760072;
UPDATE ruian_katastr SET nazev = 'Mistřín' WHERE kod = 760081;
UPDATE ruian_katastr SET nazev = 'Svatobořice' WHERE kod = 760099;
UPDATE ruian_katastr SET nazev = 'Svatoslav u Tišnova' WHERE kod = 760102;
UPDATE ruian_katastr SET nazev = 'Svatoslav u Třebíče' WHERE kod = 760111;
UPDATE ruian_katastr SET nazev = 'Bražná' WHERE kod = 760129;
UPDATE ruian_katastr SET nazev = 'Drážkov' WHERE kod = 760145;
UPDATE ruian_katastr SET nazev = 'Hojšín' WHERE kod = 760153;
UPDATE ruian_katastr SET nazev = 'Hrachov' WHERE kod = 760161;
UPDATE ruian_katastr SET nazev = 'Skrýšov u Svatého Jana' WHERE kod = 760188;
UPDATE ruian_katastr SET nazev = 'Chlum nad Malší' WHERE kod = 760218;
UPDATE ruian_katastr SET nazev = 'Sedlce' WHERE kod = 760226;
UPDATE ruian_katastr SET nazev = 'Svatý Jan nad Malší' WHERE kod = 760234;
UPDATE ruian_katastr SET nazev = 'Svatý Jan pod Skalou' WHERE kod = 760269;
UPDATE ruian_katastr SET nazev = 'Svébohov' WHERE kod = 760285;
UPDATE ruian_katastr SET nazev = 'Svépravice' WHERE kod = 760293;
UPDATE ruian_katastr SET nazev = 'Svéradice' WHERE kod = 760307;
UPDATE ruian_katastr SET nazev = 'Svésedlice' WHERE kod = 760315;
UPDATE ruian_katastr SET nazev = 'Světce' WHERE kod = 760323;
UPDATE ruian_katastr SET nazev = 'Chotějovice' WHERE kod = 760331;
UPDATE ruian_katastr SET nazev = 'Chotovenka' WHERE kod = 760340;
UPDATE ruian_katastr SET nazev = 'Světec' WHERE kod = 760366;
UPDATE ruian_katastr SET nazev = 'Štrbice' WHERE kod = 760374;
UPDATE ruian_katastr SET nazev = 'Pohradice' WHERE kod = 760382;
UPDATE ruian_katastr SET nazev = 'Světice u Říčan' WHERE kod = 760391;
UPDATE ruian_katastr SET nazev = 'Světlá pod Javořicí' WHERE kod = 760404;
UPDATE ruian_katastr SET nazev = 'Andělská Hora ve Slezsku' WHERE kod = 760412;
UPDATE ruian_katastr SET nazev = 'Dětřichovice' WHERE kod = 760421;
UPDATE ruian_katastr SET nazev = 'Stará Voda v Jeseníkách' WHERE kod = 760447;
UPDATE ruian_katastr SET nazev = 'Suchá Rudná' WHERE kod = 760455;
UPDATE ruian_katastr SET nazev = 'Světlá ve Slezsku' WHERE kod = 760463;
UPDATE ruian_katastr SET nazev = 'Dolní Bohušice' WHERE kod = 760471;
UPDATE ruian_katastr SET nazev = 'Horní Bohušice' WHERE kod = 760480;
UPDATE ruian_katastr SET nazev = 'Světlá nad Sázavou' WHERE kod = 760510;
UPDATE ruian_katastr SET nazev = 'Závidkovice' WHERE kod = 760536;
UPDATE ruian_katastr SET nazev = 'Žebrákov u Světlé nad Sázavou' WHERE kod = 760544;
UPDATE ruian_katastr SET nazev = 'Světlá pod Ještědem' WHERE kod = 760579;
UPDATE ruian_katastr SET nazev = 'Světlice' WHERE kod = 760587;
UPDATE ruian_katastr SET nazev = 'Skubice' WHERE kod = 760609;
UPDATE ruian_katastr SET nazev = 'Svéraz' WHERE kod = 760617;
UPDATE ruian_katastr SET nazev = 'Světlík' WHERE kod = 760625;
UPDATE ruian_katastr SET nazev = 'Dvořetín' WHERE kod = 760633;
UPDATE ruian_katastr SET nazev = 'Pasovary' WHERE kod = 760641;
UPDATE ruian_katastr SET nazev = 'Cikháj' WHERE kod = 760650;
UPDATE ruian_katastr SET nazev = 'Světnov' WHERE kod = 760668;
UPDATE ruian_katastr SET nazev = 'Sviadnov' WHERE kod = 760676;
UPDATE ruian_katastr SET nazev = 'Svídnice u Dymokur' WHERE kod = 760684;
UPDATE ruian_katastr SET nazev = 'Svídnice u Slatiňan' WHERE kod = 760706;
UPDATE ruian_katastr SET nazev = 'Trpišov' WHERE kod = 760714;
UPDATE ruian_katastr SET nazev = 'Svijanský Újezd' WHERE kod = 760731;
UPDATE ruian_katastr SET nazev = 'Svijany' WHERE kod = 760749;
UPDATE ruian_katastr SET nazev = 'Svinary' WHERE kod = 760765;
UPDATE ruian_katastr SET nazev = 'Svinaře' WHERE kod = 760790;
UPDATE ruian_katastr SET nazev = 'Svinařov u Kladna' WHERE kod = 760803;
UPDATE ruian_katastr SET nazev = 'Svinařov' WHERE kod = 760811;
UPDATE ruian_katastr SET nazev = 'Raškovice u Přelouče' WHERE kod = 760820;
UPDATE ruian_katastr SET nazev = 'Svinčany' WHERE kod = 760854;
UPDATE ruian_katastr SET nazev = 'Svinětice' WHERE kod = 760862;
UPDATE ruian_katastr SET nazev = 'Svinný' WHERE kod = 760871;
UPDATE ruian_katastr SET nazev = 'Svinošice' WHERE kod = 760889;
UPDATE ruian_katastr SET nazev = 'Kundratice u Svinů' WHERE kod = 760897;
UPDATE ruian_katastr SET nazev = 'Sviny' WHERE kod = 760901;
UPDATE ruian_katastr SET nazev = 'Sviny u Křižanova' WHERE kod = 760927;
UPDATE ruian_katastr SET nazev = 'Sasina' WHERE kod = 760935;
UPDATE ruian_katastr SET nazev = 'Svitávka' WHERE kod = 760943;
UPDATE ruian_katastr SET nazev = 'Svitavy-město' WHERE kod = 760951;
UPDATE ruian_katastr SET nazev = 'Svitavy-předměstí' WHERE kod = 760960;
UPDATE ruian_katastr SET nazev = 'Moravský Lačnov' WHERE kod = 760994;
UPDATE ruian_katastr SET nazev = 'Čtyřicet Lánů' WHERE kod = 761001;
UPDATE ruian_katastr SET nazev = 'Maršov II' WHERE kod = 761087;
UPDATE ruian_katastr SET nazev = 'Svoboda nad Úpou' WHERE kod = 761095;
UPDATE ruian_katastr SET nazev = 'Maršov I' WHERE kod = 761109;
UPDATE ruian_katastr SET nazev = 'Svobodné Dvory' WHERE kod = 761125;
UPDATE ruian_katastr SET nazev = 'Svobodné Heřmanice' WHERE kod = 761133;
UPDATE ruian_katastr SET nazev = 'Svojanov' WHERE kod = 761141;
UPDATE ruian_katastr SET nazev = 'Svojek' WHERE kod = 761150;
UPDATE ruian_katastr SET nazev = 'Tample' WHERE kod = 761168;
UPDATE ruian_katastr SET nazev = 'Svojetice' WHERE kod = 761176;
UPDATE ruian_katastr SET nazev = 'Svojetín' WHERE kod = 761184;
UPDATE ruian_katastr SET nazev = 'Veclov u Svojetína' WHERE kod = 761192;
UPDATE ruian_katastr SET nazev = 'Svojkov' WHERE kod = 761214;
UPDATE ruian_katastr SET nazev = 'Svojkovice' WHERE kod = 761222;
UPDATE ruian_katastr SET nazev = 'Svojkovice na Moravě' WHERE kod = 761231;
UPDATE ruian_katastr SET nazev = 'Bošice u Kouřimi' WHERE kod = 761249;
UPDATE ruian_katastr SET nazev = 'Krychnov' WHERE kod = 761265;
UPDATE ruian_katastr SET nazev = 'Poboří' WHERE kod = 761281;
UPDATE ruian_katastr SET nazev = 'Svojšice u Kouřimi' WHERE kod = 761290;
UPDATE ruian_katastr SET nazev = 'Kletice' WHERE kod = 761311;
UPDATE ruian_katastr SET nazev = 'Nestrašovice' WHERE kod = 761320;
UPDATE ruian_katastr SET nazev = 'Svojšice' WHERE kod = 761338;
UPDATE ruian_katastr SET nazev = 'Tušovice' WHERE kod = 761346;
UPDATE ruian_katastr SET nazev = 'Částkov u Svojšic' WHERE kod = 761362;
UPDATE ruian_katastr SET nazev = 'Maršovice u Svojšic' WHERE kod = 761371;
UPDATE ruian_katastr SET nazev = 'Svojšice u Sušice' WHERE kod = 761389;
UPDATE ruian_katastr SET nazev = 'Žikov' WHERE kod = 761397;
UPDATE ruian_katastr SET nazev = 'Svojšice u Choltic' WHERE kod = 761401;
UPDATE ruian_katastr SET nazev = 'Holyně u Svojšína' WHERE kod = 761427;
UPDATE ruian_katastr SET nazev = 'Nynkov' WHERE kod = 761435;
UPDATE ruian_katastr SET nazev = 'Řebří' WHERE kod = 761443;
UPDATE ruian_katastr SET nazev = 'Svojšín' WHERE kod = 761451;
UPDATE ruian_katastr SET nazev = 'Otice u Svojšovic' WHERE kod = 761460;
UPDATE ruian_katastr SET nazev = 'Svojšovice' WHERE kod = 761478;
UPDATE ruian_katastr SET nazev = 'Svor' WHERE kod = 761494;
UPDATE ruian_katastr SET nazev = 'Nasavrky u Tábora' WHERE kod = 761516;
UPDATE ruian_katastr SET nazev = 'Svrabov' WHERE kod = 761524;
UPDATE ruian_katastr SET nazev = 'Česká Cikánka' WHERE kod = 761532;
UPDATE ruian_katastr SET nazev = 'Moravská Cikánka' WHERE kod = 761541;
UPDATE ruian_katastr SET nazev = 'Moravská Svratka' WHERE kod = 761559;
UPDATE ruian_katastr SET nazev = 'Svratka' WHERE kod = 761567;
UPDATE ruian_katastr SET nazev = 'Svratouch' WHERE kod = 761583;
UPDATE ruian_katastr SET nazev = 'Hole u Svrkyně' WHERE kod = 761591;
UPDATE ruian_katastr SET nazev = 'Svrkyně' WHERE kod = 761605;
UPDATE ruian_katastr SET nazev = 'Svučice' WHERE kod = 761621;
UPDATE ruian_katastr SET nazev = 'Sýčina' WHERE kod = 761630;
UPDATE ruian_katastr SET nazev = 'Čtveřín' WHERE kod = 761648;
UPDATE ruian_katastr SET nazev = 'Lažany u Sychrova' WHERE kod = 761672;
UPDATE ruian_katastr SET nazev = 'Paceřice' WHERE kod = 761681;
UPDATE ruian_katastr SET nazev = 'Radimovice u Sychrova' WHERE kod = 761699;
UPDATE ruian_katastr SET nazev = 'Žďárek u Sychrova' WHERE kod = 761729;
UPDATE ruian_katastr SET nazev = 'Sýkořice' WHERE kod = 761737;
UPDATE ruian_katastr SET nazev = 'Synalov' WHERE kod = 761753;
UPDATE ruian_katastr SET nazev = 'Bor u Chroustovic' WHERE kod = 761761;
UPDATE ruian_katastr SET nazev = 'Brčekoly' WHERE kod = 761770;
UPDATE ruian_katastr SET nazev = 'Synčany' WHERE kod = 761788;
UPDATE ruian_katastr SET nazev = 'Slemeno u Rychnova nad Kněžnou' WHERE kod = 761800;
UPDATE ruian_katastr SET nazev = 'Synkov' WHERE kod = 761818;
UPDATE ruian_katastr SET nazev = 'Syrovátka' WHERE kod = 761826;
UPDATE ruian_katastr SET nazev = 'Syrovice' WHERE kod = 761834;
UPDATE ruian_katastr SET nazev = 'Syrovín' WHERE kod = 761842;
UPDATE ruian_katastr SET nazev = 'Syřenov' WHERE kod = 761851;
UPDATE ruian_katastr SET nazev = 'Žďár u Kumburku' WHERE kod = 761877;
UPDATE ruian_katastr SET nazev = 'Lhota u Stříbra' WHERE kod = 761885;
UPDATE ruian_katastr SET nazev = 'Sytno' WHERE kod = 761893;
UPDATE ruian_katastr SET nazev = 'Šafov' WHERE kod = 761907;
UPDATE ruian_katastr SET nazev = 'Šakvice' WHERE kod = 761915;
UPDATE ruian_katastr SET nazev = 'Šalmanovice' WHERE kod = 761940;
UPDATE ruian_katastr SET nazev = 'Šanov u Rakovníka' WHERE kod = 761958;
UPDATE ruian_katastr SET nazev = 'Šanov' WHERE kod = 761966;
UPDATE ruian_katastr SET nazev = 'Šanov nad Jevišovkou' WHERE kod = 762016;
UPDATE ruian_katastr SET nazev = 'Šaplava' WHERE kod = 762032;
UPDATE ruian_katastr SET nazev = 'Šaratice' WHERE kod = 762041;
UPDATE ruian_katastr SET nazev = 'Šardice' WHERE kod = 762059;
UPDATE ruian_katastr SET nazev = 'Šarovy' WHERE kod = 762067;
UPDATE ruian_katastr SET nazev = 'Šatov' WHERE kod = 762075;
UPDATE ruian_katastr SET nazev = 'Strnadice' WHERE kod = 762105;
UPDATE ruian_katastr SET nazev = 'Šebáňovice' WHERE kod = 762113;
UPDATE ruian_katastr SET nazev = 'Šeberov' WHERE kod = 762130;
UPDATE ruian_katastr SET nazev = 'Březí u Šebestěnic' WHERE kod = 762148;
UPDATE ruian_katastr SET nazev = 'Šebestěnice' WHERE kod = 762156;
UPDATE ruian_katastr SET nazev = 'Zbudovice' WHERE kod = 762164;
UPDATE ruian_katastr SET nazev = 'Světlá u Šebetova' WHERE kod = 762172;
UPDATE ruian_katastr SET nazev = 'Šebetov' WHERE kod = 762181;
UPDATE ruian_katastr SET nazev = 'Šebířov' WHERE kod = 762211;
UPDATE ruian_katastr SET nazev = 'Záříčí u Mladé Vožice' WHERE kod = 762229;
UPDATE ruian_katastr SET nazev = 'Milatice' WHERE kod = 762237;
UPDATE ruian_katastr SET nazev = 'Šebkovice' WHERE kod = 762245;
UPDATE ruian_katastr SET nazev = 'Svatá Kateřina' WHERE kod = 762253;
UPDATE ruian_katastr SET nazev = 'Šebrov' WHERE kod = 762261;
UPDATE ruian_katastr SET nazev = 'Šedivec' WHERE kod = 762270;
UPDATE ruian_katastr SET nazev = 'Pulovice' WHERE kod = 762296;
UPDATE ruian_katastr SET nazev = 'Sedlečko u Karlových Var' WHERE kod = 762300;
UPDATE ruian_katastr SET nazev = 'Šemnice' WHERE kod = 762318;
UPDATE ruian_katastr SET nazev = 'Šenov u Ostravy' WHERE kod = 762342;
UPDATE ruian_katastr SET nazev = 'Šerkovice' WHERE kod = 762377;
UPDATE ruian_katastr SET nazev = 'Šestajovice u Prahy' WHERE kod = 762385;
UPDATE ruian_katastr SET nazev = 'Roztoky nad Metují' WHERE kod = 762393;
UPDATE ruian_katastr SET nazev = 'Šestajovice u Jaroměře' WHERE kod = 762407;
UPDATE ruian_katastr SET nazev = 'Dolní Rápotice' WHERE kod = 762415;
UPDATE ruian_katastr SET nazev = 'Šetějovice' WHERE kod = 762423;
UPDATE ruian_katastr SET nazev = 'Žibřidovice' WHERE kod = 762431;
UPDATE ruian_katastr SET nazev = 'Mazelov' WHERE kod = 762440;
UPDATE ruian_katastr SET nazev = 'Ševětín' WHERE kod = 762458;
UPDATE ruian_katastr SET nazev = 'Šilheřovice' WHERE kod = 762474;
UPDATE ruian_katastr SET nazev = 'Šimanov na Moravě' WHERE kod = 762482;
UPDATE ruian_katastr SET nazev = 'Minkovice' WHERE kod = 762504;
UPDATE ruian_katastr SET nazev = 'Rašovka' WHERE kod = 762512;
UPDATE ruian_katastr SET nazev = 'Šimonovice' WHERE kod = 762521;
UPDATE ruian_katastr SET nazev = 'Krásná Lípa u Šindelové' WHERE kod = 762539;
UPDATE ruian_katastr SET nazev = 'Obora u Šindelové' WHERE kod = 762547;
UPDATE ruian_katastr SET nazev = 'Ptačí' WHERE kod = 762555;
UPDATE ruian_katastr SET nazev = 'Šindelová' WHERE kod = 762563;
UPDATE ruian_katastr SET nazev = 'Milíře u Šindelové' WHERE kod = 762580;
UPDATE ruian_katastr SET nazev = 'Milíčov' WHERE kod = 762601;
UPDATE ruian_katastr SET nazev = 'Šípy' WHERE kod = 762610;
UPDATE ruian_katastr SET nazev = 'Skrbovice' WHERE kod = 762636;
UPDATE ruian_katastr SET nazev = 'Široká Niva' WHERE kod = 762644;
UPDATE ruian_katastr SET nazev = 'Markvartice u Široké Nivy' WHERE kod = 762652;
UPDATE ruian_katastr SET nazev = 'Široký Důl' WHERE kod = 762661;
UPDATE ruian_katastr SET nazev = 'Šišma' WHERE kod = 762679;
UPDATE ruian_katastr SET nazev = 'Šitbořice' WHERE kod = 762687;
UPDATE ruian_katastr SET nazev = 'Škodějov' WHERE kod = 762695;
UPDATE ruian_katastr SET nazev = 'Škrdlovice' WHERE kod = 762709;
UPDATE ruian_katastr SET nazev = 'Škůdra' WHERE kod = 762717;
UPDATE ruian_katastr SET nazev = 'Zvotoky' WHERE kod = 762725;
UPDATE ruian_katastr SET nazev = 'Škvorec' WHERE kod = 762733;
UPDATE ruian_katastr SET nazev = 'Třebohostice u Škvorce' WHERE kod = 762741;
UPDATE ruian_katastr SET nazev = 'Pacelice' WHERE kod = 762750;
UPDATE ruian_katastr SET nazev = 'Škvořetice' WHERE kod = 762768;
UPDATE ruian_katastr SET nazev = 'Šlapanice v Čechách' WHERE kod = 762784;
UPDATE ruian_katastr SET nazev = 'Šlapanice u Brna' WHERE kod = 762792;
UPDATE ruian_katastr SET nazev = 'Kněžská' WHERE kod = 762806;
UPDATE ruian_katastr SET nazev = 'Šachotín' WHERE kod = 762814;
UPDATE ruian_katastr SET nazev = 'Šlapanov' WHERE kod = 762822;
UPDATE ruian_katastr SET nazev = 'Šlovice u Plzně' WHERE kod = 762831;
UPDATE ruian_katastr SET nazev = 'Císařský' WHERE kod = 762849;
UPDATE ruian_katastr SET nazev = 'Královka' WHERE kod = 762857;
UPDATE ruian_katastr SET nazev = 'Kunratice u Šluknova' WHERE kod = 762865;
UPDATE ruian_katastr SET nazev = 'Nové Hraběcí' WHERE kod = 762873;
UPDATE ruian_katastr SET nazev = 'Rožany' WHERE kod = 762881;
UPDATE ruian_katastr SET nazev = 'Šluknov' WHERE kod = 762890;
UPDATE ruian_katastr SET nazev = 'Šonov u Broumova' WHERE kod = 762903;
UPDATE ruian_katastr SET nazev = 'Šonov u Nového Města nad Metují' WHERE kod = 762920;
UPDATE ruian_katastr SET nazev = 'Šošůvka' WHERE kod = 762938;
UPDATE ruian_katastr SET nazev = 'Hranické Loučky' WHERE kod = 762946;
UPDATE ruian_katastr SET nazev = 'Špičky' WHERE kod = 762954;
UPDATE ruian_katastr SET nazev = 'Bedřichov v Krkonoších' WHERE kod = 762962;
UPDATE ruian_katastr SET nazev = 'Labská' WHERE kod = 763012;
UPDATE ruian_katastr SET nazev = 'Přední Labská' WHERE kod = 763063;
UPDATE ruian_katastr SET nazev = 'Špindlerův Mlýn' WHERE kod = 763098;
UPDATE ruian_katastr SET nazev = 'Štáblovice' WHERE kod = 763110;
UPDATE ruian_katastr SET nazev = 'Nezbavětice' WHERE kod = 763136;
UPDATE ruian_katastr SET nazev = 'Šťáhlavice' WHERE kod = 763144;
UPDATE ruian_katastr SET nazev = 'Šťáhlavy' WHERE kod = 763152;
UPDATE ruian_katastr SET nazev = 'Štarnov' WHERE kod = 763161;
UPDATE ruian_katastr SET nazev = 'Brložec u Štědré' WHERE kod = 763179;
UPDATE ruian_katastr SET nazev = 'Lažany u Štědré' WHERE kod = 763187;
UPDATE ruian_katastr SET nazev = 'Mostec' WHERE kod = 763195;
UPDATE ruian_katastr SET nazev = 'Přestání' WHERE kod = 763209;
UPDATE ruian_katastr SET nazev = 'Štědrá' WHERE kod = 763217;
UPDATE ruian_katastr SET nazev = 'Štědrákova Lhota' WHERE kod = 763225;
UPDATE ruian_katastr SET nazev = 'Lačnov u Lysic' WHERE kod = 763233;
UPDATE ruian_katastr SET nazev = 'Štěchov' WHERE kod = 763241;
UPDATE ruian_katastr SET nazev = 'Štěchovice u Prahy' WHERE kod = 763250;
UPDATE ruian_katastr SET nazev = 'Štěchovice' WHERE kod = 763276;
UPDATE ruian_katastr SET nazev = 'Štěkeň' WHERE kod = 763292;
UPDATE ruian_katastr SET nazev = 'Vítkov u Štěkně' WHERE kod = 763306;
UPDATE ruian_katastr SET nazev = 'Štěměchy' WHERE kod = 763314;
UPDATE ruian_katastr SET nazev = 'Mravín' WHERE kod = 763322;
UPDATE ruian_katastr SET nazev = 'Štěnec' WHERE kod = 763331;
UPDATE ruian_katastr SET nazev = 'Štěnovice' WHERE kod = 763349;
UPDATE ruian_katastr SET nazev = 'Svatý Štěpán' WHERE kod = 763357;
UPDATE ruian_katastr SET nazev = 'Štěpánkovice' WHERE kod = 763390;
UPDATE ruian_katastr SET nazev = 'Štěpánov u Přelouče' WHERE kod = 763403;
UPDATE ruian_katastr SET nazev = 'Březce' WHERE kod = 763411;
UPDATE ruian_katastr SET nazev = 'Štěpánov u Olomouce' WHERE kod = 763438;
UPDATE ruian_katastr SET nazev = 'Borovec' WHERE kod = 763446;
UPDATE ruian_katastr SET nazev = 'Olešnička' WHERE kod = 763454;
UPDATE ruian_katastr SET nazev = 'Štěpánov nad Svratkou' WHERE kod = 763462;
UPDATE ruian_katastr SET nazev = 'Vrtěžíř' WHERE kod = 763471;
UPDATE ruian_katastr SET nazev = 'Štěpánovice u Českých Budějovic' WHERE kod = 763489;
UPDATE ruian_katastr SET nazev = 'Štěpánovice u Tišnova' WHERE kod = 763501;
UPDATE ruian_katastr SET nazev = 'Štěpkov' WHERE kod = 763519;
UPDATE ruian_katastr SET nazev = 'Šternberk' WHERE kod = 763527;
UPDATE ruian_katastr SET nazev = 'Lhota u Šternberka' WHERE kod = 763578;
UPDATE ruian_katastr SET nazev = 'Počeplice' WHERE kod = 763675;
UPDATE ruian_katastr SET nazev = 'Stračí' WHERE kod = 763683;
UPDATE ruian_katastr SET nazev = 'Štětí I' WHERE kod = 763691;
UPDATE ruian_katastr SET nazev = 'Štětice' WHERE kod = 763705;
UPDATE ruian_katastr SET nazev = 'Štětkovice' WHERE kod = 763730;
UPDATE ruian_katastr SET nazev = 'Křečov' WHERE kod = 763748;
UPDATE ruian_katastr SET nazev = 'Štichovice' WHERE kod = 763756;
UPDATE ruian_katastr SET nazev = 'Štikov' WHERE kod = 763764;
UPDATE ruian_katastr SET nazev = 'Bzí u Dolního Bukovska' WHERE kod = 763772;
UPDATE ruian_katastr SET nazev = 'Modrá Hůrka' WHERE kod = 763802;
UPDATE ruian_katastr SET nazev = 'Štipoklasy' WHERE kod = 763829;
UPDATE ruian_katastr SET nazev = 'Hašov' WHERE kod = 763837;
UPDATE ruian_katastr SET nazev = 'Svinná u Štítar' WHERE kod = 763845;
UPDATE ruian_katastr SET nazev = 'Štítary nad Radbuzou' WHERE kod = 763853;
UPDATE ruian_katastr SET nazev = 'Tasnovice' WHERE kod = 763861;
UPDATE ruian_katastr SET nazev = 'Štítary na Moravě' WHERE kod = 763870;
UPDATE ruian_katastr SET nazev = 'Štítina' WHERE kod = 763888;
UPDATE ruian_katastr SET nazev = 'Smrčná u Čkyně' WHERE kod = 763900;
UPDATE ruian_katastr SET nazev = 'Štítkov' WHERE kod = 763918;
UPDATE ruian_katastr SET nazev = 'Popov nad Vláří' WHERE kod = 763934;
UPDATE ruian_katastr SET nazev = 'Štítná nad Vláří' WHERE kod = 763942;
UPDATE ruian_katastr SET nazev = 'Štítné' WHERE kod = 763977;
UPDATE ruian_katastr SET nazev = 'Štítov u Blovic' WHERE kod = 763985;
UPDATE ruian_katastr SET nazev = 'Štíty-město' WHERE kod = 763993;
UPDATE ruian_katastr SET nazev = 'Štíty Hamerské' WHERE kod = 764027;
UPDATE ruian_katastr SET nazev = 'Studénka u Štoků' WHERE kod = 764043;
UPDATE ruian_katastr SET nazev = 'Štoky' WHERE kod = 764051;
UPDATE ruian_katastr SET nazev = 'Štramberk' WHERE kod = 764116;
UPDATE ruian_katastr SET nazev = 'Študlov u Vítějevsi' WHERE kod = 764124;
UPDATE ruian_katastr SET nazev = 'Študlov' WHERE kod = 764132;
UPDATE ruian_katastr SET nazev = 'Šubířov' WHERE kod = 764159;
UPDATE ruian_katastr SET nazev = 'Buk pod Boubínem' WHERE kod = 764167;
UPDATE ruian_katastr SET nazev = 'Kosmo' WHERE kod = 764175;
UPDATE ruian_katastr SET nazev = 'Šumavské Hoštice' WHERE kod = 764205;
UPDATE ruian_katastr SET nazev = 'Včelná pod Boubínem' WHERE kod = 764213;
UPDATE ruian_katastr SET nazev = 'Vyšovatka' WHERE kod = 764221;
UPDATE ruian_katastr SET nazev = 'Šumice u Uherského Brodu' WHERE kod = 764230;
UPDATE ruian_katastr SET nazev = 'Šumice' WHERE kod = 764248;
UPDATE ruian_katastr SET nazev = 'Šumná' WHERE kod = 764256;
UPDATE ruian_katastr SET nazev = 'Šumperk' WHERE kod = 764264;
UPDATE ruian_katastr SET nazev = 'Dolní Temenice' WHERE kod = 764442;
UPDATE ruian_katastr SET nazev = 'Horní Temenice' WHERE kod = 764469;
UPDATE ruian_katastr SET nazev = 'Šumvald' WHERE kod = 764515;
UPDATE ruian_katastr SET nazev = 'Švábenice' WHERE kod = 764523;
UPDATE ruian_katastr SET nazev = 'Švábov' WHERE kod = 764531;
UPDATE ruian_katastr SET nazev = 'Motyčín' WHERE kod = 764540;
UPDATE ruian_katastr SET nazev = 'Hnidousy' WHERE kod = 764558;
UPDATE ruian_katastr SET nazev = 'Švihov u Rakovníka' WHERE kod = 764566;
UPDATE ruian_katastr SET nazev = 'Kamýk u Švihova' WHERE kod = 764574;
UPDATE ruian_katastr SET nazev = 'Kokšín' WHERE kod = 764582;
UPDATE ruian_katastr SET nazev = 'Lhovice' WHERE kod = 764591;
UPDATE ruian_katastr SET nazev = 'Mezihoří u Švihova' WHERE kod = 764604;
UPDATE ruian_katastr SET nazev = 'Švihov u Klatov' WHERE kod = 764621;
UPDATE ruian_katastr SET nazev = 'Vosí' WHERE kod = 764647;
UPDATE ruian_katastr SET nazev = 'Švihov' WHERE kod = 764680;
UPDATE ruian_katastr SET nazev = 'Tábor' WHERE kod = 764701;
UPDATE ruian_katastr SET nazev = 'Tábor ve Slezsku' WHERE kod = 764817;
UPDATE ruian_katastr SET nazev = 'Tachlovice' WHERE kod = 764825;
UPDATE ruian_katastr SET nazev = 'Vítkov u Tachova' WHERE kod = 764833;
UPDATE ruian_katastr SET nazev = 'Tachov' WHERE kod = 764914;
UPDATE ruian_katastr SET nazev = 'Malý Rapotín' WHERE kod = 764922;
UPDATE ruian_katastr SET nazev = 'Oldřichov u Tachova' WHERE kod = 764949;
UPDATE ruian_katastr SET nazev = 'Tachov u Doks' WHERE kod = 764957;
UPDATE ruian_katastr SET nazev = 'Bílkovice' WHERE kod = 764965;
UPDATE ruian_katastr SET nazev = 'Paseky u Písku' WHERE kod = 765007;
UPDATE ruian_katastr SET nazev = 'Tálín' WHERE kod = 765015;
UPDATE ruian_katastr SET nazev = 'Tanvald' WHERE kod = 765023;
UPDATE ruian_katastr SET nazev = 'Šumburk nad Desnou' WHERE kod = 765031;
UPDATE ruian_katastr SET nazev = 'Tasov nad Veličkou' WHERE kod = 765091;
UPDATE ruian_katastr SET nazev = 'Tasov' WHERE kod = 765104;
UPDATE ruian_katastr SET nazev = 'Tasovice' WHERE kod = 765112;
UPDATE ruian_katastr SET nazev = 'Tasovice nad Dyjí' WHERE kod = 765121;
UPDATE ruian_katastr SET nazev = 'Čeřeniště' WHERE kod = 765139;
UPDATE ruian_katastr SET nazev = 'Horní Zálezly' WHERE kod = 765147;
UPDATE ruian_katastr SET nazev = 'Proboštov u Tašova' WHERE kod = 765155;
UPDATE ruian_katastr SET nazev = 'Tašov' WHERE kod = 765163;
UPDATE ruian_katastr SET nazev = 'Tatce' WHERE kod = 765171;
UPDATE ruian_katastr SET nazev = 'Tatenice' WHERE kod = 765180;
UPDATE ruian_katastr SET nazev = 'Tatobity' WHERE kod = 765201;
UPDATE ruian_katastr SET nazev = 'Žlábek' WHERE kod = 765228;
UPDATE ruian_katastr SET nazev = 'Dobronice' WHERE kod = 765236;
UPDATE ruian_katastr SET nazev = 'Přeskače' WHERE kod = 765244;
UPDATE ruian_katastr SET nazev = 'Tavíkovice' WHERE kod = 765252;
UPDATE ruian_katastr SET nazev = 'Ohrazenice u Tažovic' WHERE kod = 765261;
UPDATE ruian_katastr SET nazev = 'Tažovice' WHERE kod = 765279;
UPDATE ruian_katastr SET nazev = 'Tehov' WHERE kod = 765295;
UPDATE ruian_katastr SET nazev = 'Tehov u Říčan' WHERE kod = 765309;
UPDATE ruian_katastr SET nazev = 'Tehovec' WHERE kod = 765317;
UPDATE ruian_katastr SET nazev = 'Těchanov' WHERE kod = 765333;
UPDATE ruian_katastr SET nazev = 'Jezerce' WHERE kod = 765341;
UPDATE ruian_katastr SET nazev = 'Otročín u Stříbra' WHERE kod = 765350;
UPDATE ruian_katastr SET nazev = 'Těchlovice u Stříbra' WHERE kod = 765368;
UPDATE ruian_katastr SET nazev = 'Víchov' WHERE kod = 765376;
UPDATE ruian_katastr SET nazev = 'Babětín' WHERE kod = 765384;
UPDATE ruian_katastr SET nazev = 'Přední Lhota u Těchlovic' WHERE kod = 765392;
UPDATE ruian_katastr SET nazev = 'Přerov u Těchlovic' WHERE kod = 765406;
UPDATE ruian_katastr SET nazev = 'Těchlovice nad Labem' WHERE kod = 765414;
UPDATE ruian_katastr SET nazev = 'Těchlovice u Hradce Králové' WHERE kod = 765431;
UPDATE ruian_katastr SET nazev = 'Těchobuz' WHERE kod = 765449;
UPDATE ruian_katastr SET nazev = 'Těchonice' WHERE kod = 765457;
UPDATE ruian_katastr SET nazev = 'Žďár u Nalžovských Hor' WHERE kod = 765465;
UPDATE ruian_katastr SET nazev = 'Celné' WHERE kod = 765473;
UPDATE ruian_katastr SET nazev = 'Těchonín' WHERE kod = 765490;
UPDATE ruian_katastr SET nazev = 'Těchoraz' WHERE kod = 765503;
UPDATE ruian_katastr SET nazev = 'Těchov' WHERE kod = 765520;
UPDATE ruian_katastr SET nazev = 'Telce' WHERE kod = 765538;
UPDATE ruian_katastr SET nazev = 'Telč' WHERE kod = 765546;
UPDATE ruian_katastr SET nazev = 'Telčice' WHERE kod = 765694;
UPDATE ruian_katastr SET nazev = 'Telecí' WHERE kod = 765708;
UPDATE ruian_katastr SET nazev = 'Liboňov' WHERE kod = 765716;
UPDATE ruian_katastr SET nazev = 'Telnice' WHERE kod = 765724;
UPDATE ruian_katastr SET nazev = 'Varvažov u Telnice' WHERE kod = 765732;
UPDATE ruian_katastr SET nazev = 'Telnice u Brna' WHERE kod = 765767;
UPDATE ruian_katastr SET nazev = 'Lhota pod Horami' WHERE kod = 765783;
UPDATE ruian_katastr SET nazev = 'Sedlec u Temelína' WHERE kod = 765791;
UPDATE ruian_katastr SET nazev = 'Temelín' WHERE kod = 765805;
UPDATE ruian_katastr SET nazev = 'Temelínec' WHERE kod = 765813;
UPDATE ruian_katastr SET nazev = 'Babín' WHERE kod = 765821;
UPDATE ruian_katastr SET nazev = 'Drahoňov' WHERE kod = 765830;
UPDATE ruian_katastr SET nazev = 'Dráchov u Těmic' WHERE kod = 765848;
UPDATE ruian_katastr SET nazev = 'Těmice u Kamenice nad Lipou' WHERE kod = 765864;
UPDATE ruian_katastr SET nazev = 'Těmice u Hodonína' WHERE kod = 765872;
UPDATE ruian_katastr SET nazev = 'Těně' WHERE kod = 765899;
UPDATE ruian_katastr SET nazev = 'Hořehledy' WHERE kod = 765902;
UPDATE ruian_katastr SET nazev = 'Lučiště' WHERE kod = 765911;
UPDATE ruian_katastr SET nazev = 'Těnovice' WHERE kod = 765929;
UPDATE ruian_katastr SET nazev = 'Záluží u Spáleného Poříčí' WHERE kod = 765937;
UPDATE ruian_katastr SET nazev = 'Bezvěrov u Teplé' WHERE kod = 765945;
UPDATE ruian_katastr SET nazev = 'Klášter Teplá' WHERE kod = 765953;
UPDATE ruian_katastr SET nazev = 'Teplá' WHERE kod = 765961;
UPDATE ruian_katastr SET nazev = 'Mrázov' WHERE kod = 765970;
UPDATE ruian_katastr SET nazev = 'Rankovice' WHERE kod = 765988;
UPDATE ruian_katastr SET nazev = 'Teplice' WHERE kod = 766003;
UPDATE ruian_katastr SET nazev = 'Teplice-Řetenice' WHERE kod = 766135;
UPDATE ruian_katastr SET nazev = 'Prosetice' WHERE kod = 766208;
UPDATE ruian_katastr SET nazev = 'Teplice-Trnovany' WHERE kod = 766259;
UPDATE ruian_katastr SET nazev = 'Teplice nad Bečvou' WHERE kod = 766283;
UPDATE ruian_katastr SET nazev = 'Bohdašín' WHERE kod = 766291;
UPDATE ruian_katastr SET nazev = 'Dědov' WHERE kod = 766313;
UPDATE ruian_katastr SET nazev = 'Dolní Teplice' WHERE kod = 766321;
UPDATE ruian_katastr SET nazev = 'Horní Teplice' WHERE kod = 766330;
UPDATE ruian_katastr SET nazev = 'Javor u Teplic nad Metují' WHERE kod = 766348;
UPDATE ruian_katastr SET nazev = 'Lachov' WHERE kod = 766356;
UPDATE ruian_katastr SET nazev = 'Skály u Teplic nad Metují' WHERE kod = 766372;
UPDATE ruian_katastr SET nazev = 'Teplice nad Metují' WHERE kod = 766399;
UPDATE ruian_katastr SET nazev = 'Teplička' WHERE kod = 766402;
UPDATE ruian_katastr SET nazev = 'Teplýšovice' WHERE kod = 766429;
UPDATE ruian_katastr SET nazev = 'Terešov' WHERE kod = 766453;
UPDATE ruian_katastr SET nazev = 'Terezín' WHERE kod = 766470;
UPDATE ruian_katastr SET nazev = 'Terezín u Čejče' WHERE kod = 766542;
UPDATE ruian_katastr SET nazev = 'Tereziny Dary' WHERE kod = 766551;
UPDATE ruian_katastr SET nazev = 'Horní Těrlicko' WHERE kod = 766577;
UPDATE ruian_katastr SET nazev = 'Dolní Těrlicko' WHERE kod = 766607;
UPDATE ruian_katastr SET nazev = 'Termesivy' WHERE kod = 766631;
UPDATE ruian_katastr SET nazev = 'Divoky' WHERE kod = 766640;
UPDATE ruian_katastr SET nazev = 'Lebedov' WHERE kod = 766658;
UPDATE ruian_katastr SET nazev = 'Těšánky' WHERE kod = 766666;
UPDATE ruian_katastr SET nazev = 'Těšany' WHERE kod = 766674;
UPDATE ruian_katastr SET nazev = 'Těšenov' WHERE kod = 766682;
UPDATE ruian_katastr SET nazev = 'Těšetice u Znojma' WHERE kod = 766691;
UPDATE ruian_katastr SET nazev = 'Těšetice u Olomouce' WHERE kod = 766704;
UPDATE ruian_katastr SET nazev = 'Dolní Těšice' WHERE kod = 766712;
UPDATE ruian_katastr SET nazev = 'Horní Těšice' WHERE kod = 766721;
UPDATE ruian_katastr SET nazev = 'Lipina u Šternberka' WHERE kod = 766739;
UPDATE ruian_katastr SET nazev = 'Stachov u Šternberka' WHERE kod = 766747;
UPDATE ruian_katastr SET nazev = 'Těšíkov' WHERE kod = 766755;
UPDATE ruian_katastr SET nazev = 'Těšínov' WHERE kod = 766771;
UPDATE ruian_katastr SET nazev = 'Těškovice' WHERE kod = 766780;
UPDATE ruian_katastr SET nazev = 'Těšnovice' WHERE kod = 766798;
UPDATE ruian_katastr SET nazev = 'Trávník' WHERE kod = 766810;
UPDATE ruian_katastr SET nazev = 'Těšov' WHERE kod = 766828;
UPDATE ruian_katastr SET nazev = 'Běleč u Těšovic' WHERE kod = 766836;
UPDATE ruian_katastr SET nazev = 'Těšovice u Prachatic' WHERE kod = 766852;
UPDATE ruian_katastr SET nazev = 'Tetčice' WHERE kod = 766861;
UPDATE ruian_katastr SET nazev = 'Rochov u Tetčiněvsi' WHERE kod = 766879;
UPDATE ruian_katastr SET nazev = 'Tetčiněves' WHERE kod = 766887;
UPDATE ruian_katastr SET nazev = 'Tetín u Berouna' WHERE kod = 766917;
UPDATE ruian_katastr SET nazev = 'Tetín' WHERE kod = 766925;
UPDATE ruian_katastr SET nazev = 'Vřesník u Tetína' WHERE kod = 766950;
UPDATE ruian_katastr SET nazev = 'Tetov' WHERE kod = 766968;
UPDATE ruian_katastr SET nazev = 'Tchořovice' WHERE kod = 766976;
UPDATE ruian_katastr SET nazev = 'Tichá na Moravě' WHERE kod = 766992;
UPDATE ruian_katastr SET nazev = 'Tichonice' WHERE kod = 767026;
UPDATE ruian_katastr SET nazev = 'Tichov' WHERE kod = 767034;
UPDATE ruian_katastr SET nazev = 'Kněž' WHERE kod = 767042;
UPDATE ruian_katastr SET nazev = 'Tis u Habrů' WHERE kod = 767051;
UPDATE ruian_katastr SET nazev = 'Balková' WHERE kod = 767069;
UPDATE ruian_katastr SET nazev = 'Kračín' WHERE kod = 767077;
UPDATE ruian_katastr SET nazev = 'Tis u Blatna' WHERE kod = 767085;
UPDATE ruian_katastr SET nazev = 'Ostrov u Tisé' WHERE kod = 767093;
UPDATE ruian_katastr SET nazev = 'Tisá' WHERE kod = 767115;
UPDATE ruian_katastr SET nazev = 'Tísek' WHERE kod = 767131;
UPDATE ruian_katastr SET nazev = 'Tisem' WHERE kod = 767140;
UPDATE ruian_katastr SET nazev = 'Limuzy' WHERE kod = 767158;
UPDATE ruian_katastr SET nazev = 'Mrzky' WHERE kod = 767166;
UPDATE ruian_katastr SET nazev = 'Tismice' WHERE kod = 767174;
UPDATE ruian_katastr SET nazev = 'Vrátkov' WHERE kod = 767182;
UPDATE ruian_katastr SET nazev = 'Tisov' WHERE kod = 767191;
UPDATE ruian_katastr SET nazev = 'Jemnice u Tisové' WHERE kod = 767204;
UPDATE ruian_katastr SET nazev = 'Kumpolec' WHERE kod = 767212;
UPDATE ruian_katastr SET nazev = 'Tisová u Tachova' WHERE kod = 767221;
UPDATE ruian_katastr SET nazev = 'Trnová u Tachova' WHERE kod = 767239;
UPDATE ruian_katastr SET nazev = 'Tisová u Vysokého Mýta' WHERE kod = 767263;
UPDATE ruian_katastr SET nazev = 'Kvasín' WHERE kod = 767298;
UPDATE ruian_katastr SET nazev = 'Tisovec' WHERE kod = 767310;
UPDATE ruian_katastr SET nazev = 'Chrást u Tišic' WHERE kod = 767344;
UPDATE ruian_katastr SET nazev = 'Kozly u Tišic' WHERE kod = 767352;
UPDATE ruian_katastr SET nazev = 'Tišice' WHERE kod = 767361;
UPDATE ruian_katastr SET nazev = 'Tišnov' WHERE kod = 767379;
UPDATE ruian_katastr SET nazev = 'Předklášteří' WHERE kod = 767492;
UPDATE ruian_katastr SET nazev = 'Tišnovská Nová Ves' WHERE kod = 767531;
UPDATE ruian_katastr SET nazev = 'Tištín' WHERE kod = 767549;
UPDATE ruian_katastr SET nazev = 'Tlučná' WHERE kod = 767557;
UPDATE ruian_katastr SET nazev = 'Tlumačov u Domažlic' WHERE kod = 767573;
UPDATE ruian_katastr SET nazev = 'Tlumačov na Moravě' WHERE kod = 767590;
UPDATE ruian_katastr SET nazev = 'Tlustice' WHERE kod = 767603;
UPDATE ruian_katastr SET nazev = 'Lounín' WHERE kod = 767611;
UPDATE ruian_katastr SET nazev = 'Tmaň' WHERE kod = 767620;
UPDATE ruian_katastr SET nazev = 'Tmáň' WHERE kod = 767638;
UPDATE ruian_katastr SET nazev = 'Dehtín' WHERE kod = 767646;
UPDATE ruian_katastr SET nazev = 'Otín u Točníku' WHERE kod = 767654;
UPDATE ruian_katastr SET nazev = 'Štěpánovice u Klatov' WHERE kod = 767662;
UPDATE ruian_katastr SET nazev = 'Točník u Klatov' WHERE kod = 767671;
UPDATE ruian_katastr SET nazev = 'Vícenice u Klatov' WHERE kod = 767689;
UPDATE ruian_katastr SET nazev = 'Hořejany' WHERE kod = 767701;
UPDATE ruian_katastr SET nazev = 'Tochovice' WHERE kod = 767719;
UPDATE ruian_katastr SET nazev = 'Tomice u Dolních Kralovic' WHERE kod = 767727;
UPDATE ruian_katastr SET nazev = 'Tomice u Votic' WHERE kod = 767735;
UPDATE ruian_katastr SET nazev = 'Topělec' WHERE kod = 767743;
UPDATE ruian_katastr SET nazev = 'Topolany u Vyškova' WHERE kod = 767751;
UPDATE ruian_katastr SET nazev = 'Topolany u Olomouce' WHERE kod = 767760;
UPDATE ruian_katastr SET nazev = 'Topolná' WHERE kod = 767778;
UPDATE ruian_katastr SET nazev = 'Tošovice' WHERE kod = 767786;
UPDATE ruian_katastr SET nazev = 'Touboř' WHERE kod = 767794;
UPDATE ruian_katastr SET nazev = 'Dolní Šebířov' WHERE kod = 767808;
UPDATE ruian_katastr SET nazev = 'Hlupice' WHERE kod = 767816;
UPDATE ruian_katastr SET nazev = 'Knínice u Touchořin' WHERE kod = 767824;
UPDATE ruian_katastr SET nazev = 'Touchořiny' WHERE kod = 767832;
UPDATE ruian_katastr SET nazev = 'Touchovice' WHERE kod = 767841;
UPDATE ruian_katastr SET nazev = 'Lázně Toušeň' WHERE kod = 767859;
UPDATE ruian_katastr SET nazev = 'Mlékovice' WHERE kod = 767867;
UPDATE ruian_katastr SET nazev = 'Toušice' WHERE kod = 767875;
UPDATE ruian_katastr SET nazev = 'Touškov' WHERE kod = 767883;
UPDATE ruian_katastr SET nazev = 'Donín' WHERE kod = 767891;
UPDATE ruian_katastr SET nazev = 'Toužetín' WHERE kod = 767913;
UPDATE ruian_katastr SET nazev = 'Kojšovice' WHERE kod = 767921;
UPDATE ruian_katastr SET nazev = 'Lachovice' WHERE kod = 767930;
UPDATE ruian_katastr SET nazev = 'Toužim' WHERE kod = 767948;
UPDATE ruian_katastr SET nazev = 'Radyně' WHERE kod = 767964;
UPDATE ruian_katastr SET nazev = 'Tovačov' WHERE kod = 768014;
UPDATE ruian_katastr SET nazev = 'Traplice' WHERE kod = 768022;
UPDATE ruian_katastr SET nazev = 'Nučničky' WHERE kod = 768031;
UPDATE ruian_katastr SET nazev = 'Travčice' WHERE kod = 768049;
UPDATE ruian_katastr SET nazev = 'Trboušany' WHERE kod = 768057;
UPDATE ruian_katastr SET nazev = 'Trhanov' WHERE kod = 768065;
UPDATE ruian_katastr SET nazev = 'Hluboká u Trhové Kamenice' WHERE kod = 768073;
UPDATE ruian_katastr SET nazev = 'Rohozná u Trhové Kamenice' WHERE kod = 768111;
UPDATE ruian_katastr SET nazev = 'Trhová Kamenice' WHERE kod = 768120;
UPDATE ruian_katastr SET nazev = 'Trhové Dušníky' WHERE kod = 768146;
UPDATE ruian_katastr SET nazev = 'Trhové Sviny' WHERE kod = 768154;
UPDATE ruian_katastr SET nazev = 'Bukvice u Trhových Svinů' WHERE kod = 768201;
UPDATE ruian_katastr SET nazev = 'Pěčín u Trhových Svinů' WHERE kod = 768235;
UPDATE ruian_katastr SET nazev = 'Trhový Štěpánov' WHERE kod = 768251;
UPDATE ruian_katastr SET nazev = 'Trnava' WHERE kod = 768260;
UPDATE ruian_katastr SET nazev = 'Trnava u Zlína' WHERE kod = 768278;
UPDATE ruian_katastr SET nazev = 'Trnava u Třebíče' WHERE kod = 768286;
UPDATE ruian_katastr SET nazev = 'Trnávka u Nového Jičína' WHERE kod = 768308;
UPDATE ruian_katastr SET nazev = 'Trnávka u Lipníka nad Bečvou' WHERE kod = 768316;
UPDATE ruian_katastr SET nazev = 'Trněný Újezd' WHERE kod = 768324;
UPDATE ruian_katastr SET nazev = 'Houdkovice' WHERE kod = 768332;
UPDATE ruian_katastr SET nazev = 'Trnov' WHERE kod = 768359;
UPDATE ruian_katastr SET nazev = 'Zádolí u Trnova' WHERE kod = 768367;
UPDATE ruian_katastr SET nazev = 'Záhornice' WHERE kod = 768375;
UPDATE ruian_katastr SET nazev = 'Trnová u Katusic' WHERE kod = 768383;
UPDATE ruian_katastr SET nazev = 'Trnová u Plzně' WHERE kod = 768391;
UPDATE ruian_katastr SET nazev = 'Trnovany u Litoměřic' WHERE kod = 768413;
UPDATE ruian_katastr SET nazev = 'Trnové Pole' WHERE kod = 768421;
UPDATE ruian_katastr SET nazev = 'Radostice u Trocnova' WHERE kod = 768430;
UPDATE ruian_katastr SET nazev = 'Trocnov' WHERE kod = 768448;
UPDATE ruian_katastr SET nazev = 'Trojanovice' WHERE kod = 768499;
UPDATE ruian_katastr SET nazev = 'Řemešín' WHERE kod = 768502;
UPDATE ruian_katastr SET nazev = 'Trojany u Mladotic' WHERE kod = 768511;
UPDATE ruian_katastr SET nazev = 'Trojovice' WHERE kod = 768529;
UPDATE ruian_katastr SET nazev = 'Trokavec' WHERE kod = 768537;
UPDATE ruian_katastr SET nazev = 'Vísky' WHERE kod = 768545;
UPDATE ruian_katastr SET nazev = 'Troskotovice' WHERE kod = 768553;
UPDATE ruian_katastr SET nazev = 'Troskovice' WHERE kod = 768588;
UPDATE ruian_katastr SET nazev = 'Trotina' WHERE kod = 768618;
UPDATE ruian_katastr SET nazev = 'Zábřezí' WHERE kod = 768626;
UPDATE ruian_katastr SET nazev = 'Zdobín' WHERE kod = 768634;
UPDATE ruian_katastr SET nazev = 'Dědinka' WHERE kod = 768642;
UPDATE ruian_katastr SET nazev = 'Lazce u Troubelic' WHERE kod = 768651;
UPDATE ruian_katastr SET nazev = 'Troubelice' WHERE kod = 768669;
UPDATE ruian_katastr SET nazev = 'Troubky nad Bečvou' WHERE kod = 768685;
UPDATE ruian_katastr SET nazev = 'Troubky' WHERE kod = 768693;
UPDATE ruian_katastr SET nazev = 'Zdislavice' WHERE kod = 768707;
UPDATE ruian_katastr SET nazev = 'Troubsko' WHERE kod = 768715;
UPDATE ruian_katastr SET nazev = 'Trpín' WHERE kod = 768740;
UPDATE ruian_katastr SET nazev = 'Sviňomazy' WHERE kod = 768758;
UPDATE ruian_katastr SET nazev = 'Trpísty' WHERE kod = 768766;
UPDATE ruian_katastr SET nazev = 'Dobrovítova Lhota' WHERE kod = 768782;
UPDATE ruian_katastr SET nazev = 'Koňkovice' WHERE kod = 768791;
UPDATE ruian_katastr SET nazev = 'Trpišovice' WHERE kod = 768804;
UPDATE ruian_katastr SET nazev = 'Trpoměchy' WHERE kod = 768812;
UPDATE ruian_katastr SET nazev = 'Horní Ves u Mariánských Lázní' WHERE kod = 768821;
UPDATE ruian_katastr SET nazev = 'Trstěnice u Mariánských Lázní' WHERE kod = 768839;
UPDATE ruian_katastr SET nazev = 'Skelné Hutě' WHERE kod = 768847;
UPDATE ruian_katastr SET nazev = 'Trstěnice u Litomyšle' WHERE kod = 768855;
UPDATE ruian_katastr SET nazev = 'Trstěnice u Moravského Krumlova' WHERE kod = 768863;
UPDATE ruian_katastr SET nazev = 'Tršice' WHERE kod = 768871;
UPDATE ruian_katastr SET nazev = 'Dlouhé Mosty' WHERE kod = 768880;
UPDATE ruian_katastr SET nazev = 'Jindřichov u Tršnic' WHERE kod = 768898;
UPDATE ruian_katastr SET nazev = 'Tršnice' WHERE kod = 768901;
UPDATE ruian_katastr SET nazev = 'Kramolna' WHERE kod = 768910;
UPDATE ruian_katastr SET nazev = 'Lhotky' WHERE kod = 768928;
UPDATE ruian_katastr SET nazev = 'Městská Kramolna' WHERE kod = 768936;
UPDATE ruian_katastr SET nazev = 'Trubějov' WHERE kod = 768952;
UPDATE ruian_katastr SET nazev = 'Trubín' WHERE kod = 768961;
UPDATE ruian_katastr SET nazev = 'Trubská' WHERE kod = 768979;
UPDATE ruian_katastr SET nazev = 'Opočno nad Loučnou' WHERE kod = 768995;
UPDATE ruian_katastr SET nazev = 'Trusnov' WHERE kod = 769002;
UPDATE ruian_katastr SET nazev = 'Trutnov' WHERE kod = 769029;
UPDATE ruian_katastr SET nazev = 'Volanov' WHERE kod = 769118;
UPDATE ruian_katastr SET nazev = 'Dolní Staré Město' WHERE kod = 769134;
UPDATE ruian_katastr SET nazev = 'Horní Staré Město' WHERE kod = 769151;
UPDATE ruian_katastr SET nazev = 'Poříčí u Trutnova' WHERE kod = 769223;
UPDATE ruian_katastr SET nazev = 'Bojiště u Trutnova' WHERE kod = 769266;
UPDATE ruian_katastr SET nazev = 'Oblanov' WHERE kod = 769274;
UPDATE ruian_katastr SET nazev = 'Třanovice' WHERE kod = 769282;
UPDATE ruian_katastr SET nazev = 'Hoříkovice' WHERE kod = 769339;
UPDATE ruian_katastr SET nazev = 'Třebanice' WHERE kod = 769347;
UPDATE ruian_katastr SET nazev = 'Třebařov' WHERE kod = 769355;
UPDATE ruian_katastr SET nazev = 'Třebčín' WHERE kod = 769363;
UPDATE ruian_katastr SET nazev = 'Dvorec u Třebče' WHERE kod = 769371;
UPDATE ruian_katastr SET nazev = 'Lhotka u Třebče' WHERE kod = 769380;
UPDATE ruian_katastr SET nazev = 'Třebeč' WHERE kod = 769398;
UPDATE ruian_katastr SET nazev = 'Krňovice' WHERE kod = 769410;
UPDATE ruian_katastr SET nazev = 'Polánky nad Dědinou' WHERE kod = 769436;
UPDATE ruian_katastr SET nazev = 'Štěnkov' WHERE kod = 769444;
UPDATE ruian_katastr SET nazev = 'Třebechovice pod Orebem' WHERE kod = 769452;
UPDATE ruian_katastr SET nazev = 'Třebějice' WHERE kod = 769461;
UPDATE ruian_katastr SET nazev = 'Rácovice' WHERE kod = 769479;
UPDATE ruian_katastr SET nazev = 'Třebelovice' WHERE kod = 769487;
UPDATE ruian_katastr SET nazev = 'Doubí u Třebeně' WHERE kod = 769495;
UPDATE ruian_katastr SET nazev = 'Dvorek' WHERE kod = 769509;
UPDATE ruian_katastr SET nazev = 'Horní Ves u Třebeně' WHERE kod = 769517;
UPDATE ruian_katastr SET nazev = 'Chocovice' WHERE kod = 769525;
UPDATE ruian_katastr SET nazev = 'Lesina' WHERE kod = 769533;
UPDATE ruian_katastr SET nazev = 'Nový Drahov' WHERE kod = 769541;
UPDATE ruian_katastr SET nazev = 'Povodí' WHERE kod = 769550;
UPDATE ruian_katastr SET nazev = 'Třebeň' WHERE kod = 769568;
UPDATE ruian_katastr SET nazev = 'Vokov u Třebeně' WHERE kod = 769576;
UPDATE ruian_katastr SET nazev = 'Kololeč' WHERE kod = 769584;
UPDATE ruian_katastr SET nazev = 'Teplá u Třebenic' WHERE kod = 769592;
UPDATE ruian_katastr SET nazev = 'Třebenice' WHERE kod = 769606;
UPDATE ruian_katastr SET nazev = 'Chroustov u Třebenic' WHERE kod = 769614;
UPDATE ruian_katastr SET nazev = 'Plešice' WHERE kod = 769622;
UPDATE ruian_katastr SET nazev = 'Třebenice na Moravě' WHERE kod = 769631;
UPDATE ruian_katastr SET nazev = 'Třebestovice' WHERE kod = 769649;
UPDATE ruian_katastr SET nazev = 'Třebešice u Divišova' WHERE kod = 769657;
UPDATE ruian_katastr SET nazev = 'Libel' WHERE kod = 769665;
UPDATE ruian_katastr SET nazev = 'Třebešov' WHERE kod = 769673;
UPDATE ruian_katastr SET nazev = 'Manešovice' WHERE kod = 769681;
UPDATE ruian_katastr SET nazev = 'Třebětice u Dačic' WHERE kod = 769690;
UPDATE ruian_katastr SET nazev = 'Třebětice' WHERE kod = 769703;
UPDATE ruian_katastr SET nazev = 'Hostkovice u Třebětína' WHERE kod = 769711;
UPDATE ruian_katastr SET nazev = 'Třebětín' WHERE kod = 769720;
UPDATE ruian_katastr SET nazev = 'Třebíč' WHERE kod = 769738;
UPDATE ruian_katastr SET nazev = 'Řípov' WHERE kod = 769886;
UPDATE ruian_katastr SET nazev = 'Podklášteří' WHERE kod = 769916;
UPDATE ruian_katastr SET nazev = 'Týn u Třebíče' WHERE kod = 769941;
UPDATE ruian_katastr SET nazev = 'Třebihošť' WHERE kod = 769975;
UPDATE ruian_katastr SET nazev = 'Zvičina' WHERE kod = 769983;
UPDATE ruian_katastr SET nazev = 'Saky' WHERE kod = 769991;
UPDATE ruian_katastr SET nazev = 'Třebichovice' WHERE kod = 770001;
UPDATE ruian_katastr SET nazev = 'Třebiště' WHERE kod = 770019;
UPDATE ruian_katastr SET nazev = 'Třebívlice' WHERE kod = 770027;
UPDATE ruian_katastr SET nazev = 'Třebíz' WHERE kod = 770035;
UPDATE ruian_katastr SET nazev = 'Solopysky u Třebnic' WHERE kod = 770043;
UPDATE ruian_katastr SET nazev = 'Bozdíš' WHERE kod = 770060;
UPDATE ruian_katastr SET nazev = 'Jeníkovice u Horšovského Týna' WHERE kod = 770078;
UPDATE ruian_katastr SET nazev = 'Mrchojedy' WHERE kod = 770086;
UPDATE ruian_katastr SET nazev = 'Němčice u Třebnic' WHERE kod = 770094;
UPDATE ruian_katastr SET nazev = 'Třebnice u Domažlic' WHERE kod = 770108;
UPDATE ruian_katastr SET nazev = 'Třebnice' WHERE kod = 770116;
UPDATE ruian_katastr SET nazev = 'Ostrov v Podkrkonoší' WHERE kod = 770124;
UPDATE ruian_katastr SET nazev = 'Třebnouševes' WHERE kod = 770132;
UPDATE ruian_katastr SET nazev = 'Vinice v Podkrkonoší' WHERE kod = 770141;
UPDATE ruian_katastr SET nazev = 'Třeboc' WHERE kod = 770159;
UPDATE ruian_katastr SET nazev = 'Hubenov u Třebohostic' WHERE kod = 770167;
UPDATE ruian_katastr SET nazev = 'Třebohostice' WHERE kod = 770175;
UPDATE ruian_katastr SET nazev = 'Únice' WHERE kod = 770183;
UPDATE ruian_katastr SET nazev = 'Zadní Zborovice' WHERE kod = 770191;
UPDATE ruian_katastr SET nazev = 'Třebom' WHERE kod = 770205;
UPDATE ruian_katastr SET nazev = 'Horažďovická Lhota' WHERE kod = 770213;
UPDATE ruian_katastr SET nazev = 'Třebomyslice u Horažďovic' WHERE kod = 770221;
UPDATE ruian_katastr SET nazev = 'Třeboň' WHERE kod = 770230;
UPDATE ruian_katastr SET nazev = 'Třebonice' WHERE kod = 770353;
UPDATE ruian_katastr SET nazev = 'Třebonín' WHERE kod = 770361;
UPDATE ruian_katastr SET nazev = 'Třebotov' WHERE kod = 770396;
UPDATE ruian_katastr SET nazev = 'Luhov u Toužimi' WHERE kod = 770400;
UPDATE ruian_katastr SET nazev = 'Nežichov' WHERE kod = 770418;
UPDATE ruian_katastr SET nazev = 'Políkno u Toužimi' WHERE kod = 770426;
UPDATE ruian_katastr SET nazev = 'Třebouň' WHERE kod = 770434;
UPDATE ruian_katastr SET nazev = 'Třeboutice' WHERE kod = 770442;
UPDATE ruian_katastr SET nazev = 'Třebovětice' WHERE kod = 770451;
UPDATE ruian_katastr SET nazev = 'Třebovice' WHERE kod = 770469;
UPDATE ruian_katastr SET nazev = 'Hlaváčova Lhota' WHERE kod = 770477;
UPDATE ruian_katastr SET nazev = 'Klášterní Skalice' WHERE kod = 770485;
UPDATE ruian_katastr SET nazev = 'Miškovice u Kouřimi' WHERE kod = 770507;
UPDATE ruian_katastr SET nazev = 'Třebovle' WHERE kod = 770515;
UPDATE ruian_katastr SET nazev = 'Třebsko' WHERE kod = 770523;
UPDATE ruian_katastr SET nazev = 'Třebusice' WHERE kod = 770531;
UPDATE ruian_katastr SET nazev = 'Třebušice' WHERE kod = 770540;
UPDATE ruian_katastr SET nazev = 'Dolní Týnec' WHERE kod = 770558;
UPDATE ruian_katastr SET nazev = 'Horní Týnec' WHERE kod = 770566;
UPDATE ruian_katastr SET nazev = 'Kotelice' WHERE kod = 770574;
UPDATE ruian_katastr SET nazev = 'Řepčice' WHERE kod = 770582;
UPDATE ruian_katastr SET nazev = 'Třebušín' WHERE kod = 770591;
UPDATE ruian_katastr SET nazev = 'Třemblat' WHERE kod = 770612;
UPDATE ruian_katastr SET nazev = 'Rudíkovy' WHERE kod = 770639;
UPDATE ruian_katastr SET nazev = 'Třemešná' WHERE kod = 770647;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Třemešného' WHERE kod = 770655;
UPDATE ruian_katastr SET nazev = 'Dubec' WHERE kod = 770663;
UPDATE ruian_katastr SET nazev = 'Pavlíkov u Třemešného' WHERE kod = 770671;
UPDATE ruian_katastr SET nazev = 'Třemešné' WHERE kod = 770680;
UPDATE ruian_katastr SET nazev = 'Třemošná' WHERE kod = 770698;
UPDATE ruian_katastr SET nazev = 'Záluží u Třemošné' WHERE kod = 770701;
UPDATE ruian_katastr SET nazev = 'Třemošnice' WHERE kod = 770710;
UPDATE ruian_katastr SET nazev = 'Kubíkovy Duby' WHERE kod = 770728;
UPDATE ruian_katastr SET nazev = 'Třemošnice nad Doubravou' WHERE kod = 770736;
UPDATE ruian_katastr SET nazev = 'Třenice' WHERE kod = 770744;
UPDATE ruian_katastr SET nazev = 'Třesovice' WHERE kod = 770752;
UPDATE ruian_katastr SET nazev = 'Třešť' WHERE kod = 770761;
UPDATE ruian_katastr SET nazev = 'Třeštice' WHERE kod = 770779;
UPDATE ruian_katastr SET nazev = 'Třeština' WHERE kod = 770795;
UPDATE ruian_katastr SET nazev = 'Tři Dvory' WHERE kod = 770809;
UPDATE ruian_katastr SET nazev = 'Chodovská Huť' WHERE kod = 770817;
UPDATE ruian_katastr SET nazev = 'Krásné u Tří Seker' WHERE kod = 770825;
UPDATE ruian_katastr SET nazev = 'Plánská Huť' WHERE kod = 770833;
UPDATE ruian_katastr SET nazev = 'Tachovská Huť' WHERE kod = 770841;
UPDATE ruian_katastr SET nazev = 'Tři Sekery u Kynžvartu' WHERE kod = 770850;
UPDATE ruian_katastr SET nazev = 'Tři Sekery u Tachova' WHERE kod = 770868;
UPDATE ruian_katastr SET nazev = 'Tříč' WHERE kod = 770876;
UPDATE ruian_katastr SET nazev = 'Třímany' WHERE kod = 770884;
UPDATE ruian_katastr SET nazev = 'Třinec' WHERE kod = 770892;
UPDATE ruian_katastr SET nazev = 'Konská' WHERE kod = 771015;
UPDATE ruian_katastr SET nazev = 'Horní Líštná' WHERE kod = 771066;
UPDATE ruian_katastr SET nazev = 'Kojkovice u Třince' WHERE kod = 771074;
UPDATE ruian_katastr SET nazev = 'Český Puncov' WHERE kod = 771082;
UPDATE ruian_katastr SET nazev = 'Dolní Líštná' WHERE kod = 771091;
UPDATE ruian_katastr SET nazev = 'Lyžbice' WHERE kod = 771104;
UPDATE ruian_katastr SET nazev = 'Rájov u Třískolup' WHERE kod = 771112;
UPDATE ruian_katastr SET nazev = 'Třískolupy pod Přimdou' WHERE kod = 771121;
UPDATE ruian_katastr SET nazev = 'Třískolupy' WHERE kod = 771139;
UPDATE ruian_katastr SET nazev = 'Třtěnice' WHERE kod = 771147;
UPDATE ruian_katastr SET nazev = 'Mnichovský Týnec' WHERE kod = 771155;
UPDATE ruian_katastr SET nazev = 'Třtěno' WHERE kod = 771163;
UPDATE ruian_katastr SET nazev = 'Třtice u Nového Strašecí' WHERE kod = 771171;
UPDATE ruian_katastr SET nazev = 'Brandlín u Tučap' WHERE kod = 771180;
UPDATE ruian_katastr SET nazev = 'Dvorce u Tučap' WHERE kod = 771198;
UPDATE ruian_katastr SET nazev = 'Tučapy u Soběslavi' WHERE kod = 771201;
UPDATE ruian_katastr SET nazev = 'Tučapy u Holešova' WHERE kod = 771210;
UPDATE ruian_katastr SET nazev = 'Tučapy' WHERE kod = 771228;
UPDATE ruian_katastr SET nazev = 'Tučapy u Vyškova' WHERE kod = 771236;
UPDATE ruian_katastr SET nazev = 'Tučín' WHERE kod = 771244;
UPDATE ruian_katastr SET nazev = 'Tuhaň' WHERE kod = 771261;
UPDATE ruian_katastr SET nazev = 'Pavličky' WHERE kod = 771287;
UPDATE ruian_katastr SET nazev = 'Tuhaň u Dubé' WHERE kod = 771295;
UPDATE ruian_katastr SET nazev = 'Tuhanec' WHERE kod = 771309;
UPDATE ruian_katastr SET nazev = 'Tuchlovice' WHERE kod = 771317;
UPDATE ruian_katastr SET nazev = 'Tuchoměřice' WHERE kod = 771341;
UPDATE ruian_katastr SET nazev = 'Kněžívka' WHERE kod = 771350;
UPDATE ruian_katastr SET nazev = 'Tuchomyšl' WHERE kod = 771368;
UPDATE ruian_katastr SET nazev = 'Přehvozdí' WHERE kod = 771376;
UPDATE ruian_katastr SET nazev = 'Tuchoraz' WHERE kod = 771384;
UPDATE ruian_katastr SET nazev = 'Třeskonice' WHERE kod = 771392;
UPDATE ruian_katastr SET nazev = 'Tuchořice' WHERE kod = 771406;
UPDATE ruian_katastr SET nazev = 'Tlustovousy' WHERE kod = 771414;
UPDATE ruian_katastr SET nazev = 'Tuklaty' WHERE kod = 771422;
UPDATE ruian_katastr SET nazev = 'Tukleky' WHERE kod = 771431;
UPDATE ruian_katastr SET nazev = 'Tulešice' WHERE kod = 771449;
UPDATE ruian_katastr SET nazev = 'Tůně u Nechanic' WHERE kod = 771457;
UPDATE ruian_katastr SET nazev = 'Tuněchody' WHERE kod = 771465;
UPDATE ruian_katastr SET nazev = 'Adamov u Tupadel' WHERE kod = 771473;
UPDATE ruian_katastr SET nazev = 'Schořov' WHERE kod = 771481;
UPDATE ruian_katastr SET nazev = 'Tupadly u Čáslavi' WHERE kod = 771490;
UPDATE ruian_katastr SET nazev = 'Drslavice u Tupadel' WHERE kod = 771503;
UPDATE ruian_katastr SET nazev = 'Tajanov u Tupadel' WHERE kod = 771511;
UPDATE ruian_katastr SET nazev = 'Tupadly u Klatov' WHERE kod = 771520;
UPDATE ruian_katastr SET nazev = 'Věckovice u Janovic nad Úhlavou' WHERE kod = 771538;
UPDATE ruian_katastr SET nazev = 'Tupesy u Přelouče' WHERE kod = 771546;
UPDATE ruian_katastr SET nazev = 'Tupesy na Moravě' WHERE kod = 771554;
UPDATE ruian_katastr SET nazev = 'Bumbalka' WHERE kod = 771571;
UPDATE ruian_katastr SET nazev = 'Rašovy' WHERE kod = 771589;
UPDATE ruian_katastr SET nazev = 'Turkovice u Přelouče' WHERE kod = 771597;
UPDATE ruian_katastr SET nazev = 'Turnov' WHERE kod = 771601;
UPDATE ruian_katastr SET nazev = 'Daliměřice' WHERE kod = 771627;
UPDATE ruian_katastr SET nazev = 'Mašov u Turnova' WHERE kod = 771686;
UPDATE ruian_katastr SET nazev = 'Turov nad Loučnou' WHERE kod = 771732;
UPDATE ruian_katastr SET nazev = 'Turovka' WHERE kod = 771741;
UPDATE ruian_katastr SET nazev = 'Tursko' WHERE kod = 771759;
UPDATE ruian_katastr SET nazev = 'Butoves' WHERE kod = 771767;
UPDATE ruian_katastr SET nazev = 'Hubálov' WHERE kod = 771775;
UPDATE ruian_katastr SET nazev = 'Kacákova Lhota' WHERE kod = 771783;
UPDATE ruian_katastr SET nazev = 'Tuř' WHERE kod = 771791;
UPDATE ruian_katastr SET nazev = 'Lipoltov' WHERE kod = 771805;
UPDATE ruian_katastr SET nazev = 'Mokřina' WHERE kod = 771813;
UPDATE ruian_katastr SET nazev = 'Tuřany u Kynšperku nad Ohří' WHERE kod = 771830;
UPDATE ruian_katastr SET nazev = 'Tuřice' WHERE kod = 771856;
UPDATE ruian_katastr SET nazev = 'Tušimice' WHERE kod = 771899;
UPDATE ruian_katastr SET nazev = 'Tušť' WHERE kod = 771937;
UPDATE ruian_katastr SET nazev = 'Tutleky' WHERE kod = 771961;
UPDATE ruian_katastr SET nazev = 'Tvarožná' WHERE kod = 771970;
UPDATE ruian_katastr SET nazev = 'Tvarožná Lhota' WHERE kod = 771988;
UPDATE ruian_katastr SET nazev = 'Tvorovice' WHERE kod = 771996;
UPDATE ruian_katastr SET nazev = 'Tvořihráz' WHERE kod = 772003;
UPDATE ruian_katastr SET nazev = 'Tvrdkov' WHERE kod = 772011;
UPDATE ruian_katastr SET nazev = 'Tvrdonice' WHERE kod = 772020;
UPDATE ruian_katastr SET nazev = 'Selibice' WHERE kod = 772038;
UPDATE ruian_katastr SET nazev = 'Tvršice' WHERE kod = 772046;
UPDATE ruian_katastr SET nazev = 'Bohunice u Tvrzic' WHERE kod = 772054;
UPDATE ruian_katastr SET nazev = 'Tvrzice' WHERE kod = 772062;
UPDATE ruian_katastr SET nazev = 'Újezdec u Tvrzic' WHERE kod = 772071;
UPDATE ruian_katastr SET nazev = 'Lhůta u Tymákova' WHERE kod = 772089;
UPDATE ruian_katastr SET nazev = 'Mokrouše' WHERE kod = 772097;
UPDATE ruian_katastr SET nazev = 'Tymákov' WHERE kod = 772101;
UPDATE ruian_katastr SET nazev = 'Týn nad Bečvou' WHERE kod = 772119;
UPDATE ruian_katastr SET nazev = 'Týn nad Vltavou' WHERE kod = 772127;
UPDATE ruian_katastr SET nazev = 'Hněvkovice u Týna nad Vltavou' WHERE kod = 772194;
UPDATE ruian_katastr SET nazev = 'Mezihoří u Týnčan' WHERE kod = 772232;
UPDATE ruian_katastr SET nazev = 'Skoupý' WHERE kod = 772241;
UPDATE ruian_katastr SET nazev = 'Týnčany' WHERE kod = 772259;
UPDATE ruian_katastr SET nazev = 'Týnec u Dobrovice' WHERE kod = 772267;
UPDATE ruian_katastr SET nazev = 'Horní Lhota u Klatov' WHERE kod = 772275;
UPDATE ruian_katastr SET nazev = 'Javor' WHERE kod = 772283;
UPDATE ruian_katastr SET nazev = 'Klenová' WHERE kod = 772291;
UPDATE ruian_katastr SET nazev = 'Loučany' WHERE kod = 772305;
UPDATE ruian_katastr SET nazev = 'Týnec u Janovic nad Úhlavou' WHERE kod = 772313;
UPDATE ruian_katastr SET nazev = 'Týnec na Moravě' WHERE kod = 772321;
UPDATE ruian_katastr SET nazev = 'Lžovice' WHERE kod = 772330;
UPDATE ruian_katastr SET nazev = 'Týnec nad Labem' WHERE kod = 772356;
UPDATE ruian_katastr SET nazev = 'Vinařice u Týnce nad Labem' WHERE kod = 772364;
UPDATE ruian_katastr SET nazev = 'Týnec nad Sázavou' WHERE kod = 772399;
UPDATE ruian_katastr SET nazev = 'Týneček' WHERE kod = 772411;
UPDATE ruian_katastr SET nazev = 'Týniště nad Orlicí' WHERE kod = 772429;
UPDATE ruian_katastr SET nazev = 'Týnišťko' WHERE kod = 772437;
UPDATE ruian_katastr SET nazev = 'Tyra' WHERE kod = 772445;
UPDATE ruian_katastr SET nazev = 'Tytry' WHERE kod = 772453;
UPDATE ruian_katastr SET nazev = 'Česká Proseč' WHERE kod = 772461;
UPDATE ruian_katastr SET nazev = 'Stav' WHERE kod = 772496;
UPDATE ruian_katastr SET nazev = 'Úbislavice' WHERE kod = 772518;
UPDATE ruian_katastr SET nazev = 'Zboží u Nové Paky' WHERE kod = 772526;
UPDATE ruian_katastr SET nazev = 'Ublo' WHERE kod = 772534;
UPDATE ruian_katastr SET nazev = 'Úboč' WHERE kod = 772551;
UPDATE ruian_katastr SET nazev = 'Úlíkov' WHERE kod = 772569;
UPDATE ruian_katastr SET nazev = 'Stružinec' WHERE kod = 772577;
UPDATE ruian_katastr SET nazev = 'Údavy' WHERE kod = 772585;
UPDATE ruian_katastr SET nazev = 'Nezabylice' WHERE kod = 772593;
UPDATE ruian_katastr SET nazev = 'Přečaply' WHERE kod = 772607;
UPDATE ruian_katastr SET nazev = 'Údlice' WHERE kod = 772615;
UPDATE ruian_katastr SET nazev = 'Herstošice' WHERE kod = 772623;
UPDATE ruian_katastr SET nazev = 'Polom u Údrče' WHERE kod = 772631;
UPDATE ruian_katastr SET nazev = 'Údrč' WHERE kod = 772640;
UPDATE ruian_katastr SET nazev = 'Bílsko u Kopidlna' WHERE kod = 772658;
UPDATE ruian_katastr SET nazev = 'Údrnice' WHERE kod = 772666;
UPDATE ruian_katastr SET nazev = 'Údrnická Lhota' WHERE kod = 772674;
UPDATE ruian_katastr SET nazev = 'Únětice' WHERE kod = 772682;
UPDATE ruian_katastr SET nazev = 'Nové Vilémovice' WHERE kod = 772704;
UPDATE ruian_katastr SET nazev = 'Uhelná' WHERE kod = 772712;
UPDATE ruian_katastr SET nazev = 'Dolní Fořt' WHERE kod = 772721;
UPDATE ruian_katastr SET nazev = 'Petrovice u Uhelné Příbramě' WHERE kod = 772747;
UPDATE ruian_katastr SET nazev = 'Pukšice' WHERE kod = 772755;
UPDATE ruian_katastr SET nazev = 'Uhelná Příbram' WHERE kod = 772763;
UPDATE ruian_katastr SET nazev = 'Úhelnice' WHERE kod = 772771;
UPDATE ruian_katastr SET nazev = 'Úherce' WHERE kod = 772780;
UPDATE ruian_katastr SET nazev = 'Úherčice' WHERE kod = 772798;
UPDATE ruian_katastr SET nazev = 'Uherčice u Hustopečí' WHERE kod = 772810;
UPDATE ruian_katastr SET nazev = 'Uherčice u Znojma' WHERE kod = 772836;
UPDATE ruian_katastr SET nazev = 'Uherské Hradiště' WHERE kod = 772844;
UPDATE ruian_katastr SET nazev = 'Sady' WHERE kod = 772917;
UPDATE ruian_katastr SET nazev = 'Mařatice' WHERE kod = 772925;
UPDATE ruian_katastr SET nazev = 'Uhersko' WHERE kod = 772976;
UPDATE ruian_katastr SET nazev = 'Uherský Brod' WHERE kod = 772984;
UPDATE ruian_katastr SET nazev = 'Kvačice' WHERE kod = 773115;
UPDATE ruian_katastr SET nazev = 'Ostrožské Předměstí' WHERE kod = 773123;
UPDATE ruian_katastr SET nazev = 'Uherský Ostroh' WHERE kod = 773131;
UPDATE ruian_katastr SET nazev = 'Úhlejov' WHERE kod = 773158;
UPDATE ruian_katastr SET nazev = 'Uhlířov' WHERE kod = 773166;
UPDATE ruian_katastr SET nazev = 'Rasochy' WHERE kod = 773174;
UPDATE ruian_katastr SET nazev = 'Uhlířská Lhota' WHERE kod = 773182;
UPDATE ruian_katastr SET nazev = 'Bláto' WHERE kod = 773191;
UPDATE ruian_katastr SET nazev = 'Janovická Lhota' WHERE kod = 773204;
UPDATE ruian_katastr SET nazev = 'Uhlířské Janovice' WHERE kod = 773212;
UPDATE ruian_katastr SET nazev = 'Úholičky' WHERE kod = 773239;
UPDATE ruian_katastr SET nazev = 'Úhonice' WHERE kod = 773247;
UPDATE ruian_katastr SET nazev = 'Pastviny' WHERE kod = 773255;
UPDATE ruian_katastr SET nazev = 'Úhošťany' WHERE kod = 773271;
UPDATE ruian_katastr SET nazev = 'Úhošť' WHERE kod = 773280;
UPDATE ruian_katastr SET nazev = 'Úhřetice' WHERE kod = 773298;
UPDATE ruian_katastr SET nazev = 'Úhřetická Lhota' WHERE kod = 773301;
UPDATE ruian_katastr SET nazev = 'Uhřice u Vlachova Březí' WHERE kod = 773328;
UPDATE ruian_katastr SET nazev = 'Uhřice u Boskovic' WHERE kod = 773336;
UPDATE ruian_katastr SET nazev = 'Prasklice' WHERE kod = 773344;
UPDATE ruian_katastr SET nazev = 'Uhřice u Kroměříže' WHERE kod = 773352;
UPDATE ruian_katastr SET nazev = 'Uhřice u Kyjova' WHERE kod = 773379;
UPDATE ruian_katastr SET nazev = 'Uhřičice' WHERE kod = 773387;
UPDATE ruian_katastr SET nazev = 'Hájek u Uhříněvsi' WHERE kod = 773395;
UPDATE ruian_katastr SET nazev = 'Pitkovice' WHERE kod = 773417;
UPDATE ruian_katastr SET nazev = 'Uhříněves' WHERE kod = 773425;
UPDATE ruian_katastr SET nazev = 'Šeborov' WHERE kod = 773433;
UPDATE ruian_katastr SET nazev = 'Uhřínov u Velkého Meziříčí' WHERE kod = 773441;
UPDATE ruian_katastr SET nazev = 'Uhřínov u Hranic' WHERE kod = 773450;
UPDATE ruian_katastr SET nazev = 'Malý Uhřínov' WHERE kod = 773476;
UPDATE ruian_katastr SET nazev = 'Velký Uhřínov' WHERE kod = 773484;
UPDATE ruian_katastr SET nazev = 'Uhřínovice u Jihlavy' WHERE kod = 773492;
UPDATE ruian_katastr SET nazev = 'Uhy' WHERE kod = 773506;
UPDATE ruian_katastr SET nazev = 'Dolní Čepí' WHERE kod = 773514;
UPDATE ruian_katastr SET nazev = 'Horní Čepí' WHERE kod = 773522;
UPDATE ruian_katastr SET nazev = 'Kovářová' WHERE kod = 773549;
UPDATE ruian_katastr SET nazev = 'Lískovec u Nedvědice' WHERE kod = 773557;
UPDATE ruian_katastr SET nazev = 'Ujčov' WHERE kod = 773565;
UPDATE ruian_katastr SET nazev = 'Újezd u Hořovic' WHERE kod = 773573;
UPDATE ruian_katastr SET nazev = 'Újezd u Luštěnic' WHERE kod = 773581;
UPDATE ruian_katastr SET nazev = 'Újezdec u Luštěnic' WHERE kod = 773590;
UPDATE ruian_katastr SET nazev = 'Hvožďany u Vodňan' WHERE kod = 773603;
UPDATE ruian_katastr SET nazev = 'Újezd u Vodňan' WHERE kod = 773611;
UPDATE ruian_katastr SET nazev = 'Újezd u Domažlic' WHERE kod = 773620;
UPDATE ruian_katastr SET nazev = 'Újezd u Manětína' WHERE kod = 773646;
UPDATE ruian_katastr SET nazev = 'Újezd u Hradce Králové' WHERE kod = 773654;
UPDATE ruian_katastr SET nazev = 'Újezd u Sezemic' WHERE kod = 773662;
UPDATE ruian_katastr SET nazev = 'Újezd u Přelouče' WHERE kod = 773689;
UPDATE ruian_katastr SET nazev = 'Újezd u Valašských Klobouk' WHERE kod = 773697;
UPDATE ruian_katastr SET nazev = 'Újezd nad Rokytnou' WHERE kod = 773719;
UPDATE ruian_katastr SET nazev = 'Újezd u Žďáru nad Sázavou' WHERE kod = 773727;
UPDATE ruian_katastr SET nazev = 'Újezd u Uničova' WHERE kod = 773751;
UPDATE ruian_katastr SET nazev = 'Újezd u Mohelnice' WHERE kod = 773760;
UPDATE ruian_katastr SET nazev = 'Újezd nad Lesy' WHERE kod = 773778;
UPDATE ruian_katastr SET nazev = 'Újezd nad Zbečnem' WHERE kod = 773794;
UPDATE ruian_katastr SET nazev = 'Újezd nade Mží' WHERE kod = 773808;
UPDATE ruian_katastr SET nazev = 'Mlýnec pod Přimdou' WHERE kod = 773816;
UPDATE ruian_katastr SET nazev = 'Újezd pod Přimdou' WHERE kod = 773824;
UPDATE ruian_katastr SET nazev = 'Újezd pod Troskami' WHERE kod = 773867;
UPDATE ruian_katastr SET nazev = 'Újezd u Boskovic' WHERE kod = 773875;
UPDATE ruian_katastr SET nazev = 'Újezd u Brna' WHERE kod = 773905;
UPDATE ruian_katastr SET nazev = 'Újezd u Černé Hory' WHERE kod = 773913;
UPDATE ruian_katastr SET nazev = 'Újezd u Chocně' WHERE kod = 773948;
UPDATE ruian_katastr SET nazev = 'Mlynářovice' WHERE kod = 773956;
UPDATE ruian_katastr SET nazev = 'Mlýnské Struhadlo' WHERE kod = 773964;
UPDATE ruian_katastr SET nazev = 'Újezd u Plánice' WHERE kod = 773972;
UPDATE ruian_katastr SET nazev = 'Újezd u Průhonic' WHERE kod = 773999;
UPDATE ruian_katastr SET nazev = 'Újezd u Rosic' WHERE kod = 774006;
UPDATE ruian_katastr SET nazev = 'Újezdec u Mělníka' WHERE kod = 774014;
UPDATE ruian_katastr SET nazev = 'Újezdec u Rakovníka' WHERE kod = 774022;
UPDATE ruian_katastr SET nazev = 'Újezdec u Bělčic' WHERE kod = 774031;
UPDATE ruian_katastr SET nazev = 'Újezdec u Litomyšle' WHERE kod = 774049;
UPDATE ruian_katastr SET nazev = 'Újezdec u Osvětiman' WHERE kod = 774057;
UPDATE ruian_katastr SET nazev = 'Újezdec u Přerova' WHERE kod = 774073;
UPDATE ruian_katastr SET nazev = 'Újezdec u Luhačovic' WHERE kod = 774081;
UPDATE ruian_katastr SET nazev = 'Újezdeček' WHERE kod = 774090;
UPDATE ruian_katastr SET nazev = 'Ujkovice' WHERE kod = 774103;
UPDATE ruian_katastr SET nazev = 'Jetišov' WHERE kod = 774111;
UPDATE ruian_katastr SET nazev = 'Radkovice' WHERE kod = 774120;
UPDATE ruian_katastr SET nazev = 'Švejcarova Lhota' WHERE kod = 774138;
UPDATE ruian_katastr SET nazev = 'Úlehle' WHERE kod = 774146;
UPDATE ruian_katastr SET nazev = 'Řeheč' WHERE kod = 774154;
UPDATE ruian_katastr SET nazev = 'Úlibice' WHERE kod = 774162;
UPDATE ruian_katastr SET nazev = 'Hracholusky nade Mží' WHERE kod = 774171;
UPDATE ruian_katastr SET nazev = 'Kníje' WHERE kod = 774197;
UPDATE ruian_katastr SET nazev = 'Úlice' WHERE kod = 774219;
UPDATE ruian_katastr SET nazev = 'Březová u Úmonína' WHERE kod = 774227;
UPDATE ruian_katastr SET nazev = 'Korotice' WHERE kod = 774243;
UPDATE ruian_katastr SET nazev = 'Lomec u Úmonína' WHERE kod = 774251;
UPDATE ruian_katastr SET nazev = 'Úmonín' WHERE kod = 774278;
UPDATE ruian_katastr SET nazev = 'Ostrov u Poděbrad' WHERE kod = 774286;
UPDATE ruian_katastr SET nazev = 'Úmyslovice' WHERE kod = 774294;
UPDATE ruian_katastr SET nazev = 'Únanov' WHERE kod = 774308;
UPDATE ruian_katastr SET nazev = 'Unčín' WHERE kod = 774316;
UPDATE ruian_katastr SET nazev = 'Rozvadovice' WHERE kod = 774332;
UPDATE ruian_katastr SET nazev = 'Unčovice' WHERE kod = 774341;
UPDATE ruian_katastr SET nazev = 'Únějovice' WHERE kod = 774359;
UPDATE ruian_katastr SET nazev = 'Čbán' WHERE kod = 774367;
UPDATE ruian_katastr SET nazev = 'Hvožďany u Úněšova' WHERE kod = 774375;
UPDATE ruian_katastr SET nazev = 'Lípa u Úněšova' WHERE kod = 774383;
UPDATE ruian_katastr SET nazev = 'Podmokly u Úněšova' WHERE kod = 774391;
UPDATE ruian_katastr SET nazev = 'Úněšov' WHERE kod = 774405;
UPDATE ruian_katastr SET nazev = 'Únětice u Prahy' WHERE kod = 774413;
UPDATE ruian_katastr SET nazev = 'Únětice u Blovic' WHERE kod = 774421;
UPDATE ruian_katastr SET nazev = 'Unhošť' WHERE kod = 774499;
UPDATE ruian_katastr SET nazev = 'Uničov' WHERE kod = 774502;
UPDATE ruian_katastr SET nazev = 'Brníčko' WHERE kod = 774596;
UPDATE ruian_katastr SET nazev = 'Unín' WHERE kod = 774634;
UPDATE ruian_katastr SET nazev = 'Unkovice' WHERE kod = 774642;
UPDATE ruian_katastr SET nazev = 'Úpice' WHERE kod = 774651;
UPDATE ruian_katastr SET nazev = 'Úpohlavy' WHERE kod = 774669;
UPDATE ruian_katastr SET nazev = 'Želechovice' WHERE kod = 774677;
UPDATE ruian_katastr SET nazev = 'Urbanice' WHERE kod = 774685;
UPDATE ruian_katastr SET nazev = 'Urbanov' WHERE kod = 774693;
UPDATE ruian_katastr SET nazev = 'Alojzov u Prostějova' WHERE kod = 774707;
UPDATE ruian_katastr SET nazev = 'Seloutky' WHERE kod = 774715;
UPDATE ruian_katastr SET nazev = 'Určice' WHERE kod = 774723;
UPDATE ruian_katastr SET nazev = 'Úsilné' WHERE kod = 774731;
UPDATE ruian_katastr SET nazev = 'Úsilov' WHERE kod = 774740;
UPDATE ruian_katastr SET nazev = 'Úsobí' WHERE kod = 774766;
UPDATE ruian_katastr SET nazev = 'Úsobrno' WHERE kod = 774774;
UPDATE ruian_katastr SET nazev = 'Úsov-město' WHERE kod = 774782;
UPDATE ruian_katastr SET nazev = 'Úsov-Židovská obec' WHERE kod = 774791;
UPDATE ruian_katastr SET nazev = 'Krutěnice' WHERE kod = 774804;
UPDATE ruian_katastr SET nazev = 'Ústaleč' WHERE kod = 774812;
UPDATE ruian_katastr SET nazev = 'Ústí u Humpolce' WHERE kod = 774821;
UPDATE ruian_katastr SET nazev = 'Ústí' WHERE kod = 774839;
UPDATE ruian_katastr SET nazev = 'Ústí u Vsetína' WHERE kod = 774847;
UPDATE ruian_katastr SET nazev = 'Ústí nad Labem' WHERE kod = 774871;
UPDATE ruian_katastr SET nazev = 'Trmice' WHERE kod = 774979;
UPDATE ruian_katastr SET nazev = 'Předlice' WHERE kod = 775002;
UPDATE ruian_katastr SET nazev = 'Klíše' WHERE kod = 775053;
UPDATE ruian_katastr SET nazev = 'Bukov' WHERE kod = 775096;
UPDATE ruian_katastr SET nazev = 'Všebořice' WHERE kod = 775118;
UPDATE ruian_katastr SET nazev = 'Střekov' WHERE kod = 775258;
UPDATE ruian_katastr SET nazev = 'Krásné Březno' WHERE kod = 775266;
UPDATE ruian_katastr SET nazev = 'Ústí nad Orlicí' WHERE kod = 775274;
UPDATE ruian_katastr SET nazev = 'Hylváty' WHERE kod = 775339;
UPDATE ruian_katastr SET nazev = 'Kerhartice nad Orlicí' WHERE kod = 775347;
UPDATE ruian_katastr SET nazev = 'Oldřichovice u Ústí nad Orlicí' WHERE kod = 775355;
UPDATE ruian_katastr SET nazev = 'Gerhartice' WHERE kod = 775410;
UPDATE ruian_katastr SET nazev = 'Ústín' WHERE kod = 775428;
UPDATE ruian_katastr SET nazev = 'Ústrašice' WHERE kod = 775436;
UPDATE ruian_katastr SET nazev = 'Ústrašín' WHERE kod = 775444;
UPDATE ruian_katastr SET nazev = 'Čížky' WHERE kod = 775452;
UPDATE ruian_katastr SET nazev = 'Úsuší' WHERE kod = 775461;
UPDATE ruian_katastr SET nazev = 'Dolní Vysoké I' WHERE kod = 775479;
UPDATE ruian_katastr SET nazev = 'Habřina u Úštěku' WHERE kod = 775487;
UPDATE ruian_katastr SET nazev = 'Lhota u Úštěku' WHERE kod = 775495;
UPDATE ruian_katastr SET nazev = 'Lukov u Úštěku' WHERE kod = 775509;
UPDATE ruian_katastr SET nazev = 'Úštěk' WHERE kod = 775533;
UPDATE ruian_katastr SET nazev = 'Útěchov u Moravské Třebové' WHERE kod = 775541;
UPDATE ruian_katastr SET nazev = 'Útěchov u Brna' WHERE kod = 775550;
UPDATE ruian_katastr SET nazev = 'Mašovice u Hořepníku' WHERE kod = 775568;
UPDATE ruian_katastr SET nazev = 'Útěchovice u Hořepníku' WHERE kod = 775576;
UPDATE ruian_katastr SET nazev = 'Litohošť' WHERE kod = 775584;
UPDATE ruian_katastr SET nazev = 'Útěchovičky' WHERE kod = 775592;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Pošné' WHERE kod = 775606;
UPDATE ruian_katastr SET nazev = 'Olešovice' WHERE kod = 775614;
UPDATE ruian_katastr SET nazev = 'Úterý' WHERE kod = 775622;
UPDATE ruian_katastr SET nazev = 'Vidžín' WHERE kod = 775631;
UPDATE ruian_katastr SET nazev = 'Utín' WHERE kod = 775649;
UPDATE ruian_katastr SET nazev = 'Robčice u Štěnovic' WHERE kod = 775657;
UPDATE ruian_katastr SET nazev = 'Útušice' WHERE kod = 775665;
UPDATE ruian_katastr SET nazev = 'Chylice u Útviny' WHERE kod = 775673;
UPDATE ruian_katastr SET nazev = 'Sedlo u Toužimi' WHERE kod = 775681;
UPDATE ruian_katastr SET nazev = 'Svinov u Toužimi' WHERE kod = 775690;
UPDATE ruian_katastr SET nazev = 'Útvina' WHERE kod = 775703;
UPDATE ruian_katastr SET nazev = 'Úvalno' WHERE kod = 775711;
UPDATE ruian_katastr SET nazev = 'Úvaly u Prahy' WHERE kod = 775738;
UPDATE ruian_katastr SET nazev = 'Chobot' WHERE kod = 775754;
UPDATE ruian_katastr SET nazev = 'Uzenice' WHERE kod = 775771;
UPDATE ruian_katastr SET nazev = 'Uzeničky' WHERE kod = 775789;
UPDATE ruian_katastr SET nazev = 'Čekanov' WHERE kod = 775801;
UPDATE ruian_katastr SET nazev = 'Mělník nad Sázavou' WHERE kod = 775827;
UPDATE ruian_katastr SET nazev = 'Radvanice nad Sázavou' WHERE kod = 775843;
UPDATE ruian_katastr SET nazev = 'Smrk u Úžic' WHERE kod = 775851;
UPDATE ruian_katastr SET nazev = 'Úžice u Kutné Hory' WHERE kod = 775860;
UPDATE ruian_katastr SET nazev = 'Úžice u Kralup nad Vltavou' WHERE kod = 775886;
UPDATE ruian_katastr SET nazev = 'Dělouš' WHERE kod = 775894;
UPDATE ruian_katastr SET nazev = 'Vacanovice' WHERE kod = 775924;
UPDATE ruian_katastr SET nazev = 'Vacenovice u Kyjova' WHERE kod = 775932;
UPDATE ruian_katastr SET nazev = 'Vacíkov' WHERE kod = 775941;
UPDATE ruian_katastr SET nazev = 'Václavice u Benešova' WHERE kod = 775959;
UPDATE ruian_katastr SET nazev = 'Václavice u Hrádku nad Nisou' WHERE kod = 775991;
UPDATE ruian_katastr SET nazev = 'Václavov u Zábřeha' WHERE kod = 776009;
UPDATE ruian_katastr SET nazev = 'Dolní Václavov' WHERE kod = 776017;
UPDATE ruian_katastr SET nazev = 'Horní Václavov' WHERE kod = 776025;
UPDATE ruian_katastr SET nazev = 'Václavovice u Frýdku-Místku' WHERE kod = 776033;
UPDATE ruian_katastr SET nazev = 'Václavy' WHERE kod = 776050;
UPDATE ruian_katastr SET nazev = 'Miřetice u Vacova' WHERE kod = 776068;
UPDATE ruian_katastr SET nazev = 'Mladíkov' WHERE kod = 776076;
UPDATE ruian_katastr SET nazev = 'Vacov' WHERE kod = 776092;
UPDATE ruian_katastr SET nazev = 'Vlkonice u Vacova' WHERE kod = 776106;
UPDATE ruian_katastr SET nazev = 'Vrbice u Vacova' WHERE kod = 776114;
UPDATE ruian_katastr SET nazev = 'Hamr nad Nežárkou' WHERE kod = 776122;
UPDATE ruian_katastr SET nazev = 'Val u Veselí nad Lužnicí' WHERE kod = 776131;
UPDATE ruian_katastr SET nazev = 'Chlístov u Dobrušky' WHERE kod = 776149;
UPDATE ruian_katastr SET nazev = 'Provoz' WHERE kod = 776157;
UPDATE ruian_katastr SET nazev = 'Val u Dobrušky' WHERE kod = 776165;
UPDATE ruian_katastr SET nazev = 'Valašská Bystřice' WHERE kod = 776254;
UPDATE ruian_katastr SET nazev = 'Valašská Polanka' WHERE kod = 776271;
UPDATE ruian_katastr SET nazev = 'Valašská Senice' WHERE kod = 776297;
UPDATE ruian_katastr SET nazev = 'Mirošov u Valašských Klobouk' WHERE kod = 776301;
UPDATE ruian_katastr SET nazev = 'Valašské Klobouky' WHERE kod = 776319;
UPDATE ruian_katastr SET nazev = 'Valašské Meziříčí-město' WHERE kod = 776360;
UPDATE ruian_katastr SET nazev = 'Krásno nad Bečvou' WHERE kod = 776432;
UPDATE ruian_katastr SET nazev = 'Krhová' WHERE kod = 776505;
UPDATE ruian_katastr SET nazev = 'Valašské Příkazy' WHERE kod = 776521;
UPDATE ruian_katastr SET nazev = 'Valdice' WHERE kod = 776530;
UPDATE ruian_katastr SET nazev = 'Přibyslav u Nové Paky' WHERE kod = 776548;
UPDATE ruian_katastr SET nazev = 'Pustá Proseč' WHERE kod = 776556;
UPDATE ruian_katastr SET nazev = 'Valdov' WHERE kod = 776564;
UPDATE ruian_katastr SET nazev = 'Jeřeň' WHERE kod = 776572;
UPDATE ruian_katastr SET nazev = 'Valeč v Čechách' WHERE kod = 776581;
UPDATE ruian_katastr SET nazev = 'Valeč u Hrotovic' WHERE kod = 776599;
UPDATE ruian_katastr SET nazev = 'Valchov' WHERE kod = 776602;
UPDATE ruian_katastr SET nazev = 'Valkeřice' WHERE kod = 776629;
UPDATE ruian_katastr SET nazev = 'Valšov' WHERE kod = 776637;
UPDATE ruian_katastr SET nazev = 'Valšovice' WHERE kod = 776645;
UPDATE ruian_katastr SET nazev = 'Valteřice u Žandova' WHERE kod = 776653;
UPDATE ruian_katastr SET nazev = 'Valteřice v Krkonoších' WHERE kod = 776661;
UPDATE ruian_katastr SET nazev = 'Úvaly u Valtic' WHERE kod = 776688;
UPDATE ruian_katastr SET nazev = 'Valtice' WHERE kod = 776696;
UPDATE ruian_katastr SET nazev = 'Valtínov' WHERE kod = 776700;
UPDATE ruian_katastr SET nazev = 'Valtířov nad Labem' WHERE kod = 776726;
UPDATE ruian_katastr SET nazev = 'Křídlůvky' WHERE kod = 776734;
UPDATE ruian_katastr SET nazev = 'Valtrovice' WHERE kod = 776742;
UPDATE ruian_katastr SET nazev = 'Valy u Mariánských Lázní' WHERE kod = 776751;
UPDATE ruian_katastr SET nazev = 'Valy nad Labem' WHERE kod = 776769;
UPDATE ruian_katastr SET nazev = 'Vamberk' WHERE kod = 776785;
UPDATE ruian_katastr SET nazev = 'Vanice' WHERE kod = 776793;
UPDATE ruian_katastr SET nazev = 'Vaňov' WHERE kod = 776807;
UPDATE ruian_katastr SET nazev = 'Vanov' WHERE kod = 776815;
UPDATE ruian_katastr SET nazev = 'Drválovice' WHERE kod = 776823;
UPDATE ruian_katastr SET nazev = 'Vanovice' WHERE kod = 776831;
UPDATE ruian_katastr SET nazev = 'Vanůvek' WHERE kod = 776840;
UPDATE ruian_katastr SET nazev = 'Vápenice u Starého Hrozenkova' WHERE kod = 776882;
UPDATE ruian_katastr SET nazev = 'Vápenná' WHERE kod = 776904;
UPDATE ruian_katastr SET nazev = 'Cítkov' WHERE kod = 776921;
UPDATE ruian_katastr SET nazev = 'Nerozhovice' WHERE kod = 776939;
UPDATE ruian_katastr SET nazev = 'Vápenný Podol' WHERE kod = 776947;
UPDATE ruian_katastr SET nazev = 'Vápno u Přelouče' WHERE kod = 776955;
UPDATE ruian_katastr SET nazev = 'Vápovice' WHERE kod = 776963;
UPDATE ruian_katastr SET nazev = 'Varnsdorf' WHERE kod = 776971;
UPDATE ruian_katastr SET nazev = 'Sazomín' WHERE kod = 777153;
UPDATE ruian_katastr SET nazev = 'Vatín' WHERE kod = 777161;
UPDATE ruian_katastr SET nazev = 'Držkovice' WHERE kod = 777170;
UPDATE ruian_katastr SET nazev = 'Palhanec' WHERE kod = 777188;
UPDATE ruian_katastr SET nazev = 'Vávrovice' WHERE kod = 777196;
UPDATE ruian_katastr SET nazev = 'Chmeliště' WHERE kod = 777200;
UPDATE ruian_katastr SET nazev = 'Vavřinec' WHERE kod = 777218;
UPDATE ruian_katastr SET nazev = 'Žíšov' WHERE kod = 777226;
UPDATE ruian_katastr SET nazev = 'Suchdol v Moravském krasu' WHERE kod = 777251;
UPDATE ruian_katastr SET nazev = 'Vavřinec na Moravě' WHERE kod = 777269;
UPDATE ruian_katastr SET nazev = 'Veselice na Moravě' WHERE kod = 777277;
UPDATE ruian_katastr SET nazev = 'Vážany u Boskovic' WHERE kod = 777285;
UPDATE ruian_katastr SET nazev = 'Vážany u Uherského Hradiště' WHERE kod = 777293;
UPDATE ruian_katastr SET nazev = 'Vážany u Vyškova' WHERE kod = 777307;
UPDATE ruian_katastr SET nazev = 'Královopolské Vážany' WHERE kod = 777315;
UPDATE ruian_katastr SET nazev = 'Vítovice' WHERE kod = 777323;
UPDATE ruian_katastr SET nazev = 'Vážany nad Litavou' WHERE kod = 777331;
UPDATE ruian_katastr SET nazev = 'Babákov' WHERE kod = 777358;
UPDATE ruian_katastr SET nazev = 'Příkrakov' WHERE kod = 777366;
UPDATE ruian_katastr SET nazev = 'Včelákov' WHERE kod = 777374;
UPDATE ruian_katastr SET nazev = 'Včelná' WHERE kod = 777382;
UPDATE ruian_katastr SET nazev = 'Včelnička' WHERE kod = 777391;
UPDATE ruian_katastr SET nazev = 'Návary' WHERE kod = 777404;
UPDATE ruian_katastr SET nazev = 'Veclov' WHERE kod = 777412;
UPDATE ruian_katastr SET nazev = 'Koníkov' WHERE kod = 777439;
UPDATE ruian_katastr SET nazev = 'Jimramovské Pavlovice' WHERE kod = 777447;
UPDATE ruian_katastr SET nazev = 'Míchov' WHERE kod = 777455;
UPDATE ruian_katastr SET nazev = 'Odranec' WHERE kod = 777463;
UPDATE ruian_katastr SET nazev = 'Roženecké Paseky' WHERE kod = 777471;
UPDATE ruian_katastr SET nazev = 'Věcov' WHERE kod = 777480;
UPDATE ruian_katastr SET nazev = 'Vědlice' WHERE kod = 777501;
UPDATE ruian_katastr SET nazev = 'Vědomice' WHERE kod = 777510;
UPDATE ruian_katastr SET nazev = 'Vedrovice' WHERE kod = 777536;
UPDATE ruian_katastr SET nazev = 'Věchnov' WHERE kod = 777544;
UPDATE ruian_katastr SET nazev = 'Vejprnice' WHERE kod = 777552;
UPDATE ruian_katastr SET nazev = 'Černý Potok' WHERE kod = 777561;
UPDATE ruian_katastr SET nazev = 'Vejprty' WHERE kod = 777579;
UPDATE ruian_katastr SET nazev = 'Chomle' WHERE kod = 777587;
UPDATE ruian_katastr SET nazev = 'Vejvanov' WHERE kod = 777609;
UPDATE ruian_katastr SET nazev = 'Dvakačovice' WHERE kod = 777617;
UPDATE ruian_katastr SET nazev = 'Vejvanovice' WHERE kod = 777625;
UPDATE ruian_katastr SET nazev = 'Velatice' WHERE kod = 777633;
UPDATE ruian_katastr SET nazev = 'Pastuchovice' WHERE kod = 777650;
UPDATE ruian_katastr SET nazev = 'Velečín' WHERE kod = 777668;
UPDATE ruian_katastr SET nazev = 'Velehrad' WHERE kod = 777676;
UPDATE ruian_katastr SET nazev = 'Březno' WHERE kod = 777684;
UPDATE ruian_katastr SET nazev = 'Velemín' WHERE kod = 777692;
UPDATE ruian_katastr SET nazev = 'Minice' WHERE kod = 777706;
UPDATE ruian_katastr SET nazev = 'Velemyšleves' WHERE kod = 777722;
UPDATE ruian_katastr SET nazev = 'Zálezly' WHERE kod = 777731;
UPDATE ruian_katastr SET nazev = 'Veleň' WHERE kod = 777757;
UPDATE ruian_katastr SET nazev = 'Velenice' WHERE kod = 777765;
UPDATE ruian_katastr SET nazev = 'Velenice u Zákup' WHERE kod = 777773;
UPDATE ruian_katastr SET nazev = 'Velenka' WHERE kod = 777781;
UPDATE ruian_katastr SET nazev = 'Velenov' WHERE kod = 777790;
UPDATE ruian_katastr SET nazev = 'Velenovy' WHERE kod = 777803;
UPDATE ruian_katastr SET nazev = 'Prostřední Svince-Holkov' WHERE kod = 777820;
UPDATE ruian_katastr SET nazev = 'Chodeč' WHERE kod = 777838;
UPDATE ruian_katastr SET nazev = 'Mojné-Skřidla' WHERE kod = 777846;
UPDATE ruian_katastr SET nazev = 'Velešín' WHERE kod = 777854;
UPDATE ruian_katastr SET nazev = 'Holubice' WHERE kod = 777871;
UPDATE ruian_katastr SET nazev = 'Velešovice' WHERE kod = 777897;
UPDATE ruian_katastr SET nazev = 'Veletiny' WHERE kod = 777919;
UPDATE ruian_katastr SET nazev = 'Veletov' WHERE kod = 777927;
UPDATE ruian_katastr SET nazev = 'Velhartice' WHERE kod = 777935;
UPDATE ruian_katastr SET nazev = 'Velichov' WHERE kod = 777943;
UPDATE ruian_katastr SET nazev = 'Velichovky' WHERE kod = 777951;
UPDATE ruian_katastr SET nazev = 'Veliká Ves u Prahy' WHERE kod = 777960;
UPDATE ruian_katastr SET nazev = 'Veliká Ves' WHERE kod = 778001;
UPDATE ruian_katastr SET nazev = 'Velíková' WHERE kod = 778028;
UPDATE ruian_katastr SET nazev = 'Velim' WHERE kod = 778036;
UPDATE ruian_katastr SET nazev = 'Vítězov' WHERE kod = 778044;
UPDATE ruian_katastr SET nazev = 'Veliny' WHERE kod = 778052;
UPDATE ruian_katastr SET nazev = 'Hrzín' WHERE kod = 778061;
UPDATE ruian_katastr SET nazev = 'Nespery' WHERE kod = 778079;
UPDATE ruian_katastr SET nazev = 'Ostrov u Veliše' WHERE kod = 778087;
UPDATE ruian_katastr SET nazev = 'Sedlečko u Veliše' WHERE kod = 778095;
UPDATE ruian_katastr SET nazev = 'Veliš' WHERE kod = 778109;
UPDATE ruian_katastr SET nazev = 'Bukvice' WHERE kod = 778117;
UPDATE ruian_katastr SET nazev = 'Veliš u Jičína' WHERE kod = 778133;
UPDATE ruian_katastr SET nazev = 'Vesec u Jičína' WHERE kod = 778141;
UPDATE ruian_katastr SET nazev = 'Velká nad Vltavou' WHERE kod = 778150;
UPDATE ruian_katastr SET nazev = 'Velká u Milevska' WHERE kod = 778168;
UPDATE ruian_katastr SET nazev = 'Lhotka u Hranic' WHERE kod = 778176;
UPDATE ruian_katastr SET nazev = 'Velká u Hranic' WHERE kod = 778184;
UPDATE ruian_katastr SET nazev = 'Košíkov' WHERE kod = 778192;
UPDATE ruian_katastr SET nazev = 'Ludvíkov u Velké Bíteše' WHERE kod = 778206;
UPDATE ruian_katastr SET nazev = 'Velká Bíteš' WHERE kod = 778214;
UPDATE ruian_katastr SET nazev = 'Velká Buková' WHERE kod = 778257;
UPDATE ruian_katastr SET nazev = 'Karlovka' WHERE kod = 778265;
UPDATE ruian_katastr SET nazev = 'Velká Bukovina' WHERE kod = 778273;
UPDATE ruian_katastr SET nazev = 'Velká Bystřice' WHERE kod = 778281;
UPDATE ruian_katastr SET nazev = 'Velká Černoc' WHERE kod = 778290;
UPDATE ruian_katastr SET nazev = 'Velká Dobrá' WHERE kod = 778303;
UPDATE ruian_katastr SET nazev = 'Klimentov' WHERE kod = 778311;
UPDATE ruian_katastr SET nazev = 'Malá Hleďsebe' WHERE kod = 778320;
UPDATE ruian_katastr SET nazev = 'Velká Hleďsebe' WHERE kod = 778338;
UPDATE ruian_katastr SET nazev = 'Velká Chmelištná' WHERE kod = 778354;
UPDATE ruian_katastr SET nazev = 'Lesná u Velké Chyšky' WHERE kod = 778362;
UPDATE ruian_katastr SET nazev = 'Útěchovice pod Stražištěm' WHERE kod = 778371;
UPDATE ruian_katastr SET nazev = 'Velká Chyška' WHERE kod = 778389;
UPDATE ruian_katastr SET nazev = 'Velká Javorská' WHERE kod = 778397;
UPDATE ruian_katastr SET nazev = 'Velká Jesenice' WHERE kod = 778419;
UPDATE ruian_katastr SET nazev = 'Veselice nad Metují' WHERE kod = 778427;
UPDATE ruian_katastr SET nazev = 'Volovka' WHERE kod = 778443;
UPDATE ruian_katastr SET nazev = 'Fojtova Kraš' WHERE kod = 778451;
UPDATE ruian_katastr SET nazev = 'Hukovice u Velké Kraše' WHERE kod = 778460;
UPDATE ruian_katastr SET nazev = 'Malá Kraš' WHERE kod = 778478;
UPDATE ruian_katastr SET nazev = 'Velká Kraš' WHERE kod = 778486;
UPDATE ruian_katastr SET nazev = 'Velká Lečice' WHERE kod = 778494;
UPDATE ruian_katastr SET nazev = 'Velká Lhota u Dačic' WHERE kod = 778516;
UPDATE ruian_katastr SET nazev = 'Velká Lhota u Valašského Meziříčí' WHERE kod = 778541;
UPDATE ruian_katastr SET nazev = 'Nové Dvory u Velké Losenice' WHERE kod = 778559;
UPDATE ruian_katastr SET nazev = 'Pořežín' WHERE kod = 778567;
UPDATE ruian_katastr SET nazev = 'Velká Losenice' WHERE kod = 778575;
UPDATE ruian_katastr SET nazev = 'Velká nad Veličkou' WHERE kod = 778583;
UPDATE ruian_katastr SET nazev = 'Velká Polom' WHERE kod = 778591;
UPDATE ruian_katastr SET nazev = 'Velká Roudka' WHERE kod = 778605;
UPDATE ruian_katastr SET nazev = 'Velká Skrovnice' WHERE kod = 778630;
UPDATE ruian_katastr SET nazev = 'Velká Veleň' WHERE kod = 778648;
UPDATE ruian_katastr SET nazev = 'Velká Ves' WHERE kod = 778656;
UPDATE ruian_katastr SET nazev = 'Velké Albrechtice' WHERE kod = 778664;
UPDATE ruian_katastr SET nazev = 'Velké Bílovice' WHERE kod = 778672;
UPDATE ruian_katastr SET nazev = 'Velké Březno' WHERE kod = 778681;
UPDATE ruian_katastr SET nazev = 'Vítov u Velkého Března' WHERE kod = 778699;
UPDATE ruian_katastr SET nazev = 'Jadruž' WHERE kod = 778702;
UPDATE ruian_katastr SET nazev = 'Kundratice u Přimdy' WHERE kod = 778711;
UPDATE ruian_katastr SET nazev = 'Malé Dvorce' WHERE kod = 778729;
UPDATE ruian_katastr SET nazev = 'Velké Dvorce' WHERE kod = 778737;
UPDATE ruian_katastr SET nazev = 'Bohdalovice' WHERE kod = 778745;
UPDATE ruian_katastr SET nazev = 'Velké Hamry' WHERE kod = 778753;
UPDATE ruian_katastr SET nazev = 'Velké Heraltice' WHERE kod = 778770;
UPDATE ruian_katastr SET nazev = 'Velké Heřmanice' WHERE kod = 778796;
UPDATE ruian_katastr SET nazev = 'Velké Hostěrádky' WHERE kod = 778800;
UPDATE ruian_katastr SET nazev = 'Velké Hoštice' WHERE kod = 778826;
UPDATE ruian_katastr SET nazev = 'Velké Hydčice' WHERE kod = 778834;
UPDATE ruian_katastr SET nazev = 'Velké Chvalovice' WHERE kod = 778842;
UPDATE ruian_katastr SET nazev = 'Malé Chvojno' WHERE kod = 778851;
UPDATE ruian_katastr SET nazev = 'Velké Chvojno' WHERE kod = 778869;
UPDATE ruian_katastr SET nazev = 'Velké Janovice' WHERE kod = 778877;
UPDATE ruian_katastr SET nazev = 'Malé Karlovice' WHERE kod = 778958;
UPDATE ruian_katastr SET nazev = 'Velké Karlovice' WHERE kod = 779016;
UPDATE ruian_katastr SET nazev = 'Velké Koloděje' WHERE kod = 779041;
UPDATE ruian_katastr SET nazev = 'Velké Kunětice' WHERE kod = 779075;
UPDATE ruian_katastr SET nazev = 'Velké Losiny' WHERE kod = 779083;
UPDATE ruian_katastr SET nazev = 'Velké Meziříčí' WHERE kod = 779091;
UPDATE ruian_katastr SET nazev = 'Velké Němčice' WHERE kod = 779229;
UPDATE ruian_katastr SET nazev = 'Velké Opatovice' WHERE kod = 779237;
UPDATE ruian_katastr SET nazev = 'Velké Pavlovice' WHERE kod = 779245;
UPDATE ruian_katastr SET nazev = 'Maršov nad Metují' WHERE kod = 779253;
UPDATE ruian_katastr SET nazev = 'Velké Petrovice' WHERE kod = 779261;
UPDATE ruian_katastr SET nazev = 'Lojovice' WHERE kod = 779318;
UPDATE ruian_katastr SET nazev = 'Mokřany u Velkých Popovic' WHERE kod = 779326;
UPDATE ruian_katastr SET nazev = 'Velké Popovice' WHERE kod = 779342;
UPDATE ruian_katastr SET nazev = 'Kamýk u Velkých Přílep' WHERE kod = 779351;
UPDATE ruian_katastr SET nazev = 'Velké Přílepy' WHERE kod = 779369;
UPDATE ruian_katastr SET nazev = 'Velké Přítočno' WHERE kod = 779377;
UPDATE ruian_katastr SET nazev = 'Velké Svatoňovice' WHERE kod = 779385;
UPDATE ruian_katastr SET nazev = 'Velké Všelisy' WHERE kod = 779415;
UPDATE ruian_katastr SET nazev = 'Malíč' WHERE kod = 779431;
UPDATE ruian_katastr SET nazev = 'Michalovice u Velkých Žernosek' WHERE kod = 779440;
UPDATE ruian_katastr SET nazev = 'Velké Žernoseky' WHERE kod = 779458;
UPDATE ruian_katastr SET nazev = 'Bradlo' WHERE kod = 779466;
UPDATE ruian_katastr SET nazev = 'Jeclov' WHERE kod = 779474;
UPDATE ruian_katastr SET nazev = 'Velký Beranov' WHERE kod = 779491;
UPDATE ruian_katastr SET nazev = 'Velký Bor u Strunkovic' WHERE kod = 779512;
UPDATE ruian_katastr SET nazev = 'Jetenovice' WHERE kod = 779521;
UPDATE ruian_katastr SET nazev = 'Velký Bor u Horažďovic' WHERE kod = 779539;
UPDATE ruian_katastr SET nazev = 'Mělnická Vrutice' WHERE kod = 779547;
UPDATE ruian_katastr SET nazev = 'Skuhrov u Mělníka' WHERE kod = 779555;
UPDATE ruian_katastr SET nazev = 'Velký Borek' WHERE kod = 779563;
UPDATE ruian_katastr SET nazev = 'Velký Grunov' WHERE kod = 779571;
UPDATE ruian_katastr SET nazev = 'Velký Chlumec' WHERE kod = 779598;
UPDATE ruian_katastr SET nazev = 'Velký Jeníkov' WHERE kod = 779601;
UPDATE ruian_katastr SET nazev = 'Malý Ježov' WHERE kod = 779610;
UPDATE ruian_katastr SET nazev = 'Velký Ježov' WHERE kod = 779628;
UPDATE ruian_katastr SET nazev = 'Těchobuz II' WHERE kod = 779636;
UPDATE ruian_katastr SET nazev = 'Jivjany' WHERE kod = 779644;
UPDATE ruian_katastr SET nazev = 'Ostromeč' WHERE kod = 779652;
UPDATE ruian_katastr SET nazev = 'Velký Malahov' WHERE kod = 779661;
UPDATE ruian_katastr SET nazev = 'Velký Ořechov' WHERE kod = 779679;
UPDATE ruian_katastr SET nazev = 'Velký Osek' WHERE kod = 779687;
UPDATE ruian_katastr SET nazev = 'Velký Pěčín' WHERE kod = 779695;
UPDATE ruian_katastr SET nazev = 'Velký Ratmírov' WHERE kod = 779709;
UPDATE ruian_katastr SET nazev = 'Velký Rybník u Humpolce' WHERE kod = 779717;
UPDATE ruian_katastr SET nazev = 'Knížecí' WHERE kod = 779733;
UPDATE ruian_katastr SET nazev = 'Staré Hraběcí' WHERE kod = 779750;
UPDATE ruian_katastr SET nazev = 'Velký Šenov' WHERE kod = 779768;
UPDATE ruian_katastr SET nazev = 'Velký Třebešov' WHERE kod = 779776;
UPDATE ruian_katastr SET nazev = 'Velký Týnec' WHERE kod = 779784;
UPDATE ruian_katastr SET nazev = 'Velký Újezd' WHERE kod = 779792;
UPDATE ruian_katastr SET nazev = 'Velký Valtinov' WHERE kod = 779822;
UPDATE ruian_katastr SET nazev = 'Velký Vřešťov' WHERE kod = 779831;
UPDATE ruian_katastr SET nazev = 'Vělopolí' WHERE kod = 779849;
UPDATE ruian_katastr SET nazev = 'Veltěže' WHERE kod = 779857;
UPDATE ruian_katastr SET nazev = 'Veltruby' WHERE kod = 779865;
UPDATE ruian_katastr SET nazev = 'Veltrusy' WHERE kod = 779873;
UPDATE ruian_katastr SET nazev = 'Velká Bučina' WHERE kod = 779954;
UPDATE ruian_katastr SET nazev = 'Velvary' WHERE kod = 779962;
UPDATE ruian_katastr SET nazev = 'Vémyslice' WHERE kod = 779971;
UPDATE ruian_katastr SET nazev = 'Vendolí' WHERE kod = 779989;
UPDATE ruian_katastr SET nazev = 'Vendryně' WHERE kod = 780014;
UPDATE ruian_katastr SET nazev = 'Miřátky' WHERE kod = 780031;
UPDATE ruian_katastr SET nazev = 'Vepříkov' WHERE kod = 780049;
UPDATE ruian_katastr SET nazev = 'Vepřová' WHERE kod = 780057;
UPDATE ruian_katastr SET nazev = 'Verdek' WHERE kod = 780073;
UPDATE ruian_katastr SET nazev = 'Verměřovice' WHERE kod = 780081;
UPDATE ruian_katastr SET nazev = 'Čáslav u Verneřic' WHERE kod = 780090;
UPDATE ruian_katastr SET nazev = 'Loučky u Verneřic' WHERE kod = 780103;
UPDATE ruian_katastr SET nazev = 'Příbram pod Bukovou horou' WHERE kod = 780111;
UPDATE ruian_katastr SET nazev = 'Rychnov u Verneřic' WHERE kod = 780120;
UPDATE ruian_katastr SET nazev = 'Rytířov' WHERE kod = 780138;
UPDATE ruian_katastr SET nazev = 'Verneřice' WHERE kod = 780146;
UPDATE ruian_katastr SET nazev = 'Velké Stínky' WHERE kod = 780154;
UPDATE ruian_katastr SET nazev = 'Dolní Paseky' WHERE kod = 780162;
UPDATE ruian_katastr SET nazev = 'Horní Paseky' WHERE kod = 780171;
UPDATE ruian_katastr SET nazev = 'Vernéřov u Aše' WHERE kod = 780189;
UPDATE ruian_katastr SET nazev = 'Hradiště u Vernéřova' WHERE kod = 780197;
UPDATE ruian_katastr SET nazev = 'Pavlov u Vernéřova' WHERE kod = 780201;
UPDATE ruian_katastr SET nazev = 'Potočná u Vernéřova' WHERE kod = 780219;
UPDATE ruian_katastr SET nazev = 'Vernéřov' WHERE kod = 780227;
UPDATE ruian_katastr SET nazev = 'Vernířovice u Sobotína' WHERE kod = 780235;
UPDATE ruian_katastr SET nazev = 'Věrovany' WHERE kod = 780260;
UPDATE ruian_katastr SET nazev = 'Budov' WHERE kod = 780278;
UPDATE ruian_katastr SET nazev = 'Hřivínov' WHERE kod = 780286;
UPDATE ruian_katastr SET nazev = 'Týniště' WHERE kod = 780294;
UPDATE ruian_katastr SET nazev = 'Vahaneč' WHERE kod = 780308;
UPDATE ruian_katastr SET nazev = 'Verušičky' WHERE kod = 780316;
UPDATE ruian_katastr SET nazev = 'Záhoří u Verušiček' WHERE kod = 780324;
UPDATE ruian_katastr SET nazev = 'Boubín' WHERE kod = 780332;
UPDATE ruian_katastr SET nazev = 'Veřechov' WHERE kod = 780341;
UPDATE ruian_katastr SET nazev = 'Věřňovice' WHERE kod = 780359;
UPDATE ruian_katastr SET nazev = 'Veřovice' WHERE kod = 780367;
UPDATE ruian_katastr SET nazev = 'Mířovice' WHERE kod = 780375;
UPDATE ruian_katastr SET nazev = 'Ves Touškov' WHERE kod = 780383;
UPDATE ruian_katastr SET nazev = 'Vesce u Dačic' WHERE kod = 780391;
UPDATE ruian_katastr SET nazev = 'Čeraz' WHERE kod = 780405;
UPDATE ruian_katastr SET nazev = 'Mokrá u Soběslavi' WHERE kod = 780413;
UPDATE ruian_katastr SET nazev = 'Nedvědice u Soběslavi' WHERE kod = 780421;
UPDATE ruian_katastr SET nazev = 'Vesce u Soběslavi' WHERE kod = 780430;
UPDATE ruian_katastr SET nazev = 'Častohostice' WHERE kod = 780448;
UPDATE ruian_katastr SET nazev = 'Lažínky' WHERE kod = 780456;
UPDATE ruian_katastr SET nazev = 'Vesce u Moravských Budějovic' WHERE kod = 780464;
UPDATE ruian_katastr SET nazev = 'Vesec u Liberce' WHERE kod = 780472;
UPDATE ruian_katastr SET nazev = 'Buda' WHERE kod = 780481;
UPDATE ruian_katastr SET nazev = 'Horka u Bakova nad Jizerou' WHERE kod = 780499;
UPDATE ruian_katastr SET nazev = 'Veselá u Mnichova Hradiště' WHERE kod = 780502;
UPDATE ruian_katastr SET nazev = 'Veselá u Častrova' WHERE kod = 780511;
UPDATE ruian_katastr SET nazev = 'Veselá u Rokycan' WHERE kod = 780529;
UPDATE ruian_katastr SET nazev = 'Bítouchov u Veselé' WHERE kod = 780537;
UPDATE ruian_katastr SET nazev = 'Kotelsko' WHERE kod = 780545;
UPDATE ruian_katastr SET nazev = 'Veselá u Semil' WHERE kod = 780561;
UPDATE ruian_katastr SET nazev = 'Veselá u Zlína' WHERE kod = 780588;
UPDATE ruian_katastr SET nazev = 'Veselá u Valašského Meziříčí' WHERE kod = 780596;
UPDATE ruian_katastr SET nazev = 'Kamenická Nová Víska' WHERE kod = 780600;
UPDATE ruian_katastr SET nazev = 'Veselé' WHERE kod = 780618;
UPDATE ruian_katastr SET nazev = 'Veselí u Přelouče' WHERE kod = 780642;
UPDATE ruian_katastr SET nazev = 'Vacetín' WHERE kod = 780651;
UPDATE ruian_katastr SET nazev = 'Veselí u Mohelnice' WHERE kod = 780669;
UPDATE ruian_katastr SET nazev = 'Veselí nad Lužnicí' WHERE kod = 780685;
UPDATE ruian_katastr SET nazev = 'Žíšov u Veselí nad Lužnicí' WHERE kod = 780693;
UPDATE ruian_katastr SET nazev = 'Veselí nad Moravou' WHERE kod = 780723;
UPDATE ruian_katastr SET nazev = 'Veselí-Předměstí' WHERE kod = 780731;
UPDATE ruian_katastr SET nazev = 'Milokošť' WHERE kod = 780791;
UPDATE ruian_katastr SET nazev = 'Zarazice' WHERE kod = 780804;
UPDATE ruian_katastr SET nazev = 'Veselice' WHERE kod = 780812;
UPDATE ruian_katastr SET nazev = 'Bilina' WHERE kod = 780821;
UPDATE ruian_katastr SET nazev = 'Veselíčko u Milevska' WHERE kod = 780839;
UPDATE ruian_katastr SET nazev = 'Veselíčko u Žďáru nad Sázavou' WHERE kod = 780847;
UPDATE ruian_katastr SET nazev = 'Tupec' WHERE kod = 780855;
UPDATE ruian_katastr SET nazev = 'Veselíčko u Lipníka nad Bečvou' WHERE kod = 780863;
UPDATE ruian_katastr SET nazev = 'Jedovary' WHERE kod = 780880;
UPDATE ruian_katastr SET nazev = 'Ostrolovský Újezd' WHERE kod = 780898;
UPDATE ruian_katastr SET nazev = 'Otěvěk' WHERE kod = 780901;
UPDATE ruian_katastr SET nazev = 'Rankov u Trhových Svinů' WHERE kod = 780910;
UPDATE ruian_katastr SET nazev = 'Knínice u Žlutic' WHERE kod = 780936;
UPDATE ruian_katastr SET nazev = 'Ratiboř u Žlutic' WHERE kod = 780944;
UPDATE ruian_katastr SET nazev = 'Veselov' WHERE kod = 780952;
UPDATE ruian_katastr SET nazev = 'Veselý Žďár' WHERE kod = 780961;
UPDATE ruian_katastr SET nazev = 'Veská' WHERE kod = 780979;
UPDATE ruian_katastr SET nazev = 'Véska u Olomouce' WHERE kod = 780987;
UPDATE ruian_katastr SET nazev = 'Vésky' WHERE kod = 780995;
UPDATE ruian_katastr SET nazev = 'Vestec nad Mrlinou' WHERE kod = 781011;
UPDATE ruian_katastr SET nazev = 'Vestec u Prahy' WHERE kod = 781029;
UPDATE ruian_katastr SET nazev = 'Bolešín' WHERE kod = 781037;
UPDATE ruian_katastr SET nazev = 'Věstín' WHERE kod = 781045;
UPDATE ruian_katastr SET nazev = 'Věstínek' WHERE kod = 781053;
UPDATE ruian_katastr SET nazev = 'Buková u Rožmitálu pod Třemšínem' WHERE kod = 781061;
UPDATE ruian_katastr SET nazev = 'Věšín' WHERE kod = 781088;
UPDATE ruian_katastr SET nazev = 'Věteřov' WHERE kod = 781096;
UPDATE ruian_katastr SET nazev = 'Velešov' WHERE kod = 781100;
UPDATE ruian_katastr SET nazev = 'Větrný Jeníkov' WHERE kod = 781118;
UPDATE ruian_katastr SET nazev = 'Větrušice u Klecan' WHERE kod = 781126;
UPDATE ruian_katastr SET nazev = 'Jelenice' WHERE kod = 781134;
UPDATE ruian_katastr SET nazev = 'Nové Vrbno' WHERE kod = 781142;
UPDATE ruian_katastr SET nazev = 'Větřkovice u Vítkova' WHERE kod = 781151;
UPDATE ruian_katastr SET nazev = 'Bohdalovice u Větřní' WHERE kod = 781169;
UPDATE ruian_katastr SET nazev = 'Hašlovice' WHERE kod = 781193;
UPDATE ruian_katastr SET nazev = 'Záhoří u Větřní' WHERE kod = 781215;
UPDATE ruian_katastr SET nazev = 'Větřní' WHERE kod = 781231;
UPDATE ruian_katastr SET nazev = 'Všeměry-Zátoň' WHERE kod = 781240;
UPDATE ruian_katastr SET nazev = 'Zátoňské Dvory' WHERE kod = 781258;
UPDATE ruian_katastr SET nazev = 'Svéraz u Větřní' WHERE kod = 781266;
UPDATE ruian_katastr SET nazev = 'Velké Strážné' WHERE kod = 781274;
UPDATE ruian_katastr SET nazev = 'Vevčice' WHERE kod = 781282;
UPDATE ruian_katastr SET nazev = 'Veverská Bítýška' WHERE kod = 781304;
UPDATE ruian_katastr SET nazev = 'Veverské Knínice' WHERE kod = 781312;
UPDATE ruian_katastr SET nazev = 'Věž' WHERE kod = 781321;
UPDATE ruian_katastr SET nazev = 'Věžky' WHERE kod = 781339;
UPDATE ruian_katastr SET nazev = 'Vlčí Doly' WHERE kod = 781347;
UPDATE ruian_katastr SET nazev = 'Věžná' WHERE kod = 781355;
UPDATE ruian_katastr SET nazev = 'Jabloňov' WHERE kod = 781363;
UPDATE ruian_katastr SET nazev = 'Věžná na Moravě' WHERE kod = 781380;
UPDATE ruian_katastr SET nazev = 'Dolní Věžnice' WHERE kod = 781398;
UPDATE ruian_katastr SET nazev = 'Horní Věžnice' WHERE kod = 781401;
UPDATE ruian_katastr SET nazev = 'Věžnice' WHERE kod = 781410;
UPDATE ruian_katastr SET nazev = 'Věžnička' WHERE kod = 781428;
UPDATE ruian_katastr SET nazev = 'Radostice u Vchynice' WHERE kod = 781436;
UPDATE ruian_katastr SET nazev = 'Vchynice' WHERE kod = 781444;
UPDATE ruian_katastr SET nazev = 'Víceměřice' WHERE kod = 781452;
UPDATE ruian_katastr SET nazev = 'Vícemil' WHERE kod = 781479;
UPDATE ruian_katastr SET nazev = 'Vícenice u Náměště nad Oslavou' WHERE kod = 781487;
UPDATE ruian_katastr SET nazev = 'Vícov' WHERE kod = 781495;
UPDATE ruian_katastr SET nazev = 'Vidče' WHERE kod = 781525;
UPDATE ruian_katastr SET nazev = 'Vídeň' WHERE kod = 781541;
UPDATE ruian_katastr SET nazev = 'Mukoděly' WHERE kod = 781550;
UPDATE ruian_katastr SET nazev = 'Vidhostice' WHERE kod = 781568;
UPDATE ruian_katastr SET nazev = 'Roztěž' WHERE kod = 781592;
UPDATE ruian_katastr SET nazev = 'Tuchotice' WHERE kod = 781606;
UPDATE ruian_katastr SET nazev = 'Vidice u Kutné Hory' WHERE kod = 781614;
UPDATE ruian_katastr SET nazev = 'Chřebřany' WHERE kod = 781622;
UPDATE ruian_katastr SET nazev = 'Libosváry' WHERE kod = 781631;
UPDATE ruian_katastr SET nazev = 'Oplotec' WHERE kod = 781649;
UPDATE ruian_katastr SET nazev = 'Vidice' WHERE kod = 781657;
UPDATE ruian_katastr SET nazev = 'Osinalice' WHERE kod = 781673;
UPDATE ruian_katastr SET nazev = 'Vidim' WHERE kod = 781681;
UPDATE ruian_katastr SET nazev = 'Vidlatá Seč' WHERE kod = 781690;
UPDATE ruian_katastr SET nazev = 'Vidnava' WHERE kod = 781711;
UPDATE ruian_katastr SET nazev = 'Stupná' WHERE kod = 781720;
UPDATE ruian_katastr SET nazev = 'Vidochov' WHERE kod = 781738;
UPDATE ruian_katastr SET nazev = 'Vidonice' WHERE kod = 781746;
UPDATE ruian_katastr SET nazev = 'Vidonín' WHERE kod = 781754;
UPDATE ruian_katastr SET nazev = 'Vigantice' WHERE kod = 781762;
UPDATE ruian_katastr SET nazev = 'Horní Sytová' WHERE kod = 781771;
UPDATE ruian_katastr SET nazev = 'Víchová nad Jizerou' WHERE kod = 781789;
UPDATE ruian_katastr SET nazev = 'Víchovská Lhota' WHERE kod = 781797;
UPDATE ruian_katastr SET nazev = 'Šléglov' WHERE kod = 781801;
UPDATE ruian_katastr SET nazev = 'Vikantice' WHERE kod = 781819;
UPDATE ruian_katastr SET nazev = 'Vikýřovice' WHERE kod = 781827;
UPDATE ruian_katastr SET nazev = 'Čížov u Jihlavy' WHERE kod = 781835;
UPDATE ruian_katastr SET nazev = 'Loučky u Jihlavy' WHERE kod = 781843;
UPDATE ruian_katastr SET nazev = 'Vílanec' WHERE kod = 781851;
UPDATE ruian_katastr SET nazev = 'Vilantice' WHERE kod = 781878;
UPDATE ruian_katastr SET nazev = 'Vilémov u Šluknova' WHERE kod = 781886;
UPDATE ruian_katastr SET nazev = 'Vilémov u Kadaně' WHERE kod = 781894;
UPDATE ruian_katastr SET nazev = 'Heřmanice u Vilémova' WHERE kod = 781924;
UPDATE ruian_katastr SET nazev = 'Hostovlice' WHERE kod = 781932;
UPDATE ruian_katastr SET nazev = 'Zhoř u Vilémova' WHERE kod = 781941;
UPDATE ruian_katastr SET nazev = 'Klášter u Vilémova' WHERE kod = 781959;
UPDATE ruian_katastr SET nazev = 'Vilémov u Golčova Jeníkova' WHERE kod = 781975;
UPDATE ruian_katastr SET nazev = 'Ždánice u Vilémova' WHERE kod = 781983;
UPDATE ruian_katastr SET nazev = 'Olbramice u Vilémova' WHERE kod = 781991;
UPDATE ruian_katastr SET nazev = 'Vilémov u Litovle' WHERE kod = 782009;
UPDATE ruian_katastr SET nazev = 'Vilémovice u Ledče nad Sázavou' WHERE kod = 782017;
UPDATE ruian_katastr SET nazev = 'Vilémovice u Macochy' WHERE kod = 782033;
UPDATE ruian_katastr SET nazev = 'Vilice' WHERE kod = 782050;
UPDATE ruian_katastr SET nazev = 'Vílov' WHERE kod = 782076;
UPDATE ruian_katastr SET nazev = 'Vimperk' WHERE kod = 782084;
UPDATE ruian_katastr SET nazev = 'Výškovice u Vimperka' WHERE kod = 782149;
UPDATE ruian_katastr SET nazev = 'Janovice u Vinar' WHERE kod = 782157;
UPDATE ruian_katastr SET nazev = 'Kozojídky u Vinar' WHERE kod = 782165;
UPDATE ruian_katastr SET nazev = 'Smidarská Lhota' WHERE kod = 782173;
UPDATE ruian_katastr SET nazev = 'Vinary u Smidar' WHERE kod = 782181;
UPDATE ruian_katastr SET nazev = 'Vinary u Vysokého Mýta' WHERE kod = 782190;
UPDATE ruian_katastr SET nazev = 'Vinaře' WHERE kod = 782203;
UPDATE ruian_katastr SET nazev = 'Vinaře u Kadaně' WHERE kod = 782238;
UPDATE ruian_katastr SET nazev = 'Vinařice u Suchomast' WHERE kod = 782246;
UPDATE ruian_katastr SET nazev = 'Vinařice u Kladna' WHERE kod = 782271;
UPDATE ruian_katastr SET nazev = 'Vinařice u Dobrovice' WHERE kod = 782297;
UPDATE ruian_katastr SET nazev = 'Divice' WHERE kod = 782301;
UPDATE ruian_katastr SET nazev = 'Vinařice u Loun' WHERE kod = 782319;
UPDATE ruian_katastr SET nazev = 'Vinec' WHERE kod = 782327;
UPDATE ruian_katastr SET nazev = 'Lýsky' WHERE kod = 782335;
UPDATE ruian_katastr SET nazev = 'Popovice u Přerova' WHERE kod = 782343;
UPDATE ruian_katastr SET nazev = 'Vinary u Přerova' WHERE kod = 782351;
UPDATE ruian_katastr SET nazev = 'Viničné Šumice' WHERE kod = 782360;
UPDATE ruian_katastr SET nazev = 'Vinoř' WHERE kod = 782378;
UPDATE ruian_katastr SET nazev = 'Moudrov' WHERE kod = 782386;
UPDATE ruian_katastr SET nazev = 'Vintířov' WHERE kod = 782394;
UPDATE ruian_katastr SET nazev = 'Vintířov u Sokolova' WHERE kod = 782408;
UPDATE ruian_katastr SET nazev = 'Háj u Vintířova' WHERE kod = 782416;
UPDATE ruian_katastr SET nazev = 'Kadaňský Rohozec' WHERE kod = 782424;
UPDATE ruian_katastr SET nazev = 'Kojetín u Radonic' WHERE kod = 782432;
UPDATE ruian_katastr SET nazev = 'Vintířov u Radonic' WHERE kod = 782441;
UPDATE ruian_katastr SET nazev = 'Vojnín' WHERE kod = 782459;
UPDATE ruian_katastr SET nazev = 'Sedlec u Radonic' WHERE kod = 782475;
UPDATE ruian_katastr SET nazev = 'Hrdá Ves' WHERE kod = 782483;
UPDATE ruian_katastr SET nazev = 'Vír' WHERE kod = 782491;
UPDATE ruian_katastr SET nazev = 'Lhota pod Kůstrým' WHERE kod = 782505;
UPDATE ruian_katastr SET nazev = 'Víska u Strakonic' WHERE kod = 782513;
UPDATE ruian_katastr SET nazev = 'Víska u Jevíčka' WHERE kod = 782521;
UPDATE ruian_katastr SET nazev = 'Vísky u Letovic' WHERE kod = 782530;
UPDATE ruian_katastr SET nazev = 'Višňová' WHERE kod = 782548;
UPDATE ruian_katastr SET nazev = 'Poustka u Frýdlantu' WHERE kod = 782564;
UPDATE ruian_katastr SET nazev = 'Předlánce' WHERE kod = 782572;
UPDATE ruian_katastr SET nazev = 'Víska u Frýdlantu' WHERE kod = 782581;
UPDATE ruian_katastr SET nazev = 'Višňová u Frýdlantu' WHERE kod = 782599;
UPDATE ruian_katastr SET nazev = 'Višňové' WHERE kod = 782602;
UPDATE ruian_katastr SET nazev = 'Stan u Hlinska' WHERE kod = 782611;
UPDATE ruian_katastr SET nazev = 'Vítanov' WHERE kod = 782629;
UPDATE ruian_katastr SET nazev = 'Vitčice na Moravě' WHERE kod = 782637;
UPDATE ruian_katastr SET nazev = 'Vítějeves' WHERE kod = 782645;
UPDATE ruian_katastr SET nazev = 'Vitějovice' WHERE kod = 782670;
UPDATE ruian_katastr SET nazev = 'Božtěšice na Šumavě' WHERE kod = 782688;
UPDATE ruian_katastr SET nazev = 'Brtí' WHERE kod = 782696;
UPDATE ruian_katastr SET nazev = 'Horní Němčice u Čachrova' WHERE kod = 782700;
UPDATE ruian_katastr SET nazev = 'Mladotice u Čachrova' WHERE kod = 782718;
UPDATE ruian_katastr SET nazev = 'Viteň' WHERE kod = 782726;
UPDATE ruian_katastr SET nazev = 'Huntířov' WHERE kod = 782742;
UPDATE ruian_katastr SET nazev = 'Kocléřov' WHERE kod = 782751;
UPDATE ruian_katastr SET nazev = 'Komárov u Dvora Králové' WHERE kod = 782769;
UPDATE ruian_katastr SET nazev = 'Záboří u Dvora Králové' WHERE kod = 782777;
UPDATE ruian_katastr SET nazev = 'Dobré Pole u Vitic' WHERE kod = 782785;
UPDATE ruian_katastr SET nazev = 'Hřiby' WHERE kod = 782793;
UPDATE ruian_katastr SET nazev = 'Chotýš' WHERE kod = 782807;
UPDATE ruian_katastr SET nazev = 'Kšely' WHERE kod = 782815;
UPDATE ruian_katastr SET nazev = 'Vitice' WHERE kod = 782831;
UPDATE ruian_katastr SET nazev = 'Lískovice' WHERE kod = 782840;
UPDATE ruian_katastr SET nazev = 'Vitice u Humpolce' WHERE kod = 782858;
UPDATE ruian_katastr SET nazev = 'Vřesník' WHERE kod = 782866;
UPDATE ruian_katastr SET nazev = 'Vitín' WHERE kod = 782882;
UPDATE ruian_katastr SET nazev = 'Vitiněves' WHERE kod = 782912;
UPDATE ruian_katastr SET nazev = 'Vitinka' WHERE kod = 782939;
UPDATE ruian_katastr SET nazev = 'Hrušková' WHERE kod = 782947;
UPDATE ruian_katastr SET nazev = 'Novina u Sokolova' WHERE kod = 782955;
UPDATE ruian_katastr SET nazev = 'Vítkov u Sokolova' WHERE kod = 782963;
UPDATE ruian_katastr SET nazev = 'Dolní Vítkov' WHERE kod = 782971;
UPDATE ruian_katastr SET nazev = 'Horní Vítkov' WHERE kod = 782980;
UPDATE ruian_katastr SET nazev = 'Vítkov' WHERE kod = 782998;
UPDATE ruian_katastr SET nazev = 'Klokočov u Vítkova' WHERE kod = 783081;
UPDATE ruian_katastr SET nazev = 'Vítkovice v Krkonoších' WHERE kod = 783129;
UPDATE ruian_katastr SET nazev = 'Vítonice u Bystřice pod Hostýnem' WHERE kod = 783137;
UPDATE ruian_katastr SET nazev = 'Vítonice u Znojma' WHERE kod = 783145;
UPDATE ruian_katastr SET nazev = 'Vizovice' WHERE kod = 783196;
UPDATE ruian_katastr SET nazev = 'Vižina' WHERE kod = 783200;
UPDATE ruian_katastr SET nazev = 'Vlačice' WHERE kod = 783218;
UPDATE ruian_katastr SET nazev = 'Hostákov' WHERE kod = 783226;
UPDATE ruian_katastr SET nazev = 'Vladislav' WHERE kod = 783234;
UPDATE ruian_katastr SET nazev = 'Lhota u Vlachnovic' WHERE kod = 783242;
UPDATE ruian_katastr SET nazev = 'Vlachnovice' WHERE kod = 783251;
UPDATE ruian_katastr SET nazev = 'Vlachova Lhota' WHERE kod = 783269;
UPDATE ruian_katastr SET nazev = 'Vlachovice' WHERE kod = 783277;
UPDATE ruian_katastr SET nazev = 'Vrbětice' WHERE kod = 783285;
UPDATE ruian_katastr SET nazev = 'Vlachovo Březí' WHERE kod = 783293;
UPDATE ruian_katastr SET nazev = 'Vlasatice' WHERE kod = 783307;
UPDATE ruian_katastr SET nazev = 'Vlasenice u Kamenice nad Lipou' WHERE kod = 783315;
UPDATE ruian_katastr SET nazev = 'Vlásenice u Pelhřimova' WHERE kod = 783323;
UPDATE ruian_katastr SET nazev = 'Březina nad Sázavou' WHERE kod = 783331;
UPDATE ruian_katastr SET nazev = 'Kounice nad Sázavou' WHERE kod = 783358;
UPDATE ruian_katastr SET nazev = 'Milošovice' WHERE kod = 783366;
UPDATE ruian_katastr SET nazev = 'Pavlovice u Vlastějovic' WHERE kod = 783374;
UPDATE ruian_katastr SET nazev = 'Vlastějovice' WHERE kod = 783382;
UPDATE ruian_katastr SET nazev = 'Volavá Lhota' WHERE kod = 783391;
UPDATE ruian_katastr SET nazev = 'Svinky' WHERE kod = 783404;
UPDATE ruian_katastr SET nazev = 'Vlastiboř u Soběslavi' WHERE kod = 783412;
UPDATE ruian_katastr SET nazev = 'Záluží u Vlastiboře' WHERE kod = 783421;
UPDATE ruian_katastr SET nazev = 'Vlastiboř u Železného Brodu' WHERE kod = 783439;
UPDATE ruian_katastr SET nazev = 'Vlastibořice' WHERE kod = 783463;
UPDATE ruian_katastr SET nazev = 'Sutom' WHERE kod = 783471;
UPDATE ruian_katastr SET nazev = 'Vlastislav' WHERE kod = 783480;
UPDATE ruian_katastr SET nazev = 'Vlašim' WHERE kod = 783544;
UPDATE ruian_katastr SET nazev = 'Jarkovice' WHERE kod = 783595;
UPDATE ruian_katastr SET nazev = 'Vlaštovičky' WHERE kod = 783609;
UPDATE ruian_katastr SET nazev = 'Vlčatín' WHERE kod = 783617;
UPDATE ruian_katastr SET nazev = 'Vlčetín' WHERE kod = 783625;
UPDATE ruian_katastr SET nazev = 'Vlčeves' WHERE kod = 783641;
UPDATE ruian_katastr SET nazev = 'Vlčí' WHERE kod = 783650;
UPDATE ruian_katastr SET nazev = 'Heřmaničky u Dobranova' WHERE kod = 783668;
UPDATE ruian_katastr SET nazev = 'Vítkov u Dobranova' WHERE kod = 783676;
UPDATE ruian_katastr SET nazev = 'Vlčí Důl' WHERE kod = 783684;
UPDATE ruian_katastr SET nazev = 'Vlčí Habřina' WHERE kod = 783692;
UPDATE ruian_katastr SET nazev = 'Vlčí Hora' WHERE kod = 783714;
UPDATE ruian_katastr SET nazev = 'Zahrady' WHERE kod = 783722;
UPDATE ruian_katastr SET nazev = 'Vlčí Pole' WHERE kod = 783731;
UPDATE ruian_katastr SET nazev = 'Vlčice u Blovic' WHERE kod = 783757;
UPDATE ruian_katastr SET nazev = 'Hrádeček' WHERE kod = 783765;
UPDATE ruian_katastr SET nazev = 'Vlčice u Trutnova' WHERE kod = 783773;
UPDATE ruian_katastr SET nazev = 'Dolní Les' WHERE kod = 783790;
UPDATE ruian_katastr SET nazev = 'Vlčice u Javorníka' WHERE kod = 783811;
UPDATE ruian_katastr SET nazev = 'Vojtovice' WHERE kod = 783820;
UPDATE ruian_katastr SET nazev = 'Vlčkov' WHERE kod = 783838;
UPDATE ruian_katastr SET nazev = 'Vlčková' WHERE kod = 783846;
UPDATE ruian_katastr SET nazev = 'Vlčkovice u Mladkova' WHERE kod = 783854;
UPDATE ruian_katastr SET nazev = 'Dolní Vlčkovice' WHERE kod = 783862;
UPDATE ruian_katastr SET nazev = 'Horní Vlčkovice' WHERE kod = 783871;
UPDATE ruian_katastr SET nazev = 'Vlčnov u Zavlekova' WHERE kod = 783889;
UPDATE ruian_katastr SET nazev = 'Vlčnov' WHERE kod = 783897;
UPDATE ruian_katastr SET nazev = 'Vlčovice' WHERE kod = 783901;
UPDATE ruian_katastr SET nazev = 'Vlčtejn' WHERE kod = 783919;
UPDATE ruian_katastr SET nazev = 'Vlkančice' WHERE kod = 783943;
UPDATE ruian_katastr SET nazev = 'Kozohlody' WHERE kod = 783951;
UPDATE ruian_katastr SET nazev = 'Přibyslavice u Vlkanče' WHERE kod = 783960;
UPDATE ruian_katastr SET nazev = 'Vlkaneč' WHERE kod = 783978;
UPDATE ruian_katastr SET nazev = 'Opatovice u Světlé nad Sázavou' WHERE kod = 783986;
UPDATE ruian_katastr SET nazev = 'Vlkanov' WHERE kod = 783994;
UPDATE ruian_katastr SET nazev = 'Vlkava' WHERE kod = 784010;
UPDATE ruian_katastr SET nazev = 'Vlkonice' WHERE kod = 784028;
UPDATE ruian_katastr SET nazev = 'Vlkoš u Kyjova' WHERE kod = 784036;
UPDATE ruian_katastr SET nazev = 'Kanovsko' WHERE kod = 784044;
UPDATE ruian_katastr SET nazev = 'Vlkoš u Přerova' WHERE kod = 784052;
UPDATE ruian_katastr SET nazev = 'Vlkov nad Lužnicí' WHERE kod = 784061;
UPDATE ruian_katastr SET nazev = 'Vlkov u Jaroměře' WHERE kod = 784079;
UPDATE ruian_katastr SET nazev = 'Vlkov u Osové Bítýšky' WHERE kod = 784087;
UPDATE ruian_katastr SET nazev = 'Vlkov pod Oškobrhem' WHERE kod = 784095;
UPDATE ruian_katastr SET nazev = 'Martinov u Mariánských Lázní' WHERE kod = 784109;
UPDATE ruian_katastr SET nazev = 'Vlkovice u Mariánských Lázní' WHERE kod = 784117;
UPDATE ruian_katastr SET nazev = 'Dolejší Kunčice' WHERE kod = 784125;
UPDATE ruian_katastr SET nazev = 'Moravské Vlkovice' WHERE kod = 784133;
UPDATE ruian_katastr SET nazev = 'Slezské Vlkovice' WHERE kod = 784141;
UPDATE ruian_katastr SET nazev = 'Střítež u Milevska' WHERE kod = 784168;
UPDATE ruian_katastr SET nazev = 'Vlksice' WHERE kod = 784176;
UPDATE ruian_katastr SET nazev = 'Vnorovice' WHERE kod = 784184;
UPDATE ruian_katastr SET nazev = 'Lidéřovice na Moravě' WHERE kod = 784192;
UPDATE ruian_katastr SET nazev = 'Vnorovy' WHERE kod = 784206;
UPDATE ruian_katastr SET nazev = 'Uhřínovice u Voděrad' WHERE kod = 784214;
UPDATE ruian_katastr SET nazev = 'Voděrady u Rychnova nad Kněžnou' WHERE kod = 784222;
UPDATE ruian_katastr SET nazev = 'Voděrady u Českých Heřmanic' WHERE kod = 784231;
UPDATE ruian_katastr SET nazev = 'Voděrady u Kunštátu' WHERE kod = 784249;
UPDATE ruian_katastr SET nazev = 'Malešín u Vodice' WHERE kod = 784265;
UPDATE ruian_katastr SET nazev = 'Vodice u Tábora' WHERE kod = 784273;
UPDATE ruian_katastr SET nazev = 'Vodňany' WHERE kod = 784281;
UPDATE ruian_katastr SET nazev = 'Čavyně' WHERE kod = 784338;
UPDATE ruian_katastr SET nazev = 'Hoštice u Vodochod' WHERE kod = 784354;
UPDATE ruian_katastr SET nazev = 'Vodochody u Prahy' WHERE kod = 784362;
UPDATE ruian_katastr SET nazev = 'Háje u Vodokrt' WHERE kod = 784371;
UPDATE ruian_katastr SET nazev = 'Knihy' WHERE kod = 784389;
UPDATE ruian_katastr SET nazev = 'Osek u Vodokrt' WHERE kod = 784397;
UPDATE ruian_katastr SET nazev = 'Vodokrty' WHERE kod = 784401;
UPDATE ruian_katastr SET nazev = 'Vohančice' WHERE kod = 784419;
UPDATE ruian_katastr SET nazev = 'Vochov' WHERE kod = 784427;
UPDATE ruian_katastr SET nazev = 'Bezmíř' WHERE kod = 784435;
UPDATE ruian_katastr SET nazev = 'Minartice' WHERE kod = 784451;
UPDATE ruian_katastr SET nazev = 'Vojkov u Votic' WHERE kod = 784486;
UPDATE ruian_katastr SET nazev = 'Křivousy' WHERE kod = 784516;
UPDATE ruian_katastr SET nazev = 'Vojkovice u Kralup nad Vltavou' WHERE kod = 784524;
UPDATE ruian_katastr SET nazev = 'Jakubov' WHERE kod = 784532;
UPDATE ruian_katastr SET nazev = 'Vojkovice nad Ohří' WHERE kod = 784559;
UPDATE ruian_katastr SET nazev = 'Vojkovice u Židlochovic' WHERE kod = 784567;
UPDATE ruian_katastr SET nazev = 'Vojkovice' WHERE kod = 784575;
UPDATE ruian_katastr SET nazev = 'Vojnice u Olomouce' WHERE kod = 784583;
UPDATE ruian_katastr SET nazev = 'Vojnův Městec' WHERE kod = 784605;
UPDATE ruian_katastr SET nazev = 'Vojovice' WHERE kod = 784613;
UPDATE ruian_katastr SET nazev = 'Vojslavice nad Želivkou' WHERE kod = 784621;
UPDATE ruian_katastr SET nazev = 'Vojtanov' WHERE kod = 784630;
UPDATE ruian_katastr SET nazev = 'Zelený Háj' WHERE kod = 784648;
UPDATE ruian_katastr SET nazev = 'Vojtěchov u Hlinska' WHERE kod = 784656;
UPDATE ruian_katastr SET nazev = 'Volanice' WHERE kod = 784664;
UPDATE ruian_katastr SET nazev = 'Volárna' WHERE kod = 784672;
UPDATE ruian_katastr SET nazev = 'Chlum u Volar' WHERE kod = 784681;
UPDATE ruian_katastr SET nazev = 'Krejčovice' WHERE kod = 784699;
UPDATE ruian_katastr SET nazev = 'Milešice' WHERE kod = 784702;
UPDATE ruian_katastr SET nazev = 'Mlynářovice u Volar' WHERE kod = 784711;
UPDATE ruian_katastr SET nazev = 'Volary' WHERE kod = 784737;
UPDATE ruian_katastr SET nazev = 'Cudrovice' WHERE kod = 784745;
UPDATE ruian_katastr SET nazev = 'Horní Sněžná' WHERE kod = 784753;
UPDATE ruian_katastr SET nazev = 'Volduchy' WHERE kod = 784770;
UPDATE ruian_katastr SET nazev = 'Voleč' WHERE kod = 784796;
UPDATE ruian_katastr SET nazev = 'Bubovice u Březnice' WHERE kod = 784800;
UPDATE ruian_katastr SET nazev = 'Pročevily' WHERE kod = 784818;
UPDATE ruian_katastr SET nazev = 'Volenice u Březnice' WHERE kod = 784826;
UPDATE ruian_katastr SET nazev = 'Volenice' WHERE kod = 784834;
UPDATE ruian_katastr SET nazev = 'Voletice' WHERE kod = 784851;
UPDATE ruian_katastr SET nazev = 'Debrné' WHERE kod = 784869;
UPDATE ruian_katastr SET nazev = 'Voletiny' WHERE kod = 784877;
UPDATE ruian_katastr SET nazev = 'Volevčice u Telče' WHERE kod = 784885;
UPDATE ruian_katastr SET nazev = 'Volfartická Nová Ves' WHERE kod = 784893;
UPDATE ruian_katastr SET nazev = 'Volfartice' WHERE kod = 784907;
UPDATE ruian_katastr SET nazev = 'Šach' WHERE kod = 784915;
UPDATE ruian_katastr SET nazev = 'Volfířov' WHERE kod = 784923;
UPDATE ruian_katastr SET nazev = 'Voltuš' WHERE kod = 784931;
UPDATE ruian_katastr SET nazev = 'Starov' WHERE kod = 784940;
UPDATE ruian_katastr SET nazev = 'Volyně' WHERE kod = 784958;
UPDATE ruian_katastr SET nazev = 'Zechovice' WHERE kod = 784966;
UPDATE ruian_katastr SET nazev = 'Vonoklasy' WHERE kod = 784982;
UPDATE ruian_katastr SET nazev = 'Lhoty' WHERE kod = 784991;
UPDATE ruian_katastr SET nazev = 'Vortová' WHERE kod = 785008;
UPDATE ruian_katastr SET nazev = 'Votice' WHERE kod = 785041;
UPDATE ruian_katastr SET nazev = 'Voznice' WHERE kod = 785059;
UPDATE ruian_katastr SET nazev = 'Slavče' WHERE kod = 785091;
UPDATE ruian_katastr SET nazev = 'Vrábče' WHERE kod = 785105;
UPDATE ruian_katastr SET nazev = 'Zahorčice u Vrábče' WHERE kod = 785121;
UPDATE ruian_katastr SET nazev = 'Sedlec u Vraclavi' WHERE kod = 785148;
UPDATE ruian_katastr SET nazev = 'Vraclav' WHERE kod = 785164;
UPDATE ruian_katastr SET nazev = 'Vracov' WHERE kod = 785172;
UPDATE ruian_katastr SET nazev = 'Vracovice' WHERE kod = 785199;
UPDATE ruian_katastr SET nazev = 'Vračovice' WHERE kod = 785211;
UPDATE ruian_katastr SET nazev = 'Čechůvky' WHERE kod = 785229;
UPDATE ruian_katastr SET nazev = 'Vrahovice' WHERE kod = 785237;
UPDATE ruian_katastr SET nazev = 'Mlčechvosty' WHERE kod = 785245;
UPDATE ruian_katastr SET nazev = 'Vraňany' WHERE kod = 785253;
UPDATE ruian_katastr SET nazev = 'Mýšlovice' WHERE kod = 785270;
UPDATE ruian_katastr SET nazev = 'Těchařovice' WHERE kod = 785288;
UPDATE ruian_katastr SET nazev = 'Vrančice' WHERE kod = 785296;
UPDATE ruian_katastr SET nazev = 'Vrané nad Vltavou' WHERE kod = 785318;
UPDATE ruian_katastr SET nazev = 'Vranín' WHERE kod = 785326;
UPDATE ruian_katastr SET nazev = 'Vranov u Čerčan' WHERE kod = 785351;
UPDATE ruian_katastr SET nazev = 'Vranovská Lhota' WHERE kod = 785369;
UPDATE ruian_katastr SET nazev = 'Butov' WHERE kod = 785377;
UPDATE ruian_katastr SET nazev = 'Svinná u Stříbra' WHERE kod = 785385;
UPDATE ruian_katastr SET nazev = 'Vranov u Stříbra' WHERE kod = 785393;
UPDATE ruian_katastr SET nazev = 'Vranov u Brna' WHERE kod = 785407;
UPDATE ruian_katastr SET nazev = 'Vranov nad Dyjí' WHERE kod = 785415;
UPDATE ruian_katastr SET nazev = 'Vranová u Letovic' WHERE kod = 785431;
UPDATE ruian_katastr SET nazev = 'Vranová' WHERE kod = 785458;
UPDATE ruian_katastr SET nazev = 'Vranová Lhota' WHERE kod = 785466;
UPDATE ruian_katastr SET nazev = 'Hoděmyšl' WHERE kod = 785482;
UPDATE ruian_katastr SET nazev = 'Vranovice pod Třemšínem' WHERE kod = 785504;
UPDATE ruian_katastr SET nazev = 'Vranovice nad Svratkou' WHERE kod = 785512;
UPDATE ruian_katastr SET nazev = 'Kelčice' WHERE kod = 785521;
UPDATE ruian_katastr SET nazev = 'Vranovice' WHERE kod = 785539;
UPDATE ruian_katastr SET nazev = 'Vranovská Ves' WHERE kod = 785555;
UPDATE ruian_katastr SET nazev = 'Vraný' WHERE kod = 785563;
UPDATE ruian_katastr SET nazev = 'Mešovice' WHERE kod = 785571;
UPDATE ruian_katastr SET nazev = 'Vratěnín' WHERE kod = 785580;
UPDATE ruian_katastr SET nazev = 'Vratíkov' WHERE kod = 785598;
UPDATE ruian_katastr SET nazev = 'Vratimov' WHERE kod = 785601;
UPDATE ruian_katastr SET nazev = 'Kunratice u Liberce' WHERE kod = 785628;
UPDATE ruian_katastr SET nazev = 'Vratislavice nad Nisou' WHERE kod = 785644;
UPDATE ruian_katastr SET nazev = 'Vratislávka' WHERE kod = 785652;
UPDATE ruian_katastr SET nazev = 'Vrátno' WHERE kod = 785661;
UPDATE ruian_katastr SET nazev = 'Hlinsko u Vráta' WHERE kod = 785679;
UPDATE ruian_katastr SET nazev = 'Vráto' WHERE kod = 785687;
UPDATE ruian_katastr SET nazev = 'Vráž u Berouna' WHERE kod = 785717;
UPDATE ruian_katastr SET nazev = 'Vráž u Písku' WHERE kod = 785733;
UPDATE ruian_katastr SET nazev = 'Vražkov' WHERE kod = 785741;
UPDATE ruian_katastr SET nazev = 'Vrážné' WHERE kod = 785750;
UPDATE ruian_katastr SET nazev = 'Vražné u Oder' WHERE kod = 785768;
UPDATE ruian_katastr SET nazev = 'Hynčice u Vražného' WHERE kod = 785792;
UPDATE ruian_katastr SET nazev = 'Dubany na Hané' WHERE kod = 785806;
UPDATE ruian_katastr SET nazev = 'Štětovice' WHERE kod = 785814;
UPDATE ruian_katastr SET nazev = 'Vrbátky' WHERE kod = 785822;
UPDATE ruian_katastr SET nazev = 'Louka u Vrbatova Kostelce' WHERE kod = 785857;
UPDATE ruian_katastr SET nazev = 'Vrbatův Kostelec' WHERE kod = 785865;
UPDATE ruian_katastr SET nazev = 'Vrbčany' WHERE kod = 785873;
UPDATE ruian_katastr SET nazev = 'Vrbice u Poděbrad' WHERE kod = 785881;
UPDATE ruian_katastr SET nazev = 'Skřipová' WHERE kod = 785903;
UPDATE ruian_katastr SET nazev = 'Vrbice u Valče' WHERE kod = 785911;
UPDATE ruian_katastr SET nazev = 'Mastířovice' WHERE kod = 785920;
UPDATE ruian_katastr SET nazev = 'Vetlá' WHERE kod = 785938;
UPDATE ruian_katastr SET nazev = 'Vrbice u Roudnice nad Labem' WHERE kod = 785946;
UPDATE ruian_katastr SET nazev = 'Vrbice nad Cidlinou' WHERE kod = 785954;
UPDATE ruian_katastr SET nazev = 'Vrbice u Velkých Pavlovic' WHERE kod = 785962;
UPDATE ruian_katastr SET nazev = 'Vrbice nad Odrou' WHERE kod = 785971;
UPDATE ruian_katastr SET nazev = 'Vrbičany' WHERE kod = 785989;
UPDATE ruian_katastr SET nazev = 'Vrbičany u Lovosic' WHERE kod = 785997;
UPDATE ruian_katastr SET nazev = 'Sychrov u Ledče nad Sázavou' WHERE kod = 786004;
UPDATE ruian_katastr SET nazev = 'Vrbka u Ledče nad Sázavou' WHERE kod = 786012;
UPDATE ruian_katastr SET nazev = 'Vrbka u Opavy' WHERE kod = 786021;
UPDATE ruian_katastr SET nazev = 'Vrbno nad Lesy' WHERE kod = 786039;
UPDATE ruian_katastr SET nazev = 'Ludvíkov pod Pradědem' WHERE kod = 786055;
UPDATE ruian_katastr SET nazev = 'Mnichov pod Pradědem' WHERE kod = 786063;
UPDATE ruian_katastr SET nazev = 'Vrbno pod Pradědem' WHERE kod = 786080;
UPDATE ruian_katastr SET nazev = 'Železná pod Pradědem' WHERE kod = 786098;
UPDATE ruian_katastr SET nazev = 'Vrbová Lhota' WHERE kod = 786101;
UPDATE ruian_katastr SET nazev = 'Vrbovec' WHERE kod = 786128;
UPDATE ruian_katastr SET nazev = 'Držov' WHERE kod = 786136;
UPDATE ruian_katastr SET nazev = 'Louka nad Otavou' WHERE kod = 786144;
UPDATE ruian_katastr SET nazev = 'Vojníkov' WHERE kod = 786152;
UPDATE ruian_katastr SET nazev = 'Vrcovice' WHERE kod = 786161;
UPDATE ruian_katastr SET nazev = 'Sedliště nad Úslavou' WHERE kod = 786179;
UPDATE ruian_katastr SET nazev = 'Srby nad Úslavou' WHERE kod = 786187;
UPDATE ruian_katastr SET nazev = 'Tojice' WHERE kod = 786195;
UPDATE ruian_katastr SET nazev = 'Vrčeň' WHERE kod = 786209;
UPDATE ruian_katastr SET nazev = 'Dolní Bučice' WHERE kod = 786217;
UPDATE ruian_katastr SET nazev = 'Horní Bučice' WHERE kod = 786225;
UPDATE ruian_katastr SET nazev = 'Vrdy' WHERE kod = 786233;
UPDATE ruian_katastr SET nazev = 'Zbyslav' WHERE kod = 786241;
UPDATE ruian_katastr SET nazev = 'Malá Víska u Klatov' WHERE kod = 786250;
UPDATE ruian_katastr SET nazev = 'Neznašovy' WHERE kod = 786268;
UPDATE ruian_katastr SET nazev = 'Radinovy' WHERE kod = 786276;
UPDATE ruian_katastr SET nazev = 'Vrhaveč u Klatov' WHERE kod = 786284;
UPDATE ruian_katastr SET nazev = 'Vrchlabí' WHERE kod = 786306;
UPDATE ruian_katastr SET nazev = 'Podhůří-Harta' WHERE kod = 786331;
UPDATE ruian_katastr SET nazev = 'Hořejší Vrchlabí' WHERE kod = 786349;
UPDATE ruian_katastr SET nazev = 'Vrchoslavice' WHERE kod = 786381;
UPDATE ruian_katastr SET nazev = 'Vrchotice' WHERE kod = 786411;
UPDATE ruian_katastr SET nazev = 'Manělovice' WHERE kod = 786446;
UPDATE ruian_katastr SET nazev = 'Rudoltice u Vrchotových Janovic' WHERE kod = 786462;
UPDATE ruian_katastr SET nazev = 'Vrchotovy Janovice' WHERE kod = 786489;
UPDATE ruian_katastr SET nazev = 'Vrchovany' WHERE kod = 786497;
UPDATE ruian_katastr SET nazev = 'Vrchovina' WHERE kod = 786519;
UPDATE ruian_katastr SET nazev = 'Vrchoviny' WHERE kod = 786527;
UPDATE ruian_katastr SET nazev = 'Vrchy' WHERE kod = 786535;
UPDATE ruian_katastr SET nazev = 'Vroutek' WHERE kod = 786543;
UPDATE ruian_katastr SET nazev = 'Kyjice' WHERE kod = 786551;
UPDATE ruian_katastr SET nazev = 'Vrskmaň' WHERE kod = 786586;
UPDATE ruian_katastr SET nazev = 'Vršce' WHERE kod = 786608;
UPDATE ruian_katastr SET nazev = 'Vršovice u Loun' WHERE kod = 786616;
UPDATE ruian_katastr SET nazev = 'Vršovice u Opavy' WHERE kod = 786624;
UPDATE ruian_katastr SET nazev = 'Vršovka' WHERE kod = 786632;
UPDATE ruian_katastr SET nazev = 'Svařenice' WHERE kod = 786641;
UPDATE ruian_katastr SET nazev = 'Vrutice' WHERE kod = 786659;
UPDATE ruian_katastr SET nazev = 'Vřesce' WHERE kod = 786667;
UPDATE ruian_katastr SET nazev = 'Vřesina u Bílovce' WHERE kod = 786683;
UPDATE ruian_katastr SET nazev = 'Vřesina u Opavy' WHERE kod = 786691;
UPDATE ruian_katastr SET nazev = 'Křemenitá' WHERE kod = 786705;
UPDATE ruian_katastr SET nazev = 'Tatrovice' WHERE kod = 786713;
UPDATE ruian_katastr SET nazev = 'Vřesová' WHERE kod = 786721;
UPDATE ruian_katastr SET nazev = 'Spomyšl u Vřesové' WHERE kod = 786730;
UPDATE ruian_katastr SET nazev = 'Vřesovice' WHERE kod = 786748;
UPDATE ruian_katastr SET nazev = 'Vřesovice u Prostějova' WHERE kod = 786756;
UPDATE ruian_katastr SET nazev = 'Vsetín' WHERE kod = 786764;
UPDATE ruian_katastr SET nazev = 'Rokytnice u Vsetína' WHERE kod = 786951;
UPDATE ruian_katastr SET nazev = 'Jasenka' WHERE kod = 786969;
UPDATE ruian_katastr SET nazev = 'Vsisko' WHERE kod = 786977;
UPDATE ruian_katastr SET nazev = 'Vstiš' WHERE kod = 786985;
UPDATE ruian_katastr SET nazev = 'Bezděkov u Dolních Kralovic' WHERE kod = 786993;
UPDATE ruian_katastr SET nazev = 'Všebořice u Dolních Kralovic' WHERE kod = 787019;
UPDATE ruian_katastr SET nazev = 'Všehrdy u Kralovic' WHERE kod = 787027;
UPDATE ruian_katastr SET nazev = 'Všehrdy' WHERE kod = 787035;
UPDATE ruian_katastr SET nazev = 'Všechlapy nad Blanicí' WHERE kod = 787043;
UPDATE ruian_katastr SET nazev = 'Všechlapy u Nymburka' WHERE kod = 787051;
UPDATE ruian_katastr SET nazev = 'Skalička u Tišnova' WHERE kod = 787060;
UPDATE ruian_katastr SET nazev = 'Všechovice u Tišnova' WHERE kod = 787078;
UPDATE ruian_katastr SET nazev = 'Všechovice' WHERE kod = 787086;
UPDATE ruian_katastr SET nazev = 'Všechromy' WHERE kod = 787094;
UPDATE ruian_katastr SET nazev = 'Všejany' WHERE kod = 787108;
UPDATE ruian_katastr SET nazev = 'Březová u Všelibic' WHERE kod = 787116;
UPDATE ruian_katastr SET nazev = 'Malčice u Všelibic' WHERE kod = 787132;
UPDATE ruian_katastr SET nazev = 'Všelibice' WHERE kod = 787159;
UPDATE ruian_katastr SET nazev = 'Všemina' WHERE kod = 787167;
UPDATE ruian_katastr SET nazev = 'Bohunice nad Vltavou' WHERE kod = 787175;
UPDATE ruian_katastr SET nazev = 'Slavětice u Všemyslic' WHERE kod = 787205;
UPDATE ruian_katastr SET nazev = 'Všemyslice' WHERE kod = 787213;
UPDATE ruian_katastr SET nazev = 'Všeteč' WHERE kod = 787221;
UPDATE ruian_katastr SET nazev = 'Všeň' WHERE kod = 787256;
UPDATE ruian_katastr SET nazev = 'Všenory' WHERE kod = 787272;
UPDATE ruian_katastr SET nazev = 'Všepadly' WHERE kod = 787281;
UPDATE ruian_katastr SET nazev = 'Všeradice' WHERE kod = 787299;
UPDATE ruian_katastr SET nazev = 'Všeradov' WHERE kod = 787329;
UPDATE ruian_katastr SET nazev = 'Studánky u Všerub' WHERE kod = 787337;
UPDATE ruian_katastr SET nazev = 'Všeruby u Kdyně' WHERE kod = 787345;
UPDATE ruian_katastr SET nazev = 'Myslív u Všerub' WHERE kod = 787353;
UPDATE ruian_katastr SET nazev = 'Radimovice u Všerub' WHERE kod = 787361;
UPDATE ruian_katastr SET nazev = 'Všeruby u Plzně' WHERE kod = 787370;
UPDATE ruian_katastr SET nazev = 'Všestary u Říčan' WHERE kod = 787396;
UPDATE ruian_katastr SET nazev = 'Bříza u Všestar' WHERE kod = 787400;
UPDATE ruian_katastr SET nazev = 'Rosnice u Všestar' WHERE kod = 787418;
UPDATE ruian_katastr SET nazev = 'Světí' WHERE kod = 787426;
UPDATE ruian_katastr SET nazev = 'Všestary' WHERE kod = 787434;
UPDATE ruian_katastr SET nazev = 'Dušníky nad Vltavou' WHERE kod = 787442;
UPDATE ruian_katastr SET nazev = 'Všestudy u Veltrus' WHERE kod = 787451;
UPDATE ruian_katastr SET nazev = 'Všestudy' WHERE kod = 787469;
UPDATE ruian_katastr SET nazev = 'Všesulov' WHERE kod = 787477;
UPDATE ruian_katastr SET nazev = 'Všetaty' WHERE kod = 787485;
UPDATE ruian_katastr SET nazev = 'Všetaty u Rakovníka' WHERE kod = 787493;
UPDATE ruian_katastr SET nazev = 'Vtelno' WHERE kod = 787507;
UPDATE ruian_katastr SET nazev = 'Štěpánovice u Jaroměřic nad Rokytnou' WHERE kod = 787515;
UPDATE ruian_katastr SET nazev = 'Výčapy' WHERE kod = 787523;
UPDATE ruian_katastr SET nazev = 'Vydří' WHERE kod = 787531;
UPDATE ruian_katastr SET nazev = 'Vyhnanice u Voděrad' WHERE kod = 787540;
UPDATE ruian_katastr SET nazev = 'Vykáň' WHERE kod = 787558;
UPDATE ruian_katastr SET nazev = 'Vyklantice' WHERE kod = 787591;
UPDATE ruian_katastr SET nazev = 'Výkleky' WHERE kod = 787604;
UPDATE ruian_katastr SET nazev = 'Vyklice' WHERE kod = 787621;
UPDATE ruian_katastr SET nazev = 'Zalužany u Vyklic' WHERE kod = 787639;
UPDATE ruian_katastr SET nazev = 'Valteřice u Výprachtic' WHERE kod = 787647;
UPDATE ruian_katastr SET nazev = 'Výprachtice' WHERE kod = 787655;
UPDATE ruian_katastr SET nazev = 'Výrava' WHERE kod = 787671;
UPDATE ruian_katastr SET nazev = 'Výrov u Kralovic' WHERE kod = 787698;
UPDATE ruian_katastr SET nazev = 'Výrovice' WHERE kod = 787701;
UPDATE ruian_katastr SET nazev = 'Vyskeř' WHERE kod = 787744;
UPDATE ruian_katastr SET nazev = 'Vyskytná' WHERE kod = 787752;
UPDATE ruian_katastr SET nazev = 'Rounek' WHERE kod = 787761;
UPDATE ruian_katastr SET nazev = 'Vyskytná nad Jihlavou' WHERE kod = 787779;
UPDATE ruian_katastr SET nazev = 'Sobětice u Výsluní' WHERE kod = 787787;
UPDATE ruian_katastr SET nazev = 'Třebíška' WHERE kod = 787795;
UPDATE ruian_katastr SET nazev = 'Volyně u Výsluní' WHERE kod = 787809;
UPDATE ruian_katastr SET nazev = 'Výsluní' WHERE kod = 787817;
UPDATE ruian_katastr SET nazev = 'Úbočí u Výsluní' WHERE kod = 787825;
UPDATE ruian_katastr SET nazev = 'Housko' WHERE kod = 787833;
UPDATE ruian_katastr SET nazev = 'Molenburk' WHERE kod = 787841;
UPDATE ruian_katastr SET nazev = 'Vysočany u Znojma' WHERE kod = 787850;
UPDATE ruian_katastr SET nazev = 'Dřevíkov' WHERE kod = 787868;
UPDATE ruian_katastr SET nazev = 'Možděnice' WHERE kod = 787876;
UPDATE ruian_katastr SET nazev = 'Rváčov u Hlinska' WHERE kod = 787884;
UPDATE ruian_katastr SET nazev = 'Svobodné Hamry' WHERE kod = 787906;
UPDATE ruian_katastr SET nazev = 'Bosyně' WHERE kod = 787922;
UPDATE ruian_katastr SET nazev = 'Chodeč u Mělníka' WHERE kod = 787949;
UPDATE ruian_katastr SET nazev = 'Strážnice u Mělníka' WHERE kod = 787957;
UPDATE ruian_katastr SET nazev = 'Střednice' WHERE kod = 787965;
UPDATE ruian_katastr SET nazev = 'Vysoká u Mělníka' WHERE kod = 787973;
UPDATE ruian_katastr SET nazev = 'Vysoká u Jevíčka' WHERE kod = 787981;
UPDATE ruian_katastr SET nazev = 'Bartultovice' WHERE kod = 787990;
UPDATE ruian_katastr SET nazev = 'Pitárné' WHERE kod = 788007;
UPDATE ruian_katastr SET nazev = 'Vysoká ve Slezsku' WHERE kod = 788015;
UPDATE ruian_katastr SET nazev = 'Vysoká u Hustopečí nad Bečvou' WHERE kod = 788023;
UPDATE ruian_katastr SET nazev = 'Vysoká u Valašského Meziříčí' WHERE kod = 788031;
UPDATE ruian_katastr SET nazev = 'Vysoká Lhota' WHERE kod = 788040;
UPDATE ruian_katastr SET nazev = 'Radouň' WHERE kod = 788058;
UPDATE ruian_katastr SET nazev = 'Vysoká Libeň' WHERE kod = 788066;
UPDATE ruian_katastr SET nazev = 'Vysoká Libyně' WHERE kod = 788074;
UPDATE ruian_katastr SET nazev = 'Vysoká nad Labem' WHERE kod = 788082;
UPDATE ruian_katastr SET nazev = 'Drmaly' WHERE kod = 788091;
UPDATE ruian_katastr SET nazev = 'Podhůří u Vysoké Pece' WHERE kod = 788104;
UPDATE ruian_katastr SET nazev = 'Vysoká Pec' WHERE kod = 788112;
UPDATE ruian_katastr SET nazev = 'Vysoká Srbská' WHERE kod = 788121;
UPDATE ruian_katastr SET nazev = 'Zlíčko' WHERE kod = 788147;
UPDATE ruian_katastr SET nazev = 'Mezné' WHERE kod = 788180;
UPDATE ruian_katastr SET nazev = 'Vysoká u Kosovy Hory' WHERE kod = 788198;
UPDATE ruian_katastr SET nazev = 'Vysoká u Příbramě' WHERE kod = 788201;
UPDATE ruian_katastr SET nazev = 'Vysoké Chvojno' WHERE kod = 788210;
UPDATE ruian_katastr SET nazev = 'Vysoké Mýto' WHERE kod = 788228;
UPDATE ruian_katastr SET nazev = 'Vysoké nad Jizerou' WHERE kod = 788309;
UPDATE ruian_katastr SET nazev = 'Vysoké Pole' WHERE kod = 788317;
UPDATE ruian_katastr SET nazev = 'Vysoké Popovice' WHERE kod = 788325;
UPDATE ruian_katastr SET nazev = 'Vysoké Studnice' WHERE kod = 788333;
UPDATE ruian_katastr SET nazev = 'Veselská Lhota' WHERE kod = 788341;
UPDATE ruian_katastr SET nazev = 'Vysoké Veselí' WHERE kod = 788350;
UPDATE ruian_katastr SET nazev = 'Vysoké Žibřidovice' WHERE kod = 788368;
UPDATE ruian_katastr SET nazev = 'Žleb' WHERE kod = 788376;
UPDATE ruian_katastr SET nazev = 'Starkoč u Vysokova' WHERE kod = 788384;
UPDATE ruian_katastr SET nazev = 'Vysokov' WHERE kod = 788392;
UPDATE ruian_katastr SET nazev = 'Vápenice u Vysokého Chlumce' WHERE kod = 788406;
UPDATE ruian_katastr SET nazev = 'Vysoký Chlumec' WHERE kod = 788414;
UPDATE ruian_katastr SET nazev = 'Vysoký Újezd' WHERE kod = 788431;
UPDATE ruian_katastr SET nazev = 'Vysoký Újezd u Berouna' WHERE kod = 788449;
UPDATE ruian_katastr SET nazev = 'Vysoký Újezd nad Dědinou' WHERE kod = 788457;
UPDATE ruian_katastr SET nazev = 'Vystrčenovice' WHERE kod = 788465;
UPDATE ruian_katastr SET nazev = 'Vyšehněvice' WHERE kod = 788473;
UPDATE ruian_katastr SET nazev = 'Vyšehoří' WHERE kod = 788481;
UPDATE ruian_katastr SET nazev = 'Kozovazy' WHERE kod = 788490;
UPDATE ruian_katastr SET nazev = 'Vyšehořovice' WHERE kod = 788503;
UPDATE ruian_katastr SET nazev = 'Vyšetice' WHERE kod = 788546;
UPDATE ruian_katastr SET nazev = 'Výškov u Počerad' WHERE kod = 788554;
UPDATE ruian_katastr SET nazev = 'Vyškov' WHERE kod = 788571;
UPDATE ruian_katastr SET nazev = 'Dědice u Vyškova' WHERE kod = 788759;
UPDATE ruian_katastr SET nazev = 'Vyškovec' WHERE kod = 788856;
UPDATE ruian_katastr SET nazev = 'Obora u Vyšného' WHERE kod = 788864;
UPDATE ruian_katastr SET nazev = 'Vyšné' WHERE kod = 788872;
UPDATE ruian_katastr SET nazev = 'Vyšní Lhoty' WHERE kod = 788929;
UPDATE ruian_katastr SET nazev = 'Výšovice' WHERE kod = 788937;
UPDATE ruian_katastr SET nazev = 'Dolní Drkolná' WHERE kod = 788945;
UPDATE ruian_katastr SET nazev = 'Hrudkov' WHERE kod = 788953;
UPDATE ruian_katastr SET nazev = 'Studánky u Vyššího Brodu' WHERE kod = 788970;
UPDATE ruian_katastr SET nazev = 'Herbertov' WHERE kod = 788988;
UPDATE ruian_katastr SET nazev = 'Vyšší Brod' WHERE kod = 788996;
UPDATE ruian_katastr SET nazev = 'Svatomírov' WHERE kod = 789003;
UPDATE ruian_katastr SET nazev = 'Vyžice' WHERE kod = 789038;
UPDATE ruian_katastr SET nazev = 'Vyžlovka' WHERE kod = 789046;
UPDATE ruian_katastr SET nazev = 'Zábeštní Lhota' WHERE kod = 789054;
UPDATE ruian_katastr SET nazev = 'Záblatí' WHERE kod = 789089;
UPDATE ruian_katastr SET nazev = 'Albrechtovice' WHERE kod = 789101;
UPDATE ruian_katastr SET nazev = 'Hlásná Lhota' WHERE kod = 789127;
UPDATE ruian_katastr SET nazev = 'Horní Záblatí' WHERE kod = 789135;
UPDATE ruian_katastr SET nazev = 'Křišťanovice u Záblatí' WHERE kod = 789143;
UPDATE ruian_katastr SET nazev = 'Řepešín' WHERE kod = 789151;
UPDATE ruian_katastr SET nazev = 'Saladín' WHERE kod = 789160;
UPDATE ruian_katastr SET nazev = 'Záblatí u Prachatic' WHERE kod = 789178;
UPDATE ruian_katastr SET nazev = 'Zvěřenice' WHERE kod = 789186;
UPDATE ruian_katastr SET nazev = 'Petrovice u Záblatí' WHERE kod = 789194;
UPDATE ruian_katastr SET nazev = 'Záblatí u Osové Bítýšky' WHERE kod = 789208;
UPDATE ruian_katastr SET nazev = 'Záblatí u Bohumína' WHERE kod = 789216;
UPDATE ruian_katastr SET nazev = 'Kněževísko' WHERE kod = 789224;
UPDATE ruian_katastr SET nazev = 'Zábludov' WHERE kod = 789232;
UPDATE ruian_katastr SET nazev = 'Záborná' WHERE kod = 789241;
UPDATE ruian_katastr SET nazev = 'Záborná Lhota' WHERE kod = 789259;
UPDATE ruian_katastr SET nazev = 'Lipanovice' WHERE kod = 789275;
UPDATE ruian_katastr SET nazev = 'Záboří u Českých Budějovic' WHERE kod = 789283;
UPDATE ruian_katastr SET nazev = 'Bratronice' WHERE kod = 789291;
UPDATE ruian_katastr SET nazev = 'Záboří u Blatné' WHERE kod = 789313;
UPDATE ruian_katastr SET nazev = 'Habrkovice' WHERE kod = 789321;
UPDATE ruian_katastr SET nazev = 'Kobylnice nad Doubravou' WHERE kod = 789330;
UPDATE ruian_katastr SET nazev = 'Záboří nad Labem' WHERE kod = 789348;
UPDATE ruian_katastr SET nazev = 'Horní Rybníky' WHERE kod = 789356;
UPDATE ruian_katastr SET nazev = 'Zábrodí' WHERE kod = 789364;
UPDATE ruian_katastr SET nazev = 'Všechlapy u Zabrušan' WHERE kod = 789381;
UPDATE ruian_katastr SET nazev = 'Zabrušany' WHERE kod = 789399;
UPDATE ruian_katastr SET nazev = 'Želénky' WHERE kod = 789402;
UPDATE ruian_katastr SET nazev = 'Zábřeh u Hlučína' WHERE kod = 789411;
UPDATE ruian_katastr SET nazev = 'Zábřeh na Moravě' WHERE kod = 789429;
UPDATE ruian_katastr SET nazev = 'Zadní Arnoštov' WHERE kod = 789551;
UPDATE ruian_katastr SET nazev = 'Broumov u Zadního Chodova' WHERE kod = 789569;
UPDATE ruian_katastr SET nazev = 'Kyjov u Zadního Chodova' WHERE kod = 789577;
UPDATE ruian_katastr SET nazev = 'Zadní Chodov' WHERE kod = 789585;
UPDATE ruian_katastr SET nazev = 'Zadní Třebaň' WHERE kod = 789593;
UPDATE ruian_katastr SET nazev = 'Zadní Zhořec' WHERE kod = 789607;
UPDATE ruian_katastr SET nazev = 'Vlkonice u Neveklova' WHERE kod = 789631;
UPDATE ruian_katastr SET nazev = 'Zádolí u Neveklova' WHERE kod = 789640;
UPDATE ruian_katastr SET nazev = 'Stříhanov' WHERE kod = 789658;
UPDATE ruian_katastr SET nazev = 'Zádolí u Vysokého Mýta' WHERE kod = 789666;
UPDATE ruian_katastr SET nazev = 'Zadražany' WHERE kod = 789674;
UPDATE ruian_katastr SET nazev = 'Milhostov u Mariánských Lázní' WHERE kod = 789682;
UPDATE ruian_katastr SET nazev = 'Zádub' WHERE kod = 789691;
UPDATE ruian_katastr SET nazev = 'Závišín' WHERE kod = 789704;
UPDATE ruian_katastr SET nazev = 'Raková' WHERE kod = 789739;
UPDATE ruian_katastr SET nazev = 'Zádveřice' WHERE kod = 789747;
UPDATE ruian_katastr SET nazev = 'Zahájí u Hluboké nad Vltavou' WHERE kod = 789755;
UPDATE ruian_katastr SET nazev = 'Chrášťany u Hulína' WHERE kod = 789763;
UPDATE ruian_katastr SET nazev = 'Záhlinice' WHERE kod = 789771;
UPDATE ruian_katastr SET nazev = 'Zahnašovice' WHERE kod = 789780;
UPDATE ruian_katastr SET nazev = 'Zahorčice u Volyně' WHERE kod = 789798;
UPDATE ruian_katastr SET nazev = 'Zahorčičky' WHERE kod = 789801;
UPDATE ruian_katastr SET nazev = 'Záhornice u Městce Králové' WHERE kod = 789828;
UPDATE ruian_katastr SET nazev = 'Záhorovice' WHERE kod = 789836;
UPDATE ruian_katastr SET nazev = 'Zahořany u Berouna' WHERE kod = 789844;
UPDATE ruian_katastr SET nazev = 'Chrást u Zahořan' WHERE kod = 789852;
UPDATE ruian_katastr SET nazev = 'Předbořice u Zahořan' WHERE kod = 789895;
UPDATE ruian_katastr SET nazev = 'Zahořany' WHERE kod = 789909;
UPDATE ruian_katastr SET nazev = 'Žebrákov u Zahořan' WHERE kod = 789917;
UPDATE ruian_katastr SET nazev = 'Zahořany u Domažlic' WHERE kod = 789925;
UPDATE ruian_katastr SET nazev = 'Sedlec u Litoměřic' WHERE kod = 789933;
UPDATE ruian_katastr SET nazev = 'Zahořany u Litoměřic' WHERE kod = 789941;
UPDATE ruian_katastr SET nazev = 'Záhoří u Humpolce' WHERE kod = 789950;
UPDATE ruian_katastr SET nazev = 'Dolní Novosedly' WHERE kod = 789968;
UPDATE ruian_katastr SET nazev = 'Horní Záhoří u Písku' WHERE kod = 789992;
UPDATE ruian_katastr SET nazev = 'Chrastiny' WHERE kod = 790001;
UPDATE ruian_katastr SET nazev = 'Svatonice' WHERE kod = 790028;
UPDATE ruian_katastr SET nazev = 'Záhoří u Bechyně' WHERE kod = 790044;
UPDATE ruian_katastr SET nazev = 'Smrčí u Semil' WHERE kod = 790087;
UPDATE ruian_katastr SET nazev = 'Záhoří u Semil' WHERE kod = 790095;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Benešova' WHERE kod = 790133;
UPDATE ruian_katastr SET nazev = 'Hůrky u Zahrádky' WHERE kod = 790150;
UPDATE ruian_katastr SET nazev = 'Mostice' WHERE kod = 790168;
UPDATE ruian_katastr SET nazev = 'Zahrádka u Všerub' WHERE kod = 790176;
UPDATE ruian_katastr SET nazev = 'Horní Paseka' WHERE kod = 790192;
UPDATE ruian_katastr SET nazev = 'Častotice' WHERE kod = 790214;
UPDATE ruian_katastr SET nazev = 'Zahrádka na Moravě' WHERE kod = 790222;
UPDATE ruian_katastr SET nazev = 'Horní Dvorce' WHERE kod = 790231;
UPDATE ruian_katastr SET nazev = 'Zahrádky' WHERE kod = 790249;
UPDATE ruian_katastr SET nazev = 'Šváby' WHERE kod = 790265;
UPDATE ruian_katastr SET nazev = 'Zahrádky u České Lípy' WHERE kod = 790273;
UPDATE ruian_katastr SET nazev = 'Záhrobí' WHERE kod = 790281;
UPDATE ruian_katastr SET nazev = 'Záchlumí u Stříbra' WHERE kod = 790290;
UPDATE ruian_katastr SET nazev = 'Záchlumí' WHERE kod = 790303;
UPDATE ruian_katastr SET nazev = 'Zachotín' WHERE kod = 790311;
UPDATE ruian_katastr SET nazev = 'Vysočany u Nového Bydžova' WHERE kod = 790320;
UPDATE ruian_katastr SET nazev = 'Zachrašťany' WHERE kod = 790338;
UPDATE ruian_katastr SET nazev = 'Zaječí' WHERE kod = 790346;
UPDATE ruian_katastr SET nazev = 'Zaječice u Chrudimi' WHERE kod = 790362;
UPDATE ruian_katastr SET nazev = 'Zaječov' WHERE kod = 790389;
UPDATE ruian_katastr SET nazev = 'Zájezd u Buštěhradu' WHERE kod = 790401;
UPDATE ruian_katastr SET nazev = 'Zájezdec' WHERE kod = 790419;
UPDATE ruian_katastr SET nazev = 'Zajíčkov' WHERE kod = 790435;
UPDATE ruian_katastr SET nazev = 'Kováry' WHERE kod = 790443;
UPDATE ruian_katastr SET nazev = 'Trněný Újezd u Zákolan' WHERE kod = 790451;
UPDATE ruian_katastr SET nazev = 'Zakřany' WHERE kod = 790478;
UPDATE ruian_katastr SET nazev = 'Zákřov' WHERE kod = 790486;
UPDATE ruian_katastr SET nazev = 'Deštná u Dubé' WHERE kod = 790508;
UPDATE ruian_katastr SET nazev = 'Zakšín' WHERE kod = 790516;
UPDATE ruian_katastr SET nazev = 'Božíkov' WHERE kod = 790524;
UPDATE ruian_katastr SET nazev = 'Lasvice' WHERE kod = 790532;
UPDATE ruian_katastr SET nazev = 'Starý Šidlov' WHERE kod = 790559;
UPDATE ruian_katastr SET nazev = 'Zákupy' WHERE kod = 790567;
UPDATE ruian_katastr SET nazev = 'Zálesí u Bítova' WHERE kod = 790575;
UPDATE ruian_katastr SET nazev = 'Zálesná Zhoř' WHERE kod = 790583;
UPDATE ruian_katastr SET nazev = 'Zálesní Lhota' WHERE kod = 790591;
UPDATE ruian_katastr SET nazev = 'Přebozy' WHERE kod = 790605;
UPDATE ruian_katastr SET nazev = 'Zalešany' WHERE kod = 790613;
UPDATE ruian_katastr SET nazev = 'Zálezlice' WHERE kod = 790630;
UPDATE ruian_katastr SET nazev = 'Zálezly u Čkyně' WHERE kod = 790656;
UPDATE ruian_katastr SET nazev = 'Horní Dolce' WHERE kod = 790664;
UPDATE ruian_katastr SET nazev = 'Rtyně' WHERE kod = 790672;
UPDATE ruian_katastr SET nazev = 'Vestec u Jaroměře' WHERE kod = 790681;
UPDATE ruian_katastr SET nazev = 'Zaloňov' WHERE kod = 790699;
UPDATE ruian_katastr SET nazev = 'Klečaty' WHERE kod = 790702;
UPDATE ruian_katastr SET nazev = 'Mažice' WHERE kod = 790711;
UPDATE ruian_katastr SET nazev = 'Zálší' WHERE kod = 790729;
UPDATE ruian_katastr SET nazev = 'Kosořín' WHERE kod = 790737;
UPDATE ruian_katastr SET nazev = 'Zálší u Chocně' WHERE kod = 790745;
UPDATE ruian_katastr SET nazev = 'Zalužany' WHERE kod = 790761;
UPDATE ruian_katastr SET nazev = 'Záluží u Hořovic' WHERE kod = 790770;
UPDATE ruian_katastr SET nazev = 'Chlumec' WHERE kod = 790796;
UPDATE ruian_katastr SET nazev = 'Štěkře' WHERE kod = 790818;
UPDATE ruian_katastr SET nazev = 'Záluží nad Vltavou' WHERE kod = 790826;
UPDATE ruian_katastr SET nazev = 'Záluží u Vodňan' WHERE kod = 790834;
UPDATE ruian_katastr SET nazev = 'Záluží u Litvínova' WHERE kod = 790842;
UPDATE ruian_katastr SET nazev = 'Záluží u Budislavě' WHERE kod = 790851;
UPDATE ruian_katastr SET nazev = 'Rybňany' WHERE kod = 790869;
UPDATE ruian_katastr SET nazev = 'Stekník' WHERE kod = 790877;
UPDATE ruian_katastr SET nazev = 'Zálužice nad Ohří' WHERE kod = 790885;
UPDATE ruian_katastr SET nazev = 'Zamachy' WHERE kod = 790907;
UPDATE ruian_katastr SET nazev = 'Záměl' WHERE kod = 790915;
UPDATE ruian_katastr SET nazev = 'Zámlyní' WHERE kod = 790923;
UPDATE ruian_katastr SET nazev = 'Janovičky u Zámrsku' WHERE kod = 790931;
UPDATE ruian_katastr SET nazev = 'Zámrsk' WHERE kod = 790958;
UPDATE ruian_katastr SET nazev = 'Zámrsky' WHERE kod = 790974;
UPDATE ruian_katastr SET nazev = 'Zárubice' WHERE kod = 790982;
UPDATE ruian_katastr SET nazev = 'Zárybničná Lhota' WHERE kod = 790991;
UPDATE ruian_katastr SET nazev = 'Martinov' WHERE kod = 791008;
UPDATE ruian_katastr SET nazev = 'Záryby' WHERE kod = 791016;
UPDATE ruian_katastr SET nazev = 'Zářecká Lhota' WHERE kod = 791024;
UPDATE ruian_katastr SET nazev = 'Záříčí' WHERE kod = 791032;
UPDATE ruian_katastr SET nazev = 'Zásada' WHERE kod = 791059;
UPDATE ruian_katastr SET nazev = 'Doubravčany' WHERE kod = 791067;
UPDATE ruian_katastr SET nazev = 'Nesměň u Zásmuk' WHERE kod = 791075;
UPDATE ruian_katastr SET nazev = 'Sobočice' WHERE kod = 791083;
UPDATE ruian_katastr SET nazev = 'Vršice' WHERE kod = 791091;
UPDATE ruian_katastr SET nazev = 'Zásmuky' WHERE kod = 791105;
UPDATE ruian_katastr SET nazev = 'Zastávka' WHERE kod = 791113;
UPDATE ruian_katastr SET nazev = 'Zástřizly' WHERE kod = 791148;
UPDATE ruian_katastr SET nazev = 'Zašová' WHERE kod = 791164;
UPDATE ruian_katastr SET nazev = 'Nová Brtnice' WHERE kod = 791172;
UPDATE ruian_katastr SET nazev = 'Zašovice' WHERE kod = 791181;
UPDATE ruian_katastr SET nazev = 'Loučky u Zátoru' WHERE kod = 791199;
UPDATE ruian_katastr SET nazev = 'Zátor' WHERE kod = 791202;
UPDATE ruian_katastr SET nazev = 'Lhota u Dřevčic' WHERE kod = 791211;
UPDATE ruian_katastr SET nazev = 'Zátyní' WHERE kod = 791229;
UPDATE ruian_katastr SET nazev = 'Závada u Hlučína' WHERE kod = 791237;
UPDATE ruian_katastr SET nazev = 'Zavidov' WHERE kod = 791245;
UPDATE ruian_katastr SET nazev = 'Závišice' WHERE kod = 791261;
UPDATE ruian_katastr SET nazev = 'Závišín u Bělčic' WHERE kod = 791288;
UPDATE ruian_katastr SET nazev = 'Plichtice' WHERE kod = 791300;
UPDATE ruian_katastr SET nazev = 'Skránčice' WHERE kod = 791318;
UPDATE ruian_katastr SET nazev = 'Tužice' WHERE kod = 791326;
UPDATE ruian_katastr SET nazev = 'Zavlekov' WHERE kod = 791334;
UPDATE ruian_katastr SET nazev = 'Lhůty' WHERE kod = 791342;
UPDATE ruian_katastr SET nazev = 'Závratec' WHERE kod = 791351;
UPDATE ruian_katastr SET nazev = 'Zbečno' WHERE kod = 791377;
UPDATE ruian_katastr SET nazev = 'Zbelítov' WHERE kod = 791385;
UPDATE ruian_katastr SET nazev = 'Hanov' WHERE kod = 791393;
UPDATE ruian_katastr SET nazev = 'Jestřebice' WHERE kod = 791407;
UPDATE ruian_katastr SET nazev = 'Kolišov' WHERE kod = 791415;
UPDATE ruian_katastr SET nazev = 'Popovec u Zběšiček' WHERE kod = 791423;
UPDATE ruian_katastr SET nazev = 'Srlín' WHERE kod = 791431;
UPDATE ruian_katastr SET nazev = 'Zběšičky' WHERE kod = 791440;
UPDATE ruian_katastr SET nazev = 'Zbilidy' WHERE kod = 791458;
UPDATE ruian_katastr SET nazev = 'Zbinohy' WHERE kod = 791466;
UPDATE ruian_katastr SET nazev = 'Týček' WHERE kod = 791491;
UPDATE ruian_katastr SET nazev = 'Zbiroh' WHERE kod = 791504;
UPDATE ruian_katastr SET nazev = 'Makolusky' WHERE kod = 791539;
UPDATE ruian_katastr SET nazev = 'Vlková' WHERE kod = 791547;
UPDATE ruian_katastr SET nazev = 'Vranice' WHERE kod = 791555;
UPDATE ruian_katastr SET nazev = 'Zbizuby' WHERE kod = 791563;
UPDATE ruian_katastr SET nazev = 'Zblovice' WHERE kod = 791571;
UPDATE ruian_katastr SET nazev = 'Zbonín' WHERE kod = 791601;
UPDATE ruian_katastr SET nazev = 'Zborná' WHERE kod = 791610;
UPDATE ruian_katastr SET nazev = 'Ohrazení' WHERE kod = 791628;
UPDATE ruian_katastr SET nazev = 'Zborov' WHERE kod = 791644;
UPDATE ruian_katastr SET nazev = 'Zborov na Moravě' WHERE kod = 791652;
UPDATE ruian_katastr SET nazev = 'Medlov u Zborovic' WHERE kod = 791661;
UPDATE ruian_katastr SET nazev = 'Zborovice' WHERE kod = 791679;
UPDATE ruian_katastr SET nazev = 'Zbožíčko' WHERE kod = 791687;
UPDATE ruian_katastr SET nazev = 'Lhota u Skutče' WHERE kod = 791695;
UPDATE ruian_katastr SET nazev = 'Štěpánov u Skutče' WHERE kod = 791709;
UPDATE ruian_katastr SET nazev = 'Zbožnov' WHERE kod = 791717;
UPDATE ruian_katastr SET nazev = 'Zbraslav' WHERE kod = 791733;
UPDATE ruian_katastr SET nazev = 'Domašín u Zbraslavi' WHERE kod = 791776;
UPDATE ruian_katastr SET nazev = 'Zbraslav u Štědré' WHERE kod = 791784;
UPDATE ruian_katastr SET nazev = 'Zbraslav na Moravě' WHERE kod = 791806;
UPDATE ruian_katastr SET nazev = 'Zbraslavec' WHERE kod = 791814;
UPDATE ruian_katastr SET nazev = 'Malá Skalice u Zbraslavic' WHERE kod = 791849;
UPDATE ruian_katastr SET nazev = 'Rápošov' WHERE kod = 791865;
UPDATE ruian_katastr SET nazev = 'Útěšenovice' WHERE kod = 791873;
UPDATE ruian_katastr SET nazev = 'Velká Skalice' WHERE kod = 791881;
UPDATE ruian_katastr SET nazev = 'Zbraslavice' WHERE kod = 791890;
UPDATE ruian_katastr SET nazev = 'Hořany u Zbrašína' WHERE kod = 791903;
UPDATE ruian_katastr SET nazev = 'Senkov' WHERE kod = 791911;
UPDATE ruian_katastr SET nazev = 'Zbrašín' WHERE kod = 791920;
UPDATE ruian_katastr SET nazev = 'Červený Újezd u Zbůchu' WHERE kod = 791938;
UPDATE ruian_katastr SET nazev = 'Úherce u Nýřan' WHERE kod = 791946;
UPDATE ruian_katastr SET nazev = 'Zbůch' WHERE kod = 791954;
UPDATE ruian_katastr SET nazev = 'Zbuzany' WHERE kod = 791962;
UPDATE ruian_katastr SET nazev = 'Zbyny' WHERE kod = 791971;
UPDATE ruian_katastr SET nazev = 'Zbyslav u Klatov' WHERE kod = 791997;
UPDATE ruian_katastr SET nazev = 'Zbyslavice' WHERE kod = 792004;
UPDATE ruian_katastr SET nazev = 'Čejkovice u Zbýšova' WHERE kod = 792012;
UPDATE ruian_katastr SET nazev = 'Damírov' WHERE kod = 792021;
UPDATE ruian_katastr SET nazev = 'Dědice u Zbýšova' WHERE kod = 792039;
UPDATE ruian_katastr SET nazev = 'Dobrovítov' WHERE kod = 792047;
UPDATE ruian_katastr SET nazev = 'Chlum u Zbýšova' WHERE kod = 792055;
UPDATE ruian_katastr SET nazev = 'Klucké Chvalovice' WHERE kod = 792063;
UPDATE ruian_katastr SET nazev = 'Krchlebská Lhota' WHERE kod = 792071;
UPDATE ruian_katastr SET nazev = 'Opatovice u Zbýšova' WHERE kod = 792080;
UPDATE ruian_katastr SET nazev = 'Zbýšov v Čechách' WHERE kod = 792098;
UPDATE ruian_katastr SET nazev = 'Zbýšov u Oslavan' WHERE kod = 792110;
UPDATE ruian_katastr SET nazev = 'Zbýšov' WHERE kod = 792128;
UPDATE ruian_katastr SET nazev = 'Koryto' WHERE kod = 792144;
UPDATE ruian_katastr SET nazev = 'Skříněřov' WHERE kod = 792152;
UPDATE ruian_katastr SET nazev = 'Spálenec' WHERE kod = 792161;
UPDATE ruian_katastr SET nazev = 'Zbytiny' WHERE kod = 792179;
UPDATE ruian_katastr SET nazev = 'Zdebuzeves' WHERE kod = 792187;
UPDATE ruian_katastr SET nazev = 'Zděchov' WHERE kod = 792225;
UPDATE ruian_katastr SET nazev = 'Morašice v Železných horách' WHERE kod = 792233;
UPDATE ruian_katastr SET nazev = 'Spytovice' WHERE kod = 792241;
UPDATE ruian_katastr SET nazev = 'Zdechovice' WHERE kod = 792250;
UPDATE ruian_katastr SET nazev = 'Zdelov' WHERE kod = 792268;
UPDATE ruian_katastr SET nazev = 'Zdemyslice' WHERE kod = 792276;
UPDATE ruian_katastr SET nazev = 'Zdenice' WHERE kod = 792284;
UPDATE ruian_katastr SET nazev = 'Zdeňkov' WHERE kod = 792292;
UPDATE ruian_katastr SET nazev = 'Zderadice' WHERE kod = 792331;
UPDATE ruian_katastr SET nazev = 'Křekovice' WHERE kod = 792349;
UPDATE ruian_katastr SET nazev = 'Zdeslav u Rakovníka' WHERE kod = 792357;
UPDATE ruian_katastr SET nazev = 'Zdešov' WHERE kod = 792365;
UPDATE ruian_katastr SET nazev = 'Zdětín u Benátek nad Jizerou' WHERE kod = 792373;
UPDATE ruian_katastr SET nazev = 'Zdětín na Moravě' WHERE kod = 792381;
UPDATE ruian_katastr SET nazev = 'Brnky' WHERE kod = 792390;
UPDATE ruian_katastr SET nazev = 'Přemyšlení' WHERE kod = 792403;
UPDATE ruian_katastr SET nazev = 'Zdiby' WHERE kod = 792411;
UPDATE ruian_katastr SET nazev = 'Černín u Zdic' WHERE kod = 792420;
UPDATE ruian_katastr SET nazev = 'Knížkovice' WHERE kod = 792438;
UPDATE ruian_katastr SET nazev = 'Zdice' WHERE kod = 792446;
UPDATE ruian_katastr SET nazev = 'Masákova Lhota' WHERE kod = 792454;
UPDATE ruian_katastr SET nazev = 'Putkov' WHERE kod = 792471;
UPDATE ruian_katastr SET nazev = 'Račov' WHERE kod = 792489;
UPDATE ruian_katastr SET nazev = 'Zdíkov' WHERE kod = 792501;
UPDATE ruian_katastr SET nazev = 'Žírec' WHERE kod = 792519;
UPDATE ruian_katastr SET nazev = 'Branišov u Zdíkovce' WHERE kod = 792527;
UPDATE ruian_katastr SET nazev = 'Hodonín u Zdíkovce' WHERE kod = 792535;
UPDATE ruian_katastr SET nazev = 'Jaroškov' WHERE kod = 792543;
UPDATE ruian_katastr SET nazev = 'Zdíkovec' WHERE kod = 792551;
UPDATE ruian_katastr SET nazev = 'Zdislava' WHERE kod = 792560;
UPDATE ruian_katastr SET nazev = 'Zdislavice u Vlašimi' WHERE kod = 792578;
UPDATE ruian_katastr SET nazev = 'Dubí' WHERE kod = 792586;
UPDATE ruian_katastr SET nazev = 'Zdislavice u Herálce' WHERE kod = 792608;
UPDATE ruian_katastr SET nazev = 'Kačerov u Zdobnice' WHERE kod = 792616;
UPDATE ruian_katastr SET nazev = 'Kunčina Ves u Zdobnice' WHERE kod = 792624;
UPDATE ruian_katastr SET nazev = 'Souvlastní' WHERE kod = 792632;
UPDATE ruian_katastr SET nazev = 'Velká Zdobnice' WHERE kod = 792641;
UPDATE ruian_katastr SET nazev = 'Malá Zdobnice' WHERE kod = 792659;
UPDATE ruian_katastr SET nazev = 'Zdoňov' WHERE kod = 792667;
UPDATE ruian_katastr SET nazev = 'Libná' WHERE kod = 792675;
UPDATE ruian_katastr SET nazev = 'Zdounky' WHERE kod = 792683;
UPDATE ruian_katastr SET nazev = 'Zduchovice' WHERE kod = 792705;
UPDATE ruian_katastr SET nazev = 'Zelená Hora na Moravě' WHERE kod = 792721;
UPDATE ruian_katastr SET nazev = 'Hamry na Šumavě' WHERE kod = 792730;
UPDATE ruian_katastr SET nazev = 'Zelená Lhota' WHERE kod = 792748;
UPDATE ruian_katastr SET nazev = 'Zadní Chalupy' WHERE kod = 792756;
UPDATE ruian_katastr SET nazev = 'Mstětice' WHERE kod = 792764;
UPDATE ruian_katastr SET nazev = 'Svémyslice' WHERE kod = 792772;
UPDATE ruian_katastr SET nazev = 'Zeleneč' WHERE kod = 792781;
UPDATE ruian_katastr SET nazev = 'Zeměchy u Kralup nad Vltavou' WHERE kod = 792799;
UPDATE ruian_katastr SET nazev = 'Čelákovy' WHERE kod = 792802;
UPDATE ruian_katastr SET nazev = 'Zemětice' WHERE kod = 792829;
UPDATE ruian_katastr SET nazev = 'Blehov' WHERE kod = 792837;
UPDATE ruian_katastr SET nazev = 'Osletín' WHERE kod = 792845;
UPDATE ruian_katastr SET nazev = 'Zhoř u Milevska' WHERE kod = 792861;
UPDATE ruian_katastr SET nazev = 'Březí u Milevska' WHERE kod = 792870;
UPDATE ruian_katastr SET nazev = 'Telice' WHERE kod = 792888;
UPDATE ruian_katastr SET nazev = 'Zhoř u Stříbra' WHERE kod = 792896;
UPDATE ruian_katastr SET nazev = 'Zhoř u České Třebové' WHERE kod = 792900;
UPDATE ruian_katastr SET nazev = 'Zhoř u Rohozce' WHERE kod = 792918;
UPDATE ruian_katastr SET nazev = 'Zhoř u Jihlavy' WHERE kod = 792926;
UPDATE ruian_katastr SET nazev = 'Bedřichov u Zhořce' WHERE kod = 792934;
UPDATE ruian_katastr SET nazev = 'Velká Rovná' WHERE kod = 792942;
UPDATE ruian_katastr SET nazev = 'Zhoř u Pacova' WHERE kod = 792951;
UPDATE ruian_katastr SET nazev = 'Zhořec u Pacova' WHERE kod = 792969;
UPDATE ruian_katastr SET nazev = 'Zichovec' WHERE kod = 792985;
UPDATE ruian_katastr SET nazev = 'Zlámanec' WHERE kod = 792993;
UPDATE ruian_katastr SET nazev = 'Zlámanka' WHERE kod = 793001;
UPDATE ruian_katastr SET nazev = 'Zlatá' WHERE kod = 793019;
UPDATE ruian_katastr SET nazev = 'Plešovice' WHERE kod = 793027;
UPDATE ruian_katastr SET nazev = 'Rájov' WHERE kod = 793035;
UPDATE ruian_katastr SET nazev = 'Zlatá Koruna' WHERE kod = 793043;
UPDATE ruian_katastr SET nazev = 'Lhotka u Zlaté Olešnice' WHERE kod = 793051;
UPDATE ruian_katastr SET nazev = 'Stanový' WHERE kod = 793060;
UPDATE ruian_katastr SET nazev = 'Zlatá Olešnice Semilská' WHERE kod = 793078;
UPDATE ruian_katastr SET nazev = 'Zlatá Olešnice Navarovská' WHERE kod = 793086;
UPDATE ruian_katastr SET nazev = 'Zlatá Olešnice' WHERE kod = 793094;
UPDATE ruian_katastr SET nazev = 'Kamberk' WHERE kod = 793124;
UPDATE ruian_katastr SET nazev = 'Dolní Údolí' WHERE kod = 793132;
UPDATE ruian_katastr SET nazev = 'Horní Údolí' WHERE kod = 793141;
UPDATE ruian_katastr SET nazev = 'Ondřejovice v Jeseníkách' WHERE kod = 793159;
UPDATE ruian_katastr SET nazev = 'Rejvíz' WHERE kod = 793167;
UPDATE ruian_katastr SET nazev = 'Zlaté Hory v Jeseníkách' WHERE kod = 793191;
UPDATE ruian_katastr SET nazev = 'Zlátenka' WHERE kod = 793205;
UPDATE ruian_katastr SET nazev = 'Hodkovice u Zlatníků' WHERE kod = 793213;
UPDATE ruian_katastr SET nazev = 'Zlatníky u Prahy' WHERE kod = 793221;
UPDATE ruian_katastr SET nazev = 'Zlatníky u Opavy' WHERE kod = 793230;
UPDATE ruian_katastr SET nazev = 'Zlechov' WHERE kod = 793248;
UPDATE ruian_katastr SET nazev = 'Sobín' WHERE kod = 793256;
UPDATE ruian_katastr SET nazev = 'Zličín' WHERE kod = 793264;
UPDATE ruian_katastr SET nazev = 'Zliv u Českých Budějovic' WHERE kod = 793272;
UPDATE ruian_katastr SET nazev = 'Zliv u Libáně' WHERE kod = 793281;
UPDATE ruian_katastr SET nazev = 'Bojanovice u Zlobic' WHERE kod = 793299;
UPDATE ruian_katastr SET nazev = 'Zlobice' WHERE kod = 793302;
UPDATE ruian_katastr SET nazev = 'Lisovice' WHERE kod = 793311;
UPDATE ruian_katastr SET nazev = 'Vyšínek' WHERE kod = 793329;
UPDATE ruian_katastr SET nazev = 'Zlonice' WHERE kod = 793337;
UPDATE ruian_katastr SET nazev = 'Zlonín' WHERE kod = 793345;
UPDATE ruian_katastr SET nazev = 'Zlosyň' WHERE kod = 793353;
UPDATE ruian_katastr SET nazev = 'Zlukov' WHERE kod = 793361;
UPDATE ruian_katastr SET nazev = 'Zminný' WHERE kod = 793388;
UPDATE ruian_katastr SET nazev = 'Zňátky' WHERE kod = 793396;
UPDATE ruian_katastr SET nazev = 'Znětínek' WHERE kod = 793400;
UPDATE ruian_katastr SET nazev = 'Znojmo-město' WHERE kod = 793418;
UPDATE ruian_katastr SET nazev = 'Znojmo-Hradiště' WHERE kod = 793426;
UPDATE ruian_katastr SET nazev = 'Znojmo-Louka' WHERE kod = 793574;
UPDATE ruian_katastr SET nazev = 'Senec u Plzně' WHERE kod = 793612;
UPDATE ruian_katastr SET nazev = 'Zruč' WHERE kod = 793621;
UPDATE ruian_katastr SET nazev = 'Nesměřice' WHERE kod = 793647;
UPDATE ruian_katastr SET nazev = 'Zruč nad Sázavou' WHERE kod = 793655;
UPDATE ruian_katastr SET nazev = 'Věžovatá Pláně' WHERE kod = 793680;
UPDATE ruian_katastr SET nazev = 'Zubčice' WHERE kod = 793698;
UPDATE ruian_katastr SET nazev = 'Týniště u Zubrnic' WHERE kod = 793710;
UPDATE ruian_katastr SET nazev = 'Zubrnice' WHERE kod = 793728;
UPDATE ruian_katastr SET nazev = 'Zubří u Nového Města na Moravě' WHERE kod = 793736;
UPDATE ruian_katastr SET nazev = 'Zubří' WHERE kod = 793787;
UPDATE ruian_katastr SET nazev = 'Zvánovice' WHERE kod = 793795;
UPDATE ruian_katastr SET nazev = 'Zvěrkovice u Moravských Budějovic' WHERE kod = 793809;
UPDATE ruian_katastr SET nazev = 'Sedlečko u Soběslavě' WHERE kod = 793817;
UPDATE ruian_katastr SET nazev = 'Zvěrotice' WHERE kod = 793825;
UPDATE ruian_katastr SET nazev = 'Zvěřínek' WHERE kod = 793833;
UPDATE ruian_katastr SET nazev = 'Zvěstov' WHERE kod = 793876;
UPDATE ruian_katastr SET nazev = 'Spytice' WHERE kod = 793884;
UPDATE ruian_katastr SET nazev = 'Zvěstovice' WHERE kod = 793892;
UPDATE ruian_katastr SET nazev = 'Hvozdec u Lišova' WHERE kod = 793914;
UPDATE ruian_katastr SET nazev = 'Vlkovice' WHERE kod = 793922;
UPDATE ruian_katastr SET nazev = 'Zvíkov u Lišova' WHERE kod = 793931;
UPDATE ruian_katastr SET nazev = 'Zvíkov nad Bystřicí' WHERE kod = 793957;
UPDATE ruian_katastr SET nazev = 'Zvíkovec' WHERE kod = 793973;
UPDATE ruian_katastr SET nazev = 'Zvíkovské Podhradí' WHERE kod = 793981;
UPDATE ruian_katastr SET nazev = 'Zvírotice' WHERE kod = 793990;
UPDATE ruian_katastr SET nazev = 'Zvířetice' WHERE kod = 794015;
UPDATE ruian_katastr SET nazev = 'Březová u Zvole' WHERE kod = 794023;
UPDATE ruian_katastr SET nazev = 'Oleško u Zvole' WHERE kod = 794040;
UPDATE ruian_katastr SET nazev = 'Zvole u Prahy' WHERE kod = 794058;
UPDATE ruian_katastr SET nazev = 'Branišov nad Pernštejnem' WHERE kod = 794066;
UPDATE ruian_katastr SET nazev = 'Olešínky' WHERE kod = 794074;
UPDATE ruian_katastr SET nazev = 'Zvole nad Pernštejnem' WHERE kod = 794082;
UPDATE ruian_katastr SET nazev = 'Zvole u Zábřeha' WHERE kod = 794091;
UPDATE ruian_katastr SET nazev = 'Zvoleněves' WHERE kod = 794104;
UPDATE ruian_katastr SET nazev = 'Zvolenovice' WHERE kod = 794112;
UPDATE ruian_katastr SET nazev = 'Žabčice' WHERE kod = 794121;
UPDATE ruian_katastr SET nazev = 'Žabeň' WHERE kod = 794139;
UPDATE ruian_katastr SET nazev = 'Břehov' WHERE kod = 794147;
UPDATE ruian_katastr SET nazev = 'Dehtáře u Českých Budějovic' WHERE kod = 794155;
UPDATE ruian_katastr SET nazev = 'Žabovřesky u Českých Budějovic' WHERE kod = 794163;
UPDATE ruian_katastr SET nazev = 'Žabovřesky nad Ohří' WHERE kod = 794171;
UPDATE ruian_katastr SET nazev = 'Bobr' WHERE kod = 794180;
UPDATE ruian_katastr SET nazev = 'Černá Voda u Žacléře' WHERE kod = 794198;
UPDATE ruian_katastr SET nazev = 'Prkenný Důl' WHERE kod = 794228;
UPDATE ruian_katastr SET nazev = 'Rýchory' WHERE kod = 794236;
UPDATE ruian_katastr SET nazev = 'Žacléř' WHERE kod = 794244;
UPDATE ruian_katastr SET nazev = 'Vernířovice' WHERE kod = 794252;
UPDATE ruian_katastr SET nazev = 'Žádovice' WHERE kod = 794261;
UPDATE ruian_katastr SET nazev = 'Žákovice' WHERE kod = 794279;
UPDATE ruian_katastr SET nazev = 'Žáky' WHERE kod = 794295;
UPDATE ruian_katastr SET nazev = 'Černčice u Žalan' WHERE kod = 794309;
UPDATE ruian_katastr SET nazev = 'Žalany' WHERE kod = 794325;
UPDATE ruian_katastr SET nazev = 'Píšťany' WHERE kod = 794333;
UPDATE ruian_katastr SET nazev = 'Žalhostice' WHERE kod = 794341;
UPDATE ruian_katastr SET nazev = 'Žalkovice' WHERE kod = 794350;
UPDATE ruian_katastr SET nazev = 'Žamberk' WHERE kod = 794368;
UPDATE ruian_katastr SET nazev = 'Dlouhoňovice' WHERE kod = 794392;
UPDATE ruian_katastr SET nazev = 'Žampach' WHERE kod = 794465;
UPDATE ruian_katastr SET nazev = 'Dolní Police' WHERE kod = 794473;
UPDATE ruian_katastr SET nazev = 'Žandov u České Lípy' WHERE kod = 794481;
UPDATE ruian_katastr SET nazev = 'Žandov u Chlumce' WHERE kod = 794490;
UPDATE ruian_katastr SET nazev = 'Božejov u Nových Hradů' WHERE kod = 794503;
UPDATE ruian_katastr SET nazev = 'Buková u Nových Hradů' WHERE kod = 794511;
UPDATE ruian_katastr SET nazev = 'Žár u Nových Hradů' WHERE kod = 794546;
UPDATE ruian_katastr SET nazev = 'Žumberk u Nových Hradů' WHERE kod = 794554;
UPDATE ruian_katastr SET nazev = 'Nespice' WHERE kod = 794562;
UPDATE ruian_katastr SET nazev = 'Žár u Čkyně' WHERE kod = 794589;
UPDATE ruian_katastr SET nazev = 'Žáravice' WHERE kod = 794597;
UPDATE ruian_katastr SET nazev = 'Žarošice' WHERE kod = 794627;
UPDATE ruian_katastr SET nazev = 'Žárová' WHERE kod = 794643;
UPDATE ruian_katastr SET nazev = 'Hamry' WHERE kod = 794651;
UPDATE ruian_katastr SET nazev = 'Žárovice' WHERE kod = 794660;
UPDATE ruian_katastr SET nazev = 'Vojslavice u Žárovné' WHERE kod = 794678;
UPDATE ruian_katastr SET nazev = 'Žárovná' WHERE kod = 794686;
UPDATE ruian_katastr SET nazev = 'Žatčany' WHERE kod = 794724;
UPDATE ruian_katastr SET nazev = 'Žatec' WHERE kod = 794732;
UPDATE ruian_katastr SET nazev = 'Velichov u Žatce' WHERE kod = 794902;
UPDATE ruian_katastr SET nazev = 'Žatec na Moravě' WHERE kod = 794945;
UPDATE ruian_katastr SET nazev = 'Ždánice u Kouřimi' WHERE kod = 794953;
UPDATE ruian_katastr SET nazev = 'Ždánice' WHERE kod = 794961;
UPDATE ruian_katastr SET nazev = 'Karasín' WHERE kod = 794970;
UPDATE ruian_katastr SET nazev = 'Ždánice u Bystřice nad Pernštejnem' WHERE kod = 794988;
UPDATE ruian_katastr SET nazev = 'Ždánov' WHERE kod = 794996;
UPDATE ruian_katastr SET nazev = 'Žďár u Mnichova Hradiště' WHERE kod = 795046;
UPDATE ruian_katastr SET nazev = 'Žehrov' WHERE kod = 795054;
UPDATE ruian_katastr SET nazev = 'Otěvěky' WHERE kod = 795062;
UPDATE ruian_katastr SET nazev = 'Podbořánky' WHERE kod = 795071;
UPDATE ruian_katastr SET nazev = 'Žďár u Rakovníka' WHERE kod = 795089;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Protivína' WHERE kod = 795097;
UPDATE ruian_katastr SET nazev = 'Žďár u Protivína' WHERE kod = 795101;
UPDATE ruian_katastr SET nazev = 'Kruh v Podbezdězí' WHERE kod = 795127;
UPDATE ruian_katastr SET nazev = 'Vojetín' WHERE kod = 795135;
UPDATE ruian_katastr SET nazev = 'Žďár v Podbezdězí' WHERE kod = 795143;
UPDATE ruian_katastr SET nazev = 'Knínice u Libouchce' WHERE kod = 795151;
UPDATE ruian_katastr SET nazev = 'Žďár u Velkého Chvojna' WHERE kod = 795160;
UPDATE ruian_katastr SET nazev = 'Žďár nad Metují' WHERE kod = 795186;
UPDATE ruian_katastr SET nazev = 'Žďár u Blanska' WHERE kod = 795194;
UPDATE ruian_katastr SET nazev = 'Žďár nad Orlicí' WHERE kod = 795224;
UPDATE ruian_katastr SET nazev = 'Město Žďár' WHERE kod = 795232;
UPDATE ruian_katastr SET nazev = 'Zámek Žďár' WHERE kod = 795453;
UPDATE ruian_katastr SET nazev = 'Víckov' WHERE kod = 795470;
UPDATE ruian_katastr SET nazev = 'Žďárec' WHERE kod = 795488;
UPDATE ruian_katastr SET nazev = 'Žďárec u Seče' WHERE kod = 795496;
UPDATE ruian_katastr SET nazev = 'Žďárec u Skutče' WHERE kod = 795500;
UPDATE ruian_katastr SET nazev = 'Žďárky' WHERE kod = 795526;
UPDATE ruian_katastr SET nazev = 'Žďárná' WHERE kod = 795534;
UPDATE ruian_katastr SET nazev = 'Smederov' WHERE kod = 795551;
UPDATE ruian_katastr SET nazev = 'Žďár u Blovic' WHERE kod = 795569;
UPDATE ruian_katastr SET nazev = 'Ždírec u Blovic' WHERE kod = 795577;
UPDATE ruian_katastr SET nazev = 'Ždírec v Podbezdězí' WHERE kod = 795593;
UPDATE ruian_katastr SET nazev = 'Ždírec na Moravě' WHERE kod = 795607;
UPDATE ruian_katastr SET nazev = 'Benátky u Ždírce nad Doubravou' WHERE kod = 795615;
UPDATE ruian_katastr SET nazev = 'Kohoutov u Ždírce nad Doubravou' WHERE kod = 795623;
UPDATE ruian_katastr SET nazev = 'Ždírec nad Doubravou' WHERE kod = 795640;
UPDATE ruian_katastr SET nazev = 'Přední Ždírnice' WHERE kod = 795658;
UPDATE ruian_katastr SET nazev = 'Zadní Ždírnice' WHERE kod = 795666;
UPDATE ruian_katastr SET nazev = 'Žebětín' WHERE kod = 795674;
UPDATE ruian_katastr SET nazev = 'Žebnice' WHERE kod = 795682;
UPDATE ruian_katastr SET nazev = 'Sedlec u Žebráku' WHERE kod = 795691;
UPDATE ruian_katastr SET nazev = 'Točník' WHERE kod = 795704;
UPDATE ruian_katastr SET nazev = 'Žebrák' WHERE kod = 795712;
UPDATE ruian_katastr SET nazev = 'Choťovice' WHERE kod = 795721;
UPDATE ruian_katastr SET nazev = 'Žehuň' WHERE kod = 795739;
UPDATE ruian_katastr SET nazev = 'Bojmany' WHERE kod = 795747;
UPDATE ruian_katastr SET nazev = 'Horka u Žehušic' WHERE kod = 795763;
UPDATE ruian_katastr SET nazev = 'Horušice' WHERE kod = 795771;
UPDATE ruian_katastr SET nazev = 'Žehušice' WHERE kod = 795798;
UPDATE ruian_katastr SET nazev = 'Želatovice' WHERE kod = 795801;
UPDATE ruian_katastr SET nazev = 'Bezděčín' WHERE kod = 795810;
UPDATE ruian_katastr SET nazev = 'Želeč u Tábora' WHERE kod = 795828;
UPDATE ruian_katastr SET nazev = 'Želeč u Žatce' WHERE kod = 795836;
UPDATE ruian_katastr SET nazev = 'Želeč na Hané' WHERE kod = 795844;
UPDATE ruian_katastr SET nazev = 'Želechovice u Uničova' WHERE kod = 795852;
UPDATE ruian_katastr SET nazev = 'Lípa nad Dřevnicí' WHERE kod = 795861;
UPDATE ruian_katastr SET nazev = 'Lužkovice' WHERE kod = 795887;
UPDATE ruian_katastr SET nazev = 'Želechovice nad Dřevnicí' WHERE kod = 795909;
UPDATE ruian_katastr SET nazev = 'Želenice' WHERE kod = 795917;
UPDATE ruian_katastr SET nazev = 'Liběšice u Želenic' WHERE kod = 795925;
UPDATE ruian_katastr SET nazev = 'Želenice u Mostu' WHERE kod = 795933;
UPDATE ruian_katastr SET nazev = 'Damětice' WHERE kod = 795941;
UPDATE ruian_katastr SET nazev = 'Frymburk u Sušice' WHERE kod = 795950;
UPDATE ruian_katastr SET nazev = 'Želešice' WHERE kod = 795968;
UPDATE ruian_katastr SET nazev = 'Bítovánky' WHERE kod = 795976;
UPDATE ruian_katastr SET nazev = 'Horky u Želetavy' WHERE kod = 795984;
UPDATE ruian_katastr SET nazev = 'Šašovice' WHERE kod = 795992;
UPDATE ruian_katastr SET nazev = 'Želetava' WHERE kod = 796000;
UPDATE ruian_katastr SET nazev = 'Želetice u Kyjova' WHERE kod = 796018;
UPDATE ruian_katastr SET nazev = 'Želetice u Znojma' WHERE kod = 796026;
UPDATE ruian_katastr SET nazev = 'Lhotka u Berouna' WHERE kod = 796034;
UPDATE ruian_katastr SET nazev = 'Železná' WHERE kod = 796042;
UPDATE ruian_katastr SET nazev = 'Špičák' WHERE kod = 796051;
UPDATE ruian_katastr SET nazev = 'Železná Ruda' WHERE kod = 796069;
UPDATE ruian_katastr SET nazev = 'Alžbětín' WHERE kod = 796077;
UPDATE ruian_katastr SET nazev = 'Debrník u Železné Rudy' WHERE kod = 796085;
UPDATE ruian_katastr SET nazev = 'Pancíř' WHERE kod = 796093;
UPDATE ruian_katastr SET nazev = 'Železné' WHERE kod = 796107;
UPDATE ruian_katastr SET nazev = 'Železné Horky' WHERE kod = 796115;
UPDATE ruian_katastr SET nazev = 'Železnice' WHERE kod = 796123;
UPDATE ruian_katastr SET nazev = 'Bzí u Železného Brodu' WHERE kod = 796131;
UPDATE ruian_katastr SET nazev = 'Hrubá Horka' WHERE kod = 796140;
UPDATE ruian_katastr SET nazev = 'Chlístov u Železného Brodu' WHERE kod = 796158;
UPDATE ruian_katastr SET nazev = 'Železný Brod' WHERE kod = 796221;
UPDATE ruian_katastr SET nazev = 'Chynín' WHERE kod = 796239;
UPDATE ruian_katastr SET nazev = 'Přešín' WHERE kod = 796247;
UPDATE ruian_katastr SET nazev = 'Železný Újezd' WHERE kod = 796255;
UPDATE ruian_katastr SET nazev = 'Želiv' WHERE kod = 796271;
UPDATE ruian_katastr SET nazev = 'Horákova Lhota' WHERE kod = 796280;
UPDATE ruian_katastr SET nazev = 'Želivsko' WHERE kod = 796298;
UPDATE ruian_katastr SET nazev = 'Chudolazy' WHERE kod = 796301;
UPDATE ruian_katastr SET nazev = 'Medonosy' WHERE kod = 796310;
UPDATE ruian_katastr SET nazev = 'Sitné' WHERE kod = 796328;
UPDATE ruian_katastr SET nazev = 'Tupadly' WHERE kod = 796336;
UPDATE ruian_katastr SET nazev = 'Dolní Zimoř' WHERE kod = 796344;
UPDATE ruian_katastr SET nazev = 'Želízy' WHERE kod = 796352;
UPDATE ruian_katastr SET nazev = 'Želkovice u Loun' WHERE kod = 796361;
UPDATE ruian_katastr SET nazev = 'Pěkná' WHERE kod = 796379;
UPDATE ruian_katastr SET nazev = 'Želnava' WHERE kod = 796395;
UPDATE ruian_katastr SET nazev = 'Ženklava' WHERE kod = 796409;
UPDATE ruian_katastr SET nazev = 'Žeranovice' WHERE kod = 796417;
UPDATE ruian_katastr SET nazev = 'Žeravice u Kyjova' WHERE kod = 796425;
UPDATE ruian_katastr SET nazev = 'Žeravice' WHERE kod = 796441;
UPDATE ruian_katastr SET nazev = 'Žeraviny' WHERE kod = 796450;
UPDATE ruian_katastr SET nazev = 'Žerčice' WHERE kod = 796468;
UPDATE ruian_katastr SET nazev = 'Hradíšťko' WHERE kod = 796484;
UPDATE ruian_katastr SET nazev = 'Vlhošť' WHERE kod = 796492;
UPDATE ruian_katastr SET nazev = 'Žeretice' WHERE kod = 796506;
UPDATE ruian_katastr SET nazev = 'Žermanice' WHERE kod = 796514;
UPDATE ruian_katastr SET nazev = 'Václaví' WHERE kod = 796531;
UPDATE ruian_katastr SET nazev = 'Žernov' WHERE kod = 796549;
UPDATE ruian_katastr SET nazev = 'Žernovník u Černé Hory' WHERE kod = 796557;
UPDATE ruian_katastr SET nazev = 'Červená Hora' WHERE kod = 796565;
UPDATE ruian_katastr SET nazev = 'Všeliby' WHERE kod = 796581;
UPDATE ruian_katastr SET nazev = 'Žernov u České Skalice' WHERE kod = 796590;
UPDATE ruian_katastr SET nazev = 'Žerotice' WHERE kod = 796603;
UPDATE ruian_katastr SET nazev = 'Strukov' WHERE kod = 796611;
UPDATE ruian_katastr SET nazev = 'Žerotín' WHERE kod = 796620;
UPDATE ruian_katastr SET nazev = 'Žerovice' WHERE kod = 796638;
UPDATE ruian_katastr SET nazev = 'Žerůtky' WHERE kod = 796654;
UPDATE ruian_katastr SET nazev = 'Žerůtky u Znojma' WHERE kod = 796662;
UPDATE ruian_katastr SET nazev = 'Žešov' WHERE kod = 796671;
UPDATE ruian_katastr SET nazev = 'Žežice' WHERE kod = 796689;
UPDATE ruian_katastr SET nazev = 'Žibřidice' WHERE kod = 796697;
UPDATE ruian_katastr SET nazev = 'Židlochovice' WHERE kod = 796701;
UPDATE ruian_katastr SET nazev = 'Židněves' WHERE kod = 796786;
UPDATE ruian_katastr SET nazev = 'Židovice nad Labem' WHERE kod = 796794;
UPDATE ruian_katastr SET nazev = 'Kamenná Voda' WHERE kod = 796808;
UPDATE ruian_katastr SET nazev = 'Stránce' WHERE kod = 796816;
UPDATE ruian_katastr SET nazev = 'Židovice u Bečova' WHERE kod = 796824;
UPDATE ruian_katastr SET nazev = 'Židovice' WHERE kod = 796832;
UPDATE ruian_katastr SET nazev = 'Hluboká u Žihle' WHERE kod = 796841;
UPDATE ruian_katastr SET nazev = 'Kalec' WHERE kod = 796859;
UPDATE ruian_katastr SET nazev = 'Nový Dvůr u Žihle' WHERE kod = 796867;
UPDATE ruian_katastr SET nazev = 'Odlezly' WHERE kod = 796875;
UPDATE ruian_katastr SET nazev = 'Přehořov u Žihle' WHERE kod = 796883;
UPDATE ruian_katastr SET nazev = 'Žihle' WHERE kod = 796891;
UPDATE ruian_katastr SET nazev = 'Žihobce' WHERE kod = 796905;
UPDATE ruian_katastr SET nazev = 'Žichlínek' WHERE kod = 796913;
UPDATE ruian_katastr SET nazev = 'Žichovice' WHERE kod = 796930;
UPDATE ruian_katastr SET nazev = 'Žilina' WHERE kod = 796948;
UPDATE ruian_katastr SET nazev = 'Tatiná' WHERE kod = 796964;
UPDATE ruian_katastr SET nazev = 'Žilov' WHERE kod = 796972;
UPDATE ruian_katastr SET nazev = 'Žim' WHERE kod = 796999;
UPDATE ruian_katastr SET nazev = 'Žimrovice' WHERE kod = 797006;
UPDATE ruian_katastr SET nazev = 'Bečice' WHERE kod = 797014;
UPDATE ruian_katastr SET nazev = 'Hartmanice u Žimutic' WHERE kod = 797031;
UPDATE ruian_katastr SET nazev = 'Krakovčice' WHERE kod = 797057;
UPDATE ruian_katastr SET nazev = 'Sobětice u Žimutic' WHERE kod = 797065;
UPDATE ruian_katastr SET nazev = 'Žimutice' WHERE kod = 797073;
UPDATE ruian_katastr SET nazev = 'Březí u Žinkov' WHERE kod = 797081;
UPDATE ruian_katastr SET nazev = 'Kokořov' WHERE kod = 797103;
UPDATE ruian_katastr SET nazev = 'Žinkovy' WHERE kod = 797111;
UPDATE ruian_katastr SET nazev = 'Žirov' WHERE kod = 797138;
UPDATE ruian_katastr SET nazev = 'Cholunná' WHERE kod = 797146;
UPDATE ruian_katastr SET nazev = 'Žirovnice' WHERE kod = 797154;
UPDATE ruian_katastr SET nazev = 'Žíteč' WHERE kod = 797171;
UPDATE ruian_katastr SET nazev = 'Skalice u Žitenic' WHERE kod = 797189;
UPDATE ruian_katastr SET nazev = 'Žitenice' WHERE kod = 797197;
UPDATE ruian_katastr SET nazev = 'Žítková' WHERE kod = 797243;
UPDATE ruian_katastr SET nazev = 'Vrbice u Žitné' WHERE kod = 797251;
UPDATE ruian_katastr SET nazev = 'Žitná u Netolic' WHERE kod = 797260;
UPDATE ruian_katastr SET nazev = 'Pojedy' WHERE kod = 797278;
UPDATE ruian_katastr SET nazev = 'Žitovlice' WHERE kod = 797286;
UPDATE ruian_katastr SET nazev = 'Nerad' WHERE kod = 797308;
UPDATE ruian_katastr SET nazev = 'Neratov' WHERE kod = 797316;
UPDATE ruian_katastr SET nazev = 'Živanice' WHERE kod = 797332;
UPDATE ruian_katastr SET nazev = 'Živonín' WHERE kod = 797359;
UPDATE ruian_katastr SET nazev = 'Životice u Kasejovic' WHERE kod = 797367;
UPDATE ruian_katastr SET nazev = 'Životice u Nového Jičína' WHERE kod = 797375;
UPDATE ruian_katastr SET nazev = 'Žizníkov' WHERE kod = 797391;
UPDATE ruian_katastr SET nazev = 'Vrchovnice' WHERE kod = 797405;
UPDATE ruian_katastr SET nazev = 'Želkovice' WHERE kod = 797413;
UPDATE ruian_katastr SET nazev = 'Žíželeves' WHERE kod = 797421;
UPDATE ruian_katastr SET nazev = 'Hradišťko II' WHERE kod = 797430;
UPDATE ruian_katastr SET nazev = 'Končice' WHERE kod = 797448;
UPDATE ruian_katastr SET nazev = 'Kundratice u Žiželic nad Cidlinou' WHERE kod = 797456;
UPDATE ruian_katastr SET nazev = 'Loukonosy' WHERE kod = 797464;
UPDATE ruian_katastr SET nazev = 'Žiželice nad Cidlinou' WHERE kod = 797481;
UPDATE ruian_katastr SET nazev = 'Hořetice u Žiželic' WHERE kod = 797499;
UPDATE ruian_katastr SET nazev = 'Žiželice u Žatce' WHERE kod = 797502;
UPDATE ruian_katastr SET nazev = 'Drnov' WHERE kod = 797511;
UPDATE ruian_katastr SET nazev = 'Luníkov' WHERE kod = 797529;
UPDATE ruian_katastr SET nazev = 'Osluchov' WHERE kod = 797545;
UPDATE ruian_katastr SET nazev = 'Vítov' WHERE kod = 797553;
UPDATE ruian_katastr SET nazev = 'Žižice' WHERE kod = 797561;
UPDATE ruian_katastr SET nazev = 'Macourov' WHERE kod = 797570;
UPDATE ruian_katastr SET nazev = 'Žižkovo Pole' WHERE kod = 797596;
UPDATE ruian_katastr SET nazev = 'Žlebské Chvalovice' WHERE kod = 797618;
UPDATE ruian_katastr SET nazev = 'Zehuby' WHERE kod = 797642;
UPDATE ruian_katastr SET nazev = 'Žleby' WHERE kod = 797651;
UPDATE ruian_katastr SET nazev = 'Žloukovice' WHERE kod = 797669;
UPDATE ruian_katastr SET nazev = 'Kozojedy u Žlunic' WHERE kod = 797677;
UPDATE ruian_katastr SET nazev = 'Sekeřice' WHERE kod = 797685;
UPDATE ruian_katastr SET nazev = 'Slavhostice' WHERE kod = 797693;
UPDATE ruian_katastr SET nazev = 'Žlunice' WHERE kod = 797707;
UPDATE ruian_katastr SET nazev = 'Žlutava' WHERE kod = 797723;
UPDATE ruian_katastr SET nazev = 'Skoky u Žlutic' WHERE kod = 797740;
UPDATE ruian_katastr SET nazev = 'Verušice' WHERE kod = 797758;
UPDATE ruian_katastr SET nazev = 'Žlutice' WHERE kod = 797766;
UPDATE ruian_katastr SET nazev = 'Mlyňany' WHERE kod = 797774;
UPDATE ruian_katastr SET nazev = 'Žopy' WHERE kod = 797782;
UPDATE ruian_katastr SET nazev = 'Žulová' WHERE kod = 797804;
UPDATE ruian_katastr SET nazev = 'Žumberk' WHERE kod = 797839;
UPDATE ruian_katastr SET nazev = 'Kvaslice' WHERE kod = 797901;
UPDATE ruian_katastr SET nazev = 'Nemrlov' WHERE kod = 798193;
UPDATE ruian_katastr SET nazev = 'Sedlečko u Jiřetic' WHERE kod = 798231;
UPDATE ruian_katastr SET nazev = 'Páleč u Milešova' WHERE kod = 798321;
UPDATE ruian_katastr SET nazev = 'Hundorf' WHERE kod = 798347;
UPDATE ruian_katastr SET nazev = 'Sklená' WHERE kod = 798355;
UPDATE ruian_katastr SET nazev = 'Prameny u Žárové' WHERE kod = 798363;
UPDATE ruian_katastr SET nazev = 'Nové Oldřůvky' WHERE kod = 798371;
UPDATE ruian_katastr SET nazev = 'Mýtnice' WHERE kod = 798380;
UPDATE ruian_katastr SET nazev = 'Pavlův Studenec 3' WHERE kod = 798398;
UPDATE ruian_katastr SET nazev = 'Bezvěrov II' WHERE kod = 798401;
UPDATE ruian_katastr SET nazev = 'Vestec u Mezna' WHERE kod = 798428;
UPDATE ruian_katastr SET nazev = 'Podskalí' WHERE kod = 798436;
UPDATE ruian_katastr SET nazev = 'Šardičky' WHERE kod = 798444;
UPDATE ruian_katastr SET nazev = 'Loučka II' WHERE kod = 798452;
UPDATE ruian_katastr SET nazev = 'Maršovice u Dubé' WHERE kod = 798461;
UPDATE ruian_katastr SET nazev = 'Bolechovice II' WHERE kod = 798479;
UPDATE ruian_katastr SET nazev = 'Svahová I' WHERE kod = 798487;
UPDATE ruian_katastr SET nazev = 'Kunov' WHERE kod = 798495;
UPDATE ruian_katastr SET nazev = 'Dolní Cazov' WHERE kod = 798509;
UPDATE ruian_katastr SET nazev = 'Léštnice' WHERE kod = 798525;
UPDATE ruian_katastr SET nazev = 'Dětřiš' WHERE kod = 798533;
UPDATE ruian_katastr SET nazev = 'Košlák' WHERE kod = 798541;
UPDATE ruian_katastr SET nazev = 'Košťálkov' WHERE kod = 798550;
UPDATE ruian_katastr SET nazev = 'Kuní pod Landštejnem' WHERE kod = 798568;
UPDATE ruian_katastr SET nazev = 'Pernárec' WHERE kod = 798576;
UPDATE ruian_katastr SET nazev = 'Rajchéřov' WHERE kod = 798584;
UPDATE ruian_katastr SET nazev = 'Romava' WHERE kod = 798592;
UPDATE ruian_katastr SET nazev = 'Staré Hutě u Veclova' WHERE kod = 798606;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Klikova' WHERE kod = 798614;
UPDATE ruian_katastr SET nazev = 'Mnich u Nové Bystřice' WHERE kod = 798622;
UPDATE ruian_katastr SET nazev = 'Hrdlovka' WHERE kod = 798673;
UPDATE ruian_katastr SET nazev = 'Vchynice-Tetov II' WHERE kod = 798681;
UPDATE ruian_katastr SET nazev = 'Březenský Dvůr' WHERE kod = 798703;
UPDATE ruian_katastr SET nazev = 'Staňkov-ves' WHERE kod = 798711;
UPDATE ruian_katastr SET nazev = 'Bražec u Bochova' WHERE kod = 798720;
UPDATE ruian_katastr SET nazev = 'Zábrdovice u Vedrovic' WHERE kod = 798754;
UPDATE ruian_katastr SET nazev = 'Nové Petrovice' WHERE kod = 798762;
UPDATE ruian_katastr SET nazev = 'Dolní Vysoké II' WHERE kod = 798819;
UPDATE ruian_katastr SET nazev = 'Dolní Bolíkov-Rubašov' WHERE kod = 798827;
UPDATE ruian_katastr SET nazev = 'Ječmeniště' WHERE kod = 798835;
UPDATE ruian_katastr SET nazev = 'Štětí II' WHERE kod = 798843;
UPDATE ruian_katastr SET nazev = 'Dubina u Ostravy' WHERE kod = 798894;
UPDATE ruian_katastr SET nazev = 'Paště' WHERE kod = 798908;
UPDATE ruian_katastr SET nazev = 'Kapličky' WHERE kod = 798916;
UPDATE ruian_katastr SET nazev = 'Mnichovice u Loučovic' WHERE kod = 798924;
UPDATE ruian_katastr SET nazev = 'Hůrka u Železné Rudy' WHERE kod = 798932;
UPDATE ruian_katastr SET nazev = 'Zhůří' WHERE kod = 798975;
UPDATE ruian_katastr SET nazev = 'Horky u Srní' WHERE kod = 798983;
UPDATE ruian_katastr SET nazev = 'Hartmanice II' WHERE kod = 798991;
UPDATE ruian_katastr SET nazev = 'Kochánov III' WHERE kod = 799009;
UPDATE ruian_katastr SET nazev = 'Kundratice II' WHERE kod = 799025;
UPDATE ruian_katastr SET nazev = 'Zálužice II' WHERE kod = 799033;
UPDATE ruian_katastr SET nazev = 'Klášterský Mlýn II' WHERE kod = 799041;
UPDATE ruian_katastr SET nazev = 'Velký Radkov II' WHERE kod = 799050;
UPDATE ruian_katastr SET nazev = 'Srní II' WHERE kod = 799068;
UPDATE ruian_katastr SET nazev = 'Jabloneček' WHERE kod = 799106;
UPDATE ruian_katastr SET nazev = 'Svébořice' WHERE kod = 799114;
UPDATE ruian_katastr SET nazev = 'Javorná u Polomu' WHERE kod = 799122;
UPDATE ruian_katastr SET nazev = 'Podlázky' WHERE kod = 900125;
UPDATE ruian_katastr SET nazev = 'Chotěnov u Mariánských Lázní' WHERE kod = 901903;
UPDATE ruian_katastr SET nazev = 'Souš' WHERE kod = 903337;
UPDATE ruian_katastr SET nazev = 'Labuť u Bílovce' WHERE kod = 905038;
UPDATE ruian_katastr SET nazev = 'Nová Ves u Teplic' WHERE kod = 911780;
UPDATE ruian_katastr SET nazev = 'Albeřice u Hradiště' WHERE kod = 917923;
UPDATE ruian_katastr SET nazev = 'Bražec u Doupova' WHERE kod = 917931;
UPDATE ruian_katastr SET nazev = 'Doupovské Hradiště' WHERE kod = 917940;
UPDATE ruian_katastr SET nazev = 'Vrchbělá' WHERE kod = 918121;
UPDATE ruian_katastr SET nazev = 'Boreček' WHERE kod = 918407;
UPDATE ruian_katastr SET nazev = 'Horní Krupá' WHERE kod = 918415;
UPDATE ruian_katastr SET nazev = 'Hradčany nad Ploučnicí' WHERE kod = 918423;
UPDATE ruian_katastr SET nazev = 'Náhlov' WHERE kod = 918440;
UPDATE ruian_katastr SET nazev = 'Ploužnice pod Ralskem' WHERE kod = 918458;
UPDATE ruian_katastr SET nazev = 'Kozlov u Velkého Újezdu' WHERE kod = 920673;
UPDATE ruian_katastr SET nazev = 'Luboměř u Potštátu' WHERE kod = 920681;
UPDATE ruian_katastr SET nazev = 'Krásensko II' WHERE kod = 920762;
UPDATE ruian_katastr SET nazev = 'Kozlov u Velkého Újezdu I' WHERE kod = 929930;
UPDATE ruian_katastr SET nazev = 'Stráž u Hradiště I' WHERE kod = 929981;
UPDATE ruian_katastr SET nazev = 'Stráž u Hradiště II' WHERE kod = 929999;
UPDATE ruian_katastr SET nazev = 'Vojkovice u Hradiště I' WHERE kod = 930008;
UPDATE ruian_katastr SET nazev = 'Vojkovice u Hradiště II' WHERE kod = 930016;
UPDATE ruian_katastr SET nazev = 'Kyselka u Hradiště' WHERE kod = 930024;
UPDATE ruian_katastr SET nazev = 'Okounov u Hradiště' WHERE kod = 930032;
UPDATE ruian_katastr SET nazev = 'Bražec u Těšetic' WHERE kod = 930041;
UPDATE ruian_katastr SET nazev = 'Podbořanský Rohozec u Hradiště I' WHERE kod = 930059;
UPDATE ruian_katastr SET nazev = 'Radonice u Hradiště' WHERE kod = 930067;
UPDATE ruian_katastr SET nazev = 'Podbořanský Rohozec u Hradiště II' WHERE kod = 930075;
UPDATE ruian_katastr SET nazev = 'Těně v Brdech' WHERE kod = 930091;
UPDATE ruian_katastr SET nazev = 'Strašice v Brdech' WHERE kod = 930105;
UPDATE ruian_katastr SET nazev = 'Dobřív v Brdech' WHERE kod = 930113;
UPDATE ruian_katastr SET nazev = 'Mirošov v Brdech' WHERE kod = 930121;
UPDATE ruian_katastr SET nazev = 'Štítov v Brdech' WHERE kod = 930130;
UPDATE ruian_katastr SET nazev = 'Skořice v Brdech' WHERE kod = 930148;
UPDATE ruian_katastr SET nazev = 'Trokavec v Brdech' WHERE kod = 930156;
UPDATE ruian_katastr SET nazev = 'Číčov v Brdech' WHERE kod = 930164;
UPDATE ruian_katastr SET nazev = 'Borovno v Brdech' WHERE kod = 930172;
UPDATE ruian_katastr SET nazev = 'Míšov v Brdech' WHERE kod = 930181;
UPDATE ruian_katastr SET nazev = 'Věšín v Brdech' WHERE kod = 930199;
UPDATE ruian_katastr SET nazev = 'Nepomuk v Brdech' WHERE kod = 930202;
UPDATE ruian_katastr SET nazev = 'Vranovice v Brdech' WHERE kod = 930211;
UPDATE ruian_katastr SET nazev = 'Láz v Brdech' WHERE kod = 930229;
UPDATE ruian_katastr SET nazev = 'Obecnice v Brdech' WHERE kod = 930237;
UPDATE ruian_katastr SET nazev = 'Drahlín v Brdech' WHERE kod = 930245;
UPDATE ruian_katastr SET nazev = 'Sádek v Brdech' WHERE kod = 930253;
UPDATE ruian_katastr SET nazev = 'Bratkovice v Brdech' WHERE kod = 930261;
UPDATE ruian_katastr SET nazev = 'Jince v Brdech' WHERE kod = 930270;
UPDATE ruian_katastr SET nazev = 'Ohrazenice v Brdech' WHERE kod = 930288;
UPDATE ruian_katastr SET nazev = 'Křešín v Brdech' WHERE kod = 930296;
UPDATE ruian_katastr SET nazev = 'Felbabka v Brdech' WHERE kod = 930300;
UPDATE ruian_katastr SET nazev = 'Podluhy v Brdech' WHERE kod = 930318;
UPDATE ruian_katastr SET nazev = 'Hvozdec v Brdech' WHERE kod = 930326;
UPDATE ruian_katastr SET nazev = 'Chaloupky v Brdech' WHERE kod = 930334;
UPDATE ruian_katastr SET nazev = 'Malá Víska v Brdech' WHERE kod = 930342;
UPDATE ruian_katastr SET nazev = 'Zaječov v Brdech' WHERE kod = 930351;
UPDATE ruian_katastr SET nazev = 'Cihelny u Podivic' WHERE kod = 930369;
UPDATE ruian_katastr SET nazev = 'Chaloupky u Otaslavic' WHERE kod = 930377;
UPDATE ruian_katastr SET nazev = 'Občiny u Drahan' WHERE kod = 930385;
UPDATE ruian_katastr SET nazev = 'Osinky u Krumsína' WHERE kod = 930393;
UPDATE ruian_katastr SET nazev = 'Žleb u Prostějoviček' WHERE kod = 930407;
UPDATE ruian_katastr SET nazev = 'Ostatky u Křenůvek' WHERE kod = 930415;
UPDATE ruian_katastr SET nazev = 'Březovík 1' WHERE kod = 930423;
UPDATE ruian_katastr SET nazev = 'Březovík 2' WHERE kod = 930431;
UPDATE ruian_katastr SET nazev = 'Okrouhlík' WHERE kod = 930440;
UPDATE ruian_katastr SET nazev = 'Kraví Hora' WHERE kod = 930458;
UPDATE ruian_katastr SET nazev = 'Polná na Šumavě' WHERE kod = 930466;
UPDATE ruian_katastr SET nazev = 'Houbový Vrch' WHERE kod = 930474;
UPDATE ruian_katastr SET nazev = 'Mýtina u Želnavy' WHERE kod = 930482;
UPDATE ruian_katastr SET nazev = 'Hájenky' WHERE kod = 930491;
UPDATE ruian_katastr SET nazev = 'Domašov nad Bystřicí I' WHERE kod = 930504;
UPDATE ruian_katastr SET nazev = 'Dřemovice u Města Libavá' WHERE kod = 930512;
UPDATE ruian_katastr SET nazev = 'Předměstí u Města Libavá' WHERE kod = 930521;
UPDATE ruian_katastr SET nazev = 'Město Libavá I' WHERE kod = 930539;
UPDATE ruian_katastr SET nazev = 'Město Libavá II' WHERE kod = 930547;
UPDATE ruian_katastr SET nazev = 'Nové Oldřůvky I' WHERE kod = 930555;
UPDATE ruian_katastr SET nazev = 'Hadinka' WHERE kod = 930563;
UPDATE ruian_katastr SET nazev = 'Varhošť u Města Libavá' WHERE kod = 930571;
UPDATE ruian_katastr SET nazev = 'Mrsklesy na Moravě I' WHERE kod = 930580;
UPDATE ruian_katastr SET nazev = 'Hlubočky I' WHERE kod = 930598;
UPDATE ruian_katastr SET nazev = 'Hlubočky II' WHERE kod = 930601;
UPDATE ruian_katastr SET nazev = 'Hlubočky III' WHERE kod = 930610;
UPDATE ruian_katastr SET nazev = 'Hlubočky IV' WHERE kod = 930628;
UPDATE ruian_katastr SET nazev = 'Jívová I' WHERE kod = 930636;
UPDATE ruian_katastr SET nazev = 'Čermná u Města Libavá' WHERE kod = 990078;
UPDATE ruian_katastr SET nazev = 'Rudoltovice' WHERE kod = 990191;
UPDATE ruian_katastr SET nazev = 'Velká Střelná' WHERE kod = 990256;
UPDATE ruian_katastr SET nazev = 'Tureč u Hradiště' WHERE kod = 990329;
UPDATE ruian_katastr SET nazev = 'Žďár u Hradiště' WHERE kod = 990388;
UPDATE ruian_katastr SET nazev = 'Bražec u Hradiště' WHERE kod = 990779;
UPDATE ruian_katastr SET nazev = 'Doupov u Hradiště' WHERE kod = 990833;
UPDATE ruian_katastr SET nazev = 'Radošov u Hradiště' WHERE kod = 991244;
UPDATE ruian_katastr SET nazev = 'Arnoštov u Českého Krumlova' WHERE kod = 991694;
UPDATE ruian_katastr SET nazev = 'Jablonec u Českého Krumlova' WHERE kod = 991732;
UPDATE ruian_katastr SET nazev = 'Polná u Českého Krumlova' WHERE kod = 991741;
UPDATE ruian_katastr SET nazev = 'Maňávka u Českého Krumlova' WHERE kod = 991759;
UPDATE ruian_katastr SET nazev = 'Ondřejov u Českého Krumlova' WHERE kod = 991775;
UPDATE ruian_katastr SET nazev = 'Uhlíkov u Českého Krumlova' WHERE kod = 991813;
UPDATE ruian_katastr SET nazev = 'Třebovice u Českého Krumlova' WHERE kod = 991821;
UPDATE ruian_katastr SET nazev = 'Doubrava u Březiny' WHERE kod = 991864;
UPDATE ruian_katastr SET nazev = 'Kotáry' WHERE kod = 991872;
UPDATE ruian_katastr SET nazev = 'Osina' WHERE kod = 991881;
UPDATE ruian_katastr SET nazev = 'Pulkava' WHERE kod = 991899;
UPDATE ruian_katastr SET nazev = 'Žbánov' WHERE kod = 991902;
UPDATE ruian_katastr SET nazev = 'Valeč u Hradiště' WHERE kod = 992399;
